/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/process","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","child_process","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],le=function(x){for(var e=[],n=0,r=x.length;n<r;n++)e[n]=ce[x[n]];return e};define(ce[138],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=n,e.$fb=r,e.$gb=P,e.$hb=D,e.$ib=T,e.$jb=I,e.$kb=p,e.$mb=m,e.$nb=h,e.$ob=d,e.$pb=w,e.$qb=f;function n(g,v){const b=r(g,v);if(b!==-1)return g[b]}function r(g,v,b=g.length-1){for(let $=b;$>=0;$--){const k=g[$];if(v(k))return $}return-1}function P(g,v){const b=D(g,v);return b===-1?void 0:g[b]}function D(g,v,b=0,$=g.length){let k=b,S=$;for(;k<S;){const t=Math.floor((k+S)/2);v(g[t])?k=t+1:S=t}return k-1}function T(g,v){const b=I(g,v);return b===g.length?void 0:g[b]}function I(g,v,b=0,$=g.length){let k=b,S=$;for(;k<S;){const t=Math.floor((k+S)/2);v(g[t])?S=t:k=t+1}return k}function p(g,v,b=0,$=g.length){const k=I(g,v,b,$);return k===g.length?-1:k}class c{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(c.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!v($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const b=D(this.e,v,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$lb=c;function m(g,v){if(g.length===0)return;let b=g[0];for(let $=1;$<g.length;$++){const k=g[$];v(k,b)>0&&(b=k)}return b}function h(g,v){if(g.length===0)return;let b=g[0];for(let $=1;$<g.length;$++){const k=g[$];v(k,b)>=0&&(b=k)}return b}function d(g,v){return m(g,(b,$)=>-v(b,$))}function w(g,v){if(g.length===0)return-1;let b=0;for(let $=1;$<g.length;$++){const k=g[$];v(k,g[b])>0&&(b=$)}return b}function f(g,v){for(const b of g){const $=v(b);if($!==void 0)return $}}}),define(ce[39],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(ce[139],le([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=r,e.$d=P,e.$e=D,e.$f=T;function r(p,c){const m=Object.create(null);for(const h of p){const d=c(h);let w=m[d];w||(w=m[d]=[]),w.push(h)}return m}function P(p,c){const m=[],h=[];for(const d of p)c.has(d)||m.push(d);for(const d of c)p.has(d)||h.push(d);return{removed:m,added:h}}function D(p,c){const m=[],h=[];for(const[d,w]of p)c.has(d)||m.push(w);for(const[d,w]of c)p.has(d)||h.push(w);return{removed:m,added:h}}function T(p,c){const m=new Set;for(const h of c)p.has(h)&&m.add(h);return m}class I{static{n=Symbol.toStringTag}constructor(c,m){this.b=m,this.a=new Map,this[n]="SetWithKey";for(const h of c)this.add(h)}get size(){return this.a.size}add(c){const m=this.b(c);return this.a.set(m,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,m){this.a.forEach(h=>c.call(m,h,h,this))}[Symbol.iterator](){return this.values()}}e.$g=I}),define(ce[140],le([0,1,39]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nu=e.$mu=e.$lu=e.$ku=void 0;function r(p,c){const m=Math.pow(10,c);return Math.round(p*m)/m}class P{constructor(c,m,h,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.r===m.r&&c.g===m.g&&c.b===m.b&&c.a===m.a}}e.$ku=P;class D{constructor(c,m,h,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.l=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.l===m.l&&c.a===m.a}static fromRGBA(c){const m=c.r/255,h=c.g/255,d=c.b/255,w=c.a,f=Math.max(m,h,d),g=Math.min(m,h,d);let v=0,b=0;const $=(g+f)/2,k=f-g;if(k>0){switch(b=Math.min($<=.5?k/(2*$):k/(2-2*$),1),f){case m:v=(h-d)/k+(h<d?6:0);break;case h:v=(d-m)/k+2;break;case d:v=(m-h)/k+4;break}v*=60,v=Math.round(v)}return new D(v,b,$,w)}static i(c,m,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?c+(m-c)*6*h:h<1/2?m:h<2/3?c+(m-c)*(2/3-h)*6:c}static toRGBA(c){const m=c.h/360,{s:h,l:d,a:w}=c;let f,g,v;if(h===0)f=g=v=d;else{const b=d<.5?d*(1+h):d+h-d*h,$=2*d-b;f=D.i($,b,m+1/3),g=D.i($,b,m),v=D.i($,b,m-1/3)}return new P(Math.round(f*255),Math.round(g*255),Math.round(v*255),w)}}e.$lu=D;class T{constructor(c,m,h,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.v=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.v===m.v&&c.a===m.a}static fromRGBA(c){const m=c.r/255,h=c.g/255,d=c.b/255,w=Math.max(m,h,d),f=Math.min(m,h,d),g=w-f,v=w===0?0:g/w;let b;return g===0?b=0:w===m?b=((h-d)/g%6+6)%6:w===h?b=(d-m)/g+2:b=(m-h)/g+4,new T(Math.round(b*60),v,w,c.a)}static toRGBA(c){const{h:m,s:h,v:d,a:w}=c,f=d*h,g=f*(1-Math.abs(m/60%2-1)),v=d-f;let[b,$,k]=[0,0,0];return m<60?(b=f,$=g):m<120?(b=g,$=f):m<180?($=f,k=g):m<240?($=g,k=f):m<300?(b=g,k=f):m<=360&&(b=f,k=g),b=Math.round((b+v)*255),$=Math.round(($+v)*255),k=Math.round((k+v)*255),new P(b,$,k,w)}}e.$mu=T;class I{static fromHex(c){return I.Format.CSS.parseHex(c)||I.red}static equals(c,m){return!c&&!m?!0:!c||!m?!1:c.equals(m)}get hsla(){return this.i?this.i:D.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:T.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof P)this.rgba=c;else if(c instanceof D)this.i=c,this.rgba=D.toRGBA(c);else if(c instanceof T)this.j=c,this.rgba=T.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&P.equals(this.rgba,c.rgba)&&D.equals(this.hsla,c.hsla)&&T.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=I.k(this.rgba.r),m=I.k(this.rgba.g),h=I.k(this.rgba.b),d=.2126*c+.7152*m+.0722*h;return r(d,4)}static k(c){const m=c/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(c){const m=this.getRelativeLuminance(),h=c.getRelativeLuminance();return m>h?(m+.05)/(h+.05):(h+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const m=this.getRelativeLuminance(),h=c.getRelativeLuminance();return m>h}isDarkerThan(c){const m=this.getRelativeLuminance(),h=c.getRelativeLuminance();return m<h}lighten(c){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:m,g:h,b:d,a:w}=this.rgba;return new I(new P(m,h,d,w*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const m=c.rgba,h=this.rgba.a,d=m.a,w=h+d*(1-h);if(w<1e-6)return I.transparent;const f=this.rgba.r*h/w+m.r*d*(1-h)/w,g=this.rgba.g*h/w+m.g*d*(1-h)/w,v=this.rgba.b*h/w+m.b*d*(1-h)/w;return new I(new P(f,g,v,w))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:m,g:h,b:d,a:w}=this.rgba;return new I(new P(c.rgba.r-w*(c.rgba.r-m),c.rgba.g-w*(c.rgba.g-h),c.rgba.b-w*(c.rgba.b-d),1))}flatten(...c){const m=c.reduceRight((h,d)=>I.o(d,h));return I.o(this,m)}static o(c,m){const h=1-c.rgba.a;return new I(new P(h*m.rgba.r+c.rgba.a*c.rgba.r,h*m.rgba.g+c.rgba.a*c.rgba.g,h*m.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(c,m,h){if(c.isLighterThan(m))return c;h=h||.5;const d=c.getRelativeLuminance(),w=m.getRelativeLuminance();return h=h*(w-d)/w,c.lighten(h)}static getDarkerColor(c,m,h){if(c.isDarkerThan(m))return c;h=h||.5;const d=c.getRelativeLuminance(),w=m.getRelativeLuminance();return h=h*(d-w)/d,c.darken(h)}static{this.white=new I(new P(255,255,255,1))}static{this.black=new I(new P(0,0,0,1))}static{this.red=new I(new P(255,0,0,1))}static{this.blue=new I(new P(0,0,255,1))}static{this.green=new I(new P(0,255,0,1))}static{this.cyan=new I(new P(0,255,255,1))}static{this.lightgrey=new I(new P(211,211,211,1))}static{this.transparent=new I(new P(0,0,0,0))}}e.$nu=I,function(p){let c;(function(m){let h;(function(d){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:p.Format.CSS.formatRGBA(i)}d.formatRGB=w;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}d.formatRGBA=f;function g(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:p.Format.CSS.formatHSLA(i)}d.formatHSL=g;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}d.formatHSLA=v;function b(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function $(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}d.formatHex=$;function k(i,o=!1){return o&&i.rgba.a===1?p.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}d.formatHexA=k;function S(i){return i.isOpaque()?p.Format.CSS.formatHex(i):p.Format.CSS.formatRGBA(i)}d.format=S;function t(i){const o=i.length;if(o===0||i.charCodeAt(0)!==n.CharCode.Hash)return null;if(o===7){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),a=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new p(new P(s,a,l,1))}if(o===9){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),a=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),E=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new p(new P(s,a,l,E/255))}if(o===4){const s=u(i.charCodeAt(1)),a=u(i.charCodeAt(2)),l=u(i.charCodeAt(3));return new p(new P(16*s+s,16*a+a,16*l+l))}if(o===5){const s=u(i.charCodeAt(1)),a=u(i.charCodeAt(2)),l=u(i.charCodeAt(3)),E=u(i.charCodeAt(4));return new p(new P(16*s+s,16*a+a,16*l+l,(16*E+E)/255))}return null}d.parseHex=t;function u(i){switch(i){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(h=m.CSS||(m.CSS={}))})(c=p.Format||(p.Format={}))}(I||(e.$nu=I={}))}),define(ce[54],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=r,e.$0h=P,e.$$h=D;function n(T){return(I,p,c)=>{let m=null,h=null;if(typeof c.value=="function"?(m="value",h=c.value):typeof c.get=="function"&&(m="get",h=c.get),!h)throw new Error("not supported");c[m]=T(h,p)}}function r(T,I,p){let c=null,m=null;if(typeof p.value=="function"?(c="value",m=p.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",m=p.get),!m)throw new Error("not supported");const h=`$memoize$${I}`;p[c]=function(...d){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,d)}),this[h]}}function P(T,I,p){return n((c,m)=>{const h=`$debounce$${m}`,d=`$debounce$result$${m}`;return function(...w){this[d]||(this[d]=p?p():void 0),clearTimeout(this[h]),I&&(this[d]=I(this[d],...w),w=[this[d]]),this[h]=setTimeout(()=>{c.apply(this,w),this[d]=p?p():void 0},T)}})}function D(T,I,p){return n((c,m)=>{const h=`$throttle$timer$${m}`,d=`$throttle$result$${m}`,w=`$throttle$lastRun$${m}`,f=`$throttle$pending$${m}`;return function(...g){if(this[d]||(this[d]=p?p():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[d]=I(this[d],...g)),this[f])return;const v=this[w]+T;v<=Date.now()?(this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0):(this[f]=!0,this[h]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0},v-Date.now()))}})}}),define(ce[15],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=r,e.$X=P,e.$Y=D,e.$Z=T,e.$1=I,e.$2=p,e.$3=m,e.$5=d,e.$6=w,e.$7=f,e.$9=v;class n{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?S.isErrorNoTelemetry(i)?new S(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=n,e.$V=new n;function r(u){e.$V.setUnexpectedErrorHandler(u)}function P(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function D(u){m(u)||e.$V.onUnexpectedError(u)}function T(u){m(u)||e.$V.onUnexpectedExternalError(u)}function I(u){if(u instanceof Error){const{name:i,message:o}=u,s=u.stacktrace||u.stack;return{$isError:!0,name:i,message:o,stack:s,noTelemetry:S.isErrorNoTelemetry(u)}}return u}function p(u){let i;return u.noTelemetry?i=new S:(i=new Error,i.name=u.name),i.message=u.message,i.stack=u.stack,i}const c="Canceled";function m(u){return u instanceof h?!0:u instanceof Error&&u.name===c&&u.message===c}class h extends Error{constructor(){super(c),this.name=this.message}}e.$4=h;function d(){const u=new Error(c);return u.name=u.message,u}function w(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class g extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=g;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=b;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=$;class k extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=k;class S extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof S)return i;const o=new S;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=S;class t extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$bb=t}),define(ce[21],le([0,1,15,138]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=P,e.$sb=D,e.$tb=T,e.$ub=I,e.$vb=p,e.$wb=c,e.$xb=m,e.$yb=h,e.$zb=d,e.$Ab=w,e.$Bb=f,e.$Cb=g,e.$Db=v,e.top=b,e.$Fb=$,e.$Gb=S,e.$Hb=t,e.$Ib=u,e.$Jb=i,e.$Kb=o,e.$Lb=s,e.$Mb=a,e.$Nb=l,e.$Ob=E,e.$Pb=y,e.$Qb=R,e.$Rb=L,e.$Sb=A,e.$Tb=O,e.$Ub=M,e.$Vb=H,e.$Wb=q,e.$Xb=K,e.$Yb=de,e.$Zb=Y,e.$1b=J,e.$2b=U,e.$3b=Z,e.$4b=W,e.$5b=X,e.$6b=oe,e.$9b=re,e.$ac=_;function P(z,ie=0){return z[z.length-(1+ie)]}function D(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function T(z,ie,G=(B,te)=>B===te){if(z===ie)return!0;if(!z||!ie||z.length!==ie.length)return!1;for(let B=0,te=z.length;B<te;B++)if(!G(z[B],ie[B]))return!1;return!0}function I(z,ie){const G=z.length-1;ie<G&&(z[ie]=z[G]),z.pop()}function p(z,ie,G){return c(z.length,B=>G(z[B],ie))}function c(z,ie){let G=0,B=z-1;for(;G<=B;){const te=(G+B)/2|0,he=ie(te);if(he<0)G=te+1;else if(he>0)B=te-1;else return te}return-(G+1)}function m(z,ie,G){if(z=z|0,z>=ie.length)throw new TypeError("invalid index");const B=ie[Math.floor(ie.length*Math.random())],te=[],he=[],me=[];for(const we of ie){const Ie=G(we,B);Ie<0?te.push(we):Ie>0?he.push(we):me.push(we)}return z<te.length?m(z,te,G):z<te.length+me.length?me[0]:m(z-(te.length+me.length),he,G)}function h(z,ie){const G=[];let B;for(const te of z.slice(0).sort(ie))!B||ie(B[0],te)!==0?(B=[te],G.push(B)):B.push(te);return G}function*d(z,ie){let G,B;for(const te of z)B!==void 0&&ie(B,te)?G.push(te):(G&&(yield G),G=[te]),B=te;G&&(yield G)}function w(z,ie){for(let G=0;G<=z.length;G++)ie(G===0?void 0:z[G-1],G===z.length?void 0:z[G])}function f(z,ie){for(let G=0;G<z.length;G++)ie(G===0?void 0:z[G-1],z[G],G+1===z.length?void 0:z[G+1])}function g(z,ie,G){const B=[];function te(we,Ie,Ce){if(Ie===0&&Ce.length===0)return;const Re=B[B.length-1];Re&&Re.start+Re.deleteCount===we?(Re.deleteCount+=Ie,Re.toInsert.push(...Ce)):B.push({start:we,deleteCount:Ie,toInsert:Ce})}let he=0,me=0;for(;;){if(he===z.length){te(he,0,ie.slice(me));break}if(me===ie.length){te(he,z.length-he,[]);break}const we=z[he],Ie=ie[me],Ce=G(we,Ie);Ce===0?(he+=1,me+=1):Ce<0?(te(he,1,[]),he+=1):Ce>0&&(te(he,0,[Ie]),me+=1)}return B}function v(z,ie,G){const B=g(z,ie,G),te=[],he=[];for(const me of B)te.push(...z.slice(me.start,me.start+me.deleteCount)),he.push(...me.toInsert);return{removed:te,added:he}}function b(z,ie,G){if(G===0)return[];const B=z.slice(0,G).sort(ie);return k(z,ie,B,G,z.length),B}function $(z,ie,G,B,te){return G===0?Promise.resolve([]):new Promise((he,me)=>{(async()=>{const we=z.length,Ie=z.slice(0,G).sort(ie);for(let Ce=G,Re=Math.min(G+B,we);Ce<we;Ce=Re,Re=Math.min(Re+B,we)){if(Ce>G&&await new Promise(ve=>setTimeout(ve)),te&&te.isCancellationRequested)throw new n.$4;k(z,ie,Ie,Ce,Re)}return Ie})().then(he,me)})}function k(z,ie,G,B,te){for(const he=G.length;B<te;B++){const me=z[B];if(ie(me,G[he-1])<0){G.pop();const we=(0,r.$jb)(G,Ie=>ie(me,Ie)<0);G.splice(we,0,me)}}}function S(z){return z.filter(ie=>!!ie)}function t(z){let ie=0;for(let G=0;G<z.length;G++)z[G]&&(z[ie]=z[G],ie+=1);z.length=ie}function u(z,ie,G){z.splice(G,0,z.splice(ie,1)[0])}function i(z){return!Array.isArray(z)||z.length===0}function o(z){return Array.isArray(z)&&z.length>0}function s(z,ie=G=>G){const G=new Set;return z.filter(B=>{const te=ie(B);return G.has(te)?!1:(G.add(te),!0)})}function a(z){const ie=new Set;return G=>{const B=z(G);return ie.has(B)?!1:(ie.add(B),!0)}}function l(z,ie){return z.length>0?z[0]:ie}function E(z,ie){return z.length>0?z[z.length-1]:ie}function y(z,ie,G=(B,te)=>B===te){let B=0;for(let te=0,he=Math.min(z.length,ie.length);te<he&&G(z[te],ie[te]);te++)B++;return B}function R(z,ie){let G=typeof ie=="number"?z:0;typeof ie=="number"?G=z:(G=0,ie=z);const B=[];if(G<=ie)for(let te=G;te<ie;te++)B.push(te);else for(let te=G;te>ie;te--)B.push(te);return B}function L(z,ie,G){return z.reduce((B,te)=>(B[ie(te)]=G?G(te):te,B),Object.create(null))}function A(z,ie){return z.push(ie),()=>O(z,ie)}function O(z,ie){const G=z.indexOf(ie);if(G>-1)return z.splice(G,1),ie}function M(z,ie,G){const B=z.slice(0,ie),te=z.slice(ie);return B.concat(G,te)}function H(z,ie){let G;if(typeof ie=="number"){let B=ie;G=()=>{const te=Math.sin(B++)*179426549;return te-Math.floor(te)}}else G=Math.random;for(let B=z.length-1;B>0;B-=1){const te=Math.floor(G()*(B+1)),he=z[B];z[B]=z[te],z[te]=he}}function q(z,ie){const G=z.indexOf(ie);G>-1&&(z.splice(G,1),z.unshift(ie))}function K(z,ie){const G=z.indexOf(ie);G>-1&&(z.splice(G,1),z.push(ie))}function de(z,ie){for(const G of ie)z.push(G)}function Y(z,ie){return Array.isArray(z)?z.map(ie):ie(z)}function J(z){return Array.isArray(z)?z:[z]}function U(z){return z[Math.floor(Math.random()*z.length)]}function Z(z,ie,G){const B=j(z,ie),te=z.length,he=G.length;z.length=te+he;for(let me=te-1;me>=B;me--)z[me+he]=z[me];for(let me=0;me<he;me++)z[me+B]=G[me]}function W(z,ie,G,B){const te=j(z,ie);let he=z.splice(te,G);return he===void 0&&(he=[]),Z(z,te,B),he}function j(z,ie){return ie<0?Math.max(ie+z.length,0):Math.min(ie,z.length)}var C;(function(z){function ie(he){return he<0}z.isLessThan=ie;function G(he){return he<=0}z.isLessThanOrEqual=G;function B(he){return he>0}z.isGreaterThan=B;function te(he){return he===0}z.isNeitherLessOrGreaterThan=te,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(C||(e.CompareResult=C={}));function X(z,ie){return(G,B)=>ie(z(G),z(B))}function oe(...z){return(ie,G)=>{for(const B of z){const te=B(ie,G);if(!C.isNeitherLessOrGreaterThan(te))return te}return C.neitherLessOrGreaterThan}}const V=(z,ie)=>z-ie;e.$7b=V;const ue=(z,ie)=>(0,e.$7b)(z?1:0,ie?1:0);e.$8b=ue;function re(z){return(ie,G)=>-z(ie,G)}class Q{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let G=this.c;for(;G<this.g.length&&ie(this.g[G]);)G++;const B=G===this.c?null:this.g.slice(this.c,G);return this.c=G,B}takeFromEndWhile(ie){let G=this.d;for(;G>=0&&ie(this.g[G]);)G--;const B=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const G=this.g.slice(this.c,this.c+ie);return this.c+=ie,G}}e.$0b=Q;class N{static{this.empty=new N(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(G=>(ie(G),!0))}toArray(){const ie=[];return this.iterate(G=>(ie.push(G),!0)),ie}filter(ie){return new N(G=>this.iterate(B=>ie(B)?G(B):!0))}map(ie){return new N(G=>this.iterate(B=>G(ie(B))))}some(ie){let G=!1;return this.iterate(B=>(G=ie(B),!G)),G}findFirst(ie){let G;return this.iterate(B=>ie(B)?(G=B,!1):!0),G}findLast(ie){let G;return this.iterate(B=>(ie(B)&&(G=B),!0)),G}findLastMaxBy(ie){let G,B=!0;return this.iterate(te=>((B||C.isGreaterThan(ie(te,G)))&&(B=!1,G=te),!0)),G}}e.$$b=N;class F{constructor(ie){this.c=ie}static createSortPermutation(ie,G){const B=Array.from(ie.keys()).sort((te,he)=>G(ie[te],ie[he]));return new F(B)}apply(ie){return ie.map((G,B)=>ie[this.c[B]])}inverse(){const ie=this.c.slice();for(let G=0;G<this.c.length;G++)ie[this.c[G]]=G;return new F(ie)}}e.$_b=F;async function _(z,ie){return(await Promise.all(z.map(async(B,te)=>({element:B,ok:await ie(B,te)})))).find(B=>B.ok)?.element}}),define(ce[141],le([0,1,15]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$ed=P,e.$fd=D,e.$gd=T,e.$hd=I,e.$id=p;function r(c,m){if(!c)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}function P(c,m="Unreachable"){throw new Error(m)}function D(c,m="unexpected state"){if(!c)throw new n.$bb(`Assertion Failed: ${m}`)}function T(c){c||(0,n.$Y)(new n.$bb("Soft Assertion Failed"))}function I(c){if(!c()){debugger;c(),(0,n.$Y)(new n.$bb("Assertion Failed"))}}function p(c,m){let h=0;for(;h<c.length-1;){const d=c[h],w=c[h+1];if(!m(d,w))return!1;h++}return!0}}),define(ce[89],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=n;function n(r,P){const D=this;let T=!1,I;return function(){if(T)return I;if(T=!0,P)try{I=r.apply(D,arguments)}finally{P()}else I=r.apply(D,arguments);return I}}}),define(ce[77],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function P(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}r.is=P;const D=Object.freeze([]);function T(){return D}r.empty=T;function*I(i){yield i}r.single=I;function p(i){return P(i)?i:I(i)}r.wrap=p;function c(i){return i||D}r.from=c;function*m(i){for(let o=i.length-1;o>=0;o--)yield i[o]}r.reverse=m;function h(i){return!i||i[Symbol.iterator]().next().done===!0}r.isEmpty=h;function d(i){return i[Symbol.iterator]().next().value}r.first=d;function w(i,o){let s=0;for(const a of i)if(o(a,s++))return!0;return!1}r.some=w;function f(i,o){for(const s of i)if(o(s))return s}r.find=f;function*g(i,o){for(const s of i)o(s)&&(yield s)}r.filter=g;function*v(i,o){let s=0;for(const a of i)yield o(a,s++)}r.map=v;function*b(i,o){let s=0;for(const a of i)yield*o(a,s++)}r.flatMap=b;function*$(...i){for(const o of i)yield*o}r.concat=$;function k(i,o,s){let a=s;for(const l of i)a=o(a,l);return a}r.reduce=k;function*S(i,o,s=i.length){for(o<0&&(o+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);o<s;o++)yield i[o]}r.slice=S;function t(i,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,i];const a=i[Symbol.iterator]();for(let l=0;l<o;l++){const E=a.next();if(E.done)return[s,r.empty()];s.push(E.value)}return[s,{[Symbol.iterator](){return a}}]}r.consume=t;async function u(i){const o=[];for await(const s of i)o.push(s);return Promise.resolve(o)}r.asyncToArray=u})(n||(e.Iterable=n={}))}),define(ce[43],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=T,e.$Wn=h,e.$Xn=d,e.$Yn=w,e.$Zn=f,e.$1n=g,e.$2n=v,e.$3n=b,e.$4n=$,e.$5n=k,e.$6n=S;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function T(t,u=!1){let i=0;const o=t.length;let s="",a=0,l=r.Unknown,E=n.None;function y(q){let K=0,de=0;for(;K<q;){const Y=t.charCodeAt(i);if(Y>=m._0&&Y<=m._9)de=de*16+Y-m._0;else if(Y>=m.A&&Y<=m.F)de=de*16+Y-m.A+10;else if(Y>=m.a&&Y<=m.f)de=de*16+Y-m.a+10;else break;i++,K++}return K<q&&(de=-1),de}function R(q){i=q,s="",a=0,l=r.Unknown,E=n.None}function L(){const q=i;if(t.charCodeAt(i)===m._0)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===m.dot)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return E=n.UnexpectedEndOfNumber,t.substring(q,i);let K=i;if(i<t.length&&(t.charCodeAt(i)===m.E||t.charCodeAt(i)===m.e))if(i++,(i<t.length&&t.charCodeAt(i)===m.plus||t.charCodeAt(i)===m.minus)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;K=i}else E=n.UnexpectedEndOfNumber;return t.substring(q,K)}function A(){let q="",K=i;for(;;){if(i>=o){q+=t.substring(K,i),E=n.UnexpectedEndOfString;break}const de=t.charCodeAt(i);if(de===m.doubleQuote){q+=t.substring(K,i),i++;break}if(de===m.backslash){if(q+=t.substring(K,i),i++,i>=o){E=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case m.doubleQuote:q+='"';break;case m.backslash:q+="\\";break;case m.slash:q+="/";break;case m.b:q+="\b";break;case m.f:q+="\f";break;case m.n:q+=`
`;break;case m.r:q+="\r";break;case m.t:q+="	";break;case m.u:{const J=y(4);J>=0?q+=String.fromCharCode(J):E=n.InvalidUnicode;break}default:E=n.InvalidEscapeCharacter}K=i;continue}if(de>=0&&de<=31)if(p(de)){q+=t.substring(K,i),E=n.UnexpectedEndOfString;break}else E=n.InvalidCharacter;i++}return q}function O(){if(s="",E=n.None,a=i,i>=o)return a=o,l=r.EOF;let q=t.charCodeAt(i);if(I(q)){do i++,s+=String.fromCharCode(q),q=t.charCodeAt(i);while(I(q));return l=r.Trivia}if(p(q))return i++,s+=String.fromCharCode(q),q===m.carriageReturn&&t.charCodeAt(i)===m.lineFeed&&(i++,s+=`
`),l=r.LineBreakTrivia;switch(q){case m.openBrace:return i++,l=r.OpenBraceToken;case m.closeBrace:return i++,l=r.CloseBraceToken;case m.openBracket:return i++,l=r.OpenBracketToken;case m.closeBracket:return i++,l=r.CloseBracketToken;case m.colon:return i++,l=r.ColonToken;case m.comma:return i++,l=r.CommaToken;case m.doubleQuote:return i++,s=A(),l=r.StringLiteral;case m.slash:{const K=i-1;if(t.charCodeAt(i+1)===m.slash){for(i+=2;i<o&&!p(t.charCodeAt(i));)i++;return s=t.substring(K,i),l=r.LineCommentTrivia}if(t.charCodeAt(i+1)===m.asterisk){i+=2;const de=o-1;let Y=!1;for(;i<de;){if(t.charCodeAt(i)===m.asterisk&&t.charCodeAt(i+1)===m.slash){i+=2,Y=!0;break}i++}return Y||(i++,E=n.UnexpectedEndOfComment),s=t.substring(K,i),l=r.BlockCommentTrivia}return s+=String.fromCharCode(q),i++,l=r.Unknown}case m.minus:if(s+=String.fromCharCode(q),i++,i===o||!c(t.charCodeAt(i)))return l=r.Unknown;case m._0:case m._1:case m._2:case m._3:case m._4:case m._5:case m._6:case m._7:case m._8:case m._9:return s+=L(),l=r.NumericLiteral;default:for(;i<o&&M(q);)i++,q=t.charCodeAt(i);if(a!==i){switch(s=t.substring(a,i),s){case"true":return l=r.TrueKeyword;case"false":return l=r.FalseKeyword;case"null":return l=r.NullKeyword}return l=r.Unknown}return s+=String.fromCharCode(q),i++,l=r.Unknown}}function M(q){if(I(q)||p(q))return!1;switch(q){case m.closeBrace:case m.closeBracket:case m.openBrace:case m.openBracket:case m.doubleQuote:case m.colon:case m.comma:case m.slash:return!1}return!0}function H(){let q;do q=O();while(q>=r.LineCommentTrivia&&q<=r.Trivia);return q}return{setPosition:R,getPosition:()=>i,scan:u?H:O,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>E}}function I(t){return t===m.space||t===m.tab||t===m.verticalTab||t===m.formFeed||t===m.nonBreakingSpace||t===m.ogham||t>=m.enQuad&&t<=m.zeroWidthSpace||t===m.narrowNoBreakSpace||t===m.mathematicalSpace||t===m.ideographicSpace||t===m.byteOrderMark}function p(t){return t===m.lineFeed||t===m.carriageReturn||t===m.lineSeparator||t===m.paragraphSeparator}function c(t){return t>=m._0&&t<=m._9}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function h(t,u){const i=[],o=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function E(y,R,L,A){a.value=y,a.offset=R,a.length=L,a.type=A,a.colonOffset=void 0,s=a}try{k(t,{onObjectBegin:(y,R)=>{if(u<=y)throw o;s=void 0,l=u>y,i.push("")},onObjectProperty:(y,R,L)=>{if(u<R||(E(y,R,L,"property"),i[i.length-1]=y,u<=R+L))throw o},onObjectEnd:(y,R)=>{if(u<=y)throw o;s=void 0,i.pop()},onArrayBegin:(y,R)=>{if(u<=y)throw o;s=void 0,i.push(0)},onArrayEnd:(y,R)=>{if(u<=y)throw o;s=void 0,i.pop()},onLiteralValue:(y,R,L)=>{if(u<R||(E(y,R,L,S(y)),u<=R+L))throw o},onSeparator:(y,R,L)=>{if(u<=R)throw o;if(y===":"&&s&&s.type==="property")s.colonOffset=R,l=!1,s=void 0;else if(y===","){const A=i[i.length-1];typeof A=="number"?i[i.length-1]=A+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==o)throw y}return{path:i,previousNode:s,isAtPropertyKey:l,matches:y=>{let R=0;for(let L=0;R<y.length&&L<i.length;L++)if(y[R]===i[L]||y[R]==="*")R++;else if(y[R]!=="**")return!1;return R===y.length}}}function d(t,u=[],i=D.DEFAULT){let o=null,s=[];const a=[];function l(y){Array.isArray(s)?s.push(y):o!==null&&(s[o]=y)}return k(t,{onObjectBegin:()=>{const y={};l(y),a.push(s),s=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const y=[];l(y),a.push(s),s=y,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(y,R,L)=>{u.push({error:y,offset:R,length:L})}},i),s[0]}function w(t,u=[],i=D.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){o.type==="property"&&(o.length=y-o.offset,o=o.parent)}function a(y){return o.children.push(y),y}k(t,{onObjectBegin:y=>{o=a({type:"object",offset:y,length:-1,parent:o,children:[]})},onObjectProperty:(y,R,L)=>{o=a({type:"property",offset:R,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:y,offset:R,length:L,parent:o})},onObjectEnd:(y,R)=>{o.length=y+R-o.offset,o=o.parent,s(y+R)},onArrayBegin:(y,R)=>{o=a({type:"array",offset:y,length:-1,parent:o,children:[]})},onArrayEnd:(y,R)=>{o.length=y+R-o.offset,o=o.parent,s(y+R)},onLiteralValue:(y,R,L)=>{a({type:S(y),offset:R,length:L,parent:o,value:y}),s(R+L)},onSeparator:(y,R,L)=>{o.type==="property"&&(y===":"?o.colonOffset=R:y===","&&s(R))},onError:(y,R,L)=>{u.push({error:y,offset:R,length:L})}},i);const E=o.children[0];return E&&delete E.parent,E}function f(t,u){if(!t)return;let i=t;for(const o of u)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===o){i=a.children[1],s=!0;break}if(!s)return}else{const s=o;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function g(t){if(!t.parent||!t.parent.children)return[];const u=g(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;u.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&u.push(i)}return u}function v(t){switch(t.type){case"array":return t.children.map(v);case"object":{const u=Object.create(null);for(const i of t.children){const o=i.children[1];o&&(u[i.children[0].value]=v(o))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function b(t,u,i=!1){return u>=t.offset&&u<t.offset+t.length||i&&u===t.offset+t.length}function $(t,u,i=!1){if(b(t,u,i)){const o=t.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=u;s++){const a=$(o[s],u,i);if(a)return a}return t}}function k(t,u,i=D.DEFAULT){const o=T(t,!1);function s(X){return X?()=>X(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(X){return X?oe=>X(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=s(u.onObjectBegin),E=a(u.onObjectProperty),y=s(u.onObjectEnd),R=s(u.onArrayBegin),L=s(u.onArrayEnd),A=a(u.onLiteralValue),O=a(u.onSeparator),M=s(u.onComment),H=a(u.onError),q=i&&i.disallowComments,K=i&&i.allowTrailingComma;function de(){for(;;){const X=o.scan();switch(o.getTokenError()){case n.InvalidUnicode:Y(P.InvalidUnicode);break;case n.InvalidEscapeCharacter:Y(P.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:Y(P.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:q||Y(P.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:Y(P.UnexpectedEndOfString);break;case n.InvalidCharacter:Y(P.InvalidCharacter);break}switch(X){case r.LineCommentTrivia:case r.BlockCommentTrivia:q?Y(P.InvalidCommentToken):M();break;case r.Unknown:Y(P.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return X}}}function Y(X,oe=[],V=[]){if(H(X),oe.length+V.length>0){let ue=o.getToken();for(;ue!==r.EOF;){if(oe.indexOf(ue)!==-1){de();break}else if(V.indexOf(ue)!==-1)break;ue=de()}}}function J(X){const oe=o.getTokenValue();return X?A(oe):E(oe),de(),!0}function U(){switch(o.getToken()){case r.NumericLiteral:{let X=0;try{X=JSON.parse(o.getTokenValue()),typeof X!="number"&&(Y(P.InvalidNumberFormat),X=0)}catch{Y(P.InvalidNumberFormat)}A(X);break}case r.NullKeyword:A(null);break;case r.TrueKeyword:A(!0);break;case r.FalseKeyword:A(!1);break;default:return!1}return de(),!0}function Z(){return o.getToken()!==r.StringLiteral?(Y(P.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(J(!1),o.getToken()===r.ColonToken?(O(":"),de(),C()||Y(P.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):Y(P.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function W(){l(),de();let X=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(X||Y(P.ValueExpected,[],[]),O(","),de(),o.getToken()===r.CloseBraceToken&&K)break}else X&&Y(P.CommaExpected,[],[]);Z()||Y(P.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),X=!0}return y(),o.getToken()!==r.CloseBraceToken?Y(P.CloseBraceExpected,[r.CloseBraceToken],[]):de(),!0}function j(){R(),de();let X=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(X||Y(P.ValueExpected,[],[]),O(","),de(),o.getToken()===r.CloseBracketToken&&K)break}else X&&Y(P.CommaExpected,[],[]);C()||Y(P.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),X=!0}return L(),o.getToken()!==r.CloseBracketToken?Y(P.CloseBracketExpected,[r.CloseBracketToken],[]):de(),!0}function C(){switch(o.getToken()){case r.OpenBracketToken:return j();case r.OpenBraceToken:return W();case r.StringLiteral:return J(!0);default:return U()}}return de(),o.getToken()===r.EOF?i.allowEmptyContent?!0:(Y(P.ValueExpected,[],[]),!1):C()?(o.getToken()!==r.EOF&&Y(P.EndOfFileExpected,[],[]),!0):(Y(P.ValueExpected,[],[]),!1)}function S(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[142],le([0,1,43]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=r,e.$8n=P,e.$9n=I,e.$0n=p;function r(c,m,h){let d,w,f,g,v;if(m){for(g=m.offset,v=g+m.length,f=g;f>0&&!p(c,f-1);)f--;let E=v;for(;E<c.length&&!p(c,E);)E++;w=c.substring(f,E),d=T(w,h)}else w=c,d=0,f=0,g=0,v=c.length;const b=I(h,c);let $=!1,k=0,S;h.insertSpaces?S=D(" ",h.tabSize||4):S="	";const t=(0,n.$Vn)(w,!1);let u=!1;function i(){return b+D(S,d+k)}function o(){let E=t.scan();for($=!1;E===n.SyntaxKind.Trivia||E===n.SyntaxKind.LineBreakTrivia;)$=$||E===n.SyntaxKind.LineBreakTrivia,E=t.scan();return u=E===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,E}const s=[];function a(E,y,R){!u&&y<v&&R>g&&c.substring(y,R)!==E&&s.push({offset:y,length:R-y,content:E})}let l=o();if(l!==n.SyntaxKind.EOF){const E=t.getTokenOffset()+f,y=D(S,d);a(y,f,E)}for(;l!==n.SyntaxKind.EOF;){let E=t.getTokenOffset()+t.getTokenLength()+f,y=o(),R="";for(;!$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia);){const A=t.getTokenOffset()+f;a(" ",E,A),E=t.getTokenOffset()+t.getTokenLength()+f,R=y===n.SyntaxKind.LineCommentTrivia?i():"",y=o()}if(y===n.SyntaxKind.CloseBraceToken)l!==n.SyntaxKind.OpenBraceToken&&(k--,R=i());else if(y===n.SyntaxKind.CloseBracketToken)l!==n.SyntaxKind.OpenBracketToken&&(k--,R=i());else{switch(l){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:k++,R=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:R=i();break;case n.SyntaxKind.BlockCommentTrivia:$?R=i():R=" ";break;case n.SyntaxKind.ColonToken:R=" ";break;case n.SyntaxKind.StringLiteral:if(y===n.SyntaxKind.ColonToken){R="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia?R=" ":y!==n.SyntaxKind.CommaToken&&y!==n.SyntaxKind.EOF&&(u=!0);break;case n.SyntaxKind.Unknown:u=!0;break}$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia)&&(R=i())}const L=t.getTokenOffset()+f;a(R,E,L),l=y}return s}function P(c,m){const h=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?h.replace(/\r\n|\r|\n/g,m.eol):h}function D(c,m){let h="";for(let d=0;d<m;d++)h+=c;return h}function T(c,m){let h=0,d=0;const w=m.tabSize||4;for(;h<c.length;){const f=c.charAt(h);if(f===" ")d++;else if(f==="	")d+=w;else break;h++}return Math.floor(d/w)}function I(c,m){for(let h=0;h<m.length;h++){const d=m.charAt(h);if(d==="\r")return h+1<m.length&&m.charAt(h+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return c&&c.eol||`
`}function p(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}}),define(ce[107],le([0,1,43,142]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=P,e.$_n=D,e.$ao=T,e.$bo=I,e.$co=p;function P(c,m,h){return D(c,m,void 0,h)}function D(c,m,h,d,w){const f=m.slice(),g=[],v=(0,n.$Yn)(c,g);let b,$;for(;f.length>0&&($=f.pop(),b=(0,n.$Zn)(v,f),b===void 0&&h!==void 0);)typeof $=="string"?h={[$]:h}:h=[h];if(b)if(b.type==="object"&&typeof $=="string"&&Array.isArray(b.children)){const k=(0,n.$Zn)(b,[$]);if(k!==void 0)if(h===void 0){if(!k.parent)throw new Error("Malformed AST");const S=b.children.indexOf(k.parent);let t,u=k.parent.offset+k.parent.length;if(S>0){const i=b.children[S-1];t=i.offset+i.length}else t=b.offset+1,b.children.length>1&&(u=b.children[1].offset);return T(c,{offset:t,length:u-t,content:""},d)}else return T(c,{offset:k.offset,length:k.length,content:JSON.stringify(h)},d);else{if(h===void 0)return[];const S=`${JSON.stringify($)}: ${JSON.stringify(h)}`,t=w?w(b.children.map(i=>i.children[0].value)):b.children.length;let u;if(t>0){const i=b.children[t-1];u={offset:i.offset+i.length,length:0,content:","+S}}else b.children.length===0?u={offset:b.offset+1,length:0,content:S}:u={offset:b.offset+1,length:0,content:S+","};return T(c,u,d)}}else if(b.type==="array"&&typeof $=="number"&&Array.isArray(b.children))if(h!==void 0){const k=`${JSON.stringify(h)}`;let S;if(b.children.length===0||$===0)S={offset:b.offset+1,length:0,content:b.children.length===0?k:k+","};else{const t=$===-1||$>b.children.length?b.children.length:$,u=b.children[t-1];S={offset:u.offset+u.length,length:0,content:","+k}}return T(c,S,d)}else{const k=$,S=b.children[k];let t;if(b.children.length===1)t={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===k){const u=b.children[k-1],i=u.offset+u.length,o=b.offset+b.length;t={offset:i,length:o-2-i,content:""}}else t={offset:S.offset,length:b.children[k+1].offset-S.offset,content:""};return T(c,t,d)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${b.type}`);else return h===void 0?[]:T(c,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(h)},d)}function T(c,m,h){let d=I(c,m),w=m.offset,f=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;w>0&&!(0,r.$0n)(d,w-1);)w--;for(;f<d.length&&!(0,r.$0n)(d,f);)f++}const g=(0,r.$7n)(d,{offset:w,length:f-w},h);for(let b=g.length-1;b>=0;b--){const $=g[b];d=I(d,$),w=Math.min(w,$.offset),f=Math.max(f,$.offset+$.length),f+=$.content.length-$.length}const v=c.length-(d.length-f)-w;return[{offset:w,length:v,content:d.substring(w,f)}]}function I(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}function p(c,m){const h=m.slice(0).sort((w,f)=>{const g=w.offset-f.offset;return g===0?w.length-f.length:g});let d=c.length;for(let w=h.length-1;w>=0;w--){const f=h[w];if(f.offset+f.length<=d)c=I(c,f);else throw new Error("Overlapping edit");d=f.offset}return c}}),define(ce[143],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=n;function n(D){let T=!1;const I=new Map,p=new Map;if(P(D,g=>{if(D===g)return!0;const v=JSON.stringify(g);if(v.length<30)return!0;const b=I.get(v);if(!b){const $={schemas:[g]};return I.set(v,$),p.set(g,$),!0}return b.schemas.push(g),p.set(g,b),T=!0,!1}),I.clear(),!T)return JSON.stringify(D);let m="$defs";for(;D.hasOwnProperty(m);)m+="_";const h=[];function d(g){return JSON.stringify(g,(v,b)=>{if(b!==g){const $=p.get(b);if($&&$.schemas.length>1)return $.id||($.id=`_${h.length}`,h.push($.schemas[0])),{$ref:`#/${m}/${$.id}`}}return b})}const w=d(D),f=[];for(let g=0;g<h.length;g++)f.push(`"_${g}":${d(h[g])}`);return f.length?`${w.substring(0,w.length-1)},"${m}":{${f.join(",")}}}`:w}function r(D){return typeof D=="object"&&D!==null}function P(D,T){if(!D||typeof D!="object")return;const I=(...w)=>{for(const f of w)r(f)&&h.push(f)},p=(...w)=>{for(const f of w)if(r(f))for(const g in f){const v=f[g];r(v)&&h.push(v)}},c=(...w)=>{for(const f of w)if(Array.isArray(f))for(const g of f)r(g)&&h.push(g)},m=w=>{if(Array.isArray(w))for(const f of w)r(f)&&h.push(f);else r(w)&&h.push(w)},h=[D];let d=h.pop();for(;d;)T(d)&&(I(d.additionalItems,d.additionalProperties,d.not,d.contains,d.propertyNames,d.if,d.then,d.else,d.unevaluatedItems,d.unevaluatedProperties),p(d.definitions,d.$defs,d.properties,d.patternProperties,d.dependencies,d.dependentSchemas),c(d.anyOf,d.allOf,d.oneOf,d.prefixItems),m(d.items)),d=h.pop()}}),function(){function x(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function n(P){return P.replace(e,function(D,T,I,p,c,m){if(p)return"";if(c){const h=c.length;return c[h-1]===`
`?c[h-2]==="\r"?`\r
`:`
`:""}else return m?D.substring(1):D})}function r(P){const D=n(P);try{return JSON.parse(D)}catch{const I=D.replace(/,\s*([}\]])/g,"$1");return JSON.parse(I)}}return{stripComments:n,parse:r}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[65],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=n}),define(ce[108],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(D){this.element=D,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let D=this.a;for(;D!==n.Undefined;){const T=D.next;D.prev=n.Undefined,D.next=n.Undefined,D=T}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,T){const I=new n(D);if(this.a===n.Undefined)this.a=I,this.b=I;else if(T){const c=this.b;this.b=I,I.prev=c,c.next=I}else{const c=this.a;this.a=I,I.next=c,c.prev=I}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==n.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==n.Undefined&&D.next!==n.Undefined){const T=D.prev;T.next=D.next,D.next.prev=T}else D.prev===n.Undefined&&D.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):D.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):D.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==n.Undefined;)yield D.element,D=D.next}}e.$5c=r}),define(ce[31],le([0,1]),function(x,e){"use strict";var n,r,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=D,e.$yc=T,e.$zc=I,e.$Ic=S;function D(t,u,i){let o=t.get(u);return o===void 0&&(o=i,t.set(u,o)),o}function T(t){const u=[];return t.forEach((i,o)=>{u.push(`${o} => ${i}`)}),`Map(${t.size}) {${u.join(", ")}}`}function I(t){const u=[];return t.forEach(i=>{u.push(i)}),`Set(${t.size}) {${u.join(", ")}}`}class p{constructor(u,i){this.uri=u,this.value=i}}function c(t){return Array.isArray(t)}class m{static{this.c=u=>u.toString()}constructor(u,i){if(this[n]="ResourceMap",u instanceof m)this.d=new Map(u.d),this.e=i??m.c;else if(c(u)){this.d=new Map,this.e=i??m.c;for(const[o,s]of u)this.set(o,s)}else this.d=new Map,this.e=u??m.c}set(u,i){return this.d.set(this.e(u),new p(u,i)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,i){typeof i<"u"&&(u=u.bind(i));for(const[o,s]of this.d)u(s.value,s.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}e.$Ac=m;class h{constructor(u,i){this[r]="ResourceSet",!u||typeof u=="function"?this.c=new m(u):(this.c=new m(i),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,i){this.c.forEach((o,s)=>u.call(i,s,s,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=h;var d;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class w{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,i=d.None){const o=this.c.get(u);if(o)return i!==d.None&&this.m(o,i),o.value}set(u,i,o=d.None){let s=this.c.get(u);if(s)s.value=i,o!==d.None&&this.m(s,o);else{switch(s={key:u,value:i,next:void 0,previous:void 0},o){case d.None:this.k(s);break;case d.AsOld:this.j(s);break;case d.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(u,s),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const i=this.c.get(u);if(i)return this.c.delete(u),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,i){const o=this.g;let s=this.d;for(;s;){if(i?u.bind(i)(s.value,s.key,this):u(s.value,s.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.key,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}values(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.value,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}entries(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:[o.key,o.value],done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.d,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.next,o--;this.d=i,this.f=o,i&&(i.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.e,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.previous,o--;this.e=i,this.f=o,i&&(i.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const i=u.next,o=u.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}u.next=void 0,u.previous=void 0,this.g++}m(u,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==d.AsOld&&i!==d.AsNew)){if(i===d.AsOld){if(u===this.d)return;const o=u.next,s=u.previous;u===this.e?(s.next=void 0,this.e=s):(o.previous=s,s.next=o),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(i===d.AsNew){if(u===this.e)return;const o=u.next,s=u.previous;u===this.d?(o.previous=void 0,this.d=o):(o.previous=s,s.next=o),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((i,o)=>{u.push([o,i])}),u}fromJSON(u){this.clear();for(const[i,o]of u)this.set(i,o)}}e.$Cc=w;class f extends w{constructor(u,i=1){super(),this.n=u,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,i=d.AsNew){return super.get(u,i)}peek(u){return super.get(u,d.None)}set(u,i){return super.set(u,i,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends f{constructor(u,i=1){super(u,i)}q(u){this.h(u)}set(u,i){return super.set(u,i),this.p(),this}}e.$Dc=g;class v extends f{constructor(u,i=1){super(u,i)}q(u){this.i(u)}set(u,i){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,i),this}}e.$Ec=v;class b{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let i=this.c.get(u)||0;return i===0?!1:(i--,i===0?this.c.delete(u):this.c.set(u,i),!0)}has(u){return this.c.has(u)}}e.$Fc=b;class ${constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[i,o]of u)this.set(i,o)}clear(){this.c.clear(),this.d.clear()}set(u,i){this.c.set(u,i),this.d.set(i,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const i=this.c.get(u);return i===void 0?!1:(this.c.delete(u),this.d.delete(i),!0)}forEach(u,i){this.c.forEach((o,s)=>{u.call(i,o,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=$;class k{constructor(){this.c=new Map}add(u,i){let o=this.c.get(u);o||(o=new Set,this.c.set(u,o)),o.add(i)}delete(u,i){const o=this.c.get(u);o&&(o.delete(i),o.size===0&&this.c.delete(u))}forEach(u,i){const o=this.c.get(u);o&&o.forEach(i)}get(u){const i=this.c.get(u);return i||new Set}}e.$Hc=k;function S(t,u){if(t===u)return!0;if(t.size!==u.size)return!1;for(const[i,o]of t)if(!u.has(i)||u.get(i)!==o)return!1;for(const[i]of u)if(!t.has(i))return!1;return!0}}),define(ce[2],le([0,1,21,139,31,89,77]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=m,e.$Lc=h,e.$Mc=d,e.$Nc=g,e.$Oc=v,e.$Pc=b,e.$Qc=$,e.$Rc=k,e.$Sc=S,e.$3c=R;const I=!1;let p=null;class c{constructor(){this.b=new Map}static{this.a=0}c(O){let M=this.b.get(O);return M||(M={parent:null,source:null,isSingleton:!1,value:O,idx:c.a++},this.b.set(O,M)),M}trackDisposable(O){const M=this.c(O);M.source||(M.source=new Error().stack)}setParent(O,M){const H=this.c(O);H.parent=M}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,M){const H=M.get(O);if(H)return H;const q=O.parent?this.f(this.c(O.parent),M):O;return M.set(O,q),q}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,H])=>H.source!==null&&!this.f(H,O).isSingleton).flatMap(([H])=>H)}computeLeakingDisposables(O=10,M){let H;if(M)H=M;else{const J=new Map,U=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,J).isSingleton);if(U.length===0)return;const Z=new Set(U.map(W=>W.value));if(H=U.filter(W=>!(W.parent&&Z.has(W.parent))),H.length===0)throw new Error("There are cyclic diposable chains!")}if(!H)return;function q(J){function U(W,j){for(;W.length>0&&j.some(C=>typeof C=="string"?C===W[0]:W[0].match(C));)W.shift()}const Z=J.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return U(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const K=new P.$Hc;for(const J of H){const U=q(J);for(let Z=0;Z<=U.length;Z++)K.add(U.slice(0,Z).join(`
`),J)}H.sort((0,n.$5b)(J=>J.idx,n.$7b));let de="",Y=0;for(const J of H.slice(0,O)){Y++;const U=q(J),Z=[];for(let W=0;W<U.length;W++){let j=U[W];j=`(shared with ${K.get(U.slice(0,W+1).join(`
`)).size}/${H.length} leaks) at ${j}`;const X=K.get(U.slice(0,W).join(`
`)),oe=(0,r.$c)([...X].map(V=>q(V)[W]),V=>V);delete oe[U[W]];for(const[V,ue]of Object.entries(oe))Z.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${V}`);Z.unshift(j)}de+=`


==================== Leaking disposable ${Y}/${H.length}: ${J.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return H.length>O&&(de+=`


... and ${H.length-O} more leaking disposables

`),{leaks:H,details:de}}}e.$Jc=c;function m(A){p=A}if(I){const A="__is_disposable_tracked__";m(new class{trackDisposable(O){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[A]||console.log(M)},3e3)}setParent(O,M){if(O&&O!==u.None)try{O[A]=!0}catch{}}markAsDisposed(O){if(O&&O!==u.None)try{O[A]=!0}catch{}}markAsSingleton(O){}})}function h(A){return p?.trackDisposable(A),A}function d(A){p?.markAsDisposed(A)}function w(A,O){p?.setParent(A,O)}function f(A,O){if(p)for(const M of A)p.setParent(M,O)}function g(A){return p?.markAsSingleton(A),A}function v(A){return typeof A=="object"&&A!==null&&typeof A.dispose=="function"&&A.dispose.length===0}function b(A){if(T.Iterable.is(A)){const O=[];for(const M of A)if(M)try{M.dispose()}catch(H){O.push(H)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}function $(A){for(const O of A)v(O)&&O.dispose();return[]}function k(...A){const O=S(()=>b(A));return f(A,O),O}function S(A){const O=h({dispose:(0,D.$cb)(()=>{d(O),A()})});return O}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,h(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return w(O,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),w(O,null))}}e.$Tc=t;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,h(this),w(this.q,this)}dispose(){d(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}e.$Uc=u;class i{constructor(){this.b=!1,h(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&w(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&w(O,null),O}}e.$Vc=i;class o{constructor(O){this.a=new i,this.b=!1,this.a.value=O}get value(){return this.a.value}set value(O){this.b||O===this.a.value||(this.a.value=O)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=o;class s{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(O){let M=O;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,d(this))},this}}e.$Yc=a;class l{constructor(){this.a=new Map}acquire(O,...M){let H=this.a.get(O);H||(H={counter:0,object:this.b(O,...M)},this.a.set(O,H));const{object:q}=H,K=(0,D.$cb)(()=>{--H.counter===0&&(this.c(O,H.object),this.a.delete(O))});return H.counter++,{object:q,dispose:K}}}e.$Zc=l;class E{constructor(O){this.a=O}async acquire(O,...M){const H=this.a.acquire(O,...M);try{return{object:await H.object,dispose:()=>H.dispose()}}catch(q){throw H.dispose(),q}}}e.$1c=E;class y{constructor(O){this.object=O}dispose(){}}e.$2c=y;function R(A){const O=new t;try{A(O)}finally{O.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,h(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,M,H=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),H||this.a.get(O)?.dispose(),this.a.set(O,M)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}deleteAndLeak(O){const M=this.a.get(O);return this.a.delete(O),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=L}),define(ce[90],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(ce[78],le([0,1,31]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=P,e.$nm=T;const r=new n.$Dc(1e4);function P(c){return p(c,"NFC",r)}const D=new n.$Dc(1e4);function T(c){return p(c,"NFD",D)}const I=/[^\u0000-\u0080]/;function p(c,m,h){if(!c)return c;const d=h.get(c);if(d)return d;let w;return I.test(c)?w=c.normalize(m):w=c,h.set(c,w),w}e.$om=function(){const c=/[\u0300-\u036f]/g;return function(m){return T(m).replace(c,"")}}()}),define(ce[144],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=n,e.rot=r,e.$Pm=I;function n(p,c,m){return Math.min(Math.max(p,c),m)}function r(p,c){return(c+p%c)%c}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=P;class D{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=D;class T{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const m=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=T;function I(p,c,m,h,d,w,f,g){const v=f-m,b=g-h,$=d-m,k=w-h,S=p-m,t=c-h,u=v*v+b*b,i=v*$+b*k,o=v*S+b*t,s=$*$+k*k,a=$*S+k*t,l=1/(u*s-i*i),E=(s*o-i*a)*l,y=(u*a-i*o)*l;return E>=0&&y>=0&&E+y<1}}),function(){function x(P){const D=[];typeof P=="number"&&D.push("code/timeOrigin",P);function T(p){D.push(p,Date.now())}function I(){const p=[];for(let c=0;c<D.length;c+=2)p.push({name:D[c],startTime:D[c+1]});return p}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))D.push({name:T.name,startTime:Math.round(P+T.startTime)});return D}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(ce[3],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=u,e.$E=E,e.$K=y,e.$h="en";let n=!1,r=!1,P=!1,D=!1,T=!1,I=!1,p=!1,c=!1,m=!1,h=!1,d,w=e.$h,f=e.$h,g,v;const b=globalThis;let $;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?$=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const k=typeof $?.versions?.electron=="string",S=k&&$?.type==="renderer";if(typeof $=="object"){n=$.platform==="win32",r=$.platform==="darwin",P=$.platform==="linux",D=P&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=k,m=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$h,w=e.$h;const R=$.env.VSCODE_NLS_CONFIG;if(R)try{const L=JSON.parse(R);d=L.userLocale,f=L.osLocale,w=L.resolvedLanguage||e.$h,g=L.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!S?(v=navigator.userAgent,n=v.indexOf("Windows")>=0,r=v.indexOf("Macintosh")>=0,c=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=v.indexOf("Linux")>=0,h=v?.indexOf("Mobi")>=0,I=!0,w=globalThis._VSCODE_NLS_LANGUAGE||e.$h,d=navigator.language.toLowerCase(),f=d):console.error("Unable to resolve platform.");var t;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(R){switch(R){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let i=t.Web;r?i=t.Mac:n?i=t.Windows:P&&(i=t.Linux),e.$j=n,e.$k=r,e.$l=P,e.$m=D,e.$n=T,e.$o=p,e.$p=I,e.$q=I&&typeof b.importScripts=="function",e.$r=e.$q?b.origin:void 0,e.$s=c,e.$t=h,e.$u=m,e.$v=i,e.$w=v,e.$x=w;var o;(function(R){function L(){return e.$x}R.value=L;function A(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}R.isDefaultVariant=A;function O(){return e.$x==="en"}R.isDefault=O})(o||(e.Language=o={})),e.$y=d,e.$z=f,e.$A=g,e.$B=typeof b.postMessage=="function"&&!b.importScripts,e.$C=(()=>{if(e.$B){const R=[];b.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let O=0,M=R.length;O<M;O++){const H=R[O];if(H.id===A.data.vscodeScheduleAsyncWork){R.splice(O,1),H.callback();return}}});let L=0;return A=>{const O=++L;R.push({id:O,callback:A}),b.postMessage({vscodeScheduleAsyncWork:O},"*")}}return R=>setTimeout(R)})();var s;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=r||c?s.Macintosh:n?s.Windows:s.Linux;let a=!0,l=!1;function E(){if(!l){l=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,a=new Uint16Array(R.buffer)[0]===513}return a}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(R){return parseFloat(R)>=20}}),define(ce[36],le([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let r;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const D=P.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$j?"win32":n.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$dc=r.platform,e.$ec=r.arch});var Dt=this&&this.__createBinding||(Object.create?function(x,e,n,r){r===void 0&&(r=n);var P=Object.getOwnPropertyDescriptor(e,n);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(x,r,P)}:function(x,e,n,r){r===void 0&&(r=n),x[r]=e[n]}),At=this&&this.__setModuleDefault||(Object.create?function(x,e){Object.defineProperty(x,"default",{enumerable:!0,value:e})}:function(x,e){x.default=e}),Pe=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var e={};if(x!=null)for(var n in x)n!=="default"&&Object.prototype.hasOwnProperty.call(x,n)&&Dt(e,x,n);return At(e,x),e};define(ce[9],le([0,1,36]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,n=Pe(n);const r=65,P=97,D=90,T=122,I=46,p=47,c=92,m=58,h=63;class d extends Error{constructor(o,s,a){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const E=o.indexOf(".")!==-1?"property":"argument";let y=`The "${o}" ${E} ${l} of type ${s}`;y+=`. Received type ${typeof a}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function w(i,o){if(i===null||typeof i!="object")throw new d(o,"Object",i)}function f(i,o){if(typeof i!="string")throw new d(o,"string",i)}const g=n.$dc==="win32";function v(i){return i===p||i===c}function b(i){return i===p}function $(i){return i>=r&&i<=D||i>=P&&i<=T}function k(i,o,s,a){let l="",E=0,y=-1,R=0,L=0;for(let A=0;A<=i.length;++A){if(A<i.length)L=i.charCodeAt(A);else{if(a(L))break;L=p}if(a(L)){if(!(y===A-1||R===1))if(R===2){if(l.length<2||E!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const O=l.lastIndexOf(s);O===-1?(l="",E=0):(l=l.slice(0,O),E=l.length-1-l.lastIndexOf(s)),y=A,R=0;continue}else if(l.length!==0){l="",E=0,y=A,R=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",E=2)}else l.length>0?l+=`${s}${i.slice(y+1,A)}`:l=i.slice(y+1,A),E=A-y-1;y=A,R=0}else L===I&&R!==-1?++R:R=-1}return l}function S(i){return i?`${i[0]==="."?"":"."}${i}`:""}function t(i,o){w(o,"pathObject");const s=o.dir||o.root,a=o.base||`${o.name||""}${S(o.ext)}`;return s?s===o.root?`${s}${a}`:`${s}${i}${a}`:a}e.$fc={resolve(...i){let o="",s="",a=!1;for(let l=i.length-1;l>=-1;l--){let E;if(l>=0){if(E=i[l],f(E,`paths[${l}]`),E.length===0)continue}else o.length===0?E=n.cwd():(E=n.env[`=${o}`]||n.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==o.toLowerCase()&&E.charCodeAt(2)===c)&&(E=`${o}\\`));const y=E.length;let R=0,L="",A=!1;const O=E.charCodeAt(0);if(y===1)v(O)&&(R=1,A=!0);else if(v(O))if(A=!0,v(E.charCodeAt(1))){let M=2,H=M;for(;M<y&&!v(E.charCodeAt(M));)M++;if(M<y&&M!==H){const q=E.slice(H,M);for(H=M;M<y&&v(E.charCodeAt(M));)M++;if(M<y&&M!==H){for(H=M;M<y&&!v(E.charCodeAt(M));)M++;(M===y||M!==H)&&(L=`\\\\${q}\\${E.slice(H,M)}`,R=M)}}}else R=1;else $(O)&&E.charCodeAt(1)===m&&(L=E.slice(0,2),R=2,y>2&&v(E.charCodeAt(2))&&(A=!0,R=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(a){if(o.length>0)break}else if(s=`${E.slice(R)}\\${s}`,a=A,A&&o.length>0)break}return s=k(s,!a,"\\",v),a?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){f(i,"path");const o=i.length;if(o===0)return".";let s=0,a,l=!1;const E=i.charCodeAt(0);if(o===1)return b(E)?"\\":i;if(v(E))if(l=!0,v(i.charCodeAt(1))){let R=2,L=R;for(;R<o&&!v(i.charCodeAt(R));)R++;if(R<o&&R!==L){const A=i.slice(L,R);for(L=R;R<o&&v(i.charCodeAt(R));)R++;if(R<o&&R!==L){for(L=R;R<o&&!v(i.charCodeAt(R));)R++;if(R===o)return`\\\\${A}\\${i.slice(L)}\\`;R!==L&&(a=`\\\\${A}\\${i.slice(L,R)}`,s=R)}}}else s=1;else $(E)&&i.charCodeAt(1)===m&&(a=i.slice(0,2),s=2,o>2&&v(i.charCodeAt(2))&&(l=!0,s=3));let y=s<o?k(i.slice(s),!l,"\\",v):"";return y.length===0&&!l&&(y="."),y.length>0&&v(i.charCodeAt(o-1))&&(y+="\\"),a===void 0?l?`\\${y}`:y:l?`${a}\\${y}`:`${a}${y}`},isAbsolute(i){f(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return v(s)||o>2&&$(s)&&i.charCodeAt(1)===m&&v(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let E=0;E<i.length;++E){const y=i[E];f(y,"path"),y.length>0&&(o===void 0?o=s=y:o+=`\\${y}`)}if(o===void 0)return".";let a=!0,l=0;if(typeof s=="string"&&v(s.charCodeAt(0))){++l;const E=s.length;E>1&&v(s.charCodeAt(1))&&(++l,E>2&&(v(s.charCodeAt(2))?++l:a=!1))}if(a){for(;l<o.length&&v(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.$fc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o)return"";const s=e.$fc.resolve(i),a=e.$fc.resolve(o);if(s===a||(i=s.toLowerCase(),o=a.toLowerCase(),i===o))return"";let l=0;for(;l<i.length&&i.charCodeAt(l)===c;)l++;let E=i.length;for(;E-1>l&&i.charCodeAt(E-1)===c;)E--;const y=E-l;let R=0;for(;R<o.length&&o.charCodeAt(R)===c;)R++;let L=o.length;for(;L-1>R&&o.charCodeAt(L-1)===c;)L--;const A=L-R,O=y<A?y:A;let M=-1,H=0;for(;H<O;H++){const K=i.charCodeAt(l+H);if(K!==o.charCodeAt(R+H))break;K===c&&(M=H)}if(H!==O){if(M===-1)return a}else{if(A>O){if(o.charCodeAt(R+H)===c)return a.slice(R+H+1);if(H===2)return a.slice(R+H)}y>O&&(i.charCodeAt(l+H)===c?M=H:H===2&&(M=3)),M===-1&&(M=0)}let q="";for(H=l+M+1;H<=E;++H)(H===E||i.charCodeAt(H)===c)&&(q+=q.length===0?"..":"\\..");return R+=M,q.length>0?`${q}${a.slice(R,L)}`:(a.charCodeAt(R)===c&&++R,a.slice(R,L))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const s=o.charCodeAt(2);if(s!==h&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if($(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return i},dirname(i){f(i,"path");const o=i.length;if(o===0)return".";let s=-1,a=0;const l=i.charCodeAt(0);if(o===1)return v(l)?i:".";if(v(l)){if(s=a=1,v(i.charCodeAt(1))){let R=2,L=R;for(;R<o&&!v(i.charCodeAt(R));)R++;if(R<o&&R!==L){for(L=R;R<o&&v(i.charCodeAt(R));)R++;if(R<o&&R!==L){for(L=R;R<o&&!v(i.charCodeAt(R));)R++;if(R===o)return i;R!==L&&(s=a=R+1)}}}}else $(l)&&i.charCodeAt(1)===m&&(s=o>2&&v(i.charCodeAt(2))?3:2,a=s);let E=-1,y=!0;for(let R=o-1;R>=a;--R)if(v(i.charCodeAt(R))){if(!y){E=R;break}}else y=!1;if(E===-1){if(s===-1)return".";E=s}return i.slice(0,E)},basename(i,o){o!==void 0&&f(o,"suffix"),f(i,"path");let s=0,a=-1,l=!0,E;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===m&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,R=-1;for(E=i.length-1;E>=s;--E){const L=i.charCodeAt(E);if(v(L)){if(!l){s=E+1;break}}else R===-1&&(l=!1,R=E+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=E):(y=-1,a=R))}return s===a?a=R:a===-1&&(a=i.length),i.slice(s,a)}for(E=i.length-1;E>=s;--E)if(v(i.charCodeAt(E))){if(!l){s=E+1;break}}else a===-1&&(l=!1,a=E+1);return a===-1?"":i.slice(s,a)},extname(i){f(i,"path");let o=0,s=-1,a=0,l=-1,E=!0,y=0;i.length>=2&&i.charCodeAt(1)===m&&$(i.charCodeAt(0))&&(o=a=2);for(let R=i.length-1;R>=o;--R){const L=i.charCodeAt(R);if(v(L)){if(!E){a=R+1;break}continue}l===-1&&(E=!1,l=R+1),L===I?s===-1?s=R:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||l===-1||y===0||y===1&&s===l-1&&s===a+1?"":i.slice(s,l)},format:t.bind(null,"\\"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let a=0,l=i.charCodeAt(0);if(s===1)return v(l)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(v(l)){if(a=1,v(i.charCodeAt(1))){let M=2,H=M;for(;M<s&&!v(i.charCodeAt(M));)M++;if(M<s&&M!==H){for(H=M;M<s&&v(i.charCodeAt(M));)M++;if(M<s&&M!==H){for(H=M;M<s&&!v(i.charCodeAt(M));)M++;M===s?a=M:M!==H&&(a=M+1)}}}}else if($(l)&&i.charCodeAt(1)===m){if(s<=2)return o.root=o.dir=i,o;if(a=2,v(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;a=3}}a>0&&(o.root=i.slice(0,a));let E=-1,y=a,R=-1,L=!0,A=i.length-1,O=0;for(;A>=a;--A){if(l=i.charCodeAt(A),v(l)){if(!L){y=A+1;break}continue}R===-1&&(L=!1,R=A+1),l===I?E===-1?E=A:O!==1&&(O=1):E!==-1&&(O=-1)}return R!==-1&&(E===-1||O===0||O===1&&E===R-1&&E===y+1?o.base=o.name=i.slice(y,R):(o.name=i.slice(y,E),o.base=i.slice(y,R),o.ext=i.slice(E,R))),y>0&&y!==a?o.dir=i.slice(0,y-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(g){const i=/\\/g;return()=>{const o=n.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...i){let o="",s=!1;for(let a=i.length-1;a>=-1&&!s;a--){const l=a>=0?i[a]:u();f(l,`paths[${a}]`),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===p)}return o=k(o,!s,"/",b),s?`/${o}`:o.length>0?o:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===p,s=i.charCodeAt(i.length-1)===p;return i=k(i,!o,"/",b),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===p},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const a=i[s];f(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const s=1,a=i.length,l=a-s,E=1,y=o.length-E,R=l<y?l:y;let L=-1,A=0;for(;A<R;A++){const M=i.charCodeAt(s+A);if(M!==o.charCodeAt(E+A))break;M===p&&(L=A)}if(A===R)if(y>R){if(o.charCodeAt(E+A)===p)return o.slice(E+A+1);if(A===0)return o.slice(E+A)}else l>R&&(i.charCodeAt(s+A)===p?L=A:A===0&&(L=0));let O="";for(A=s+L+1;A<=a;++A)(A===a||i.charCodeAt(A)===p)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(E+L)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===p;let s=-1,a=!0;for(let l=i.length-1;l>=1;--l)if(i.charCodeAt(l)===p){if(!a){s=l;break}}else a=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let s=0,a=-1,l=!0,E;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,R=-1;for(E=i.length-1;E>=0;--E){const L=i.charCodeAt(E);if(L===p){if(!l){s=E+1;break}}else R===-1&&(l=!1,R=E+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=E):(y=-1,a=R))}return s===a?a=R:a===-1&&(a=i.length),i.slice(s,a)}for(E=i.length-1;E>=0;--E)if(i.charCodeAt(E)===p){if(!l){s=E+1;break}}else a===-1&&(l=!1,a=E+1);return a===-1?"":i.slice(s,a)},extname(i){f(i,"path");let o=-1,s=0,a=-1,l=!0,E=0;for(let y=i.length-1;y>=0;--y){const R=i.charCodeAt(y);if(R===p){if(!l){s=y+1;break}continue}a===-1&&(l=!1,a=y+1),R===I?o===-1?o=y:E!==1&&(E=1):o!==-1&&(E=-1)}return o===-1||a===-1||E===0||E===1&&o===a-1&&o===s+1?"":i.slice(o,a)},format:t.bind(null,"/"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===p;let a;s?(o.root="/",a=1):a=0;let l=-1,E=0,y=-1,R=!0,L=i.length-1,A=0;for(;L>=a;--L){const O=i.charCodeAt(L);if(O===p){if(!R){E=L+1;break}continue}y===-1&&(R=!1,y=L+1),O===I?l===-1?l=L:A!==1&&(A=1):l!==-1&&(A=-1)}if(y!==-1){const O=E===0&&s?1:E;l===-1||A===0||A===1&&l===y-1&&l===E+1?o.base=o.name=i.slice(O,y):(o.name=i.slice(O,l),o.base=i.slice(O,y),o.ext=i.slice(l,y))}return E>0?o.dir=i.slice(0,E-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=g?e.$fc.normalize:e.$gc.normalize,e.$ic=g?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=g?e.$fc.join:e.$gc.join,e.$kc=g?e.$fc.resolve:e.$gc.resolve,e.$lc=g?e.$fc.relative:e.$gc.relative,e.$mc=g?e.$fc.dirname:e.$gc.dirname,e.$nc=g?e.$fc.basename:e.$gc.basename,e.$oc=g?e.$fc.extname:e.$gc.extname,e.$pc=g?e.$fc.format:e.$gc.format,e.$qc=g?e.$fc.parse:e.$gc.parse,e.$rc=g?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=g?e.$fc.sep:e.$gc.sep,e.$tc=g?e.$fc.delimiter:e.$gc.delimiter}),define(ce[79],le([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=D,e.$lm=T;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function D(I,...p){const c=p.reduce((d,w)=>(d[w]=!0,d),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(d=>!c[d]).forEach(d=>{for(let w=0;w<m.length;w++)if(d.search(m[w])!==-1){delete I[d];break}})}function T(I){I&&(delete I.DEBUG,n.$l&&delete I.LD_PRELOAD)}}),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:x)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function n(r){if(e[r])return e[r].exports;var P=e[r]={i:r,l:!1,exports:{}};return x[r].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=x,n.c=e,n.d=function(r,P,D){n.o(r,P)||Object.defineProperty(r,P,{enumerable:!0,get:D})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,P){if(1&P&&(r=n(r)),8&P||4&P&&typeof r=="object"&&r&&r.__esModule)return r;var D=Object.create(null);if(n.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:r}),2&P&&typeof r!="string")for(var T in r)n.d(D,T,function(I){return r[I]}.bind(null,T));return D},n.n=function(r){var P=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(P,"a",P),P},n.o=function(r,P){return Object.prototype.hasOwnProperty.call(r,P)},n.p="",n(n.s=0)}([function(x,e,n){(function(r){var P;e=x.exports=ue,P=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],p=e.src=[],c=0,m=c++;p[m]="0|[1-9]\\d*";var h=c++;p[h]="[0-9]+";var d=c++;p[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=c++;p[w]="("+p[m]+")\\.("+p[m]+")\\.("+p[m]+")";var f=c++;p[f]="("+p[h]+")\\.("+p[h]+")\\.("+p[h]+")";var g=c++;p[g]="(?:"+p[m]+"|"+p[d]+")";var v=c++;p[v]="(?:"+p[h]+"|"+p[d]+")";var b=c++;p[b]="(?:-("+p[g]+"(?:\\."+p[g]+")*))";var $=c++;p[$]="(?:-?("+p[v]+"(?:\\."+p[v]+")*))";var k=c++;p[k]="[0-9A-Za-z-]+";var S=c++;p[S]="(?:\\+("+p[k]+"(?:\\."+p[k]+")*))";var t=c++,u="v?"+p[w]+p[b]+"?"+p[S]+"?";p[t]="^"+u+"$";var i="[v=\\s]*"+p[f]+p[$]+"?"+p[S]+"?",o=c++;p[o]="^"+i+"$";var s=c++;p[s]="((?:<|>)?=?)";var a=c++;p[a]=p[h]+"|x|X|\\*";var l=c++;p[l]=p[m]+"|x|X|\\*";var E=c++;p[E]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[b]+")?"+p[S]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[$]+")?"+p[S]+"?)?)?";var R=c++;p[R]="^"+p[s]+"\\s*"+p[E]+"$";var L=c++;p[L]="^"+p[s]+"\\s*"+p[y]+"$";var A=c++;p[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=c++;p[O]="(?:~>?)";var M=c++;p[M]="(\\s*)"+p[O]+"\\s+",I[M]=new RegExp(p[M],"g");var H=c++;p[H]="^"+p[O]+p[E]+"$";var q=c++;p[q]="^"+p[O]+p[y]+"$";var K=c++;p[K]="(?:\\^)";var de=c++;p[de]="(\\s*)"+p[K]+"\\s+",I[de]=new RegExp(p[de],"g");var Y=c++;p[Y]="^"+p[K]+p[E]+"$";var J=c++;p[J]="^"+p[K]+p[y]+"$";var U=c++;p[U]="^"+p[s]+"\\s*("+i+")$|^$";var Z=c++;p[Z]="^"+p[s]+"\\s*("+u+")$|^$";var W=c++;p[W]="(\\s*)"+p[s]+"\\s*("+i+"|"+p[E]+")",I[W]=new RegExp(p[W],"g");var j=c++;p[j]="^\\s*("+p[E]+")\\s+-\\s+("+p[E]+")\\s*$";var C=c++;p[C]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var X=c++;p[X]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)P(oe,p[oe]),I[oe]||(I[oe]=new RegExp(p[oe]));function V(ee,ae){if(ee instanceof ue)return ee;if(typeof ee!="string"||ee.length>D||!(ae?I[o]:I[t]).test(ee))return null;try{return new ue(ee,ae)}catch{return null}}function ue(ee,ae){if(ee instanceof ue){if(ee.loose===ae)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof ue))return new ue(ee,ae);P("SemVer",ee,ae),this.loose=ae;var fe=ee.trim().match(ae?I[o]:I[t]);if(!fe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var De=+be;if(De>=0&&De<T)return De}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=V,e.valid=function(ee,ae){var fe=V(ee,ae);return fe?fe.version:null},e.clean=function(ee,ae){var fe=V(ee.trim().replace(/^[=v]+/,""),ae);return fe?fe.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(ee){return P("SemVer.compare",this.version,this.loose,ee),ee instanceof ue||(ee=new ue(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ue.prototype.compareMain=function(ee){return ee instanceof ue||(ee=new ue(ee,this.loose)),Q(this.major,ee.major)||Q(this.minor,ee.minor)||Q(this.patch,ee.patch)},ue.prototype.comparePre=function(ee){if(ee instanceof ue||(ee=new ue(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ae=0;do{var fe=this.prerelease[ae],be=ee.prerelease[ae];if(P("prerelease compare",ae,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return Q(fe,be)}while(++ae)},ue.prototype.inc=function(ee,ae){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ae,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new ue(ee,fe).inc(ae,be).version}catch{return null}},e.diff=function(ee,ae){if(z(ee,ae))return null;var fe=V(ee),be=V(ae);if(fe.prerelease.length||be.prerelease.length){for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==be[De])return"pre"+De;return"prerelease"}for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==be[De])return De},e.compareIdentifiers=Q;var re=/^[0-9]+$/;function Q(ee,ae){var fe=re.test(ee),be=re.test(ae);return fe&&be&&(ee=+ee,ae=+ae),fe&&!be?-1:be&&!fe?1:ee<ae?-1:ee>ae?1:0}function N(ee,ae,fe){return new ue(ee,fe).compare(new ue(ae,fe))}function F(ee,ae,fe){return N(ee,ae,fe)>0}function _(ee,ae,fe){return N(ee,ae,fe)<0}function z(ee,ae,fe){return N(ee,ae,fe)===0}function ie(ee,ae,fe){return N(ee,ae,fe)!==0}function G(ee,ae,fe){return N(ee,ae,fe)>=0}function B(ee,ae,fe){return N(ee,ae,fe)<=0}function te(ee,ae,fe,be){var De;switch(ae){case"===":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),De=ee===fe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),De=ee!==fe;break;case"":case"=":case"==":De=z(ee,fe,be);break;case"!=":De=ie(ee,fe,be);break;case">":De=F(ee,fe,be);break;case">=":De=G(ee,fe,be);break;case"<":De=_(ee,fe,be);break;case"<=":De=B(ee,fe,be);break;default:throw new TypeError("Invalid operator: "+ae)}return De}function he(ee,ae){if(ee instanceof he){if(ee.loose===ae)return ee;ee=ee.value}if(!(this instanceof he))return new he(ee,ae);P("comparator",ee,ae),this.loose=ae,this.parse(ee),this.semver===me?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(ee,ae){return Q(ae,ee)},e.major=function(ee,ae){return new ue(ee,ae).major},e.minor=function(ee,ae){return new ue(ee,ae).minor},e.patch=function(ee,ae){return new ue(ee,ae).patch},e.compare=N,e.compareLoose=function(ee,ae){return N(ee,ae,!0)},e.rcompare=function(ee,ae,fe){return N(ae,ee,fe)},e.sort=function(ee,ae){return ee.sort(function(fe,be){return e.compare(fe,be,ae)})},e.rsort=function(ee,ae){return ee.sort(function(fe,be){return e.rcompare(fe,be,ae)})},e.gt=F,e.lt=_,e.eq=z,e.neq=ie,e.gte=G,e.lte=B,e.cmp=te,e.Comparator=he;var me={};function we(ee,ae){if(ee instanceof we)return ee.loose===ae?ee:new we(ee.raw,ae);if(ee instanceof he)return new we(ee.value,ae);if(!(this instanceof we))return new we(ee,ae);if(this.loose=ae,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ie(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Ce(ee,ae,fe,be,De,Ne,Me,Ae,Be,Ge,Ze,qe,Xe){return((ae=Ie(fe)?"":Ie(be)?">="+fe+".0.0":Ie(De)?">="+fe+"."+be+".0":">="+ae)+" "+(Ae=Ie(Be)?"":Ie(Ge)?"<"+(+Be+1)+".0.0":Ie(Ze)?"<"+Be+"."+(+Ge+1)+".0":qe?"<="+Be+"."+Ge+"."+Ze+"-"+qe:"<="+Ae)).trim()}function Re(ee,ae){for(var fe=0;fe<ee.length;fe++)if(!ee[fe].test(ae))return!1;if(ae.prerelease.length){for(fe=0;fe<ee.length;fe++)if(P(ee[fe].semver),ee[fe].semver!==me&&ee[fe].semver.prerelease.length>0){var be=ee[fe].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function ve(ee,ae,fe){try{ae=new we(ae,fe)}catch{return!1}return ae.test(ee)}function $e(ee,ae,fe,be){var De,Ne,Me,Ae,Be;switch(ee=new ue(ee,be),ae=new we(ae,be),fe){case">":De=F,Ne=B,Me=_,Ae=">",Be=">=";break;case"<":De=_,Ne=G,Me=F,Ae="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(ee,ae,be))return!1;for(var Ge=0;Ge<ae.set.length;++Ge){var Ze=ae.set[Ge],qe=null,Xe=null;if(Ze.forEach(function(Qe){Qe.semver===me&&(Qe=new he(">=0.0.0")),qe=qe||Qe,Xe=Xe||Qe,De(Qe.semver,qe.semver,be)?qe=Qe:Me(Qe.semver,Xe.semver,be)&&(Xe=Qe)}),qe.operator===Ae||qe.operator===Be||(!Xe.operator||Xe.operator===Ae)&&Ne(ee,Xe.semver)||Xe.operator===Be&&Me(ee,Xe.semver))return!1}return!0}he.prototype.parse=function(ee){var ae=this.loose?I[U]:I[Z],fe=ee.match(ae);if(!fe)throw new TypeError("Invalid comparator: "+ee);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ue(fe[2],this.loose):this.semver=me},he.prototype.toString=function(){return this.value},he.prototype.test=function(ee){return P("Comparator.test",ee,this.loose),this.semver===me||(typeof ee=="string"&&(ee=new ue(ee,this.loose)),te(ee,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ee,ae){if(!(ee instanceof he))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(ee.value,ae),ve(this.value,fe,ae);if(ee.operator==="")return fe=new we(this.value,ae),ve(ee.semver,fe,ae);var be=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Ne=this.semver.version===ee.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ae=te(this.semver,"<",ee.semver,ae)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Be=te(this.semver,">",ee.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return be||De||Ne&&Me||Ae||Be},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ee){var ae=this.loose;ee=ee.trim(),P("range",ee,ae);var fe=ae?I[C]:I[j];ee=ee.replace(fe,Ce),P("hyphen replace",ee),ee=ee.replace(I[W],"$1$2$3"),P("comparator trim",ee,I[W]),ee=(ee=(ee=ee.replace(I[M],"$1~")).replace(I[de],"$1^")).split(/\s+/).join(" ");var be=ae?I[U]:I[Z],De=ee.split(" ").map(function(Ne){return function(Me,Ae){return P("comp",Me),Me=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Ze){return function(qe,Xe){P("caret",qe,Xe);var Qe=Xe?I[J]:I[Y];return qe.replace(Qe,function(Je,We,ne,ge,pe){var ye;return P("caret",qe,Je,We,ne,ge,pe),Ie(We)?ye="":Ie(ne)?ye=">="+We+".0.0 <"+(+We+1)+".0.0":Ie(ge)?ye=We==="0"?">="+We+"."+ne+".0 <"+We+"."+(+ne+1)+".0":">="+We+"."+ne+".0 <"+(+We+1)+".0.0":pe?(P("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=We==="0"?ne==="0"?">="+We+"."+ne+"."+ge+pe+" <"+We+"."+ne+"."+(+ge+1):">="+We+"."+ne+"."+ge+pe+" <"+We+"."+(+ne+1)+".0":">="+We+"."+ne+"."+ge+pe+" <"+(+We+1)+".0.0"):(P("no pr"),ye=We==="0"?ne==="0"?">="+We+"."+ne+"."+ge+" <"+We+"."+ne+"."+(+ge+1):">="+We+"."+ne+"."+ge+" <"+We+"."+(+ne+1)+".0":">="+We+"."+ne+"."+ge+" <"+(+We+1)+".0.0"),P("caret return",ye),ye})}(Ze,Ge)}).join(" ")}(Me,Ae),P("caret",Me),Me=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Ze){return function(qe,Xe){var Qe=Xe?I[q]:I[H];return qe.replace(Qe,function(Je,We,ne,ge,pe){var ye;return P("tilde",qe,Je,We,ne,ge,pe),Ie(We)?ye="":Ie(ne)?ye=">="+We+".0.0 <"+(+We+1)+".0.0":Ie(ge)?ye=">="+We+"."+ne+".0 <"+We+"."+(+ne+1)+".0":pe?(P("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+We+"."+ne+"."+ge+pe+" <"+We+"."+(+ne+1)+".0"):ye=">="+We+"."+ne+"."+ge+" <"+We+"."+(+ne+1)+".0",P("tilde return",ye),ye})}(Ze,Ge)}).join(" ")}(Me,Ae),P("tildes",Me),Me=function(Be,Ge){return P("replaceXRanges",Be,Ge),Be.split(/\s+/).map(function(Ze){return function(qe,Xe){qe=qe.trim();var Qe=Xe?I[L]:I[R];return qe.replace(Qe,function(Je,We,ne,ge,pe,ye){P("xRange",qe,Je,We,ne,ge,pe,ye);var je=Ie(ne),Ue=je||Ie(ge),_e=Ue||Ie(pe);return We==="="&&_e&&(We=""),je?Je=We===">"||We==="<"?"<0.0.0":"*":We&&_e?(Ue&&(ge=0),_e&&(pe=0),We===">"?(We=">=",Ue?(ne=+ne+1,ge=0,pe=0):_e&&(ge=+ge+1,pe=0)):We==="<="&&(We="<",Ue?ne=+ne+1:ge=+ge+1),Je=We+ne+"."+ge+"."+pe):Ue?Je=">="+ne+".0.0 <"+(+ne+1)+".0.0":_e&&(Je=">="+ne+"."+ge+".0 <"+ne+"."+(+ge+1)+".0"),P("xRange return",Je),Je})}(Ze,Ge)}).join(" ")}(Me,Ae),P("xrange",Me),Me=function(Be,Ge){return P("replaceStars",Be,Ge),Be.trim().replace(I[X],"")}(Me,Ae),P("stars",Me),Me}(Ne,ae)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Ne){return!!Ne.match(be)})),De=De.map(function(Ne){return new he(Ne,ae)})},we.prototype.intersects=function(ee,ae){if(!(ee instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return ee.set.some(function(De){return De.every(function(Ne){return be.intersects(Ne,ae)})})})})},e.toComparators=function(ee,ae){return new we(ee,ae).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ue(ee,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Re(this.set[ae],ee))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(ee,ae,fe){var be=null,De=null;try{var Ne=new we(ae,fe)}catch{return null}return ee.forEach(function(Me){Ne.test(Me)&&(be&&De.compare(Me)!==-1||(De=new ue(be=Me,fe)))}),be},e.minSatisfying=function(ee,ae,fe){var be=null,De=null;try{var Ne=new we(ae,fe)}catch{return null}return ee.forEach(function(Me){Ne.test(Me)&&(be&&De.compare(Me)!==1||(De=new ue(be=Me,fe)))}),be},e.validRange=function(ee,ae){try{return new we(ee,ae).range||"*"}catch{return null}},e.ltr=function(ee,ae,fe){return $e(ee,ae,"<",fe)},e.gtr=function(ee,ae,fe){return $e(ee,ae,">",fe)},e.outside=$e,e.prerelease=function(ee,ae){var fe=V(ee,ae);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ee,ae,fe){return ee=new we(ee,fe),ae=new we(ae,fe),ee.intersects(ae)},e.coerce=function(ee){if(ee instanceof ue)return ee;if(typeof ee!="string")return null;var ae=ee.match(I[A]);return ae==null?null:V((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,n(1))},function(x,e){var n,r,P=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(v){if(n===setTimeout)return setTimeout(v,0);if((n===D||!n)&&setTimeout)return n=setTimeout,setTimeout(v,0);try{return n(v,0)}catch{try{return n.call(null,v,0)}catch{return n.call(this,v,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:D}catch{n=D}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var p,c=[],m=!1,h=-1;function d(){m&&p&&(m=!1,p.length?c=p.concat(c):h=-1,c.length&&w())}function w(){if(!m){var v=I(d);m=!0;for(var b=c.length;b;){for(p=c,c=[];++h<b;)p&&p[h].run();h=-1,b=c.length}p=null,m=!1,function($){if(r===clearTimeout)return clearTimeout($);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout($);try{r($)}catch{try{return r.call(null,$)}catch{return r.call(this,$)}}}(v)}}function f(v,b){this.fun=v,this.array=b}function g(){}P.nextTick=function(v){var b=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)b[$-1]=arguments[$];c.push(new f(v,b)),c.length!==1||m||I(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(v){return[]},P.binding=function(v){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(v){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ce[145],le([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class r{constructor(I,p,c){this.level=I,this.key=p,this.value=c,this.forward=[]}}const P=void 0;class D{constructor(I,p=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new r(this.c,P,P)}get size(){return this.f}clear(){this.e=new r(this.c,P,P),this.f=0}has(I){return!!D.g(this,I,this.comparator)}get(I){return D.g(this,I,this.comparator)?.value}set(I,p){return D.h(this,I,p,this.comparator)&&(this.f+=1),this}delete(I){const p=D.k(this,I,this.comparator);return p&&(this.f-=1),p}forEach(I,p){let c=this.e.forward[0];for(;c;)I.call(p,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",p=this.e.forward[0];for(;p;)I+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return I}static g(I,p,c){let m=I.e;for(let h=I.d-1;h>=0;h--)for(;m.forward[h]&&c(m.forward[h].key,p)<0;)m=m.forward[h];if(m=m.forward[0],m&&c(m.key,p)===0)return m}static h(I,p,c,m){const h=[];let d=I.e;for(let w=I.d-1;w>=0;w--){for(;d.forward[w]&&m(d.forward[w].key,p)<0;)d=d.forward[w];h[w]=d}if(d=d.forward[0],d&&m(d.key,p)===0)return d.value=c,!1;{const w=D.j(I);if(w>I.d){for(let f=I.d;f<w;f++)h[f]=I.e;I.d=w}d=new r(w,p,c);for(let f=0;f<w;f++)d.forward[f]=h[f].forward[f],h[f].forward[f]=d;return!0}}static j(I,p=.5){let c=1;for(;Math.random()<p&&c<I.c;)c+=1;return c}static k(I,p,c){const m=[];let h=I.e;for(let d=I.d-1;d>=0;d--){for(;h.forward[d]&&c(h.forward[d].key,p)<0;)h=h.forward[d];m[d]=h}if(h=h.forward[0],!h||c(h.key,p)!==0)return!1;for(let d=0;d<I.d&&m[d].forward[d]===h;d++)m[d].forward[d]=h.forward[d];for(;I.d>0&&I.e.forward[I.d-1]===P;)I.d-=1;return!0}}e.$Ss=D}),define(ce[66],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(D){return new r(D)}constructor(D){this.c=n&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=r}),define(ce[4],le([0,1,15,89,2,108,66]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=w;const I=!1,p=!1,c=!1;var m;(function(q){q.None=()=>P.$Uc.None;function K(Re){if(c){const{onDidAddListener:ve}=Re,$e=g.create();let ee=0;Re.onDidAddListener=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),ve?.()}}}function de(Re,ve){return V(Re,()=>{},0,void 0,!0,void 0,ve)}q.defer=de;function Y(Re){return(ve,$e=null,ee)=>{let ae=!1,fe;return fe=Re(be=>{if(!ae)return fe?fe.dispose():ae=!0,ve.call($e,be)},null,ee),ae&&fe.dispose(),fe}}q.once=Y;function J(Re,ve,$e){return X((ee,ae=null,fe)=>Re(be=>ee.call(ae,ve(be)),null,fe),$e)}q.map=J;function U(Re,ve,$e){return X((ee,ae=null,fe)=>Re(be=>{ve(be),ee.call(ae,be)},null,fe),$e)}q.forEach=U;function Z(Re,ve,$e){return X((ee,ae=null,fe)=>Re(be=>ve(be)&&ee.call(ae,be),null,fe),$e)}q.filter=Z;function W(Re){return Re}q.signal=W;function j(...Re){return(ve,$e=null,ee)=>{const ae=(0,P.$Rc)(...Re.map(fe=>fe(be=>ve.call($e,be))));return oe(ae,ee)}}q.any=j;function C(Re,ve,$e,ee){let ae=$e;return J(Re,fe=>(ae=ve(ae,fe),ae),ee)}q.reduce=C;function X(Re,ve){let $e;const ee={onWillAddFirstListener(){$e=Re(ae.fire,ae)},onDidRemoveLastListener(){$e?.dispose()}};ve||K(ee);const ae=new i(ee);return ve?.add(ae),ae.event}function oe(Re,ve){return ve instanceof Array?ve.push(Re):ve&&ve.add(Re),Re}function V(Re,ve,$e=100,ee=!1,ae=!1,fe,be){let De,Ne,Me,Ae=0,Be;const Ge={leakWarningThreshold:fe,onWillAddFirstListener(){De=Re(qe=>{Ae++,Ne=ve(Ne,qe),ee&&!Me&&(Ze.fire(Ne),Ne=void 0),Be=()=>{const Xe=Ne;Ne=void 0,Me=void 0,(!ee||Ae>1)&&Ze.fire(Xe),Ae=0},typeof $e=="number"?(clearTimeout(Me),Me=setTimeout(Be,$e)):Me===void 0&&(Me=0,queueMicrotask(Be))})},onWillRemoveListener(){ae&&Ae>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,De.dispose()}};be||K(Ge);const Ze=new i(Ge);return be?.add(Ze),Ze.event}q.debounce=V;function ue(Re,ve=0,$e){return q.debounce(Re,(ee,ae)=>ee?(ee.push(ae),ee):[ae],ve,void 0,!0,void 0,$e)}q.accumulate=ue;function re(Re,ve=(ee,ae)=>ee===ae,$e){let ee=!0,ae;return Z(Re,fe=>{const be=ee||!ve(fe,ae);return ee=!1,ae=fe,be},$e)}q.latch=re;function Q(Re,ve,$e){return[q.filter(Re,ve,$e),q.filter(Re,ee=>!ve(ee),$e)]}q.split=Q;function N(Re,ve=!1,$e=[],ee){let ae=$e.slice(),fe=Re(Ne=>{ae?ae.push(Ne):De.fire(Ne)});ee&&ee.add(fe);const be=()=>{ae?.forEach(Ne=>De.fire(Ne)),ae=null},De=new i({onWillAddFirstListener(){fe||(fe=Re(Ne=>De.fire(Ne)),ee&&ee.add(fe))},onDidAddFirstListener(){ae&&(ve?setTimeout(be):be())},onDidRemoveLastListener(){fe&&fe.dispose(),fe=null}});return ee&&ee.add(De),De.event}q.buffer=N;function F(Re,ve){return(ee,ae,fe)=>{const be=ve(new z);return Re(function(De){const Ne=be.evaluate(De);Ne!==_&&ee.call(ae,Ne)},void 0,fe)}}q.chain=F;const _=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(ve){return this.f.push(ve),this}forEach(ve){return this.f.push($e=>(ve($e),$e)),this}filter(ve){return this.f.push($e=>ve($e)?$e:_),this}reduce(ve,$e){let ee=$e;return this.f.push(ae=>(ee=ve(ee,ae),ee)),this}latch(ve=($e,ee)=>$e===ee){let $e=!0,ee;return this.f.push(ae=>{const fe=$e||!ve(ae,ee);return $e=!1,ee=ae,fe?ae:_}),this}evaluate(ve){for(const $e of this.f)if(ve=$e(ve),ve===_)break;return ve}}function ie(Re,ve,$e=ee=>ee){const ee=(...De)=>be.fire($e(...De)),ae=()=>Re.on(ve,ee),fe=()=>Re.removeListener(ve,ee),be=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return be.event}q.fromNodeEventEmitter=ie;function G(Re,ve,$e=ee=>ee){const ee=(...De)=>be.fire($e(...De)),ae=()=>Re.addEventListener(ve,ee),fe=()=>Re.removeEventListener(ve,ee),be=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return be.event}q.fromDOMEventEmitter=G;function B(Re){return new Promise(ve=>Y(Re)(ve))}q.toPromise=B;function te(Re){const ve=new i;return Re.then($e=>{ve.fire($e)},()=>{ve.fire(void 0)}).finally(()=>{ve.dispose()}),ve.event}q.fromPromise=te;function he(Re,ve){return Re($e=>ve.fire($e))}q.forward=he;function me(Re,ve,$e){return ve($e),Re(ee=>ve(ee))}q.runAndSubscribe=me;class we{constructor(ve,$e){this._observable=ve,this.f=0,this.g=!1;const ee={onWillAddFirstListener:()=>{ve.addObserver(this)},onDidRemoveLastListener:()=>{ve.removeObserver(this)}};$e||K(ee),this.emitter=new i(ee),$e&&$e.add(this.emitter)}beginUpdate(ve){this.f++}handlePossibleChange(ve){}handleChange(ve,$e){this.g=!0}endUpdate(ve){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ie(Re,ve){return new we(Re,ve).emitter.event}q.fromObservable=Ie;function Ce(Re){return(ve,$e,ee)=>{let ae=0,fe=!1;const be={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(Re.reportChanges(),fe&&(fe=!1,ve.call($e)))},handlePossibleChange(){},handleChange(){fe=!0}};Re.addObserver(be),Re.reportChanges();const De={dispose(){Re.removeObserver(be)}};return ee instanceof P.$Tc?ee.add(De):Array.isArray(ee)&&ee.push(De),De}}q.fromObservableLight=Ce})(m||(e.Event=m={}));class h{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${h.f++}`,h.all.add(this)}start(K){this.g=new T.$fe,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}e.$he=h;let d=-1;function w(q){const K=d;return d=q,{dispose(){d=K}}}class f{static{this.f=1}constructor(K,de,Y=(f.f++).toString(16).padStart(3,"0")){this.j=K,this.threshold=de,this.name=Y,this.h=0}dispose(){this.g?.clear()}check(K,de){const Y=this.threshold;if(Y<=0||de<Y)return;this.g||(this.g=new Map);const J=this.g.get(K.value)||0;if(this.g.set(K.value,J+1),this.h-=1,this.h<=0){this.h=Y*.5;const[U,Z]=this.getMostFrequentStack(),W=`[${this.name}] potential listener LEAK detected, having ${de} listeners already. MOST frequent listener (${Z}):`;console.warn(W),console.warn(U);const j=new v(W,U);this.j(j)}return()=>{const U=this.g.get(K.value)||0;this.g.set(K.value,U-1)}}getMostFrequentStack(){if(!this.g)return;let K,de=0;for(const[Y,J]of this.g)(!K||de<J)&&(K=[Y,J],de=J);return K}}class g{static create(){const K=new Error;return new g(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(K,de){super(K),this.name="ListenerLeakError",this.stack=de}}e.$je=v;class b extends Error{constructor(K,de){super(K),this.name="ListenerRefusalError",this.stack=de}}e.$ke=b;let $=0;class k{constructor(K){this.value=K,this.id=$++}}const S=2,t=(q,K)=>{if(q instanceof k)K(q);else for(let de=0;de<q.length;de++){const Y=q[de];Y&&K(Y)}};let u;if(I){const q=[];setInterval(()=>{q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(q.join(`
`)),q.length=0)},3e3),u=new FinalizationRegistry(K=>{typeof K=="string"&&q.push(K)})}class i{constructor(K){this.z=0,this.f=K,this.g=d>0||this.f?.leakWarningThreshold?new f(K?.onListenerError??n.$Y,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const K=this.u;queueMicrotask(()=>{t(K,de=>de.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,de,Y)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const C=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],X=new b(`${j}. HINT: Stack shows most frequent listener (${C[1]}-times)`,C[0]);return(this.f?.onListenerError||n.$Y)(X),P.$Uc.None}if(this.m)return P.$Uc.None;de&&(K=K.bind(de));const J=new k(K);let U,Z;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(J.stack=g.create(),U=this.g.check(J.stack,this.z+1)),p&&(J.stack=Z??g.create()),this.u?this.u instanceof k?(this.w??=new s,this.u=[this.u,J]):this.u.push(J):(this.f?.onWillAddFirstListener?.(this),this.u=J,this.f?.onDidAddFirstListener?.(this)),this.z++;const W=(0,P.$Sc)(()=>{u?.unregister(W),U?.(),this.A(J)});if(Y instanceof P.$Tc?Y.add(W):Array.isArray(Y)&&Y.push(W),u){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),C=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);u.register(W,C?.[2]??j,W)}return W},this.q}A(K){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const de=this.u,Y=de.indexOf(K);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,de[Y]=void 0;const J=this.w.current===this;if(this.z*S<=de.length){let U=0;for(let Z=0;Z<de.length;Z++)de[Z]?de[U++]=de[Z]:J&&(this.w.end--,U<this.w.i&&this.w.i--);de.length=U}}B(K,de){if(!K)return;const Y=this.f?.onListenerError||n.$Y;if(!Y){K.value(de);return}try{K.value(de)}catch(J){Y(J)}}C(K){const de=K.current.u;for(;K.i<K.end;)this.B(de[K.i++],K.value);K.reset()}fire(K){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof k)this.B(this.u,K);else{const de=this.w;de.enqueue(this,K,this.u.length),this.C(de)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=i;const o=()=>new s;e.$me=o;class s{constructor(){this.i=-1,this.end=0}enqueue(K,de,Y){this.i=0,this.end=Y,this.current=K,this.value=de}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends i{async fireAsync(K,de,Y){if(this.u)for(this.h||(this.h=new D.$5c),t(this.u,J=>this.h.push([J.value,K]));this.h.size>0&&!de.isCancellationRequested;){const[J,U]=this.h.shift(),Z=[],W={...U,token:de,waitUntil:j=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");Y&&(j=Y(j,J)),Z.push(j)}};try{J(W)}catch(j){(0,n.$Y)(j);continue}Object.freeze(Z),await Promise.allSettled(Z).then(j=>{for(const C of j)C.status==="rejected"&&(0,n.$Y)(C.reason)})}}}e.$ne=a;class l extends i{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new D.$5c,this.t=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.t(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.z&&(this.h!==0?this.s.push(K):super.fire(K))}}e.$oe=l;class E extends l{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}e.$pe=E;class y extends i{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(de=>super.fire(de)),this.h=[]}))}}e.$qe=y;class R{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const de={event:K,listener:null};this.h.push(de),this.g&&this.m(de);const Y=()=>{this.g&&this.o(de);const J=this.h.indexOf(de);this.h.splice(J,1)};return(0,P.$Sc)((0,r.$cb)(Y))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(de=>this.f.fire(de))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}e.$re=R;class L{constructor(K,de,Y,J){this.f=new P.$Tc;const U=this.f.add(new R),Z=this.f.add(new P.$4c);function W(j){Z.set(j,U.add(J(j)))}for(const j of K)W(j);this.f.add(de(j=>{W(j)})),this.f.add(Y(j=>{Z.deleteAndDispose(j)})),this.event=U.event}dispose(){this.f.dispose()}}e.$se=L;class A{constructor(){this.f=[]}wrapEvent(K,de,Y){return(J,U,Z)=>K(W=>{const j=this.f[this.f.length-1];if(!de){j?j.buffers.push(()=>J.call(U,W)):J.call(U,W);return}const C=j;if(!C){J.call(U,de(Y,W));return}C.items??=[],C.items.push(W),C.buffers.length===0&&j.buffers.push(()=>{C.reducedResult??=Y?C.items.reduce(de,Y):C.items.reduce(de),J.call(U,C.reducedResult)})},void 0,Z)}bufferEvents(K){const de={buffers:new Array};this.f.push(de);const Y=K();return this.f.pop(),de.buffers.forEach(J=>J()),Y}}e.$te=A;class O{constructor(){this.f=!1,this.g=m.None,this.h=P.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=O;class M{static const(K){return new H(K)}constructor(K){this.g=K,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}e.$ve=M;class H{constructor(K){this.value=K,this.onDidChange=m.None}}}),define(ce[22],le([0,1,4]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=I;const r=Object.freeze(function(p,c){const m=setTimeout(p.bind(c),0);return{dispose(){clearTimeout(m)}}});var P;(function(p){function c(m){return m===p.None||m===p.Cancelled||m instanceof D?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}p.isCancellationToken=c,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(P||(e.CancellationToken=P={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=P.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=P.None}}e.$we=T;function I(p){const c=new T;return p.add({dispose(){c.cancel()}}),c.token}}),define(ce[146],le([0,1,22]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=P;class r{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new n.$we,c=this.b(p.token);return this.a={promise:c,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$9e=r;function P(I){return I}class D{constructor(p,c){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=P):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);return this.b!==c&&(this.b=c,this.a=this.c(p)),this.a}}e.$$e=D;class T{get cachedValues(){return this.a}constructor(p,c){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=P):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);if(this.b.has(c))return this.b.get(c);const m=this.c(p);return this.a.set(p,m),this.b.set(c,m),m}}e.$_e=T}),define(ce[67],le([0,1,15,2]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=P,e.$ze=D,e.$Ae=T,e.$Be=I,e.$Ce=c,e.$De=m,e.$Ee=h,e.$Fe=d,e.$Ge=w,e.$He=f,e.$Ie=g,e.$Je=v,e.$Ke=b,e.$Le=$,e.$Me=k;function P(S){const t=S;return t?typeof t.read=="function":!1}function D(S){const t=S;return t?[t.on,t.pause,t.resume,t.destroy].every(u=>typeof u=="function"):!1}function T(S){const t=S;return t?D(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function I(S,t){return new p(S,t)}class p{constructor(t,u){this.e=t,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(u=>u(t))}h(t){this.c.error.length===0?(0,n.$Y)(t):this.c.error.slice(0).forEach(u=>u(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,u){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(t,u){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const o=i.indexOf(u);o>=0&&i.splice(o,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(S,t){const u=[];let i;for(;(i=S.read())!==null;)u.push(i);return t(u)}function m(S,t,u){const i=[];let o;for(;(o=S.read())!==null&&i.length<u;)i.push(o);return o===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return S.read()}}}function h(S,t){return new Promise((u,i)=>{const o=[];d(S,{onData:s=>{t&&o.push(s)},onError:s=>{t?i(s):u(void 0)},onEnd:()=>{u(t?t(o):void 0)}})})}function d(S,t,u){S.on("error",i=>{u?.isCancellationRequested||t.onError(i)}),S.on("end",()=>{u?.isCancellationRequested||t.onEnd()}),S.on("data",i=>{u?.isCancellationRequested||t.onData(i)})}function w(S,t){return new Promise((u,i)=>{const o=new r.$Tc,s=[],a=y=>{if(s.push(y),s.length>t)return o.dispose(),S.pause(),u({stream:S,buffer:s,ended:!1})},l=y=>(o.dispose(),i(y)),E=()=>(o.dispose(),u({stream:S,buffer:s,ended:!0}));o.add((0,r.$Sc)(()=>S.removeListener("error",l))),S.on("error",l),o.add((0,r.$Sc)(()=>S.removeListener("end",E))),S.on("end",E),o.add((0,r.$Sc)(()=>S.removeListener("data",a))),S.on("data",a)})}function f(S,t){const u=I(t);return u.end(S),u}function g(){const S=I(()=>{throw new Error("not supported")});return S.end(),S}function v(S){let t=!1;return{read:()=>t?null:(t=!0,S)}}function b(S,t,u){const i=I(u);return d(S,{onData:o=>i.write(t.data(o)),onError:o=>i.error(t.error?t.error(o):o),onEnd:()=>i.end()}),i}function $(S,t,u){let i=!1;return{read:()=>{const o=t.read();return i?o:(i=!0,o!==null?u([S,o]):S)}}}function k(S,t,u){let i=!1;const o=I(u);return d(t,{onData:s=>i?o.write(s):(i=!0,o.write(u([S,s]))),onError:s=>o.error(s),onEnd:()=>{i||(i=!0,o.write(S)),o.end()}}),o}}),define(ce[17],le([0,1,65,67]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=c,e.$Pe=m,e.$Qe=h,e.$Re=d,e.$Se=w,e.$Te=f,e.$Ue=g,e.$Ve=v,e.$We=b,e.$Xe=$,e.$Ye=k,e.$Ze=S,e.$1e=t,e.$2e=u,e.$3e=i,e.$4e=o,e.$5e=s,e.$6e=a,e.$7e=l,e.$8e=R,r=Pe(r);const P=typeof Buffer<"u",D=new n.$T(()=>new Uint8Array(256));let T,I;class p{static alloc(A){return P?new p(Buffer.allocUnsafe(A)):new p(new Uint8Array(A))}static wrap(A){return P&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new p(A)}static fromString(A,O){return!(O?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from(A)):(T||(T=new TextEncoder),new p(T.encode(A)))}static fromByteArray(A){const O=p.alloc(A.length);for(let M=0,H=A.length;M<H;M++)O.buffer[M]=A[M];return O}static concat(A,O){if(typeof O>"u"){O=0;for(let q=0,K=A.length;q<K;q++)O+=A[q].byteLength}const M=p.alloc(O);let H=0;for(let q=0,K=A.length;q<K;q++){const de=A[q];M.set(de,H),H+=de.byteLength}return M}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=p.alloc(this.byteLength);return A.set(this),A}toString(){return P?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(A,O){return new p(this.buffer.subarray(A,O))}set(A,O){if(A instanceof p)this.buffer.set(A.buffer,O);else if(A instanceof Uint8Array)this.buffer.set(A,O);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),O);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return d(this.buffer,A)}writeUInt32BE(A,O){w(this.buffer,A,O)}readUInt32LE(A){return f(this.buffer,A)}writeUInt32LE(A,O){g(this.buffer,A,O)}readUInt8(A){return v(this.buffer,A)}writeUInt8(A,O){b(this.buffer,A,O)}indexOf(A,O=0){return c(this.buffer,A instanceof p?A.buffer:A,O)}}e.$Ne=p;function c(L,A,O=0){const M=A.byteLength,H=L.byteLength;if(M===0)return 0;if(M===1)return L.indexOf(A[0]);if(M>H-O)return-1;const q=D.value;q.fill(A.length);for(let J=0;J<A.length;J++)q[A[J]]=A.length-J-1;let K=O+A.length-1,de=K,Y=-1;for(;K<H;)if(L[K]===A[de]){if(de===0){Y=K;break}K--,de--}else K+=Math.max(A.length-de,q[L[K]]),de=A.length-1;return Y}function m(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0}function h(L,A,O){L[O+0]=A&255,A=A>>>8,L[O+1]=A&255}function d(L,A){return L[A]*2**24+L[A+1]*2**16+L[A+2]*2**8+L[A+3]}function w(L,A,O){L[O+3]=A,A=A>>>8,L[O+2]=A,A=A>>>8,L[O+1]=A,A=A>>>8,L[O]=A}function f(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0|L[A+2]<<16>>>0|L[A+3]<<24>>>0}function g(L,A,O){L[O+0]=A&255,A=A>>>8,L[O+1]=A&255,A=A>>>8,L[O+2]=A&255,A=A>>>8,L[O+3]=A&255}function v(L,A){return L[A]}function b(L,A,O){L[O]=A}function $(L){return r.$Ce(L,A=>p.concat(A))}function k(L){return r.$Je(L)}function S(L){return r.$Ee(L,A=>p.concat(A))}async function t(L){return L.ended?p.concat(L.buffer):p.concat([...L.buffer,await S(L.stream)])}function u(L){return r.$He(L,A=>p.concat(A))}function i(L){return r.$Ke(L,{data:A=>typeof A=="string"?p.fromString(A):p.wrap(A)},A=>p.concat(A))}function o(L){return r.$Be(A=>p.concat(A),L)}function s(L,A){return r.$Le(L,A,O=>p.concat(O))}function a(L,A){return r.$Me(L,A,O=>p.concat(O))}function l(L){let A=0,O=0,M=0;const H=new Uint8Array(Math.floor(L.length/4*3)),q=de=>{switch(O){case 3:H[M++]=A|de,O=0;break;case 2:H[M++]=A|de>>>2,A=de<<6,O=3;break;case 1:H[M++]=A|de>>>4,A=de<<4,O=2;break;default:A=de<<2,O=1}};for(let de=0;de<L.length;de++){const Y=L.charCodeAt(de);if(Y>=65&&Y<=90)q(Y-65);else if(Y>=97&&Y<=122)q(Y-97+26);else if(Y>=48&&Y<=57)q(Y-48+52);else if(Y===43||Y===45)q(62);else if(Y===47||Y===95)q(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${L[de]}`)}}const K=M;for(;O>0;)q(0);return p.wrap(H).slice(0,K)}const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:L},A=!0,O=!1){const M=O?y:E;let H="";const q=L.byteLength%3;let K=0;for(;K<L.byteLength-q;K+=3){const de=L[K+0],Y=L[K+1],J=L[K+2];H+=M[de>>>2],H+=M[(de<<4|Y>>>4)&63],H+=M[(Y<<2|J>>>6)&63],H+=M[J&63]}if(q===1){const de=L[K+0];H+=M[de>>>2],H+=M[de<<4&63],A&&(H+="==")}else if(q===2){const de=L[K+0],Y=L[K+1];H+=M[de>>>2],H+=M[(de<<4|Y>>>4)&63],H+=M[Y<<2&63],A&&(H+="=")}return H}}),define(ce[147],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(ce[12],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=n,e.$fg=r,e.$gg=P,e.$hg=D,e.$ig=T,e.$jg=I,e.$kg=p,e.$lg=c,e.$mg=m,e.$ng=h,e.$og=d,e.$pg=w,e.$qg=f,e.$rg=v,e.$sg=b,e.$tg=$,e.$ug=k,e.$vg=S;function n(t){return typeof t=="string"}function r(t){return Array.isArray(t)&&t.every(u=>n(u))}function P(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function D(t){const u=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof u}function T(t){return typeof t=="number"&&!isNaN(t)}function I(t){return!!t&&typeof t[Symbol.iterator]=="function"}function p(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function m(t){return!h(t)}function h(t){return c(t)||t===null}function d(t,u){if(!t)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function w(t){if(h(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function f(...t){const u=[];for(let i=0;i<t.length;i++){const o=t[i];if(h(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);u.push(o)}return u}const g=Object.prototype.hasOwnProperty;function v(t){if(!P(t))return!1;for(const u in t)if(g.call(t,u))return!1;return!0}function b(t){return typeof t=="function"}function $(...t){return t.length>0&&t.every(b)}function k(t,u){const i=Math.min(t.length,u.length);for(let o=0;o<i;o++)S(t[o],u[o])}function S(t,u){if(n(u)){if(typeof t!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(b(u)){try{if(t instanceof u)return}catch{}if(!h(t)&&t.constructor===u||u.length===1&&u.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ce[109],le([0,1,12]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=P,e.$Zj=D;const r=Object.create(null);function P(T,I){if((0,n.$eg)(I)){const p=r[I];if(p===void 0)throw new Error(`${T} references an unknown codicon: ${I}`);I=p}return r[T]=I,{id:T}}function D(){return r}}),define(ce[148],le([0,1,109]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=void 0,e.$1j={add:(0,n.$Yj)("add",6e4),plus:(0,n.$Yj)("plus",6e4),gistNew:(0,n.$Yj)("gist-new",6e4),repoCreate:(0,n.$Yj)("repo-create",6e4),lightbulb:(0,n.$Yj)("lightbulb",60001),lightBulb:(0,n.$Yj)("light-bulb",60001),repo:(0,n.$Yj)("repo",60002),repoDelete:(0,n.$Yj)("repo-delete",60002),gistFork:(0,n.$Yj)("gist-fork",60003),repoForked:(0,n.$Yj)("repo-forked",60003),gitPullRequest:(0,n.$Yj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Yj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Yj)("record-keys",60005),keyboard:(0,n.$Yj)("keyboard",60005),tag:(0,n.$Yj)("tag",60006),gitPullRequestLabel:(0,n.$Yj)("git-pull-request-label",60006),tagAdd:(0,n.$Yj)("tag-add",60006),tagRemove:(0,n.$Yj)("tag-remove",60006),person:(0,n.$Yj)("person",60007),personFollow:(0,n.$Yj)("person-follow",60007),personOutline:(0,n.$Yj)("person-outline",60007),personFilled:(0,n.$Yj)("person-filled",60007),gitBranch:(0,n.$Yj)("git-branch",60008),gitBranchCreate:(0,n.$Yj)("git-branch-create",60008),gitBranchDelete:(0,n.$Yj)("git-branch-delete",60008),sourceControl:(0,n.$Yj)("source-control",60008),mirror:(0,n.$Yj)("mirror",60009),mirrorPublic:(0,n.$Yj)("mirror-public",60009),star:(0,n.$Yj)("star",60010),starAdd:(0,n.$Yj)("star-add",60010),starDelete:(0,n.$Yj)("star-delete",60010),starEmpty:(0,n.$Yj)("star-empty",60010),comment:(0,n.$Yj)("comment",60011),commentAdd:(0,n.$Yj)("comment-add",60011),alert:(0,n.$Yj)("alert",60012),warning:(0,n.$Yj)("warning",60012),search:(0,n.$Yj)("search",60013),searchSave:(0,n.$Yj)("search-save",60013),logOut:(0,n.$Yj)("log-out",60014),signOut:(0,n.$Yj)("sign-out",60014),logIn:(0,n.$Yj)("log-in",60015),signIn:(0,n.$Yj)("sign-in",60015),eye:(0,n.$Yj)("eye",60016),eyeUnwatch:(0,n.$Yj)("eye-unwatch",60016),eyeWatch:(0,n.$Yj)("eye-watch",60016),circleFilled:(0,n.$Yj)("circle-filled",60017),primitiveDot:(0,n.$Yj)("primitive-dot",60017),closeDirty:(0,n.$Yj)("close-dirty",60017),debugBreakpoint:(0,n.$Yj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Yj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Yj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Yj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Yj)("primitive-square",60018),edit:(0,n.$Yj)("edit",60019),pencil:(0,n.$Yj)("pencil",60019),info:(0,n.$Yj)("info",60020),issueOpened:(0,n.$Yj)("issue-opened",60020),gistPrivate:(0,n.$Yj)("gist-private",60021),gitForkPrivate:(0,n.$Yj)("git-fork-private",60021),lock:(0,n.$Yj)("lock",60021),mirrorPrivate:(0,n.$Yj)("mirror-private",60021),close:(0,n.$Yj)("close",60022),removeClose:(0,n.$Yj)("remove-close",60022),x:(0,n.$Yj)("x",60022),repoSync:(0,n.$Yj)("repo-sync",60023),sync:(0,n.$Yj)("sync",60023),clone:(0,n.$Yj)("clone",60024),desktopDownload:(0,n.$Yj)("desktop-download",60024),beaker:(0,n.$Yj)("beaker",60025),microscope:(0,n.$Yj)("microscope",60025),vm:(0,n.$Yj)("vm",60026),deviceDesktop:(0,n.$Yj)("device-desktop",60026),file:(0,n.$Yj)("file",60027),fileText:(0,n.$Yj)("file-text",60027),more:(0,n.$Yj)("more",60028),ellipsis:(0,n.$Yj)("ellipsis",60028),kebabHorizontal:(0,n.$Yj)("kebab-horizontal",60028),mailReply:(0,n.$Yj)("mail-reply",60029),reply:(0,n.$Yj)("reply",60029),organization:(0,n.$Yj)("organization",60030),organizationFilled:(0,n.$Yj)("organization-filled",60030),organizationOutline:(0,n.$Yj)("organization-outline",60030),newFile:(0,n.$Yj)("new-file",60031),fileAdd:(0,n.$Yj)("file-add",60031),newFolder:(0,n.$Yj)("new-folder",60032),fileDirectoryCreate:(0,n.$Yj)("file-directory-create",60032),trash:(0,n.$Yj)("trash",60033),trashcan:(0,n.$Yj)("trashcan",60033),history:(0,n.$Yj)("history",60034),clock:(0,n.$Yj)("clock",60034),folder:(0,n.$Yj)("folder",60035),fileDirectory:(0,n.$Yj)("file-directory",60035),symbolFolder:(0,n.$Yj)("symbol-folder",60035),logoGithub:(0,n.$Yj)("logo-github",60036),markGithub:(0,n.$Yj)("mark-github",60036),github:(0,n.$Yj)("github",60036),terminal:(0,n.$Yj)("terminal",60037),console:(0,n.$Yj)("console",60037),repl:(0,n.$Yj)("repl",60037),zap:(0,n.$Yj)("zap",60038),symbolEvent:(0,n.$Yj)("symbol-event",60038),error:(0,n.$Yj)("error",60039),stop:(0,n.$Yj)("stop",60039),variable:(0,n.$Yj)("variable",60040),symbolVariable:(0,n.$Yj)("symbol-variable",60040),array:(0,n.$Yj)("array",60042),symbolArray:(0,n.$Yj)("symbol-array",60042),symbolModule:(0,n.$Yj)("symbol-module",60043),symbolPackage:(0,n.$Yj)("symbol-package",60043),symbolNamespace:(0,n.$Yj)("symbol-namespace",60043),symbolObject:(0,n.$Yj)("symbol-object",60043),symbolMethod:(0,n.$Yj)("symbol-method",60044),symbolFunction:(0,n.$Yj)("symbol-function",60044),symbolConstructor:(0,n.$Yj)("symbol-constructor",60044),symbolBoolean:(0,n.$Yj)("symbol-boolean",60047),symbolNull:(0,n.$Yj)("symbol-null",60047),symbolNumeric:(0,n.$Yj)("symbol-numeric",60048),symbolNumber:(0,n.$Yj)("symbol-number",60048),symbolStructure:(0,n.$Yj)("symbol-structure",60049),symbolStruct:(0,n.$Yj)("symbol-struct",60049),symbolParameter:(0,n.$Yj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Yj)("symbol-type-parameter",60050),symbolKey:(0,n.$Yj)("symbol-key",60051),symbolText:(0,n.$Yj)("symbol-text",60051),symbolReference:(0,n.$Yj)("symbol-reference",60052),goToFile:(0,n.$Yj)("go-to-file",60052),symbolEnum:(0,n.$Yj)("symbol-enum",60053),symbolValue:(0,n.$Yj)("symbol-value",60053),symbolRuler:(0,n.$Yj)("symbol-ruler",60054),symbolUnit:(0,n.$Yj)("symbol-unit",60054),activateBreakpoints:(0,n.$Yj)("activate-breakpoints",60055),archive:(0,n.$Yj)("archive",60056),arrowBoth:(0,n.$Yj)("arrow-both",60057),arrowDown:(0,n.$Yj)("arrow-down",60058),arrowLeft:(0,n.$Yj)("arrow-left",60059),arrowRight:(0,n.$Yj)("arrow-right",60060),arrowSmallDown:(0,n.$Yj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Yj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Yj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Yj)("arrow-small-up",60064),arrowUp:(0,n.$Yj)("arrow-up",60065),bell:(0,n.$Yj)("bell",60066),bold:(0,n.$Yj)("bold",60067),book:(0,n.$Yj)("book",60068),bookmark:(0,n.$Yj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Yj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Yj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Yj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Yj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Yj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Yj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Yj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Yj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Yj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Yj)("briefcase",60076),broadcast:(0,n.$Yj)("broadcast",60077),browser:(0,n.$Yj)("browser",60078),bug:(0,n.$Yj)("bug",60079),calendar:(0,n.$Yj)("calendar",60080),caseSensitive:(0,n.$Yj)("case-sensitive",60081),check:(0,n.$Yj)("check",60082),checklist:(0,n.$Yj)("checklist",60083),chevronDown:(0,n.$Yj)("chevron-down",60084),chevronLeft:(0,n.$Yj)("chevron-left",60085),chevronRight:(0,n.$Yj)("chevron-right",60086),chevronUp:(0,n.$Yj)("chevron-up",60087),chromeClose:(0,n.$Yj)("chrome-close",60088),chromeMaximize:(0,n.$Yj)("chrome-maximize",60089),chromeMinimize:(0,n.$Yj)("chrome-minimize",60090),chromeRestore:(0,n.$Yj)("chrome-restore",60091),circleOutline:(0,n.$Yj)("circle-outline",60092),circle:(0,n.$Yj)("circle",60092),debugBreakpointUnverified:(0,n.$Yj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Yj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Yj)("circle-slash",60093),circuitBoard:(0,n.$Yj)("circuit-board",60094),clearAll:(0,n.$Yj)("clear-all",60095),clippy:(0,n.$Yj)("clippy",60096),closeAll:(0,n.$Yj)("close-all",60097),cloudDownload:(0,n.$Yj)("cloud-download",60098),cloudUpload:(0,n.$Yj)("cloud-upload",60099),code:(0,n.$Yj)("code",60100),collapseAll:(0,n.$Yj)("collapse-all",60101),colorMode:(0,n.$Yj)("color-mode",60102),commentDiscussion:(0,n.$Yj)("comment-discussion",60103),creditCard:(0,n.$Yj)("credit-card",60105),dash:(0,n.$Yj)("dash",60108),dashboard:(0,n.$Yj)("dashboard",60109),database:(0,n.$Yj)("database",60110),debugContinue:(0,n.$Yj)("debug-continue",60111),debugDisconnect:(0,n.$Yj)("debug-disconnect",60112),debugPause:(0,n.$Yj)("debug-pause",60113),debugRestart:(0,n.$Yj)("debug-restart",60114),debugStart:(0,n.$Yj)("debug-start",60115),debugStepInto:(0,n.$Yj)("debug-step-into",60116),debugStepOut:(0,n.$Yj)("debug-step-out",60117),debugStepOver:(0,n.$Yj)("debug-step-over",60118),debugStop:(0,n.$Yj)("debug-stop",60119),debug:(0,n.$Yj)("debug",60120),deviceCameraVideo:(0,n.$Yj)("device-camera-video",60121),deviceCamera:(0,n.$Yj)("device-camera",60122),deviceMobile:(0,n.$Yj)("device-mobile",60123),diffAdded:(0,n.$Yj)("diff-added",60124),diffIgnored:(0,n.$Yj)("diff-ignored",60125),diffModified:(0,n.$Yj)("diff-modified",60126),diffRemoved:(0,n.$Yj)("diff-removed",60127),diffRenamed:(0,n.$Yj)("diff-renamed",60128),diff:(0,n.$Yj)("diff",60129),diffSidebyside:(0,n.$Yj)("diff-sidebyside",60129),discard:(0,n.$Yj)("discard",60130),editorLayout:(0,n.$Yj)("editor-layout",60131),emptyWindow:(0,n.$Yj)("empty-window",60132),exclude:(0,n.$Yj)("exclude",60133),extensions:(0,n.$Yj)("extensions",60134),eyeClosed:(0,n.$Yj)("eye-closed",60135),fileBinary:(0,n.$Yj)("file-binary",60136),fileCode:(0,n.$Yj)("file-code",60137),fileMedia:(0,n.$Yj)("file-media",60138),filePdf:(0,n.$Yj)("file-pdf",60139),fileSubmodule:(0,n.$Yj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Yj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Yj)("file-symlink-file",60142),fileZip:(0,n.$Yj)("file-zip",60143),files:(0,n.$Yj)("files",60144),filter:(0,n.$Yj)("filter",60145),flame:(0,n.$Yj)("flame",60146),foldDown:(0,n.$Yj)("fold-down",60147),foldUp:(0,n.$Yj)("fold-up",60148),fold:(0,n.$Yj)("fold",60149),folderActive:(0,n.$Yj)("folder-active",60150),folderOpened:(0,n.$Yj)("folder-opened",60151),gear:(0,n.$Yj)("gear",60152),gift:(0,n.$Yj)("gift",60153),gistSecret:(0,n.$Yj)("gist-secret",60154),gist:(0,n.$Yj)("gist",60155),gitCommit:(0,n.$Yj)("git-commit",60156),gitCompare:(0,n.$Yj)("git-compare",60157),compareChanges:(0,n.$Yj)("compare-changes",60157),gitMerge:(0,n.$Yj)("git-merge",60158),githubAction:(0,n.$Yj)("github-action",60159),githubAlt:(0,n.$Yj)("github-alt",60160),globe:(0,n.$Yj)("globe",60161),grabber:(0,n.$Yj)("grabber",60162),graph:(0,n.$Yj)("graph",60163),gripper:(0,n.$Yj)("gripper",60164),heart:(0,n.$Yj)("heart",60165),home:(0,n.$Yj)("home",60166),horizontalRule:(0,n.$Yj)("horizontal-rule",60167),hubot:(0,n.$Yj)("hubot",60168),inbox:(0,n.$Yj)("inbox",60169),issueReopened:(0,n.$Yj)("issue-reopened",60171),issues:(0,n.$Yj)("issues",60172),italic:(0,n.$Yj)("italic",60173),jersey:(0,n.$Yj)("jersey",60174),json:(0,n.$Yj)("json",60175),kebabVertical:(0,n.$Yj)("kebab-vertical",60176),key:(0,n.$Yj)("key",60177),law:(0,n.$Yj)("law",60178),lightbulbAutofix:(0,n.$Yj)("lightbulb-autofix",60179),linkExternal:(0,n.$Yj)("link-external",60180),link:(0,n.$Yj)("link",60181),listOrdered:(0,n.$Yj)("list-ordered",60182),listUnordered:(0,n.$Yj)("list-unordered",60183),liveShare:(0,n.$Yj)("live-share",60184),loading:(0,n.$Yj)("loading",60185),location:(0,n.$Yj)("location",60186),mailRead:(0,n.$Yj)("mail-read",60187),mail:(0,n.$Yj)("mail",60188),markdown:(0,n.$Yj)("markdown",60189),megaphone:(0,n.$Yj)("megaphone",60190),mention:(0,n.$Yj)("mention",60191),milestone:(0,n.$Yj)("milestone",60192),gitPullRequestMilestone:(0,n.$Yj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Yj)("mortar-board",60193),move:(0,n.$Yj)("move",60194),multipleWindows:(0,n.$Yj)("multiple-windows",60195),mute:(0,n.$Yj)("mute",60196),noNewline:(0,n.$Yj)("no-newline",60197),note:(0,n.$Yj)("note",60198),octoface:(0,n.$Yj)("octoface",60199),openPreview:(0,n.$Yj)("open-preview",60200),package:(0,n.$Yj)("package",60201),paintcan:(0,n.$Yj)("paintcan",60202),pin:(0,n.$Yj)("pin",60203),play:(0,n.$Yj)("play",60204),run:(0,n.$Yj)("run",60204),plug:(0,n.$Yj)("plug",60205),preserveCase:(0,n.$Yj)("preserve-case",60206),preview:(0,n.$Yj)("preview",60207),project:(0,n.$Yj)("project",60208),pulse:(0,n.$Yj)("pulse",60209),question:(0,n.$Yj)("question",60210),quote:(0,n.$Yj)("quote",60211),radioTower:(0,n.$Yj)("radio-tower",60212),reactions:(0,n.$Yj)("reactions",60213),references:(0,n.$Yj)("references",60214),refresh:(0,n.$Yj)("refresh",60215),regex:(0,n.$Yj)("regex",60216),remoteExplorer:(0,n.$Yj)("remote-explorer",60217),remote:(0,n.$Yj)("remote",60218),remove:(0,n.$Yj)("remove",60219),replaceAll:(0,n.$Yj)("replace-all",60220),replace:(0,n.$Yj)("replace",60221),repoClone:(0,n.$Yj)("repo-clone",60222),repoForcePush:(0,n.$Yj)("repo-force-push",60223),repoPull:(0,n.$Yj)("repo-pull",60224),repoPush:(0,n.$Yj)("repo-push",60225),report:(0,n.$Yj)("report",60226),requestChanges:(0,n.$Yj)("request-changes",60227),rocket:(0,n.$Yj)("rocket",60228),rootFolderOpened:(0,n.$Yj)("root-folder-opened",60229),rootFolder:(0,n.$Yj)("root-folder",60230),rss:(0,n.$Yj)("rss",60231),ruby:(0,n.$Yj)("ruby",60232),saveAll:(0,n.$Yj)("save-all",60233),saveAs:(0,n.$Yj)("save-as",60234),save:(0,n.$Yj)("save",60235),screenFull:(0,n.$Yj)("screen-full",60236),screenNormal:(0,n.$Yj)("screen-normal",60237),searchStop:(0,n.$Yj)("search-stop",60238),server:(0,n.$Yj)("server",60240),settingsGear:(0,n.$Yj)("settings-gear",60241),settings:(0,n.$Yj)("settings",60242),shield:(0,n.$Yj)("shield",60243),smiley:(0,n.$Yj)("smiley",60244),sortPrecedence:(0,n.$Yj)("sort-precedence",60245),splitHorizontal:(0,n.$Yj)("split-horizontal",60246),splitVertical:(0,n.$Yj)("split-vertical",60247),squirrel:(0,n.$Yj)("squirrel",60248),starFull:(0,n.$Yj)("star-full",60249),starHalf:(0,n.$Yj)("star-half",60250),symbolClass:(0,n.$Yj)("symbol-class",60251),symbolColor:(0,n.$Yj)("symbol-color",60252),symbolConstant:(0,n.$Yj)("symbol-constant",60253),symbolEnumMember:(0,n.$Yj)("symbol-enum-member",60254),symbolField:(0,n.$Yj)("symbol-field",60255),symbolFile:(0,n.$Yj)("symbol-file",60256),symbolInterface:(0,n.$Yj)("symbol-interface",60257),symbolKeyword:(0,n.$Yj)("symbol-keyword",60258),symbolMisc:(0,n.$Yj)("symbol-misc",60259),symbolOperator:(0,n.$Yj)("symbol-operator",60260),symbolProperty:(0,n.$Yj)("symbol-property",60261),wrench:(0,n.$Yj)("wrench",60261),wrenchSubaction:(0,n.$Yj)("wrench-subaction",60261),symbolSnippet:(0,n.$Yj)("symbol-snippet",60262),tasklist:(0,n.$Yj)("tasklist",60263),telescope:(0,n.$Yj)("telescope",60264),textSize:(0,n.$Yj)("text-size",60265),threeBars:(0,n.$Yj)("three-bars",60266),thumbsdown:(0,n.$Yj)("thumbsdown",60267),thumbsup:(0,n.$Yj)("thumbsup",60268),tools:(0,n.$Yj)("tools",60269),triangleDown:(0,n.$Yj)("triangle-down",60270),triangleLeft:(0,n.$Yj)("triangle-left",60271),triangleRight:(0,n.$Yj)("triangle-right",60272),triangleUp:(0,n.$Yj)("triangle-up",60273),twitter:(0,n.$Yj)("twitter",60274),unfold:(0,n.$Yj)("unfold",60275),unlock:(0,n.$Yj)("unlock",60276),unmute:(0,n.$Yj)("unmute",60277),unverified:(0,n.$Yj)("unverified",60278),verified:(0,n.$Yj)("verified",60279),versions:(0,n.$Yj)("versions",60280),vmActive:(0,n.$Yj)("vm-active",60281),vmOutline:(0,n.$Yj)("vm-outline",60282),vmRunning:(0,n.$Yj)("vm-running",60283),watch:(0,n.$Yj)("watch",60284),whitespace:(0,n.$Yj)("whitespace",60285),wholeWord:(0,n.$Yj)("whole-word",60286),window:(0,n.$Yj)("window",60287),wordWrap:(0,n.$Yj)("word-wrap",60288),zoomIn:(0,n.$Yj)("zoom-in",60289),zoomOut:(0,n.$Yj)("zoom-out",60290),listFilter:(0,n.$Yj)("list-filter",60291),listFlat:(0,n.$Yj)("list-flat",60292),listSelection:(0,n.$Yj)("list-selection",60293),selection:(0,n.$Yj)("selection",60293),listTree:(0,n.$Yj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Yj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Yj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Yj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Yj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Yj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Yj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Yj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Yj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Yj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Yj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Yj)("symbol-string",60301),debugReverseContinue:(0,n.$Yj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Yj)("debug-step-back",60303),debugRestartFrame:(0,n.$Yj)("debug-restart-frame",60304),debugAlt:(0,n.$Yj)("debug-alt",60305),callIncoming:(0,n.$Yj)("call-incoming",60306),callOutgoing:(0,n.$Yj)("call-outgoing",60307),menu:(0,n.$Yj)("menu",60308),expandAll:(0,n.$Yj)("expand-all",60309),feedback:(0,n.$Yj)("feedback",60310),gitPullRequestReviewer:(0,n.$Yj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Yj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Yj)("ungroup-by-ref-type",60312),account:(0,n.$Yj)("account",60313),gitPullRequestAssignee:(0,n.$Yj)("git-pull-request-assignee",60313),bellDot:(0,n.$Yj)("bell-dot",60314),debugConsole:(0,n.$Yj)("debug-console",60315),library:(0,n.$Yj)("library",60316),output:(0,n.$Yj)("output",60317),runAll:(0,n.$Yj)("run-all",60318),syncIgnored:(0,n.$Yj)("sync-ignored",60319),pinned:(0,n.$Yj)("pinned",60320),githubInverted:(0,n.$Yj)("github-inverted",60321),serverProcess:(0,n.$Yj)("server-process",60322),serverEnvironment:(0,n.$Yj)("server-environment",60323),pass:(0,n.$Yj)("pass",60324),issueClosed:(0,n.$Yj)("issue-closed",60324),stopCircle:(0,n.$Yj)("stop-circle",60325),playCircle:(0,n.$Yj)("play-circle",60326),record:(0,n.$Yj)("record",60327),debugAltSmall:(0,n.$Yj)("debug-alt-small",60328),vmConnect:(0,n.$Yj)("vm-connect",60329),cloud:(0,n.$Yj)("cloud",60330),merge:(0,n.$Yj)("merge",60331),export:(0,n.$Yj)("export",60332),graphLeft:(0,n.$Yj)("graph-left",60333),magnet:(0,n.$Yj)("magnet",60334),notebook:(0,n.$Yj)("notebook",60335),redo:(0,n.$Yj)("redo",60336),checkAll:(0,n.$Yj)("check-all",60337),pinnedDirty:(0,n.$Yj)("pinned-dirty",60338),passFilled:(0,n.$Yj)("pass-filled",60339),circleLargeFilled:(0,n.$Yj)("circle-large-filled",60340),circleLarge:(0,n.$Yj)("circle-large",60341),circleLargeOutline:(0,n.$Yj)("circle-large-outline",60341),combine:(0,n.$Yj)("combine",60342),gather:(0,n.$Yj)("gather",60342),table:(0,n.$Yj)("table",60343),variableGroup:(0,n.$Yj)("variable-group",60344),typeHierarchy:(0,n.$Yj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Yj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Yj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Yj)("git-pull-request-create",60348),runAbove:(0,n.$Yj)("run-above",60349),runBelow:(0,n.$Yj)("run-below",60350),notebookTemplate:(0,n.$Yj)("notebook-template",60351),debugRerun:(0,n.$Yj)("debug-rerun",60352),workspaceTrusted:(0,n.$Yj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Yj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Yj)("workspace-unknown",60355),terminalCmd:(0,n.$Yj)("terminal-cmd",60356),terminalDebian:(0,n.$Yj)("terminal-debian",60357),terminalLinux:(0,n.$Yj)("terminal-linux",60358),terminalPowershell:(0,n.$Yj)("terminal-powershell",60359),terminalTmux:(0,n.$Yj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Yj)("terminal-ubuntu",60361),terminalBash:(0,n.$Yj)("terminal-bash",60362),arrowSwap:(0,n.$Yj)("arrow-swap",60363),copy:(0,n.$Yj)("copy",60364),personAdd:(0,n.$Yj)("person-add",60365),filterFilled:(0,n.$Yj)("filter-filled",60366),wand:(0,n.$Yj)("wand",60367),debugLineByLine:(0,n.$Yj)("debug-line-by-line",60368),inspect:(0,n.$Yj)("inspect",60369),layers:(0,n.$Yj)("layers",60370),layersDot:(0,n.$Yj)("layers-dot",60371),layersActive:(0,n.$Yj)("layers-active",60372),compass:(0,n.$Yj)("compass",60373),compassDot:(0,n.$Yj)("compass-dot",60374),compassActive:(0,n.$Yj)("compass-active",60375),azure:(0,n.$Yj)("azure",60376),issueDraft:(0,n.$Yj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Yj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Yj)("git-pull-request-draft",60379),debugAll:(0,n.$Yj)("debug-all",60380),debugCoverage:(0,n.$Yj)("debug-coverage",60381),runErrors:(0,n.$Yj)("run-errors",60382),folderLibrary:(0,n.$Yj)("folder-library",60383),debugContinueSmall:(0,n.$Yj)("debug-continue-small",60384),beakerStop:(0,n.$Yj)("beaker-stop",60385),graphLine:(0,n.$Yj)("graph-line",60386),graphScatter:(0,n.$Yj)("graph-scatter",60387),pieChart:(0,n.$Yj)("pie-chart",60388),bracket:(0,n.$Yj)("bracket",60175),bracketDot:(0,n.$Yj)("bracket-dot",60389),bracketError:(0,n.$Yj)("bracket-error",60390),lockSmall:(0,n.$Yj)("lock-small",60391),azureDevops:(0,n.$Yj)("azure-devops",60392),verifiedFilled:(0,n.$Yj)("verified-filled",60393),newline:(0,n.$Yj)("newline",60394),layout:(0,n.$Yj)("layout",60395),layoutActivitybarLeft:(0,n.$Yj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Yj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Yj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Yj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Yj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Yj)("layout-panel-right",60401),layoutPanel:(0,n.$Yj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Yj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Yj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Yj)("layout-statusbar",60405),layoutMenubar:(0,n.$Yj)("layout-menubar",60406),layoutCentered:(0,n.$Yj)("layout-centered",60407),target:(0,n.$Yj)("target",60408),indent:(0,n.$Yj)("indent",60409),recordSmall:(0,n.$Yj)("record-small",60410),errorSmall:(0,n.$Yj)("error-small",60411),terminalDecorationError:(0,n.$Yj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Yj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Yj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Yj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Yj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Yj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Yj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Yj)("layout-sidebar-left-off",60418),blank:(0,n.$Yj)("blank",60419),heartFilled:(0,n.$Yj)("heart-filled",60420),map:(0,n.$Yj)("map",60421),mapHorizontal:(0,n.$Yj)("map-horizontal",60421),foldHorizontal:(0,n.$Yj)("fold-horizontal",60421),mapFilled:(0,n.$Yj)("map-filled",60422),mapHorizontalFilled:(0,n.$Yj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Yj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Yj)("circle-small",60423),bellSlash:(0,n.$Yj)("bell-slash",60424),bellSlashDot:(0,n.$Yj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Yj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Yj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Yj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Yj)("search-fuzzy",60429),commentDraft:(0,n.$Yj)("comment-draft",60430),send:(0,n.$Yj)("send",60431),sparkle:(0,n.$Yj)("sparkle",60432),insert:(0,n.$Yj)("insert",60433),mic:(0,n.$Yj)("mic",60434),thumbsdownFilled:(0,n.$Yj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Yj)("thumbsup-filled",60436),coffee:(0,n.$Yj)("coffee",60437),snake:(0,n.$Yj)("snake",60438),game:(0,n.$Yj)("game",60439),vr:(0,n.$Yj)("vr",60440),chip:(0,n.$Yj)("chip",60441),piano:(0,n.$Yj)("piano",60442),music:(0,n.$Yj)("music",60443),micFilled:(0,n.$Yj)("mic-filled",60444),repoFetch:(0,n.$Yj)("repo-fetch",60445),copilot:(0,n.$Yj)("copilot",60446),lightbulbSparkle:(0,n.$Yj)("lightbulb-sparkle",60447),robot:(0,n.$Yj)("robot",60448),sparkleFilled:(0,n.$Yj)("sparkle-filled",60449),diffSingle:(0,n.$Yj)("diff-single",60450),diffMultiple:(0,n.$Yj)("diff-multiple",60451),surroundWith:(0,n.$Yj)("surround-with",60452),share:(0,n.$Yj)("share",60453),gitStash:(0,n.$Yj)("git-stash",60454),gitStashApply:(0,n.$Yj)("git-stash-apply",60455),gitStashPop:(0,n.$Yj)("git-stash-pop",60456),vscode:(0,n.$Yj)("vscode",60457),vscodeInsiders:(0,n.$Yj)("vscode-insiders",60458),codeOss:(0,n.$Yj)("code-oss",60459),runCoverage:(0,n.$Yj)("run-coverage",60460),runAllCoverage:(0,n.$Yj)("run-all-coverage",60461),coverage:(0,n.$Yj)("coverage",60462),githubProject:(0,n.$Yj)("github-project",60463),mapVertical:(0,n.$Yj)("map-vertical",60464),foldVertical:(0,n.$Yj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Yj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Yj)("fold-vertical-filled",60465),goToSearch:(0,n.$Yj)("go-to-search",60466),percentage:(0,n.$Yj)("percentage",60467),sortPercentage:(0,n.$Yj)("sort-percentage",60467),attach:(0,n.$Yj)("attach",60468)}}),define(ce[80],le([0,1,109,148]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=void 0,e.$2j=P;function P(){return Object.values(e.$4j)}e.$3j={dialogError:(0,n.$Yj)("dialog-error","error"),dialogWarning:(0,n.$Yj)("dialog-warning","warning"),dialogInfo:(0,n.$Yj)("dialog-info","info"),dialogClose:(0,n.$Yj)("dialog-close","close"),treeItemExpanded:(0,n.$Yj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Yj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Yj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Yj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Yj)("tree-item-loading","loading"),menuSelection:(0,n.$Yj)("menu-selection","check"),menuSubmenu:(0,n.$Yj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Yj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Yj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Yj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Yj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Yj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Yj)("toolbar-more","more"),quickInputBack:(0,n.$Yj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Yj)("drop-down-button",60084),symbolCustomColor:(0,n.$Yj)("symbol-customcolor",60252),exportIcon:(0,n.$Yj)("export",60332),workspaceUnspecified:(0,n.$Yj)("workspace-unspecified",60355),newLine:(0,n.$Yj)("newline",60394),thumbsDownFilled:(0,n.$Yj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Yj)("thumbsup-filled",60436),gitFetch:(0,n.$Yj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Yj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Yj)("debug-breakpoint-pending",60377)},e.$4j={...r.$1j,...e.$3j}}),define(ce[37],le([0,1,12]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=r,e.$eo=P,e.$fo=T,e.$go=p,e.$ho=c,e.$io=m,e.$jo=h,e.$ko=d,e.$lo=w,e.$mo=f,e.$no=g,e.$oo=v,e.$po=b;function r($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const k=Array.isArray($)?[]:{};return Object.entries($).forEach(([S,t])=>{k[S]=t&&typeof t=="object"?r(t):t}),k}function P($){if(!$||typeof $!="object")return $;const k=[$];for(;k.length>0;){const S=k.shift();Object.freeze(S);for(const t in S)if(D.call(S,t)){const u=S[t];typeof u=="object"&&!Object.isFrozen(u)&&!(0,n.$hg)(u)&&k.push(u)}}return $}const D=Object.prototype.hasOwnProperty;function T($,k){return I($,k,new Set)}function I($,k,S){if((0,n.$ng)($))return $;const t=k($);if(typeof t<"u")return t;if(Array.isArray($)){const u=[];for(const i of $)u.push(I(i,k,S));return u}if((0,n.$gg)($)){if(S.has($))throw new Error("Cannot clone recursive data-structure");S.add($);const u={};for(const i in $)D.call($,i)&&(u[i]=I($[i],k,S));return S.delete($),u}return $}function p($,k,S=!0){return(0,n.$gg)($)?((0,n.$gg)(k)&&Object.keys(k).forEach(t=>{t in $?S&&((0,n.$gg)($[t])&&(0,n.$gg)(k[t])?p($[t],k[t],S):$[t]=k[t]):$[t]=k[t]}),$):k}function c($,k){if($===k)return!0;if($==null||k===null||k===void 0||typeof $!=typeof k||typeof $!="object"||Array.isArray($)!==Array.isArray(k))return!1;let S,t;if(Array.isArray($)){if($.length!==k.length)return!1;for(S=0;S<$.length;S++)if(!c($[S],k[S]))return!1}else{const u=[];for(t in $)u.push(t);u.sort();const i=[];for(t in k)i.push(t);if(i.sort(),!c(u,i))return!1;for(S=0;S<u.length;S++)if(!c($[u[S]],k[u[S]]))return!1}return!0}function m($){const k=new Set;return JSON.stringify($,(S,t)=>{if((0,n.$gg)(t)||Array.isArray(t)){if(k.has(t))return"[Circular]";k.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function h($,k){const S=Object.create(null);return!$||!k||Object.keys(k).forEach(u=>{const i=$[u],o=k[u];c(i,o)||(S[u]=o)}),S}function d($,k){const S=k.toLowerCase(),t=Object.keys($).find(u=>u.toLowerCase()===S);return t?$[t]:$[k]}function w($,k){const S=Object.create(null);for(const[t,u]of Object.entries($))k(t,u)&&(S[t]=u);return S}function f($){let k=[];for(;Object.prototype!==$;)k=k.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return k}function g($){const k=[];for(const S of f($))typeof $[S]=="function"&&k.push(S);return k}function v($,k){const S=u=>function(){const i=Array.prototype.slice.call(arguments,0);return k(u,i)},t={};for(const u of $)t[u]=S(u);return t}function b($,k){const S={};for(const[t,u]of Object.entries($))S[t]=k(u,t);return S}}),define(ce[110],le([0,1,80]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$5j=P;var r;(function(T){function I(p){return p&&typeof p=="object"&&typeof p.id=="string"}T.isThemeColor=I})(r||(e.ThemeColor=r={}));function P(T){return{id:T}}var D;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function p($){const k=I.exec($.id);if(!k)return p(n.$4j.error);const[,S,t]=k,u=["codicon","codicon-"+S];return t&&u.push("codicon-modifier-"+t.substring(1)),u}T.asClassNameArray=p;function c($){return p($).join(" ")}T.asClassName=c;function m($){return"."+p($).join(".")}T.asCSSSelector=m;function h($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||r.isThemeColor($.color))}T.isThemeIcon=h;const d=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function w($){const k=d.exec($);if(!k)return;const[,S]=k;return{id:S}}T.fromString=w;function f($){return{id:$}}T.fromId=f;function g($,k){let S=$.id;const t=S.lastIndexOf("~");return t!==-1&&(S=S.substring(0,t)),k&&(S=`${S}~${k}`),{id:S}}T.modify=g;function v($){const k=$.id.lastIndexOf("~");if(k!==-1)return $.id.substring(k+1)}T.getModifier=v;function b($,k){return $.id===k.id&&$.color?.id===k.color?.id}T.isEqual=b})(D||(e.ThemeIcon=D={}))}),define(ce[149],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=r,e.$bf=P;var n;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(D){return D<0?0:D>n.MAX_UINT_8?n.MAX_UINT_8:D|0}function P(D){return D<0?0:D>n.MAX_UINT_32?n.MAX_UINT_32:D|0}}),define(ce[25],le([0,1,146,39,65,149]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=T,e.$df=p,e.$ef=m,e.$ff=h,e.$gf=d,e.$hf=w,e.$if=f,e.$jf=g,e.$kf=v,e.$lf=b,e.$mf=$,e.$nf=k,e.$of=S,e.$pf=t,e.$qf=u,e.$rf=i,e.$sf=o,e.$tf=s,e.$uf=a,e.$vf=l,e.$wf=E,e.$xf=y,e.$yf=R,e.$zf=L,e.$Af=A,e.$Bf=O,e.$Cf=M,e.$Df=H,e.$Ef=q,e.$Ff=K,e.$Gf=de,e.$Hf=Y,e.$If=J,e.$Jf=U,e.$Kf=Z,e.$Lf=W,e.$Mf=j,e.$Pf=V,e.$Qf=ue,e.$Rf=re,e.$Sf=Q,e.$Tf=_,e.$Uf=ie,e.$Wf=G,e.$Xf=B,e.$Yf=te,e.$Zf=he,e.$1f=we,e.$2f=Ie,e.$3f=Re,e.$5f=ve,e.$6f=$e,e.$7f=ee,e.$8f=ae,e.$9f=fe,e.$0f=be,e.$$f=De,e.$_f=Ne,e.$ag=Ze;function T(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const I=/{(\d+)}/g;function p(ne,...ge){return ge.length===0?ne:ne.replace(I,function(pe,ye){const je=parseInt(ye,10);return isNaN(je)||je<0||je>=ge.length?pe:ge[je]})}const c=/{([^}]+)}/g;function m(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(c,(pe,ye)=>ge[ye]??pe)}function h(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function d(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(ne,ge){let pe=0,ye=ne.indexOf(ge);for(;ye!==-1;)pe++,ye=ne.indexOf(ge,ye+ge.length);return pe}function g(ne,ge,pe="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${pe}`}function v(ne,ge,pe="\u2026"){if(ne.length<=ge)return ne;const ye=Math.ceil(ge/2)-pe.length/2,je=Math.floor(ge/2)-pe.length/2;return`${ne.substr(0,ye)}${pe}${ne.substr(ne.length-je)}`}function b(ne,ge=" "){const pe=$(ne,ge);return k(pe,ge)}function $(ne,ge){if(!ne||!ge)return ne;const pe=ge.length;if(pe===0||ne.length===0)return ne;let ye=0;for(;ne.indexOf(ge,ye)===ye;)ye=ye+pe;return ne.substring(ye)}function k(ne,ge){if(!ne||!ge)return ne;const pe=ge.length,ye=ne.length;if(pe===0||ye===0)return ne;let je=ye,Ue=-1;for(;Ue=ne.lastIndexOf(ge,je-1),!(Ue===-1||Ue+pe!==je);){if(Ue===0)return"";je=Ue}return ne.substring(0,je)}function S(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(ne){return ne.replace(/\*/g,"")}function u(ne,ge,pe={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=w(ne)),pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(ne,ye)}function i(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function o(ne){return ne.split(/\r\n|\r|\n/)}function s(ne){const ge=[],pe=ne.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function a(ne){for(let ge=0,pe=ne.length;ge<pe;ge++){const ye=ne.charCodeAt(ge);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ge}return-1}function l(ne,ge=0,pe=ne.length){for(let ye=ge;ye<pe;ye++){const je=ne.charCodeAt(ye);if(je!==r.CharCode.Space&&je!==r.CharCode.Tab)return ne.substring(ge,ye)}return ne.substring(ge,pe)}function E(ne,ge=ne.length-1){for(let pe=ge;pe>=0;pe--){const ye=ne.charCodeAt(pe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return pe}return-1}function y(ne,ge,pe){const ye=[];let je=0;for(const Ue of ne.matchAll(ge)){if(ye.push(ne.slice(je,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");je=Ue.index+Ue[0].length,ye.push(pe(Ue[0],...Ue.slice(1),Ue.index,ne,Ue.groups))}return ye.push(ne.slice(je)),Promise.all(ye).then(Ue=>Ue.join(""))}function R(ne,ge){return ne<ge?-1:ne>ge?1:0}function L(ne,ge,pe=0,ye=ne.length,je=0,Ue=ge.length){for(;pe<ye&&je<Ue;pe++,je++){const rt=ne.charCodeAt(pe),at=ge.charCodeAt(je);if(rt<at)return-1;if(rt>at)return 1}const _e=ye-pe,lt=Ue-je;return _e<lt?-1:_e>lt?1:0}function A(ne,ge){return O(ne,ge,0,ne.length,0,ge.length)}function O(ne,ge,pe=0,ye=ne.length,je=0,Ue=ge.length){for(;pe<ye&&je<Ue;pe++,je++){let rt=ne.charCodeAt(pe),at=ge.charCodeAt(je);if(rt===at)continue;if(rt>=128||at>=128)return L(ne.toLowerCase(),ge.toLowerCase(),pe,ye,je,Ue);H(rt)&&(rt-=32),H(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const _e=ye-pe,lt=Ue-je;return _e<lt?-1:_e>lt?1:0}function M(ne){return ne>=r.CharCode.Digit0&&ne<=r.CharCode.Digit9}function H(ne){return ne>=r.CharCode.a&&ne<=r.CharCode.z}function q(ne){return ne>=r.CharCode.A&&ne<=r.CharCode.Z}function K(ne,ge){return ne.length===ge.length&&O(ne,ge)===0}function de(ne,ge){const pe=ge.length;return ge.length>ne.length?!1:O(ne,ge,0,pe)===0}function Y(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function J(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;const je=ne.length-1,Ue=ge.length-1;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(je-ye)!==ge.charCodeAt(Ue-ye))return ye;return pe}function U(ne){return 55296<=ne&&ne<=56319}function Z(ne){return 56320<=ne&&ne<=57343}function W(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}function j(ne,ge,pe){const ye=ne.charCodeAt(pe);if(U(ye)&&pe+1<ge){const je=ne.charCodeAt(pe+1);if(Z(je))return W(ye,je)}return ye}function C(ne,ge){const pe=ne.charCodeAt(ge-1);if(Z(pe)&&ge>1){const ye=ne.charCodeAt(ge-2);if(U(ye))return W(ye,pe)}return pe}class X{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=C(this.c,this.e);return this.e-=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Nf=X;class oe{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new X(ge,pe)}nextGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let je=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ue=pe.offset,_e=ge.getGraphemeBreakType(pe.nextCodePoint());if(Me(je,_e)){pe.setOffset(Ue);break}je=_e}return pe.offset-ye}prevGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let je=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ue=pe.offset,_e=ge.getGraphemeBreakType(pe.prevCodePoint());if(Me(_e,je)){pe.setOffset(Ue);break}je=_e}return ye-pe.offset}eol(){return this.c.eol()}}e.$Of=oe;function V(ne,ge){return new oe(ne,ge).nextGraphemeLength()}function ue(ne,ge){return new oe(ne,ge).prevGraphemeLength()}function re(ne,ge){ge>0&&Z(ne.charCodeAt(ge))&&ge--;const pe=ge+V(ne,ge);return[pe-ue(ne,pe),pe]}function Q(ne){const ge=new oe(ne);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let N;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(ne){return N||(N=F()),N.test(ne)}const z=/^[\t\n\r\x20-\x7E]*$/;function ie(ne){return z.test(ne)}e.$Vf=/[\u2028\u2029]/;function G(ne){return e.$Vf.test(ne)}function B(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function te(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function he(ne,ge,pe=""){const ye=ne.trimStart();if(ye.length<ge)return ye;const je=/\b/g;let Ue=0;for(;je.test(ye)&&!(ye.length-je.lastIndex<ge);)Ue=je.lastIndex,je.lastIndex+=1;return Ue===0?ye:pe+ye.substring(Ue).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(ne){let ge=0;for(const pe of ne.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:ne.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==ne.length&&(yield{isCode:!1,str:ne.substring(ge)})}function Ie(ne){return ne&&(ne=ne.replace(me,"")),ne}const Ce=/\\\[.*?\\\]/g;function Re(ne){return Ie(ne).replace(Ce,"")}e.$4f=String.fromCharCode(r.CharCode.UTF8_BOM);function ve(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(ne){return ve(ne)?ne.substr(1):ne}function ee(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const pe=ge.length,ye=ne.toLowerCase();let je=0,Ue=-1;for(;je<pe;){const _e=ye.indexOf(ge[je],Ue+1);if(_e<0)return!1;Ue=_e,je++}return!0}function ae(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function fe(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function be(ne,ge=1){if(ge===0)return"";let pe=-1;do pe=ne.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ne:(ne[pe-1]==="\r"&&pe--,ne.substr(0,pe))}function De(ne){const ge=r.CharCode.Z-r.CharCode.A+1;return ne=ne%(2*ge),ne<ge?String.fromCharCode(r.CharCode.a+ne):String.fromCharCode(r.CharCode.A+ne-ge)}function Ne(ne){return Be.getInstance().getGraphemeBreakType(ne)}function Me(ne,ge){return ne===Ae.Other?ge!==Ae.Extend&&ge!==Ae.SpacingMark:ne===Ae.CR&&ge===Ae.LF?!1:ne===Ae.Control||ne===Ae.CR||ne===Ae.LF||ge===Ae.Control||ge===Ae.CR||ge===Ae.LF?!0:!(ne===Ae.L&&(ge===Ae.L||ge===Ae.V||ge===Ae.LV||ge===Ae.LVT)||(ne===Ae.LV||ne===Ae.V)&&(ge===Ae.V||ge===Ae.T)||(ne===Ae.LVT||ne===Ae.T)&&ge===Ae.T||ge===Ae.Extend||ge===Ae.ZWJ||ge===Ae.SpacingMark||ne===Ae.Prepend||ne===Ae.ZWJ&&ge===Ae.Extended_Pictographic||ne===Ae.Regional_Indicator&&ge===Ae.Regional_Indicator)}var Ae;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=Ge()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Ae.LF:ge===r.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(ge<127)return Ae.Other;const pe=this.d,ye=pe.length/3;let je=1;for(;je<=ye;)if(ge<pe[3*je])je=2*je;else if(ge>pe[3*je+1])je=2*je+1;else return pe[3*je+2];return Ae.Other}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(ne,ge){if(ne===0)return 0;const pe=qe(ne,ge);if(pe!==void 0)return pe;const ye=new X(ge,ne);return ye.prevCodePoint(),ye.offset}function qe(ne,ge){const pe=new X(ge,ne);let ye=pe.prevCodePoint();for(;Xe(ye)||ye===Qe.emojiVariantSelector||ye===Qe.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!te(ye))return;let je=pe.offset;return je>0&&pe.prevCodePoint()===Qe.zwj&&(je=pe.offset),je}function Xe(ne){return 127995<=ne&&ne<=127999}var Qe;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$bg="\xA0";class Je{static{this.c=new P.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$$e({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function je(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Ue=this.c.value;let _e=ge.filter(tt=>!tt.startsWith("_")&&tt in Ue);_e.length===0&&(_e=["_default"]);let lt;for(const tt of _e){const ut=pe(Ue[tt]);lt=je(lt,ut)}const rt=pe(Ue._common),at=ye(rt,lt);return new Je(at)})}static getInstance(ge){return Je.d.get(Array.from(ge))}static{this.e=new P.$T(()=>Object.keys(Je.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Je.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=Je;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(ge){return We.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&We.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return We.e()}}e.$dg=We}),define(ce[32],le([0,1,39,9,3,25,12]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=I,e.$xg=p,e.$yg=c,e.$zg=m,e.$Ag=h,e.$Bg=g,e.$Cg=v,e.$Dg=b,e.$Eg=$,e.$Fg=k,e.$Gg=S,e.$Hg=t,e.$Ig=u,e.$Jg=i,e.$Kg=o,e.$Lg=s,e.$Mg=E;function I(y){return y===n.CharCode.Slash||y===n.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,r.$gc.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function m(y,R=r.$gc.sep){if(!y)return"";const L=y.length,A=y.charCodeAt(0);if(I(A)){if(I(y.charCodeAt(1))&&!I(y.charCodeAt(2))){let M=3;const H=M;for(;M<L&&!I(y.charCodeAt(M));M++);if(H!==M&&!I(y.charCodeAt(M+1))){for(M+=1;M<L;M++)if(I(y.charCodeAt(M)))return y.slice(0,M+1).replace(/[\\/]/g,R)}}return R}else if($(A)&&y.charCodeAt(1)===n.CharCode.Colon)return I(y.charCodeAt(2))?y.slice(0,2)+R:y.slice(0,2);let O=y.indexOf("://");if(O!==-1){for(O+=3;O<L;O++)if(I(y.charCodeAt(O)))return y.slice(0,O+1)}return""}function h(y){if(!P.$j||!y||y.length<5)return!1;let R=y.charCodeAt(0);if(R!==n.CharCode.Backslash||(R=y.charCodeAt(1),R!==n.CharCode.Backslash))return!1;let L=2;const A=L;for(;L<y.length&&(R=y.charCodeAt(L),R!==n.CharCode.Backslash);L++);return!(A===L||(R=y.charCodeAt(L+1),isNaN(R)||R===n.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,w=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(y,R=P.$j){const L=R?d:w;return!(!y||y.length===0||/^\s+$/.test(y)||(L.lastIndex=0,L.test(y))||R&&f.test(y)||y==="."||y===".."||R&&y[y.length-1]==="."||R&&y.length!==y.trim().length||y.length>255)}function v(y,R,L){const A=y===R;return!L||A?A:!y||!R?!1:(0,D.$Ff)(y,R)}function b(y,R,L,A=r.sep){if(y===R)return!0;if(!y||!R||R.length>y.length)return!1;if(L){if(!(0,D.$Gf)(y,R))return!1;if(R.length===y.length)return!0;let M=R.length;return R.charAt(R.length-1)===A&&M--,y.charAt(M)===A}return R.charAt(R.length-1)!==A&&(R+=A),y.indexOf(R)===0}function $(y){return y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.a&&y<=n.CharCode.z}function k(y,R){return P.$j&&y.endsWith(":")&&(y+=r.sep),(0,r.$ic)(y)||(y=(0,r.$jc)(R,y)),y=(0,r.$hc)(y),S(y)}function S(y){return P.$j?(y=(0,D.$nf)(y,r.sep),y.endsWith(":")&&(y+=r.sep)):(y=(0,D.$nf)(y,r.sep),y||(y=r.sep)),y}function t(y){const R=(0,r.$hc)(y);return P.$j?y.length>3?!1:u(R)&&(y.length===2||R.charCodeAt(2)===n.CharCode.Backslash):R===r.$gc.sep}function u(y,R=P.$j){return R?$(y.charCodeAt(0))&&y.charCodeAt(1)===n.CharCode.Colon:!1}function i(y,R=P.$j){return u(y,R)?y[0]:void 0}function o(y,R,L){return R.length>y.length?-1:y===R?0:(L&&(y=y.toLowerCase(),R=R.toLowerCase()),y.indexOf(R))}function s(y){const R=y.split(":");let L,A,O;for(const M of R){const H=Number(M);(0,T.$ig)(H)?A===void 0?A=H:O===void 0&&(O=H):L=L?[L,M].join(":"):M}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:A!==void 0?A:void 0,column:O!==void 0?O:A!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(y,R,L=8){let A="";for(let M=0;M<L;M++){let H;M===0&&P.$j&&!R&&(L===3||L===4)?H=l:H=a,A+=H.charAt(Math.floor(Math.random()*H.length))}let O;return R?O=`${R}-${A}`:O=A,y?(0,r.$jc)(y,O):O}}),define(ce[46],le([0,1,25]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$wj=void 0,e.$sj=r,e.$tj=P,e.$uj=D,e.$vj=I,e.$xj=g,n=Pe(n);function r(b){return P(b,0)}function P(b,$){switch(typeof b){case"object":return b===null?D(349,$):Array.isArray(b)?p(b,$):c(b,$);case"string":return I(b,$);case"boolean":return T(b,$);case"number":return D(b,$);case"undefined":return D(937,$);default:return D(617,$)}}function D(b,$){return($<<5)-$+b|0}function T(b,$){return D(b?433:863,$)}function I(b,$){$=D(149417,$);for(let k=0,S=b.length;k<S;k++)$=D(b.charCodeAt(k),$);return $}function p(b,$){return $=D(104579,$),b.reduce((k,S)=>P(S,k),$)}function c(b,$){return $=D(181387,$),Object.keys(b).sort().reduce((k,S)=>(k=I(S,k),P(b[S],k)),$)}class m{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=P($,this.g),this.g}}e.$wj=m;var h;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function d(b,$,k=32){const S=k-$,t=~((1<<S)-1);return(b<<$|(t&b)>>>S)>>>0}function w(b,$=0,k=b.byteLength,S=0){for(let t=0;t<k;t++)b[$+t]=S}function f(b,$,k="0"){for(;b.length<$;)b=k+b;return b}function g(b,$=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(k=>k.toString(16).padStart(2,"0")).join(""):f((b>>>0).toString(16),$/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(h.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const k=$.length;if(k===0)return;const S=this.p;let t=this.r,u=this.u,i,o;for(u!==0?(i=u,o=-1,u=0):(i=$.charCodeAt(0),o=0);;){let s=i;if(n.$Jf(i))if(o+1<k){const a=$.charCodeAt(o+1);n.$Kf(a)?(o++,s=n.$Lf(i,a)):s=h.UNICODE_REPLACEMENT}else{u=i;break}else n.$Kf(i)&&(s=h.UNICODE_REPLACEMENT);if(t=this.w(S,t,s),o++,o<k)i=$.charCodeAt(o);else break}this.r=t,this.u=u}w($,k,S){return S<128?$[k++]=S:S<2048?($[k++]=192|(S&1984)>>>6,$[k++]=128|(S&63)>>>0):S<65536?($[k++]=224|(S&61440)>>>12,$[k++]=128|(S&4032)>>>6,$[k++]=128|(S&63)>>>0):($[k++]=240|(S&1835008)>>>18,$[k++]=128|(S&258048)>>>12,$[k++]=128|(S&4032)>>>6,$[k++]=128|(S&63)>>>0),k>=h.BLOCK_SIZE&&(this.y(),k-=h.BLOCK_SIZE,this.t+=h.BLOCK_SIZE,$[0]=$[h.BLOCK_SIZE+0],$[1]=$[h.BLOCK_SIZE+1],$[2]=$[h.BLOCK_SIZE+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,h.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=v.g,k=this.q;for(let E=0;E<64;E+=4)$.setUint32(E,k.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)$.setUint32(E,d($.getUint32(E-12,!1)^$.getUint32(E-32,!1)^$.getUint32(E-56,!1)^$.getUint32(E-64,!1),1),!1);let S=this.h,t=this.l,u=this.m,i=this.n,o=this.o,s,a,l;for(let E=0;E<80;E++)E<20?(s=t&u|~t&i,a=1518500249):E<40?(s=t^u^i,a=1859775393):E<60?(s=t&u|t&i|u&i,a=2400959708):(s=t^u^i,a=3395469782),l=d(S,5)+s+o+a+$.getUint32(E*4,!1)&4294967295,o=i,i=u,u=d(t,30),t=S,S=l;this.h=this.h+S&4294967295,this.l=this.l+t&4294967295,this.m=this.m+u&4294967295,this.n=this.n+i&4294967295,this.o=this.o+o&4294967295}}e.$yj=v}),define(ce[81],le([0,1,25]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=Pe(n);var r;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(r||(r={})),function(P){const D="error",T="warning",I="warn",p="info",c="ignore";function m(d){return d?n.$Ff(D,d)?P.Error:n.$Ff(T,d)||n.$Ff(I,d)?P.Warning:n.$Ff(p,d)?P.Info:P.Ignore:P.Ignore}P.fromValue=m;function h(d){switch(d){case P.Error:return D;case P.Warning:return T;case P.Info:return p;default:return c}}P.toString=h}(r||(r={})),e.default=r}),define(ce[60],le([0,1,21,39,25]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class D{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const g=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return g-v}value(){return this.b[this.c]}}e.$Gi=D;class T{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,P.$zf)(f,this.b,0,f.length,this.c,this.d):(0,P.$Bf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=T;class I{constructor(f=!0,g=!0){this.f=f,this.g=g}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let g=f.length-1;g>=0;g--,this.c--){const v=this.b.charCodeAt(g);if(!(v===r.CharCode.Slash||this.f&&v===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===r.CharCode.Slash||this.f&&g===r.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,P.$zf)(f,this.b,0,f.length,this.d,this.e):(0,P.$Bf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=I;var p;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(f,g){this.f=f,this.g=g,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new I(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,P.$Af)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$Af)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,P.$yf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$yf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ji=c;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(h||(h={}));class d{static forUris(f=()=>!1,g=()=>!1){return new d(new c(f,g))}static forPaths(f=!1){return new d(new I(void 0,!f))}static forStrings(){return new d(new D)}static forConfigKeys(){return new d(new T)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,g){if(g){const v=g.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b,f)}else{const v=f.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b[0],b[1])}}set(f,g){const v=this.b.reset(f);let b;this.c||(this.c=new m,this.c.segment=v.value());const $=[];for(b=this.c;;){const S=v.cmp(b.segment);if(S>0)b.left||(b.left=new m,b.left.segment=v.value()),$.push([h.Left,b]),b=b.left;else if(S<0)b.right||(b.right=new m,b.right.segment=v.value()),$.push([h.Right,b]),b=b.right;else if(v.hasNext())v.next(),b.mid||(b.mid=new m,b.mid.segment=v.value()),$.push([h.Mid,b]),b=b.mid;else break}const k=b.value;b.value=g,b.key=f;for(let S=$.length-1;S>=0;S--){const t=$[S][1];t.updateHeight();const u=t.balanceFactor();if(u<-1||u>1){const i=$[S][0],o=$[S+1][0];if(i===h.Right&&o===h.Right)$[S][1]=t.rotateLeft();else if(i===h.Left&&o===h.Left)$[S][1]=t.rotateRight();else if(i===h.Right&&o===h.Left)t.right=$[S+1][1]=$[S+1][1].rotateRight(),$[S][1]=t.rotateLeft();else if(i===h.Left&&o===h.Right)t.left=$[S+1][1]=$[S+1][1].rotateLeft(),$[S][1]=t.rotateRight();else throw new Error;if(S>0)switch($[S-1][0]){case h.Left:$[S-1][1].left=$[S][1];break;case h.Right:$[S-1][1].right=$[S][1];break;case h.Mid:$[S-1][1].mid=$[S][1];break}else this.c=$[0][1]}}return k}get(f){return this.d(f)?.value}d(f){const g=this.b.reset(f);let v=this.c;for(;v;){const b=g.cmp(v.segment);if(b>0)v=v.left;else if(b<0)v=v.right;else if(g.hasNext())g.next(),v=v.mid;else break}return v}has(f){const g=this.d(f);return!(g?.value===void 0&&g?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,g){const v=this.b.reset(f),b=[];let $=this.c;for(;$;){const k=v.cmp($.segment);if(k>0)b.push([h.Left,$]),$=$.left;else if(k<0)b.push([h.Right,$]),$=$.right;else if(v.hasNext())v.next(),b.push([h.Mid,$]),$=$.mid;else break}if($){if(g?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const k=this.f($.right);if(k.key){const{key:S,value:t,segment:u}=k;this.e(k.key,!1),$.key=S,$.value=t,$.segment=u}}else{const k=$.left??$.right;if(b.length>0){const[S,t]=b[b.length-1];switch(S){case h.Left:t.left=k;break;case h.Mid:t.mid=k;break;case h.Right:t.right=k;break}}else this.c=k}for(let k=b.length-1;k>=0;k--){const S=b[k][1];S.updateHeight();const t=S.balanceFactor();if(t>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),b[k][1]=S.rotateLeft()):t<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),b[k][1]=S.rotateRight()),k>0)switch(b[k-1][0]){case h.Left:b[k-1][1].left=b[k][1];break;case h.Right:b[k-1][1].right=b[k][1];break;case h.Mid:b[k-1][1].mid=b[k][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const g=this.b.reset(f);let v=this.c,b;for(;v;){const $=g.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(g.hasNext())g.next(),b=v.value||b,v=v.mid;else break}return v&&v.value||b}findSuperstr(f){return this.g(f,!1)}g(f,g){const v=this.b.reset(f);let b=this.c;for(;b;){const $=v.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else return b.mid?this.h(b.mid):g?b.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[g,v]of this)f(v,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const g=[];return this.j(f,g),g[Symbol.iterator]()}j(f,g){f&&(f.left&&this.j(f.left,g),f.value&&g.push([f.key,f.value]),f.mid&&this.j(f.mid,g),f.right&&this.j(f.right,g))}_isBalanced(){const f=g=>{if(!g)return!0;const v=g.balanceFactor();return v<-1||v>1?!1:f(g.left)&&f(g.right)};return f(this.c)}}e.$Ki=d}),define(ce[7],le([0,1,39,90,9,3]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=v,e.$wc=u,P=Pe(P);const T=/^\w[\w\d+.-]*$/,I=/^\//,p=/^\/\//;function c(l,E){if(!l.scheme&&E)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!T.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(l,E){return!l&&!E?"file":l}function h(l,E){switch(l){case"https":case"http":case"file":E?E[0]!==w&&(E=w+E):E=w;break}return E}const d="",w="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(E){return E instanceof g?!0:E?typeof E.authority=="string"&&typeof E.fragment=="string"&&typeof E.path=="string"&&typeof E.query=="string"&&typeof E.scheme=="string"&&typeof E.fsPath=="string"&&typeof E.with=="function"&&typeof E.toString=="function":!1}constructor(E,y,R,L,A,O=!1){typeof E=="object"?(this.scheme=E.scheme||d,this.authority=E.authority||d,this.path=E.path||d,this.query=E.query||d,this.fragment=E.fragment||d):(this.scheme=m(E,O),this.authority=y||d,this.path=h(this.scheme,R||d),this.query=L||d,this.fragment=A||d,c(this,O))}get fsPath(){return u(this,!1)}with(E){if(!E)return this;let{scheme:y,authority:R,path:L,query:A,fragment:O}=E;return y===void 0?y=this.scheme:y===null&&(y=d),R===void 0?R=this.authority:R===null&&(R=d),L===void 0?L=this.path:L===null&&(L=d),A===void 0?A=this.query:A===null&&(A=d),O===void 0?O=this.fragment:O===null&&(O=d),y===this.scheme&&R===this.authority&&L===this.path&&A===this.query&&O===this.fragment?this:new $(y,R,L,A,O)}static parse(E,y=!1){const R=f.exec(E);return R?new $(R[2]||d,a(R[4]||d),a(R[5]||d),a(R[7]||d),a(R[9]||d),y):new $(d,d,d,d,d)}static file(E){let y=d;if(D.$j&&(E=E.replace(/\\/g,w)),E[0]===w&&E[1]===w){const R=E.indexOf(w,2);R===-1?(y=E.substring(2),E=w):(y=E.substring(2,R),E=E.substring(R)||w)}return new $("file",y,E,d,d)}static from(E,y){return new $(E.scheme,E.authority,E.path,E.query,E.fragment,y)}static joinPath(E,...y){if(!E.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return D.$j&&E.scheme==="file"?R=g.file(P.$fc.join(u(E,!0),...y)).path:R=P.$gc.join(E.path,...y),E.with({path:R})}toString(E=!1){return i(this,E)}toJSON(){return this}static revive(E){if(E){if(E instanceof g)return E;{const y=new $(E);return y._formatted=E.external??null,y._fsPath=E._sep===b?E.fsPath??null:null,y}}else return E}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=g;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const b=D.$j?1:void 0;class $ extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(E=!1){return E?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const E={$mid:r.MarshalledId.Uri};return this._fsPath&&(E.fsPath=this._fsPath,E._sep=b),this._formatted&&(E.external=this._formatted),this.path&&(E.path=this.path),this.scheme&&(E.scheme=this.scheme),this.authority&&(E.authority=this.authority),this.query&&(E.query=this.query),this.fragment&&(E.fragment=this.fragment),E}}const k={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function S(l,E,y){let R,L=-1;for(let A=0;A<l.length;A++){const O=l.charCodeAt(A);if(O>=n.CharCode.a&&O<=n.CharCode.z||O>=n.CharCode.A&&O<=n.CharCode.Z||O>=n.CharCode.Digit0&&O<=n.CharCode.Digit9||O===n.CharCode.Dash||O===n.CharCode.Period||O===n.CharCode.Underline||O===n.CharCode.Tilde||E&&O===n.CharCode.Slash||y&&O===n.CharCode.OpenSquareBracket||y&&O===n.CharCode.CloseSquareBracket||y&&O===n.CharCode.Colon)L!==-1&&(R+=encodeURIComponent(l.substring(L,A)),L=-1),R!==void 0&&(R+=l.charAt(A));else{R===void 0&&(R=l.substr(0,A));const M=k[O];M!==void 0?(L!==-1&&(R+=encodeURIComponent(l.substring(L,A)),L=-1),R+=M):L===-1&&(L=A)}}return L!==-1&&(R+=encodeURIComponent(l.substring(L))),R!==void 0?R:l}function t(l){let E;for(let y=0;y<l.length;y++){const R=l.charCodeAt(y);R===n.CharCode.Hash||R===n.CharCode.QuestionMark?(E===void 0&&(E=l.substr(0,y)),E+=k[R]):E!==void 0&&(E+=l[y])}return E!==void 0?E:l}function u(l,E){let y;return l.authority&&l.path.length>1&&l.scheme==="file"?y=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===n.CharCode.Slash&&(l.path.charCodeAt(1)>=n.CharCode.A&&l.path.charCodeAt(1)<=n.CharCode.Z||l.path.charCodeAt(1)>=n.CharCode.a&&l.path.charCodeAt(1)<=n.CharCode.z)&&l.path.charCodeAt(2)===n.CharCode.Colon?E?y=l.path.substr(1):y=l.path[1].toLowerCase()+l.path.substr(2):y=l.path,D.$j&&(y=y.replace(/\//g,"\\")),y}function i(l,E){const y=E?t:S;let R="",{scheme:L,authority:A,path:O,query:M,fragment:H}=l;if(L&&(R+=L,R+=":"),(A||L==="file")&&(R+=w,R+=w),A){let q=A.indexOf("@");if(q!==-1){const K=A.substr(0,q);A=A.substr(q+1),q=K.lastIndexOf(":"),q===-1?R+=y(K,!1,!1):(R+=y(K.substr(0,q),!1,!1),R+=":",R+=y(K.substr(q+1),!1,!0)),R+="@"}A=A.toLowerCase(),q=A.lastIndexOf(":"),q===-1?R+=y(A,!1,!0):(R+=y(A.substr(0,q),!1,!0),R+=A.substr(q))}if(O){if(O.length>=3&&O.charCodeAt(0)===n.CharCode.Slash&&O.charCodeAt(2)===n.CharCode.Colon){const q=O.charCodeAt(1);q>=n.CharCode.A&&q<=n.CharCode.Z&&(O=`/${String.fromCharCode(q+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===n.CharCode.Colon){const q=O.charCodeAt(0);q>=n.CharCode.A&&q<=n.CharCode.Z&&(O=`${String.fromCharCode(q+32)}:${O.substr(2)}`)}R+=y(O,!0,!1)}return M&&(R+="?",R+=y(M,!1,!1)),H&&(R+="#",R+=E?H:S(H,!1,!1)),R}function o(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+o(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(l){return l.match(s)?l.replace(s,E=>o(E)):l}}),define(ce[150],le([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=r,e.$dr=P,e.$er=D,e.log=I;function r(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}function P(c){const m=[];let h;try{const d=JSON.parse(c.arguments),w=d[d.length-1];w&&w.__$stack&&(d.pop(),h=w.__$stack),m.push(...d)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:h}}function D(c){if(typeof c!="string")return D(P(c).stack);const m=c;if(m){const h=T(m),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(d&&d.length===4)return{uri:n.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function T(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function I(c,m){const{args:h,stack:d}=P(c),w=typeof h[0]=="string"&&h.length===1;let f=T(d);f&&(f=`(${f.trim()})`);let g=[];if(typeof h[0]=="string"?f&&w?g=[`%c[${m}] %c${h[0]} %c${f}`,p("blue"),p(""),p("grey")]:g=[`%c[${m}] %c${h[0]}`,p("blue"),p(""),...h.slice(1)]:g=[`%c[${m}]%`,p("blue"),...h],f&&!w&&g.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,g)}function p(c){return`color: ${c}`}}),define(ce[82],le([0,1,17,7,90]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=D,e.$ai=T,e.$bi=p;function D(c){return JSON.stringify(c,I)}function T(c){let m=JSON.parse(c);return m=p(m),m}function I(c,m){return m instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:m.source,flags:m.flags}:m}function p(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case P.MarshalledId.Uri:return r.URI.revive(c);case P.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case P.MarshalledId.Date:return new Date(c.source)}if(c instanceof n.$Ne||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let h=0;h<c.length;++h)c[h]=p(c[h],m+1);else for(const h in c)Object.hasOwnProperty.call(c,h)&&(c[h]=p(c[h],m+1))}return c}}),define(ce[11],le([0,1,15,3,25,7,9]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=p,e.$Og=c,e.$Sg=h,n=Pe(n),r=Pe(r),T=Pe(T);var I;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(I||(e.Schemas=I={}));function p(f,g){return D.URI.isUri(f)?(0,P.$Ff)(f.scheme,g):(0,P.$Gf)(f,g+":")}function c(f,...g){return g.some(v=>p(f,v))}e.$Pg="vscode-tkn",e.$Qg="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,v){this.f=h(g,v)}getServerRootPath(){return this.f}get g(){return T.$gc.join(this.f,I.vscodeRemoteResource)}set(g,v,b){this.a[g]=v,this.b[g]=b}setConnectionToken(g,v){this.c[g]=v}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(t){return n.$Y(t),g}const v=g.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const $=this.b[v],k=this.c[v];let S=`path=${encodeURIComponent(g.path)}`;return typeof k=="string"&&(S+=`&${e.$Qg}=${encodeURIComponent(k)}`),D.URI.from({scheme:r.$p?this.d:I.vscodeRemoteResource,authority:`${b}:${$}`,path:this.g,query:S})}}e.$Rg=new m;function h(f,g){return T.$gc.join(g??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class d{static{this.a=e.$Xg}asBrowserUri(g){const v=this.b(g,x);return this.uriToBrowserUri(v)}uriToBrowserUri(g){return g.scheme===I.vscodeRemote?e.$Rg.rewrite(g):g.scheme===I.file&&(r.$n||r.$r===`${I.vscodeFileResource}://${d.a}`)?g.with({scheme:I.vscodeFileResource,authority:g.authority||d.a,query:null,fragment:null}):g}asFileUri(g){const v=this.b(g,x);return this.uriToFileUri(v)}uriToFileUri(g){return g.scheme===I.vscodeFileResource?g.with({scheme:I.file,authority:g.authority!==d.a?g.authority:null,query:null,fragment:null}):g}b(g,v){return D.URI.isUri(g)?g:D.URI.parse(v.toUrl(g))}}e.$Yg=new d;var w;(function(f){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(g.get("3"));const v="vscode-coi";function b(k){let S;typeof k=="string"?S=new URL(k).searchParams:k instanceof URL?S=k.searchParams:D.URI.isUri(k)&&(S=new URL(k.toString(!0)).searchParams);const t=S?.get(v);if(t)return g.get(t)}f.getHeadersFromQuery=b;function $(k,S,t){if(!globalThis.crossOriginIsolated)return;const u=S&&t?"3":t?"2":"1";k instanceof URLSearchParams?k.set(v,u):k[v]=u}f.addSearchParam=$})(w||(e.COI=w={}))}),define(ce[18],le([0,1,39,32,11,9,3,25,7]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=c,e.$oh=h,e.$ph=w,r=Pe(r),D=Pe(D);function c(f){return(0,p.$wc)(f,!0)}class m{constructor(g){this.a=g}compare(g,v,b=!1){return g===v?0:(0,I.$yf)(this.getComparisonKey(g,b),this.getComparisonKey(v,b))}isEqual(g,v,b=!1){return g===v?!0:!g||!v?!1:this.getComparisonKey(g,b)===this.getComparisonKey(v,b)}getComparisonKey(g,v=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,v,b=!1){if(g.scheme===v.scheme){if(g.scheme===P.Schemas.file)return r.$Dg(c(g),c(v),this.a(g))&&g.query===v.query&&(b||g.fragment===v.fragment);if((0,e.$kh)(g.authority,v.authority))return r.$Dg(g.path,v.path,this.a(g),"/")&&g.query===v.query&&(b||g.fragment===v.fragment)}return!1}joinPath(g,...v){return p.URI.joinPath(g,...v)}basenameOrAuthority(g){return(0,e.$ch)(g)||g.authority}basename(g){return D.$gc.basename(g.path)}extname(g){return D.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let v;return g.scheme===P.Schemas.file?v=p.URI.file(D.$mc(c(g))).path:(v=D.$gc.dirname(g.path),g.authority&&v.length&&v.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),v="/")),g.with({path:v})}normalizePath(g){if(!g.path.length)return g;let v;return g.scheme===P.Schemas.file?v=p.URI.file(D.$hc(c(g))).path:v=D.$gc.normalize(g.path),g.with({path:v})}relativePath(g,v){if(g.scheme!==v.scheme||!(0,e.$kh)(g.authority,v.authority))return;if(g.scheme===P.Schemas.file){const k=D.$lc(c(g),c(v));return T.$j?r.$xg(k):k}let b=g.path||"/";const $=v.path||"/";if(this.a(g)){let k=0;for(const S=Math.min(b.length,$.length);k<S&&!(b.charCodeAt(k)!==$.charCodeAt(k)&&b.charAt(k).toLowerCase()!==$.charAt(k).toLowerCase());k++);b=$.substr(0,k)+b.substr(k)}return D.$gc.relative(b,$)}resolvePath(g,v){if(g.scheme===P.Schemas.file){const b=p.URI.file(D.$kc(c(g),v));return g.with({authority:b.authority,path:b.path})}return v=r.$yg(v),g.with({path:D.$gc.resolve(g.path,v)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,v){return g===v||g!==void 0&&v!==void 0&&(0,I.$Ff)(g,v)}hasTrailingPathSeparator(g,v=D.sep){if(g.scheme===P.Schemas.file){const b=c(g);return b.length>r.$zg(b).length&&b[b.length-1]===v}else{const b=g.path;return b.length>1&&b.charCodeAt(b.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,v=D.sep){return(0,e.$lh)(g,v)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,v=D.sep){let b=!1;if(g.scheme===P.Schemas.file){const $=c(g);b=$!==void 0&&$.length===r.$zg($).length&&$[$.length-1]===v}else{v="/";const $=g.path;b=$.length===1&&$.charCodeAt($.length-1)===n.CharCode.Slash}return!b&&!(0,e.$lh)(g,v)?g.with({path:g.path+"/"}):g}}e.$7g=m,e.$8g=new m(()=>!1),e.$9g=new m(f=>f.scheme===P.Schemas.file?!T.$l:!0),e.$0g=new m(f=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function h(f,g){const v=[];for(let b=0;b<f.length;b++){const $=g(f[b]);f.some((k,S)=>S===b?!1:(0,e.$_g)($,g(k)))||v.push(f[b])}return v}var d;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function g(v){const b=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(S=>{const[t,u]=S.split(":");t&&u&&b.set(t,u)});const k=v.path.substring(0,v.path.indexOf(";"));return k&&b.set(f.META_DATA_MIME,k),b}f.parseMetaData=g})(d||(e.DataUri=d={}));function w(f,g,v){if(g){let b=f.path;return b&&b[0]!==D.$gc.sep&&(b=D.$gc.sep+b),f.with({scheme:v,authority:g,path:b})}return f.with({scheme:v})}}),define(ce[8],le([0,1,22,15,4,2,18,3,147,65]),function(x,e,n,r,P,D,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=m,e.$rh=h,e.$sh=d,e.$th=w,e.$uh=f,e.$vh=g,e.$wh=v,e.$xh=b,e.$Fh=l,e.$Gh=E,e.$Hh=y,e.$Ih=R,e.$Jh=L,e.$Yh=j,e.$7h=z;function m(G){return!!G&&typeof G.then=="function"}function h(G){const B=new n.$we,te=G(B.token),he=new Promise((me,we)=>{const Ie=B.token.onCancellationRequested(()=>{Ie.dispose(),we(new r.$4)});Promise.resolve(te).then(Ce=>{Ie.dispose(),B.dispose(),me(Ce)},Ce=>{Ie.dispose(),B.dispose(),we(Ce)})});return new class{cancel(){B.cancel(),B.dispose()}then(me,we){return he.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return he.finally(me)}}}function d(G,B,te){return new Promise((he,me)=>{const we=B.onCancellationRequested(()=>{we.dispose(),he(te)});G.then(he,me).finally(()=>we.dispose())})}function w(G,B){return new Promise((te,he)=>{const me=B.onCancellationRequested(()=>{me.dispose(),he(new r.$4)});G.then(te,he).finally(()=>me.dispose())})}async function f(G){let B=-1;const te=G.map((he,me)=>he.then(we=>(B=me,we)));try{return await Promise.race(te)}finally{G.forEach((he,me)=>{me!==B&&he.cancel()})}}function g(G,B,te){let he;const me=setTimeout(()=>{he?.(void 0),te?.()},B);return Promise.race([G.finally(()=>clearTimeout(me)),new Promise(we=>he=we)])}function v(G){return new Promise((B,te)=>{const he=G();m(he)?he.then(B,te):B(he)})}function b(){let G,B;return{promise:new Promise((he,me)=>{G=he,B=me}),resolve:G,reject:B}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const te=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(te,te).then(he)})}return new Promise((te,he)=>{this.b.then(te,he)})}return this.a=B(),new Promise((te,he)=>{this.a.then(me=>{this.a=null,te(me)},me=>{this.a=null,he(me)})})}dispose(){this.f=!0}}e.$yh=$;class k{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$zh=k;class S{constructor(){this.a=new Map}queue(B,te){const me=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(B)===me&&this.a.delete(B)});return this.a.set(B,me),me}}e.$Ah=S;const t=(G,B)=>{let te=!0;const he=setTimeout(()=>{te=!1,B()},G);return{isTriggered:()=>te,dispose:()=>{clearTimeout(he),te=!1}}},u=G=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,G())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class i{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,te=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=te===p.$ge?u(he):t(te,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=i;class o{constructor(B){this.a=new i(B),this.b=new $}trigger(B,te){return this.a.trigger(()=>this.b.queue(B),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=o;class s{constructor(){this.a=!1,this.b=new Promise((B,te)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=s;class a extends s{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$Eh=a;function l(G,B){return B?new Promise((te,he)=>{const me=setTimeout(()=>{we.dispose(),te()},G),we=B.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),he(new r.$4)})}):h(te=>l(G,te))}function E(G,B=0,te){const he=setTimeout(()=>{G(),te&&me.dispose()},B),me=(0,D.$Sc)(()=>{clearTimeout(he),te?.deleteAndLeak(me)});return te?.add(me),me}function y(G){const B=[];let te=0;const he=G.length;function me(){return te<he?G[te++]():null}function we(Ie){Ie!=null&&B.push(Ie);const Ce=me();return Ce?Ce.then(we):Promise.resolve(B)}return Promise.resolve(null).then(we)}function R(G,B=he=>!!he,te=null){let he=0;const me=G.length,we=()=>{if(he>=me)return Promise.resolve(te);const Ie=G[he++];return Promise.resolve(Ie()).then(Re=>B(Re)?Promise.resolve(Re):we())};return we()}function L(G,B=he=>!!he,te=null){if(G.length===0)return Promise.resolve(te);let he=G.length;const me=()=>{he=-1;for(const we of G)we.cancel?.()};return new Promise((we,Ie)=>{for(const Ce of G)Ce.then(Re=>{--he>=0&&B(Re)?(me(),we(Re)):he===0&&we(te)}).catch(Re=>{--he>=0&&(me(),Ie(Re))})})}class A{constructor(B){this.a=0,this.b=!1,this.f=B,this.g=[],this.d=0,this.h=new P.$le}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(B){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,he)=>{this.g.push({factory:B,c:te,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const B=this.g.shift();this.d++;const te=B.factory();te.then(B.c,B.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=A;class O extends A{constructor(){super(1)}}e.$Lh=O;class M{constructor(){this.a=new C,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$Mh=M;class H{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new V;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueSize(B,te=T.$8g){const he=te.getComparisonKey(B);return this.a.get(he)?.size??0}queueFor(B,te,he=T.$8g){const me=he.getComparisonKey(B);let we=this.a.get(me);if(!we){we=new O;const Ie=this.f++,Ce=P.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$4c),this.d.set(Ie,Ce),this.a.set(me,we)}return we.queue(te)}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=H;class q{constructor(B,te){this.b=!1,this.a=-1,typeof B=="function"&&typeof te=="number"&&this.setIfNotSet(B,te)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,te){if(this.b)throw new r.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},te)}setIfNotSet(B,te){if(this.b)throw new r.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},te))}}e.$Oh=q;class K{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,te,he=globalThis){if(this.f)throw new r.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=he.setInterval(()=>{B()},te);this.d=(0,D.$Sc)(()=>{he.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=K;class de{constructor(B,te){this.b=-1,this.a=B,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=de;class Y{constructor(B,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=B,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=Y;class J extends de{constructor(B,te){super(B,te),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$Sh=J;class U extends D.$Uc{constructor(B,te){super(),this.g=B,this.h=te,this.a=[],this.b=this.B(new D.$Vc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of B)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new de(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=U,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(G,B)=>{(0,I.$C)(()=>{if(te)return;const he=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$Vh=(G,B,te)=>{const he=G.requestIdleCallback(B,typeof te=="number"?{timeout:te}:void 0);let me=!1;return{dispose(){me||(me=!0,G.cancelIdleCallback(he))}}},e.$Uh=G=>(0,e.$Vh)(globalThis,G)}();class Z{constructor(B,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Vh)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=Z;class W extends Z{constructor(B){super(globalThis,B)}}e.$Xh=W;async function j(G,B,te){let he;for(let me=0;me<te;me++)try{return await G()}catch(we){he=we,await l(B)}throw he}class C{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,te,he){return this.a={taskId:B,cancel:()=>he?.(),promise:te},te.then(()=>this.d(B),()=>this.d(B)),te}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{const{promise:te,resolve:he,reject:me}=b();this.b={run:B,promise:te,promiseResolve:he,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=C;class X{constructor(B,te=()=>Date.now()){this.d=B,this.f=te,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$1h=X;var oe;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(oe||(oe={}));class V{get isRejected(){return this.d?.outcome===oe.Rejected}get isResolved(){return this.d?.outcome===oe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===oe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((B,te)=>{this.a=B,this.b=te})}complete(B){return new Promise(te=>{this.a(B),this.d={outcome:oe.Resolved,value:B},te()})}error(B){return new Promise(te=>{this.b(B),this.d={outcome:oe.Rejected,value:B},te()})}cancel(){return this.error(new r.$4)}}e.$2h=V;var ue;(function(G){async function B(he){let me;const we=await Promise.all(he.map(Ie=>Ie.then(Ce=>Ce,Ce=>{me||(me=Ce)})));if(typeof me<"u")throw me;return we}G.settled=B;function te(he){return new Promise(async(me,we)=>{try{await he(me,we)}catch(Ie){we(Ie)}})}G.withAsyncBody=te})(ue||(e.Promises=ue={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new r.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=re;class Q{constructor(B){this.b=B,this.a=new c.$T(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=Q;var N;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(N||(N={}));class F{static fromArray(B){return new F(te=>{te.emitMany(B)})}static fromPromise(B){return new F(async te=>{te.emitMany(await B)})}static fromPromises(B){return new F(async te=>{await Promise.all(B.map(async he=>te.emitOne(await he)))})}static merge(B){return new F(async te=>{await Promise.all(B.map(async he=>{for await(const me of he)te.emitOne(me)}))})}static{this.EMPTY=F.fromArray([])}constructor(B,te){this.a=N.Initial,this.b=[],this.d=null,this.f=te,this.g=new P.$le,queueMicrotask(async()=>{const he={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(B(he)),this.k()}catch(me){this.l(me)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===N.DoneError)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===N.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(B,te){return new F(async he=>{for await(const me of B)he.emitOne(te(me))})}map(B){return F.map(this,B)}static filter(B,te){return new F(async he=>{for await(const me of B)te(me)&&he.emitOne(me)})}filter(B){return F.filter(this,B)}static coalesce(B){return F.filter(B,te=>!!te)}coalesce(){return F.coalesce(this)}static async toPromise(B){const te=[];for await(const he of B)te.push(he);return te}toPromise(){return F.toPromise(this)}h(B){this.a===N.Initial&&(this.b.push(B),this.g.fire())}j(B){this.a===N.Initial&&(this.b=this.b.concat(B),this.g.fire())}k(){this.a===N.Initial&&(this.a=N.DoneOK,this.g.fire())}l(B){this.a===N.Initial&&(this.a=N.DoneError,this.d=B,this.g.fire())}}e.$5h=F;class _ extends F{constructor(B,te){super(te),this.m=B}cancel(){this.m.cancel()}}e.$6h=_;function z(G){const B=new n.$we,te=G(B.token);return new _(B,async he=>{const me=B.token.onCancellationRequested(()=>{me.dispose(),B.dispose(),he.reject(new r.$4)});try{for await(const we of te){if(B.token.isCancellationRequested)return;he.emitOne(we)}me.dispose(),B.dispose()}catch(we){me.dispose(),B.dispose(),he.reject(we)}})}class ie{constructor(B){this.a=new V,this.b=new F(me=>{if(te){me.reject(te);return}return he&&me.emitMany(he),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},B);let te,he;this.f=me=>{he||(he=[]),he.push(me)},this.d=me=>{te||(te=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$8h=ie}),define(ce[111],le([0,1,21,8,39,32,31,9,3,25]),function(x,e,n,r,P,D,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=m,e.$xk=g,e.$yk=M,e.$zk=H,e.$Ak=q,e.$Bk=K,e.$Ck=de,e.$Dk=Z;function m(){return Object.create(null)}e.$vk="**",e.$wk="/";const h="[/\\\\]",d="[^/\\\\]",w=/\//g;function f(W,j){switch(W){case 0:return"";case 1:return`${d}*?`;default:return`(?:${h}|${d}+${h}${j?`|${h}${d}+`:""})*?`}}function g(W,j){if(!W)return[];const C=[];let X=!1,oe=!1,V="";for(const ue of W){switch(ue){case j:if(!X&&!oe){C.push(V),V="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}V+=ue}return V&&C.push(V),C}function v(W){if(!W)return"";let j="";const C=g(W,e.$wk);if(C.every(X=>X===e.$vk))j=".*";else{let X=!1;C.forEach((oe,V)=>{if(oe===e.$vk){if(X)return;j+=f(2,V===C.length-1)}else{let ue=!1,re="",Q=!1,N="";for(const F of oe){if(F!=="}"&&ue){re+=F;continue}if(Q&&(F!=="]"||!N)){let _;F==="-"?_=F:(F==="^"||F==="!")&&!N?_="^":F===e.$wk?_="":_=(0,c.$hf)(F),N+=_;continue}switch(F){case"{":ue=!0;continue;case"[":Q=!0;continue;case"}":{const z=`(?:${g(re,",").map(ie=>v(ie)).join("|")})`;j+=z,ue=!1,re="";break}case"]":{j+="["+N+"]",Q=!1,N="";break}case"?":j+=d;continue;case"*":j+=f(1);continue;default:j+=(0,c.$hf)(F)}}V<C.length-1&&(C[V+1]!==e.$vk||V+2<C.length)&&(j+=h)}X=oe===e.$vk})}return j}const b=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,k=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Dc(1e4),o=function(){return!1},s=function(){return null};function a(W,j){if(!W)return s;let C;typeof W!="string"?C=W.pattern:C=W,C=C.trim();const X=`${C}_${!!j.trimForExclusions}`;let oe=i.get(X);if(oe)return l(oe,W);let V;return b.test(C)?oe=y(C.substr(4),C):(V=$.exec(E(C,j)))?oe=R(V[1],C):(j.trimForExclusions?S:k).test(C)?oe=L(C,j):(V=t.exec(E(C,j)))?oe=A(V[1].substr(1),C,!0):(V=u.exec(E(C,j)))?oe=A(V[1],C,!1):oe=O(C),i.set(X,oe),l(oe,W)}function l(W,j){if(typeof j=="string")return W;const C=function(X,oe){return(0,D.$Dg)(X,j.base,!p.$l)?W((0,c.$mf)(X.substr(j.base.length),I.sep),oe):null};return C.allBasenames=W.allBasenames,C.allPaths=W.allPaths,C.basenames=W.basenames,C.patterns=W.patterns,C}function E(W,j){return j.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function y(W,j){return function(C,X){return typeof C=="string"&&C.endsWith(W)?j:null}}function R(W,j){const C=`/${W}`,X=`\\${W}`,oe=function(ue,re){return typeof ue!="string"?null:re?re===W?j:null:ue===W||ue.endsWith(C)||ue.endsWith(X)?j:null},V=[W];return oe.basenames=V,oe.patterns=[j],oe.allBasenames=V,oe}function L(W,j){const C=U(W.slice(1,-1).split(",").map(re=>a(re,j)).filter(re=>re!==s),W),X=C.length;if(!X)return s;if(X===1)return C[0];const oe=function(re,Q){for(let N=0,F=C.length;N<F;N++)if(C[N](re,Q))return W;return null},V=C.find(re=>!!re.allBasenames);V&&(oe.allBasenames=V.allBasenames);const ue=C.reduce((re,Q)=>Q.allPaths?re.concat(Q.allPaths):re,[]);return ue.length&&(oe.allPaths=ue),oe}function A(W,j,C){const X=I.sep===I.$gc.sep,oe=X?W:W.replace(w,I.sep),V=I.sep+oe,ue=I.$gc.sep+W;let re;return C?re=function(Q,N){return typeof Q=="string"&&(Q===oe||Q.endsWith(V)||!X&&(Q===W||Q.endsWith(ue)))?j:null}:re=function(Q,N){return typeof Q=="string"&&(Q===oe||!X&&Q===W)?j:null},re.allPaths=[(C?"*/":"./")+W],re}function O(W){try{const j=new RegExp(`^${v(W)}$`);return function(C){return j.lastIndex=0,typeof C=="string"&&j.test(C)?W:null}}catch{return s}}function M(W,j,C){return!W||typeof j!="string"?!1:H(W)(j,void 0,C)}function H(W,j={}){if(!W)return o;if(typeof W=="string"||q(W)){const C=a(W,j);if(C===s)return o;const X=function(oe,V){return!!C(oe,V)};return C.allBasenames&&(X.allBasenames=C.allBasenames),C.allPaths&&(X.allPaths=C.allPaths),X}return Y(W,j)}function q(W){const j=W;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function K(W){return W.allBasenames||[]}function de(W){return W.allPaths||[]}function Y(W,j){const C=U(Object.getOwnPropertyNames(W).map(re=>J(re,W[re],j)).filter(re=>re!==s)),X=C.length;if(!X)return s;if(!C.some(re=>!!re.requiresSiblings)){if(X===1)return C[0];const re=function(F,_){let z;for(let ie=0,G=C.length;ie<G;ie++){const B=C[ie](F,_);if(typeof B=="string")return B;(0,r.$qh)(B)&&(z||(z=[]),z.push(B))}return z?(async()=>{for(const ie of z){const G=await ie;if(typeof G=="string")return G}return null})():null},Q=C.find(F=>!!F.allBasenames);Q&&(re.allBasenames=Q.allBasenames);const N=C.reduce((F,_)=>_.allPaths?F.concat(_.allPaths):F,[]);return N.length&&(re.allPaths=N),re}const oe=function(re,Q,N){let F,_;for(let z=0,ie=C.length;z<ie;z++){const G=C[z];G.requiresSiblings&&N&&(Q||(Q=(0,I.$nc)(re)),F||(F=Q.substr(0,Q.length-(0,I.$oc)(re).length)));const B=G(re,Q,F,N);if(typeof B=="string")return B;(0,r.$qh)(B)&&(_||(_=[]),_.push(B))}return _?(async()=>{for(const z of _){const ie=await z;if(typeof ie=="string")return ie}return null})():null},V=C.find(re=>!!re.allBasenames);V&&(oe.allBasenames=V.allBasenames);const ue=C.reduce((re,Q)=>Q.allPaths?re.concat(Q.allPaths):re,[]);return ue.length&&(oe.allPaths=ue),oe}function J(W,j,C){if(j===!1)return s;const X=a(W,C);if(X===s)return s;if(typeof j=="boolean")return X;if(j){const oe=j.when;if(typeof oe=="string"){const V=(ue,re,Q,N)=>{if(!N||!X(ue,re))return null;const F=oe.replace("$(basename)",()=>Q),_=N(F);return(0,r.$qh)(_)?_.then(z=>z?W:null):_?W:null};return V.requiresSiblings=!0,V}}return X}function U(W,j){const C=W.filter(re=>!!re.basenames);if(C.length<2)return W;const X=C.reduce((re,Q)=>{const N=Q.basenames;return N?re.concat(N):re},[]);let oe;if(j){oe=[];for(let re=0,Q=X.length;re<Q;re++)oe.push(j)}else oe=C.reduce((re,Q)=>{const N=Q.patterns;return N?re.concat(N):re},[]);const V=function(re,Q){if(typeof re!="string")return null;if(!Q){let F;for(F=re.length;F>0;F--){const _=re.charCodeAt(F-1);if(_===P.CharCode.Slash||_===P.CharCode.Backslash)break}Q=re.substr(F)}const N=X.indexOf(Q);return N!==-1?oe[N]:null};V.basenames=X,V.patterns=oe,V.allBasenames=X;const ue=W.filter(re=>!re.basenames);return ue.push(V),ue}function Z(W,j){return(0,n.$tb)(W,j,(C,X)=>typeof C=="string"&&typeof X=="string"?C===X:typeof C!="string"&&typeof X!="string"?C.base===X.base&&C.pattern===X.pattern:!1)}}),define(ce[47],le([0,1,21,32,9,3,18,25]),function(x,e,n,r,P,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yw=p,e.$Zw=m,e.$1w=d,e.$2w=w,e.$3w=b,e.$4w=k,e.$5w=S,e.$6w=t,e.$7w=u,e.$8w=i;function p(s,a){const{os:l,tildify:E,relative:y}=a;if(y){const A=c(s,y,l);if(typeof A=="string")return A}let R=s.fsPath;if(l===D.OperatingSystem.Windows&&!D.$j?R=R.replace(/\//g,"\\"):l!==D.OperatingSystem.Windows&&D.$j&&(R=R.replace(/\\/g,"/")),l!==D.OperatingSystem.Windows&&E?.userHome){const A=E.userHome.fsPath;let O;s.scheme!==E.userHome.scheme&&s.path[0]===P.$gc.sep&&s.path[1]!==P.$gc.sep?O=E.userHome.with({path:s.path}).fsPath:O=R,R=d(O,A,l)}return(l===D.OperatingSystem.Windows?P.$fc:P.$gc).normalize(m(R,l===D.OperatingSystem.Windows))}function c(s,a,l){const E=l===D.OperatingSystem.Windows?P.$fc:P.$gc,y=l===D.OperatingSystem.Linux?T.$8g:T.$0g,R=a.getWorkspace(),L=(0,n.$Nb)(R.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===P.$gc.sep&&s.path[1]!==P.$gc.sep&&(s=L.uri.with({path:s.path}));const A=a.getWorkspaceFolder(s);if(!A)return;let O;if(y.isEqual(A.uri,s)?O="":O=y.relativePath(A.uri,s)??"",O&&(O=E.normalize(O)),R.folders.length>1&&!a.noPrefix){const M=A.name?A.name:y.basenameOrAuthority(A.uri);O=O?`${M} \u2022 ${O}`:M}return O}function m(s,a=D.$j){return(0,r.$Ig)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}let h=Object.create(null);function d(s,a,l=D.OS){if(l===D.OperatingSystem.Windows||!s||!a)return s;let E=h.original===a?h.normalized:void 0;E||(E=a,D.$j&&(E=(0,r.$xg)(E)),E=`${(0,I.$nf)(E,P.$gc.sep)}${P.$gc.sep}`,h={original:a,normalized:E});let y=s;return D.$j&&(y=(0,r.$xg)(y)),(l===D.OperatingSystem.Linux?y.startsWith(E):(0,I.$Gf)(y,E))?`~/${y.substr(E.length)}`:s}function w(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}const f="\u2026",g="\\\\",v="~";function b(s,a=P.sep){const l=new Array(s.length);let E=!1;for(let y=0;y<s.length;y++){const R=s[y];if(R===""){l[y]=`.${a}`;continue}if(!R){l[y]=R;continue}E=!0;let L="",A=R;A.indexOf(g)===0?(L=A.substr(0,A.indexOf(g)+g.length),A=A.substr(A.indexOf(g)+g.length)):A.indexOf(a)===0?(L=A.substr(0,A.indexOf(a)+a.length),A=A.substr(A.indexOf(a)+a.length)):A.indexOf(v)===0&&(L=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const O=A.split(a);for(let M=1;E&&M<=O.length;M++)for(let H=O.length-M;E&&H>=0;H--){E=!1;let q=O.slice(H,H+M).join(a);for(let K=0;!E&&K<s.length;K++)if(K!==y&&s[K]&&s[K].indexOf(q)>-1){const de=H+M===O.length,Y=H>0&&s[K].indexOf(a)>-1?a+q:q,J=s[K].endsWith(Y);E=!de||J}if(!E){let K="";(O[0].endsWith(":")||L!=="")&&(H===1&&(H=0,M++,q=O[0]+a+q),H>0&&(K=O[0]+a),K=L+K),H>0&&(K=K+f+a),K=K+q,H+M<O.length&&(K=K+a+f),l[y]=K}}E&&(l[y]=R)}return l}var $;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})($||($={}));function k(s,a=Object.create(null)){const l=[];let E=!1,y="";for(const R of s)if(R==="$"||E&&R==="{")y&&l.push({value:y,type:$.TEXT}),y="",E=!0;else if(R==="}"&&E){const L=a[y];if(typeof L=="string")L.length&&l.push({value:L,type:$.VARIABLE});else if(L){const A=l[l.length-1];(!A||A.type!==$.SEPARATOR)&&l.push({value:L.label,type:$.SEPARATOR})}y="",E=!1}else y+=R;return y&&!E&&l.push({value:y,type:$.TEXT}),l.filter((R,L)=>{if(R.type===$.SEPARATOR){const A=l[L-1],O=l[L+1];return[A,O].every(M=>M&&(M.type===$.VARIABLE||M.type===$.TEXT)&&M.value.length>0)}return!0}).map(R=>R.value).join("")}function S(s,a){return D.$k||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$k?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function t(s,a){return D.$k||a?s.replace(/\(&&\w\)|&&/g,""):D.$j?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}function u(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const a=s.lastIndexOf(" [",s.length-2);if(a!==-1){const l=o(s.substring(0,a)),E=s.substring(a);return{name:l.name+E,parentPath:l.parentPath}}}return o(s)}function o(s){const a=s.indexOf("/")!==-1?P.$gc:P.$fc,l=a.basename(s),E=a.dirname(s);return l.length?{name:l,parentPath:E}:{name:E,parentPath:""}}}),define(ce[151],le([0,1,17,90,7]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=p,e.$On=m,e.$Pn=h;function D(d){return d.toJSON()}class T{constructor(w){this.a=w}transformIncoming(w){const f=this.a.transformIncoming(w);return f===w?w:D(P.URI.from(f))}transformOutgoing(w){const f=this.a.transformOutgoing(w);return f===w?w:D(P.URI.from(f))}transformOutgoingURI(w){const f=this.a.transformOutgoing(w);return f===w?w:P.URI.from(f)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Ln=T,e.$Mn=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function I(d,w,f){if(!d||f>200)return null;if(typeof d=="object"){if(d instanceof P.URI)return w.transformOutgoing(d);for(const g in d)if(Object.hasOwnProperty.call(d,g)){const v=I(d[g],w,f+1);v!==null&&(d[g]=v)}}return null}function p(d,w){const f=I(d,w,0);return f===null?d:f}function c(d,w,f,g){if(!d||g>200)return null;if(typeof d=="object"){if(d.$mid===r.MarshalledId.Uri)return f?P.URI.revive(w.transformIncoming(d)):w.transformIncoming(d);if(d instanceof n.$Ne)return null;for(const v in d)if(Object.hasOwnProperty.call(d,v)){const b=c(d[v],w,f,g+1);b!==null&&(d[v]=b)}}return null}function m(d,w){const f=c(d,w,!1,0);return f===null?d:f}function h(d,w){const f=c(d,w,!0,0);return f===null?d:f}}),define(ce[33],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(P){return n.test(P)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(I){for(let p=0;p<I.length;p++)I[p]=Math.floor(Math.random()*256);return I};const D=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let p=0,c="";return c+=T[D[p++]],c+=T[D[p++]],c+=T[D[p++]],c+=T[D[p++]],c+="-",c+=T[D[p++]],c+=T[D[p++]],c+="-",c+=T[D[p++]],c+=T[D[p++]],c+="-",c+=T[D[p++]],c+=T[D[p++]],c+="-",c+=T[D[p++]],c+=T[D[p++]],c+=T[D[p++]],c+=T[D[p++]],c+=T[D[p++]],c+=T[D[p++]],c}}()}),define(ce[152],le([0,1,91,26,89]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MX=D,n=Pe(n),r=Pe(r);async function D(T,I){if(await new Promise((m,h)=>{const d=r.createReadStream(T),w=n.createHash("sha256");d.pipe(w);const f=(0,P.$cb)((g,v)=>{d.removeAllListeners(),w.removeAllListeners(),g?h(g):m(v)});d.once("error",f),d.once("end",f),w.once("error",f),w.once("data",g=>f(void 0,g.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(ce[153],le([0,1,27]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=D;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(T){const I=T.replace(/\-/g,":").toLowerCase();return!r.has(I)}function D(){const T=(0,n.networkInterfaces)();for(const I in T){const p=T[I];if(p){for(const{mac:c}of p)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[92],le([0,1,27,60,33,153,3]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0,e.$Sn=p,e.$Tn=h,e.$Un=d,P=Pe(P),e.$Rn=new class{c(w){return this.a||(this.a=r.$Ki.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,f=0;const g=(0,n.networkInterfaces)();for(const v in g){const b=g[v];if(b)for(const{mac:$,internal:k}of b)k||(f+=1,this.c($.toUpperCase())&&(w+=1))}this.b=f>0?w/f:0}return this.b}};let I;async function p(w){return I||(I=(async()=>await c(w)||P.$1g())()),I}async function c(w){try{const f=await new Promise((v,b)=>{x(["crypto"],v,b)}).then(Pe),g=(0,D.$Qn)();return f.createHash("sha256").update(g,"utf8").digest("hex")}catch(f){w(f);return}}const m="Software\\Microsoft\\SQMClient";async function h(w){if(T.$j){const f=await new Promise((g,v)=>{x(["@vscode/windows-registry"],g,v)}).then(Pe);try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",m,"MachineId")||""}catch(g){return w(g),""}}return""}async function d(w){try{return await(await new Promise((v,b)=>{x(["@vscode/deviceid"],v,b)}).then(Pe)).getDeviceId()}catch(f){return w(f),""}}}),define(ce[23],le([0,1,26,27,154,8,32,78,9,3,18,7]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=k,e.whenDeleted=u,e.configureFlushOnWrite=l,e.writeFileSync=y,n=Pe(n);var d;(function(Y){Y[Y.UNLINK=0]="UNLINK",Y[Y.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function w(Y,J=d.UNLINK,U){if((0,T.$Hg)(Y))throw new Error("rimraf - will refuse to recursively delete root");return J===d.UNLINK?g(Y):f(Y,U)}async function f(Y,J=(0,T.$Mg)((0,r.tmpdir)())){try{try{await n.promises.rename(Y,J)}catch(U){return U.code==="ENOENT"?void 0:g(Y)}g(J).catch(U=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function g(Y){return n.promises.rm(Y,{recursive:!0,force:!0,maxRetries:3})}function v(Y){if((0,T.$Hg)(Y))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(Y,{recursive:!0,force:!0,maxRetries:3})}async function b(Y,J){return S(await(J?$(Y):n.promises.readdir(Y)))}async function $(Y){try{return await n.promises.readdir(Y,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const J=[],U=await b(Y);for(const Z of U){let W=!1,j=!1,C=!1;try{const X=await n.promises.lstat((0,p.$jc)(Y,Z));W=X.isFile(),j=X.isDirectory(),C=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}J.push({name:Z,isFile:()=>W,isDirectory:()=>j,isSymbolicLink:()=>C})}return J}function k(Y){return S(n.readdirSync(Y))}function S(Y){return Y.map(J=>typeof J=="string"?c.$k?(0,I.$mm)(J):J:(J.name=c.$k?(0,I.$mm)(J.name):J.name,J))}async function t(Y){const J=await b(Y),U=[];for(const Z of J)await i.existsDirectory((0,p.$jc)(Y,Z))&&U.push(Z);return U}function u(Y,J=1e3){return new Promise(U=>{let Z=!1;const W=setInterval(()=>{Z||(Z=!0,n.access(Y,j=>{Z=!1,j&&(clearInterval(W),U(void 0))}))},J)})}var i;(function(Y){async function J(W){let j;try{if(j=await n.promises.lstat(W),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await n.promises.stat(W),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(C){if(C.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(c.$j&&C.code==="EACCES")try{return{stat:await n.promises.stat(await n.promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw X}throw C}}Y.stat=J;async function U(W){try{const{stat:j,symbolicLink:C}=await Y.stat(W);return j.isFile()&&C?.dangling!==!0}catch{}return!1}Y.existsFile=U;async function Z(W){try{const{stat:j,symbolicLink:C}=await Y.stat(W);return j.isDirectory()&&C?.dangling!==!0}catch{}return!1}Y.existsDirectory=Z})(i||(e.SymlinkSupport=i={}));const o=new D.$Nh;function s(Y,J,U){return o.queueFor(h.URI.file(Y),()=>{const Z=R(U);return new Promise((W,j)=>E(Y,J,Z,C=>C?j(C):W()))},m.$9g)}let a=!0;function l(Y){a=Y}function E(Y,J,U,Z){if(!a)return n.writeFile(Y,J,{mode:U.mode,flag:U.flag},Z);n.open(Y,U.flag,U.mode,(W,j)=>{if(W)return Z(W);n.writeFile(j,J,C=>{if(C)return n.close(j,()=>Z(C));n.fdatasync(j,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),l(!1)),n.close(j,oe=>Z(oe))))})})}function y(Y,J,U){const Z=R(U);if(!a)return n.writeFileSync(Y,J,{mode:Z.mode,flag:Z.flag});const W=n.openSync(Y,Z.flag,Z.mode);try{n.writeFileSync(W,J);try{n.fdatasyncSync(W)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{n.closeSync(W)}}function R(Y){return Y?{mode:typeof Y.mode=="number"?Y.mode:438,flag:typeof Y.flag=="string"?Y.flag:"w"}:{mode:438,flag:"w"}}async function L(Y,J,U=6e4){if(Y!==J)try{c.$j&&typeof U=="number"?await A(Y,J,Date.now(),U):await n.promises.rename(Y,J)}catch(Z){if(Y.toLowerCase()!==J.toLowerCase()&&Z.code==="EXDEV"||Y.endsWith("."))await O(Y,J,{preserveSymlinks:!1}),await w(Y,d.MOVE);else throw Z}}async function A(Y,J,U,Z,W=0){try{return await n.promises.rename(Y,J)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-U>=Z)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${j}`),j;if(W===0){let C=!1;try{const{stat:X}=await i.stat(J);X.isFile()||(C=!0)}catch{}if(C)throw j}return await(0,D.$Fh)(Math.min(100,W*10)),A(Y,J,U,Z,W+1)}}async function O(Y,J,U){return H(Y,J,{root:{source:Y,target:J},options:U,handledSourcePaths:new Set})}const M=511;async function H(Y,J,U){if(U.handledSourcePaths.has(Y))return;U.handledSourcePaths.add(Y);const{stat:Z,symbolicLink:W}=await i.stat(Y);if(W){if(U.options.preserveSymlinks)try{return await de(Y,J,U)}catch{}if(W.dangling)return}return Z.isDirectory()?q(Y,J,Z.mode&M,U):K(Y,J,Z.mode&M)}async function q(Y,J,U,Z){await n.promises.mkdir(J,{recursive:!0,mode:U});const W=await b(Y);for(const j of W)await H((0,p.$jc)(Y,j),(0,p.$jc)(J,j),Z)}async function K(Y,J,U){await n.promises.copyFile(Y,J),await n.promises.chmod(J,U)}async function de(Y,J,U){let Z=await n.promises.readlink(Y);(0,T.$Dg)(Z,U.root.source,!c.$l)&&(Z=(0,p.$jc)(U.root.target,Z.substr(U.root.source.length+1))),await n.promises.symlink(Z,J)}e.Promises=new class{get read(){return(Y,J,U,Z,W)=>new Promise((j,C)=>{n.read(Y,J,U,Z,W,(X,oe,V)=>X?C(X):j({bytesRead:oe,buffer:V}))})}get write(){return(Y,J,U,Z,W)=>new Promise((j,C)=>{n.write(Y,J,U,Z,W,(X,oe,V)=>X?C(X):j({bytesWritten:oe,buffer:V}))})}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get realpath(){return(0,P.promisify)(n.realpath)}async exists(Y){try{return await n.promises.access(Y),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return w}get rename(){return L}get copy(){return O}}}),define(ce[112],le([0,1,26,9,3,25,23]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=I,e.$lr=p,e.$mr=c,e.$nr=m,n=Pe(n);function I(d){if(P.$l)return d;const w=(0,r.$mc)(d);if(d===w)return d;const f=((0,r.$nc)(d)||d).toLowerCase();try{const v=(0,T.readdirSync)(w).filter(b=>b.toLowerCase()===f);if(v.length===1){const b=I(w);if(b)return(0,r.$jc)(b,v[0])}else if(v.length>1){const b=v.indexOf(f);if(b>=0){const $=I(w);if($)return(0,r.$jc)($,v[b])}}}catch{}return null}async function p(d,w){if(P.$l)return d;const f=(0,r.$mc)(d);if(d===f)return d;const g=((0,r.$nc)(d)||d).toLowerCase();try{if(w?.isCancellationRequested)return null;const b=(await T.Promises.readdir(f)).filter($=>$.toLowerCase()===g);if(b.length===1){const $=await p(f,w);if($)return(0,r.$jc)($,b[0])}else if(b.length>1){const $=b.indexOf(g);if($>=0){const k=await p(f,w);if(k)return(0,r.$jc)(k,b[$])}}}catch{}return null}async function c(d){try{return await T.Promises.realpath(d)}catch{const f=h(d);return await n.promises.access(f,n.constants.R_OK),f}}function m(d){try{return n.realpathSync(d)}catch{const f=h(d);return n.accessSync(f,n.constants.R_OK),f}}function h(d){return(0,D.$nf)((0,r.$hc)(d),r.sep)}}),define(ce[113],le([0,1,93]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=void 0,e.$3g=r,e.$5g=D,n=Pe(n);function r(I,p,c,m=1){let h=!1;return new Promise(d=>{const w=setTimeout(()=>{if(!h)return h=!0,d(0)},c);P(I,p,m,f=>{if(!h)return h=!0,clearTimeout(w),d(f)})})}function P(I,p,c,m){if(p===0)return m(0);const h=new n.Socket;h.once("connect",()=>(T(h),P(I+c,p-1,c,m))),h.once("data",()=>{}),h.once("error",d=>(T(h),d.code!=="ECONNREFUSED"?P(I+c,p-1,c,m):m(I))),h.connect(I,"127.0.0.1")}e.$4g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(I,p,c,m="127.0.0.1"){let h=!1,d,w=1;const f=n.createServer({pauseOnConnect:!0});function g(v,b){h||(h=!0,f.removeAllListeners(),f.close(),d&&clearTimeout(d),b(v))}return new Promise(v=>{d=setTimeout(()=>{g(0,v)},c),f.on("listening",()=>{g(I,v)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&w<p?(I++,w++,f.listen(I,m)):g(0,v)}),f.on("close",()=>{g(0,v)}),f.listen(I,m)})}function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(p){console.error(p)}}}),define(ce[114],le([0,1,27,9,23]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=$,e.$wm=k,n=Pe(n),r=Pe(r),P=Pe(P);const D=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var p;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(p||(p={}));let c;switch(process.arch){case"ia32":c=p.x86;break;case"arm":case"arm64":c=p.ARM;break;default:c=p.x64;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=p.x86:m=p.x64;class h{constructor(t,u,i){this.exePath=t,this.displayName=u,this.a=i}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:S=!1}={}){return S?c===p.x64?process.env["ProgramFiles(x86)"]||null:m===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:S=!1,findPreview:t=!1}={}){const u=d({useAlternateBitness:S});if(!u)return null;const i=r.$jc(u,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(i))return null;let o=-1,s=null;for(const E of await P.Promises.readdir(i)){let y=-1;if(t){const L=E.indexOf("-");if(L<0)continue;const A=E.substring(0,L);if(!D.test(A)||E.substring(L+1)!=="preview")continue;y=parseInt(A,10)}else{if(!D.test(E))continue;y=parseInt(E,10)}if(y<=o)continue;const R=r.$jc(i,E,"pwsh.exe");await P.SymlinkSupport.existsFile(R)&&(s=R,o=y)}if(!s)return null;const a=u.includes("x86")?" (x86)":"",l=t?" Preview":"";return new h(s,`PowerShell${l}${a}`,!0)}async function f({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const t=r.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:u,pwshMsixName:i}=S?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const o of await P.Promises.readdir(t))if(u.test(o)){const s=r.$jc(t,o,"pwsh.exe");return new h(s,i)}return null}function g(){const S=r.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new h(S,".NET Core PowerShell Global Tool")}function v(){const S=r.$jc(process.env.windir,c===p.x86&&m!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(S,"Windows PowerShell",!0)}async function*b(){let S=await w();S&&(yield S),S=await w({useAlternateBitness:!0}),S&&(yield S),S=await f(),S&&(yield S),S=g(),S&&(yield S),S=await w({findPreview:!0}),S&&(yield S),S=await f({findPreview:!0}),S&&(yield S),S=await w({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=v(),S&&(yield S)}async function*$(){for await(const S of b())await S.exists()&&(yield S)}async function k(){for await(const S of $())return S;return null}}),define(ce[94],le([0,1,26,9,3,36,79,12,23]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=c,e.$ym=m,r=Pe(r),P=Pe(P),D=Pe(D),I=Pe(I),p=Pe(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function c(d=D.env){return d.comspec||"cmd.exe"}function m(d){let w=[],f=!1;const g=function(v){if(f){w.push(v);return}(!d.send(v,$=>{if($&&console.error($),f=!1,w.length>0){const k=w.slice(0);w=[],k.forEach(S=>g(S))}})||P.$j)&&(f=!0)};return{send:g}}var h;(function(d){async function w(f,g,v){if(r.$ic(f))return f;if(g===void 0&&(g=D.cwd()),r.$mc(f)!=="."||(v===void 0&&I.$eg(D.env.PATH)&&(v=D.env.PATH.split(r.$tc)),v===void 0||v.length===0))return r.$jc(g,f);async function $(k){if(await p.Promises.exists(k)){let S;try{S=await n.promises.stat(k)}catch(t){t.message.startsWith("EACCES")&&(S=await n.promises.lstat(k))}return S?!S.isDirectory():!1}return!1}for(const k of v){let S;if(r.$ic(k)?S=r.$jc(k,f):S=r.$jc(g,k,f),await $(S))return S;let t=S+".com";if(await $(t)||(t=S+".exe",await $(t)))return t}return r.$jc(g,f)}d.findExecutable=w})(h||(e.win32=h={}))}),define(ce[115],le([0,1,48,11]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=P;function P(T){return new Promise((I,p)=>{let c;const m=new Map;function h(w,f,g,v,b){const $=m.get(f);if(w===T||$){const k={name:d(g),cmd:g,pid:w,ppid:f,load:v,mem:b};m.set(w,k),w===T&&(c=k),$&&($.children||($.children=[]),$.children.push(k),$.children.length>1&&($.children=$.children.sort((S,t)=>S.pid-t.pid)))}}function d(w){const f=/--utility-sub-type=network/i,g=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(g.exec(w))return"electron-crash-reporter";if(v.exec(w))return"winpty-agent";if(b.exec(w))return"conpty-agent";let k=$.exec(w);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?f.exec(w)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const S=/[a-zA-Z-]+\.js/g;let t="";do k=S.exec(w),k&&(t+=k+" ");while(k);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,g)=>{x(["@vscode/windows-process-tree"],f,g)}).then(Pe).then(f=>{f.getProcessList(T,g=>{if(!g){p(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(g,v=>{const b=new Map;v.forEach($=>{const k=w($.commandLine||"");b.set($.pid,{name:d(k),cmd:k,pid:$.pid,ppid:$.ppid,load:$.cpu||0,mem:$.memory||0})}),c=b.get(T),c?(b.forEach($=>{const k=b.get($.ppid);k&&(k.children||(k.children=[]),k.children.push($))}),b.forEach($=>{$.children&&($.children=$.children.sort((k,S)=>k.pid-S.pid))}),I(c)):p(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let w=function(){let f=[c];const g=[];for(;f.length;){const b=f.shift();b&&(g.push(b.pid),b.children&&(f=f.concat(b.children)))}let v=JSON.stringify(r.$Yg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+g.join(" "),(0,n.exec)(v,{},(b,$,k)=>{if(b||k)p(b||new Error(k.toString()));else{const S=$.toString().split(`
`);for(let t=0;t<g.length;t++){const u=m.get(g[t]);u.load=parseFloat(S[t])}if(!c){p(new Error(`Root process ${T} not found`));return}I(c)}})};(0,n.exec)("which ps",{},(f,g,v)=>{if(f||v)if(process.platform!=="linux")p(f||new Error(v.toString()));else{const b=JSON.stringify(r.$Yg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(b,{},($,k,S)=>{$||S?p($||new Error(S.toString())):(D(k,h),w())})}else{const b=g.toString().trim();(0,n.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,S,t)=>{k||t&&!t.includes("screen size is bogus")?p(k||new Error(t.toString())):(D(S,h),process.platform==="linux"?w():c?I(c):p(new Error(`Root process ${T} not found`)))})}})}})}function D(T,I){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=T.toString().split(`
`);for(const m of c){const h=p.exec(m.trim());h&&h.length===6&&I(parseInt(h[1]),parseInt(h[2]),h[5],parseFloat(h[3]),parseFloat(h[4]))}}}),define(ce[116],le([0,1,27,3,114,94]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=T,r=Pe(r),D=Pe(D);async function T(h,d){return h===r.OperatingSystem.Windows?r.$j?m():D.$xm(d):p(h,d)}let I=null;function p(h,d){if(r.$l&&h===r.OperatingSystem.Macintosh||r.$k&&h===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(r.$j)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let c=null;async function m(){return c||(c=(await(0,P.$wm)()).exePath),c}}),function(){function x(){function e(){return process.uncHostAllowlist}function n(p){const c=new Set;if(Array.isArray(p))for(const m of p)typeof m=="string"&&c.add(m);return Array.from(c)}function r(){const p=e();return p?Array.from(p):[]}function P(p){if(process.platform!=="win32")return;const c=e();if(c)if(typeof p=="string")c.add(p.toLowerCase());else for(const m of n(p))P(m)}function D(p){if(typeof p!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const h of c){if(p.indexOf(h)!==0)continue;const w=p.indexOf("\\",h.length);if(w===-1)continue;const f=p.substring(h.length,w);if(f){m=f;break}}return m}function T(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:P,getUNCHost:D,disableUNCAccessRestrictions:T,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[155],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SX=e.$RX=void 0,e.$RX="vscode:contextmenu",e.$SX="vscode:onCloseContextMenu"});var Se=this&&this.__decorate||function(x,e,n,r){var P=arguments.length,D=P<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,n,r);else for(var I=x.length-1;I>=0;I--)(T=x[I])&&(D=(P<3?T(D):P>3?T(e,n,D):T(e,n))||D);return P>3&&D&&Object.defineProperty(e,n,D),D};define(ce[44],le([0,1,21,8,17,22,54,15,4,2,82,25,12]),function(x,e,n,r,P,D,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.ProxyChannel=e.$mi=e.$ji=e.$ii=e.$hi=e.RequestInitiator=e.$gi=e.$di=e.$ci=void 0,e.$ei=l,e.$fi=E,e.$ki=M,e.$li=H,h=Pe(h);var w;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(w||(w={}));function f(W){switch(W){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var g;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(g||(g={}));function v(W){switch(W){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var b;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(b||(b={}));function $(W){let j=0;for(let C=0;;C+=7){const X=W.read(1);if(j|=(X.buffer[0]&127)<<C,!(X.buffer[0]&128))return j}}const k=o(0);function S(W,j){if(j===0){W.write(k);return}let C=0;for(let oe=j;oe!==0;oe=oe>>>7)C++;const X=P.$Ne.alloc(C);for(let oe=0;j!==0;oe++)X.buffer[oe]=j&127,j=j>>>7,j>0&&(X.buffer[oe]|=128);W.write(X)}class t{constructor(j){this.b=j,this.a=0}read(j){const C=this.b.slice(this.a,this.a+j);return this.a+=C.byteLength,C}}e.$ci=t;class u{constructor(){this.a=[]}get buffer(){return P.$Ne.concat(this.a)}write(j){this.a.push(j)}}e.$di=u;var i;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(i||(i={}));function o(W){const j=P.$Ne.alloc(1);return j.writeUInt8(W,0),j}const s={Undefined:o(i.Undefined),String:o(i.String),Buffer:o(i.Buffer),VSBuffer:o(i.VSBuffer),Array:o(i.Array),Object:o(i.Object),Uint:o(i.Int)},a=typeof Buffer<"u";function l(W,j){if(typeof j>"u")W.write(s.Undefined);else if(typeof j=="string"){const C=P.$Ne.fromString(j);W.write(s.String),S(W,C.byteLength),W.write(C)}else if(a&&Buffer.isBuffer(j)){const C=P.$Ne.wrap(j);W.write(s.Buffer),S(W,C.byteLength),W.write(C)}else if(j instanceof P.$Ne)W.write(s.VSBuffer),S(W,j.byteLength),W.write(j);else if(Array.isArray(j)){W.write(s.Array),S(W,j.length);for(const C of j)l(W,C)}else if(typeof j=="number"&&(j|0)===j)W.write(s.Uint),S(W,j);else{const C=P.$Ne.fromString(JSON.stringify(j));W.write(s.Object),S(W,C.byteLength),W.write(C)}}function E(W){switch(W.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return W.read($(W)).toString();case i.Buffer:return W.read($(W)).buffer;case i.VSBuffer:return W.read($(W));case i.Array:{const C=$(W),X=[];for(let oe=0;oe<C;oe++)X.push(E(W));return X}case i.Object:return JSON.parse(W.read($(W)).toString());case i.Int:return $(W)}}class y{constructor(j,C,X=null,oe=1e3){this.h=j,this.j=C,this.k=X,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(V=>this.q(V)),this.m({type:g.Initialize})}registerChannel(j,C){this.b.set(j,C),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case g.Initialize:{const C=this.o([j.type]);this.k?.logOutgoing(C,0,R.OtherSide,v(j.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const C=this.o([j.type,j.id],j.data);this.k?.logOutgoing(C,j.id,R.OtherSide,v(j.type),j.data);return}}}o(j,C=void 0){const X=new u;return l(X,j),l(X,C),this.p(X.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const C=new t(j),X=E(C),oe=E(C),V=X[0];switch(V){case w.Promise:return this.k?.logIncoming(j.byteLength,X[1],R.OtherSide,`${f(V)}: ${X[2]}.${X[3]}`,oe),this.s({type:V,id:X[1],channelName:X[2],name:X[3],arg:oe});case w.EventListen:return this.k?.logIncoming(j.byteLength,X[1],R.OtherSide,`${f(V)}: ${X[2]}.${X[3]}`,oe),this.t({type:V,id:X[1],channelName:X[2],name:X[3],arg:oe});case w.PromiseCancel:return this.k?.logIncoming(j.byteLength,X[1],R.OtherSide,`${f(V)}`),this.u({type:V,id:X[1]});case w.EventDispose:return this.k?.logIncoming(j.byteLength,X[1],R.OtherSide,`${f(V)}`),this.u({type:V,id:X[1]})}}s(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const X=new D.$we;let oe;try{oe=C.call(this.j,j.name,j.arg,X.token)}catch(re){oe=Promise.reject(re)}const V=j.id;oe.then(re=>{this.m({id:V,data:re,type:g.PromiseSuccess})},re=>{re instanceof Error?this.m({id:V,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split(`
`):void 0},type:g.PromiseError}):this.m({id:V,data:re,type:g.PromiseErrorObj})}).finally(()=>{ue.dispose(),this.d.delete(j.id)});const ue=(0,c.$Sc)(()=>X.cancel());this.d.set(j.id,ue)}t(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const X=j.id,V=C.listen(this.j,j.name,j.arg)(ue=>this.m({id:X,data:ue,type:g.EventFire}));this.d.set(j.id,V)}u(j){const C=this.d.get(j.id);C&&(C.dispose(),this.d.delete(j.id))}v(j){let C=this.g.get(j.channelName);C||(C=[],this.g.set(j.channelName,C));const X=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===w.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:g.PromiseError})},this.l);C.push({request:j,timeoutTimer:X})}w(j){const C=this.g.get(j);if(C){for(const X of C)switch(clearTimeout(X.timeoutTimer),X.request.type){case w.Promise:this.s(X.request);break;case w.EventListen:this.t(X.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$gi=y;var R;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class L{constructor(j,C=null){this.l=j,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=C}getChannel(j){const C=this;return{call(X,oe,V){return C.a?Promise.reject(new I.$4):C.m(j,X,oe,V)},listen(X,oe){return C.a?p.Event.None:C.o(j,X,oe)}}}m(j,C,X,oe=D.CancellationToken.None){const V=this.g++,ue=w.Promise,re={id:V,type:ue,channelName:j,name:C,arg:X};if(oe.isCancellationRequested)return Promise.reject(new I.$4);let Q;return new Promise((F,_)=>{if(oe.isCancellationRequested)return _(new I.$4);const z=()=>{const te=he=>{switch(he.type){case g.PromiseSuccess:this.f.delete(V),F(he.data);break;case g.PromiseError:{this.f.delete(V);const me=new Error(he.data.message);me.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,me.name=he.data.name,_(me);break}case g.PromiseErrorObj:this.f.delete(V),_(he.data);break}};this.f.set(V,te),this.p(re)};let ie=null;this.b===b.Idle?z():(ie=(0,r.$rh)(te=>this.u()),ie.then(()=>{ie=null,z()}));const G=()=>{ie?(ie.cancel(),ie=null):this.p({id:V,type:w.PromiseCancel}),_(new I.$4)},B=oe.onCancellationRequested(G);Q=(0,c.$Rc)((0,c.$Sc)(G),B),this.d.add(Q)}).finally(()=>{Q.dispose(),this.d.delete(Q)})}o(j,C,X){const oe=this.g++,V=w.EventListen,ue={id:oe,type:V,channelName:j,name:C,arg:X};let re=null;const Q=new p.$le({onWillAddFirstListener:()=>{re=(0,r.$rh)(F=>this.u()),re.then(()=>{re=null,this.d.add(Q),this.p(ue)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(Q),this.p({id:oe,type:w.EventDispose}))}}),N=F=>Q.fire(F.data);return this.f.set(oe,N),Q.event}p(j){switch(j.type){case w.Promise:case w.EventListen:{const C=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(C,j.id,R.LocalSide,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case w.PromiseCancel:case w.EventDispose:{const C=this.q([j.type,j.id]);this.j?.logOutgoing(C,j.id,R.LocalSide,f(j.type));return}}}q(j,C=void 0){const X=new u;return l(X,j),l(X,C),this.r(X.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const C=new t(j),X=E(C),oe=E(C),V=X[0];switch(V){case g.Initialize:return this.j?.logIncoming(j.byteLength,0,R.LocalSide,v(V)),this.t({type:X[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,X[1],R.LocalSide,v(V),oe),this.t({type:X[0],id:X[1],data:oe})}}t(j){if(j.type===g.Initialize){this.b=b.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$hi=L,Se([T.$9h],L.prototype,"onDidInitializePromise",null);class A{get connections(){const j=[];return this.f.forEach(C=>j.push(C)),j}constructor(j,C,X){this.a=new Map,this.f=new Set,this.g=new p.$le,this.onDidAddConnection=this.g.event,this.h=new p.$le,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(j(({protocol:oe,onDidClientDisconnect:V})=>{const ue=p.Event.once(oe.onMessage);this.j.add(ue(re=>{const Q=new t(re),N=E(Q),F=new y(oe,N,C,X),_=new L(oe,C);this.a.forEach((ie,G)=>F.registerChannel(G,ie));const z={channelServer:F,channelClient:_,ctx:N};this.f.add(z),this.g.fire(z),this.j.add(V(()=>{F.dispose(),_.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(j,C){const X=this;return{call(oe,V,ue){let re;if((0,d.$sg)(C)){const N=(0,n.$2b)(X.connections.filter(C));re=N?Promise.resolve(N):p.Event.toPromise(p.Event.filter(X.onDidAddConnection,C))}else re=C.routeCall(X,oe,V);const Q=re.then(N=>N.channelClient.getChannel(j));return M(Q).call(oe,V,ue)},listen(oe,V){if((0,d.$sg)(C))return X.k(j,C,oe,V);const ue=C.routeEvent(X,oe,V).then(re=>re.channelClient.getChannel(j));return M(ue).listen(oe,V)}}}k(j,C,X,oe){const V=this;let ue;const re=new p.$le({onWillAddFirstListener:()=>{ue=new c.$Tc;const Q=new p.$re,N=new Map,F=z=>{const G=z.channelClient.getChannel(j).listen(X,oe),B=Q.add(G);N.set(z,B)},_=z=>{const ie=N.get(z);ie&&(ie.dispose(),N.delete(z))};V.connections.filter(C).forEach(F),p.Event.filter(V.onDidAddConnection,C)(F,void 0,ue),V.onDidRemoveConnection(_,void 0,ue),Q.event(re.fire,re,ue),ue.add(Q)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return re.event}registerChannel(j,C){this.a.set(j,C);for(const X of this.f)X.channelServer.registerChannel(j,C)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ii=A;class O{constructor(j,C,X=null){const oe=new u;l(oe,C),j.send(oe.buffer),this.a=new L(j,X),this.d=new y(j,C,X)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,C){this.d.registerChannel(j,C)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ji=O;function M(W){return{call(j,C,X){return W.then(oe=>oe.call(j,C,X))},listen(j,C){const X=new p.$ue;return W.then(oe=>X.input=oe.listen(j,C)),X.event}}}function H(W){let j=!1;return{call(C,X,oe){return j?W.call(C,X,oe):(0,r.$Fh)(0).then(()=>j=!0).then(()=>W.call(C,X,oe))},listen(C,X){if(j)return W.listen(C,X);const oe=new p.$ue;return(0,r.$Fh)(0).then(()=>j=!0).then(()=>oe.input=W.listen(C,X)),oe.event}}}class q{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const C of j.connections)if(await Promise.resolve(this.a(C.ctx)))return Promise.resolve(C);return await p.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$mi=q;var K;(function(W){function j(V,ue,re){const Q=V,N=re&&re.disableMarshalling,F=new Map;for(const _ in Q)X(_)&&F.set(_,p.Event.buffer(Q[_],!0,void 0,ue));return new class{listen(_,z,ie){const G=F.get(z);if(G)return G;const B=Q[z];if(typeof B=="function"){if(oe(z))return B.call(Q,ie);if(X(z))return F.set(z,p.Event.buffer(Q[z],!0,void 0,ue)),F.get(z)}throw new I.$ab(`Event not found: ${z}`)}call(_,z,ie){const G=Q[z];if(typeof G=="function"){if(!N&&Array.isArray(ie))for(let te=0;te<ie.length;te++)ie[te]=(0,m.$bi)(ie[te]);let B=G.apply(Q,ie);return B instanceof Promise||(B=Promise.resolve(B)),B}throw new I.$ab(`Method not found: ${z}`)}}}W.fromService=j;function C(V,ue){const re=ue&&ue.disableMarshalling;return new Proxy({},{get(Q,N){if(typeof N=="string")return ue?.properties?.has(N)?ue.properties.get(N):oe(N)?function(F){return V.listen(N,F)}:X(N)?V.listen(N):async function(...F){let _;ue&&!(0,d.$ng)(ue.context)?_=[ue.context,...F]:_=F;const z=await V.call(N,_);return re?z:(0,m.$bi)(z)};throw new I.$ab(`Property not found: ${String(N)}`)}})}W.toService=C;function X(V){return V[0]==="o"&&V[1]==="n"&&h.$Ef(V.charCodeAt(2))}function oe(V){return/^onDynamic/.test(V)&&h.$Ef(V.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Y(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const j=W.toString();if(j!=="[object Object]")return j}return W}function J(W){return Array.isArray(W)?W.map(Y):Y(W)}function U(W,j,C,X,oe,V,ue){ue=J(ue);const re=de[oe],Q=re[X%re.length];let N=[`%c[${W}]%c[${String(j).padStart(7," ")}]%c[len: ${String(C).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(V)?(N=N.concat(ue),N.push(")")):N.push(ue),console.log.apply(console,N)}class Z{constructor(j,C){this.d=j,this.f=C,this.a=0,this.b=0}logOutgoing(j,C,X,oe,V){this.b+=j,U(this.d,this.b,j,C,X,oe,V)}logIncoming(j,C,X,oe,V){this.a+=j,U(this.f,this.a,j,C,X,oe,V)}}e.$ni=Z}),define(ce[156],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZX=void 0;class n{constructor(P,D){this.a=P,this.onMessage=D}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$ZX=n}),define(ce[157],le([0,1,17,4,44]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XX=e.$WX=void 0;class D{constructor(p){this.a=p,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$Ne.wrap(c.data):n.$Ne.alloc(0)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}e.$WX=D;class T extends P.$ji{constructor(p,c){const m=new D(p);super(m,c),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$XX=T}),define(ce[117],le([0,1,17,4,2,44]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.ProtocolConstants=e.$oi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let l=0;function E(R,L){if(!a.has(R)){const A=String(++l);a.set(R,A)}return a.get(R)}function y(R,L,A,O){if(!s.enableDiagnostics)return;const M=E(R,L);if(O instanceof n.$Ne||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const H=n.$Ne.alloc(O.byteLength);H.set(O),s.records.push({timestamp:Date.now(),id:M,label:L,type:A,buff:H})}else s.records.push({timestamp:Date.now(),id:M,label:L,type:A,data:O})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let c=null;function m(){return c||(c=n.$Ne.alloc(0)),c}class h{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return m();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const L=this.a[0];return l&&(this.a.shift(),this.b-=a),L}if(this.a[0].byteLength>a){const L=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),L}const E=n.$Ne.alloc(a);let y=0,R=0;for(;a>0;){const L=this.a[R];if(L.byteLength>a){const A=L.slice(0,a);E.set(A,y),y+=a,l&&(this.a[R]=L.slice(a),this.b-=a),a-=a}else E.set(L,y),y+=L.byteLength,l?(this.a.shift(),this.b-=L.byteLength):R++,a-=L.byteLength}return E}}e.$oi=h;var d;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(d||(d={}));function w(s){switch(s){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class g{constructor(a,l,E,y){this.type=a,this.id=l,this.ack=E,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends P.$Uc{constructor(a){super(),this.f=this.B(new r.$le),this.onMessage=this.f.event,this.g={readHead:!0,readLen:f.HeaderLength,messageType:d.None,id:0,ack:0},this.a=a,this.b=!1,this.c=new h,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const E=this.g.messageType,y=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=f.HeaderLength,this.g.messageType=d.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,l),this.f.fire(new g(E,y,R,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$Ne.alloc(f.HeaderLength);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:w(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,a.data),this.j(l,a.data)}g(a,l){const E=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,E}h(){const a=n.$Ne.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:a.byteLength}),this.c.write(a)}}class $ extends P.$Uc{constructor(a){super(),this.f=new r.$le,this.onMessage=this.f.event,this.g=new r.$le,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new b(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(l=>{l.type===d.Regular&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new g(d.Regular,0,0,a))}}e.$pi=$;class k extends D.$ji{static fromSocket(a,l){return new k(new $(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,E=null){super(a,l,E),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$qi=k;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$le({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$ri=S;class t{constructor(a){this.data=a,this.next=null}}class u{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,E=this.a;for(;E;)a[l++]=E.data,E=E.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new t(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<i.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=i.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+i.a)*1e3;let E=0;for(let y=0;y<i.a;y++)a-this.c[y]<=l&&E++;return 1-E/i.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(a){this.v=new S,this.onControlMessage=this.v.event,this.w=new S,this.onMessage=this.w.event,this.x=new S,this.onDidDispose=this.x.event,this.y=new S,this.onSocketClose=this.y.event,this.z=new S,this.onSocketTimeout=this.z.event,this.t=a.loadEstimator??i.getInstance(),this.u=a.sendKeepAlive??!0,this.a=!1,this.c=new u,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new P.$Tc,this.p=a.socket,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(l=>this.A(l))),this.s.add(this.p.onClose(l=>this.y.fire(l))),a.initialChunk&&this.r.acceptChunk(a.initialChunk),this.u?this.m=setInterval(()=>{this.E()},f.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const a=new g(d.Disconnect,0,0,m());this.q.write(a),this.q.flush()}}sendPause(){const a=new g(d.Pause,0,0,m());this.q.write(a)}sendResume(){const a=new g(d.Resume,0,0,m());this.q.write(a)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.s.dispose(),this.s=new P.$Tc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=a,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(E=>this.A(E))),this.s.add(this.p.onClose(E=>this.y.fire(E))),this.r.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.j=this.h;const a=new g(d.Ack,0,this.j,m());this.q.write(a);const l=this.c.toArray();for(let E=0,y=l.length;E<y;E++)this.q.write(l[E]);this.C()}acceptDisconnect(){this.x.fire()}A(a){if(a.ack>this.f){this.f=a.ack;do{const l=this.c.peek();if(l&&l.id<=a.ack)this.c.pop();else break}while(!0)}switch(a.type){case d.None:break;case d.Regular:{if(a.id>this.h)if(a.id!==this.h+1){const l=Date.now();l-this.n>1e4&&(this.n=l,this.q.write(new g(d.ReplayRequest,0,0,m())))}else this.h=a.id,this.k=Date.now(),this.B(),this.w.fire(a.data);break}case d.Control:{this.v.fire(a.data);break}case d.Ack:break;case d.Disconnect:{this.x.fire();break}case d.ReplayRequest:{const l=this.c.toArray();for(let E=0,y=l.length;E<y;E++)this.q.write(l[E]);this.C();break}case d.Pause:{this.q.pause();break}case d.Resume:{this.q.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(a){const l=++this.d;this.j=this.h;const E=new g(d.Regular,l,this.j,a);this.c.push(E),this.a||(this.q.write(E),this.C())}sendControl(a){const l=new g(d.Control,0,0,a);this.q.write(l)}B(){if(this.h<=this.j||this.l)return;const a=Date.now()-this.k;if(a>=f.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},f.AcknowledgeTime-a+5)}C(){if(this.d<=this.f||this.g||this.a)return;const a=this.c.peek(),l=Date.now()-a.writtenTime,E=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(l>=f.TimeoutTime&&E>=f.TimeoutTime&&y>=f.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:E});return}const R=Math.max(f.TimeoutTime-l,f.TimeoutTime-E,f.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},R)}D(){if(this.h<=this.j)return;this.j=this.h;const a=new g(d.Ack,0,this.j,m());this.q.write(a)}E(){this.j=this.h;const a=new g(d.KeepAlive,0,this.j,m());this.q.write(a)}}e.$si=o});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[35],le([0,1,13,15,11]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TX=void 0,n=Ve(n);class D{constructor(){this.a=new WeakMap}on(I,p){const c=(m,...h)=>{this.b(I,m)&&p(m,...h)};return this.a.set(p,c),n.default.ipcMain.on(I,c),this}once(I,p){return n.default.ipcMain.once(I,(c,...m)=>{this.b(I,c)&&p(c,...m)}),this}handle(I,p){return n.default.ipcMain.handle(I,(c,...m)=>this.b(I,c)?p(c,...m):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.default.ipcMain.removeHandler(I),this}removeListener(I,p){const c=this.a.get(p);return c&&(n.default.ipcMain.removeListener(I,c),this.a.delete(p)),this}b(I,p){if(!I||!I.startsWith("vscode:"))return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const c=p.senderFrame,m=c.url;if(!m||m==="about:blank")return!0;let h="unknown";try{h=new URL(m).host}catch{return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${m}'.`),!1}return h!==P.$Xg?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${h}'.`),!1):c.parent!==null?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${h}' is not a main frame.`),!1):!0}}e.$TX=new D}),define(ce[158],le([0,1,13,35,155]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UX=D;function D(){r.$TX.on(P.$RX,(I,p,c,m,h)=>{const d=T(I,m,c);d.popup({x:h?h.x:void 0,y:h?h.y:void 0,positioningItem:h?h.positioningItem:void 0,callback:()=>{d&&I.sender.send(P.$SX,p)}})})}function T(I,p,c){const m=new n.Menu;return c.forEach(h=>{let d;h.type==="separator"?d=new n.MenuItem({type:h.type}):Array.isArray(h.submenu)?d=new n.MenuItem({submenu:T(I,p,h.submenu),label:h.label}):d=new n.MenuItem({label:h.label,type:h.type,accelerator:h.accelerator,checked:h.checked,enabled:h.enabled,visible:h.visible,click:(w,f,g)=>I.sender.send(p,h.id,g)}),m.append(d)}),m}}),define(ce[159],le([0,1,35,17,4,2,44,156]),function(x,e,n,r,P,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1X=void 0;function p(m,h){const d=P.Event.fromNodeEventEmitter(n.$TX,h,(f,g)=>({event:f,message:g})),w=P.Event.filter(d,({event:f})=>f.sender.id===m);return P.Event.map(w,({message:f})=>f&&r.$Ne.wrap(f))}class c extends T.$ii{static{this.b=new Map}static d(){const h=P.Event.fromNodeEventEmitter(n.$TX,"vscode:hello",({sender:d})=>d);return P.Event.map(h,d=>{const w=d.id;c.b.get(w)?.dispose();const g=new P.$le;c.b.set(w,(0,D.$Sc)(()=>g.fire()));const v=p(w,"vscode:message"),b=P.Event.any(P.Event.signal(p(w,"vscode:disconnect")),g.event);return{protocol:new I.$ZX(d,v),onDidClientDisconnect:b}})}constructor(){super(c.d())}}e.$1X=c}),define(ce[118],le([0,1,35,4,33,157]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2X=void 0,e.$3X=I;class T extends D.$XX{constructor(c,m){super({addEventListener:(h,d)=>c.addListener(h,d),removeEventListener:(h,d)=>c.removeListener(h,d),postMessage:h=>c.postMessage(h),start:()=>c.start(),close:()=>c.close()},m)}}e.$2X=T;async function I(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,P.$1g)();p.webContents.send("vscode:createMessageChannel",c);const m=r.Event.fromNodeEventEmitter(n.$TX,"vscode:createMessageChannelResult",(d,w)=>({nonce:w,port:d.ports[0]})),{port:h}=await r.Event.toPromise(r.Event.once(r.Event.filter(m,d=>d.nonce===c)));return h}}),define(ce[160],le([0,1,48,8,17,22,150,15,4,2,37,94,79,44]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0,I=Pe(I);class f extends w.$gi{constructor(b){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",$=>P.$Ne.wrap(Buffer.from($,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$gr=f;class g{constructor(b,$){this.i=b,this.j=$,this.c=new Set,this.g=new Map,this.h=new p.$le,this.onDidProcessExit=this.h.event;const k=$&&$.timeout?$.timeout:6e4;this.b=new r.$Bh(k),this.d=null,this.f=null}getChannel(b){const $=this;return{call(k,S,t){return $.k(b,k,S,t)},listen(k,S){return $.l(b,k,S)}}}k(b,$,k,S=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(I.$5());this.b.cancel();const t=this.n(b),u=(0,r.$rh)(s=>t.call($,k,s)),i=S.onCancellationRequested(()=>u.cancel()),o=(0,c.$Sc)(()=>u.cancel());return this.c.add(o),u.finally(()=>{i.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),u}l(b,$,k){if(!this.b)return p.Event.None;this.b.cancel();let S;const t=new p.$le({onWillAddFirstListener:()=>{S=this.n(b).listen($,k)(t.fire,t),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,m.$do)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,d.$lm)($.env),this.d=(0,n.fork)(this.i,b,$);const k=new p.$le,t=p.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,T.$cr)(l)){(0,T.log)(l,`IPC Library: ${this.j.serverName}`);return}k.fire(P.$Ne.wrap(Buffer.from(l,"base64")))}),u=this.j.useQueue?(0,h.$ym)(this.d):this.d,i=l=>this.d&&this.d.connected&&u.send(l.buffer.toString("base64")),o=k.event,s={send:i,onMessage:o};this.f=new w.$hi(s);const a=()=>this.o();process.once("exit",a),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,E)=>{process.removeListener("exit",a),t.dispose(),this.c.forEach(y=>(0,c.$Pc)(y)),this.c.clear(),l!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+E),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:E})})}return this.f}n(b){let $=this.g.get(b);return $||($=this.m.getChannel(b),this.g.set(b,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$hr=g}),define(ce[119],le([0,1,8,4,2,82,12]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.StorageState=e.StorageHint=void 0,e.$cq=p;var I;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function p(d){const w=d;return w?.changed instanceof Map||w?.deleted instanceof Set}var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class m extends P.$Uc{static{this.a=100}constructor(w,f=Object.create(null)){super(),this.r=w,this.s=f,this.b=this.B(new r.$oe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$Ch(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((f,g)=>this.w(g,f)),w.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(w,f){if(this.c===c.Closed)return;let g=!1;(0,T.$ng)(f)?g=this.f.delete(w):this.f.get(w)!==f&&(this.f.set(w,f),g=!0),g&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,f){const g=this.f.get(w);return(0,T.$ng)(g)?f:g}getBoolean(w,f){const g=this.get(w);return(0,T.$ng)(g)?f:g==="true"}getNumber(w,f){const g=this.get(w);return(0,T.$ng)(g)?f:parseInt(g,10)}getObject(w,f){const g=this.get(w);return(0,T.$ng)(g)?f:(0,D.$ai)(g)}async set(w,f,g=!1){if(this.c===c.Closed)return;if((0,T.$ng)(f))return this.delete(w,g);const v=(0,T.$gg)(f)||Array.isArray(f)?(0,D.$_h)(f):String(f);if(this.f.get(w)!==v)return this.f.set(w,v),this.j.set(w,v),this.h.delete(w),this.b.fire({key:w,external:g}),this.D()}async delete(w,f=!1){if(!(this.c===c.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:f}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===c.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$dq=m;class h{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((f,g)=>this.a.set(g,f)),w.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$eq=h}),define(ce[161],le([0,1,26,8,4,31,9,23]),function(x,e,n,r,P,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mY=void 0,n=Pe(n);class p{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return P.Event.None}static{this.a=2e3}static{this.b=256}constructor(h,d=Object.create(null)){this.g=h,this.h=d,this.c=(0,T.$nc)(this.g),this.d=new c(this.h.logging),this.f=this.n(this.g)}async getItems(){const h=await this.f,d=new Map;return(await this.s(h,"SELECT * FROM ItemTable")).forEach(f=>d.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems(h){const d=await this.f;return this.j(d,h)}j(h,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,D.$yc)(d.insert):"0"}), delete(${d.delete?(0,D.$zc)(d.delete):"0"})`),this.t(h,()=>{const w=d.insert,f=d.delete;if(w&&w.size>0){const g=[];g.push([]);let v=0;w.forEach((b,$)=>{let k=g[v];k.length>p.b&&(v++,k=[],g.push(k)),k.push($,b)}),g.forEach(b=>{this.u(h,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,$=>$.run(b),()=>{const $=[];let k=0;return w.forEach((S,t)=>{$.push(t),k+=S.length}),`Keys: ${$.join(", ")} Length: ${k}`})})}if(f&&f.size){const g=[];g.push([]);let v=0;f.forEach(b=>{let $=g[v];$.length>p.b&&(v++,$=[],g.push($)),$.push(b)}),g.forEach(b=>{this.u(h,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,$=>$.run(b),()=>{const $=[];return f.forEach(k=>{$.push(k)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const h=await this.f;return this.q(h,"VACUUM")}async close(h){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,h)}k(h,d){return new Promise((w,f)=>{h.db.close(g=>(g&&this.o(h,`[storage ${this.c}] close(): ${g}`),this.g===p.IN_MEMORY_PATH?w():!h.isErroneous&&!h.isInMemory?this.l().then(w,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),w())):typeof d=="function"?n.promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const b=()=>this.k(v,void 0);return this.j(v,{insert:d()}).then(()=>b(),$=>(b(),Promise.reject($)))})).then(w,f):f(g||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const h=this.m(this.g);return I.Promises.copy(this.g,h,{preserveSymlinks:!1})}m(h){return`${h}.backup`}async checkIntegrity(h){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${h})`);const d=await this.f,w=await this.r(d,h?"PRAGMA integrity_check":"PRAGMA quick_check"),f=h?w.integrity_check:w.quick_check;return d.isErroneous?`${f} (last error: ${d.lastError})`:d.isInMemory?`${f} (in-memory!)`:f}async n(h,d=!0){this.d.trace(`[storage ${this.c}] open(${h}, retryOnBusy: ${d})`);try{return await this.p(h)}catch(w){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&d)return await(0,r.$Fh)(p.a),this.n(h,!1);try{await n.promises.unlink(h);try{await I.Promises.rename(this.m(h),h,!1)}catch{}return await this.p(h)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(p.IN_MEMORY_PATH)}}}o(h,d){h.isErroneous=!0,h.lastError=d,this.d.error(d)}p(h){return new Promise((d,w)=>{new Promise((f,g)=>{x(["@vscode/sqlite3"],f,g)}).then(Pe).then(f=>{const g=this.d.isTracing?f.verbose().Database:f.Database,v={db:new g(h,b=>b?v.db&&b.code!=="SQLITE_CANTOPEN"?v.db.close(()=>w(b)):w(b):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(v),$=>v.db.close(()=>w($)))),isInMemory:h===p.IN_MEMORY_PATH};v.db.on("error",b=>this.o(v,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&v.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},w)})}q(h,d){return new Promise((w,f)=>{h.db.exec(d,g=>g?(this.o(h,`[storage ${this.c}] exec(): ${g}`),f(g)):w())})}r(h,d){return new Promise((w,f)=>{h.db.get(d,(g,v)=>g?(this.o(h,`[storage ${this.c}] get(): ${g}`),f(g)):w(v))})}s(h,d){return new Promise((w,f)=>{h.db.all(d,(g,v)=>g?(this.o(h,`[storage ${this.c}] all(): ${g}`),f(g)):w(v))})}t(h,d){return new Promise((w,f)=>{h.db.serialize(()=>{h.db.run("BEGIN TRANSACTION"),d(),h.db.run("END TRANSACTION",g=>g?(this.o(h,`[storage ${this.c}] transaction(): ${g}`),f(g)):w())})})}u(h,d,w,f){const g=h.db.prepare(d),v=b=>{this.o(h,`[storage ${this.c}] prepare(): ${b} (${d}). Details: ${f()}`)};g.on("error",v),w(g),g.finalize(b=>{b&&v(b),g.removeListener("error",v)})}}e.$mY=p;class c{static{this.a="VSCODE_TRACE_STORAGE"}constructor(h){h&&typeof h.logTrace=="function"&&process.env[c.a]&&(this.b=h.logTrace),h&&typeof h.logError=="function"&&(this.c=h.logError)}get isTracing(){return!!this.b}trace(h){this.b?.(h)}error(h){this.c?.(h)}}}),define(ce[10],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=P,e.localize2=T;const n=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(I,p){let c;return p.length===0?c=I:c=I.replace(/\{(\d+)\}/g,(m,h)=>{const d=h[0],w=p[d];let f=m;return typeof w=="string"?f=w:(typeof w=="number"||typeof w=="boolean"||w===void 0||w===null)&&(f=String(w)),f}),n&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function P(I,p,...c){return r(typeof I=="number"?D(I,p):p,c)}function D(I,p){const c=globalThis._VSCODE_NLS_MESSAGES?.[I];if(typeof c!="string"){if(typeof p=="string")return p;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return c}function T(I,p,...c){let m;typeof I=="number"?m=D(I,p):m=p;const h=r(m,c);return{value:h,original:p===m?h:r(p,c)}}}),define(ce[162],le([0,1,10]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=c,e.$2m=m,e.$3m=h;const r=60,P=r*60,D=P*24,T=D*7,I=D*30,p=D*365;function c(d,w,f,g){typeof d!="number"&&(d=d.getTime());const v=Math.round((new Date().getTime()-d)/1e3);if(v<-30)return(0,n.localize)(12940,null,c(new Date().getTime()+v*1e3,!1));if(!g&&v<30)return(0,n.localize)(12941,null);let b;return v<r?(b=v,w?b===1?f?(0,n.localize)(12942,null,b):(0,n.localize)(12943,null,b):f?(0,n.localize)(12944,null,b):(0,n.localize)(12945,null,b):b===1?f?(0,n.localize)(12946,null,b):(0,n.localize)(12947,null,b):f?(0,n.localize)(12948,null,b):(0,n.localize)(12949,null,b)):v<P?(b=Math.floor(v/r),w?b===1?f?(0,n.localize)(12950,null,b):(0,n.localize)(12951,null,b):f?(0,n.localize)(12952,null,b):(0,n.localize)(12953,null,b):b===1?f?(0,n.localize)(12954,null,b):(0,n.localize)(12955,null,b):f?(0,n.localize)(12956,null,b):(0,n.localize)(12957,null,b)):v<D?(b=Math.floor(v/P),w?b===1?f?(0,n.localize)(12958,null,b):(0,n.localize)(12959,null,b):f?(0,n.localize)(12960,null,b):(0,n.localize)(12961,null,b):b===1?f?(0,n.localize)(12962,null,b):(0,n.localize)(12963,null,b):f?(0,n.localize)(12964,null,b):(0,n.localize)(12965,null,b)):v<T?(b=Math.floor(v/D),w?b===1?(0,n.localize)(12966,null,b):(0,n.localize)(12967,null,b):b===1?(0,n.localize)(12968,null,b):(0,n.localize)(12969,null,b)):v<I?(b=Math.floor(v/T),w?b===1?f?(0,n.localize)(12970,null,b):(0,n.localize)(12971,null,b):f?(0,n.localize)(12972,null,b):(0,n.localize)(12973,null,b):b===1?f?(0,n.localize)(12974,null,b):(0,n.localize)(12975,null,b):f?(0,n.localize)(12976,null,b):(0,n.localize)(12977,null,b)):v<p?(b=Math.floor(v/I),w?b===1?f?(0,n.localize)(12978,null,b):(0,n.localize)(12979,null,b):f?(0,n.localize)(12980,null,b):(0,n.localize)(12981,null,b):b===1?f?(0,n.localize)(12982,null,b):(0,n.localize)(12983,null,b):f?(0,n.localize)(12984,null,b):(0,n.localize)(12985,null,b)):(b=Math.floor(v/p),w?b===1?f?(0,n.localize)(12986,null,b):(0,n.localize)(12987,null,b):f?(0,n.localize)(12988,null,b):(0,n.localize)(12989,null,b):b===1?f?(0,n.localize)(12990,null,b):(0,n.localize)(12991,null,b):f?(0,n.localize)(12992,null,b):(0,n.localize)(12993,null,b))}function m(d,w){const f=Math.abs(d/1e3);return f<1?w?(0,n.localize)(12994,null,d):(0,n.localize)(12995,null,d):f<r?w?(0,n.localize)(12996,null,Math.round(d)/1e3):(0,n.localize)(12997,null,Math.round(d)/1e3):f<P?w?(0,n.localize)(12998,null,Math.round(d/(1e3*r))):(0,n.localize)(12999,null,Math.round(d/(1e3*r))):f<D?w?(0,n.localize)(13e3,null,Math.round(d/(1e3*P))):(0,n.localize)(13001,null,Math.round(d/(1e3*P))):(0,n.localize)(13002,null,Math.round(d/(1e3*D)))}function h(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[55],le([0,1,21,12,10]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=p,e.$qj=c,e.$rj=m,n=Pe(n),r=Pe(r),P=Pe(P);function D(h,d){return d&&(h.stack||h.stacktrace)?P.localize(12934,null,I(h),T(h.stack)||T(h.stacktrace)):I(h)}function T(h){return Array.isArray(h)?h.join(`
`):h}function I(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?P.localize(12935,null,h.message):h.message||P.localize(12936,null)}function p(h=null,d=!1){if(!h)return P.localize(12937,null);if(Array.isArray(h)){const w=n.$Gb(h),f=p(w[0],d);return w.length>1?P.localize(12938,null,f,w.length):f}if(r.$eg(h))return h;if(h.detail){const w=h.detail;if(w.error)return D(w.error,d);if(w.exception)return D(w.exception,d)}return h.stack?D(h,d):h.message?h.message:P.localize(12939,null)}function c(h){const d=h;return d instanceof Error&&Array.isArray(d.actions)}function m(h,d){let w;return typeof h=="string"?w=new Error(h):w=h,w.actions=d,w}}),define(ce[163],le([0,1,10,43]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=P;function P(D){switch(D){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(12925,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(12926,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(12927,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(12928,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(12929,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(12930,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(12931,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(12932,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(12933,null);default:return""}}}),define(ce[164],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hb=n,e.$aib=r;function n(P){return P&&P.hasOwnProperty("folderUri")}function r(P){return P&&P.hasOwnProperty("workspace")}}),define(ce[165],le([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=r,e.$Gfc=P,e.$Hfc=D;function r(T){return typeof T?.backupFolder=="string"}function P(T){let I=[];try{Array.isArray(T.workspaces)&&(I=T.workspaces.map(p=>({workspace:{id:p.id,configPath:n.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return I}function D(T){let I=[];try{Array.isArray(T.folders)&&(I=T.folders.map(p=>({folderUri:n.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return I}}),define(ce[166],le([0,1,39,15,10]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var D;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(D||(e.TokenType=D={}));function T(...m){switch(m.length){case 1:return(0,P.localize)(11538,null,m[0]);case 2:return(0,P.localize)(11539,null,m[0],m[1]);case 3:return(0,P.localize)(11540,null,m[0],m[1],m[2]);default:return}}const I=(0,P.localize)(11541,null),p=(0,P.localize)(11542,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return h.isTripleEq?"===":"==";case D.NotEq:return h.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return h.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return h.lexeme;case D.QuotedStr:return h.lexeme;case D.Error:return h.lexeme;case D.EOF:return"EOF";default:throw(0,r.$7)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(D.LParen);break;case n.CharCode.CloseParen:this.k(D.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const d=this.h(n.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:d})}else this.k(D.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const d=this.h(n.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:d})}else this.h(n.CharCode.Tilde)?this.k(D.RegexOp):this.l(T("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?D.LtEq:D.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?D.GtEq:D.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(D.And):this.l(T("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(D.Or):this.l(T("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const d=this.d,w=this.c.substring(this.d,this.e),f={type:D.Error,offset:this.d,lexeme:w};this.g.push({offset:d,lexeme:w,additionalInfo:h}),this.f.push(f)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const d=this.c.substring(this.d,this.e),w=c.b.get(d);w?this.k(w):this.f.push({type:D.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,d=!1,w=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(p);return}const g=this.c.charCodeAt(h);if(d)d=!1;else if(g===n.CharCode.Slash&&!w){h++;break}else g===n.CharCode.OpenSquareBracket?w=!0:g===n.CharCode.Backslash?d=!0:g===n.CharCode.CloseSquareBracket&&(w=!1);h++}for(;h<this.c.length&&c.a.has(this.c.charCodeAt(h));)h++;this.e=h;const f=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=c}),define(ce[167],le([0,1,4,2]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=void 0;class P{constructor(){this.a=new n.$le,this.b=new n.$le,this.c=new n.$le,this.d=new n.$le}static{this.ChannelName="extensionhostdebugservice"}call(I,p,c){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(I,p,c){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Yo=P;class D extends r.$Uc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,p,c){this.b.call("attach",[I,p,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,p){this.b.call("terminate",[I,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,p){return this.b.call("openExtensionDevelopmentHostWindow",[I,p])}}e.$Zo=D}),define(ce[168],le([0,1,162,54,11,9,36,18,7]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=m,e.$7m=h,e.$4m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,D.$mc)(P.$Yg.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,D.$jc)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,I.$fh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$fh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$jc)(this.userDataPath,"logs",w)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$fh)(p.URI.file((0,D.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$fh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$fh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$fh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,D.$jc)(w,"argv.json")):(0,I.$fh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,D.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,D.$kc)(w):(0,D.$hc)((0,D.$jc)(P.$Yg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?p.URI.file((0,D.$kc)(w)):p.URI.file((0,D.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,D.$kc)(w);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const g=T.env.VSCODE_PORTABLE;return g?(0,D.$jc)(g,"extensions"):(0,I.$fh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(f=>/^[^:/?#]+?:\/\//.test(f)?p.URI.parse(f):p.URI.file((0,D.$hc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,D.$hc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$4m.test(w))}get extensionLogLevel(){const w=[];for(const f of this.args.log||[]){const g=e.$4m.exec(f);g&&g[1]&&g[2]&&w.push([g[1],g[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$fh)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,D.$jc)(w,"policy.json")):(0,I.$fh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,f,g){this.a=w,this.b=f,this.c=g,this.editSessionId=this.args.editSessionId}}e.$5m=c,Se([r.$9h],c.prototype,"appRoot",null),Se([r.$9h],c.prototype,"userHome",null),Se([r.$9h],c.prototype,"userDataPath",null),Se([r.$9h],c.prototype,"appSettingsHome",null),Se([r.$9h],c.prototype,"tmpDir",null),Se([r.$9h],c.prototype,"cacheHome",null),Se([r.$9h],c.prototype,"stateResource",null),Se([r.$9h],c.prototype,"userRoamingDataHome",null),Se([r.$9h],c.prototype,"userDataSyncHome",null),Se([r.$9h],c.prototype,"sync",null),Se([r.$9h],c.prototype,"machineSettingsResource",null),Se([r.$9h],c.prototype,"workspaceStorageHome",null),Se([r.$9h],c.prototype,"localHistoryHome",null),Se([r.$9h],c.prototype,"keyboardLayoutResource",null),Se([r.$9h],c.prototype,"argvResource",null),Se([r.$9h],c.prototype,"isExtensionDevelopment",null),Se([r.$9h],c.prototype,"untitledWorkspacesHome",null),Se([r.$9h],c.prototype,"builtinExtensionsPath",null),Se([r.$9h],c.prototype,"extensionsPath",null),Se([r.$9h],c.prototype,"extensionDevelopmentLocationURI",null),Se([r.$9h],c.prototype,"extensionDevelopmentKind",null),Se([r.$9h],c.prototype,"extensionTestsLocationURI",null),Se([r.$9h],c.prototype,"debugExtensionHost",null),Se([r.$9h],c.prototype,"logLevel",null),Se([r.$9h],c.prototype,"extensionLogLevel",null),Se([r.$9h],c.prototype,"serviceMachineIdResource",null),Se([r.$9h],c.prototype,"disableTelemetry",null),Se([r.$9h],c.prototype,"disableWorkspaceTrust",null),Se([r.$9h],c.prototype,"useInMemorySecretStorage",null),Se([r.$9h],c.prototype,"policyFile",null);function m(d,w){return h(d["inspect-extensions"],d["inspect-brk-extensions"],5870,w,d.debugId,d.extensionEnvironment)}function h(d,w,f,g,v,b){const k=Number(w||d)||(g?null:f),S=k?!!w:!1;let t;if(b)try{t=JSON.parse(b)}catch{}return{port:k,break:S,debugId:v,env:t}}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[120],le([0,1,280,3,10]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=void 0,e.$Cm=I,e.$Dm=c,e.$Em=w,e.$Fm=f,n=Ve(n);const D={o:(0,P.localize)(11475,null),e:(0,P.localize)(11476,null),t:(0,P.localize)(11477,null)};e.$Am=["tunnel","serve-web"],e.$Bm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(11478,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(11479,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(11480,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(11481,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(11482,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(11483,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(11484,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(11485,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11486,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(11487,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(11488,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(11489,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(11490,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(11491,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(11492,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(11493,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(11494,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(11495,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(11496,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(11497,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(11498,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(11499,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(11500,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(11501,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(11502,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(11503,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(11504,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(11505,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(11506,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(11507,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(11508,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(11509,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,P.localize)(11510,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(11511,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(11512,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(11513,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(g,v,b=T){const $=g.find(l=>l.length>0&&l[0]!=="-"),k={},S=["_"],t=[],u={};let i;for(const l in v){const E=v[l];E.type==="subcommand"?l===$&&(i=E):(E.alias&&(k[l]=E.alias),E.type==="string"||E.type==="string[]"?(S.push(l),E.deprecates&&S.push(...E.deprecates)):E.type==="boolean"&&(t.push(l),E.deprecates&&t.push(...E.deprecates)),E.global&&(u[l]=E))}if(i&&$){const l=u;for(const L in i.options)l[L]=i.options[L];const E=g.filter(L=>L!==$),y=b.getSubcommandReporter?b.getSubcommandReporter($):void 0,R=I(E,l,y);return{[$]:R,_:[]}}const o=(0,n.default)(g,{string:S,boolean:t,alias:k}),s={},a=o;s._=o._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in v){const E=v[l];if(E.type==="subcommand")continue;E.alias&&delete a[E.alias];let y=a[l];if(E.deprecates)for(const R of E.deprecates)a.hasOwnProperty(R)&&(y||(y=a[R],y&&b.onDeprecatedOption(R,E.deprecationMessage||(0,P.localize)(11514,null,l))),delete a[R]);if(typeof y<"u"){if(E.type==="string[]"){if(Array.isArray(y)||(y=[y]),!E.allowEmptyValue){const R=y.filter(L=>L.length>0);R.length!==y.length&&(b.onEmptyValue(l),y=R.length>0?R:void 0)}}else E.type==="string"&&(Array.isArray(y)?(y=y.pop(),b.onMultipleValues(l,y)):!y&&!E.allowEmptyValue&&(b.onEmptyValue(l),y=void 0));s[l]=y,E.deprecationMessage&&b.onDeprecatedOption(l,E.deprecationMessage)}delete a[l]}for(const l in a)b.onUnknownOption(l);return s}function p(g,v){let b="";return v.args&&(Array.isArray(v.args)?b=` <${v.args.join("> <")}>`:b=` <${v.args}>`),v.alias?`-${v.alias} --${g}${b}`:`--${g}${b}`}function c(g,v){const b=[];for(const $ in g){const k=g[$],S=p($,k);b.push([S,k.description])}return m(b,v)}function m(g,v){const $=g.reduce((t,u)=>Math.max(t,u[0].length),12)+2+1;if(v-$<25)return g.reduce((t,u)=>t.concat([`  ${u[0]}`,`      ${u[1]}`]),[]);const k=v-$-1,S=[];for(const t of g){const u=t[0],i=d(t[1],k),o=h($-u.length-2);S.push("  "+u+o+i[0]);for(let s=1;s<i.length;s++)S.push(h($)+i[s])}return S}function h(g){return" ".repeat(g)}function d(g,v){const b=[];for(;g.length;){const $=g.length<v?g.length:g.lastIndexOf(" ",v),k=g.slice(0,$).trim();g=g.slice($),b.push(k)}return b}function w(g,v,b,$,k){const S=process.stdout.isTTY&&process.stdout.columns||80,t=k?.noInputFiles!==!0?`[${(0,P.localize)(11515,null)}...]`:"",u=[`${g} ${b}`];u.push(""),u.push(`${(0,P.localize)(11516,null)}: ${v} [${(0,P.localize)(11517,null)}]${t}`),u.push(""),k?.noPipe!==!0&&(r.$j?u.push((0,P.localize)(11518,null,v)):u.push((0,P.localize)(11519,null,v)),u.push(""));const i={},o=[];for(const s in $){const a=$[s];if(a.type==="subcommand")a.description&&o.push({command:s,description:a.description});else if(a.description&&a.cat){let l=i[a.cat];l||(i[a.cat]=l={}),l[s]=a}}for(const s in i){const a=s,l=i[a];l&&(u.push(D[a]),u.push(...c(l,S)),u.push(""))}return o.length&&(u.push((0,P.localize)(11520,null)),u.push(...m(o.map(s=>[s.command,s.description]),S)),u.push("")),u.join(`
`)}function f(g,v){return`${g||(0,P.localize)(11521,null)}
${v||(0,P.localize)(11522,null)}
${process.arch}`}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[68],le([0,1,281,10,120]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=I,e.$Hm=p,e.$Im=c,e.$Jm=m,n=Ve(n);function D(h,d){const w=(k,S)=>{console.warn((0,r.localize)(11469,null,k,S))},f=k=>{console.warn((0,r.localize)(11470,null,k))},g=(k,S)=>{console.warn((0,r.localize)(11471,null,k,S))},v=k=>({onUnknownOption:S=>{P.$Am.includes(k)||console.warn((0,r.localize)(11472,null,S,k))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:g,getSubcommandReporter:P.$Am.includes(k)?v:void 0}),b={onUnknownOption:k=>{console.warn((0,r.localize)(11473,null,k))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:g,getSubcommandReporter:v},$=(0,P.$Cm)(h,P.$Bm,d?b:void 0);return $.goto&&$._.forEach(k=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(k),(0,r.localize)(11474,null))),$}function T(h){const d=h.findIndex(w=>!/^-/.test(w));if(d>-1)return[...h.slice(0,d),...h.slice(d+1)]}function I(h){let[,...d]=h;process.env.VSCODE_DEV&&(d=T(d)||[]);const w=!m(process.env);return D(d,w)}function p(h){let[,,...d]=h;return process.env.VSCODE_DEV&&(d=T(d)||[]),D(d,!0)}function c(h,...d){const w=h.indexOf("--");return w===-1?h.push(...d):h.splice(w,0,...d),h}function m(h){return h.VSCODE_CLI==="1"}}),function(){function x(e,n,r){function P(T,I){const p=D(T,I),c=[p];return e.isAbsolute(p)||c.unshift(r),e.resolve(...c)}function D(T,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const m=T["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(h,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:P}}if(typeof define=="function")define(ce[169],le([121,27,36]),function(e,n,r){return x(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=x(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[95],le([0,1,27,168,169]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=T,e.$0m=I;class D extends r.$5m{constructor(c,m){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)(c,m.nameShort)},m)}}e.$8m=D;function T(p,c){return(0,r.$7m)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,c,p.extensionEnvironment)}function I(p,c){return(0,r.$7m)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,c,p.extensionEnvironment)}}),define(ce[170],le([0,1,26,27,32]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=D;function D(T){const I=(0,P.$Mg)((0,r.tmpdir)());try{return(0,n.writeFileSync)(I,""),T&&console.log(`Marker file for --wait created: ${I}`),I}catch(p){T&&console.error(`Failed to create marker file for --wait: ${p}`);return}}}),define(ce[171],le([0,1,12,10]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=P;function P(T,I,p,c){try{D(T,I,p,c)}catch(m){T.error(m?.message??m)}return I}function D(T,I,p,c){const m=(h,d,w)=>{const f=h[d];if((0,n.$eg)(f)){const g=f,v=g.length;if(v>1&&g[0]==="%"&&g[v-1]==="%"){const b=g.substr(1,v-2);let $=p[b];$===void 0&&c&&($=c[b]);const k=typeof $=="string"?$:$?.message,S=c?.[b],t=typeof S=="string"?S:S?.message;if(!k){t||T.warn(`[${I.name}]: ${(0,r.localize)(11421,null,b)}`);return}if(w&&(d==="title"||d==="category")&&t&&t!==k){const u={value:k,original:t};h[d]=u}else h[d]=k}}else if((0,n.$gg)(f))for(const g in f)f.hasOwnProperty(g)&&(g==="commands"?m(f,g,!0):m(f,g,w));else if(Array.isArray(f))for(let g=0;g<f.length;g++)m(f,g,w)};for(const h in I)I.hasOwnProperty(h)&&m(I,h)}}),define(ce[172],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(ce[83],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class n{constructor(P,D=[],T=!1){this.ctor=P,this.staticArguments=D,this.supportsDelayedInstantiation=T}}e.$Bi=n}),define(ce[173],le([0,1,83]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Qs=D,e.$Rs=T;const r=[];var P;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function D(I,p,c){p instanceof n.$Bi||(p=new n.$Bi(p,[],!!c)),r.push([I,p])}function T(){return r}}),define(ce[174],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;class n{constructor(D,T){this.key=D,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$tr=n;class r{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const T of this.a.values())T.outgoing.size===0&&D.push(T);return D}insertEdge(D,T){const I=this.lookupOrInsertNode(D),p=this.lookupOrInsertNode(T);I.outgoing.set(p.key,p),p.incoming.set(I.key,I)}removeNode(D){const T=this.b(D);this.a.delete(T);for(const I of this.a.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(D){const T=this.b(D);let I=this.a.get(T);return I||(I=new n(T,D),this.a.set(T,I)),I}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[T,I]of this.a)D.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,T]of this.a){const I=new Set([D]),p=this.c(T,I);if(p)return p}}c(D,T){for(const[I,p]of D.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const c=this.c(p,T);if(c)return c;T.delete(I)}}}e.$ur=r}),define(ce[6],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=P,e.$Fi=D;var n;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(p){return p[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(n||(e._util=n={})),e.$Di=P("instantiationService");function r(T,I,p){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:T,index:p}):(I[n.DI_DEPENDENCIES]=[{id:T,index:p}],I[n.DI_TARGET]=I)}function P(T){if(n.serviceIds.has(T))return n.serviceIds.get(T);const I=function(p,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,p,m)};return I.toString=()=>T,n.serviceIds.set(T,I),I}function D(T){return T}}),define(ce[84],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0,e.$Agc=(0,n.$Ei)("auxiliaryWindowsMainService")}),define(ce[69],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0,e.$Ifc=(0,n.$Ei)("backupMainService")}),define(ce[16],le([0,1,12,7,6]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$$i=void 0,e.$_i=D,e.$aj=T,e.$bj=p,e.$cj=c,e.$dj=m,e.$ej=h,e.$fj=d,e.$gj=f,e.$hj=g,e.$ij=v,n=Pe(n),e.$$i=(0,P.$Ei)("configurationService");function D(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof r.URI)}function T(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof r.URI)}var I;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function p(b){switch(b){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function c(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function m(b,$){const k=Object.create(null);for(const S in b)h(k,S,b[S],$);return k}function h(b,$,k,S){const t=$.split("."),u=t.pop();let i=b;for(let o=0;o<t.length;o++){const s=t[o];let a=i[s];switch(typeof a){case"undefined":a=i[s]=Object.create(null);break;case"object":if(a===null){S(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is null`);return}break;default:S(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}i=a}if(typeof i=="object"&&i!==null)try{i[u]=k}catch{S(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}else S(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}function d(b,$){const k=$.split(".");w(b,k)}function w(b,$){const k=$.shift();if($.length===0){delete b[k];return}if(Object.keys(b).indexOf(k)!==-1){const S=b[k];typeof S=="object"&&!Array.isArray(S)&&(w(S,$),Object.keys(S).length===0&&delete b[k])}}function f(b,$,k){function S(i,o){let s=i;for(const a of o){if(typeof s!="object"||s===null)return;s=s[a]}return s}const t=$.split("."),u=S(b,t);return typeof u>"u"?k:u}function g(b,$,k){Object.keys($).forEach(S=>{S!=="__proto__"&&(S in b?n.$gg(b[S])&&n.$gg($[S])?g(b[S],$[S],k):k&&(b[S]=$[S]):b[S]=$[S])})}function v(b){return b.replace(/[\[\]]/g,"")}}),define(ce[122],le([0,1,39,3,25,166,6,10,15]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=m,e.$Dj=o,e.$Ej=s,e.$Xj=V;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",r.$k),c.set("isLinux",r.$l),c.set("isWindows",r.$j),c.set("isWeb",r.$p),c.set("isMacNative",r.$k&&!r.$p),c.set("isEdge",r.$I),c.set("isFirefox",r.$G),c.set("isChrome",r.$F),c.set("isSafari",r.$H);function m(Q,N){if(c.get(Q)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Q,N)}const h=Object.prototype.hasOwnProperty;var d;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const w={regexParsingWithErrorRecovery:!0},f=(0,I.localize)(11552,null),g=(0,I.localize)(11553,null),v=(0,I.localize)(11554,null),b=(0,I.localize)(11555,null),$=(0,I.localize)(11556,null),k=(0,I.localize)(11557,null),S=(0,I.localize)(11558,null),t=(0,I.localize)(11559,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(N=w){this.k=N,this.d=new D.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(N){if(N===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(N).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const _=this.D(),z=_.type===D.TokenType.Str?k:void 0;throw this.h.push({message:$,offset:_.offset,lexeme:D.$zj.getLexeme(_),additionalInfo:z}),u.c}return F}catch(F){if(F!==u.c)throw F;return}}l(){return this.m()}m(){const N=[this.o()];for(;this.y(D.TokenType.Or);){const F=this.o();N.push(F)}return N.length===1?N[0]:i.or(...N)}o(){const N=[this.s()];for(;this.y(D.TokenType.And);){const F=this.s();N.push(F)}return N.length===1?N[0]:i.and(...N)}s(){if(this.y(D.TokenType.Neg)){const N=this.D();switch(N.type){case D.TokenType.True:return this.z(),l.INSTANCE;case D.TokenType.False:return this.z(),E.INSTANCE;case D.TokenType.LParen:{this.z();const F=this.l();return this.A(D.TokenType.RParen,b),F?.negate()}case D.TokenType.Str:return this.z(),M.create(N.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.D();switch(N.type){case D.TokenType.True:return this.z(),i.true();case D.TokenType.False:return this.z(),i.false();case D.TokenType.LParen:{this.z();const F=this.l();return this.A(D.TokenType.RParen,b),F}case D.TokenType.Str:{const F=N.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==D.TokenType.RegexStr)throw this.B("REGEX",z);const ie=z.lexeme,G=ie.lastIndexOf("/"),B=G===ie.length-1?void 0:this.w(ie.substring(G+1));let te;try{te=new RegExp(ie.substring(1,G),B)}catch{throw this.B("REGEX",z)}return J.create(F,te)}switch(z.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const ie=[z.lexeme];this.z();let G=this.D(),B=0;for(let Ie=0;Ie<z.lexeme.length;Ie++)z.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?B++:z.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&B--;for(;!this.E()&&G.type!==D.TokenType.And&&G.type!==D.TokenType.Or;){switch(G.type){case D.TokenType.LParen:B++;break;case D.TokenType.RParen:B--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Ie=0;Ie<G.lexeme.length;Ie++)G.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?B++:z.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&B--}if(B<0)break;ie.push(D.$zj.getLexeme(G)),this.z(),G=this.D()}const te=ie.join(""),he=te.lastIndexOf("/"),me=he===te.length-1?void 0:this.w(te.substring(he+1));let we;try{we=new RegExp(te.substring(1,he),me)}catch{throw this.B("REGEX",z)}return i.regex(F,we)}case D.TokenType.QuotedStr:{const ie=z.lexeme;this.z();let G=null;if(!(0,P.$cf)(ie)){const B=ie.indexOf("/"),te=ie.lastIndexOf("/");if(B!==te&&B>=0){const he=ie.slice(B+1,te),me=ie[te+1]==="i"?"i":"";try{G=new RegExp(he,me)}catch{throw this.B("REGEX",z)}}}if(G===null)throw this.B("REGEX",z);return J.create(F,G)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,v);const z=this.u();return i.notIn(F,z)}switch(this.D().type){case D.TokenType.Eq:{this.z();const z=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.equals(F,z);switch(z){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,z)}}case D.TokenType.NotEq:{this.z();const z=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.notEquals(F,z);switch(z){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,z)}}case D.TokenType.Lt:return this.z(),de.create(F,this.u());case D.TokenType.LtEq:return this.z(),Y.create(F,this.u());case D.TokenType.Gt:return this.z(),q.create(F,this.u());case D.TokenType.GtEq:return this.z(),K.create(F,this.u());case D.TokenType.In:return this.z(),i.in(F,this.u());default:return i.has(F)}}case D.TokenType.EOF:throw this.h.push({message:S,offset:N.offset,lexeme:"",additionalInfo:t}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const N=this.D();switch(N.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),N.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(N){return N.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(N){return this.C(N)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(N,F){if(this.C(N))return this.z();throw this.B(F,this.D())}B(N,F,_){const z=(0,I.localize)(11560,null,N,D.$zj.getLexeme(F)),ie=F.offset,G=D.$zj.getLexeme(F);return this.h.push({message:z,offset:ie,lexeme:G,additionalInfo:_}),u.c}C(N){return this.D().type===N}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$Bj=u;class i{static false(){return l.INSTANCE}static true(){return E.INSTANCE}static has(N){return y.create(N)}static equals(N,F){return R.create(N,F)}static notEquals(N,F){return O.create(N,F)}static regex(N,F){return J.create(N,F)}static in(N,F){return L.create(N,F)}static notIn(N,F){return A.create(N,F)}static not(N){return M.create(N)}static and(...N){return W.create(N,null,!0)}static or(...N){return j.create(N,null,!0)}static greater(N,F){return q.create(N,F)}static greaterEquals(N,F){return K.create(N,F)}static smaller(N,F){return de.create(N,F)}static smallerEquals(N,F){return Y.create(N,F)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this.c.parse(N)}}e.$Cj=i;function o(Q){const N=new u({regexParsingWithErrorRecovery:!1});return Q.map(F=>(N.parse(F),N.lexingErrors.length>0?N.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,I.localize)(11561,null,_.additionalInfo):(0,I.localize)(11562,null),offset:_.offset,length:_.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(Q,N){const F=Q?Q.substituteConstants():void 0,_=N?N.substituteConstants():void 0;return!F&&!_?!0:!F||!_?!1:F.equals(_)}function a(Q,N){return Q.cmp(N)}class l{static{this.INSTANCE=new l}constructor(){this.type=d.False}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return E.INSTANCE}}e.$Fj=l;class E{static{this.INSTANCE=new E}constructor(){this.type=d.True}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return l.INSTANCE}}e.$Gj=E;class y{static create(N,F=null){const _=c.get(N);return typeof _=="boolean"?_?E.INSTANCE:l.INSTANCE:new y(N,F)}constructor(N,F){this.key=N,this.c=F,this.type=d.Defined}cmp(N){return N.type!==this.type?this.type-N.type:X(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=c.get(this.key);return typeof N=="boolean"?N?E.INSTANCE:l.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Hj=y;class R{static create(N,F,_=null){if(typeof F=="boolean")return F?y.create(N,_):M.create(N,_);const z=c.get(N);return typeof z=="boolean"?F===(z?"true":"false")?E.INSTANCE:l.INSTANCE:new R(N,F,_)}constructor(N,F,_){this.c=N,this.d=F,this.f=_,this.type=d.Equals}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=c.get(this.c);if(typeof N=="boolean"){const F=N?"true":"false";return this.d===F?E.INSTANCE:l.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ij=R;class L{static create(N,F){return new L(N,F)}constructor(N,F){this.d=N,this.f=F,this.type=d.In,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const F=N.getValue(this.f),_=N.getValue(this.d);return Array.isArray(F)?F.includes(_):typeof _=="string"&&typeof F=="object"&&F!==null?h.call(F,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Jj=L;class A{static create(N,F){return new A(N,F)}constructor(N,F){this.d=N,this.f=F,this.type=d.NotIn,this.c=L.create(N,F)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=A;class O{static create(N,F,_=null){if(typeof F=="boolean")return F?M.create(N,_):y.create(N,_);const z=c.get(N);return typeof z=="boolean"?F===(z?"true":"false")?l.INSTANCE:E.INSTANCE:new O(N,F,_)}constructor(N,F,_){this.c=N,this.d=F,this.f=_,this.type=d.NotEquals}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=c.get(this.c);if(typeof N=="boolean"){const F=N?"true":"false";return this.d===F?l.INSTANCE:E.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Lj=O;class M{static create(N,F=null){const _=c.get(N);return typeof _=="boolean"?_?l.INSTANCE:E.INSTANCE:new M(N,F)}constructor(N,F){this.c=N,this.d=F,this.type=d.Not}cmp(N){return N.type!==this.type?this.type-N.type:X(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=c.get(this.c);return typeof N=="boolean"?N?l.INSTANCE:E.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Mj=M;function H(Q,N){if(typeof Q=="string"){const F=parseFloat(Q);isNaN(F)||(Q=F)}return typeof Q=="string"||typeof Q=="number"?N(Q):l.INSTANCE}class q{static create(N,F,_=null){return H(F,z=>new q(N,z,_))}constructor(N,F,_){this.c=N,this.d=F,this.f=_,this.type=d.Greater}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Nj=q;class K{static create(N,F,_=null){return H(F,z=>new K(N,z,_))}constructor(N,F,_){this.c=N,this.d=F,this.f=_,this.type=d.GreaterEquals}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=de.create(this.c,this.d,this)),this.f}}e.$Oj=K;class de{static create(N,F,_=null){return H(F,z=>new de(N,z,_))}constructor(N,F,_){this.c=N,this.d=F,this.f=_,this.type=d.Smaller}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Pj=de;class Y{static create(N,F,_=null){return H(F,z=>new Y(N,z,_))}constructor(N,F,_){this.c=N,this.d=F,this.f=_,this.type=d.SmallerEquals}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Qj=Y;class J{static create(N,F){return new J(N,F)}constructor(N,F){this.d=N,this.f=F,this.type=d.Regex,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const F=this.f?this.f.source:"",_=N.f?N.f.source:"";return F<_?-1:F>_?1:0}equals(N){if(N.type===this.type){const F=this.f?this.f.source:"",_=N.f?N.f.source:"";return this.d===N.d&&F===_}return!1}substituteConstants(){return this}evaluate(N){const F=N.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$Rj=J;class U{static create(N){return new U(N)}constructor(N){this.c=N,this.type=d.NotRegex}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(N){return new U(this.c.map(N))}negate(){return this.c}}e.$Sj=U;function Z(Q){let N=null;for(let F=0,_=Q.length;F<_;F++){const z=Q[F].substituteConstants();if(Q[F]!==z&&N===null){N=[];for(let ie=0;ie<F;ie++)N[ie]=Q[ie]}N!==null&&(N[F]=z)}return N===null?Q:N}class W{static create(N,F,_){return W.d(N,F,_)}constructor(N,F){this.expr=N,this.c=F,this.type=d.And}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const z=a(this.expr[F],N.expr[F]);if(z!==0)return z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(N.expr[F]))return!1;return!0}return!1}substituteConstants(){const N=Z(this.expr);return N===this.expr?this:W.create(N,this.c,!1)}evaluate(N){for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].evaluate(N))return!1;return!0}static d(N,F,_){const z=[];let ie=!1;for(const G of N)if(G){if(G.type===d.True){ie=!0;continue}if(G.type===d.False)return l.INSTANCE;if(G.type===d.And){z.push(...G.expr);continue}z.push(G)}if(z.length===0&&ie)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(a);for(let G=1;G<z.length;G++)z[G-1].equals(z[G])&&(z.splice(G,1),G--);if(z.length===1)return z[0];for(;z.length>1;){const G=z[z.length-1];if(G.type!==d.Or)break;z.pop();const B=z.pop(),te=z.length===0,he=j.create(G.expr.map(me=>W.create([me,B],null,_)),null,te);he&&(z.push(he),z.sort(a))}if(z.length===1)return z[0];if(_){for(let G=0;G<z.length;G++)for(let B=G+1;B<z.length;B++)if(z[G].negate().equals(z[B]))return l.INSTANCE;if(z.length===1)return z[0]}return new W(z,F)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const F of this.expr)N.push(...F.keys());return N}map(N){return new W(this.expr.map(F=>F.map(N)),null)}negate(){if(!this.c){const N=[];for(const F of this.expr)N.push(F.negate());this.c=j.create(N,this,!0)}return this.c}}e.$Tj=W;class j{static create(N,F,_){return j.d(N,F,_)}constructor(N,F){this.expr=N,this.c=F,this.type=d.Or}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const z=a(this.expr[F],N.expr[F]);if(z!==0)return z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(N.expr[F]))return!1;return!0}return!1}substituteConstants(){const N=Z(this.expr);return N===this.expr?this:j.create(N,this.c,!1)}evaluate(N){for(let F=0,_=this.expr.length;F<_;F++)if(this.expr[F].evaluate(N))return!0;return!1}static d(N,F,_){let z=[],ie=!1;if(N){for(let G=0,B=N.length;G<B;G++){const te=N[G];if(te){if(te.type===d.False){ie=!0;continue}if(te.type===d.True)return E.INSTANCE;if(te.type===d.Or){z=z.concat(te.expr);continue}z.push(te)}}if(z.length===0&&ie)return l.INSTANCE;z.sort(a)}if(z.length!==0){if(z.length===1)return z[0];for(let G=1;G<z.length;G++)z[G-1].equals(z[G])&&(z.splice(G,1),G--);if(z.length===1)return z[0];if(_){for(let G=0;G<z.length;G++)for(let B=G+1;B<z.length;B++)if(z[G].negate().equals(z[B]))return E.INSTANCE;if(z.length===1)return z[0]}return new j(z,F)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const F of this.expr)N.push(...F.keys());return N}map(N){return new j(this.expr.map(F=>F.map(N)),null)}negate(){if(!this.c){const N=[];for(const F of this.expr)N.push(F.negate());for(;N.length>1;){const F=N.shift(),_=N.shift(),z=[];for(const ie of re(F))for(const G of re(_))z.push(W.create([ie,G],null,!1));N.unshift(j.create(z,null,!1))}this.c=j.create(N,this,!0)}return this.c}}e.$Uj=j;class C extends y{static{this.d=[]}static all(){return C.d.values()}constructor(N,F,_){super(N,null),this.f=F,typeof _=="object"?C.d.push({..._,key:N}):_!==!0&&C.d.push({key:N,description:_,type:F!=null?typeof F:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return R.create(this.key,N)}notEqualsTo(N){return O.create(this.key,N)}}e.$Vj=C,e.$Wj=(0,T.$Ei)("contextKeyService");function X(Q,N){return Q<N?-1:Q>N?1:0}function oe(Q,N,F,_){return Q<F?-1:Q>F?1:N<_?-1:N>_?1:0}function V(Q,N){if(Q.type===d.False||N.type===d.True)return!0;if(Q.type===d.Or)return N.type===d.Or?ue(Q.expr,N.expr):!1;if(N.type===d.Or){for(const F of N.expr)if(V(Q,F))return!0;return!1}if(Q.type===d.And){if(N.type===d.And)return ue(N.expr,Q.expr);for(const F of Q.expr)if(V(F,N))return!0;return!1}return Q.equals(N)}function ue(Q,N){let F=0,_=0;for(;F<Q.length&&_<N.length;){const z=Q[F].cmp(N[_]);if(z<0)return!1;z===0&&F++,_++}return F===Q.length}function re(Q){return Q.type===d.Or?Q.expr:[Q]}}),define(ce[96],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Sm=e.ID=void 0,e.$Tm=r,e.ID="diagnosticsService",e.$Sm=(0,n.$Ei)(e.ID);function r(D){return!!D.hostName&&!!D.errorMessage}class P{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Um=P});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[123],le([0,1,18,81,10,6,47,3,37]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$$w=e.$0w=e.$9w=void 0,e.$_w=w,e.$ax=f,r=Ve(r),e.$9w=(0,D.$Ei)("dialogService");var c;(function(g){g[g.Confirmation=1]="Confirmation",g[g.Prompt=2]="Prompt",g[g.Input=3]="Input"})(c||(c={}));class m{a(v){return this.d(v,c.Confirmation)}b(v){return this.d(v,c.Prompt)}c(v){return this.d(v,c.Input)}d(v,b){const $=[];switch(b){case c.Confirmation:{const k=v;k.primaryButton?$.push(k.primaryButton):$.push((0,P.localize)(11529,null)),k.cancelButton?$.push(k.cancelButton):$.push((0,P.localize)(11530,null));break}case c.Prompt:{const k=v;Array.isArray(k.buttons)&&k.buttons.length>0&&$.push(...k.buttons.map(S=>S.label)),k.cancelButton&&(k.cancelButton===!0?$.push((0,P.localize)(11531,null)):typeof k.cancelButton=="string"?$.push(k.cancelButton):k.cancelButton.label?$.push(k.cancelButton.label):$.push((0,P.localize)(11532,null))),$.length===0&&$.push((0,P.localize)(11533,null));break}case c.Input:{const k=v;k.primaryButton?$.push(k.primaryButton):$.push((0,P.localize)(11534,null)),k.cancelButton?$.push(k.cancelButton):$.push((0,P.localize)(11535,null));break}}return $}e(v){if(typeof v=="string")return v;if(typeof v=="number")return v===r.default.Info?"info":v===r.default.Error?"error":v===r.default.Warning?"warning":"none"}f(v,b,$){const k=[...v.buttons??[]];v.cancelButton&&typeof v.cancelButton!="string"&&typeof v.cancelButton!="boolean"&&k.push(v.cancelButton);let S=k[b]?.run({checkboxChecked:$});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:$}}}e.$0w=m,e.$$w=(0,D.$Ei)("fileDialogService");var h;(function(g){g[g.SAVE=0]="SAVE",g[g.DONT_SAVE=1]="DONT_SAVE",g[g.CANCEL=2]="CANCEL"})(h||(e.ConfirmResult=h={}));const d=10;function w(g){const v=[];return v.push(...g.slice(0,d).map(b=>typeof b=="string"?b:(0,n.$ch)(b))),g.length>d&&(g.length-d===1?v.push((0,P.localize)(11536,null)):v.push((0,P.localize)(11537,null,g.length-d))),v.push(""),v.join(`
`)}function f(g,v){const b=(0,p.$do)(g);let $=(b.buttons??[]).map(u=>(0,T.$6w)(u)),k=(g.buttons||[]).map((u,i)=>i),S=0,t=b.cancelId??$.length-1;if($.length>1){const u=typeof t=="number"?$[t]:void 0;if(I.$l||I.$k){if(typeof u=="string"&&$.length>1&&t!==1){$.splice(t,1),$.splice(1,0,u);const i=k[t];k.splice(t,1),k.splice(1,0,i),t=1}I.$l&&$.length>1&&($=$.reverse(),k=k.reverse(),S=$.length-1,typeof u=="string"&&(t=S-1))}else if(I.$j&&typeof u=="string"&&$.length>1&&t!==$.length-1){$.splice(t,1),$.push(u);const i=k[t];k.splice(t,1),k.push(i),t=$.length-1}}return b.buttons=$,b.defaultId=S,b.cancelId=t,b.noLink=!0,b.title=b.title||v.nameLong,{options:b,buttonIndeces:k}}}),define(ce[97],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$CY=e.$BY=void 0,e.$DY=D,e.$EY=T,e.$BY=(0,n.$Ei)("encryptionService"),e.$CY=(0,n.$Ei)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var P;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function D(I){return I===P.kwallet||I===P.kwallet5||I===P.kwallet6}function T(I){return I===P.gnomeAny||I===P.gnomeLibsecret||I===P.gnomeKeyring}}),define(ce[38],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=void 0,e.$Li=(0,n.$Ei)("environmentService"),e.$Mi=(0,n.$Fi)(e.$Li)}),define(ce[175],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=e.$pgc=void 0,e.$pgc=(0,n.$Ei)("extensionHostStarter"),e.$qgc="extensionHostStarter"}),define(ce[176],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=e.$E0b=void 0,e.$E0b=(0,n.$Ei)("externalTerminal"),e.$F0b="Terminal.app"}),define(ce[177],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0,e.$sgc=(0,n.$Ei)("externalTerminal")}),define(ce[178],le([0,1,48,54,11,9,3,79,23,94,10,176]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=e.$tgc=void 0,n=Pe(n),D=Pe(D),T=Pe(T),p=Pe(p),c=Pe(c),m=Pe(m);const d=m.localize(11379,null);class w{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends w{static{this.b="cmd.exe"}openTerminal(t,u){return this.spawnTerminal(n,t,c.$xm(),u)}spawnTerminal(t,u,i,o){const s=u.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const a=D.$nc(s,".exe").toLowerCase();if(a==="cmder")return t.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push(s),l.push(s),a==="wt"&&l.push("-d ."),new Promise((E,y)=>{const R=b(process),L=t.spawn(i,l,{cwd:o,env:R,detached:!0});L.on("error",y),L.on("exit",()=>E())})}async runInTerminal(t,u,i,o,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows(),l=await f.f();return new Promise((E,y)=>{const R=`"${u} - ${d}"`,L=`"${i.join('" "')}" & pause`,A=Object.assign({},b(process),o);Object.keys(A).filter(K=>A[K]===null).forEach(K=>delete A[K]);const O={cwd:u,env:A,windowsVerbatimArguments:!0};let M,H;D.$nc(a,".exe")==="wt"?(M=a,H=["-d",".",f.b,"/c",L]):l?(M=l,H=["-d",".",a,"/c",L]):(M=f.b,H=["/c","start",R,"/wait",a,"/c",`"${L}"`]),n.spawn(M,H,O).on("error",K=>{y($(K))}),E(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await p.Promises.exists(t)?t:void 0}catch{return}}}e.$tgc=f,Se([r.$9h],f,"f",null);class g extends w{static{this.b="/usr/bin/osascript"}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const a=s.osxExec||h.$F0b;return new Promise((l,E)=>{if(a===h.$F0b||a==="iTerm.app"){const y=a===h.$F0b?"TerminalHelper":"iTermHelper",L=[P.$Yg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||d,"-w",u];for(const M of i)L.push("-a"),L.push(M);if(o){const M=Object.assign({},b(process),o);for(const H in M){const q=M[H];q===null?(L.push("-u"),L.push(H)):(L.push("-e"),L.push(`${H}=${q}`))}}let A="";const O=n.spawn(g.b,L);O.on("error",M=>{E($(M))}),O.stderr.on("data",M=>{A+=M.toString()}),O.on("exit",M=>{if(M===0)l(void 0);else if(A){const H=A.split(`
`,1);E(new Error(H[0]))}else E(new Error(m.localize(11380,null,y,M)))})}else E(new Error(m.localize(11381,null,a)))})}spawnTerminal(t,u,i){const o=u.osxExec||h.$F0b;return new Promise((s,a)=>{const l=["-a",o];i&&l.push(i);const E=b(process),y=t.spawn("/usr/bin/open",l,{cwd:i,env:E});y.on("error",a),y.on("exit",()=>s())})}}e.$ugc=g;class v extends w{static{this.b=m.localize(11382,null)}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,E)=>{const y=[];a.then(R=>{R.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const L=`${k(i)}; echo; read -p "${v.b}" -n1;`;y.push(`''${L}''`);const A=Object.assign({},b(process),o);Object.keys(A).filter(q=>A[q]===null).forEach(q=>delete A[q]);const O={cwd:u,env:A};let M="";const H=n.spawn(R,y,O);H.on("error",q=>{E($(q))}),H.stderr.on("data",q=>{M+=q.toString()}),H.on("exit",q=>{if(q===0)l(void 0);else if(M){const K=M.split(`
`,1);E(new Error(K[0]))}else E(new Error(m.localize(11383,null,R,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!T.$l)v.d=Promise.resolve("xterm");else{const t=await p.Promises.exists("/etc/debian_version");v.d=new Promise(u=>{t?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return v.d}spawnTerminal(t,u,i){const o=u.linuxExec?Promise.resolve(u.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{o.then(l=>{const E=b(process),y=t.spawn(l,[],{cwd:i,env:E});y.on("error",a),y.on("exit",()=>s())})})}}e.$vgc=v;function b(S){const t={...S.env};return(0,I.$km)(t),t}function $(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(m.localize(11384,null,S.path)):S}function k(S){let t="";for(const u of S)u.indexOf(" ")>=0?t+='"'+u+'"':t+=u,t+=" ";return t}}),define(ce[14],le([0,1,60,9,25,12,7,10,6,3,11,65]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=d,e.$bl=v,e.$cl=$,e.$dl=k,e.$el=S,e.$fl=t,e.$gl=u,e.$hl=i,e.$il=o,e.$jl=s,e.$kl=a,e.$ml=y,e.$nl=R,e.$ol=L,e.$pl=A,e.$ql=O,e.$tl=de,e.$Fl=j,e.$Gl=C,e.$Il=oe,e.$_k=(0,p.$Ei)("fileService");function d(V){return V.create===!0}var w;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var f;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var g;(function(V){V[V.UPDATED=2]="UPDATED",V[V.ADDED=4]="ADDED",V[V.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function v(V){const ue=V;return!!ue&&typeof ue.onDidChange=="function"}var b;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function $(V){return!!(V.capabilities&b.FileReadWrite)}function k(V){return!!(V.capabilities&b.FileFolderCopy)}function S(V){return!!(V.capabilities&b.FileClone)}function t(V){return!!(V.capabilities&b.FileOpenReadWriteClose)}function u(V){return!!(V.capabilities&b.FileReadStream)}function i(V){return $(V)?!!(V.capabilities&b.FileAtomicRead):!1}function o(V){return $(V)?!!(V.capabilities&b.FileAtomicWrite):!1}function s(V){return!!(V.capabilities&b.FileAtomicDelete)}function a(V){return!!(V.capabilities&b.Readonly)}var l;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class E extends Error{static create(ue,re){const Q=new E(ue.toString(),re);return L(Q,re),Q}constructor(ue,re){super(ue),this.code=re}}e.$ll=E;function y(V,ue){return E.create(V,ue)}function R(V){return V||y((0,I.localize)(11338,null),l.Unknown)}function L(V,ue){return V.name=ue?`${ue} (FileSystemError)`:"FileSystemError",V}function A(V){if(!V)return l.Unknown;if(V instanceof E)return V.code;const ue=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!ue)return l.Unknown;switch(ue[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function O(V){if(V instanceof Y)return V.fileOperationResult;switch(A(V)){case l.FileNotFound:return Z.FILE_NOT_FOUND;case l.FileIsADirectory:return Z.FILE_IS_DIRECTORY;case l.FileNotADirectory:return Z.FILE_NOT_DIRECTORY;case l.FileWriteLocked:return Z.FILE_WRITE_LOCKED;case l.NoPermissions:return Z.FILE_PERMISSION_DENIED;case l.FileExists:return Z.FILE_MOVE_CONFLICT;case l.FileTooLarge:return Z.FILE_TOO_LARGE;default:return Z.FILE_OTHER_ERROR}}var M;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class H{constructor(ue,re,Q){this.resource=ue,this.operation=re,this.target=Q}isOperation(ue){return this.operation===ue}}e.$rl=H;var q;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class K{static{this.a=null}constructor(ue,re){this.c=re,this.b=void 0,this.d=new h.$T(()=>{const Q=n.$Ki.forUris(()=>this.c);return Q.fill(this.rawAdded.map(N=>[N,!0])),Q}),this.f=new h.$T(()=>{const Q=n.$Ki.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(N=>[N,!0])),Q}),this.g=new h.$T(()=>{const Q=n.$Ki.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(N=>[N,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of ue){switch(Q.type){case q.ADDED:this.rawAdded.push(Q.resource);break;case q.UPDATED:this.rawUpdated.push(Q.resource);break;case q.DELETED:this.rawDeleted.push(Q.resource);break}this.b!==K.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(ue,...re){return this.h(ue,{includeChildren:!1},...re)}affects(ue,...re){return this.h(ue,{includeChildren:!0},...re)}h(ue,re,...Q){if(!ue)return!1;const N=Q.length>0;return!!((!N||Q.includes(q.ADDED))&&(this.d.value.get(ue)||re.includeChildren&&this.d.value.findSuperstr(ue))||(!N||Q.includes(q.UPDATED))&&(this.f.value.get(ue)||re.includeChildren&&this.f.value.findSuperstr(ue))||(!N||Q.includes(q.DELETED))&&(this.g.value.findSubstr(ue)||re.includeChildren&&this.g.value.findSuperstr(ue)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ue){return this.b===ue}hasCorrelation(){return typeof this.b=="number"}}e.$sl=K;function de(V,ue,re){return!V||!ue||V===ue||ue.length>V.length?!1:(ue.charAt(ue.length-1)!==r.sep&&(ue+=r.sep),re?(0,P.$Gf)(V,ue):V.indexOf(ue)===0)}class Y extends Error{constructor(ue,re,Q){super(ue),this.fileOperationResult=re,this.options=Q}}e.$ul=Y;class J extends Y{constructor(ue,re,Q,N){super(ue,re,N),this.fileOperationResult=re,this.size=Q}}e.$vl=J;class U extends Y{constructor(ue,re,Q){super(ue,Z.FILE_NOT_MODIFIED_SINCE,Q),this.stat=re}}e.$wl=U;var Z;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var W;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(W||(e.FileKind=W={})),e.$El="";function j(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}async function C(V,ue){if(!ue.hasProvider(T.URI.from({scheme:V.scheme})))return new Promise(re=>{const Q=ue.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===V.scheme&&N.added&&(Q.dispose(),re())})})}class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(ue){return(0,D.$ig)(ue)||(ue=0),ue<X.KB?(0,I.localize)(11339,null,ue.toFixed(0)):ue<X.MB?(0,I.localize)(11340,null,(ue/X.KB).toFixed(2)):ue<X.GB?(0,I.localize)(11341,null,(ue/X.MB).toFixed(2)):ue<X.TB?(0,I.localize)(11342,null,(ue/X.GB).toFixed(2)):(0,I.localize)(11343,null,(ue/X.TB).toFixed(2))}}e.$Hl=X;function oe(V){const ue=typeof V=="string"||V?.scheme===m.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===m.Schemas.file?1024*X.MB:ue?10*X.MB:c.$p?50*X.MB:1024*X.MB}}),define(ce[124],le([0,1,17,15,10,14]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=T;async function T(m,h,d,w,f,g){let v;try{await I(m,h,d,w,f,g)}catch(b){v=b}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&d.error(v),d.end()}}async function I(m,h,d,w,f,g){p(g);const v=await m.open(h,{create:!1});try{p(g);let b=0,$=0,k=f&&typeof f.length=="number"?f.length:void 0,S=n.$Ne.alloc(Math.min(f.bufferSize,typeof k=="number"?k:f.bufferSize)),t=f&&typeof f.position=="number"?f.position:0,u=0;do $=await m.read(v,t,S.buffer,u,S.byteLength-u),t+=$,u+=$,b+=$,typeof k=="number"&&(k-=$),u===S.byteLength&&(await d.write(w(S)),S=n.$Ne.alloc(Math.min(f.bufferSize,typeof k=="number"?k:f.bufferSize)),u=0);while($>0&&(typeof k!="number"||k>0)&&p(g)&&c(b,f));if(u>0){let i=u;typeof k=="number"&&(i=Math.min(u,k)),d.write(w(S.slice(0,i)))}}catch(b){throw(0,D.$nl)(b)}finally{await m.close(v)}}function p(m){if(m.isCancellationRequested)throw(0,r.$5)();return!0}function c(m,h){if(typeof h?.limits?.size=="number"&&m>h.limits.size)throw(0,D.$ml)((0,P.localize)(11337,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[61],le([0,1,111,2,9,3,7,14]),function(x,e,n,r,P,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0,e.$3q=p,e.$4q=c,e.$8q=w,e.$9q=f,e.$0q=g,e.$$q=v,e.$_q=$,e.$ar=k;function p(S){return typeof S.correlationId=="number"}function c(S){return S.recursive===!0}class m extends r.$Uc{static{this.a=5}constructor(t,u,i,o){super(),this.h=t,this.j=u,this.m=i,this.n=o,this.c=this.B(new r.$Vc),this.f=void 0,this.g=0}s(){const t=new r.$Tc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(u=>this.h(u))),t.add(this.b.onDidLogMessage(u=>this.j(u))),t.add(this.b.onDidError(u=>this.t(u.error,u.request)))}t(t,u){this.u(t,u)?this.g<m.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,u){return!(!this.n.restartOnError||u||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$5q=m;class h extends m{constructor(t,u,i){super(t,u,i,{type:"node.js",restartOnError:!1})}}e.$6q=h;class d extends m{constructor(t,u,i){super(t,u,i,{type:"universal",restartOnError:!0})}}e.$7q=d;function w(S){return S.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function f(S){const t=new b;for(const u of S)t.processEvent(u);return t.coalesce()}function g(S,t){return typeof t=="string"&&!t.startsWith(n.$vk)&&!(0,P.$ic)(t)?{base:S,pattern:t}:t}function v(S,t){const u=[];for(const i of t)u.push((0,n.$zk)(g(S,i)));return u}class b{constructor(){this.a=new Set,this.b=new Map}c(t){return D.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const u=this.b.get(this.c(t));let i=!1;if(u){const o=u.type,s=t.type;u.resource.fsPath!==t.resource.fsPath&&(t.type===I.FileChangeType.DELETED||t.type===I.FileChangeType.ADDED)?i=!0:o===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(u)):o===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?u.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(u.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],u=[];return Array.from(this.a).filter(i=>i.type!==I.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,o)=>i.resource.fsPath.length-o.resource.fsPath.length).filter(i=>u.some(o=>(0,I.$tl)(i.resource.fsPath,o,!D.$l))?!1:(u.push(i.resource.fsPath),!0)).concat(t)}}function $(S,t){if(typeof t=="number")switch(S.type){case I.FileChangeType.ADDED:return(t&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(t&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(t&I.FileChangeFilter.UPDATED)===0}return!1}function k(S){if(typeof S=="number"){const t=[];return S&I.FileChangeFilter.ADDED&&t.push("Added"),S&I.FileChangeFilter.DELETED&&t.push("Deleted"),S&I.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ce[179],le([0,1,17,55,15,4,2,67,33,14,61]),function(x,e,n,r,P,D,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qR=e.$pR=void 0,e.$pR="localFilesystem";class h extends T.$Uc{constructor(w,f){super(),this.a=w,this.b=f,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$le),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$le),this.onDidWatchError=this.g.event,this.h=(0,p.$1g)(),this.j()}get capabilities(){return this.c||(this.c=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=c.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,f){const{buffer:g}=await this.a.call("readFile",[w,f]);return g}readFileStream(w,f,g){const v=(0,I.$Be)($=>n.$Ne.concat($.map(k=>n.$Ne.wrap(k))).buffer),b=new T.$Tc;return b.add(this.a.listen("readFileStream",[w,f])($=>{if($ instanceof n.$Ne)v.write($.buffer);else{if($==="end")v.end();else{let k;if($ instanceof Error)k=$;else{const S=$;k=(0,c.$ml)(S.message??(0,r.$pj)(S),S.code??c.FileSystemProviderErrorCode.Unknown)}v.error(k),v.end()}b.dispose()}})),b.add(g.onCancellationRequested(()=>{v.error((0,P.$5)()),v.end(),b.dispose()})),v}writeFile(w,f,g){return this.a.call("writeFile",[w,n.$Ne.wrap(f),g])}open(w,f){return this.a.call("open",[w,f])}close(w){return this.a.call("close",[w])}async read(w,f,g,v,b){const[$,k]=await this.a.call("read",[w,f,b]);return g.set($.buffer.slice(0,k),v),k}write(w,f,g,v,b){return this.a.call("write",[w,f,n.$Ne.wrap(g),v,b])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,f){return this.a.call("delete",[w,f])}rename(w,f,g){return this.a.call("rename",[w,f,g])}copy(w,f,g){return this.a.call("copy",[w,f,g])}cloneFile(w,f){return this.a.call("cloneFile",[w,f])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const f=w;this.f.fire((0,m.$8q)(f))}else{const f=w;this.g.fire(f)}}))}watch(w,f){const g=(0,p.$1g)();return this.a.call("watch",[this.h,g,w,f]),(0,T.$Sc)(()=>this.a.call("unwatch",[this.h,g]))}}e.$qR=h}),define(ce[180],le([0,1,26,2,61,4,14,7,8]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class c extends r.$Uc{constructor(){super(),this.a=this.B(new D.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$4c),this.m=new Set,this.n=this.B(new p.$Ch(this.y())),this.r=5007,this.s=new p.$2h,this.R=!1,this.B(this.f(h=>this.t(h)))}t(h){this.u(h)&&this.z(h)}u(h){return(0,P.$3q)(h)}async watch(h){this.s.isSettled||this.s.complete(),this.s=new p.$2h;try{this.h.clear(),this.g.clear();for(const d of h)this.u(d)?this.h.set(d.correlationId,d):this.g.add(d);for(const[d]of this.j)this.h.has(d)||(this.j.deleteAndDispose(d),this.m.delete(d));return await this.w(!1)}finally{this.s.complete()}}w(h){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))]),h?this.y():0)}y(){return 800}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async z(h){if(this.j.has(h.correlationId))return;const d=new r.$Tc;this.j.set(h.correlationId,d),await this.s.p,!d.isDisposed&&(this.D(h,d),this.w(!0))}C(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.w(!1)}D(h,d){this.F(h,d)?(this.P(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.G(h,d),this.m.add(h.correlationId))}F(h,d){const w=this.O?.subscribe(h.path,(f,g)=>{d.isDisposed||(f?this.D(h,d):g?.type===T.FileChangeType.ADDED&&this.H(h))});return w?(d.add(w),!0):!1}G(h,d){let w=!1;const f=(g,v)=>{if(d.isDisposed)return;const b=this.I(g),$=this.I(v),k=w;w=b,!b&&($||k)&&this.H(h)};this.P(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.watchFile)(h.path,{persistent:!1,interval:this.r},f)}catch(g){this.Q(`fs.watchFile() failed with error ${g} on path ${h.path} (correlationId: ${h.correlationId})`)}d.add((0,r.$Sc)(()=>{this.P(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.unwatchFile)(h.path,f)}catch(g){this.Q(`fs.unwatchFile() failed with error ${g} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}H(h){this.P(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const d={resource:I.URI.file(h.path),type:T.FileChangeType.ADDED,cId:h.correlationId};this.a.fire([d]),this.J(d,h),this.C(h)}I(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(h,d){if(this.R){const w=` >> normalized ${h.type===T.FileChangeType.ADDED?"[ADDED]":h.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.L(w,d)}}L(h,d){this.R&&this.P(`${h}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}M(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,P.$ar)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.R=h}}e.$jr=c}),define(ce[181],le([0,1,26,8,22,32,2,78,9,3,18,7,112,23,14,61]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0,e.$pr=b;class v extends T.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(k,S,t,u,i,o){super(),this.s=k,this.t=S,this.u=t,this.w=u,this.y=i,this.z=o,this.c=this.B(new r.$Th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Sh(s=>this.M(s),v.b)),this.g=(0,g.$$q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$$q)(this.s.path,this.s.includes):void 0,this.j=(0,g.$3q)(this.s)?this.s.filter:void 0,this.m=new P.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const k=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const S=await n.promises.stat(k);if(this.m.token.isCancellationRequested)return;this.B(await this.G(k,S.isDirectory()))}catch(k){k.code!=="ENOENT"?this.O(k):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${k})`),this.D()}}D(){this.r=!0,this.w?.()}async F(k){let S=k.path;try{S=await w.Promises.realpath(k.path),k.path===S&&(S=await(0,d.$lr)(k.path,this.m.token)??k.path),k.path!==S&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${k.path}, real: ${S})`)}catch{}return S}async G(k,S){const t=new T.$Tc;return this.H(k,S,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(k,S,t)),t}H(k,S,t){if(S)return!1;const u=h.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(o,s)=>{if(!t.isDisposed)if(o){const a=await this.G(k,S);t.isDisposed?a.dispose():t.add(a)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:u,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(k,S,t){if(c.$k&&(0,D.$Dg)(k,"/Volumes/",!0)){this.O(`Refusing to watch ${k} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const u=new P.$we(this.m.token);t.add((0,T.$Sc)(()=>u.dispose(!0)));const i=new T.$Tc;t.add(i);try{const o=h.URI.file(this.s.path),s=(0,p.$nc)(k),a=(0,n.watch)(k);i.add((0,T.$Sc)(()=>{a.removeAllListeners(),a.close()})),this.Q(`Started watching: '${k}'`);const l=new Set;if(S)try{for(const y of await w.Promises.readdir(k))l.add(y)}catch(y){this.O(y)}if(u.token.isCancellationRequested)return;const E=new Map;i.add((0,T.$Sc)(()=>{for(const[,y]of E)y.dispose();E.clear()})),a.on("error",(y,R)=>{u.token.isCancellationRequested||(this.O(`Failed to watch ${k} for changes using fs.watch() (${y}, ${R})`),this.D())}),a.on("change",(y,R)=>{if(u.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${R}`);let L="";if(R&&(L=R.toString(),c.$k&&(L=(0,I.$mm)(L))),!(!L||y!=="change"&&y!=="rename"))if(S)if(y==="rename"){E.get(L)?.dispose();const A=setTimeout(async()=>{if(E.delete(L),L===s&&!await w.Promises.exists(k)){this.J(o);return}if(u.token.isCancellationRequested)return;const O=await this.N((0,p.$jc)(k,L));if(u.token.isCancellationRequested)return;let M;O?l.has(L)?M=f.FileChangeType.UPDATED:(M=f.FileChangeType.ADDED,l.add(L)):(l.delete(L),M=f.FileChangeType.DELETED),this.L({resource:(0,m.$fh)(o,L),type:M,cId:this.s.correlationId})},v.a);E.set(L,(0,T.$Sc)(()=>clearTimeout(A)))}else{let A;l.has(L)?A=f.FileChangeType.UPDATED:(A=f.FileChangeType.ADDED,l.add(L)),this.L({resource:(0,m.$fh)(o,L),type:A,cId:this.s.correlationId})}else if(y==="rename"||L!==s){const A=setTimeout(async()=>{const O=await w.Promises.exists(k);u.token.isCancellationRequested||(O?(this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(k,!1))):this.J(o))},v.a);i.clear(),i.add((0,T.$Sc)(()=>clearTimeout(A)))}else this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){u.token.isCancellationRequested||this.O(`Failed to watch ${k} for changes using fs.watch() (${o.toString()})`),this.D()}}J(k){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:k,type:f.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(k,S=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${k.type===f.FileChangeType.ADDED?"[ADDED]":k.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`),!S&&this.g.some(t=>t(k.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${k.resource.fsPath}`):!S&&this.h&&this.h.length>0&&!this.h.some(t=>t(k.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${k.resource.fsPath}`):this.f.work(k))}M(k){const S=(0,g.$9q)(k),t=[];for(const i of S){if((0,g.$_q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===f.FileChangeType.ADDED?"[ADDED]":i.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(k){if(c.$l)return w.Promises.exists(k);try{const S=(0,p.$nc)(k);return(await w.Promises.readdir((0,p.$mc)(k))).some(u=>u===S)}catch(S){return this.Q(S),!1}}setVerboseLogging(k){this.z=k}O(k){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${k}`})}P(k){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${k}`})}Q(k){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${k}`})}R(k){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${k}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$or=v;async function b($,k,S,t,u=512){const i=await w.Promises.open($,"r"),o=Buffer.allocUnsafe(u),s=new P.$we(t);let a,l=!1;const E={path:$,excludes:[],recursive:!1},y=new v(E,void 0,R=>{(async()=>{for(const{type:L}of R)if(L===f.FileChangeType.UPDATED){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:A}=await w.Promises.read(i,o,0,u,null);if(!A||s.token.isCancellationRequested)break;k(o.slice(0,A))}}catch(A){a=new Error(A),s.dispose(!0)}finally{l=!1}}})()});return await y.ready,S(),new Promise((R,L)=>{s.token.onCancellationRequested(async()=>{y.dispose();try{await w.Promises.close(i)}catch(A){a=new Error(A)}a?L(a):R()})})}}),define(ce[182],le([0,1,4,111,180,3,181,32]),function(x,e,n,r,P,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class p extends P.$jr{constructor(m){super(),this.O=m,this.onDidError=n.Event.None,this.watchers=new Set}async N(m){m=this.Z(m);const h=[],d=new Set(Array.from(this.watchers));for(const w of m){const f=this.W(w);f&&(0,r.$Dk)(f.request.excludes,w.excludes)&&(0,r.$Dk)(f.request.includes,w.includes)?d.delete(f):h.push(w)}h.length&&this.P(`Request to start watching: ${h.map(w=>this.M(w)).join(",")}`),d.size&&this.P(`Request to stop watching: ${Array.from(d).map(w=>this.M(w.request)).join(",")}`);for(const w of d)this.Y(w);for(const w of h)this.X(w)}W(m){for(const h of this.watchers)if(typeof m.correlationId=="number"||typeof h.request.correlationId=="number"){if(h.request.correlationId===m.correlationId)return h}else if((0,I.$Cg)(h.request.path,m.path,!D.$l))return h}X(m){const h=new T.$or(m,this.O,w=>this.a.fire(w),()=>this.c.fire(m),w=>this.b.fire(w),this.R),d={request:m,instance:h};this.watchers.add(d)}async stop(){await super.stop();for(const m of this.watchers)this.Y(m)}Y(m){this.P("stopping file watcher",m),this.watchers.delete(m),m.instance.dispose()}Z(m){const h=new Map;for(const d of m){const w=D.$l?d.path:d.path.toLowerCase();let f=h.get(d.correlationId);f||(f=new Map,h.set(d.correlationId,f)),f.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(d)}`),f.set(w,d)}return Array.from(h.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(m){super.setVerboseLogging(m);for(const h of this.watchers)h.instance.setVerboseLogging(m)}P(m,h){this.R&&this.b.fire({type:"trace",message:this.bb(m,h)})}Q(m){this.b.fire({type:"warn",message:this.bb(m)})}bb(m,h){return h?`[File Watcher (node.js)] ${m} (${this.M(h.request)})`:`[File Watcher (node.js)] ${m}`}}e.$qr=p}),define(ce[183],le([0,1,61,182]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class P extends n.$6q{constructor(T,I,p){super(T,I,p),this.s()}r(T){return T.add(new r.$qr(void 0))}}e.$rr=P}),define(ce[184],le([0,1,11,44,160,61]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class T extends D.$7q{constructor(p,c,m){super(p,c,m),this.s()}r(p){const c=p.add(new P.$hr(n.$Yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:m,signal:h})=>this.t(`terminated by itself with code ${m}, signal: ${h} (ETERM)`))),r.ProxyChannel.toService((0,r.$li)(c.getChannel("watcher")))}}e.$ir=T}),define(ce[98],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class n{constructor(...P){this.a=new Map;for(const[D,T]of P)this.set(D,T)}set(P,D){const T=this.a.get(P);return this.a.set(P,D),T}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ci=n}),define(ce[185],le([0,1,8,15,2,83,174,6,98,108]),function(x,e,n,r,P,D,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;const m=!1;class h extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class d{constructor(v=new p.$Ci,b=!1,$,k=m){this.i=v,this.j=b,this.k=$,this.l=k,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Di,this),this._globalGraph=k?$?._globalGraph??new T.$ur(S=>S):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Pc)(this.h),this.h.clear();for(const v of this.g)(0,P.$Oc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,b){this.m();const $=this,k=new class extends d{dispose(){$.h.delete(k),super.dispose()}}(v,this.j,this,this.l);return this.h.add(k),b?.add(k),k}invokeFunction(v,...b){this.m();const $=f.traceInvocation(this.l,v);let k=!1;try{return v({get:t=>{if(k)throw(0,r.$7)("service accessor is only valid during the invocation of its target method");const u=this.s(t,$);if(!u)throw new Error(`[invokeFunction] unknown service '${t}'`);return u}},...b)}finally{k=!0,$.stop()}}createInstance(v,...b){this.m();let $,k;return v instanceof D.$Bi?($=f.traceCreation(this.l,v.ctor),k=this.o(v.ctor,v.staticArguments.concat(b),$)):($=f.traceCreation(this.l,v),k=this.o(v,b,$)),$.stop(),k}o(v,b=[],$){const k=I._util.getServiceDependencies(v).sort((u,i)=>u.index-i.index),S=[];for(const u of k){const i=this.s(u.id,$);i||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${u.id}.`,!1),S.push(i)}const t=k.length>0?k[0].index:b.length;if(b.length!==t){console.trace(`[createInstance] First service dependency of ${v.name} at position ${t+1} conflicts with ${b.length} static arguments`);const u=t-b.length;u>0?b=b.concat(new Array(u)):b=b.slice(0,t)}return Reflect.construct(v,b.concat(S))}q(v,b){if(this.i.get(v)instanceof D.$Bi)this.i.set(v,b);else if(this.k)this.k.q(v,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const b=this.i.get(v);return!b&&this.k?this.k.r(v):b}s(v,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const $=this.r(v);return $ instanceof D.$Bi?this.u(v,$,b.branch(v,!0)):(b.branch(v,!1),$)}u(v,b,$){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,b,$)}finally{this.t.delete(v)}}v(v,b,$){const k=new T.$ur(i=>i.id.toString());let S=0;const t=[{id:v,desc:b,_trace:$}],u=new Set;for(;t.length;){const i=t.pop();if(!u.has(String(i.id))){if(u.add(String(i.id)),k.lookupOrInsertNode(i),S++>1e3)throw new h(k);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof D.$Bi){const a={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};k.insertEdge(i,a),t.push(a)}}}}for(;;){const i=k.roots();if(i.length===0){if(!k.isEmpty())throw new h(k);break}for(const{data:o}of i){if(this.r(o.id)instanceof D.$Bi){const a=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,a)}k.removeNode(o)}}return this.r(v)}w(v,b,$=[],k,S){if(this.i.get(v)instanceof D.$Bi)return this.x(v,b,$,k,S,this.g);if(this.k)return this.k.w(v,b,$,k,S);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(v,b,$=[],k,S,t){if(k){const u=new d(void 0,this.j,this,this.l);u.c=String(v);const i=new Map,o=new n.$Xh(()=>{const s=u.o(b,$,S);for(const[a,l]of i){const E=s[a];if(typeof E=="function")for(const y of l)y.disposable=E.apply(s,y.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let y=i.get(a);return y||(y=new c.$5c,i.set(a,y)),(L,A,O)=>{if(o.isInitialized)return o.value[a](L,A,O);{const M={listener:[L,A,O],disposable:void 0},H=y.push(M);return(0,P.$Sc)(()=>{H(),M.disposable?.dispose()})}}}if(a in s)return s[a];const l=o.value;let E=l[a];return typeof E!="function"||(E=E.bind(l),s[a]=E),E},set(s,a,l){return o.value[a]=l,!0},getPrototypeOf(s){return b.prototype}})}else{const u=this.o(b,$,S);return t.add(u),u}}y(v,b){if(b&&console.warn(v),this.j)throw new Error(v)}}e.$vr=d;var w;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(w||(w={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,b){return v?new f(w.Invocation,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(v,b){return v?new f(w.Creation,b.name):f.c}static{this.f=0}constructor(v,b){this.type=v,this.name=b,this.g=Date.now(),this.h=[]}branch(v,b){const $=new f(w.Branch,v.toString());return this.h.push([v,b,$]),$}stop(){const v=Date.now()-this.g;f.f+=v;let b=!1;function $(S,t){const u=[],i=new Array(S+1).join("	");for(const[o,s,a]of t.h)if(s&&a){b=!0,u.push(`${i}CREATES -> ${o}`);const l=$(S+1,a);l&&u.push(l)}else u.push(`${i}uses -> ${o}`);return u.join(`
`)}const k=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(v>2||b)&&f.all.add(k.join(`
`))}}e.$wr=f}),define(ce[186],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=e.$$_b=e.IssueSource=e.IssueType=void 0;var r;(function(D){D[D.Bug=0]="Bug",D[D.PerformanceIssue=1]="PerformanceIssue",D[D.FeatureRequest=2]="FeatureRequest"})(r||(e.IssueType=r={}));var P;(function(D){D.VSCode="vscode",D.Extension="extension",D.Marketplace="marketplace"})(P||(e.IssueSource=P={})),e.$$_b=(0,n.$Ei)("issueService"),e.$__b=(0,n.$Ei)("processService")}),define(ce[5],le([0,1,10,55,4,46,2,31,3,18,12,7,122,6]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=g,e.log=b,e.$nk=E,e.$ok=y,e.$pk=R,e.$qk=L,n=Pe(n),e.$_j=(0,w.$Ei)("logService"),e.$ak=(0,w.$Ei)("loggerService");function f(){return new Date().toISOString()}function g(A){return(0,m.$ig)(A)}var v;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$ck=v.Info;function b(A,O,M){switch(O){case v.Trace:A.trace(M);break;case v.Debug:A.debug(M);break;case v.Info:A.info(M);break;case v.Warning:A.warn(M);break;case v.Error:A.error(M);break;case v.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function $(A,O=!1){let M="";for(let H=0;H<A.length;H++){let q=A[H];if(q instanceof Error&&(q=(0,r.$pj)(q,O)),typeof q=="object")try{q=JSON.stringify(q)}catch{}M+=(H>0?" ":"")+q}return M}class k extends T.$Uc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new P.$le),this.onDidChangeLogLevel=this.c.event}setLevel(O){this.b!==O&&(this.b=O,this.c.fire(this.b))}getLevel(){return this.b}f(O){return this.b!==v.Off&&this.b<=O}}e.$ek=k;class S extends k{constructor(O){super(),this.h=O}f(O){return this.h||super.f(O)}trace(O,...M){this.f(v.Trace)&&this.g(v.Trace,$([O,...M],!0))}debug(O,...M){this.f(v.Debug)&&this.g(v.Debug,$([O,...M]))}info(O,...M){this.f(v.Info)&&this.g(v.Info,$([O,...M]))}warn(O,...M){this.f(v.Warning)&&this.g(v.Warning,$([O,...M]))}error(O,...M){if(this.f(v.Error))if(O instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=O.stack,this.g(v.Error,$(H))}else this.g(v.Error,$([O,...M]))}flush(){}}e.$fk=S;class t extends k{constructor(O=e.$ck){super(),this.setLevel(O),this.g=!p.$j}trace(O,...M){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...M):console.log(`[main ${f()}]`,O,...M))}debug(O,...M){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...M):console.log(`[main ${f()}]`,O,...M))}info(O,...M){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...M):console.log(`[main ${f()}]`,O,...M))}warn(O,...M){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,O,...M):console.warn(`[main ${f()}]`,O,...M))}error(O,...M){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,O,...M):console.error(`[main ${f()}]`,O,...M))}flush(){}}e.$gk=t;class u extends k{constructor(O=e.$ck,M=!0){super(),this.g=M,this.setLevel(O)}trace(O,...M){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",O,...M):console.log(O,...M))}debug(O,...M){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",O,...M):console.log(O,...M))}info(O,...M){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",O,...M):console.log(O,...M))}warn(O,...M){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",O,...M):console.log(O,...M))}error(O,...M){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",O,...M):console.error(O,...M))}flush(){}}e.$hk=u;class i extends k{constructor(O,M=e.$ck){super(),this.g=O,this.setLevel(M)}trace(O,...M){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(O),...M])}debug(O,...M){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(O),...M])}info(O,...M){this.f(v.Info)&&this.g.log(v.Info,[this.h(O),...M])}warn(O,...M){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(O),...M])}error(O,...M){this.f(v.Error)&&this.g.log(v.Error,[this.h(O),...M])}h(O){return typeof O=="string"?O:(0,r.$pj)(O,this.f(v.Trace))}flush(){}}e.$ik=i;class o extends k{constructor(O){super(),this.g=O,O.length&&this.setLevel(O[0].getLevel())}setLevel(O){for(const M of this.g)M.setLevel(O);super.setLevel(O)}trace(O,...M){for(const H of this.g)H.trace(O,...M)}debug(O,...M){for(const H of this.g)H.debug(O,...M)}info(O,...M){for(const H of this.g)H.info(O,...M)}warn(O,...M){for(const H of this.g)H.warn(O,...M)}error(O,...M){for(const H of this.g)H.error(O,...M)}flush(){for(const O of this.g)O.flush()}dispose(){for(const O of this.g)O.dispose();super.dispose()}}e.$jk=o;class s extends T.$Uc{constructor(O,M,H){if(super(),this.h=O,this.j=M,this.b=new I.$Ac,this.c=this.B(new P.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$le),this.onDidChangeVisibility=this.g.event,H)for(const q of H)this.b.set(q.resource,{logger:void 0,info:q})}m(O){return(0,m.$eg)(O)?[...this.b.values()].find(M=>M.info.id===O):this.b.get(O)}getLogger(O){return this.m(O)?.logger}createLogger(O,M){const H=this.n(O),q=(0,m.$eg)(O)?O:M?.id??(0,D.$sj)(H.toString()).toString(16);let K=this.b.get(H)?.logger;const de=M?.logLevel==="always"?v.Trace:M?.logLevel;K||(K=this.s(H,de??this.getLogLevel(H)??this.h,{...M,id:q}));const Y={logger:K,info:{resource:H,id:q,logLevel:de,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(Y.info),this.b.set(H,Y),K}n(O){return(0,m.$eg)(O)?(0,c.$fh)(this.j,`${O}.log`):O}setLogLevel(O,M){if(h.URI.isUri(O)){const H=O,q=M,K=this.b.get(H);K&&q!==K.info.logLevel&&(K.info.logLevel=q===this.h?void 0:q,K.logger?.setLevel(q),this.b.set(K.info.resource,K),this.f.fire([H,q]))}else{this.h=O;for(const[H,q]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(O,M){const H=this.m(O);H&&M!==!H.info.hidden&&(H.info.hidden=!M,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,M]))}getLogLevel(O){let M;return O&&(M=this.b.get(O)?.info.logLevel),M??this.h}registerLogger(O){const M=this.b.get(O.resource);M?M.info.hidden!==O.hidden&&this.setVisibility(O.resource,!O.hidden):(this.b.set(O.resource,{info:O,logger:void 0}),this.c.fire({added:[O],removed:[]}))}deregisterLogger(O){const M=this.b.get(O);M&&(M.logger&&M.logger.dispose(),this.b.delete(O),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const O of this.b.values())yield O.info}getRegisteredLogger(O){return this.b.get(O)?.info}dispose(){this.b.forEach(O=>O.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=s;class a{constructor(){this.onDidChangeLogLevel=new P.$le().event}setLevel(O){}getLevel(){return v.Info}trace(O,...M){}debug(O,...M){}info(O,...M){}warn(O,...M){}error(O,...M){}critical(O,...M){}dispose(){}flush(){}}e.$lk=a;class l extends a{}e.$mk=l;function E(A){if(A.verbose)return v.Trace;if(typeof A.logLevel=="string"){const O=L(A.logLevel.toLowerCase());if(O!==void 0)return O}return e.$ck}function y(A){switch(A){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function R(A){switch(A){case v.Trace:return{original:"Trace",value:n.localize(11271,null)};case v.Debug:return{original:"Debug",value:n.localize(11272,null)};case v.Info:return{original:"Info",value:n.localize(11273,null)};case v.Warning:return{original:"Warning",value:n.localize(11274,null)};case v.Error:return{original:"Error",value:n.localize(11275,null)};case v.Off:return{original:"Off",value:n.localize(11276,null)}}}function L(A){switch(A){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$rk=new d.$Vj("logLevel",y(v.Info))});var se=this&&this.__param||function(x,e){return function(n,r){e(n,r,x)}};define(ce[187],le([0,1,13,3,97,5]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;const T=n.safeStorage;let I=class{constructor(c){this.a=c,n.app.commandLine.getSwitchValue("password-store")===P.PasswordStoreCLIOption.basic&&T.setUsePlainTextEncryption?.(!0)}async encrypt(c){this.a.trace("[EncryptionMainService] Encrypting value.");try{const m=JSON.stringify(T.encryptString(c));return this.a.trace("[EncryptionMainService] Encrypted value."),m}catch(m){throw this.a.error(m),m}}async decrypt(c){let m;try{if(m=JSON.parse(c),!m.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const h=Buffer.from(m.data);this.a.trace("[EncryptionMainService] Decrypting value.");const d=T.decryptString(h);return this.a.trace("[EncryptionMainService] Decrypted value."),d}catch(h){throw this.a.error(h),h}}isEncryptionAvailable(){return Promise.resolve(T.isEncryptionAvailable())}getKeyStorageProvider(){if(r.$j)return Promise.resolve(P.KnownStorageProvider.dplib);if(r.$k)return Promise.resolve(P.KnownStorageProvider.keychainAccess);if(T.getSelectedStorageBackend)try{const c=T.getSelectedStorageBackend();return Promise.resolve(c)}catch(c){this.a.error(c)}return Promise.resolve(P.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!T.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");T.setUsePlainTextEncryption(!0)}};e.$ogc=I,e.$ogc=I=Se([se(0,D.$_j)],I)}),define(ce[188],le([0,1,21,8,15,4,32,2,9,61,5]),function(x,e,n,r,P,D,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class h extends I.$Uc{constructor(w,f){super(),this.a=w,this.b=f,this.c=this.B(new D.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Ch(0)),this.w=[],this.y=this.B(new r.$Ch(0))}watch(w,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(w,f):this.z(w,f)}n(w,f){const g={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.j,g);return this.r(),(0,I.$Sc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,P.$Y)(w))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,c.$8q)(f)),f=>this.G(f),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const f of this.j)(0,c.$4q)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const f of this.j)(0,c.$4q)(f)&&w.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,f){const g={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.w,g);return this.C(),(0,I.$Sc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,P.$Y)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,c.$8q)(w)),w=>this.G(w),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,p.$hc)(w.fsPath)}J(w){const f=this.I(w);return(0,T.$Gg)(f)}}e.$br=h}),define(ce[189],le([0,1,21,8,17,22,4,46,77,2,60,11,70,18,67,10,14,124,5,15]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let t=class extends c.$Uc{static{S=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$le),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$le),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$le),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$le),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$le),this.Y=this.B(new T.$le),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$le),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Nh)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${i}`);const s=new c.$Tc;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),s.add(o.onDidChangeFile(a=>{const l=new v.$sl(a,!this.S(o));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(a=>this.Z.fire(new Error(a)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,c.$Sc)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,c.$Pc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(s){o.push(s)}}),!this.h.has(i)&&await r.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return p.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,w.$jh)(i))throw new v.$ul((0,g.localize)(11344,null,this.sb(i)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const s=new k.$ab;throw s.message=(0,g.localize)(11345,null,i.toString()),s}return o}async m(i){const o=await this.j(i);if((0,v.$fl)(o)||(0,v.$cl)(o)||(0,v.$gl)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const o=await this.j(i);if((0,v.$fl)(o)||(0,v.$cl)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.s(i,o)}catch(s){throw(0,v.$pl)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.$ul((0,g.localize)(11346,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$nl)(s)}}async s(i,o){const s=await this.j(i),a=this.S(s),l=o?.resolveTo,E=o?.resolveSingleChildDescendants,y=o?.resolveMetadata,R=await s.stat(i);let L;return this.t(s,i,R,void 0,!!y,(A,O)=>(L||(L=m.$Ki.forUris(()=>!a),L.set(i,!0),l&&L.fill(!0,l)),L.get(A.resource)||L.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&E?O===1:!1))}async t(i,o,s,a,l,E){const{providerExtUri:y}=this.R(i),R={resource:o,name:y.basename(o),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&v.FilePermission.Readonly)||!!(i.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Fl)({mtime:s.mtime,size:s.size}),children:void 0};if(R.isDirectory&&E(R,a)){try{const L=await i.readdir(o),A=await r.Promises.settled(L.map(async([O,M])=>{try{const H=y.joinPath(o,O),q=l?await i.stat(H):{type:M};return await this.t(i,H,q,L.length,l,E)}catch(H){return this.b.trace(H),null}}));R.children=(0,n.$Gb)(A)}catch(L){this.b.trace(L),R.children=[]}return R}return R}async resolveAll(i){return r.Promises.settled(i.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),s=await o.stat(i);return this.t(o,i,s,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.u(i,o)}catch(s){return s}return!0}async u(i,o){if(!o?.overwrite&&await this.exists(i))throw new v.$ul((0,g.localize)(11347,null,this.sb(i)),v.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(i,o=P.$Ne.fromString(""),s){await this.u(i,s);const a=await this.writeFile(i,o);return this.r.fire(new v.$rl(i,v.FileOperation.CREATE,a)),a}async writeFile(i,o,s){const a=this.qb(await this.n(i),i),{providerExtUri:l}=this.R(a);let E=s;if((0,v.$il)(a)&&!E?.atomic){const y=a.enforceAtomicWriteFile?.(i);y&&(E={...s,atomic:y})}try{await this.w(a,i,E)||await this.U(a,l.dirname(i));let R;if((0,v.$cl)(a)&&!(o instanceof P.$Ne))if((0,f.$ze)(o)){const L=await(0,f.$Ge)(o,3);L.ended?R=P.$Ne.concat(L.buffer):R=L}else R=(0,f.$De)(o,L=>P.$Ne.concat(L),3);else R=o;!(0,v.$fl)(a)||(0,v.$cl)(a)&&R instanceof P.$Ne||(0,v.$cl)(a)&&(0,v.$il)(a)&&E?.atomic?await this.hb(a,i,E,R):await this.db(a,i,E,R instanceof P.$Ne?(0,P.$Ye)(R):R),this.r.fire(new v.$rl(i,v.FileOperation.WRITE))}catch(y){throw new v.$ul((0,g.localize)(11348,null,this.sb(i),(0,v.$nl)(y).toString()),(0,v.$ql)(y),E)}return this.resolve(i,{resolveMetadata:!0})}async w(i,o,s){const a=!!s?.unlock;if(a&&!(i.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(11349,null,this.sb(o)));if(!!s?.atomic){if(!(i.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(11350,null,this.sb(o)));if(!(i.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(11351,null,this.sb(o)));if(a)throw new Error((0,g.localize)(11352,null,this.sb(o)))}let E;try{E=await i.stat(o)}catch{return}if(E.type&v.FileType.Directory)throw new v.$ul((0,g.localize)(11353,null,this.sb(o)),v.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(o,E),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.$El&&typeof E.mtime=="number"&&typeof E.size=="number"&&s.mtime<E.mtime&&s.etag!==(0,v.$Fl)({mtime:s.mtime,size:E.size}))throw new v.$ul((0,g.localize)(11354,null),v.FileOperationResult.FILE_MODIFIED_SINCE,s);return E}async readFile(i,o,s){const a=await this.m(i);return o?.atomic?this.z(a,i,o,s):this.C(a,i,o,s)}async z(i,o,s,a){return new Promise((l,E)=>{this.cb.queueFor(o,async()=>{try{const y=await this.C(i,o,s,a);l(y)}catch(y){E(y)}},this.R(i).providerExtUri)})}async C(i,o,s,a){const l=await this.D(i,o,{...s,preferUnbuffered:!0},a);return{...l,value:await(0,P.$Ze)(l.value)}}async readFileStream(i,o,s){const a=await this.m(i);return this.D(a,i,o,s)}async D(i,o,s,a){const l=new D.$we(a);let E=s;(0,v.$hl)(i)&&i.enforceAtomicReadFile?.(o)&&(E={...s,atomic:!0});const y=this.J(o,E).then(L=>L,L=>{throw l.dispose(!0),L});let R;try{return typeof E?.etag=="string"&&E.etag!==v.$El&&await y,E?.atomic&&(0,v.$hl)(i)||!((0,v.$fl)(i)||(0,v.$gl)(i))||(0,v.$cl)(i)&&E?.preferUnbuffered?R=this.I(i,o,E):(0,v.$gl)(i)?R=this.G(i,o,l.token,E):R=this.H(i,o,l.token,E),R.on("end",()=>l.dispose()),R.on("error",()=>l.dispose()),{...await y,value:R}}catch(L){throw R&&await(0,f.$Ee)(R),this.F(L,o,E)}}F(i,o,s){const a=(0,g.localize)(11355,null,this.sb(o),(0,v.$nl)(i).toString());return i instanceof v.$wl?new v.$wl(a,i.stat,s):i instanceof v.$vl?new v.$vl(a,i.fileOperationResult,i.size,i.options):new v.$ul(a,(0,v.$ql)(i),s)}G(i,o,s,a=Object.create(null)){const l=i.readFileStream(o,a,s);return(0,f.$Ke)(l,{data:E=>E instanceof P.$Ne?E:P.$Ne.wrap(E),error:E=>this.F(E,o,a)},E=>P.$Ne.concat(E))}H(i,o,s,a=Object.create(null)){const l=(0,P.$4e)();return(0,b.$1q)(i,o,l,E=>E,{...a,bufferSize:this.a,errorTransformer:E=>this.F(E,o,a)},s),l}I(i,o,s){const a=(0,f.$Be)(l=>P.$Ne.concat(l));return(async()=>{try{let l;s?.atomic&&(0,v.$hl)(i)?l=await i.readFile(o,{atomic:!0}):l=await i.readFile(o),typeof s?.position=="number"&&(l=l.slice(s.position)),typeof s?.length=="number"&&(l=l.slice(0,s.length)),this.L(o,l.byteLength,s),a.end(P.$Ne.wrap(l))}catch(l){a.error(l),a.end()}})(),a}async J(i,o){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new v.$ul((0,g.localize)(11356,null,this.sb(i)),v.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==v.$El&&o.etag===s.etag)throw new v.$wl((0,g.localize)(11357,null),s,o);return this.L(i,s.size,o),s}L(i,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new v.$vl((0,g.localize)(11358,null,this.sb(i)),v.FileOperationResult.FILE_TOO_LARGE,o,s)}async canMove(i,o,s){return this.M(i,o,"move",s)}async canCopy(i,o,s){return this.M(i,o,"copy",s)}async M(i,o,s,a){if(i.toString()!==o.toString())try{const l=s==="move"?this.qb(await this.n(i),i):await this.m(i),E=this.qb(await this.n(o),o);await this.Q(l,i,E,o,s,a)}catch(l){return l}return!0}async move(i,o,s){const a=this.qb(await this.n(i),i),l=this.qb(await this.n(o),o),E=await this.N(a,i,l,o,"move",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$rl(i,E==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,y)),y}async copy(i,o,s){const a=await this.m(i),l=this.qb(await this.n(o),o),E=await this.N(a,i,l,o,"copy",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$rl(i,E==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,y)),y}async N(i,o,s,a,l,E){if(o.toString()===a.toString())return l;const{exists:y,isSameResourceWithDifferentPathCase:R}=await this.Q(i,o,s,a,l,E);if(y&&!R&&E&&await this.del(a,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(a)),l==="copy"){if(i===s&&(0,v.$dl)(i))await i.copy(o,a,{overwrite:E});else{const L=await this.resolve(o);L.isDirectory?await this.P(i,L,s,a):await this.O(i,o,s,a)}return l}else return i===s?(await i.rename(o,a,{overwrite:E}),l):(await this.N(i,o,s,a,"copy",E),await this.del(o,{recursive:!0}),"copy")}async O(i,o,s,a){if((0,v.$fl)(i)&&(0,v.$fl)(s))return this.jb(i,o,s,a);if((0,v.$fl)(i)&&(0,v.$cl)(s))return this.pb(i,o,s,a);if((0,v.$cl)(i)&&(0,v.$fl)(s))return this.nb(i,o,s,a);if((0,v.$cl)(i)&&(0,v.$cl)(s))return this.lb(i,o,s,a)}async P(i,o,s,a){await s.mkdir(a),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async l=>{const E=this.R(s).providerExtUri.joinPath(a,l.name);return l.isDirectory?this.P(i,await this.resolve(l.resource),s,E):this.O(i,l.resource,s,E)}))}async Q(i,o,s,a,l,E){let y=!1;if(i===s){const{providerExtUri:L,isPathCaseSensitive:A}=this.R(i);if(A||(y=L.isEqual(o,a)),y&&l==="copy")throw new Error((0,g.localize)(11359,null,this.sb(o),this.sb(a)));if(!y&&L.isEqualOrParent(a,o))throw new Error((0,g.localize)(11360,null,this.sb(o),this.sb(a)))}const R=await this.exists(a);if(R&&!y){if(!E)throw new v.$ul((0,g.localize)(11361,null,this.sb(o),this.sb(a)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(o,a))throw new Error((0,g.localize)(11362,null,this.sb(o),this.sb(a)))}}return{exists:R,isSameResourceWithDifferentPathCase:y}}R(i){const o=this.S(i);return{providerExtUri:o?w.$8g:w.$0g,isPathCaseSensitive:o}}S(i){return!!(i.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const o=this.qb(await this.j(i),i);await this.U(o,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new v.$rl(i,v.FileOperation.CREATE,s)),s}async U(i,o){const s=[],{providerExtUri:a}=this.R(i);for(;!a.isEqual(o,a.dirname(o));)try{if(!((await i.stat(o)).type&v.FileType.Directory))throw new Error((0,g.localize)(11363,null,this.sb(o)));break}catch(l){if((0,v.$pl)(l)!==v.FileSystemProviderErrorCode.FileNotFound)throw l;s.push(a.basename(o)),o=a.dirname(o)}for(let l=s.length-1;l>=0;l--){o=a.joinPath(o,s[l]);try{await i.mkdir(o)}catch(E){if((0,v.$pl)(E)!==v.FileSystemProviderErrorCode.FileExists)throw E}}}async canDelete(i,o){try{await this.W(i,o)}catch(s){return s}return!0}async W(i,o){const s=this.qb(await this.j(i),i),a=!!o?.useTrash;if(a&&!(s.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(11364,null,this.sb(i)));const l=o?.atomic;if(l&&!(s.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(11365,null,this.sb(i)));if(a&&l)throw new Error((0,g.localize)(11366,null,this.sb(i)));let E;try{E=await s.stat(i)}catch{}if(E)this.rb(i,E);else throw new v.$ul((0,g.localize)(11367,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const R=await this.resolve(i);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,g.localize)(11368,null,this.sb(i)))}return s}async del(i,o){const s=await this.W(i,o);let a=o;if((0,v.$jl)(s)&&!a?.atomic){const R=s.enforceAtomicDelete?.(i);R&&(a={...o,atomic:R})}const l=!!a?.useTrash,E=!!a?.recursive,y=a?.atomic??!1;await s.delete(i,{recursive:E,useTrash:l,atomic:y}),this.r.fire(new v.$rl(i,v.FileOperation.DELETE))}async cloneFile(i,o){const s=await this.j(i),a=this.qb(await this.n(o),o);if(!(s===a&&this.R(s).providerExtUri.isEqual(i,o)))return s===a&&(0,v.$el)(s)?s.cloneFile(i,o):(await this.U(a,this.R(a).providerExtUri.dirname(o)),s===a&&(0,v.$dl)(s)?this.cb.queueFor(i,()=>s.copy(i,o,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,a,o),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(i,o){return this.watch(i,{...o,correlationId:S.ab++})}watch(i,o={recursive:!1,excludes:[]}){const s=new c.$Tc;let a=!1,l=()=>{a=!0};s.add((0,c.$Sc)(()=>l())),(async()=>{try{const y=await this.bb(i,o);a?(0,c.$Pc)(y):l=()=>(0,c.$Pc)(y)}catch(y){this.b.error(y)}})();const E=o.correlationId;if(typeof E=="number"){const y=s.add(new T.$le);return s.add(this.X.event(L=>{L.correlates(E)&&y.fire(L)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(i,o){const s=await this.j(i),a=(0,I.$sj)([this.R(s).providerExtUri.getComparisonKey(i),o]);let l=this.$.get(a);return l||(l={count:0,disposable:s.watch(i,o)},this.$.set(a,l)),l.count+=1,(0,c.$Sc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Pc)(l.disposable),this.$.delete(a)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,c.$Pc)(i.disposable);this.$.clear()}async db(i,o,s,a){return this.cb.queueFor(o,async()=>{const l=await i.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,f.$ze)(a)||(0,f.$Ae)(a)?await this.eb(i,l,a):await this.fb(i,l,a)}catch(E){throw(0,v.$nl)(E)}finally{await i.close(l)}},this.R(i).providerExtUri)}async eb(i,o,s){let a=0,l;if((0,f.$Ae)(s)){if(s.buffer.length>0){const E=P.$Ne.concat(s.buffer);await this.gb(i,o,E,E.byteLength,a,0),a+=E.byteLength}if(s.ended)return;l=s.stream}else l=s;return new Promise((E,y)=>{(0,f.$Fe)(l,{onData:async R=>{l.pause();try{await this.gb(i,o,R,R.byteLength,a,0)}catch(L){return y(L)}a+=R.byteLength,setTimeout(()=>l.resume())},onError:R=>y(R),onEnd:()=>E()})})}async fb(i,o,s){let a=0,l;for(;(l=s.read())!==null;)await this.gb(i,o,l,l.byteLength,a,0),a+=l.byteLength}async gb(i,o,s,a,l,E){let y=0;for(;y<a;){const R=await i.write(o,l+y,s.buffer,E+y,a-y);y+=R}}async hb(i,o,s,a){return this.cb.queueFor(o,()=>this.ib(i,o,s,a),this.R(i).providerExtUri)}async ib(i,o,s,a){let l;a instanceof P.$Ne?l=a:(0,f.$ze)(a)?l=await(0,P.$Ze)(a):(0,f.$Ae)(a)?l=await(0,P.$1e)(a):l=(0,P.$Xe)(a),await i.writeFile(o,l.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,o,s,a){return this.cb.queueFor(a,()=>this.kb(i,o,s,a),this.R(s).providerExtUri)}async kb(i,o,s,a){let l,E;try{l=await i.open(o,{create:!1}),E=await s.open(a,{create:!0,unlock:!1});const y=P.$Ne.alloc(this.a);let R=0,L=0,A=0;do A=await i.read(l,R,y.buffer,L,y.byteLength-L),await this.gb(s,E,y,A,R,L),R+=A,L+=A,L===y.byteLength&&(L=0);while(A>0)}catch(y){throw(0,v.$nl)(y)}finally{await r.Promises.settled([typeof l=="number"?i.close(l):Promise.resolve(),typeof E=="number"?s.close(E):Promise.resolve()])}}async lb(i,o,s,a){return this.cb.queueFor(a,()=>this.mb(i,o,s,a),this.R(s).providerExtUri)}async mb(i,o,s,a){return s.writeFile(a,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,o,s,a){return this.cb.queueFor(a,()=>this.ob(i,o,s,a),this.R(s).providerExtUri)}async ob(i,o,s,a){const l=await s.open(a,{create:!0,unlock:!1});try{const E=await i.readFile(o);await this.gb(s,l,P.$Ne.wrap(E),E.byteLength,0,0)}catch(E){throw(0,v.$nl)(E)}finally{await s.close(l)}}async pb(i,o,s,a){const l=await(0,P.$Ze)(this.H(i,o,D.CancellationToken.None));await this.hb(s,a,void 0,l)}qb(i,o){if(i.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$ul((0,g.localize)(11369,null,this.sb(o)),v.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,o){if((o.permissions??0)&v.FilePermission.Readonly)throw new v.$ul((0,g.localize)(11370,null,this.sb(i)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===h.Schemas.file?i.fsPath:i.toString(!0)}};e.$2q=t,e.$2q=t=S=Se([se(0,$.$_j)],t)}),define(ce[99],le([0,1,26,8,31,17,4,32,2,9,3,18,67,23,10,14,124,188,184,183]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class S extends b.$br{static{this.L=!1}constructor(u,i){super(u,i),this.onDidChangeCapabilities=T.Event.None,this.P=new P.$Ac(o=>h.$9g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,m.$l&&(this.M|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:i,symbolicLink:o}=await w.SymlinkSupport.stat(this.I(u));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const i=await w.Promises.readdir(this.I(u),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,h.$fh)(u,s.name))).type:a=this.O(s),o.push([s.name,a])}catch(a){this.a.trace(a)}})),o}catch(i){throw this.hb(i)}}O(u,i){let o;return i?.dangling?o=g.FileType.Unknown:u.isFile()?o=g.FileType.File:u.isDirectory()?o=g.FileType.Directory:o=g.FileType.Unknown,i&&(o|=g.FileType.SymbolicLink),o}async Q(u){const i=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const s=new r.$Dh;return this.P.set(u,s),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,p.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(u)===s&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),s.open()})}async readFile(u,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),o=await this.Q(u));const s=this.I(u);return await n.promises.readFile(s)}catch(s){throw this.hb(s)}finally{o?.dispose()}}R(u){S.L&&this.a.trace(u)}readFileStream(u,i,o){const s=(0,d.$Be)(a=>D.$Ne.concat(a.map(l=>D.$Ne.wrap(l))).buffer);return(0,v.$1q)(this,u,s,a=>a.buffer,{...i,bufferSize:256*1024},o),s}async writeFile(u,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(u)?this.U(u,(0,h.$fh)((0,h.$eh)(u),`${(0,h.$ch)(u)}${o.atomic.postfix}`),i,o):this.W(u,i,o)}async S(u){try{const i=this.I(u),{symbolicLink:o}=await w.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(u,i,o,s){const a=new p.$Tc;try{a.add(await this.Q(u)),a.add(await this.Q(i)),await this.W(i,o,s,!0);try{await this.rename(i,u,{overwrite:!0})}catch(l){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{a.dispose()}}async W(u,i,o,s){let a;try{const l=this.I(u);if(!o.create||!o.overwrite){if(await w.Promises.exists(l)){if(!o.overwrite)throw(0,g.$ml)((0,f.localize)(11328,null),g.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,g.$ml)((0,f.localize)(11329,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(u,{create:!0,unlock:o.unlock},s),await this.write(a,0,i,0,i.byteLength)}catch(l){throw await this.ib(u,l)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(u){S.$=u}async open(u,i,o){const s=this.I(u);let a;(0,g.$al)(i)&&!o&&(a=await this.Q(u));let l;try{if((0,g.$al)(i)&&i.unlock)try{const{stat:y}=await w.SymlinkSupport.stat(s);y.mode&128||await n.promises.chmod(s,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let E;if((0,g.$al)(i)){if(m.$j)try{await n.promises.truncate(s,0),E="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}E||(E="w")}else E="r";l=await w.Promises.open(s,E)}catch(E){throw a?.dispose(),(0,g.$al)(i)?await this.ib(u,E):this.hb(E)}if(this.X.set(l,0),(0,g.$al)(i)&&this.Z.set(l,u),a){const E=this.Y.get(l);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.Y.set(l,a),E&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),E.dispose())}return l}async close(u){const i=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&S.$)try{await w.Promises.fdatasync(u)}catch(o){S.configureFlushOnWrite(!1),this.a.error(o)}return await w.Promises.close(u)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(u)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),i.dispose())}}async read(u,i,o,s,a){const l=this.ab(u,i);let E=null;try{E=(await w.Promises.read(u,o,s,a,l)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(u,l,E)}return E}ab(u,i){return i===this.X.get(u)?null:i}bb(u,i,o){const s=this.X.get(u);typeof s=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(u,s+o):this.X.delete(u)))}async write(u,i,o,s,a){return(0,r.$Yh)(()=>this.cb(u,i,o,s,a),100,3)}async cb(u,i,o,s,a){const l=this.ab(u,i);let E=null;try{E=(await w.Promises.write(u,o,s,a,l)).bytesWritten}catch(y){throw await this.ib(this.Z.get(u),y)}finally{this.bb(u,l,E)}return E}async mkdir(u){try{await n.promises.mkdir(this.I(u))}catch(i){throw this.hb(i)}}async delete(u,i){try{const o=this.I(u);if(i.recursive){let s;i?.atomic!==!1&&i.atomic.postfix&&(s=(0,c.$jc)((0,c.$mc)(o),`${(0,c.$nc)(o)}${i.atomic.postfix}`)),await w.Promises.rm(o,w.RimRafMode.MOVE,s)}else try{await n.promises.unlink(o)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let a=!1;try{const{stat:l,symbolicLink:E}=await w.SymlinkSupport.stat(o);a=l.isDirectory()&&!E}catch{}if(a)await n.promises.rmdir(o);else throw s}else throw s}}catch(o){throw this.hb(o)}}async rename(u,i,o){const s=this.I(u),a=this.I(i);if(s!==a)try{await this.db(u,i,"move",o.overwrite),await w.Promises.rename(s,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11330,null,(0,c.$nc)(s),(0,c.$nc)((0,c.$mc)(a)),l.toString()))),this.hb(l)}}async copy(u,i,o){const s=this.I(u),a=this.I(i);if(s!==a)try{await this.db(u,i,"copy",o.overwrite),await w.Promises.copy(s,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11331,null,(0,c.$nc)(s),(0,c.$nc)((0,c.$mc)(a)),l.toString()))),this.hb(l)}}async db(u,i,o,s){const a=this.I(u),l=this.I(i);let E=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(E=(0,I.$Cg)(a,l,!0)),E){if(o==="copy")throw(0,g.$ml)((0,f.localize)(11332,null),g.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const R=await this.N(u);if(!R)throw(0,g.$ml)((0,f.localize)(11333,null),g.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(i);if(L){if(!s)throw(0,g.$ml)((0,f.localize)(11334,null),g.FileSystemProviderErrorCode.FileExists);R.type&g.FileType.File&&L.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,i){return this.eb(u,i,!1)}async eb(u,i,o){const s=this.I(u),a=this.I(i),l=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Cg)(s,a,!l))return;const E=new p.$Tc;try{E.add(await this.Q(u)),E.add(await this.Q(i)),o&&await n.promises.mkdir((0,c.$mc)(a),{recursive:!0}),await n.promises.copyFile(s,a)}catch(y){if(y.code==="ENOENT"&&!o)return this.eb(u,i,!0);throw this.hb(y)}finally{E.dispose()}}t(u,i,o){return new $.$ir(s=>u(s),s=>i(s),o)}F(u,i,o){return new k.$rr(s=>u(s),s=>i(s),o)}hb(u){if(u instanceof g.$ll)return u;let i=u,o;switch(u.code){case"ENOENT":o=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=g.FileSystemProviderErrorCode.Unknown;break;default:o=g.FileSystemProviderErrorCode.Unknown}return(0,g.$ml)(i,o)}async ib(u,i){let o=this.hb(i);if(u&&o.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await w.SymlinkSupport.stat(this.I(u));s.mode&128||(o=(0,g.$ml)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.a.trace(s)}return o}}e.$sr=S}),define(ce[190],le([0,1,4,99,2,17,67,22]),function(x,e,n,r,P,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=void 0;class p extends P.$Uc{constructor(h,d){super(),this.a=h,this.b=d,this.F=new Map,this.G=new Map}call(h,d,w){const f=this.c(h);switch(d){case"stat":return this.g(f,w[0]);case"readdir":return this.h(f,w[0]);case"open":return this.r(f,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(f,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(f,w[0],w[1],w[2]);case"rename":return this.z(f,w[0],w[1],w[2]);case"copy":return this.C(f,w[0],w[1],w[2]);case"cloneFile":return this.D(f,w[0],w[1]);case"mkdir":return this.w(f,w[0]);case"delete":return this.y(f,w[0],w[1]);case"watch":return this.I(f,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${d} not found`)}listen(h,d,w){const f=this.c(h);switch(d){case"fileChange":return this.H(f,w[0]);case"readFileStream":return this.m(f,w[0],w[1])}throw new Error(`Unknown event ${d}`)}g(h,d){const w=this.f(h,d,!0);return this.a.stat(w)}h(h,d){const w=this.f(h,d);return this.a.readdir(w)}async j(h,d,w){const f=this.f(h,d,!0),g=await this.a.readFile(f,w);return D.$Ne.wrap(g)}m(h,d,w){const f=this.f(h,d,!0),g=new I.$we,v=new n.$le({onDidRemoveLastListener:()=>{g.cancel()}}),b=this.a.readFileStream(f,w,g.token);return(0,T.$Fe)(b,{onData:$=>v.fire(D.$Ne.wrap($)),onError:$=>v.fire($),onEnd:()=>{v.fire("end"),v.dispose(),g.dispose()}}),v.event}n(h,d,w,f){const g=this.f(h,d);return this.a.writeFile(g,w.buffer,f)}r(h,d,w){const f=this.f(h,d,!0);return this.a.open(f,w)}s(h){return this.a.close(h)}async t(h,d,w){const f=D.$Ne.alloc(w),v=await this.a.read(h,d,f.buffer,0,w);return[f,v]}u(h,d,w,f,g){return this.a.write(h,d,w.buffer,f,g)}w(h,d){const w=this.f(h,d);return this.a.mkdir(w)}y(h,d,w){const f=this.f(h,d);return this.a.delete(f,w)}z(h,d,w,f){const g=this.f(h,d),v=this.f(h,w);return this.a.rename(g,v,f)}C(h,d,w,f){const g=this.f(h,d),v=this.f(h,w);return this.a.copy(g,v,f)}D(h,d,w){const f=this.f(h,d),g=this.f(h,w);return this.a.cloneFile(f,g)}H(h,d){const w=new n.$le({onWillAddFirstListener:()=>{this.F.set(d,this.L(h,w))},onDidRemoveLastListener:()=>{(0,P.$Pc)(this.F.get(d)),this.F.delete(d)}});return w.event}async I(h,d,w,f,g){const v=this.F.get(d);if(v){const b=this.f(h,f),$=v.watch(w,b,g);this.G.set(d+w,$)}}async J(h,d){const w=h+d,f=this.G.get(w);f&&((0,P.$Pc)(f),this.G.delete(w))}dispose(){super.dispose();for(const[,h]of this.G)h.dispose();this.G.clear();for(const[,h]of this.F)h.dispose();this.F.clear()}}e.$3s=p;class c extends P.$Uc{constructor(h,d,w,f){super(),this.c=h,this.f=w,this.g=f,this.a=new Map,this.b=this.B(new r.$sr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(d)}h(h){const d=this.B(new n.$le);this.B(d.event(w=>{h.fire(w.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(w=>d.fire(w))),this.B(this.b.onDidWatchError(w=>h.fire(w)))}j(h){}m(h){}watch(h,d,w){const f=this.m(this.g);return Array.isArray(f)&&(w.excludes=[...w.excludes,...f]),this.a.set(h,this.b.watch(d,w)),(0,P.$Sc)(()=>{(0,P.$Pc)(this.a.get(h)),this.a.delete(h)})}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),super.dispose()}}e.$4s=c}),define(ce[191],le([0,1,13,10,3,7,14,9,190,151,55]),function(x,e,n,r,P,D,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class h extends p.$3s{constructor(f,g,v){super(f,g),this.M=v}c(f){return c.$Mn}f(f,g){return D.URI.revive(g)}async y(f,g,v){if(!v.useTrash)return super.y(f,g,v);const b=this.f(f,g),$=(0,I.$hc)(b.fsPath);try{await n.shell.trashItem($)}catch(k){throw(0,T.$ml)(P.$j?(0,r.localize)(11335,null,(0,I.$nc)($),(0,m.$pj)(k)):(0,r.localize)(11336,null,(0,I.$nc)($),(0,m.$pj)(k)),T.FileSystemProviderErrorCode.Unknown)}}L(f,g){return new d(f,g,this.b,this.M)}}e.$wgc=h;class d extends p.$4s{watch(f,g,v){if(v.recursive)throw(0,T.$ml)("Recursive file watching is not supported from main process for performance reasons.",T.FileSystemProviderErrorCode.Unavailable);return super.watch(f,g,v)}}}),define(ce[192],le([0,1,5]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class r extends n.$fk{constructor(D=n.$ck){super(),this.m=[],this.n=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(T=>{this.n?.setLevel(T)}))}set logger(D){this.n=D;for(const{level:T,message:I}of this.m)(0,n.log)(D,T,I);this.m=[]}g(D,T){this.n?(0,n.log)(this.n,D,T):this.getLevel()<=D&&this.m.push({level:D,message:T})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$cdc=r}),define(ce[193],le([0,1,7,4,5,2]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=e.$ts=e.$ss=void 0;class T extends P.$kk{constructor(h,d,w,f,g){super(d,w,f),this.r=h,this.t=g,this.B(g.listen("onDidChangeLogLevel",h)(v=>{(0,P.$bk)(v)?super.setLogLevel(v):super.setLogLevel(n.URI.revive(v[0]),v[1])})),this.B(g.listen("onDidChangeVisibility",h)(([v,b])=>super.setVisibility(n.URI.revive(v),b))),this.B(g.listen("onDidChangeLoggers",h)(({added:v,removed:b})=>{for(const $ of v)super.registerLogger({...$,resource:n.URI.revive($.resource)});for(const $ of b)super.deregisterLogger($.resource)}))}createConsoleMainLogger(){return new P.$ik({log:(h,d)=>{this.t.call("consoleLog",[h,d])}})}registerLogger(h){super.registerLogger(h),this.t.call("registerLogger",[h,this.r])}deregisterLogger(h){super.deregisterLogger(h),this.t.call("deregisterLogger",[h,this.r])}setLogLevel(h,d){super.setLogLevel(h,d),this.t.call("setLogLevel",[h,d])}setVisibility(h,d){super.setVisibility(h,d),this.t.call("setVisibility",[this.n(h),d])}s(h,d,w){return new I(this.t,h,d,w,this.r)}static setLogLevel(h,d,w){return h.call("setLogLevel",[d,w])}}e.$ss=T;class I extends P.$fk{constructor(h,d,w,f,g){super(f?.logLevel==="always"),this.r=h,this.s=d,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[d,f,g]).then(()=>{this.u(this.n),this.m=!0})}g(h,d){const w=[[h,d]];this.m?this.u(w):this.n.push(...w)}u(h){this.r.call("log",[this.s,h])}}class p{constructor(h,d){this.a=h,this.b=d}listen(h,d){const w=this.b(h);switch(d){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(g=>this.c(g,w)),removed:[...f.removed].map(g=>this.c(g,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,f=>[w.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,f=>(0,P.$bk)(f)?f:[w.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${d}`)}async call(h,d,w){const f=this.b(h);switch(d){case"setLogLevel":return(0,P.$bk)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,f)))}throw new Error(`Call not found: ${d}`)}c(h,d){return{...h,resource:d.transformOutgoingURI(h.resource)}}}e.$ts=p;class c extends D.$Uc{constructor(h,d){super(),d.call("setLogLevel",[h.getLogLevel()]),this.B(h.onDidChangeLogLevel(w=>d.call("setLogLevel",[w]))),d.call("getRegisteredLoggers").then(w=>{for(const f of w)h.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(d.listen("onDidChangeVisibility")(([w,f])=>h.setVisibility(n.URI.revive(w),f))),this.B(d.listen("onDidChangeLoggers")(({added:w,removed:f})=>{for(const g of w)h.registerLogger({...g,resource:n.URI.revive(g.resource)});for(const g of f)h.deregisterLogger(g.resource)}))}}e.$us=c}),define(ce[194],le([0,1,2,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=void 0;class P extends n.$Uc{constructor(T,I=[]){super(),this.a=new r.$jk([T,...I]),this.B(T.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...I){this.a.trace(T,...I)}debug(T,...I){this.a.debug(T,...I)}info(T,...I){this.a.info(T,...I)}warn(T,...I){this.a.warn(T,...I)}error(T,...I){this.a.error(T,...I)}flush(){this.a.flush()}}e.$HR=P}),define(ce[195],le([0,1,31,7,5]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;class D{constructor(I){this.b=I,this.a=new n.$Ac}listen(I,p,c){switch(p){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${p}`)}async call(I,p,c){switch(p){case"createLogger":this.c(r.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(r.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,P.$bk)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(r.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:r.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(c[0]))}throw new Error(`Call not found: ${p}`)}c(I,p,c){this.a.set(I,this.b.createLogger(I,p,c))}d(I,p){let c=console.log;switch(I){case P.LogLevel.Error:c=console.error;break;case P.LogLevel.Warning:c=console.warn;break;case P.LogLevel.Info:c=console.info;break}c.call(console,...p)}e(I,p){const c=this.a.get(I);if(!c)throw new Error("Create the logger before logging");for(const[m,h]of p)(0,P.log)(c,m,h)}}e.$uhc=D}),define(ce[196],le([0,1,14,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wR=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function D(c,m,h,d,w){try{const f=await new Promise((v,b)=>{x(["@vscode/spdlog"],v,b)}).then(Pe);f.setFlushOn(P.Trace);const g=await f.createAsyncRotatingLogger(c,m,h,d);return w?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(f){console.error(f)}return null}function T(c,m,h){switch(m){case r.LogLevel.Trace:c.trace(h);break;case r.LogLevel.Debug:c.debug(h);break;case r.LogLevel.Info:c.info(h);break;case r.LogLevel.Warning:c.warn(h);break;case r.LogLevel.Error:c.error(h);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function I(c,m){switch(m){case r.LogLevel.Trace:c.setLevel(P.Trace);break;case r.LogLevel.Debug:c.setLevel(P.Debug);break;case r.LogLevel.Info:c.setLevel(P.Info);break;case r.LogLevel.Warning:c.setLevel(P.Warning);break;case r.LogLevel.Error:c.setLevel(P.Error);break;case r.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class p extends r.$fk{constructor(m,h,d,w,f){super(),this.m=[],this.setLevel(f),this.n=this.s(m,h,d,w),this.B(this.onDidChangeLogLevel(g=>{this.r&&I(this.r,g)}))}async s(m,h,d,w){const f=d?6:1,g=30/f*n.$Hl.MB,v=await D(m,h,g,f,w);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:b,message:$}of this.m)T(this.r,b,$);this.m=[]}}g(m,h){this.r?T(this.r,m,h):this.getLevel()<=m&&this.m.push({level:m,message:h})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$wR=p}),define(ce[197],le([0,1,33,5,196]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xR=void 0;class D extends r.$kk{s(I,p,c){return new P.$wR((0,n.$1g)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,p)}}e.$xR=D}),define(ce[71],le([0,1,31,4,6,5,197]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=void 0,e.$3fc=(0,P.$Fi)(D.$ak);class I extends T.$xR{constructor(){super(...arguments),this.u=new n.$Ac}createLogger(c,m,h){h!==void 0&&this.u.set(this.n(c),h);try{return super.createLogger(c,m)}catch(d){throw this.u.delete(this.n(c)),d}}registerLogger(c,m){m!==void 0&&this.u.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const h of super.getRegisteredLoggers())c===this.u.get(h.resource)&&m.push(h);return m}getOnDidChangeLogLevelEvent(c){return r.Event.filter(this.onDidChangeLogLevel,m=>(0,D.$bk)(m)||this.w(m[0],c))}getOnDidChangeVisibilityEvent(c){return r.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,c))}getOnDidChangeLoggersEvent(c){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(d=>this.w(d.resource,c)),removed:[...m.removed].filter(d=>this.w(d.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,h]of this.u)h===c&&this.deregisterLogger(m)}w(c,m){const h=this.u.get(c);return h===void 0||h===m}dispose(){super.dispose(),this.u.clear()}}e.$4fc=I}),define(ce[198],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=n,e.$Lgc=r,e.$Mgc=P,e.$Ngc=D;function n(T){return T.submenu!==void 0}function r(T){return T.id==="vscode.menubar.separator"}function P(T){return T.uri!==void 0}function D(T){return!n(T)&&!r(T)&&!P(T)}}),define(ce[40],le([0,1,4,77,2,6]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=void 0,e.$so=(0,D.$Ei)("policy");class T extends P.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$le),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const m=Object.keys(this.f).length;return this.f={...c,...this.f},m!==Object.keys(this.f).length&&await this.j(c),r.Iterable.reduce(this.g.entries(),(h,[d,w])=>({...h,[d]:w}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(c,[m,h])=>({...c,[m]:{definition:h,value:this.g.get(m)}}),{})}}e.$to=T;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$uo=I}),define(ce[199],le([0,1,8,4,77,12,14,5,40]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;function c(h,d){const w=[];for(const f of new Set(P.Iterable.concat(h.keys(),d.keys())))h.get(f)!==d.get(f)&&w.push(f);return w}let m=class extends p.$to{constructor(d,w,f){super(),this.m=d,this.n=w,this.s=f,this.c=this.B(new n.$Ch(500));const g=r.Event.filter(w.onDidFilesChange,v=>v.affects(d));this.B(w.watch(d)),this.B(g(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const w=await this.n.readFile(this.m),f=JSON.parse(w.value.toString());if(!(0,D.$gg)(f))throw new Error("Policy file isn't a JSON object");for(const g of Object.keys(f))this.f[g]&&d.set(g,f[g])}catch(w){w.fileOperationResult!==T.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return d}async w(){const d=await this.u(),w=c(this.g,d);this.g=d,w.length>0&&this.h.fire(w)}};e.$Nhc=m,e.$Nhc=m=Se([se(1,T.$_k),se(2,I.$_j)],m)}),define(ce[200],le([0,1,4,2,40]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=void 0;class D{constructor(p){this.b=p,this.a=new r.$Tc}listen(p,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,m=>m.reduce((h,d)=>({...h,[d]:this.b.getPolicyValue(d)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(p,c,m){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$jhc=D;class T extends P.$to{constructor(p,c){super(),this.a=c;for(const m in p){const{definition:h,value:d}=p[m];this.f[m]=h,d!==void 0&&this.g.set(m,d)}this.a.listen("onDidChange")(m=>{for(const h in m){const d=m[h];d===null?this.g.delete(h):this.g.set(h,d)}this.h.fire(Object.keys(m))})}async j(p){const c=await this.a.call("updatePolicyDefinitions",p);for(const m in c)this.g.set(m,c[m])}}e.$khc=T}),define(ce[201],le([0,1,40,8,2,5]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;let T=class extends n.$to{constructor(p,c){super(),this.m=p,this.n=c,this.a=new r.$yh,this.b=this.B(new P.$Vc)}async j(p){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:c}=await new Promise((m,h)=>{x(["@vscode/policy-watcher"],m,h)}).then(Pe);await this.a.queue(()=>new Promise((m,h)=>{try{this.b.value=c(this.n,p,d=>{this.t(d),m()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),h(d)}}))}t(p){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const c in p){const m=p[c];m===void 0?this.g.delete(c):this.g.set(c,m)}this.h.fire(Object.keys(p))}};e.$Mhc=T,e.$Mhc=T=Se([se(0,D.$_j)],T)}),define(ce[72],le([0,1,36]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const D=P.context.configuration();if(D)r=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:D.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ce[28],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,n.$Ei)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(ce[202],le([0,1,8,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;let P=class{constructor(T,I,p){this.a=T,this.b=I,this.c=p}async inspect(T){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Fh)(T);const p=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),p.profile}async d(){const T=this.a.webContents.debugger;T.attach(),await T.sendCommand("Profiler.enable")}async e(){const T=this.a.webContents.debugger;await T.sendCommand("Profiler.disable"),T.detach()}};e.$zgc=P,e.$zgc=P=Se([se(2,r.$_j)],P)}),define(ce[73],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0,e.$Lfc=(0,n.$Ei)("protocolMainService")}),define(ce[45],le([0,1,141,12]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,n=Pe(n),r=Pe(r);class P{constructor(){this.a=new Map}add(T,I){n.ok(r.$eg(T)),n.ok(r.$gg(I)),n.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,I)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$qo=new P}),define(ce[203],le([0,1,4,143,45]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,P=Pe(P),e.$ro={JSONContribution:"base.contributions.json"};function D(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class T{constructor(){this.b=new n.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,m){this.a[D(c)]=m,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const m=this.a[c];return m?(0,r.$7j)(m):void 0}hasSchemaContent(c){return!!this.a[c]}}const I=new T;P.$qo.add(e.$ro.JSONContribution,I)}),define(ce[56],le([0,1,21,4,12,10,16,203,45]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=g,e.$Ho=v,e.$Io=b,e.$Jo=k,e.$Ko=S,e.$Lo=t,e.$Mo=u,P=Pe(P),D=Pe(D);var c;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$vo={Configuration:"base.contributions.configuration"};var m;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const h=p.$qo.as(I.$ro.JSONContribution);class d{constructor(){this.a=[],this.i=new Set,this.j=new r.$le,this.onDidSchemaChange=this.j.event,this.k=new r.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:D.localize(11564,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},h.registerSchema(e.$Co,this.h),this.z()}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const a=new Set;this.r(o,s,a),h.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:a})}deregisterConfigurations(o){const s=new Set;this.s(o,s),h.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:s})}updateConfigurations({add:o,remove:s}){const a=new Set;this.s(s,a),this.r(o,!1,a),h.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:a})}registerDefaultConfigurations(o){const s=new Set;this.l(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}l(o,s){this.a.push(...o);const a=[];for(const{overrides:l,source:E}of o)for(const y in l){s.add(y);const R=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),L=l[y];if(R.configurationDefaultOverrides.push({value:L,source:E}),e.$Fo.test(y)){const A=this.o(y,L,E,R.configurationDefaultOverrideValue);if(!A)continue;R.configurationDefaultOverrideValue=A,this.n(y,A,E),a.push(...g(y))}else{const A=this.p(y,L,E,R.configurationDefaultOverrideValue);if(!A)continue;R.configurationDefaultOverrideValue=A;const O=this.e[y];O&&(this.A(y,O),this.w(y,O))}}this.q(a)}deregisterDefaultConfigurations(o){const s=new Set;this.m(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}m(o,s){for(const a of o){const l=this.a.indexOf(a);l!==-1&&this.a.splice(l,1)}for(const{overrides:a,source:l}of o)for(const E in a){const y=this.b.get(E);if(!y)continue;const R=y.configurationDefaultOverrides.findIndex(L=>l?L.source?.id===l.id:L.value===a[E]);if(R!==-1){if(y.configurationDefaultOverrides.splice(R,1),y.configurationDefaultOverrides.length===0&&this.b.delete(E),e.$Fo.test(E)){let L;for(const A of y.configurationDefaultOverrides)L=this.o(E,A.value,A.source,L);L&&!P.$rg(L.value)?(y.configurationDefaultOverrideValue=L,this.n(E,L,l)):(this.b.delete(E),delete this.e[E],delete this.c.properties[E])}else{let L;for(const O of y.configurationDefaultOverrides)L=this.p(E,O.value,O.source,L);y.configurationDefaultOverrideValue=L;const A=this.e[E];A&&(this.A(E,A),this.w(E,A))}s.add(E)}}this.y()}n(o,s,a){const l={type:"object",default:s.value,description:D.localize(11565,null,(0,T.$ij)(o)),$ref:e.$Co,defaultDefaultValue:s.value,source:a,defaultValueSource:a};this.e[o]=l,this.c.properties[o]=l}o(o,s,a,l){const E=l?.value||{},y=l?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const R of Object.keys(s)){const L=s[R];if(P.$gg(L)&&(P.$lg(E[R])||P.$gg(E[R]))){if(E[R]={...E[R]??{},...L},a)for(const O in L)y.set(`${R}.${O}`,a)}else E[R]=L,a?y.set(R,a):y.delete(R)}return{value:E,source:y}}p(o,s,a,l){const E=this.e[o],y=l?.value??E?.defaultDefaultValue;let R=a;if(P.$gg(s)&&(E!==void 0&&E.type==="object"||E===void 0&&(P.$lg(y)||P.$gg(y)))){if(R=l?.source??new Map,!(R instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in s)a&&R.set(`${o}.${A}`,a);s={...P.$gg(y)?y:{},...s}}return{value:s,source:R}}deltaConfiguration(o){let s=!1;const a=new Set;o.removedDefaults&&(this.m(o.removedDefaults,a),s=!0),o.addedDefaults&&(this.l(o.addedDefaults,a),s=!0),o.removedConfigurations&&this.s(o.removedConfigurations,a),o.addedConfigurations&&this.r(o.addedConfigurations,!1,a),this.j.fire(),this.k.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...o){this.j.fire()}registerOverrideIdentifiers(o){this.q(o),this.j.fire()}q(o){for(const s of o)this.i.add(s);this.y()}r(o,s,a){o.forEach(l=>{this.u(l,s,l.extensionInfo,l.restrictedProperties,void 0,a),this.d.push(l),this.v(l)})}s(o,s){const a=l=>{if(l.properties)for(const E in l.properties){s.add(E);const y=this.e[E];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[E],this.x(E,l.properties[E])}l.allOf?.forEach(E=>a(E))};for(const l of o){a(l);const E=this.d.indexOf(l);E!==-1&&this.d.splice(E,1)}}u(o,s=!0,a,l,E=m.WINDOW,y){E=P.$ng(o.scope)?E:o.scope;const R=o.properties;if(R)for(const A in R){const O=R[A];if(s&&k(A,O)){delete R[A];continue}if(O.source=a,O.defaultDefaultValue=R[A].default,this.A(A,O),e.$Fo.test(A)?O.scope=void 0:(O.scope=P.$ng(O.scope)?E:O.scope,O.restricted=P.$ng(O.restricted)?!!l?.includes(A):O.restricted),R[A].hasOwnProperty("included")&&!R[A].included){this.g[A]=R[A],delete R[A];continue}else this.e[A]=R[A],R[A].policy?.name&&this.f.set(R[A].policy.name,A);!R[A].deprecationMessage&&R[A].markdownDeprecationMessage&&(R[A].deprecationMessage=R[A].markdownDeprecationMessage),y.add(A)}const L=o.allOf;if(L)for(const A of L)this.u(A,s,a,l,E,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[s,a]of this.b)a.configurationDefaultOverrideValue&&o.set(s,a.configurationDefaultOverrideValue);return o}v(o){const s=a=>{const l=a.properties;if(l)for(const y in l)this.w(y,l[y]);a.allOf?.forEach(s)};s(o)}w(o,s){switch(e.$wo.properties[o]=s,s.scope){case m.APPLICATION:e.$xo.properties[o]=s;break;case m.MACHINE:e.$yo.properties[o]=s;break;case m.MACHINE_OVERRIDABLE:e.$zo.properties[o]=s;break;case m.WINDOW:e.$Ao.properties[o]=s;break;case m.RESOURCE:e.$Bo.properties[o]=s;break;case m.LANGUAGE_OVERRIDABLE:e.$Bo.properties[o]=s,this.h.properties[o]=s;break}}x(o,s){switch(delete e.$wo.properties[o],s.scope){case m.APPLICATION:delete e.$xo.properties[o];break;case m.MACHINE:delete e.$yo.properties[o];break;case m.MACHINE_OVERRIDABLE:delete e.$zo.properties[o];break;case m.WINDOW:delete e.$Ao.properties[o];break;case m.RESOURCE:case m.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[o],delete this.h.properties[o];break}}y(){for(const o of this.i.values()){const s=`[${o}]`,a={type:"object",description:D.localize(11566,null),errorMessage:D.localize(11567,null),$ref:e.$Co};this.A(s,a),e.$wo.properties[s]=a,e.$xo.properties[s]=a,e.$yo.properties[s]=a,e.$zo.properties[s]=a,e.$Ao.properties[s]=a,e.$Bo.properties[s]=a}}z(){const o={type:"object",description:D.localize(11568,null),errorMessage:D.localize(11569,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=o,e.$xo.patternProperties[e.$Eo]=o,e.$yo.patternProperties[e.$Eo]=o,e.$zo.patternProperties[e.$Eo]=o,e.$Ao.patternProperties[e.$Eo]=o,e.$Bo.patternProperties[e.$Eo]=o,this.j.fire()}A(o,s){const a=this.b.get(o)?.configurationDefaultOverrideValue;let l,E;a&&(!s.disallowConfigurationDefault||!a.source)&&(l=a.value,E=a.source),P.$lg(l)&&(l=s.defaultDefaultValue,E=void 0),P.$lg(l)&&(l=b(s.type)),s.default=l,s.defaultValueSource=E}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.$Eo=`^(${w})+$`,e.$Fo=new RegExp(e.$Eo);function g(i){const o=[];if(e.$Fo.test(i)){let s=f.exec(i);for(;s?.length;){const a=s[1].trim();a&&o.push(a),s=f.exec(i)}}return(0,n.$Lb)(o)}function v(i){return i.reduce((o,s)=>`${o}[${s}]`,"")}function b(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new d;p.$qo.add(e.$vo.Configuration,$);function k(i,o){return i.trim()?e.$Fo.test(i)?D.localize(11571,null,i):$.getConfigurationProperties()[i]!==void 0?D.localize(11572,null,i):o.policy?.name&&$.getPolicyConfigurations().get(o.policy?.name)!==void 0?D.localize(11573,null,i,o.policy?.name,$.getPolicyConfigurations().get(o.policy?.name)):null:D.localize(11570,null)}function S(){const i=[],o=$.getConfigurationProperties();for(const s of Object.keys(o))i.push([s,o[s].scope]);return i.push(["launch",m.RESOURCE]),i.push(["task",m.RESOURCE]),i}function t(i){const o={};for(const s of i){const a=s.properties;if(P.$gg(a))for(const l in a)o[l]=a[l];s.allOf&&Object.assign(o,t(s.allOf))}return o}function u(i){switch(i){case"application":return m.APPLICATION;case"machine":return m.MACHINE;case"resource":return m.RESOURCE;case"machine-overridable":return m.MACHINE_OVERRIDABLE;case"language-overridable":return m.LANGUAGE_OVERRIDABLE;default:return m.WINDOW}}}),define(ce[125],le([0,1,21,4,43,2,31,37,12,7,16,56,14,45]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$Ro=S,n=Pe(n),P=Pe(P),I=Pe(I),p=Pe(p);function f(o){return Object.isFrozen(o)?o:I.$eo(o)}class g{static createEmptyModel(s){return new g({},[],[],void 0,s)}constructor(s,a,l,E,y){this.b=s,this.c=a,this.d=l,this.raw=E,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof g)return a;const l=new v("",this.f);return l.parseRaw(a),l.configurationModel});this.g=s.reduce((a,l)=>l===a?l:a.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,m.$gj)(this.contents,s):this.contents}inspect(s,a){const l=this;return{get value(){return f(l.rawConfiguration.getValue(s))},get override(){return a?f(l.rawConfiguration.getOverrideValue(s,a)):void 0},get merged(){return f(a?l.rawConfiguration.override(a).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const E=[];for(const{contents:y,identifiers:R,keys:L}of l.rawConfiguration.overrides){const A=new g(y,L,[],void 0,l.f).getValue(s);A!==void 0&&E.push({identifiers:R,value:A})}return E.length?f(E):void 0}}}getOverrideValue(s,a){const l=this.j(a);return l?s?(0,m.$gj)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const l of this.overrides)l.identifiers.includes(s)&&a.push(...l.keys);return n.$Lb(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return n.$Lb(s)}override(s){let a=this.a.get(s);return a||(a=this.h(s),this.a.set(s,a)),a}merge(...s){const a=I.$do(this.contents),l=I.$do(this.overrides),E=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const R of s)if(y.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(a,R.contents);for(const L of R.overrides){const[A]=l.filter(O=>n.$tb(O.identifiers,L.identifiers));A?(this.i(A.contents,L.contents),A.keys.push(...L.keys),A.keys=n.$Lb(A.keys)):l.push(I.$do(L))}for(const L of R.keys)E.indexOf(L)===-1&&E.push(L)}return new g(a,E,l,y.every(R=>R instanceof g)?void 0:y,this.f)}h(s){const a=this.j(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const E of n.$Lb([...Object.keys(this.contents),...Object.keys(a)])){let y=this.contents[E];const R=a[E];R&&(typeof y=="object"&&typeof R=="object"?(y=I.$do(y),this.i(y,R)):y=R),l[E]=y}return new g(l,this.keys,this.overrides,void 0,this.f)}i(s,a){for(const l of Object.keys(a)){if(l in s&&p.$gg(s[l])&&p.$gg(a[l])){this.i(s[l],a[l]);continue}s[l]=I.$do(a[l])}}j(s){let a=null,l=null;const E=y=>{y&&(l?this.i(l,y):l=I.$do(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===s?a=y.contents:y.identifiers.includes(s)&&E(y.contents);return E(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,a){this.k(s,a,!0)}setValue(s,a){this.k(s,a,!1)}removeValue(s){const a=this.keys.indexOf(s);a!==-1&&(this.keys.splice(a,1),(0,m.$fj)(this.contents,s),h.$Fo.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>n.$tb(l.identifiers,(0,h.$Go)(s))),1))}k(s,a,l){if((0,m.$ej)(this.contents,s,a,E=>this.f.error(E)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),h.$Fo.test(s)){const E=(0,h.$Go)(s),y={identifiers:E,keys:Object.keys(this.contents[s]),contents:(0,m.$dj)(this.contents[s],L=>this.f.error(L))},R=this.overrides.findIndex(L=>n.$tb(L.identifiers,E));R!==-1?this.overrides[R]=y:this.overrides.push(y)}}}e.$No=g;class v{constructor(s,a){this.f=s,this.g=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!p.$ng(s)){const l=this.h(s);this.parseRaw(l,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:l,keys:E,overrides:y,restricted:R,hasExcludedProperties:L}=this.i(s,a);this.b=new g(l,E,y,L?[s]:void 0,this.g),this.c=R||[]}h(s){let a={},l=null,E=[];const y=[],R=[];function L(O){Array.isArray(E)?E.push(O):l!==null&&(E[l]=O)}const A={onObjectBegin:()=>{const O={};L(O),y.push(E),E=O,l=null},onObjectProperty:O=>{l=O},onObjectEnd:()=>{E=y.pop()},onArrayBegin:()=>{const O=[];L(O),y.push(E),E=O,l=null},onArrayEnd:()=>{E=y.pop()},onLiteralValue:L,onError:(O,M,H)=>{R.push({error:O,offset:M,length:H})}};if(s)try{P.$5n(s,A),a=E[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return a}i(s,a){const l=w.$qo.as(h.$vo.Configuration).getConfigurationProperties(),E=this.j(s,l,!0,a);s=E.raw;const y=(0,m.$dj)(s,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),R=Object.keys(s),L=this.l(s,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:y,keys:R,overrides:L,restricted:E.restricted,hasExcludedProperties:E.hasExcludedProperties}}j(s,a,l,E){let y=!1;if(!E?.scopes&&!E?.skipRestricted&&!E?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:y};const R={},L=[];for(const A in s)if(h.$Fo.test(A)&&l){const O=this.j(s[A],a,!1,E);R[A]=O.raw,y=y||O.hasExcludedProperties,L.push(...O.restricted)}else{const O=a[A],M=O?typeof O.scope<"u"?O.scope:h.ConfigurationScope.WINDOW:void 0;O?.restricted&&L.push(A),!E.exclude?.includes(A)&&(E.include?.includes(A)||(M===void 0||E.scopes===void 0||E.scopes.includes(M))&&!(E.skipRestricted&&O?.restricted))?R[A]=s[A]:y=!0}return{raw:R,restricted:L,hasExcludedProperties:y}}l(s,a){const l=[];for(const E of Object.keys(s))if(h.$Fo.test(E)){const y={};for(const R in s[E])y[R]=s[E][R];l.push({identifiers:(0,h.$Go)(E),keys:Object.keys(y),contents:(0,m.$dj)(y,a)})}return l}}e.$Oo=v;class b extends D.$Uc{constructor(s,a,l,E,y){super(),this.c=s,this.f=a,this.g=E,this.h=y,this.b=this.B(new r.$le),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),y),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(d.FileOperation.CREATE)||R.isOperation(d.FileOperation.COPY)||R.isOperation(d.FileOperation.DELETE)||R.isOperation(d.FileOperation.WRITE))&&l.isEqual(R.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Po=b;class ${constructor(s,a,l,E,y,R,L,A,O,M,H,q,K){this.a=s,this.b=a,this.c=l,this.overrideIdentifiers=E,this.d=y,this.f=R,this.g=L,this.h=A,this.i=O,this.j=M,this.k=H,this.l=q,this.m=K}get value(){return f(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class k{constructor(s,a,l,E,y,R,L,A,O,M){this.j=s,this.l=a,this.m=l,this.n=E,this.p=y,this.q=R,this.r=L,this.s=A,this.t=O,this.u=M,this.h=null,this.i=new T.$Ac,this.v=null}getValue(s,a,l){return this.w(s,a,l).getValue(s)}updateValue(s,a,l={}){let E;l.resource?(E=this.t.get(l.resource),E||(E=g.createEmptyModel(this.u),this.t.set(l.resource,E))):E=this.s,a===void 0?E.removeValue(s):E.setValue(s,a),l.resource||(this.h=null)}inspect(s,a,l){const E=this.w(s,a,l),y=this.A(a.resource,l),R=a.resource?this.t.get(a.resource)||this.s:this.s,L=new Set;for(const A of E.overrides)for(const O of A.identifiers)E.getOverrideValue(s,O)!==void 0&&L.add(O);return new $(s,a,E.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,y||void 0,R)}keys(s){const a=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,a){this.r.set(s,a),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const l=[];if(!a){const{added:E,updated:y,removed:R}=u(this.j,s);a=[...E,...y,...R]}for(const E of a)for(const y of(0,h.$Go)(E)){const R=this.j.getKeysForOverrideIdentifier(y),L=s.getKeysForOverrideIdentifier(y),A=[...L.filter(O=>R.indexOf(O)===-1),...R.filter(O=>L.indexOf(O)===-1),...R.filter(O=>!I.$ho(this.j.override(y).getValue(O),s.override(y).getValue(O)))];l.push([y,A])}return this.updateDefaultConfiguration(s),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:l,removed:E}=u(this.l,s),y=[...a,...l,...E];return y.length&&this.updatePolicyConfiguration(s),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:l,removed:E,overrides:y}=u(this.applicationConfiguration,s),R=[...a,...l,...E];return R.length&&this.updateApplicationConfiguration(s),{keys:R,overrides:y}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:l,removed:E,overrides:y}=u(this.localUserConfiguration,s),R=[...a,...l,...E];return R.length&&this.updateLocalUserConfiguration(s),{keys:R,overrides:y}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:l,removed:E,overrides:y}=u(this.remoteUserConfiguration,s),R=[...a,...l,...E];return R.length&&this.updateRemoteUserConfiguration(s),{keys:R,overrides:y}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:l,removed:E,overrides:y}=u(this.workspaceConfiguration,s),R=[...a,...l,...E];return R.length&&this.updateWorkspaceConfiguration(s),{keys:R,overrides:y}}compareAndUpdateFolderConfiguration(s,a){const l=this.folderConfigurations.get(s),{added:E,updated:y,removed:R,overrides:L}=u(l,a),A=[...E,...y,...R];return(A.length||!l)&&this.updateFolderConfiguration(s,a),{keys:A,overrides:L}}compareAndDeleteFolderConfiguration(s){const a=this.folderConfigurations.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:E,removed:y,overrides:R}=u(a,void 0);return{keys:[...l,...E,...y],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,a,l){let E=this.x(a,l);return a.overrideIdentifier&&(E=E.override(a.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(E=E.merge(this.l)),E}x({resource:s},a){let l=this.y();if(a&&s){const E=a.getFolder(s);E&&(l=this.z(E.uri)||l);const y=this.t.get(s);y&&(l=l.merge(y))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let a=this.i.get(s);if(!a){const l=this.y(),E=this.r.get(s);E?(a=l.merge(E),this.i.set(s,a)):a=l}return a}A(s,a){if(a&&s){const l=a.getFolder(s);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,a)=>{const{contents:l,overrides:E,keys:y}=this.r.get(a);return s.push([a,{contents:l,overrides:E,keys:y}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(a=>s.add(a)),this.userConfiguration.keys.forEach(a=>s.add(a)),this.q.keys.forEach(a=>s.add(a)),this.r.forEach(a=>a.keys.forEach(l=>s.add(l))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.q.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.r.forEach(a=>a.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}D(s){const a=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.q.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(E=>a.add(E))),[...a.values()]}static parse(s,a){const l=this.E(s.defaults,a),E=this.E(s.policy,a),y=this.E(s.application,a),R=this.E(s.user,a),L=this.E(s.workspace,a),A=s.folders.reduce((O,M)=>(O.set(c.URI.revive(M[0]),this.E(M[1],a)),O),new T.$Ac);return new k(l,E,y,R,g.createEmptyModel(a),L,A,g.createEmptyModel(a),new T.$Ac,a)}static E(s,a){return new g(s.contents,s.keys,s.overrides,void 0,a)}}e.$Qo=k;function S(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,a=new Map;for(const E of o)E.keys.forEach(y=>s.add(y)),E.overrides.forEach(([y,R])=>{const L=(0,T.$xc)(a,y,new Set);R.forEach(A=>L.add(A))});const l=[];return a.forEach((E,y)=>l.push([y,[...E.values()]])),{keys:[...s.values()],overrides:l}}class t{constructor(s,a,l,E,y){this.change=s,this.f=a,this.g=l,this.h=E,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of s.keys)this.affectedKeys.add(R);for(const[,R]of s.overrides)for(const L of R)this.affectedKeys.add(L);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=k.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,a){const l=this.a+s,E=this.d.indexOf(l);if(E<0)return!1;const y=E+l.length;if(y>=this.d.length)return!1;const R=this.d.charCodeAt(y);if(R!==this.b&&R!==this.c)return!1;if(a){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,A=this.g.getValue(s,a,this.h);return!I.$ho(L,A)}return!0}}e.$So=t;function u(o,s){const{added:a,removed:l,updated:E}=i(s?.rawConfiguration,o?.rawConfiguration),y=[],R=o?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const A=L.filter(O=>!R.includes(O));for(const O of A)y.push([O,s.getKeysForOverrideIdentifier(O)])}if(o){const A=R.filter(O=>!L.includes(O));for(const O of A)y.push([O,o.getKeysForOverrideIdentifier(O)])}if(s&&o){for(const A of R)if(L.includes(A)){const O=i({contents:o.getOverrideValue(void 0,A)||{},keys:o.getKeysForOverrideIdentifier(A)},{contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)});y.push([A,[...O.added,...O.removed,...O.updated]])}}return{added:a,removed:l,updated:E,overrides:y}}function i(o,s){const a=o?s?o.keys.filter(y=>s.keys.indexOf(y)===-1):[...o.keys]:[],l=s?o?s.keys.filter(y=>o.keys.indexOf(y)===-1):[...s.keys]:[],E=[];if(o&&s){for(const y of s.keys)if(o.keys.indexOf(y)!==-1){const R=(0,m.$gj)(s.contents,y),L=(0,m.$gj)(o.contents,y);I.$ho(R,L)||E.push(y)}}return{added:a,removed:l,updated:E}}}),define(ce[204],le([0,1,21,4,2,37,12,125,56,5,40,45]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=void 0;class d extends P.$Uc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new r.$le),this.onDidChangeConfiguration=this.a.event,this.b=I.$No.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(h.$qo.as(p.$vo.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:b})=>this.f(Array.from(v),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,b){this.j(v,h.$qo.as(p.$vo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$No.createEmptyModel(this.c);const v=h.$qo.as(p.$vo.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,b){const $=this.g();for(const k of v){const S=$[k],t=b[k];S!==void 0?this.b.setValue(k,S):t?this.b.setValue(k,t.default):this.b.removeValue(k)}}}e.$To=d;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$No.createEmptyModel(new c.$mk)}async initialize(){return this.configurationModel}}e.$Uo=w;let f=class extends P.$Uc{get configurationModel(){return this.b}constructor(v,b,$){super(),this.c=v,this.f=b,this.g=$,this.a=this.B(new r.$le),this.onDidChangeConfiguration=this.a.event,this.b=I.$No.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const b={},$=[],k=h.$qo.as(p.$vo.Configuration).getConfigurationProperties();for(const S of v){const t=k[S];if(!t){$.push(S);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}$.push(S),b[t.policy.name]={type:t.type}}}return(0,T.$rg)(b)||await this.f.updatePolicyDefinitions(b),$}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const b=h.$qo.as(p.$vo.Configuration).getPolicyConfigurations(),$=(0,n.$Gb)(v.map(k=>b.get(k)));this.m($,!0)}m(v,b){this.g.trace("PolicyConfiguration#update",v);const $=h.$qo.as(p.$vo.Configuration).getConfigurationProperties(),k=[],S=this.b.isEmpty();for(const t of v){const u=$[t]?.policy?.name;if(u){const i=this.f.getPolicyValue(u);(S?i!==void 0:!(0,D.$ho)(this.b.getValue(t),i))&&k.push([t,i])}else this.b.getValue(t)!==void 0&&k.push([t,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const t=this.b;this.b=I.$No.createEmptyModel(this.g);for(const u of t.keys)this.b.setValue(u,t.getValue(u));for(const[u,i]of k)i===void 0?this.b.removeValue(u):this.b.setValue(u,i);b&&this.a.fire(this.b)}}};e.$Vo=f,e.$Vo=f=Se([se(1,m.$so),se(2,c.$_j)],f)}),define(ce[205],le([0,1,21,8,17,4,43,107,2,31,37,3,18,16,125,56,204,14,40]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=void 0;class k extends p.$Uc{constructor(u,i,o,s){super(),this.m=u,this.n=s,this.h=this.B(new D.$le),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$To(s)),this.c=o instanceof $.$uo?new v.$Uo:this.B(new v.$Vo(this.b,o,s)),this.f=this.B(new f.$Po(this.m,{},d.$9g,i,s)),this.a=new f.$Qo(this.b.configurationModel,this.c.configurationModel,f.$No.createEmptyModel(s),f.$No.createEmptyModel(s),f.$No.createEmptyModel(s),f.$No.createEmptyModel(s),new c.$Ac,f.$No.createEmptyModel(s),new c.$Ac,s),this.j=new S(u,i,this),this.g=this.B(new r.$Qh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:l})=>this.s(a,l))),this.B(this.c.onDidChangeConfiguration(a=>this.t(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,i,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$Qo(u,i,f.$No.createEmptyModel(this.n),o,f.$No.createEmptyModel(this.n),f.$No.createEmptyModel(this.n),new c.$Ac,f.$No.createEmptyModel(this.n),new c.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(u,i){const o=typeof u=="string"?u:void 0,s=(0,w.$_i)(u)?u:(0,w.$_i)(i)?i:{};return this.a.getValue(o,s,void 0)}async updateValue(u,i,o,s,a){const l=(0,w.$aj)(o)?o:(0,w.$_i)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,E=l?s:o;if(E!==void 0&&E!==w.ConfigurationTarget.USER_LOCAL&&E!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${u} to target ${E}.`);l?.overrideIdentifiers&&(l.overrideIdentifiers=(0,n.$Lb)(l.overrideIdentifiers),l.overrideIdentifiers=l.overrideIdentifiers.length?l.overrideIdentifiers:void 0);const y=this.inspect(u,{resource:l?.resource,overrideIdentifier:l?.overrideIdentifiers?l.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,m.$ho)(i,y.defaultValue)&&(i=void 0),l?.overrideIdentifiers?.length&&l.overrideIdentifiers.length>1){const L=l.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(O=>(0,n.$tb)([...O.identifiers].sort(),L));A&&(l.overrideIdentifiers=A.identifiers)}const R=l?.overrideIdentifiers?.length?[(0,g.$Ho)(l.overrideIdentifiers),u]:[u];await this.j.write(R,i),await this.reloadConfiguration()}inspect(u,i={}){return this.a.inspect(u,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.r(u)}r(u){const i=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(u);this.u(o,i,w.ConfigurationTarget.USER)}s(u,i){const o=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(u,i);this.u(s,o,w.ConfigurationTarget.DEFAULT)}t(u){const i=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(u);this.u(o,i,w.ConfigurationTarget.DEFAULT)}u(u,i,o){const s=new f.$So(u,{data:i},this.a,void 0,this.n);s.source=o,this.h.fire(s)}}e.$Wo=k;class S{constructor(u,i,o){this.b=u,this.c=i,this.d=o,this.a=new r.$Lh}write(u,i){return this.a.queue(()=>this.e(u,i))}async e(u,i){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(l){if(l.fileOperationResult===b.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw l}const s=[];if((0,T.$Xn)(o,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const a=this.f(o,u,i);o=(0,I.$co)(o,a),await this.c.writeFile(this.b,P.$Ne.fromString(o))}f(u,i,o){const{tabSize:s,insertSpaces:a,eol:l}=this.h;if(!i.length){const E=JSON.stringify(o,null,a?" ".repeat(s):"	");return[{content:E,length:E.length,offset:0}]}return(0,I.$_n)(u,i,o,{tabSize:s,insertSpaces:a,eol:l})}get h(){if(!this.g){let u=h.OS===h.OperatingSystem.Linux||h.OS===h.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(u=i),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[206],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=e.$Ahc=e.$zhc=void 0,e.$zhc="request",e.$Ahc="remoteResourceHandler";class n{async routeCall(P,D,T){if(D!==e.$zhc)throw new Error(`Call not found: ${D}`);const I=T[0];if(I?.authority){const p=P.connections.find(c=>c.ctx===I.authority);if(p)return p}throw new Error("Caller not found")}routeEvent(P,D){throw new Error(`Event not found: ${D}`)}}e.$Bhc=n}),define(ce[207],le([0,1,15,6]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=c,e.$Ql=(0,r.$Ei)("remoteAuthorityResolverService");var P;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class D{constructor(h){this.id=h,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=D;class T{constructor(h,d){this.host=h,this.port=d,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=T;var I;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class p extends n.$ab{static isNotAvailable(h){return h instanceof p&&h._code===I.NotAvailable}static isTemporarilyNotAvailable(h){return h instanceof p&&h._code===I.TemporarilyNotAvailable}static isNoResolverFound(h){return h instanceof p&&h._code===I.NoResolverFound}static isInvalidAuthority(h){return h instanceof p&&h._code===I.InvalidAuthority}static isHandled(h){return h instanceof p&&h.isHandled}constructor(h,d=I.Unknown,w){super(h),this._message=h,this._code=d,this._detail=w,this.isHandled=d===I.NotAvailable&&w===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Tl=p;function c(m){const h=m.indexOf("+");return h===-1?m:m.substring(0,h)}}),define(ce[208],le([0,1,8,17,22,15,4,2,11,70,66,33,117,207]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=y,e.$1l=R,e.$2l=A,c=Pe(c);const f=30*1e3;var g;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function v(re){switch(re){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function b(re){const Q=new P.$we;return setTimeout(()=>Q.cancel(),re),Q.token}function $(re,Q){if(re.isCancellationRequested||Q.isCancellationRequested)return P.CancellationToken.Cancelled;const N=new P.$we;return re.onCancellationRequested(()=>N.cancel()),Q.onCancellationRequested(()=>N.cancel()),N.token}class k{get didTimeout(){return this.c==="timedout"}constructor(Q){this.c="pending",this.d=new I.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$xh)(),Q.isCancellationRequested?this.h():this.d.add(Q.onCancellationRequested(()=>this.h()))}registerDisposable(Q){this.c==="pending"?this.d.add(Q):Q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Q))}reject(Q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Q))}}function S(re,Q){const N=new k(Q);return N.registerDisposable(re.onControlMessage(F=>{const _=JSON.parse(F.toString()),z=j(_);z?N.reject(z):N.resolve(_)})),N.promise}function t(re,Q,N,F,_,z,ie,G){const B=new k(G),te=m.$fe.create(!1);return re.info(`Creating a socket (${ie})...`),c.mark(`code/willCreateSocket/${z}`),Q.connect(N,F,_,ie).then(he=>{B.didTimeout?(c.mark(`code/didCreateSocketError/${z}`),re.info(`Creating a socket (${ie}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(c.mark(`code/didCreateSocketOK/${z}`),re.info(`Creating a socket (${ie}) was successful after ${te.elapsed()} ms.`),B.resolve(he))},he=>{c.mark(`code/didCreateSocketError/${z}`),re.info(`Creating a socket (${ie}) returned an error after ${te.elapsed()} ms.`),re.error(he),B.reject(he)}),B.promise}function u(re,Q){const N=new k(Q);return re.then(F=>{N.didTimeout||N.resolve(F)},F=>{N.didTimeout||N.reject(F)}),N.promise}async function i(re,Q,N,F){const _=V(re,Q);re.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let z;try{z=await t(re.logService,re.remoteSocketFactoryService,re.connectTo,p.$Rg.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,v(Q),`renderer-${v(Q)}-${re.reconnectionToken}`,F)}catch(he){throw re.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),re.logService.error(he),he}re.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let ie,G;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(z,null),ie=re.reconnectionProtocol,G=!1):(ie=new d.$si({socket:z}),G=!0),re.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const B=await u(re.signService.createNewMessage((0,h.$1g)()),F),te={type:"auth",auth:re.connectionToken||"00000000000000000000",data:B.data};ie.sendControl(r.$Ne.fromString(JSON.stringify(te)));try{const he=await S(ie,$(F,b(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(re.logService.trace(`${_} 4/6. received SignRequest control message.`),!await u(re.signService.validate(B,he.signedData),F)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const we=await u(re.signService.sign(he.data),F),Ie={type:"connectionType",commit:re.commit,signedData:we,desiredConnectionType:Q};return N&&(Ie.args=N),re.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(r.$Ne.fromString(JSON.stringify(Ie))),{protocol:ie,ownsProtocol:G}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(re.logService.error(`${_} the handshake timed out. Error:`),re.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${_} received error control message when negotiating connection. Error:`),re.logService.error(he)),G&&W(ie),he}}async function o(re,Q,N,F){const _=Date.now(),z=V(re,Q),{protocol:ie,ownsProtocol:G}=await i(re,Q,N,F),B=new k(F);return B.registerDisposable(ie.onControlMessage(te=>{const he=JSON.parse(te.toString()),me=j(he);me?(re.logService.error(`${z} received error control message when negotiating connection. Error:`),re.logService.error(me),G&&W(ie),B.reject(me)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ue(_)}!`),B.resolve({protocol:ie,firstMessage:he}))})),B.promise}async function s(re,Q){const{protocol:N}=await o(re,g.Management,void 0,Q);return{protocol:N}}async function a(re,Q,N){const{protocol:F,firstMessage:_}=await o(re,g.ExtensionHost,Q,N),z=_&&_.debugPort;return{protocol:F,debugPort:z}}async function l(re,Q,N){const F=Date.now(),_=V(re,g.Tunnel),{protocol:z}=await i(re,g.Tunnel,Q,N);return re.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${ue(F)}!`),z}async function E(re,Q,N){const{connectTo:F,connectionToken:_}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:F,connectionToken:_,reconnectionToken:Q,reconnectionProtocol:N,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function y(re,Q,N){return L(re,async F=>{const{protocol:_}=await s(F,P.CancellationToken.None);return new U(re,Q,N,F.reconnectionToken,_)})}async function R(re,Q){return L(re,async N=>{const{protocol:F,debugPort:_}=await a(N,Q,P.CancellationToken.None);return new Z(re,Q,N.reconnectionToken,F,_)})}async function L(re,Q){for(let F=1;;F++)try{const _=(0,h.$1g)(),z=await E(re,_,null);return await Q(z)}catch(_){if(F<5)re.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(_);else throw re.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(_),J.triggerPermanentFailure(0,0,w.$Tl.isHandled(_)),_}}async function A(re,Q,N){const F=await E(re,(0,h.$1g)(),null);return await l(F,{host:Q,port:N},P.CancellationToken.None)}function O(re){return(0,n.$rh)(Q=>new Promise((N,F)=>{const _=setTimeout(N,re*1e3);Q.onCancellationRequested(()=>{clearTimeout(_),N()})}))}var M;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class H{constructor(Q,N){this.reconnectionToken=Q,this.millisSinceLastIncomingData=N,this.type=M.ConnectionLost}}e.$3l=H;class q{constructor(Q,N,F,_){this.reconnectionToken=Q,this.millisSinceLastIncomingData=N,this.durationSeconds=F,this.c=_,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=q;class K{constructor(Q,N,F){this.reconnectionToken=Q,this.millisSinceLastIncomingData=N,this.attempt=F,this.type=M.ReconnectionRunning}}e.$5l=K;class de{constructor(Q,N,F){this.reconnectionToken=Q,this.millisSinceLastIncomingData=N,this.attempt=F,this.type=M.ConnectionGain}}e.$6l=de;class Y{constructor(Q,N,F,_){this.reconnectionToken=Q,this.millisSinceLastIncomingData=N,this.attempt=F,this.handled=_,this.type=M.ReconnectionPermanentFailure}}e.$7l=Y;class J extends I.$Uc{static triggerPermanentFailure(Q,N,F){this._permanentFailure=!0,this.f=Q,this.g=N,this.h=F,this.j.forEach(_=>_.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Q=>Q.y())}static debugPauseSocketWriting(){this.j.forEach(Q=>Q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||J._permanentFailure}constructor(Q,N,F,_,z){super(),this.t=Q,this.u=N,this.reconnectionToken=F,this.protocol=_,this.w=z,this.m=this.B(new T.$le),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new de(this.reconnectionToken,0,0)),this.B(_.onSocketClose(ie=>{const G=oe(this.t,this.reconnectionToken,!0);ie?ie.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${G} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.u.logService.error(ie.error)):(this.u.logService.info(`${G} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.u.logService.error(ie.event)):this.u.logService.info(`${G} received socket close event.`),this.y()})),this.B(_.onSocketTimeout(ie=>{const G=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${G} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.y()})),J.j.push(this),this.B((0,I.$Sc)(()=>{const ie=J.j.indexOf(this);ie>=0&&J.j.splice(ie,1)})),this.n&&this.D(J.f,J.g,J.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Q=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const _=F<N.length?N[F]:N[N.length-1];try{if(_>0){const ie=O(_);this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,ie)),this.u.logService.info(`${Q} waiting for ${_} seconds before reconnecting...`);try{await ie}catch{}}if(this.n){this.u.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this.u.logService.info(`${Q} resolving connection...`);const z=await E(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Q} connecting to ${z.connectTo}...`),await this.G(z,b(f)),this.u.logService.info(`${Q} reconnected!`),this.m.fire(new de(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this.u.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(w.$Tl.isTemporarilyNotAvailable(z)){this.u.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,D.$3)(z)){this.u.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof w.$Tl){this.u.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,w.$Tl.isHandled(z));break}this.u.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this.n&&!this.s)}C(Q,N,F){this.w?J.triggerPermanentFailure(Q,N,F):this.D(Q,N,F)}D(Q,N,F){this.m.fire(new Y(this.reconnectionToken,Q,N,F)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=J;class U extends J{constructor(Q,N,F,_,z){super(g.Management,Q,_,z,!0),this.client=this.B(new d.$qi(z,{remoteAuthority:N,clientId:F},Q.ipcLogger))}async G(Q,N){await s(Q,N)}}e.$9l=U;class Z extends J{constructor(Q,N,F,_,z){super(g.ExtensionHost,Q,F,_,!1),this.H=N,this.debugPort=z}async G(Q,N){await a(Q,this.H,N)}}e.$0l=Z;function W(re){try{re.acceptDisconnect();const Q=re.getSocket();re.dispose(),Q.dispose()}catch(Q){(0,D.$Y)(Q)}}function j(re){if(re&&re.type==="error"){const Q=new Error(`Connection error: ${re.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function C(re,Q){for(;re.length<Q;)re+=" ";return re}function X(re,Q){return`[remote-connection][${C(v(re),13)}][${Q.substr(0,5)}\u2026]`}function oe(re,Q,N){return`${X(re,Q)}[${N?"reconnect":"initial"}]`}function V(re,Q){return`${oe(Q,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function ue(re){return`${Date.now()-re} ms`}}),define(ce[74],le([0,1,11]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=r,e.$hn=P,e.$in=D,e.$jn=T;function r(p){return p.scheme===n.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function D(p){const{host:c,port:m}=I(p);if(typeof m>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:m}}function T(p,c){let{host:m,port:h}=I(p);return typeof h>"u"&&(h=c),{host:m,port:h}}function I(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const m=p.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const h=p.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:p,port:void 0}}}),define(ce[85],le([0,1,25,6,74]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=D,e.$tn=h,e.$un=d,e.$vn=w,e.$wn=f,e.$xn=g,e.$yn=v,n=Pe(n),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function D(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$pn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(T||(e.ExtensionType=T={}));var I;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class p{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,k){if(typeof $>"u"||$===null)return typeof k>"u"||k===null;if(typeof k>"u"||k===null)return!1;if(typeof $=="string"||typeof k=="string"){const S=typeof $=="string"?$:$.value,t=typeof k=="string"?k:k.value;return n.$Ff(S,t)}return $._lower===k._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$qn=p;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const k of $)this.add(k)}add($){this.c.add(p.toKey($))}delete($){return this.c.delete(p.toKey($))}has($){return this.c.has(p.toKey($))}}e.$rn=c;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(p.toKey($))}get($){return this.c.get(p.toKey($))}has($){return this.c.has(p.toKey($))}set($,k){this.c.set(p.toKey($),k)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=m;function h(b){return d(b)}function d(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function w(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function f(b,$){if($){const k=`onResolveRemoteAuthority:${(0,P.$hn)($)}`;return!!b.activationEvents?.includes(k)}return!1}function g(b){return b.map($=>{const[k,S]=$.split("@");return{proposalName:k,version:S?parseInt(S):void 0}})}function v(b){return b.map($=>$.split("@")[0])}e.$zn=(0,r.$Ei)("IBuiltinExtensionsScannerService")}),define(ce[126],le([0,1,3,10,85,6]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.ExtensionManagementErrorCode=e.$lp=e.ExtensionGalleryErrorCode=e.$kp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0,e.$ep=I,e.$fp=p,e.$gp=c,e.$hp=m,e.$ip=h,e.$jp=d,e.$0o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$o=new RegExp(e.$0o),e.$_o="__web_extension",e.$ap="skipWalkthrough",e.$bp="extensionInstallSource",e.$cp="dependecyOrPackExtensionInstall",e.$dp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function I(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function c(t,u){switch(t){case n.Platform.Windows:return u==="x64"?P.TargetPlatform.WIN32_X64:u==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Linux:return u==="x64"?P.TargetPlatform.LINUX_X64:u==="arm64"?P.TargetPlatform.LINUX_ARM64:u==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return u==="x64"?P.TargetPlatform.ALPINE_X64:u==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Mac:return u==="x64"?P.TargetPlatform.DARWIN_X64:u==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Web:return P.TargetPlatform.WEB}}function m(t,u){return u===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function h(t,u,i){return m(u,i)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===i}function d(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var g;(function(t){t.Install="install",t.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var v;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$kp=(0,D.$Ei)("extensionGalleryService");var b;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(b||(e.ExtensionGalleryErrorCode=b={}));class $ extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$lp=$;var k;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));class S extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$mp=S,e.$np=(0,D.$Ei)("extensionManagementService"),e.$op="extensionsIdentifiers/disabled",e.$pp="extensionsIdentifiers/enabled",e.$qp=(0,D.$Ei)("IGlobalExtensionEnablementService"),e.$rp=(0,D.$Ei)("IExtensionTipsService"),e.$sp=(0,r.localize2)(11454,"Extensions"),e.$tp=(0,r.localize2)(11455,"Preferences")});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[209],le([0,1,18,81,10,210,85,172]),function(x,e,n,r,P,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=m,e.$Zp=h,e.$1p=d,e.$2p=w,e.$3p=f,e.$4p=g,e.$5p=v,e.$6p=b,r=Ve(r),P=Pe(P),D=Pe(D);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function m(S){return S=S.trim(),S==="*"||p.test(S)}function h(S){if(!m(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=S.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function d(S){if(!S)return null;const t=S.majorBase,u=S.majorMustEqual,i=S.minorBase;let o=S.minorMustEqual;const s=S.patchBase;let a=S.patchMustEqual;S.hasCaret&&(t===0||(o=!1),a=!1);let l=0;if(S.preRelease){const E=c.exec(S.preRelease);if(E){const[,y,R,L]=E;l=Date.UTC(Number(y),Number(R)-1,Number(L))}}return{majorBase:t,majorMustEqual:u,minorBase:i,minorMustEqual:o,patchBase:s,patchMustEqual:a,isMinimum:S.hasGreaterEquals,notBefore:l}}function w(S,t,u){let i;typeof S=="string"?i=d(h(S)):i=S;let o;t instanceof Date?o=t.getTime():typeof t=="string"&&(o=new Date(t).getTime());let s;if(typeof u=="string"?s=d(h(u)):s=u,!i||!s)return!1;const a=i.majorBase,l=i.minorBase,E=i.patchBase;let y=s.majorBase,R=s.minorBase,L=s.patchBase;const A=s.notBefore;let O=s.majorMustEqual,M=s.minorMustEqual,H=s.patchMustEqual;return s.isMinimum?a>y?!0:a<y?!1:l>R?!0:l<R||o&&o<A?!1:E>=L:(a===1&&y===0&&(!O||!M||!H)&&(y=1,R=0,L=0,O=!0,M=!1,H=!1),a<y?!1:a>y?!O:l<R?!1:l>R?!M:E<L?!1:E>L?!H:!(o&&o<A))}function f(S,t,u,i,o,s){const a=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return a.push([r.default.Error,P.localize(11385,null)]),a;if(typeof i.name!="string")return a.push([r.default.Error,P.localize(11386,null,"name")]),a;if(typeof i.version!="string")return a.push([r.default.Error,P.localize(11387,null,"version")]),a;if(!i.engines)return a.push([r.default.Error,P.localize(11388,null,"engines")]),a;if(typeof i.engines.vscode!="string")return a.push([r.default.Error,P.localize(11389,null,"engines.vscode")]),a;if(typeof i.extensionDependencies<"u"&&!k(i.extensionDependencies))return a.push([r.default.Error,P.localize(11390,null,"extensionDependencies")]),a;if(typeof i.activationEvents<"u"){if(!k(i.activationEvents))return a.push([r.default.Error,P.localize(11391,null,"activationEvents")]),a;if(typeof i.main>"u"&&typeof i.browser>"u")return a.push([r.default.Error,P.localize(11392,null,"activationEvents","main","browser")]),a}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&a.push([r.default.Warning,P.localize(11393,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return a.push([r.default.Error,P.localize(11394,null,"main")]),a;{const y=(0,n.$fh)(u,i.main);(0,n.$_g)(y,u)||a.push([r.default.Warning,P.localize(11395,null,y.path,u.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return a.push([r.default.Error,P.localize(11396,null,"browser")]),a;{const y=(0,n.$fh)(u,i.browser);(0,n.$_g)(y,u)||a.push([r.default.Warning,P.localize(11397,null,y.path,u.path)])}}if(!D.valid(i.version))return a.push([r.default.Error,P.localize(11398,null)]),a;const l=[];if(!g(S,t,i,o,l))for(const y of l)a.push([r.default.Error,y]);if(s&&i.enabledApiProposals?.length){const y=[];if(!b([...i.enabledApiProposals],y))for(const R of y)a.push([r.default.Error,R])}return a}function g(S,t,u,i,o){return i||typeof u.main>"u"&&typeof u.browser>"u"?!0:$(S,t,u.engines.vscode,o)}function v(S,t,u){return S==="*"||$(t,u,S)}function b(S,t){if(S.length===0)return!0;const u=Array.isArray(t)?t:void 0,i=(u?void 0:t)??I.allApiProposals,o=[],s=(0,T.$xn)(S);for(const{proposalName:a,version:l}of s){const E=i[a];E&&l&&E.version!==l&&o.push(P.localize(11399,null,a))}return u?.push(...o),o.length===0}function $(S,t,u,i=[]){const o=d(h(u));if(!o)return i.push(P.localize(11400,null,u)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return i.push(P.localize(11401,null,u)),!1}else if(!o.majorMustEqual)return i.push(P.localize(11402,null,u)),!1;return w(S,t,o)?!0:(i.push(P.localize(11403,null,S,u)),!1)}function k(S){if(!Array.isArray(S))return!1;for(let t=0,u=S.length;t<u;t++)if(typeof S[t]!="string")return!1;return!0}}),define(ce[211],le([0,1,2,6]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,r.$Ei)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(T,I){return this.a[T]??=[],this.a[T].push(I),(0,n.$Sc)(()=>{const p=this.a[T]?.indexOf(I);typeof p=="number"&&p>=0&&this.a[T]?.splice(p,1)})}b(T){return(this.a[T.type]||[]).find(p=>p.supports(T))}connect(T,I,p,c){const m=this.b(T);if(!m)throw new Error(`No socket factory found for ${T}`);return m.connect(T,I,p,c)}}e.$Wl=P}),define(ce[212],le([0,1,26,27,48,121]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=I,n=Pe(n),r=Pe(r),P=Pe(P),D=Pe(D);let T;async function I(w=!1){return(T===void 0||w)&&(T=p()),T}async function p(){const w=c();if(w===void 0)return!1;if(w>=22e3){const f=h();if(f)return new Promise(g=>{P.execFile(f,["--status"],v=>g(!v))})}else{const f=d();if(f)try{if((await n.promises.stat(f)).isFile())return!0}catch{}}return!1}function c(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(w)return parseInt(w[3])}function m(w){const f=process.env.SystemRoot;if(f){const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(f,g?"Sysnative":"System32",w)}}function h(){return m("wsl.exe")}function d(){return m("lxss\\LxssManager.dll")}}),define(ce[49],le([0,1,17,15,2,10,56,6,5,45]),function(x,e,n,r,P,D,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$9p=d,e.$0p=w,e.$$p=f,e.$_p=g,e.$aq=v,e.$bq=b,e.$7p=(0,I.$Ei)("requestService");class m{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const u in this.b)u.toLowerCase()==="authorization"||u.toLowerCase()==="proxy-authorization"?t[u]="*****":t[u]=this.b[u];this.a=t}return this.a}}class h extends P.$Uc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,D.localize)(11172,null),when:p.$rk.isEqualTo((0,p.$ok)(p.LogLevel.Trace)).serialize()})}async c(t,u,i){const o=`${t} #${++this.b}: ${u.url}`;this.a.trace(`${o} - begin`,u.type,new m(u.headers??{}));try{const s=await i();return this.a.trace(`${o} - end`,u.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,u.type,(0,r.$9)(s)),s}}}e.$8p=h;function d(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function w(S){return S.res.statusCode===204}async function f(S){return w(S)?null:(await(0,n.$Ze)(S.stream)).toString()}async function g(S){if(!d(S))throw new Error("Server returned "+S.res.statusCode);return f(S)}async function v(S){if(!d(S))throw new Error("Server returned "+S.res.statusCode);if(w(S))return null;const u=(await(0,n.$Ze)(S.stream)).toString();try{return JSON.parse(u)}catch(i){throw i.message+=`:
`+u,i}}function b(S){k(S)}let $;function k(S){const t=c.$qo.as(T.$vo.Configuration),u=$;$={id:"http",order:15,title:(0,D.localize)(11173,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(11174,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(11175,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(11176,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,D.localize)(11177,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(11178,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(11179,null),(0,D.localize)(11180,null),(0,D.localize)(11181,null),(0,D.localize)(11182,null)],default:"override",description:(0,D.localize)(11183,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11184,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(11185,null),restricted:!0}}},t.updateConfigurations({add:[$],remove:u?[u]:[]})}k(T.ConfigurationScope.APPLICATION)}),define(ce[213],le([0,1,17,22]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=void 0;class P{constructor(I){this.a=I}listen(I,p){throw new Error("Invalid listen")}call(I,p,c,m=r.CancellationToken.None){switch(p){case"request":return this.a.request(c[0],m).then(async({res:h,stream:d})=>{const w=await(0,n.$Ze)(d);return[{statusCode:h.statusCode,headers:h.headers},w]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"lookupAuthorization":return this.a.lookupAuthorization(c[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$bs=P;class D{constructor(I){this.a=I}async request(I,p){const[c,m]=await this.a.call("request",[I],p);return{res:c,stream:(0,n.$2e)(m)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async lookupAuthorization(I){return this.a.call("lookupAuthorization",[I])}async lookupKerberosAuthorization(I){return this.a.call("lookupKerberosAuthorization",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$cs=D}),define(ce[214],le([0,1,215,12]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=D;function P(T,I){return T.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:T.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function D(T,I,p={}){const c=(0,n.parse)(T),m=p.proxyUrl||P(c,I);if(!m)return null;const h=(0,n.parse)(m);if(!/^https?:$/.test(h.protocol||""))return null;const d={host:h.hostname||"",port:(h.port?+h.port:0)||(h.protocol==="https"?443:80),auth:h.auth,rejectUnauthorized:(0,r.$kg)(p.strictSSL)?p.strictSSL:!0};if(c.protocol==="http:"){const w=await new Promise((f,g)=>{x(["http-proxy-agent"],f,g)}).then(Pe);return new w.HttpProxyAgent(m,d)}else{const w=await new Promise((f,g)=>{x(["https-proxy-agent"],f,g)}).then(Pe);return new w.HttpsProxyAgent(m,d)}}}),define(ce[216],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=void 0,e.$Tgc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Ugc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Vgc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[100],le([0,1,48,9,10,22,55,15,3,33,116,68,8,144]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=g;let f;async function g(b,$,k,S){return k["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,h.$Jm)(S)&&!k["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,h.$Jm)(S)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=d.Promises.withAsyncBody(async(t,u)=>{const i=new D.$we;let o=1e4;const s=b.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,w.$Km)(s,1,120)*1e3);const a=setTimeout(()=>{i.dispose(!0),u(new Error((0,P.localize)(11169,null)))},o);try{t(await v($,i.token))}catch(l){!(0,I.$3)(l)&&!i.token.isCancellationRequested?u(new Error((0,P.localize)(11170,null,(0,T.$pj)(l)))):t({})}finally{clearTimeout(a),i.dispose()}})),f)}async function v(b,$){const k=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",k);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",S);const t=(0,c.$1g)().replace(/-/g,"").substr(0,12),u=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",i);const o=await(0,m.$zm)(p.OS,i);return b.trace("getUnixShellEnvironment#shell",o),new Promise((s,a)=>{if($.isCancellationRequested)return a(new I.$4);const l=(0,r.$nc)(o);let E,y;const R="";/^pwsh(-preview)?$/.test(l)?(E=`& '${process.execPath}' ${R} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,y=["-Login","-Command"]):l==="nu"?(E=`^'${process.execPath}' ${R} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,y=["-i","-l","-c"]):l==="xonsh"?(E=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,y=["-i","-l","-c"]):(E=`'${process.execPath}' ${R} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,l==="tcsh"||l==="csh"?y=["-ic"]:y=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),E);const L=(0,n.spawn)(o,[...y,E],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});$.onCancellationRequested(()=>(L.kill(),a(new I.$4))),L.on("error",M=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,T.$pj)(M)),a(M)});const A=[];L.stdout.on("data",M=>A.push(M));const O=[];L.stderr.on("data",M=>O.push(M)),L.on("close",(M,H)=>{const q=Buffer.concat(A).toString("utf8");b.trace("getUnixShellEnvironment#raw",q);const K=Buffer.concat(O).toString("utf8");if(K.trim()&&b.trace("getUnixShellEnvironment#stderr",K),M||H)return a(new Error((0,P.localize)(11171,null,M,H)));const de=u.exec(q),Y=de?de[1]:"{}";try{const J=JSON.parse(Y);k?J.ELECTRON_RUN_AS_NODE=k:delete J.ELECTRON_RUN_AS_NODE,S?J.ELECTRON_NO_ATTACH_CONSOLE=S:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.VSCODE_RESOLVING_ENVIRONMENT,delete J.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",J),s(J)}catch(J){b.error("getUnixShellEnvironment#errorCaught",(0,T.$pj)(J)),a(J)}})})}}),define(ce[217],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const D=await this.c();if(D){const T=String(n.a++);return this.b.set(T,D),{id:T,data:D.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,D){if(!P.id)return!0;const T=this.b.get(P.id);if(!T)return!1;this.b.delete(P.id);try{return T.validate(D)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$Ecc=n}),define(ce[101],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,n.$Ei)(e.$Xl)}),define(ce[218],le([0,1,217]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class r extends n.$Ecc{c(){return this.h().then(D=>new D.validator)}d(D){return this.h().then(T=>new T.signer().sign(D))}h(){return new Promise((D,T)=>x(["vsda"],D,T))}}e.$Lhc=r}),define(ce[34],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=e.$yR=void 0,e.$yR=(0,n.$Ei)("stateReadService"),e.$zR=(0,n.$Ei)("stateService")}),define(ce[127],le([0,1,8,17,2,12,38,14,5]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=e.$BR=e.$AR=e.SaveStrategy=void 0;var c;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class m extends P.$Uc{constructor(f,g,v,b){super(),this.h=f,this.j=g,this.m=v,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Ch(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(f)}}getItem(f,g){const v=this.a[f];return(0,D.$ng)(v)?g:v}setItem(f,g){this.setItems([{key:f,data:g}])}setItems(f){let g=!1;for(const{key:v,data:b}of f)this.a[v]!==b&&((0,D.$ng)(b)?(0,D.$lg)(this.a[v])||(this.a[v]=void 0,g=!0):(this.a[v]=b,g=!0));g&&this.s()}removeItem(f){(0,D.$lg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,r.$Ne.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(g){this.m.error(g)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$AR=m;let h=class extends P.$Uc{constructor(f,g,v,b){super(),this.a=this.B(new m(g.stateResource,f,v,b))}async init(){await this.a.init()}getItem(f,g){return this.a.getItem(f,g)}};e.$BR=h,e.$BR=h=Se([se(1,T.$Li),se(2,p.$_j),se(3,I.$_k)],h);class d extends h{setItem(f,g){this.a.setItem(f,g)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$CR=d}),define(ce[128],le([0,1,3,36,33]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=T,e.$vp=I;function D(p){if(n.$v===n.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function T(p,c,m,h,d,w,f,g,v,b){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=f,$["common.devDeviceId"]=g,$.sessionID=(0,P.$1g)()+Date.now(),$.commitHash=h,$.version=d,$["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$i)(n.$v),$["common.nodePlatform"]=r.$dc,$["common.nodeArch"]=m,$["common.product"]=b||"desktop",v&&($["common.msftInternal"]=v);let k=0;const S=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>k++,enumerable:!0}}),n.$m&&($["common.snap"]="true");const t=D(c);return t&&($["common.platformDetail"]=t),$}function I(p){const c=r.env.USERDNSDOMAIN;if(!c)return!1;const m=c.toLowerCase();return p.some(h=>m===h)}}),define(ce[24],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,n.$Ei)("telemetryService"),e.$_l=(0,n.$Ei)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var r;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var P;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(ce[219],le([0,1,26,27,8,43,11,9,3,66,7,92,23,115,96,14,28,24]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0,e.$Xs=k,e.$Ys=t,e.$Zs=u,n=Pe(n),r=Pe(r);const $=new Map;async function k(o,s){const a=`${o}::${s.join(":")}`,l=$.get(a);if(l)return l;const E=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],y=new Map,R=new Map,L=2e4;function A(M,H,q,K){const de=H.substring(M.length+1);return P.Promises.withAsyncBody(async Y=>{let J;K.readdirCount++;try{J=await d.Promises.readdir(H,{withFileTypes:!0})}catch{Y();return}if(K.count>=L){K.count+=J.length,K.maxReached=!0,Y();return}let U=J.length;if(U===0){Y();return}let Z=J;K.count+J.length>L&&(K.maxReached=!0,U=L-K.count,Z=J.slice(0,U)),K.count+=J.length;for(const W of Z)if(W.isDirectory()){if(q.includes(W.name)||await A(M,(0,I.$jc)(H,W.name),q,K),--U===0){Y();return}}else{const j=W.name.lastIndexOf(".");if(j>=0){const C=W.name.substring(j+1);C&&y.set(C,(y.get(C)??0)+1)}for(const C of E)C.relativePathPattern?.test(de)!==!1&&C.filePattern.test(W.name)&&R.set(C.tag,(R.get(C.tag)??0)+1);if(--U===0){Y();return}}})}const O=P.Promises.withAsyncBody(async M=>{const H={count:0,maxReached:!1,readdirCount:0},q=new c.$fe(!0);await A(o,o,s,H);const K=await u(o);M({configFiles:S(R),fileTypes:S(y),fileCount:H.count,maxFilesReached:H.maxReached,launchConfigFiles:K,totalScanTime:q.elapsed(),totalReaddirCount:H.readdirCount})});return $.set(a,O),O}function S(o){return Array.from(o.entries(),([s,a])=>({name:s,count:a})).sort((s,a)=>a.count-s.count)}function t(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/g.$Hl.GB).toFixed(2)}GB (${(r.freemem()/g.$Hl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$Rn.value()*100)}%`},s=r.cpus();return s&&s.length>0&&(o.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),o}async function u(o){try{const s=new Map,a=(0,I.$jc)(o,".vscode","launch.json"),l=await n.promises.readFile(a),E=[],y=(0,D.$Xn)(l.toString(),E);if(E.length)return console.log(`Unable to parse ${a}`),[];if((0,D.$6n)(y)==="object"&&y.configurations)for(const R of y.configurations){const L=R.type;L&&(s.has(L)?s.set(L,s.get(L)+1):s.set(L,1))}return S(s)}catch{return[]}}let i=class{constructor(s,a){this.c=s,this.d=a}f(s){const a=[];return a.push(`OS Version:       ${s.os}`),a.push(`CPUs:             ${s.cpus}`),a.push(`Memory (System):  ${s.memory}`),a.push(`VM:               ${s.vmHint}`),a.join(`
`)}g(s){const a=[];a.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),a.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const l=r.cpus();return l&&l.length>0&&a.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),a.push(`Memory (System):  ${(r.totalmem()/g.$Hl.GB).toFixed(2)}GB (${(r.freemem()/g.$Hl.GB).toFixed(2)}GB free)`),p.$j||a.push(`Load (avg):       ${r.loadavg().map(E=>Math.round(E)).join(", ")}`),a.push(`VM:               ${Math.round(h.$Rn.value()*100)}%`),a.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${s.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(s,a){return Promise.all([(0,w.$Ws)(s.mainPID),this.k(s)]).then(async l=>{let[E,y]=l,R=this.m(s,E);return a.forEach(L=>{if((0,f.$Tm)(L))R+=`
${L.errorMessage}`,y+=`
${L.errorMessage}`;else if(R+=`

Remote: ${L.hostName}`,L.processes&&(R+=`
${this.m(s,L.processes)}`),L.workspaceMetadata){y+=`
|  Remote: ${L.hostName}`;for(const A of Object.keys(L.workspaceMetadata)){const O=L.workspaceMetadata[A];let M=`${O.fileCount} files`;O.maxFilesReached&&(M=`more than ${M}`),y+=`|    Folder (${A}): ${M}`,y+=this.h(O)}}}),{processInfo:R,workspaceInfo:y}})}async getSystemInfo(s,a){const{memory:l,vmHint:E,os:y,cpus:R}=t(),L={os:y,memory:l,cpus:R,vmHint:E,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:a};return p.$j||(L.load=`${r.loadavg().map(A=>Math.round(A)).join(", ")}`),p.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(s,a){const l=[];return(0,w.$Ws)(s.mainPID).then(async E=>(l.push(""),l.push(this.g(s)),l.push(""),l.push(this.m(s,E)),s.windows.some(y=>y.folderURIs&&y.folderURIs.length>0&&!y.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.k(s))),a.forEach(y=>{if((0,f.$Tm)(y))l.push(`
${y.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${y.hostName}`),l.push(this.f(y.machineInfo)),y.processes&&l.push(this.m(s,y.processes)),y.workspaceMetadata)for(const R of Object.keys(y.workspaceMetadata)){const L=y.workspaceMetadata[R];let A=`${L.fileCount} files`;L.maxFilesReached&&(A=`more than ${A}`),l.push(`Folder (${R}): ${A}`),l.push(this.h(L))}}),l.push(""),l.push(""),l.join(`
`)))}h(s){const a=[];let E=0;const y=(O,M)=>{const H=` ${O}(${M})`;E+H.length>60?(a.push(R),R="|                 ",E=R.length):E+=H.length,R+=H};let R="|      File types:";const L=10,A=s.fileTypes.length>L?L:s.fileTypes.length;for(let O=0;O<A;O++){const M=s.fileTypes[O];y(M.name,M.count)}if(a.push(R),s.configFiles.length>=0&&(R="|      Conf files:",E=0,s.configFiles.forEach(O=>{y(O.name,O.count)}),a.push(R)),s.launchConfigFiles.length>0){let O="|      Launch Configs:";s.launchConfigFiles.forEach(M=>{const H=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`;O+=H}),a.push(O)}return a.join(`
`)}j(s){const a=Math.max(...Object.keys(s).map(l=>l.length));return Object.keys(s).map(l=>`${l}:  ${" ".repeat(a-l.length)}  ${s[l]}`).join(`
                  `)}k(s){const a=[],l=[];return s.windows.forEach(E=>{E.folderURIs.length===0||E.remoteAuthority||(a.push(`|  Window (${E.title})`),E.folderURIs.forEach(y=>{const R=m.URI.revive(y);if(R.scheme===T.Schemas.file){const L=R.fsPath;l.push(k(L,["node_modules",".git"]).then(A=>{let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),a.push(`|    Folder (${(0,I.$nc)(L)}): ${O}`),a.push(this.h(A))}).catch(A=>{a.push(`|      Error: Unable to collect workspace stats for folder ${L} (${A.toString()})`)}))}else a.push(`|    Folder (${R.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(E=>a.join(`
`)).catch(E=>`Unable to collect workspace stats: ${E}`)}m(s,a){const l=new Map;s.windows.forEach(y=>l.set(y.pid,`window [${y.id}] (${y.title})`)),s.pidToNames.forEach(({pid:y,name:R})=>l.set(y,R));const E=[];return E.push("CPU %	Mem MB	   PID	Process"),a&&this.n(s.mainPID,l,E,a,0),E.join(`
`)}n(s,a,l,E,y){const R=y===0;let L;R?L=E.pid===s?`${this.d.applicationName} main`:"remote agent":a.has(E.pid)?L=a.get(E.pid):L=`${"  ".repeat(y)} ${E.name}`;const A=process.platform==="win32"?E.mem:r.totalmem()*(E.mem/100);l.push(`${E.load.toFixed(0).padStart(5," ")}	${(A/g.$Hl.MB).toFixed(0).padStart(6," ")}	${E.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(E.children)&&E.children.forEach(O=>this.n(s,a,l,O,y+1))}async getWorkspaceFileExtensions(s){const a=new Set;for(const{uri:l}of s.folders){const E=m.URI.revive(l);if(E.scheme!==T.Schemas.file)continue;const y=E.fsPath;try{(await k(y,["node_modules",".git"])).fileTypes.forEach(L=>a.add(L.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(s){for(const{uri:a}of s.folders){const l=m.URI.revive(a);if(l.scheme!==T.Schemas.file)continue;const E=l.fsPath;try{const y=await k(E,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),y.fileTypes.forEach(R=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:R.name,count:R.count})}),y.launchConfigFiles.forEach(R=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:R.name,count:R.count})}),y.configFiles.forEach(R=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:R.name,count:R.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:y.totalScanTime,reachedLimit:y.maxFilesReached,fileCount:y.fileCount,readdirCount:y.totalReaddirCount})}catch{}}}};e.$1s=i,e.$1s=i=Se([se(0,b.$$l),se(1,v.$sk)],i)}),define(ce[220],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0;class n{constructor(D){this.b=D}listen(D,T){throw new Error(`Event not found: ${T}`)}call(D,T,{eventName:I,data:p}){return this.b.forEach(c=>c.log(I,p)),Promise.resolve(null)}}e.$Ygc=n;class r{constructor(D){this.b=D}log(D,T){return this.b.call("log",{eventName:D,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Zgc=r}),define(ce[57],le([0,1,37,12,74,128,24]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$Dp=m,e.$Ep=h,e.$Fp=d,e.$Gp=w,e.$Hp=g,e.$Ip=b,e.$Jp=$,e.$Kp=t;class I{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$wp=I;class p{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xp=p,e.$yp=new p;class c{async publicLog(i,o,s){}async publicLogError(i,o,s){}}e.$zp=c,e.$Ap="telemetry",e.$Bp="extensionTelemetryLog",e.$Cp={log:()=>null,flush:()=>Promise.resolve(null)};function m(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry)}function h(u,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}function d(u){const i=u.getValue(T.$hm),o=u.getValue(T.$im);if(u.getValue(T.$jm)===!1||o===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function w(u){const i={},o={},s={};v(u,s);for(let a in s){a=a.length>150?a.substr(a.length-149):a;const l=s[a];typeof l=="number"?o[a]=l:typeof l=="boolean"?o[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),i[a]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(i[a]=l)}return{properties:i,measurements:o}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(u){if(!u)return"none";const i=(0,P.$hn)(u);return f.has(i)?i:"other"}function v(u,i,o=0,s){if(u)for(const a of Object.getOwnPropertyNames(u)){const l=u[a],E=s?s+a:a;Array.isArray(l)?i[E]=(0,n.$io)(l):l instanceof Date?i[E]=l.toISOString():(0,r.$gg)(l)?o<2?v(l,i,o+1,E+"."):i[E]=(0,n.$io)(l):i[E]=l}}function b(u,i){const o=u.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,D.$vp)(o)||s}function $(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}function k(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let o=u;const s=[];for(const y of i)for(;;){const R=y.exec(u);if(!R)break;s.push([R.index,y.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(o="";;){const y=l.exec(u);if(!y)break;const R=s.some(([L,A])=>y.index<A&&L<l.lastIndex);!a.test(y[0])&&!R&&(o+=u.substring(E,y.index)+"<REDACTED: user-file-path>",E=l.lastIndex)}return E<u.length&&(o+=u.substr(E)),o}function S(u){if(!u)return u;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of i)if(o.regex.test(u))return`<REDACTED: ${o.label}>`;return u}function t(u,i){return(0,n.$fo)(u,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let s=o.replaceAll("%20"," ");s=k(s,i);for(const a of i)s=s.replace(a,"");return s=S(s),s}})}}),define(ce[129],le([0,1,25,126,85,3,7,15,36,57]),function(x,e,n,r,P,D,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Mp=void 0,e.$Lp=m,e.$Np=f,e.$Op=g,e.$Pp=v,e.$Qp=b,e.$Rp=$,e.$Sp=k,e.$Tp=S,e.$Vp=t,e.$Wp=i;function m(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,n.$Af)(o.id,s.id)===0}const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(s){const a=s.manifest?s.manifest.version:s.version,l=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new d(s.identifier,a,l)}static parse(s){const a=h.exec(s);return a&&a[1]&&a[2]?new d({id:a[1]},a[2],a[4]||void 0):null}constructor(s,a,l=P.TargetPlatform.UNDEFINED){this.identifier=s,this.version=a,this.targetPlatform=l,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof d?m(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Mp=d;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const s=w.exec(o);return s&&s[1]?[v(s[1]),s[2]]:[v(o),void 0]}function g(o,s){return`${o}.${s}`}function v(o){return o.toLowerCase()}function b(o,s){return v(g(o??P.$mn,s))}function $(o,s){const a=[],l=E=>{for(const y of a)if(y.some(R=>m(s(R),s(E))))return y;return null};for(const E of o){const y=l(E);y?y.push(E):a.push([E])}return a}function k(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function S(o){return{id:new c.$wp(o.identifier.id),name:new c.$wp(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Up=new P.$qn("pprice.better-merge");function t(o,s){const a=[],l=s.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const E=l.shift();if(E&&a.every(y=>!m(y.identifier,{id:E}))){const y=o.filter(R=>m(R.identifier,{id:E}));y.length===1&&(a.push(y[0]),l.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function u(o,s){if(!D.$l)return!1;let a;try{a=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){s.debug("Error while getting the os-release file.",(0,I.$9)(E))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(o,s){const a=await u(o,s),l=(0,r.$gp)(a?"alpine":D.$v,p.$ec);return s.debug("ComputeTargetPlatform:",l),l}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[221],le([0,1,2,37,3,25,10,16,56,72,28,45,24,57]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0,c=Ve(c);let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,$,k){this.k=$,this.l=k,this.d={},this.i=new n.$Tc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=d.TelemetryLevel.USAGE,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,D.$hf)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$hf)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(d.$hm)||S.affectsConfiguration(d.$jm)||S.affectsConfiguration(d.$im))&&this.m()}))}setExperimentProperty(b,$){this.d[b]=$}m(){let b=(0,w.$Fp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const k=$.usage?d.TelemetryLevel.USAGE:$.error?d.TelemetryLevel.ERROR:d.TelemetryLevel.NONE;b=Math.min(b,k)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,$,k){this.g<$||(k=(0,r.$go)(k,this.d),k=(0,w.$Kp)(k,this.j),k=(0,r.$go)(k,this.c),this.b.forEach(S=>S.log(b,k)))}publicLog(b,$){this.n(b,d.TelemetryLevel.USAGE,$)}publicLog2(b,$){this.publicLog(b,$)}publicLogError(b,$){this.h&&this.n(b,d.TelemetryLevel.ERROR,$)}publicLogError2(b,$){this.publicLogError(b,$)}};e.$gs=f,e.$gs=f=Se([se(1,I.$$i),se(2,m.$sk)],f);function g(){const v=(0,T.localize)(11150,null,c.default.nameLong),b=c.default.privacyStatementUrl?(0,T.localize)(11152,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,T.localize)(11151,null,"https://aka.ms/vscode-telemetry"),$=P.$p?"":(0,T.localize)(11153,null),k=(0,T.localize)(11154,null),S=(0,T.localize)(11155,null),t=(0,T.localize)(11156,null),u=(0,T.localize)(11157,null),i=`
|       | ${k} | ${S} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,T.localize)(11158,null);return`
${v} ${b} ${$}

&nbsp;

${u}
${i}

&nbsp;

${o}
`}h.$qo.as(p.$vo.Configuration).registerConfiguration({id:d.$gm,order:1,type:"object",title:(0,T.localize)(11159,null),properties:{[d.$hm]:{type:"string",enum:[d.TelemetryConfiguration.ON,d.TelemetryConfiguration.ERROR,d.TelemetryConfiguration.CRASH,d.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(11160,null),(0,T.localize)(11161,null),(0,T.localize)(11162,null),(0,T.localize)(11163,null)],markdownDescription:g(),default:d.TelemetryConfiguration.ON,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),h.$qo.as(p.$vo.Configuration).registerConfiguration({id:d.$gm,order:110,type:"object",title:(0,T.localize)(11164,null),properties:{[d.$jm]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,T.localize)(11166,null,c.default.nameLong,c.default.privacyStatementUrl):(0,T.localize)(11165,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(11167,null,`\`#${d.$hm}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[222],le([0,1,3,92,24]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=D,e.$phc=T,e.$qhc=I;async function D(p,c){let m=p.getItem(P.$dm);return(typeof m!="string"||n.$k&&m==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(m=await(0,r.$Sn)(c.error.bind(c))),m}async function T(p,c){let m=p.getItem(P.$em);return typeof m!="string"&&(m=await(0,r.$Tn)(c.error.bind(c))),m}async function I(p,c){let m=p.getItem(P.$fm);return typeof m!="string"&&(m=await(0,r.$Un)(c.error.bind(c))),m}}),define(ce[223],le([0,1,24,222]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=P,e.$shc=D,e.$thc=T;async function P(I,p){const c=await(0,r.$ohc)(I,p);return I.setItem(n.$dm,c),c}async function D(I,p){const c=await(0,r.$phc)(I,p);return I.setItem(n.$em,c),c}async function T(I,p){const c=await(0,r.$qhc)(I,p);return I.setItem(n.$fm,c),c}}),define(ce[130],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ce[224],le([0,1,3,130]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0;const P=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((h,d)=>{this.d(h,d);const w=h.map.entries();let f=w.next();for(;!f.done;){const g=f.value[1],v=f.value[0];let b=this.a.get(v);if(b||(b=[],this.a.set(v,b)),b.length>0&&b[0].type===r.EnvironmentVariableMutatorType.Replace){f=w.next();continue}const $={extensionIdentifier:d,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};$.scope||delete $.scope,b.unshift($),f=w.next()}})}async applyToProcessEnvironment(m,h,d){let w;n.$j&&(w={},Object.keys(m).forEach(f=>w[f.toLowerCase()]=f));for(const[f,g]of this.getVariableMap(h)){const v=n.$j&&w[f.toLowerCase()]||f;for(const b of g){const $=d?await d(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case r.EnvironmentVariableMutatorType.Append:m[v]=(m[v]||"")+$;break;case r.EnvironmentVariableMutatorType.Prepend:m[v]=$+(m[v]||"");break;case r.EnvironmentVariableMutatorType.Replace:m[v]=$;break}if(b.options?.applyAtShellIntegration??!1){const k=`VSCODE_ENV_${P.get(b.type)}`;m[k]=(m[k]?m[k]+":":"")+f+"="+this.c($)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,h){const d=new Map,w=new Map,f=new Map;if(m.getVariableMap(h).forEach((g,v)=>{const b=this.getVariableMap(h).get(v),$=I(g,b);$&&d.set(v,$)}),this.getVariableMap(h).forEach((g,v)=>{const b=m.getVariableMap(h).get(v),$=I(g,b);$&&f.set(v,$)}),this.getVariableMap(h).forEach((g,v)=>{const b=m.getVariableMap(h).get(v),$=p(g,b);$&&w.set(v,$)}),!(d.size===0&&w.size===0&&f.size===0))return{added:d,changed:w,removed:f}}getVariableMap(m){const h=new Map;for(const d of this.a.values()){const w=d.filter(f=>T(f,m));w.length>0&&h.set(w[0].variable,w)}return h}getDescriptionMap(m){const h=new Map;for(const d of this.b.values()){const w=d.filter(f=>T(f,m,!0));for(const f of w)h.set(f.extensionIdentifier,f.description)}return h}d(m,h){if(!m.descriptionMap)return;const d=m.descriptionMap.entries();let w=d.next();for(;!w.done;){const f=w.value[1],g=w.value[0];let v=this.b.get(g);v||(v=[],this.b.set(g,v));const b={extensionIdentifier:h,scope:f.scope,description:f.description};b.scope||delete b.scope,v.push(b),w=d.next()}}}e.$Ks=D;function T(c,m,h=!1){return c.scope?!!(c.scope.workspaceFolder&&m?.workspaceFolder&&c.scope.workspaceFolder.index===m.workspaceFolder.index):h?m===c.scope:!0}function I(c,m){if(!m)return c;const h=new Set;m.forEach(w=>h.add(w.extensionIdentifier));const d=[];return c.forEach(w=>{h.has(w.extensionIdentifier)||d.push(w)}),d.length===0?void 0:d}function p(c,m){if(!m)return;const h=new Map;m.forEach(w=>h.set(w.extensionIdentifier,w));const d=[];return c.forEach(w=>{const f=h.get(w.extensionIdentifier);f&&(w.type!==f.type||w.value!==f.value||w.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&d.push(f)}),d.length===0?void 0:d}}),define(ce[225],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=n,e.$Fs=r,e.$Gs=P,e.$Hs=D,e.$Is=T,e.$Js=I;function n(p){return[...p.entries()]}function r(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function D(p){return new Map(p??[])}function T(p){return Array.from(p.entries()).map(c=>[c[0],n(c[1].map),r(c[1].descriptionMap)])}function I(p){return new Map(p.map(c=>[c[0],{map:P(c[1]),descriptionMap:D(c[2])}]))}}),define(ce[226],le([0,1,8,22,4,2,5]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;let I=class extends D.$Uc{constructor(c,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$le),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,D.$Sc)(()=>{for(const h of this.f.values())(0,D.$Pc)(h)}))}createRequest(c){return new Promise((m,h)=>{const d=++this.a;this.c.set(d,m),this.g.fire({requestId:d,...c});const w=new r.$we;(0,n.$Fh)(this.b,w.token).then(()=>h(`Request ${d} timed out (${this.b}ms)`)),this.f.set(d,[(0,D.$Sc)(()=>w.cancel())])})}acceptReply(c,m){const h=this.c.get(c);h?(this.c.delete(c),(0,D.$Pc)(this.f.get(c)||[]),this.f.delete(c),h(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$vs=I,e.$vs=I=Se([se(1,T.$_j)],I)}),define(ce[75],le([0,1,6,122,45]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$os=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ns=void 0,e.$ns=new r.$Vj("terminalTabFocusMode",!1,!0);var D;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var I;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(I||(e.PosixShellType=I={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var m;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var h;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(h||(e.ProcessPropertyType=h={})),e.$os=(0,n.$Ei)("ptyService");var d;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d||(e.HeartbeatConstants=d={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var f;(function(t){t.TerminalView="view",t.Editor="editor"})(f||(e.TerminalLocationString=f={}));var g;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var v;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(v||(e.FlowControlConstants=v={}));var b;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(b||(e.ProfileSource=b={}));var $;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})($||(e.ShellIntegrationStatus=$={}));var k;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(k||(e.TerminalExitReason=k={})),e.$ps={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(u){const i=this.b(u.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,u)}getTerminalBackend(u){return this.a.get(this.b(u))}b(u){return u?.toLowerCase()??""}}P.$qo.add(e.$ps.Backend,new S),e.$qs=(0,n.$Ei)("localPtyService"),e.$rs=(0,n.$Ei)("terminalLogService")}),define(ce[227],le([0,1,80,7,10,110]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=T,e.$xs=c,e.$ys=m,e.$zs=h;function T(d,w){const f=[{name:null,description:(0,P.localize)(11117,null)}];return f.push(...d.map(g=>({name:g.profileName,description:I(g)}))),w&&f.push(...w.map(g=>({name:g.title,description:p(g)}))),{values:f.map(g=>g.name),markdownDescriptions:f.map(g=>g.description)}}function I(d){let w=`$(${D.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:n.$4j.terminal.id}) ${d.profileName}
- path: ${d.path}`;return d.args&&(typeof d.args=="string"?w+=`
- args: "${d.args}"`:w+=`
- args: [${d.args.length===0?"":`'${d.args.join("','")}'`}]`),d.overrideName!==void 0&&(w+=`
- overrideName: ${d.overrideName}`),d.color&&(w+=`
- color: ${d.color}`),d.env&&(w+=`
- env: ${JSON.stringify(d.env)}`),w}function p(d){return`$(${D.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:n.$4j.terminal.id}) ${d.title}
- extensionIdentifier: ${d.extensionIdentifier}`}function c(d,w){if(!d&&!w)return!0;if(typeof d=="string"&&typeof w=="string")return d===w;if(Array.isArray(d)&&Array.isArray(w)){if(d.length!==w.length)return!1;for(let f=0;f<d.length;f++)if(d[f]!==w[f])return!1;return!0}return!1}function m(d,w){if(!d&&!w)return!0;if(!d||!w)return!1;if(D.ThemeIcon.isThemeIcon(d)&&D.ThemeIcon.isThemeIcon(w))return d.id===w.id&&d.color===w.color;if(typeof d=="object"&&"light"in d&&"dark"in d&&typeof w=="object"&&"light"in w&&"dark"in w){const f=d,g=w;if((r.URI.isUri(f.light)||h(f.light))&&(r.URI.isUri(f.dark)||h(f.dark))&&(r.URI.isUri(g.light)||h(g.light))&&(r.URI.isUri(g.dark)||h(g.dark)))return f.light.path===g.light.path&&f.dark.path===g.dark.path}if(r.URI.isUri(d)&&r.URI.isUri(w)||h(d)||h(w)){const f=d,g=w;return f.path===g.path&&f.scheme===g.scheme}return!1}function h(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}}),define(ce[228],le([0,1,80,3,10,56,45,75,227]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=e.$As=void 0,e.$Cs=f,e.$Ds=v,e.$As={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Bs={type:"string",enum:Array.from((0,n.$2j)(),b=>b.id),markdownEnumDescriptions:Array.from((0,n.$2j)(),b=>`$(${b.id})`)};const c={args:{description:(0,P.localize)(11118,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(11119,null),type:"boolean"},icon:{description:(0,P.localize)(11120,null),...e.$Bs},color:{description:(0,P.localize)(11121,null),...e.$As},env:{markdownDescription:(0,P.localize)(11122,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(11123,null),type:["string","array"],items:{type:"string"}},...c}},h={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(11124,null),type:["string"],items:{type:"string"}},...c}};function d(b){const $=b===r.Platform.Linux?"linux":b===r.Platform.Mac?"osx":"windows";return(0,P.localize)(11125,null,(0,r.$i)(b),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,P.localize)(11126,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(11127,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(11128,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(11129,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:d(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(11130,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(11131,null),type:"string"},id:{description:(0,P.localize)(11132,null),type:"string"},title:{description:(0,P.localize)(11133,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:d(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(11134,null),type:"string"},id:{description:(0,P.localize)(11135,null),type:"string"},title:{description:(0,P.localize)(11136,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:d(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(11137,null),type:"string"},id:{description:(0,P.localize)(11138,null),type:"string"},title:{description:(0,P.localize)(11139,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,P.localize)(11140,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,P.localize)(11141,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,P.localize)(11142,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,P.localize)(11143,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,P.localize)(11144,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){T.$qo.as(D.$vo.Configuration).registerConfiguration(w),v()}let g;function v(b,$){const k=T.$qo.as(D.$vo.Configuration);let S;b&&(S=(0,p.$ws)(b?.profiles,$));const t=g;g={id:"terminal",order:100,title:(0,P.localize)(11145,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(11146,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Linux?S?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Linux?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(11147,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Macintosh?S?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Macintosh?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(11148,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Windows?S?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Windows?S?.markdownDescriptions:void 0}}},k.updateConfigurations({add:[g],remove:t?[t]:[]})}}),define(ce[229],le([0,1,27,11,37,9,3,36,25,12,23,130,225,224]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=f,e.$Ms=g,e.$Ns=v,n=Pe(n),D=Pe(D),I=Pe(I),m=Pe(m);function f(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let E=0;return l&&l.length===4&&(E=parseInt(l[3])),E}async function g(l,E,y,R=I.env,L=m.Promises.exists){if(D.$ic(l))return await L(l)?l:void 0;if(E===void 0&&(E=I.cwd()),D.$mc(l)!=="."){const H=D.$jc(E,l);return await L(H)?H:void 0}const O=(0,P.$ko)(R,"PATH");if(y===void 0&&(0,c.$eg)(O)&&(y=O.split(D.$tc)),y===void 0||y.length===0){const H=D.$jc(E,l);return await L(H)?H:void 0}for(const H of y){let q;if(D.$ic(H)?q=D.$jc(H,l):q=D.$jc(E,H,l),await L(q))return q;if(T.$j){let K=q+".com";if(await L(K)||(K=q+".exe",await L(K)))return K}}const M=D.$jc(E,l);return await L(M)?M:void 0}function v(l,E,y,R,L){const A=T.$j&&(!E.windowsEnableConpty||f()<18309);if(!E.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||A)return;const O=l.args,M=I.$dc==="win32"?D.$nc(l.executable).toLowerCase():D.$nc(l.executable),H=D.$mc(r.$Yg.asFileUri("").fsPath);let q;const K={VSCODE_INJECTION:"1"};if(E.shellIntegration.nonce&&(K.VSCODE_NONCE=E.shellIntegration.nonce),T.$j){if(M==="pwsh.exe"||M==="powershell.exe")return!O||s(O)?q=k.get($.WindowsPwsh):o(O)&&(q=k.get($.WindowsPwshLogin)),q?(q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],H,""),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",E.shellIntegration.suggestEnabled&&(K.VSCODE_SUGGEST="1"),{newArgs:q,envMixin:K}):void 0;if(M==="bash.exe")return!O||O.length===0?q=k.get($.Bash):a(O)&&(K.VSCODE_SHELL_LOGIN="1",b(E,K),q=k.get($.Bash)),q?(q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],H),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:K}):void 0;R.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(M){case"bash":return!O||O.length===0?q=k.get($.Bash):a(O)&&(K.VSCODE_SHELL_LOGIN="1",b(E,K),q=k.get($.Bash)),q?(q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],H),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:K}):void 0;case"fish":{const de=y?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Y=D.$jc(H,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return K.XDG_DATA_DIRS=`${de}:${Y}`,b(E,K),{newArgs:void 0,envMixin:K}}case"pwsh":return!O||s(O)?q=k.get($.Pwsh):o(O)&&(q=k.get($.PwshLogin)),q?(E.shellIntegration.suggestEnabled&&(K.VSCODE_SUGGEST="1"),q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],H,""),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:K}):void 0;case"zsh":{if(!O||O.length===0?q=k.get($.Zsh):a(O)?(q=k.get($.ZshLogin),b(E,K)):(O===k.get($.Zsh)||O===k.get($.ZshLogin))&&(q=O),!q)return;q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],H);let de;try{de=n.userInfo().username}catch{de="unknown"}const Y=D.$jc(n.tmpdir(),`${de}-${L.applicationName}-zsh`);K.ZDOTDIR=Y;const J=y?.ZDOTDIR??n.homedir()??"~";K.USER_ZDOTDIR=J;const U=[];return U.push({source:D.$jc(H,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$jc(Y,".zshrc")}),U.push({source:D.$jc(H,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$jc(Y,".zprofile")}),U.push({source:D.$jc(H,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$jc(Y,".zshenv")}),U.push({source:D.$jc(H,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$jc(Y,".zlogin")}),{newArgs:q,envMixin:K,filesToCopy:U}}}R.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function b(l,E){if(T.$k&&l.environmentVariableCollections){const y=(0,d.$Js)(l.environmentVariableCollections),L=new w.$Ks(y).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),A=[];if(L)for(const O of L)O.type===h.EnvironmentVariableMutatorType.Prepend&&A.push(O.value);A.length>0&&(E.VSCODE_PATH_PREFIX=A.join(""))}}var $;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})($||($={}));const k=new Map;k.set($.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),k.set($.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),k.set($.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),k.set($.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),k.set($.Zsh,["-i"]),k.set($.ZshLogin,["-il"]),k.set($.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],t=["--login","-l"],u=["-i","--interactive"],i=["-nol","-nologo"];function o(l){return typeof l=="string"?S.includes(l.toLowerCase()):l.length===1&&S.includes(l[0].toLowerCase())||l.length===2&&(S.includes(l[0].toLowerCase())||S.includes(l[1].toLowerCase()))&&(i.includes(l[0].toLowerCase())||i.includes(l[1].toLowerCase()))}function s(l){return typeof l=="string"?i.includes(l.toLowerCase()):l.length===0||l?.length===1&&i.includes(l[0].toLowerCase())}function a(l){return typeof l!="string"&&(l=l.filter(E=>!u.includes(E.toLowerCase()))),l==="string"&&t.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&t.includes(l[0].toLowerCase())}}),define(ce[230],le([0,1,26,48,80,9,3,12,23,114,75,229,121]),function(x,e,n,r,P,D,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=v,n=Pe(n),r=Pe(r),p=Pe(p);var w;(function(y){y.UnixShellsPath="/etc/shells"})(w||(w={}));let f,g=!0;function v(y,R,L,A,O=process.env,M,H,q,K){return M=M||{existsFile:p.SymlinkSupport.existsFile,readFile:n.promises.readFile},T.$j?b(L,M,O,H,A.getValue(m.TerminalSettingId.UseWslProfiles)!==!1,y&&typeof y=="object"?{...y}:A.getValue(m.TerminalSettingId.ProfilesWindows),typeof R=="string"?R:A.getValue(m.TerminalSettingId.DefaultProfileWindows),K,q):a(M,H,L,y&&typeof y=="object"?{...y}:A.getValue(T.$l?m.TerminalSettingId.ProfilesLinux:m.TerminalSettingId.ProfilesMacOs),typeof R=="string"?R:A.getValue(T.$l?m.TerminalSettingId.DefaultProfileLinux:m.TerminalSettingId.DefaultProfileMacOs),K,q,O)}async function b(y,R,L,A,O,M,H,q,K){const de=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=`${process.env.windir}\\${de?"Sysnative":"System32"}`;let J=!1;(0,h.$Ls)()>=16299&&(J=!0),await t(q);const U=new Map;if(y){U.set("PowerShell",{source:m.ProfileSource.Pwsh,icon:P.$4j.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${Y}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:P.$4j.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:m.ProfileSource.GitBash,isAutoDetected:!0}),U.set("Command Prompt",{path:`${Y}\\cmd.exe`,icon:P.$4j.terminalCmd,isAutoDetected:!0}),U.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),U.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:P.$4j.terminalBash,isAutoDetected:!0});const W=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;U.set("Cmder",{path:`${Y}\\cmd.exe`,args:["/K",W],requiresPath:process.env.CMDER_ROOT?W:{path:W,isUnsafe:!0},isAutoDetected:!0})}l(M,U);const Z=await $(U.entries(),H,R,L,A,K);if(y&&O)try{const W=await o(`${Y}\\${J?"wsl":"bash"}.exe`,H);for(const j of W)(!M||!(j.profileName in M))&&Z.push(j)}catch{g&&(A?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return Z}async function $(y,R,L,A=process.env,O,M){const H=[];for(const[q,K]of y)H.push(k(q,K,R,L,A,O,M));return(await Promise.all(H)).filter(q=>!!q)}async function k(y,R,L,A,O=process.env,M,H){if(R===null)return;let q,K,de;if("source"in R&&!("path"in R)){const Z=f?.get(R.source);if(!Z)return;q=Z.paths,K=R.args||Z.args,R.icon?de=S(R.icon):Z.icon&&(de=Z.icon)}else q=Array.isArray(R.path)?R.path:[R.path],K=T.$j||Array.isArray(R.args)?R.args:void 0,de=S(R.icon);let Y;if(H){const Z=q.map(j=>typeof j=="string"?j:j.path),W=await H(Z);Y=new Array(q.length);for(let j=0;j<q.length;j++)typeof q[j]=="string"?Y[j]=W[j]:Y[j]={path:W[j],isUnsafe:!0}}else Y=q.slice();let J;if(R.requiresPath){let Z;if((0,I.$eg)(R.requiresPath)?Z=R.requiresPath:(Z=R.requiresPath.path,R.requiresPath.isUnsafe&&(J=Z)),!await A.existsFile(Z))return}const U=await E(y,L,Y,A,O,K,R.env,R.overrideName,R.isAutoDetected,J);if(!U){M?.debug("Terminal profile not validated",y,q);return}return U.isAutoDetected=R.isAutoDetected,U.icon=de,U.color=R.color,U}function S(y){return typeof y=="string"?{id:y}:y}async function t(y){if(f&&!y)return;const[R,L]=await Promise.all([u(),y||i()]);f=new Map,f.set(m.ProfileSource.GitBash,{profileName:"Git Bash",paths:R,args:["--login","-i"]}),f.set(m.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:P.$4j.terminalPowershell})}async function u(){const y=new Set,R=await(0,h.$Ms)("git.exe");if(R){const O=(0,d.dirname)(R);y.add((0,d.resolve)(O,"../.."))}function L(O,M){M&&O.add(M)}L(y,process.env.ProgramW6432),L(y,process.env.ProgramFiles),L(y,process.env["ProgramFiles(X86)"]),L(y,`${process.env.LocalAppData}\\Program`);const A=[];for(const O of y)A.push(`${O}\\Git\\bin\\bash.exe`,`${O}\\Git\\usr\\bin\\bash.exe`,`${O}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function i(){const y=[];for await(const R of(0,c.$vm)())y.push(R.exePath);return y}async function o(y,R){const L=[],A=await new Promise((H,q)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(K,de)=>{if(K)return q("Problem occurred when getting wsl distros");H(de)})});if(!A)return[];const O=new RegExp(/[\r?\n]/),M=A.split(O).filter(H=>H.trim().length>0&&H!=="");for(const H of M){if(H===""||H.startsWith("docker-desktop"))continue;const q=`${H} (WSL)`,K={profileName:q,path:y,args:["-d",`${H}`],isDefault:q===R,icon:s(H),isAutoDetected:!1};L.push(K)}return L}function s(y){return y.includes("Ubuntu")?P.$4j.terminalUbuntu:y.includes("Debian")?P.$4j.terminalDebian:P.$4j.terminalLinux}async function a(y,R,L,A,O,M,H,q){const K=new Map;if(L&&await y.existsFile(w.UnixShellsPath)){const de=(await y.readFile(w.UnixShellsPath)).toString(),Y=(M||de.split(`
`)).map(U=>{const Z=U.indexOf("#");return Z===-1?U:U.substring(0,Z)}).filter(U=>U.trim().length>0),J=new Map;for(const U of Y){let Z=(0,D.$nc)(U),W=J.get(Z)||0;W++,W>1&&(Z=`${Z} (${W})`),J.set(Z,W),K.set(Z,{path:U,isAutoDetected:!0})}}return l(A,K),await $(K.entries(),O,y,q,R,H)}function l(y,R){if(y)for(const[L,A]of Object.entries(y))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?R.delete(L):(A.icon=A.icon||R.get(L)?.icon,R.set(L,A))}async function E(y,R,L,A,O,M,H,q,K,de){if(L.length===0)return Promise.resolve(void 0);const Y=L.shift();if(Y==="")return E(y,R,L,A,O,M,H,q,K);const J=typeof Y!="string"&&Y.isUnsafe,U=typeof Y=="string"?Y:Y.path,Z={profileName:y,path:U,args:M,env:H,overrideName:q,isAutoDetected:K,isDefault:y===R,isUnsafePath:J,requiresUnsafePath:de};if((0,D.$nc)(U)===U){const j=O.PATH?O.PATH.split(D.$tc):void 0,C=await(0,h.$Ms)(U,void 0,j,void 0,A.existsFile);return C?(Z.path=C,Z.isFromPath=!0,Z):E(y,R,L,A,O,M)}return await A.existsFile((0,D.$hc)(U))?Z:E(y,R,L,A,O,M,H,q,K)}}),define(ce[231],le([0,1,4,2,3,44,16,5,193,100,226,75,228,230,116,66]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0;var v;(function($){$[$.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let b=class extends r.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(k,S,t,u){super(),this.M=k,this.N=S,this.O=t,this.P=u,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$le),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$le),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$le),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$le),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$le),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$le),this.onProcessData=this.D.event,this.F=this.B(new n.$le),this.onProcessReady=this.F.event,this.G=this.B(new n.$le),this.onProcessReplay=this.G.event,this.H=this.B(new n.$le),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$le),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$le),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$le),this.onProcessExit=this.L.event,(0,d.$Cs)(),this.B(this.M),this.B((0,r.$Sc)(()=>this.W())),this.j=this.B(new m.$vs(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(h.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$j)return process.env;try{return await(0,c.$Qm)(this.N,this.O,{_:[]},process.env)}catch(k){return this.O.error("ptyHost was unable to resolve shell environment",k),{}}}U(){const k=this.M.start(),S=k.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(S.getChannel(h.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(k.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=v.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const u=D.ProxyChannel.toService(S.getChannel(h.TerminalIpcChannels.PtyHost));return this.B(u.onProcessData(i=>this.D.fire(i))),this.B(u.onProcessReady(i=>this.F.fire(i))),this.B(u.onProcessExit(i=>this.L.fire(i))),this.B(u.onDidChangeProperty(i=>this.J.fire(i))),this.B(u.onProcessReplay(i=>this.G.fire(i))),this.B(u.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(u.onDidRequestDetach(i=>this.I.fire(i))),this.B(new p.$us(this.P,S.getChannel(h.TerminalIpcChannels.Logger))),this.a=k,this.b=u,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(h.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[k,u]}async createProcess(k,S,t,u,i,o,s,a,l,E,y){const R=setTimeout(()=>this.$(),h.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(k,S,t,u,i,o,s,a,l,E,y);return clearTimeout(R),L}updateTitle(k,S,t){return this.f.updateTitle(k,S,t)}updateIcon(k,S,t,u){return this.f.updateIcon(k,S,t,u)}attachToProcess(k){return this.f.attachToProcess(k)}detachFromProcess(k,S){return this.f.detachFromProcess(k,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(k){return this.f.start(k)}shutdown(k,S){return this.f.shutdown(k,S)}input(k,S){return this.f.input(k,S)}processBinary(k,S){return this.f.processBinary(k,S)}resize(k,S,t){return this.f.resize(k,S,t)}clearBuffer(k){return this.f.clearBuffer(k)}acknowledgeDataEvent(k,S){return this.f.acknowledgeDataEvent(k,S)}setUnicodeVersion(k,S){return this.f.setUnicodeVersion(k,S)}getInitialCwd(k){return this.f.getInitialCwd(k)}getCwd(k){return this.f.getCwd(k)}async getLatency(){const k=new g.$fe,S=await this.f.getLatency();return k.stop(),[{label:"ptyhostservice<->ptyhost",latency:k.elapsed()},...S]}orphanQuestionReply(k){return this.f.orphanQuestionReply(k)}installAutoReply(k,S){return this.f.installAutoReply(k,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(k){return this.f.uninstallAutoReply(k)}getDefaultSystemShell(k){return this.g?.getDefaultSystemShell(k)??(0,f.$zm)(k??P.OS,process.env)}async getProfiles(k,S,t,u=!1){const i=await this.S();return(0,w.$Os)(S,t,u,this.N,i,void 0,this.O,this.bb.bind(this,k))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(k,S){return this.f.getWslPath(k,S)}getRevivedPtyNewId(k,S){return this.f.getRevivedPtyNewId(k,S)}setTerminalLayoutInfo(k){return this.f.setTerminalLayoutInfo(k)}async getTerminalLayoutInfo(k){return this.g?.getTerminalLayoutInfo(k)}async requestDetachInstance(k,S){return this.f.requestDetachInstance(k,S)}async acceptDetachInstanceReply(k,S){return this.f.acceptDetachInstanceReply(k,S)}async freePortKillProcess(k){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(k)}async serializeTerminalState(k){return this.f.serializeTerminalState(k)}async reviveTerminalProcesses(k,S,t){return this.f.reviveTerminalProcesses(k,S,t)}async refreshProperty(k,S){return this.f.refreshProperty(k,S)}async updateProperty(k,S,t){return this.f.updateProperty(k,S,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(k){this.ab(),this.s=setTimeout(()=>this.Y(),k?h.HeartbeatConstants.ConnectingBeatInterval:h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier+h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${h.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(k,S){return this.j.createRequest({workspaceId:k,originalText:S})}async acceptPtyHostResolvedVariables(k,S){this.j.acceptReply(k,S)}};e.$Ps=b,e.$Ps=b=Se([se(1,T.$$i),se(2,I.$_j),se(3,I.$ak)],b)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[76],le([0,1,13,4,2,3,16,6,34]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=void 0,n=Ve(n);const c="#FFFFFF",m="#1E1E1E",h="#000000",d="#FFFFFF",w="theme",f="themeBackground",g="windowSplash";var v;(function($){$.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",$.SYSTEM_COLOR_THEME="window.systemColorTheme"})(v||(v={})),e.$Mfc=(0,I.$Ei)("themeMainService");let b=class extends P.$Uc{constructor(k,S){super(),this.b=k,this.c=S,this.a=this.B(new r.$le),this.onDidChangeColorScheme=this.a.event,D.$l||this.B(this.c.onDidChangeConfiguration(t=>{(t.affectsConfiguration(v.SYSTEM_COLOR_THEME)||t.affectsConfiguration(v.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(n.default.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(D.$l||this.c.getValue(v.DETECT_COLOR_SCHEME))n.default.nativeTheme.themeSource="system";else switch(this.c.getValue(v.SYSTEM_COLOR_THEME)){case"dark":n.default.nativeTheme.themeSource="dark";break;case"light":n.default.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.default.nativeTheme.themeSource="light";break;case"vs-dark":n.default.nativeTheme.themeSource="dark";break;default:n.default.nativeTheme.themeSource="system"}break;default:n.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(D.$j){if(n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.$k){if(n.default.nativeTheme.shouldUseInvertedColorScheme||n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.$l&&n.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const k=this.getColorScheme();if(k.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return k.dark?h:d;let S=this.b.getItem(f,null);if(!S)switch(this.g()){case"vs":S=c;break;case"hc-black":S=h;break;case"hc-light":S=d;break;default:S=m}return D.$k&&S.toUpperCase()===m&&(S="#171717"),S}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(k,S){this.b.setItems([{key:w,data:S.baseTheme},{key:f,data:S.colorInfo.background},{key:g,data:S}]),typeof k=="number"&&this.h(k,S),this.f()}h(k,S){for(const t of n.default.BrowserWindow.getAllWindows())if(t.id===k){t.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(g)}};e.$Nfc=b,e.$Nfc=b=Se([se(0,p.$zR),se(1,T.$$i)],b)}),define(ce[131],le([0,1,4,2,3,7,16,6,5]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ow=e.$Nw=e.$Kw=e.$Iw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ew=e.$Dw=void 0,e.$Fw=h,e.$Gw=w,e.$Hw=f,e.$Jw=g,e.$Lw=v,e.$Mw=b,e.$Dw=(0,I.$Ei)("tunnelService"),e.$Ew=(0,I.$Ei)("sharedTunnelsService");var c;(function(S){S.Http="http",S.Https="https"})(c||(e.TunnelProtocol=c={}));var m;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(m||(e.TunnelPrivacyId=m={}));function h(S){return!!S.forwardPort}var d;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function w(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(t)return{address:t[1],port:+t[2]}}function f(S){if(S.scheme!=="http"&&S.scheme!=="https"||!S.query)return;const t=S.query.split("&");for(const u of t){const i=u.split("=")[1];if(/^https?:/.exec(i)){const o=w(D.URI.parse(i));if(o)return o}}}e.$Iw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(S){return e.$Iw.indexOf(S)>=0}e.$Kw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(S){return e.$Kw.indexOf(S)>=0}function b(S,t,u,i){if(u===P.OperatingSystem.Windows)return!1;if(u===P.OperatingSystem.Macintosh&&v(t)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(o?.length===4&&parseInt(o[1])>=18)return!1}return S<1024}class ${constructor(t,u,i){this.remoteAddress=t,this.localAddress=u,this.b=i,this.a=new n.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Nw=$;let k=class extends r.$Uc{constructor(t,u){super(),this.r=t,this.s=u,this.a=new n.$le,this.onTunnelOpened=this.a.event,this.b=new n.$le,this.onTunnelClosed=this.b.event,this.c=new n.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],u=Array.from(this.f.values());for(const i of u){const o=Array.from(i.values());for(const s of o){const a=await s.value;a&&typeof a!="string"&&t.push(a)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:u}of t.values())await u.then(i=>typeof i!="string"?i?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,u,i,o,s){this.z(t,u,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:u,localAddress:i,privacy:o,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,u){(v(t)||g(t))&&(t=e.$Iw[0]);const i=this.D(t,u);if(i)return++i.refcount,i.value}openTunnel(t,u,i,o,s,a=!1,l,E){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${i} on local port ${s}.`);const y=this.g??t;if(!y)return;if(u||(u="localhost"),o||(o=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(y,u,i,o,s,a,l,E);return R?R.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(u,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(u,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const A=this.w(L);return(L.tunnelRemoteHost!==u||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&L.privacy!==l&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(A),A}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const u=this.f.get(t.tunnelRemoteHost);if(u){const i=u.get(t.tunnelRemotePort);i&&(i.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,i))}}}}async y(t,u,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${u}.`);const o=i.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(u),o}}async closeTunnel(t,u){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${u} `);const i=this.f.get(t);if(i&&i.has(u)){const o=i.get(u);o.refcount=0,await this.y(t,u,o)}}z(t,u,i){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(u,{refcount:1,value:i})}async C(t,u){const i=this.f.get(t);if(i){const o=i.get(u),s=o?await o.value:void 0;(!s||typeof s=="string")&&i.delete(u),i.size===0&&this.f.delete(t)}}D(t,u){const i=[t];g(t)?(i.push(...e.$Iw),i.push(...e.$Kw)):v(t)&&i.push(...e.$Kw);const o=i.map(s=>this.f.get(s));for(const s of o){const a=s?.get(u);if(a)return a}}canTunnel(t){return!!w(t)}G(t,u,i,o,s,a,l){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${i} on local port ${o}.`);const E=i;this.n.add(E);const y=o===void 0?i:o,R={elevationRequired:s?this.isPortPrivileged(y):!1},L={remoteAddress:{host:u,port:i},localAddressPort:o,privacy:a,public:a?a!==m.Private:void 0,protocol:l},A=t.forwardPort(L,R);return A?(this.z(u,i,A),A.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(E)})):this.n.delete(E),A}};e.$Ow=k,e.$Ow=k=Se([se(0,p.$_j),se(1,T.$$i)],k)}),define(ce[50],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SY=e.$RY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(T){T.Uninitialized="uninitialized",T.Idle="idle",T.Disabled="disabled",T.CheckingForUpdates="checking for updates",T.AvailableForDownload="available for download",T.Downloading="downloading",T.Downloaded="downloaded",T.Updating="updating",T.Ready="ready"})(r||(e.StateType=r={}));var P;(function(T){T[T.Setup=0]="Setup",T[T.Archive=1]="Archive",T[T.Snap=2]="Snap"})(P||(e.UpdateType=P={}));var D;(function(T){T[T.NotBuilt=0]="NotBuilt",T[T.DisabledByEnvironment=1]="DisabledByEnvironment",T[T.ManuallyDisabled=2]="ManuallyDisabled",T[T.MissingConfiguration=3]="MissingConfiguration",T[T.InvalidConfiguration=4]="InvalidConfiguration",T[T.RunningAsAdmin=5]="RunningAsAdmin"})(D||(e.DisablementReason=D={})),e.$RY={Uninitialized:{type:r.Uninitialized},Disabled:T=>({type:r.Disabled,reason:T}),Idle:(T,I)=>({type:r.Idle,updateType:T,error:I}),CheckingForUpdates:T=>({type:r.CheckingForUpdates,explicit:T}),AvailableForDownload:T=>({type:r.AvailableForDownload,update:T}),Downloading:{type:r.Downloading},Downloaded:T=>({type:r.Downloaded,update:T}),Updating:T=>({type:r.Updating,update:T}),Ready:T=>({type:r.Ready,update:T})},e.$SY=(0,n.$Ei)("updateService")}),define(ce[232],le([0,1,3,10,56,45]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.$qo.as(P.$vo.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(11031,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,r.localize)(11032,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(11033,null),(0,r.localize)(11034,null),(0,r.localize)(11035,null),(0,r.localize)(11036,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,r.localize)(11037,null),deprecationMessage:(0,r.localize)(11038,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,title:(0,r.localize)(11039,null),description:(0,r.localize)(11040,null),included:n.$j&&!n.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,description:(0,r.localize)(11041,null),tags:["usesOnlineServices"]}}})}),define(ce[233],le([0,1,4,50]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0;class P{constructor(I){this.a=I}listen(I,p){switch(p){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${p}`)}}e.$1gc=P;class D{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$le,this.onStateChange=this.a.event,this.b=r.$RY.Uninitialized,this.c.listen("onStateChange")(p=>this.state=p),this.c.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$2gc=D}),define(ce[41],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,n.$Ei)("IUriIdentityService")}),define(ce[234],le([0,1,41,173,14,18,145,4,2]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let m=class{constructor(d){this.g=d,this.c=new p.$Tc,this.f=2**16;const w=new Map,f=g=>{let v=w.get(g.scheme);return v===void 0&&(v=d.hasProvider(g)&&!this.g.hasCapability(g,P.FileSystemProviderCapabilities.PathCaseSensitive),w.set(g.scheme,v)),v};this.c.add(I.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(g=>{w.delete(g.scheme)})),this.extUri=new D.$7g(f),this.d=new T.$Ss((g,v)=>this.extUri.compare(g,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,D.$gh)(d));const w=this.d.get(d);return w?w.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((f,g)=>f[1].time<g[1].time?1:f[1].time>g[1].time?-1:0);c._clock=0,this.d.clear();const w=this.f*.5;for(let f=0;f<w;f++)this.d.set(d[f][0],d[f][1].touch())}};e.$Ts=m,e.$Ts=m=Se([se(0,P.$_k)],m),(0,r.$Qs)(n.$Jl,m,r.InstantiationType.Delayed)}),define(ce[132],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IY=void 0,e.$IY=(0,n.$Ei)("urlService")}),define(ce[235],le([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=e.$9gc=void 0;class r{constructor(I){this.a=I}listen(I,p){throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${p}`)}}e.$9gc=r;class P{constructor(I){this.a=I}handleURL(I,p){return this.a.call("handleURL",[I.toJSON(),p])}}e.$0gc=P;class D{constructor(I,p){this.a=I,this.b=p}async routeCall(I,p,c,m){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(Array.isArray(c)&&c.length>0){const h=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",h.toString(!0)),h.query){const d=/\bwindowId=(\d+)/.exec(h.query);if(d){const w=d[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,h.toString(!0));const f=new RegExp(`window:${w}`),g=I.connections.find(v=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",v.ctx),f.test(v.ctx)));if(g)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",h.toString(!0)),g;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",h.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",h.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,p,c,m)}routeEvent(I,p){throw new Error(`Event not found: ${p}`)}}e.$$gc=D}),define(ce[236],le([0,1,8,2,7,28]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KY=e.$JY=void 0;class T extends r.$Uc{constructor(){super(...arguments),this.a=new Set}open(c,m){const h=[...this.a.values()];return(0,n.$Ih)(h.map(d=>()=>d.handleURL(c,m)),void 0,!1).then(d=>d||!1)}registerHandler(c){return this.a.add(c),(0,r.$Sc)(()=>this.a.delete(c))}}e.$JY=T;let I=class extends T{constructor(c){super(),this.b=c}create(c){let{authority:m,path:h,query:d,fragment:w}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&h&&h.indexOf("/")!==0&&(h=`/${h}`),P.URI.from({scheme:this.b.urlProtocol,authority:m,path:h,query:d,fragment:w})}};e.$KY=I,e.$KY=I=Se([se(0,D.$sk)],I)}),define(ce[237],le([0,1,13,8,4,2,3,7]),function(x,e,n,r,P,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class p extends D.$Uc{constructor(m,h,d,w,f,g){if(super(),this.c=h,this.f=g,this.a=[],this.b=0,m&&(g.trace("ElectronURLListener initialUrisToHandle:",m.map($=>$.originalUrl)),this.a=m),T.$j){const $=w.isBuilt?[]:[`"${w.appRoot}"`];$.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,$)}const v=P.Event.map(P.Event.fromNodeEventEmitter(n.app,"open-url",($,k)=>({event:$,url:k})),({event:$,url:k})=>($.preventDefault(),k));this.B(v($=>{const k=this.g($);k&&this.c.open(k,{originalUrl:$})})),d.getWindows().filter($=>$.isReady).length>0?(g.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(g.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(P.Event.once(d.onDidSignalReadyWindow)(()=>this.h())))}g(m){try{return I.URI.parse(m)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const h of this.a)await this.c.open(h.uri,{originalUrl:h.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",h.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",h.originalUrl),m.push(h));m.length!==0&&(this.a=m,(0,r.$Gh)(()=>this.h(),500,this.q))}}e.$_gc=p}),define(ce[238],le([0,1,4,2,14,60,31]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class I extends r.$Uc{constructor(c,m,h,d,w,f){super(),this.f=c,this.g=m,this.h=h,this.j=d,this.m=w,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$le),this.onDidChangeFile=this.a.event,this.b=D.$Ki.forUris(()=>!(this.capabilities&P.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Bc(g=>this.m.extUri.getComparisonKey(this.t(g))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(g=>this.s(g)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,m){return this.g.open(this.t(c),m)}close(c){return this.g.close(c)}read(c,m,h,d,w){return this.g.read(c,m,h,d,w)}write(c,m,h,d,w){return this.g.write(c,m,h,d,w)}watch(c,m){this.b.set(c,c);const h=this.g.watch(this.t(c),m);return(0,r.$Sc)(()=>{this.b.delete(c),h.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,m,h){return this.g.rename(this.t(c),this.t(m),h)}readFile(c,m){return this.g.readFile(this.t(c),m)}readFileStream(c,m,h){return this.g.readFileStream(this.t(c),m,h)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,m,h){return this.g.writeFile(this.t(c),m,h)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,m){return this.g.delete(this.t(c),m)}copy(c,m,h){if((0,P.$dl)(this.g))return this.g.copy(this.t(c),this.t(m),h);throw new Error("copy not supported")}cloneFile(c,m){if((0,P.$el)(this.g))return this.g.cloneFile(this.t(c),this.t(m));throw new Error("clone not supported")}s(c){const m=[];for(const h of c){if(h.resource.scheme!==this.f)continue;const d=this.u(h.resource);this.b.findSubstr(d)&&m.push({resource:d,type:h.type,cId:h.cId})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Ohc=I}),define(ce[239],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0,e.$vhc="utilityProcessWorker"}),define(ce[240],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0,e.$ahc=(0,n.$Ei)("webviewManagerService")}),define(ce[241],le([0,1,13,2,11,7]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class T extends r.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const p=this.b.bind(this);n.protocol.registerFileProtocol(P.Schemas.vscodeWebview,p)}b(p,c){try{const m=D.URI.parse(p.url),h=T.a.get(m.path);if(typeof h=="string"){const d=`vs/workbench/contrib/webview/browser/pre/${h}`,w=P.$Yg.asFileUri(d);return c({path:w.fsPath,headers:{...P.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$bhc=T}),define(ce[51],le([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dE=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$7D=void 0,e.$8D=r,e.$9D=P,e.$0D=D,e.$$D=T,e.$_D=I,e.$aE=h,e.$bE=d,e.$cE=w,e.$eE=f,e.$fE=g,e.$gE=v,e.$7D={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(b){return typeof b.parentId=="number"}function P(b){return!!b.workspaceUri}function D(b){return!!b.folderUri}function T(b){return!!b.fileUri}function I(b){const $=d(b),k=b.getValue("window.menuBarVisibility");return k==="default"||$&&k==="compact"||n.$k&&n.$n?"classic":k}var p;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(p||(e.TitleBarSetting=p={}));var c;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var m;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(m||(e.CustomTitleBarVisibility=m={}));function h(b,$){return!0}function d(b,$){return $||($=w(b)),$===c.NATIVE}function w(b){if(n.$p)return c.CUSTOM;const $=b.getValue("window");if($){if(n.$k&&$.nativeTabs===!0||n.$k&&$.nativeFullScreen===!1)return c.NATIVE;const t=$.titleBarStyle;if(t===c.NATIVE||t===c.CUSTOM)return t}return n.$l?c.NATIVE:c.CUSTOM}e.$dE=35;function f(b){return!(!n.$j||n.$p||d(b))}function g(b){const $=b.getValue("window");return!$||typeof $.nativeFullScreen!="boolean"||$.nativeTabs?!0:$.nativeFullScreen!==!1}function v(b=0){return Math.pow(1.2,b)}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[52],le([0,1,13]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Efc=e.$Dfc=e.UnloadReason=e.LoadReason=void 0,n=Ve(n);var r;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var P;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const D=function(c=I.Normal){return{width:1024,height:768,mode:c}};e.$Dfc=D;const T=function(){const h=n.default.screen.getPrimaryDisplay().workArea,d=Math.max(h.x+h.width/2-800/2,0),w=Math.max(h.y+h.height/2-600/2,0);return{x:d,y:w,width:800,height:600,mode:I.Normal}};e.$Efc=T;var I;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var p;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(p||(e.WindowError=p={}))}),define(ce[242],le([0,1,8,4,2]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class D extends P.$Uc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:p,getActiveWindowId:c}){super(),this.a=this.B(new P.$Tc),r.Event.latch(r.Event.any(I,p))(this.f,this,this.a),this.b=(0,n.$rh)(()=>c()),(async()=>{try{const h=await this.b;this.c=typeof this.c=="number"?this.c:h}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$hhc=D}),define(ce[30],le([0,1,10,9,60,18,7,6,11]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Yi=e.$Xi=e.WorkbenchState=e.$Ri=e.$Qi=e.$Ni=void 0,e.$Oi=c,e.$Pi=m,e.$Si=h,e.$Ti=d,e.$Ui=w,e.$Vi=g,e.$Wi=v,e.$Zi=k,e.$5i=S,e.$6i=t,e.$8i=u,e.$9i=i,e.$0i=o,e.$Ni=(0,I.$Ei)("contextService");function c(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.uri)}function m(s){return typeof s?.id=="string"&&!c(s)&&!d(s)}e.$Qi={id:"ext-dev"},e.$Ri={id:"empty-window"};function h(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$nc)(s)}:a?e.$Qi:e.$Ri;const l=s;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function d(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.configPath)}function w(s){const a=s;if(a?.uri)return{id:a.id,uri:T.URI.revive(a.uri)};const l=s;if(l?.configPath)return{id:l.id,configPath:T.URI.revive(l.configPath)};if(s?.id)return{id:s.id}}var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function g(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function v(s){const a=s;return!!(a&&typeof a=="object"&&T.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class b{constructor(a,l,E,y,R){this.h=a,this.j=E,this.k=y,this.l=R,this.c=P.$Ki.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=P.$Ki.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Xi=b;class ${constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,D.$fh)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Yi=$;function k(s){return new $({uri:s,index:0,name:(0,D.$bh)(s)},{uri:s.toString()})}e.$1i="code-workspace",e.$2i=`.${e.$1i}`,e.$3i=[{name:(0,n.localize)(10983,null),extensions:[e.$1i]}],e.$4i="workspace.json";function S(s,a){return D.$9g.isEqualOrParent(s,a.untitledWorkspacesHome)}function t(s){let a;return T.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===p.Schemas.tmp}e.$7i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function u(s){return s.id===e.$7i}function i(s,a){return!S(s,a)&&!t(s)}function o(s){return(typeof s=="string"?(0,r.$oc)(s):(0,D.$dh)(s))===e.$2i}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[53],le([0,1,13,8,46,47,2,78,3,23,10,123,6,5,28,30]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=void 0,n=Ve(n),e.$Jfc=(0,d.$Ei)("dialogMainService");let v=class{constructor($,k){this.d=$,this.e=k,this.a=new Map,this.b=new Map,this.c=new r.$Lh}pickFileFolder($,k){return this.f({...$,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(11524,null)},k)}pickFolder($,k){return this.f({...$,pickFolders:!0,title:(0,m.localize)(11525,null)},k)}pickFile($,k){return this.f({...$,pickFiles:!0,title:(0,m.localize)(11526,null)},k)}pickWorkspace($,k){const S=(0,m.localize)(11527,null),t=(0,D.$6w)((0,m.localize)(11528,null)),u=g.$3i;return this.f({...$,pickFiles:!0,title:S,filters:u,buttonLabel:t},k)}async f($,k){const S={title:$.title,buttonLabel:$.buttonLabel,filters:$.filters,defaultPath:$.defaultPath};(typeof $.pickFiles=="boolean"||typeof $.pickFolders=="boolean")&&(S.properties=void 0,$.pickFiles&&$.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",$.pickFolders?"openDirectory":"openFile","createDirectory"]),p.$k&&S.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(S,(k||n.default.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g($){if($){let k=this.b.get($.id);return k||(k=new r.$Lh,this.b.set($.id,k)),k}else return this.c}showMessageBox($,k){return this.g(k).queue(async()=>{const{options:S,buttonIndeces:t}=(0,h.$ax)($,this.e);let u;return k?u=await n.default.dialog.showMessageBox(k,S):u=await n.default.dialog.showMessageBox(S),{response:t[u.response],checkboxChecked:u.checkboxChecked}})}async showSaveDialog($,k){const S=this.j($,k);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(k).queue(async()=>{let t;return k?t=await n.default.dialog.showSaveDialog(k,$):t=await n.default.dialog.showSaveDialog($),t.filePath=this.h(t.filePath),t})}finally{(0,T.$Pc)(S)}}h($){return $&&p.$k&&($=(0,I.$mm)($)),$}i($){return $.map(k=>this.h(k))}async showOpenDialog($,k){$.defaultPath&&(await c.Promises.exists($.defaultPath)||($.defaultPath=void 0));const S=this.j($,k);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(k).queue(async()=>{let t;return k?t=await n.default.dialog.showOpenDialog(k,$):t=await n.default.dialog.showOpenDialog($),t.filePaths=this.i(t.filePaths),t})}finally{(0,T.$Pc)(S)}}j($,k){if(!k)return T.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",$);let S=this.a.get(k.id);S||(S=new Set,this.a.set(k.id,S));const t=(0,P.$sj)($);if(!S.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",$),S.add(t),(0,T.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",$),S?.delete(t),S?.size===0&&this.a.delete(k.id)})}};e.$Kfc=v,e.$Kfc=v=Se([se(0,w.$_j),se(1,f.$sk)],v)}),define(ce[243],le([0,1,4,2,82,30]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class T extends r.$Uc{static{this.a=100}constructor(p,c){super(),this.f=p,this.g=c,this.b=this.B(new n.$le),this.c=new Map,this.h(c.applicationStorage,this.b)}h(p,c){this.B(n.Event.debounce(p.onDidChangeStorage,(m,h)=>(m?m.push(h):m=[h],m),T.a)(m=>{m.length&&c.fire(this.j(m,p))}))}j(p,c){const m=new Map,h=new Set;return p.forEach(d=>{const w=c.get(d.key);typeof w=="string"?m.set(d.key,w):h.add(d.key)}),{changed:Array.from(m.entries()),deleted:Array.from(h.values())}}listen(p,c,m){switch(c){case"onDidChangeStorage":{const h=m.profile?(0,P.$bi)(m.profile):void 0;if(!h)return this.b.event;let d=this.c.get(h.id);return d||(d=this.B(new n.$le),this.h(this.g.profileStorage(h),d),this.c.set(h.id,d)),d.event}}throw new Error(`Event not found: ${c}`)}async call(p,c,m){const h=m.profile?(0,P.$bi)(m.profile):void 0,d=(0,D.$Ui)(m.workspace),w=await this.m(h,d);switch(c){case"getItems":return Array.from(w.items.entries());case"updateItems":{const f=m;if(f.insert)for(const[g,v]of f.insert)w.set(g,v);f.delete?.forEach(g=>w.delete(g));break}case"optimize":return w.optimize();case"isUsed":{const f=m.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${c}`)}}async m(p,c){let m;c?m=this.g.workspaceStorage(c):p?m=this.g.profileStorage(p):m=this.g.applicationStorage;try{await m.init()}catch(h){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":p?"profile":"application"} storage due to ${h}`)}return m}}e.$Xgc=T}),define(ce[42],le([0,1,46,4,2,18,7,10,38,14,6,5,30,31,41,8,33,25,12]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=S,e.$Ml=t,e.$Nl=u;var k;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(k||(e.ProfileResourceType=k={}));function S(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&T.URI.isUri(a.location)&&T.URI.isUri(a.globalStorageHome)&&T.URI.isUri(a.settingsResource)&&T.URI.isUri(a.keybindingsResource)&&T.URI.isUri(a.tasksResource)&&T.URI.isUri(a.snippetsHome)&&T.URI.isUri(a.extensionsResource))}e.$Ll=(0,m.$Ei)("IUserDataProfilesService");function t(s,a){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:T.URI.revive(s.location).with({scheme:a}),globalStorageHome:T.URI.revive(s.globalStorageHome).with({scheme:a}),settingsResource:T.URI.revive(s.settingsResource).with({scheme:a}),keybindingsResource:T.URI.revive(s.keybindingsResource).with({scheme:a}),tasksResource:T.URI.revive(s.tasksResource).with({scheme:a}),snippetsHome:T.URI.revive(s.snippetsHome).with({scheme:a}),extensionsResource:T.URI.revive(s.extensionsResource).with({scheme:a}),cacheHome:T.URI.revive(s.cacheHome).with({scheme:a}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function u(s,a,l,E,y,R){return{id:s,name:a,location:l,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:R&&y?.useDefaultFlags?.globalState?R.globalStorageHome:(0,D.$fh)(l,"globalStorage"),settingsResource:R&&y?.useDefaultFlags?.settings?R.settingsResource:(0,D.$fh)(l,"settings.json"),keybindingsResource:R&&y?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,D.$fh)(l,"keybindings.json"),tasksResource:R&&y?.useDefaultFlags?.tasks?R.tasksResource:(0,D.$fh)(l,"tasks.json"),snippetsHome:R&&y?.useDefaultFlags?.snippets?R.snippetsHome:(0,D.$fh)(l,"snippets"),extensionsResource:R&&y?.useDefaultFlags?.extensions?R.extensionsResource:(0,D.$fh)(l,"extensions.json"),cacheHome:(0,D.$fh)(E,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let i=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,l,E,y){super(),this.t=a,this.u=l,this.w=E,this.y=y,this.f=!0,this.h=this.B(new r.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Ac,workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,D.$fh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$fh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),l=[a];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,$.$eg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}l.push(u((0,D.$ch)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},a))}}catch(R){this.y.error(R)}const E=new w.$Ac,y=new Map;if(l.length)try{const R=this.Q();if(R.workspaces)for(const[L,A]of Object.entries(R.workspaces)){const O=T.URI.parse(L),M=l.find(H=>H.id===A);M&&E.set(O,M)}if(R.emptyWindows)for(const[L,A]of Object.entries(R.emptyWindows)){const O=l.find(M=>M.id===A);O&&y.set(L,O)}}catch(R){this.y.error(R)}this.z={profiles:l,workspaces:E,emptyWindows:y}}return this.z}D(){const a=u("__default__profile__",(0,I.localize)(11030,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",E=new RegExp(`${(0,b.$hf)(l)}\\s(\\d+)`);let y=0;for(const L of this.profiles){const A=E.exec(L.name),O=A?parseInt(A[1]):0;y=O>y?O:y}const R=`${l} ${y+1}`;return this.createProfile((0,n.$sj)((0,v.$1g)()).toString(16),R,{transient:!0},a)}async createNamedProfile(a,l,E){return this.createProfile((0,n.$sj)((0,v.$1g)()).toString(16),a,l,E)}async createProfile(a,l,E,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(a,l,E);return y&&await this.setProfileForWorkspace(y,R),R}async F(a,l,E){if(!(0,$.$eg)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(l);return y||(y=(async()=>{try{if(this.profiles.find(O=>O.name===l||O.id===a))throw new Error(`Profile with ${l} name already exists`);const L=u(a,l,(0,D.$fh)(this.profilesHome,a),this.g,E,this.defaultProfile);await this.u.createFolder(L.location);const A=[];return this.j.fire({profile:L,join(O){A.push(O)}}),await g.Promises.settled(A),this.I([L],[],[]),L}finally{this.r.delete(l)}})(),this.r.set(l,y)),y}async updateProfile(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(y=>y.id===a.id);if(!E)throw new Error(`Profile '${a.name}' does not exist`);return E=u(E.id,l.name??E.name,E.location,this.g,{shortName:l.shortName??E.shortName,icon:l.icon===null?void 0:l.icon??E.icon,transient:l.transient??E.isTransient,useDefaultFlags:l.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(y=>y.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const E=[];this.m.fire({profile:l,join(y){E.push(y)}});try{await Promise.allSettled(E)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(y){(0,c.$ql)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(y=>y.id===l.id);if(!E)throw new Error(`Profile '${l.name}' does not exist`);this.L(a,E)}unsetWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,l)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.G(a),E=T.URI.isUri(l)?this.C.workspaces.get(l):this.C.emptyWindows.get(l);return E||((0,d.$Oi)(a)?this.s.folders.get(a.uri):(0,d.$Ti)(a)?this.s.workspaces.get(a.configPath):this.s.emptyWindows.get(a.id))}G(a){return(0,d.$Oi)(a)?a.uri:(0,d.$Ti)(a)?a.configPath:a.id}H(a){return!!([...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.folders.values()].some(l=>this.w.extUri.isEqual(l.location,a.location)))}I(a,l,E){const y=[...this.profiles,...a],R=[],L=this.s.profiles;this.s.profiles=[];for(let A of y){if(A.isDefault||l.some(M=>A.id===M.id))continue;A=E.find(M=>A.id===M.id)??A;const O=L.find(M=>A.id===M.id);if(A.isTransient)this.s.profiles.push(A);else{if(O){for(const[M,H]of this.s.emptyWindows.entries())if(A.id===H.id){this.L({id:M},A);break}for(const[M,H]of this.s.workspaces.entries())if(A.id===H.id){this.L({id:"",configPath:M},A);break}for(const[M,H]of this.s.folders.entries())if(A.id===H.id){this.L({id:"",uri:M},A);break}}R.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(a,l,E)}J(a,l,E){this.h.fire({added:a,removed:l,updated:E,all:this.profiles})}L(a,l,E){if(E=l?.isTransient?!0:E,E)(0,d.$Oi)(a)?(this.s.folders.delete(a.uri),l&&this.s.folders.set(a.uri,l)):(0,d.$Ti)(a)?(this.s.workspaces.delete(a.configPath),l&&this.s.workspaces.set(a.configPath,l)):(this.s.emptyWindows.delete(a.id),l&&this.s.emptyWindows.set(a.id,l));else{this.L(a,void 0,!0);const y=this.G(a);T.URI.isUri(y)?(this.C.workspaces.delete(y),l&&this.C.workspaces.set(y,l)):(this.C.emptyWindows.delete(y),l&&this.C.emptyWindows.set(y,l)),this.M()}}M(){const a={};for(const[E,y]of this.C.workspaces.entries())a[E.toString()]=y.id;const l={};for(const[E,y]of this.C.emptyWindows.entries())l[E.toString()]=y.id;this.R({workspaces:a,emptyWindows:l}),this.z=void 0}N(a){const l={},E=this.D();if(a.workspaces)for(const[R,L]of Object.entries(a.workspaces)){const A=T.URI.parse(L);l[R]=this.w.extUri.isEqual(A,E.location)?E.id:this.w.extUri.basename(A)}const y={};if(a.emptyWindows)for(const[R,L]of Object.entries(a.emptyWindows)){const A=T.URI.parse(L);y[R]=this.w.extUri.isEqual(A,E.location)?E.id:this.w.extUri.basename(A)}return{workspaces:l,emptyWindows:y}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Ol=i,e.$Ol=i=Se([se(0,p.$Li),se(1,c.$_k),se(2,f.$Jl),se(3,h.$_j)],i);class o extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Pl=o}),define(ce[86],le([0,1,8,17,2,4,31,7,126,129,14,6,5,42,41,12,15,24]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class k extends Error{constructor(o,s){super(o),this.code=s}}e.$Hq=k,e.$Iq=(0,h.$Ei)("IExtensionsProfileScannerService");let S=class extends P.$Uc{constructor(o,s,a,l,E,y){super(),this.j=o,this.m=s,this.n=a,this.r=l,this.s=E,this.t=y,this.b=this.B(new D.$le),this.onAddExtensions=this.b.event,this.c=this.B(new D.$le),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$le),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$le),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Ac}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s,a){const l=[],E=[];try{return await this.u(s,y=>{const R=[];if(a)R.push(...y);else for(const L of y)o.some(([A])=>(0,c.$Lp)(A.identifier,L.identifier)&&A.manifest.version!==L.version)?l.push(L):R.push(L);for(const[L,A]of o){const O=R.findIndex(H=>(0,c.$Lp)(H.identifier,L.identifier)&&H.version===L.manifest.version),M={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:A};O===-1?(E.push(M),R.push(M)):R.splice(O,1,M)}return E.length&&this.b.fire({extensions:E,profileLocation:s}),l.length&&this.f.fire({extensions:l,profileLocation:s}),R}),E.length&&this.c.fire({extensions:E,profileLocation:s}),l.length&&this.g.fire({extensions:l,profileLocation:s}),E}catch(y){throw E.length&&this.c.fire({extensions:E,error:y,profileLocation:s}),l.length&&this.g.fire({extensions:l,error:y,profileLocation:s}),y}}async updateMetadata(o,s){const a=[];return await this.u(s,l=>{const E=[];for(const y of l){const R=o.find(([L])=>(0,c.$Lp)(L.identifier,y.identifier)&&L.manifest.version===y.version);R&&(y.metadata={...y.metadata,...R[1]},a.push(y)),E.push(y)}return E}),a}async removeExtensionFromProfile(o,s){const a=[];try{await this.u(s,l=>{const E=[];for(const y of l)(0,c.$Lp)(y.identifier,o.identifier)?a.push(y):E.push(y);return a.length&&this.f.fire({extensions:a,profileLocation:s}),E}),a.length&&this.g.fire({extensions:a,profileLocation:s})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:s}),l}}async u(o,s,a){return this.F(o).queue(async()=>{let l=[],E;try{const y=await this.m.readFile(o);E=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,m.$ql)(y)!==m.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(E=await this.D()),!E&&a?.bailOutWhenFileNotFound)throw new k((0,v.$9)(y),$.ERROR_PROFILE_NOT_FOUND)}if(E){Array.isArray(E)||this.w(o);let y=!1;for(const R of E){t(R)||this.w(o);let L;if((0,g.$eg)(R.relativeLocation)&&R.relativeLocation)L=this.z(R.relativeLocation);else if((0,g.$eg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{L=I.URI.revive(R.location);const A=this.y(L);A&&(y=!0,R.relativeLocation=A)}(0,g.$lg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(y=!0,R.metadata.hasPreReleaseVersion=!0),l.push({identifier:R.identifier,location:L,version:R.version,metadata:R.metadata})}y&&await this.m.writeFile(o,r.$Ne.fromString(JSON.stringify(E)))}if(s){l=s(l);const y=l.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(o,r.$Ne.fromString(JSON.stringify(y)))}return l})}w(o){const s=new k(`Invalid extensions content in ${o.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let a;try{a=(await this.m.readFile(o)).value.toString()}catch(E){if((0,m.$ql)(E)===m.FileOperationResult.FILE_NOT_FOUND)return;throw E}this.t.info("Migrating extensions from old default profile location",o.toString());let l;try{const E=JSON.parse(a);Array.isArray(E)&&E.every(y=>t(y))?l=E:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",E)}catch(E){this.t.error(E)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Ne.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(E){if((0,m.$ql)(E)===m.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw E}try{await this.m.del(o)}catch(E){(0,m.$ql)(E)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(E)}try{await this.m.del(s)}catch(E){(0,m.$ql)(E)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(E)}return l})()),this.C}F(o){let s=this.h.get(o);return s||(s=new n.$Lh,this.h.set(o,s)),s}};e.$Jq=S,e.$Jq=S=Se([se(1,m.$_k),se(2,w.$Ll),se(3,f.$Jl),se(4,b.$$l),se(5,d.$_j)],S);function t(i){return(0,g.$gg)(i)&&(0,p.$jp)(i.identifier)&&(u(i.location)||(0,g.$eg)(i.location)&&i.location)&&((0,g.$lg)(i.relativeLocation)||(0,g.$eg)(i.relativeLocation))&&i.version&&(0,g.$eg)(i.version)}function u(i){return i?(0,g.$eg)(i.path)&&(0,g.$eg)(i.scheme):!1}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[133],le([0,1,21,8,37,17,15,43,163,2,11,9,3,18,210,81,12,7,10,38,129,85,209,14,6,5,28,4,82,86,42,41,171]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t,u,i,o,s,a,l,E,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Oq=e.$Nq=e.$Mq=e.Translations=void 0,e.$Pq=de,P=Pe(P),h=Pe(h),d=Pe(d),f=Pe(f),g=Ve(g);var O;(function(J){function U(Z,W){if(Z===W)return!0;const j=Object.keys(Z),C=new Set;for(const X of Object.keys(W))C.add(X);if(j.length!==C.size)return!1;for(const X of j){if(Z[X]!==W[X])return!1;C.delete(X)}return C.size===0}J.equals=U})(O||(e.Translations=O={})),e.$Mq=(0,o.$Ei)("IExtensionsScannerService");let M=class extends c.$Uc{constructor(U,Z,W,j,C,X,oe,V,ue,re,Q,N){super(),this.systemExtensionsLocation=U,this.userExtensionsLocation=Z,this.r=W,this.s=j,this.t=C,this.u=X,this.w=oe,this.y=V,this.z=ue,this.C=re,this.D=Q,this.F=N,this.g=this.B(new l.$le),this.onDidChangeCache=this.g.event,this.h=(0,w.$fh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(K,this.s,this.h)),this.m=this.B(this.F.createInstance(K,this.s,this.h)),this.n=this.B(this.F.createInstance(q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,S.$Wp)(this.w,this.y)),this.G}async scanAllExtensions(U,Z,W){const[j,C]=await Promise.all([this.scanSystemExtensions(U),this.scanUserExtensions(Z)]),X=W?await this.scanExtensionsUnderDevelopment(U,[...j,...C]):[];return this.L(j,C,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(U){const Z=[];Z.push(this.M(!!U.useCache,U.language)),Z.push(this.N(U.language,!!U.checkControlFile));const[W,j]=await Promise.all(Z);return this.J([...W,...j],t.ExtensionType.System,U,!1)}async scanUserExtensions(U){const Z=U.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const W=this.D.extUri.isEqual(U.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(Z,!!U.profileLocation,t.ExtensionType.User,!U.includeUninstalled,U.language,!0,W,U.productVersion??this.R()),C=U.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let X;try{X=await C.scanExtensions(j)}catch(oe){if(oe instanceof y.$Hq&&oe.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),X=await C.scanExtensions(j);else throw oe}return X=await this.J(X,t.ExtensionType.User,U,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(U,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===m.Schemas.file).map(async j=>{const C=await this.P(j,!1,t.ExtensionType.User,!0,U.language,!1,void 0,U.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(C)).map(oe=>(oe.type=Z.find(V=>(0,S.$Lp)(V.identifier,oe.identifier))?.type??oe.type,this.n.validate(oe,C)))}))).flat();return this.J(W,"development",U,!0)}return[]}async scanExistingExtension(U,Z,W){const j=await this.P(U,!1,Z,!0,W.language,!0,void 0,W.productVersion??this.R()),C=await this.n.scanExtension(j);return!C||!W.includeInvalid&&!C.isValid?null:C}async scanOneOrMultipleExtensions(U,Z,W){const j=await this.P(U,!1,Z,!0,W.language,!0,void 0,W.productVersion??this.R()),C=await this.n.scanOneOrMultipleExtensions(j);return this.J(C,Z,W,!0)}async scanMultipleExtensions(U,Z,W){const j=[];return await Promise.all(U.map(async C=>{const X=await this.scanOneOrMultipleExtensions(C,Z,W);j.push(...X)})),this.J(j,Z,W,!0)}async scanMetadata(U){const Z=(0,w.$fh)(U,"package.json"),W=(await this.w.readFile(Z)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(U,Z){const W=(0,w.$fh)(U,"package.json"),j=(await this.w.readFile(W)).value.toString(),C=JSON.parse(j);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,C.__metadata={...C.__metadata,...Z},await this.w.writeFile((0,w.$fh)(U,"package.json"),D.$Ne.fromString(JSON.stringify(C,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(U){if(U instanceof y.$Hq&&U.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw U}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const U=await this.scanUserExtensions({includeInvalid:!0});if(U.length)await this.u.addExtensionsToProfile(U.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Ne.fromString(JSON.stringify([])))}catch(Z){(0,i.$ql)(Z)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$9)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(U){this.y.error(U)}finally{this.H=void 0}})()),this.H}async J(U,Z,W,j){return W.includeAllVersions||(U=this.L(Z===t.ExtensionType.System?U:void 0,Z===t.ExtensionType.User?U:void 0,Z==="development"?U:void 0,await this.getTargetPlatform(),j)),W.includeInvalid||(U=U.filter(C=>C.isValid)),U.sort((C,X)=>{const oe=h.$nc(C.location.fsPath),V=h.$nc(X.location.fsPath);return oe<V?-1:oe>V?1:0})}L(U,Z,W,j,C){const X=(V,ue,re)=>{if(V.isValid&&!ue.isValid)return!1;if(V.isValid===ue.isValid){if(C&&f.gt(V.manifest.version,ue.manifest.version))return this.y.debug(`Skipping extension ${ue.location.path} with lower version ${ue.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(f.eq(V.manifest.version,ue.manifest.version)){if(V.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${ue.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===j)return this.y.debug(`Skipping extension ${ue.location.path} from different target platform ${ue.targetPlatform}`),!1}}return re?this.y.warn(`Overwriting user extension ${V.location.path} with ${ue.location.path}.`):this.y.debug(`Overwriting user extension ${V.location.path} with ${ue.location.path}.`),!0},oe=new t.$sn;return U?.forEach(V=>{const ue=oe.get(V.identifier.id);(!ue||X(ue,V,!1))&&oe.set(V.identifier.id,V)}),Z?.forEach(V=>{const ue=oe.get(V.identifier.id);if(!ue&&U&&V.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!ue||X(ue,V,!1))&&oe.set(V.identifier.id,V)}),W?.forEach(V=>{const ue=oe.get(V.identifier.id);(!ue||X(ue,V,!0))&&oe.set(V.identifier.id,V),oe.set(V.identifier.id,V)}),[...oe.values()]}async M(U,Z){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,Z,!0,void 0,this.R()),C=await(U&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",C.length),C}async N(U,Z){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const j=Z?await this.O():{},C=[],X=b.URI.file(h.$hc(h.$jc(m.$Yg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of W){const ue=j[V.name]||"marketplace";switch(ue){case"disabled":break;case"marketplace":C.push((0,w.$fh)(X,V.name));break;default:C.push(b.URI.file(ue));break}}const oe=await Promise.all(C.map(async V=>this.n.scanExtension(await this.P(V,!1,t.ExtensionType.System,!0,U,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",oe.length),(0,n.$Gb)(oe)}async O(){try{const U=await this.w.readFile(this.r);return JSON.parse(U.value.toString())}catch{return{}}}async P(U,Z,W,j,C,X,oe,V){const ue=await this.f(C??d.$x),re=await this.Q(U),Q=Z&&!this.D.extUri.isEqual(U,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=Q?await this.Q(Q):void 0;return new H(U,re,Q,N,Z,oe,W,j,X,V.version,V.date,this.C.commit,!this.z.isBuilt,C,ue)}async Q(U){try{const Z=await this.w.stat(U);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Nq=M,e.$Nq=M=Se([se(4,R.$Ll),se(5,y.$Iq),se(6,i.$_k),se(7,s.$_j),se(8,k.$Li),se(9,a.$sk),se(10,L.$Jl),se(11,o.$Di)],M);class H{constructor(U,Z,W,j,C,X,oe,V,ue,re,Q,N,F,_,z){this.location=U,this.mtime=Z,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=j,this.profile=C,this.profileScanOptions=X,this.type=oe,this.excludeObsolete=V,this.validate=ue,this.productVersion=re,this.productDate=Q,this.productCommit=N,this.devMode=F,this.language=_,this.translations=z}static createNlsConfiguration(U){return{language:U.language,pseudo:U.language==="pseudo",devMode:U.devMode,translations:U.translations}}static equals(U,Z){return(0,w.$$g)(U.location,Z.location)&&U.mtime===Z.mtime&&(0,w.$$g)(U.applicationExtensionslocation,Z.applicationExtensionslocation)&&U.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&U.profile===Z.profile&&P.$ho(U.profileScanOptions,Z.profileScanOptions)&&U.type===Z.type&&U.excludeObsolete===Z.excludeObsolete&&U.validate===Z.validate&&U.productVersion===Z.productVersion&&U.productDate===Z.productDate&&U.productCommit===Z.productCommit&&U.devMode===Z.devMode&&U.language===Z.language&&O.equals(U.translations,Z.translations)}}e.$Oq=H;let q=class extends c.$Uc{constructor(U,Z,W,j,C,X,oe){super(),this.g=U,this.h=Z,this.j=W,this.m=j,this.n=X,this.r=oe,this.f=C.extensionsEnabledWithApiProposalVersion?.map(V=>V.toLowerCase())??[]}async scanExtensions(U){const Z=U.profile?await this.t(U):await this.s(U);let W={};if(U.excludeObsolete&&U.type===t.ExtensionType.User)try{const j=(await this.m.readFile(this.g)).value.toString();W=JSON.parse(j)}catch{}return(0,v.$rg)(W)?Z:Z.filter(j=>!W[S.$Mp.create(j).toString()])}async s(U){const Z=await this.m.resolve(U.location);if(!Z.children?.length)return[];const W=await Promise.all(Z.children.map(async j=>{if(!j.isDirectory||U.type===t.ExtensionType.User&&(0,w.$ch)(j.resource).indexOf(".")===0)return null;const C=new H(j.resource,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(C)}));return(0,n.$Gb)(W).sort((j,C)=>j.location.path<C.location.path?-1:1)}async t(U){let Z=await this.u(U.location,()=>!0,U);if(U.applicationExtensionslocation&&!this.j.extUri.isEqual(U.location,U.applicationExtensionslocation)){Z=Z.filter(j=>!j.metadata?.isApplicationScoped);const W=await this.u(U.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,U);Z.push(...W)}return Z}async u(U,Z,W){const j=await this.h.scanProfileExtensions(U,W.profileScanOptions);if(!j.length)return[];const C=await Promise.all(j.map(async X=>{if(Z(X)){const oe=new H(X.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(oe,X.metadata)}return null}));return(0,n.$Gb)(C)}async scanOneOrMultipleExtensions(U){try{if(await this.m.exists((0,w.$fh)(U.location,"package.json"))){const Z=await this.scanExtension(U);return Z?[Z]:[]}else return await this.scanExtensions(U)}catch(Z){return this.r.error(`Error scanning extensions at ${U.location.path}:`,(0,T.$9)(Z)),[]}}async scanExtension(U,Z){try{let W=await this.w(U.location);if(W){W.publisher||(W.publisher=t.$mn),Z=Z??W.__metadata,delete W.__metadata;const j=(0,S.$Qp)(W.publisher,W.name),C=Z?.id?{id:j,uuid:Z.id}:{id:j},X=Z?.isSystem?t.ExtensionType.System:U.type,oe=X===t.ExtensionType.System||!!Z?.isBuiltin;W=await this.y(U.location,W,H.createNlsConfiguration(U));let V={type:X,identifier:C,manifest:W,location:U.location,isBuiltin:oe,targetPlatform:Z?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return U.validate&&(V=this.validate(V,U)),W.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(j.toLowerCase()))&&(W.originalEnabledApiProposals=W.enabledApiProposals,W.enabledApiProposals=(0,t.$yn)([...W.enabledApiProposals])),V}}catch(W){U.type!==t.ExtensionType.System&&this.r.error(W)}return null}validate(U,Z){let W=!0;const j=this.n.isBuilt&&this.f.includes(U.identifier.id.toLowerCase()),C=(0,u.$3p)(Z.productVersion,Z.productDate,Z.location,U.manifest,U.isBuiltin,j);for(const[X,oe]of C)X===g.default.Error&&(W=!1,this.r.error(this.F(Z.location,oe)));return U.isValid=W,U.validations=C,U}async w(U){const Z=(0,w.$fh)(U,"package.json");let W;try{W=(await this.m.readFile(Z)).value.toString()}catch(C){return(0,i.$ql)(C)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(U,(0,$.localize)(11414,null,Z.path,C.message))),null}let j;try{j=JSON.parse(W)}catch{const X=[];(0,I.$Xn)(W,X);for(const oe of X)this.r.error(this.F(U,(0,$.localize)(11415,null,Z.path,oe.offset,oe.length,(0,p.$Kq)(oe.error))));return null}return(0,I.$6n)(j)!=="object"?(this.r.error(this.F(U,(0,$.localize)(11416,null,Z.path))),null):j}async y(U,Z,W){const j=await this.z(U,Z,W);if(j)try{const C=[],X=await this.C(j.default,C);if(C.length>0)return C.forEach(V=>{this.r.error(this.F(U,(0,$.localize)(11417,null,j.default?.path,(0,p.$Kq)(V.error))))}),Z;if((0,I.$6n)(j)!=="object")return this.r.error(this.F(U,(0,$.localize)(11418,null,j.default?.path))),Z;const oe=j.values||Object.create(null);return(0,A.$Lq)(this.r,Z,oe,X)}catch{}return Z}async z(U,Z,W){const j=(0,w.$fh)(U,"package.nls.json"),C=(ue,re)=>{re.forEach(Q=>{this.r.error(this.F(U,(0,$.localize)(11419,null,ue?.path,(0,p.$Kq)(Q.error))))})},X=ue=>{this.r.error(this.F(U,(0,$.localize)(11420,null,ue?.path)))},oe=`${Z.publisher}.${Z.name}`,V=W.translations[oe];if(V)try{const ue=b.URI.file(V),re=(await this.m.readFile(ue)).value.toString(),Q=[],N=(0,I.$Xn)(re,Q);return Q.length>0?(C(ue,Q),{values:void 0,default:j}):(0,I.$6n)(N)!=="object"?(X(ue),{values:void 0,default:j}):{values:N.contents?N.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.m.exists(j))return;let re;try{re=await this.D(U,W)}catch{return}if(!re.localized)return{values:void 0,default:re.original};try{const Q=(await this.m.readFile(re.localized)).value.toString(),N=[],F=(0,I.$Xn)(Q,N);return N.length>0?(C(re.localized,N),{values:void 0,default:re.original}):(0,I.$6n)(F)!=="object"?(X(re.localized),{values:void 0,default:re.original}):{values:F,default:re.original}}catch{return{values:void 0,default:re.original}}}}async C(U,Z){if(U)try{const W=(await this.m.readFile(U)).value.toString();return(0,I.$Xn)(W,Z)}catch{}}D(U,Z){return new Promise((W,j)=>{const C=X=>{const oe=(0,w.$fh)(U,`package.nls.${X}.json`);this.m.exists(oe).then(V=>{V&&W({localized:oe,original:(0,w.$fh)(U,"package.nls.json")});const ue=X.lastIndexOf("-");ue===-1?W({localized:(0,w.$fh)(U,"package.nls.json"),original:null}):(X=X.substring(0,ue),C(X))})};if(Z.devMode||Z.pseudo||!Z.language)return W({localized:(0,w.$fh)(U,"package.nls.json"),original:null});C(Z.language)})}F(U,Z){return`[${U.path}]: ${Z}`}};q=Se([se(1,y.$Iq),se(2,L.$Jl),se(3,i.$_k),se(4,a.$sk),se(5,k.$Li),se(6,s.$_j)],q);let K=class extends q{constructor(U,Z,W,j,C,X,oe,V,ue){super(Z,j,C,X,oe,V,ue),this.J=U,this.L=W,this.H=this.B(new r.$Ch(3e3)),this.I=this.B(new l.$le),this.onDidChangeCache=this.I.event}async scanExtensions(U){const Z=this.P(U),W=await this.M(Z);if(this.G=U,W&&W.input&&H.equals(W.input,this.G))return this.r.debug("Using cached extensions scan result",U.type===t.ExtensionType.System?"system":"user",U.location.toString()),this.H.trigger(()=>this.O()),W.result.map(C=>(C.location=b.URI.revive(C.location),C));const j=await super.scanExtensions(U);return await this.N(Z,{input:U,result:j}),j}async M(U){try{const Z=await this.m.readFile(U),W=JSON.parse(Z.value.toString());return{result:W.result,input:(0,E.$bi)(W.input)}}catch(Z){this.r.debug("Error while reading the extension cache file:",U.path,(0,T.$9)(Z))}return null}async N(U,Z){try{await this.m.writeFile(U,D.$Ne.fromString(JSON.stringify(Z)))}catch(W){this.r.debug("Error while writing the extension cache file:",U.path,(0,T.$9)(W))}}async O(){if(!this.G)return;const U=this.P(this.G),Z=await this.M(U);if(!Z)return;const W=Z.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!P.$ho(j,W))try{this.r.info("Invalidating Cache",W,j),await this.m.del(U),this.I.fire()}catch(C){this.r.error(C)}}P(U){const Z=this.Q(U);return this.j.extUri.joinPath(Z.cacheHome,U.type===t.ExtensionType.System?t.$ln:t.$kn)}Q(U){return U.type===t.ExtensionType.System?this.L.defaultProfile:U.profile?this.j.extUri.isEqual(U.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Z=>this.j.extUri.isEqual(U.location,Z.extensionsResource))??this.J:this.L.defaultProfile}};K=Se([se(2,R.$Ll),se(3,y.$Iq),se(4,L.$Jl),se(5,i.$_k),se(6,a.$sk),se(7,k.$Li),se(8,s.$_j)],K);function de(J,U){const Z=(0,S.$Op)(J.manifest.publisher,J.manifest.name);return{id:Z,identifier:new t.$qn(Z),isBuiltin:J.type===t.ExtensionType.System,isUserBuiltin:J.type===t.ExtensionType.User&&J.isBuiltin,isUnderDevelopment:U,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,publisherDisplayName:J.publisherDisplayName,...J.manifest}}class Y extends M{constructor(U,Z,W,j,C,X,oe,V,ue,re,Q,N){super(U,Z,(0,w.$fh)(W,".vscode-oss-dev","extensions","control.json"),j,C,X,oe,V,ue,re,Q,N),this.S=(async()=>{if(d.$A)try{const F=await this.w.readFile(b.URI.file(d.$A));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(U){return this.S}}e.$Qq=Y}),define(ce[244],le([0,1,5,42,41,24,86,14,38,7]),function(x,e,n,r,P,D,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GR=void 0;let m=class extends T.$Jq{constructor(d,w,f,g,v,b){super(c.URI.file(d.extensionsPath),w,f,g,v,b)}};e.$GR=m,e.$GR=m=Se([se(0,p.$Mi),se(1,I.$_k),se(2,r.$Ll),se(3,P.$Jl),se(4,D.$$l),se(5,n.$_j)],m)}),define(ce[245],le([0,1,7,38,86,133,14,6,5,28,41,42]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;let d=class extends D.$Qq{constructor(f,g,v,b,$,k,S,t){super(n.URI.file($.builtinExtensionsPath),n.URI.file($.extensionsPath),$.userHome,f.defaultProfile,f,g,v,b,$,k,S,t)}};e.$lhc=d,e.$lhc=d=Se([se(0,h.$Ll),se(1,P.$Iq),se(2,T.$_k),se(3,p.$_j),se(4,r.$Mi),se(5,c.$sk),se(6,m.$Jl),se(7,I.$Di)],d)}),define(ce[246],le([0,1,13,2,11,9,3,60,7,33,35,38,5,42]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;let f=class extends r.$Uc{constructor(v,b,$){super(),this.c=v,this.f=$,this.a=I.$Ki.forPaths(!T.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(v.appRoot),this.addValidFileRoot(v.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(v.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:v}=n.session;v.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,(b,$)=>this.j(b,$)),v.protocol.interceptFileProtocol(P.Schemas.file,(b,$)=>this.h(b,$)),this.B((0,r.$Sc)(()=>{v.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),v.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(v){const b=(0,D.$hc)(v);return this.a.get(b)?r.$Uc.None:(this.a.set(b,!0),(0,r.$Sc)(()=>this.a.delete(b)))}h(v,b){const $=p.URI.parse(v.url);return this.f.error(`Refused to load resource ${$.fsPath} from ${P.Schemas.file}: protocol (original URL: ${v.url})`),b({error:-3})}j(v,b){const $=this.m(v);let k;return this.c.crossOriginIsolated&&((0,D.$nc)($)==="workbench.html"||(0,D.$nc)($)==="workbench-dev.html"?k=P.COI.CoopAndCoep:k=P.COI.getHeadersFromQuery(v.url)),this.a.findSubstr($)?b({path:$,headers:k}):this.b.has((0,D.$oc)($).toLowerCase())?b({path:$}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${$} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${v.url})`),b({error:-3}))}m(v){const b=p.URI.parse(v.url),$=P.$Yg.uriToFileUri(b);return(0,D.$hc)($.fsPath)}createIPCObjectUrl(){let v;const b=p.URI.from({scheme:"vscode",path:(0,c.$1g)()}),$=b.toString(),k=async()=>v;return m.$TX.handle($,k),this.f.trace(`IPC Object URL: Registered new channel ${$}.`),{resource:b,update:S=>v=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${$}.`),m.$TX.removeHandler($)}}}};e.$Fhc=f,e.$Fhc=f=Se([se(0,h.$Mi),se(1,w.$Ll),se(2,d.$_j)],f)}),define(ce[62],le([0,1,8,4,2,70,12,119,6,42]),function(x,e,n,r,P,D,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$jq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hq=e.$gq=e.$fq=void 0,e.$iq=w,e.$kq=g,e.$mq=b,e.$fq="__$__isNewStorageMarker",e.$gq="__$__targetStorageMarker",e.$hq=(0,p.$Ei)("storageService");var m;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var h;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(h||(e.StorageScope=h={}));var d;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function w($){const k=$.get(e.$gq);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}class f extends P.$Uc{static{this.a=60*1e3}constructor(k={flushInterval:f.a}){super(),this.m=k,this.b=this.B(new r.$oe),this.c=this.B(new r.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$le),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(k,S,t){return r.Event.filter(this.b.event,u=>u.scope===k&&(S===void 0||u.key===S),t)}n(){this.j.value=(0,n.$Uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(k,S){const{key:t,external:u}=S;if(t===e.$gq){switch(k){case h.APPLICATION:this.H=void 0;break;case h.PROFILE:this.F=void 0;break;case h.WORKSPACE:this.C=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:t,target:this.J(k)[t],external:u})}w(k){this.f.fire({reason:k})}get(k,S,t){return this.P(S)?.get(k,t)}getBoolean(k,S,t){return this.P(S)?.getBoolean(k,t)}getNumber(k,S,t){return this.P(S)?.getNumber(k,t)}getObject(k,S,t){return this.P(S)?.getObject(k,t)}storeAll(k,S){this.y(()=>{for(const t of k)this.store(t.key,t.value,t.scope,t.target,S)})}store(k,S,t,u,i=!1){if((0,T.$ng)(S)){this.remove(k,t,i);return}this.y(()=>{this.z(k,t,u),this.P(t)?.set(k,S,i)})}remove(k,S,t=!1){this.y(()=>{this.z(k,S,void 0),this.P(S)?.delete(k,t)})}y(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,S){const t=[],u=this.J(k);for(const i of Object.keys(u))u[i]===S&&t.push(i);return t}z(k,S,t,u=!1){const i=this.J(S);typeof t=="number"?i[k]!==t&&(i[k]=t,this.P(S)?.set(e.$gq,JSON.stringify(i),u)):typeof i[k]=="number"&&(delete i[k],this.P(S)?.set(e.$gq,JSON.stringify(i),u))}get D(){return this.C||(this.C=this.L(h.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(h.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(h.APPLICATION)),this.H}J(k){switch(k){case h.APPLICATION:return this.I;case h.PROFILE:return this.G;default:return this.D}}L(k){const S=this.P(k);return S?w(S):Object.create(null)}isNew(k){return this.getBoolean(e.$fq,k)===!0}async flush(k=m.NONE){this.f.fire({reason:k});const S=this.P(h.APPLICATION),t=this.P(h.PROFILE),u=this.P(h.WORKSPACE);switch(k){case m.NONE:await n.Promises.settled([S?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await n.Promises.settled([S?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.P(h.APPLICATION)?.items??new Map,S=this.P(h.PROFILE)?.items??new Map,t=this.P(h.WORKSPACE)?.items??new Map;return b(k,S,t,this.Q(h.APPLICATION)??"",this.Q(h.PROFILE)??"",this.Q(h.WORKSPACE)??"")}async optimize(k){return await this.flush(),this.P(k)?.optimize()}async switch(k,S){return this.w(m.NONE),(0,c.$Kl)(k)?this.R(k,S):this.S(k,S)}M(k,S){return!(k.id===S.id||g(S)&&g(k))}N(k,S,t){this.y(()=>{const u=new Set;for(const[i,o]of k)u.add(i),S.get(i)!==o&&this.u(t,{key:i,external:!0});for(const[i]of S.items)u.has(i)||this.u(t,{key:i,external:!0})})}}e.$jq=f;function g($){return $.isDefault||!!$.useDefaultFlags?.globalState}class v extends f{constructor(){super(),this.U=this.B(new I.$dq(new I.$eq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$dq(new I.$eq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$dq(new I.$eq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(k=>this.u(h.WORKSPACE,k))),this.B(this.W.onDidChangeStorage(k=>this.u(h.PROFILE,k))),this.B(this.U.onDidChangeStorage(k=>this.u(h.APPLICATION,k)))}P(k){switch(k){case h.APPLICATION:return this.U;case h.PROFILE:return this.W;default:return this.X}}Q(k){switch(k){case h.APPLICATION:return"inMemory (application)";case h.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(k){return!1}}e.$lq=v;async function b($,k,S,t,u,i){const o=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,a=new Map;$.forEach((O,M)=>{s.set(M,O),a.set(M,o(O))});const l=new Map,E=new Map;k.forEach((O,M)=>{l.set(M,O),E.set(M,o(O))});const y=new Map,R=new Map;S.forEach((O,M)=>{y.set(M,O),R.set(M,o(O))}),console.group(t!==u?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const L=[];if(s.forEach((O,M)=>{L.push({key:M,value:O})}),console.table(L),console.groupEnd(),console.log(a),t!==u){console.group(`Storage: Profile (path: ${u}, profile specific)`);const O=[];l.forEach((M,H)=>{O.push({key:H,value:M})}),console.table(O),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${i})`);const A=[];y.forEach((O,M)=>{A.push({key:M,value:O})}),console.table(A),console.groupEnd(),console.log(R)}}),define(ce[247],le([0,1,17,33,62]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=D;async function D(T,I,p){let c=p&&p.get("storage.serviceMachineId",P.StorageScope.APPLICATION)||null;if(c)return c;try{const h=(await I.readFile(T.serviceMachineIdResource)).value.toString();c=(0,r.$Zg)(h)?h:null}catch{c=null}if(!c){c=(0,r.$1g)();try{await I.writeFile(T.serviceMachineIdResource,n.$Ne.fromString(c))}catch{}}return p?.store("storage.serviceMachineId",c,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),c}}),define(ce[248],le([0,1,247,24,57]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=D;async function D(T,I,p,c,m,h,d){const w={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${I.nameShort})`};if((0,P.$Dp)(I,p)&&(0,P.$Fp)(c)===r.TelemetryLevel.USAGE){const f=await(0,n.$nq)(p,m,h);w["X-Market-User-Id"]=f,w["VSCode-SessionId"]=d.machineId||f}return w}}),define(ce[249],le([0,1,26,21,8,4,2,9,66,7,23,119,161,5,62,24,30,11]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=e.$_fc=e.$$fc=e.$0fc=void 0,n=Pe(n);class $ extends T.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(s,a){super(),this.m=s,this.n=a,this.b=this.B(new D.$le),this.onDidChangeStorage=this.b.event,this.c=this.B(new D.$le),this.onDidCloseStorage=this.c.event,this.f=this.B(new h.$dq(new h.$eq,{hint:h.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new P.$2h,this.whenInit=this.h.p,this.j=h.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===h.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(l=>this.b.fire(l))),await this.s(s);const a=s.getBoolean(f.$fq);a===void 0?s.set(f.$fq,!0):a&&s.set(f.$fq,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=h.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===w.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,a){return this.f.get(s,a)}set(s,a){return this.f.set(s,a)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new p.$fe(!1);await this.w(),s.stop(),s.elapsed()>$.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const a=(0,r.top)(Array.from(this.f.items.entries()).map(([E,y])=>({key:E,length:y.length})),(E,y)=>y.length-E.length,5).map(E=>`${E.key}:${E.length}`).join(", "),l=(await this.n.stat(c.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${l}b, Large Keys: ${a}`)}catch(a){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",a)}}async w(){this.g&&await this.g,this.j=h.StorageState.Closed,await this.f.close()}}class k extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$jc)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,k.y)}constructor(s,a,l,E){super(l,E),this.z=s,this.C=a}async t(){return new h.$dq(new d.$mY(this.path??d.$mY.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:h.StorageHint.STORAGE_IN_MEMORY})}}class S extends k{constructor(s,a,l,E){super(s,a,l,E)}}e.$0fc=S;class t extends k{constructor(s,a,l,E){super(a.defaultProfile,s,l,E)}async s(s){await super.s(s),this.G(s)}G(s){s.get(g.$bm,void 0)===void 0&&s.set(g.$bm,new Date().toUTCString());const l=s.get(g.$am,void 0),E=new Date().toUTCString();s.set(g.$cm,typeof l>"u"?null:l),s.set(g.$am,E)}}e.$$fc=t;class u extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$jc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,u.y)}constructor(s,a,l,E,y){super(l,y),this.C=s,this.D=a,this.F=E}async t(){const{storageFilePath:s,wasCreated:a}=await this.H();return new h.$dq(new d.$mY(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?h.StorageHint.STORAGE_IN_MEMORY:a?h.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:d.$mY.IN_MEMORY_PATH,wasCreated:!0};const s=(0,I.$jc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),a=(0,I.$jc)(s,u.y);return await m.Promises.exists(s)?{storageFilePath:a,wasCreated:!1}:(await n.promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:a,wasCreated:!0})}async I(s){let a;if((0,v.$Oi)(this.C)?a={folder:this.C.uri.toString()}:(0,v.$Ti)(this.C)&&(a={workspace:this.C.configPath.toString()}),a)try{const l=(0,I.$jc)(s,u.z);await m.Promises.exists(l)||await m.Promises.writeFile(l,JSON.stringify(a,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$_fc=u;class i extends ${get path(){}async t(){return new h.$dq(new h.$eq,{hint:h.StorageHint.STORAGE_IN_MEMORY})}}e.$agc=i}),define(ce[250],le([0,1,4,2,62]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class D extends r.$Uc{constructor(I,p,c){super(),this.b=I,this.c=p,this.f=c;const m=this.B(new r.$Vc);this.a=this.B(new n.$le({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Tc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(p,c)=>(p?p.push(c.key):p=[c.key],p),100)(p=>this.h(p))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(p,c)=>{p||(p=new Map);let m=p.get(c.profile.id);return m||p.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),p},100)(p=>this.j(p))),I}h(I){const p=I.includes(P.$gq)?[this.c.defaultProfile]:[],c=[];if(I=I.filter(m=>m!==P.$gq),I.length){const m=(0,P.$iq)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:I.map(h=>({key:h,scope:P.StorageScope.PROFILE,target:m[h]}))})}this.m(p,c)}j(I){const p=[],c=new Map;for(const[m,h]of I.entries()){h.keys.includes(P.$gq)&&p.push(h.profile);const d=h.keys.filter(w=>w!==P.$gq);if(d.length){const w=(0,P.$iq)(h.storage.storage);c.set(m,{profile:h.profile,changes:d.map(f=>({key:f,scope:P.StorageScope.PROFILE,target:w[f]}))})}}this.m(p,[...c.values()])}m(I,p){(I.length||p.length)&&this.a.fire({valueChanges:p,targetChanges:I})}listen(I,p,c){switch(p){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${p}`)}async call(I,p){throw new Error(`Call not found: ${p}`)}}e.$nhc=D}),define(ce[251],le([0,1,7,38,14,5,34,41,42,12,127]),function(x,e,n,r,P,D,T,I,p,c,m){"use strict";var h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$FR=e.$ER=e.$DR=void 0;let w=class extends p.$Ol{static{h=this}static{this.a="profileAssociationsMigration"}constructor(b,$,k,S,t){super(k,S,$,t),this.U=b,this.W=k}O(){return this.U.getItem(h.b,[]).map($=>({...$,location:(0,c.$eg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):n.URI.revive($.location)}))}Q(){const b=this.U.getItem(h.c,{});return this.U.getItem(h.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$DR=w,e.$DR=w=h=Se([se(0,T.$yR),se(1,I.$Jl),se(2,r.$Mi),se(3,P.$_k),se(4,D.$_j)],w);let f=d=class extends w{constructor(b,$,k,S,t){super(b,$,k,S,t),this.$=b}P(b){b.length?this.$.setItem(d.b,b.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(d.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(d.c,b):this.$.removeItem(d.c)}Q(){const b="workspaceAndProfileInfo",$=this.$.getItem(b,void 0);if($){this.$.removeItem(b);const S=$.reduce((t,{workspace:u,profile:i})=>(t[n.URI.revive(u).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(d.c,{workspaces:S})}const k=super.Q();return this.$.getItem(d.a,!1)||(this.R(k),this.$.setItem(d.a,!0)),k}};e.$ER=f,e.$ER=f=d=Se([se(0,T.$zR),se(1,I.$Jl),se(2,r.$Mi),se(3,P.$_k),se(4,D.$_j)],f);let g=class extends f{constructor(b,$,k,S){super(new m.$CR(m.SaveStrategy.IMMEDIATE,$,S,k),b,$,k,S)}async init(){return await this.$.init(),super.init()}};e.$FR=g,e.$FR=g=Se([se(0,I.$Jl),se(1,r.$Mi),se(2,P.$_k),se(3,D.$_j)],g)}),define(ce[58],le([0,1,38,14,6,5,41,42,251,34]),function(x,e,n,r,P,D,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=void 0,e.$Rfc=(0,P.$Fi)(I.$Ll);let m=class extends p.$ER{constructor(d,w,f,g,v){super(d,w,f,g,v)}getAssociatedEmptyWindows(){const d=[];for(const w of this.C.emptyWindows.keys())d.push({id:w});return d}};e.$Sfc=m,e.$Sfc=m=Se([se(0,c.$zR),se(1,T.$Jl),se(2,n.$Mi),se(3,r.$_k),se(4,D.$_j)],m)}),define(ce[134],le([0,1,18,7,30]),function(x,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=D,e.$Ufc=T,e.$Vfc=I;async function D(p,c,m){for(const d of p){const w=d.openedWorkspace;if((0,P.$Ti)(w)){const f=await m(w);if(f){if(f.folders.some(g=>n.$9g.isEqualOrParent(c,g.uri)))return d}else if(n.$9g.isEqualOrParent(c,w.configPath))return d}}const h=p.filter(d=>(0,P.$Oi)(d.openedWorkspace)&&n.$9g.isEqualOrParent(c,d.openedWorkspace.uri));if(h.length)return h.sort((d,w)=>-(d.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function T(p,c){for(const m of p)if((0,P.$Ti)(m.openedWorkspace)&&n.$9g.isEqual(m.openedWorkspace.configPath,c)||(0,P.$Oi)(m.openedWorkspace)&&n.$9g.isEqual(m.openedWorkspace.uri,c))return m}function I(p,c){const m=h=>c.some(d=>n.$9g.isEqual(r.URI.file(d),r.URI.file(h)));for(const h of p)if(h.config?.extensionDevelopmentPath?.some(d=>m(d)))return h}}),define(ce[102],le([0,1,32,43,107,47,11,9,3,18,7,6,74,30]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bib=void 0,e.$cib=f,e.$dib=g,e.$eib=v,e.$fib=b,e.$gib=S,e.$hib=u,e.$iib=i,e.$jib=E,e.$kib=y,r=Pe(r),P=Pe(P),e.$bib=(0,h.$Ei)("workspacesService");function f(R){return R.hasOwnProperty("workspace")}function g(R){return R.hasOwnProperty("folderUri")}function v(R){return R.hasOwnProperty("fileUri")}function b(R){return $(R)||k(R)}function $(R){const L=R;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function k(R){const L=R;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function S(R,L,A,O,M){if(R.scheme!==O.scheme)return{name:A,uri:R.toString(!0)};let H=L?void 0:M.relativePath(O,R);if(H!==void 0)H.length===0?H=".":p.$j&&(H=t(H));else if(R.scheme===T.Schemas.file)H=R.fsPath,p.$j&&(H=t(H));else if(M.isEqualAuthority(R.authority,O.authority))H=R.path;else return{name:A,uri:R.toString(!0)};return{name:A,path:H}}function t(R){return R=(0,D.$Zw)(R),(0,n.$Ag)(R)||(R=(0,n.$xg)(R)),R}function u(R,L,A){const O=[],M=new Set,H=A.dirname(L);for(const q of R){let K;if($(q))q.path&&(K=A.resolvePath(H,q.path));else if(k(q))try{K=m.URI.parse(q.uri),K.path[0]!==I.$gc.sep&&(K=K.with({path:I.$gc.sep+K.path}))}catch(de){console.warn(de)}if(K){const de=A.getComparisonKey(K);if(!M.has(de)){M.add(de);const Y=q.name||A.basenameOrAuthority(K);O.push(new w.$Yi({uri:K,name:Y,index:O.length},q))}}}return O}function i(R,L,A,O,M){const H=o(L,R),q=M.dirname(L),K=M.dirname(O),de=[];for(const Z of H.folders){const W=$(Z)?M.resolvePath(q,Z.path):m.URI.parse(Z.uri);let j;A?j=!1:j=!$(Z)||(0,I.$ic)(Z.path),de.push(S(W,j,Z.name,K,M))}const Y={insertSpaces:!1,tabSize:4,eol:p.$l||p.$k?`
`:`\r
`},J=P.$_n(R,["folders"],de,Y);let U=P.$co(R,J);return(0,c.$kh)(H.remoteAuthority,(0,d.$gn)(O))&&(U=P.$co(U,P.$$n(U,["remoteAuthority"],Y))),U}function o(R,L){const A=r.$Xn(L);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(O=>b(O));else throw new Error(`${R} looks like an invalid workspace file.`);return A}function s(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function a(R){return typeof R.folderUri=="string"}function l(R){return typeof R.fileUri=="string"}function E(R,L){const A={workspaces:[],files:[]};if(R){const O=function(H,q){for(let K=0;K<H.length;K++)try{q(H[K],K)}catch(de){L.warn(`Error restoring recent entry ${JSON.stringify(H[K])}: ${de.toString()}. Skip entry.`)}},M=R;Array.isArray(M.entries)&&O(M.entries,H=>{const q=H.label,K=H.remoteAuthority;s(H)?A.workspaces.push({label:q,remoteAuthority:K,workspace:{id:H.workspace.id,configPath:m.URI.parse(H.workspace.configPath)}}):a(H)?A.workspaces.push({label:q,remoteAuthority:K,folderUri:m.URI.parse(H.folderUri)}):l(H)&&A.files.push({label:q,remoteAuthority:K,fileUri:m.URI.parse(H.fileUri)})})}return A}function y(R){const L={entries:[]};for(const A of R.workspaces)g(A)?L.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):L.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of R.files)L.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return L}}),define(ce[103],le([0,1,91,11,3,18]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=void 0,e.$Xfc=T,e.$Yfc=I,e.$Zfc=p,e.$Wfc=128/4;function T(c){function m(){let h=c.scheme===r.Schemas.file?(0,D.$6g)(c):c.toString();return P.$l||(h=h.toLowerCase()),(0,n.createHash)("md5").update(h).digest("hex")}return{id:m(),configPath:c}}function I(c,m){function h(){if(c.scheme!==r.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let w;return P.$l?w=m.ino:P.$k?w=m.birthtime.getTime():P.$j&&(typeof m.birthtimeMs=="number"?w=Math.floor(m.birthtimeMs):w=m.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(w?String(w):"").digest("hex")}const d=h();if(typeof d=="string")return{id:d,uri:c}}function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[104],le([0,1,91,93,27,252,17,15,4,2,9,3,33,44,117]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$vi=e.$ui=e.$ti=void 0,e.$wi=s,e.$xi=a,e.$zi=y,e.$Ai=R;const g=3e4;class v{traceSocketEvent(A,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,O)}constructor(A,O=""){this.f=!0,this.debugLabel=O,this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=H=>{if(this.traceSocketEvent(f.SocketDiagnosticsEventType.Error,{code:H?.code,message:H?.message}),H){if(H.code==="EPIPE")return;(0,I.$Y)(H)}},this.socket.on("error",this.a);let M;this.b=H=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Close,{hadError:H}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>A.destroy(),g)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(A){const O=M=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Read,M),A(T.$Ne.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(A){const O=M=>{A({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(A){const O=()=>{A()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(A){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(f.SocketDiagnosticsEventType.Write,A),this.socket.write(A.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}}end(){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((A,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ti=v;var b;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var $;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})($||($={}));class k extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(A,O){this.socket.traceSocketEvent(A,O)}constructor(A,O,M,H){super(),this.f=this.B(new p.$le),this.g=this.B(new p.$le),this.h=!1,this.j={state:$.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:H}),this.a=this.B(new S(this,O,M,H,this.f,(q,K)=>this.m(q,K))),this.B(this.a.onError(q=>{console.error(q),(0,I.$Y)(q),this.g.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:q})})),this.b=new f.$oi,this.B(this.socket.onData(q=>this.n(q))),this.B(this.socket.onClose(async q=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this.f.event(A)}onClose(A){return this.g.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){let O=0;for(;O<A.byteLength;)this.a.writeMessage(A.slice(O,Math.min(O+b.MaxWebSocketMessageLength,A.byteLength)),{compressed:!0,opcode:2}),O+=b.MaxWebSocketMessageLength}m(A,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,A);let H=b.MinHeaderByteSize;A.byteLength<126?H+=0:A.byteLength<2**16?H+=2:H+=8;const q=T.$Ne.alloc(H),K=O?64:0,de=M&15;if(q.writeUInt8(128|K|de,0),A.byteLength<126)q.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){q.writeUInt8(126,1);let Y=1;q.writeUInt8(A.byteLength>>>8&255,++Y),q.writeUInt8(A.byteLength>>>0&255,++Y)}else{q.writeUInt8(127,1);let Y=1;q.writeUInt8(0,++Y),q.writeUInt8(0,++Y),q.writeUInt8(0,++Y),q.writeUInt8(0,++Y),q.writeUInt8(A.byteLength>>>24&255,++Y),q.writeUInt8(A.byteLength>>>16&255,++Y),q.writeUInt8(A.byteLength>>>8&255,++Y),q.writeUInt8(A.byteLength>>>0&255,++Y)}this.socket.write(T.$Ne.concat([q,A]))}end(){this.h=!0,this.socket.end()}n(A){if(A.byteLength!==0){for(this.b.acceptChunk(A);this.b.byteLength>=this.j.readLen;)if(this.j.state===$.PeekHeader){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),H=(M&128)>>>7,q=(M&64)>>>6,K=M&15,de=O.readUInt8(1),Y=(de&128)>>>7,J=de&127;this.j.state=$.ReadHeader,this.j.readLen=b.MinHeaderByteSize+(Y?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=H,this.j.firstFrameOfMessage&&(this.j.compressed=!!q),this.j.firstFrameOfMessage=!!H,this.j.mask=0,this.j.opcode=K,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===$.ReadHeader){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),H=(M&128)>>>7;let q=M&127,K=1;q===126?q=O.readUInt8(++K)*2**8+O.readUInt8(++K):q===127&&(q=O.readUInt8(++K)*0+O.readUInt8(++K)*0+O.readUInt8(++K)*0+O.readUInt8(++K)*0+O.readUInt8(++K)*2**24+O.readUInt8(++K)*2**16+O.readUInt8(++K)*2**8+O.readUInt8(++K));let de=0;H&&(de=O.readUInt8(++K)*2**24+O.readUInt8(++K)*2**16+O.readUInt8(++K)*2**8+O.readUInt8(++K)),this.j.state=$.ReadBody,this.j.readLen=q,this.j.mask=de,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===$.ReadBody){const O=this.b.read(this.j.readLen);this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,O),i(O,this.j.mask),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,O),this.j.state=$.PeekHeader,this.j.readLen=b.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$ui=k;class S extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Ne.alloc(0)}constructor(A,O,M,H,q,K){super(),this.n=A,this.r=q,this.s=K,this.a=this.B(new p.$le),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$le),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$le),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new t(this.n,H,M,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(de=>this.a.fire(de))),this.B(this.f.onError(de=>this.a.fire(de)))):(this.b=null,this.f=null)}writeMessage(A,O){this.g.push({data:A,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:A,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,A);this.s(M,O)}else this.s(A,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(A,O){return new Promise((M,H)=>{A.write(O),A.flush(q=>M(q))})}acceptFrame(A,O,M){this.h.push({data:A,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const A=this.h.shift();if(this.b&&A.isCompressed){const O=await this.C(this.b,A.data,A.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(A.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(A,O,M){return new Promise((H,q)=>{A.write(O),M&&A.write(T.$Ne.fromByteArray([0,0,255,255])),A.flush(K=>H(K))})}}class t extends c.$Uc{get recordedInflateBytes(){return this.j?T.$Ne.concat(this.f):T.$Ne.alloc(0)}constructor(A,O,M,H){super(),this.h=A,this.j=O,this.a=this.B(new p.$le),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(H),this.b.on("error",q=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateError,{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateData,q),this.g.push(T.$Ne.wrap(q))}),M&&(this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(A){this.j&&this.f.push(A.clone()),this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateWrite,A),this.b.write(A.buffer)}flush(A){this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateFlushFired);const O=T.$Ne.concat(this.g);this.g.length=0,A(O)})}}class u extends c.$Uc{constructor(A,O){super(),this.g=A,this.a=this.B(new p.$le),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(T.$Ne.wrap(M))})}write(A){this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateWrite,A.buffer),this.b.write(A.buffer)}flush(A){this.b.flush(2,()=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateFlushFired);let O=T.$Ne.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),A(O)})}}function i(L,A){if(A===0)return;const O=L.byteLength>>>2;for(let Y=0;Y<O;Y++){const J=L.readUInt32BE(Y*4);L.writeUInt32BE(J^A,Y*4)}const M=O*4,H=L.byteLength-M,q=A>>>24&255,K=A>>>16&255,de=A>>>8&255;H>=1&&L.writeUInt8(L.readUInt8(M)^q,M),H>=2&&L.writeUInt8(L.readUInt8(M+1)^K,M+1),H>=3&&L.writeUInt8(L.readUInt8(M+2)^de,M+2)}e.$vi=process.env.XDG_RUNTIME_DIR;const o={[h.Platform.Linux]:107,[h.Platform.Mac]:103};function s(){const L=(0,d.$1g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const A=process.platform!=="darwin"&&e.$vi?e.$vi:(0,P.tmpdir)(),O=(0,m.$jc)(A,`vscode-ipc-${L}.sock`);return l(O),O}function a(L,A,O){const H=(0,n.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${H}-${O}-${A}-sock`;const q=O.substr(0,4),K=A.substr(0,6);let de;return process.platform!=="darwin"&&e.$vi&&!process.env.VSCODE_PORTABLE?de=(0,m.$jc)(e.$vi,`vscode-${H}-${q}-${K}.sock`):de=(0,m.$jc)(L,`${q}-${K}.sock`),l(de),de}function l(L){const A=o[h.$v];typeof A=="number"&&L.length>=A&&console.warn(`WARNING: IPC handle "${L}" is longer than ${A} chars, try a shorter --user-data-dir`)}class E extends w.$ii{static b(A){const O=p.Event.fromNodeEventEmitter(A,"connection");return p.Event.map(O,M=>({protocol:new f.$pi(new v(M,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(M,"close"))}))}constructor(A){super(E.b(A)),this.d=A}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$yi=E;function y(L){return new Promise((A,O)=>{const M=(0,r.createServer)();M.on("error",O),M.listen(L,()=>{M.removeListener("error",O),A(new E(M))})})}function R(L,A){return new Promise((O,M)=>{const H=(0,r.createConnection)(L,()=>{H.removeListener("error",M),O(f.$qi.fromSocket(new v(H,`ipc-client${A}`),A))});H.once("error",M)})}}),define(ce[20],le([0,1,54,9,3,104,38,95,6]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=void 0,e.$Bfc=(0,p.$Fi)(T.$Li);class c extends I.$8m{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,D.$xi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.$l){for(const h in process.env)if(h.endsWith("_VSCODE_SNAP_ORIG")){const d=h.slice(0,-17);if(this.d[d])continue;process.env[d]&&(this.d[d]=process.env[d]),process.env[h]?process.env[d]=process.env[h]:delete process.env[d]}}}restoreSnapExportedVariables(){if(P.$l)for(const h in this.d)process.env[h]=this.d[h],delete this.d[h]}}e.$Cfc=c,Se([n.$9h],c.prototype,"backupHome",null),Se([n.$9h],c.prototype,"mainIPCHandle",null),Se([n.$9h],c.prototype,"mainLockfile",null),Se([n.$9h],c.prototype,"disableUpdates",null),Se([n.$9h],c.prototype,"crossOriginIsolated",null),Se([n.$9h],c.prototype,"codeCachePath",null),Se([n.$9h],c.prototype,"useCodeCache",null)}),define(ce[253],le([0,1,91,32,11,9,3,18,23,165,16,20,34,14,5,164,30,103]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;let k=class{static{$=this}static{this.a="backupWorkspaces"}constructor(t,u,i,o){this.j=t,this.k=u,this.l=i,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$9g,this.i={isEqual:(s,a)=>(0,r.$Cg)(s,a,!T.$l)}}async initialize(){const t=this.m.getItem($.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(t.emptyWindows),this.d=await this.u((0,c.$Gfc)(t)),this.e=await this.v((0,c.$Hfc)(t)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$yl.OFF}q(){return this.s()===w.$yl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$yl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(t,u){this.d.some(o=>t.workspace.id===o.workspace.id)||(this.d.push(t),this.C());const i=(0,D.$jc)(this.c,t.workspace.id);return u?this.t(i,u).then(()=>i):i}async t(t,u){if(await p.Promises.exists(t)&&await this.z(t),await p.Promises.exists(u))try{await p.Promises.rename(u,t,!1)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(t){return this.e.some(u=>this.h.isEqual(t.folderUri,u.folderUri))||(this.e.push(t),this.C()),(0,D.$jc)(this.c,this.D(t))}registerEmptyWindowBackup(t){return this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.backupFolder))||(this.g.push(t),this.C()),(0,D.$jc)(this.c,t.backupFolder)}async u(t){if(!Array.isArray(t))return[];const u=new Set,i=[];for(const o of t){const s=o.workspace;if(!(0,v.$Ti)(s))return[];if(!u.has(s.id)){u.add(s.id);const a=(0,D.$jc)(this.c,s.id);await this.B(a)?s.configPath.scheme!==P.Schemas.file||await p.Promises.exists(s.configPath.fsPath)?i.push(o):await this.z(a):await this.x(a)}}return i}async v(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.folderUri,a=this.h.getComparisonKey(s);if(!i.has(a)){i.add(a);const l=(0,D.$jc)(this.c,this.D(o));await this.B(l)?s.scheme!==P.Schemas.file||await p.Promises.exists(s.fsPath)?u.push(o):await this.z(l):await this.x(l)}}return u}async w(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.backupFolder;if(typeof s!="string")return[];if(!i.has(s)){i.add(s);const a=(0,D.$jc)(this.c,s);await this.B(a)?u.push(o):await this.x(a)}}return u}async x(t){try{await p.Promises.rm(t,p.RimRafMode.MOVE)}catch(u){this.l.error(`Backup: Could not delete stale backup: ${u.toString()}`)}}y(){let t=(0,b.$Zfc)();for(;this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.id));)t=(0,b.$Zfc)();return{backupFolder:t.id}}async z(t){const u=this.y(),i=(0,D.$jc)(this.c,u.backupFolder);try{await p.Promises.rename(t,i,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(u),!0}async getDirtyWorkspaces(){const t=[];for(const u of this.d)await this.A(u)&&t.push(u);for(const u of this.e)await this.A(u)&&t.push(u);return t}A(t){let u;return(0,c.$Ffc)(t)?u=(0,D.$jc)(this.c,t.backupFolder):(0,g.$_hb)(t)?u=(0,D.$jc)(this.c,this.D(t)):u=(0,D.$jc)(this.c,t.workspace.id),this.B(u)}async B(t){try{const u=await p.Promises.readdir(t);for(const i of u)try{if((await p.Promises.readdir((0,D.$jc)(t,i))).length>0)return!0}catch{}}catch{}return!1}C(){const t={workspaces:this.d.map(({workspace:u,remoteAuthority:i})=>{const o={id:u.id,configURIPath:u.configPath.toString()};return i&&(o.remoteAuthority=i),o}),folders:this.e.map(({folderUri:u,remoteAuthority:i})=>{const o={folderUri:u.toString()};return i&&(o.remoteAuthority=i),o}),emptyWindows:this.g.map(({backupFolder:u,remoteAuthority:i})=>{const o={backupFolder:u};return i&&(o.remoteAuthority=i),o})};this.m.setItem($.a,t)}D(t){const u=t.folderUri;let i;return u.scheme===P.Schemas.file?i=T.$l?u.fsPath:u.fsPath.toLowerCase():i=u.toString().toLowerCase(),(0,n.createHash)("md5").update(i).digest("hex")}};e.$hgc=k,e.$hgc=k=$=Se([se(0,h.$Bfc),se(1,m.$$i),se(2,f.$_j),se(3,d.$zR)],k)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[19],le([0,1,13,35,8,4,2,3,36,12,6,5,34,52,20]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.LifecycleMainPhase=e.ShutdownReason=e.$8fc=void 0,n=Ve(n),e.$8fc=(0,m.$Ei)("lifecycleMainService");var v;(function(k){k[k.QUIT=1]="QUIT",k[k.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var b;(function(k){k[k.Starting=1]="Starting",k[k.Ready=2]="Ready",k[k.AfterWindowOpen=3]="AfterWindowOpen",k[k.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let $=class extends T.$Uc{static{g=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(S,t,u){super(),this.F=S,this.G=t,this.H=u,this.c=this.B(new D.$le),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.$le),this.onWillShutdown=this.f.event,this.g=this.B(new D.$le),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.$le),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=b.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(b.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(g.b),this.m&&this.G.removeItem(g.b)}J(){const S=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$k&&this.t===0&&this.L(v.QUIT))};n.default.app.addListener("before-quit",S);const t=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$k)&&n.default.app.quit()};n.default.app.addListener("window-all-closed",t),n.default.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(v.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.default.app.removeListener("before-quit",S),n.default.app.removeListener("window-all-closed",t),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.default.app.quit()})})}L(S){if(this.y)return this.y;const t=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:S,join(i,o){t.trace(`Lifecycle#onWillShutdown - begin '${i}'`),u.push(o.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await P.Promises.settled(u)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===S)return;this.S(`lifecycle (main): phase changed (value: ${S})`),this.n=S;const t=this.C.get(this.n);t&&(t.open(),this.C.delete(this.n))}async when(S){if(S<=this.n)return;let t=this.C.get(S);t||(t=new P.$Dh,this.C.set(S,t)),await t.wait()}registerWindow(S){const t=new T.$Tc;this.t++,t.add(S.onWillLoad(i=>this.g.fire({window:S,workspace:i.workspace,reason:i.reason})));const u=(0,c.$pg)(S.win);t.add(D.Event.fromNodeEventEmitter(u,"close")(i=>{const o=S.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${S.id}`),i.preventDefault(),this.unload(S,w.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(S),S.close()})})),t.add(D.Event.fromNodeEventEmitter(u,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.t--,t.dispose(),this.t===0&&(!I.$k||this.j)&&this.L(v.QUIT)}))}registerAuxWindow(S){const t=(0,c.$pg)(S.win),u=new T.$Tc;u.add(D.Event.fromNodeEventEmitter(t,"close")(i=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${S.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),i.preventDefault())})),u.add(D.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${S.id}`),u.dispose()}))}async reload(S,t){await this.unload(S,w.UnloadReason.RELOAD)||S.reload(t)}unload(S,t){const u=this.z.get(S.id);if(u)return u;const i=this.M(S,t).finally(()=>{this.z.delete(S.id)});return this.z.set(S.id,i),i}async M(S,t){if(!S.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${S.id}`);const u=this.j?w.UnloadReason.QUIT:t,i=await this.P(S,u);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.N(i)):(await this.Q(S,u),!1)}N(S){return S?(this.O(!0),this.j=!1,!0):!1}O(S){this.w&&(this.w(S),this.w=void 0,this.u=void 0)}P(S,t){return new Promise(u=>{const i=this.s++,o=`vscode:ok${i}`,s=`vscode:cancel${i}`;r.$TX.once(o,()=>{u(!1)}),r.$TX.once(s,()=>{u(!0)}),S.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:t})})}Q(S,t){return new Promise(u=>{const o=`vscode:reply${this.s++}`;r.$TX.once(o,()=>u()),S.send("vscode:onWillUnload",{replyChannel:o,reason:t})})}quit(S){return this.R(S).then(t=>{if(!t&&S)try{if(I.$j){const u=(0,p.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return t})}R(S){return this.S(`Lifecycle#quit() - begin (willRestart: ${S})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(S&&this.G.setItem(g.b,!0),this.u=new Promise(t=>{this.w=t,this.S("Lifecycle#quit() - calling app.quit()"),n.default.app.quit()}),this.u)}S(S){this.H.args["enable-smoke-test-driver"]?this.F.info(S):this.F.trace(S)}setRelaunchHandler(S){this.D=S}async relaunch(S){this.S("Lifecycle#relaunch()");const t=process.argv.slice(1);if(S?.addArgs&&t.push(...S.addArgs),S?.removeArgs)for(const o of S.removeArgs){const s=t.indexOf(o);s>=0&&t.splice(s,1)}const u=()=>{this.D?.handleRelaunch(S)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.default.app.relaunch({args:t}))};n.default.app.once("quit",u),await this.quit(!0)&&n.default.app.removeListener("quit",u)}async kill(S){this.S("Lifecycle#kill()"),await this.L(v.KILL),await Promise.race([(0,P.$Fh)(1e3),(async()=>{for(const t of n.default.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let u;t.webContents&&!t.webContents.isDestroyed()?u=new Promise(i=>t.once("closed",i)):u=Promise.resolve(),t.destroy(),await u}})()]),n.default.app.exit(S)}};e.$9fc=$,e.$9fc=$=g=Se([se(0,h.$_j),se(1,d.$zR),se(2,f.$Bfc)],$)}),define(ce[254],le([0,1,3,4,2,6,19]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=void 0,n=Pe(n),e.$Fgc=(0,D.$Ei)("keyboardLayoutMainService");let I=class extends P.$Uc{constructor(m){super(),this.a=this.B(new r.$le),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(T.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((h,d)=>{x(["native-keymap"],h,d)}).then(Pe);this.c=p(m),n.$u||m.onDidChangeKeyboardLayout(()=>{this.c=p(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Ggc=I,e.$Ggc=I=Se([se(0,T.$8fc)],I);function p(c){const m=c.getKeyMap(),h=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:h}}}),define(ce[255],le([0,1,215,8,17,15,12,16,38,100,5,49,214,252]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,e.$fs=v;let f=class extends h.$8p{constructor($,k,S,t){super(t),this.m=$,this.n=k,this.r=S,this.s(),this.B($.onDidChangeConfiguration(u=>{u.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,k){const{f:S,g:t}=this;let u;try{u=await(0,c.$Qm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$9)(s)))}const i={...process.env,...u},o=$.agent?$.agent:await(0,d.$ds)($.url||"",i,{proxyUrl:S,strictSSL:t});return $.agent=o,$.strictSSL=t,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>v($,k))}async resolveProxy($){}async lookupAuthorization($){}async lookupKerberosAuthorization($){try{const k=await new Promise((o,s)=>{x(["kerberos"],o,s)}).then(Pe),S=new URL($),t=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${S.hostname}`:`HTTP@${S.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${S}`,`spn:${t}`),"Negotiate "+await(await k.initializeClient(t)).step("")}catch(k){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",k);return}}async loadCertificates(){return(await new Promise((k,S)=>{x(["@vscode/proxy-agent"],k,S)}).then(Pe)).loadSystemCertificates({log:this.r})}};e.$es=f,e.$es=f=Se([se(0,I.$$i),se(1,p.$Mi),se(2,m.$_j),se(3,m.$ak)],f);async function g(b){return((0,n.parse)(b.url).protocol==="https:"?await new Promise((S,t)=>{x(["https"],S,t)}).then(Pe):await new Promise((S,t)=>{x(["http"],S,t)}).then(Pe)).request}async function v(b,$){return r.Promises.withAsyncBody(async(k,S)=>{const t=(0,n.parse)(b.url),u=b.getRawRequest?b.getRawRequest(b):await g(b),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,T.$kg)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(i.auth=b.user+":"+b.password);const o=u(i,s=>{const a=(0,T.$ig)(b.followRedirects)?b.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&a>0&&s.headers.location)v({...b,url:s.headers.location,followRedirects:a-1},$).then(k,S);else{let l=s;!b.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,w.createGunzip)())),k({res:s,stream:(0,P.$3e)(l)})}});o.on("error",S),b.timeout&&o.setTimeout(b.timeout),b.isChromiumNetwork&&o.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),$.onCancellationRequested(()=>{o.abort(),S(new D.$4)})})}}),define(ce[256],le([0,1,13,255]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;function P(T){return n.net.request}class D extends r.$es{request(I,p){return super.request({...I||{},getRawRequest:P,isChromiumNetwork:!0},p)}}e.$Khc=D}),define(ce[87],le([0,1,7,4,2,38,14,6,19,5,62,249,42,58,41,11]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=e.$dgc=e.$cgc=e.$bgc=void 0,e.$bgc=(0,I.$Ei)("storageMainService");let v=class extends P.$Uc{constructor(k,S,t,u,i,o){super(),this.c=k,this.f=S,this.g=t,this.h=u,this.j=i,this.m=o,this.a=void 0,this.b=this.B(new r.$le),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(p.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)k.join("profileStorage",S.close());for(const[,S]of this.w)k.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.j.exists(k.profile.globalStorageHome)||await this.j.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const S=this.t.get(k.profile.id);S&&k.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const k=new h.$$fc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),k}profileStorage(k){if((0,m.$kq)(k))return this.applicationStorage;let S=this.t.get(k.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),S=this.B(this.u(k)),this.t.set(k.id,S);const t=this.B(S.onDidChangeStorage(u=>this.b.fire({...u,storage:S,profile:k})));this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.t.delete(k.id),t.dispose()}))}return S}u(k){return this.a===p.ShutdownReason.KILL?new h.$agc(this.c,this.j):new h.$0fc(k,this.n(),this.c,this.j)}workspaceStorage(k){let S=this.w.get(k.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),S=this.B(this.y(k)),this.w.set(k.id,S),this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.w.delete(k.id)}))),S}y(k){return this.a===p.ShutdownReason.KILL?new h.$agc(this.c,this.j):new h.$_fc(k,this.n(),this.c,this.f,this.j)}isUsed(k){const S=n.URI.file(k);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(n.URI.file(t.path),S))return!0;return!1}};e.$cgc=v,e.$cgc=v=Se([se(0,c.$_j),se(1,D.$Li),se(2,w.$Rfc),se(3,p.$8fc),se(4,T.$_k),se(5,f.$Jl)],v),e.$dgc=(0,I.$Ei)("applicationStorageMainService");let b=class extends m.$jq{constructor(k,S){super(),this.s=k,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(k){if(k===m.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(k){if(k===m.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$egc=b,e.$egc=b=Se([se(0,d.$Ll),se(1,e.$bgc)],b)}),define(ce[257],le([0,1,93,27,113,104,8,2,3,16,5,28,208,211,101,131,17]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=e.$Hhc=e.$Ghc=void 0,n=Pe(n),r=Pe(r);async function b(u,i,o,s,a){let l;for(let E=3;E&&(l?.dispose(),l=await new $(u,i,o,s,a).waitForReady(),!(a&&P.$4g[a]||!P.$4g[l.tunnelLocalPort]));E--);return l}class $ extends I.$Uc{constructor(i,o,s,a,l){super(),this.m=o,this.n=l,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=n.createServer(),this.c=new T.$Dh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=E=>this.r(E),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,o=(0,g.$Lw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,P.$5g)(i,2,1e3,o),a=null;return this.b.listen(s,this.m),await this.c.wait(),a=this.b.address(),a||(s=0,this.b.listen(s,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(i){i.pause();const o=(0,g.$Jw)(this.tunnelRemoteHost)||(0,g.$Lw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,d.$2l)(this.a,o,this.tunnelRemotePort),a=s.getSocket(),l=s.readEntireBuffer();s.dispose(),l.byteLength>0&&i.write(l.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),a.end()}),i.on("close",()=>a.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),a instanceof D.$ti?a.socket.destroy():a.end()}),a instanceof D.$ti?this.t(i,a):this.s(i,a),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),a.end()})}s(i,o){o.onClose(()=>i.destroy()),o.onEnd(()=>i.end()),o.onData(s=>i.write(s.buffer)),i.on("data",s=>o.write(v.$Ne.wrap(s))),i.resume()}t(i,o){const s=o.socket;s.on("end",()=>i.end()),s.on("close",()=>i.end()),s.on("error",()=>{i.destroy()}),s.pipe(i),i.pipe(s)}}e.$Ghc=$;let k=class extends g.$Ow{constructor(i,o,s,a,l){super(o,l),this.H=i,this.I=s,this.J=a}isPortPrivileged(i){return(0,g.$Mw)(i,this.t,p.OS,r.release())}F(i,o,s,a,l,E,y,R){const L=this.D(o,s);if(L)return++L.refcount,L.value;if((0,g.$Fw)(i))return this.G(i,o,s,l,E,y,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${s} on local port ${l}.`);const A={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},O=b(A,a,o,s,l);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,s,O),O}}};e.$Hhc=k,e.$Hhc=k=Se([se(0,w.$Vl),se(1,m.$_j),se(2,f.$Yl),se(3,h.$sk),se(4,c.$$i)],k);let S=class extends k{constructor(i,o,s,a,l){super(i,o,s,a,l)}};e.$Ihc=S,e.$Ihc=S=Se([se(0,w.$Vl),se(1,m.$_j),se(2,f.$Yl),se(3,h.$sk),se(4,c.$$i)],S);let t=class extends I.$Uc{constructor(i,o,s,a,l){super(),this.b=i,this.c=o,this.f=s,this.g=a,this.h=l,this.a=new Map}async openTunnel(i,o,s,a,l,E,y,R,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${a} on local port ${E}.`),!this.a.has(i)){const A=new S(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(i,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(o,s,a,l,E,y,R,L)}};e.$Jhc=t,e.$Jhc=t=Se([se(0,w.$Vl),se(1,m.$_j),se(2,h.$sk),se(3,f.$Yl),se(4,c.$$i)],t)}),define(ce[105],le([0,1,8,22,4,16,20,19,5,28,49,50]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0,e.$3gc=d;function d(f,g,v){return`${v.updateUrl}/api/update/${f}/${g}/${v.commit}`}let w=class{get state(){return this.b}d(g){this.j.info("update#setState",g.type),this.b=g,this.c.fire(g)}constructor(g,v,b,$,k,S){this.f=g,this.g=v,this.h=b,this.i=$,this.j=k,this.k=S,this.b=h.$RY.Uninitialized,this.c=new P.$le,this.onStateChange=this.c.event,g.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(h.$RY.Disabled(h.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(h.$RY.Disabled(h.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(h.$RY.Disabled(h.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.g.getValue("update.mode"),v=this.m(g);if(!v){this.d(h.$RY.Disabled(h.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(v),!this.a){this.d(h.$RY.Disabled(h.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const b=new URL(this.a);b.searchParams.set("prss","true"),this.a=b.toString()}if(this.d(h.$RY.Idle(this.q())),g==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,b=>this.j.error(b))}m(g){return g==="none"?void 0:this.k.quality}n(g=60*60*1e3){return(0,n.$Fh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(g){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.t(g)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.o(this.state)}async o(g){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(v){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(v);return}}async _applySpecificUpdate(g){}q(){return h.UpdateType.Archive}r(){}};e.$4gc=w,e.$4gc=w=Se([se(0,I.$8fc),se(1,D.$$i),se(2,T.$Bfc),se(3,m.$7p),se(4,p.$_j),se(5,c.$sk)],w)}),define(ce[258],le([0,1,13,54,4,46,2,16,20,19,5,28,49,24,50,105]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0,n=Pe(n);let v=class extends g.$4gc{get v(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"error",($,k)=>k)}get w(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",($,k,S,t)=>({version:S,productVersion:S,timestamp:t}))}constructor($,k,S,t,u,i,o){super($,k,t,u,i,o),this.z=S,this.u=new T.$Tc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!==f.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.z.publicLog2("update:error",{messageHash:String((0,D.$sj)(String($)))}),this.j.error("UpdateService error:",$);const k=this.state.type===f.StateType.CheckingForUpdates&&this.state.explicit?$:void 0;this.d(f.$RY.Idle(f.UpdateType.Archive,k))}s($){let k;this.k.darwinUniversalAssetId?k=this.k.darwinUniversalAssetId:k=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,g.$3gc)(k,$,this.k);try{n.autoUpdater.setFeedURL({url:S})}catch(t){this.j.error("Failed to set update feed URL",t);return}return S}t($){this.d(f.$RY.CheckingForUpdates($)),n.autoUpdater.checkForUpdates()}E(){this.state.type===f.StateType.CheckingForUpdates&&this.d(f.$RY.Downloading)}F($){this.state.type===f.StateType.Downloading&&(this.d(f.$RY.Downloaded($)),this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$RY.Ready($)))}G(){this.state.type===f.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$RY.Idle(f.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$5gc=v,Se([r.$9h],v.prototype,"v",null),Se([r.$9h],v.prototype,"w",null),Se([r.$9h],v.prototype,"x",null),Se([r.$9h],v.prototype,"y",null),e.$5gc=v=Se([se(0,c.$8fc),se(1,I.$$i),se(2,w.$$l),se(3,p.$Bfc),se(4,d.$7p),se(5,m.$_j),se(6,h.$sk)],v)}),define(ce[259],le([0,1,48,26,8,4,9,20,19,5,24,50]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0,T=Pe(T);let d=class{get state(){return this.a}d(g){this.g.info("update#setState",g.type),this.a=g,this.b.fire(g)}constructor(g,v,b){if(this.f=g,this.g=b,this.a=h.$RY.Uninitialized,this.b=new D.$le,this.onStateChange=this.b.event,v.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(h.$RY.Idle(this.k())),this.h(30*1e3).then(void 0,$=>this.g.error($))}h(g=60*60*1e3){return(0,P.$Fh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(g){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.m(g)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.i(this.state)}i(g){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return h.UpdateType.Snap}l(){}async _applySpecificUpdate(g){}};d=Se([se(0,p.$8fc),se(1,I.$Bfc),se(2,c.$_j)],d);let w=class extends d{constructor(g,v,b,$,k,S){super(b,$,k),this.o=g,this.p=v,this.q=S;const t=(0,r.watch)(T.$mc(this.o)),u=D.Event.fromNodeEventEmitter(t,"change",(a,l)=>l),i=D.Event.filter(u,a=>a==="current"),s=D.Event.debounce(i,(a,l)=>l,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{s.dispose(),t.close()})}m(){this.d(h.$RY.CheckingForUpdates(!1)),this.u().then(g=>{g?this.d(h.$RY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$RY.Idle(h.UpdateType.Snap)))},g=>{this.g.error(g),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$RY.Idle(h.UpdateType.Snap,g.message||g))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+T.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const g=await new Promise((b,$)=>(0,r.realpath)(`${T.$mc(this.o)}/current`,(k,S)=>k?$(k):b(S))),v=T.$nc(g);return this.p!==v}isLatestVersion(){return this.u().then(void 0,g=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$7gc=w,e.$7gc=w=Se([se(2,p.$8fc),se(3,I.$Bfc),se(4,c.$_j),se(5,m.$$l)],w)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[29],le([0,1,13,3,6,52,51,76,28,16,20,9,140]),function(x,e,n,r,P,D,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Ofc=void 0,e.$Pfc=f,e.$Qfc=g,n=Ve(n),e.$Ofc=(0,P.$Ei)("windowsMainService");var w;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API"})(w||(e.OpenContext=w={}));function f(b,$,k){const S=b.get(I.$Mfc),t=b.get(p.$sk),u=b.get(c.$$i),i=b.get(m.$Bfc),o=u.getValue("window"),s={backgroundColor:S.getBackgroundColor(),minWidth:T.$7D.WIDTH,minHeight:T.$7D.HEIGHT,title:t.nameLong,show:$.mode!==D.WindowMode.Maximized&&$.mode!==D.WindowMode.Fullscreen,x:$.x,y:$.y,width:$.width,height:$.height,webPreferences:{...k,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,T.$gE)($.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(r.$l?s.icon=(0,h.$jc)(i.appRoot,"resources/linux/code.png"):r.$j&&!i.isBuilt&&(s.icon=(0,h.$jc)(i.appRoot,"resources/win32/code_150x150.png")),r.$k&&(s.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),r.$k&&!(0,T.$fE)(u)&&(s.fullscreenable=!1),r.$k&&o?.nativeTabs===!0&&(s.tabbingIdentifier=t.nameShort),!(0,T.$bE)(u)&&(s.titleBarStyle="hidden",r.$k||(s.frame=!1),(0,T.$eE)(u))){const E=S.getWindowSplash()?.colorInfo.titleBarBackground??S.getBackgroundColor(),y=d.$nu.fromHex(E).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:E,symbolColor:y}}return s}function g(b){let $,k=Number.MIN_VALUE;for(const S of b)S.lastFocusTime>k&&(k=S.lastFocusTime,$=S);return $}var v;(function(b){function $(S,t,u=n.default.screen.getAllDisplays()){if(S.trace(`window#validateWindowState: validating window state on ${u.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){S.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){S.trace("window#validateWindowState: unexpected negative values");return}if(u.length===1){const s=k(u[0]);if(S.trace("window#validateWindowState: single monitor working area",s),s){let a=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!s||(t.x<s.x&&(t.x=s.x),t.y<s.y&&(t.y=s.y))};a(),t.width>s.width&&(t.width=s.width),t.height>s.height&&(t.height=s.height),t.x>s.x+s.width-128&&(t.x=s.x+s.width-t.width),t.y>s.y+s.height-128&&(t.y=s.y+s.height-t.height),a()}return t}if(t.display&&t.mode===D.WindowMode.Fullscreen){const s=u.find(a=>a.id===t.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){S.trace("window#validateWindowState: restoring fullscreen to previous display");const a=(0,D.$Dfc)(D.WindowMode.Fullscreen);return a.x=s.bounds.x,a.y=s.bounds.y,a}}let i,o;try{i=n.default.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),o=k(i),S.trace("window#validateWindowState: multi-monitor working area",o)}catch(s){S.error("window#validateWindowState: error finding display for window state",s)}if(i&&o&&t.x+t.width>o.x&&t.y+t.height>o.y&&t.x<o.x+o.width&&t.y<o.y+o.height)return t;S.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=$;function k(S){if(S.workArea.width>0&&S.workArea.height>0)return S.workArea;if(S.bounds.width>0&&S.bounds.height>0)return S.bounds}})(v||(e.WindowStateValidator=v={}))}),define(ce[260],le([0,1,93,167,120,29]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class T extends r.$Yo{constructor(p){super(),this.f=p}call(p,c,m){return c==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(p,c,m)}async g(p,c){const m=(0,P.$Cm)(p,P.$Bm);m.debugRenderer=c;const h=m.extensionDevelopmentPath;if(!h)return{success:!1};const[d]=await this.f.openExtensionDevelopmentHostWindow(h,{context:D.OpenContext.API,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!c)return{success:!0};const w=d.win;if(!w)return{success:!0};const f=w.webContents.debugger;let g=f.isAttached()?1/0:0;const v=(0,n.createServer)(b=>{g++===0&&f.attach();let $=!1;const k=u=>{$||b.write(JSON.stringify(u)+"\0")},S=(u,i,o,s)=>k({method:i,params:o,sessionId:s});w.on("close",()=>{f.removeListener("message",S),b.end(),$=!0}),f.addListener("message",S);let t=Buffer.alloc(0);b.on("data",u=>{t=Buffer.concat([t,u]);for(let i=t.indexOf(0);i!==-1;i=t.indexOf(0)){let o;try{const s=t.slice(0,i).toString("utf8");t=t.slice(i+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(o.method,o.params,o.sessionId).then(s=>k({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>k({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{$=!0,--g===0&&f.detach()})});return await new Promise(b=>v.listen(0,b)),w.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$igc=T}),define(ce[261],le([0,1,13,21,3,7,23,16,68,6,5,132,29]),function(x,e,n,r,P,D,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=e.$Igc=e.ID=void 0,e.ID="launchMainService",e.$Igc=(0,c.$Ei)(e.ID);let w=class{constructor(g,v,b,$){this.a=g,this.b=v,this.c=b,this.d=$}async start(g,v){this.a.trace("Received data from other instance: ",g,v),P.$k&&n.app.focus({steal:!0});const b=this.e(g);if(b.length){let $=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,r.$Nb)(await this.b.openEmptyWindow({context:d.OpenContext.DESKTOP}));k&&($=k.ready())}$.then(()=>{for(const{uri:k,originalUrl:S}of b)this.c.open(k,{originalUrl:S})})}else return this.f(g,v)}e(g){return g["open-url"]&&g._urls&&g._urls.length>0?(0,r.$Gb)(g._urls.map(v=>{try{return{uri:D.URI.parse(v),originalUrl:v}}catch{return null}})):[]}async f(g,v){const b=(0,p.$Jm)(v)?d.OpenContext.CLI:d.OpenContext.DESKTOP;let $=[];const k=g.wait&&g.waitMarkerFilePath?D.URI.file(g.waitMarkerFilePath):void 0,S=g.remote||void 0,t={context:b,cli:g,userEnv:g["preserve-env"]||b===d.OpenContext.CLI?v:void 0,waitMarkerFileURI:k,remoteAuthority:S,forceProfile:g.profile,forceTempProfile:g["profile-temp"]};if(g.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(g.extensionDevelopmentPath,t);else if(!g._.length&&!g["folder-uri"]&&!g["file-uri"]){let u=!1;if(g["new-window"]||t.forceProfile||t.forceTempProfile)u=!0;else if(g["reuse-window"])u=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!P.$k}if(u)$=await this.b.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const i=this.b.getLastActiveWindow();i?(this.b.openExistingWindow(i,t),$=[i]):$=await this.b.open({...t,forceEmpty:!0})}}else $=await this.b.open({...t,forceNewWindow:g["new-window"],preferNewWindow:!g["reuse-window"]&&!g.wait,forceReuseWindow:g["reuse-window"],diffMode:g.diff,mergeMode:g.merge,addMode:g.add,noRecentEntry:!!g["skip-add-to-recently-opened"],gotoLineMode:g.goto});if(k&&$.length===1&&$[0])return Promise.race([$[0].whenClosedOrLoaded,(0,T.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Jgc=w,e.$Jgc=w=Se([se(0,m.$_j),se(1,d.$Ofc),se(2,h.$IY),se(3,I.$$i)],w)}),define(ce[135],le([0,1,13,22,4,46,2,7,33,16,97,20,6,5,62,87,29]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=void 0,e.$fgc=(0,d.$Ei)("proxyAuthService");let b=class extends T.$Uc{constructor(k,S,t,u,i,o){super(),this.h=k,this.m=S,this.n=t,this.r=u,this.s=i,this.t=o,this.a="proxy-credentials://",this.b=new Map,this.c=void 0,this.f=new Set,this.g=new Map,this.u()}u(){const k=P.Event.fromNodeEventEmitter(n.app,"login",(S,t,u,i,o)=>({event:S,authInfo:{...i,attempt:u.firstAuthAttempt?1:2},callback:o}));this.B(k(this.w,this))}async lookupAuthorization(k){return this.w({authInfo:k})}async w({event:k,authInfo:S,callback:t}){if(!S.isProxy)return;k?.preventDefault();const u=String((0,D.$sj)({scheme:S.scheme,host:S.host,port:S.port}));let i,o=this.b.get(u);if(o)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),i=await o;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.y(S,u),this.b.set(u,o);try{i=await o}finally{this.b.delete(u)}}return t?.(i?.username,i?.password),i}async y(k,S){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const t=await this.z(k,S);if(t)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),t;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async z(k,S){if(this.h.trace("auth#doResolveProxyCredentials - enter",k),this.t.extensionTestsLocationURI){const l=this.s.getValue("integration-test.http.proxyAuth");if(l){const E=l.indexOf(":");return E!==-1?{username:l.substring(0,E),password:l.substring(E+1)}:{username:l,password:""}}return}const t=(this.s.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(t?.indexOf("@")!==-1){const l=I.URI.parse(t),E=l.authority.indexOf("@");if(E!==-1){if(k.attempt>1){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const y=l.authority.substring(0,E),R=y.indexOf(":");return R!==-1?{username:y.substring(0,R),password:y.substring(R+1)}:{username:y,password:""}}}const u=k.attempt===1&&this.g.get(S);if(u){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:l,password:E}=u;return{username:l,password:E}}let i,o;try{const l=this.r.get(this.a+S,f.StorageScope.APPLICATION);if(l){const E=JSON.parse(await this.n.decrypt(l));i=E.username,o=E.password}}catch(l){this.h.error(l)}if(k.attempt===1&&typeof i=="string"&&typeof o=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.g.set(S,{username:i,password:o}),{username:i,password:o};const s=this.c,a=this.c=(async()=>{await s;const l=await this.C(k,S,i,o);return this.c===a&&(this.c=void 0),l})();return a}async C(k,S,t,u){if(this.f.has(S)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const i=this.m.getFocusedWindow()||this.m.getLastActiveWindow();if(!i){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${i.id} to handle proxy login`);const o=this.g.get(S),s={authInfo:k,username:o?.username??t,password:o?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,p.$1g)()}`};i.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,s);const a=await new Promise(l=>{const E=async(y,R,L)=>{if(R===s.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${i.id}`),i.win?.webContents.off("ipc-message",E),L){const A={username:L.username,password:L.password};try{if(L.remember){const O=await this.n.encrypt(JSON.stringify(A));this.r.store(this.a+S,O,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.r.remove(this.a+S,f.StorageScope.APPLICATION)}catch(O){this.h.error(O)}l({username:A.username,password:A.password})}else this.f.add(S),l(void 0)};i.win?.webContents.on("ipc-message",E)});return this.g.set(S,a),a}};e.$ggc=b,e.$ggc=b=Se([se(0,w.$_j),se(1,v.$Ofc),se(2,m.$CY),se(3,g.$dgc),se(4,c.$$i),se(5,h.$Bfc)],b)}),define(ce[262],le([0,1,2,19,52,58,30,8,29]),function(x,e,n,r,P,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;let c=class extends n.$Uc{constructor(h,d,w){super(),this.a=d,this.b=w,this.B(h.onWillLoadWindow(f=>{f.reason===P.LoadReason.LOAD&&this.c(f.window)})),this.B(h.onBeforeCloseWindow(f=>this.c(f))),this.B(new I.$Qh(()=>this.g(),30*1e3)).schedule()}async c(h){const d=this.f(h),w=this.a.getProfileForWorkspace(d);w?.isTransient&&(this.a.unsetWorkspace(d,w.isTransient),w.isTransient&&await this.a.cleanUpTransientProfiles())}f(h){return h.openedWorkspace??(0,T.$Si)(h.backupPath,h.isExtensionDevelopmentHost)}g(){const h=this.a.getAssociatedEmptyWindows();if(h.length===0)return;const d=this.b.getWindows().map(w=>this.f(w));for(const w of h)d.some(f=>f.id===w.id)||this.a.unsetWorkspace(w,!1)}};e.$mhc=c,e.$mhc=c=Se([se(0,r.$8fc),se(1,D.$Rfc),se(2,p.$Ofc)],c)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[63],le([0,1,13,2,4,5,282,8,11,29,81,24,19,79,37,3,106]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=void 0,m=Ve(m);function $(t){return typeof t.responseWindowId=="number"}let k=class extends r.$Uc{static{b=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(b.b.values())}constructor(u,i,o){super(),this.w=u,this.y=i,this.z=o,this.c=String(++b.a),this.f=this.B(new P.$le),this.onStdout=this.f.event,this.g=this.B(new P.$le),this.onStderr=this.g.event,this.h=this.B(new P.$le),this.onMessage=this.h.event,this.j=this.B(new P.$le),this.onSpawn=this.j.event,this.m=this.B(new P.$le),this.onExit=this.m.event,this.n=this.B(new P.$le),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(u,i){let o;switch(this.t?.correlationId?o=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`:o=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`,i){case m.default.Error:this.w.error(o);break;case m.default.Warning:this.w.warn(o);break;case m.default.Info:this.w.trace(o);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(u){const i=this.F(u);return i&&u.payload&&this.postMessage(u.payload)&&this.C("payload sent via postMessage()",m.default.Info),i}F(u){if(!this.D())return!1;this.t=u;const i=`${this.t.type}-${this.c}`,o=p.$Yg.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],a=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,E=this.t.forceAllocationsToV8Sandbox,y=this.t.respondToAuthRequestsFromMainProcess,R="pipe",L=this.G(u);return this.C("creating new...",m.default.Info),this.r=n.utilityProcess.fork(o,s,{serviceName:i,env:L,execArgv:a,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:E,respondToAuthRequestsFromMainProcess:y,stdio:R}),this.H(this.r,this.t,i),!0}G(u){const i=u.env?{...u.env}:{...(0,f.$do)(process.env)};i.VSCODE_AMD_ENTRYPOINT=u.entryPoint,typeof u.parentLifecycleBound=="number"&&(i.VSCODE_PARENT_PID=String(u.parentLifecycleBound)),i.VSCODE_CRASH_REPORTER_PROCESS_TYPE=u.type,g.$j&&((0,v.isUNCAccessRestrictionsDisabled)()?i.NODE_DISABLE_UNC_ACCESS_CHECKS="1":i.NODE_UNC_HOST_ALLOWLIST=(0,v.getUNCHostAllowlist)().join("\\")),(0,w.$lm)(i);for(const o of Object.keys(i))i[o]=String(i[o]);return i}H(u,i,o){if(u.stdout){const s=new T.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(u.stdout,"data")(a=>this.f.fire(typeof a=="string"?a:s.write(a))))}if(u.stderr){const s=new T.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(u.stderr,"data")(a=>this.g.fire(typeof a=="string"?a:s.write(a))))}this.B(P.Event.fromNodeEventEmitter(u,"message")(s=>this.h.fire(s))),this.B(P.Event.fromNodeEventEmitter(u,"spawn")(()=>{this.s=u.pid,typeof u.pid=="number"&&b.b.set(u.pid,{pid:u.pid,name:$(i)?`${i.type} [${i.responseWindowId}]`:i.type}),this.C("successfully created",m.default.Info),this.j.fire(u.pid)})),this.B(P.Event.fromNodeEventEmitter(u,"exit")(s=>{const a=this.I(s)?0:s;this.C(`received exit event with code ${a}`,m.default.Info),this.m.fire({pid:this.s,code:a,signal:"unknown"}),this.J()})),this.B(P.Event.fromNodeEventEmitter(n.app,"child-process-gone",(s,a)=>({event:s,details:a}))(({details:s})=>{s.type==="Utility"&&s.name===o&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,m.default.Error),this.y.publicLog2("utilityprocesscrash",{type:i.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(u,i){const o=this.B(this.h.event(s=>{s===u&&(o.dispose(),i())}))}postMessage(u,i){return this.r?(this.r.postMessage(u,i),!0):!1}connect(u){const{port1:i,port2:o}=new n.MessageChannelMain;return this.postMessage(u,[o]),i}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",m.default.Info);const u=process;return typeof u._debugProcess=="function"?(u._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",m.default.Info),this.r.kill()?(this.C("successfully killed the process",m.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",m.default.Warning)}I(u){return u===0?!0:this.u&&u===15}J(){typeof this.s=="number"&&b.b.delete(this.s),this.r=void 0}async waitForExit(u){this.r&&(this.C("waiting to exit...",m.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,I.$Fh)(u)]),this.r&&(this.C(`did not exit within ${u}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$jgc=k,e.$jgc=k=b=Se([se(0,D.$_j),se(1,h.$$l),se(2,d.$8fc)],k);let S=class extends k{constructor(u,i,o,s){super(u,o,s),this.L=i}start(u){const i=this.L.getWindowById(u.responseWindowId);if(!i?.win||i.win.isDestroyed()||i.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.F(u))return!1;this.M(i.win,u);const s=this.connect(u.payload);return i.win.webContents.postMessage(u.responseChannel,u.responseNonce,[s]),!0}M(u,i){i.windowLifecycleBound&&(this.B(P.Event.filter(this.z.onWillLoadWindow,o=>o.window.win===u)(()=>this.kill())),this.B(P.Event.fromNodeEventEmitter(u,"closed")(()=>this.kill())))}};e.$kgc=S,e.$kgc=S=Se([se(0,D.$_j),se(1,c.$Ofc),se(2,h.$$l),se(3,d.$8fc)],S)}),define(ce[263],le([0,1,8,15,4,2,19,5,24,63,29]),function(x,e,n,r,P,D,T,I,p,c,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;let d=class extends D.$Uc{static{h=this}static{this.a=0}constructor(f,g,v,b){super(),this.f=f,this.g=g,this.h=v,this.j=b,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(f){const g=this.b.get(f);if(!g)throw new Error("Unknown extension host!");return g}onDynamicStdout(f){return this.m(f).onStdout}onDynamicStderr(f){return this.m(f).onStderr}onDynamicMessage(f){return this.m(f).onMessage}onDynamicExit(f){return this.m(f).onExit}async createExtensionHost(){if(this.c)throw(0,r.$5)();const f=String(++h.a),g=new c.$kgc(this.f,this.h,this.j,this.g);this.b.set(f,g);const v=g.onExit(({pid:b,code:$,signal:k})=>{v.dispose(),this.f.info(`Extension host with pid ${b} exited with code: ${$}, signal: ${k}.`),setTimeout(()=>{g.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(b,0),this.f.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)});return{id:f}}async start(f,g){if(this.c)throw(0,r.$5)();const v=this.m(f);return v.start({...g,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:g.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,respondToAuthRequestsFromMainProcess:!0,correlationId:f}),{pid:await P.Event.toPromise(v.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,r.$5)();const g=this.b.get(f);return g?g.enableInspectPort():!1}async kill(f){if(this.c)throw(0,r.$5)();const g=this.b.get(f);g&&g.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const g=[];for(const[,v]of this.b)g.push(v.waitForExit(f));return n.Promises.settled(g).then(()=>{})}};e.$rgc=d,e.$rgc=d=h=Se([se(0,I.$_j),se(1,T.$8fc),se(2,m.$Ofc),se(3,p.$$l)],d)}),define(ce[264],le([0,1,35,8,2,20,19,5,42,40,71,63,57,95,12,216,4]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;let b=class extends P.$Uc{constructor(k,S,t,u,i,o,s,a,l){super(),this.g=k,this.h=S,this.j=t,this.m=u,this.n=i,this.r=o,this.s=s,this.t=a,this.u=l,this.a=new r.$Dh,this.b=void 0,this.c=void 0,this.f=this.B(new v.$le),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$TX.on(g.$Ugc.request,(k,S)=>this.y(k,S,g.$Ugc.response)),n.$TX.on(g.$Vgc.request,(k,S)=>this.y(k,S,g.$Vgc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(k,S,t){this.s.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.a.isOpen()||this.a.open(),await this.whenReady();const u=await this.connect(t);if(k.sender.isDestroyed())return u.close();k.sender.postMessage(t,S,[u])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(g.$Tgc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const k=new r.$2h;this.b?.once(g.$Tgc.initDone,()=>k.complete()),await k.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const k=new r.$2h;this.b?.once(g.$Tgc.ipcReady,()=>k.complete()),await k.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new h.$jgc(this.s,d.$yp,this.r)),this.c=this.b.onMessage(t=>{typeof t.warning=="string"?this.s.warn(t.warning):typeof t.error=="string"&&this.s.error(t.error)});const k=(0,w.$0m)(this.m.args,this.m.isBuilt);let S;k.port&&(S=["--nolazy"],k.break?S.push(`--inspect-brk=${k.port}`):S.push(`--inspect=${k.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:S}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(k){return await this.F,(0,f.$pg)(this.b).connect(k)}};e.$Wgc=b,e.$Wgc=b=Se([se(3,D.$Bfc),se(4,p.$Ll),se(5,T.$8fc),se(6,I.$_j),se(7,m.$3fc),se(8,c.$so)],b)}),define(ce[265],le([0,1,20,95,19,5,57,75,63,118,35,2,4,37,16,11]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;let v=class extends h.$Uc{constructor($,k,S,t,u){super(),this.f=$,this.g=k,this.h=S,this.j=t,this.m=u,this.a=void 0,this.b=new d.$le,this.onRequestConnection=this.b.event,this.c=new d.$le,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),m.$TX.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,h.$Sc)(()=>{m.$TX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new p.$jgc(this.m,T.$yp,this.j);const $=(0,r.$9m)(this.h.args,this.h.isBuilt),k=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:k,args:["--logsPath",this.h.logsHome.with({scheme:g.Schemas.file}).fsPath],env:this.n()});const S=this.a.connect(),t=new c.$2X(S,"ptyHost"),u=new h.$Tc;return u.add(t),u.add((0,h.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:t,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,w.$do)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},k=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);k&&typeof k=="number"&&($.VSCODE_LATENCY=String(k));const S=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return S&&typeof S=="number"&&($.VSCODE_STARTUP_DELAY=String(S)),this.h.restoreSnapExportedVariables(),$}r($,k){this.b.fire();const S=this.a.connect();if($.sender.isDestroyed()){S.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",k,[S])}};e.$yhc=v,e.$yhc=v=Se([se(1,f.$$i),se(2,n.$Bfc),se(3,P.$8fc),se(4,D.$_j)],v)}),define(ce[266],le([0,1,2,6,5,29,63,24,46,4,8,19]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0,e.$whc=(0,r.$Ei)("utilityProcessWorker");let d=class extends n.$Uc{constructor(g,v,b,$){super(),this.b=g,this.c=v,this.f=b,this.g=$,this.a=new Map}async createWorker(g){const v=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${v})`);const b=this.h(g);this.a.has(b)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${v})`),this.disposeWorker(g));const $=new w(this.b,this.c,this.f,this.g,g);if(!$.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(b,$);const k=new m.$2h;return c.Event.once($.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(b),k.complete({reason:S})}),k.p}h(g){return(0,p.$sj)({moduleId:g.process.moduleId,windowId:g.reply.windowId})}async disposeWorker(g){const v=this.h(g),b=this.a.get(v);b&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),b.kill(),b.dispose(),this.a.delete(v))}};e.$xhc=d,e.$xhc=d=Se([se(0,P.$_j),se(1,D.$Ofc),se(2,I.$$l),se(3,h.$8fc)],d);let w=class extends n.$Uc{constructor(g,v,b,$,k){super(),this.c=g,this.f=v,this.g=b,this.h=$,this.j=k,this.a=this.B(new c.$le),this.onDidTerminate=this.a.event,this.b=this.B(new T.$kgc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(g=>this.a.fire({code:g.code,signal:g.signal}))),this.B(this.b.onCrash(g=>this.a.fire({code:g.code,signal:"ECRASH"})))}spawn(){const v=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:v,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=Se([se(0,P.$_j),se(1,D.$Ofc),se(2,I.$$l),se(3,h.$8fc)],w)}),define(ce[267],le([0,1,13,4,2,241,29]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;let I=class extends P.$Uc{constructor(c){super(),this.b=c,this.a=this.B(new r.$le),this.onFoundInFrame=this.a.event,this.B(new D.$bhc)}async setIgnoreMenuShortcuts(c,m){let h;if(typeof c.windowId=="number"){const{windowId:d}=c,w=this.b.getWindowById(d);if(!w?.win)throw new Error(`Invalid windowId: ${d}`);h=w.win.webContents}else{const{webContentsId:d}=c;if(h=n.webContents.fromId(d),!h)throw new Error(`Invalid webContentsId: ${d}`)}h.isDestroyed()||h.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,h,d){const f=this.c(c,m);if(typeof f.findInFrame=="function"){f.findInFrame(h,{findNext:d.findNext,forward:d.forward});const g=(v,b)=>{b.finalUpdate&&(this.a.fire(b),f.removeListener("found-in-frame",g))};f.on("found-in-frame",g)}}async stopFindInFrame(c,m,h){const w=this.c(c,m);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(h.keepSelection?"keepSelection":"clearSelection")}c(c,m){const h=this.b.getWindowById(c.windowId);if(!h?.win)throw new Error(`Invalid windowId: ${c}`);const d=h.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===m);if(!d)throw new Error(`Unknown frame: ${m}`);return d}};e.$chc=I,e.$chc=I=Se([se(0,T.$Ofc)],I)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[268],le([0,1,13,2,3,18,7,16,19,5,34,29,52,30]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0,e.$ehc=v,e.$fhc=$,n=Ve(n);let g=class extends r.$Uc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(t,u,i,o,s){super(),this.g=t,this.h=u,this.j=i,this.m=o,this.n=s,this.b=v(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.default.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(t=>this.u(t))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(t=>this.u(t)))}s(){this.f=!0,this.t()}t(){const t=new Set,u={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!u.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),s&&(u.lastActiveWindow=this.w(s),u.lastActiveWindow.uiState.mode===d.WindowMode.Fullscreen&&t.add(u.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);i&&(u.lastPluginDevelopmentHostWindow=this.w(i),u.lastPluginDevelopmentHostWindow.uiState.mode===d.WindowMode.Fullscreen&&(t.has(u.lastPluginDevelopmentHostWindow.uiState.display)?P.$k&&!i.win?.isSimpleFullScreen()&&(u.lastPluginDevelopmentHostWindow.uiState.mode=d.WindowMode.Normal):t.add(u.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(u.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const a=this.w(s);return a.uiState.mode===d.WindowMode.Fullscreen&&(t.has(a.uiState.display)?P.$k&&a.windowId!==u.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(a.uiState.mode=d.WindowMode.Normal):t.add(a.uiState.display)),a}));const o=$(u);this.h.setItem(f.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(t){if(this.j.quitRequested)return;const u=this.w(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=u:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this.b.openedWindows.forEach(i=>{const o=(0,w.$Ti)(t.openedWorkspace)&&i.workspace?.id===t.openedWorkspace.id,s=(0,w.$Oi)(t.openedWorkspace)&&i.folderUri&&D.$9g.isEqual(i.folderUri,t.openedWorkspace.uri);(o||s)&&(i.uiState=u.uiState)}),this.g.getWindowCount()===1&&(this.c=u)}w(t){return{windowId:t.id,workspace:(0,w.$Ti)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,w.$Oi)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const u=this.z(t),i=this.n.getValue("window");if(u.mode===d.WindowMode.Fullscreen){let o;u.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||i?.restoreFullscreen),o||(u.mode=d.WindowMode.Normal)}return u}z(t){const u=this.g.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const E=t.workspace;if((0,w.$Ti)(E)){const R=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===E.id).map(L=>L.uiState);if(R.length)return R[0]}if((0,w.$Oi)(E)){const R=this.state.openedWindows.filter(L=>L.folderUri&&D.$9g.isEqual(L.folderUri,E.uri)).map(L=>L.uiState);if(R.length)return R[0]}else if(t.backupPath){const R=this.state.openedWindows.filter(L=>L.backupPath===t.backupPath).map(L=>L.uiState);if(R.length)return R[0]}const y=this.c||this.state.lastActiveWindow;if(!u&&y)return y.uiState}let i;const o=n.default.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(P.$k){const E=n.default.screen.getCursorScreenPoint();i=n.default.screen.getDisplayNearestPoint(E)}!i&&u&&(i=n.default.screen.getDisplayMatching(u.getBounds())),i||(i=n.default.screen.getPrimaryDisplay()||o[0])}let s=(0,d.$Dfc)();s.x=Math.round(i.bounds.x+i.bounds.width/2-s.width/2),s.y=Math.round(i.bounds.y+i.bounds.height/2-s.height/2);const a=this.n.getValue("window");let l=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")s.mode=d.WindowMode.Maximized,l=!1;else if(a.newWindowDimensions==="fullscreen")s.mode=d.WindowMode.Fullscreen,l=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&u){const E=u.serializeWindowState();E.mode===d.WindowMode.Fullscreen?s.mode=d.WindowMode.Fullscreen:s={...E,zoomLevel:void 0},l=s.mode!==d.WindowMode.Fullscreen&&a.newWindowDimensions==="offset"}}return l&&(s=this.C(s)),s.hasDefaultState=!0,s}C(t){if(this.g.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const u=this.g.getWindows().map(i=>i.getBounds());for(;u.some(i=>i.x===t.x||i.y===t.y);)t.x+=30,t.y+=30;return t}};e.$dhc=g,e.$dhc=g=f=Se([se(0,h.$Ofc),se(1,m.$zR),se(2,p.$8fc),se(3,c.$_j),se(4,I.$$i)],g);function v(S){const t={openedWindows:[]},u=S||{openedWindows:[]};return u.lastActiveWindow&&(t.lastActiveWindow=b(u.lastActiveWindow)),u.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=b(u.lastPluginDevelopmentHostWindow)),Array.isArray(u.openedWindows)&&(t.openedWindows=u.openedWindows.map(i=>b(i))),t}function b(S){const t={uiState:S.uiState};return S.backupPath&&(t.backupPath=S.backupPath),S.remoteAuthority&&(t.remoteAuthority=S.remoteAuthority),S.folder&&(t.folderUri=T.URI.parse(S.folder)),S.workspaceIdentifier&&(t.workspace={id:S.workspaceIdentifier.id,configPath:T.URI.parse(S.workspaceIdentifier.configURIPath)}),t}function $(S){return{lastActiveWindow:S.lastActiveWindow&&k(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&k(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(t=>k(t))}}function k(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[59],le([0,1,26,13,4,43,2,11,9,18,23,10,69,53,20,6,5,58,134,30,102,103]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=void 0,n=Pe(n),r=Ve(r),e.$1fc=(0,g.$Ei)("workspacesManagementMainService");let u=class extends T.$Uc{constructor(o,s,a,l,E){super(),this.g=o,this.h=s,this.j=a,this.m=l,this.n=E,this.a=this.B(new P.$le),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new P.$le),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await m.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(s=>(0,c.$fh)(this.c,s,k.$4i));for(const s of o){const a=(0,t.$Xfc)(s),l=await this.resolveLocalWorkspace(s);l?this.f.push({workspace:a,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,s=>n.promises.readFile(s,"utf8"))}r(o,s){if(this.s(o)&&o.scheme===I.Schemas.file)try{const a=s(o.fsPath);return a instanceof Promise?a.then(l=>this.t(o,l),l=>{}):this.t(o,a)}catch{return}}s(o){return(0,k.$5i)(o,this.g)||(0,k.$0i)(o)}t(o,s){try{const a=this.u(o,s),l=(0,t.$Xfc)(o);return{id:l.id,configPath:l.configPath,folders:(0,S.$hib)(a.folders,l.configPath,c.$9g),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.h.warn(a.toString())}}u(o,s){const a=(0,D.$Xn)(s);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(l=>(0,S.$fib)(l));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(o,s){const{workspace:a,storedWorkspace:l}=this.w(o,s),E=a.configPath.fsPath;return await n.promises.mkdir((0,p.$mc)(E),{recursive:!0}),await m.Promises.writeFile(E,JSON.stringify(l,null,"	")),this.f.push({workspace:a,remoteAuthority:s}),a}w(o=[],s){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,c.$fh)(this.c,a),E=(0,c.$fh)(l,k.$4i),y=[];for(const R of o)y.push((0,S.$gib)(R.uri,!0,R.name,l,c.$9g));return{workspace:(0,t.$Xfc)(E),storedWorkspace:{folders:y,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,t.$Xfc)(o)}isUntitledWorkspace(o){return(0,k.$5i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const s=(0,c.$6g)(o.configPath);try{await m.Promises.rm((0,p.$mc)(s));const a=(0,p.$jc)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await m.Promises.exists(a)&&await m.Promises.writeFile((0,p.$jc)(a,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==o.id)}catch(a){this.h.warn(`Unable to delete untitled workspace ${s} (${a}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,s,a){if(!o||!o.win||!o.isReady||!await this.z(o,s,a))return;const E=await this.C(o,(0,t.$Xfc)(a));if(E)return this.b.fire({window:o,workspace:E.workspace}),E}async z(o,s,a){return a?(0,k.$Ti)(o.openedWorkspace)&&c.$9g.isEqual(o.openedWorkspace.configPath,a)?!1:(0,$.$Ufc)(s,a)?(await this.n.showMessageBox({type:"info",buttons:[(0,h.localize)(10970,null)],message:(0,h.localize)(10971,null,(0,c.$ch)(a)),detail:(0,h.localize)(10972,null)},r.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,s){if(!o.config)return;o.focus();let a;return o.config.extensionDevelopmentPath||(o.config.backupPath?a=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):a=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,k.$Ti)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=a,{workspace:s,backupPath:a}}};e.$2fc=u,e.$2fc=u=Se([se(0,f.$Bfc),se(1,v.$_j),se(2,b.$Rfc),se(3,d.$Ifc),se(4,w.$Jfc)],u)}),define(ce[136],le([0,1,13,35,22,6,29,30,59,12,5,63]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=e.ID=void 0,e.ID="diagnosticsMainService",e.$mgc=(0,D.$Ei)(e.ID);let d=class{constructor(f,g,v){this.a=f,this.b=g,this.c=v}async getRemoteDiagnostics(f){const g=this.a.getWindows();return(await Promise.all(g.map(async b=>{const $=b.remoteAuthority;if(!$)return;const k=`vscode:getDiagnosticInfoResponse${b.id}`,S={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(t=>{b.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:k,args:S}),r.$TX.once(k,(u,i)=>{i||t({hostName:$,errorMessage:`Unable to resolve connection to '${$}'.`}),t(i)}),setTimeout(()=>{t({hostName:$,errorMessage:`Connection to '${$}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const v of n.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(v.id);b?f.push(await this.d(b)):f.push(this.e(v))}const g=[];for(const{pid:v,name:b}of h.$jgc.getAll())g.push({pid:v,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:g,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const g=await this.f(f),v=(0,c.$pg)(f.win);return this.e(v,g,f.remoteAuthority)}e(f,g=[],v){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:g,remoteAuthority:v}}async f(f){const g=[],v=f.openedWorkspace;if((0,I.$Oi)(v))g.push(v.uri);else if((0,I.$Ti)(v)){const b=await this.b.resolveLocalWorkspace(v.configPath);b&&b.folders.forEach(k=>{g.push(k.uri)})}return g}};e.$ngc=d,e.$ngc=d=Se([se(0,T.$Ofc),se(1,p.$1fc),se(2,m.$_j)],d)}),define(ce[64],le([0,1,26,48,13,27,154,54,4,2,11,9,3,7,112,92,23,113,10,53,20,6,19,5,28,76,29,30,59,17,212,202,84,15,16,135,49]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t,u,i,o,s,a,l,E,y,R,L,A,O,M,H,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=void 0,n=Pe(n),e.$Bgc=(0,t.$Ei)("nativeHostMainService");let K=class extends c.$Uc{constructor(Y,J,U,Z,W,j,C,X,oe,V,ue,re){super(),this.a=Y,this.b=J,this.c=U,this.f=Z,this.g=W,this.h=j,this.j=C,this.m=X,this.n=oe,this.r=V,this.s=ue,this.t=re,this.onDidOpenMainWindow=p.Event.map(this.a.onDidOpenWindow,Q=>Q.id),this.onDidTriggerWindowSystemContextMenu=p.Event.any(p.Event.map(this.a.onDidTriggerSystemContextMenu,({window:Q,x:N,y:F})=>({windowId:Q.id,x:N,y:F})),p.Event.map(this.b.onDidTriggerSystemContextMenu,({window:Q,x:N,y:F})=>({windowId:Q.id,x:N,y:F}))),this.onDidMaximizeWindow=p.Event.any(p.Event.map(this.a.onDidMaximizeWindow,Q=>Q.id),p.Event.map(this.b.onDidMaximizeWindow,Q=>Q.id)),this.onDidUnmaximizeWindow=p.Event.any(p.Event.map(this.a.onDidUnmaximizeWindow,Q=>Q.id),p.Event.map(this.b.onDidUnmaximizeWindow,Q=>Q.id)),this.onDidChangeWindowFullScreen=p.Event.any(p.Event.map(this.a.onDidChangeFullScreen,Q=>({windowId:Q.window.id,fullscreen:Q.fullscreen})),p.Event.map(this.b.onDidChangeFullScreen,Q=>({windowId:Q.window.id,fullscreen:Q.fullscreen}))),this.onDidBlurMainWindow=p.Event.filter(p.Event.fromNodeEventEmitter(P.app,"browser-window-blur",(Q,N)=>N.id),Q=>!!this.a.getWindowById(Q)),this.onDidFocusMainWindow=p.Event.any(p.Event.map(p.Event.filter(p.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),Q=>!!Q),Q=>Q.id),p.Event.filter(p.Event.fromNodeEventEmitter(P.app,"browser-window-focus",(Q,N)=>N.id),Q=>!!this.a.getWindowById(Q))),this.onDidBlurMainOrAuxiliaryWindow=p.Event.any(this.onDidBlurMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(P.app,"browser-window-blur",(Q,N)=>this.b.getWindowByWebContents(N.webContents)),Q=>!!Q),Q=>Q.id)),this.onDidFocusMainOrAuxiliaryWindow=p.Event.any(this.onDidFocusMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(P.app,"browser-window-focus",(Q,N)=>this.b.getWindowByWebContents(N.webContents)),Q=>!!Q),Q=>Q.id)),this.onDidResumeOS=p.Event.fromNodeEventEmitter(P.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.u=this.B(new p.$le),this.onDidChangePassword=this.u.event,this.onDidChangeDisplay=p.Event.debounce(p.Event.any(p.Event.filter(p.Event.fromNodeEventEmitter(P.screen,"display-metrics-changed",(Q,N,F)=>F),Q=>!(Array.isArray(Q)&&Q.length===1&&Q[0]==="workArea")),p.Event.fromNodeEventEmitter(P.screen,"display-added"),p.Event.fromNodeEventEmitter(P.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(Y,J){const U=this.a.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace??(0,l.$Si)(W.backupPath,W.isExtensionDevelopmentHost),title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()})),Z=[];return J.includeAuxiliaryWindows&&Z.push(...this.b.getWindows().map(W=>({id:W.id,parentId:W.parentId,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename()}))),[...U,...Z]}async getWindowCount(Y){return this.a.getWindowCount()}async getActiveWindowId(Y){const J=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(J)return J.id}openWindow(Y,J,U){return Array.isArray(J)?this.w(Y,J,U):this.z(Y,J)}async w(Y,J,U=Object.create(null)){J.length>0&&await this.a.open({context:a.OpenContext.API,contextWindowId:Y,urisToOpen:J,cli:this.g.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,mergeMode:U.mergeMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async z(Y,J){await this.a.openEmptyWindow({context:a.OpenContext.API,contextWindowId:Y},J)}async isFullScreen(Y,J){return this.H(J?.targetWindowId,Y)?.isFullScreen??!1}async toggleFullScreen(Y,J){this.H(J?.targetWindowId,Y)?.toggleFullScreen()}async handleTitleDoubleClick(Y,J){this.H(J?.targetWindowId,Y)?.handleTitleDoubleClick()}async getCursorScreenPoint(Y){const J=P.screen.getCursorScreenPoint(),U=P.screen.getDisplayNearestPoint(J);return{point:J,display:U.bounds}}async isMaximized(Y,J){return this.H(J?.targetWindowId,Y)?.win?.isMaximized()??!1}async maximizeWindow(Y,J){this.H(J?.targetWindowId,Y)?.win?.maximize()}async unmaximizeWindow(Y,J){this.H(J?.targetWindowId,Y)?.win?.unmaximize()}async minimizeWindow(Y,J){this.H(J?.targetWindowId,Y)?.win?.minimize()}async moveWindowTop(Y,J){this.H(J?.targetWindowId,Y)?.win?.moveTop()}async positionWindow(Y,J,U){const Z=this.H(U?.targetWindowId,Y);if(Z?.win){if(Z.win.isFullScreen()){const W=p.Event.toPromise(p.Event.once(p.Event.fromNodeEventEmitter(Z.win,"leave-full-screen")));Z.win.setFullScreen(!1),await W}Z.win.setBounds(J)}}async updateWindowControls(Y,J){this.H(J?.targetWindowId,Y)?.updateWindowControls(J)}async focusWindow(Y,J){this.H(J?.targetWindowId,Y)?.focus({force:J?.force??!1})}async setMinimumSize(Y,J,U){const Z=this.I(Y);if(Z?.win){const[W,j]=Z.win.getSize(),[C,X]=Z.win.getMinimumSize(),[oe,V]=[J??C,U??X],[ue,re]=[Math.max(W,oe),Math.max(j,V)];(C!==oe||X!==V)&&Z.win.setMinimumSize(oe,V),(W!==ue||j!==re)&&Z.win.setSize(ue,re)}}async saveWindowSplash(Y,J){this.m.saveWindowSplash(Y,J)}async installShellCommand(Y){const{source:J,target:U}=await this.C();try{const{symbolicLink:Z}=await v.SymlinkSupport.stat(J);if(Z&&!Z.dangling){const W=await(0,f.$mr)(J);if(U===W)return}await n.promises.unlink(J)}catch(Z){if(Z.code!=="ENOENT")throw Z}try{await n.promises.symlink(U,J)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="ENOENT")throw Z;const{response:W}=await this.showMessageBox(Y,{type:"info",message:(0,$.localize)(11223,null,this.j.nameShort),buttons:[(0,$.localize)(11224,null),(0,$.localize)(11225,null)]});if(W===1)throw new O.$4;try{const j=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${J}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(j)}catch{throw new Error((0,$.localize)(11226,null,J))}}}async uninstallShellCommand(Y){const{source:J}=await this.C();try{await n.promises.unlink(J)}catch(U){switch(U.code){case"EACCES":{const{response:Z}=await this.showMessageBox(Y,{type:"info",message:(0,$.localize)(11227,null,this.j.nameShort),buttons:[(0,$.localize)(11228,null),(0,$.localize)(11229,null)]});if(Z===1)throw new O.$4;try{const W=`osascript -e "do shell script \\"rm '${J}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(W)}catch{throw new Error((0,$.localize)(11230,null,J))}break}case"ENOENT":break;default:throw U}}}async C(){const Y=(0,h.$kc)(this.g.appRoot,"bin","code"),J=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(Y))throw new Error((0,$.localize)(11231,null,Y));return{source:J,target:Y}}async showMessageBox(Y,J){const U=this.H(J?.targetWindowId,Y);return this.c.showMessageBox(J,U?.win??void 0)}async showSaveDialog(Y,J){const U=this.H(J?.targetWindowId,Y);return this.c.showSaveDialog(J,U?.win??void 0)}async showOpenDialog(Y,J){const U=this.H(J?.targetWindowId,Y);return this.c.showOpenDialog(J,U?.win??void 0)}async pickFileFolderAndOpen(Y,J){const U=await this.c.pickFileFolder(J);U&&await this.D(await Promise.all(U.map(async Z=>await v.SymlinkSupport.existsDirectory(Z)?{folderUri:w.URI.file(Z)}:{fileUri:w.URI.file(Z)})),J,Y)}async pickFolderAndOpen(Y,J){const U=await this.c.pickFolder(J);U&&await this.D(U.map(Z=>({folderUri:w.URI.file(Z)})),J,Y)}async pickFileAndOpen(Y,J){const U=await this.c.pickFile(J);U&&await this.D(U.map(Z=>({fileUri:w.URI.file(Z)})),J,Y)}async pickWorkspaceAndOpen(Y,J){const U=await this.c.pickWorkspace(J);U&&await this.D(U.map(Z=>({workspaceUri:w.URI.file(Z)})),J,Y)}async D(Y,J,U){await this.a.open({context:a.OpenContext.DIALOG,contextWindowId:U,cli:this.g.args,urisToOpen:Y,forceNewWindow:J.forceNewWindow})}async showItemInFolder(Y,J){P.shell.showItemInFolder(J)}async setRepresentedFilename(Y,J,U){this.H(U?.targetWindowId,Y)?.setRepresentedFilename(J)}async setDocumentEdited(Y,J,U){this.H(U?.targetWindowId,Y)?.setDocumentEdited(J)}async openExternal(Y,J,U){this.g.unsetSnapExportedVariables();try{(0,m.$Og)(J,m.Schemas.http,m.Schemas.https)?this.F(J,U):P.shell.openExternal(J)}finally{this.g.restoreSnapExportedVariables()}return!0}async F(Y,J){const U=J??this.r.getValue("workbench.externalBrowser");if(!U)return P.shell.openExternal(Y);if((U.includes(h.$gc.sep)||U.includes(h.$fc.sep))&&!await v.Promises.exists(U))return this.h.error(`Configured external browser path does not exist: ${U}`),P.shell.openExternal(Y);try{const{default:Z}=await new Promise((W,j)=>{x(["open"],W,j)}).then(Pe);await Z(Y,{app:{name:Object.hasOwn(Z.apps,U)?Z.apps[U]:U}})}catch(Z){return this.h.error(`Unable to open external URL '${Y}' using browser '${U}' due to ${Z}.`),P.shell.openExternal(Y)}}moveItemToTrash(Y,J){return P.shell.trashItem(J)}async isAdmin(){let Y;return d.$j?Y=(await new Promise((J,U)=>{x(["native-is-elevated"],J,U)}).then(Pe)).default():Y=process.getuid?.()===0,Y}async writeElevated(Y,J,U,Z){const W=await new Promise((j,C)=>{x(["@vscode/sudo-prompt"],j,C)}).then(Pe);return new Promise((j,C)=>{const X=[`"${this.G}"`];Z?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${J.fsPath}"`,`"${U.fsPath}"`);const oe={name:this.j.nameLong.replace("-",""),icns:d.$k&&this.g.isBuilt?(0,h.$jc)((0,h.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};W.exec(X.join(" "),oe,(V,ue,re)=>{ue&&this.h.trace(`[sudo-prompt] received stdout: ${ue}`),re&&this.h.trace(`[sudo-prompt] received stderr: ${re}`),V?C(V):j(void 0)})})}async isRunningUnderARM64Translation(){return d.$l||d.$j?!1:P.app.runningUnderARM64Translation}get G(){return d.$j?this.g.isBuilt?(0,h.$jc)((0,h.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,h.$jc)(this.g.appRoot,"scripts","code-cli.bat"):d.$l?this.g.isBuilt?(0,h.$jc)((0,h.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,h.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,h.$jc)(this.g.appRoot,"bin","code"):(0,h.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return g.$Rn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return d.$j&&(0,R.$ygc)()}async getProcessId(Y){return this.H(void 0,Y)?.win?.webContents.getOSProcessId()}async killProcess(Y,J,U){process.kill(J,U)}async readClipboardText(Y,J){return P.clipboard.readText(J)}async writeClipboardText(Y,J,U){return P.clipboard.writeText(J,U)}async readClipboardFindText(Y){return P.clipboard.readFindText()}async writeClipboardFindText(Y,J){return P.clipboard.writeFindText(J)}async writeClipboardBuffer(Y,J,U,Z){return P.clipboard.writeBuffer(J,Buffer.from(U.buffer),Z)}async readClipboardBuffer(Y,J){return y.$Ne.wrap(P.clipboard.readBuffer(J))}async hasClipboard(Y,J,U){return P.clipboard.has(J,U)}async newWindowTab(){await this.a.open({context:a.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){P.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){P.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){P.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){P.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){P.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(Y,J){this.I(Y)?.updateTouchBar(J)}async notifyReady(Y){this.I(Y)?.setReady()}async relaunch(Y,J){return this.f.relaunch(J)}async reload(Y,J){const U=this.I(Y);if(U){if((0,l.$Ti)(U.openedWorkspace)){const Z=U.openedWorkspace.configPath;if(Z.scheme===m.Schemas.file&&(await this.n.resolveLocalWorkspace(Z))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.f.reload(U,J?.disableExtensions!==void 0?{_:[],"disable-extensions":J.disableExtensions}:void 0)}}async closeWindow(Y,J){return this.H(J?.targetWindowId,Y)?.win?.close()}async quit(Y){const J=this.a.getLastActiveWindow();J?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&J.win?J.win.close():this.f.quit()}async exit(Y,J){await this.f.kill(J)}async resolveProxy(Y,J){if(this.g.extensionTestsLocationURI){const W=this.r.getValue("integration-test.http.proxy");if(W)return W}return this.I(Y)?.win?.webContents?.session?.resolveProxy(J)}async lookupAuthorization(Y,J){return this.t.lookupAuthorization(J)}async lookupKerberosAuthorization(Y,J){return this.s.lookupKerberosAuthorization(J)}async loadCertificates(Y){return this.s.loadCertificates()}findFreePort(Y,J,U,Z,W=1){return(0,b.$3g)(J,U,Z,W)}async openDevTools(Y,J){this.H(J?.targetWindowId,Y)?.win?.webContents.openDevTools(J?.mode?{mode:J.mode,activate:J.activate}:void 0)}async toggleDevTools(Y,J){this.H(J?.targetWindowId,Y)?.win?.webContents.toggleDevTools()}async profileRenderer(Y,J,U){const Z=this.I(Y);if(!Z||!Z.win)throw new Error;return await new L.$zgc(Z.win,J,this.h).inspect(U)}async windowsGetStringRegKey(Y,J,U,Z){if(!d.$j)return;const W=await new Promise((j,C)=>{x(["@vscode/windows-registry"],j,C)}).then(Pe);try{return W.GetStringRegKey(J,U,Z)}catch{return}}H(Y,J){return this.I(Y)??this.J(Y)??this.I(J)}I(Y){if(typeof Y=="number")return this.a.getWindowById(Y)}J(Y){if(typeof Y!="number")return;const J=P.webContents.fromId(Y);if(J)return this.b.getWindowByWebContents(J)}};e.$Cgc=K,Se([I.$9h],K.prototype,"G",null),e.$Cgc=K=Se([se(0,a.$Ofc),se(1,A.$Agc),se(2,k.$Jfc),se(3,u.$8fc),se(4,S.$Bfc),se(5,i.$_j),se(6,o.$sk),se(7,s.$Mfc),se(8,E.$1fc),se(9,M.$$i),se(10,q.$7p),se(11,H.$fgc)],K)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[269],le([0,1,13,27,8,22,2,11,3,35,10,53,20,5,64,72,73,51,29]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0,g=Ve(g);let S=class{static{k=this}static{this.a="#1E1E1E"}constructor(u,i,o,s,a,l,E){this.d=u,this.e=i,this.f=o,this.g=s,this.h=a,this.i=l,this.j=E,this.b=null,this.c=null}async openReporter(u){if(this.b)this.b&&this.k(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const i=new T.$Tc,o=i.add(this.i.createIPCObjectUrl()),s=this.m(this.c,700,800);this.b=this.l(s,o,{backgroundColor:u.styles.backgroundColor,title:(0,m.localize)(11320,null),zoomLevel:u.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:u,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:g.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(I.$Yg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,i.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,i.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(u){this.f.error(u)}}async $showConfirmCloseDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(11321,null),buttons:[(0,m.localize)(11322,null),(0,m.localize)(11323,null)]},this.b);u===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(11324,null),buttons:[(0,m.localize)(11325,null),(0,m.localize)(11326,null)]},this.b);return u===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const u=this.j.getWindowById(this.c.id);if(!u)throw new Error("Window not found");return u}async $sendReporterMenu(u,i){const o=this.issueReporterWindowCheck(),s="vscode:triggerReporterMenu",a=new D.$we;return o.sendWhenReady(s,a.token,{replyChannel:s,extensionId:u,extensionName:i}),await(0,P.$vh)(new Promise(E=>c.$TX.once(`vscode:triggerReporterMenuResponse:${u}`,(y,R)=>E(R))),5e3,()=>{this.f.error(`Error: Extension ${u} timed out waiting for menu response`),a.cancel()})}async $closeReporter(){this.b?.close()}k(u){u.isMinimized()&&u.restore(),u.focus()}l(u,i,o,s){const a=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:o.title,backgroundColor:o.backgroundColor||k.a,webPreferences:{preload:I.$Yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.$gE)(o.zoomLevel),sandbox:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return a.setMenuBarVisibility(!1),a}m(u,i,o){let s;const a=n.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(p.$k){const y=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(y)}!s&&u&&(s=n.screen.getDisplayMatching(u.getBounds())),s||(s=n.screen.getPrimaryDisplay()||a[0])}const l=s.bounds,E={width:i,height:o,x:l.x+l.width/2-i/2,y:l.y+l.height/2-o/2};return l.width>0&&l.height>0&&(E.x<l.x&&(E.x=l.x),E.y<l.y&&(E.y=l.y),E.x>l.x+l.width&&(E.x=l.x),E.y>l.y+l.height&&(E.y=l.y),E.width>l.width&&(E.width=l.width),E.height>l.height&&(E.height=l.height)),E}};e.$Dgc=S,e.$Dgc=S=k=Se([se(1,d.$Bfc),se(2,w.$_j),se(3,h.$Jfc),se(4,f.$Bgc),se(5,v.$Lfc),se(6,$.$Ofc)],S)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[270],le([0,1,13,32,2,11,3,115,35,10,96,136,53,20,5,64,72,28,73,34,63,51]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0,v=Ve(v);const i="issue.processExplorerWindowState";let o=class{static{u=this}static{this.a="#1E1E1E"}constructor(l,E,y,R,L,A,O,M,H,q){this.d=l,this.f=E,this.g=y,this.h=R,this.i=L,this.j=A,this.k=O,this.l=M,this.m=H,this.n=q,this.b=null,this.c=null,this.o()}o(){p.$TX.on("vscode:listProcesses",async l=>{const E=[];try{E.push({name:(0,c.localize)(11315,null),rootProcess:await(0,I.$Ws)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(R=>{(0,m.$Tm)(R)?E.push({name:R.hostName,rootProcess:R}):R.processes&&E.push({name:R.hostName,rootProcess:R.processes})})}catch(y){this.g.error(`Listing processes failed: ${y}`)}this.s(l,"vscode:listProcessesResponse",E)}),p.$TX.on("vscode:workbenchCommand",(l,E)=>{const{id:y,from:R,args:L}=E;let A;switch(R){case"processExplorer":A=this.c;break;default:throw new Error(`Unexpected command source: ${R}`)}A?.webContents.send("vscode:runAction",{id:y,from:R,args:L})}),p.$TX.on("vscode:closeProcessExplorer",l=>{this.b?.close()}),p.$TX.on("vscode:pidToNameRequest",async l=>{const E=await this.i.getMainDiagnostics(),y=[];for(const R of E.windows)y.push([R.pid,`window [${R.id}] (${R.title})`]);for(const{pid:R,name:L}of S.$jgc.getAll())y.push([R,L]);this.s(l,"vscode:pidToNameResponse",y)})}async openProcessExplorer(l){if(!this.b&&(this.c=n.BrowserWindow.getFocusedWindow(),this.c)){const E=new P.$Tc,y=E.add(this.l.createIPCObjectUrl()),R=this.n.getItem(i,void 0),L=s(R)?R:this.q(this.c,800,500);this.b=this.r(L,y,{backgroundColor:l.styles.backgroundColor,title:(0,c.localize)(11316,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),y.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:l,product:v.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(D.$Yg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,E.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,E.dispose())});const A=()=>{if(!this.b)return;const O=this.b.getSize(),M=this.b.getPosition();if(!O||!M)return;const H={width:O[0],height:O[1],x:M[0],y:M[1]};this.n.setItem(i,H)};this.b.on("moved",A),this.b.on("resized",A)}this.b&&this.p(this.b)}p(l){l.isMinimized()&&l.restore(),l.focus()}q(l,E,y){let R;const L=n.screen.getAllDisplays();if(L.length===1)R=L[0];else{if(T.$k){const M=n.screen.getCursorScreenPoint();R=n.screen.getDisplayNearestPoint(M)}!R&&l&&(R=n.screen.getDisplayMatching(l.getBounds())),R||(R=n.screen.getPrimaryDisplay()||L[0])}const A=R.bounds,O={width:E,height:y,x:A.x+A.width/2-E/2,y:A.y+A.height/2-y/2};return A.width>0&&A.height>0&&(O.x<A.x&&(O.x=A.x),O.y<A.y&&(O.y=A.y),O.x>A.x+A.width&&(O.x=A.x),O.y>A.y+A.height&&(O.y=A.y),O.width>A.width&&(O.width=A.width),O.height>A.height&&(O.height=A.height)),O}async stopTracing(){if(!this.f.args.trace)return;const l=await n.contentTracing.stopRecording(`${(0,r.$Mg)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,c.localize)(11317,null),detail:(0,c.localize)(11318,null,l),buttons:[(0,c.localize)(11319,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,l)}async getSystemStatus(){const[l,E]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(l,E)}async $getSystemInfo(){const[l,E]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(l,E)}async $getPerformanceInfo(){try{const[l,E]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(l,E)}catch(l){throw this.g.warn("issueService#getPerformanceInfo ",l.message),l}}r(l,E,y,R){const L=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:y.title,backgroundColor:y.backgroundColor||u.a,webPreferences:{preload:D.$Yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${E.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$gE)(y.zoomLevel),sandbox:!0},alwaysOnTop:y.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}s(l,E,...y){l.sender.isDestroyed()||l.sender.send(E,...y)}async closeProcessExplorer(){this.b?.close()}};e.$Egc=o,e.$Egc=o=u=Se([se(1,w.$Bfc),se(2,f.$_j),se(3,m.$Sm),se(4,h.$mgc),se(5,d.$Jfc),se(6,g.$Bgc),se(7,$.$Lfc),se(8,b.$sk),se(9,k.$zR)],o);function s(a){return typeof a!="object"||a===null?!1:"x"in a&&"y"in a&&"width"in a&&"height"in a}}),define(ce[271],le([0,1,22,16,20,19,5,64,28,49,24,50,105]),function(x,e,n,r,P,D,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;let w=class extends d.$4gc{constructor(g,v,b,$,k,S,t,u){super(g,v,$,k,S,u),this.e=b,this.u=t}s(g){return(0,d.$3gc)(`linux-${process.arch}`,g,this.k)}t(g){this.a&&(this.d(h.$RY.CheckingForUpdates(g)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$aq).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!g}),this.d(h.$RY.Idle(h.UpdateType.Archive))):this.d(h.$RY.AvailableForDownload(v))}).then(void 0,v=>{this.j.error(v);const b=g?v.message||v:void 0;this.d(h.$RY.Idle(h.UpdateType.Archive,b))}))}async o(g){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):g.update.url&&this.u.openExternal(void 0,g.update.url),this.d(h.$RY.Idle(h.UpdateType.Archive))}};e.$6gc=w,e.$6gc=w=Se([se(0,D.$8fc),se(1,r.$$i),se(2,m.$$l),se(3,P.$Bfc),se(4,c.$7p),se(5,T.$_j),se(6,I.$Bgc),se(7,p.$sk)],w)}),define(ce[272],le([0,1,48,26,27,8,22,54,46,9,7,152,23,16,20,14,19,5,64,28,49,24,50,105]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0,r=Pe(r),c=Pe(c),d=Pe(d);async function o(E,y=1e3){for(;!E();)await(0,D.$Fh)(y)}let s;function a(){return typeof s>"u"&&(s=r.existsSync(c.$jc(c.$mc(process.execPath),"unins000.exe"))?u.UpdateType.Setup:u.UpdateType.Archive),s}let l=class extends i.$4gc{get cachePath(){const y=c.$jc((0,P.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(y,{recursive:!0}).then(()=>y)}constructor(y,R,L,A,O,M,H,q,K){super(y,R,A,O,M,K),this.u=L,this.v=H,this.w=q,y.setRelaunchHandler(this)}handleRelaunch(y){return y?.addArgs||y?.removeArgs||this.state.type!==u.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$RY.Disabled(u.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(y){let R=`win32-${process.arch}`;return a()===u.UpdateType.Archive?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,i.$3gc)(R,y,this.k)}t(y){this.a&&(this.d(u.$RY.CheckingForUpdates(y)),this.i.request({url:this.a},T.CancellationToken.None).then(S.$aq).then(R=>{const L=a();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!y}),this.d(u.$RY.Idle(L)),Promise.resolve(null)):L===u.UpdateType.Archive?(this.d(u.$RY.AvailableForDownload(R)),Promise.resolve(null)):(this.d(u.$RY.Downloading),this.C(R.version).then(()=>this.B(R.version).then(A=>d.Promises.exists(A).then(O=>{if(O)return Promise.resolve(A);const M=`${A}.tmp`;return this.i.request({url:R.url},T.CancellationToken.None).then(H=>this.v.writeFile(m.URI.file(M),H.stream)).then(R.sha256hash?()=>(0,h.$MX)(M,R.sha256hash):()=>{}).then(()=>d.Promises.rename(M,A,!1)).then(()=>A)})).then(A=>{this.e={packagePath:A},this.d(u.$RY.Downloaded(R)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(u.$RY.Ready(R))})))}).then(void 0,R=>{this.u.publicLog2("update:error",{messageHash:String((0,p.$sj)(String(R)))}),this.j.error(R);const L=y?R.message||R:void 0;this.d(u.$RY.Idle(a(),L))}))}async o(y){y.update.url&&this.w.openExternal(void 0,y.update.url),this.d(u.$RY.Idle(a()))}async B(y){const R=await this.cachePath;return c.$jc(R,`CodeSetup-${this.k.quality}-${y}.exe`)}async C(y=null){const R=y?M=>!new RegExp(`${this.k.quality}-${y}\\.exe$`).test(M):()=>!0,L=await this.cachePath,O=(await d.Promises.readdir(L)).filter(R).map(async M=>{try{await r.promises.unlink(c.$jc(L,M))}catch{}});await Promise.all(O)}async p(){if(this.state.type!==u.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const y=this.state.update;this.d(u.$RY.Updating(y));const R=await this.cachePath;this.e.updateFilePath=c.$jc(R,`CodeSetup-${this.k.quality}-${y.version}.flag`),await d.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$RY.Idle(a()))});const A=`${this.k.win32MutexName}-ready`,O=await new Promise((M,H)=>{x(["@vscode/windows-mutex"],M,H)}).then(Pe);o(()=>O.isActive(A)).then(()=>this.d(u.$RY.Ready(y)))}r(){this.state.type!==u.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(y){if(this.state.type!==u.StateType.Idle)return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(u.$RY.Downloading),this.e={packagePath:y},this.d(u.$RY.Downloaded(L)),R?this.k.target==="user"&&this.p():this.d(u.$RY.Ready(L))}};e.$8gc=l,Se([I.$9h],l.prototype,"cachePath",null),e.$8gc=l=Se([se(0,v.$8fc),se(1,w.$$i),se(2,t.$$l),se(3,f.$Bfc),se(4,S.$7p),se(5,b.$_j),se(6,g.$_k),se(7,$.$Bgc),se(8,k.$sk)],l)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[137],le([0,1,13,8,22,55,4,2,11,70,3,7,10,27,69,16,53,20,68,14,19,5,28,73,248,87,24,110,76,51,29,30,59,52,40,34,58,71,21,6]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t,u,i,o,s,a,l,E,y,R,L,A,O,M,H,q,K,de,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=e.$5fc=void 0,n=Ve(n);var J;(function(W){W[W.NONE=0]="NONE",W[W.NAVIGATING=1]="NAVIGATING",W[W.READY=2]="READY"})(J||(J={}));class U extends I.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(T.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(T.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(T.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(T.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(T.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(T.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const C=!(0,y.$bE)(this.r);if(m.$k&&C&&j.setSheetOffset((0,m.$K)((0,w.release)())?28:22),C&&(m.$j&&(0,y.$eE)(this.r)||m.$k)){const X=this.s.getItem(U.D);X?this.updateWindowControls({height:X}):this.updateWindowControls({height:y.$dE})}m.$j&&C&&j.hookWindowMessage(278,()=>{const[oe,V]=j.getPosition(),ue=n.default.screen.getCursorScreenPoint(),re=ue.x-oe,Q=ue.y-V;return!(re>30&&Q>=0&&Q<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:re,y:Q})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),m.$k&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,C,X,oe){super(),this.r=j,this.s=C,this.t=X,this.u=oe,this.a=this.B(new T.$le),this.onDidClose=this.a.event,this.b=this.B(new T.$le),this.onDidMaximize=this.b.event,this.c=this.B(new T.$le),this.onDidUnmaximize=this.c.event,this.f=this.B(new T.$le),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new T.$le),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new T.$le),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,y.$eE)(this.r),this.G=void 0,this.H=void 0}w(j,C=n.default.screen.getAllDisplays().length>0){const X=this.r.getValue("window"),oe=m.$k&&X?.nativeTabs===!0;(m.$k||m.$j)&&C&&(!oe||n.default.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(V=>typeof V=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===O.WindowMode.Maximized||j.mode===O.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===O.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){m.$k?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return m.$k?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){m.$k&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return m.$k?!!this.win?.isDocumentEdited():!!this.C}focus(j){m.$k&&j?.force&&n.default.app.focus({steal:!0});const C=this.win;C&&(C.isMinimized()&&C.restore(),C.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(m.$k)switch(n.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const C=this.win;if(C){if(j.height&&this.s.setItem(Z.D,j.height),m.$j&&this.F)C.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(m.$k&&j.height!==void 0){const X=(j.height-15)/2;X?C.setWindowButtonPosition({x:X,y:X}):C.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,C){(0,y.$fE)(this.r)?this.J(j,C):this.M(j)}get isFullScreen(){if(m.$k&&typeof this.G=="boolean")return this.G;const j=this.win,C=j?.isFullScreen(),X=j?.isSimpleFullScreen();return!!(C||X)}J(j,C){const X=this.win;X?.isSimpleFullScreen()&&X?.setSimpleFullScreen(!1),this.L(j,C)}L(j,C){if(m.$k){this.G=j;const oe=this.H=new r.$2h;(async()=>{const V=await Promise.race([oe.p,(0,r.$Fh)(1e4).then(()=>!1)]);this.H===oe&&(this.G=void 0,this.H=void 0,!V&&j&&C&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const C=this.win;C?.isFullScreen()&&this.L(!1,!1),C?.setSimpleFullScreen(j),C?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$5fc=U;let Z=class extends U{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(C=>C.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Si)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,C,X,oe,V,ue,re,Q,N,F,_,z,ie,G,B,te,he,me,we,Ie,Ce){super(F,Ie,oe,C),this.fb=X,this.gb=V,this.hb=ue,this.ib=re,this.jb=Q,this.kb=N,this.lb=_,this.mb=z,this.nb=ie,this.ob=G,this.pb=B,this.qb=te,this.rb=he,this.sb=me,this.tb=we,this.N=this.B(new T.$le),this.onWillLoad=this.N.event,this.O=this.B(new T.$le),this.onDidSignalReady=this.O.event,this.P=this.B(new T.$le),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=J.NONE;{const[Re,ve]=this.Eb(j.state);this.U=Re,this.u.trace("window#ctor: using window state",Re);const $e=Ce.invokeFunction(R.$Pfc,this.U,{preload:p.$Yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.default.BrowserWindow($e),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,ve),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=J.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===J.READY}get whenClosedOrLoaded(){return new Promise(j=>{function C(){X.dispose(),oe.dispose(),j()}const X=this.onDidClose(()=>C()),oe=this.onWillLoad(()=>C())})}vb(){this.B(T.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(O.WindowError.UNRESPONSIVE))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(C,X)=>X)(C=>this.yb(O.WindowError.PROCESS_GONE,{...C}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(C,X,oe)=>({exitCode:X,reason:oe}))(({exitCode:C,reason:X})=>this.yb(O.WindowError.LOAD,{reason:X,exitCode:C}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(C=>C.preventDefault())),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(C=>this.Bb(C))),this.B(this.mb.onDidDeleteUntitledWorkspace(C=>this.Ab(C)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(C,X)=>{const oe=await this.xb();X({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,oe)})})}xb(){return this.wb||(this.wb=(0,o.$oq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,C){switch(j){case O.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break;case O.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case O.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:C?.reason,code:C?.exitCode}),j){case O.WindowError.UNRESPONSIVE:case O.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===O.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:X,checkboxChecked:oe}=await this.pb.showMessageBox({type:"warning",buttons:[(0,d.localize)(10995,null),(0,d.localize)(10996,null),(0,d.localize)(10997,null)],message:(0,d.localize)(10998,null),detail:(0,d.localize)(10999,null),checkboxLabel:this.S?.workspace?(0,d.localize)(11e3,null):void 0},this.m);if(X!==2){const V=X===0;await this.zb(V,oe)}}else if(j===O.WindowError.PROCESS_GONE){let X;C?X=(0,d.localize)(11002,null,C.reason,C.exitCode??"<unknown>"):X=(0,d.localize)(11001,null);const{response:oe,checkboxChecked:V}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,d.localize)(11003,null):(0,d.localize)(11004,null),(0,d.localize)(11005,null)],message:X,detail:this.S?.workspace?(0,d.localize)(11006,null):(0,d.localize)(11007,null),checkboxLabel:this.S?.workspace?(0,d.localize)(11008,null):void 0},this.m),ue=oe===0;await this.zb(ue,V)}break}}async zb(j,C){const X=this.S?.workspace;if(C&&X)try{const oe=this.kb.workspaceStorage(X);await oe.init(),oe.delete("memento/workbench.parts.editor"),await oe.close()}catch(oe){this.u.error(oe)}this.P.fire();try{if(j&&this.S){let oe,V;(0,L.$Oi)(X)?oe={folderUri:X.uri}:(0,L.$Ti)(X)?oe={workspaceUri:X.configPath}:V=!0,(0,de.$Nb)(await this.tb.open({context:R.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:oe?[oe]:void 0,forceEmpty:V,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const C=this.Gb();C!==this.W&&(this.W=C,this.Hb(C))}if(!j||j.affectsConfiguration("http.proxy")||j.affectsConfiguration("http.noProxy")){let C=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(C?.indexOf("@")!==-1){const oe=h.URI.parse(C),V=oe.authority.indexOf("@");V!==-1&&(C=oe.with({authority:oe.authority.substring(V+1)}).toString())}C?.endsWith("/")&&(C=C.substr(0,C.length-1));const X=(this.r.getValue("http.noProxy")||[]).map(oe=>oe.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((C||"").indexOf("@")===-1&&(C!==this.Z||X!==this.$)){this.Z=C,this.$=X;const oe=C||"",V=X?`${X},<local>`:"<local>";this.u.trace(`Setting proxy to '${oe}', bypassing '${V}'`),this.m.webContents.session.setProxy({proxyRules:oe,proxyBypassRules:V,pacScript:""}),n.default.app.setProxy({proxyRules:oe,proxyBypassRules:V,pacScript:""})}}}addTabbedWindow(j){m.$k&&j.win&&this.m.addTabbedWindow(j.win)}load(j,C=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!C.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),C.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,C),this.ub===J.NONE?this.S=j:this.db=j,this.ub=J.NAVIGATING,this.m.loadURL(p.$Yg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const X=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Qh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:C.isReload?O.LoadReason.RELOAD:X?O.LoadReason.LOAD:O.LoadReason.INITIAL})}Cb(j,C){const X=(this.S??this.db)?.userEnv;if(X){const oe=(0,$.$Jm)(X)&&!(0,$.$Jm)(j.userEnv),V=this.isExtensionDevelopmentHost;(oe||V)&&(j.userEnv={...X,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),C.disableExtensions!==void 0&&(j["disable-extensions"]=C.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),j.perfMarks=(0,c.getMarks)(),this.bb.update(j)}async reload(j){const C=Object.assign({},this.S);C.workspace=await this.Db(C),delete C.filesToOpenOrCreate,delete C.filesToDiff,delete C.filesToMerge,delete C.filesToWait,this.isExtensionDevelopmentHost&&j&&(C.verbose=j.verbose,C.debugId=j.debugId,C.extensionEnvironment=j.extensionEnvironment,C["inspect-extensions"]=j["inspect-extensions"],C["inspect-brk-extensions"]=j["inspect-brk-extensions"],C["extensions-dir"]=j["extensions-dir"]),C.accessibilitySupport=n.default.app.isAccessibilitySupportEnabled(),C.isInitialStartup=!1,C.policiesData=this.gb.serialize(),C.continueOn=this.t.continueOn,C.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},C.logLevel=this.fb.getLogLevel(),C.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(C,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,L.$Ti)(j.workspace)){const C=j.workspace.configPath;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}else if((0,L.$Oi)(j.workspace)){const C=j.workspace.uri;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,O.$Dfc)();if(this.isFullScreen){let X;try{X=n.default.screen.getDisplayMatching(this.getBounds())}catch{}const oe=(0,O.$Dfc)();return{mode:O.WindowMode.Fullscreen,display:X?X.id:void 0,width:this.U.width||oe.width,height:this.U.height||oe.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let C;if(!m.$k&&this.m.isMaximized()?C=O.WindowMode.Maximized:C=O.WindowMode.Normal,C===O.WindowMode.Maximized?j.mode=O.WindowMode.Maximized:j.mode=O.WindowMode.Normal,C===O.WindowMode.Normal||C===O.WindowMode.Maximized){let X;C===O.WindowMode.Normal?X=this.getBounds():X=this.m.getNormalBounds(),j.x=X.x,j.y=X.y,j.width=X.width,j.height=X.height}return j.zoomLevel=this.ab,j}Eb(j){(0,c.mark)("code/willRestoreCodeWindowState");let C=!1;if(j){this.ab=j.zoomLevel;try{const X=n.default.screen.getAllDisplays();C=X.length>1,j=R.WindowStateValidator.validateWindowState(this.u,j,X)}catch(X){this.u.warn(`Unexpected error validating window state: ${X}
${X.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[j||(0,O.$Dfc)(),C]}getBounds(){const[j,C]=this.m.getPosition(),[X,oe]=this.m.getSize();return{x:j,y:C,width:X,height:oe}}I(j,C){super.I(j,C),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,y.$_D)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,C=!0){m.$k||(j==="toggle"&&C&&this.send("vscode:showInfoMessage",(0,d.localize)(11009,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const C=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!C),this.m.autoHideMenuBar=C;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,C,...X){this.isReady?this.send(j,...X):this.ready().then(()=>{C.isCancellationRequested||this.send(j,...X)})}send(j,...C){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...C)}catch(X){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,D.$pj)(X)}`)}}}updateTouchBar(j){m.$k&&this.Y.forEach((C,X)=>{const oe=j[X];C.segments=this.Mb(oe)})}Kb(){if(m.$k){for(let j=0;j<10;j++){const C=this.Lb();this.Y.push(C)}this.m.setTouchBar(new n.default.TouchBar({items:this.Y}))}}Lb(j=[]){const C=this.Mb(j),X=new n.default.TouchBar.TouchBarSegmentedControl({segments:C,mode:"buttons",segmentStyle:"automatic",change:oe=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:X.segments[oe].id,from:"touchbar"})}});return X}Mb(j=[]){return j.map(X=>{let oe;X.icon&&!l.ThemeIcon.isThemeIcon(X.icon)&&X.icon?.dark?.scheme===p.Schemas.file&&(oe=n.default.nativeImage.createFromPath(h.URI.revive(X.icon.dark).fsPath),oe.isEmpty()&&(oe=void 0));let V;return typeof X.title=="string"?V=X.title:V=X.title.value,{id:X.id,label:oe?void 0:V,icon:oe}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$6fc=Z,e.$6fc=Z=Se([se(1,t.$_j),se(2,K.$3fc),se(3,b.$Bfc),se(4,M.$so),se(5,q.$Rfc),se(6,k.$_k),se(7,s.$dgc),se(8,s.$bgc),se(9,g.$$i),se(10,E.$Mfc),se(11,A.$1fc),se(12,f.$Ifc),se(13,a.$$l),se(14,v.$Jfc),se(15,S.$8fc),se(16,u.$sk),se(17,i.$Lfc),se(18,R.$Ofc),se(19,H.$zR),se(20,Y.$Di)],Z)}),define(ce[273],le([0,1,13,3,16,20,19,5,34,51,52,137]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;let d=class extends h.$5fc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(f,g,v,b,$,k){super(b,$,g,v),this.O=f,this.P=k,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(f){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),f&&!this.N&&(this.N=!0,this.w({x:f.x,y:f.y,width:f.width,height:f.height,mode:f.show===!1?m.WindowMode.Maximized:m.WindowMode.Normal})))}Q(){if(this.m)return;const f=n.BrowserWindow.fromWebContents(this.O);f&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(f),f.setMenu(null),(r.$j||r.$l)&&(0,c.$bE)(this.r)&&f.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(f){return this.O.id===f.id}};e.$7fc=d,e.$7fc=d=Se([se(1,D.$Bfc),se(2,I.$_j),se(3,P.$$i),se(4,p.$zR),se(5,T.$8fc)],d)}),define(ce[274],le([0,1,13,4,2,11,35,273,6,5,52,29]),function(x,e,n,r,P,D,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;let d=class extends P.$Uc{constructor(f,g){super(),this.h=f,this.j=g,this.a=this.B(new r.$le),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$le),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$le),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$le),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,g)=>{const v=this.getWindowByWebContents(g.webContents);if(v)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow();else{const b=new P.$Tc;b.add(r.Event.fromNodeEventEmitter(g.webContents,"did-create-window",($,k)=>({browserWindow:$,details:k}))(({browserWindow:$,details:k})=>{const S=this.getWindowByWebContents($.webContents);S&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),S.tryClaimWindow(k.options))})),b.add(r.Event.fromNodeEventEmitter(g,"closed")(()=>b.dispose()))}}),T.$TX.handle("vscode:registerAuxiliaryWindow",async(f,g)=>{const v=this.getWindowByWebContents(f.sender);return v&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=g),f.sender.id})}createWindow(f){return this.h.invokeFunction(h.$Pfc,this.n(f),{preload:D.$Yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const g={},v=f.features.split(",");for(const $ of v){const[k,S]=$.split("=");switch(k){case"width":g.width=parseInt(S,10);break;case"height":g.height=parseInt(S,10);break;case"left":g.x=parseInt(S,10);break;case"top":g.y=parseInt(S,10);break;case"window-maximized":g.mode=m.WindowMode.Maximized;break;case"window-fullscreen":g.mode=m.WindowMode.Fullscreen;break}}const b=h.WindowStateValidator.validateWindowState(this.j,g)??(0,m.$Efc)();return this.j.trace("[aux window] using window state",b),b}registerWindow(f){const g=new P.$Tc,v=this.h.createInstance(I.$7fc,f);this.g.set(v.id,v),g.add((0,P.$Sc)(()=>this.g.delete(v.id))),g.add(v.onDidMaximize(()=>this.a.fire(v))),g.add(v.onDidUnmaximize(()=>this.b.fire(v))),g.add(v.onDidEnterFullScreen(()=>this.c.fire({window:v,fullscreen:!0}))),g.add(v.onDidLeaveFullScreen(()=>this.c.fire({window:v,fullscreen:!1}))),g.add(v.onDidTriggerSystemContextMenu(({x:b,y:$})=>this.f.fire({window:v,x:b,y:$}))),r.Event.once(v.onDidClose)(()=>g.dispose())}getWindowByWebContents(f){const g=this.g.get(f.id);return g?.matches(f)?g:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,h.$Qfc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Chc=d,e.$Chc=d=Se([se(0,p.$Di),se(1,c.$_j)],d)}),define(ce[88],le([0,1,13,21,8,4,47,2,11,3,18,7,23,10,6,19,5,62,87,102,30,59,31,53]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0,e.$Ogc=(0,f.$Ei)("workspacesHistoryMainService");let s=class extends I.$Uc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(l,E,y,R,L){super(),this.f=l,this.g=E,this.h=y,this.j=R,this.m=L,this.c=this.B(new D.$le),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new P.$Ch(800)),this.n()}n(){this.h.when(g.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){let E=[],y=[];for(const L of l)if((0,k.$cib)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(E,L.workspace)&&E.push(L);else if((0,k.$dib)(L))this.y(E,L.folderUri)||E.push(L);else{const A=this.z(y,L.fileUri),O=L.fileUri.scheme===p.Schemas.file&&o.G.indexOf((0,m.$ch)(L.fileUri))>=0;!A&&!O&&(y.push(L),c.$j&&L.fileUri.scheme===p.Schemas.file&&n.app.addRecentDocument(L.fileUri.fsPath))}const R=await this.r({workspaces:E,files:y});E=R.workspaces,y=R.files,E.length>o.a&&(E.length=o.a),y.length>o.a&&(y.length=o.a),await this.t({workspaces:E,files:y}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(l){const E=A=>{const O=this.u(A);for(const M of l)if(m.$9g.isEqual(M,O))return!1;return!0},y=await this.getRecentlyOpened(),R=y.workspaces.filter(E),L=y.files.filter(E);(R.length!==y.workspaces.length||L.length!==y.files.length)&&(await this.t({files:L,workspaces:R}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(l){if(l?.confirm){const{response:E}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(10973,null),(0,w.localize)(10974,null)],message:(0,w.localize)(10975,null),detail:(0,w.localize)(10976,null),cancelId:1});if(E!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(l){const E=new u.$Ac(L=>m.$9g.getComparisonKey(L));if(l?.workspaces)for(const L of l.workspaces)E.set(this.u(L),L);const y=new u.$Ac(L=>m.$9g.getComparisonKey(L));if(l?.files)for(const L of l.files)y.set(this.u(L),L);const R=await this.s();for(const L of R.workspaces){const A=E.get(this.u(L));A?A.label=A.label??L.label:E.set(this.u(L),L)}for(const L of R.files){const A=y.get(this.u(L));A?A.label=A.label??L.label:y.set(this.u(L),L)}return{workspaces:[...E.values()],files:[...y.values()]}}async s(){await this.j.whenReady;let l;const E=this.j.get(o.b,b.StorageScope.APPLICATION);if(typeof E=="string")try{l=JSON.parse(E)}catch(y){this.f.error("Unexpected error parsing opened paths list",y)}return(0,k.$jib)(l,this.f)}async t(l){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,k.$kib)(l)),b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}u(l){return(0,k.$dib)(l)?l.folderUri:(0,k.$eib)(l)?l.fileUri:l.workspace.configPath}w(l,E){return!!l.find(y=>(0,k.$cib)(y)&&y.workspace.id===E.id)}y(l,E){return!!l.find(y=>(0,k.$dib)(y)&&m.$9g.isEqual(y.folderUri,E))}z(l,E){return!!l.find(y=>m.$9g.isEqual(y.fileUri,E))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$j)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(10977,null),description:(0,w.localize)(10978,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const E=[];for(const L of n.app.getJumpListSettings().removedItems){const A=L.args;if(A){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);O&&E.push(h.URI.parse(O[2]))}}await this.removeRecentlyOpened(E);let y=!1;const R=(0,r.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(L=>{const A=(0,k.$cib)(L)?L.workspace:L.folderUri,{title:O,description:M}=this.L(A,L.label);let H;return h.URI.isUri(A)?H=`--folder-uri "${A.toString()}"`:(y=!0,H=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:M.substr(0,255),program:process.execPath,args:H,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&l.push({type:"custom",name:y?(0,w.localize)(10979,null):(0,w.localize)(10980,null),items:R})}l.push({type:"recent"});try{const E=n.app.setJumpList(l);E&&E!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${E}`)}catch(E){this.f.warn("updateWindowsJumpList#setJumpList",E)}}L(l,E){if(E)return{title:(0,T.$8w)(E).name,description:E};if(h.URI.isUri(l))return{title:(0,m.$ch)(l),description:this.M(l)};if(this.g.isUntitledWorkspace(l))return{title:(0,w.localize)(10981,null),description:""};let y=(0,m.$ch)(l.configPath);return y.endsWith(S.$1i)&&(y=y.substr(0,y.length-S.$1i.length-1)),{title:(0,w.localize)(10982,null,y),description:this.M(l.configPath)}}M(l){return l.scheme==="file"?(0,T.$Zw)(l.fsPath):l.toString()}async N(){if(!c.$k)return;n.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),E=[];let y=0;for(let L=0;L<l.workspaces.length&&y<o.C;L++){const A=this.u(l.workspaces[L]);if(A.scheme===p.Schemas.file){const O=(0,m.$6g)(A);await d.Promises.exists(O)&&(E.push(O),y++)}}const R=[];for(let L=0;L<l.files.length&&y<o.D;L++){const A=this.u(l.files[L]);if(A.scheme===p.Schemas.file){const O=(0,m.$6g)(A);if(o.G.includes((0,m.$ch)(A))||E.includes(O))continue;await d.Promises.exists(O)&&(R.push(O),y++)}}R.reverse().forEach(L=>n.app.addRecentDocument(L)),E.reverse().forEach(L=>n.app.addRecentDocument(L))}};e.$Pgc=s,e.$Pgc=s=o=Se([se(0,v.$_j),se(1,t.$1fc),se(2,g.$8fc),se(3,$.$dgc),se(4,i.$Jfc)],s)}),define(ce[275],le([0,1,13,8,22,47,3,7,10,84,16,20,19,5,198,64,28,34,24,50,51,29,88,2]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0,p=Pe(p);const s="menu";let a=class extends i.$Uc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(y,R,L,A,O,M,H,q,K,de,Y,J){super(),this.t=y,this.u=R,this.w=L,this.y=A,this.z=O,this.C=M,this.D=H,this.F=q,this.G=K,this.H=de,this.I=Y,this.J=J,this.s=Object.create(null),this.h=new r.$Qh(()=>this.R(),0),this.j=new r.$Qh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(T.$k||(0,S.$bE)(R))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const y=this.D.getItem(o.a);y&&(y.menus&&(this.n=y.menus),y.keybindings&&(this.r=y.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(M,H,q)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:H?.id})},this.s["workbench.action.newWindow"]=(M,H,q)=>this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:H?.id}),this.s["workbench.action.files.openFileFolder"]=(M,H,q)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(M,H,q)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(M,H,q)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const y=this.I.youTubeUrl;y&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(y,"openYouTubeUrl"));const R=this.I.requestFeatureUrl;R&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(R,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const A=this.I.licenseUrl;A&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(T.$x){const M=A.indexOf("?")>0?"&":"?";this.ob(`${A}${M}lang=${T.$x}`,"openLicenseUrl")}else this.ob(A,"openLicenseUrl")});const O=this.I.privacyStatementUrl;O&&A&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(O,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(y=>this.S(y))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const y=this.u.getValue("window.enableMenuBarMnemonics");return typeof y!="boolean"?!0:y}get P(){if(!T.$k)return!1;const y=this.u.getValue("window.nativeTabs");return typeof y!="boolean"?!1:y}updateMenu(y,R){this.n=y.menus,this.r=y.keybindings,this.D.setItem(o.a,y),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(y){T.$k&&(y.oldCount===0&&y.newCount>0||y.oldCount>0&&y.newCount===0)&&(this.f=y.newCount===0,this.Q())}U(){if(!T.$k)return;const y=n.BrowserWindow.getFocusedWindow();this.g=!y||!!this.J.getWindowByWebContents(y.webContents),this.Q()}W(){const y=n.Menu.getApplicationMenu();if(y&&this.m.push(y),Object.keys(this.n).length===0){this.X(T.$k?new n.Menu:null);return}const R=new n.Menu;let L;if(T.$k){const O=new n.Menu;L=new n.MenuItem({label:this.I.nameShort,submenu:O}),this.Y(O),R.append(L)}if(T.$k&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.qb(p.localize(11232,null)),click:()=>this.w.openEmptyWindow({context:t.OpenContext.DOCK})})),n.app.dock.setMenu(O)}if(this.$("File")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11233,null)),submenu:O});this.bb(O,"File"),R.append(M)}if(this.$("Edit")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11234,null)),submenu:O});this.bb(O,"Edit"),R.append(M)}if(this.$("Selection")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11235,null)),submenu:O});this.bb(O,"Selection"),R.append(M)}if(this.$("View")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11236,null)),submenu:O});this.bb(O,"View"),R.append(M)}if(this.$("Go")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11237,null)),submenu:O});this.bb(O,"Go"),R.append(M)}if(this.$("Run")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11238,null)),submenu:O});this.bb(O,"Run"),R.append(M)}if(this.$("Terminal")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11239,null)),submenu:O});this.bb(O,"Terminal"),R.append(M)}let A;if(this.$("Window")){const O=new n.Menu;A=new n.MenuItem({label:this.qb(p.localize(11240,null)),submenu:O,role:"window"}),this.hb(O)}if(A&&R.append(A),this.$("Help")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11241,null)),submenu:O,role:"help"});this.bb(O,"Help"),R.append(M)}R.items&&R.items.length>0?this.X(R):this.X(null),this.j.schedule()}X(y){if(n.Menu.setApplicationMenu(y),y)for(const R of this.J.getWindows())R.win?.setMenu(null)}Y(y){const R=this.jb(p.localize(11242,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let A;if(this.$("Preferences")){const J=new n.Menu;this.bb(J,"Preferences"),A=new n.MenuItem({label:this.qb(p.localize(11243,null)),submenu:J})}const O=new n.Menu,M=new n.MenuItem({label:p.localize(11244,null),role:"services",submenu:O}),H=new n.MenuItem({label:p.localize(11245,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),q=new n.MenuItem({label:p.localize(11246,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new n.MenuItem({label:p.localize(11247,null),role:"unhide"}),de=new n.MenuItem(this.nb("workbench.action.quit",{label:p.localize(11248,null,this.I.nameLong),click:async(J,U,Z)=>{const W=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||W?.win?.isMinimized())&&await this.Z(Z)&&this.H.quit(void 0)}})),Y=[R];Y.push(...L),A&&Y.push(l(),A),Y.push(l(),M,l(),H,q,K,l(),de),Y.forEach(J=>y.append(J))}async Z(y){if(this.w.getWindowCount()===0)return!0;const R=this.u.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.fb(y)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[p.localize(11249,null),p.localize(11250,null)],message:p.localize(11251,null)});return L===0}return!0}$(y){if(!T.$k&&!(0,S.$bE)(this.u))return!1;switch(y){case"File":case"Help":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[y];case"Window":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[y]}}ab(y,R){R.forEach(L=>{if((0,f.$Lgc)(L))y.append(l());else if((0,f.$Kgc)(L)){const A=new n.Menu,O=new n.MenuItem({label:this.qb(L.label),submenu:A});this.ab(A,L.submenu.items),y.append(O)}else(0,f.$Mgc)(L)?y.append(this.db(L)):(0,f.$Ngc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(y),T.$k?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?y.append(new n.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):y.append(this.jb(L.label,L.id,!1,L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(y,R){this.n&&this.n[R]&&this.ab(y,this.n[R].items)}cb(y){const R=this.ib();R.length&&(R.forEach(L=>y.append(L)),y.append(l()))}db(y){const R=I.URI.revive(y.uri),L=y.id,A=L==="openRecentFile"?{fileUri:R}:L==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new n.MenuItem(this.nb(L,{label:y.label,click:async(O,M,H)=>{const q=this.eb(H);(await this.w.open({context:t.OpenContext.MENU,cli:this.y.args,urisToOpen:[A],forceNewWindow:q,gotoLineMode:!1,remoteAuthority:y.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([R])}},!1))}eb(y){return!!(y&&(!T.$k&&(y.ctrlKey||y.shiftKey)||T.$k&&(y.metaKey||y.altKey)))}fb(y){return!!(y.triggeredByAccelerator||y.altKey||y.ctrlKey||y.metaKey||y.shiftKey)}gb(y,R,L){const A={label:this.qb(y),role:L,enabled:!0};return new n.MenuItem(this.mb(R,A))}hb(y){const R=new n.MenuItem({label:p.localize(11252,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:p.localize(11253,null),role:"zoom",enabled:this.w.getWindowCount()>0}),A=new n.MenuItem({label:p.localize(11254,null),role:"front",enabled:this.w.getWindowCount()>0}),O=this.jb(p.localize(11255,null),"workbench.action.switchWindow"),M=[];this.P&&(M.push(l()),M.push(this.jb(p.localize(11256,null),"workbench.action.newWindowTab")),M.push(this.gb(p.localize(11257,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.gb(p.localize(11258,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.gb(p.localize(11259,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.gb(p.localize(11260,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,L,l(),O,...M,l(),A].forEach(H=>y.append(H))}ib(){switch(this.t.state.type){case k.StateType.Idle:return[new n.MenuItem({label:this.qb(p.localize(11261,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case k.StateType.CheckingForUpdates:return[new n.MenuItem({label:p.localize(11262,null),enabled:!1})];case k.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(p.localize(11263,null)),click:()=>{this.t.downloadUpdate()}})];case k.StateType.Downloading:return[new n.MenuItem({label:p.localize(11264,null),enabled:!1})];case k.StateType.Downloaded:return T.$k?[]:[new n.MenuItem({label:this.qb(p.localize(11265,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case k.StateType.Updating:return[new n.MenuItem({label:p.localize(11266,null),enabled:!1})];case k.StateType.Ready:return[new n.MenuItem({label:this.qb(p.localize(11267,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(y,R,L,A){const O=this.qb(y),M=typeof R=="function"?R:(Y,J,U)=>{const Z=Y?Y.userSettingsLabel:null;let W=R;Array.isArray(R)&&(W=this.eb(U)?R[1]:R[0]),Z&&U.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:Z}):this.lb({type:"commandId",commandId:W})},H=typeof L=="boolean"?L:this.w.getWindowCount()>0,q=typeof A=="boolean"?A:!1,K={label:O,click:M,enabled:H};q&&(K.type="checkbox",K.checked=q);let de;return typeof R=="string"?de=R:Array.isArray(R)&&(de=R[0]),T.$k&&(de==="editor.action.clipboardCutAction"?K.role="cut":de==="editor.action.clipboardCopyAction"?K.role="copy":de==="editor.action.clipboardPasteAction"&&(K.role="paste"),de==="undo"?K.click=this.kb(M,{inDevTools:Y=>Y.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):de==="redo"?K.click=this.kb(M,{inDevTools:Y=>Y.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):de==="editor.action.selectAll"&&(K.click=this.kb(M,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(de,K))}kb(y,R){return(L,A,O)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return R.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return R.inDevTools(M.webContents.devToolsWebContents);y(L,A||M,O)}}lb(y){let R=n.BrowserWindow.getFocusedWindow();if(R){const A=this.J.getWindowByWebContents(R.webContents);A&&(R=this.w.getWindowById(A.parentId)?.win??null)}if(!R){const A=this.w.getLastActiveWindow();A?.win?.isMinimized()&&(R=A.win)}const L=R?this.w.getWindowById(R.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",y),T.$k&&!this.y.isBuilt&&!L.isReady&&(y.type==="commandId"&&y.commandId==="workbench.action.toggleDevTools"||y.type!=="commandId"&&y.userSettingsLabel==="alt+cmd+i"))return!1;if(y.type==="commandId"){const A={id:y.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",P.CancellationToken.None,A)}else{const A={userSettingsLabel:y.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,A)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",y),!1}mb(y,R){const L=typeof y=="string"?this.r[y]:void 0;if(L?.label){if(L.isNative!==!1)R.accelerator=L.label,R.userSettingsLabel=L.userSettingsLabel;else if(typeof R.label=="string"){const A=R.label.indexOf("[");A>=0?R.label=`${R.label.substr(0,A)} [${L.label}]`:R.label=`${R.label} [${L.label}]`}}else R.accelerator=void 0;return R}nb(y,R,L=!R.accelerator){L&&(R=this.mb(y,R));const A=R.click;return R.click=(O,M,H)=>{this.pb(y),A?.(O,M,H)},R}ob(y,R){this.H.openExternal(void 0,y),this.pb(R)}pb(y){this.z.publicLog2("workbenchActionExecuted",{id:y,from:s})}qb(y){return(0,D.$5w)(y,!this.O)}};e.$Qgc=a,e.$Qgc=a=o=Se([se(0,k.$SY),se(1,m.$$i),se(2,t.$Ofc),se(3,h.$Bfc),se(4,$.$$l),se(5,u.$Ogc),se(6,b.$zR),se(7,d.$8fc),se(8,w.$_j),se(9,g.$Bgc),se(10,v.$sk),se(11,c.$Agc)],a);function l(){return new n.MenuItem({type:"separator"})}}),define(ce[276],le([0,1,6,19,5,275,2]),function(x,e,n,r,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=void 0,e.$Rgc=(0,n.$Ei)("menubarMainService");let I=class extends T.$Uc{constructor(c,m,h){super(),this.b=c,this.c=m,this.f=h,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(D.$Qgc))}async updateMenubar(c,m){this.f.trace("menubarService#updateMenubar",c),(await this.a).updateMenu(m,c)}};e.$Sgc=I,e.$Sgc=I=Se([se(0,n.$Di),se(1,r.$8fc),se(2,P.$_j)],I)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[277],le([0,1,26,13,106,27,21,22,39,4,32,47,2,11,9,70,3,36,18,12,7,10,69,16,53,20,14,6,19,5,72,73,74,34,51,137,29,134,268,30,103,88,59,52,76,40,58,71,84]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t,u,i,o,s,a,l,E,y,R,L,A,O,M,H,q,K,de,Y,J,U,Z,W,j,C,X,oe,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0,n=Pe(n),R=Ve(R);function ue(N){return(0,Y.$Ti)(N?.workspace)}function re(N){return(0,Y.$Oi)(N?.workspace)}let Q=class extends d.$Uc{constructor(F,_,z,ie,G,B,te,he,me,we,Ie,Ce,Re,ve,$e,ee,ae,fe,be,De,Ne){super(),this.s=F,this.t=_,this.u=z,this.w=ie,this.z=G,this.C=B,this.D=te,this.F=he,this.G=me,this.H=we,this.I=Ie,this.J=Ce,this.L=Re,this.M=ve,this.N=$e,this.O=ee,this.P=ae,this.Q=fe,this.R=be,this.S=De,this.U=Ne,this.a=this.B(new c.$le),this.onDidOpenWindow=this.a.event,this.b=this.B(new c.$le),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new c.$le),this.onDidDestroyWindow=this.c.event,this.f=this.B(new c.$le),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new c.$le),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new c.$le),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new c.$le),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new c.$le),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new de.$dhc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(F=>this.b.fire(F.window))),this.B(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const _=new d.$Tc;if(_.add(c.Event.any(F.onDidClose,F.onDidDestroy)(()=>_.dispose())),F.config.extensionDevelopmentPath)for(const z of F.config.extensionDevelopmentPath)_.add(this.R.addValidFileRoot(z));F.config.extensionTestsPath&&_.add(this.R.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,_){const z=this.G.args,ie=_?.remoteAuthority||void 0,G=!0,B=_?.forceReuseWindow,te=!B;return this.open({...F,cli:z,forceEmpty:G,forceNewWindow:te,forceReuseWindow:B,remoteAuthority:ie,forceTempProfile:_?.forceTempProfile,forceProfile:_?.forceProfile})}openExistingWindow(F,_){F.focus(),this.X(_,[F])}async open(F){this.z.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const _=[],z=[],ie=[],G=[],B=[];let te,he=0;const me=await this.db(F);this.z.trace("windowsManager#open pathsToOpen",me);for(const ve of me)re(ve)?F.addMode?_.push(ve):z.push(ve):ue(ve)?ie.push(ve):ve.fileUri?(te||(te={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ve.remoteAuthority}),te.filesToOpenOrCreate.push(ve)):ve.backupPath?B.push({backupFolder:(0,f.$nc)(ve.backupPath),remoteAuthority:ve.remoteAuthority}):he++;F.diffMode&&te&&te.filesToOpenOrCreate.length>=2&&(te.filesToDiff=te.filesToOpenOrCreate.slice(0,2),te.filesToOpenOrCreate=[]),F.mergeMode&&te&&te.filesToOpenOrCreate.length===4&&(te.filesToMerge=te.filesToOpenOrCreate.slice(0,4),te.filesToOpenOrCreate=[],te.filesToDiff=[]),te&&F.waitMarkerFileURI&&(te.filesToWait={paths:(0,T.$Gb)([...te.filesToDiff,te.filesToMerge[3],...te.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(G.push(...this.N.getUntitledWorkspaces()),ie.push(...G),B.push(...this.J.getEmptyWindowBackups())):B.length=0;const{windows:we,filesOpenedInWindow:Ie}=await this.Y(F,ie,z,B,he,te,_);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${ie.length}, foldersToOpen: ${z.length}, emptyToRestore: ${B.length}, emptyToOpen: ${he})`),we.length>1)if(Ie)Ie.focus();else{const ve=this.r.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let $e=!0,ee=!0;if(ve){const ae=we.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ae.length&&(ae[0].focus(),$e=!1,ee=!1)}if($e)for(let ae=we.length-1;ae>=0;ae--){const fe=we[ae];if(!(fe.openedWorkspace&&G.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&B.some(be=>fe.backupPath&&be.backupFolder===(0,f.$nc)(fe.backupPath)))){fe.focus(),ee=!1;break}}ee&&we[we.length-1].focus()}const Ce=te&&te.filesToDiff.length>0,Re=te&&te.filesToMerge.length>0;if(!we.some(ve=>ve.isExtensionDevelopmentHost)&&!Ce&&!Re&&!F.noRecentEntry){const ve=[];for(const $e of me)ue($e)&&!$e.transient?ve.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):re($e)?ve.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&ve.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(ve)}return this.X(F,we),we}X(F,_){const z=F.waitMarkerFileURI;F.context===q.OpenContext.CLI&&z&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.Q.del(z)}catch{}})()}async Y(F,_,z,ie,G,B,te){const he=[];let me;function we(ae,fe){he.push(ae),fe&&(me=ae,B=void 0)}let{openFolderInNewWindow:Ie,openFilesInNewWindow:Ce}=this.pb(F);if(!F.initialStartup&&te.length>0){const ae=te[0].remoteAuthority,fe=this.vb(ae);fe&&we(this.ab(fe,te.map(be=>be.workspace.uri)))}const Re=z.length+_.length+ie.length;if(B&&Re===0){const ae=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],fe=this.getWindows().filter(De=>B&&(0,$.$kh)(De.remoteAuthority,B.remoteAuthority));let be;ae?.fileUri&&!Ce&&((F.context===q.OpenContext.DESKTOP||F.context===q.OpenContext.CLI||F.context===q.OpenContext.DOCK)&&(be=await(0,K.$Tfc)(fe,ae.fileUri,async De=>De.configPath.scheme===w.Schemas.file?this.N.resolveLocalWorkspace(De.configPath):void 0)),be||(be=this.wb(fe))),be?(0,Y.$Ti)(be.openedWorkspace)?_.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,Y.$Oi)(be.openedWorkspace)?z.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(F,be,B),!0):we(await this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const ve=(0,T.$Lb)(_,ae=>ae.workspace.id);if(ve.length>0){const ae=(0,T.$Gb)(ve.map(fe=>(0,K.$Ufc)(this.getWindows(),fe.workspace.configPath)));if(ae.length>0){const fe=ae[0],be=(0,$.$kh)(B?.remoteAuthority,fe.remoteAuthority)?B:void 0;we(this.Z(F,fe,be),!!be),Ie=!0}for(const fe of ve){if(ae.some(Ne=>Ne.openedWorkspace&&Ne.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,De=(0,$.$kh)(B?.remoteAuthority,be)?B:void 0;we(await this.cb(F,fe,Ie,De),!!De),Ie=!0}}const $e=(0,T.$Lb)(z,ae=>$.$9g.getComparisonKey(ae.workspace.uri));if($e.length>0){const ae=(0,T.$Gb)($e.map(fe=>(0,K.$Ufc)(this.getWindows(),fe.workspace.uri)));if(ae.length>0){const fe=ae[0],be=(0,$.$kh)(B?.remoteAuthority,fe.remoteAuthority)?B:void 0;we(this.Z(F,fe,be),!!be),Ie=!0}for(const fe of $e){if(ae.some(Ne=>(0,Y.$Oi)(Ne.openedWorkspace)&&$.$9g.isEqual(Ne.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,De=(0,$.$kh)(B?.remoteAuthority,be)?B:void 0;we(await this.cb(F,fe,Ie,De),!!De),Ie=!0}}const ee=(0,T.$Lb)(ie,ae=>ae.backupFolder);if(ee.length>0)for(const ae of ee){const fe=ae.remoteAuthority,be=(0,$.$kh)(B?.remoteAuthority,fe)?B:void 0;we(await this.bb(F,!0,fe,be,ae),!!be),Ie=!0}if(he.length===0||B){B&&!G&&G++;const ae=B?B.remoteAuthority:F.remoteAuthority;for(let fe=0;fe<G;fe++)we(await this.bb(F,Ie,ae,B),!!B),Ie=!0}return{windows:(0,T.$Lb)(he),filesOpenedInWindow:me}}Z(F,_,z){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:z}),this.$(_);const ie={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToMerge:z?.filesToMerge,filesToWait:z?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",I.CancellationToken.None,ie),_}$(F){let _=F;const z=r.BrowserWindow.getFocusedWindow();if(z&&z.id!==F.id){const ie=this.U.getWindowByWebContents(z.webContents);ie&&ie.parentId===F.id&&(_=ie)}_.focus()}ab(F,_){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:_}),F.focus();const z={foldersToAdd:_};return F.sendWhenReady("vscode:addFolders",I.CancellationToken.None,z),F}bb(F,_,z,ie,G){this.z.trace("windowsManager#doOpenEmpty",{restore:!!G,remoteAuthority:z,filesToOpen:ie,forceNewWindow:_});let B;return!_&&typeof F.contextWindowId=="number"&&(B=this.getWindowById(F.contextWindowId)),this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:z,forceNewWindow:_,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:ie,windowToUse:B,emptyWindowBackupInfo:G,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}cb(F,_,z,ie,G){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:_,filesToOpen:ie}),!z&&!G&&typeof F.contextWindowId=="number"&&(G=this.getWindowById(F.contextWindowId)),this.qb({workspace:_.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:ie,windowToUse:G,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async db(F){let _,z=!1,ie=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(_=await this.eb(F),z=!0):F.forceEmpty?_=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(_=await this.fb(F.cli),_.length===0&&_.push(Object.create(null)),z=!0):(_=await this.hb(),_.length===0&&_.push(Object.create(null)),ie=!0),!F.addMode&&z){const G=_.filter(B=>re(B));if(G.length>1){const B=G[0].remoteAuthority;if(G.every(te=>(0,$.$kh)(te.remoteAuthority,B))){const te=await this.N.createUntitledWorkspace(G.map(he=>({uri:he.workspace.uri})));_.push({workspace:te,remoteAuthority:B}),_=_.filter(he=>!re(he))}}}if(F.initialStartup&&!ie&&this.L.getValue("window")?.restoreWindows==="preserve"){const G=await this.hb();_.unshift(...G.filter(B=>ue(B)||re(B)||B.backupPath))}return _}async eb(F){const _={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},z=await Promise.all((0,T.$Gb)(F.urisToOpen||[]).map(async ie=>{const G=await this.jb(ie,_);if(G)return G.label=ie.label,G;const B=this.lb(ie);this.P.showMessageBox({type:"info",buttons:[(0,t.localize)(10984,null)],message:B.scheme===w.Schemas.file?(0,t.localize)(10985,null):(0,t.localize)(10986,null),detail:B.scheme===w.Schemas.file?(0,t.localize)(10987,null,(0,h.$Yw)(B,{os:v.OS,tildify:this.G})):(0,t.localize)(10988,null,B.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,T.$Gb)(z)}async fb(F){const _=[],z={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},ie=F["folder-uri"];if(ie){const te=await Promise.all(ie.map(he=>{const me=this.gb(he);if(me)return this.jb({folderUri:me},z)}));_.push(...(0,T.$Gb)(te))}const G=F["file-uri"];if(G){const te=await Promise.all(G.map(he=>{const me=this.gb(he);if(me)return this.jb((0,Y.$0i)(he)?{workspaceUri:me}:{fileUri:me},z)}));_.push(...(0,T.$Gb)(te))}const B=await Promise.all(F._.map(te=>z.remoteAuthority?this.ob(te,z):this.mb(te,z)));return _.push(...(0,T.$Gb)(B)),_}gb(F){try{const _=S.URI.parse(F);if(!_.scheme){this.z.error(`Invalid URI input string, scheme missing: ${F}`);return}return _.path?_:_.with({path:"/"})}catch(_){this.z.error(`Invalid URI input string: ${F}, ${_.message}`)}}async hb(){const F=this.ib();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const _=[];F!=="one"&&_.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&_.push(this.r.state.lastActiveWindow);const z=await Promise.all(_.map(async ie=>{if(ie.workspace){const G=await this.jb({workspaceUri:ie.workspace.configPath},{remoteAuthority:ie.remoteAuthority,rejectTransientWorkspaces:!0});if(ue(G))return G}else if(ie.folderUri){const G=await this.jb({folderUri:ie.folderUri},{remoteAuthority:ie.remoteAuthority});if(re(G))return G}else if(F!=="folders"&&ie.backupPath)return{backupPath:ie.backupPath,remoteAuthority:ie.remoteAuthority}}));return(0,T.$Gb)(z)}}}ib(){let F;return this.I.wasRestarted?F="all":(F=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async jb(F,_=Object.create(null)){const z=this.lb(F);return z.scheme===w.Schemas.file?((0,M.$$D)(F)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.mb(z.fsPath,_)):this.kb(F,_)}kb(F,_){let z=this.lb(F);const ie=(0,A.$gn)(z)||_.remoteAuthority;if(z=(0,$.$mh)((0,$.$gh)(z)),(0,M.$$D)(F)){if(_.gotoLineMode){const{path:G,line:B,column:te}=(0,m.$Lg)(z.path);return{fileUri:z.with({path:G}),options:{selection:B?{startLineNumber:B,startColumn:te||1}:void 0},remoteAuthority:ie}}return{fileUri:z,remoteAuthority:ie}}else if((0,M.$9D)(F))return{workspace:(0,J.$Xfc)(z),remoteAuthority:ie};return{workspace:(0,J.$Yfc)(z),remoteAuthority:ie}}lb(F){return(0,M.$9D)(F)?F.workspaceUri:(0,M.$0D)(F)?F.folderUri:F.fileUri}async mb(F,_,z){let ie,G;_.gotoLineMode&&({path:F,line:ie,column:G}=(0,m.$Lg)(F)),F=(0,m.$Fg)((0,f.$hc)(F),(0,b.cwd)());try{const B=await n.promises.stat(F);if(B.isFile()){if(!_.forceOpenWorkspaceAsFile){const te=await this.N.resolveLocalWorkspace(S.URI.file(F));if(te)return te.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:te.id,configPath:te.configPath},type:a.FileType.File,exists:!0,remoteAuthority:te.remoteAuthority,transient:te.transient}}return{fileUri:S.URI.file(F),type:a.FileType.File,exists:!0,options:{selection:ie?{startLineNumber:ie,startColumn:G||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,J.$Yfc)(S.URI.file(F),B),type:a.FileType.Directory,exists:!0};if(!v.$j&&F==="/dev/null")return{fileUri:S.URI.file(F),type:a.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!z)return this.nb(F,_);const te=S.URI.file(F);if(this.M.removeRecentlyOpened([te]),_.ignoreFileNotFound)return{fileUri:te,type:a.FileType.File,exists:!1}}}async nb(F,_){const z=S.URI.file(F),{response:ie,checkboxChecked:G}=await this.P.showMessageBox({type:"warning",buttons:[(0,t.localize)(10989,null),(0,t.localize)(10990,null),(0,t.localize)(10991,null)],message:(0,t.localize)(10992,null,z.authority),detail:(0,t.localize)(10993,null,(0,h.$Yw)(z,{os:v.OS,tildify:this.G})),checkboxLabel:(0,t.localize)(10994,null,z.authority),cancelId:1});if(ie===0){if((0,P.addUNCHostToAllowlist)(z.authority),G){const B={channel:"vscode:configureAllowedUNCHost",args:z.authority};this.sendToFocused(B.channel,B.args),this.sendToOpeningWindow(B.channel,B.args)}return this.mb(F,_,!0)}if(ie===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(F,_)}ob(F,_){const z=F.charCodeAt(0),ie=_.remoteAuthority;let G,B;_.gotoLineMode&&({path:F,line:G,column:B}=(0,m.$Lg)(F)),z!==p.CharCode.Slash&&((0,m.$Eg)(z)&&F.charCodeAt(F.charCodeAt(1))===p.CharCode.Colon&&(F=(0,m.$xg)(F)),F=`/${F}`);const te=S.URI.from({scheme:w.Schemas.vscodeRemote,authority:ie,path:F});if(F.charCodeAt(F.length-1)!==p.CharCode.Slash){if((0,Y.$0i)(F))return _.forceOpenWorkspaceAsFile?{fileUri:te,options:{selection:G?{startLineNumber:G,startColumn:B||1}:void 0},remoteAuthority:_.remoteAuthority}:{workspace:(0,J.$Xfc)(te),remoteAuthority:ie};if(_.gotoLineMode||f.$gc.basename(F).indexOf(".")!==-1)return{fileUri:te,options:{selection:G?{startLineNumber:G,startColumn:B||1}:void 0},remoteAuthority:ie}}return{workspace:(0,J.$Yfc)(te),remoteAuthority:ie}}pb(F){const _=this.L.getValue("window"),z=_?.openFoldersInNewWindow||"default",ie=_?.openFilesInNewWindow||"off";let G=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(z==="on"||z==="off")&&(G=z==="on");let B=!1;return F.forceNewWindow||F.forceReuseWindow?B=!!F.forceNewWindow&&!F.forceReuseWindow:(v.$k?F.context===q.OpenContext.DOCK&&(B=!0):F.context!==q.OpenContext.DIALOG&&F.context!==q.OpenContext.MENU&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!F.cli.extensionDevelopmentPath&&(ie==="on"||ie==="off")&&(B=ie==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(F,_){const z=(0,K.$Vfc)(this.getWindows(),F);if(z)return this.I.reload(z,_.cli),z.focus(),[z];let ie=_.cli["folder-uri"]||[],G=_.cli["file-uri"]||[],B=_.cli._;if(!B.length&&!ie.length&&!G.length&&!_.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(S.URI.isUri(we)?we.scheme===w.Schemas.file?B=[we.fsPath]:ie=[we.toString()]:we.configPath.scheme===w.Schemas.file?B=[(0,$.$6g)(we.configPath)]:G=[we.configPath.toString()])}let te=_.remoteAuthority;for(const me of F)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=S.URI.parse(me),Ie=(0,A.$gn)(we);Ie&&(te?(0,$.$kh)(Ie,te)||this.z.error("more than one extension development path authority"):te=Ie)}B=B.filter(me=>{const we=S.URI.file(me);return(0,K.$Ufc)(this.getWindows(),we)?!1:(0,$.$kh)((0,A.$gn)(we),te)}),ie=ie.filter(me=>{const we=this.gb(me);return we&&(0,K.$Ufc)(this.getWindows(),we)?!1:we?(0,$.$kh)((0,A.$gn)(we),te):!1}),G=G.filter(me=>{const we=this.gb(me);return we&&(0,K.$Ufc)(this.getWindows(),we)?!1:we?(0,$.$kh)((0,A.$gn)(we),te):!1}),_.cli._=B,_.cli["folder-uri"]=ie,_.cli["file-uri"]=G;const he={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:!B.length&&!ie.length&&!G.length,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:te,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile};return this.open(he)}async qb(F){const _=this.L.getValue("window"),z=this.getLastActiveWindow(),G=(_?.newWindowProfile?this.H.profiles.find(he=>he.name===_.newWindowProfile):void 0)??z?.profile??this.H.defaultProfile;let B;!F.forceNewWindow&&!F.forceNewTabbedWindow&&(B=F.windowToUse||z,B&&B.focus());const te={...this.G.args,...F.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,f.$jc)(this.G.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:G},homeDir:this.G.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.w,...F.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:w.Schemas.file}).fsPath,product:R.default,isInitialStartup:F.initialStartup,perfMarks:(0,g.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)(),arch:(0,D.arch)()},autoDetectHighContrast:_?.autoDetectHighContrast??!0,autoDetectColorScheme:_?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(B){const he=B.config;!te.extensionDevelopmentPath&&he?.extensionDevelopmentPath&&(te.extensionDevelopmentPath=he.extensionDevelopmentPath,te.extensionDevelopmentKind=he.extensionDevelopmentKind,te["enable-proposed-api"]=he["enable-proposed-api"],te.verbose=he.verbose,te["inspect-extensions"]=he["inspect-extensions"],te["inspect-brk-extensions"]=he["inspect-brk-extensions"],te.debugId=he.debugId,te.extensionEnvironment=he.extensionEnvironment,te["extensions-dir"]=he["extensions-dir"],te["disable-extensions"]=he["disable-extensions"]),te.loggers={global:te.loggers.global,window:he?.loggers.window??te.loggers.window}}else{const he=this.r.getNewWindowState(te);(0,g.mark)("code/willCreateCodeWindow");const me=B=this.O.createInstance(H.$6fc,{state:he,extensionDevelopmentPath:te.extensionDevelopmentPath,isExtensionTestHost:!!te.extensionTestsPath});(0,g.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new d.$Tc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(c.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(c.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:Ce,y:Re})=>this.m.fire({window:me,x:Ce,y:Re})));const Ie=(0,k.$pg)(me.win?.webContents);Ie.removeAllListeners("devtools-reload-page"),we.add(c.Event.fromNodeEventEmitter(Ie,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return te.windowId=B.id,B.isReady?this.I.unload(B,W.UnloadReason.LOAD).then(async he=>{he||await this.rb(B,te,F,G)}):await this.rb(B,te,F,G),B}async rb(F,_,z,ie){if(_.extensionDevelopmentPath||((0,Y.$Ti)(_.workspace)?_.backupPath=this.J.registerWorkspaceBackup({workspace:_.workspace,remoteAuthority:_.remoteAuthority}):(0,Y.$Oi)(_.workspace)?_.backupPath=this.J.registerFolderBackup({folderUri:_.workspace.uri,remoteAuthority:_.remoteAuthority}):_.backupPath=this.J.registerEmptyWindowBackup({backupFolder:z.emptyWindowBackupInfo?.backupFolder??(0,J.$Zfc)().id,remoteAuthority:_.remoteAuthority})),this.H.isEnabled()){const G=_.workspace??(0,Y.$Si)(_.backupPath,!1),B=this.sb(z,G,ie),te=B instanceof Promise?await B:B;_.profiles.profile=te,_.extensionDevelopmentPath||await this.H.setProfileForWorkspace(G,te)}F.load(_)}sb(F,_,z){return F.forceProfile?this.H.profiles.find(ie=>ie.name===F.forceProfile)??this.H.createNamedProfile(F.forceProfile):F.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(_)??z}tb(F,_){this.n.delete(F.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),_.dispose()}ub(F){this.n.delete(F.id),this.c.fire(F)}getFocusedWindow(){const F=r.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(F){return this.wb(this.getWindows().filter(_=>(0,$.$kh)(_.remoteAuthority,F)))}wb(F){return(0,q.$Qfc)(F)}sendToFocused(F,..._){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,I.CancellationToken.None,..._)}sendToOpeningWindow(F,..._){this.B(c.Event.once(this.onDidSignalReadyWindow)(z=>{z.sendWhenReady(F,I.CancellationToken.None,..._)}))}sendToAll(F,_,z){for(const ie of this.getWindows())z&&z.indexOf(ie.id)>=0||ie.sendWhenReady(F,I.CancellationToken.None,_)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(F){return this.n.get(F)}getWindowByWebContents(F){const _=r.BrowserWindow.fromWebContents(F);if(!_)return;const z=this.getWindowById(_.id);return z?.matches(F)?z:void 0}};e.$ghc=Q,e.$ghc=Q=Se([se(4,y.$_j),se(5,oe.$3fc),se(6,O.$zR),se(7,C.$so),se(8,s.$Bfc),se(9,X.$Rfc),se(10,E.$8fc),se(11,u.$Ifc),se(12,i.$$i),se(13,U.$Ogc),se(14,Z.$1fc),se(15,l.$Di),se(16,o.$Jfc),se(17,a.$_k),se(18,L.$Lfc),se(19,j.$Mfc),se(20,V.$Agc)],Q)}),define(ce[278],le([0,1,69,29,88,59]),function(x,e,n,r,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;let T=class{constructor(p,c,m,h){this.a=p,this.b=c,this.c=m,this.d=h,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(p,c){const m=this.b.getWindowById(p);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),c)}createUntitledWorkspace(p,c,m){return this.a.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(p,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(p,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(p){return this.c.getRecentlyOpened()}addRecentlyOpened(p,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(p,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(p){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$ihc=T,e.$ihc=T=Se([se(0,D.$1fc),se(1,r.$Ofc),se(2,P.$Ogc),se(3,n.$Ifc)],T)}),define(ce[279],le([0,1,13,106,35,27,17,55,15,4,283,47,2,11,9,3,12,7,33,158,44,159,118,135,10,69,253,16,260,96,136,53,97,187,20,68,100,175,263,177,178,179,14,191,99,83,6,98,186,269,270,254,261,19,5,276,64,28,74,264,101,34,243,87,128,24,220,221,57,50,233,258,271,259,272,132,235,236,237,240,267,51,29,277,242,30,102,88,278,59,40,200,58,213,49,86,133,245,262,250,8,223,244,195,71,266,239,21,75,265,231,206,65,84,274,78]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t,u,i,o,s,a,l,E,y,R,L,A,O,M,H,q,K,de,Y,J,U,Z,W,j,C,X,oe,V,ue,re,Q,N,F,_,z,ie,G,B,te,he,me,we,Ie,Ce,Re,ve,$e,ee,ae,fe,be,De,Ne,Me,Ae,Be,Ge,Ze,qe,Xe,Qe,Je,We,ne,ge,pe,ye,je,Ue,_e,lt,rt,at,tt,ut,ct,ft,gt,Ot,mt,$t,Tt,Lt,jt,pt,Mt,Et,dt,Nt,Ft,wt,Ct,St,Wt,kt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;let yt=class extends d.$Uc{static{bt=this}static{this.a={[w.Schemas.file]:"security.promptForLocalFileProtocolHandling",[w.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Oe,Te,Le,Ee,ke,Ye,xe,Ke,Fe,He,ze,et){super(),this.g=Oe,this.h=Te,this.j=Le,this.m=Ee,this.n=ke,this.s=Ye,this.t=xe,this.u=Ke,this.w=Fe,this.y=He,this.z=ze,this.C=et,this.D(),this.F()}D(){const Oe=Fe=>Fe?.startsWith(`${w.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Fe,He,ze,et)=>Oe(et.requestingUrl)?ze(Te.has(He)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Fe,He,ze,et)=>Oe(et.requestingUrl)?Te.has(He):!1);const Le=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,w.Schemas.vscodeManagedRemoteResource,"devtools"]),Ee=Fe=>{for(let He=Fe;He;He=He.parent)if(He.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},ke=Fe=>Fe.resourceType==="xhr"||Ee(Fe.frame),Ye=Fe=>{const He=Fe.frame;if(!He||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const et of ze)if(He.processId===et.webContents.mainFrame.processId)return!0;return!1},xe=(Fe,He)=>{if(Fe.path!=="/index.html")return!0;const ze=He.frame;if(!ze||!this.b)return!1;for(const et of this.b.getWindows())if(et.win&&ze.processId===et.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Fe,He)=>{const ze=b.URI.parse(Fe.url);return ze.scheme===w.Schemas.vscodeWebview&&!xe(ze,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),He({cancel:!0})):ze.scheme===w.Schemas.vscodeFileResource&&!Ye(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),He({cancel:!0})):ze.path.endsWith(".svg")&&!Le.has(ze.scheme)?He({cancel:!ke(Fe)}):He({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,He)=>{const ze=Fe.responseHeaders,et=ze["content-type"]||ze["Content-Type"];if(et&&Array.isArray(et)){const it=b.URI.parse(Fe.url);if(it.path.endsWith(".svg")&&Le.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],He({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(w.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return He({cancel:!ke(Fe)})}return He({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,He)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Fe.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],He({cancel:!1,responseHeaders:ze})}return He({cancel:!1})});const Ke=n.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,f.$jc)(this.s.codeCachePath,"chrome")),g.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,p.setUnexpectedErrorHandler)(Le=>this.G(Le)),process.on("uncaughtException",Le=>{(0,p.$X)(Le)||(0,p.$Y)(Le)}),process.on("unhandledRejection",Le=>(0,p.$Y)(Le)),c.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,k.$UX)(),n.app.on("accessibility-support-changed",(Le,Ee)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),n.app.on("activate",async(Le,Ee)=>{this.m.trace("app#activate"),Ee||await this.b?.openEmptyWindow({context:Je.OpenContext.DOCK})}),n.app.on("web-contents-created",(Le,Ee)=>{Ee?.opener?.url.startsWith(`${w.Schemas.vscodeFileResource}://${w.$Xg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(Ee)),Ee.on("will-navigate",ke=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Ee.setWindowOpenHandler(ke=>ke.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(ke)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${ke.url}}`),this.f?.openExternal(void 0,ke.url),{action:"deny"}))});let Oe=[],Te;n.app.on("open-file",(Le,Ee)=>{Ee=(0,kt.$mm)(Ee),this.m.trace("app#open-file: ",Ee),Le.preventDefault(),Oe.push((0,ge.$0i)(Ee)?{workspaceUri:b.URI.file(Ee)}:{fileUri:b.URI.file(Ee)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.b?.open({context:Je.OpenContext.DOCK,cli:this.s.args,urisToOpen:Oe,gotoLineMode:!1,preferNewWindow:!0}),Oe=[],Te=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Je.OpenContext.DESKTOP})}),P.$TX.handle("vscode:fetchShellEnv",Le=>{const Ee=this.b?.getWindowByWebContents(Le.sender);let ke,Ye;return Ee?.config?(ke=Ee.config,Ye={...process.env,...Ee.config.userEnv}):(ke=this.s.args,Ye=process.env),this.W(ke,Ye,!1)}),P.$TX.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),P.$TX.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),P.$TX.on("vscode:reloadWindow",Le=>Le.sender.reload()),P.$TX.handle("vscode:notifyZoomLevel",async(Le,Ee)=>{const ke=this.b?.getWindowByWebContents(Le.sender);ke&&ke.notifyZoomLevel(Ee)})}G(Oe){if(Oe){const Te={message:`[uncaught exception in main]: ${Oe.message}`,stack:Oe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.m.error(`[uncaught exception in main]: ${Oe}`),Oe.stack&&this.m.error(Oe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Oe=this.z.win32AppUserModelId;g.$j&&Oe&&n.app.setAppUserModelId(Oe);try{g.$k&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Te=new t.$1X;c.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===F.ShutdownReason.KILL&&Te.dispose()}),this.m.trace("Resolving machine identifier...");const[Le,Ee,ke]=await Promise.all([(0,$t.$rhc)(this.w,this.m),(0,$t.$shc)(this.w,this.m),(0,$t.$thc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:Ye,sharedProcessClient:xe}=this.O(Le,Ee,ke),Ke=await this.P(Le,Ee,ke,Ye);Ke.invokeFunction(ze=>ze.get(i.$fgc)),this.B(Ke.createInstance(gt.$mhc)),Ke.invokeFunction(ze=>this.Q(ze,Te,xe));const Fe=await Ke.invokeFunction(ze=>this.H(ze,Te));this.I(Te),this.t.phase=F.LifecycleMainPhase.Ready,await Ke.invokeFunction(ze=>this.R(ze,Fe)),this.t.phase=F.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Qh(()=>{this.B((0,mt.$Uh)(()=>this.t.phase=F.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(Oe,Te){const Le=this.b=Oe.get(Je.$Ofc),Ee=Oe.get(Ae.$IY),ke=this.f=Oe.get(ie.$Bgc),Ye=Oe.get(L.$Jfc),xe=this;Ee.registerHandler({async handleURL(it,ot){return xe.N(Le,Ye,Ee,it,ot)}});const Ke=this.B(new ne.$hhc({onDidOpenMainWindow:ke.onDidOpenMainWindow,onDidFocusMainWindow:ke.onDidFocusMainWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Fe=new S.$mi(it=>Ke.getActiveClientId().then(ot=>it===ot)),He=new Be.$$gc(Fe,this.m),ze=Te.getChannel("urlHandler",He);Ee.registerHandler(new Be.$0gc(ze));const et=await this.J(Le,Ye);return this.B(new Ze.$_gc(et?.urls,Ee,Le,this.s,this.z,this.m)),et}I(Oe){const Te=()=>({statusCode:404,data:"Not found"}),Le=new Ct.$T(()=>Oe.getChannel(wt.$Ahc,new wt.$Bhc));n.protocol.registerBufferProtocol(w.Schemas.vscodeManagedRemoteResource,(Ee,ke)=>{const Ye=b.URI.parse(Ee.url);if(!Ye.authority.startsWith("window:"))return ke(Te());Le.value.call(wt.$zhc,[Ye]).then(xe=>ke({...xe,data:Buffer.from(xe.body,"base64")}),xe=>{this.m.warn("error dispatching remote resource call",xe),ke({statusCode:500,data:String(xe)})})})}async J(Oe,Te){const Le=this.s.args["open-url"]?this.s.args._urls||[]:[];Le.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Le.length+Ee.length===0)return;const ke=[...Le,...Ee].map(Ke=>{try{return{uri:b.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Ye=[],xe=[];for(const Ke of ke){if(!Ke)continue;const Fe=this.M(Ke.uri);if(Fe)if(await this.L(Fe,Oe,Te)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Fe),Ye.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),xe.push(Ke)}return{urls:xe,openables:Ye}}async L(Oe,Te,Le){let Ee,ke;if((0,Qe.$9D)(Oe)?(Ee=Oe.workspaceUri,ke=(0,o.localize)(12894,null,Ee.scheme===w.Schemas.file?(0,h.$Yw)(Ee,{os:g.OS,tildify:this.s}):Ee.toString(!0),this.z.nameShort)):(0,Qe.$0D)(Oe)?(Ee=Oe.folderUri,ke=(0,o.localize)(12895,null,Ee.scheme===w.Schemas.file?(0,h.$Yw)(Ee,{os:g.OS,tildify:this.s}):Ee.toString(!0),this.z.nameShort)):(Ee=Oe.fileUri,ke=(0,o.localize)(12896,null,Ee.scheme===w.Schemas.file?(0,h.$Yw)(Ee,{os:g.OS,tildify:this.s}):Ee.toString(!0),this.z.nameShort)),Ee.scheme!==w.Schemas.file&&Ee.scheme!==w.Schemas.vscodeRemote||this.u.getValue(bt.a[Ee.scheme])===!1)return!1;const{response:xe,checkboxChecked:Ke}=await Le.showMessageBox({type:"warning",buttons:[(0,o.localize)(12897,null),(0,o.localize)(12898,null)],message:ke,detail:(0,o.localize)(12899,null),checkboxLabel:Ee.scheme===w.Schemas.file?(0,o.localize)(12900,null):(0,o.localize)(12901,null),cancelId:1});if(xe!==0)return!0;if(Ke){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:Ee.scheme===w.Schemas.file?"local":"remote"};Te.sendToFocused(Fe.channel,Fe.args),Te.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}M(Oe){if(Oe.path){if(Oe.authority===w.Schemas.file){const Te=b.URI.file(Oe.fsPath);return(0,ge.$0i)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(Oe.authority===w.Schemas.vscodeRemote){const Te=Oe.path.indexOf(f.$gc.sep,1);if(Te!==-1){const Le=Oe.path.substring(1,Te),Ee=Oe.path.substring(Te);let ke=Oe.query;const Ye=new URLSearchParams(Oe.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),ke=Ye.toString());const xe=b.URI.from({scheme:w.Schemas.vscodeRemote,authority:Le,path:Ee,query:ke,fragment:Oe.fragment});return(0,ge.$0i)(Ee)?{workspaceUri:xe}:/:[\d]+$/.test(Ee)?{fileUri:xe}:{folderUri:xe}}}}}async N(Oe,Te,Le,Ee,ke){this.m.trace("app#handleProtocolUrl():",Ee.toString(!0),ke),Ee.scheme===this.z.urlProtocol&&Ee.path==="workspace"&&(Ee=Ee.with({authority:"file",path:b.URI.parse(Ee.query).path,query:""}));let Ye=!1;const xe=new URLSearchParams(Ee.query);xe.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),xe.delete("windowId"),Ee=Ee.with({query:xe.toString()}),Ye=!0):g.$k&&Oe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),Ye=!0);const Ke=xe.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Ee.toString(!0)),xe.delete("continueOn"),Ee=Ee.with({query:xe.toString()}),this.s.continueOn=Ke??void 0);const Fe=this.M(Ee);return Fe?await this.L(Fe,Oe,Te)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",Ee.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,Ee.toString(!0)),(0,Et.$Nb)(await Oe.open({context:Je.OpenContext.API,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:Ye,gotoLineMode:!0}))?.focus(),!0):Ye?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Ee.toString(!0)),await(0,Et.$Nb)(await Oe.open({context:Je.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,B.$gn)(Ee)}))?.ready(),Le.open(Ee,ke)):(this.m.trace("app#handleProtocolUrl(): not handled",Ee.toString(!0),ke),!1)}O(Oe,Te,Le){const Ee=this.B(this.j.createInstance(te.$Wgc,Oe,Te,Le));this.B(Ee.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const ke=(async()=>{this.m.trace("Main->SharedProcess#connect");const xe=await Ee.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new u.$2X(xe,"main")})();return{sharedProcessReady:(async()=>(await Ee.whenReady(),ke))(),sharedProcessClient:ke}}async P(Oe,Te,Le,Ee){const ke=new oe.$Ci;switch(process.platform){case"win32":ke.set(ae.$SY,new C.$Bi(Me.$8gc));break;case"linux":g.$m?ke.set(ae.$SY,new C.$Bi(Ne.$7gc,[process.env.SNAP,process.env.SNAP_REVISION])):ke.set(ae.$SY,new C.$Bi(De.$6gc));break;case"darwin":ke.set(ae.$SY,new C.$Bi(be.$5gc));break}ke.set(Je.$Ofc,new C.$Bi(We.$ghc,[Oe,Te,Le,this.h],!1)),ke.set(St.$Agc,new C.$Bi(Wt.$Chc,void 0,!1));const Ye=new L.$Kfc(this.m,this.z);ke.set(L.$Jfc,Ye),ke.set(N.$Igc,new C.$Bi(N.$Jgc,void 0,!1)),ke.set(R.$mgc,new C.$Bi(R.$ngc,void 0,!1)),ke.set(y.$Sm,S.ProxyChannel.toService((0,S.$ki)(Ee.then(ze=>ze.getChannel("diagnostics"))))),ke.set(V.$$_b,new C.$Bi(ue.$Dgc,[this.h])),ke.set(V.$__b,new C.$Bi(re.$Egc,[this.h])),ke.set(A.$CY,new C.$Bi(O.$ogc)),ke.set(Q.$Fgc,new C.$Bi(Q.$Ggc)),ke.set(ie.$Bgc,new C.$Bi(ie.$Cgc,void 0,!1)),ke.set(qe.$ahc,new C.$Bi(Xe.$chc)),ke.set(z.$Rgc,new C.$Bi(z.$Sgc)),ke.set(K.$pgc,new C.$Bi(de.$rgc)),ke.set(Ie.$bgc,new C.$Bi(Ie.$cgc)),ke.set(Ie.$dgc,new C.$Bi(Ie.$egc));const xe=new Nt.$yhc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ke=new Ft.$Ps(xe,this.u,this.m,this.n);ke.set(dt.$qs,Ke),g.$j?ke.set(Y.$sgc,new C.$Bi(J.$tgc)):g.$k?ke.set(Y.$sgc,new C.$Bi(J.$ugc)):g.$l&&ke.set(Y.$sgc,new C.$Bi(J.$vgc));const Fe=new a.$hgc(this.s,this.u,this.m,this.w);ke.set(s.$Ifc,Fe);const He=new Ue.$2fc(this.s,this.m,this.C,Fe,Ye);if(ke.set(Ue.$1fc,He),ke.set(pe.$bib,new C.$Bi(je.$ihc,void 0,!1)),ke.set(ye.$Ogc,new C.$Bi(ye.$Pgc,void 0,!1)),ke.set(Ae.$IY,new C.$Bi(Ge.$KY,void 0,!1)),(0,ee.$Dp)(this.z,this.s)){const ze=(0,ee.$Ip)(this.z,this.u),et=(0,S.$ki)(Ee.then(vt=>vt.getChannel("telemetryAppender"))),it=new ve.$Zgc(et),ot=(0,Ce.$up)((0,D.release)(),(0,D.hostname)(),process.arch,this.z.commit,this.z.version,Oe,Te,Le,ze),nt=(0,ee.$Jp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};ke.set(Re.$$l,new C.$Bi($e.$gs,[ht],!1))}else ke.set(Re.$$l,ee.$yp);return ke.set(ut.$Iq,new C.$Bi(Tt.$GR,void 0,!0)),ke.set(ct.$Mq,new C.$Bi(ft.$lhc,void 0,!0)),ke.set(pt.$whc,new C.$Bi(pt.$xhc,void 0,!0)),ke.set(i.$fgc,new C.$Bi(i.$ggc)),await mt.Promises.settled([Fe.initialize(),He.initialize()]),this.j.createChild(ke)}Q(Oe,Te,Le){const Ee=this.B(new d.$Tc),ke=S.ProxyChannel.fromService(Oe.get(N.$Igc),Ee,{disableMarshalling:!0});this.g.registerChannel("launch",ke);const Ye=S.ProxyChannel.fromService(Oe.get(R.$mgc),Ee,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Ye);const xe=Ee.add(new lt.$jhc(Oe.get(_e.$so)));Te.registerChannel("policy",xe),Le.then(st=>st.registerChannel("policy",xe));const Ke=this.y.getProvider(w.Schemas.file);(0,v.$og)(Ke instanceof j.$sr);const Fe=Ee.add(new W.$wgc(Ke,this.m,this.s));Te.registerChannel(U.$pR,Fe),Le.then(st=>st.registerChannel(U.$pR,Fe));const He=S.ProxyChannel.fromService(Oe.get(rt.$Rfc),Ee);Te.registerChannel("userDataProfiles",He),Le.then(st=>st.registerChannel("userDataProfiles",He));const ze=new at.$bs(Oe.get(tt.$7p));Le.then(st=>st.registerChannel("request",ze));const et=new fe.$1gc(Oe.get(ae.$SY));Te.registerChannel("update",et);const it=S.ProxyChannel.fromService(Oe.get(V.$$_b),Ee);Te.registerChannel("issue",it);const ot=S.ProxyChannel.fromService(Oe.get(V.$__b),Ee);Te.registerChannel("process",ot);const nt=S.ProxyChannel.fromService(Oe.get(A.$CY),Ee);Te.registerChannel("encryption",nt);const ht=S.ProxyChannel.fromService(Oe.get(he.$Yl),Ee);Te.registerChannel("sign",ht);const vt=S.ProxyChannel.fromService(Oe.get(Q.$Fgc),Ee);Te.registerChannel("keyboardLayout",vt),this.f=Oe.get(ie.$Bgc);const Pt=S.ProxyChannel.fromService(this.f,Ee);Te.registerChannel("nativeHost",Pt),Le.then(st=>st.registerChannel("nativeHost",Pt));const Bt=S.ProxyChannel.fromService(Oe.get(pe.$bib),Ee);Te.registerChannel("workspaces",Bt);const Ut=S.ProxyChannel.fromService(Oe.get(z.$Rgc),Ee);Te.registerChannel("menubar",Ut);const zt=S.ProxyChannel.fromService(Oe.get(Ae.$IY),Ee);Te.registerChannel("url",zt);const qt=S.ProxyChannel.fromService(Oe.get(qe.$ahc),Ee);Te.registerChannel("webview",qt);const It=Ee.add(new we.$Xgc(this.m,Oe.get(Ie.$bgc)));Te.registerChannel("storage",It),Le.then(st=>st.registerChannel("storage",It));const Yt=Ee.add(new Ot.$nhc(Oe.get(Ie.$bgc),Oe.get(rt.$Rfc),this.m));Le.then(st=>st.registerChannel("profileStorageListener",Yt));const Ht=S.ProxyChannel.fromService(Oe.get(dt.$qs),Ee);Te.registerChannel(dt.TerminalIpcChannels.LocalPty,Ht);const xt=S.ProxyChannel.fromService(Oe.get(Y.$sgc),Ee);Te.registerChannel("externalTerminal",xt);const Rt=new Lt.$uhc(Oe.get(jt.$3fc));Te.registerChannel("logger",Rt),Le.then(st=>st.registerChannel("logger",Rt));const Vt=new E.$igc(Oe.get(Je.$Ofc));Te.registerChannel("extensionhostdebugservice",Vt);const Gt=S.ProxyChannel.fromService(Oe.get(K.$pgc),Ee);Te.registerChannel(K.$qgc,Gt);const Kt=S.ProxyChannel.fromService(Oe.get(pt.$whc),Ee);Te.registerChannel(Mt.$vhc,Kt)}async R(Oe,Te){const Le=this.b=Oe.get(Je.$Ofc);this.c=Oe.get(St.$Agc);const Ee=(0,H.$Jm)(process.env)?Je.OpenContext.CLI:Je.OpenContext.DESKTOP,ke=this.s.args;if(Te){if(Te.openables.length>0)return Le.open({context:Ee,cli:ke,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),Le.open({context:Ee,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ye=global.macOpenFiles,xe=ke._.length,Ke=!!ke["folder-uri"],Fe=!!ke["file-uri"],He=ke["skip-add-to-recently-opened"]===!0,ze=ke.wait&&ke.waitMarkerFilePath?b.URI.file(ke.waitMarkerFilePath):void 0,et=ke.remote||void 0,it=ke.profile,ot=ke["profile-temp"];if(!xe&&!Ke&&!Fe){if(ke["new-window"]||it||ot)return Le.open({context:Ee,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if(Ye.length)return Le.open({context:Je.OpenContext.DOCK,cli:ke,urisToOpen:Ye.map(nt=>(nt=(0,kt.$mm)(nt),(0,ge.$0i)(nt)?{workspaceUri:b.URI.file(nt)}:{fileUri:b.URI.file(nt)})),noRecentEntry:He,waitMarkerFileURI:ze,initialStartup:!0})}return Le.open({context:Ee,cli:ke,forceNewWindow:ke["new-window"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:He,waitMarkerFileURI:ze,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}S(){this.U(),n.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Oe,Te)=>{Te({url:Oe.url.replace(/^vscode-remote-resource:/,"http:"),method:Oe.method})}),this.W(this.s.args,process.env,!0),this.X(),g.$k&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Oe=this.z.win32MutexName;if(g.$j&&Oe)try{const Te=await new Promise((Ee,ke)=>{x(["@vscode/windows-mutex"],Ee,ke)}).then(Pe),Le=new Te.Mutex(Oe);c.Event.once(this.t.onWillShutdown)(()=>Le.release())}catch(Te){this.m.error(Te)}}async W(Oe,Te,Le){try{return await(0,q.$Qm)(this.u,this.m,Oe,Te)}catch(Ee){const ke=(0,I.$pj)(Ee);Le?this.b?.sendToFocused("vscode:showResolveShellEnvError",ke):this.m.error(ke)}return{}}async X(){try{const Te=(await this.y.readFile(this.s.argvResource)).value.toString(),Le=(0,m.parse)(Te),ke=(0,ee.$Fp)(this.u)>=Re.TelemetryLevel.CRASH;if(Le["enable-crash-reporter"]===void 0){const Ye=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$1g)()}"`,"}"],xe=Te.substring(0,Te.length-2).concat(`,
`,Ye.join(`
`));await this.y.writeFile(this.s.argvResource,T.$Ne.fromString(xe))}else{const Ye=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);Ye!==Te&&await this.y.writeFile(this.s.argvResource,T.$Ne.fromString(Ye))}}catch(Oe){this.m.error(Oe),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$Dhc=yt,e.$Dhc=yt=bt=Se([se(2,X.$Di),se(3,_.$_j),se(4,_.$ak),se(5,M.$Bfc),se(6,F.$8fc),se(7,l.$$i),se(8,me.$zR),se(9,Z.$_k),se(10,G.$sk),se(11,rt.$Rfc)],yt)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[284],le([0,1,13,26,7,21,8,55,15,32,4,47,11,9,70,3,36,25,23,44,104,279,10,16,205,219,20,68,170,14,189,99,83,185,98,19,192,5,72,28,73,246,131,257,49,256,101,218,34,57,76,58,40,201,199,2,41,234,71,194,123,127,238,106,232]),function(x,e,n,r,P,D,T,I,p,c,m,h,d,w,f,g,v,b,$,k,S,t,u,i,o,s,a,l,E,y,R,L,A,O,M,H,q,K,de,Y,J,U,Z,W,j,C,X,oe,V,ue,re,Q,N,F,_,z,ie,G,B,te,he,me,we,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),de=Ve(de);class Ce{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,p.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[$e,ee,ae,fe,be,De,Ne,Me]=this.b();try{try{await this.d(ae,Me,fe,be,Ne)}catch(Ae){throw this.g(ae,Ne,Ae),Ae}await $e.invokeFunction(async Ae=>{const Be=Ae.get(K.$_j),Ge=Ae.get(H.$8fc),Ze=Ae.get(y.$_k),qe=Ae.get(K.$ak),Xe=await this.f(Be,ae,Ge,$e,Ne,!0);return $.Promises.writeFile(ae.mainLockfile,String(process.pid)).catch(Qe=>{Be.warn(`app#startup(): Error writing main lockfile: ${Qe.stack}`)}),De.logger=qe.createLogger("main",{name:(0,u.localize)(12885,null)}),m.Event.once(Ge.onWillShutdown)(Qe=>{Ze.dispose(),fe.dispose(),Qe.join("instanceLockfile",r.promises.unlink(ae.mainLockfile).catch(()=>{}))}),$e.createInstance(t.$Dhc,Xe,ee).startup()})}catch(Ae){$e.invokeFunction(this.j,Ae)}}b(){const $e=new M.$Ci,ee=new z.$Tc;process.once("exit",()=>ee.dispose());const ae={_serviceBrand:void 0,...de.default};$e.set(Y.$sk,ae);const fe=new a.$Cfc(this.k(),ae),be=this.c(fe);$e.set(a.$Bfc,fe);const De=new B.$4fc((0,K.$nk)(fe),fe.logsHome);$e.set(B.$3fc,De);const Ne=new q.$cdc(De.getLogLevel()),Me=ee.add(new te.$HR(Ne,[new K.$gk(De.getLogLevel())]));$e.set(K.$_j,Me);const Ae=new R.$2q(Me);$e.set(y.$_k,Ae);const Be=new L.$sr(Me);Ae.registerProvider(d.Schemas.file,Be);const Ge=new G.$Ts(Ae);$e.set(ie.$Jl,Ge);const Ze=new me.$CR(me.SaveStrategy.DELAYED,fe,Me,Ae);$e.set(V.$yR,Ze),$e.set(V.$zR,Ze);const qe=new Q.$Sfc(Ze,Ge,fe,Ae,Me);$e.set(Q.$Rfc,qe),Ae.registerProvider(d.Schemas.vscodeUserData,new we.$Ohc(d.Schemas.file,Be,d.Schemas.vscodeUserData,qe,Ge,Me));const Xe=g.$j&&ae.win32RegValueName?ee.add(new F.$Mhc(Me,ae.win32RegValueName)):fe.policyFile?ee.add(new _.$Nhc(fe.policyFile,Ae,Me)):new N.$uo;$e.set(N.$so,Xe);const Qe=new o.$Wo(qe.defaultProfile.settingsResource,Ae,Xe,Me);return $e.set(i.$$i,Qe),$e.set(H.$8fc,new A.$Bi(H.$9fc,void 0,!1)),$e.set(j.$7p,new A.$Bi(C.$Khc,void 0,!0)),$e.set(re.$Mfc,new A.$Bi(re.$Nfc)),$e.set(X.$Yl,new A.$Bi(oe.$Lhc,void 0,!1)),$e.set(Z.$Dw,new A.$Bi(W.$Ihc)),$e.set(J.$Lfc,new U.$Fhc(fe,qe,Me)),[new O.$vr($e,!0),be,fe,Qe,Ze,Ne,ae,qe]}c($e){const ee={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ae=>{const fe=process.env[ae];typeof fe=="string"&&(ee[ae]=fe)}),Object.assign(process.env,ee),ee}async d($e,ee,ae,fe,be){await T.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:d.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:d.Schemas.file}).fsPath,$e.backupHome].map(De=>De?r.promises.mkdir(De,{recursive:!0}):void 0)),fe.init(),ae.initialize()]),ee.init()}e($e){if(g.$j){const ee=(0,Ie.getUNCHost)($e);ee&&(0,Ie.addUNCHostToAllowlist)(ee)}return $e}async f($e,ee,ae,fe,be,De){let Ne;try{(0,f.mark)("code/willStartMainServer"),Ne=await(0,S.$zi)(ee.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),m.Event.once(ae.onWillShutdown)(()=>Ne.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(ee,be,Me),Me;let Ae;try{Ae=await(0,S.$Ai)(ee.mainIPCHandle,"main")}catch(qe){if(!De||g.$j||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,u.localize)(12886,null,be.nameShort),(0,u.localize)(12887,null),be),qe;try{(0,r.unlinkSync)(ee.mainIPCHandle)}catch(Xe){throw $e.warn("Could not delete obsolete instance handle",Xe),Xe}return this.f($e,ee,ae,fe,be,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),Ae.dispose(),new Error(qe)}let Be;!ee.args.wait&&!ee.args.status&&(Be=setTimeout(()=>{this.h((0,u.localize)(12888,null,be.nameShort),(0,u.localize)(12889,null),be)},1e4));const Ge=k.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Ze=k.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return fe.invokeFunction(async()=>{const qe=new s.$1s(ue.$yp,be),Xe=await Ze.getMainDiagnostics(),Qe=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Je=await qe.getDiagnostics(Xe,Qe);throw console.log(Je),new p.$_});throw g.$j&&await this.i(Ge,$e),$e.trace("Sending env to running instance..."),await Ge.start(ee.args,process.env),Ae.dispose(),Be&&clearTimeout(Be),new p.$_("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,u.localize)(12890,null,be.nameShort)),new p.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ne}g($e,ee,ae){if(ae.code==="EACCES"||ae.code==="EPERM"){const fe=(0,D.$Gb)([$e.userDataPath,$e.extensionsPath,S.$vi]).map(be=>(0,h.$Yw)(P.URI.file(be),{os:g.OS,tildify:$e}));this.h((0,u.localize)(12891,null),(0,u.localize)(12892,null,(0,I.$pj)(ae),fe.join(`
`)),ee)}}h($e,ee,ae){n.dialog.showMessageBoxSync((0,he.$ax)({type:"warning",buttons:[(0,u.localize)(12893,null)],message:$e,detail:ee},ae).options)}async i($e,ee){if(g.$j){const ae=await $e.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",ae);try{(await new Promise((fe,be)=>{x(["windows-foreground-love"],fe,be)}).then(Pe)).allowSetForegroundWindow(ae)}catch(fe){ee.error(fe)}}}j($e,ee){const ae=$e.get(K.$_j),fe=$e.get(H.$8fc);let be=0;ee&&(ee.isExpected?ee.message&&ae.trace(ee.message):(be=1,ee.stack?ae.error(ee.stack):ae.error(`Startup error: ${ee.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,l.$Gm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const ee=(0,E.$Ehc)($e.verbose);ee&&((0,l.$Im)(process.argv,"--waitMarkerFilePath",ee),$e.waitMarkerFilePath=ee)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const ee=this.m($e._,$e.goto);$e._=ee}return $e}m($e,ee){const ae=(0,v.cwd)(),fe=$e.map(Ne=>{let Me=String(Ne),Ae;ee&&(Ae=(0,c.$Lg)(Me),Me=Ae.path),Me&&(Me=this.n(ae,Me));const Be=(0,c.$Fg)(Me,ae),Ge=(0,w.$nc)(Be);return Ge&&!(0,c.$Bg)(Ge)?null:ee&&Ae?(Ae.path=Be,this.o(Ae)):Be}),be=g.$j||g.$k,De=(0,D.$Lb)(fe,Ne=>Ne&&be?Ne.toLowerCase():Ne||"");return(0,D.$Gb)(De)}n($e,ee){return g.$j&&(ee=(0,b.$nf)(ee,'"')),ee=(0,b.$lf)((0,b.$lf)(ee," "),"	"),g.$j&&(ee=(0,w.$kc)($e,ee),ee=(0,b.$nf)(ee,".")),ee}o($e){const ee=[$e.path];return typeof $e.line=="number"&&ee.push(String($e.line)),typeof $e.column=="number"&&ee.push(String($e.column)),ee.join(":")}}new Ce().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/97d1b933ada0ca69bea107f7a89e029991277ccc/core/vs/code/electron-main/main.js.map
