/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/nls","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function($e){for(var e=[],r=0,h=$e.length;r<h;r++)e[r]=ke[$e[r]];return e};define(ke[174],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var r;(function(C){C[C.LoaderAvailable=1]="LoaderAvailable",C[C.BeginLoadingScript=10]="BeginLoadingScript",C[C.EndLoadingScriptOK=11]="EndLoadingScriptOK",C[C.EndLoadingScriptError=12]="EndLoadingScriptError",C[C.BeginInvokeFactory=21]="BeginInvokeFactory",C[C.EndInvokeFactory=22]="EndInvokeFactory",C[C.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",C[C.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",C[C.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",C[C.NodeEndNativeRequire=34]="NodeEndNativeRequire",C[C.CachedDataFound=60]="CachedDataFound",C[C.CachedDataMissed=61]="CachedDataMissed",C[C.CachedDataRejected=62]="CachedDataRejected",C[C.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,L=new Map,T=new Map,b=new Map;function c(w,a){w.has(a.detail)||w.set(a.detail,-a.timestamp)}function I(w,a){const m=w.get(a.detail);m&&(m>=0||w.set(a.detail,m+a.timestamp))}let S=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(S=$e.getStats().slice(0).sort((w,a)=>w.timestamp-a.timestamp));for(const w of S)switch(w.type){case r.BeginLoadingScript:c(R,w);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(R,w);break;case r.BeginInvokeFactory:c(L,w);break;case r.EndInvokeFactory:I(L,w);break;case r.NodeBeginNativeRequire:c(T,w);break;case r.NodeEndNativeRequire:I(T,w);break;case r.NodeBeginEvaluatingScript:c(b,w);break;case r.NodeEndEvaluatingScript:I(b,w);break}let u=0;T.forEach(w=>u+=w);function P(w){const a=[];return w.forEach((m,$)=>a.push([$,m])),a}return{amdLoad:P(R),amdInvoke:P(L),nodeRequire:P(T),nodeEval:P(b),nodeRequireTotal:u}}static toMarkdownTable(R,L){let T="";const b=[];return R.forEach((c,I)=>{b[I]=c.length}),L.forEach(c=>{c.forEach((I,S)=>{typeof I>"u"&&(I=c[S]="-");const u=I.toString().length;b[S]=Math.max(u,b[S])})}),R.forEach((c,I)=>{T+=`| ${c+" ".repeat(b[I]-c.toString().length)} `}),T+=`|
`,R.forEach((c,I)=>{T+=`| ${"-".repeat(b[I])} `}),T+=`|
`,L.forEach(c=>{c.forEach((I,S)=>{typeof I<"u"&&(T+=`| ${I+" ".repeat(b[S]-I.toString().length)} `)}),T+=`|
`}),T}}e.$S=h}),define(ke[131],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=r,e.$fb=h,e.$gb=C,e.$hb=R,e.$ib=L,e.$jb=T,e.$kb=b,e.$mb=I,e.$nb=S,e.$ob=u,e.$pb=P,e.$qb=w;function r(a,m){const $=h(a,m);if($!==-1)return a[$]}function h(a,m,$=a.length-1){for(let f=$;f>=0;f--){const i=a[f];if(m(i))return f}return-1}function C(a,m){const $=R(a,m);return $===-1?void 0:a[$]}function R(a,m,$=0,f=a.length){let i=$,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?i=t+1:s=t}return i-1}function L(a,m){const $=T(a,m);return $===a.length?void 0:a[$]}function T(a,m,$=0,f=a.length){let i=$,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?s=t:i=t+1}return i}function b(a,m,$=0,f=a.length){const i=T(a,m,$,f);return i===a.length?-1:i}class c{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!m(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const $=R(this.e,m,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$lb=c;function I(a,m){if(a.length===0)return;let $=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,$)>0&&($=i)}return $}function S(a,m){if(a.length===0)return;let $=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,$)>=0&&($=i)}return $}function u(a,m){return I(a,($,f)=>-m($,f))}function P(a,m){if(a.length===0)return-1;let $=0;for(let f=1;f<a.length;f++){const i=a[f];m(i,a[$])>0&&($=f)}return $}function w(a,m){for(const $ of a){const f=m($);if(f!==void 0)return f}}}),define(ke[26],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(ke[78],Ie([1,0]),function($e,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=h,e.$d=C,e.$e=R,e.$f=L;function h(b,c){const I=Object.create(null);for(const S of b){const u=c(S);let P=I[u];P||(P=I[u]=[]),P.push(S)}return I}function C(b,c){const I=[],S=[];for(const u of b)c.has(u)||I.push(u);for(const u of c)b.has(u)||S.push(u);return{removed:I,added:S}}function R(b,c){const I=[],S=[];for(const[u,P]of b)c.has(u)||I.push(P);for(const[u,P]of c)b.has(u)||S.push(P);return{removed:I,added:S}}function L(b,c){const I=new Set;for(const S of c)b.has(S)&&I.add(S);return I}class T{static{r=Symbol.toStringTag}constructor(c,I){this.b=I,this.a=new Map,this[r]="SetWithKey";for(const S of c)this.add(S)}get size(){return this.a.size}add(c){const I=this.b(c);return this.a.set(I,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,I){this.a.forEach(S=>c.call(I,S,S,this))}[Symbol.iterator](){return this.values()}}e.$g=T}),define(ke[59],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=h,e.$0h=C,e.$$h=R;function r(L){return(T,b,c)=>{let I=null,S=null;if(typeof c.value=="function"?(I="value",S=c.value):typeof c.get=="function"&&(I="get",S=c.get),!S)throw new Error("not supported");c[I]=L(S,b)}}function h(L,T,b){let c=null,I=null;if(typeof b.value=="function"?(c="value",I=b.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(c="get",I=b.get),!I)throw new Error("not supported");const S=`$memoize$${T}`;b[c]=function(...u){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[S]}}function C(L,T,b){return r((c,I)=>{const S=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...P){this[u]||(this[u]=b?b():void 0),clearTimeout(this[S]),T&&(this[u]=T(this[u],...P),P=[this[u]]),this[S]=setTimeout(()=>{c.apply(this,P),this[u]=b?b():void 0},L)}})}function R(L,T,b){return r((c,I)=>{const S=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,P=`$throttle$lastRun$${I}`,w=`$throttle$pending$${I}`;return function(...a){if(this[u]||(this[u]=b?b():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...a)),this[w])return;const m=this[P]+L;m<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0):(this[w]=!0,this[S]=setTimeout(()=>{this[w]=!1,this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0},m-Date.now()))}})}}),define(ke[13],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=h,e.$X=C,e.$Y=R,e.$Z=L,e.$1=T,e.$2=b,e.$3=I,e.$5=u,e.$6=P,e.$7=w,e.$9=m;class r{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?s.isErrorNoTelemetry(n)?new s(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(d=>{d(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$U=r,e.$V=new r;function h(o){e.$V.setUnexpectedErrorHandler(o)}function C(o){if(!o||typeof o!="object")return!1;const n=o;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function R(o){I(o)||e.$V.onUnexpectedError(o)}function L(o){I(o)||e.$V.onUnexpectedExternalError(o)}function T(o){if(o instanceof Error){const{name:n,message:d}=o,l=o.stacktrace||o.stack;return{$isError:!0,name:n,message:d,stack:l,noTelemetry:s.isErrorNoTelemetry(o)}}return o}function b(o){let n;return o.noTelemetry?n=new s:(n=new Error,n.name=o.name),n.message=o.message,n.stack=o.stack,n}const c="Canceled";function I(o){return o instanceof S?!0:o instanceof Error&&o.name===c&&o.message===c}class S extends Error{constructor(){super(c),this.name=this.message}}e.$4=S;function u(){const o=new Error(c);return o.name=o.message,o}function P(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function w(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class a extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=a;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class $ extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$0=$;class f extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$$=f;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class s extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof s)return n;const d=new s;return d.message=n.message,d.stack=n.stack,d}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$ab=s;class t extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$bb=t}),define(ke[18],Ie([1,0,13,131]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=C,e.$sb=R,e.$tb=L,e.$ub=T,e.$vb=b,e.$wb=c,e.$xb=I,e.$yb=S,e.$zb=u,e.$Ab=P,e.$Bb=w,e.$Cb=a,e.$Db=m,e.top=$,e.$Fb=f,e.$Gb=s,e.$Hb=t,e.$Ib=o,e.$Jb=n,e.$Kb=d,e.$Lb=l,e.$Mb=g,e.$Nb=E,e.$Ob=D,e.$Pb=y,e.$Qb=k,e.$Rb=A,e.$Sb=p,e.$Tb=v,e.$Ub=F,e.$Vb=N,e.$Wb=O,e.$Xb=j,e.$Yb=z,e.$Zb=M,e.$1b=U,e.$2b=V,e.$3b=ie,e.$4b=B,e.$5b=_,e.$6b=le,e.$9b=me,e.$ac=we;function C(ee,ae=0){return ee[ee.length-(1+ae)]}function R(ee){if(ee.length===0)throw new Error("Invalid tail call");return[ee.slice(0,ee.length-1),ee[ee.length-1]]}function L(ee,ae,oe=(x,ne)=>x===ne){if(ee===ae)return!0;if(!ee||!ae||ee.length!==ae.length)return!1;for(let x=0,ne=ee.length;x<ne;x++)if(!oe(ee[x],ae[x]))return!1;return!0}function T(ee,ae){const oe=ee.length-1;ae<oe&&(ee[ae]=ee[oe]),ee.pop()}function b(ee,ae,oe){return c(ee.length,x=>oe(ee[x],ae))}function c(ee,ae){let oe=0,x=ee-1;for(;oe<=x;){const ne=(oe+x)/2|0,pe=ae(ne);if(pe<0)oe=ne+1;else if(pe>0)x=ne-1;else return ne}return-(oe+1)}function I(ee,ae,oe){if(ee=ee|0,ee>=ae.length)throw new TypeError("invalid index");const x=ae[Math.floor(ae.length*Math.random())],ne=[],pe=[],be=[];for(const Fe of ae){const ze=oe(Fe,x);ze<0?ne.push(Fe):ze>0?pe.push(Fe):be.push(Fe)}return ee<ne.length?I(ee,ne,oe):ee<ne.length+be.length?be[0]:I(ee-(ne.length+be.length),pe,oe)}function S(ee,ae){const oe=[];let x;for(const ne of ee.slice(0).sort(ae))!x||ae(x[0],ne)!==0?(x=[ne],oe.push(x)):x.push(ne);return oe}function*u(ee,ae){let oe,x;for(const ne of ee)x!==void 0&&ae(x,ne)?oe.push(ne):(oe&&(yield oe),oe=[ne]),x=ne;oe&&(yield oe)}function P(ee,ae){for(let oe=0;oe<=ee.length;oe++)ae(oe===0?void 0:ee[oe-1],oe===ee.length?void 0:ee[oe])}function w(ee,ae){for(let oe=0;oe<ee.length;oe++)ae(oe===0?void 0:ee[oe-1],ee[oe],oe+1===ee.length?void 0:ee[oe+1])}function a(ee,ae,oe){const x=[];function ne(Fe,ze,Ae){if(ze===0&&Ae.length===0)return;const De=x[x.length-1];De&&De.start+De.deleteCount===Fe?(De.deleteCount+=ze,De.toInsert.push(...Ae)):x.push({start:Fe,deleteCount:ze,toInsert:Ae})}let pe=0,be=0;for(;;){if(pe===ee.length){ne(pe,0,ae.slice(be));break}if(be===ae.length){ne(pe,ee.length-pe,[]);break}const Fe=ee[pe],ze=ae[be],Ae=oe(Fe,ze);Ae===0?(pe+=1,be+=1):Ae<0?(ne(pe,1,[]),pe+=1):Ae>0&&(ne(pe,0,[ze]),be+=1)}return x}function m(ee,ae,oe){const x=a(ee,ae,oe),ne=[],pe=[];for(const be of x)ne.push(...ee.slice(be.start,be.start+be.deleteCount)),pe.push(...be.toInsert);return{removed:ne,added:pe}}function $(ee,ae,oe){if(oe===0)return[];const x=ee.slice(0,oe).sort(ae);return i(ee,ae,x,oe,ee.length),x}function f(ee,ae,oe,x,ne){return oe===0?Promise.resolve([]):new Promise((pe,be)=>{(async()=>{const Fe=ee.length,ze=ee.slice(0,oe).sort(ae);for(let Ae=oe,De=Math.min(oe+x,Fe);Ae<Fe;Ae=De,De=Math.min(De+x,Fe)){if(Ae>oe&&await new Promise(Ce=>setTimeout(Ce)),ne&&ne.isCancellationRequested)throw new r.$4;i(ee,ae,ze,Ae,De)}return ze})().then(pe,be)})}function i(ee,ae,oe,x,ne){for(const pe=oe.length;x<ne;x++){const be=ee[x];if(ae(be,oe[pe-1])<0){oe.pop();const Fe=(0,h.$jb)(oe,ze=>ae(be,ze)<0);oe.splice(Fe,0,be)}}}function s(ee){return ee.filter(ae=>!!ae)}function t(ee){let ae=0;for(let oe=0;oe<ee.length;oe++)ee[oe]&&(ee[ae]=ee[oe],ae+=1);ee.length=ae}function o(ee,ae,oe){ee.splice(oe,0,ee.splice(ae,1)[0])}function n(ee){return!Array.isArray(ee)||ee.length===0}function d(ee){return Array.isArray(ee)&&ee.length>0}function l(ee,ae=oe=>oe){const oe=new Set;return ee.filter(x=>{const ne=ae(x);return oe.has(ne)?!1:(oe.add(ne),!0)})}function g(ee){const ae=new Set;return oe=>{const x=ee(oe);return ae.has(x)?!1:(ae.add(x),!0)}}function E(ee,ae){return ee.length>0?ee[0]:ae}function D(ee,ae){return ee.length>0?ee[ee.length-1]:ae}function y(ee,ae,oe=(x,ne)=>x===ne){let x=0;for(let ne=0,pe=Math.min(ee.length,ae.length);ne<pe&&oe(ee[ne],ae[ne]);ne++)x++;return x}function k(ee,ae){let oe=typeof ae=="number"?ee:0;typeof ae=="number"?oe=ee:(oe=0,ae=ee);const x=[];if(oe<=ae)for(let ne=oe;ne<ae;ne++)x.push(ne);else for(let ne=oe;ne>ae;ne--)x.push(ne);return x}function A(ee,ae,oe){return ee.reduce((x,ne)=>(x[ae(ne)]=oe?oe(ne):ne,x),Object.create(null))}function p(ee,ae){return ee.push(ae),()=>v(ee,ae)}function v(ee,ae){const oe=ee.indexOf(ae);if(oe>-1)return ee.splice(oe,1),ae}function F(ee,ae,oe){const x=ee.slice(0,ae),ne=ee.slice(ae);return x.concat(oe,ne)}function N(ee,ae){let oe;if(typeof ae=="number"){let x=ae;oe=()=>{const ne=Math.sin(x++)*179426549;return ne-Math.floor(ne)}}else oe=Math.random;for(let x=ee.length-1;x>0;x-=1){const ne=Math.floor(oe()*(x+1)),pe=ee[x];ee[x]=ee[ne],ee[ne]=pe}}function O(ee,ae){const oe=ee.indexOf(ae);oe>-1&&(ee.splice(oe,1),ee.unshift(ae))}function j(ee,ae){const oe=ee.indexOf(ae);oe>-1&&(ee.splice(oe,1),ee.push(ae))}function z(ee,ae){for(const oe of ae)ee.push(oe)}function M(ee,ae){return Array.isArray(ee)?ee.map(ae):ae(ee)}function U(ee){return Array.isArray(ee)?ee:[ee]}function V(ee){return ee[Math.floor(Math.random()*ee.length)]}function ie(ee,ae,oe){const x=Y(ee,ae),ne=ee.length,pe=oe.length;ee.length=ne+pe;for(let be=ne-1;be>=x;be--)ee[be+pe]=ee[be];for(let be=0;be<pe;be++)ee[be+x]=oe[be]}function B(ee,ae,oe,x){const ne=Y(ee,ae);let pe=ee.splice(ne,oe);return pe===void 0&&(pe=[]),ie(ee,ne,x),pe}function Y(ee,ae){return ae<0?Math.max(ae+ee.length,0):Math.min(ae,ee.length)}var J;(function(ee){function ae(pe){return pe<0}ee.isLessThan=ae;function oe(pe){return pe<=0}ee.isLessThanOrEqual=oe;function x(pe){return pe>0}ee.isGreaterThan=x;function ne(pe){return pe===0}ee.isNeitherLessOrGreaterThan=ne,ee.greaterThan=1,ee.lessThan=-1,ee.neitherLessOrGreaterThan=0})(J||(e.CompareResult=J={}));function _(ee,ae){return(oe,x)=>ae(ee(oe),ee(x))}function le(...ee){return(ae,oe)=>{for(const x of ee){const ne=x(ae,oe);if(!J.isNeitherLessOrGreaterThan(ne))return ne}return J.neitherLessOrGreaterThan}}const re=(ee,ae)=>ee-ae;e.$7b=re;const Se=(ee,ae)=>(0,e.$7b)(ee?1:0,ae?1:0);e.$8b=Se;function me(ee){return(ae,oe)=>-ee(ae,oe)}class Q{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let oe=this.c;for(;oe<this.g.length&&ae(this.g[oe]);)oe++;const x=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,x}takeFromEndWhile(ae){let oe=this.d;for(;oe>=0&&ae(this.g[oe]);)oe--;const x=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,x}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const oe=this.g.slice(this.c,this.c+ae);return this.c+=ae,oe}}e.$0b=Q;class q{static{this.empty=new q(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(oe=>(ae(oe),!0))}toArray(){const ae=[];return this.iterate(oe=>(ae.push(oe),!0)),ae}filter(ae){return new q(oe=>this.iterate(x=>ae(x)?oe(x):!0))}map(ae){return new q(oe=>this.iterate(x=>oe(ae(x))))}some(ae){let oe=!1;return this.iterate(x=>(oe=ae(x),!oe)),oe}findFirst(ae){let oe;return this.iterate(x=>ae(x)?(oe=x,!1):!0),oe}findLast(ae){let oe;return this.iterate(x=>(ae(x)&&(oe=x),!0)),oe}findLastMaxBy(ae){let oe,x=!0;return this.iterate(ne=>((x||J.isGreaterThan(ae(ne,oe)))&&(x=!1,oe=ne),!0)),oe}}e.$$b=q;class se{constructor(ae){this.c=ae}static createSortPermutation(ae,oe){const x=Array.from(ae.keys()).sort((ne,pe)=>oe(ae[ne],ae[pe]));return new se(x)}apply(ae){return ae.map((oe,x)=>ae[this.c[x]])}inverse(){const ae=this.c.slice();for(let oe=0;oe<this.c.length;oe++)ae[this.c[oe]]=oe;return new se(ae)}}e.$_b=se;async function we(ee,ae){return(await Promise.all(ee.map(async(x,ne)=>({element:x,ok:await ae(x,ne)})))).find(x=>x.ok)?.element}}),define(ke[65],Ie([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$ed=C,e.$fd=R,e.$gd=L,e.$hd=T,e.$id=b;function h(c,I){if(!c)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function C(c,I="Unreachable"){throw new Error(I)}function R(c,I="unexpected state"){if(!c)throw new r.$bb(`Assertion Failed: ${I}`)}function L(c){c||(0,r.$Y)(new r.$bb("Soft Assertion Failed"))}function T(c){if(!c()){debugger;c(),(0,r.$Y)(new r.$bb("Assertion Failed"))}}function b(c,I){let S=0;for(;S<c.length-1;){const u=c[S],P=c[S+1];if(!I(u,P))return!1;S++}return!0}});var Gn=this&&this.__createBinding||(Object.create?function($e,e,r,h){h===void 0&&(h=r);var C=Object.getOwnPropertyDescriptor(e,r);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty($e,h,C)}:function($e,e,r,h){h===void 0&&(h=r),$e[h]=e[r]}),Yn=this&&this.__setModuleDefault||(Object.create?function($e,e){Object.defineProperty($e,"default",{enumerable:!0,value:e})}:function($e,e){$e.default=e}),qe=this&&this.__importStar||function($e){if($e&&$e.__esModule)return $e;var e={};if($e!=null)for(var r in $e)r!=="default"&&Object.prototype.hasOwnProperty.call($e,r)&&Gn(e,$e,r);return Yn(e,$e),e};define(ke[175],Ie([1,0,18]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=C,e.$8c=R,e.$9c=L,e.$0c=T,e.$$c=b,e.$_c=c,r=qe(r);const h=(P,w)=>P===w;e.$6c=h;function C(P=e.$6c){return(w,a)=>r.$tb(w,a,P)}function R(){return(P,w)=>JSON.stringify(P)===JSON.stringify(w)}function L(){return(P,w)=>P.equals(w)}function T(P,w,a){if(a!==void 0){const m=P;return m==null||w===void 0||w===null?w===m:a(m,w)}else{const m=P;return($,f)=>$==null||f===void 0||f===null?f===$:m($,f)}}function b(P,w){if(P===w)return!0;if(Array.isArray(P)&&Array.isArray(w)){if(P.length!==w.length)return!1;for(let a=0;a<P.length;a++)if(!b(P[a],w[a]))return!1;return!0}if(P&&typeof P=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const a=P,m=w,$=Object.keys(a),f=Object.keys(m),i=new Set(f);if($.length!==f.length)return!1;for(const s of $)if(!i.has(s)||!b(a[s],m[s]))return!1;return!0}return!1}function c(P){return JSON.stringify(u(P))}let I=0;const S=new WeakMap;function u(P){if(Array.isArray(P))return P.map(u);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const w=P,a=Object.create(null);for(const m of Object.keys(w).sort())a[m]=u(w[m]);return a}else{let w=S.get(P);return w===void 0&&(w=I++,S.set(P,w)),w+"----2b76a038c20c4bcc"}return P}}),define(ke[79],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=r;function r(h,C){const R=this;let L=!1,T;return function(){if(L)return T;if(L=!0,C)try{T=h.apply(R,arguments)}finally{C()}else T=h.apply(R,arguments);return T}}}),define(ke[132],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$mQ=void 0;class r{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$mQ=r,e.$nQ=new r("id#")}),define(ke[39],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function C(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}h.is=C;const R=Object.freeze([]);function L(){return R}h.empty=L;function*T(n){yield n}h.single=T;function b(n){return C(n)?n:T(n)}h.wrap=b;function c(n){return n||R}h.from=c;function*I(n){for(let d=n.length-1;d>=0;d--)yield n[d]}h.reverse=I;function S(n){return!n||n[Symbol.iterator]().next().done===!0}h.isEmpty=S;function u(n){return n[Symbol.iterator]().next().value}h.first=u;function P(n,d){let l=0;for(const g of n)if(d(g,l++))return!0;return!1}h.some=P;function w(n,d){for(const l of n)if(d(l))return l}h.find=w;function*a(n,d){for(const l of n)d(l)&&(yield l)}h.filter=a;function*m(n,d){let l=0;for(const g of n)yield d(g,l++)}h.map=m;function*$(n,d){let l=0;for(const g of n)yield*d(g,l++)}h.flatMap=$;function*f(...n){for(const d of n)yield*d}h.concat=f;function i(n,d,l){let g=l;for(const E of n)g=d(g,E);return g}h.reduce=i;function*s(n,d,l=n.length){for(d<0&&(d+=n.length),l<0?l+=n.length:l>n.length&&(l=n.length);d<l;d++)yield n[d]}h.slice=s;function t(n,d=Number.POSITIVE_INFINITY){const l=[];if(d===0)return[l,n];const g=n[Symbol.iterator]();for(let E=0;E<d;E++){const D=g.next();if(D.done)return[l,h.empty()];l.push(D.value)}return[l,{[Symbol.iterator](){return g}}]}h.consume=t;async function o(n){const d=[];for await(const l of n)d.push(l);return Promise.resolve(d)}h.asyncToArray=o})(r||(e.Iterable=r={}))}),define(ke[176],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=L,e.$Wn=S,e.$Xn=u,e.$Yn=P,e.$Zn=w,e.$1n=a,e.$2n=m,e.$3n=$,e.$4n=f,e.$5n=i,e.$6n=s;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,o=!1){let n=0;const d=t.length;let l="",g=0,E=h.Unknown,D=r.None;function y(O){let j=0,z=0;for(;j<O;){const M=t.charCodeAt(n);if(M>=I._0&&M<=I._9)z=z*16+M-I._0;else if(M>=I.A&&M<=I.F)z=z*16+M-I.A+10;else if(M>=I.a&&M<=I.f)z=z*16+M-I.a+10;else break;n++,j++}return j<O&&(z=-1),z}function k(O){n=O,l="",g=0,E=h.Unknown,D=r.None}function A(){const O=n;if(t.charCodeAt(n)===I._0)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===I.dot)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return D=r.UnexpectedEndOfNumber,t.substring(O,n);let j=n;if(n<t.length&&(t.charCodeAt(n)===I.E||t.charCodeAt(n)===I.e))if(n++,(n<t.length&&t.charCodeAt(n)===I.plus||t.charCodeAt(n)===I.minus)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;j=n}else D=r.UnexpectedEndOfNumber;return t.substring(O,j)}function p(){let O="",j=n;for(;;){if(n>=d){O+=t.substring(j,n),D=r.UnexpectedEndOfString;break}const z=t.charCodeAt(n);if(z===I.doubleQuote){O+=t.substring(j,n),n++;break}if(z===I.backslash){if(O+=t.substring(j,n),n++,n>=d){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case I.doubleQuote:O+='"';break;case I.backslash:O+="\\";break;case I.slash:O+="/";break;case I.b:O+="\b";break;case I.f:O+="\f";break;case I.n:O+=`
`;break;case I.r:O+="\r";break;case I.t:O+="	";break;case I.u:{const U=y(4);U>=0?O+=String.fromCharCode(U):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}j=n;continue}if(z>=0&&z<=31)if(b(z)){O+=t.substring(j,n),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;n++}return O}function v(){if(l="",D=r.None,g=n,n>=d)return g=d,E=h.EOF;let O=t.charCodeAt(n);if(T(O)){do n++,l+=String.fromCharCode(O),O=t.charCodeAt(n);while(T(O));return E=h.Trivia}if(b(O))return n++,l+=String.fromCharCode(O),O===I.carriageReturn&&t.charCodeAt(n)===I.lineFeed&&(n++,l+=`
`),E=h.LineBreakTrivia;switch(O){case I.openBrace:return n++,E=h.OpenBraceToken;case I.closeBrace:return n++,E=h.CloseBraceToken;case I.openBracket:return n++,E=h.OpenBracketToken;case I.closeBracket:return n++,E=h.CloseBracketToken;case I.colon:return n++,E=h.ColonToken;case I.comma:return n++,E=h.CommaToken;case I.doubleQuote:return n++,l=p(),E=h.StringLiteral;case I.slash:{const j=n-1;if(t.charCodeAt(n+1)===I.slash){for(n+=2;n<d&&!b(t.charCodeAt(n));)n++;return l=t.substring(j,n),E=h.LineCommentTrivia}if(t.charCodeAt(n+1)===I.asterisk){n+=2;const z=d-1;let M=!1;for(;n<z;){if(t.charCodeAt(n)===I.asterisk&&t.charCodeAt(n+1)===I.slash){n+=2,M=!0;break}n++}return M||(n++,D=r.UnexpectedEndOfComment),l=t.substring(j,n),E=h.BlockCommentTrivia}return l+=String.fromCharCode(O),n++,E=h.Unknown}case I.minus:if(l+=String.fromCharCode(O),n++,n===d||!c(t.charCodeAt(n)))return E=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return l+=A(),E=h.NumericLiteral;default:for(;n<d&&F(O);)n++,O=t.charCodeAt(n);if(g!==n){switch(l=t.substring(g,n),l){case"true":return E=h.TrueKeyword;case"false":return E=h.FalseKeyword;case"null":return E=h.NullKeyword}return E=h.Unknown}return l+=String.fromCharCode(O),n++,E=h.Unknown}}function F(O){if(T(O)||b(O))return!1;switch(O){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let O;do O=v();while(O>=h.LineCommentTrivia&&O<=h.Trivia);return O}return{setPosition:k,getPosition:()=>n,scan:o?N:v,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>D}}function T(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function b(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function c(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function S(t,o){const n=[],d=new Object;let l;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(y,k,A,p){g.value=y,g.offset=k,g.length=A,g.type=p,g.colonOffset=void 0,l=g}try{i(t,{onObjectBegin:(y,k)=>{if(o<=y)throw d;l=void 0,E=o>y,n.push("")},onObjectProperty:(y,k,A)=>{if(o<k||(D(y,k,A,"property"),n[n.length-1]=y,o<=k+A))throw d},onObjectEnd:(y,k)=>{if(o<=y)throw d;l=void 0,n.pop()},onArrayBegin:(y,k)=>{if(o<=y)throw d;l=void 0,n.push(0)},onArrayEnd:(y,k)=>{if(o<=y)throw d;l=void 0,n.pop()},onLiteralValue:(y,k,A)=>{if(o<k||(D(y,k,A,s(y)),o<=k+A))throw d},onSeparator:(y,k,A)=>{if(o<=k)throw d;if(y===":"&&l&&l.type==="property")l.colonOffset=k,E=!1,l=void 0;else if(y===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(E=!0,n[n.length-1]=""),l=void 0}}})}catch(y){if(y!==d)throw y}return{path:n,previousNode:l,isAtPropertyKey:E,matches:y=>{let k=0;for(let A=0;k<y.length&&A<n.length;A++)if(y[k]===n[A]||y[k]==="*")k++;else if(y[k]!=="**")return!1;return k===y.length}}}function u(t,o=[],n=R.DEFAULT){let d=null,l=[];const g=[];function E(y){Array.isArray(l)?l.push(y):d!==null&&(l[d]=y)}return i(t,{onObjectBegin:()=>{const y={};E(y),g.push(l),l=y,d=null},onObjectProperty:y=>{d=y},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const y=[];E(y),g.push(l),l=y,d=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:E,onError:(y,k,A)=>{o.push({error:y,offset:k,length:A})}},n),l[0]}function P(t,o=[],n=R.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(y){d.type==="property"&&(d.length=y-d.offset,d=d.parent)}function g(y){return d.children.push(y),y}i(t,{onObjectBegin:y=>{d=g({type:"object",offset:y,length:-1,parent:d,children:[]})},onObjectProperty:(y,k,A)=>{d=g({type:"property",offset:k,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:y,offset:k,length:A,parent:d})},onObjectEnd:(y,k)=>{d.length=y+k-d.offset,d=d.parent,l(y+k)},onArrayBegin:(y,k)=>{d=g({type:"array",offset:y,length:-1,parent:d,children:[]})},onArrayEnd:(y,k)=>{d.length=y+k-d.offset,d=d.parent,l(y+k)},onLiteralValue:(y,k,A)=>{g({type:s(y),offset:k,length:A,parent:d,value:y}),l(k+A)},onSeparator:(y,k,A)=>{d.type==="property"&&(y===":"?d.colonOffset=k:y===","&&l(k))},onError:(y,k,A)=>{o.push({error:y,offset:k,length:A})}},n);const D=d.children[0];return D&&delete D.parent,D}function w(t,o){if(!t)return;let n=t;for(const d of o)if(typeof d=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===d){n=g.children[1],l=!0;break}if(!l)return}else{const l=d;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}function a(t){if(!t.parent||!t.parent.children)return[];const o=a(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const o=Object.create(null);for(const n of t.children){const d=n.children[1];d&&(o[n.children[0].value]=m(d))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}function f(t,o,n=!1){if($(t,o,n)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=o;l++){const g=f(d[l],o,n);if(g)return g}return t}}function i(t,o,n=R.DEFAULT){const d=L(t,!1);function l(_){return _?()=>_(d.getTokenOffset(),d.getTokenLength()):()=>!0}function g(_){return _?le=>_(le,d.getTokenOffset(),d.getTokenLength()):()=>!0}const E=l(o.onObjectBegin),D=g(o.onObjectProperty),y=l(o.onObjectEnd),k=l(o.onArrayBegin),A=l(o.onArrayEnd),p=g(o.onLiteralValue),v=g(o.onSeparator),F=l(o.onComment),N=g(o.onError),O=n&&n.disallowComments,j=n&&n.allowTrailingComma;function z(){for(;;){const _=d.scan();switch(d.getTokenError()){case r.InvalidUnicode:M(C.InvalidUnicode);break;case r.InvalidEscapeCharacter:M(C.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:M(C.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:O||M(C.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:M(C.UnexpectedEndOfString);break;case r.InvalidCharacter:M(C.InvalidCharacter);break}switch(_){case h.LineCommentTrivia:case h.BlockCommentTrivia:O?M(C.InvalidCommentToken):F();break;case h.Unknown:M(C.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return _}}}function M(_,le=[],re=[]){if(N(_),le.length+re.length>0){let Se=d.getToken();for(;Se!==h.EOF;){if(le.indexOf(Se)!==-1){z();break}else if(re.indexOf(Se)!==-1)break;Se=z()}}}function U(_){const le=d.getTokenValue();return _?p(le):D(le),z(),!0}function V(){switch(d.getToken()){case h.NumericLiteral:{let _=0;try{_=JSON.parse(d.getTokenValue()),typeof _!="number"&&(M(C.InvalidNumberFormat),_=0)}catch{M(C.InvalidNumberFormat)}p(_);break}case h.NullKeyword:p(null);break;case h.TrueKeyword:p(!0);break;case h.FalseKeyword:p(!1);break;default:return!1}return z(),!0}function ie(){return d.getToken()!==h.StringLiteral?(M(C.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(U(!1),d.getToken()===h.ColonToken?(v(":"),z(),J()||M(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):M(C.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function B(){E(),z();let _=!1;for(;d.getToken()!==h.CloseBraceToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(_||M(C.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBraceToken&&j)break}else _&&M(C.CommaExpected,[],[]);ie()||M(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),_=!0}return y(),d.getToken()!==h.CloseBraceToken?M(C.CloseBraceExpected,[h.CloseBraceToken],[]):z(),!0}function Y(){k(),z();let _=!1;for(;d.getToken()!==h.CloseBracketToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(_||M(C.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBracketToken&&j)break}else _&&M(C.CommaExpected,[],[]);J()||M(C.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),_=!0}return A(),d.getToken()!==h.CloseBracketToken?M(C.CloseBracketExpected,[h.CloseBracketToken],[]):z(),!0}function J(){switch(d.getToken()){case h.OpenBracketToken:return Y();case h.OpenBraceToken:return B();case h.StringLiteral:return U(!0);default:return V()}}return z(),d.getToken()===h.EOF?n.allowEmptyContent?!0:(M(C.ValueExpected,[],[]),!1):J()?(d.getToken()!==h.EOF&&M(C.EndOfFileExpected,[],[]),!0):(M(C.ValueExpected,[],[]),!1)}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[177],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=r;function r(R){let L=!1;const T=new Map,b=new Map;if(C(R,a=>{if(R===a)return!0;const m=JSON.stringify(a);if(m.length<30)return!0;const $=T.get(m);if(!$){const f={schemas:[a]};return T.set(m,f),b.set(a,f),!0}return $.schemas.push(a),b.set(a,$),L=!0,!1}),T.clear(),!L)return JSON.stringify(R);let I="$defs";for(;R.hasOwnProperty(I);)I+="_";const S=[];function u(a){return JSON.stringify(a,(m,$)=>{if($!==a){const f=b.get($);if(f&&f.schemas.length>1)return f.id||(f.id=`_${S.length}`,S.push(f.schemas[0])),{$ref:`#/${I}/${f.id}`}}return $})}const P=u(R),w=[];for(let a=0;a<S.length;a++)w.push(`"_${a}":${u(S[a])}`);return w.length?`${P.substring(0,P.length-1)},"${I}":{${w.join(",")}}}`:P}function h(R){return typeof R=="object"&&R!==null}function C(R,L){if(!R||typeof R!="object")return;const T=(...P)=>{for(const w of P)h(w)&&S.push(w)},b=(...P)=>{for(const w of P)if(h(w))for(const a in w){const m=w[a];h(m)&&S.push(m)}},c=(...P)=>{for(const w of P)if(Array.isArray(w))for(const a of w)h(a)&&S.push(a)},I=P=>{if(Array.isArray(P))for(const w of P)h(w)&&S.push(w);else h(P)&&S.push(P)},S=[R];let u=S.pop();for(;u;)L(u)&&(T(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),b(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),c(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=S.pop()}}),define(ke[49],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class r{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=r}),define(ke[80],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const L=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=L}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const T=new r(R);if(this.a===r.Undefined)this.a=T,this.b=T;else if(L){const c=this.b;this.b=T,T.prev=c,c.next=T}else{const c=this.a;this.a=T,T.next=c,c.prev=T}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(T))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$5c=h}),define(ke[28],Ie([1,0]),function($e,e){"use strict";var r,h,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=L,e.$zc=T,e.$Ic=s;function R(t,o,n){let d=t.get(o);return d===void 0&&(d=n,t.set(o,d)),d}function L(t){const o=[];return t.forEach((n,d)=>{o.push(`${d} => ${n}`)}),`Map(${t.size}) {${o.join(", ")}}`}function T(t){const o=[];return t.forEach(n=>{o.push(n)}),`Set(${t.size}) {${o.join(", ")}}`}class b{constructor(o,n){this.uri=o,this.value=n}}function c(t){return Array.isArray(t)}class I{static{this.c=o=>o.toString()}constructor(o,n){if(this[r]="ResourceMap",o instanceof I)this.d=new Map(o.d),this.e=n??I.c;else if(c(o)){this.d=new Map,this.e=n??I.c;for(const[d,l]of o)this.set(d,l)}else this.d=new Map,this.e=o??I.c}set(o,n){return this.d.set(this.e(o),new b(o,n)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,n){typeof n<"u"&&(o=o.bind(n));for(const[d,l]of this.d)o(l.value,l.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}e.$Ac=I;class S{constructor(o,n){this[h]="ResourceSet",!o||typeof o=="function"?this.c=new I(o):(this.c=new I(n),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,n){this.c.forEach((d,l)=>o.call(n,l,l,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var u;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class P{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,n=u.None){const d=this.c.get(o);if(d)return n!==u.None&&this.m(d,n),d.value}set(o,n,d=u.None){let l=this.c.get(o);if(l)l.value=n,d!==u.None&&this.m(l,d);else{switch(l={key:o,value:n,next:void 0,previous:void 0},d){case u.None:this.k(l);break;case u.AsOld:this.j(l);break;case u.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(o,l),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const n=this.c.get(o);if(n)return this.c.delete(o),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,n){const d=this.g;let l=this.d;for(;l;){if(n?o.bind(n)(l.value,l.key,this):o(l.value,l.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.key,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}values(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.value,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}entries(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:[d.key,d.value],done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.d,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.next,d--;this.d=n,this.f=d,n&&(n.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.e,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.previous,d--;this.e=n,this.f=d,n&&(n.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const n=o.next,d=o.previous;if(!n||!d)throw new Error("Invalid list");n.previous=d,d.next=n}o.next=void 0,o.previous=void 0,this.g++}m(o,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==u.AsOld&&n!==u.AsNew)){if(n===u.AsOld){if(o===this.d)return;const d=o.next,l=o.previous;o===this.e?(l.next=void 0,this.e=l):(d.previous=l,l.next=d),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(n===u.AsNew){if(o===this.e)return;const d=o.next,l=o.previous;o===this.d?(d.previous=void 0,this.d=d):(d.previous=l,l.next=d),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((n,d)=>{o.push([d,n])}),o}fromJSON(o){this.clear();for(const[n,d]of o)this.set(n,d)}}e.$Cc=P;class w extends P{constructor(o,n=1){super(),this.n=o,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,n=u.AsNew){return super.get(o,n)}peek(o){return super.get(o,u.None)}set(o,n){return super.set(o,n,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends w{constructor(o,n=1){super(o,n)}q(o){this.h(o)}set(o,n){return super.set(o,n),this.p(),this}}e.$Dc=a;class m extends w{constructor(o,n=1){super(o,n)}q(o){this.i(o)}set(o,n){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,n),this}}e.$Ec=m;class ${constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let n=this.c.get(o)||0;return n===0?!1:(n--,n===0?this.c.delete(o):this.c.set(o,n),!0)}has(o){return this.c.has(o)}}e.$Fc=$;class f{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[n,d]of o)this.set(n,d)}clear(){this.c.clear(),this.d.clear()}set(o,n){this.c.set(o,n),this.d.set(n,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const n=this.c.get(o);return n===void 0?!1:(this.c.delete(o),this.d.delete(n),!0)}forEach(o,n){this.c.forEach((d,l)=>{o.call(n,d,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=f;class i{constructor(){this.c=new Map}add(o,n){let d=this.c.get(o);d||(d=new Set,this.c.set(o,d)),d.add(n)}delete(o,n){const d=this.c.get(o);d&&(d.delete(n),d.size===0&&this.c.delete(o))}forEach(o,n){const d=this.c.get(o);d&&d.forEach(n)}get(o){const n=this.c.get(o);return n||new Set}}e.$Hc=i;function s(t,o){if(t===o)return!0;if(t.size!==o.size)return!1;for(const[n,d]of t)if(!o.has(n)||o.get(n)!==d)return!1;for(const[n]of o)if(!t.has(n))return!1;return!0}}),define(ke[3],Ie([1,0,18,78,28,79,39]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=I,e.$Lc=S,e.$Mc=u,e.$Nc=a,e.$Oc=m,e.$Pc=$,e.$Qc=f,e.$Rc=i,e.$Sc=s,e.$3c=k;const T=!1;let b=null;class c{constructor(){this.b=new Map}static{this.a=0}c(v){let F=this.b.get(v);return F||(F={parent:null,source:null,isSingleton:!1,value:v,idx:c.a++},this.b.set(v,F)),F}trackDisposable(v){const F=this.c(v);F.source||(F.source=new Error().stack)}setParent(v,F){const N=this.c(v);N.parent=F}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,F){const N=F.get(v);if(N)return N;const O=v.parent?this.f(this.c(v.parent),F):v;return F.set(v,O),O}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,F){let N;if(F)N=F;else{const U=new Map,V=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,U).isSingleton);if(V.length===0)return;const ie=new Set(V.map(B=>B.value));if(N=V.filter(B=>!(B.parent&&ie.has(B.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(U){function V(B,Y){for(;B.length>0&&Y.some(J=>typeof J=="string"?J===B[0]:B[0].match(J));)B.shift()}const ie=U.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return V(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const j=new C.$Hc;for(const U of N){const V=O(U);for(let ie=0;ie<=V.length;ie++)j.add(V.slice(0,ie).join(`
`),U)}N.sort((0,r.$5b)(U=>U.idx,r.$7b));let z="",M=0;for(const U of N.slice(0,v)){M++;const V=O(U),ie=[];for(let B=0;B<V.length;B++){let Y=V[B];Y=`(shared with ${j.get(V.slice(0,B+1).join(`
`)).size}/${N.length} leaks) at ${Y}`;const _=j.get(V.slice(0,B).join(`
`)),le=(0,h.$c)([..._].map(re=>O(re)[B]),re=>re);delete le[V[B]];for(const[re,Se]of Object.entries(le))ie.unshift(`    - stacktraces of ${Se.length} other leaks continue with ${re}`);ie.unshift(Y)}z+=`


==================== Leaking disposable ${M}/${N.length}: ${U.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return N.length>v&&(z+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:z}}}e.$Jc=c;function I(p){b=p}if(T){const p="__is_disposable_tracked__";I(new class{trackDisposable(v){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[p]||console.log(F)},3e3)}setParent(v,F){if(v&&v!==o.None)try{v[p]=!0}catch{}}markAsDisposed(v){if(v&&v!==o.None)try{v[p]=!0}catch{}}markAsSingleton(v){}})}function S(p){return b?.trackDisposable(p),p}function u(p){b?.markAsDisposed(p)}function P(p,v){b?.setParent(p,v)}function w(p,v){if(b)for(const F of p)b.setParent(F,v)}function a(p){return b?.markAsSingleton(p),p}function m(p){return typeof p=="object"&&p!==null&&typeof p.dispose=="function"&&p.dispose.length===0}function $(p){if(L.Iterable.is(p)){const v=[];for(const F of p)if(F)try{F.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}function f(p){for(const v of p)m(v)&&v.dispose();return[]}function i(...p){const v=s(()=>$(p));return w(p,v),v}function s(p){const v=S({dispose:(0,R.$cb)(()=>{u(v),p()})});return v}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return P(v,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),P(v,null))}}e.$Tc=t;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,S(this),P(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Uc=o;class n{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&P(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&P(v,null),v}}e.$Vc=n;class d{constructor(v){this.a=new n,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class l{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(v){let F=v;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,u(this))},this}}e.$Yc=g;class E{constructor(){this.a=new Map}acquire(v,...F){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...F)},this.a.set(v,N));const{object:O}=N,j=(0,R.$cb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:O,dispose:j}}}e.$Zc=E;class D{constructor(v){this.a=v}async acquire(v,...F){const N=this.a.acquire(v,...F);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.$1c=D;class y{constructor(v){this.object=v}dispose(){}}e.$2c=y;function k(p){const v=new t;try{p(v)}finally{v.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,F,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,F)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const F=this.a.get(v);return this.a.delete(v),F}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=A}),function($e,e){typeof define=="function"&&define.amd?define(ke[178],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(ee,ae){for(var oe=0;oe<ae.length;oe++){var x=ae[oe];x.enumerable=x.enumerable||!1,x.configurable=!0,"value"in x&&(x.writable=!0),Object.defineProperty(ee,x.key,x)}}function r(ee,ae,oe){return ae&&e(ee.prototype,ae),oe&&e(ee,oe),Object.defineProperty(ee,"prototype",{writable:!1}),ee}function h(ee,ae){if(ee){if(typeof ee=="string")return C(ee,ae);var oe=Object.prototype.toString.call(ee).slice(8,-1);if(oe==="Object"&&ee.constructor&&(oe=ee.constructor.name),oe==="Map"||oe==="Set")return Array.from(ee);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return C(ee,ae)}}function C(ee,ae){(ae==null||ae>ee.length)&&(ae=ee.length);for(var oe=0,x=new Array(ae);oe<ae;oe++)x[oe]=ee[oe];return x}function R(ee,ae){var oe=typeof Symbol<"u"&&ee[Symbol.iterator]||ee["@@iterator"];if(oe)return(oe=oe.call(ee)).next.bind(oe);if(Array.isArray(ee)||(oe=h(ee))||ae&&ee&&typeof ee.length=="number"){oe&&(ee=oe);var x=0;return function(){return x>=ee.length?{done:!0}:{done:!1,value:ee[x++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=L();function T(ee){$e.defaults=ee}var b=/[&<>"']/,c=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(ae){return u[ae]};function w(ee,ae){if(ae){if(b.test(ee))return ee.replace(c,P)}else if(I.test(ee))return ee.replace(S,P);return ee}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ee){return ee.replace(a,function(ae,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var $=/(^|[^\[])\^/g;function f(ee,ae){ee=typeof ee=="string"?ee:ee.source,ae=ae||"";var oe={replace:function(ne,pe){return pe=pe.source||pe,pe=pe.replace($,"$1"),ee=ee.replace(ne,pe),oe},getRegex:function(){return new RegExp(ee,ae)}};return oe}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ee,ae,oe){if(ee){var x;try{x=decodeURIComponent(m(oe)).replace(i,"").toLowerCase()}catch{return null}if(x.indexOf("javascript:")===0||x.indexOf("vbscript:")===0||x.indexOf("data:")===0)return null}ae&&!s.test(oe)&&(oe=g(ae,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var o={},n=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(ee,ae){o[" "+ee]||(n.test(ee)?o[" "+ee]=ee+"/":o[" "+ee]=k(ee,"/",!0)),ee=o[" "+ee];var oe=ee.indexOf(":")===-1;return ae.substring(0,2)==="//"?oe?ae:ee.replace(d,"$1")+ae:ae.charAt(0)==="/"?oe?ae:ee.replace(l,"$1")+ae:ee+ae}var E={exec:function(){}};function D(ee){for(var ae=1,oe,x;ae<arguments.length;ae++){oe=arguments[ae];for(x in oe)Object.prototype.hasOwnProperty.call(oe,x)&&(ee[x]=oe[x])}return ee}function y(ee,ae){var oe=ee.replace(/\|/g,function(pe,be,Fe){for(var ze=!1,Ae=be;--Ae>=0&&Fe[Ae]==="\\";)ze=!ze;return ze?"|":" |"}),x=oe.split(/ \|/),ne=0;if(x[0].trim()||x.shift(),x.length>0&&!x[x.length-1].trim()&&x.pop(),x.length>ae)x.splice(ae);else for(;x.length<ae;)x.push("");for(;ne<x.length;ne++)x[ne]=x[ne].trim().replace(/\\\|/g,"|");return x}function k(ee,ae,oe){var x=ee.length;if(x===0)return"";for(var ne=0;ne<x;){var pe=ee.charAt(x-ne-1);if(pe===ae&&!oe)ne++;else if(pe!==ae&&oe)ne++;else break}return ee.slice(0,x-ne)}function A(ee,ae){if(ee.indexOf(ae[1])===-1)return-1;for(var oe=ee.length,x=0,ne=0;ne<oe;ne++)if(ee[ne]==="\\")ne++;else if(ee[ne]===ae[0])x++;else if(ee[ne]===ae[1]&&(x--,x<0))return ne;return-1}function p(ee){ee&&ee.sanitize&&!ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(ee,ae){if(ae<1)return"";for(var oe="";ae>1;)ae&1&&(oe+=ee),ae>>=1,ee+=ee;return oe+ee}function F(ee,ae,oe,x){var ne=ae.href,pe=ae.title?w(ae.title):null,be=ee[1].replace(/\\([\[\]])/g,"$1");if(ee[0].charAt(0)!=="!"){x.state.inLink=!0;var Fe={type:"link",raw:oe,href:ne,title:pe,text:be,tokens:x.inlineTokens(be)};return x.state.inLink=!1,Fe}return{type:"image",raw:oe,href:ne,title:pe,text:w(be)}}function N(ee,ae){var oe=ee.match(/^(\s+)(?:```)/);if(oe===null)return ae;var x=oe[1];return ae.split(`
`).map(function(ne){var pe=ne.match(/^\s+/);if(pe===null)return ne;var be=pe[0];return be.length>=x.length?ne.slice(x.length):ne}).join(`
`)}var O=function(){function ee(oe){this.options=oe||$e.defaults}var ae=ee.prototype;return ae.space=function(x){var ne=this.rules.block.newline.exec(x);if(ne&&ne[0].length>0)return{type:"space",raw:ne[0]}},ae.code=function(x){var ne=this.rules.block.code.exec(x);if(ne){var pe=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:k(pe,`
`)}}},ae.fences=function(x){var ne=this.rules.block.fences.exec(x);if(ne){var pe=ne[0],be=N(pe,ne[3]||"");return{type:"code",raw:pe,lang:ne[2]?ne[2].trim():ne[2],text:be}}},ae.heading=function(x){var ne=this.rules.block.heading.exec(x);if(ne){var pe=ne[2].trim();if(/#$/.test(pe)){var be=k(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ae.hr=function(x){var ne=this.rules.block.hr.exec(x);if(ne)return{type:"hr",raw:ne[0]}},ae.blockquote=function(x){var ne=this.rules.block.blockquote.exec(x);if(ne){var pe=ne[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ne[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ae.list=function(x){var ne=this.rules.block.list.exec(x);if(ne){var pe,be,Fe,ze,Ae,De,Ce,W,H,X,Z,de,ve=ne[1].trim(),Oe=ve.length>1,He={type:"list",raw:"",ordered:Oe,start:Oe?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Oe?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Oe?ve:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");x&&(de=!1,!(!(ne=Ke.exec(x))||this.rules.block.hr.test(x)));){if(pe=ne[0],x=x.substring(pe.length),W=ne[2].split(`
`,1)[0],H=x.split(`
`,1)[0],this.options.pedantic?(ze=2,Z=W.trimLeft()):(ze=ne[2].search(/[^ ]/),ze=ze>4?1:ze,Z=W.slice(ze),ze+=ne[1].length),De=!1,!W&&/^ *$/.test(H)&&(pe+=H+`
`,x=x.substring(H.length+1),de=!0),!de)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),st=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");x&&(X=x.split(`
`,1)[0],W=X,this.options.pedantic&&(W=W.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(st.test(W)||rt.test(W)||_e.test(W)||nt.test(x)));){if(W.search(/[^ ]/)>=ze||!W.trim())Z+=`
`+W.slice(ze);else if(!De)Z+=`
`+W;else break;!De&&!W.trim()&&(De=!0),pe+=X+`
`,x=x.substring(X.length+1)}He.loose||(Ce?He.loose=!0:/\n *\n *$/.test(pe)&&(Ce=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(Z),be&&(Fe=be[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:pe,task:!!be,checked:Fe,loose:!1,text:Z}),He.raw+=pe}He.items[He.items.length-1].raw=pe.trimRight(),He.items[He.items.length-1].text=Z.trimRight(),He.raw=He.raw.trimRight();var at=He.items.length;for(Ae=0;Ae<at;Ae++){this.lexer.state.top=!1,He.items[Ae].tokens=this.lexer.blockTokens(He.items[Ae].text,[]);var gt=He.items[Ae].tokens.filter(function(ct){return ct.type==="space"}),ht=gt.every(function(ct){for(var Pe=ct.raw.split(""),Be=0,Ye=R(Pe),Ne;!(Ne=Ye()).done;){var je=Ne.value;if(je===`
`&&(Be+=1),Be>1)return!0}return!1});!He.loose&&gt.length&&ht&&(He.loose=!0,He.items[Ae].loose=!0)}return He}},ae.html=function(x){var ne=this.rules.block.html.exec(x);if(ne){var pe={type:"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:ne[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ne[0]):w(ne[0]);pe.type="paragraph",pe.text=be,pe.tokens=this.lexer.inline(be)}return pe}},ae.def=function(x){var ne=this.rules.block.def.exec(x);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var pe=ne[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:ne[0],href:ne[2],title:ne[3]}}},ae.table=function(x){var ne=this.rules.block.table.exec(x);if(ne){var pe={type:"table",header:y(ne[1]).map(function(Ce){return{text:Ce}}),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ne[3]&&ne[3].trim()?ne[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ne[0];var be=pe.align.length,Fe,ze,Ae,De;for(Fe=0;Fe<be;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(be=pe.rows.length,Fe=0;Fe<be;Fe++)pe.rows[Fe]=y(pe.rows[Fe],pe.header.length).map(function(Ce){return{text:Ce}});for(be=pe.header.length,ze=0;ze<be;ze++)pe.header[ze].tokens=this.lexer.inline(pe.header[ze].text);for(be=pe.rows.length,ze=0;ze<be;ze++)for(De=pe.rows[ze],Ae=0;Ae<De.length;Ae++)De[Ae].tokens=this.lexer.inline(De[Ae].text);return pe}}},ae.lheading=function(x){var ne=this.rules.block.lheading.exec(x);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1],tokens:this.lexer.inline(ne[1])}},ae.paragraph=function(x){var ne=this.rules.block.paragraph.exec(x);if(ne){var pe=ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1];return{type:"paragraph",raw:ne[0],text:pe,tokens:this.lexer.inline(pe)}}},ae.text=function(x){var ne=this.rules.block.text.exec(x);if(ne)return{type:"text",raw:ne[0],text:ne[0],tokens:this.lexer.inline(ne[0])}},ae.escape=function(x){var ne=this.rules.inline.escape.exec(x);if(ne)return{type:"escape",raw:ne[0],text:w(ne[1])}},ae.tag=function(x){var ne=this.rules.inline.tag.exec(x);if(ne)return!this.lexer.state.inLink&&/^<a /i.test(ne[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ne[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ne[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ne[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ne[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):w(ne[0]):ne[0]}},ae.link=function(x){var ne=this.rules.inline.link.exec(x);if(ne){var pe=ne[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=k(pe.slice(0,-1),"\\");if((pe.length-be.length)%2===0)return}else{var Fe=A(ne[2],"()");if(Fe>-1){var ze=ne[0].indexOf("!")===0?5:4,Ae=ze+ne[1].length+Fe;ne[2]=ne[2].substring(0,Fe),ne[0]=ne[0].substring(0,Ae).trim(),ne[3]=""}}var De=ne[2],Ce="";if(this.options.pedantic){var W=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(De);W&&(De=W[1],Ce=W[3])}else Ce=ne[3]?ne[3].slice(1,-1):"";return De=De.trim(),/^</.test(De)&&(this.options.pedantic&&!/>$/.test(pe)?De=De.slice(1):De=De.slice(1,-1)),F(ne,{href:De&&De.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},ne[0],this.lexer)}},ae.reflink=function(x,ne){var pe;if((pe=this.rules.inline.reflink.exec(x))||(pe=this.rules.inline.nolink.exec(x))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ne[be.toLowerCase()],!be||!be.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return F(pe,be,pe[0],this.lexer)}},ae.emStrong=function(x,ne,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(x);if(be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=be[1]||be[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ze=be[0].length-1,Ae,De,Ce=ze,W=0,H=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,ne=ne.slice(-1*x.length+ze);(be=H.exec(ne))!=null;)if(Ae=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Ae){if(De=Ae.length,be[3]||be[4]){Ce+=De;continue}else if((be[5]||be[6])&&ze%3&&!((ze+De)%3)){W+=De;continue}if(Ce-=De,!(Ce>0)){if(De=Math.min(De,De+Ce+W),Math.min(ze,De)%2){var X=x.slice(1,ze+be.index+De);return{type:"em",raw:x.slice(0,ze+be.index+De+1),text:X,tokens:this.lexer.inlineTokens(X)}}var Z=x.slice(2,ze+be.index+De-1);return{type:"strong",raw:x.slice(0,ze+be.index+De+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},ae.codespan=function(x){var ne=this.rules.inline.code.exec(x);if(ne){var pe=ne[2].replace(/\n/g," "),be=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return be&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=w(pe,!0),{type:"codespan",raw:ne[0],text:pe}}},ae.br=function(x){var ne=this.rules.inline.br.exec(x);if(ne)return{type:"br",raw:ne[0]}},ae.del=function(x){var ne=this.rules.inline.del.exec(x);if(ne)return{type:"del",raw:ne[0],text:ne[2],tokens:this.lexer.inlineTokens(ne[2])}},ae.autolink=function(x,ne){var pe=this.rules.inline.autolink.exec(x);if(pe){var be,Fe;return pe[2]==="@"?(be=w(this.options.mangle?ne(pe[1]):pe[1]),Fe="mailto:"+be):(be=w(pe[1]),Fe=be),{type:"link",raw:pe[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},ae.url=function(x,ne){var pe;if(pe=this.rules.inline.url.exec(x)){var be,Fe;if(pe[2]==="@")be=w(this.options.mangle?ne(pe[0]):pe[0]),Fe="mailto:"+be;else{var ze;do ze=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ze!==pe[0]);be=w(pe[0]),pe[1]==="www."?Fe="http://"+be:Fe=be}return{type:"link",raw:pe[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},ae.inlineText=function(x,ne){var pe=this.rules.inline.text.exec(x);if(pe){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):w(pe[0]):pe[0]:be=w(this.options.smartypants?ne(pe[0]):pe[0]),{type:"text",raw:pe[0],text:be}}},ee}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=f(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=f(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=f(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=f(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=f(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=f(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=D({},j),j.gfm=D({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=f(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=f(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=D({},j.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:f(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=f(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=f(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=f(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=f(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=f(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=f(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=f(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=f(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=f(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=f(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=f(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=D({},z),z.pedantic=D({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=D({},z.normal,{escape:f(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=f(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=D({},z.gfm,{br:f(z.br).replace("{2,}","*").getRegex(),text:f(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ee){return ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(ee){var ae="",oe,x,ne=ee.length;for(oe=0;oe<ne;oe++)x=ee.charCodeAt(oe),Math.random()>.5&&(x="x"+x.toString(16)),ae+="&#"+x+";";return ae}var V=function(){function ee(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||$e.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var x={block:j.normal,inline:z.normal};this.options.pedantic?(x.block=j.pedantic,x.inline=z.pedantic):this.options.gfm&&(x.block=j.gfm,this.options.breaks?x.inline=z.breaks:x.inline=z.gfm),this.tokenizer.rules=x}ee.lex=function(x,ne){var pe=new ee(ne);return pe.lex(x)},ee.lexInline=function(x,ne){var pe=new ee(ne);return pe.inlineTokens(x)};var ae=ee.prototype;return ae.lex=function(x){x=x.replace(/\r\n|\r/g,`
`),this.blockTokens(x,this.tokens);for(var ne;ne=this.inlineQueue.shift();)this.inlineTokens(ne.src,ne.tokens);return this.tokens},ae.blockTokens=function(x,ne){var pe=this;ne===void 0&&(ne=[]),this.options.pedantic?x=x.replace(/\t/g,"    ").replace(/^ +$/gm,""):x=x.replace(/^( *)(\t+)/gm,function(Ce,W,H){return W+"    ".repeat(H.length)});for(var be,Fe,ze,Ae;x;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(be=Ce.call({lexer:pe},x,ne))?(x=x.substring(be.raw.length),ne.push(be),!0):!1}))){if(be=this.tokenizer.space(x)){x=x.substring(be.raw.length),be.raw.length===1&&ne.length>0?ne[ne.length-1].raw+=`
`:ne.push(be);continue}if(be=this.tokenizer.code(x)){x=x.substring(be.raw.length),Fe=ne[ne.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ne.push(be);continue}if(be=this.tokenizer.fences(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.heading(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.hr(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.blockquote(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.list(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.html(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.def(x)){x=x.substring(be.raw.length),Fe=ne[ne.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.lheading(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(ze=x,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,W=x.slice(1),H=void 0;pe.options.extensions.startBlock.forEach(function(X){H=X.call({lexer:this},W),typeof H=="number"&&H>=0&&(Ce=Math.min(Ce,H))}),Ce<1/0&&Ce>=0&&(ze=x.substring(0,Ce+1))}(),this.state.top&&(be=this.tokenizer.paragraph(ze))){Fe=ne[ne.length-1],Ae&&Fe.type==="paragraph"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ne.push(be),Ae=ze.length!==x.length,x=x.substring(be.raw.length);continue}if(be=this.tokenizer.text(x)){x=x.substring(be.raw.length),Fe=ne[ne.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ne.push(be);continue}if(x){var De="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return this.state.top=!0,ne},ae.inline=function(x,ne){return ne===void 0&&(ne=[]),this.inlineQueue.push({src:x,tokens:ne}),ne},ae.inlineTokens=function(x,ne){var pe=this;ne===void 0&&(ne=[]);var be,Fe,ze,Ae=x,De,Ce,W;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(De=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)H.includes(De[0].slice(De[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(De=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(De=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,De.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;x;)if(Ce||(W=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(be=Z.call({lexer:pe},x,ne))?(x=x.substring(be.raw.length),ne.push(be),!0):!1}))){if(be=this.tokenizer.escape(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.tag(x)){x=x.substring(be.raw.length),Fe=ne[ne.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ne.push(be);continue}if(be=this.tokenizer.link(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.reflink(x,this.tokens.links)){x=x.substring(be.raw.length),Fe=ne[ne.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ne.push(be);continue}if(be=this.tokenizer.emStrong(x,Ae,W)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.codespan(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.br(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.del(x)){x=x.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.autolink(x,U)){x=x.substring(be.raw.length),ne.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(x,U))){x=x.substring(be.raw.length),ne.push(be);continue}if(ze=x,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,de=x.slice(1),ve=void 0;pe.options.extensions.startInline.forEach(function(Oe){ve=Oe.call({lexer:this},de),typeof ve=="number"&&ve>=0&&(Z=Math.min(Z,ve))}),Z<1/0&&Z>=0&&(ze=x.substring(0,Z+1))}(),be=this.tokenizer.inlineText(ze,M)){x=x.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(W=be.raw.slice(-1)),Ce=!0,Fe=ne[ne.length-1],Fe&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ne.push(be);continue}if(x){var X="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return ne},r(ee,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),ee}(),ie=function(){function ee(oe){this.options=oe||$e.defaults}var ae=ee.prototype;return ae.code=function(x,ne,pe){var be=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(x,be);Fe!=null&&Fe!==x&&(pe=!0,x=Fe)}return x=x.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+w(be,!0)+'">'+(pe?x:w(x,!0))+`</code></pre>
`:"<pre><code>"+(pe?x:w(x,!0))+`</code></pre>
`},ae.blockquote=function(x){return`<blockquote>
`+x+`</blockquote>
`},ae.html=function(x){return x},ae.heading=function(x,ne,pe,be){if(this.options.headerIds){var Fe=this.options.headerPrefix+be.slug(pe);return"<h"+ne+' id="'+Fe+'">'+x+"</h"+ne+`>
`}return"<h"+ne+">"+x+"</h"+ne+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(x,ne,pe){var be=ne?"ol":"ul",Fe=ne&&pe!==1?' start="'+pe+'"':"";return"<"+be+Fe+`>
`+x+"</"+be+`>
`},ae.listitem=function(x){return"<li>"+x+`</li>
`},ae.checkbox=function(x){return"<input "+(x?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(x){return"<p>"+x+`</p>
`},ae.table=function(x,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+x+`</thead>
`+ne+`</table>
`},ae.tablerow=function(x){return`<tr>
`+x+`</tr>
`},ae.tablecell=function(x,ne){var pe=ne.header?"th":"td",be=ne.align?"<"+pe+' align="'+ne.align+'">':"<"+pe+">";return be+x+("</"+pe+`>
`)},ae.strong=function(x){return"<strong>"+x+"</strong>"},ae.em=function(x){return"<em>"+x+"</em>"},ae.codespan=function(x){return"<code>"+x+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(x){return"<del>"+x+"</del>"},ae.link=function(x,ne,pe){if(x=t(this.options.sanitize,this.options.baseUrl,x),x===null)return pe;var be='<a href="'+w(x)+'"';return ne&&(be+=' title="'+ne+'"'),be+=">"+pe+"</a>",be},ae.image=function(x,ne,pe){if(x=t(this.options.sanitize,this.options.baseUrl,x),x===null)return pe;var be='<img src="'+x+'" alt="'+pe+'"';return ne&&(be+=' title="'+ne+'"'),be+=this.options.xhtml?"/>":">",be},ae.text=function(x){return x},ee}(),B=function(){function ee(){}var ae=ee.prototype;return ae.strong=function(x){return x},ae.em=function(x){return x},ae.codespan=function(x){return x},ae.del=function(x){return x},ae.html=function(x){return x},ae.text=function(x){return x},ae.link=function(x,ne,pe){return""+pe},ae.image=function(x,ne,pe){return""+pe},ae.br=function(){return""},ee}(),Y=function(){function ee(){this.seen={}}var ae=ee.prototype;return ae.serialize=function(x){return x.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(x,ne){var pe=x,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[x];do be++,pe=x+"-"+be;while(this.seen.hasOwnProperty(pe))}return ne||(this.seen[x]=be,this.seen[pe]=0),pe},ae.slug=function(x,ne){ne===void 0&&(ne={});var pe=this.serialize(x);return this.getNextSafeSlug(pe,ne.dryrun)},ee}(),J=function(){function ee(oe){this.options=oe||$e.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new B,this.slugger=new Y}ee.parse=function(x,ne){var pe=new ee(ne);return pe.parse(x)},ee.parseInline=function(x,ne){var pe=new ee(ne);return pe.parseInline(x)};var ae=ee.prototype;return ae.parse=function(x,ne){ne===void 0&&(ne=!0);var pe="",be,Fe,ze,Ae,De,Ce,W,H,X,Z,de,ve,Oe,He,Ke,_e,nt,st,rt,at=x.length;for(be=0;be<at;be++){if(Z=x[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(rt=this.options.extensions.renderers[Z.type].call({parser:this},Z),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){pe+=rt||"";continue}switch(Z.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,m(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(H="",W="",Ae=Z.header.length,Fe=0;Fe<Ae;Fe++)W+=this.renderer.tablecell(this.parseInline(Z.header[Fe].tokens),{header:!0,align:Z.align[Fe]});for(H+=this.renderer.tablerow(W),X="",Ae=Z.rows.length,Fe=0;Fe<Ae;Fe++){for(Ce=Z.rows[Fe],W="",De=Ce.length,ze=0;ze<De;ze++)W+=this.renderer.tablecell(this.parseInline(Ce[ze].tokens),{header:!1,align:Z.align[ze]});X+=this.renderer.tablerow(W)}pe+=this.renderer.table(H,X);continue}case"blockquote":{X=this.parse(Z.tokens),pe+=this.renderer.blockquote(X);continue}case"list":{for(de=Z.ordered,ve=Z.start,Oe=Z.loose,Ae=Z.items.length,X="",Fe=0;Fe<Ae;Fe++)Ke=Z.items[Fe],_e=Ke.checked,nt=Ke.task,He="",Ke.task&&(st=this.renderer.checkbox(_e),Oe?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=st+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=st+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:st}):He+=st),He+=this.parse(Ke.tokens,Oe),X+=this.renderer.listitem(He,nt,_e);pe+=this.renderer.list(X,de,ve);continue}case"html":{pe+=this.renderer.html(Z.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(X=Z.tokens?this.parseInline(Z.tokens):Z.text;be+1<at&&x[be+1].type==="text";)Z=x[++be],X+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);pe+=ne?this.renderer.paragraph(X):X;continue}default:{var gt='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return pe},ae.parseInline=function(x,ne){ne=ne||this.renderer;var pe="",be,Fe,ze,Ae=x.length;for(be=0;be<Ae;be++){if(Fe=x[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(ze=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=ze||"";continue}switch(Fe.type){case"escape":{pe+=ne.text(Fe.text);break}case"html":{pe+=ne.html(Fe.text);break}case"link":{pe+=ne.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ne));break}case"image":{pe+=ne.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=ne.strong(this.parseInline(Fe.tokens,ne));break}case"em":{pe+=ne.em(this.parseInline(Fe.tokens,ne));break}case"codespan":{pe+=ne.codespan(Fe.text);break}case"br":{pe+=ne.br();break}case"del":{pe+=ne.del(this.parseInline(Fe.tokens,ne));break}case"text":{pe+=ne.text(Fe.text);break}default:{var De='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(De);return}else throw new Error(De)}}}return pe},ee}();function _(ee,ae,oe){if(typeof ee>"u"||ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");if(typeof ae=="function"&&(oe=ae,ae=null),ae=D({},_.defaults,ae||{}),p(ae),oe){var x=ae.highlight,ne;try{ne=V.lex(ee,ae)}catch(Ae){return oe(Ae)}var pe=function(De){var Ce;if(!De)try{ae.walkTokens&&_.walkTokens(ne,ae.walkTokens),Ce=J.parse(ne,ae)}catch(W){De=W}return ae.highlight=x,De?oe(De):oe(null,Ce)};if(!x||x.length<3||(delete ae.highlight,!ne.length))return pe();var be=0;_.walkTokens(ne,function(Ae){Ae.type==="code"&&(be++,setTimeout(function(){x(Ae.text,Ae.lang,function(De,Ce){if(De)return pe(De);Ce!=null&&Ce!==Ae.text&&(Ae.text=Ce,Ae.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}function Fe(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(Ae.message+"",!0)+"</pre>";throw Ae}try{var ze=V.lex(ee,ae);if(ae.walkTokens){if(ae.async)return Promise.all(_.walkTokens(ze,ae.walkTokens)).then(function(){return J.parse(ze,ae)}).catch(Fe);_.walkTokens(ze,ae.walkTokens)}return J.parse(ze,ae)}catch(Ae){Fe(Ae)}}_.options=_.setOptions=function(ee){return D(_.defaults,ee),T(_.defaults),_},_.getDefaults=L,_.defaults=$e.defaults,_.use=function(){for(var ee=arguments.length,ae=new Array(ee),oe=0;oe<ee;oe++)ae[oe]=arguments[oe];var x=D.apply(void 0,[{}].concat(ae)),ne=_.defaults.extensions||{renderers:{},childTokens:{}},pe;ae.forEach(function(be){if(be.extensions&&(pe=!0,be.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ae=ne.renderers?ne.renderers[ze.name]:null;Ae?ne.renderers[ze.name]=function(){for(var De=arguments.length,Ce=new Array(De),W=0;W<De;W++)Ce[W]=arguments[W];var H=ze.renderer.apply(this,Ce);return H===!1&&(H=Ae.apply(this,Ce)),H}:ne.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ne[ze.level]?ne[ze.level].unshift(ze.tokenizer):ne[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?ne.startBlock?ne.startBlock.push(ze.start):ne.startBlock=[ze.start]:ze.level==="inline"&&(ne.startInline?ne.startInline.push(ze.start):ne.startInline=[ze.start]))}ze.childTokens&&(ne.childTokens[ze.name]=ze.childTokens)})),be.renderer&&function(){var ze=_.defaults.renderer||new ie,Ae=function(W){var H=ze[W];ze[W]=function(){for(var X=arguments.length,Z=new Array(X),de=0;de<X;de++)Z[de]=arguments[de];var ve=be.renderer[W].apply(ze,Z);return ve===!1&&(ve=H.apply(ze,Z)),ve}};for(var De in be.renderer)Ae(De);x.renderer=ze}(),be.tokenizer&&function(){var ze=_.defaults.tokenizer||new O,Ae=function(W){var H=ze[W];ze[W]=function(){for(var X=arguments.length,Z=new Array(X),de=0;de<X;de++)Z[de]=arguments[de];var ve=be.tokenizer[W].apply(ze,Z);return ve===!1&&(ve=H.apply(ze,Z)),ve}};for(var De in be.tokenizer)Ae(De);x.tokenizer=ze}(),be.walkTokens){var Fe=_.defaults.walkTokens;x.walkTokens=function(ze){var Ae=[];return Ae.push(be.walkTokens.call(this,ze)),Fe&&(Ae=Ae.concat(Fe.call(this,ze))),Ae}}pe&&(x.extensions=ne),_.setOptions(x)})},_.walkTokens=function(ee,ae){for(var oe=[],x=function(){var Fe=pe.value;switch(oe=oe.concat(ae.call(_,Fe)),Fe.type){case"table":{for(var ze=R(Fe.header),Ae;!(Ae=ze()).done;){var De=Ae.value;oe=oe.concat(_.walkTokens(De.tokens,ae))}for(var Ce=R(Fe.rows),W;!(W=Ce()).done;)for(var H=W.value,X=R(H),Z;!(Z=X()).done;){var de=Z.value;oe=oe.concat(_.walkTokens(de.tokens,ae))}break}case"list":{oe=oe.concat(_.walkTokens(Fe.items,ae));break}default:_.defaults.extensions&&_.defaults.extensions.childTokens&&_.defaults.extensions.childTokens[Fe.type]?_.defaults.extensions.childTokens[Fe.type].forEach(function(ve){oe=oe.concat(_.walkTokens(Fe[ve],ae))}):Fe.tokens&&(oe=oe.concat(_.walkTokens(Fe.tokens,ae)))}},ne=R(ee),pe;!(pe=ne()).done;)x();return oe},_.parseInline=function(ee,ae){if(typeof ee>"u"||ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");ae=D({},_.defaults,ae||{}),p(ae);try{var oe=V.lexInline(ee,ae);return ae.walkTokens&&_.walkTokens(oe,ae.walkTokens),J.parseInline(oe,ae)}catch(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(x.message+"",!0)+"</pre>";throw x}},_.Parser=J,_.parser=J.parse,_.Renderer=ie,_.TextRenderer=B,_.Lexer=V,_.lexer=V.lex,_.Tokenizer=O,_.Slugger=Y,_.parse=_;var le=_.options,re=_.setOptions,Se=_.use,me=_.walkTokens,Q=_.parseInline,q=_,se=J.parse,we=V.lex;$e.Lexer=V,$e.Parser=J,$e.Renderer=ie,$e.Slugger=Y,$e.TextRenderer=B,$e.Tokenizer=O,$e.getDefaults=L,$e.lexer=we,$e.marked=_,$e.options=le,$e.parse=q,$e.parseInline=Q,$e.parser=se,$e.setOptions=re,$e.use=Se,$e.walkTokens=me,Object.defineProperty($e,"__esModule",{value:!0})}),define(ke[40],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(ke[179],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=r;function r(a){const m=R(a);if(m&&m.length>0)return new Uint32Array(m)}let h=0;const C=new Uint32Array(10);function R(a){if(h=0,L(a,S,b.InitialConsonant),h>0||(L(a,u,b.Vowel),h>0)||(L(a,P,b.FinalConsonant),h>0)||(L(a,w,b.CompatibilityJamo),h))return C.subarray(0,h);if(a>=44032&&a<=55203){const m=a-44032,$=m%588,f=Math.floor(m/588),i=Math.floor($/28),s=$%28-1;if(f<S.length?L(f,S,0):b.InitialConsonant+f-b.CompatibilityJamo<w.length&&L(b.InitialConsonant+f,w,b.CompatibilityJamo),i<u.length?L(i,u,0):b.Vowel+i-b.CompatibilityJamo<w.length&&L(b.Vowel+i-b.CompatibilityJamo,w,b.CompatibilityJamo),s>=0&&(s<P.length?L(s,P,0):b.FinalConsonant+s-b.CompatibilityJamo<w.length&&L(b.FinalConsonant+s-b.CompatibilityJamo,w,b.CompatibilityJamo)),h>0)return C.subarray(0,h)}}function L(a,m,$){a>=$&&a<$+m.length&&T(m[a-$])}function T(a){a!==c.NUL&&(C[h++]=a&255,a>>8&&(C[h++]=a>>8&255),a>>16&&(C[h++]=a>>16&255))}var b;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var c;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(c||(c={}));var I;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(I||(I={}));const S=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l]),P=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,I.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),w=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.E,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,c.Q,I.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l])}),define(ke[81],Ie([1,0,28]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=C,e.$nm=L;const h=new r.$Dc(1e4);function C(c){return b(c,"NFC",h)}const R=new r.$Dc(1e4);function L(c){return b(c,"NFD",R)}const T=/[^\u0000-\u0080]/;function b(c,I,S){if(!c)return c;const u=S.get(c);if(u)return u;let P;return T.test(c)?P=c.normalize(I):P=c,S.set(c,P),P}e.$om=function(){const c=/[\u0300-\u036f]/g;return function(I){return L(I).replace(c,"")}}()}),define(ke[133],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=r,e.rot=h,e.$Pm=T;function r(b,c,I){return Math.min(Math.max(b,c),I)}function h(b,c){return(c+b%c)%c}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=C;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=R;class L{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const I=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=L;function T(b,c,I,S,u,P,w,a){const m=w-I,$=a-S,f=u-I,i=P-S,s=b-I,t=c-S,o=m*m+$*$,n=m*f+$*i,d=m*s+$*t,l=f*f+i*i,g=f*s+i*t,E=1/(o*l-n*n),D=(l*d-n*g)*E,y=(o*g-n*d)*E;return D>=0&&y>=0&&D+y<1}}),define(ke[180],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=R,e.$cd=u;class r{constructor(w,a,m){this.owner=w,this.debugNameSource=a,this.referenceFn=m}getDebugName(w){return R(w,this)}}e.$ad=r;const h=new Map,C=new WeakMap;function R(P,w){const a=C.get(P);if(a)return a;const m=L(P,w);if(m){let $=h.get(m)??0;$++,h.set(m,$);const f=$===1?m:`${m}#${$}`;return C.set(P,f),f}}function L(P,w){const a=C.get(P);if(a)return a;const m=w.owner?I(w.owner)+".":"";let $;const f=w.debugNameSource;if(f!==void 0)if(typeof f=="function"){if($=f(),$!==void 0)return m+$}else return m+f;const i=w.referenceFn;if(i!==void 0&&($=u(i),$!==void 0))return m+$;if(w.owner!==void 0){const s=T(w.owner,P);if(s!==void 0)return m+s}}function T(P,w){for(const a in P)if(P[a]===w)return a}const b=new Map,c=new WeakMap;function I(P){const w=c.get(P);if(w)return w;const a=S(P);let m=b.get(a)??0;m++,b.set(a,m);const $=m===1?a:`${a}#${m}`;return c.set(P,$),$}function S(P){const w=P.constructor;return w?w.name:"Object"}function u(P){const w=P.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(m?m[1]:void 0)?.trim()}}),define(ke[181],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0,e.$Kd=h,e.$Ld=C;let r;function h(a){r=a}function C(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(m){return L([T(P("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[T(" "),c(I(m.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),c(I(m.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),c(I(m.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(m,$){console.log(...this.b([b("observable value changed"),c(m.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(m){if(m.size!==0)return c(" (changed deps: "+[...m].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),$.apply(m,[f,i]))}handleDerivedRecomputed(m,$){const f=this.d.get(m);console.log(...this.b([b("derived recomputed"),c(m.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(f),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),f.clear()}handleFromEventObservableTriggered(m,$){console.log(...this.b([b("observable from event triggered"),c(m.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),$.apply(m,[f,i]))}handleAutorunTriggered(m){const $=this.d.get(m);console.log(...this.b([b("autorun"),c(m.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let $=m.getDebugName();$===void 0&&($=""),console.log(...this.b([b("transaction"),c($,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Md=R;function L(a){const m=new Array,$=[];let f="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(f+=`%c${t.text}`,m.push(t.style),t.data&&$.push(...t.data)):"data"in t&&$.push(...t.data)}i(a);const s=[f,...m];return s.push(...$),s}function T(a){return c(a,{color:"black"})}function b(a){return c(w(`${a}: `,10),{color:"black",bold:!0})}function c(a,m={color:"black"}){function $(i){return Object.entries(i).reduce((s,[t,o])=>`${s}${t}:${o};`,"")}const f={color:m.color};return m.strikeThrough&&(f["text-decoration"]="line-through"),m.bold&&(f["font-weight"]="bold"),{text:a,style:$(f)}}function I(a,m){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=m?`"${a}"`:`"${a.substr(0,m-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?S(a,m):u(a,m);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function S(a,m){let $="[ ",f=!0;for(const i of a){if(f||($+=", "),$.length-5>m){$+="...";break}f=!1,$+=`${I(i,m-$.length)}`}return $+=" ]",$}function u(a,m){let $="{ ",f=!0;for(const[i,s]of Object.entries(a)){if(f||($+=", "),$.length-5>m){$+="...";break}f=!1,$+=`${i}: ${I(s,m-$.length)}`}return $+=" }",$}function P(a,m){let $="";for(let f=1;f<=m;f++)$+=a;return $}function w(a,m){for(;a.length<m;)a+=" ";return a}}),define(ke[182],Ie([1,0,175,180,181]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=e.$7d=e.$5d=e.$Zd=e.$Yd=void 0,e.$Vd=L,e.$Wd=b,e.$Xd=I,e.$1d=P,e.$2d=a,e.$3d=m,e.$4d=$,e.$6d=i,e.$8d=t;let R;function L(n){R=n}let T;function b(n){T=n}let c;function I(n){c=n}class S{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,l){const g=l===void 0?void 0:d,E=l===void 0?d:l;return c({owner:g,debugName:()=>{const D=(0,h.$cd)(E);if(D!==void 0)return D;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(k)return`${this.debugName}.${k[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}flatten(){return c({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},d=>this.read(d).read(d))}recomputeInitiallyAndOnChange(d,l){return d.add(R(this,l)),this}keepObserved(d){return d.add(T(this)),this}get a(){return this.get()}}e.$Yd=S;class u extends S{constructor(){super(...arguments),this.b=new Set}addObserver(d){const l=this.b.size;this.b.add(d),l===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Zd=u;function P(n,d){const l=new f(n,d);try{n(l)}finally{l.finish()}}let w;function a(n){if(w)n(w);else{const d=new f(n,void 0);w=d;try{n(d)}finally{d.finish(),w=void 0}}}async function m(n,d){const l=new f(n,d);try{await n(l)}finally{l.finish()}}function $(n,d,l){n?d(n):P(d,l)}class f{constructor(d,l){this._fn=d,this.b=l,this.a=[],(0,C.$Ld)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$cd)(this._fn)}updateObserver(d,l){this.a.push({observer:d,observable:l}),d.beginUpdate(l)}finish(){const d=this.a;for(let l=0;l<d.length;l++){const{observer:g,observable:E}=d[l];g.endUpdate(E)}this.a=null,(0,C.$Ld)()?.handleEndTransaction()}}e.$5d=f;function i(n,d){let l;return typeof n=="string"?l=new h.$ad(void 0,n,void 0):l=new h.$ad(n,void 0,void 0),new s(l,d,r.$6c)}class s extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,l,g){super(),this.e=d,this.g=g,this.d=l}get(){return this.d}set(d,l,g){if(g===void 0&&this.g(this.d,d))return;let E;l||(l=E=new f(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(d),(0,C.$Ld)()?.handleObservableChanged(this,{oldValue:D,newValue:d,change:g,didChange:!0,hadValue:!0});for(const y of this.b)l.updateObserver(y,this),y.handleChange(this,g)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$7d=s;function t(n,d){let l;return typeof n=="string"?l=new h.$ad(void 0,n,void 0):l=new h.$ad(n,void 0,void 0),new o(l,d,r.$6c)}class o extends s{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$9d=o}),function(){function $e(C){const R=[];typeof C=="number"&&R.push("code/timeOrigin",C);function L(b){R.push(b,Date.now())}function T(){const b=[];for(let c=0;c<R.length;c+=2)b.push({name:R[c],startTime:R[c+1]});return b}return{mark:L,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(C+L.startTime)});return R}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function r(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(ke[10],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=o,e.$E=D,e.$K=y,e.$h="en";let r=!1,h=!1,C=!1,R=!1,L=!1,T=!1,b=!1,c=!1,I=!1,S=!1,u,P=e.$h,w=e.$h,a,m;const $=globalThis;let f;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?f=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const i=typeof f?.versions?.electron=="string",s=i&&f?.type==="renderer";if(typeof f=="object"){r=f.platform==="win32",h=f.platform==="darwin",C=f.platform==="linux",R=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,b=i,I=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$h,P=e.$h;const k=f.env.VSCODE_NLS_CONFIG;if(k)try{const A=JSON.parse(k);u=A.userLocale,w=A.osLocale,P=A.resolvedLanguage||e.$h,a=A.languagePack?.translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!s?(m=navigator.userAgent,r=m.indexOf("Windows")>=0,h=m.indexOf("Macintosh")>=0,c=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=m.indexOf("Linux")>=0,S=m?.indexOf("Mobi")>=0,T=!0,P=globalThis._VSCODE_NLS_LANGUAGE||e.$h,u=navigator.language.toLowerCase(),w=u):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(k){switch(k){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let n=t.Web;h?n=t.Mac:r?n=t.Windows:C&&(n=t.Linux),e.$j=r,e.$k=h,e.$l=C,e.$m=R,e.$n=L,e.$o=b,e.$p=T,e.$q=T&&typeof $.importScripts=="function",e.$r=e.$q?$.origin:void 0,e.$s=c,e.$t=S,e.$u=I,e.$v=n,e.$w=m,e.$x=P;var d;(function(k){function A(){return e.$x}k.value=A;function p(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}k.isDefaultVariant=p;function v(){return e.$x==="en"}k.isDefault=v})(d||(e.Language=d={})),e.$y=u,e.$z=w,e.$A=a,e.$B=typeof $.postMessage=="function"&&!$.importScripts,e.$C=(()=>{if(e.$B){const k=[];$.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let v=0,F=k.length;v<F;v++){const N=k[v];if(N.id===p.data.vscodeScheduleAsyncWork){k.splice(v,1),N.callback();return}}});let A=0;return p=>{const v=++A;k.push({id:v,callback:p}),$.postMessage({vscodeScheduleAsyncWork:v},"*")}}return k=>setTimeout(k)})();var l;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=h||c?l.Macintosh:r?l.Windows:l.Linux;let g=!0,E=!1;function D(){if(!E){E=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,g=new Uint16Array(k.buffer)[0]===513}return g}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(k){return parseFloat(k)>=20}}),define(ke[183],Ie([1,0,39]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=void 0;const h=Symbol("unset");class C{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}get entries(){return this.a.children?.entries()||r.Iterable.empty()}insert(b,c,I){this.d(b,S=>S._value=c,I)}mutate(b,c){this.d(b,I=>I._value=c(I._value===h?void 0:I._value))}mutatePath(b,c){this.d(b,()=>{},I=>c(I))}delete(b){const c=this.c(b);if(!c)return;let I=c.length-1;const S=c[I].node._value;if(S!==h){for(this.b--,c[I].node._value=h;I>0;I--){const{node:u,part:P}=c[I];if(u.children?.size||u._value!==h)break;c[I-1].node.children.delete(P)}return S}}*deleteRecursive(b){const c=this.c(b);if(!c)return;const I=c[c.length-1].node;for(let S=c.length-1;S>0;S--){const u=c[S-1];if(u.node.children.delete(c[S].part),u.node.children.size>0||u.node._value!==h)break}for(const S of R(I))S._value!==h&&(this.b--,yield S._value)}find(b){let c=this.a;for(const I of b){const S=c.children?.get(I);if(!S)return;c=S}return c._value===h?void 0:c._value}hasKeyOrParent(b){let c=this.a;for(const I of b){const S=c.children?.get(I);if(!S)return!1;if(S._value!==h)return!0;c=S}return!1}hasKeyOrChildren(b){let c=this.a;for(const I of b){const S=c.children?.get(I);if(!S)return!1;c=S}return!0}hasKey(b){let c=this.a;for(const I of b){const S=c.children?.get(I);if(!S)return!1;c=S}return c._value!==h}c(b){const c=[{part:"",node:this.a}];let I=0;for(const S of b){const u=c[I].node.children?.get(S);if(!u)return;c.push({part:S,node:u}),I++}return c}d(b,c,I){let S=this.a;for(const w of b){if(S.children)if(S.children.has(w))S=S.children.get(w);else{const a=new L;S.children.set(w,a),S=a}else{const a=new L;S.children=new Map([[w,a]]),S=a}I?.(S)}const u=S._value===h?0:1;c(S);const P=S._value===h?0:1;this.b+=P-u}*values(){for(const{_value:b}of R(this.a))b!==h&&(yield b)}}e.$4I=C;function*R(T){const b=[T];for(;b.length>0;){const c=b.pop();if(yield c,c.children)for(const I of c.children.values())b.push(I)}}class L{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value(b){this._value=b===void 0?h:b}}}),define(ke[55],Ie([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const R=C.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$j?"win32":r.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$dc=h.platform,e.$ec=h.arch}),define(ke[16],Ie([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,r=qe(r);const h=65,C=97,R=90,L=122,T=46,b=47,c=92,I=58,S=63;class u extends Error{constructor(d,l,g){let E;typeof l=="string"&&l.indexOf("not ")===0?(E="must not be",l=l.replace(/^not /,"")):E="must be";const D=d.indexOf(".")!==-1?"property":"argument";let y=`The "${d}" ${D} ${E} of type ${l}`;y+=`. Received type ${typeof g}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function P(n,d){if(n===null||typeof n!="object")throw new u(d,"Object",n)}function w(n,d){if(typeof n!="string")throw new u(d,"string",n)}const a=r.$dc==="win32";function m(n){return n===b||n===c}function $(n){return n===b}function f(n){return n>=h&&n<=R||n>=C&&n<=L}function i(n,d,l,g){let E="",D=0,y=-1,k=0,A=0;for(let p=0;p<=n.length;++p){if(p<n.length)A=n.charCodeAt(p);else{if(g(A))break;A=b}if(g(A)){if(!(y===p-1||k===1))if(k===2){if(E.length<2||D!==2||E.charCodeAt(E.length-1)!==T||E.charCodeAt(E.length-2)!==T){if(E.length>2){const v=E.lastIndexOf(l);v===-1?(E="",D=0):(E=E.slice(0,v),D=E.length-1-E.lastIndexOf(l)),y=p,k=0;continue}else if(E.length!==0){E="",D=0,y=p,k=0;continue}}d&&(E+=E.length>0?`${l}..`:"..",D=2)}else E.length>0?E+=`${l}${n.slice(y+1,p)}`:E=n.slice(y+1,p),D=p-y-1;y=p,k=0}else A===T&&k!==-1?++k:k=-1}return E}function s(n){return n?`${n[0]==="."?"":"."}${n}`:""}function t(n,d){P(d,"pathObject");const l=d.dir||d.root,g=d.base||`${d.name||""}${s(d.ext)}`;return l?l===d.root?`${l}${g}`:`${l}${n}${g}`:g}e.$fc={resolve(...n){let d="",l="",g=!1;for(let E=n.length-1;E>=-1;E--){let D;if(E>=0){if(D=n[E],w(D,`paths[${E}]`),D.length===0)continue}else d.length===0?D=r.cwd():(D=r.env[`=${d}`]||r.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==d.toLowerCase()&&D.charCodeAt(2)===c)&&(D=`${d}\\`));const y=D.length;let k=0,A="",p=!1;const v=D.charCodeAt(0);if(y===1)m(v)&&(k=1,p=!0);else if(m(v))if(p=!0,m(D.charCodeAt(1))){let F=2,N=F;for(;F<y&&!m(D.charCodeAt(F));)F++;if(F<y&&F!==N){const O=D.slice(N,F);for(N=F;F<y&&m(D.charCodeAt(F));)F++;if(F<y&&F!==N){for(N=F;F<y&&!m(D.charCodeAt(F));)F++;(F===y||F!==N)&&(A=`\\\\${O}\\${D.slice(N,F)}`,k=F)}}}else k=1;else f(v)&&D.charCodeAt(1)===I&&(A=D.slice(0,2),k=2,y>2&&m(D.charCodeAt(2))&&(p=!0,k=3));if(A.length>0)if(d.length>0){if(A.toLowerCase()!==d.toLowerCase())continue}else d=A;if(g){if(d.length>0)break}else if(l=`${D.slice(k)}\\${l}`,g=p,p&&d.length>0)break}return l=i(l,!g,"\\",m),g?`${d}\\${l}`:`${d}${l}`||"."},normalize(n){w(n,"path");const d=n.length;if(d===0)return".";let l=0,g,E=!1;const D=n.charCodeAt(0);if(d===1)return $(D)?"\\":n;if(m(D))if(E=!0,m(n.charCodeAt(1))){let k=2,A=k;for(;k<d&&!m(n.charCodeAt(k));)k++;if(k<d&&k!==A){const p=n.slice(A,k);for(A=k;k<d&&m(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&!m(n.charCodeAt(k));)k++;if(k===d)return`\\\\${p}\\${n.slice(A)}\\`;k!==A&&(g=`\\\\${p}\\${n.slice(A,k)}`,l=k)}}}else l=1;else f(D)&&n.charCodeAt(1)===I&&(g=n.slice(0,2),l=2,d>2&&m(n.charCodeAt(2))&&(E=!0,l=3));let y=l<d?i(n.slice(l),!E,"\\",m):"";return y.length===0&&!E&&(y="."),y.length>0&&m(n.charCodeAt(d-1))&&(y+="\\"),g===void 0?E?`\\${y}`:y:E?`${g}\\${y}`:`${g}${y}`},isAbsolute(n){w(n,"path");const d=n.length;if(d===0)return!1;const l=n.charCodeAt(0);return m(l)||d>2&&f(l)&&n.charCodeAt(1)===I&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let d,l;for(let D=0;D<n.length;++D){const y=n[D];w(y,"path"),y.length>0&&(d===void 0?d=l=y:d+=`\\${y}`)}if(d===void 0)return".";let g=!0,E=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++E;const D=l.length;D>1&&m(l.charCodeAt(1))&&(++E,D>2&&(m(l.charCodeAt(2))?++E:g=!1))}if(g){for(;E<d.length&&m(d.charCodeAt(E));)E++;E>=2&&(d=`\\${d.slice(E)}`)}return e.$fc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d)return"";const l=e.$fc.resolve(n),g=e.$fc.resolve(d);if(l===g||(n=l.toLowerCase(),d=g.toLowerCase(),n===d))return"";let E=0;for(;E<n.length&&n.charCodeAt(E)===c;)E++;let D=n.length;for(;D-1>E&&n.charCodeAt(D-1)===c;)D--;const y=D-E;let k=0;for(;k<d.length&&d.charCodeAt(k)===c;)k++;let A=d.length;for(;A-1>k&&d.charCodeAt(A-1)===c;)A--;const p=A-k,v=y<p?y:p;let F=-1,N=0;for(;N<v;N++){const j=n.charCodeAt(E+N);if(j!==d.charCodeAt(k+N))break;j===c&&(F=N)}if(N!==v){if(F===-1)return g}else{if(p>v){if(d.charCodeAt(k+N)===c)return g.slice(k+N+1);if(N===2)return g.slice(k+N)}y>v&&(n.charCodeAt(E+N)===c?F=N:N===2&&(F=3)),F===-1&&(F=0)}let O="";for(N=E+F+1;N<=D;++N)(N===D||n.charCodeAt(N)===c)&&(O+=O.length===0?"..":"\\..");return k+=F,O.length>0?`${O}${g.slice(k,A)}`:(g.charCodeAt(k)===c&&++k,g.slice(k,A))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const d=e.$fc.resolve(n);if(d.length<=2)return n;if(d.charCodeAt(0)===c){if(d.charCodeAt(1)===c){const l=d.charCodeAt(2);if(l!==S&&l!==T)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(f(d.charCodeAt(0))&&d.charCodeAt(1)===I&&d.charCodeAt(2)===c)return`\\\\?\\${d}`;return n},dirname(n){w(n,"path");const d=n.length;if(d===0)return".";let l=-1,g=0;const E=n.charCodeAt(0);if(d===1)return m(E)?n:".";if(m(E)){if(l=g=1,m(n.charCodeAt(1))){let k=2,A=k;for(;k<d&&!m(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&m(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&!m(n.charCodeAt(k));)k++;if(k===d)return n;k!==A&&(l=g=k+1)}}}}else f(E)&&n.charCodeAt(1)===I&&(l=d>2&&m(n.charCodeAt(2))?3:2,g=l);let D=-1,y=!0;for(let k=d-1;k>=g;--k)if(m(n.charCodeAt(k))){if(!y){D=k;break}}else y=!1;if(D===-1){if(l===-1)return".";D=l}return n.slice(0,D)},basename(n,d){d!==void 0&&w(d,"suffix"),w(n,"path");let l=0,g=-1,E=!0,D;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(l=2),d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let y=d.length-1,k=-1;for(D=n.length-1;D>=l;--D){const A=n.charCodeAt(D);if(m(A)){if(!E){l=D+1;break}}else k===-1&&(E=!1,k=D+1),y>=0&&(A===d.charCodeAt(y)?--y===-1&&(g=D):(y=-1,g=k))}return l===g?g=k:g===-1&&(g=n.length),n.slice(l,g)}for(D=n.length-1;D>=l;--D)if(m(n.charCodeAt(D))){if(!E){l=D+1;break}}else g===-1&&(E=!1,g=D+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=0,l=-1,g=0,E=-1,D=!0,y=0;n.length>=2&&n.charCodeAt(1)===I&&f(n.charCodeAt(0))&&(d=g=2);for(let k=n.length-1;k>=d;--k){const A=n.charCodeAt(k);if(m(A)){if(!D){g=k+1;break}continue}E===-1&&(D=!1,E=k+1),A===T?l===-1?l=k:y!==1&&(y=1):l!==-1&&(y=-1)}return l===-1||E===-1||y===0||y===1&&l===E-1&&l===g+1?"":n.slice(l,E)},format:t.bind(null,"\\"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.length;let g=0,E=n.charCodeAt(0);if(l===1)return m(E)?(d.root=d.dir=n,d):(d.base=d.name=n,d);if(m(E)){if(g=1,m(n.charCodeAt(1))){let F=2,N=F;for(;F<l&&!m(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&m(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&!m(n.charCodeAt(F));)F++;F===l?g=F:F!==N&&(g=F+1)}}}}else if(f(E)&&n.charCodeAt(1)===I){if(l<=2)return d.root=d.dir=n,d;if(g=2,m(n.charCodeAt(2))){if(l===3)return d.root=d.dir=n,d;g=3}}g>0&&(d.root=n.slice(0,g));let D=-1,y=g,k=-1,A=!0,p=n.length-1,v=0;for(;p>=g;--p){if(E=n.charCodeAt(p),m(E)){if(!A){y=p+1;break}continue}k===-1&&(A=!1,k=p+1),E===T?D===-1?D=p:v!==1&&(v=1):D!==-1&&(v=-1)}return k!==-1&&(D===-1||v===0||v===1&&D===k-1&&D===y+1?d.base=d.name=n.slice(y,k):(d.name=n.slice(y,D),d.base=n.slice(y,k),d.ext=n.slice(D,k))),y>0&&y!==g?d.dir=n.slice(0,y-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(a){const n=/\\/g;return()=>{const d=r.cwd().replace(n,"/");return d.slice(d.indexOf("/"))}}return()=>r.cwd()})();e.$gc={resolve(...n){let d="",l=!1;for(let g=n.length-1;g>=-1&&!l;g--){const E=g>=0?n[g]:o();w(E,`paths[${g}]`),E.length!==0&&(d=`${E}/${d}`,l=E.charCodeAt(0)===b)}return d=i(d,!l,"/",$),l?`/${d}`:d.length>0?d:"."},normalize(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b,l=n.charCodeAt(n.length-1)===b;return n=i(n,!d,"/",$),n.length===0?d?"/":l?"./":".":(l&&(n+="/"),d?`/${n}`:n)},isAbsolute(n){return w(n,"path"),n.length>0&&n.charCodeAt(0)===b},join(...n){if(n.length===0)return".";let d;for(let l=0;l<n.length;++l){const g=n[l];w(g,"path"),g.length>0&&(d===void 0?d=g:d+=`/${g}`)}return d===void 0?".":e.$gc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d||(n=e.$gc.resolve(n),d=e.$gc.resolve(d),n===d))return"";const l=1,g=n.length,E=g-l,D=1,y=d.length-D,k=E<y?E:y;let A=-1,p=0;for(;p<k;p++){const F=n.charCodeAt(l+p);if(F!==d.charCodeAt(D+p))break;F===b&&(A=p)}if(p===k)if(y>k){if(d.charCodeAt(D+p)===b)return d.slice(D+p+1);if(p===0)return d.slice(D+p)}else E>k&&(n.charCodeAt(l+p)===b?A=p:p===0&&(A=0));let v="";for(p=l+A+1;p<=g;++p)(p===g||n.charCodeAt(p)===b)&&(v+=v.length===0?"..":"/..");return`${v}${d.slice(D+A)}`},toNamespacedPath(n){return n},dirname(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b;let l=-1,g=!0;for(let E=n.length-1;E>=1;--E)if(n.charCodeAt(E)===b){if(!g){l=E;break}}else g=!1;return l===-1?d?"/":".":d&&l===1?"//":n.slice(0,l)},basename(n,d){d!==void 0&&w(d,"ext"),w(n,"path");let l=0,g=-1,E=!0,D;if(d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let y=d.length-1,k=-1;for(D=n.length-1;D>=0;--D){const A=n.charCodeAt(D);if(A===b){if(!E){l=D+1;break}}else k===-1&&(E=!1,k=D+1),y>=0&&(A===d.charCodeAt(y)?--y===-1&&(g=D):(y=-1,g=k))}return l===g?g=k:g===-1&&(g=n.length),n.slice(l,g)}for(D=n.length-1;D>=0;--D)if(n.charCodeAt(D)===b){if(!E){l=D+1;break}}else g===-1&&(E=!1,g=D+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=-1,l=0,g=-1,E=!0,D=0;for(let y=n.length-1;y>=0;--y){const k=n.charCodeAt(y);if(k===b){if(!E){l=y+1;break}continue}g===-1&&(E=!1,g=y+1),k===T?d===-1?d=y:D!==1&&(D=1):d!==-1&&(D=-1)}return d===-1||g===-1||D===0||D===1&&d===g-1&&d===l+1?"":n.slice(d,g)},format:t.bind(null,"/"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.charCodeAt(0)===b;let g;l?(d.root="/",g=1):g=0;let E=-1,D=0,y=-1,k=!0,A=n.length-1,p=0;for(;A>=g;--A){const v=n.charCodeAt(A);if(v===b){if(!k){D=A+1;break}continue}y===-1&&(k=!1,y=A+1),v===T?E===-1?E=A:p!==1&&(p=1):E!==-1&&(p=-1)}if(y!==-1){const v=D===0&&l?1:D;E===-1||p===0||p===1&&E===y-1&&E===D+1?d.base=d.name=n.slice(v,y):(d.name=n.slice(v,E),d.base=n.slice(v,y),d.ext=n.slice(E,y))}return D>0?d.dir=n.slice(0,D-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=a?e.$fc.normalize:e.$gc.normalize,e.$ic=a?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=a?e.$fc.join:e.$gc.join,e.$kc=a?e.$fc.resolve:e.$gc.resolve,e.$lc=a?e.$fc.relative:e.$gc.relative,e.$mc=a?e.$fc.dirname:e.$gc.dirname,e.$nc=a?e.$fc.basename:e.$gc.basename,e.$oc=a?e.$fc.extname:e.$gc.extname,e.$pc=a?e.$fc.format:e.$gc.format,e.$qc=a?e.$fc.parse:e.$gc.parse,e.$rc=a?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=a?e.$fc.sep:e.$gc.sep,e.$tc=a?e.$fc.delimiter:e.$gc.delimiter}),define(ke[134],Ie([1,0,49,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=T,e.$Ar=b,e.$Br=c,e.$Cr=I,e.$Dr=S,e.$Er=u,e.$Fr=P,e.$Gr=w,e.$Hr=a,e.$Ir=m,e.$Jr=g,e.$Kr=E,e.$Lr=D;const C=new r.$T(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),R=new r.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new r.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(y,k,A=!1){const p=y||"",v=k||"",F=C.value.collator.compare(p,v);return C.value.collatorIsNumeric&&F===0&&p!==v?p<v?-1:1:F}function b(y,k){const A=R.value.collator;return y=y||"",k=k||"",s(A,y,k)}function c(y,k){const A=R.value.collator;return y=y||"",k=k||"",d(y,k)||s(A,y,k)}function I(y,k){const A=R.value.collator;return y=y||"",k=k||"",n(y,k)||s(A,y,k)}function S(y,k){return y=y||"",k=k||"",y===k?0:y<k?-1:1}function u(y,k){const[A,p]=f(y),[v,F]=f(k);let N=C.value.collator.compare(p,F);if(N===0){if(C.value.collatorIsNumeric&&p!==F)return p<F?-1:1;if(N=C.value.collator.compare(A,v),C.value.collatorIsNumeric&&N===0&&A!==v)return A<v?-1:1}return N}function P(y,k){y=y||"",k=k||"";const A=i(y),p=i(k),v=R.value.collator,F=L.value.collator;return s(F,A,p)||s(v,y,k)}function w(y,k){y=y||"",k=k||"";const A=i(y),p=i(k),v=R.value.collator,F=L.value.collator;return s(F,A,p)||d(y,k)||s(v,y,k)}function a(y,k){y=y||"",k=k||"";const A=i(y),p=i(k),v=R.value.collator,F=L.value.collator;return s(F,A,p)||n(y,k)||s(v,y,k)}function m(y,k){y=y||"",k=k||"";const A=i(y).toLowerCase(),p=i(k).toLowerCase();return A!==p?A<p?-1:1:y!==k?y<k?-1:1:0}const $=/^(.*?)(\.([^.]*))?$/;function f(y,k=!1){const A=y?$.exec(y):[];let p=[A&&A[1]||"",A&&A[3]||""];return k&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function i(y){const k=y?$.exec(y):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function s(y,k,A){const p=y.compare(k,A);return p!==0?p:k.length!==A.length?k.length<A.length?-1:1:0}function t(y){const k=y.charAt(0);return k.toLocaleUpperCase()!==k}function o(y){const k=y.charAt(0);return k.toLocaleLowerCase()!==k}function n(y,k){return t(y)&&o(k)?-1:o(y)&&t(k)?1:0}function d(y,k){return o(y)&&t(k)?-1:t(y)&&o(k)?1:0}function l(y,k,A=!1){return A||(y=y&&y.toLowerCase(),k=k&&k.toLowerCase()),y===k?0:y<k?-1:1}function g(y,k,A=!1){const p=y.split(h.sep),v=k.split(h.sep),F=p.length-1,N=v.length-1;let O,j;for(let z=0;;z++){if(O=F===z,j=N===z,O&&j)return T(p[z],v[z],A);if(O)return-1;if(j)return 1;const M=l(p[z],v[z],A);if(M!==0)return M}}function E(y,k,A){const p=y.toLowerCase(),v=k.toLowerCase(),F=D(y,k,A);if(F)return F;const N=p.endsWith(A),O=v.endsWith(A);if(N!==O)return N?-1:1;const j=T(p,v);return j!==0?j:p.localeCompare(v)}function D(y,k,A){const p=y.toLowerCase(),v=k.toLowerCase(),F=p.startsWith(A),N=v.startsWith(A);if(F!==N)return F?-1:1;if(F&&N){if(p.length<v.length)return-1;if(p.length>v.length)return 1}return 0}}),define(ke[103],Ie([1,0,16]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$$s=R,e.$_s=L,e.$at=T,e.$bt=c,e.$0s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(I){const S=(0,r.$oc)(I),u=h[S.toLowerCase()];return u!==void 0?u:L(I)}function L(I){const S=(0,r.$oc)(I);return C[S.toLowerCase()]}function T(I){for(const S in C)if(C[S]===I)return S}const b=/^(.+)\/(.+?)(;.+)?$/;function c(I,S){const u=b.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:S?void 0:I}}),define(ke[104],Ie([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=R,e.$lm=L;var h;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(h||(e.Source=h={}));var C;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function R(T,...b){const c=b.reduce((u,P)=>(u[P]=!0,u),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(u=>!c[u]).forEach(u=>{for(let P=0;P<I.length;P++)if(u.search(I[P])!==-1){delete T[u];break}})}function L(T){T&&(delete T.DEBUG,r.$l&&delete T.LD_PRELOAD)}}),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:$e)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function r(h){if(e[h])return e[h].exports;var C=e[h]={i:h,l:!1,exports:{}};return $e[h].call(C.exports,C,C.exports,r),C.l=!0,C.exports}return r.m=$e,r.c=e,r.d=function(h,C,R){r.o(h,C)||Object.defineProperty(h,C,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,C){if(1&C&&(h=r(h)),8&C||4&C&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&C&&typeof h!="string")for(var L in h)r.d(R,L,function(T){return h[T]}.bind(null,L));return R},r.n=function(h){var C=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(C,"a",C),C},r.o=function(h,C){return Object.prototype.hasOwnProperty.call(h,C)},r.p="",r(r.s=0)}([function($e,e,r){(function(h){var C;e=$e.exports=Se,C=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],b=e.src=[],c=0,I=c++;b[I]="0|[1-9]\\d*";var S=c++;b[S]="[0-9]+";var u=c++;b[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;b[P]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var w=c++;b[w]="("+b[S]+")\\.("+b[S]+")\\.("+b[S]+")";var a=c++;b[a]="(?:"+b[I]+"|"+b[u]+")";var m=c++;b[m]="(?:"+b[S]+"|"+b[u]+")";var $=c++;b[$]="(?:-("+b[a]+"(?:\\."+b[a]+")*))";var f=c++;b[f]="(?:-?("+b[m]+"(?:\\."+b[m]+")*))";var i=c++;b[i]="[0-9A-Za-z-]+";var s=c++;b[s]="(?:\\+("+b[i]+"(?:\\."+b[i]+")*))";var t=c++,o="v?"+b[P]+b[$]+"?"+b[s]+"?";b[t]="^"+o+"$";var n="[v=\\s]*"+b[w]+b[f]+"?"+b[s]+"?",d=c++;b[d]="^"+n+"$";var l=c++;b[l]="((?:<|>)?=?)";var g=c++;b[g]=b[S]+"|x|X|\\*";var E=c++;b[E]=b[I]+"|x|X|\\*";var D=c++;b[D]="[v=\\s]*("+b[E]+")(?:\\.("+b[E]+")(?:\\.("+b[E]+")(?:"+b[$]+")?"+b[s]+"?)?)?";var y=c++;b[y]="[v=\\s]*("+b[g]+")(?:\\.("+b[g]+")(?:\\.("+b[g]+")(?:"+b[f]+")?"+b[s]+"?)?)?";var k=c++;b[k]="^"+b[l]+"\\s*"+b[D]+"$";var A=c++;b[A]="^"+b[l]+"\\s*"+b[y]+"$";var p=c++;b[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=c++;b[v]="(?:~>?)";var F=c++;b[F]="(\\s*)"+b[v]+"\\s+",T[F]=new RegExp(b[F],"g");var N=c++;b[N]="^"+b[v]+b[D]+"$";var O=c++;b[O]="^"+b[v]+b[y]+"$";var j=c++;b[j]="(?:\\^)";var z=c++;b[z]="(\\s*)"+b[j]+"\\s+",T[z]=new RegExp(b[z],"g");var M=c++;b[M]="^"+b[j]+b[D]+"$";var U=c++;b[U]="^"+b[j]+b[y]+"$";var V=c++;b[V]="^"+b[l]+"\\s*("+n+")$|^$";var ie=c++;b[ie]="^"+b[l]+"\\s*("+o+")$|^$";var B=c++;b[B]="(\\s*)"+b[l]+"\\s*("+n+"|"+b[D]+")",T[B]=new RegExp(b[B],"g");var Y=c++;b[Y]="^\\s*("+b[D]+")\\s+-\\s+("+b[D]+")\\s*$";var J=c++;b[J]="^\\s*("+b[y]+")\\s+-\\s+("+b[y]+")\\s*$";var _=c++;b[_]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)C(le,b[le]),T[le]||(T[le]=new RegExp(b[le]));function re(H,X){if(H instanceof Se)return H;if(typeof H!="string"||H.length>R||!(X?T[d]:T[t]).test(H))return null;try{return new Se(H,X)}catch{return null}}function Se(H,X){if(H instanceof Se){if(H.loose===X)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Se))return new Se(H,X);C("SemVer",H,X),this.loose=X;var Z=H.trim().match(X?T[d]:T[t]);if(!Z)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var ve=+de;if(ve>=0&&ve<L)return ve}return de}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=re,e.valid=function(H,X){var Z=re(H,X);return Z?Z.version:null},e.clean=function(H,X){var Z=re(H.trim().replace(/^[=v]+/,""),X);return Z?Z.version:null},e.SemVer=Se,Se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Se.prototype.toString=function(){return this.version},Se.prototype.compare=function(H){return C("SemVer.compare",this.version,this.loose,H),H instanceof Se||(H=new Se(H,this.loose)),this.compareMain(H)||this.comparePre(H)},Se.prototype.compareMain=function(H){return H instanceof Se||(H=new Se(H,this.loose)),Q(this.major,H.major)||Q(this.minor,H.minor)||Q(this.patch,H.patch)},Se.prototype.comparePre=function(H){if(H instanceof Se||(H=new Se(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var X=0;do{var Z=this.prerelease[X],de=H.prerelease[X];if(C("prerelease compare",X,Z,de),Z===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(Z===void 0)return-1;if(Z!==de)return Q(Z,de)}while(++X)},Se.prototype.inc=function(H,X){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,X,Z,de){typeof Z=="string"&&(de=Z,Z=void 0);try{return new Se(H,Z).inc(X,de).version}catch{return null}},e.diff=function(H,X){if(ee(H,X))return null;var Z=re(H),de=re(X);if(Z.prerelease.length||de.prerelease.length){for(var ve in Z)if((ve==="major"||ve==="minor"||ve==="patch")&&Z[ve]!==de[ve])return"pre"+ve;return"prerelease"}for(var ve in Z)if((ve==="major"||ve==="minor"||ve==="patch")&&Z[ve]!==de[ve])return ve},e.compareIdentifiers=Q;var me=/^[0-9]+$/;function Q(H,X){var Z=me.test(H),de=me.test(X);return Z&&de&&(H=+H,X=+X),Z&&!de?-1:de&&!Z?1:H<X?-1:H>X?1:0}function q(H,X,Z){return new Se(H,Z).compare(new Se(X,Z))}function se(H,X,Z){return q(H,X,Z)>0}function we(H,X,Z){return q(H,X,Z)<0}function ee(H,X,Z){return q(H,X,Z)===0}function ae(H,X,Z){return q(H,X,Z)!==0}function oe(H,X,Z){return q(H,X,Z)>=0}function x(H,X,Z){return q(H,X,Z)<=0}function ne(H,X,Z,de){var ve;switch(X){case"===":typeof H=="object"&&(H=H.version),typeof Z=="object"&&(Z=Z.version),ve=H===Z;break;case"!==":typeof H=="object"&&(H=H.version),typeof Z=="object"&&(Z=Z.version),ve=H!==Z;break;case"":case"=":case"==":ve=ee(H,Z,de);break;case"!=":ve=ae(H,Z,de);break;case">":ve=se(H,Z,de);break;case">=":ve=oe(H,Z,de);break;case"<":ve=we(H,Z,de);break;case"<=":ve=x(H,Z,de);break;default:throw new TypeError("Invalid operator: "+X)}return ve}function pe(H,X){if(H instanceof pe){if(H.loose===X)return H;H=H.value}if(!(this instanceof pe))return new pe(H,X);C("comparator",H,X),this.loose=X,this.parse(H),this.semver===be?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(H,X){return Q(X,H)},e.major=function(H,X){return new Se(H,X).major},e.minor=function(H,X){return new Se(H,X).minor},e.patch=function(H,X){return new Se(H,X).patch},e.compare=q,e.compareLoose=function(H,X){return q(H,X,!0)},e.rcompare=function(H,X,Z){return q(X,H,Z)},e.sort=function(H,X){return H.sort(function(Z,de){return e.compare(Z,de,X)})},e.rsort=function(H,X){return H.sort(function(Z,de){return e.rcompare(Z,de,X)})},e.gt=se,e.lt=we,e.eq=ee,e.neq=ae,e.gte=oe,e.lte=x,e.cmp=ne,e.Comparator=pe;var be={};function Fe(H,X){if(H instanceof Fe)return H.loose===X?H:new Fe(H.raw,X);if(H instanceof pe)return new Fe(H.value,X);if(!(this instanceof Fe))return new Fe(H,X);if(this.loose=X,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function ze(H){return!H||H.toLowerCase()==="x"||H==="*"}function Ae(H,X,Z,de,ve,Oe,He,Ke,_e,nt,st,rt,at){return((X=ze(Z)?"":ze(de)?">="+Z+".0.0":ze(ve)?">="+Z+"."+de+".0":">="+X)+" "+(Ke=ze(_e)?"":ze(nt)?"<"+(+_e+1)+".0.0":ze(st)?"<"+_e+"."+(+nt+1)+".0":rt?"<="+_e+"."+nt+"."+st+"-"+rt:"<="+Ke)).trim()}function De(H,X){for(var Z=0;Z<H.length;Z++)if(!H[Z].test(X))return!1;if(X.prerelease.length){for(Z=0;Z<H.length;Z++)if(C(H[Z].semver),H[Z].semver!==be&&H[Z].semver.prerelease.length>0){var de=H[Z].semver;if(de.major===X.major&&de.minor===X.minor&&de.patch===X.patch)return!0}return!1}return!0}function Ce(H,X,Z){try{X=new Fe(X,Z)}catch{return!1}return X.test(H)}function W(H,X,Z,de){var ve,Oe,He,Ke,_e;switch(H=new Se(H,de),X=new Fe(X,de),Z){case">":ve=se,Oe=x,He=we,Ke=">",_e=">=";break;case"<":ve=we,Oe=oe,He=se,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(H,X,de))return!1;for(var nt=0;nt<X.set.length;++nt){var st=X.set[nt],rt=null,at=null;if(st.forEach(function(gt){gt.semver===be&&(gt=new pe(">=0.0.0")),rt=rt||gt,at=at||gt,ve(gt.semver,rt.semver,de)?rt=gt:He(gt.semver,at.semver,de)&&(at=gt)}),rt.operator===Ke||rt.operator===_e||(!at.operator||at.operator===Ke)&&Oe(H,at.semver)||at.operator===_e&&He(H,at.semver))return!1}return!0}pe.prototype.parse=function(H){var X=this.loose?T[V]:T[ie],Z=H.match(X);if(!Z)throw new TypeError("Invalid comparator: "+H);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new Se(Z[2],this.loose):this.semver=be},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(H){return C("Comparator.test",H,this.loose),this.semver===be||(typeof H=="string"&&(H=new Se(H,this.loose)),ne(H,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(H,X){if(!(H instanceof pe))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Fe(H.value,X),Ce(this.value,Z,X);if(H.operator==="")return Z=new Fe(this.value,X),Ce(H.semver,Z,X);var de=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Oe=this.semver.version===H.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Ke=ne(this.semver,"<",H.semver,X)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),_e=ne(this.semver,">",H.semver,X)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return de||ve||Oe&&He||Ke||_e},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(H){var X=this.loose;H=H.trim(),C("range",H,X);var Z=X?T[J]:T[Y];H=H.replace(Z,Ae),C("hyphen replace",H),H=H.replace(T[B],"$1$2$3"),C("comparator trim",H,T[B]),H=(H=(H=H.replace(T[F],"$1~")).replace(T[z],"$1^")).split(/\s+/).join(" ");var de=X?T[V]:T[ie],ve=H.split(" ").map(function(Oe){return function(He,Ke){return C("comp",He),He=function(_e,nt){return _e.trim().split(/\s+/).map(function(st){return function(rt,at){C("caret",rt,at);var gt=at?T[U]:T[M];return rt.replace(gt,function(ht,ct,Pe,Be,Ye){var Ne;return C("caret",rt,ht,ct,Pe,Be,Ye),ze(ct)?Ne="":ze(Pe)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":ze(Be)?Ne=ct==="0"?">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+".0 <"+(+ct+1)+".0.0":Ye?(C("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),Ne=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+Be+Ye+" <"+ct+"."+Pe+"."+(+Be+1):">="+ct+"."+Pe+"."+Be+Ye+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+Be+Ye+" <"+(+ct+1)+".0.0"):(C("no pr"),Ne=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+Be+" <"+ct+"."+Pe+"."+(+Be+1):">="+ct+"."+Pe+"."+Be+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+Be+" <"+(+ct+1)+".0.0"),C("caret return",Ne),Ne})}(st,nt)}).join(" ")}(He,Ke),C("caret",He),He=function(_e,nt){return _e.trim().split(/\s+/).map(function(st){return function(rt,at){var gt=at?T[O]:T[N];return rt.replace(gt,function(ht,ct,Pe,Be,Ye){var Ne;return C("tilde",rt,ht,ct,Pe,Be,Ye),ze(ct)?Ne="":ze(Pe)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":ze(Be)?Ne=">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":Ye?(C("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),Ne=">="+ct+"."+Pe+"."+Be+Ye+" <"+ct+"."+(+Pe+1)+".0"):Ne=">="+ct+"."+Pe+"."+Be+" <"+ct+"."+(+Pe+1)+".0",C("tilde return",Ne),Ne})}(st,nt)}).join(" ")}(He,Ke),C("tildes",He),He=function(_e,nt){return C("replaceXRanges",_e,nt),_e.split(/\s+/).map(function(st){return function(rt,at){rt=rt.trim();var gt=at?T[A]:T[k];return rt.replace(gt,function(ht,ct,Pe,Be,Ye,Ne){C("xRange",rt,ht,ct,Pe,Be,Ye,Ne);var je=ze(Pe),ue=je||ze(Be),he=ue||ze(Ye);return ct==="="&&he&&(ct=""),je?ht=ct===">"||ct==="<"?"<0.0.0":"*":ct&&he?(ue&&(Be=0),he&&(Ye=0),ct===">"?(ct=">=",ue?(Pe=+Pe+1,Be=0,Ye=0):he&&(Be=+Be+1,Ye=0)):ct==="<="&&(ct="<",ue?Pe=+Pe+1:Be=+Be+1),ht=ct+Pe+"."+Be+"."+Ye):ue?ht=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":he&&(ht=">="+Pe+"."+Be+".0 <"+Pe+"."+(+Be+1)+".0"),C("xRange return",ht),ht})}(st,nt)}).join(" ")}(He,Ke),C("xrange",He),He=function(_e,nt){return C("replaceStars",_e,nt),_e.trim().replace(T[_],"")}(He,Ke),C("stars",He),He}(Oe,X)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Oe){return!!Oe.match(de)})),ve=ve.map(function(Oe){return new pe(Oe,X)})},Fe.prototype.intersects=function(H,X){if(!(H instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(de){return H.set.some(function(ve){return ve.every(function(Oe){return de.intersects(Oe,X)})})})})},e.toComparators=function(H,X){return new Fe(H,X).set.map(function(Z){return Z.map(function(de){return de.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new Se(H,this.loose));for(var X=0;X<this.set.length;X++)if(De(this.set[X],H))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(H,X,Z){var de=null,ve=null;try{var Oe=new Fe(X,Z)}catch{return null}return H.forEach(function(He){Oe.test(He)&&(de&&ve.compare(He)!==-1||(ve=new Se(de=He,Z)))}),de},e.minSatisfying=function(H,X,Z){var de=null,ve=null;try{var Oe=new Fe(X,Z)}catch{return null}return H.forEach(function(He){Oe.test(He)&&(de&&ve.compare(He)!==1||(ve=new Se(de=He,Z)))}),de},e.validRange=function(H,X){try{return new Fe(H,X).range||"*"}catch{return null}},e.ltr=function(H,X,Z){return W(H,X,"<",Z)},e.gtr=function(H,X,Z){return W(H,X,">",Z)},e.outside=W,e.prerelease=function(H,X){var Z=re(H,X);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(H,X,Z){return H=new Fe(H,Z),X=new Fe(X,Z),H.intersects(X)},e.coerce=function(H){if(H instanceof Se)return H;if(typeof H!="string")return null;var X=H.match(T[p]);return X==null?null:re((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,r(1))},function($e,e){var r,h,C=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function T(m){if(r===setTimeout)return setTimeout(m,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(m,0);try{return r(m,0)}catch{try{return r.call(null,m,0)}catch{return r.call(this,m,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:L}catch{h=L}})();var b,c=[],I=!1,S=-1;function u(){I&&b&&(I=!1,b.length?c=b.concat(c):S=-1,c.length&&P())}function P(){if(!I){var m=T(u);I=!0;for(var $=c.length;$;){for(b=c,c=[];++S<$;)b&&b[S].run();S=-1,$=c.length}b=null,I=!1,function(f){if(h===clearTimeout)return clearTimeout(f);if((h===L||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(f);try{h(f)}catch{try{return h.call(null,f)}catch{return h.call(this,f)}}}(m)}}function w(m,$){this.fun=m,this.array=$}function a(){}C.nextTick=function(m){var $=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)$[f-1]=arguments[f];c.push(new w(m,$)),c.length!==1||I||T(P)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=a,C.addListener=a,C.once=a,C.off=a,C.removeListener=a,C.removeAllListeners=a,C.emit=a,C.prependListener=a,C.prependOnceListener=a,C.listeners=function(m){return[]},C.binding=function(m){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(m){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ke[42],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=h}),define(ke[4],Ie([1,0,13,79,3,80,42]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=P;const T=!1,b=!1,c=!1;var I;(function(O){O.None=()=>C.$Uc.None;function j(De){if(c){const{onDidAddListener:Ce}=De,W=a.create();let H=0;De.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),W.print()),Ce?.()}}}function z(De,Ce){return re(De,()=>{},0,void 0,!0,void 0,Ce)}O.defer=z;function M(De){return(Ce,W=null,H)=>{let X=!1,Z;return Z=De(de=>{if(!X)return Z?Z.dispose():X=!0,Ce.call(W,de)},null,H),X&&Z.dispose(),Z}}O.once=M;function U(De,Ce,W){return _((H,X=null,Z)=>De(de=>H.call(X,Ce(de)),null,Z),W)}O.map=U;function V(De,Ce,W){return _((H,X=null,Z)=>De(de=>{Ce(de),H.call(X,de)},null,Z),W)}O.forEach=V;function ie(De,Ce,W){return _((H,X=null,Z)=>De(de=>Ce(de)&&H.call(X,de),null,Z),W)}O.filter=ie;function B(De){return De}O.signal=B;function Y(...De){return(Ce,W=null,H)=>{const X=(0,C.$Rc)(...De.map(Z=>Z(de=>Ce.call(W,de))));return le(X,H)}}O.any=Y;function J(De,Ce,W,H){let X=W;return U(De,Z=>(X=Ce(X,Z),X),H)}O.reduce=J;function _(De,Ce){let W;const H={onWillAddFirstListener(){W=De(X.fire,X)},onDidRemoveLastListener(){W?.dispose()}};Ce||j(H);const X=new n(H);return Ce?.add(X),X.event}function le(De,Ce){return Ce instanceof Array?Ce.push(De):Ce&&Ce.add(De),De}function re(De,Ce,W=100,H=!1,X=!1,Z,de){let ve,Oe,He,Ke=0,_e;const nt={leakWarningThreshold:Z,onWillAddFirstListener(){ve=De(rt=>{Ke++,Oe=Ce(Oe,rt),H&&!He&&(st.fire(Oe),Oe=void 0),_e=()=>{const at=Oe;Oe=void 0,He=void 0,(!H||Ke>1)&&st.fire(at),Ke=0},typeof W=="number"?(clearTimeout(He),He=setTimeout(_e,W)):He===void 0&&(He=0,queueMicrotask(_e))})},onWillRemoveListener(){X&&Ke>0&&_e?.()},onDidRemoveLastListener(){_e=void 0,ve.dispose()}};de||j(nt);const st=new n(nt);return de?.add(st),st.event}O.debounce=re;function Se(De,Ce=0,W){return O.debounce(De,(H,X)=>H?(H.push(X),H):[X],Ce,void 0,!0,void 0,W)}O.accumulate=Se;function me(De,Ce=(H,X)=>H===X,W){let H=!0,X;return ie(De,Z=>{const de=H||!Ce(Z,X);return H=!1,X=Z,de},W)}O.latch=me;function Q(De,Ce,W){return[O.filter(De,Ce,W),O.filter(De,H=>!Ce(H),W)]}O.split=Q;function q(De,Ce=!1,W=[],H){let X=W.slice(),Z=De(Oe=>{X?X.push(Oe):ve.fire(Oe)});H&&H.add(Z);const de=()=>{X?.forEach(Oe=>ve.fire(Oe)),X=null},ve=new n({onWillAddFirstListener(){Z||(Z=De(Oe=>ve.fire(Oe)),H&&H.add(Z))},onDidAddFirstListener(){X&&(Ce?setTimeout(de):de())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return H&&H.add(ve),ve.event}O.buffer=q;function se(De,Ce){return(H,X,Z)=>{const de=Ce(new ee);return De(function(ve){const Oe=de.evaluate(ve);Oe!==we&&H.call(X,Oe)},void 0,Z)}}O.chain=se;const we=Symbol("HaltChainable");class ee{constructor(){this.f=[]}map(Ce){return this.f.push(Ce),this}forEach(Ce){return this.f.push(W=>(Ce(W),W)),this}filter(Ce){return this.f.push(W=>Ce(W)?W:we),this}reduce(Ce,W){let H=W;return this.f.push(X=>(H=Ce(H,X),H)),this}latch(Ce=(W,H)=>W===H){let W=!0,H;return this.f.push(X=>{const Z=W||!Ce(X,H);return W=!1,H=X,Z?X:we}),this}evaluate(Ce){for(const W of this.f)if(Ce=W(Ce),Ce===we)break;return Ce}}function ae(De,Ce,W=H=>H){const H=(...ve)=>de.fire(W(...ve)),X=()=>De.on(Ce,H),Z=()=>De.removeListener(Ce,H),de=new n({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return de.event}O.fromNodeEventEmitter=ae;function oe(De,Ce,W=H=>H){const H=(...ve)=>de.fire(W(...ve)),X=()=>De.addEventListener(Ce,H),Z=()=>De.removeEventListener(Ce,H),de=new n({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return de.event}O.fromDOMEventEmitter=oe;function x(De){return new Promise(Ce=>M(De)(Ce))}O.toPromise=x;function ne(De){const Ce=new n;return De.then(W=>{Ce.fire(W)},()=>{Ce.fire(void 0)}).finally(()=>{Ce.dispose()}),Ce.event}O.fromPromise=ne;function pe(De,Ce){return De(W=>Ce.fire(W))}O.forward=pe;function be(De,Ce,W){return Ce(W),De(H=>Ce(H))}O.runAndSubscribe=be;class Fe{constructor(Ce,W){this._observable=Ce,this.f=0,this.g=!1;const H={onWillAddFirstListener:()=>{Ce.addObserver(this)},onDidRemoveLastListener:()=>{Ce.removeObserver(this)}};W||j(H),this.emitter=new n(H),W&&W.add(this.emitter)}beginUpdate(Ce){this.f++}handlePossibleChange(Ce){}handleChange(Ce,W){this.g=!0}endUpdate(Ce){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ze(De,Ce){return new Fe(De,Ce).emitter.event}O.fromObservable=ze;function Ae(De){return(Ce,W,H)=>{let X=0,Z=!1;const de={beginUpdate(){X++},endUpdate(){X--,X===0&&(De.reportChanges(),Z&&(Z=!1,Ce.call(W)))},handlePossibleChange(){},handleChange(){Z=!0}};De.addObserver(de),De.reportChanges();const ve={dispose(){De.removeObserver(de)}};return H instanceof C.$Tc?H.add(ve):Array.isArray(H)&&H.push(ve),ve}}O.fromObservableLight=Ae})(I||(e.Event=I={}));class S{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${S.f++}`,S.all.add(this)}start(j){this.g=new L.$fe,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$he=S;let u=-1;function P(O){const j=u;return u=O,{dispose(){u=j}}}class w{static{this.f=1}constructor(j,z,M=(w.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=z,this.name=M,this.h=0}dispose(){this.g?.clear()}check(j,z){const M=this.threshold;if(M<=0||z<M)return;this.g||(this.g=new Map);const U=this.g.get(j.value)||0;if(this.g.set(j.value,U+1),this.h-=1,this.h<=0){this.h=M*.5;const[V,ie]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${ie}):`;console.warn(B),console.warn(V);const Y=new m(B,V);this.j(Y)}return()=>{const V=this.g.get(j.value)||0;this.g.set(j.value,V-1)}}getMostFrequentStack(){if(!this.g)return;let j,z=0;for(const[M,U]of this.g)(!j||z<U)&&(j=[M,U],z=U);return j}}class a{static create(){const j=new Error;return new a(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(j,z){super(j),this.name="ListenerLeakError",this.stack=z}}e.$je=m;class $ extends Error{constructor(j,z){super(j),this.name="ListenerRefusalError",this.stack=z}}e.$ke=$;let f=0;class i{constructor(j){this.value=j,this.id=f++}}const s=2,t=(O,j)=>{if(O instanceof i)j(O);else for(let z=0;z<O.length;z++){const M=O[z];M&&j(M)}};let o;if(T){const O=[];setInterval(()=>{O.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(O.join(`
`)),O.length=0)},3e3),o=new FinalizationRegistry(j=>{typeof j=="string"&&O.push(j)})}class n{constructor(j){this.z=0,this.f=j,this.g=u>0||this.f?.leakWarningThreshold?new w(j?.onListenerError??r.$Y,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new S(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const j=this.u;queueMicrotask(()=>{t(j,z=>z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,z,M)=>{if(this.g&&this.z>this.g.threshold**2){const Y=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(Y);const J=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],_=new $(`${Y}. HINT: Stack shows most frequent listener (${J[1]}-times)`,J[0]);return(this.f?.onListenerError||r.$Y)(_),C.$Uc.None}if(this.m)return C.$Uc.None;z&&(j=j.bind(z));const U=new i(j);let V,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(U.stack=a.create(),V=this.g.check(U.stack,this.z+1)),b&&(U.stack=ie??a.create()),this.u?this.u instanceof i?(this.w??=new l,this.u=[this.u,U]):this.u.push(U):(this.f?.onWillAddFirstListener?.(this),this.u=U,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,C.$Sc)(()=>{o?.unregister(B),V?.(),this.A(U)});if(M instanceof C.$Tc?M.add(B):Array.isArray(M)&&M.push(B),o){const Y=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),J=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(Y);o.register(B,J?.[2]??Y,B)}return B},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const z=this.u,M=z.indexOf(j);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,z[M]=void 0;const U=this.w.current===this;if(this.z*s<=z.length){let V=0;for(let ie=0;ie<z.length;ie++)z[ie]?z[V++]=z[ie]:U&&(this.w.end--,V<this.w.i&&this.w.i--);z.length=V}}B(j,z){if(!j)return;const M=this.f?.onListenerError||r.$Y;if(!M){j.value(z);return}try{j.value(z)}catch(U){M(U)}}C(j){const z=j.current.u;for(;j.i<j.end;)this.B(z[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof i)this.B(this.u,j);else{const z=this.w;z.enqueue(this,j,this.u.length),this.C(z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=n;const d=()=>new l;e.$me=d;class l{constructor(){this.i=-1,this.end=0}enqueue(j,z,M){this.i=0,this.end=M,this.current=j,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class g extends n{async fireAsync(j,z,M){if(this.u)for(this.h||(this.h=new R.$5c),t(this.u,U=>this.h.push([U.value,j]));this.h.size>0&&!z.isCancellationRequested;){const[U,V]=this.h.shift(),ie=[],B={...V,token:z,waitUntil:Y=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");M&&(Y=M(Y,U)),ie.push(Y)}};try{U(B)}catch(Y){(0,r.$Y)(Y);continue}Object.freeze(ie),await Promise.allSettled(ie).then(Y=>{for(const J of Y)J.status==="rejected"&&(0,r.$Y)(J.reason)})}}}e.$ne=g;class E extends n{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$5c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$oe=E;class D extends E{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$pe=D;class y extends n{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$qe=y;class k{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const z={event:j,listener:null};this.h.push(z),this.g&&this.m(z);const M=()=>{this.g&&this.o(z);const U=this.h.indexOf(z);this.h.splice(U,1)};return(0,C.$Sc)((0,h.$cb)(M))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(z=>this.f.fire(z))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$re=k;class A{constructor(j,z,M,U){this.f=new C.$Tc;const V=this.f.add(new k),ie=this.f.add(new C.$4c);function B(Y){ie.set(Y,V.add(U(Y)))}for(const Y of j)B(Y);this.f.add(z(Y=>{B(Y)})),this.f.add(M(Y=>{ie.deleteAndDispose(Y)})),this.event=V.event}dispose(){this.f.dispose()}}e.$se=A;class p{constructor(){this.f=[]}wrapEvent(j,z,M){return(U,V,ie)=>j(B=>{const Y=this.f[this.f.length-1];if(!z){Y?Y.buffers.push(()=>U.call(V,B)):U.call(V,B);return}const J=Y;if(!J){U.call(V,z(M,B));return}J.items??=[],J.items.push(B),J.buffers.length===0&&Y.buffers.push(()=>{J.reducedResult??=M?J.items.reduce(z,M):J.items.reduce(z),U.call(V,J.reducedResult)})},void 0,ie)}bufferEvents(j){const z={buffers:new Array};this.f.push(z);const M=j();return this.f.pop(),z.buffers.forEach(U=>U()),M}}e.$te=p;class v{constructor(){this.f=!1,this.g=I.None,this.h=C.$Uc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=v;class F{static const(j){return new N(j)}constructor(j){this.g=j,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$ve=F;class N{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(ke[20],Ie([1,0,4]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=T;const h=Object.freeze(function(b,c){const I=setTimeout(b.bind(c),0);return{dispose(){clearTimeout(I)}}});var C;(function(b){function c(I){return I===b.None||I===b.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}b.isCancellationToken=c,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(C||(e.CancellationToken=C={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=C.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=C.None}}e.$we=L;function T(b){const c=new L;return b.add({dispose(){c.cancel()}}),c.token}}),define(ke[184],Ie([1,0,20]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=C;class h{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new r.$we,c=this.b(b.token);return this.a={promise:c,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$9e=h;function C(T){return T}class R{constructor(b,c){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=C):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);return this.b!==c&&(this.b=c,this.a=this.c(b)),this.a}}e.$$e=R;class L{get cachedValues(){return this.a}constructor(b,c){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=C):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);if(this.b.has(c))return this.b.get(c);const I=this.c(b);return this.a.set(b,I),this.b.set(c,I),I}}e.$_e=L}),define(ke[185],Ie([1,0,4,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=e.$ct=e.ScrollbarVisibility=void 0;var C;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(C||(e.ScrollbarVisibility=C={}));class R{constructor(w,a,m,$,f,i,s){this.c=w,this._scrollStateBrand=void 0,this.c&&(a=a|0,m=m|0,$=$|0,f=f|0,i=i|0,s=s|0),this.rawScrollLeft=$,this.rawScrollTop=s,a<0&&(a=0),$+a>m&&($=m-a),$<0&&($=0),f<0&&(f=0),s+f>i&&(s=i-f),s<0&&(s=0),this.width=a,this.scrollWidth=m,this.scrollLeft=$,this.height=f,this.scrollHeight=i,this.scrollTop=s}equals(w){return this.rawScrollLeft===w.rawScrollLeft&&this.rawScrollTop===w.rawScrollTop&&this.width===w.width&&this.scrollWidth===w.scrollWidth&&this.scrollLeft===w.scrollLeft&&this.height===w.height&&this.scrollHeight===w.scrollHeight&&this.scrollTop===w.scrollTop}withScrollDimensions(w,a){return new R(this.c,typeof w.width<"u"?w.width:this.width,typeof w.scrollWidth<"u"?w.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof w.height<"u"?w.height:this.height,typeof w.scrollHeight<"u"?w.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(w){return new R(this.c,this.width,this.scrollWidth,typeof w.scrollLeft<"u"?w.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof w.scrollTop<"u"?w.scrollTop:this.rawScrollTop)}createScrollEvent(w,a){const m=this.width!==w.width,$=this.scrollWidth!==w.scrollWidth,f=this.scrollLeft!==w.scrollLeft,i=this.height!==w.height,s=this.scrollHeight!==w.scrollHeight,t=this.scrollTop!==w.scrollTop;return{inSmoothScrolling:a,oldWidth:w.width,oldScrollWidth:w.scrollWidth,oldScrollLeft:w.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:w.height,oldScrollHeight:w.scrollHeight,oldScrollTop:w.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:$,scrollLeftChanged:f,heightChanged:i,scrollHeightChanged:s,scrollTopChanged:t}}}e.$ct=R;class L extends h.$Uc{constructor(w){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$le),this.onScroll=this.j.event,this.c=w.smoothScrollDuration,this.f=w.scheduleAtNextAnimationFrame,this.g=new R(w.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(w){this.c=w}validateScrollPosition(w){return this.g.withScrollPosition(w)}getScrollDimensions(){return this.g}setScrollDimensions(w,a){const m=this.g.withScrollDimensions(w,a);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(w){const a=this.g.withScrollPosition(w);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(w,a){if(this.c===0)return this.setScrollPositionNow(w);if(this.h){w={scrollLeft:typeof w.scrollLeft>"u"?this.h.to.scrollLeft:w.scrollLeft,scrollTop:typeof w.scrollTop>"u"?this.h.to.scrollTop:w.scrollTop};const m=this.g.withScrollPosition(w);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let $;a?$=new I(this.h.from,m,this.h.startTime,this.h.duration):$=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=$}else{const m=this.g.withScrollPosition(w);this.h=I.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const w=this.h.tick(),a=this.g.withScrollPosition(w);if(this.n(a,!0),!!this.h){if(w.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(w,a){const m=this.g;m.equals(w)||(this.g=w,this.j.fire(this.g.createScrollEvent(m,a)))}}e.$dt=L;class T{constructor(w,a,m){this.scrollLeft=w,this.scrollTop=a,this.isDone=m}}e.$et=T;function b(P,w){const a=w-P;return function(m){return P+a*u(m)}}function c(P,w,a){return function(m){return m<a?P(m/a):w((m-a)/(1-a))}}class I{constructor(w,a,m,$){this.from=w,this.to=a,this.duration=$,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(w,a,m){if(Math.abs(w-a)>2.5*m){let f,i;return w<a?(f=w+.75*m,i=a-.75*m):(f=w-.75*m,i=a+.75*m),c(b(w,f),b(i,a),.33)}return b(w,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(w){this.to=w.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(w){const a=(w-this.startTime)/this.duration;if(a<1){const m=this.c(a),$=this.d(a);return new T(m,$,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(w,a,m){return I.start(w,a,m)}static start(w,a,m){m=m+10;const $=Date.now()-10;return new I(w,a,$,m)}}e.$ft=I;function S(P){return Math.pow(P,3)}function u(P){return 1-S(1-P)}}),define(ke[105],Ie([1,0,13,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=C,e.$ze=R,e.$Ae=L,e.$Be=T,e.$Ce=c,e.$De=I,e.$Ee=S,e.$Fe=u,e.$Ge=P,e.$He=w,e.$Ie=a,e.$Je=m,e.$Ke=$,e.$Le=f,e.$Me=i;function C(s){const t=s;return t?typeof t.read=="function":!1}function R(s){const t=s;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function L(s){const t=s;return t?R(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(s,t){return new b(s,t)}class b{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,r.$Y)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let n;switch(t){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const d=n.indexOf(o);d>=0&&n.splice(d,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,t){const o=[];let n;for(;(n=s.read())!==null;)o.push(n);return t(o)}function I(s,t,o){const n=[];let d;for(;(d=s.read())!==null&&n.length<o;)n.push(d);return d===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return s.read()}}}function S(s,t){return new Promise((o,n)=>{const d=[];u(s,{onData:l=>{t&&d.push(l)},onError:l=>{t?n(l):o(void 0)},onEnd:()=>{o(t?t(d):void 0)}})})}function u(s,t,o){s.on("error",n=>{o?.isCancellationRequested||t.onError(n)}),s.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),s.on("data",n=>{o?.isCancellationRequested||t.onData(n)})}function P(s,t){return new Promise((o,n)=>{const d=new h.$Tc,l=[],g=y=>{if(l.push(y),l.length>t)return d.dispose(),s.pause(),o({stream:s,buffer:l,ended:!1})},E=y=>(d.dispose(),n(y)),D=()=>(d.dispose(),o({stream:s,buffer:l,ended:!0}));d.add((0,h.$Sc)(()=>s.removeListener("error",E))),s.on("error",E),d.add((0,h.$Sc)(()=>s.removeListener("end",D))),s.on("end",D),d.add((0,h.$Sc)(()=>s.removeListener("data",g))),s.on("data",g)})}function w(s,t){const o=T(t);return o.end(s),o}function a(){const s=T(()=>{throw new Error("not supported")});return s.end(),s}function m(s){let t=!1;return{read:()=>t?null:(t=!0,s)}}function $(s,t,o){const n=T(o);return u(s,{onData:d=>n.write(t.data(d)),onError:d=>n.error(t.error?t.error(d):d),onEnd:()=>n.end()}),n}function f(s,t,o){let n=!1;return{read:()=>{const d=t.read();return n?d:(n=!0,d!==null?o([s,d]):s)}}}function i(s,t,o){let n=!1;const d=T(o);return u(t,{onData:l=>n?d.write(l):(n=!0,d.write(o([s,l]))),onError:l=>d.error(l),onEnd:()=>{n||(n=!0,d.write(s)),d.end()}}),d}}),define(ke[21],Ie([1,0,49,105]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=c,e.$Pe=I,e.$Qe=S,e.$Re=u,e.$Se=P,e.$Te=w,e.$Ue=a,e.$Ve=m,e.$We=$,e.$Xe=f,e.$Ye=i,e.$Ze=s,e.$1e=t,e.$2e=o,e.$3e=n,e.$4e=d,e.$5e=l,e.$6e=g,e.$7e=E,e.$8e=k,h=qe(h);const C=typeof Buffer<"u",R=new r.$T(()=>new Uint8Array(256));let L,T;class b{static alloc(p){return C?new b(Buffer.allocUnsafe(p)):new b(new Uint8Array(p))}static wrap(p){return C&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new b(p)}static fromString(p,v){return!(v?.dontUseNodeBuffer||!1)&&C?new b(Buffer.from(p)):(L||(L=new TextEncoder),new b(L.encode(p)))}static fromByteArray(p){const v=b.alloc(p.length);for(let F=0,N=p.length;F<N;F++)v.buffer[F]=p[F];return v}static concat(p,v){if(typeof v>"u"){v=0;for(let O=0,j=p.length;O<j;O++)v+=p[O].byteLength}const F=b.alloc(v);let N=0;for(let O=0,j=p.length;O<j;O++){const z=p[O];F.set(z,N),N+=z.byteLength}return F}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=b.alloc(this.byteLength);return p.set(this),p}toString(){return C?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(p,v){return new b(this.buffer.subarray(p,v))}set(p,v){if(p instanceof b)this.buffer.set(p.buffer,v);else if(p instanceof Uint8Array)this.buffer.set(p,v);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),v);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,v){P(this.buffer,p,v)}readUInt32LE(p){return w(this.buffer,p)}writeUInt32LE(p,v){a(this.buffer,p,v)}readUInt8(p){return m(this.buffer,p)}writeUInt8(p,v){$(this.buffer,p,v)}indexOf(p,v=0){return c(this.buffer,p instanceof b?p.buffer:p,v)}}e.$Ne=b;function c(A,p,v=0){const F=p.byteLength,N=A.byteLength;if(F===0)return 0;if(F===1)return A.indexOf(p[0]);if(F>N-v)return-1;const O=R.value;O.fill(p.length);for(let U=0;U<p.length;U++)O[p[U]]=p.length-U-1;let j=v+p.length-1,z=j,M=-1;for(;j<N;)if(A[j]===p[z]){if(z===0){M=j;break}j--,z--}else j+=Math.max(p.length-z,O[A[j]]),z=p.length-1;return M}function I(A,p){return A[p+0]<<0>>>0|A[p+1]<<8>>>0}function S(A,p,v){A[v+0]=p&255,p=p>>>8,A[v+1]=p&255}function u(A,p){return A[p]*2**24+A[p+1]*2**16+A[p+2]*2**8+A[p+3]}function P(A,p,v){A[v+3]=p,p=p>>>8,A[v+2]=p,p=p>>>8,A[v+1]=p,p=p>>>8,A[v]=p}function w(A,p){return A[p+0]<<0>>>0|A[p+1]<<8>>>0|A[p+2]<<16>>>0|A[p+3]<<24>>>0}function a(A,p,v){A[v+0]=p&255,p=p>>>8,A[v+1]=p&255,p=p>>>8,A[v+2]=p&255,p=p>>>8,A[v+3]=p&255}function m(A,p){return A[p]}function $(A,p,v){A[v]=p}function f(A){return h.$Ce(A,p=>b.concat(p))}function i(A){return h.$Je(A)}function s(A){return h.$Ee(A,p=>b.concat(p))}async function t(A){return A.ended?b.concat(A.buffer):b.concat([...A.buffer,await s(A.stream)])}function o(A){return h.$He(A,p=>b.concat(p))}function n(A){return h.$Ke(A,{data:p=>typeof p=="string"?b.fromString(p):b.wrap(p)},p=>b.concat(p))}function d(A){return h.$Be(p=>b.concat(p),A)}function l(A,p){return h.$Le(A,p,v=>b.concat(v))}function g(A,p){return h.$Me(A,p,v=>b.concat(v))}function E(A){let p=0,v=0,F=0;const N=new Uint8Array(Math.floor(A.length/4*3)),O=z=>{switch(v){case 3:N[F++]=p|z,v=0;break;case 2:N[F++]=p|z>>>2,p=z<<6,v=3;break;case 1:N[F++]=p|z>>>4,p=z<<4,v=2;break;default:p=z<<2,v=1}};for(let z=0;z<A.length;z++){const M=A.charCodeAt(z);if(M>=65&&M<=90)O(M-65);else if(M>=97&&M<=122)O(M-97+26);else if(M>=48&&M<=57)O(M-48+52);else if(M===43||M===45)O(62);else if(M===47||M===95)O(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${A[z]}`)}}const j=F;for(;v>0;)O(0);return b.wrap(N).slice(0,j)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:A},p=!0,v=!1){const F=v?y:D;let N="";const O=A.byteLength%3;let j=0;for(;j<A.byteLength-O;j+=3){const z=A[j+0],M=A[j+1],U=A[j+2];N+=F[z>>>2],N+=F[(z<<4|M>>>4)&63],N+=F[(M<<2|U>>>6)&63],N+=F[U&63]}if(O===1){const z=A[j+0];N+=F[z>>>2],N+=F[z<<4&63],p&&(N+="==")}else if(O===2){const z=A[j+0],M=A[j+1];N+=F[z>>>2],N+=F[(z<<4|M>>>4)&63],N+=F[M<<2&63],p&&(N+="=")}return N}}),define(ke[186],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(ke[17],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=r,e.$fg=h,e.$gg=C,e.$hg=R,e.$ig=L,e.$jg=T,e.$kg=b,e.$lg=c,e.$mg=I,e.$ng=S,e.$og=u,e.$pg=P,e.$qg=w,e.$rg=m,e.$sg=$,e.$tg=f,e.$ug=i,e.$vg=s;function r(t){return typeof t=="string"}function h(t){return Array.isArray(t)&&t.every(o=>r(o))}function C(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function R(t){const o=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof o}function L(t){return typeof t=="number"&&!isNaN(t)}function T(t){return!!t&&typeof t[Symbol.iterator]=="function"}function b(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function I(t){return!S(t)}function S(t){return c(t)||t===null}function u(t,o){if(!t)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}function P(t){if(S(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function w(...t){const o=[];for(let n=0;n<t.length;n++){const d=t[n];if(S(d))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);o.push(d)}return o}const a=Object.prototype.hasOwnProperty;function m(t){if(!C(t))return!1;for(const o in t)if(a.call(t,o))return!1;return!0}function $(t){return typeof t=="function"}function f(...t){return t.length>0&&t.every($)}function i(t,o){const n=Math.min(t.length,o.length);for(let d=0;d<n;d++)s(t[d],o[d])}function s(t,o){if(r(o)){if(typeof t!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if($(o)){try{if(t instanceof o)return}catch{}if(!S(t)&&t.constructor===o||o.length===1&&o.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[106],Ie([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=C,e.$Zj=R;const h=Object.create(null);function C(L,T){if((0,r.$eg)(T)){const b=h[T];if(b===void 0)throw new Error(`${L} references an unknown codicon: ${T}`);T=b}return h[L]=T,{id:L}}function R(){return h}}),define(ke[187],Ie([1,0,106]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=void 0,e.$1j={add:(0,r.$Yj)("add",6e4),plus:(0,r.$Yj)("plus",6e4),gistNew:(0,r.$Yj)("gist-new",6e4),repoCreate:(0,r.$Yj)("repo-create",6e4),lightbulb:(0,r.$Yj)("lightbulb",60001),lightBulb:(0,r.$Yj)("light-bulb",60001),repo:(0,r.$Yj)("repo",60002),repoDelete:(0,r.$Yj)("repo-delete",60002),gistFork:(0,r.$Yj)("gist-fork",60003),repoForked:(0,r.$Yj)("repo-forked",60003),gitPullRequest:(0,r.$Yj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Yj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Yj)("record-keys",60005),keyboard:(0,r.$Yj)("keyboard",60005),tag:(0,r.$Yj)("tag",60006),gitPullRequestLabel:(0,r.$Yj)("git-pull-request-label",60006),tagAdd:(0,r.$Yj)("tag-add",60006),tagRemove:(0,r.$Yj)("tag-remove",60006),person:(0,r.$Yj)("person",60007),personFollow:(0,r.$Yj)("person-follow",60007),personOutline:(0,r.$Yj)("person-outline",60007),personFilled:(0,r.$Yj)("person-filled",60007),gitBranch:(0,r.$Yj)("git-branch",60008),gitBranchCreate:(0,r.$Yj)("git-branch-create",60008),gitBranchDelete:(0,r.$Yj)("git-branch-delete",60008),sourceControl:(0,r.$Yj)("source-control",60008),mirror:(0,r.$Yj)("mirror",60009),mirrorPublic:(0,r.$Yj)("mirror-public",60009),star:(0,r.$Yj)("star",60010),starAdd:(0,r.$Yj)("star-add",60010),starDelete:(0,r.$Yj)("star-delete",60010),starEmpty:(0,r.$Yj)("star-empty",60010),comment:(0,r.$Yj)("comment",60011),commentAdd:(0,r.$Yj)("comment-add",60011),alert:(0,r.$Yj)("alert",60012),warning:(0,r.$Yj)("warning",60012),search:(0,r.$Yj)("search",60013),searchSave:(0,r.$Yj)("search-save",60013),logOut:(0,r.$Yj)("log-out",60014),signOut:(0,r.$Yj)("sign-out",60014),logIn:(0,r.$Yj)("log-in",60015),signIn:(0,r.$Yj)("sign-in",60015),eye:(0,r.$Yj)("eye",60016),eyeUnwatch:(0,r.$Yj)("eye-unwatch",60016),eyeWatch:(0,r.$Yj)("eye-watch",60016),circleFilled:(0,r.$Yj)("circle-filled",60017),primitiveDot:(0,r.$Yj)("primitive-dot",60017),closeDirty:(0,r.$Yj)("close-dirty",60017),debugBreakpoint:(0,r.$Yj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Yj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Yj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Yj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Yj)("primitive-square",60018),edit:(0,r.$Yj)("edit",60019),pencil:(0,r.$Yj)("pencil",60019),info:(0,r.$Yj)("info",60020),issueOpened:(0,r.$Yj)("issue-opened",60020),gistPrivate:(0,r.$Yj)("gist-private",60021),gitForkPrivate:(0,r.$Yj)("git-fork-private",60021),lock:(0,r.$Yj)("lock",60021),mirrorPrivate:(0,r.$Yj)("mirror-private",60021),close:(0,r.$Yj)("close",60022),removeClose:(0,r.$Yj)("remove-close",60022),x:(0,r.$Yj)("x",60022),repoSync:(0,r.$Yj)("repo-sync",60023),sync:(0,r.$Yj)("sync",60023),clone:(0,r.$Yj)("clone",60024),desktopDownload:(0,r.$Yj)("desktop-download",60024),beaker:(0,r.$Yj)("beaker",60025),microscope:(0,r.$Yj)("microscope",60025),vm:(0,r.$Yj)("vm",60026),deviceDesktop:(0,r.$Yj)("device-desktop",60026),file:(0,r.$Yj)("file",60027),fileText:(0,r.$Yj)("file-text",60027),more:(0,r.$Yj)("more",60028),ellipsis:(0,r.$Yj)("ellipsis",60028),kebabHorizontal:(0,r.$Yj)("kebab-horizontal",60028),mailReply:(0,r.$Yj)("mail-reply",60029),reply:(0,r.$Yj)("reply",60029),organization:(0,r.$Yj)("organization",60030),organizationFilled:(0,r.$Yj)("organization-filled",60030),organizationOutline:(0,r.$Yj)("organization-outline",60030),newFile:(0,r.$Yj)("new-file",60031),fileAdd:(0,r.$Yj)("file-add",60031),newFolder:(0,r.$Yj)("new-folder",60032),fileDirectoryCreate:(0,r.$Yj)("file-directory-create",60032),trash:(0,r.$Yj)("trash",60033),trashcan:(0,r.$Yj)("trashcan",60033),history:(0,r.$Yj)("history",60034),clock:(0,r.$Yj)("clock",60034),folder:(0,r.$Yj)("folder",60035),fileDirectory:(0,r.$Yj)("file-directory",60035),symbolFolder:(0,r.$Yj)("symbol-folder",60035),logoGithub:(0,r.$Yj)("logo-github",60036),markGithub:(0,r.$Yj)("mark-github",60036),github:(0,r.$Yj)("github",60036),terminal:(0,r.$Yj)("terminal",60037),console:(0,r.$Yj)("console",60037),repl:(0,r.$Yj)("repl",60037),zap:(0,r.$Yj)("zap",60038),symbolEvent:(0,r.$Yj)("symbol-event",60038),error:(0,r.$Yj)("error",60039),stop:(0,r.$Yj)("stop",60039),variable:(0,r.$Yj)("variable",60040),symbolVariable:(0,r.$Yj)("symbol-variable",60040),array:(0,r.$Yj)("array",60042),symbolArray:(0,r.$Yj)("symbol-array",60042),symbolModule:(0,r.$Yj)("symbol-module",60043),symbolPackage:(0,r.$Yj)("symbol-package",60043),symbolNamespace:(0,r.$Yj)("symbol-namespace",60043),symbolObject:(0,r.$Yj)("symbol-object",60043),symbolMethod:(0,r.$Yj)("symbol-method",60044),symbolFunction:(0,r.$Yj)("symbol-function",60044),symbolConstructor:(0,r.$Yj)("symbol-constructor",60044),symbolBoolean:(0,r.$Yj)("symbol-boolean",60047),symbolNull:(0,r.$Yj)("symbol-null",60047),symbolNumeric:(0,r.$Yj)("symbol-numeric",60048),symbolNumber:(0,r.$Yj)("symbol-number",60048),symbolStructure:(0,r.$Yj)("symbol-structure",60049),symbolStruct:(0,r.$Yj)("symbol-struct",60049),symbolParameter:(0,r.$Yj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Yj)("symbol-type-parameter",60050),symbolKey:(0,r.$Yj)("symbol-key",60051),symbolText:(0,r.$Yj)("symbol-text",60051),symbolReference:(0,r.$Yj)("symbol-reference",60052),goToFile:(0,r.$Yj)("go-to-file",60052),symbolEnum:(0,r.$Yj)("symbol-enum",60053),symbolValue:(0,r.$Yj)("symbol-value",60053),symbolRuler:(0,r.$Yj)("symbol-ruler",60054),symbolUnit:(0,r.$Yj)("symbol-unit",60054),activateBreakpoints:(0,r.$Yj)("activate-breakpoints",60055),archive:(0,r.$Yj)("archive",60056),arrowBoth:(0,r.$Yj)("arrow-both",60057),arrowDown:(0,r.$Yj)("arrow-down",60058),arrowLeft:(0,r.$Yj)("arrow-left",60059),arrowRight:(0,r.$Yj)("arrow-right",60060),arrowSmallDown:(0,r.$Yj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Yj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Yj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Yj)("arrow-small-up",60064),arrowUp:(0,r.$Yj)("arrow-up",60065),bell:(0,r.$Yj)("bell",60066),bold:(0,r.$Yj)("bold",60067),book:(0,r.$Yj)("book",60068),bookmark:(0,r.$Yj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Yj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Yj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Yj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Yj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Yj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Yj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Yj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Yj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Yj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Yj)("briefcase",60076),broadcast:(0,r.$Yj)("broadcast",60077),browser:(0,r.$Yj)("browser",60078),bug:(0,r.$Yj)("bug",60079),calendar:(0,r.$Yj)("calendar",60080),caseSensitive:(0,r.$Yj)("case-sensitive",60081),check:(0,r.$Yj)("check",60082),checklist:(0,r.$Yj)("checklist",60083),chevronDown:(0,r.$Yj)("chevron-down",60084),chevronLeft:(0,r.$Yj)("chevron-left",60085),chevronRight:(0,r.$Yj)("chevron-right",60086),chevronUp:(0,r.$Yj)("chevron-up",60087),chromeClose:(0,r.$Yj)("chrome-close",60088),chromeMaximize:(0,r.$Yj)("chrome-maximize",60089),chromeMinimize:(0,r.$Yj)("chrome-minimize",60090),chromeRestore:(0,r.$Yj)("chrome-restore",60091),circleOutline:(0,r.$Yj)("circle-outline",60092),circle:(0,r.$Yj)("circle",60092),debugBreakpointUnverified:(0,r.$Yj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Yj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Yj)("circle-slash",60093),circuitBoard:(0,r.$Yj)("circuit-board",60094),clearAll:(0,r.$Yj)("clear-all",60095),clippy:(0,r.$Yj)("clippy",60096),closeAll:(0,r.$Yj)("close-all",60097),cloudDownload:(0,r.$Yj)("cloud-download",60098),cloudUpload:(0,r.$Yj)("cloud-upload",60099),code:(0,r.$Yj)("code",60100),collapseAll:(0,r.$Yj)("collapse-all",60101),colorMode:(0,r.$Yj)("color-mode",60102),commentDiscussion:(0,r.$Yj)("comment-discussion",60103),creditCard:(0,r.$Yj)("credit-card",60105),dash:(0,r.$Yj)("dash",60108),dashboard:(0,r.$Yj)("dashboard",60109),database:(0,r.$Yj)("database",60110),debugContinue:(0,r.$Yj)("debug-continue",60111),debugDisconnect:(0,r.$Yj)("debug-disconnect",60112),debugPause:(0,r.$Yj)("debug-pause",60113),debugRestart:(0,r.$Yj)("debug-restart",60114),debugStart:(0,r.$Yj)("debug-start",60115),debugStepInto:(0,r.$Yj)("debug-step-into",60116),debugStepOut:(0,r.$Yj)("debug-step-out",60117),debugStepOver:(0,r.$Yj)("debug-step-over",60118),debugStop:(0,r.$Yj)("debug-stop",60119),debug:(0,r.$Yj)("debug",60120),deviceCameraVideo:(0,r.$Yj)("device-camera-video",60121),deviceCamera:(0,r.$Yj)("device-camera",60122),deviceMobile:(0,r.$Yj)("device-mobile",60123),diffAdded:(0,r.$Yj)("diff-added",60124),diffIgnored:(0,r.$Yj)("diff-ignored",60125),diffModified:(0,r.$Yj)("diff-modified",60126),diffRemoved:(0,r.$Yj)("diff-removed",60127),diffRenamed:(0,r.$Yj)("diff-renamed",60128),diff:(0,r.$Yj)("diff",60129),diffSidebyside:(0,r.$Yj)("diff-sidebyside",60129),discard:(0,r.$Yj)("discard",60130),editorLayout:(0,r.$Yj)("editor-layout",60131),emptyWindow:(0,r.$Yj)("empty-window",60132),exclude:(0,r.$Yj)("exclude",60133),extensions:(0,r.$Yj)("extensions",60134),eyeClosed:(0,r.$Yj)("eye-closed",60135),fileBinary:(0,r.$Yj)("file-binary",60136),fileCode:(0,r.$Yj)("file-code",60137),fileMedia:(0,r.$Yj)("file-media",60138),filePdf:(0,r.$Yj)("file-pdf",60139),fileSubmodule:(0,r.$Yj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Yj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Yj)("file-symlink-file",60142),fileZip:(0,r.$Yj)("file-zip",60143),files:(0,r.$Yj)("files",60144),filter:(0,r.$Yj)("filter",60145),flame:(0,r.$Yj)("flame",60146),foldDown:(0,r.$Yj)("fold-down",60147),foldUp:(0,r.$Yj)("fold-up",60148),fold:(0,r.$Yj)("fold",60149),folderActive:(0,r.$Yj)("folder-active",60150),folderOpened:(0,r.$Yj)("folder-opened",60151),gear:(0,r.$Yj)("gear",60152),gift:(0,r.$Yj)("gift",60153),gistSecret:(0,r.$Yj)("gist-secret",60154),gist:(0,r.$Yj)("gist",60155),gitCommit:(0,r.$Yj)("git-commit",60156),gitCompare:(0,r.$Yj)("git-compare",60157),compareChanges:(0,r.$Yj)("compare-changes",60157),gitMerge:(0,r.$Yj)("git-merge",60158),githubAction:(0,r.$Yj)("github-action",60159),githubAlt:(0,r.$Yj)("github-alt",60160),globe:(0,r.$Yj)("globe",60161),grabber:(0,r.$Yj)("grabber",60162),graph:(0,r.$Yj)("graph",60163),gripper:(0,r.$Yj)("gripper",60164),heart:(0,r.$Yj)("heart",60165),home:(0,r.$Yj)("home",60166),horizontalRule:(0,r.$Yj)("horizontal-rule",60167),hubot:(0,r.$Yj)("hubot",60168),inbox:(0,r.$Yj)("inbox",60169),issueReopened:(0,r.$Yj)("issue-reopened",60171),issues:(0,r.$Yj)("issues",60172),italic:(0,r.$Yj)("italic",60173),jersey:(0,r.$Yj)("jersey",60174),json:(0,r.$Yj)("json",60175),kebabVertical:(0,r.$Yj)("kebab-vertical",60176),key:(0,r.$Yj)("key",60177),law:(0,r.$Yj)("law",60178),lightbulbAutofix:(0,r.$Yj)("lightbulb-autofix",60179),linkExternal:(0,r.$Yj)("link-external",60180),link:(0,r.$Yj)("link",60181),listOrdered:(0,r.$Yj)("list-ordered",60182),listUnordered:(0,r.$Yj)("list-unordered",60183),liveShare:(0,r.$Yj)("live-share",60184),loading:(0,r.$Yj)("loading",60185),location:(0,r.$Yj)("location",60186),mailRead:(0,r.$Yj)("mail-read",60187),mail:(0,r.$Yj)("mail",60188),markdown:(0,r.$Yj)("markdown",60189),megaphone:(0,r.$Yj)("megaphone",60190),mention:(0,r.$Yj)("mention",60191),milestone:(0,r.$Yj)("milestone",60192),gitPullRequestMilestone:(0,r.$Yj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Yj)("mortar-board",60193),move:(0,r.$Yj)("move",60194),multipleWindows:(0,r.$Yj)("multiple-windows",60195),mute:(0,r.$Yj)("mute",60196),noNewline:(0,r.$Yj)("no-newline",60197),note:(0,r.$Yj)("note",60198),octoface:(0,r.$Yj)("octoface",60199),openPreview:(0,r.$Yj)("open-preview",60200),package:(0,r.$Yj)("package",60201),paintcan:(0,r.$Yj)("paintcan",60202),pin:(0,r.$Yj)("pin",60203),play:(0,r.$Yj)("play",60204),run:(0,r.$Yj)("run",60204),plug:(0,r.$Yj)("plug",60205),preserveCase:(0,r.$Yj)("preserve-case",60206),preview:(0,r.$Yj)("preview",60207),project:(0,r.$Yj)("project",60208),pulse:(0,r.$Yj)("pulse",60209),question:(0,r.$Yj)("question",60210),quote:(0,r.$Yj)("quote",60211),radioTower:(0,r.$Yj)("radio-tower",60212),reactions:(0,r.$Yj)("reactions",60213),references:(0,r.$Yj)("references",60214),refresh:(0,r.$Yj)("refresh",60215),regex:(0,r.$Yj)("regex",60216),remoteExplorer:(0,r.$Yj)("remote-explorer",60217),remote:(0,r.$Yj)("remote",60218),remove:(0,r.$Yj)("remove",60219),replaceAll:(0,r.$Yj)("replace-all",60220),replace:(0,r.$Yj)("replace",60221),repoClone:(0,r.$Yj)("repo-clone",60222),repoForcePush:(0,r.$Yj)("repo-force-push",60223),repoPull:(0,r.$Yj)("repo-pull",60224),repoPush:(0,r.$Yj)("repo-push",60225),report:(0,r.$Yj)("report",60226),requestChanges:(0,r.$Yj)("request-changes",60227),rocket:(0,r.$Yj)("rocket",60228),rootFolderOpened:(0,r.$Yj)("root-folder-opened",60229),rootFolder:(0,r.$Yj)("root-folder",60230),rss:(0,r.$Yj)("rss",60231),ruby:(0,r.$Yj)("ruby",60232),saveAll:(0,r.$Yj)("save-all",60233),saveAs:(0,r.$Yj)("save-as",60234),save:(0,r.$Yj)("save",60235),screenFull:(0,r.$Yj)("screen-full",60236),screenNormal:(0,r.$Yj)("screen-normal",60237),searchStop:(0,r.$Yj)("search-stop",60238),server:(0,r.$Yj)("server",60240),settingsGear:(0,r.$Yj)("settings-gear",60241),settings:(0,r.$Yj)("settings",60242),shield:(0,r.$Yj)("shield",60243),smiley:(0,r.$Yj)("smiley",60244),sortPrecedence:(0,r.$Yj)("sort-precedence",60245),splitHorizontal:(0,r.$Yj)("split-horizontal",60246),splitVertical:(0,r.$Yj)("split-vertical",60247),squirrel:(0,r.$Yj)("squirrel",60248),starFull:(0,r.$Yj)("star-full",60249),starHalf:(0,r.$Yj)("star-half",60250),symbolClass:(0,r.$Yj)("symbol-class",60251),symbolColor:(0,r.$Yj)("symbol-color",60252),symbolConstant:(0,r.$Yj)("symbol-constant",60253),symbolEnumMember:(0,r.$Yj)("symbol-enum-member",60254),symbolField:(0,r.$Yj)("symbol-field",60255),symbolFile:(0,r.$Yj)("symbol-file",60256),symbolInterface:(0,r.$Yj)("symbol-interface",60257),symbolKeyword:(0,r.$Yj)("symbol-keyword",60258),symbolMisc:(0,r.$Yj)("symbol-misc",60259),symbolOperator:(0,r.$Yj)("symbol-operator",60260),symbolProperty:(0,r.$Yj)("symbol-property",60261),wrench:(0,r.$Yj)("wrench",60261),wrenchSubaction:(0,r.$Yj)("wrench-subaction",60261),symbolSnippet:(0,r.$Yj)("symbol-snippet",60262),tasklist:(0,r.$Yj)("tasklist",60263),telescope:(0,r.$Yj)("telescope",60264),textSize:(0,r.$Yj)("text-size",60265),threeBars:(0,r.$Yj)("three-bars",60266),thumbsdown:(0,r.$Yj)("thumbsdown",60267),thumbsup:(0,r.$Yj)("thumbsup",60268),tools:(0,r.$Yj)("tools",60269),triangleDown:(0,r.$Yj)("triangle-down",60270),triangleLeft:(0,r.$Yj)("triangle-left",60271),triangleRight:(0,r.$Yj)("triangle-right",60272),triangleUp:(0,r.$Yj)("triangle-up",60273),twitter:(0,r.$Yj)("twitter",60274),unfold:(0,r.$Yj)("unfold",60275),unlock:(0,r.$Yj)("unlock",60276),unmute:(0,r.$Yj)("unmute",60277),unverified:(0,r.$Yj)("unverified",60278),verified:(0,r.$Yj)("verified",60279),versions:(0,r.$Yj)("versions",60280),vmActive:(0,r.$Yj)("vm-active",60281),vmOutline:(0,r.$Yj)("vm-outline",60282),vmRunning:(0,r.$Yj)("vm-running",60283),watch:(0,r.$Yj)("watch",60284),whitespace:(0,r.$Yj)("whitespace",60285),wholeWord:(0,r.$Yj)("whole-word",60286),window:(0,r.$Yj)("window",60287),wordWrap:(0,r.$Yj)("word-wrap",60288),zoomIn:(0,r.$Yj)("zoom-in",60289),zoomOut:(0,r.$Yj)("zoom-out",60290),listFilter:(0,r.$Yj)("list-filter",60291),listFlat:(0,r.$Yj)("list-flat",60292),listSelection:(0,r.$Yj)("list-selection",60293),selection:(0,r.$Yj)("selection",60293),listTree:(0,r.$Yj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Yj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Yj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Yj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Yj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Yj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Yj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Yj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Yj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Yj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Yj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Yj)("symbol-string",60301),debugReverseContinue:(0,r.$Yj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Yj)("debug-step-back",60303),debugRestartFrame:(0,r.$Yj)("debug-restart-frame",60304),debugAlt:(0,r.$Yj)("debug-alt",60305),callIncoming:(0,r.$Yj)("call-incoming",60306),callOutgoing:(0,r.$Yj)("call-outgoing",60307),menu:(0,r.$Yj)("menu",60308),expandAll:(0,r.$Yj)("expand-all",60309),feedback:(0,r.$Yj)("feedback",60310),gitPullRequestReviewer:(0,r.$Yj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Yj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Yj)("ungroup-by-ref-type",60312),account:(0,r.$Yj)("account",60313),gitPullRequestAssignee:(0,r.$Yj)("git-pull-request-assignee",60313),bellDot:(0,r.$Yj)("bell-dot",60314),debugConsole:(0,r.$Yj)("debug-console",60315),library:(0,r.$Yj)("library",60316),output:(0,r.$Yj)("output",60317),runAll:(0,r.$Yj)("run-all",60318),syncIgnored:(0,r.$Yj)("sync-ignored",60319),pinned:(0,r.$Yj)("pinned",60320),githubInverted:(0,r.$Yj)("github-inverted",60321),serverProcess:(0,r.$Yj)("server-process",60322),serverEnvironment:(0,r.$Yj)("server-environment",60323),pass:(0,r.$Yj)("pass",60324),issueClosed:(0,r.$Yj)("issue-closed",60324),stopCircle:(0,r.$Yj)("stop-circle",60325),playCircle:(0,r.$Yj)("play-circle",60326),record:(0,r.$Yj)("record",60327),debugAltSmall:(0,r.$Yj)("debug-alt-small",60328),vmConnect:(0,r.$Yj)("vm-connect",60329),cloud:(0,r.$Yj)("cloud",60330),merge:(0,r.$Yj)("merge",60331),export:(0,r.$Yj)("export",60332),graphLeft:(0,r.$Yj)("graph-left",60333),magnet:(0,r.$Yj)("magnet",60334),notebook:(0,r.$Yj)("notebook",60335),redo:(0,r.$Yj)("redo",60336),checkAll:(0,r.$Yj)("check-all",60337),pinnedDirty:(0,r.$Yj)("pinned-dirty",60338),passFilled:(0,r.$Yj)("pass-filled",60339),circleLargeFilled:(0,r.$Yj)("circle-large-filled",60340),circleLarge:(0,r.$Yj)("circle-large",60341),circleLargeOutline:(0,r.$Yj)("circle-large-outline",60341),combine:(0,r.$Yj)("combine",60342),gather:(0,r.$Yj)("gather",60342),table:(0,r.$Yj)("table",60343),variableGroup:(0,r.$Yj)("variable-group",60344),typeHierarchy:(0,r.$Yj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Yj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Yj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Yj)("git-pull-request-create",60348),runAbove:(0,r.$Yj)("run-above",60349),runBelow:(0,r.$Yj)("run-below",60350),notebookTemplate:(0,r.$Yj)("notebook-template",60351),debugRerun:(0,r.$Yj)("debug-rerun",60352),workspaceTrusted:(0,r.$Yj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Yj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Yj)("workspace-unknown",60355),terminalCmd:(0,r.$Yj)("terminal-cmd",60356),terminalDebian:(0,r.$Yj)("terminal-debian",60357),terminalLinux:(0,r.$Yj)("terminal-linux",60358),terminalPowershell:(0,r.$Yj)("terminal-powershell",60359),terminalTmux:(0,r.$Yj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Yj)("terminal-ubuntu",60361),terminalBash:(0,r.$Yj)("terminal-bash",60362),arrowSwap:(0,r.$Yj)("arrow-swap",60363),copy:(0,r.$Yj)("copy",60364),personAdd:(0,r.$Yj)("person-add",60365),filterFilled:(0,r.$Yj)("filter-filled",60366),wand:(0,r.$Yj)("wand",60367),debugLineByLine:(0,r.$Yj)("debug-line-by-line",60368),inspect:(0,r.$Yj)("inspect",60369),layers:(0,r.$Yj)("layers",60370),layersDot:(0,r.$Yj)("layers-dot",60371),layersActive:(0,r.$Yj)("layers-active",60372),compass:(0,r.$Yj)("compass",60373),compassDot:(0,r.$Yj)("compass-dot",60374),compassActive:(0,r.$Yj)("compass-active",60375),azure:(0,r.$Yj)("azure",60376),issueDraft:(0,r.$Yj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Yj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Yj)("git-pull-request-draft",60379),debugAll:(0,r.$Yj)("debug-all",60380),debugCoverage:(0,r.$Yj)("debug-coverage",60381),runErrors:(0,r.$Yj)("run-errors",60382),folderLibrary:(0,r.$Yj)("folder-library",60383),debugContinueSmall:(0,r.$Yj)("debug-continue-small",60384),beakerStop:(0,r.$Yj)("beaker-stop",60385),graphLine:(0,r.$Yj)("graph-line",60386),graphScatter:(0,r.$Yj)("graph-scatter",60387),pieChart:(0,r.$Yj)("pie-chart",60388),bracket:(0,r.$Yj)("bracket",60175),bracketDot:(0,r.$Yj)("bracket-dot",60389),bracketError:(0,r.$Yj)("bracket-error",60390),lockSmall:(0,r.$Yj)("lock-small",60391),azureDevops:(0,r.$Yj)("azure-devops",60392),verifiedFilled:(0,r.$Yj)("verified-filled",60393),newline:(0,r.$Yj)("newline",60394),layout:(0,r.$Yj)("layout",60395),layoutActivitybarLeft:(0,r.$Yj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Yj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Yj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Yj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Yj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Yj)("layout-panel-right",60401),layoutPanel:(0,r.$Yj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Yj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Yj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Yj)("layout-statusbar",60405),layoutMenubar:(0,r.$Yj)("layout-menubar",60406),layoutCentered:(0,r.$Yj)("layout-centered",60407),target:(0,r.$Yj)("target",60408),indent:(0,r.$Yj)("indent",60409),recordSmall:(0,r.$Yj)("record-small",60410),errorSmall:(0,r.$Yj)("error-small",60411),terminalDecorationError:(0,r.$Yj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Yj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Yj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Yj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Yj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Yj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Yj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Yj)("layout-sidebar-left-off",60418),blank:(0,r.$Yj)("blank",60419),heartFilled:(0,r.$Yj)("heart-filled",60420),map:(0,r.$Yj)("map",60421),mapHorizontal:(0,r.$Yj)("map-horizontal",60421),foldHorizontal:(0,r.$Yj)("fold-horizontal",60421),mapFilled:(0,r.$Yj)("map-filled",60422),mapHorizontalFilled:(0,r.$Yj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Yj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Yj)("circle-small",60423),bellSlash:(0,r.$Yj)("bell-slash",60424),bellSlashDot:(0,r.$Yj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Yj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Yj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Yj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Yj)("search-fuzzy",60429),commentDraft:(0,r.$Yj)("comment-draft",60430),send:(0,r.$Yj)("send",60431),sparkle:(0,r.$Yj)("sparkle",60432),insert:(0,r.$Yj)("insert",60433),mic:(0,r.$Yj)("mic",60434),thumbsdownFilled:(0,r.$Yj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Yj)("thumbsup-filled",60436),coffee:(0,r.$Yj)("coffee",60437),snake:(0,r.$Yj)("snake",60438),game:(0,r.$Yj)("game",60439),vr:(0,r.$Yj)("vr",60440),chip:(0,r.$Yj)("chip",60441),piano:(0,r.$Yj)("piano",60442),music:(0,r.$Yj)("music",60443),micFilled:(0,r.$Yj)("mic-filled",60444),repoFetch:(0,r.$Yj)("repo-fetch",60445),copilot:(0,r.$Yj)("copilot",60446),lightbulbSparkle:(0,r.$Yj)("lightbulb-sparkle",60447),robot:(0,r.$Yj)("robot",60448),sparkleFilled:(0,r.$Yj)("sparkle-filled",60449),diffSingle:(0,r.$Yj)("diff-single",60450),diffMultiple:(0,r.$Yj)("diff-multiple",60451),surroundWith:(0,r.$Yj)("surround-with",60452),share:(0,r.$Yj)("share",60453),gitStash:(0,r.$Yj)("git-stash",60454),gitStashApply:(0,r.$Yj)("git-stash-apply",60455),gitStashPop:(0,r.$Yj)("git-stash-pop",60456),vscode:(0,r.$Yj)("vscode",60457),vscodeInsiders:(0,r.$Yj)("vscode-insiders",60458),codeOss:(0,r.$Yj)("code-oss",60459),runCoverage:(0,r.$Yj)("run-coverage",60460),runAllCoverage:(0,r.$Yj)("run-all-coverage",60461),coverage:(0,r.$Yj)("coverage",60462),githubProject:(0,r.$Yj)("github-project",60463),mapVertical:(0,r.$Yj)("map-vertical",60464),foldVertical:(0,r.$Yj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Yj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Yj)("fold-vertical-filled",60465),goToSearch:(0,r.$Yj)("go-to-search",60466),percentage:(0,r.$Yj)("percentage",60467),sortPercentage:(0,r.$Yj)("sort-percentage",60467),attach:(0,r.$Yj)("attach",60468)}}),define(ke[82],Ie([1,0,106,187]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=void 0,e.$2j=C;function C(){return Object.values(e.$4j)}e.$3j={dialogError:(0,r.$Yj)("dialog-error","error"),dialogWarning:(0,r.$Yj)("dialog-warning","warning"),dialogInfo:(0,r.$Yj)("dialog-info","info"),dialogClose:(0,r.$Yj)("dialog-close","close"),treeItemExpanded:(0,r.$Yj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Yj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Yj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Yj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Yj)("tree-item-loading","loading"),menuSelection:(0,r.$Yj)("menu-selection","check"),menuSubmenu:(0,r.$Yj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Yj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Yj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Yj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Yj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Yj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Yj)("toolbar-more","more"),quickInputBack:(0,r.$Yj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Yj)("drop-down-button",60084),symbolCustomColor:(0,r.$Yj)("symbol-customcolor",60252),exportIcon:(0,r.$Yj)("export",60332),workspaceUnspecified:(0,r.$Yj)("workspace-unspecified",60355),newLine:(0,r.$Yj)("newline",60394),thumbsDownFilled:(0,r.$Yj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Yj)("thumbsup-filled",60436),gitFetch:(0,r.$Yj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Yj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Yj)("debug-breakpoint-pending",60377)},e.$4j={...h.$1j,...e.$3j}}),define(ke[24],Ie([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=h,e.$eo=C,e.$fo=L,e.$go=b,e.$ho=c,e.$io=I,e.$jo=S,e.$ko=u,e.$lo=P,e.$mo=w,e.$no=a,e.$oo=m,e.$po=$;function h(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const i=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([s,t])=>{i[s]=t&&typeof t=="object"?h(t):t}),i}function C(f){if(!f||typeof f!="object")return f;const i=[f];for(;i.length>0;){const s=i.shift();Object.freeze(s);for(const t in s)if(R.call(s,t)){const o=s[t];typeof o=="object"&&!Object.isFrozen(o)&&!(0,r.$hg)(o)&&i.push(o)}}return f}const R=Object.prototype.hasOwnProperty;function L(f,i){return T(f,i,new Set)}function T(f,i,s){if((0,r.$ng)(f))return f;const t=i(f);if(typeof t<"u")return t;if(Array.isArray(f)){const o=[];for(const n of f)o.push(T(n,i,s));return o}if((0,r.$gg)(f)){if(s.has(f))throw new Error("Cannot clone recursive data-structure");s.add(f);const o={};for(const n in f)R.call(f,n)&&(o[n]=T(f[n],i,s));return s.delete(f),o}return f}function b(f,i,s=!0){return(0,r.$gg)(f)?((0,r.$gg)(i)&&Object.keys(i).forEach(t=>{t in f?s&&((0,r.$gg)(f[t])&&(0,r.$gg)(i[t])?b(f[t],i[t],s):f[t]=i[t]):f[t]=i[t]}),f):i}function c(f,i){if(f===i)return!0;if(f==null||i===null||i===void 0||typeof f!=typeof i||typeof f!="object"||Array.isArray(f)!==Array.isArray(i))return!1;let s,t;if(Array.isArray(f)){if(f.length!==i.length)return!1;for(s=0;s<f.length;s++)if(!c(f[s],i[s]))return!1}else{const o=[];for(t in f)o.push(t);o.sort();const n=[];for(t in i)n.push(t);if(n.sort(),!c(o,n))return!1;for(s=0;s<o.length;s++)if(!c(f[o[s]],i[o[s]]))return!1}return!0}function I(f){const i=new Set;return JSON.stringify(f,(s,t)=>{if((0,r.$gg)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function S(f,i){const s=Object.create(null);return!f||!i||Object.keys(i).forEach(o=>{const n=f[o],d=i[o];c(n,d)||(s[o]=d)}),s}function u(f,i){const s=i.toLowerCase(),t=Object.keys(f).find(o=>o.toLowerCase()===s);return t?f[t]:f[i]}function P(f,i){const s=Object.create(null);for(const[t,o]of Object.entries(f))i(t,o)&&(s[t]=o);return s}function w(f){let i=[];for(;Object.prototype!==f;)i=i.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return i}function a(f){const i=[];for(const s of w(f))typeof f[s]=="function"&&i.push(s);return i}function m(f,i){const s=o=>function(){const n=Array.prototype.slice.call(arguments,0);return i(o,n)},t={};for(const o of f)t[o]=s(o);return t}function $(f,i){const s={};for(const[t,o]of Object.entries(f))s[t]=i(o,t);return s}}),define(ke[50],Ie([1,0,82]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$5j=C;var h;(function(L){function T(b){return b&&typeof b=="object"&&typeof b.id=="string"}L.isThemeColor=T})(h||(e.ThemeColor=h={}));function C(L){return{id:L}}var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function b(f){const i=T.exec(f.id);if(!i)return b(r.$4j.error);const[,s,t]=i,o=["codicon","codicon-"+s];return t&&o.push("codicon-modifier-"+t.substring(1)),o}L.asClassNameArray=b;function c(f){return b(f).join(" ")}L.asClassName=c;function I(f){return"."+b(f).join(".")}L.asCSSSelector=I;function S(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||h.isThemeColor(f.color))}L.isThemeIcon=S;const u=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function P(f){const i=u.exec(f);if(!i)return;const[,s]=i;return{id:s}}L.fromString=P;function w(f){return{id:f}}L.fromId=w;function a(f,i){let s=f.id;const t=s.lastIndexOf("~");return t!==-1&&(s=s.substring(0,t)),i&&(s=`${s}~${i}`),{id:s}}L.modify=a;function m(f){const i=f.id.lastIndexOf("~");if(i!==-1)return f.id.substring(i+1)}L.getModifier=m;function $(f,i){return f.id===i.id&&f.color?.id===i.color?.id}L.isEqual=$})(R||(e.ThemeIcon=R={}))}),define(ke[83],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=h,e.$bf=C;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function C(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(ke[12],Ie([1,0,184,26,49,83]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=L,e.$df=b,e.$ef=I,e.$ff=S,e.$gf=u,e.$hf=P,e.$if=w,e.$jf=a,e.$kf=m,e.$lf=$,e.$mf=f,e.$nf=i,e.$of=s,e.$pf=t,e.$qf=o,e.$rf=n,e.$sf=d,e.$tf=l,e.$uf=g,e.$vf=E,e.$wf=D,e.$xf=y,e.$yf=k,e.$zf=A,e.$Af=p,e.$Bf=v,e.$Cf=F,e.$Df=N,e.$Ef=O,e.$Ff=j,e.$Gf=z,e.$Hf=M,e.$If=U,e.$Jf=V,e.$Kf=ie,e.$Lf=B,e.$Mf=Y,e.$Pf=re,e.$Qf=Se,e.$Rf=me,e.$Sf=Q,e.$Tf=we,e.$Uf=ae,e.$Wf=oe,e.$Xf=x,e.$Yf=ne,e.$Zf=pe,e.$1f=Fe,e.$2f=ze,e.$3f=De,e.$5f=Ce,e.$6f=W,e.$7f=H,e.$8f=X,e.$9f=Z,e.$0f=de,e.$$f=ve,e.$_f=Oe,e.$ag=st;function L(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const T=/{(\d+)}/g;function b(Pe,...Be){return Be.length===0?Pe:Pe.replace(T,function(Ye,Ne){const je=parseInt(Ne,10);return isNaN(je)||je<0||je>=Be.length?Ye:Be[je]})}const c=/{([^}]+)}/g;function I(Pe,Be){return Object.keys(Be).length===0?Pe:Pe.replace(c,(Ye,Ne)=>Be[Ne]??Ye)}function S(Pe){return Pe.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function u(Pe){return Pe.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(Pe,Be){let Ye=0,Ne=Pe.indexOf(Be);for(;Ne!==-1;)Ye++,Ne=Pe.indexOf(Be,Ne+Be.length);return Ye}function a(Pe,Be,Ye="\u2026"){return Pe.length<=Be?Pe:`${Pe.substr(0,Be)}${Ye}`}function m(Pe,Be,Ye="\u2026"){if(Pe.length<=Be)return Pe;const Ne=Math.ceil(Be/2)-Ye.length/2,je=Math.floor(Be/2)-Ye.length/2;return`${Pe.substr(0,Ne)}${Ye}${Pe.substr(Pe.length-je)}`}function $(Pe,Be=" "){const Ye=f(Pe,Be);return i(Ye,Be)}function f(Pe,Be){if(!Pe||!Be)return Pe;const Ye=Be.length;if(Ye===0||Pe.length===0)return Pe;let Ne=0;for(;Pe.indexOf(Be,Ne)===Ne;)Ne=Ne+Ye;return Pe.substring(Ne)}function i(Pe,Be){if(!Pe||!Be)return Pe;const Ye=Be.length,Ne=Pe.length;if(Ye===0||Ne===0)return Pe;let je=Ne,ue=-1;for(;ue=Pe.lastIndexOf(Be,je-1),!(ue===-1||ue+Ye!==je);){if(ue===0)return"";je=ue}return Pe.substring(0,je)}function s(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Pe){return Pe.replace(/\*/g,"")}function o(Pe,Be,Ye={}){if(!Pe)throw new Error("Cannot create regex from empty string");Be||(Pe=P(Pe)),Ye.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Ne="";return Ye.global&&(Ne+="g"),Ye.matchCase||(Ne+="i"),Ye.multiline&&(Ne+="m"),Ye.unicode&&(Ne+="u"),new RegExp(Pe,Ne)}function n(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function d(Pe){return Pe.split(/\r\n|\r|\n/)}function l(Pe){const Be=[],Ye=Pe.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(Ye.length/2);Ne++)Be.push(Ye[2*Ne]+(Ye[2*Ne+1]??""));return Be}function g(Pe){for(let Be=0,Ye=Pe.length;Be<Ye;Be++){const Ne=Pe.charCodeAt(Be);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return Be}return-1}function E(Pe,Be=0,Ye=Pe.length){for(let Ne=Be;Ne<Ye;Ne++){const je=Pe.charCodeAt(Ne);if(je!==h.CharCode.Space&&je!==h.CharCode.Tab)return Pe.substring(Be,Ne)}return Pe.substring(Be,Ye)}function D(Pe,Be=Pe.length-1){for(let Ye=Be;Ye>=0;Ye--){const Ne=Pe.charCodeAt(Ye);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return Ye}return-1}function y(Pe,Be,Ye){const Ne=[];let je=0;for(const ue of Pe.matchAll(Be)){if(Ne.push(Pe.slice(je,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");je=ue.index+ue[0].length,Ne.push(Ye(ue[0],...ue.slice(1),ue.index,Pe,ue.groups))}return Ne.push(Pe.slice(je)),Promise.all(Ne).then(ue=>ue.join(""))}function k(Pe,Be){return Pe<Be?-1:Pe>Be?1:0}function A(Pe,Be,Ye=0,Ne=Pe.length,je=0,ue=Be.length){for(;Ye<Ne&&je<ue;Ye++,je++){const Xe=Pe.charCodeAt(Ye),et=Be.charCodeAt(je);if(Xe<et)return-1;if(Xe>et)return 1}const he=Ne-Ye,ce=ue-je;return he<ce?-1:he>ce?1:0}function p(Pe,Be){return v(Pe,Be,0,Pe.length,0,Be.length)}function v(Pe,Be,Ye=0,Ne=Pe.length,je=0,ue=Be.length){for(;Ye<Ne&&je<ue;Ye++,je++){let Xe=Pe.charCodeAt(Ye),et=Be.charCodeAt(je);if(Xe===et)continue;if(Xe>=128||et>=128)return A(Pe.toLowerCase(),Be.toLowerCase(),Ye,Ne,je,ue);N(Xe)&&(Xe-=32),N(et)&&(et-=32);const ut=Xe-et;if(ut!==0)return ut}const he=Ne-Ye,ce=ue-je;return he<ce?-1:he>ce?1:0}function F(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function N(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function O(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function j(Pe,Be){return Pe.length===Be.length&&v(Pe,Be)===0}function z(Pe,Be){const Ye=Be.length;return Be.length>Pe.length?!1:v(Pe,Be,0,Ye)===0}function M(Pe,Be){const Ye=Math.min(Pe.length,Be.length);let Ne;for(Ne=0;Ne<Ye;Ne++)if(Pe.charCodeAt(Ne)!==Be.charCodeAt(Ne))return Ne;return Ye}function U(Pe,Be){const Ye=Math.min(Pe.length,Be.length);let Ne;const je=Pe.length-1,ue=Be.length-1;for(Ne=0;Ne<Ye;Ne++)if(Pe.charCodeAt(je-Ne)!==Be.charCodeAt(ue-Ne))return Ne;return Ye}function V(Pe){return 55296<=Pe&&Pe<=56319}function ie(Pe){return 56320<=Pe&&Pe<=57343}function B(Pe,Be){return(Pe-55296<<10)+(Be-56320)+65536}function Y(Pe,Be,Ye){const Ne=Pe.charCodeAt(Ye);if(V(Ne)&&Ye+1<Be){const je=Pe.charCodeAt(Ye+1);if(ie(je))return B(Ne,je)}return Ne}function J(Pe,Be){const Ye=Pe.charCodeAt(Be-1);if(ie(Ye)&&Be>1){const Ne=Pe.charCodeAt(Be-2);if(V(Ne))return B(Ne,Ye)}return Ye}class _{get offset(){return this.e}constructor(Be,Ye=0){this.c=Be,this.d=Be.length,this.e=Ye}setOffset(Be){this.e=Be}prevCodePoint(){const Be=J(this.c,this.e);return this.e-=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}nextCodePoint(){const Be=Y(this.c,this.d,this.e);return this.e+=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}eol(){return this.e>=this.d}}e.$Nf=_;class le{get offset(){return this.c.offset}constructor(Be,Ye=0){this.c=new _(Be,Ye)}nextGraphemeLength(){const Be=_e.getInstance(),Ye=this.c,Ne=Ye.offset;let je=Be.getGraphemeBreakType(Ye.nextCodePoint());for(;!Ye.eol();){const ue=Ye.offset,he=Be.getGraphemeBreakType(Ye.nextCodePoint());if(He(je,he)){Ye.setOffset(ue);break}je=he}return Ye.offset-Ne}prevGraphemeLength(){const Be=_e.getInstance(),Ye=this.c,Ne=Ye.offset;let je=Be.getGraphemeBreakType(Ye.prevCodePoint());for(;Ye.offset>0;){const ue=Ye.offset,he=Be.getGraphemeBreakType(Ye.prevCodePoint());if(He(he,je)){Ye.setOffset(ue);break}je=he}return Ne-Ye.offset}eol(){return this.c.eol()}}e.$Of=le;function re(Pe,Be){return new le(Pe,Be).nextGraphemeLength()}function Se(Pe,Be){return new le(Pe,Be).prevGraphemeLength()}function me(Pe,Be){Be>0&&ie(Pe.charCodeAt(Be))&&Be--;const Ye=Be+re(Pe,Be);return[Ye-Se(Pe,Ye),Ye]}function Q(Pe){const Be=new le(Pe);let Ye=0;for(;!Be.eol();)Ye++,Be.nextGraphemeLength();return Ye}let q;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(Pe){return q||(q=se()),q.test(Pe)}const ee=/^[\t\n\r\x20-\x7E]*$/;function ae(Pe){return ee.test(Pe)}e.$Vf=/[\u2028\u2029]/;function oe(Pe){return e.$Vf.test(Pe)}function x(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function ne(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,Be,Ye=""){const Ne=Pe.trimStart();if(Ne.length<Be)return Ne;const je=/\b/g;let ue=0;for(;je.test(Ne)&&!(Ne.length-je.lastIndex<Be);)ue=je.lastIndex,je.lastIndex+=1;return ue===0?Ne:Ye+Ne.substring(ue).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Pe){let Be=0;for(const Ye of Pe.matchAll(be))Be!==Ye.index&&(yield{isCode:!1,str:Pe.substring(Be,Ye.index)}),yield{isCode:!0,str:Ye[0]},Be=Ye.index+Ye[0].length;Be!==Pe.length&&(yield{isCode:!1,str:Pe.substring(Be)})}function ze(Pe){return Pe&&(Pe=Pe.replace(be,"")),Pe}const Ae=/\\\[.*?\\\]/g;function De(Pe){return ze(Pe).replace(Ae,"")}e.$4f=String.fromCharCode(h.CharCode.UTF8_BOM);function Ce(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function W(Pe){return Ce(Pe)?Pe.substr(1):Pe}function H(Pe,Be){if(!Pe||!Be||Pe.length<Be.length)return!1;const Ye=Be.length,Ne=Pe.toLowerCase();let je=0,ue=-1;for(;je<Ye;){const he=Ne.indexOf(Be[je],ue+1);if(he<0)return!1;ue=he,je++}return!0}function X(Pe,Be=!1){return Pe?(Be&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function Z(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function de(Pe,Be=1){if(Be===0)return"";let Ye=-1;do Ye=Pe.indexOf(`
`,Ye+1),Be--;while(Be>0&&Ye>=0);return Ye===-1?Pe:(Pe[Ye-1]==="\r"&&Ye--,Pe.substr(0,Ye))}function ve(Pe){const Be=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*Be),Pe<Be?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-Be)}function Oe(Pe){return _e.getInstance().getGraphemeBreakType(Pe)}function He(Pe,Be){return Pe===Ke.Other?Be!==Ke.Extend&&Be!==Ke.SpacingMark:Pe===Ke.CR&&Be===Ke.LF?!1:Pe===Ke.Control||Pe===Ke.CR||Pe===Ke.LF||Be===Ke.Control||Be===Ke.CR||Be===Ke.LF?!0:!(Pe===Ke.L&&(Be===Ke.L||Be===Ke.V||Be===Ke.LV||Be===Ke.LVT)||(Pe===Ke.LV||Pe===Ke.V)&&(Be===Ke.V||Be===Ke.T)||(Pe===Ke.LVT||Pe===Ke.T)&&Be===Ke.T||Be===Ke.Extend||Be===Ke.ZWJ||Be===Ke.SpacingMark||Pe===Ke.Prepend||Pe===Ke.ZWJ&&Be===Ke.Extended_Pictographic||Pe===Ke.Regional_Indicator&&Be===Ke.Regional_Indicator)}var Ke;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class _e{static{this.c=null}static getInstance(){return _e.c||(_e.c=new _e),_e.c}constructor(){this.d=nt()}getGraphemeBreakType(Be){if(Be<32)return Be===h.CharCode.LineFeed?Ke.LF:Be===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(Be<127)return Ke.Other;const Ye=this.d,Ne=Ye.length/3;let je=1;for(;je<=Ne;)if(Be<Ye[3*je])je=2*je;else if(Be>Ye[3*je+1])je=2*je+1;else return Ye[3*je+2];return Ke.Other}}function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(Pe,Be){if(Pe===0)return 0;const Ye=rt(Pe,Be);if(Ye!==void 0)return Ye;const Ne=new _(Be,Pe);return Ne.prevCodePoint(),Ne.offset}function rt(Pe,Be){const Ye=new _(Be,Pe);let Ne=Ye.prevCodePoint();for(;at(Ne)||Ne===gt.emojiVariantSelector||Ne===gt.enclosingKeyCap;){if(Ye.offset===0)return;Ne=Ye.prevCodePoint()}if(!ne(Ne))return;let je=Ye.offset;return je>0&&Ye.prevCodePoint()===gt.zwj&&(je=Ye.offset),je}function at(Pe){return 127995<=Pe&&Pe<=127999}var gt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(gt||(gt={})),e.$bg="\xA0";class ht{static{this.c=new C.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$$e({getCacheKey:JSON.stringify},Be=>{function Ye(ut){const mt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)mt.set(ut[Dt],ut[Dt+1]);return mt}function Ne(ut,mt){const Dt=new Map(ut);for(const[Ft,Ht]of mt)Dt.set(Ft,Ht);return Dt}function je(ut,mt){if(!ut)return mt;const Dt=new Map;for(const[Ft,Ht]of ut)mt.has(Ft)&&Dt.set(Ft,Ht);return Dt}const ue=this.c.value;let he=Be.filter(ut=>!ut.startsWith("_")&&ut in ue);he.length===0&&(he=["_default"]);let ce;for(const ut of he){const mt=Ye(ue[ut]);ce=je(ce,mt)}const Xe=Ye(ue._common),et=Ne(Xe,ce);return new ht(et)})}static getInstance(Be){return ht.d.get(Array.from(Be))}static{this.e=new C.$T(()=>Object.keys(ht.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return ht.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}containsAmbiguousCharacter(Be){for(let Ye=0;Ye<Be.length;Ye++){const Ne=Be.codePointAt(Ye);if(typeof Ne=="number"&&this.isAmbiguous(Ne))return!0}return!1}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=ht;class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(Be){return ct.e().has(Be)}static containsInvisibleCharacter(Be){for(let Ye=0;Ye<Be.length;Ye++){const Ne=Be.codePointAt(Ye);if(typeof Ne=="number"&&ct.isInvisibleCharacter(Ne))return!0}return!1}static get codePoints(){return ct.e()}}e.$dg=ct}),define(ke[31],Ie([1,0,26,16,10,12,17]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=T,e.$xg=b,e.$yg=c,e.$zg=I,e.$Ag=S,e.$Bg=a,e.$Cg=m,e.$Dg=$,e.$Eg=f,e.$Fg=i,e.$Gg=s,e.$Hg=t,e.$Ig=o,e.$Jg=n,e.$Kg=d,e.$Lg=l,e.$Mg=D;function T(y){return y===r.CharCode.Slash||y===r.CharCode.Backslash}function b(y){return y.replace(/[\\/]/g,h.$gc.sep)}function c(y){return y.indexOf("/")===-1&&(y=b(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function I(y,k=h.$gc.sep){if(!y)return"";const A=y.length,p=y.charCodeAt(0);if(T(p)){if(T(y.charCodeAt(1))&&!T(y.charCodeAt(2))){let F=3;const N=F;for(;F<A&&!T(y.charCodeAt(F));F++);if(N!==F&&!T(y.charCodeAt(F+1))){for(F+=1;F<A;F++)if(T(y.charCodeAt(F)))return y.slice(0,F+1).replace(/[\\/]/g,k)}}return k}else if(f(p)&&y.charCodeAt(1)===r.CharCode.Colon)return T(y.charCodeAt(2))?y.slice(0,2)+k:y.slice(0,2);let v=y.indexOf("://");if(v!==-1){for(v+=3;v<A;v++)if(T(y.charCodeAt(v)))return y.slice(0,v+1)}return""}function S(y){if(!C.$j||!y||y.length<5)return!1;let k=y.charCodeAt(0);if(k!==r.CharCode.Backslash||(k=y.charCodeAt(1),k!==r.CharCode.Backslash))return!1;let A=2;const p=A;for(;A<y.length&&(k=y.charCodeAt(A),k!==r.CharCode.Backslash);A++);return!(p===A||(k=y.charCodeAt(A+1),isNaN(k)||k===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,P=/[/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(y,k=C.$j){const A=k?u:P;return!(!y||y.length===0||/^\s+$/.test(y)||(A.lastIndex=0,A.test(y))||k&&w.test(y)||y==="."||y===".."||k&&y[y.length-1]==="."||k&&y.length!==y.trim().length||y.length>255)}function m(y,k,A){const p=y===k;return!A||p?p:!y||!k?!1:(0,R.$Ff)(y,k)}function $(y,k,A,p=h.sep){if(y===k)return!0;if(!y||!k||k.length>y.length)return!1;if(A){if(!(0,R.$Gf)(y,k))return!1;if(k.length===y.length)return!0;let F=k.length;return k.charAt(k.length-1)===p&&F--,y.charAt(F)===p}return k.charAt(k.length-1)!==p&&(k+=p),y.indexOf(k)===0}function f(y){return y>=r.CharCode.A&&y<=r.CharCode.Z||y>=r.CharCode.a&&y<=r.CharCode.z}function i(y,k){return C.$j&&y.endsWith(":")&&(y+=h.sep),(0,h.$ic)(y)||(y=(0,h.$jc)(k,y)),y=(0,h.$hc)(y),s(y)}function s(y){return C.$j?(y=(0,R.$nf)(y,h.sep),y.endsWith(":")&&(y+=h.sep)):(y=(0,R.$nf)(y,h.sep),y||(y=h.sep)),y}function t(y){const k=(0,h.$hc)(y);return C.$j?y.length>3?!1:o(k)&&(y.length===2||k.charCodeAt(2)===r.CharCode.Backslash):k===h.$gc.sep}function o(y,k=C.$j){return k?f(y.charCodeAt(0))&&y.charCodeAt(1)===r.CharCode.Colon:!1}function n(y,k=C.$j){return o(y,k)?y[0]:void 0}function d(y,k,A){return k.length>y.length?-1:y===k?0:(A&&(y=y.toLowerCase(),k=k.toLowerCase()),y.indexOf(k))}function l(y){const k=y.split(":");let A,p,v;for(const F of k){const N=Number(F);(0,L.$ig)(N)?p===void 0?p=N:v===void 0&&(v=N):A=A?[A,F].join(":"):F}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:p!==void 0?p:void 0,column:v!==void 0?v:p!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,k,A=8){let p="";for(let F=0;F<A;F++){let N;F===0&&C.$j&&!k&&(A===3||A===4)?N=E:N=g,p+=N.charAt(Math.floor(Math.random()*N.length))}let v;return k?v=`${k}-${p}`:v=p,y?(0,h.$jc)(y,v):v}}),define(ke[135],Ie([1,0,26,28,179,12]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=L,e.$Ik=b,e.$Jk=c,e.$Kk=u,e.$Lk=D,e.$Mk=y,e.$Nk=N,e.$Ok=O,e.$Pk=j,e.$Qk=z,e.$Rk=se,e.$Tk=oe,e.$Uk=pe,e.$Vk=be,R=qe(R);function L(...Ae){return function(De,Ce){for(let W=0,H=Ae.length;W<H;W++){const X=Ae[W](De,Ce);if(X)return X}return null}}e.$Gk=T.bind(void 0,!1),e.$Hk=T.bind(void 0,!0);function T(Ae,De,Ce){if(!Ce||Ce.length<De.length)return null;let W;return Ae?W=R.$Gf(Ce,De):W=Ce.indexOf(De)===0,W?De.length>0?[{start:0,end:De.length}]:[]:null}function b(Ae,De){const Ce=De.toLowerCase().indexOf(Ae.toLowerCase());return Ce===-1?null:[{start:Ce,end:Ce+Ae.length}]}function c(Ae,De){return I(Ae.toLowerCase(),De.toLowerCase(),0,0)}function I(Ae,De,Ce,W){if(Ce===Ae.length)return[];if(W===De.length)return null;if(Ae[Ce]===De[W]){let H=null;return(H=I(Ae,De,Ce+1,W+1))?t({start:W,end:W+1},H):null}return I(Ae,De,Ce,W+1)}function S(Ae){return r.CharCode.a<=Ae&&Ae<=r.CharCode.z}function u(Ae){return r.CharCode.A<=Ae&&Ae<=r.CharCode.Z}function P(Ae){return r.CharCode.Digit0<=Ae&&Ae<=r.CharCode.Digit9}function w(Ae){return Ae===r.CharCode.Space||Ae===r.CharCode.Tab||Ae===r.CharCode.LineFeed||Ae===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ae=>a.add(Ae.charCodeAt(0)));function m(Ae){return w(Ae)||a.has(Ae)}function $(Ae,De){return Ae===De||m(Ae)&&m(De)}const f=new Map;function i(Ae){if(f.has(Ae))return f.get(Ae);let De;const Ce=(0,C.$Ek)(Ae);return Ce&&(De=Ce),f.set(Ae,De),De}function s(Ae){return S(Ae)||u(Ae)||P(Ae)}function t(Ae,De){return De.length===0?De=[Ae]:Ae.end===De[0].start?De[0].start=Ae.start:De.unshift(Ae),De}function o(Ae,De){for(let Ce=De;Ce<Ae.length;Ce++){const W=Ae.charCodeAt(Ce);if(u(W)||P(W)||Ce>0&&!s(Ae.charCodeAt(Ce-1)))return Ce}return Ae.length}function n(Ae,De,Ce,W){if(Ce===Ae.length)return[];if(W===De.length)return null;if(Ae[Ce]!==De[W].toLowerCase())return null;{let H=null,X=W+1;for(H=n(Ae,De,Ce+1,W+1);!H&&(X=o(De,X))<De.length;)H=n(Ae,De,Ce+1,X),X++;return H===null?null:t({start:W,end:W+1},H)}}function d(Ae){let De=0,Ce=0,W=0,H=0,X=0;for(let He=0;He<Ae.length;He++)X=Ae.charCodeAt(He),u(X)&&De++,S(X)&&Ce++,s(X)&&W++,P(X)&&H++;const Z=De/Ae.length,de=Ce/Ae.length,ve=W/Ae.length,Oe=H/Ae.length;return{upperPercent:Z,lowerPercent:de,alphaPercent:ve,numericPercent:Oe}}function l(Ae){const{upperPercent:De,lowerPercent:Ce}=Ae;return Ce===0&&De>.6}function g(Ae){const{upperPercent:De,lowerPercent:Ce,alphaPercent:W,numericPercent:H}=Ae;return Ce>.2&&De<.8&&W>.6&&H<.2}function E(Ae){let De=0,Ce=0,W=0,H=0;for(let X=0;X<Ae.length;X++)W=Ae.charCodeAt(X),u(W)&&De++,S(W)&&Ce++,w(W)&&H++;return(De===0||Ce===0)&&H===0?Ae.length<=30:De<=5}function D(Ae,De){if(!De||(De=De.trim(),De.length===0)||!E(Ae))return null;De.length>60&&(De=De.substring(0,60));const Ce=d(De);if(!g(Ce)){if(!l(Ce))return null;De=De.toLowerCase()}let W=null,H=0;for(Ae=Ae.toLowerCase();H<De.length&&(W=n(Ae,De,0,H))===null;)H=o(De,H+1);return W}function y(Ae,De,Ce=!1){if(!De||De.length===0)return null;let W=null,H=0;for(Ae=Ae.toLowerCase(),De=De.toLowerCase();H<De.length&&(W=k(Ae,De,0,H,Ce),W===null);)H=A(De,H+1);return W}function k(Ae,De,Ce,W,H){let X=0;if(Ce===Ae.length)return[];if(W===De.length)return null;if(!$(Ae.charCodeAt(Ce),De.charCodeAt(W))){const ve=i(Ae.charCodeAt(Ce));if(!ve)return null;for(let Oe=0;Oe<ve.length;Oe++)if(!$(ve[Oe],De.charCodeAt(W+Oe)))return null;X+=ve.length-1}let Z=null,de=W+X+1;if(Z=k(Ae,De,Ce+1,de,H),!H)for(;!Z&&(de=A(De,de))<De.length;)Z=k(Ae,De,Ce+1,de,H),de++;if(!Z)return null;if(Ae.charCodeAt(Ce)!==De.charCodeAt(W)){const ve=i(Ae.charCodeAt(Ce));if(!ve)return Z;for(let Oe=0;Oe<ve.length;Oe++)if(ve[Oe]!==De.charCodeAt(W+Oe))return Z}return t({start:W,end:W+X+1},Z)}function A(Ae,De){for(let Ce=De;Ce<Ae.length;Ce++)if(m(Ae.charCodeAt(Ce))||Ce>0&&m(Ae.charCodeAt(Ce-1)))return Ce;return Ae.length}const p=L(e.$Hk,D,b),v=L(e.$Hk,D,c),F=new h.$Dc(1e4);function N(Ae,De,Ce=!1){if(typeof Ae!="string"||typeof De!="string")return null;let W=F.get(Ae);W||(W=new RegExp(R.$of(Ae),"i"),F.set(Ae,W));const H=W.exec(De);return H?[{start:H.index,end:H.index+H[0].length}]:Ce?v(Ae,De):p(Ae,De)}function O(Ae,De){const Ce=oe(Ae,Ae.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ce?z(Ce):null}function j(Ae,De,Ce,W,H,X){const Z=Math.min(13,Ae.length);for(;Ce<Z;Ce++){const de=oe(Ae,De,Ce,W,H,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,X]}function z(Ae){if(typeof Ae>"u")return[];const De=[],Ce=Ae[1];for(let W=Ae.length-1;W>1;W--){const H=Ae[W]+Ce,X=De[De.length-1];X&&X.end===H?X.end=H+1:De.push({start:H,end:H+1})}return De}const M=128;function U(){const Ae=[],De=[];for(let Ce=0;Ce<=M;Ce++)De[Ce]=0;for(let Ce=0;Ce<=M;Ce++)Ae.push(De.slice(0));return Ae}function V(Ae){const De=[];for(let Ce=0;Ce<=Ae;Ce++)De[Ce]=0;return De}const ie=V(2*M),B=V(2*M),Y=U(),J=U(),_=U(),le=!1;function re(Ae,De,Ce,W,H){function X(de,ve,Oe=" "){for(;de.length<ve;)de=Oe+de;return de}let Z=` |   |${W.split("").map(de=>X(de,3)).join("|")}
`;for(let de=0;de<=Ce;de++)de===0?Z+=" |":Z+=`${De[de-1]}|`,Z+=Ae[de].slice(0,H+1).map(ve=>X(ve.toString(),3)).join("|")+`
`;return Z}function Se(Ae,De,Ce,W){Ae=Ae.substr(De),Ce=Ce.substr(W),console.log(re(J,Ae,Ae.length,Ce,Ce.length)),console.log(re(_,Ae,Ae.length,Ce,Ce.length)),console.log(re(Y,Ae,Ae.length,Ce,Ce.length))}function me(Ae,De){if(De<0||De>=Ae.length)return!1;const Ce=Ae.codePointAt(De);switch(Ce){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Yf(Ce)}}function Q(Ae,De){if(De<0||De>=Ae.length)return!1;switch(Ae.charCodeAt(De)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function q(Ae,De,Ce){return De[Ae]!==Ce[Ae]}function se(Ae,De,Ce,W,H,X,Z=!1){for(;De<Ce&&H<X;)Ae[De]===W[H]&&(Z&&(ie[De]=H),De+=1),H+=1;return De===Ce}var we;(function(Ae){Ae[Ae.Diag=1]="Diag",Ae[Ae.Left=2]="Left",Ae[Ae.LeftLeft=3]="LeftLeft"})(we||(we={}));var ee;(function(Ae){Ae.Default=[-100,0];function De(Ce){return!Ce||Ce.length===2&&Ce[0]===-100&&Ce[1]===0}Ae.isDefault=De})(ee||(e.FuzzyScore=ee={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Ce){this.firstMatchCanBeWeak=De,this.boostFullMatch=Ce}}e.$Sk=ae;function oe(Ae,De,Ce,W,H,X,Z=ae.default){const de=Ae.length>M?M:Ae.length,ve=W.length>M?M:W.length;if(Ce>=de||X>=ve||de-Ce>ve-X||!se(De,Ce,de,H,X,ve,!0))return;x(de,ve,Ce,X,De,H);let Oe=1,He=1,Ke=Ce,_e=X;const nt=[!1];for(Oe=1,Ke=Ce;Ke<de;Oe++,Ke++){const ht=ie[Ke],ct=B[Ke],Pe=Ke+1<de?B[Ke+1]:ve;for(He=ht-X+1,_e=ht;_e<Pe;He++,_e++){let Be=Number.MIN_SAFE_INTEGER,Ye=!1;_e<=ct&&(Be=ne(Ae,De,Ke,Ce,W,H,_e,ve,X,Y[Oe-1][He-1]===0,nt));let Ne=0;Be!==Number.MAX_SAFE_INTEGER&&(Ye=!0,Ne=Be+J[Oe-1][He-1]);const je=_e>ht,ue=je?J[Oe][He-1]+(Y[Oe][He-1]>0?-5:0):0,he=_e>ht+1&&Y[Oe][He-1]>0,ce=he?J[Oe][He-2]+(Y[Oe][He-2]>0?-5:0):0;if(he&&(!je||ce>=ue)&&(!Ye||ce>=Ne))J[Oe][He]=ce,_[Oe][He]=we.LeftLeft,Y[Oe][He]=0;else if(je&&(!Ye||ue>=Ne))J[Oe][He]=ue,_[Oe][He]=we.Left,Y[Oe][He]=0;else if(Ye)J[Oe][He]=Ne,_[Oe][He]=we.Diag,Y[Oe][He]=Y[Oe-1][He-1]+1;else throw new Error("not possible")}}if(le&&Se(Ae,Ce,W,X),!nt[0]&&!Z.firstMatchCanBeWeak)return;Oe--,He--;const st=[J[Oe][He],X];let rt=0,at=0;for(;Oe>=1;){let ht=He;do{const ct=_[Oe][ht];if(ct===we.LeftLeft)ht=ht-2;else if(ct===we.Left)ht=ht-1;else break}while(ht>=1);rt>1&&De[Ce+Oe-1]===H[X+He-1]&&!q(ht+X-1,W,H)&&rt+1>Y[Oe][ht]&&(ht=He),ht===He?rt++:rt=1,at||(at=ht),Oe--,He=ht-1,st.push(He)}ve-X===de&&Z.boostFullMatch&&(st[0]+=2);const gt=at-de;return st[0]-=gt,st}function x(Ae,De,Ce,W,H,X){let Z=Ae-1,de=De-1;for(;Z>=Ce&&de>=W;)H[Z]===X[de]&&(B[Z]=de,Z--),de--}function ne(Ae,De,Ce,W,H,X,Z,de,ve,Oe,He){if(De[Ce]!==X[Z])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return Z===Ce-W?Ke=Ae[Ce]===H[Z]?7:5:q(Z,H,X)&&(Z===0||!q(Z-1,H,X))?(Ke=Ae[Ce]===H[Z]?7:5,_e=!0):me(X,Z)&&(Z===0||!me(X,Z-1))?Ke=5:(me(X,Z-1)||Q(X,Z-1))&&(Ke=5,_e=!0),Ke>1&&Ce===W&&(He[0]=!0),_e||(_e=q(Z,H,X)||me(X,Z-1)||Q(X,Z-1)),Ce===W?Z>ve&&(Ke-=_e?3:5):Oe?Ke+=_e?2:0:Ke+=_e?0:1,Z+1===de&&(Ke-=_e?3:5),Ke}function pe(Ae,De,Ce,W,H,X,Z){return Fe(Ae,De,Ce,W,H,X,!0,Z)}function be(Ae,De,Ce,W,H,X,Z){return Fe(Ae,De,Ce,W,H,X,!1,Z)}function Fe(Ae,De,Ce,W,H,X,Z,de){let ve=oe(Ae,De,Ce,W,H,X,de);if(ve&&!Z)return ve;if(Ae.length>=3){const Oe=Math.min(7,Ae.length-1);for(let He=Ce+1;He<Oe;He++){const Ke=ze(Ae,He);if(Ke){const _e=oe(Ke,Ke.toLowerCase(),Ce,W,H,X,de);_e&&(_e[0]-=3,(!ve||_e[0]>ve[0])&&(ve=_e))}}}return ve}function ze(Ae,De){if(De+1>=Ae.length)return;const Ce=Ae[De],W=Ae[De+1];if(Ce!==W)return Ae.slice(0,De)+W+Ce+Ae.slice(De+2)}}),define(ke[60],Ie([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$wj=void 0,e.$sj=h,e.$tj=C,e.$uj=R,e.$vj=T,e.$xj=a,r=qe(r);function h($){return C($,0)}function C($,f){switch(typeof $){case"object":return $===null?R(349,f):Array.isArray($)?b($,f):c($,f);case"string":return T($,f);case"boolean":return L($,f);case"number":return R($,f);case"undefined":return R(937,f);default:return R(617,f)}}function R($,f){return(f<<5)-f+$|0}function L($,f){return R($?433:863,f)}function T($,f){f=R(149417,f);for(let i=0,s=$.length;i<s;i++)f=R($.charCodeAt(i),f);return f}function b($,f){return f=R(104579,f),$.reduce((i,s)=>C(s,i),f)}function c($,f){return f=R(181387,f),Object.keys($).sort().reduce((i,s)=>(i=T(s,i),C($[s],i)),f)}class I{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=C(f,this.g),this.g}}e.$wj=I;var S;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function u($,f,i=32){const s=i-f,t=~((1<<s)-1);return($<<f|(t&$)>>>s)>>>0}function P($,f=0,i=$.byteLength,s=0){for(let t=0;t<i;t++)$[f+t]=s}function w($,f,i="0"){for(;$.length<f;)$=i+$;return $}function a($,f=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(i=>i.toString(16).padStart(2,"0")).join(""):w(($>>>0).toString(16),f/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(S.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const i=f.length;if(i===0)return;const s=this.p;let t=this.r,o=this.u,n,d;for(o!==0?(n=o,d=-1,o=0):(n=f.charCodeAt(0),d=0);;){let l=n;if(r.$Jf(n))if(d+1<i){const g=f.charCodeAt(d+1);r.$Kf(g)?(d++,l=r.$Lf(n,g)):l=S.UNICODE_REPLACEMENT}else{o=n;break}else r.$Kf(n)&&(l=S.UNICODE_REPLACEMENT);if(t=this.w(s,t,l),d++,d<i)n=f.charCodeAt(d);else break}this.r=t,this.u=o}w(f,i,s){return s<128?f[i++]=s:s<2048?(f[i++]=192|(s&1984)>>>6,f[i++]=128|(s&63)>>>0):s<65536?(f[i++]=224|(s&61440)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0):(f[i++]=240|(s&1835008)>>>18,f[i++]=128|(s&258048)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0),i>=S.BLOCK_SIZE&&(this.y(),i-=S.BLOCK_SIZE,this.t+=S.BLOCK_SIZE,f[0]=f[S.BLOCK_SIZE+0],f[1]=f[S.BLOCK_SIZE+1],f[2]=f[S.BLOCK_SIZE+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,S.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=m.g,i=this.q;for(let D=0;D<64;D+=4)f.setUint32(D,i.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)f.setUint32(D,u(f.getUint32(D-12,!1)^f.getUint32(D-32,!1)^f.getUint32(D-56,!1)^f.getUint32(D-64,!1),1),!1);let s=this.h,t=this.l,o=this.m,n=this.n,d=this.o,l,g,E;for(let D=0;D<80;D++)D<20?(l=t&o|~t&n,g=1518500249):D<40?(l=t^o^n,g=1859775393):D<60?(l=t&o|t&n|o&n,g=2400959708):(l=t^o^n,g=3395469782),E=u(s,5)+l+d+g+f.getUint32(D*4,!1)&4294967295,d=n,n=o,o=u(t,30),t=s,s=E;this.h=this.h+s&4294967295,this.l=this.l+t&4294967295,this.m=this.m+o&4294967295,this.n=this.n+n&4294967295,this.o=this.o+d&4294967295}}e.$yj=m}),define(ke[136],Ie([1,0,26,134,135,60,16,10,12]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=S,e.$Nr=$,e.$Or=l,e.$Pr=p,e.$Qr=z,e.$Rr=U;const c=0,I=[c,[]];function S(V,ie,B,Y){if(!V||!ie)return I;const J=V.length,_=ie.length;if(J<_)return I;const le=V.toLowerCase();return u(ie,B,_,V,le,J,Y)}function u(V,ie,B,Y,J,_,le){const re=[],Se=[];for(let se=0;se<B;se++){const we=se*_,ee=we-_,ae=se>0,oe=V[se],x=ie[se];for(let ne=0;ne<_;ne++){const pe=ne>0,be=we+ne,Fe=be-1,ze=ee+ne-1,Ae=pe?re[Fe]:0,De=ae&&pe?re[ze]:0,Ce=ae&&pe?Se[ze]:0;let W;!De&&ae?W=0:W=P(oe,x,Y,J,ne,Ce),W&&De+W>=Ae&&(le||ae||J.startsWith(ie,ne))?(Se[be]=Ce+1,re[be]=De+W):(Se[be]=c,re[be]=Ae)}}const me=[];let Q=B-1,q=_-1;for(;Q>=0&&q>=0;){const se=Q*_+q;Se[se]===c||(me.push(q),Q--),q--}return[re[B*_-1],me.reverse()]}function P(V,ie,B,Y,J,_){let le=0;if(!w(ie,Y[J]))return le;if(le+=1,_>0&&(le+=_*5),V===B[J]&&(le+=1),J===0)le+=8;else{const re=a(B.charCodeAt(J-1));re?le+=re:(0,C.$Kk)(B.charCodeAt(J))&&_===0&&(le+=2)}return le}function w(V,ie){return V===ie?!0:V==="/"||V==="\\"?ie==="/"||ie==="\\":!1}function a(V){switch(V){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function $(V,ie,B=0,Y=0){const J=ie;return J.values&&J.values.length>1?f(V,J.values,B,Y):i(V,ie,B,Y)}function f(V,ie,B,Y){let J=0;const _=[];for(const le of ie){const[re,Se]=i(V,le,B,Y);if(typeof re!="number")return m;J+=re,_.push(...Se)}return[J,k(_)]}function i(V,ie,B,Y){const J=(0,C.$Tk)(ie.original,ie.originalLowercase,B,V,V.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,C.$Qk)(J)]:m}const s=Object.freeze({score:0}),t=1<<18,o=1<<17,n=65536;function d(V,ie,B,Y){const J=Y.values?Y.values:[Y];return(0,R.$sj)({[Y.normalized]:{values:J.map(le=>({value:le.normalized,expectContiguousMatch:le.expectContiguousMatch})),label:V,description:ie,allowNonContiguousMatches:B}})}function l(V,ie,B,Y,J){if(!V||!ie.normalized)return s;const _=Y.getItemLabel(V);if(!_)return s;const le=Y.getItemDescription(V),re=d(_,le,B,ie),Se=J[re];if(Se)return Se;const me=g(_,le,Y.getItemPath(V),ie,B);return J[re]=me,me}function g(V,ie,B,Y,J){const _=!B||!Y.containsPathSeparator;return B&&(T.$l?Y.pathNormalized===B:(0,b.$Ff)(Y.pathNormalized,B))?{score:t,labelMatch:[{start:0,end:V.length}],descriptionMatch:ie?[{start:0,end:ie.length}]:void 0}:Y.values&&Y.values.length>1?E(V,ie,B,Y.values,_,J):D(V,ie,B,Y,_,J)}function E(V,ie,B,Y,J,_){let le=0;const re=[],Se=[];for(const me of Y){const{score:Q,labelMatch:q,descriptionMatch:se}=D(V,ie,B,me,J,_);if(Q===c)return s;le+=Q,q&&re.push(...q),se&&Se.push(...se)}return{score:le,labelMatch:k(re),descriptionMatch:k(Se)}}function D(V,ie,B,Y,J,_){if(J||!ie){const[le,re]=S(V,Y.normalized,Y.normalizedLowercase,_&&!Y.expectContiguousMatch);if(le){const Se=(0,C.$Hk)(Y.normalized,V);let me;if(Se){me=o;const Q=Math.round(Y.normalized.length/V.length*100);me+=Q}else me=n;return{score:me+le,labelMatch:Se||y(re)}}}if(ie){let le=ie;B&&(le=`${ie}${L.sep}`);const re=le.length,Se=`${le}${V}`,[me,Q]=S(Se,Y.normalized,Y.normalizedLowercase,_&&!Y.expectContiguousMatch);if(me){const q=y(Q),se=[],we=[];return q.forEach(ee=>{ee.start<re&&ee.end>re?(se.push({start:0,end:ee.end-re}),we.push({start:ee.start,end:re})):ee.start>=re?se.push({start:ee.start-re,end:ee.end-re}):we.push(ee)}),{score:me,labelMatch:se,descriptionMatch:we}}}return s}function y(V){const ie=[];if(!V)return ie;let B;for(const Y of V)B&&B.end===Y?B.end+=1:(B={start:Y,end:Y+1},ie.push(B));return ie}function k(V){const ie=V.sort((J,_)=>J.start-_.start),B=[];let Y;for(const J of ie)!Y||!A(Y,J)?(Y=J,B.push(J)):(Y.start=Math.min(Y.start,J.start),Y.end=Math.max(Y.end,J.end));return B}function A(V,ie){return!(V.end<ie.start||ie.end<V.start)}function p(V,ie,B,Y,J,_){const le=l(V,B,Y,J,_),re=l(ie,B,Y,J,_),Se=le.score,me=re.score;if((Se===t||me===t)&&Se!==me)return Se===t?-1:1;if(Se>n||me>n){if(Se!==me)return Se>me?-1:1;if(Se<o&&me<o){const oe=F(le.labelMatch,re.labelMatch);if(oe!==0)return oe}const ee=J.getItemLabel(V)||"",ae=J.getItemLabel(ie)||"";if(ee.length!==ae.length)return ee.length-ae.length}if(Se!==me)return Se>me?-1:1;const Q=Array.isArray(le.labelMatch)&&le.labelMatch.length>0,q=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(Q&&!q)return-1;if(q&&!Q)return 1;const se=v(V,le,J),we=v(ie,re,J);return se&&we&&se!==we?we>se?-1:1:N(V,ie,B,J)}function v(V,ie,B){let Y=-1,J=-1;if(ie.descriptionMatch&&ie.descriptionMatch.length?Y=ie.descriptionMatch[0].start:ie.labelMatch&&ie.labelMatch.length&&(Y=ie.labelMatch[0].start),ie.labelMatch&&ie.labelMatch.length){if(J=ie.labelMatch[ie.labelMatch.length-1].end,ie.descriptionMatch&&ie.descriptionMatch.length){const _=B.getItemDescription(V);_&&(J+=_.length)}}else ie.descriptionMatch&&ie.descriptionMatch.length&&(J=ie.descriptionMatch[ie.descriptionMatch.length-1].end);return J-Y}function F(V,ie){if(!V&&!ie||(!V||!V.length)&&(!ie||!ie.length))return 0;if(!ie||!ie.length)return-1;if(!V||!V.length)return 1;const B=V[0].start,J=V[V.length-1].end-B,_=ie[0].start,re=ie[ie.length-1].end-_;return J===re?0:re<J?1:-1}function N(V,ie,B,Y){const J=Y.getItemLabel(V)||"",_=Y.getItemLabel(ie)||"",le=Y.getItemDescription(V),re=Y.getItemDescription(ie),Se=J.length+(le?le.length:0),me=_.length+(re?re.length:0);if(Se!==me)return Se-me;const Q=Y.getItemPath(V),q=Y.getItemPath(ie);return Q&&q&&Q.length!==q.length?Q.length-q.length:J!==_?(0,h.$Kr)(J,_,B.normalized):le&&re&&le!==re?(0,h.$Kr)(le,re,B.normalized):Q&&q&&Q!==q?(0,h.$Kr)(Q,q,B.normalized):0}function O(V){return V.startsWith('"')&&V.endsWith('"')}const j=" ";function z(V){typeof V!="string"&&(V="");const ie=V.toLowerCase(),{pathNormalized:B,normalized:Y,normalizedLowercase:J}=M(V),_=B.indexOf(L.sep)>=0,le=O(V);let re;const Se=V.split(j);if(Se.length>1)for(const me of Se){const Q=O(me),{pathNormalized:q,normalized:se,normalizedLowercase:we}=M(me);se&&(re||(re=[]),re.push({original:me,originalLowercase:me.toLowerCase(),pathNormalized:q,normalized:se,normalizedLowercase:we,expectContiguousMatch:Q}))}return{original:V,originalLowercase:ie,pathNormalized:B,normalized:Y,normalizedLowercase:J,values:re,containsPathSeparator:_,expectContiguousMatch:le}}function M(V){let ie;T.$j?ie=V.replace(/\//g,L.sep):ie=V.replace(/\\/g,L.sep);const B=(0,b.$pf)(ie).replace(/\s|"/g,"");return{pathNormalized:ie,normalized:B,normalizedLowercase:B.toLowerCase()}}function U(V){return Array.isArray(V)?z(V.map(ie=>ie.original).join(j)):z(V.original)}}),define(ke[137],Ie([1,0,135,12,50]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=b,e.$Xk=I,e.$Yk=u,e.$Zk=P,e.$1k=a,e.$2k=m;const R="$(",L=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${L.source}`,"g");function b($){return $.replace(T,(f,i)=>i?f:`\\${f}`)}const c=new RegExp(`\\\\${L.source}`,"g");function I($){return $.replace(c,f=>`\\${f}`)}const S=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function u($){return $.indexOf(R)===-1?$:$.replace(S,(f,i,s,t)=>s?f:i||t||"")}function P($){return $?$.replace(/\$\((.*?)\)/g,(f,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function a($){w.lastIndex=0;let f="";const i=[];let s=0;for(;;){const t=w.lastIndex,o=w.exec($),n=$.substring(t,o?.index);if(n.length>0){f+=n;for(let d=0;d<n.length;d++)i.push(s)}if(!o)break;s+=o[0].length}return{text:f,iconOffsets:i}}function m($,f,i=!1){const{text:s,iconOffsets:t}=f;if(!t||t.length===0)return(0,r.$Nk)($,s,i);const o=(0,h.$mf)(s," "),n=s.length-o.length,d=(0,r.$Nk)($,o,i);if(d)for(const l of d){const g=t[l.start+n]+n;l.start+=g,l.end+=g}return d}}),define(ke[43],Ie([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=qe(r);var h;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(h||(h={})),function(C){const R="error",L="warning",T="warn",b="info",c="ignore";function I(u){return u?r.$Ff(R,u)?C.Error:r.$Ff(L,u)||r.$Ff(T,u)?C.Warning:r.$Ff(b,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=I;function S(u){switch(u){case C.Error:return R;case C.Warning:return L;case C.Info:return b;default:return c}}C.toString=S}(h||(h={})),e.default=h}),define(ke[84],Ie([1,0,18,26,12]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const a=w.charCodeAt(0),m=this.b.charCodeAt(this.c);return a-m}value(){return this.b[this.c]}}e.$Gi=R;class L{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,C.$zf)(w,this.b,0,w.length,this.c,this.d):(0,C.$Bf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=L;class T{constructor(w=!0,a=!0){this.f=w,this.g=a}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let a=w.length-1;a>=0;a--,this.c--){const m=this.b.charCodeAt(a);if(!(m===h.CharCode.Slash||this.f&&m===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===h.CharCode.Slash||this.f&&a===h.CharCode.Backslash)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,C.$zf)(w,this.b,0,w.length,this.d,this.e):(0,C.$Bf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=T;var b;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(b||(b={}));class c{constructor(w,a){this.f=w,this.g=a,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new T(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(b.Path)),this.g(w)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===b.Scheme)return(0,C.$Af)(w,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,C.$Af)(w,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(w);if(this.d[this.e]===b.Query)return(0,C.$yf)(w,this.c.query);if(this.d[this.e]===b.Fragment)return(0,C.$yf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Ji=c;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(S||(S={}));class u{static forUris(w=()=>!1,a=()=>!1){return new u(new c(w,a))}static forPaths(w=!1){return new u(new T(void 0,!w))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new L)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,a){if(a){const m=a.slice(0);(0,r.$Vb)(m);for(const $ of m)this.set($,w)}else{const m=w.slice(0);(0,r.$Vb)(m);for(const $ of m)this.set($[0],$[1])}}set(w,a){const m=this.b.reset(w);let $;this.c||(this.c=new I,this.c.segment=m.value());const f=[];for($=this.c;;){const s=m.cmp($.segment);if(s>0)$.left||($.left=new I,$.left.segment=m.value()),f.push([S.Left,$]),$=$.left;else if(s<0)$.right||($.right=new I,$.right.segment=m.value()),f.push([S.Right,$]),$=$.right;else if(m.hasNext())m.next(),$.mid||($.mid=new I,$.mid.segment=m.value()),f.push([S.Mid,$]),$=$.mid;else break}const i=$.value;$.value=a,$.key=w;for(let s=f.length-1;s>=0;s--){const t=f[s][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const n=f[s][0],d=f[s+1][0];if(n===S.Right&&d===S.Right)f[s][1]=t.rotateLeft();else if(n===S.Left&&d===S.Left)f[s][1]=t.rotateRight();else if(n===S.Right&&d===S.Left)t.right=f[s+1][1]=f[s+1][1].rotateRight(),f[s][1]=t.rotateLeft();else if(n===S.Left&&d===S.Right)t.left=f[s+1][1]=f[s+1][1].rotateLeft(),f[s][1]=t.rotateRight();else throw new Error;if(s>0)switch(f[s-1][0]){case S.Left:f[s-1][1].left=f[s][1];break;case S.Right:f[s-1][1].right=f[s][1];break;case S.Mid:f[s-1][1].mid=f[s][1];break}else this.c=f[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const a=this.b.reset(w);let m=this.c;for(;m;){const $=a.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else break}return m}has(w){const a=this.d(w);return!(a?.value===void 0&&a?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,a){const m=this.b.reset(w),$=[];let f=this.c;for(;f;){const i=m.cmp(f.segment);if(i>0)$.push([S.Left,f]),f=f.left;else if(i<0)$.push([S.Right,f]),f=f.right;else if(m.hasNext())m.next(),$.push([S.Mid,f]),f=f.mid;else break}if(f){if(a?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const i=this.f(f.right);if(i.key){const{key:s,value:t,segment:o}=i;this.e(i.key,!1),f.key=s,f.value=t,f.segment=o}}else{const i=f.left??f.right;if($.length>0){const[s,t]=$[$.length-1];switch(s){case S.Left:t.left=i;break;case S.Mid:t.mid=i;break;case S.Right:t.right=i;break}}else this.c=i}for(let i=$.length-1;i>=0;i--){const s=$[i][1];s.updateHeight();const t=s.balanceFactor();if(t>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),$[i][1]=s.rotateLeft()):t<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),$[i][1]=s.rotateRight()),i>0)switch($[i-1][0]){case S.Left:$[i-1][1].left=$[i][1];break;case S.Right:$[i-1][1].right=$[i][1];break;case S.Mid:$[i-1][1].mid=$[i][1];break}else this.c=$[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const a=this.b.reset(w);let m=this.c,$;for(;m;){const f=a.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(a.hasNext())a.next(),$=m.value||$,m=m.mid;else break}return m&&m.value||$}findSuperstr(w){return this.g(w,!1)}g(w,a){const m=this.b.reset(w);let $=this.c;for(;$;){const f=m.cmp($.segment);if(f>0)$=$.left;else if(f<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else return $.mid?this.h($.mid):a?$.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[a,m]of this)w(m,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const a=[];return this.j(w,a),a[Symbol.iterator]()}j(w,a){w&&(w.left&&this.j(w.left,a),w.value&&a.push([w.key,w.value]),w.mid&&this.j(w.mid,a),w.right&&this.j(w.right,a))}_isBalanced(){const w=a=>{if(!a)return!0;const m=a.balanceFactor();return m<-1||m>1?!1:w(a.left)&&w(a.right)};return w(this.c)}}e.$Ki=u}),define(ke[2],Ie([1,0,26,40,16,10]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=m,e.$wc=o,C=qe(C);const L=/^\w[\w\d+.-]*$/,T=/^\//,b=/^\/\//;function c(E,D){if(!E.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!L.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!T.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(E,D){return!E&&!D?"file":E}function S(E,D){switch(E){case"https":case"http":case"file":D?D[0]!==P&&(D=P+D):D=P;break}return D}const u="",P="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(D){return D instanceof a?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,y,k,A,p,v=!1){typeof D=="object"?(this.scheme=D.scheme||u,this.authority=D.authority||u,this.path=D.path||u,this.query=D.query||u,this.fragment=D.fragment||u):(this.scheme=I(D,v),this.authority=y||u,this.path=S(this.scheme,k||u),this.query=A||u,this.fragment=p||u,c(this,v))}get fsPath(){return o(this,!1)}with(D){if(!D)return this;let{scheme:y,authority:k,path:A,query:p,fragment:v}=D;return y===void 0?y=this.scheme:y===null&&(y=u),k===void 0?k=this.authority:k===null&&(k=u),A===void 0?A=this.path:A===null&&(A=u),p===void 0?p=this.query:p===null&&(p=u),v===void 0?v=this.fragment:v===null&&(v=u),y===this.scheme&&k===this.authority&&A===this.path&&p===this.query&&v===this.fragment?this:new f(y,k,A,p,v)}static parse(D,y=!1){const k=w.exec(D);return k?new f(k[2]||u,g(k[4]||u),g(k[5]||u),g(k[7]||u),g(k[9]||u),y):new f(u,u,u,u,u)}static file(D){let y=u;if(R.$j&&(D=D.replace(/\\/g,P)),D[0]===P&&D[1]===P){const k=D.indexOf(P,2);k===-1?(y=D.substring(2),D=P):(y=D.substring(2,k),D=D.substring(k)||P)}return new f("file",y,D,u,u)}static from(D,y){return new f(D.scheme,D.authority,D.path,D.query,D.fragment,y)}static joinPath(D,...y){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return R.$j&&D.scheme==="file"?k=a.file(C.$fc.join(o(D,!0),...y)).path:k=C.$gc.join(D.path,...y),D.with({path:k})}toString(D=!1){return n(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof a)return D;{const y=new f(D);return y._formatted=D.external??null,y._fsPath=D._sep===$?D.fsPath??null:null,y}}else return D}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=a;function m(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const $=R.$j?1:void 0;class f extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(D=!1){return D?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const D={$mid:h.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=$),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const i={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function s(E,D,y){let k,A=-1;for(let p=0;p<E.length;p++){const v=E.charCodeAt(p);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||D&&v===r.CharCode.Slash||y&&v===r.CharCode.OpenSquareBracket||y&&v===r.CharCode.CloseSquareBracket||y&&v===r.CharCode.Colon)A!==-1&&(k+=encodeURIComponent(E.substring(A,p)),A=-1),k!==void 0&&(k+=E.charAt(p));else{k===void 0&&(k=E.substr(0,p));const F=i[v];F!==void 0?(A!==-1&&(k+=encodeURIComponent(E.substring(A,p)),A=-1),k+=F):A===-1&&(A=p)}}return A!==-1&&(k+=encodeURIComponent(E.substring(A))),k!==void 0?k:E}function t(E){let D;for(let y=0;y<E.length;y++){const k=E.charCodeAt(y);k===r.CharCode.Hash||k===r.CharCode.QuestionMark?(D===void 0&&(D=E.substr(0,y)),D+=i[k]):D!==void 0&&(D+=E[y])}return D!==void 0?D:E}function o(E,D){let y;return E.authority&&E.path.length>1&&E.scheme==="file"?y=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===r.CharCode.Slash&&(E.path.charCodeAt(1)>=r.CharCode.A&&E.path.charCodeAt(1)<=r.CharCode.Z||E.path.charCodeAt(1)>=r.CharCode.a&&E.path.charCodeAt(1)<=r.CharCode.z)&&E.path.charCodeAt(2)===r.CharCode.Colon?D?y=E.path.substr(1):y=E.path[1].toLowerCase()+E.path.substr(2):y=E.path,R.$j&&(y=y.replace(/\//g,"\\")),y}function n(E,D){const y=D?t:s;let k="",{scheme:A,authority:p,path:v,query:F,fragment:N}=E;if(A&&(k+=A,k+=":"),(p||A==="file")&&(k+=P,k+=P),p){let O=p.indexOf("@");if(O!==-1){const j=p.substr(0,O);p=p.substr(O+1),O=j.lastIndexOf(":"),O===-1?k+=y(j,!1,!1):(k+=y(j.substr(0,O),!1,!1),k+=":",k+=y(j.substr(O+1),!1,!0)),k+="@"}p=p.toLowerCase(),O=p.lastIndexOf(":"),O===-1?k+=y(p,!1,!0):(k+=y(p.substr(0,O),!1,!0),k+=p.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const O=v.charCodeAt(1);O>=r.CharCode.A&&O<=r.CharCode.Z&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const O=v.charCodeAt(0);O>=r.CharCode.A&&O<=r.CharCode.Z&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}k+=y(v,!0,!1)}return F&&(k+="?",k+=y(F,!1,!1)),N&&(k+="#",k+=D?N:s(N,!1,!1)),k}function d(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+d(E.substr(3)):E}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(E){return E.match(l)?E.replace(l,D=>d(D)):E}}),define(ke[188],Ie([1,0,2]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=h,e.$dr=C,e.$er=R,e.log=T;function h(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function C(c){const I=[];let S;try{const u=JSON.parse(c.arguments),P=u[u.length-1];P&&P.__$stack&&(u.pop(),S=P.__$stack),I.push(...u)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:S}}function R(c){if(typeof c!="string")return R(C(c).stack);const I=c;if(I){const S=L(I),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function L(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function T(c,I){const{args:S,stack:u}=C(c),P=typeof S[0]=="string"&&S.length===1;let w=L(u);w&&(w=`(${w.trim()})`);let a=[];if(typeof S[0]=="string"?w&&P?a=[`%c[${I}] %c${S[0]} %c${w}`,b("blue"),b(""),b("grey")]:a=[`%c[${I}] %c${S[0]}`,b("blue"),b(""),...S.slice(1)]:a=[`%c[${I}]%`,b("blue"),...S],w&&!P&&a.push(w),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,a)}function b(c){return`color: ${c}`}}),define(ke[51],Ie([1,0,21,2,40]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=R,e.$ai=L,e.$bi=b;function R(c){return JSON.stringify(c,T)}function L(c){let I=JSON.parse(c);return I=b(I),I}function T(c,I){return I instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function b(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case C.MarshalledId.Uri:return h.URI.revive(c);case C.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case C.MarshalledId.Date:return new Date(c.source)}if(c instanceof r.$Ne||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let S=0;S<c.length;++S)c[S]=b(c[S],I+1);else for(const S in c)Object.hasOwnProperty.call(c,S)&&(c[S]=b(c[S],I+1))}return c}}),define(ke[14],Ie([1,0,13,10,12,2,16]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=b,e.$Og=c,e.$Sg=S,r=qe(r),h=qe(h),L=qe(L);var T;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",w.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(T||(e.Schemas=T={}));function b(w,a){return R.URI.isUri(w)?(0,C.$Ff)(w.scheme,a):(0,C.$Gf)(w,a+":")}function c(w,...a){return a.some(m=>b(w,m))}e.$Pg="vscode-tkn",e.$Qg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=S(a,m)}getServerRootPath(){return this.f}get g(){return L.$gc.join(this.f,T.vscodeRemoteResource)}set(a,m,$){this.a[a]=m,this.b[a]=$}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(t){return r.$Y(t),a}const m=a.authority;let $=this.a[m];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const f=this.b[m],i=this.c[m];let s=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(s+=`&${e.$Qg}=${encodeURIComponent(i)}`),R.URI.from({scheme:h.$p?this.d:T.vscodeRemoteResource,authority:`${$}:${f}`,path:this.g,query:s})}}e.$Rg=new I;function S(w,a){return L.$gc.join(a??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class u{static{this.a=e.$Xg}asBrowserUri(a){const m=this.b(a,$e);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===T.vscodeRemote?e.$Rg.rewrite(a):a.scheme===T.file&&(h.$n||h.$r===`${T.vscodeFileResource}://${u.a}`)?a.with({scheme:T.vscodeFileResource,authority:a.authority||u.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,$e);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===T.vscodeFileResource?a.with({scheme:T.file,authority:a.authority!==u.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return R.URI.isUri(a)?a:R.URI.parse(m.toUrl(a))}}e.$Yg=new u;var P;(function(w){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function $(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:R.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const t=s?.get(m);if(t)return a.get(t)}w.getHeadersFromQuery=$;function f(i,s,t){if(!globalThis.crossOriginIsolated)return;const o=s&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(m,o):i[m]=o}w.addSearchParam=f})(P||(e.COI=P={}))}),define(ke[189],Ie([1,0,174,14,10,17,2]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BE=S,e.$CE=u,C=qe(C);class T{constructor(w,a,m){this.id=w,this.dependencies=a,this.callback=m}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,a,m)=>{typeof w!="string"&&(m=a,a=w,w=null),(typeof a!="object"||!Array.isArray(a))&&(m=a,a=null),this.c.push(new T(w,a,m))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const a=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!a)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(w){return new Promise((a,m)=>{const $=document.createElement("script");$.setAttribute("async","async"),$.setAttribute("type","text/javascript");const f=()=>{$.removeEventListener("load",i),$.removeEventListener("error",s)},i=t=>{f(),a(this.c.pop())},s=t=>{f(),m(t)};$.addEventListener("load",i),$.addEventListener("error",s),this.f&&(w=this.f.createScriptURL(w)),$.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild($)})}i(w){return new Promise((a,m)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),a(this.c.pop())}catch($){m($)}})}async j(w){try{const a=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,$=globalThis._VSCODE_NODE_MODULES.module,f=L.URI.parse(w).fsPath,i=a.readFileSync(f).toString(),s=$.wrap(i.replace(/^#!.*/,""));return new m.Script(s).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const c=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function S(P,w,a){if(r.$R){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[P]&&(P=I[P]);const m=w?`${P}/${w}`:P;if(c.has(m))return c.get(m);let $;if(/^\w[\w\d+.-]*:\/\//.test(m))$=m;else{const t=`${a&&!C.$p?h.$Vg:h.$Ug}/${m}`;$=h.$Yg.asBrowserUri(t).toString(!0)}const f=b.INSTANCE.load($);return c.set(m,f),f}else return await new Promise((m,$)=>{$e([P],m,$)}).then(qe)}function u(P,w){(0,R.$og)(r.$R);const $=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!C.$p,f=`${P}/${w}`,s=`${$?h.$Vg:h.$Ug}/${f}`;return h.$Yg.asBrowserUri(s).toString(!0)}}),define(ke[22],Ie([1,0,26,31,14,16,10,12,2]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=c,e.$oh=S,e.$ph=P,h=qe(h),R=qe(R);function c(w){return(0,b.$wc)(w,!0)}class I{constructor(a){this.a=a}compare(a,m,$=!1){return a===m?0:(0,T.$yf)(this.getComparisonKey(a,$),this.getComparisonKey(m,$))}isEqual(a,m,$=!1){return a===m?!0:!a||!m?!1:this.getComparisonKey(a,$)===this.getComparisonKey(m,$)}getComparisonKey(a,m=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,m,$=!1){if(a.scheme===m.scheme){if(a.scheme===C.Schemas.file)return h.$Dg(c(a),c(m),this.a(a))&&a.query===m.query&&($||a.fragment===m.fragment);if((0,e.$kh)(a.authority,m.authority))return h.$Dg(a.path,m.path,this.a(a),"/")&&a.query===m.query&&($||a.fragment===m.fragment)}return!1}joinPath(a,...m){return b.URI.joinPath(a,...m)}basenameOrAuthority(a){return(0,e.$ch)(a)||a.authority}basename(a){return R.$gc.basename(a.path)}extname(a){return R.$gc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let m;return a.scheme===C.Schemas.file?m=b.URI.file(R.$mc(c(a))).path:(m=R.$gc.dirname(a.path),a.authority&&m.length&&m.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),m="/")),a.with({path:m})}normalizePath(a){if(!a.path.length)return a;let m;return a.scheme===C.Schemas.file?m=b.URI.file(R.$hc(c(a))).path:m=R.$gc.normalize(a.path),a.with({path:m})}relativePath(a,m){if(a.scheme!==m.scheme||!(0,e.$kh)(a.authority,m.authority))return;if(a.scheme===C.Schemas.file){const i=R.$lc(c(a),c(m));return L.$j?h.$xg(i):i}let $=a.path||"/";const f=m.path||"/";if(this.a(a)){let i=0;for(const s=Math.min($.length,f.length);i<s&&!($.charCodeAt(i)!==f.charCodeAt(i)&&$.charAt(i).toLowerCase()!==f.charAt(i).toLowerCase());i++);$=f.substr(0,i)+$.substr(i)}return R.$gc.relative($,f)}resolvePath(a,m){if(a.scheme===C.Schemas.file){const $=b.URI.file(R.$kc(c(a),m));return a.with({authority:$.authority,path:$.path})}return m=h.$yg(m),a.with({path:R.$gc.resolve(a.path,m)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,m){return a===m||a!==void 0&&m!==void 0&&(0,T.$Ff)(a,m)}hasTrailingPathSeparator(a,m=R.sep){if(a.scheme===C.Schemas.file){const $=c(a);return $.length>h.$zg($).length&&$[$.length-1]===m}else{const $=a.path;return $.length>1&&$.charCodeAt($.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,m=R.sep){return(0,e.$lh)(a,m)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,m=R.sep){let $=!1;if(a.scheme===C.Schemas.file){const f=c(a);$=f!==void 0&&f.length===h.$zg(f).length&&f[f.length-1]===m}else{m="/";const f=a.path;$=f.length===1&&f.charCodeAt(f.length-1)===r.CharCode.Slash}return!$&&!(0,e.$lh)(a,m)?a.with({path:a.path+"/"}):a}}e.$7g=I,e.$8g=new I(()=>!1),e.$9g=new I(w=>w.scheme===C.Schemas.file?!L.$l:!0),e.$0g=new I(w=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function S(w,a){const m=[];for(let $=0;$<w.length;$++){const f=a(w[$]);w.some((i,s)=>s===$?!1:(0,e.$_g)(f,a(i)))||m.push(w[$])}return m}var u;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function a(m){const $=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(s=>{const[t,o]=s.split(":");t&&o&&$.set(t,o)});const i=m.path.substring(0,m.path.indexOf(";"));return i&&$.set(w.META_DATA_MIME,i),$}w.parseMetaData=a})(u||(e.DataUri=u={}));function P(w,a,m){if(a){let $=w.path;return $&&$[0]!==R.$gc.sep&&($=R.$gc.sep+$),w.with({scheme:m,authority:a,path:$})}return w.with({scheme:m})}}),define(ke[7],Ie([1,0,20,13,4,3,22,10,186,49]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=I,e.$rh=S,e.$sh=u,e.$th=P,e.$uh=w,e.$vh=a,e.$wh=m,e.$xh=$,e.$Fh=E,e.$Gh=D,e.$Hh=y,e.$Ih=k,e.$Jh=A,e.$Yh=Y,e.$7h=ee;function I(oe){return!!oe&&typeof oe.then=="function"}function S(oe){const x=new r.$we,ne=oe(x.token),pe=new Promise((be,Fe)=>{const ze=x.token.onCancellationRequested(()=>{ze.dispose(),Fe(new h.$4)});Promise.resolve(ne).then(Ae=>{ze.dispose(),x.dispose(),be(Ae)},Ae=>{ze.dispose(),x.dispose(),Fe(Ae)})});return new class{cancel(){x.cancel(),x.dispose()}then(be,Fe){return pe.then(be,Fe)}catch(be){return this.then(void 0,be)}finally(be){return pe.finally(be)}}}function u(oe,x,ne){return new Promise((pe,be)=>{const Fe=x.onCancellationRequested(()=>{Fe.dispose(),pe(ne)});oe.then(pe,be).finally(()=>Fe.dispose())})}function P(oe,x){return new Promise((ne,pe)=>{const be=x.onCancellationRequested(()=>{be.dispose(),pe(new h.$4)});oe.then(ne,pe).finally(()=>be.dispose())})}async function w(oe){let x=-1;const ne=oe.map((pe,be)=>pe.then(Fe=>(x=be,Fe)));try{return await Promise.race(ne)}finally{oe.forEach((pe,be)=>{be!==x&&pe.cancel()})}}function a(oe,x,ne){let pe;const be=setTimeout(()=>{pe?.(void 0),ne?.()},x);return Promise.race([oe.finally(()=>clearTimeout(be)),new Promise(Fe=>pe=Fe)])}function m(oe){return new Promise((x,ne)=>{const pe=oe();I(pe)?pe.then(x,ne):x(pe)})}function $(){let oe,x;return{promise:new Promise((pe,be)=>{oe=pe,x=be}),resolve:oe,reject:x}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(x){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=x,!this.b){const ne=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(ne,ne).then(pe)})}return new Promise((ne,pe)=>{this.b.then(ne,pe)})}return this.a=x(),new Promise((ne,pe)=>{this.a.then(be=>{this.a=null,ne(be)},be=>{this.a=null,pe(be)})})}dispose(){this.f=!0}}e.$yh=f;class i{constructor(){this.a=Promise.resolve(null)}queue(x){return this.a=this.a.then(()=>x(),()=>x())}}e.$zh=i;class s{constructor(){this.a=new Map}queue(x,ne){const be=(this.a.get(x)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(x)===be&&this.a.delete(x)});return this.a.set(x,be),be}}e.$Ah=s;const t=(oe,x)=>{let ne=!0;const pe=setTimeout(()=>{ne=!1,x()},oe);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(pe),ne=!1}}},o=oe=>{let x=!0;return queueMicrotask(()=>{x&&(x=!1,oe())}),{isTriggered:()=>x,dispose:()=>{x=!1}}};class n{constructor(x){this.defaultDelay=x,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(x,ne=this.defaultDelay){this.g=x,this.h(),this.b||(this.b=new Promise((be,Fe)=>{this.d=be,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=ne===b.$ge?o(pe):t(ne,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=n;class d{constructor(x){this.a=new n(x),this.b=new f}trigger(x,ne){return this.a.trigger(()=>this.b.queue(x),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=d;class l{constructor(){this.a=!1,this.b=new Promise((x,ne)=>{this.d=x})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=l;class g extends l{constructor(x){super(),this.f=setTimeout(()=>this.open(),x)}open(){clearTimeout(this.f),super.open()}}e.$Eh=g;function E(oe,x){return x?new Promise((ne,pe)=>{const be=setTimeout(()=>{Fe.dispose(),ne()},oe),Fe=x.onCancellationRequested(()=>{clearTimeout(be),Fe.dispose(),pe(new h.$4)})}):S(ne=>E(oe,ne))}function D(oe,x=0,ne){const pe=setTimeout(()=>{oe(),ne&&be.dispose()},x),be=(0,R.$Sc)(()=>{clearTimeout(pe),ne?.deleteAndLeak(be)});return ne?.add(be),be}function y(oe){const x=[];let ne=0;const pe=oe.length;function be(){return ne<pe?oe[ne++]():null}function Fe(ze){ze!=null&&x.push(ze);const Ae=be();return Ae?Ae.then(Fe):Promise.resolve(x)}return Promise.resolve(null).then(Fe)}function k(oe,x=pe=>!!pe,ne=null){let pe=0;const be=oe.length,Fe=()=>{if(pe>=be)return Promise.resolve(ne);const ze=oe[pe++];return Promise.resolve(ze()).then(De=>x(De)?Promise.resolve(De):Fe())};return Fe()}function A(oe,x=pe=>!!pe,ne=null){if(oe.length===0)return Promise.resolve(ne);let pe=oe.length;const be=()=>{pe=-1;for(const Fe of oe)Fe.cancel?.()};return new Promise((Fe,ze)=>{for(const Ae of oe)Ae.then(De=>{--pe>=0&&x(De)?(be(),Fe(De)):pe===0&&Fe(ne)}).catch(De=>{--pe>=0&&(be(),ze(De))})})}class p{constructor(x){this.a=0,this.b=!1,this.f=x,this.g=[],this.d=0,this.h=new C.$le}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(x){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,pe)=>{this.g.push({factory:x,c:ne,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const x=this.g.shift();this.d++;const ne=x.factory();ne.then(x.c,x.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=p;class v extends p{constructor(){super(1)}}e.$Lh=v;class F{constructor(){this.a=new J,this.b=0}queue(x){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,x())):this.a.run(this.b++,x())}}e.$Mh=F;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const x=new re;return this.b.add(x),x.p}g(){for(const[,x]of this.a)if(x.size>0)return!1;return!0}queueSize(x,ne=L.$8g){const pe=ne.getComparisonKey(x);return this.a.get(pe)?.size??0}queueFor(x,ne,pe=L.$8g){const be=pe.getComparisonKey(x);let Fe=this.a.get(be);if(!Fe){Fe=new v;const ze=this.f++,Ae=C.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(ze,Ae),this.a.set(be,Fe)}return Fe.queue(ne)}h(){this.g()&&this.j()}j(){for(const x of this.b)x.complete();this.b.clear()}dispose(){for(const[,x]of this.a)x.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=N;class O{constructor(x,ne){this.b=!1,this.a=-1,typeof x=="function"&&typeof ne=="number"&&this.setIfNotSet(x,ne)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(x,ne){if(this.b)throw new h.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,x()},ne)}setIfNotSet(x,ne){if(this.b)throw new h.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,x()},ne))}}e.$Oh=O;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(x,ne,pe=globalThis){if(this.f)throw new h.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=pe.setInterval(()=>{x()},ne);this.d=(0,R.$Sc)(()=>{pe.clearInterval(be),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=j;class z{constructor(x,ne){this.b=-1,this.a=x,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(x=this.d){this.cancel(),this.b=setTimeout(this.f,x)}get delay(){return this.d}set delay(x){this.d=x}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=z;class M{constructor(x,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=x,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(x=this.b){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(x/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=M;class U extends z{constructor(x,ne){super(x,ne),this.j=[]}work(x){this.j.push(x),this.isScheduled()||this.schedule()}h(){const x=this.j;this.j=[],this.a?.(x)}dispose(){this.j=[],super.dispose()}}e.$Sh=U;class V extends R.$Uc{constructor(x,ne){super(),this.g=x,this.h=ne,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(x){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+x.length>this.g.maxBufferedWork)return!1}else if(this.pending+x.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of x)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(oe,x)=>{(0,T.$C)(()=>{if(ne)return;const pe=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$Vh=(oe,x,ne)=>{const pe=oe.requestIdleCallback(x,typeof ne=="number"?{timeout:ne}:void 0);let be=!1;return{dispose(){be||(be=!0,oe.cancelIdleCallback(pe))}}},e.$Uh=oe=>(0,e.$Vh)(globalThis,oe)}();class ie{constructor(x,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Vh)(x,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=ie;class B extends ie{constructor(x){super(globalThis,x)}}e.$Xh=B;async function Y(oe,x,ne){let pe;for(let be=0;be<ne;be++)try{return await oe()}catch(Fe){pe=Fe,await E(x)}throw pe}class J{isRunning(x){return typeof x=="number"?this.a?.taskId===x:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(x,ne,pe){return this.a={taskId:x,cancel:()=>pe?.(),promise:ne},ne.then(()=>this.d(x),()=>this.d(x)),ne}d(x){this.a&&x===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const x=this.b;this.b=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}queue(x){if(this.b)this.b.run=x;else{const{promise:ne,resolve:pe,reject:be}=$();this.b={run:x,promise:ne,promiseResolve:pe,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=J;class _{constructor(x,ne=()=>Date.now()){this.d=x,this.f=ne,this.a=0,this.b=0}increment(){const x=this.f();return x-this.a>this.d&&(this.a=x,this.b=0),this.b++,this.b}}e.$1h=_;var le;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(le||(le={}));class re{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((x,ne)=>{this.a=x,this.b=ne})}complete(x){return new Promise(ne=>{this.a(x),this.d={outcome:le.Resolved,value:x},ne()})}error(x){return new Promise(ne=>{this.b(x),this.d={outcome:le.Rejected,value:x},ne()})}cancel(){return this.error(new h.$4)}}e.$2h=re;var Se;(function(oe){async function x(pe){let be;const Fe=await Promise.all(pe.map(ze=>ze.then(Ae=>Ae,Ae=>{be||(be=Ae)})));if(typeof be<"u")throw be;return Fe}oe.settled=x;function ne(pe){return new Promise(async(be,Fe)=>{try{await pe(be,Fe)}catch(ze){Fe(ze)}})}oe.withAsyncBody=ne})(Se||(e.Promises=Se={}));class me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(x){this.a=void 0,this.b=void 0,this.d=!1,this.promise=x.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new h.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=me;class Q{constructor(x){this.b=x,this.a=new c.$T(()=>new me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=Q;var q;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(q||(q={}));class se{static fromArray(x){return new se(ne=>{ne.emitMany(x)})}static fromPromise(x){return new se(async ne=>{ne.emitMany(await x)})}static fromPromises(x){return new se(async ne=>{await Promise.all(x.map(async pe=>ne.emitOne(await pe)))})}static merge(x){return new se(async ne=>{await Promise.all(x.map(async pe=>{for await(const be of pe)ne.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(x,ne){this.a=q.Initial,this.b=[],this.d=null,this.f=ne,this.g=new C.$le,queueMicrotask(async()=>{const pe={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(x(pe)),this.k()}catch(be){this.l(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let x=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(x<this.b.length)return{done:!1,value:this.b[x++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(x,ne){return new se(async pe=>{for await(const be of x)pe.emitOne(ne(be))})}map(x){return se.map(this,x)}static filter(x,ne){return new se(async pe=>{for await(const be of x)ne(be)&&pe.emitOne(be)})}filter(x){return se.filter(this,x)}static coalesce(x){return se.filter(x,ne=>!!ne)}coalesce(){return se.coalesce(this)}static async toPromise(x){const ne=[];for await(const pe of x)ne.push(pe);return ne}toPromise(){return se.toPromise(this)}h(x){this.a===q.Initial&&(this.b.push(x),this.g.fire())}j(x){this.a===q.Initial&&(this.b=this.b.concat(x),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(x){this.a===q.Initial&&(this.a=q.DoneError,this.d=x,this.g.fire())}}e.$5h=se;class we extends se{constructor(x,ne){super(ne),this.m=x}cancel(){this.m.cancel()}}e.$6h=we;function ee(oe){const x=new r.$we,ne=oe(x.token);return new we(x,async pe=>{const be=x.token.onCancellationRequested(()=>{be.dispose(),x.dispose(),pe.reject(new h.$4)});try{for await(const Fe of ne){if(x.token.isCancellationRequested)return;pe.emitOne(Fe)}be.dispose(),x.dispose()}catch(Fe){be.dispose(),x.dispose(),pe.reject(Fe)}})}class ae{constructor(x){this.a=new re,this.b=new se(be=>{if(ne){be.reject(ne);return}return pe&&be.emitMany(pe),this.d=Fe=>be.reject(Fe),this.f=Fe=>be.emitOne(Fe),this.a.p},x);let ne,pe;this.f=be=>{pe||(pe=[]),pe.push(be)},this.d=be=>{ne||(ne=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(x){this.d(x),this.a.complete()}emitOne(x){this.f(x)}}e.$8h=ae}),define(ke[38],Ie([1,0,18,7,26,31,28,16,10,12]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=I,e.$xk=a,e.$yk=F,e.$zk=N,e.$Ak=O,e.$Bk=j,e.$Ck=z,e.$Dk=ie;function I(){return Object.create(null)}e.$vk="**",e.$wk="/";const S="[/\\\\]",u="[^/\\\\]",P=/\//g;function w(B,Y){switch(B){case 0:return"";case 1:return`${u}*?`;default:return`(?:${S}|${u}+${S}${Y?`|${S}${u}+`:""})*?`}}function a(B,Y){if(!B)return[];const J=[];let _=!1,le=!1,re="";for(const Se of B){switch(Se){case Y:if(!_&&!le){J.push(re),re="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":le=!0;break;case"]":le=!1;break}re+=Se}return re&&J.push(re),J}function m(B){if(!B)return"";let Y="";const J=a(B,e.$wk);if(J.every(_=>_===e.$vk))Y=".*";else{let _=!1;J.forEach((le,re)=>{if(le===e.$vk){if(_)return;Y+=w(2,re===J.length-1)}else{let Se=!1,me="",Q=!1,q="";for(const se of le){if(se!=="}"&&Se){me+=se;continue}if(Q&&(se!=="]"||!q)){let we;se==="-"?we=se:(se==="^"||se==="!")&&!q?we="^":se===e.$wk?we="":we=(0,c.$hf)(se),q+=we;continue}switch(se){case"{":Se=!0;continue;case"[":Q=!0;continue;case"}":{const ee=`(?:${a(me,",").map(ae=>m(ae)).join("|")})`;Y+=ee,Se=!1,me="";break}case"]":{Y+="["+q+"]",Q=!1,q="";break}case"?":Y+=u;continue;case"*":Y+=w(1);continue;default:Y+=(0,c.$hf)(se)}}re<J.length-1&&(J[re+1]!==e.$vk||re+2<J.length)&&(Y+=S)}_=le===e.$vk})}return Y}const $=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.$Dc(1e4),d=function(){return!1},l=function(){return null};function g(B,Y){if(!B)return l;let J;typeof B!="string"?J=B.pattern:J=B,J=J.trim();const _=`${J}_${!!Y.trimForExclusions}`;let le=n.get(_);if(le)return E(le,B);let re;return $.test(J)?le=y(J.substr(4),J):(re=f.exec(D(J,Y)))?le=k(re[1],J):(Y.trimForExclusions?s:i).test(J)?le=A(J,Y):(re=t.exec(D(J,Y)))?le=p(re[1].substr(1),J,!0):(re=o.exec(D(J,Y)))?le=p(re[1],J,!1):le=v(J),n.set(_,le),E(le,B)}function E(B,Y){if(typeof Y=="string")return B;const J=function(_,le){return(0,R.$Dg)(_,Y.base,!b.$l)?B((0,c.$mf)(_.substr(Y.base.length),T.sep),le):null};return J.allBasenames=B.allBasenames,J.allPaths=B.allPaths,J.basenames=B.basenames,J.patterns=B.patterns,J}function D(B,Y){return Y.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function y(B,Y){return function(J,_){return typeof J=="string"&&J.endsWith(B)?Y:null}}function k(B,Y){const J=`/${B}`,_=`\\${B}`,le=function(Se,me){return typeof Se!="string"?null:me?me===B?Y:null:Se===B||Se.endsWith(J)||Se.endsWith(_)?Y:null},re=[B];return le.basenames=re,le.patterns=[Y],le.allBasenames=re,le}function A(B,Y){const J=V(B.slice(1,-1).split(",").map(me=>g(me,Y)).filter(me=>me!==l),B),_=J.length;if(!_)return l;if(_===1)return J[0];const le=function(me,Q){for(let q=0,se=J.length;q<se;q++)if(J[q](me,Q))return B;return null},re=J.find(me=>!!me.allBasenames);re&&(le.allBasenames=re.allBasenames);const Se=J.reduce((me,Q)=>Q.allPaths?me.concat(Q.allPaths):me,[]);return Se.length&&(le.allPaths=Se),le}function p(B,Y,J){const _=T.sep===T.$gc.sep,le=_?B:B.replace(P,T.sep),re=T.sep+le,Se=T.$gc.sep+B;let me;return J?me=function(Q,q){return typeof Q=="string"&&(Q===le||Q.endsWith(re)||!_&&(Q===B||Q.endsWith(Se)))?Y:null}:me=function(Q,q){return typeof Q=="string"&&(Q===le||!_&&Q===B)?Y:null},me.allPaths=[(J?"*/":"./")+B],me}function v(B){try{const Y=new RegExp(`^${m(B)}$`);return function(J){return Y.lastIndex=0,typeof J=="string"&&Y.test(J)?B:null}}catch{return l}}function F(B,Y,J){return!B||typeof Y!="string"?!1:N(B)(Y,void 0,J)}function N(B,Y={}){if(!B)return d;if(typeof B=="string"||O(B)){const J=g(B,Y);if(J===l)return d;const _=function(le,re){return!!J(le,re)};return J.allBasenames&&(_.allBasenames=J.allBasenames),J.allPaths&&(_.allPaths=J.allPaths),_}return M(B,Y)}function O(B){const Y=B;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}function j(B){return B.allBasenames||[]}function z(B){return B.allPaths||[]}function M(B,Y){const J=V(Object.getOwnPropertyNames(B).map(me=>U(me,B[me],Y)).filter(me=>me!==l)),_=J.length;if(!_)return l;if(!J.some(me=>!!me.requiresSiblings)){if(_===1)return J[0];const me=function(se,we){let ee;for(let ae=0,oe=J.length;ae<oe;ae++){const x=J[ae](se,we);if(typeof x=="string")return x;(0,h.$qh)(x)&&(ee||(ee=[]),ee.push(x))}return ee?(async()=>{for(const ae of ee){const oe=await ae;if(typeof oe=="string")return oe}return null})():null},Q=J.find(se=>!!se.allBasenames);Q&&(me.allBasenames=Q.allBasenames);const q=J.reduce((se,we)=>we.allPaths?se.concat(we.allPaths):se,[]);return q.length&&(me.allPaths=q),me}const le=function(me,Q,q){let se,we;for(let ee=0,ae=J.length;ee<ae;ee++){const oe=J[ee];oe.requiresSiblings&&q&&(Q||(Q=(0,T.$nc)(me)),se||(se=Q.substr(0,Q.length-(0,T.$oc)(me).length)));const x=oe(me,Q,se,q);if(typeof x=="string")return x;(0,h.$qh)(x)&&(we||(we=[]),we.push(x))}return we?(async()=>{for(const ee of we){const ae=await ee;if(typeof ae=="string")return ae}return null})():null},re=J.find(me=>!!me.allBasenames);re&&(le.allBasenames=re.allBasenames);const Se=J.reduce((me,Q)=>Q.allPaths?me.concat(Q.allPaths):me,[]);return Se.length&&(le.allPaths=Se),le}function U(B,Y,J){if(Y===!1)return l;const _=g(B,J);if(_===l)return l;if(typeof Y=="boolean")return _;if(Y){const le=Y.when;if(typeof le=="string"){const re=(Se,me,Q,q)=>{if(!q||!_(Se,me))return null;const se=le.replace("$(basename)",()=>Q),we=q(se);return(0,h.$qh)(we)?we.then(ee=>ee?B:null):we?B:null};return re.requiresSiblings=!0,re}}return _}function V(B,Y){const J=B.filter(me=>!!me.basenames);if(J.length<2)return B;const _=J.reduce((me,Q)=>{const q=Q.basenames;return q?me.concat(q):me},[]);let le;if(Y){le=[];for(let me=0,Q=_.length;me<Q;me++)le.push(Y)}else le=J.reduce((me,Q)=>{const q=Q.patterns;return q?me.concat(q):me},[]);const re=function(me,Q){if(typeof me!="string")return null;if(!Q){let se;for(se=me.length;se>0;se--){const we=me.charCodeAt(se-1);if(we===C.CharCode.Slash||we===C.CharCode.Backslash)break}Q=me.substr(se)}const q=_.indexOf(Q);return q!==-1?le[q]:null};re.basenames=_,re.patterns=le,re.allBasenames=_;const Se=B.filter(me=>!me.basenames);return Se.push(re),Se}function ie(B,Y){return(0,r.$tb)(B,Y,(J,_)=>typeof J=="string"&&typeof _=="string"?J===_:typeof J!="string"&&typeof _!="string"?J.base===_.base&&J.pattern===_.pattern:!1)}}),define(ke[85],Ie([1,0,13,137,22,12,2]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=c,e.$5k=I,e.$6k=S,e.$7k=u,e.$8k=P,e.$9k=w,e.$0k=a,e.$$k=m;var T;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class b{constructor(f="",i=!1){if(this.value=f,typeof this.value!="string")throw(0,r.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(f,i=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Wk)(f):f).replace(/([ \t]+)/g,(s,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,i){return this.value+=`
${P(i,f)}
`,this}appendLink(f,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(f),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(f,i){const s=new RegExp((0,R.$hf)(i),"g");return f.replace(s,(t,o)=>f.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$3k=b;function c($){return I($)?!$.value:Array.isArray($)?$.every(c):!0}function I($){return $ instanceof b?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}function S($,f){return $===f?!0:!$||!f?!1:$.value===f.value&&$.isTrusted===f.isTrusted&&$.supportThemeIcons===f.supportThemeIcons&&$.supportHtml===f.supportHtml&&($.baseUri===f.baseUri||!!$.baseUri&&!!f.baseUri&&(0,C.$$g)(L.URI.from($.baseUri),L.URI.from(f.baseUri)))}function u($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P($,f){const i=$.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${f}`,$,`${"`".repeat(s)}`].join(`
`)}function w($){return $.replace(/"/g,"&quot;")}function a($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m($){const f=[],i=$.split("|").map(t=>t.trim());$=i[0];const s=i[1];if(s){const t=/height=(\d+)/.exec(s),o=/width=(\d+)/.exec(s),n=t?t[1]:"",d=o?o[1]:"",l=isFinite(parseInt(d)),g=isFinite(parseInt(n));l&&f.push(`width="${d}"`),g&&f.push(`height="${n}"`)}return{href:$,dimensions:f}}}),define(ke[107],Ie([1,0,18,31,16,10,22,12]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yw=b,e.$Zw=I,e.$1w=u,e.$2w=P,e.$3w=$,e.$4w=i,e.$5w=s,e.$6w=t,e.$7w=o,e.$8w=n;function b(l,g){const{os:E,tildify:D,relative:y}=g;if(y){const p=c(l,y,E);if(typeof p=="string")return p}let k=l.fsPath;if(E===R.OperatingSystem.Windows&&!R.$j?k=k.replace(/\//g,"\\"):E!==R.OperatingSystem.Windows&&R.$j&&(k=k.replace(/\\/g,"/")),E!==R.OperatingSystem.Windows&&D?.userHome){const p=D.userHome.fsPath;let v;l.scheme!==D.userHome.scheme&&l.path[0]===C.$gc.sep&&l.path[1]!==C.$gc.sep?v=D.userHome.with({path:l.path}).fsPath:v=k,k=u(v,p,E)}return(E===R.OperatingSystem.Windows?C.$fc:C.$gc).normalize(I(k,E===R.OperatingSystem.Windows))}function c(l,g,E){const D=E===R.OperatingSystem.Windows?C.$fc:C.$gc,y=E===R.OperatingSystem.Linux?L.$8g:L.$0g,k=g.getWorkspace(),A=(0,r.$Nb)(k.folders);if(!A)return;l.scheme!==A.uri.scheme&&l.path[0]===C.$gc.sep&&l.path[1]!==C.$gc.sep&&(l=A.uri.with({path:l.path}));const p=g.getWorkspaceFolder(l);if(!p)return;let v;if(y.isEqual(p.uri,l)?v="":v=y.relativePath(p.uri,l)??"",v&&(v=D.normalize(v)),k.folders.length>1&&!g.noPrefix){const F=p.name?p.name:y.basenameOrAuthority(p.uri);v=v?`${F} \u2022 ${v}`:F}return v}function I(l,g=R.$j){return(0,h.$Ig)(l,g)?l.charAt(0).toUpperCase()+l.slice(1):l}let S=Object.create(null);function u(l,g,E=R.OS){if(E===R.OperatingSystem.Windows||!l||!g)return l;let D=S.original===g?S.normalized:void 0;D||(D=g,R.$j&&(D=(0,h.$xg)(D)),D=`${(0,T.$nf)(D,C.$gc.sep)}${C.$gc.sep}`,S={original:g,normalized:D});let y=l;return R.$j&&(y=(0,h.$xg)(y)),(E===R.OperatingSystem.Linux?y.startsWith(D):(0,T.$Gf)(y,D))?`~/${y.substr(D.length)}`:l}function P(l,g){return l.replace(/^~($|\/|\\)/,`${g}$1`)}const w="\u2026",a="\\\\",m="~";function $(l,g=C.sep){const E=new Array(l.length);let D=!1;for(let y=0;y<l.length;y++){const k=l[y];if(k===""){E[y]=`.${g}`;continue}if(!k){E[y]=k;continue}D=!0;let A="",p=k;p.indexOf(a)===0?(A=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(g)===0?(A=p.substr(0,p.indexOf(g)+g.length),p=p.substr(p.indexOf(g)+g.length)):p.indexOf(m)===0&&(A=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length));const v=p.split(g);for(let F=1;D&&F<=v.length;F++)for(let N=v.length-F;D&&N>=0;N--){D=!1;let O=v.slice(N,N+F).join(g);for(let j=0;!D&&j<l.length;j++)if(j!==y&&l[j]&&l[j].indexOf(O)>-1){const z=N+F===v.length,M=N>0&&l[j].indexOf(g)>-1?g+O:O,U=l[j].endsWith(M);D=!z||U}if(!D){let j="";(v[0].endsWith(":")||A!=="")&&(N===1&&(N=0,F++,O=v[0]+g+O),N>0&&(j=v[0]+g),j=A+j),N>0&&(j=j+w+g),j=j+O,N+F<v.length&&(j=j+g+w),E[y]=j}}D&&(E[y]=k)}return E}var f;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function i(l,g=Object.create(null)){const E=[];let D=!1,y="";for(const k of l)if(k==="$"||D&&k==="{")y&&E.push({value:y,type:f.TEXT}),y="",D=!0;else if(k==="}"&&D){const A=g[y];if(typeof A=="string")A.length&&E.push({value:A,type:f.VARIABLE});else if(A){const p=E[E.length-1];(!p||p.type!==f.SEPARATOR)&&E.push({value:A.label,type:f.SEPARATOR})}y="",D=!1}else y+=k;return y&&!D&&E.push({value:y,type:f.TEXT}),E.filter((k,A)=>{if(k.type===f.SEPARATOR){const p=E[A-1],v=E[A+1];return[p,v].every(F=>F&&(F.type===f.VARIABLE||F.type===f.TEXT)&&F.value.length>0)}return!0}).map(k=>k.value).join("")}function s(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):l.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,""):R.$j?l.replace(/&&|&/g,E=>E==="&"?"&&":"&"):l.replace(/&&/g,"_")}function o(l){return l.replace(/&/g,"&&")}function n(l){if(l.endsWith("]")){const g=l.lastIndexOf(" [",l.length-2);if(g!==-1){const E=d(l.substring(0,g)),D=l.substring(g);return{name:E.name+D,parentPath:E.parentPath}}}return d(l)}function d(l){const g=l.indexOf("/")!==-1?C.$gc:C.$fc,E=g.basename(l),D=g.dirname(l);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(ke[138],Ie([1,0,21,40,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=b,e.$On=I,e.$Pn=S;function R(u){return u.toJSON()}class L{constructor(P){this.a=P}transformIncoming(P){const w=this.a.transformIncoming(P);return w===P?P:R(C.URI.from(w))}transformOutgoing(P){const w=this.a.transformOutgoing(P);return w===P?P:R(C.URI.from(w))}transformOutgoingURI(P){const w=this.a.transformOutgoing(P);return w===P?P:C.URI.from(w)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Ln=L,e.$Mn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,P,w){if(!u||w>200)return null;if(typeof u=="object"){if(u instanceof C.URI)return P.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const m=T(u[a],P,w+1);m!==null&&(u[a]=m)}}return null}function b(u,P){const w=T(u,P,0);return w===null?u:w}function c(u,P,w,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return w?C.URI.revive(P.transformIncoming(u)):P.transformIncoming(u);if(u instanceof r.$Ne)return null;for(const m in u)if(Object.hasOwnProperty.call(u,m)){const $=c(u[m],P,w,a+1);$!==null&&(u[m]=$)}}return null}function I(u,P){const w=c(u,P,!1,0);return w===null?u:w}function S(u,P){const w=c(u,P,!0,0);return w===null?u:w}}),define(ke[32],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(C){return r.test(C)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(T){for(let b=0;b<T.length;b++)T[b]=Math.floor(Math.random()*256);return T};const R=new Uint8Array(16),L=[];for(let T=0;T<256;T++)L.push(T.toString(16).padStart(2,"0"));return function(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let b=0,c="";return c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+="-",c+=L[R[b++]],c+=L[R[b++]],c+="-",c+=L[R[b++]],c+=L[R[b++]],c+="-",c+=L[R[b++]],c+=L[R[b++]],c+="-",c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c}}()}),define(ke[190],Ie([1,0,18,39,32]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.$qu=void 0,e.$ou=R,e.$pu=L,e.$ru=c;function R(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function L(S,u,P){const w={id:(0,C.$1g)(),name:S,uri:u,data:P};return{asString:async()=>"",asFile:()=>w,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const P of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const P=[...this.a.keys()];return h.Iterable.some(this,([w,a])=>a.asFile())&&P.push("files"),I(b(u),P)}get(u){return this.a.get(this.b(u))?.[0]}append(u,P){const w=this.a.get(u);w?w.push(P):this.a.set(this.b(u),[P])}replace(u,P){this.a.set(this.b(u),[P])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,P]of this.a)for(const w of P)yield[u,w]}b(u){return b(u)}}e.$qu=T;function b(S){return S.toLowerCase()}function c(S,u){return I(b(S),u.map(b))}function I(S,u){if(S==="*/*")return u.length>0;if(u.includes(S))return!0;const P=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[w,a,m]=P;return m==="*"?u.some($=>$.startsWith(a+"/")):!1}e.$su=Object.freeze({create:S=>(0,r.$Lb)(S.map(u=>u.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$su.split(S).filter(u=>!u.startsWith("#"))})}),define(ke[33],Ie([1,0,44,66,360,7,31,81,16,10,22,2]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=o,e.configureFlushOnWrite=E,e.writeFileSync=y,r=qe(r);var u;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function P(M,U=u.UNLINK,V){if((0,L.$Hg)(M))throw new Error("rimraf - will refuse to recursively delete root");return U===u.UNLINK?a(M):w(M,V)}async function w(M,U=(0,L.$Mg)((0,h.tmpdir)())){try{try{await r.promises.rename(M,U)}catch(V){return V.code==="ENOENT"?void 0:a(M)}a(U).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function a(M){return r.promises.rm(M,{recursive:!0,force:!0,maxRetries:3})}function m(M){if((0,L.$Hg)(M))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function $(M,U){return s(await(U?f(M):r.promises.readdir(M)))}async function f(M){try{return await r.promises.readdir(M,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const U=[],V=await $(M);for(const ie of V){let B=!1,Y=!1,J=!1;try{const _=await r.promises.lstat((0,b.$jc)(M,ie));B=_.isFile(),Y=_.isDirectory(),J=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}U.push({name:ie,isFile:()=>B,isDirectory:()=>Y,isSymbolicLink:()=>J})}return U}function i(M){return s(r.readdirSync(M))}function s(M){return M.map(U=>typeof U=="string"?c.$k?(0,T.$mm)(U):U:(U.name=c.$k?(0,T.$mm)(U.name):U.name,U))}async function t(M){const U=await $(M),V=[];for(const ie of U)await n.existsDirectory((0,b.$jc)(M,ie))&&V.push(ie);return V}function o(M,U=1e3){return new Promise(V=>{let ie=!1;const B=setInterval(()=>{ie||(ie=!0,r.access(M,Y=>{ie=!1,Y&&(clearInterval(B),V(void 0))}))},U)})}var n;(function(M){async function U(B){let Y;try{if(Y=await r.promises.lstat(B),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await r.promises.stat(B),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(c.$j&&J.code==="EACCES")try{return{stat:await r.promises.stat(await r.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw _}throw J}}M.stat=U;async function V(B){try{const{stat:Y,symbolicLink:J}=await M.stat(B);return Y.isFile()&&J?.dangling!==!0}catch{}return!1}M.existsFile=V;async function ie(B){try{const{stat:Y,symbolicLink:J}=await M.stat(B);return Y.isDirectory()&&J?.dangling!==!0}catch{}return!1}M.existsDirectory=ie})(n||(e.SymlinkSupport=n={}));const d=new R.$Nh;function l(M,U,V){return d.queueFor(S.URI.file(M),()=>{const ie=k(V);return new Promise((B,Y)=>D(M,U,ie,J=>J?Y(J):B()))},I.$9g)}let g=!0;function E(M){g=M}function D(M,U,V,ie){if(!g)return r.writeFile(M,U,{mode:V.mode,flag:V.flag},ie);r.open(M,V.flag,V.mode,(B,Y)=>{if(B)return ie(B);r.writeFile(Y,U,J=>{if(J)return r.close(Y,()=>ie(J));r.fdatasync(Y,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),E(!1)),r.close(Y,le=>ie(le))))})})}function y(M,U,V){const ie=k(V);if(!g)return r.writeFileSync(M,U,{mode:ie.mode,flag:ie.flag});const B=r.openSync(M,ie.flag,ie.mode);try{r.writeFileSync(B,U);try{r.fdatasyncSync(B)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),E(!1)}}finally{r.closeSync(B)}}function k(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,U,V=6e4){if(M!==U)try{c.$j&&typeof V=="number"?await p(M,U,Date.now(),V):await r.promises.rename(M,U)}catch(ie){if(M.toLowerCase()!==U.toLowerCase()&&ie.code==="EXDEV"||M.endsWith("."))await v(M,U,{preserveSymlinks:!1}),await P(M,u.MOVE);else throw ie}}async function p(M,U,V,ie,B=0){try{return await r.promises.rename(M,U)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-V>=ie)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${Y}`),Y;if(B===0){let J=!1;try{const{stat:_}=await n.stat(U);_.isFile()||(J=!0)}catch{}if(J)throw Y}return await(0,R.$Fh)(Math.min(100,B*10)),p(M,U,V,ie,B+1)}}async function v(M,U,V){return N(M,U,{root:{source:M,target:U},options:V,handledSourcePaths:new Set})}const F=511;async function N(M,U,V){if(V.handledSourcePaths.has(M))return;V.handledSourcePaths.add(M);const{stat:ie,symbolicLink:B}=await n.stat(M);if(B){if(V.options.preserveSymlinks)try{return await z(M,U,V)}catch{}if(B.dangling)return}return ie.isDirectory()?O(M,U,ie.mode&F,V):j(M,U,ie.mode&F)}async function O(M,U,V,ie){await r.promises.mkdir(U,{recursive:!0,mode:V});const B=await $(M);for(const Y of B)await N((0,b.$jc)(M,Y),(0,b.$jc)(U,Y),ie)}async function j(M,U,V){await r.promises.copyFile(M,U),await r.promises.chmod(U,V)}async function z(M,U,V){let ie=await r.promises.readlink(M);(0,L.$Dg)(ie,V.root.source,!c.$l)&&(ie=(0,b.$jc)(V.root.target,ie.substr(V.root.source.length+1))),await r.promises.symlink(ie,U)}e.Promises=new class{get read(){return(M,U,V,ie,B)=>new Promise((Y,J)=>{r.read(M,U,V,ie,B,(_,le,re)=>_?J(_):Y({bytesRead:le,buffer:re}))})}get write(){return(M,U,V,ie,B)=>new Promise((Y,J)=>{r.write(M,U,V,ie,B,(_,le,re)=>_?J(_):Y({bytesWritten:le,buffer:re}))})}get fdatasync(){return(0,C.promisify)(r.fdatasync)}get open(){return(0,C.promisify)(r.open)}get close(){return(0,C.promisify)(r.close)}get realpath(){return(0,C.promisify)(r.realpath)}async exists(M){try{return await r.promises.access(M),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return P}get rename(){return A}get copy(){return v}}}),define(ke[108],Ie([1,0,44,16,10,12,33]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=T,e.$lr=b,e.$mr=c,e.$nr=I,r=qe(r);function T(u){if(C.$l)return u;const P=(0,h.$mc)(u);if(u===P)return u;const w=((0,h.$nc)(u)||u).toLowerCase();try{const m=(0,L.readdirSync)(P).filter($=>$.toLowerCase()===w);if(m.length===1){const $=T(P);if($)return(0,h.$jc)($,m[0])}else if(m.length>1){const $=m.indexOf(w);if($>=0){const f=T(P);if(f)return(0,h.$jc)(f,m[$])}}}catch{}return null}async function b(u,P){if(C.$l)return u;const w=(0,h.$mc)(u);if(u===w)return u;const a=((0,h.$nc)(u)||u).toLowerCase();try{if(P?.isCancellationRequested)return null;const $=(await L.Promises.readdir(w)).filter(f=>f.toLowerCase()===a);if($.length===1){const f=await b(w,P);if(f)return(0,h.$jc)(f,$[0])}else if($.length>1){const f=$.indexOf(a);if(f>=0){const i=await b(w,P);if(i)return(0,h.$jc)(i,$[f])}}}catch{}return null}async function c(u){try{return await L.Promises.realpath(u)}catch{const w=S(u);return await r.promises.access(w,r.constants.R_OK),w}}function I(u){try{return r.realpathSync(u)}catch{const w=S(u);return r.accessSync(w,r.constants.R_OK),w}}function S(u){return(0,R.$nf)((0,h.$hc)(u),h.sep)}}),define(ke[191],Ie([1,0,67]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=void 0,e.$3g=h,e.$5g=R,r=qe(r);function h(T,b,c,I=1){let S=!1;return new Promise(u=>{const P=setTimeout(()=>{if(!S)return S=!0,u(0)},c);C(T,b,I,w=>{if(!S)return S=!0,clearTimeout(P),u(w)})})}function C(T,b,c,I){if(b===0)return I(0);const S=new r.Socket;S.once("connect",()=>(L(S),C(T+c,b-1,c,I))),S.once("data",()=>{}),S.once("error",u=>(L(S),u.code!=="ECONNREFUSED"?C(T+c,b-1,c,I):I(T))),S.connect(T,"127.0.0.1")}e.$4g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(T,b,c,I="127.0.0.1"){let S=!1,u,P=1;const w=r.createServer({pauseOnConnect:!0});function a(m,$){S||(S=!0,w.removeAllListeners(),w.close(),u&&clearTimeout(u),$(m))}return new Promise(m=>{u=setTimeout(()=>{a(0,m)},c),w.on("listening",()=>{a(T,m)}),w.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&P<b?(T++,P++,w.listen(T,I)):a(0,m)}),w.on("close",()=>{a(0,m)}),w.listen(T,I)})}function L(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch(b){console.error(b)}}}),define(ke[109],Ie([1,0,44,16,10,55,104,17,33]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=c,e.$ym=I,h=qe(h),C=qe(C),R=qe(R),T=qe(T),b=qe(b),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function c(u=R.env){return u.comspec||"cmd.exe"}function I(u){let P=[],w=!1;const a=function(m){if(w){P.push(m);return}(!u.send(m,f=>{if(f&&console.error(f),w=!1,P.length>0){const i=P.slice(0);P=[],i.forEach(s=>a(s))}})||C.$j)&&(w=!0)};return{send:a}}var S;(function(u){async function P(w,a,m){if(h.$ic(w))return w;if(a===void 0&&(a=R.cwd()),h.$mc(w)!=="."||(m===void 0&&T.$eg(R.env.PATH)&&(m=R.env.PATH.split(h.$tc)),m===void 0||m.length===0))return h.$jc(a,w);async function f(i){if(await b.Promises.exists(i)){let s;try{s=await r.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(s=await r.promises.lstat(i))}return s?!s.isDirectory():!1}return!1}for(const i of m){let s;if(h.$ic(i)?s=h.$jc(i,w):s=h.$jc(a,i,w),await f(s))return s;let t=s+".com";if(await f(t)||(t=s+".exe",await f(t)))return t}return h.$jc(a,w)}u.findExecutable=P})(S||(e.win32=S={}))});var Je=this&&this.__decorate||function($e,e,r,h){var C=arguments.length,R=C<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,r,h);else for(var T=$e.length-1;T>=0;T--)(L=$e[T])&&(R=(C<3?L(R):C>3?L(e,r,R):L(e,r))||R);return C>3&&R&&Object.defineProperty(e,r,R),R};define(ke[86],Ie([1,0,18,7,21,20,59,13,4,3,51,12,17]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.ProxyChannel=e.$mi=e.$ji=e.$ii=e.$hi=e.RequestInitiator=e.$gi=e.$di=e.$ci=void 0,e.$ei=E,e.$fi=D,e.$ki=F,e.$li=N,S=qe(S);var P;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(P||(P={}));function w(B){switch(B){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var a;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(a||(a={}));function m(B){switch(B){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var $;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})($||($={}));function f(B){let Y=0;for(let J=0;;J+=7){const _=B.read(1);if(Y|=(_.buffer[0]&127)<<J,!(_.buffer[0]&128))return Y}}const i=d(0);function s(B,Y){if(Y===0){B.write(i);return}let J=0;for(let le=Y;le!==0;le=le>>>7)J++;const _=C.$Ne.alloc(J);for(let le=0;Y!==0;le++)_.buffer[le]=Y&127,Y=Y>>>7,Y>0&&(_.buffer[le]|=128);B.write(_)}class t{constructor(Y){this.b=Y,this.a=0}read(Y){const J=this.b.slice(this.a,this.a+Y);return this.a+=J.byteLength,J}}e.$ci=t;class o{constructor(){this.a=[]}get buffer(){return C.$Ne.concat(this.a)}write(Y){this.a.push(Y)}}e.$di=o;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function d(B){const Y=C.$Ne.alloc(1);return Y.writeUInt8(B,0),Y}const l={Undefined:d(n.Undefined),String:d(n.String),Buffer:d(n.Buffer),VSBuffer:d(n.VSBuffer),Array:d(n.Array),Object:d(n.Object),Uint:d(n.Int)},g=typeof Buffer<"u";function E(B,Y){if(typeof Y>"u")B.write(l.Undefined);else if(typeof Y=="string"){const J=C.$Ne.fromString(Y);B.write(l.String),s(B,J.byteLength),B.write(J)}else if(g&&Buffer.isBuffer(Y)){const J=C.$Ne.wrap(Y);B.write(l.Buffer),s(B,J.byteLength),B.write(J)}else if(Y instanceof C.$Ne)B.write(l.VSBuffer),s(B,Y.byteLength),B.write(Y);else if(Array.isArray(Y)){B.write(l.Array),s(B,Y.length);for(const J of Y)E(B,J)}else if(typeof Y=="number"&&(Y|0)===Y)B.write(l.Uint),s(B,Y);else{const J=C.$Ne.fromString(JSON.stringify(Y));B.write(l.Object),s(B,J.byteLength),B.write(J)}}function D(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(f(B)).toString();case n.Buffer:return B.read(f(B)).buffer;case n.VSBuffer:return B.read(f(B));case n.Array:{const J=f(B),_=[];for(let le=0;le<J;le++)_.push(D(B));return _}case n.Object:return JSON.parse(B.read(f(B)).toString());case n.Int:return f(B)}}class y{constructor(Y,J,_=null,le=1e3){this.h=Y,this.j=J,this.k=_,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:a.Initialize})}registerChannel(Y,J){this.b.set(Y,J),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case a.Initialize:{const J=this.o([Y.type]);this.k?.logOutgoing(J,0,k.OtherSide,m(Y.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const J=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(J,Y.id,k.OtherSide,m(Y.type),Y.data);return}}}o(Y,J=void 0){const _=new o;return E(_,Y),E(_,J),this.p(_.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const J=new t(Y),_=D(J),le=D(J),re=_[0];switch(re){case P.Promise:return this.k?.logIncoming(Y.byteLength,_[1],k.OtherSide,`${w(re)}: ${_[2]}.${_[3]}`,le),this.s({type:re,id:_[1],channelName:_[2],name:_[3],arg:le});case P.EventListen:return this.k?.logIncoming(Y.byteLength,_[1],k.OtherSide,`${w(re)}: ${_[2]}.${_[3]}`,le),this.t({type:re,id:_[1],channelName:_[2],name:_[3],arg:le});case P.PromiseCancel:return this.k?.logIncoming(Y.byteLength,_[1],k.OtherSide,`${w(re)}`),this.u({type:re,id:_[1]});case P.EventDispose:return this.k?.logIncoming(Y.byteLength,_[1],k.OtherSide,`${w(re)}`),this.u({type:re,id:_[1]})}}s(Y){const J=this.b.get(Y.channelName);if(!J){this.v(Y);return}const _=new R.$we;let le;try{le=J.call(this.j,Y.name,Y.arg,_.token)}catch(me){le=Promise.reject(me)}const re=Y.id;le.then(me=>{this.m({id:re,data:me,type:a.PromiseSuccess})},me=>{me instanceof Error?this.m({id:re,data:{message:me.message,name:me.name,stack:me.stack?me.stack.split(`
`):void 0},type:a.PromiseError}):this.m({id:re,data:me,type:a.PromiseErrorObj})}).finally(()=>{Se.dispose(),this.d.delete(Y.id)});const Se=(0,c.$Sc)(()=>_.cancel());this.d.set(Y.id,Se)}t(Y){const J=this.b.get(Y.channelName);if(!J){this.v(Y);return}const _=Y.id,re=J.listen(this.j,Y.name,Y.arg)(Se=>this.m({id:_,data:Se,type:a.EventFire}));this.d.set(Y.id,re)}u(Y){const J=this.d.get(Y.id);J&&(J.dispose(),this.d.delete(Y.id))}v(Y){let J=this.g.get(Y.channelName);J||(J=[],this.g.set(Y.channelName,J));const _=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===P.Promise&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);J.push({request:Y,timeoutTimer:_})}w(Y){const J=this.g.get(Y);if(J){for(const _ of J)switch(clearTimeout(_.timeoutTimer),_.request.type){case P.Promise:this.s(_.request);break;case P.EventListen:this.t(_.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$gi=y;var k;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class A{constructor(Y,J=null){this.l=Y,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=J}getChannel(Y){const J=this;return{call(_,le,re){return J.a?Promise.reject(new T.$4):J.m(Y,_,le,re)},listen(_,le){return J.a?b.Event.None:J.o(Y,_,le)}}}m(Y,J,_,le=R.CancellationToken.None){const re=this.g++,Se=P.Promise,me={id:re,type:Se,channelName:Y,name:J,arg:_};if(le.isCancellationRequested)return Promise.reject(new T.$4);let Q;return new Promise((se,we)=>{if(le.isCancellationRequested)return we(new T.$4);const ee=()=>{const ne=pe=>{switch(pe.type){case a.PromiseSuccess:this.f.delete(re),se(pe.data);break;case a.PromiseError:{this.f.delete(re);const be=new Error(pe.data.message);be.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,be.name=pe.data.name,we(be);break}case a.PromiseErrorObj:this.f.delete(re),we(pe.data);break}};this.f.set(re,ne),this.p(me)};let ae=null;this.b===$.Idle?ee():(ae=(0,h.$rh)(ne=>this.u()),ae.then(()=>{ae=null,ee()}));const oe=()=>{ae?(ae.cancel(),ae=null):this.p({id:re,type:P.PromiseCancel}),we(new T.$4)},x=le.onCancellationRequested(oe);Q=(0,c.$Rc)((0,c.$Sc)(oe),x),this.d.add(Q)}).finally(()=>{Q.dispose(),this.d.delete(Q)})}o(Y,J,_){const le=this.g++,re=P.EventListen,Se={id:le,type:re,channelName:Y,name:J,arg:_};let me=null;const Q=new b.$le({onWillAddFirstListener:()=>{me=(0,h.$rh)(se=>this.u()),me.then(()=>{me=null,this.d.add(Q),this.p(Se)})},onDidRemoveLastListener:()=>{me?(me.cancel(),me=null):(this.d.delete(Q),this.p({id:le,type:P.EventDispose}))}}),q=se=>Q.fire(se.data);return this.f.set(le,q),Q.event}p(Y){switch(Y.type){case P.Promise:case P.EventListen:{const J=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(J,Y.id,k.LocalSide,`${w(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case P.PromiseCancel:case P.EventDispose:{const J=this.q([Y.type,Y.id]);this.j?.logOutgoing(J,Y.id,k.LocalSide,w(Y.type));return}}}q(Y,J=void 0){const _=new o;return E(_,Y),E(_,J),this.r(_.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const J=new t(Y),_=D(J),le=D(J),re=_[0];switch(re){case a.Initialize:return this.j?.logIncoming(Y.byteLength,0,k.LocalSide,m(re)),this.t({type:_[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(Y.byteLength,_[1],k.LocalSide,m(re),le),this.t({type:_[0],id:_[1],data:le})}}t(Y){if(Y.type===a.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$hi=A,Je([L.$9h],A.prototype,"onDidInitializePromise",null);class p{get connections(){const Y=[];return this.f.forEach(J=>Y.push(J)),Y}constructor(Y,J,_){this.a=new Map,this.f=new Set,this.g=new b.$le,this.onDidAddConnection=this.g.event,this.h=new b.$le,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(Y(({protocol:le,onDidClientDisconnect:re})=>{const Se=b.Event.once(le.onMessage);this.j.add(Se(me=>{const Q=new t(me),q=D(Q),se=new y(le,q,J,_),we=new A(le,J);this.a.forEach((ae,oe)=>se.registerChannel(oe,ae));const ee={channelServer:se,channelClient:we,ctx:q};this.f.add(ee),this.g.fire(ee),this.j.add(re(()=>{se.dispose(),we.dispose(),this.f.delete(ee),this.h.fire(ee)}))}))}))}getChannel(Y,J){const _=this;return{call(le,re,Se){let me;if((0,u.$sg)(J)){const q=(0,r.$2b)(_.connections.filter(J));me=q?Promise.resolve(q):b.Event.toPromise(b.Event.filter(_.onDidAddConnection,J))}else me=J.routeCall(_,le,re);const Q=me.then(q=>q.channelClient.getChannel(Y));return F(Q).call(le,re,Se)},listen(le,re){if((0,u.$sg)(J))return _.k(Y,J,le,re);const Se=J.routeEvent(_,le,re).then(me=>me.channelClient.getChannel(Y));return F(Se).listen(le,re)}}}k(Y,J,_,le){const re=this;let Se;const me=new b.$le({onWillAddFirstListener:()=>{Se=new c.$Tc;const Q=new b.$re,q=new Map,se=ee=>{const oe=ee.channelClient.getChannel(Y).listen(_,le),x=Q.add(oe);q.set(ee,x)},we=ee=>{const ae=q.get(ee);ae&&(ae.dispose(),q.delete(ee))};re.connections.filter(J).forEach(se),b.Event.filter(re.onDidAddConnection,J)(se,void 0,Se),re.onDidRemoveConnection(we,void 0,Se),Q.event(me.fire,me,Se),Se.add(Q)},onDidRemoveLastListener:()=>{Se?.dispose(),Se=void 0}});return me.event}registerChannel(Y,J){this.a.set(Y,J);for(const _ of this.f)_.channelServer.registerChannel(Y,J)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ii=p;class v{constructor(Y,J,_=null){const le=new o;E(le,J),Y.send(le.buffer),this.a=new A(Y,_),this.d=new y(Y,J,_)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,J){this.d.registerChannel(Y,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ji=v;function F(B){return{call(Y,J,_){return B.then(le=>le.call(Y,J,_))},listen(Y,J){const _=new b.$ue;return B.then(le=>_.input=le.listen(Y,J)),_.event}}}function N(B){let Y=!1;return{call(J,_,le){return Y?B.call(J,_,le):(0,h.$Fh)(0).then(()=>Y=!0).then(()=>B.call(J,_,le))},listen(J,_){if(Y)return B.listen(J,_);const le=new b.$ue;return(0,h.$Fh)(0).then(()=>Y=!0).then(()=>le.input=B.listen(J,_)),le.event}}}class O{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const J of Y.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await b.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$mi=O;var j;(function(B){function Y(re,Se,me){const Q=re,q=me&&me.disableMarshalling,se=new Map;for(const we in Q)_(we)&&se.set(we,b.Event.buffer(Q[we],!0,void 0,Se));return new class{listen(we,ee,ae){const oe=se.get(ee);if(oe)return oe;const x=Q[ee];if(typeof x=="function"){if(le(ee))return x.call(Q,ae);if(_(ee))return se.set(ee,b.Event.buffer(Q[ee],!0,void 0,Se)),se.get(ee)}throw new T.$ab(`Event not found: ${ee}`)}call(we,ee,ae){const oe=Q[ee];if(typeof oe=="function"){if(!q&&Array.isArray(ae))for(let ne=0;ne<ae.length;ne++)ae[ne]=(0,I.$bi)(ae[ne]);let x=oe.apply(Q,ae);return x instanceof Promise||(x=Promise.resolve(x)),x}throw new T.$ab(`Method not found: ${ee}`)}}}B.fromService=Y;function J(re,Se){const me=Se&&Se.disableMarshalling;return new Proxy({},{get(Q,q){if(typeof q=="string")return Se?.properties?.has(q)?Se.properties.get(q):le(q)?function(se){return re.listen(q,se)}:_(q)?re.listen(q):async function(...se){let we;Se&&!(0,u.$ng)(Se.context)?we=[Se.context,...se]:we=se;const ee=await re.call(q,we);return me?ee:(0,I.$bi)(ee)};throw new T.$ab(`Property not found: ${String(q)}`)}})}B.toService=J;function _(re){return re[0]==="o"&&re[1]==="n"&&S.$Ef(re.charCodeAt(2))}function le(re){return/^onDynamic/.test(re)&&S.$Ef(re.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const Y=B.toString();if(Y!=="[object Object]")return Y}return B}function U(B){return Array.isArray(B)?B.map(M):M(B)}function V(B,Y,J,_,le,re,Se){Se=U(Se);const me=z[le],Q=me[_%me.length];let q=[`%c[${B}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(re)?(q=q.concat(Se),q.push(")")):q.push(Se),console.log.apply(console,q)}class ie{constructor(Y,J){this.d=Y,this.f=J,this.a=0,this.b=0}logOutgoing(Y,J,_,le,re){this.b+=Y,V(this.d,this.b,Y,J,_,le,re)}logIncoming(Y,J,_,le,re){this.a+=Y,V(this.f,this.a,Y,J,_,le,re)}}e.$ni=ie}),define(ke[68],Ie([1,0,21,4,3,86]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.ProtocolConstants=e.$oi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var T;(function(l){l.enableDiagnostics=!1,l.records=[];const g=new WeakMap;let E=0;function D(k,A){if(!g.has(k)){const p=String(++E);g.set(k,p)}return g.get(k)}function y(k,A,p,v){if(!l.enableDiagnostics)return;const F=D(k,A);if(v instanceof r.$Ne||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const N=r.$Ne.alloc(v.byteLength);N.set(v),l.records.push({timestamp:Date.now(),id:F,label:A,type:p,buff:N})}else l.records.push({timestamp:Date.now(),id:F,label:A,type:p,data:v})}l.traceSocketEvent=y})(T||(e.SocketDiagnostics=T={}));var b;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let c=null;function I(){return c||(c=r.$Ne.alloc(0)),c}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(g){this.a.push(g),this.b+=g.byteLength}read(g){return this.c(g,!0)}peek(g){return this.c(g,!1)}c(g,E){if(g===0)return I();if(g>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===g){const A=this.a[0];return E&&(this.a.shift(),this.b-=g),A}if(this.a[0].byteLength>g){const A=this.a[0].slice(0,g);return E&&(this.a[0]=this.a[0].slice(g),this.b-=g),A}const D=r.$Ne.alloc(g);let y=0,k=0;for(;g>0;){const A=this.a[k];if(A.byteLength>g){const p=A.slice(0,g);D.set(p,y),y+=g,E&&(this.a[k]=A.slice(g),this.b-=g),g-=g}else D.set(A,y),y+=A.byteLength,E?(this.a.shift(),this.b-=A.byteLength):k++,g-=A.byteLength}return D}}e.$oi=S;var u;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(u||(u={}));function P(l){switch(l){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var w;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class a{constructor(g,E,D,y){this.type=g,this.id=E,this.ack=D,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends C.$Uc{constructor(g){super(),this.f=this.B(new h.$le),this.onMessage=this.f.event,this.g={readHead:!0,readLen:w.HeaderLength,messageType:u.None,id:0,ack:0},this.a=g,this.b=!1,this.c=new S,this.B(this.a.onData(E=>this.acceptChunk(E))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(g);this.c.byteLength>=this.g.readLen;){const E=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=E.readUInt32BE(9),this.g.messageType=E.readUInt8(0),this.g.id=E.readUInt32BE(1),this.g.ack=E.readUInt32BE(5),this.a.traceSocketEvent(L.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,y=this.g.id,k=this.g.ack;if(this.g.readHead=!0,this.g.readLen=w.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(L.ProtocolMessageRead,E),this.f.fire(new a(D,y,k,E)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(g){this.k=null,this.a=!1,this.b=!1,this.c=g,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(g){if(this.a)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const E=r.$Ne.alloc(w.HeaderLength);E.writeUInt8(g.type,0),E.writeUInt32BE(g.id,1),E.writeUInt32BE(g.ack,5),E.writeUInt32BE(g.data.byteLength,9),this.c.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:P(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this.c.traceSocketEvent(L.ProtocolMessageWrite,g.data),this.j(E,g.data)}g(g,E){const D=this.f===0;return this.d.push(g,E),this.f+=g.byteLength+E.byteLength,D}h(){const g=r.$Ne.concat(this.d,this.f);return this.d.length=0,this.f=0,g}j(g,E){this.g(g,E)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const g=this.h();this.c.traceSocketEvent(L.ProtocolWrite,{byteLength:g.byteLength}),this.c.write(g)}}class f extends C.$Uc{constructor(g){super(),this.f=new h.$le,this.onMessage=this.f.event,this.g=new h.$le,this.onDidDispose=this.g.event,this.a=g,this.b=this.B(new $(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(E=>{E.type===u.Regular&&this.f.fire(E.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(g){this.b.write(new a(u.Regular,0,0,g))}}e.$pi=f;class i extends R.$ji{static fromSocket(g,E){return new i(new f(g),E)}get onDidDispose(){return this.b.onDidDispose}constructor(g,E,D=null){super(g,E,D),this.b=g}dispose(){super.dispose();const g=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),g.end()}}e.$qi=i;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$le({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(g){this.b?this.d.length>0?this.d.push(g):this.a.fire(g):this.d.push(g)}flushBuffer(){this.d=[]}}e.$ri=s;class t{constructor(g){this.data=g,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let g=0,E=this.a;for(;E;)E=E.next,g++;return g}peek(){return this.a?this.a.data:null}toArray(){const g=[];let E=0,D=this.a;for(;D;)g[E++]=D.data,D=D.next;return g}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(g){const E=new t(g);if(!this.a){this.a=E,this.b=E;return}this.b.next=E,this.b=E}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const g=Date.now();for(let E=0;E<n.a;E++)this.c[E]=g-1e3*E;setInterval(()=>{for(let E=n.a;E>=1;E--)this.c[E]=this.c[E-1];this.c[0]=Date.now()},1e3)}d(){const g=Date.now(),E=(1+n.a)*1e3;let D=0;for(let y=0;y<n.a;y++)g-this.c[y]<=E&&D++;return 1-D/n.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.d-this.f}constructor(g){this.v=new s,this.onControlMessage=this.v.event,this.w=new s,this.onMessage=this.w.event,this.x=new s,this.onDidDispose=this.x.event,this.y=new s,this.onSocketClose=this.y.event,this.z=new s,this.onSocketTimeout=this.z.event,this.t=g.loadEstimator??n.getInstance(),this.u=g.sendKeepAlive??!0,this.a=!1,this.c=new o,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new C.$Tc,this.p=g.socket,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(E=>this.A(E))),this.s.add(this.p.onClose(E=>this.y.fire(E))),g.initialChunk&&this.r.acceptChunk(g.initialChunk),this.u?this.m=setInterval(()=>{this.E()},w.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const g=new a(u.Disconnect,0,0,I());this.q.write(g),this.q.flush()}}sendPause(){const g=new a(u.Pause,0,0,I());this.q.write(g)}sendResume(){const g=new a(u.Resume,0,0,I());this.q.write(g)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(g,E){this.a=!0,this.s.dispose(),this.s=new C.$Tc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=g,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(D=>this.A(D))),this.s.add(this.p.onClose(D=>this.y.fire(D))),this.r.acceptChunk(E)}endAcceptReconnection(){this.a=!1,this.j=this.h;const g=new a(u.Ack,0,this.j,I());this.q.write(g);const E=this.c.toArray();for(let D=0,y=E.length;D<y;D++)this.q.write(E[D]);this.C()}acceptDisconnect(){this.x.fire()}A(g){if(g.ack>this.f){this.f=g.ack;do{const E=this.c.peek();if(E&&E.id<=g.ack)this.c.pop();else break}while(!0)}switch(g.type){case u.None:break;case u.Regular:{if(g.id>this.h)if(g.id!==this.h+1){const E=Date.now();E-this.n>1e4&&(this.n=E,this.q.write(new a(u.ReplayRequest,0,0,I())))}else this.h=g.id,this.k=Date.now(),this.B(),this.w.fire(g.data);break}case u.Control:{this.v.fire(g.data);break}case u.Ack:break;case u.Disconnect:{this.x.fire();break}case u.ReplayRequest:{const E=this.c.toArray();for(let D=0,y=E.length;D<y;D++)this.q.write(E[D]);this.C();break}case u.Pause:{this.q.pause();break}case u.Resume:{this.q.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(g){const E=++this.d;this.j=this.h;const D=new a(u.Regular,E,this.j,g);this.c.push(D),this.a||(this.q.write(D),this.C())}sendControl(g){const E=new a(u.Control,0,0,g);this.q.write(E)}B(){if(this.h<=this.j||this.l)return;const g=Date.now()-this.k;if(g>=w.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},w.AcknowledgeTime-g+5)}C(){if(this.d<=this.f||this.g||this.a)return;const g=this.c.peek(),E=Date.now()-g.writtenTime,D=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(E>=w.TimeoutTime&&D>=w.TimeoutTime&&y>=w.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:E,timeSinceLastReceivedSomeData:D});return}const k=Math.max(w.TimeoutTime-E,w.TimeoutTime-D,w.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},k)}D(){if(this.h<=this.j)return;this.j=this.h;const g=new a(u.Ack,0,this.j,I());this.q.write(g)}E(){this.j=this.h;const g=new a(u.KeepAlive,0,this.j,I());this.q.write(g)}}e.$si=d}),define(ke[192],Ie([1,0,56,7,21,20,188,13,4,3,24,109,104,86]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0,T=qe(T);class w extends P.$gi{constructor($){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",f=>C.$Ne.wrap(Buffer.from(f,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$gr=w;class a{constructor($,f){this.i=$,this.j=f,this.c=new Set,this.g=new Map,this.h=new b.$le,this.onDidProcessExit=this.h.event;const i=f&&f.timeout?f.timeout:6e4;this.b=new h.$Bh(i),this.d=null,this.f=null}getChannel($){const f=this;return{call(i,s,t){return f.k($,i,s,t)},listen(i,s){return f.l($,i,s)}}}k($,f,i,s=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(T.$5());this.b.cancel();const t=this.n($),o=(0,h.$rh)(l=>t.call(f,i,l)),n=s.onCancellationRequested(()=>o.cancel()),d=(0,c.$Sc)(()=>o.cancel());return this.c.add(d),o.finally(()=>{n.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),o}l($,f,i){if(!this.b)return b.Event.None;this.b.cancel();let s;const t=new b.$le({onWillAddFirstListener:()=>{s=this.n($).listen(f,i)(t.fire,t),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,I.$do)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,u.$lm)(f.env),this.d=(0,r.fork)(this.i,$,f);const i=new b.$le,t=b.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,L.$cr)(E)){(0,L.log)(E,`IPC Library: ${this.j.serverName}`);return}i.fire(C.$Ne.wrap(Buffer.from(E,"base64")))}),o=this.j.useQueue?(0,S.$ym)(this.d):this.d,n=E=>this.d&&this.d.connected&&o.send(E.buffer.toString("base64")),d=i.event,l={send:n,onMessage:d};this.f=new P.$hi(l);const g=()=>this.o();process.once("exit",g),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,D)=>{process.removeListener("exit",g),t.dispose(),this.c.forEach(y=>(0,c.$Pc)(y)),this.c.clear(),E!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:D})})}return this.f}n($){let f=this.g.get($);return f||(f=this.m.getChannel($),this.g.set($,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$hr=a}),define(ke[193],Ie([1,0,7,4,3,51,17]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.StorageState=e.StorageHint=void 0,e.$cq=b;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function b(u){const P=u;return P?.changed instanceof Map||P?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class I extends C.$Uc{static{this.a=100}constructor(P,w=Object.create(null)){super(),this.r=P,this.s=w,this.b=this.B(new h.$oe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new r.$Ch(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((w,a)=>this.w(a,w)),P.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(P,w){if(this.c===c.Closed)return;let a=!1;(0,L.$ng)(w)?a=this.f.delete(P):this.f.get(P)!==w&&(this.f.set(P,w),a=!0),a&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,w){const a=this.f.get(P);return(0,L.$ng)(a)?w:a}getBoolean(P,w){const a=this.get(P);return(0,L.$ng)(a)?w:a==="true"}getNumber(P,w){const a=this.get(P);return(0,L.$ng)(a)?w:parseInt(a,10)}getObject(P,w){const a=this.get(P);return(0,L.$ng)(a)?w:(0,R.$ai)(a)}async set(P,w,a=!1){if(this.c===c.Closed)return;if((0,L.$ng)(w))return this.delete(P,a);const m=(0,L.$gg)(w)||Array.isArray(w)?(0,R.$_h)(w):String(w);if(this.f.get(P)!==m)return this.f.set(P,m),this.j.set(P,m),this.h.delete(P),this.b.fire({key:P,external:a}),this.D()}async delete(P,w=!1){if(!(this.c===c.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:w}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===c.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$dq=I;class S{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((w,a)=>this.a.set(a,w)),P.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$eq=S}),define(ke[139],Ie([1,0,83]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hu=e.$gu=void 0;class h{constructor(T){const b=(0,r.$af)(T);this.c=b,this.a=h.d(b),this.b=new Map}static d(T){const b=new Uint8Array(256);return b.fill(T),b}set(T,b){const c=(0,r.$af)(b);T>=0&&T<256?this.a[T]=c:this.b.set(T,c)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$gu=h;var C;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(C||(C={}));class R{constructor(){this.a=new h(C.False)}add(T){this.a.set(T,C.True)}has(T){return this.a.get(T)===C.True}clear(){return this.a.clear()}}e.$hu=R}),define(ke[194],Ie([1,0,26]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$yu=C;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function C(R){let L=0,T=0,b=0,c=h.Unknown;for(let I=0,S=R.length;I<S;I++){const u=R.charCodeAt(I);u===r.CharCode.CarriageReturn?(L===0&&(T=I),L++,I+1<S&&R.charCodeAt(I+1)===r.CharCode.LineFeed?(c|=h.CRLF,I++):c|=h.Invalid,b=I+1):u===r.CharCode.LineFeed&&(c|=h.LF,L===0&&(T=I),L++,b=I+1)}return L===0&&(T=R.length),[L,T,R.length-b,c]}}),define(ke[57],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class r{constructor(C,R){this.lineNumber=C,this.column=R}with(C=this.lineNumber,R=this.column){return C===this.lineNumber&&R===this.column?this:new r(C,R)}delta(C=0,R=0){return this.with(this.lineNumber+C,this.column+R)}equals(C){return r.equals(this,C)}static equals(C,R){return!C&&!R?!0:!!C&&!!R&&C.lineNumber===R.lineNumber&&C.column===R.column}isBefore(C){return r.isBefore(this,C)}static isBefore(C,R){return C.lineNumber<R.lineNumber?!0:R.lineNumber<C.lineNumber?!1:C.column<R.column}isBeforeOrEqual(C){return r.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,R){return C.lineNumber<R.lineNumber?!0:R.lineNumber<C.lineNumber?!1:C.column<=R.column}static compare(C,R){const L=C.lineNumber|0,T=R.lineNumber|0;if(L===T){const b=C.column|0,c=R.column|0;return b-c}return L-T}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new r(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Mt=r}),define(ke[30],Ie([1,0,57]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class h{constructor(R,L,T,b){R>T||R===T&&L>b?(this.startLineNumber=T,this.startColumn=b,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=T,this.endColumn=b)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,L){let T,b,c,I;return L.startLineNumber<R.startLineNumber?(T=L.startLineNumber,b=L.startColumn):L.startLineNumber===R.startLineNumber?(T=L.startLineNumber,b=Math.min(L.startColumn,R.startColumn)):(T=R.startLineNumber,b=R.startColumn),L.endLineNumber>R.endLineNumber?(c=L.endLineNumber,I=L.endColumn):L.endLineNumber===R.endLineNumber?(c=L.endLineNumber,I=Math.max(L.endColumn,R.endColumn)):(c=R.endLineNumber,I=R.endColumn),new h(T,b,c,I)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,L){let T=R.startLineNumber,b=R.startColumn,c=R.endLineNumber,I=R.endColumn;const S=L.startLineNumber,u=L.startColumn,P=L.endLineNumber,w=L.endColumn;return T<S?(T=S,b=u):T===S&&(b=Math.max(b,u)),c>P?(c=P,I=w):c===P&&(I=Math.min(I,w)),T>c||T===c&&b>I?null:new h(T,b,c,I)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Mt(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Mt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new h(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new h(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new h(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const c=R.startLineNumber|0,I=L.startLineNumber|0;if(c===I){const S=R.startColumn|0,u=L.startColumn|0;if(S===u){const P=R.endLineNumber|0,w=L.endLineNumber|0;if(P===w){const a=R.endColumn|0,m=L.endColumn|0;return a-m}return P-w}return S-u}return c-I}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$Nt=h}),define(ke[195],Ie([1,0,30]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class h{static insert(R,L){return{range:new r.$Nt(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$Ot=h}),define(ke[196],Ie([1,0,57,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=e.SelectionDirection=void 0;var C;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(C||(e.SelectionDirection=C={}));class R extends h.$Nt{constructor(T,b,c,I){super(T,b,c,I),this.selectionStartLineNumber=T,this.selectionStartColumn=b,this.positionLineNumber=c,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return R.selectionsEqual(this,T)}static selectionsEqual(T,b){return T.selectionStartLineNumber===b.selectionStartLineNumber&&T.selectionStartColumn===b.selectionStartColumn&&T.positionLineNumber===b.positionLineNumber&&T.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?C.LTR:C.RTL}setEndPosition(T,b){return this.getDirection()===C.LTR?new R(this.startLineNumber,this.startColumn,T,b):new R(T,b,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Mt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Mt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,b){return this.getDirection()===C.LTR?new R(T,b,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,T,b)}static fromPositions(T,b=T){return new R(T.lineNumber,T.column,b.lineNumber,b.column)}static fromRange(T,b){return b===C.LTR?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new R(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new R(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,b){if(T&&!b||!T&&b)return!1;if(!T&&!b)return!0;if(T.length!==b.length)return!1;for(let c=0,I=T.length;c<I;c++)if(!this.selectionsEqual(T[c],b[c]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,b,c,I,S){return S===C.LTR?new R(T,b,c,I):new R(c,I,T,b)}}e.$Pt=R}),define(ke[197],Ie([1,0,12,10,21]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=void 0,e.$bu=I,e.$cu=S,r=qe(r),h=qe(h),C=qe(C);let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let T;function b(){return T||(T=new TextDecoder("UTF-16BE")),T}let c;function I(){return c||(c=h.$E()?L():b()),c}function S(w,a,m){const $=new Uint16Array(w.buffer,a,m);return m>0&&($[0]===65279||$[0]===65534)?u(w,a,m):L().decode($)}function u(w,a,m){const $=[];let f=0;for(let i=0;i<m;i++){const s=C.$Pe(w,a);a+=2,$[f++]=String.fromCharCode(s)}return $.join("")}class P{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return I().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||r.$Jf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let $=0;$<m;$++)this.b[this.d++]=a.charCodeAt($)}}e.$du=P}),define(ke[198],Ie([1,0,21,197]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=void 0,e.$fu=L,r=qe(r);function C(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,I,S,u){this.oldPosition=c,this.oldText=I,this.newPosition=S,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,I,S){const u=I.length;r.$Se(c,u,S),S+=4;for(let P=0;P<u;P++)r.$Qe(c,I.charCodeAt(P),S),S+=2;return S}static d(c,I){const S=r.$Re(c,I);return I+=4,(0,h.$cu)(c,I,S)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(c,I){return r.$Se(c,this.oldPosition,I),I+=4,r.$Se(c,this.newPosition,I),I+=4,I=R.c(c,this.oldText,I),I=R.c(c,this.newText,I),I}static read(c,I,S){const u=r.$Re(c,I);I+=4;const P=r.$Re(c,I);I+=4;const w=R.d(c,I);I+=R.a(w);const a=R.d(c,I);return I+=R.a(a),S.push(new R(u,w,P,a)),I}}e.$eu=R;function L(b,c){return b===null||b.length===0?c:new T(b,c).compress()}class T{constructor(c,I){this.a=c,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,I=0,S=this.n(c),u=this.l(I);for(;c<this.f||I<this.h;){if(S===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(S),S=this.n(++c);continue}if(u.oldEnd<=S.newPosition){this.k(u),u=this.l(++I);continue}if(S.newEnd<=u.oldPosition){this.m(S),S=this.n(++c);continue}if(u.oldPosition<S.newPosition){const[$,f]=T.r(u,S.newPosition-u.oldPosition);this.k($),u=f;continue}if(S.newPosition<u.oldPosition){const[$,f]=T.q(S,u.oldPosition-S.newPosition);this.m($),S=f;continue}let a,m;if(u.oldEnd===S.newEnd)a=S,m=u,S=this.n(++c),u=this.l(++I);else if(u.oldEnd<S.newEnd){const[$,f]=T.q(S,u.oldLength);a=$,m=u,S=f,u=this.l(++I)}else{const[$,f]=T.r(u,S.newLength);a=S,m=$,S=this.n(++c),u=f}this.d[this.e++]=new R(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const P=T.s(this.d);return T.t(P)}k(c){this.d[this.e++]=T.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=T.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,I){return new R(I.oldPosition-c,I.oldText,I.newPosition,I.newText)}static p(c,I){return new R(I.oldPosition,I.oldText,I.newPosition+c,I.newText)}static q(c,I){const S=c.newText.substr(0,I),u=c.newText.substr(I);return[new R(c.oldPosition,c.oldText,c.newPosition,S),new R(c.oldEnd,"",c.newPosition+I,u)]}static r(c,I){const S=c.oldText.substr(0,I),u=c.oldText.substr(I);return[new R(c.oldPosition,S,c.newPosition,c.newText),new R(c.oldPosition+I,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const I=[];let S=0,u=c[0];for(let P=1;P<c.length;P++){const w=c[P];u.oldEnd===w.oldPosition?u=new R(u.oldPosition,u.oldText+w.oldText,u.newPosition,u.newText+w.newText):(I[S++]=u,u=w)}return I[S++]=u,I}static t(c){if(c.length===0)return c;const I=[];let S=0;for(let u=0;u<c.length;u++){const P=c[u];P.oldText!==P.newText&&(I[S++]=P)}return I}}}),define(ke[199],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0,e.$kt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[200],Ie([1,0,26,28,139]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iu=e.WordCharacterClass=void 0,e.$ju=b;var R;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class L extends C.$gu{constructor(I,S){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=S,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,P=I.length;u<P;u++)this.set(I.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,S){let u=null;for(const P of this.h(I)){if(P.index>S)break;u=P}return u}findNextIntlWordAtOrAfterOffset(I,S){for(const u of this.h(I))if(!(u.index<S))return u;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const S=[];for(const u of I)this.k(u)&&S.push(u);return S}k(I){return!!I.isWordLike}}e.$iu=L;const T=new h.$Dc(10);function b(c,I){const S=`${c}/${I.join(",")}`;let u=T.get(S);return u||(u=new L(c,I),T.set(S,u)),u}}),define(ke[140],Ie([1,0,39,3,80]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.$lt=void 0,e.$nt=L,e.$ot=b,e.$pt=c,e.$lt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(S=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$lt)S.indexOf(P)>=0||(u+="\\"+P);return u+="\\s]+)",new RegExp(u,"g")}e.$mt=R();function L(S){let u=e.$mt;if(S&&S instanceof RegExp)if(S.global)u=S;else{let P="g";S.ignoreCase&&(P+="i"),S.multiline&&(P+="m"),S.unicode&&(P+="u"),u=new RegExp(S.source,P)}return u.lastIndex=0,u}const T=new C.$5c;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(S){const u=T.unshift(S);return(0,h.$Sc)(u)}function c(S,u,P,w,a){if(u=L(u),a||(a=r.Iterable.first(T)),P.length>a.maxLen){let s=S-a.maxLen/2;return s<0?s=0:w+=s,P=P.substring(s,S+a.maxLen/2),c(S,u,P,w,a)}const m=Date.now(),$=S-1-w;let f=-1,i=null;for(let s=1;!(Date.now()-m>=a.timeBudget);s++){const t=$-a.windowSize*s;u.lastIndex=Math.max(0,t);const o=I(u,P,$,f);if(!o&&i||(i=o,t<=0))break;f=t}if(i){const s={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return u.lastIndex=0,s}return null}function I(S,u,P,w){let a;for(;a=S.exec(u);){const m=a.index||0;if(m<=P&&S.lastIndex>=P)return a;if(w>0&&m>w)return null}return null}}),define(ke[110],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(b){b[b.Null=0]="Null",b[b.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function(b){b[b.NotSet=-1]="NotSet",b[b.None=0]="None",b[b.Italic=1]="Italic",b[b.Bold=2]="Bold",b[b.Underline=4]="Underline",b[b.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var C;(function(b){b[b.None=0]="None",b[b.DefaultForeground=1]="DefaultForeground",b[b.DefaultBackground=2]="DefaultBackground"})(C||(e.ColorId=C={}));var R;(function(b){b[b.Other=0]="Other",b[b.Comment=1]="Comment",b[b.String=2]="String",b[b.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var L;(function(b){b[b.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",b[b.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",b[b.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",b[b.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",b[b.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",b[b.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",b[b.ITALIC_MASK=2048]="ITALIC_MASK",b[b.BOLD_MASK=4096]="BOLD_MASK",b[b.UNDERLINE_MASK=8192]="UNDERLINE_MASK",b[b.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",b[b.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",b[b.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",b[b.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",b[b.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",b[b.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",b[b.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",b[b.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",b[b.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",b[b.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",b[b.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",b[b.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",b[b.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class T{static getLanguageId(c){return(c&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(c){return(c&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(c){return(c&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(c){return(c&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let S="mtk"+this.getForeground(c);const u=this.getFontStyle(c);return u&h.Italic&&(S+=" mtki"),u&h.Bold&&(S+=" mtkb"),u&h.Underline&&(S+=" mtku"),u&h.Strikethrough&&(S+=" mtks"),S}static getInlineStyleFromMetadata(c,I){const S=this.getForeground(c),u=this.getFontStyle(c);let P=`color: ${I[S]};`;u&h.Italic&&(P+="font-style: italic;"),u&h.Bold&&(P+="font-weight: bold;");let w="";return u&h.Underline&&(w+=" underline"),u&h.Strikethrough&&(w+=" line-through"),w&&(P+=`text-decoration:${w};`),P}static getPresentationFromMetadata(c){const I=this.getForeground(c),S=this.getFontStyle(c);return{foreground:I,italic:!!(S&h.Italic),bold:!!(S&h.Bold),underline:!!(S&h.Underline),strikethrough:!!(S&h.Strikethrough)}}}e.$uu=T}),define(ke[201],Ie([1,0,38,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vu=C,e.$wu=R;function C(L,T,b,c,I,S){if(Array.isArray(L)){let u=0;for(const P of L){const w=C(P,T,b,c,I,S);if(w===10)return w;w>u&&(u=w)}return u}else{if(typeof L=="string")return c?L==="*"?5:L===b?10:0:0;if(L){const{language:u,pattern:P,scheme:w,hasAccessToAllModels:a,notebookType:m}=L;if(!c&&!a)return 0;m&&I&&(T=I);let $=0;if(w)if(w===T.scheme)$=10;else if(w==="*")$=5;else return 0;if(u)if(u===b)$=10;else if(u==="*")$=Math.max($,5);else return 0;if(m)if(m===S)$=10;else if(m==="*"&&S!==void 0)$=Math.max($,5);else return 0;if(P){let f;if(typeof P=="string"?f=P:f={...P,base:(0,h.$hc)(P.base)},f===T.fsPath||(0,r.$yk)(f,T.fsPath))$=10;else return 0}return $}else return 0}}function R(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(R):!!L.notebookType}}),define(ke[202],Ie([1,0,26,110]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=e.$Vu=e.IndentAction=void 0;var C;(function(b){b[b.None=0]="None",b[b.Indent=1]="Indent",b[b.IndentOutdent=2]="IndentOutdent",b[b.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class R{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let I=0,S=c.notIn.length;I<S;I++)switch(c.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,I){if(c.getTokenCount()===0)return!0;const S=c.findTokenIndexAtOffset(I-2),u=c.getStandardTokenType(S);return this.isOK(u)}g(c,I){for(let S=c;S<=I;S++){const u=String.fromCharCode(S);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Vu=R;class L{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of c)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Wu=L;function T(b,c,I){b.has(c)?b.get(c).push(I):b.set(c,[I])}}),define(ke[203],Ie([1,0,26,139]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D4=e.$C4=e.State=void 0,e.$E4=P;var C;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(C||(e.State=C={}));class R{constructor(a,m,$){const f=new Uint8Array(a*m);for(let i=0,s=a*m;i<s;i++)f[i]=$;this.a=f,this.rows=a,this.cols=m}get(a,m){return this.a[a*this.cols+m]}set(a,m,$){this.a[a*this.cols+m]=$}}class L{constructor(a){let m=0,$=C.Invalid;for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];o>m&&(m=o),t>$&&($=t),n>$&&($=n)}m++,$++;const f=new R($,m,C.Invalid);for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];f.set(t,o,n)}this.a=f,this.b=m}nextState(a,m){return m<0||m>=this.b?C.Invalid:this.a.get(a,m)}}e.$C4=L;let T=null;function b(){return T===null&&(T=new L([[C.Start,r.CharCode.h,C.H],[C.Start,r.CharCode.H,C.H],[C.Start,r.CharCode.f,C.F],[C.Start,r.CharCode.F,C.F],[C.H,r.CharCode.t,C.HT],[C.H,r.CharCode.T,C.HT],[C.HT,r.CharCode.t,C.HTT],[C.HT,r.CharCode.T,C.HTT],[C.HTT,r.CharCode.p,C.HTTP],[C.HTT,r.CharCode.P,C.HTTP],[C.HTTP,r.CharCode.s,C.BeforeColon],[C.HTTP,r.CharCode.S,C.BeforeColon],[C.HTTP,r.CharCode.Colon,C.AfterColon],[C.F,r.CharCode.i,C.FI],[C.F,r.CharCode.I,C.FI],[C.FI,r.CharCode.l,C.FIL],[C.FI,r.CharCode.L,C.FIL],[C.FIL,r.CharCode.e,C.BeforeColon],[C.FIL,r.CharCode.E,C.BeforeColon],[C.BeforeColon,r.CharCode.Colon,C.AfterColon],[C.AfterColon,r.CharCode.Slash,C.AlmostThere],[C.AlmostThere,r.CharCode.Slash,C.End]])),T}var c;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let I=null;function S(){if(I===null){I=new h.$gu(c.None);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<w.length;m++)I.set(w.charCodeAt(m),c.ForceTermination);const a=".,;:";for(let m=0;m<a.length;m++)I.set(a.charCodeAt(m),c.CannotEndIn)}return I}class u{static a(a,m,$,f,i){let s=i-1;do{const t=m.charCodeAt(s);if(a.get(t)!==c.CannotEndIn)break;s--}while(s>f);if(f>0){const t=m.charCodeAt(f-1),o=m.charCodeAt(s);(t===r.CharCode.OpenParen&&o===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&o===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&o===r.CharCode.CloseCurlyBrace)&&s--}return{range:{startLineNumber:$,startColumn:f+1,endLineNumber:$,endColumn:s+2},url:m.substring(f,s+1)}}static computeLinks(a,m=b()){const $=S(),f=[];for(let i=1,s=a.getLineCount();i<=s;i++){const t=a.getLineContent(i),o=t.length;let n=0,d=0,l=0,g=C.Start,E=!1,D=!1,y=!1,k=!1;for(;n<o;){let A=!1;const p=t.charCodeAt(n);if(g===C.Accept){let v;switch(p){case r.CharCode.OpenParen:E=!0,v=c.None;break;case r.CharCode.CloseParen:v=E?c.None:c.ForceTermination;break;case r.CharCode.OpenSquareBracket:y=!0,D=!0,v=c.None;break;case r.CharCode.CloseSquareBracket:y=!1,v=D?c.None:c.ForceTermination;break;case r.CharCode.OpenCurlyBrace:k=!0,v=c.None;break;case r.CharCode.CloseCurlyBrace:v=k?c.None:c.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:l===p?v=c.ForceTermination:l===r.CharCode.SingleQuote||l===r.CharCode.DoubleQuote||l===r.CharCode.BackTick?v=c.None:v=c.ForceTermination;break;case r.CharCode.Asterisk:v=l===r.CharCode.Asterisk?c.ForceTermination:c.None;break;case r.CharCode.Pipe:v=l===r.CharCode.Pipe?c.ForceTermination:c.None;break;case r.CharCode.Space:v=y?c.None:c.ForceTermination;break;default:v=$.get(p)}v===c.ForceTermination&&(f.push(u.a($,t,i,d,n)),A=!0)}else if(g===C.End){let v;p===r.CharCode.OpenSquareBracket?(D=!0,v=c.None):v=$.get(p),v===c.ForceTermination?A=!0:g=C.Accept}else g=m.nextState(g,p),g===C.Invalid&&(A=!0);A&&(g=C.Start,E=!1,D=!1,k=!1,d=n+1,l=p),n++}g===C.Accept&&f.push(u.a($,t,i,d,o))}return f}}e.$D4=u;function P(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:u.computeLinks(w)}}),define(ke[58],Ie([1,0,24]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$dw=e.$cw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$ew=w,e.$iw=s;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var C;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(C||(e.GlyphMarginLane=C={}));var R;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var T;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var b;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class S{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,r.$ho)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$cw=S;class u{constructor(o,n){this._findMatchBrand=void 0,this.range=o,this.matches=n}}e.$dw=u;var P;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function w(t){return t&&typeof t.read=="function"}var a;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class ${constructor(o,n,d,l,g,E){this.identifier=o,this.range=n,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=g,this._isTracked=E}}e.$fw=$;class f{constructor(o,n,d){this.regex=o,this.wordSeparators=n,this.simpleSearch=d}}e.$gw=f;class i{constructor(o,n,d){this.reverseEdits=o,this.changes=n,this.trimAutoWhitespaceLineNumbers=d}}e.$hw=i;function s(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(ke[204],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=e.NodeColor=e.$_C=void 0,e.$bD=C,e.$cD=R,e.$dD=c,e.$eD=I,e.$fD=S,e.$gD=u,e.$hD=P,e.$iD=w;class r{constructor(m,$){this.piece=m,this.color=$,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$aD)return C(this.right);let m=this;for(;m.parent!==e.$aD&&m.parent.left!==m;)m=m.parent;return m.parent===e.$aD?e.$aD:m.parent}prev(){if(this.left!==e.$aD)return R(this.left);let m=this;for(;m.parent!==e.$aD&&m.parent.right!==m;)m=m.parent;return m.parent===e.$aD?e.$aD:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$_C=r;var h;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$aD=new r(null,h.Black),e.$aD.parent=e.$aD,e.$aD.left=e.$aD,e.$aD.right=e.$aD,e.$aD.color=h.Black;function C(a){for(;a.left!==e.$aD;)a=a.left;return a}function R(a){for(;a.right!==e.$aD;)a=a.right;return a}function L(a){return a===e.$aD?0:a.size_left+a.piece.length+L(a.right)}function T(a){return a===e.$aD?0:a.lf_left+a.piece.lineFeedCnt+T(a.right)}function b(){e.$aD.parent=e.$aD}function c(a,m){const $=m.right;$.size_left+=m.size_left+(m.piece?m.piece.length:0),$.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=$.left,$.left!==e.$aD&&($.left.parent=m),$.parent=m.parent,m.parent===e.$aD?a.root=$:m.parent.left===m?m.parent.left=$:m.parent.right=$,$.left=m,m.parent=$}function I(a,m){const $=m.left;m.left=$.right,$.right!==e.$aD&&($.right.parent=m),$.parent=m.parent,m.size_left-=$.size_left+($.piece?$.piece.length:0),m.lf_left-=$.lf_left+($.piece?$.piece.lineFeedCnt:0),m.parent===e.$aD?a.root=$:m===m.parent.right?m.parent.right=$:m.parent.left=$,$.right=m,m.parent=$}function S(a,m){let $,f;if(m.left===e.$aD?(f=m,$=f.right):m.right===e.$aD?(f=m,$=f.left):(f=C(m.right),$=f.right),f===a.root){a.root=$,$.color=h.Black,m.detach(),b(),a.root.parent=e.$aD;return}const i=f.color===h.Red;if(f===f.parent.left?f.parent.left=$:f.parent.right=$,f===m?($.parent=f.parent,w(a,$)):(f.parent===m?$.parent=f:$.parent=f.parent,w(a,$),f.left=m.left,f.right=m.right,f.parent=m.parent,f.color=m.color,m===a.root?a.root=f:m===m.parent.left?m.parent.left=f:m.parent.right=f,f.left!==e.$aD&&(f.left.parent=f),f.right!==e.$aD&&(f.right.parent=f),f.size_left=m.size_left,f.lf_left=m.lf_left,w(a,f)),m.detach(),$.parent.left===$){const t=L($),o=T($);if(t!==$.parent.size_left||o!==$.parent.lf_left){const n=t-$.parent.size_left,d=o-$.parent.lf_left;$.parent.size_left=t,$.parent.lf_left=o,P(a,$.parent,n,d)}}if(w(a,$.parent),i){b();return}let s;for(;$!==a.root&&$.color===h.Black;)$===$.parent.left?(s=$.parent.right,s.color===h.Red&&(s.color=h.Black,$.parent.color=h.Red,c(a,$.parent),s=$.parent.right),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,$=$.parent):(s.right.color===h.Black&&(s.left.color=h.Black,s.color=h.Red,I(a,s),s=$.parent.right),s.color=$.parent.color,$.parent.color=h.Black,s.right.color=h.Black,c(a,$.parent),$=a.root)):(s=$.parent.left,s.color===h.Red&&(s.color=h.Black,$.parent.color=h.Red,I(a,$.parent),s=$.parent.left),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,$=$.parent):(s.left.color===h.Black&&(s.right.color=h.Black,s.color=h.Red,c(a,s),s=$.parent.left),s.color=$.parent.color,$.parent.color=h.Black,s.left.color=h.Black,I(a,$.parent),$=a.root));$.color=h.Black,b()}function u(a,m){for(w(a,m);m!==a.root&&m.parent.color===h.Red;)if(m.parent===m.parent.parent.left){const $=m.parent.parent.right;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,c(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,I(a,m.parent.parent))}else{const $=m.parent.parent.left;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,I(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,c(a,m.parent.parent))}a.root.color=h.Black}function P(a,m,$,f){for(;m!==a.root&&m!==e.$aD;)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=f),m=m.parent}function w(a,m){let $=0,f=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,$=L(m.left)-m.size_left,f=T(m.left)-m.lf_left,m.size_left+=$,m.lf_left+=f;m!==a.root&&($!==0||f!==0);)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=f),m=m.parent}}}),define(ke[205],Ie([1,0,18,83]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.$lw=void 0;class C{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,c){b=(0,h.$bf)(b);const I=this.a,S=this.b,u=c.length;return u===0?!1:(this.a=new Uint32Array(I.length+u),this.a.set(I.subarray(0,b),0),this.a.set(I.subarray(b),b+u),this.a.set(c,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}setValue(b,c){return b=(0,h.$bf)(b),c=(0,h.$bf)(c),this.a[b]===c?!1:(this.a[b]=c,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,c){b=(0,h.$bf)(b),c=(0,h.$bf)(c);const I=this.a,S=this.b;if(b>=I.length)return!1;const u=I.length-b;return c>=u&&(c=u),c===0?!1:(this.a=new Uint32Array(I.length-c),this.a.set(I.subarray(0,b),0),this.a.set(I.subarray(b+c),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,h.$bf)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),b>=this.a.length&&(b=this.a.length-1);for(let I=c;I<=b;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let c=0,I=this.a.length-1,S=0,u=0,P=0;for(;c<=I;)if(S=c+(I-c)/2|0,u=this.b[S],P=u-this.a[S],b<P)I=S-1;else if(b>=u)c=S+1;else break;return new L(S,b-P)}}e.$lw=C;class R{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const c=this.e[b],I=c>0?this.d[c-1]:0;return new L(c,b-I)}removeValues(b,c){this.a.splice(b,c),this.f(b)}insertValues(b,c){this.a=(0,r.$Ub)(this.a,b,c),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,c=this.a.length;b<c;b++){const I=this.a[b],S=b>0?this.d[b-1]:0;this.d[b]=S+I;for(let u=0;u<I;u++)this.e[S+u]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,c){this.a[b]!==c&&(this.a[b]=c,this.f(b))}}e.$mw=R;class L{constructor(b,c){this.index=b,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=c}}e.$nw=L}),define(ke[206],Ie([1,0,12,57,205]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=void 0;class R{constructor(T,b,c,I){this.d=T,this.f=b,this.g=c,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(T){T.eol&&T.eol!==this.g&&(this.g=T.eol,this.j=null);const b=T.changes;for(const c of b)this.o(c.range),this.p(new h.$Mt(c.range.startLineNumber,c.range.startColumn),c.text);this.h=T.versionId,this.k=null}l(){if(!this.j){const T=this.g.length,b=this.f.length,c=new Uint32Array(b);for(let I=0;I<b;I++)c[I]=this.f[I].length+T;this.j=new C.$lw(c)}}n(T,b){this.f[T]=b,this.j&&this.j.setValue(T,this.f[T].length+this.g.length)}o(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.startLineNumber-1].substring(T.endColumn-1));return}this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.endLineNumber-1].substring(T.endColumn-1)),this.f.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.j&&this.j.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}p(T,b){if(b.length===0)return;const c=(0,r.$sf)(b);if(c.length===1){this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+c[0]+this.f[T.lineNumber-1].substring(T.column-1));return}c[c.length-1]+=this.f[T.lineNumber-1].substring(T.column-1),this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+c[0]);const I=new Uint32Array(c.length-1);for(let S=1;S<c.length;S++)this.f.splice(T.lineNumber+S-1,0,c[S]),I[S-1]=c[S].length+this.g.length;this.j&&this.j.insertValues(T.lineNumber,I)}}e.$ow=R}),define(ke[111],Ie([1,0,26,12,200,57,30,58]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oD=e.$mD=e.$jD=void 0,e.$kD=I,e.$lD=S,e.$nD=m,h=qe(h);const b=999;class c{constructor(i,s,t,o){this.searchString=i,this.isRegex=s,this.matchCase=t,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=I(this.searchString):i=this.searchString.indexOf(`
`)>=0;let s=null;try{s=h.$qf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!s)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new T.$gw(s,this.wordSeparators?(0,C.$ju)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$jD=c;function I(f){if(!f||f.length===0)return!1;for(let i=0,s=f.length;i<s;i++){const t=f.charCodeAt(i);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(i++,i>=s)break;const o=f.charCodeAt(i);if(o===r.CharCode.n||o===r.CharCode.r||o===r.CharCode.W)return!0}}return!1}function S(f,i,s){if(!s)return new T.$dw(f,null);const t=[];for(let o=0,n=i.length;o<n;o++)t[o]=i[o];return new T.$dw(f,t)}class u{constructor(i){const s=[];let t=0;for(let o=0,n=i.length;o<n;o++)i.charCodeAt(o)===r.CharCode.LineFeed&&(s[t++]=o);this.a=s}findLineFeedCountBeforeOffset(i){const s=this.a;let t=0,o=s.length-1;if(o===-1||i<=s[0])return 0;for(;t<o;){const n=t+((o-t)/2>>0);s[n]>=i?o=n-1:s[n+1]>=i?(t=n,o=n):t=n+1}return t+1}}class P{static findMatches(i,s,t,o,n){const d=s.parseSearchRequest();return d?d.regex.multiline?this.b(i,t,new $(d.wordSeparators,d.regex),o,n):this.c(i,t,d,o,n):[]}static a(i,s,t,o,n,d){let l,g=0;o?(g=o.findLineFeedCountBeforeOffset(n),l=s+n+g):l=s+n;let E;if(o){const A=o.findLineFeedCountBeforeOffset(n+d.length)-g;E=l+d.length+A}else E=l+d.length;const D=i.getPositionAt(l),y=i.getPositionAt(E);return new L.$Nt(D.lineNumber,D.column,y.lineNumber,y.column)}static b(i,s,t,o,n){const d=i.getOffsetAt(s.getStartPosition()),l=i.getValueInRange(s,T.EndOfLinePreference.LF),g=i.getEOL()===`\r
`?new u(l):null,E=[];let D=0,y;for(t.reset(0);y=t.next(l);)if(E[D++]=S(this.a(i,d,l,g,y.index,y[0]),y,o),D>=n)return E;return E}static c(i,s,t,o,n){const d=[];let l=0;if(s.startLineNumber===s.endLineNumber){const E=i.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return l=this.d(t,E,s.startLineNumber,s.startColumn-1,l,d,o,n),d}const g=i.getLineContent(s.startLineNumber).substring(s.startColumn-1);l=this.d(t,g,s.startLineNumber,s.startColumn-1,l,d,o,n);for(let E=s.startLineNumber+1;E<s.endLineNumber&&l<n;E++)l=this.d(t,i.getLineContent(E),E,0,l,d,o,n);if(l<n){const E=i.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);l=this.d(t,E,s.endLineNumber,0,l,d,o,n)}return d}static d(i,s,t,o,n,d,l,g){const E=i.wordSeparators;if(!l&&i.simpleSearch){const k=i.simpleSearch,A=k.length,p=s.length;let v=-A;for(;(v=s.indexOf(k,v+A))!==-1;)if((!E||m(E,s,p,v,A))&&(d[n++]=new T.$dw(new L.$Nt(t,v+1+o,t,v+1+A+o),null),n>=g))return n;return n}const D=new $(i.wordSeparators,i.regex);let y;D.reset(0);do if(y=D.next(s),y&&(d[n++]=S(new L.$Nt(t,y.index+1+o,t,y.index+1+y[0].length+o),y,l),n>=g))return n;while(y);return n}static findNextMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.e(i,t,d,o):this.f(i,t,d,o)}static e(i,s,t,o){const n=new R.$Mt(s.lineNumber,1),d=i.getOffsetAt(n),l=i.getLineCount(),g=i.getValueInRange(new L.$Nt(n.lineNumber,n.column,l,i.getLineMaxColumn(l)),T.EndOfLinePreference.LF),E=i.getEOL()===`\r
`?new u(g):null;t.reset(s.column-1);const D=t.next(g);return D?S(this.a(i,d,g,E,D.index,D[0]),D,o):s.lineNumber!==1||s.column!==1?this.e(i,new R.$Mt(1,1),t,o):null}static f(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d),g=this.g(t,l,d,s.column,o);if(g)return g;for(let E=1;E<=n;E++){const D=(d+E-1)%n,y=i.getLineContent(D+1),k=this.g(t,y,D+1,1,o);if(k)return k}return null}static g(i,s,t,o,n){i.reset(o-1);const d=i.next(s);return d?S(new L.$Nt(t,d.index+1,t,d.index+1+d[0].length),d,n):null}static findPreviousMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.h(i,t,d,o):this.j(i,t,d,o)}static h(i,s,t,o){const n=this.b(i,new L.$Nt(1,1,s.lineNumber,s.column),t,o,10*b);if(n.length>0)return n[n.length-1];const d=i.getLineCount();return s.lineNumber!==d||s.column!==i.getLineMaxColumn(d)?this.h(i,new R.$Mt(d,i.getLineMaxColumn(d)),t,o):null}static j(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d).substring(0,s.column-1),g=this.k(t,l,d,o);if(g)return g;for(let E=1;E<=n;E++){const D=(n+d-E-1)%n,y=i.getLineContent(D+1),k=this.k(t,y,D+1,o);if(k)return k}return null}static k(i,s,t,o){let n=null,d;for(i.reset(0);d=i.next(s);)n=S(new L.$Nt(t,d.index+1,t,d.index+1+d[0].length),d,o);return n}}e.$mD=P;function w(f,i,s,t,o){if(t===0)return!0;const n=i.charCodeAt(t-1);if(f.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t);if(f.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function a(f,i,s,t,o){if(t+o===s)return!0;const n=i.charCodeAt(t+o);if(f.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t+o-1);if(f.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function m(f,i,s,t,o){return w(f,i,s,t,o)&&a(f,i,s,t,o)}class ${constructor(i,s){this._wordSeparators=i,this.a=s,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const s=i.length;let t;do{if(this.b+this.c===s||(t=this.a.exec(i),!t))return null;const o=t.index,n=t[0].length;if(o===this.b&&n===this.c){if(n===0){h.$Mf(i,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=n,!this._wordSeparators||m(this._wordSeparators,i,s,o,n))return t}while(t);return null}}e.$oD=$}),define(ke[141],Ie([1,0,26,57,30,58,204,111]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=e.$sD=e.$rD=void 0,e.$pD=S,e.$qD=u;const b=65535;function c(f){let i;return f[f.length-1]<65536?i=new Uint16Array(f.length):i=new Uint32Array(f.length),i.set(f,0),i}class I{constructor(i,s,t,o,n){this.lineStarts=i,this.cr=s,this.lf=t,this.crlf=o,this.isBasicASCII=n}}function S(f,i=!0){const s=[0];let t=1;for(let o=0,n=f.length;o<n;o++){const d=f.charCodeAt(o);d===r.CharCode.CarriageReturn?o+1<n&&f.charCodeAt(o+1)===r.CharCode.LineFeed?(s[t++]=o+2,o++):s[t++]=o+1:d===r.CharCode.LineFeed&&(s[t++]=o+1)}return i?c(s):s}function u(f,i){f.length=0,f[0]=0;let s=1,t=0,o=0,n=0,d=!0;for(let g=0,E=i.length;g<E;g++){const D=i.charCodeAt(g);D===r.CharCode.CarriageReturn?g+1<E&&i.charCodeAt(g+1)===r.CharCode.LineFeed?(n++,f[s++]=g+2,g++):(t++,f[s++]=g+1):D===r.CharCode.LineFeed?(o++,f[s++]=g+1):d&&D!==r.CharCode.Tab&&(D<32||D>126)&&(d=!1)}const l=new I(c(f),t,o,n,d);return f.length=0,l}class P{constructor(i,s,t,o,n){this.bufferIndex=i,this.start=s,this.end=t,this.lineFeedCnt=o,this.length=n}}e.$rD=P;class w{constructor(i,s){this.buffer=i,this.lineStarts=s}}e.$sD=w;class a{constructor(i,s){this.a=[],this.c=i,this.d=s,this.b=0,i.root!==L.$aD&&i.iterate(i.root,t=>(t!==L.$aD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class m{constructor(i){this.a=i,this.b=[]}get(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let s=!1;const t=this.b;for(let o=0;o<t.length;o++){const n=t[o];if(n.node.parent===null||n.nodeStartOffset>=i){t[o]=null,s=!0;continue}}if(s){const o=[];for(const n of t)n!==null&&o.push(n);this.b=o}}}class ${constructor(i,s,t){this.create(i,s,t)}create(i,s,t){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=L.$aD,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=t;let o=null;for(let n=0,d=i.length;n<d;n++)if(i[n].buffer.length>0){i[n].lineStarts||(i[n].lineStarts=S(i[n].buffer));const l=new P(n+1,{line:0,column:0},{line:i[n].lineStarts.length-1,column:i[n].buffer.length-i[n].lineStarts[i[n].lineStarts.length-1]},i[n].lineStarts.length-1,i[n].buffer.length);this.a.push(i[n]),o=this.S(o,l)}this.h=new m(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const s=b,t=s-Math.floor(s/3),o=t*2;let n="",d=0;const l=[];if(this.iterate(this.root,g=>{const E=this.R(g),D=E.length;if(d<=t||d+D<o)return n+=E,d+=D,!0;const y=n.replace(/\r\n|\r|\n/g,i);return l.push(new w(y,S(y))),n=E,d=D,!0}),d>0){const g=n.replace(/\r\n|\r|\n/g,i);l.push(new w(g,S(g)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new a(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let s=0;return this.iterate(this.root,o=>{if(o===L.$aD)return!0;const n=this.R(o),d=n.length,l=i.G(s),g=i.G(s+d),E=i.getValueInRange2(l,g);return s+=d,n===E})}getOffsetAt(i,s){let t=0,o=this.root;for(;o!==L.$aD;)if(o.left!==L.$aD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const n=this.B(o,i-o.lf_left-2);return t+=n+s-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let s=this.root,t=0;const o=i;for(;s!==L.$aD;)if(s.size_left!==0&&s.size_left>=i)s=s.left;else if(s.size_left+s.piece.length>=i){const n=this.A(s,i-s.size_left);if(t+=s.lf_left+n.index,n.index===0){const d=this.getOffsetAt(t+1,1),l=o-d;return new h.$Mt(t+1,l+1)}return new h.$Mt(t+1,n.remainder+1)}else if(i-=s.size_left+s.piece.length,t+=s.lf_left+s.piece.lineFeedCnt,s.right===L.$aD){const n=this.getOffsetAt(t+1,1),d=o-i-n;return new h.$Mt(t+1,d+1)}else s=s.right;return new h.$Mt(1,1)}getValueInRange(i,s){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),n=this.getValueInRange2(t,o);return s?s!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,s):n}getValueInRange2(i,s){if(i.node===s.node){const l=i.node,g=this.a[l.piece.bufferIndex].buffer,E=this.u(l.piece.bufferIndex,l.piece.start);return g.substring(E+i.remainder,E+s.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,n=this.u(t.piece.bufferIndex,t.piece.start);let d=o.substring(n+i.remainder,n+t.piece.length);for(t=t.next();t!==L.$aD;){const l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(t===s.node){d+=l.substring(g,g+s.remainder);break}else d+=l.substr(g,t.piece.length);t=t.next()}return d}getLinesContent(){const i=[];let s=0,t="",o=!1;return this.iterate(this.root,n=>{if(n===L.$aD)return!0;const d=n.piece;let l=d.length;if(l===0)return!0;const g=this.a[d.bufferIndex].buffer,E=this.a[d.bufferIndex].lineStarts,D=d.start.line,y=d.end.line;let k=E[D]+d.start.column;if(o&&(g.charCodeAt(k)===r.CharCode.LineFeed&&(k++,l--),i[s++]=t,t="",o=!1,l===0))return!0;if(D===y)return!this.f&&g.charCodeAt(k+l-1)===r.CharCode.CarriageReturn?(o=!0,t+=g.substr(k,l-1)):t+=g.substr(k,l),!0;t+=this.f?g.substring(k,Math.max(k,E[D+1]-this.e)):g.substring(k,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;for(let A=D+1;A<y;A++)t=this.f?g.substring(E[A],E[A+1]-this.e):g.substring(E[A],E[A+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;return!this.f&&g.charCodeAt(E[y]+d.end.column-1)===r.CharCode.CarriageReturn?(o=!0,d.end.column===0?s--:t=g.substr(E[y],d.end.column-1)):t=g.substr(E[y],d.end.column),!0}),o&&(i[s++]=t,t=""),i[s++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const s=i.node.next();if(!s)return 0;const t=this.a[s.piece.bufferIndex],o=this.u(s.piece.bufferIndex,s.piece.start);return t.buffer.charCodeAt(o)}else{const s=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return s.buffer.charCodeAt(o)}}getLineCharCode(i,s){const t=this.H(i,s+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const s=this.getOffsetAt(i,1);return this.getLength()-s}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const s=this.G(i);return this.l(s)}getNearestChunk(i){const s=this.G(i);if(s.remainder===s.node.piece.length){const t=s.node.next();if(!t||t===L.$aD)return"";const o=this.a[t.piece.bufferIndex],n=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(n,n+t.piece.length)}else{const t=this.a[s.node.piece.bufferIndex],o=this.u(s.node.piece.bufferIndex,s.node.piece.start),n=o+s.remainder,d=o+s.node.piece.length;return t.buffer.substring(n,d)}}findMatchesInNode(i,s,t,o,n,d,l,g,E,D,y){const k=this.a[i.piece.bufferIndex],A=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,n),v=this.u(i.piece.bufferIndex,d);let F;const N={line:0,column:0};let O,j;s._wordSeparators?(O=k.buffer.substring(p,v),j=z=>z+p,s.reset(0)):(O=k.buffer,j=z=>z,s.reset(p));do if(F=s.next(O),F){if(j(F.index)>=v)return D;this.s(i,j(F.index)-A,N);const z=this.t(i.piece.bufferIndex,n,N),M=N.line===n.line?N.column-n.column+o:N.column+1,U=M+F[0].length;if(y[D++]=(0,T.$lD)(new C.$Nt(t+z,M,t+z,U),F,g),j(F.index)+F[0].length>=v||D>=E)return D}while(F);return D}findMatchesLineByLine(i,s,t,o){const n=[];let d=0;const l=new T.$oD(s.wordSeparators,s.regex);let g=this.H(i.startLineNumber,i.startColumn);if(g===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(g.node,g.remainder);const y=this.s(E.node,E.remainder);if(g.node===E.node)return this.findMatchesInNode(g.node,l,i.startLineNumber,i.startColumn,D,y,s,t,o,d,n),n;let k=i.startLineNumber,A=g.node;for(;A!==E.node;){const v=this.t(A.piece.bufferIndex,D,A.piece.end);if(v>=1){const N=this.a[A.piece.bufferIndex].lineStarts,O=this.u(A.piece.bufferIndex,A.piece.start),j=N[D.line+v],z=k===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(A,l,k,z,D,this.s(A,j-O),s,t,o,d,n),d>=o)return n;k+=v}const F=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const N=this.getLineContent(k).substring(F,i.endColumn-1);return d=this.n(s,l,N,i.endLineNumber,F,d,n,t,o),n}if(d=this.n(s,l,this.getLineContent(k).substr(F),k,F,d,n,t,o),d>=o)return n;k++,g=this.H(k,1),A=g.node,D=this.s(g.node,g.remainder)}if(k===i.endLineNumber){const v=k===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(k).substring(v,i.endColumn-1);return d=this.n(s,l,F,i.endLineNumber,v,d,n,t,o),n}const p=k===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(E.node,l,k,p,D,y,s,t,o,d,n),n}n(i,s,t,o,n,d,l,g,E){const D=i.wordSeparators;if(!g&&i.simpleSearch){const k=i.simpleSearch,A=k.length,p=t.length;let v=-A;for(;(v=t.indexOf(k,v+A))!==-1;)if((!D||(0,T.$nD)(D,t,p,v,A))&&(l[d++]=new R.$dw(new C.$Nt(o,v+1+n,o,v+1+A+n),null),d>=E))return d;return d}let y;s.reset(0);do if(y=s.next(t),y&&(l[d++]=(0,T.$lD)(new C.$Nt(o,y.index+1+n,o,y.index+1+y[0].length+n),y,g),d>=E))return d;while(y);return d}insert(i,s,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==L.$aD){const{node:o,remainder:n,nodeStartOffset:d}=this.G(i),l=o.piece,g=l.bufferIndex,E=this.s(o,n);if(o.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&d+l.length===i&&s.length<b){this.F(o,s),this.y();return}if(d===i)this.o(s,o),this.h.validate(i);else if(d+o.piece.length>i){const D=[];let y=new P(l.bufferIndex,E,l.end,this.t(l.bufferIndex,E,l.end),this.u(g,l.end)-this.u(g,E));if(this.K()&&this.M(s)&&this.I(o,n)===10){const v={line:y.start.line+1,column:0};y=new P(y.bufferIndex,v,y.end,this.t(y.bufferIndex,v,y.end),y.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(o,n-1)===13){const v=this.s(o,n-1);this.C(o,v),s="\r"+s,o.piece.length===0&&D.push(o)}else this.C(o,E);else this.C(o,E);const k=this.w(s);y.length>0&&this.S(o,y);let A=o;for(let p=0;p<k.length;p++)A=this.S(A,k[p]);this.v(D)}else this.q(s,o)}else{const o=this.w(s);let n=this.T(null,o[0]);for(let d=1;d<o.length;d++)n=this.S(n,o[d])}this.y()}delete(i,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===L.$aD)return;const t=this.G(i),o=this.G(i+s),n=t.node,d=o.node;if(n===d){const k=this.s(n,t.remainder),A=this.s(n,o.remainder);if(t.nodeStartOffset===i){if(s===n.piece.length){const p=n.next();(0,L.$fD)(this,n),this.N(p),this.y();return}this.D(n,A),this.h.validate(i),this.N(n),this.y();return}if(t.nodeStartOffset+n.piece.length===i+s){this.C(n,k),this.O(n),this.y();return}this.E(n,k,A),this.y();return}const l=[],g=this.s(n,t.remainder);this.C(n,g),this.h.validate(i),n.piece.length===0&&l.push(n);const E=this.s(d,o.remainder);this.D(d,E),d.piece.length===0&&l.push(d);const D=n.next();for(let k=D;k!==L.$aD&&k!==d;k=k.next())l.push(k);const y=n.piece.length===0?n.prev():n;this.v(l),this.O(y),this.y()}o(i,s){const t=[];if(this.K()&&this.M(i)&&this.L(s)){const d=s.piece,l={line:d.start.line+1,column:0},g=new P(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),d.length-1);s.piece=g,i+=`
`,(0,L.$hD)(this,s,-1,-1),s.piece.length===0&&t.push(s)}const o=this.w(i);let n=this.T(s,o[o.length-1]);for(let d=o.length-2;d>=0;d--)n=this.T(n,o[d]);this.N(n),this.v(t)}q(i,s){this.Q(i,s)&&(i+=`
`);const t=this.w(i),o=this.S(s,t[0]);let n=o;for(let d=1;d<t.length;d++)n=this.S(n,t[d]);this.N(o)}s(i,s,t){const o=i.piece,n=i.piece.bufferIndex,d=this.a[n].lineStarts,g=d[o.start.line]+o.start.column+s;let E=o.start.line,D=o.end.line,y=0,k=0,A=0;for(;E<=D&&(y=E+(D-E)/2|0,A=d[y],y!==D);)if(k=d[y+1],g<A)D=y-1;else if(g>=k)E=y+1;else break;return t?(t.line=y,t.column=g-A,null):{line:y,column:g-A}}t(i,s,t){if(t.column===0)return t.line-s.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-s.line;const n=o[t.line+1],d=o[t.line]+t.column;if(n>d+1)return t.line-s.line;const l=d-1;return this.a[i].buffer.charCodeAt(l)===13?t.line-s.line+1:t.line-s.line}u(i,s){return this.a[i].lineStarts[s.line]+s.column}v(i){for(let s=0;s<i.length;s++)(0,L.$fD)(this,i[s])}w(i){if(i.length>b){const D=[];for(;i.length>b;){const k=i.charCodeAt(b-1);let A;k===r.CharCode.CarriageReturn||k>=55296&&k<=56319?(A=i.substring(0,b-1),i=i.substring(b-1)):(A=i.substring(0,b),i=i.substring(b));const p=S(A);D.push(new P(this.a.length,{line:0,column:0},{line:p.length-1,column:A.length-p[p.length-1]},p.length-1,A.length)),this.a.push(new w(A,p))}const y=S(i);return D.push(new P(this.a.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this.a.push(new w(i,y)),D}let s=this.a[0].buffer.length;const t=S(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let D=0;D<t.length;D++)t[D]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,s+=1}else{if(s!==0)for(let D=0;D<t.length;D++)t[D]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const n=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,l=n-this.a[0].lineStarts[d],g={line:d,column:l},E=new P(0,o,g,this.t(0,o,g),n-s);return this.g=g,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,s=0){let t=this.root,o="";const n=this.h.get2(i);if(n){t=n.node;const d=this.B(t,i-n.nodeStartLineNumber-1),l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(n.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=l.substring(g+d,g+t.piece.length);else{const E=this.B(t,i-n.nodeStartLineNumber);return l.substring(g+d,g+E-s)}}else{let d=0;const l=i;for(;t!==L.$aD;)if(t.left!==L.$aD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const g=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return d+=t.size_left,this.h.set({node:t,nodeStartOffset:d,nodeStartLineNumber:l-(i-1-t.lf_left)}),D.substring(y+g,y+E-s)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const g=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);o=E.substring(D+g,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,d+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==L.$aD;){const d=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.u(t.piece.bufferIndex,t.piece.start);return o+=d.substring(g,g+l-s),o}else{const l=this.u(t.piece.bufferIndex,t.piece.start);o+=d.substr(l,t.piece.length)}t=t.next()}return o}y(){let i=this.root,s=1,t=0;for(;i!==L.$aD;)s+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=s,this.c=t,this.h.validate(this.c)}A(i,s){const t=i.piece,o=this.s(i,s),n=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===s){const d=this.t(i.piece.bufferIndex,t.start,o);if(d!==n)return{index:d,remainder:0}}return{index:n,remainder:o.column}}B(i,s){if(s<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,n=t.start.line+s+1;return n>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[n]-o[t.start.line]-t.start.column}C(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.end),d=s,l=this.u(t.bufferIndex,d),g=this.t(t.bufferIndex,t.start,d),E=g-o,D=l-n,y=t.length+D;i.piece=new P(t.bufferIndex,t.start,d,g,y),(0,L.$hD)(this,i,D,E)}D(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.start),d=s,l=this.t(t.bufferIndex,d,t.end),g=this.u(t.bufferIndex,d),E=l-o,D=n-g,y=t.length+D;i.piece=new P(t.bufferIndex,d,t.end,l,y),(0,L.$hD)(this,i,D,E)}E(i,s,t){const o=i.piece,n=o.start,d=o.end,l=o.length,g=o.lineFeedCnt,E=s,D=this.t(o.bufferIndex,o.start,E),y=this.u(o.bufferIndex,s)-this.u(o.bufferIndex,n);i.piece=new P(o.bufferIndex,o.start,E,D,y),(0,L.$hD)(this,i,y-l,D-g);const k=new P(o.bufferIndex,t,d,this.t(o.bufferIndex,t,d),this.u(o.bufferIndex,d)-this.u(o.bufferIndex,t)),A=this.S(i,k);this.N(A)}F(i,s){this.Q(s,i)&&(s+=`
`);const t=this.K()&&this.L(s)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=s;const n=S(s,!1);for(let A=0;A<n.length;A++)n[A]+=o;if(t){const A=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-A}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const d=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[d],g={line:d,column:l},E=i.piece.length+s.length,D=i.piece.lineFeedCnt,y=this.t(0,i.piece.start,g),k=y-D;i.piece=new P(i.piece.bufferIndex,i.piece.start,g,y,E),this.g=g,(0,L.$hD)(this,i,s.length,k)}G(i){let s=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;s!==L.$aD;)if(s.size_left>i)s=s.left;else if(s.size_left+s.piece.length>=i){o+=s.size_left;const n={node:s,remainder:i-s.size_left,nodeStartOffset:o};return this.h.set(n),n}else i-=s.size_left+s.piece.length,o+=s.size_left+s.piece.length,s=s.right;return null}H(i,s){let t=this.root,o=0;for(;t!==L.$aD;)if(t.left!==L.$aD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const n=this.B(t,i-t.lf_left-2),d=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(n+s-1,d),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const n=this.B(t,i-t.lf_left-2);if(n+s-1<=t.piece.length)return{node:t,remainder:n+s-1,nodeStartOffset:o};s-=t.piece.length-n;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==L.$aD;){if(t.piece.lineFeedCnt>0){const n=this.B(t,0),d=this.J(t);return{node:t,remainder:Math.min(s-1,n),nodeStartOffset:d}}else if(t.piece.length>=s-1){const n=this.J(t);return{node:t,remainder:s-1,nodeStartOffset:n}}else s-=t.piece.length;t=t.next()}return null}I(i,s){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+s;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let s=i.size_left;for(;i!==this.root;)i.parent.right===i&&(s+=i.parent.size_left+i.parent.piece.length),i=i.parent;return s}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$aD||i.piece.lineFeedCnt===0)return!1;const s=i.piece,t=this.a[s.bufferIndex].lineStarts,o=s.start.line,n=t[o]+s.start.column;return o===t.length-1||t[o+1]>n+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(n)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$aD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const s=i.prev();this.M(s)&&this.P(s,i)}}O(i){if(this.K()&&this.M(i)){const s=i.next();this.L(s)&&this.P(i,s)}}P(i,s){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let n;i.piece.end.column===0?n={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:n={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new P(i.piece.bufferIndex,i.piece.start,n,l,d),(0,L.$hD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const g={line:s.piece.start.line+1,column:0},E=s.piece.length-1,D=this.t(s.piece.bufferIndex,g,s.piece.end);s.piece=new P(s.piece.bufferIndex,g,s.piece.end,D,E),(0,L.$hD)(this,s,-1,-1),s.piece.length===0&&t.push(s);const y=this.w(`\r
`);this.S(i,y[0]);for(let k=0;k<t.length;k++)(0,L.$fD)(this,t[k])}Q(i,s){if(this.K()&&this.M(i)){const t=s.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,L.$fD)(this,t);else{const o=t.piece,n={line:o.start.line+1,column:0},d=o.length-1,l=this.t(o.bufferIndex,n,o.end);t.piece=new P(o.bufferIndex,n,o.end,l,d),(0,L.$hD)(this,t,-1,-1)}return!0}}return!1}iterate(i,s){if(i===L.$aD)return s(L.$aD);const t=this.iterate(i.left,s);return t&&s(i)&&this.iterate(i.right,s)}R(i){if(i===L.$aD)return"";const s=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),n=this.u(t.bufferIndex,t.end);return s.buffer.substring(o,n)}getPieceContent(i){const s=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return s.buffer.substring(t,o)}S(i,s){const t=new L.$_C(s,L.NodeColor.Red);if(t.left=L.$aD,t.right=L.$aD,t.parent=L.$aD,t.size_left=0,t.lf_left=0,this.root===L.$aD)this.root=t,t.color=L.NodeColor.Black;else if(i.right===L.$aD)i.right=t,t.parent=i;else{const n=(0,L.$bD)(i.right);n.left=t,t.parent=n}return(0,L.$gD)(this,t),t}T(i,s){const t=new L.$_C(s,L.NodeColor.Red);if(t.left=L.$aD,t.right=L.$aD,t.parent=L.$aD,t.size_left=0,t.lf_left=0,this.root===L.$aD)this.root=t,t.color=L.NodeColor.Black;else if(i.left===L.$aD)i.left=t,t.parent=i;else{const o=(0,L.$cD)(i.left);o.right=t,t.parent=o}return(0,L.$gD)(this,t),t}U(i){let s="";return this.iterate(i,t=>(s+=this.R(t),!0)),s}}e.$tD=$}),define(ke[207],Ie([1,0,4,12,30,58,141,194,198,3]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uD=void 0,h=qe(h);class I extends c.$Uc{constructor(u,P,w,a,m,$,f){super(),this.m=this.B(new r.$le),this.onDidChangeContent=this.m.event,this.f=P,this.j=!$,this.g=a,this.h=m,this.c=new L.$tD(u,w,f)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,P){return this.c.getOffsetAt(u,P)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,P){const w=u+P,a=this.getPositionAt(u),m=this.getPositionAt(w);return new C.$Nt(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const w=this.n(P);return this.c.getValueInRange(u,w)}getValueLengthInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const w=this.getOffsetAt(u.startLineNumber,u.startColumn),a=this.getOffsetAt(u.endLineNumber,u.endColumn);let m=0;const $=this.n(P),f=this.getEOL();if($.length!==f.length){const i=$.length-f.length,s=u.endLineNumber-u.startLineNumber;m=i*s}return a-w+m}getCharacterCountInRange(u,P=R.EndOfLinePreference.TextDefined){if(this.j){let w=0;const a=u.startLineNumber,m=u.endLineNumber;for(let $=a;$<=m;$++){const f=this.getLineContent($),i=$===a?u.startColumn-1:0,s=$===m?u.endColumn-1:f.length;for(let t=i;t<s;t++)h.$Jf(f.charCodeAt(t))?(w=w+1,t=t+1):w=w+1}return w+=this.n(P).length*(m-a),w}return this.getValueLengthInRange(u,P)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,P){return this.c.getLineCharCode(u,P)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const P=h.$uf(this.getLineContent(u));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(u){const P=h.$wf(this.getLineContent(u));return P===-1?0:P+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,P,w){let a=this.g,m=this.h,$=this.j,f=!0,i=[];for(let g=0;g<u.length;g++){const E=u[g];f&&E._isTracked&&(f=!1);const D=E.range;if(E.text){let v=!0;$||(v=!h.$Uf(E.text),$=v),!a&&v&&(a=h.$Tf(E.text)),!m&&v&&(m=h.$Wf(E.text))}let y="",k=0,A=0,p=0;if(E.text){let v;[k,A,p,v]=(0,T.$yu)(E.text);const F=this.getEOL(),N=F===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;v===T.StringEOL.Unknown||v===N?y=E.text:y=E.text.replace(/\r\n|\r|\n/g,F)}i[g]={sortIndex:g,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:k,firstLineLength:A,lastLineLength:p,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(I.u);let s=!1;for(let g=0,E=i.length-1;g<E;g++){const D=i[g].range.getEndPosition(),y=i[g+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}f&&(i=this.s(i));const t=w||P?I._getInverseEditRanges(i):[],o=[];if(P)for(let g=0;g<i.length;g++){const E=i[g],D=t[g];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let k="";y===D.startLineNumber&&(k=this.getLineContent(E.range.startLineNumber),h.$uf(k)!==-1)||o.push({lineNumber:y,oldContent:k})}}let n=null;if(w){let g=0;n=[];for(let E=0;E<i.length;E++){const D=i[E],y=t[E],k=this.getValueInRange(D.range),A=D.rangeOffset+g;g+=D.text.length-k.length,n[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:k,textChange:new b.$eu(D.rangeOffset,k,A,D.text)}}s||n.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=a,this.h=m,this.j=$;const d=this.t(i);let l=null;if(P&&o.length>0){o.sort((g,E)=>E.lineNumber-g.lineNumber),l=[];for(let g=0,E=o.length;g<E;g++){const D=o[g].lineNumber;if(g>0&&o[g-1].lineNumber===D)continue;const y=o[g].oldContent,k=this.getLineContent(D);k.length===0||k===y||h.$uf(k)!==-1||l.push(D)}}return this.m.fire(),new R.$hw(n,d,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let P=!1;const w=u[0].range,a=u[u.length-1].range,m=new C.$Nt(w.startLineNumber,w.startColumn,a.endLineNumber,a.endColumn);let $=w.startLineNumber,f=w.startColumn;const i=[];for(let d=0,l=u.length;d<l;d++){const g=u[d],E=g.range;P=P||g.forceMoveMarkers,i.push(this.getValueInRange(new C.$Nt($,f,E.startLineNumber,E.startColumn))),g.text.length>0&&i.push(g.text),$=E.endLineNumber,f=E.endColumn}const s=i.join(""),[t,o,n]=(0,T.$yu)(s);return{sortIndex:0,identifier:u[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,R.EndOfLinePreference.TextDefined),text:s,eolCount:t,firstLineLength:o,lastLineLength:n,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const P=[];for(let w=0;w<u.length;w++){const a=u[w],m=a.range.startLineNumber,$=a.range.startColumn,f=a.range.endLineNumber,i=a.range.endColumn;if(m===f&&$===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const s=new C.$Nt(m,$,f,i);P.push({range:s,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return P}findMatchesLineByLine(u,P,w,a){return this.c.findMatchesLineByLine(u,P,w,a)}getPieceTree(){return this.c}static _getInverseEditRange(u,P){const w=u.startLineNumber,a=u.startColumn,[m,$,f]=(0,T.$yu)(P);let i;if(P.length>0){const s=m+1;s===1?i=new C.$Nt(w,a,w,a+$):i=new C.$Nt(w,a,w+s-1,f+1)}else i=new C.$Nt(w,a,w,a);return i}static _getInverseEditRanges(u){const P=[];let w=0,a=0,m=null;for(let $=0,f=u.length;$<f;$++){const i=u[$];let s,t;m?m.range.endLineNumber===i.range.startLineNumber?(s=w,t=a+(i.range.startColumn-m.range.endColumn)):(s=w+(i.range.startLineNumber-m.range.endLineNumber),t=i.range.startColumn):(s=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const n=i.eolCount+1;n===1?o=new C.$Nt(s,t,s,t+i.firstLineLength):o=new C.$Nt(s,t,s+n-1,i.lastLineLength+1)}else o=new C.$Nt(s,t,s,t);w=o.endLineNumber,a=o.endColumn,P.push(o),m=i}return P}static u(u,P){const w=C.$Nt.compareRangesUsingEnds(u.range,P.range);return w===0?u.sortIndex-P.sortIndex:w}static w(u,P){const w=C.$Nt.compareRangesUsingEnds(u.range,P.range);return w===0?P.sortIndex-u.sortIndex:-w}}e.$uD=I}),define(ke[208],Ie([1,0,26,12,58,141,207]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vD=void 0,h=qe(h);class T{constructor(I,S,u,P,w,a,m,$,f){this.a=I,this.b=S,this.c=u,this.d=P,this.e=w,this.f=a,this.g=m,this.h=$,this.j=f}k(I){const S=this.c+this.d+this.e,u=this.c+this.e;return S===0?I===C.DefaultEndOfLine.LF?`
`:`\r
`:u>S/2?`\r
`:`
`}create(I){const S=this.k(I),u=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let w=0,a=u.length;w<a;w++){const m=u[w].buffer.replace(/\r\n|\r|\n/g,S),$=(0,R.$pD)(m);u[w]=new R.$sD(m,$)}const P=new L.$uD(u,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class b{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$5f(I)&&(this.b=h.$4f,I=I.substr(1));const S=I.charCodeAt(I.length-1);S===r.CharCode.CarriageReturn||S>=55296&&S<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=S):(this.m(I,!1),this.c=!1,this.d=S)}m(I,S){!S&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const S=(0,R.$qD)(this.e,I);this.a.push(new R.$sD(I,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Tf(I)),this.k||(this.k=h.$Wf(I)))}finish(I=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const S=(0,R.$pD)(I.buffer);I.lineStarts=S,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$vD=b}),define(ke[142],Ie([1,0,21,10]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udb=b,e.$Vdb=I,h=qe(h);var C;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(C||(C={}));function R(S){for(let u=0,P=S.length;u<P;u+=4){const w=S[u+0],a=S[u+1],m=S[u+2],$=S[u+3];S[u+0]=$,S[u+1]=m,S[u+2]=a,S[u+3]=w}}function L(S){const u=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return h.$E()||R(u),r.$Ne.wrap(u)}function T(S){const u=S.buffer;if(h.$E()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const P=new Uint8Array(u.byteLength);return P.set(u),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function b(S){const u=new Uint32Array(c(S));let P=0;if(u[P++]=S.id,S.type==="full")u[P++]=C.Full,u[P++]=S.data.length,u.set(S.data,P),P+=S.data.length;else{u[P++]=C.Delta,u[P++]=S.deltas.length;for(const w of S.deltas)u[P++]=w.start,u[P++]=w.deleteCount,w.data?(u[P++]=w.data.length,u.set(w.data,P),P+=w.data.length):u[P++]=0}return L(u)}function c(S){let u=0;if(u+=2,S.type==="full")u+=1+S.data.length;else{u+=1,u+=3*S.deltas.length;for(const P of S.deltas)P.data&&(u+=P.data.length)}return u}function I(S){const u=T(S);let P=0;const w=u[P++];if(u[P++]===C.Full){const f=u[P++],i=u.subarray(P,P+f);return P+=f,{id:w,type:"full",data:i}}const m=u[P++],$=[];for(let f=0;f<m;f++){const i=u[P++],s=u[P++],t=u[P++];let o;t>0&&(o=u.subarray(P,P+t),P+=t),$[f]={start:i,deleteCount:s,data:o}}return{id:w,type:"delta",deltas:$}}}),define(ke[209],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_=e.$L_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$L_=r;class h{constructor(R){this.identifier=R}}e.$M_=h}),define(ke[210],Ie([1,0,4,3,110]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xu=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$le,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,c){return this.a.set(b,c),this.handleChange([b]),(0,h.$Sc)(()=>{this.a.get(b)===c&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,c){this.b.get(b)?.dispose();const I=new L(this,b,c);return this.b.set(b,I),(0,h.$Sc)(()=>{const S=this.b.get(b);!S||S!==I||(this.b.delete(b),S.dispose())})}async getOrCreate(b){const c=this.get(b);if(c)return c;const I=this.b.get(b);return!I||I.isResolved?null:(await I.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const I=this.b.get(b);return!!(!I||I.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>C.ColorId.DefaultBackground?this.d[C.ColorId.DefaultBackground]:null}}e.$xu=R;class L extends h.$Uc{get isResolved(){return this.c}constructor(b,c,I){super(),this.f=b,this.g=c,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[8],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=C,e.localize2=L;const r=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function h(T,b){let c;return b.length===0?c=T:c=T.replace(/\{(\d+)\}/g,(I,S)=>{const u=S[0],P=b[u];let w=I;return typeof P=="string"?w=P:(typeof P=="number"||typeof P=="boolean"||P===void 0||P===null)&&(w=String(P)),w}),r&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function C(T,b,...c){return h(typeof T=="number"?R(T,b):b,c)}function R(T,b){const c=globalThis._VSCODE_NLS_MESSAGES?.[T];if(typeof c!="string"){if(typeof b=="string")return b;throw new Error(`!!! NLS MISSING: ${T} !!!`)}return c}function L(T,b,...c){let I;typeof T=="number"?I=R(T,b):I=b;const S=h(I,c);return{value:S,original:b===I?S:h(b,c)}}}),define(ke[211],Ie([1,0,4,3,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=void 0,e.$oj=I,C=qe(C);class R extends h.$Uc{constructor(u,P="",w="",a=!0,m){super(),this.j=this.B(new r.$le),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=P,this.w=w,this.z=a,this.D=m}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,P){this.D&&await this.D(u)}}e.$jj=R;class L extends h.$Uc{constructor(){super(...arguments),this.f=this.B(new r.$le),this.onWillRun=this.f.event,this.m=this.B(new r.$le),this.onDidRun=this.m.event}async run(u,P){if(!u.enabled)return;this.f.fire({action:u});let w;try{await this.u(u,P)}catch(a){w=a}this.m.fire({action:u,error:w})}async u(u,P){await u.run(P)}}e.$kj=L;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let P=[];for(const w of u)w.length&&(P.length?P=[...P,new T,...w]:P=w);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$lj=T;class b{get actions(){return this.a}constructor(u,P,w,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=P,this.class=a,this.a=w}async run(){}}e.$mj=b;class c extends R{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,C.localize(13003,null),void 0,!1)}}e.$nj=c;function I(S){return{id:S.id,label:S.label,tooltip:S.tooltip??S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...u)=>S.run(...u)}}}),define(ke[212],Ie([1,0,8]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=c,e.$2m=I,e.$3m=S;const h=60,C=h*60,R=C*24,L=R*7,T=R*30,b=R*365;function c(u,P,w,a){typeof u!="number"&&(u=u.getTime());const m=Math.round((new Date().getTime()-u)/1e3);if(m<-30)return(0,r.localize)(12940,null,c(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,r.localize)(12941,null);let $;return m<h?($=m,P?$===1?w?(0,r.localize)(12942,null,$):(0,r.localize)(12943,null,$):w?(0,r.localize)(12944,null,$):(0,r.localize)(12945,null,$):$===1?w?(0,r.localize)(12946,null,$):(0,r.localize)(12947,null,$):w?(0,r.localize)(12948,null,$):(0,r.localize)(12949,null,$)):m<C?($=Math.floor(m/h),P?$===1?w?(0,r.localize)(12950,null,$):(0,r.localize)(12951,null,$):w?(0,r.localize)(12952,null,$):(0,r.localize)(12953,null,$):$===1?w?(0,r.localize)(12954,null,$):(0,r.localize)(12955,null,$):w?(0,r.localize)(12956,null,$):(0,r.localize)(12957,null,$)):m<R?($=Math.floor(m/C),P?$===1?w?(0,r.localize)(12958,null,$):(0,r.localize)(12959,null,$):w?(0,r.localize)(12960,null,$):(0,r.localize)(12961,null,$):$===1?w?(0,r.localize)(12962,null,$):(0,r.localize)(12963,null,$):w?(0,r.localize)(12964,null,$):(0,r.localize)(12965,null,$)):m<L?($=Math.floor(m/R),P?$===1?(0,r.localize)(12966,null,$):(0,r.localize)(12967,null,$):$===1?(0,r.localize)(12968,null,$):(0,r.localize)(12969,null,$)):m<T?($=Math.floor(m/L),P?$===1?w?(0,r.localize)(12970,null,$):(0,r.localize)(12971,null,$):w?(0,r.localize)(12972,null,$):(0,r.localize)(12973,null,$):$===1?w?(0,r.localize)(12974,null,$):(0,r.localize)(12975,null,$):w?(0,r.localize)(12976,null,$):(0,r.localize)(12977,null,$)):m<b?($=Math.floor(m/T),P?$===1?w?(0,r.localize)(12978,null,$):(0,r.localize)(12979,null,$):w?(0,r.localize)(12980,null,$):(0,r.localize)(12981,null,$):$===1?w?(0,r.localize)(12982,null,$):(0,r.localize)(12983,null,$):w?(0,r.localize)(12984,null,$):(0,r.localize)(12985,null,$)):($=Math.floor(m/b),P?$===1?w?(0,r.localize)(12986,null,$):(0,r.localize)(12987,null,$):w?(0,r.localize)(12988,null,$):(0,r.localize)(12989,null,$):$===1?w?(0,r.localize)(12990,null,$):(0,r.localize)(12991,null,$):w?(0,r.localize)(12992,null,$):(0,r.localize)(12993,null,$))}function I(u,P){const w=Math.abs(u/1e3);return w<1?P?(0,r.localize)(12994,null,u):(0,r.localize)(12995,null,u):w<h?P?(0,r.localize)(12996,null,Math.round(u)/1e3):(0,r.localize)(12997,null,Math.round(u)/1e3):w<C?P?(0,r.localize)(12998,null,Math.round(u/(1e3*h))):(0,r.localize)(12999,null,Math.round(u/(1e3*h))):w<R?P?(0,r.localize)(13e3,null,Math.round(u/(1e3*C))):(0,r.localize)(13001,null,Math.round(u/(1e3*C))):(0,r.localize)(13002,null,Math.round(u/(1e3*R)))}function S(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[52],Ie([1,0,18,17,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=b,e.$qj=c,e.$rj=I,r=qe(r),h=qe(h),C=qe(C);function R(S,u){return u&&(S.stack||S.stacktrace)?C.localize(12934,null,T(S),L(S.stack)||L(S.stacktrace)):T(S)}function L(S){return Array.isArray(S)?S.join(`
`):S}function T(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(12935,null,S.message):S.message||C.localize(12936,null)}function b(S=null,u=!1){if(!S)return C.localize(12937,null);if(Array.isArray(S)){const P=r.$Gb(S),w=b(P[0],u);return P.length>1?C.localize(12938,null,w,P.length):w}if(h.$eg(S))return S;if(S.detail){const P=S.detail;if(P.error)return R(P.error,u);if(P.exception)return R(P.exception,u)}return S.stack?R(S,u):S.message?S.message:C.localize(12939,null)}function c(S){const u=S;return u instanceof Error&&Array.isArray(u.actions)}function I(S,u){let P;return typeof S=="string"?P=new Error(S):P=S,P.actions=u,P}}),define(ke[87],Ie([1,0,82,2,195,30,210,8]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Qu=e.$Pu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Ou=e.$Nu=e.SymbolKinds=e.SymbolTag=e.$Lu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Ju=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Iu=e.$Hu=e.$Gu=void 0,e.$Ku=d,e.$Mu=g;class b{constructor(Y,J,_){this.offset=Y,this.type=J,this.language=_,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Gu=b;class c{constructor(Y,J){this.tokens=Y,this.endState=J,this._tokenizationResultBrand=void 0}}e.$Hu=c;class I{constructor(Y,J){this.tokens=Y,this.endState=J,this._encodedTokenizationResultBrand=void 0}}e.$Iu=I;var S;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(S||(e.HoverVerbosityAction=S={}));var u;(function(B){B[B.Method=0]="Method",B[B.Function=1]="Function",B[B.Constructor=2]="Constructor",B[B.Field=3]="Field",B[B.Variable=4]="Variable",B[B.Class=5]="Class",B[B.Struct=6]="Struct",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Event=10]="Event",B[B.Operator=11]="Operator",B[B.Unit=12]="Unit",B[B.Value=13]="Value",B[B.Constant=14]="Constant",B[B.Enum=15]="Enum",B[B.EnumMember=16]="EnumMember",B[B.Keyword=17]="Keyword",B[B.Text=18]="Text",B[B.Color=19]="Color",B[B.File=20]="File",B[B.Reference=21]="Reference",B[B.Customcolor=22]="Customcolor",B[B.Folder=23]="Folder",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue",B[B.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var P;(function(B){const Y=new Map;Y.set(u.Method,r.$4j.symbolMethod),Y.set(u.Function,r.$4j.symbolFunction),Y.set(u.Constructor,r.$4j.symbolConstructor),Y.set(u.Field,r.$4j.symbolField),Y.set(u.Variable,r.$4j.symbolVariable),Y.set(u.Class,r.$4j.symbolClass),Y.set(u.Struct,r.$4j.symbolStruct),Y.set(u.Interface,r.$4j.symbolInterface),Y.set(u.Module,r.$4j.symbolModule),Y.set(u.Property,r.$4j.symbolProperty),Y.set(u.Event,r.$4j.symbolEvent),Y.set(u.Operator,r.$4j.symbolOperator),Y.set(u.Unit,r.$4j.symbolUnit),Y.set(u.Value,r.$4j.symbolValue),Y.set(u.Enum,r.$4j.symbolEnum),Y.set(u.Constant,r.$4j.symbolConstant),Y.set(u.Enum,r.$4j.symbolEnum),Y.set(u.EnumMember,r.$4j.symbolEnumMember),Y.set(u.Keyword,r.$4j.symbolKeyword),Y.set(u.Snippet,r.$4j.symbolSnippet),Y.set(u.Text,r.$4j.symbolText),Y.set(u.Color,r.$4j.symbolColor),Y.set(u.File,r.$4j.symbolFile),Y.set(u.Reference,r.$4j.symbolReference),Y.set(u.Customcolor,r.$4j.symbolCustomColor),Y.set(u.Folder,r.$4j.symbolFolder),Y.set(u.TypeParameter,r.$4j.symbolTypeParameter),Y.set(u.User,r.$4j.account),Y.set(u.Issue,r.$4j.issues);function J(re){let Se=Y.get(re);return Se||(console.info("No codicon found for CompletionItemKind "+re),Se=r.$4j.symbolProperty),Se}B.toIcon=J;const _=new Map;_.set("method",u.Method),_.set("function",u.Function),_.set("constructor",u.Constructor),_.set("field",u.Field),_.set("variable",u.Variable),_.set("class",u.Class),_.set("struct",u.Struct),_.set("interface",u.Interface),_.set("module",u.Module),_.set("property",u.Property),_.set("event",u.Event),_.set("operator",u.Operator),_.set("unit",u.Unit),_.set("value",u.Value),_.set("constant",u.Constant),_.set("enum",u.Enum),_.set("enum-member",u.EnumMember),_.set("enumMember",u.EnumMember),_.set("keyword",u.Keyword),_.set("snippet",u.Snippet),_.set("text",u.Text),_.set("color",u.Color),_.set("file",u.File),_.set("reference",u.Reference),_.set("customcolor",u.Customcolor),_.set("folder",u.Folder),_.set("type-parameter",u.TypeParameter),_.set("typeParameter",u.TypeParameter),_.set("account",u.User),_.set("issue",u.Issue);function le(re,Se){let me=_.get(re);return typeof me>"u"&&!Se&&(me=u.Property),me}B.fromString=le})(P||(e.CompletionItemKinds=P={}));var w;(function(B){B[B.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var a;(function(B){B[B.None=0]="None",B[B.KeepWhitespace=1]="KeepWhitespace",B[B.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var m;(function(B){B[B.Word=0]="Word",B[B.Line=1]="Line",B[B.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var $;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($||(e.CompletionTriggerKind=$={}));var f;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class i{constructor(Y,J,_,le){this.range=Y,this.text=J,this.completionKind=_,this.isSnippetText=le}equals(Y){return R.$Nt.lift(this.range).equalsRange(Y.range)&&this.text===Y.text&&this.completionKind===Y.completionKind&&this.isSnippetText===Y.isSnippetText}}e.$Ju=i;var s;(function(B){B[B.Invoke=1]="Invoke",B[B.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var t;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var o;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var n;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function d(B){return B&&h.URI.isUri(B.uri)&&R.$Nt.isIRange(B.range)&&(R.$Nt.isIRange(B.originSelectionRange)||R.$Nt.isIRange(B.targetSelectionRange))}var l;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Lu={[l.Array]:(0,T.localize)(12801,null),[l.Boolean]:(0,T.localize)(12802,null),[l.Class]:(0,T.localize)(12803,null),[l.Constant]:(0,T.localize)(12804,null),[l.Constructor]:(0,T.localize)(12805,null),[l.Enum]:(0,T.localize)(12806,null),[l.EnumMember]:(0,T.localize)(12807,null),[l.Event]:(0,T.localize)(12808,null),[l.Field]:(0,T.localize)(12809,null),[l.File]:(0,T.localize)(12810,null),[l.Function]:(0,T.localize)(12811,null),[l.Interface]:(0,T.localize)(12812,null),[l.Key]:(0,T.localize)(12813,null),[l.Method]:(0,T.localize)(12814,null),[l.Module]:(0,T.localize)(12815,null),[l.Namespace]:(0,T.localize)(12816,null),[l.Null]:(0,T.localize)(12817,null),[l.Number]:(0,T.localize)(12818,null),[l.Object]:(0,T.localize)(12819,null),[l.Operator]:(0,T.localize)(12820,null),[l.Package]:(0,T.localize)(12821,null),[l.Property]:(0,T.localize)(12822,null),[l.String]:(0,T.localize)(12823,null),[l.Struct]:(0,T.localize)(12824,null),[l.TypeParameter]:(0,T.localize)(12825,null),[l.Variable]:(0,T.localize)(12826,null)};function g(B,Y){return(0,T.localize)(12827,null,B,e.$Lu[Y])}var E;(function(B){B[B.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var D;(function(B){const Y=new Map;Y.set(l.File,r.$4j.symbolFile),Y.set(l.Module,r.$4j.symbolModule),Y.set(l.Namespace,r.$4j.symbolNamespace),Y.set(l.Package,r.$4j.symbolPackage),Y.set(l.Class,r.$4j.symbolClass),Y.set(l.Method,r.$4j.symbolMethod),Y.set(l.Property,r.$4j.symbolProperty),Y.set(l.Field,r.$4j.symbolField),Y.set(l.Constructor,r.$4j.symbolConstructor),Y.set(l.Enum,r.$4j.symbolEnum),Y.set(l.Interface,r.$4j.symbolInterface),Y.set(l.Function,r.$4j.symbolFunction),Y.set(l.Variable,r.$4j.symbolVariable),Y.set(l.Constant,r.$4j.symbolConstant),Y.set(l.String,r.$4j.symbolString),Y.set(l.Number,r.$4j.symbolNumber),Y.set(l.Boolean,r.$4j.symbolBoolean),Y.set(l.Array,r.$4j.symbolArray),Y.set(l.Object,r.$4j.symbolObject),Y.set(l.Key,r.$4j.symbolKey),Y.set(l.Null,r.$4j.symbolNull),Y.set(l.EnumMember,r.$4j.symbolEnumMember),Y.set(l.Struct,r.$4j.symbolStruct),Y.set(l.Event,r.$4j.symbolEvent),Y.set(l.Operator,r.$4j.symbolOperator),Y.set(l.TypeParameter,r.$4j.symbolTypeParameter);function J(_){let le=Y.get(_);return le||(console.info("No codicon found for SymbolKind "+_),le=r.$4j.symbolProperty),le}B.toIcon=J})(D||(e.SymbolKinds=D={}));class y{static asEditOperation(Y){return C.$Ot.replace(R.$Nt.lift(Y.range),Y.text)}}e.$Nu=y;class k{static{this.Comment=new k("comment")}static{this.Imports=new k("imports")}static{this.Region=new k("region")}static fromValue(Y){switch(Y){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(Y)}constructor(Y){this.value=Y}}e.$Ou=k;var A;(function(B){B[B.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var p;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(p||(e.NewSymbolNameTriggerKind=p={}));var v;(function(B){function Y(J){return!J||typeof J!="object"?!1:typeof J.id=="string"&&typeof J.title=="string"}B.is=Y})(v||(e.Command=v={}));var F;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(F||(e.CommentThreadCollapsibleState=F={}));var N;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var O;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(O||(e.CommentThreadApplicability=O={}));var j;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var z;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(z||(e.CommentState=z={}));var M;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class U{constructor(Y){this.b=Y,this.a=null}dispose(){this.a&&this.a.then(Y=>{Y&&Y.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Pu=U,e.$Qu=new L.$xu;var V;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(V||(e.ExternalUriOpenerPriority=V={}));var ie;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(ie||(e.InlineEditTriggerKind=ie={}))}),define(ke[213],Ie([1,0,26,13,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var R;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...I){switch(I.length){case 1:return(0,C.localize)(11538,null,I[0]);case 2:return(0,C.localize)(11539,null,I[0],I[1]);case 3:return(0,C.localize)(11540,null,I[0],I[1],I[2]);default:return}}const T=(0,C.localize)(11541,null),b=(0,C.localize)(11542,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return S.isTripleEq?"===":"==";case R.NotEq:return S.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return S.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return S.lexeme;case R.QuotedStr:return S.lexeme;case R.Error:return S.lexeme;case R.EOF:return"EOF";default:throw(0,h.$7)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(L("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(L("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(L("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const u=this.d,P=this.c.substring(this.d,this.e),w={type:R.Error,offset:this.d,lexeme:P};this.g.push({offset:u,lexeme:P,additionalInfo:S}),this.f.push(w)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const u=this.c.substring(this.d,this.e),P=c.b.get(u);P?this.k(P):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,u=!1,P=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(b);return}const a=this.c.charCodeAt(S);if(u)u=!1;else if(a===r.CharCode.Slash&&!P){S++;break}else a===r.CharCode.OpenSquareBracket?P=!0:a===r.CharCode.Backslash?u=!0:a===r.CharCode.CloseSquareBracket&&(P=!1);S++}for(;S<this.c.length&&c.a.has(this.c.charCodeAt(S));)S++;this.e=S;const w=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=c}),define(ke[143],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const r={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(r)}),define(ke[112],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class r{constructor(C,R=[],L=!1){this.ctor=C,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$Bi=r}),define(ke[88],Ie([1,0,112]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Qs=R,e.$Rs=L;const h=[];var C;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function R(T,b,c){b instanceof r.$Bi||(b=new r.$Bi(b,[],!!c)),h.push([T,b])}function L(){return h}}),define(ke[214],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;class r{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$tr=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const T=this.lookupOrInsertNode(R),b=this.lookupOrInsertNode(L);T.outgoing.set(b.key,b),b.incoming.set(T.key,T)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const T of this.a.values())T.outgoing.delete(L),T.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let T=this.a.get(L);return T||(T=new r(L,R),this.a.set(L,T)),T}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,T]of this.a)R.push(`${L}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const T=new Set([R]),b=this.c(L,T);if(b)return b}}c(R,L){for(const[T,b]of R.outgoing){if(L.has(T))return[...L,T].join(" -> ");L.add(T);const c=this.c(b,L);if(c)return c;L.delete(T)}}}e.$ur=h}),define(ke[5],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=C,e.$Fi=R;var r;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function T(b){return b[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=T})(r||(e._util=r={})),e.$Di=C("instantiationService");function h(L,T,b){T[r.DI_TARGET]===T?T[r.DI_DEPENDENCIES].push({id:L,index:b}):(T[r.DI_DEPENDENCIES]=[{id:L,index:b}],T[r.DI_TARGET]=T)}function C(L){if(r.serviceIds.has(L))return r.serviceIds.get(L);const T=function(b,c,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(T,b,I)};return T.toString=()=>L,r.serviceIds.set(L,T),T}function R(L){return L}}),define(ke[45],Ie([1,0,17,2,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$$i=void 0,e.$_i=R,e.$aj=L,e.$bj=b,e.$cj=c,e.$dj=I,e.$ej=S,e.$fj=u,e.$gj=w,e.$hj=a,e.$ij=m,r=qe(r),e.$$i=(0,C.$Ei)("configurationService");function R($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof h.URI)}function L($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof h.URI)}var T;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function b($){switch($){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function I($,f){const i=Object.create(null);for(const s in $)S(i,s,$[s],f);return i}function S($,f,i,s){const t=f.split("."),o=t.pop();let n=$;for(let d=0;d<t.length;d++){const l=t[d];let g=n[l];switch(typeof g){case"undefined":g=n[l]=Object.create(null);break;case"object":if(g===null){s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is null`);return}break;default:s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is ${JSON.stringify(g)}`);return}n=g}if(typeof n=="object"&&n!==null)try{n[o]=i}catch{s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}else s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}function u($,f){const i=f.split(".");P($,i)}function P($,f){const i=f.shift();if(f.length===0){delete $[i];return}if(Object.keys($).indexOf(i)!==-1){const s=$[i];typeof s=="object"&&!Array.isArray(s)&&(P(s,f),Object.keys(s).length===0&&delete $[i])}}function w($,f,i){function s(n,d){let l=n;for(const g of d){if(typeof l!="object"||l===null)return;l=l[g]}return l}const t=f.split("."),o=s($,t);return typeof o>"u"?i:o}function a($,f,i){Object.keys(f).forEach(s=>{s!=="__proto__"&&(s in $?r.$gg($[s])&&r.$gg(f[s])?a($[s],f[s],i):i&&($[s]=f[s]):$[s]=f[s])})}function m($){return $.replace(/[\[\]]/g,"")}}),define(ke[35],Ie([1,0,26,10,12,213,5,8,13]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=I,e.$Dj=d,e.$Ej=l,e.$Xj=re;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",h.$k),c.set("isLinux",h.$l),c.set("isWindows",h.$j),c.set("isWeb",h.$p),c.set("isMacNative",h.$k&&!h.$p),c.set("isEdge",h.$I),c.set("isFirefox",h.$G),c.set("isChrome",h.$F),c.set("isSafari",h.$H);function I(Q,q){if(c.get(Q)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Q,q)}const S=Object.prototype.hasOwnProperty;var u;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const P={regexParsingWithErrorRecovery:!0},w=(0,T.localize)(11552,null),a=(0,T.localize)(11553,null),m=(0,T.localize)(11554,null),$=(0,T.localize)(11555,null),f=(0,T.localize)(11556,null),i=(0,T.localize)(11557,null),s=(0,T.localize)(11558,null),t=(0,T.localize)(11559,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=P){this.k=q,this.d=new R.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const we=this.D(),ee=we.type===R.TokenType.Str?i:void 0;throw this.h.push({message:f,offset:we.offset,lexeme:R.$zj.getLexeme(we),additionalInfo:ee}),o.c}return se}catch(se){if(se!==o.c)throw se;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(R.TokenType.Or);){const se=this.o();q.push(se)}return q.length===1?q[0]:n.or(...q)}o(){const q=[this.s()];for(;this.y(R.TokenType.And);){const se=this.s();q.push(se)}return q.length===1?q[0]:n.and(...q)}s(){if(this.y(R.TokenType.Neg)){const q=this.D();switch(q.type){case R.TokenType.True:return this.z(),E.INSTANCE;case R.TokenType.False:return this.z(),D.INSTANCE;case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,$),se?.negate()}case R.TokenType.Str:return this.z(),F.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case R.TokenType.True:return this.z(),n.true();case R.TokenType.False:return this.z(),n.false();case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,$),se}case R.TokenType.Str:{const se=q.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const ee=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ee.type!==R.TokenType.RegexStr)throw this.B("REGEX",ee);const ae=ee.lexeme,oe=ae.lastIndexOf("/"),x=oe===ae.length-1?void 0:this.w(ae.substring(oe+1));let ne;try{ne=new RegExp(ae.substring(1,oe),x)}catch{throw this.B("REGEX",ee)}return U.create(se,ne)}switch(ee.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const ae=[ee.lexeme];this.z();let oe=this.D(),x=0;for(let ze=0;ze<ee.lexeme.length;ze++)ee.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?x++:ee.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&x--;for(;!this.E()&&oe.type!==R.TokenType.And&&oe.type!==R.TokenType.Or;){switch(oe.type){case R.TokenType.LParen:x++;break;case R.TokenType.RParen:x--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let ze=0;ze<oe.lexeme.length;ze++)oe.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?x++:ee.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&x--}if(x<0)break;ae.push(R.$zj.getLexeme(oe)),this.z(),oe=this.D()}const ne=ae.join(""),pe=ne.lastIndexOf("/"),be=pe===ne.length-1?void 0:this.w(ne.substring(pe+1));let Fe;try{Fe=new RegExp(ne.substring(1,pe),be)}catch{throw this.B("REGEX",ee)}return n.regex(se,Fe)}case R.TokenType.QuotedStr:{const ae=ee.lexeme;this.z();let oe=null;if(!(0,C.$cf)(ae)){const x=ae.indexOf("/"),ne=ae.lastIndexOf("/");if(x!==ne&&x>=0){const pe=ae.slice(x+1,ne),be=ae[ne+1]==="i"?"i":"";try{oe=new RegExp(pe,be)}catch{throw this.B("REGEX",ee)}}}if(oe===null)throw this.B("REGEX",ee);return U.create(se,oe)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,m);const ee=this.u();return n.notIn(se,ee)}switch(this.D().type){case R.TokenType.Eq:{this.z();const ee=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.equals(se,ee);switch(ee){case"true":return n.has(se);case"false":return n.not(se);default:return n.equals(se,ee)}}case R.TokenType.NotEq:{this.z();const ee=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.notEquals(se,ee);switch(ee){case"true":return n.not(se);case"false":return n.has(se);default:return n.notEquals(se,ee)}}case R.TokenType.Lt:return this.z(),z.create(se,this.u());case R.TokenType.LtEq:return this.z(),M.create(se,this.u());case R.TokenType.Gt:return this.z(),O.create(se,this.u());case R.TokenType.GtEq:return this.z(),j.create(se,this.u());case R.TokenType.In:return this.z(),n.in(se,this.u());default:return n.has(se)}}case R.TokenType.EOF:throw this.h.push({message:s,offset:q.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),q.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,se){if(this.C(q))return this.z();throw this.B(se,this.D())}B(q,se,we){const ee=(0,T.localize)(11560,null,q,R.$zj.getLexeme(se)),ae=se.offset,oe=R.$zj.getLexeme(se);return this.h.push({message:ee,offset:ae,lexeme:oe,additionalInfo:we}),o.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$Bj=o;class n{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(q){return y.create(q)}static equals(q,se){return k.create(q,se)}static notEquals(q,se){return v.create(q,se)}static regex(q,se){return U.create(q,se)}static in(q,se){return A.create(q,se)}static notIn(q,se){return p.create(q,se)}static not(q){return F.create(q)}static and(...q){return B.create(q,null,!0)}static or(...q){return Y.create(q,null,!0)}static greater(q,se){return O.create(q,se)}static greaterEquals(q,se){return j.create(q,se)}static smaller(q,se){return z.create(q,se)}static smallerEquals(q,se){return M.create(q,se)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Cj=n;function d(Q){const q=new o({regexParsingWithErrorRecovery:!1});return Q.map(se=>(q.parse(se),q.lexingErrors.length>0?q.lexingErrors.map(we=>({errorMessage:we.additionalInfo?(0,T.localize)(11561,null,we.additionalInfo):(0,T.localize)(11562,null),offset:we.offset,length:we.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(we=>({errorMessage:we.additionalInfo?`${we.message}. ${we.additionalInfo}`:we.message,offset:we.offset,length:we.lexeme.length})):[]))}function l(Q,q){const se=Q?Q.substituteConstants():void 0,we=q?q.substituteConstants():void 0;return!se&&!we?!0:!se||!we?!1:se.equals(we)}function g(Q,q){return Q.cmp(q)}class E{static{this.INSTANCE=new E}constructor(){this.type=u.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return D.INSTANCE}}e.$Fj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return E.INSTANCE}}e.$Gj=D;class y{static create(q,se=null){const we=c.get(q);return typeof we=="boolean"?we?D.INSTANCE:E.INSTANCE:new y(q,se)}constructor(q,se){this.key=q,this.c=se,this.type=u.Defined}cmp(q){return q.type!==this.type?this.type-q.type:_(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=c.get(this.key);return typeof q=="boolean"?q?D.INSTANCE:E.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Hj=y;class k{static create(q,se,we=null){if(typeof se=="boolean")return se?y.create(q,we):F.create(q,we);const ee=c.get(q);return typeof ee=="boolean"?se===(ee?"true":"false")?D.INSTANCE:E.INSTANCE:new k(q,se,we)}constructor(q,se,we){this.c=q,this.d=se,this.f=we,this.type=u.Equals}cmp(q){return q.type!==this.type?this.type-q.type:le(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=c.get(this.c);if(typeof q=="boolean"){const se=q?"true":"false";return this.d===se?D.INSTANCE:E.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ij=k;class A{static create(q,se){return new A(q,se)}constructor(q,se){this.d=q,this.f=se,this.type=u.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:le(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const se=q.getValue(this.f),we=q.getValue(this.d);return Array.isArray(se)?se.includes(we):typeof we=="string"&&typeof se=="object"&&se!==null?S.call(se,we):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Jj=A;class p{static create(q,se){return new p(q,se)}constructor(q,se){this.d=q,this.f=se,this.type=u.NotIn,this.c=A.create(q,se)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=p;class v{static create(q,se,we=null){if(typeof se=="boolean")return se?F.create(q,we):y.create(q,we);const ee=c.get(q);return typeof ee=="boolean"?se===(ee?"true":"false")?E.INSTANCE:D.INSTANCE:new v(q,se,we)}constructor(q,se,we){this.c=q,this.d=se,this.f=we,this.type=u.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:le(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=c.get(this.c);if(typeof q=="boolean"){const se=q?"true":"false";return this.d===se?E.INSTANCE:D.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Lj=v;class F{static create(q,se=null){const we=c.get(q);return typeof we=="boolean"?we?E.INSTANCE:D.INSTANCE:new F(q,se)}constructor(q,se){this.c=q,this.d=se,this.type=u.Not}cmp(q){return q.type!==this.type?this.type-q.type:_(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=c.get(this.c);return typeof q=="boolean"?q?E.INSTANCE:D.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Mj=F;function N(Q,q){if(typeof Q=="string"){const se=parseFloat(Q);isNaN(se)||(Q=se)}return typeof Q=="string"||typeof Q=="number"?q(Q):E.INSTANCE}class O{static create(q,se,we=null){return N(se,ee=>new O(q,ee,we))}constructor(q,se,we){this.c=q,this.d=se,this.f=we,this.type=u.Greater}cmp(q){return q.type!==this.type?this.type-q.type:le(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Nj=O;class j{static create(q,se,we=null){return N(se,ee=>new j(q,ee,we))}constructor(q,se,we){this.c=q,this.d=se,this.f=we,this.type=u.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:le(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Oj=j;class z{static create(q,se,we=null){return N(se,ee=>new z(q,ee,we))}constructor(q,se,we){this.c=q,this.d=se,this.f=we,this.type=u.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:le(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Pj=z;class M{static create(q,se,we=null){return N(se,ee=>new M(q,ee,we))}constructor(q,se,we){this.c=q,this.d=se,this.f=we,this.type=u.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:le(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Qj=M;class U{static create(q,se){return new U(q,se)}constructor(q,se){this.d=q,this.f=se,this.type=u.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const se=this.f?this.f.source:"",we=q.f?q.f.source:"";return se<we?-1:se>we?1:0}equals(q){if(q.type===this.type){const se=this.f?this.f.source:"",we=q.f?q.f.source:"";return this.d===q.d&&se===we}return!1}substituteConstants(){return this}evaluate(q){const se=q.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$Rj=U;class V{static create(q){return new V(q)}constructor(q){this.c=q,this.type=u.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new V(this.c.map(q))}negate(){return this.c}}e.$Sj=V;function ie(Q){let q=null;for(let se=0,we=Q.length;se<we;se++){const ee=Q[se].substituteConstants();if(Q[se]!==ee&&q===null){q=[];for(let ae=0;ae<se;ae++)q[ae]=Q[ae]}q!==null&&(q[se]=ee)}return q===null?Q:q}class B{static create(q,se,we){return B.d(q,se,we)}constructor(q,se){this.expr=q,this.c=se,this.type=u.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let se=0,we=this.expr.length;se<we;se++){const ee=g(this.expr[se],q.expr[se]);if(ee!==0)return ee}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let se=0,we=this.expr.length;se<we;se++)if(!this.expr[se].equals(q.expr[se]))return!1;return!0}return!1}substituteConstants(){const q=ie(this.expr);return q===this.expr?this:B.create(q,this.c,!1)}evaluate(q){for(let se=0,we=this.expr.length;se<we;se++)if(!this.expr[se].evaluate(q))return!1;return!0}static d(q,se,we){const ee=[];let ae=!1;for(const oe of q)if(oe){if(oe.type===u.True){ae=!0;continue}if(oe.type===u.False)return E.INSTANCE;if(oe.type===u.And){ee.push(...oe.expr);continue}ee.push(oe)}if(ee.length===0&&ae)return D.INSTANCE;if(ee.length!==0){if(ee.length===1)return ee[0];ee.sort(g);for(let oe=1;oe<ee.length;oe++)ee[oe-1].equals(ee[oe])&&(ee.splice(oe,1),oe--);if(ee.length===1)return ee[0];for(;ee.length>1;){const oe=ee[ee.length-1];if(oe.type!==u.Or)break;ee.pop();const x=ee.pop(),ne=ee.length===0,pe=Y.create(oe.expr.map(be=>B.create([be,x],null,we)),null,ne);pe&&(ee.push(pe),ee.sort(g))}if(ee.length===1)return ee[0];if(we){for(let oe=0;oe<ee.length;oe++)for(let x=oe+1;x<ee.length;x++)if(ee[oe].negate().equals(ee[x]))return E.INSTANCE;if(ee.length===1)return ee[0]}return new B(ee,se)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const se of this.expr)q.push(...se.keys());return q}map(q){return new B(this.expr.map(se=>se.map(q)),null)}negate(){if(!this.c){const q=[];for(const se of this.expr)q.push(se.negate());this.c=Y.create(q,this,!0)}return this.c}}e.$Tj=B;class Y{static create(q,se,we){return Y.d(q,se,we)}constructor(q,se){this.expr=q,this.c=se,this.type=u.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let se=0,we=this.expr.length;se<we;se++){const ee=g(this.expr[se],q.expr[se]);if(ee!==0)return ee}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let se=0,we=this.expr.length;se<we;se++)if(!this.expr[se].equals(q.expr[se]))return!1;return!0}return!1}substituteConstants(){const q=ie(this.expr);return q===this.expr?this:Y.create(q,this.c,!1)}evaluate(q){for(let se=0,we=this.expr.length;se<we;se++)if(this.expr[se].evaluate(q))return!0;return!1}static d(q,se,we){let ee=[],ae=!1;if(q){for(let oe=0,x=q.length;oe<x;oe++){const ne=q[oe];if(ne){if(ne.type===u.False){ae=!0;continue}if(ne.type===u.True)return D.INSTANCE;if(ne.type===u.Or){ee=ee.concat(ne.expr);continue}ee.push(ne)}}if(ee.length===0&&ae)return E.INSTANCE;ee.sort(g)}if(ee.length!==0){if(ee.length===1)return ee[0];for(let oe=1;oe<ee.length;oe++)ee[oe-1].equals(ee[oe])&&(ee.splice(oe,1),oe--);if(ee.length===1)return ee[0];if(we){for(let oe=0;oe<ee.length;oe++)for(let x=oe+1;x<ee.length;x++)if(ee[oe].negate().equals(ee[x]))return D.INSTANCE;if(ee.length===1)return ee[0]}return new Y(ee,se)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const se of this.expr)q.push(...se.keys());return q}map(q){return new Y(this.expr.map(se=>se.map(q)),null)}negate(){if(!this.c){const q=[];for(const se of this.expr)q.push(se.negate());for(;q.length>1;){const se=q.shift(),we=q.shift(),ee=[];for(const ae of me(se))for(const oe of me(we))ee.push(B.create([ae,oe],null,!1));q.unshift(Y.create(ee,null,!1))}this.c=Y.create(q,this,!0)}return this.c}}e.$Uj=Y;class J extends y{static{this.d=[]}static all(){return J.d.values()}constructor(q,se,we){super(q,null),this.f=se,typeof we=="object"?J.d.push({...we,key:q}):we!==!0&&J.d.push({key:q,description:we,type:se!=null?typeof se:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return k.create(this.key,q)}notEqualsTo(q){return v.create(this.key,q)}}e.$Vj=J,e.$Wj=(0,L.$Ei)("contextKeyService");function _(Q,q){return Q<q?-1:Q>q?1:0}function le(Q,q,se,we){return Q<se?-1:Q>se?1:q<we?-1:q>we?1:0}function re(Q,q){if(Q.type===u.False||q.type===u.True)return!0;if(Q.type===u.Or)return q.type===u.Or?Se(Q.expr,q.expr):!1;if(q.type===u.Or){for(const se of q.expr)if(re(Q,se))return!0;return!1}if(Q.type===u.And){if(q.type===u.And)return Se(q.expr,Q.expr);for(const se of Q.expr)if(re(se,q))return!0;return!1}return Q.equals(q)}function Se(Q,q){let se=0,we=0;for(;se<Q.length&&we<q.length;){const ee=Q[se].cmp(q[we]);if(ee<0)return!1;ee===0&&se++,we++}return se===Q.length}function me(Q){return Q.type===u.Or?Q.expr:[Q]}}),define(ke[215],Ie([1,0,35,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$rt=e.AccessibilitySupport=e.$qt=void 0,e.$st=R,e.$qt=(0,h.$Ei)("accessibilityService");var C;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(C||(e.AccessibilitySupport=C={})),e.$rt=new r.$Vj("accessibilityModeEnabled",!1);function R(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.$tt="ACCESSIBLE_VIEW_SHOWN_"}),define(ke[113],Ie([1,0,18,24,10,185,83,199,140,8,215]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=n,e.stringSet=g,e.cursorStyleToString=N,e.filterValidationDecorations=De,r=qe(r),h=qe(h),C=qe(C),c=qe(c);var S;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(he){this.c=he}hasChanged(he){return this.c[he]}}e.ConfigurationChangedEvent=u;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class w{constructor(he,ce,Xe,et){this.id=he,this.name=ce,this.defaultValue=Xe,this.schema=et}applyUpdate(he,ce){return m(he,ce)}compute(he,ce,Xe){return Xe}}class a{constructor(he,ce){this.newValue=he,this.didChange=ce}}e.ApplyUpdateResult=a;function m(ue,he){if(typeof ue!="object"||typeof he!="object"||!ue||!he)return new a(he,ue!==he);if(Array.isArray(ue)||Array.isArray(he)){const Xe=Array.isArray(ue)&&Array.isArray(he)&&r.$tb(ue,he);return new a(he,!Xe)}let ce=!1;for(const Xe in he)if(he.hasOwnProperty(Xe)){const et=m(ue[Xe],he[Xe]);et.didChange&&(ue[Xe]=et.newValue,ce=!0)}return new a(ue,ce)}class ${constructor(he){this.schema=void 0,this.id=he,this.name="_never_",this.defaultValue=void 0}applyUpdate(he,ce){return m(he,ce)}validate(he){return this.defaultValue}}class f{constructor(he,ce,Xe,et){this.id=he,this.name=ce,this.defaultValue=Xe,this.schema=et}applyUpdate(he,ce){return m(he,ce)}validate(he){return typeof he>"u"?this.defaultValue:he}compute(he,ce,Xe){return Xe}}function i(ue,he){return typeof ue>"u"?he:ue==="false"?!1:!!ue}class s extends f{constructor(he,ce,Xe,et=void 0){typeof et<"u"&&(et.type="boolean",et.default=Xe),super(he,ce,Xe,et)}validate(he){return i(he,this.defaultValue)}}function t(ue,he,ce,Xe){if(typeof ue>"u")return he;let et=parseInt(ue,10);return isNaN(et)?he:(et=Math.max(ce,et),et=Math.min(Xe,et),et|0)}class o extends f{static clampedInt(he,ce,Xe,et){return t(he,ce,Xe,et)}constructor(he,ce,Xe,et,ut,mt=void 0){typeof mt<"u"&&(mt.type="integer",mt.default=Xe,mt.minimum=et,mt.maximum=ut),super(he,ce,Xe,mt),this.minimum=et,this.maximum=ut}validate(he){return o.clampedInt(he,this.defaultValue,this.minimum,this.maximum)}}function n(ue,he,ce,Xe){if(typeof ue>"u")return he;const et=d.float(ue,he);return d.clamp(et,ce,Xe)}class d extends f{static clamp(he,ce,Xe){return he<ce?ce:he>Xe?Xe:he}static float(he,ce){if(typeof he=="number")return he;if(typeof he>"u")return ce;const Xe=parseFloat(he);return isNaN(Xe)?ce:Xe}constructor(he,ce,Xe,et,ut){typeof ut<"u"&&(ut.type="number",ut.default=Xe),super(he,ce,Xe,ut),this.validationFn=et}validate(he){return this.validationFn(d.float(he,this.defaultValue))}}class l extends f{static string(he,ce){return typeof he!="string"?ce:he}constructor(he,ce,Xe,et=void 0){typeof et<"u"&&(et.type="string",et.default=Xe),super(he,ce,Xe,et)}validate(he){return l.string(he,this.defaultValue)}}function g(ue,he,ce,Xe){return typeof ue!="string"?he:Xe&&ue in Xe?Xe[ue]:ce.indexOf(ue)===-1?he:ue}class E extends f{constructor(he,ce,Xe,et,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=et,ut.default=Xe),super(he,ce,Xe,ut),this.c=et}validate(he){return g(he,this.defaultValue,this.c)}}class D extends w{constructor(he,ce,Xe,et,ut,mt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=et),super(he,ce,Xe,Dt),this.c=ut,this.d=mt}validate(he){return typeof he!="string"?this.defaultValue:this.c.indexOf(he)===-1?this.defaultValue:this.d(he)}}function y(ue){switch(ue){case"none":return S.None;case"keep":return S.Keep;case"brackets":return S.Brackets;case"advanced":return S.Advanced;case"full":return S.Full}}class k extends w{constructor(){super(je.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(11728,null),c.localize(11729,null),c.localize(11730,null)],default:"auto",tags:["accessibility"],description:c.localize(11731,null)})}validate(he){switch(he){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(he,ce,Xe){return Xe===I.AccessibilitySupport.Unknown?he.accessibilitySupport:Xe}}class A extends w{constructor(){const he={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",he,{"editor.comments.insertSpace":{type:"boolean",default:he.insertSpace,description:c.localize(11732,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:he.ignoreEmptyLines,description:c.localize(11733,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{insertSpace:i(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function v(ue){switch(ue){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var F;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(ue){switch(ue){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function O(ue){switch(ue){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class j extends ${constructor(){super(je.editorClassName)}compute(he,ce,Xe){const et=["monaco-editor"];return ce.get(je.extraEditorClassName)&&et.push(ce.get(je.extraEditorClassName)),he.extraEditorClassName&&et.push(he.extraEditorClassName),ce.get(je.mouseStyle)==="default"?et.push("mouse-default"):ce.get(je.mouseStyle)==="copy"&&et.push("mouse-copy"),ce.get(je.showUnused)&&et.push("showUnused"),ce.get(je.showDeprecated)&&et.push("showDeprecated"),et.join(" ")}}class z extends s{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(11734,null)})}compute(he,ce,Xe){return Xe&&he.emptySelectionClipboard}}class M extends w{constructor(){const he={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",he,{"editor.find.cursorMoveOnType":{type:"boolean",default:he.cursorMoveOnType,description:c.localize(11735,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:he.seedSearchStringFromSelection,enumDescriptions:[c.localize(11736,null),c.localize(11737,null),c.localize(11738,null)],description:c.localize(11739,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:he.autoFindInSelection,enumDescriptions:[c.localize(11740,null),c.localize(11741,null),c.localize(11742,null)],description:c.localize(11743,null)},"editor.find.globalFindClipboard":{type:"boolean",default:he.globalFindClipboard,description:c.localize(11744,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:he.addExtraSpaceOnTop,description:c.localize(11745,null)},"editor.find.loop":{type:"boolean",default:he.loop,description:c.localize(11746,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{cursorMoveOnType:i(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof he.seedSearchStringFromSelection=="boolean"?he.seedSearchStringFromSelection?"always":"never":g(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof he.autoFindInSelection=="boolean"?he.autoFindInSelection?"always":"never":g(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(ce.loop,this.defaultValue.loop)}}}class U extends w{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:c.localize(11747,null)},{type:"string",description:c.localize(11748,null)}],description:c.localize(11749,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"||he.length===0?U.OFF:he==="true"?U.ON:he:he?U.ON:U.OFF}}e.EditorFontLigatures=U;class V extends w{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",V.OFF,{anyOf:[{type:"boolean",description:c.localize(11750,null)},{type:"string",description:c.localize(11751,null)}],description:c.localize(11752,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"?V.OFF:he==="true"?V.TRANSLATE:he:he?V.TRANSLATE:V.OFF}compute(he,ce,Xe){return he.fontInfo.fontVariationSettings}}e.EditorFontVariations=V;class ie extends ${constructor(){super(je.fontInfo)}compute(he,ce,Xe){return he.fontInfo}}class B extends f{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(11753,null)})}validate(he){const ce=d.float(he,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ce,6,100)}compute(he,ce,Xe){return he.fontInfo.fontSize}}class Y extends w{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:c.localize(11754,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(11755,null)})}validate(he){return he==="normal"||he==="bold"?he:String(o.clampedInt(he,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class J extends w{constructor(){const he={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:he.multiple,enumDescriptions:[c.localize(11756,null),c.localize(11757,null),c.localize(11758,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",he,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(11759,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(11760,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(11761,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:c.localize(11762,null),...ce},"editor.gotoLocation.multipleImplementations":{description:c.localize(11763,null),...ce},"editor.gotoLocation.multipleReferences":{description:c.localize(11764,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:he.alternativeDefinitionCommand,enum:Xe,description:c.localize(11765,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:he.alternativeTypeDefinitionCommand,enum:Xe,description:c.localize(11766,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:he.alternativeDeclarationCommand,enum:Xe,description:c.localize(11767,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:he.alternativeImplementationCommand,enum:Xe,description:c.localize(11768,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:he.alternativeReferenceCommand,enum:Xe,description:c.localize(11769,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{multiple:g(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??g(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??g(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??g(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??g(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??g(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _ extends w{constructor(){const he={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",he,{"editor.hover.enabled":{type:"boolean",default:he.enabled,description:c.localize(11770,null)},"editor.hover.delay":{type:"number",default:he.delay,minimum:0,maximum:1e4,description:c.localize(11771,null)},"editor.hover.sticky":{type:"boolean",default:he.sticky,description:c.localize(11772,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:he.hidingDelay,description:c.localize(11773,null)},"editor.hover.above":{type:"boolean",default:he.above,description:c.localize(11774,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{enabled:i(ce.enabled,this.defaultValue.enabled),delay:o.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:i(ce.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(ce.above,this.defaultValue.above)}}}var le;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(le||(e.RenderMinimap=le={}));class re extends ${constructor(){super(je.layoutInfo)}compute(he,ce,Xe){return re.computeLayout(ce,{memory:he.memory,outerWidth:he.outerWidth,outerHeight:he.outerHeight,isDominatedByLongLines:he.isDominatedByLongLines,lineHeight:he.fontInfo.lineHeight,viewLineCount:he.viewLineCount,lineNumbersDigitCount:he.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:he.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:he.fontInfo.maxDigitWidth,pixelRatio:he.pixelRatio,glyphMarginDecorationLaneCount:he.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(he){const ce=he.height/he.lineHeight,Xe=Math.floor(he.paddingTop/he.lineHeight);let et=Math.floor(he.paddingBottom/he.lineHeight);he.scrollBeyondLastLine&&(et=Math.max(et,ce-1));const ut=(Xe+he.viewLineCount+et)/(he.pixelRatio*he.height),mt=Math.floor(he.viewLineCount/ut);return{typicalViewportLineCount:ce,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:et,desiredRatio:ut,minimapLineCount:mt}}static c(he,ce){const Xe=he.outerWidth,et=he.outerHeight,ut=he.pixelRatio;if(!he.minimap.enabled)return{renderMinimap:le.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const mt=ce.stableMinimapLayoutInput,Dt=mt&&he.outerHeight===mt.outerHeight&&he.lineHeight===mt.lineHeight&&he.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&he.pixelRatio===mt.pixelRatio&&he.scrollBeyondLastLine===mt.scrollBeyondLastLine&&he.paddingTop===mt.paddingTop&&he.paddingBottom===mt.paddingBottom&&he.minimap.enabled===mt.minimap.enabled&&he.minimap.side===mt.minimap.side&&he.minimap.size===mt.minimap.size&&he.minimap.showSlider===mt.minimap.showSlider&&he.minimap.renderCharacters===mt.minimap.renderCharacters&&he.minimap.maxColumn===mt.minimap.maxColumn&&he.minimap.scale===mt.minimap.scale&&he.verticalScrollbarWidth===mt.verticalScrollbarWidth&&he.isViewportWrapping===mt.isViewportWrapping,Ft=he.lineHeight,Ht=he.typicalHalfwidthCharacterWidth,ei=he.scrollBeyondLastLine,oi=he.minimap.renderCharacters;let Rt=ut>=2?Math.round(he.minimap.scale*2):he.minimap.scale;const tt=he.minimap.maxColumn,jt=he.minimap.size,hi=he.minimap.side,pt=he.verticalScrollbarWidth,yt=he.viewLineCount,ti=he.remainingWidth,ii=he.isViewportWrapping,qt=oi?2:3;let bt=Math.floor(ut*et);const zt=bt/ut;let ni=!1,ai=!1,xe=qt*Rt,ci=Rt/ut,di=1;if(jt==="fill"||jt==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:li,extraLinesBeyondLastLine:Wt,desiredRatio:Kt,minimapLineCount:Jt}=re.computeContainedMinimapLineCount({viewLineCount:yt,scrollBeyondLastLine:ei,paddingTop:he.paddingTop,paddingBottom:he.paddingBottom,height:et,lineHeight:Ft,pixelRatio:ut});if(yt/Jt>1)ni=!0,ai=!0,Rt=1,xe=1,ci=Rt/ut;else{let wt=!1,It=Rt+1;if(jt==="fit"){const Yt=Math.ceil((li+yt+Wt)*xe);ii&&Dt&&ti<=ce.stableFitRemainingWidth?(wt=!0,It=ce.stableFitMaxMinimapScale):wt=Yt>bt}if(jt==="fill"||wt){ni=!0;const Yt=Rt;xe=Math.min(Ft*ut,Math.max(1,Math.floor(1/Kt))),ii&&Dt&&ti<=ce.stableFitRemainingWidth&&(It=ce.stableFitMaxMinimapScale),Rt=Math.min(It,Math.max(1,Math.floor(xe/qt))),Rt>Yt&&(di=Math.min(2,Rt/Yt)),ci=Rt/ut/di,bt=Math.ceil(Math.max(Qt,li+yt+Wt)*xe),ii?(ce.stableMinimapLayoutInput=he,ce.stableFitRemainingWidth=ti,ce.stableFitMaxMinimapScale=Rt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const fi=Math.floor(tt*ci),vt=Math.min(fi,Math.max(0,Math.floor((ti-pt-2)*ci/(Ht+ci)))+e.MINIMAP_GUTTER_WIDTH);let Mt=Math.floor(ut*vt);const Lt=Mt/ut;Mt=Math.floor(Mt*di);const Gt=oi?le.Text:le.Blocks,ri=hi==="left"?0:Xe-vt-pt;return{renderMinimap:Gt,minimapLeft:ri,minimapWidth:vt,minimapHeightIsEditorHeight:ni,minimapIsSampling:ai,minimapScale:Rt,minimapLineHeight:xe,minimapCanvasInnerWidth:Mt,minimapCanvasInnerHeight:bt,minimapCanvasOuterWidth:Lt,minimapCanvasOuterHeight:zt}}static computeLayout(he,ce){const Xe=ce.outerWidth|0,et=ce.outerHeight|0,ut=ce.lineHeight|0,mt=ce.lineNumbersDigitCount|0,Dt=ce.typicalHalfwidthCharacterWidth,Ft=ce.maxDigitWidth,Ht=ce.pixelRatio,ei=ce.viewLineCount,oi=he.get(je.wordWrapOverride2),Rt=oi==="inherit"?he.get(je.wordWrapOverride1):oi,tt=Rt==="inherit"?he.get(je.wordWrap):Rt,jt=he.get(je.wordWrapColumn),hi=ce.isDominatedByLongLines,pt=he.get(je.glyphMargin),yt=he.get(je.lineNumbers).renderType!==ze.Off,ti=he.get(je.lineNumbersMinChars),ii=he.get(je.scrollBeyondLastLine),qt=he.get(je.padding),bt=he.get(je.minimap),zt=he.get(je.scrollbar),ni=zt.verticalScrollbarSize,ai=zt.verticalHasArrows,xe=zt.arrowSize,ci=zt.horizontalScrollbarSize,di=he.get(je.folding),fi=he.get(je.showFoldingControls)!=="never";let vt=he.get(je.lineDecorationsWidth);di&&fi&&(vt+=16);let Mt=0;if(yt){const gi=Math.max(mt,ti);Mt=Math.round(gi*Ft)}let Lt=0;pt&&(Lt=ut*ce.glyphMarginDecorationLaneCount);let Gt=0,ri=Gt+Lt,Qt=ri+Mt,li=Qt+vt;const Wt=Xe-Lt-Mt-vt;let Kt=!1,Jt=!1,Nt=-1;Rt==="inherit"&&hi?(Kt=!0,Jt=!0):tt==="on"||tt==="bounded"?Jt=!0:tt==="wordWrapColumn"&&(Nt=jt);const wt=re.c({outerWidth:Xe,outerHeight:et,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Ht,scrollBeyondLastLine:ii,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:bt,verticalScrollbarWidth:ni,viewLineCount:ei,remainingWidth:Wt,isViewportWrapping:Jt},ce.memory||new P);wt.renderMinimap!==le.None&&wt.minimapLeft===0&&(Gt+=wt.minimapWidth,ri+=wt.minimapWidth,Qt+=wt.minimapWidth,li+=wt.minimapWidth);const It=Wt-wt.minimapWidth,Yt=Math.max(1,Math.floor((It-ni-2)/Dt)),Pt=ai?xe:0;return Jt&&(Nt=Math.max(1,Yt),tt==="bounded"&&(Nt=Math.min(Nt,jt))),{width:Xe,height:et,glyphMarginLeft:Gt,glyphMarginWidth:Lt,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:Mt,decorationsLeft:Qt,decorationsWidth:vt,contentLeft:li,contentWidth:It,minimap:wt,viewportColumn:Yt,isWordWrapMinified:Kt,isViewportWrapping:Jt,wrappingColumn:Nt,verticalScrollbarWidth:ni,horizontalScrollbarHeight:ci,overviewRuler:{top:Pt,width:ni,height:et-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=re;class Se extends w{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(11775,null),c.localize(11776,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(11777,null)}})}validate(he){return g(he,"simple",["simple","advanced"])}compute(he,ce,Xe){return ce.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var me;(function(ue){ue.Off="off",ue.OnCode="onCode",ue.On="on"})(me||(e.ShowLightbulbIconMode=me={}));class Q extends w{constructor(){const he={enabled:me.On};super(je.lightbulb,"lightbulb",he,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[me.Off,me.OnCode,me.On],default:he.enabled,enumDescriptions:[c.localize(11778,null),c.localize(11779,null),c.localize(11780,null)],description:c.localize(11781,null)}})}validate(he){return!he||typeof he!="object"?this.defaultValue:{enabled:g(he.enabled,this.defaultValue.enabled,[me.Off,me.OnCode,me.On])}}}class q extends w{constructor(){const he={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",he,{"editor.stickyScroll.enabled":{type:"boolean",default:he.enabled,description:c.localize(11782,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:he.maxLineCount,minimum:1,maximum:20,description:c.localize(11783,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:he.defaultModel,description:c.localize(11784,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:he.scrollWithEditor,description:c.localize(11785,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{enabled:i(ce.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends w{constructor(){const he={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",he,{"editor.inlayHints.enabled":{type:"string",default:he.enabled,description:c.localize(11786,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(11787,null),c.localize(11788,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(11789,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(11790,null)]},"editor.inlayHints.fontSize":{type:"number",default:he.fontSize,markdownDescription:c.localize(11791,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:he.fontFamily,markdownDescription:c.localize(11792,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:he.padding,description:c.localize(11793,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return typeof ce.enabled=="boolean"&&(ce.enabled=ce.enabled?"on":"off"),{enabled:g(ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(ce.fontFamily,this.defaultValue.fontFamily),padding:i(ce.padding,this.defaultValue.padding)}}}class we extends w{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(he){return typeof he=="string"&&/^\d+(\.\d+)?ch$/.test(he)?-parseFloat(he.substring(0,he.length-2)):o.clampedInt(he,this.defaultValue,0,1e3)}compute(he,ce,Xe){return Xe<0?o.clampedInt(-Xe*he.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class ee extends d{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,he=>d.clamp(he,0,150),{markdownDescription:c.localize(11794,null)})}compute(he,ce,Xe){return he.fontInfo.lineHeight}}class ae extends w{constructor(){const he={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",he,{"editor.minimap.enabled":{type:"boolean",default:he.enabled,description:c.localize(11795,null)},"editor.minimap.autohide":{type:"boolean",default:he.autohide,description:c.localize(11796,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(11797,null),c.localize(11798,null),c.localize(11799,null)],default:he.size,description:c.localize(11800,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:he.side,description:c.localize(11801,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:he.showSlider,description:c.localize(11802,null)},"editor.minimap.scale":{type:"number",default:he.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(11803,null)},"editor.minimap.renderCharacters":{type:"boolean",default:he.renderCharacters,description:c.localize(11804,null)},"editor.minimap.maxColumn":{type:"number",default:he.maxColumn,description:c.localize(11805,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:he.showRegionSectionHeaders,description:c.localize(11806,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:he.showMarkSectionHeaders,description:c.localize(11807,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:he.sectionHeaderFontSize,description:c.localize(11808,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:he.sectionHeaderLetterSpacing,description:c.localize(11809,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{enabled:i(ce.enabled,this.defaultValue.enabled),autohide:i(ce.autohide,this.defaultValue.autohide),size:g(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(ce.side,this.defaultValue.side,["right","left"]),showSlider:g(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(ce.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ce.scale,1,1,3),maxColumn:o.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function oe(ue){return ue==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class x extends w{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(11810,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(11811,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{top:o.clampedInt(ce.top,0,0,1e3),bottom:o.clampedInt(ce.bottom,0,0,1e3)}}}class ne extends w{constructor(){const he={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",he,{"editor.parameterHints.enabled":{type:"boolean",default:he.enabled,description:c.localize(11812,null)},"editor.parameterHints.cycle":{type:"boolean",default:he.cycle,description:c.localize(11813,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{enabled:i(ce.enabled,this.defaultValue.enabled),cycle:i(ce.cycle,this.defaultValue.cycle)}}}class pe extends ${constructor(){super(je.pixelRatio)}compute(he,ce,Xe){return he.pixelRatio}}class be extends w{constructor(){super(je.placeholder,"placeholder",void 0)}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he:this.defaultValue}}class Fe extends w{constructor(){const he={other:"on",comments:"off",strings:"off"},ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(11814,null),c.localize(11815,null),c.localize(11816,null)]}];super(je.quickSuggestions,"quickSuggestions",he,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ce,default:he.strings,description:c.localize(11817,null)},comments:{anyOf:ce,default:he.comments,description:c.localize(11818,null)},other:{anyOf:ce,default:he.other,description:c.localize(11819,null)}},default:he,markdownDescription:c.localize(11820,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=he}validate(he){if(typeof he=="boolean"){const Ht=he?"on":"off";return{comments:Ht,strings:Ht,other:Ht}}if(!he||typeof he!="object")return this.defaultValue;const{other:ce,comments:Xe,strings:et}=he,ut=["on","inline","off"];let mt,Dt,Ft;return typeof ce=="boolean"?mt=ce?"on":"off":mt=g(ce,this.defaultValue.other,ut),typeof Xe=="boolean"?Dt=Xe?"on":"off":Dt=g(Xe,this.defaultValue.comments,ut),typeof et=="boolean"?Ft=et?"on":"off":Ft=g(et,this.defaultValue.strings,ut),{other:mt,comments:Dt,strings:Ft}}}var ze;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class Ae extends w{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(11821,null),c.localize(11822,null),c.localize(11823,null),c.localize(11824,null)],default:"on",description:c.localize(11825,null)})}validate(he){let ce=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof he<"u"&&(typeof he=="function"?(ce=ze.Custom,Xe=he):he==="interval"?ce=ze.Interval:he==="relative"?ce=ze.Relative:he==="on"?ce=ze.On:ce=ze.Off),{renderType:ce,renderFn:Xe}}}function De(ue){const he=ue.get(je.renderValidationDecorations);return he==="editable"?ue.get(je.readOnly):he!=="on"}class Ce extends w{constructor(){const he=[],ce={type:"number",description:c.localize(11826,null)};super(je.rulers,"rulers",he,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:c.localize(11827,null),format:"color-hex"}}}]},default:he,description:c.localize(11828,null)})}validate(he){if(Array.isArray(he)){const ce=[];for(const Xe of he)if(typeof Xe=="number")ce.push({column:o.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const et=Xe;ce.push({column:o.clampedInt(et.column,0,0,1e4),color:et.color})}return ce.sort((Xe,et)=>Xe.column-et.column),ce}return this.defaultValue}}class W extends w{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(he){return!he||typeof he!="object"?this.defaultValue:he}}function H(ue,he){if(typeof ue!="string")return he;switch(ue){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class X extends w{constructor(){const he={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",he,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(11829,null),c.localize(11830,null),c.localize(11831,null)],default:"auto",description:c.localize(11832,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(11833,null),c.localize(11834,null),c.localize(11835,null)],default:"auto",description:c.localize(11836,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:he.verticalScrollbarSize,description:c.localize(11837,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:he.horizontalScrollbarSize,description:c.localize(11838,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:he.scrollByPage,description:c.localize(11839,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:he.ignoreHorizontalScrollbarInContentHeight,description:c.localize(11840,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he,Xe=o.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=o.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:H(ce.vertical,this.defaultValue.vertical),horizontal:H(ce.horizontal,this.defaultValue.horizontal),useShadows:i(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:o.clampedInt(ce.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:o.clampedInt(ce.verticalSliderSize,et,0,1e3),scrollByPage:i(ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends w{constructor(){const he={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",he,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.nonBasicASCII,description:c.localize(11841,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:he.invisibleCharacters,description:c.localize(11842,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:he.ambiguousCharacters,description:c.localize(11843,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeComments,description:c.localize(11844,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeStrings,description:c.localize(11845,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:he.allowedCharacters,description:c.localize(11846,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:he.allowedLocales,description:c.localize(11847,null)}})}applyUpdate(he,ce){let Xe=!1;ce.allowedCharacters&&he&&(h.$ho(he.allowedCharacters,ce.allowedCharacters)||(he={...he,allowedCharacters:ce.allowedCharacters},Xe=!0)),ce.allowedLocales&&he&&(h.$ho(he.allowedLocales,ce.allowedLocales)||(he={...he,allowedLocales:ce.allowedLocales},Xe=!0));const et=super.applyUpdate(he,ce);return Xe?new a(et.newValue,!0):et}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{nonBasicASCII:Ke(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(he.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(he.allowedLocales,this.defaultValue.allowedLocales)}}c(he,ce){if(typeof he!="object"||!he)return ce;const Xe={};for(const[et,ut]of Object.entries(he))ut===!0&&(Xe[et]=!0);return Xe}}class de extends w{constructor(){const he={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",he,{"editor.inlineSuggest.enabled":{type:"boolean",default:he.enabled,description:c.localize(11848,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:he.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(11849,null),c.localize(11850,null),c.localize(11851,null)],description:c.localize(11852,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:he.suppressSuggestions,description:c.localize(11853,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:he.fontFamily,description:c.localize(11854,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{enabled:i(ce.enabled,this.defaultValue.enabled),mode:g(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class ve extends w{constructor(){const he={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",he,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:he.enabled,description:c.localize(11855,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:he.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(11856,null),c.localize(11857,null),c.localize(11858,null)],description:c.localize(11859,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:he.fontFamily,description:c.localize(11860,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{enabled:i(ce.enabled,this.defaultValue.enabled),showToolbar:g(ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(ce.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Oe extends w{constructor(){const he={enabled:T.$kt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$kt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",he,{"editor.bracketPairColorization.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(11861,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:he.independentColorPoolPerBracketType,description:c.localize(11862,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{enabled:i(ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class He extends w{constructor(){const he={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",he,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(11863,null),c.localize(11864,null),c.localize(11865,null)],default:he.bracketPairs,description:c.localize(11866,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(11867,null),c.localize(11868,null),c.localize(11869,null)],default:he.bracketPairsHorizontal,description:c.localize(11870,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:he.highlightActiveBracketPair,description:c.localize(11871,null)},"editor.guides.indentation":{type:"boolean",default:he.indentation,description:c.localize(11872,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(11873,null),c.localize(11874,null),c.localize(11875,null)],default:he.highlightActiveIndentation,description:c.localize(11876,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{bracketPairs:Ke(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(ue,he,ce){const Xe=ce.indexOf(ue);return Xe===-1?he:ce[Xe]}class _e extends w{constructor(){const he={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",he,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(11877,null),c.localize(11878,null)],default:he.insertMode,description:c.localize(11879,null)},"editor.suggest.filterGraceful":{type:"boolean",default:he.filterGraceful,description:c.localize(11880,null)},"editor.suggest.localityBonus":{type:"boolean",default:he.localityBonus,description:c.localize(11881,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:he.shareSuggestSelections,markdownDescription:c.localize(11882,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(11883,null),c.localize(11884,null),c.localize(11885,null),c.localize(11886,null)],default:he.selectionMode,markdownDescription:c.localize(11887,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:he.snippetsPreventQuickSuggestions,description:c.localize(11888,null)},"editor.suggest.showIcons":{type:"boolean",default:he.showIcons,description:c.localize(11889,null)},"editor.suggest.showStatusBar":{type:"boolean",default:he.showStatusBar,description:c.localize(11890,null)},"editor.suggest.preview":{type:"boolean",default:he.preview,description:c.localize(11891,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:he.showInlineDetails,description:c.localize(11892,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(11893,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(11894,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(11895,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(11896,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(11897,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(11898,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(11899,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(11900,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(11901,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(11902,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(11903,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(11904,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(11905,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(11906,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(11907,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(11908,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(11909,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(11910,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(11911,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(11912,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(11913,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(11914,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(11915,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(11916,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(11917,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(11918,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(11919,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(11920,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(11921,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(11922,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(11923,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(11924,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{insertMode:g(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(ce.showIcons,this.defaultValue.showIcons),showStatusBar:i(ce.showStatusBar,this.defaultValue.showStatusBar),preview:i(ce.preview,this.defaultValue.preview),previewMode:g(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(ce.showMethods,this.defaultValue.showMethods),showFunctions:i(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:i(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(ce.showFields,this.defaultValue.showFields),showVariables:i(ce.showVariables,this.defaultValue.showVariables),showClasses:i(ce.showClasses,this.defaultValue.showClasses),showStructs:i(ce.showStructs,this.defaultValue.showStructs),showInterfaces:i(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:i(ce.showModules,this.defaultValue.showModules),showProperties:i(ce.showProperties,this.defaultValue.showProperties),showEvents:i(ce.showEvents,this.defaultValue.showEvents),showOperators:i(ce.showOperators,this.defaultValue.showOperators),showUnits:i(ce.showUnits,this.defaultValue.showUnits),showValues:i(ce.showValues,this.defaultValue.showValues),showConstants:i(ce.showConstants,this.defaultValue.showConstants),showEnums:i(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:i(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(ce.showKeywords,this.defaultValue.showKeywords),showWords:i(ce.showWords,this.defaultValue.showWords),showColors:i(ce.showColors,this.defaultValue.showColors),showFiles:i(ce.showFiles,this.defaultValue.showFiles),showReferences:i(ce.showReferences,this.defaultValue.showReferences),showFolders:i(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:i(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(ce.showSnippets,this.defaultValue.showSnippets),showUsers:i(ce.showUsers,this.defaultValue.showUsers),showIssues:i(ce.showIssues,this.defaultValue.showIssues)}}}class nt extends w{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(11925,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(11926,null),default:!0,type:"boolean"}})}validate(he){return!he||typeof he!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(he.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(he.selectSubwords,this.defaultValue.selectSubwords)}}}class st extends w{constructor(){const he=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",he,{anyOf:[{description:c.localize(11927,null),type:"string"},{description:c.localize(11928,null),type:"array",items:{type:"string"}}]})}validate(he){if(typeof he=="string"&&(he=[he]),Array.isArray(he)){const ce=[];for(const Xe of he)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&ce.push(Xe)}catch{}return ce}return this.defaultValue}}var rt;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class at extends w{constructor(){super(je.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(11929,null),c.localize(11930,null),c.localize(11931,null),c.localize(11932,null)],description:c.localize(11933,null),default:"same"}})}validate(he){switch(he){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(he,ce,Xe){return ce.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?rt.None:Xe}}class gt extends ${constructor(){super(je.wrappingInfo)}compute(he,ce,Xe){const et=ce.get(je.layoutInfo);return{isDominatedByLongLines:he.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}class ht extends w{constructor(){const he={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",he,{"editor.dropIntoEditor.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(11934,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(11935,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(11936,null),c.localize(11937,null)],default:"afterDrop"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{enabled:i(ce.enabled,this.defaultValue.enabled),showDropSelector:g(ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ct extends w{constructor(){const he={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",he,{"editor.pasteAs.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(11938,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(11939,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(11940,null),c.localize(11941,null)],default:"afterPaste"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const ce=he;return{enabled:i(ce.enabled,this.defaultValue.enabled),showPasteSelector:g(ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?Be:C.$l?Ye:Pe,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var je;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.inlineEdit=63]="inlineEdit",ue[ue.letterSpacing=64]="letterSpacing",ue[ue.lightbulb=65]="lightbulb",ue[ue.lineDecorationsWidth=66]="lineDecorationsWidth",ue[ue.lineHeight=67]="lineHeight",ue[ue.lineNumbers=68]="lineNumbers",ue[ue.lineNumbersMinChars=69]="lineNumbersMinChars",ue[ue.linkedEditing=70]="linkedEditing",ue[ue.links=71]="links",ue[ue.matchBrackets=72]="matchBrackets",ue[ue.minimap=73]="minimap",ue[ue.mouseStyle=74]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=76]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=78]="multiCursorModifier",ue[ue.multiCursorPaste=79]="multiCursorPaste",ue[ue.multiCursorLimit=80]="multiCursorLimit",ue[ue.occurrencesHighlight=81]="occurrencesHighlight",ue[ue.overviewRulerBorder=82]="overviewRulerBorder",ue[ue.overviewRulerLanes=83]="overviewRulerLanes",ue[ue.padding=84]="padding",ue[ue.pasteAs=85]="pasteAs",ue[ue.parameterHints=86]="parameterHints",ue[ue.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ue[ue.placeholder=88]="placeholder",ue[ue.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=90]="quickSuggestions",ue[ue.quickSuggestionsDelay=91]="quickSuggestionsDelay",ue[ue.readOnly=92]="readOnly",ue[ue.readOnlyMessage=93]="readOnlyMessage",ue[ue.renameOnType=94]="renameOnType",ue[ue.renderControlCharacters=95]="renderControlCharacters",ue[ue.renderFinalNewline=96]="renderFinalNewline",ue[ue.renderLineHighlight=97]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=99]="renderValidationDecorations",ue[ue.renderWhitespace=100]="renderWhitespace",ue[ue.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ue[ue.roundedSelection=102]="roundedSelection",ue[ue.rulers=103]="rulers",ue[ue.scrollbar=104]="scrollbar",ue[ue.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=106]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=107]="scrollPredominantAxis",ue[ue.selectionClipboard=108]="selectionClipboard",ue[ue.selectionHighlight=109]="selectionHighlight",ue[ue.selectOnLineNumbers=110]="selectOnLineNumbers",ue[ue.showFoldingControls=111]="showFoldingControls",ue[ue.showUnused=112]="showUnused",ue[ue.snippetSuggestions=113]="snippetSuggestions",ue[ue.smartSelect=114]="smartSelect",ue[ue.smoothScrolling=115]="smoothScrolling",ue[ue.stickyScroll=116]="stickyScroll",ue[ue.stickyTabStops=117]="stickyTabStops",ue[ue.stopRenderingLineAfter=118]="stopRenderingLineAfter",ue[ue.suggest=119]="suggest",ue[ue.suggestFontSize=120]="suggestFontSize",ue[ue.suggestLineHeight=121]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ue[ue.suggestSelection=123]="suggestSelection",ue[ue.tabCompletion=124]="tabCompletion",ue[ue.tabIndex=125]="tabIndex",ue[ue.unicodeHighlighting=126]="unicodeHighlighting",ue[ue.unusualLineTerminators=127]="unusualLineTerminators",ue[ue.useShadowDOM=128]="useShadowDOM",ue[ue.useTabStops=129]="useTabStops",ue[ue.wordBreak=130]="wordBreak",ue[ue.wordSegmenterLocales=131]="wordSegmenterLocales",ue[ue.wordSeparators=132]="wordSeparators",ue[ue.wordWrap=133]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=136]="wordWrapColumn",ue[ue.wordWrapOverride1=137]="wordWrapOverride1",ue[ue.wordWrapOverride2=138]="wordWrapOverride2",ue[ue.wrappingIndent=139]="wrappingIndent",ue[ue.wrappingStrategy=140]="wrappingStrategy",ue[ue.showDeprecated=141]="showDeprecated",ue[ue.inlayHints=142]="inlayHints",ue[ue.editorClassName=143]="editorClassName",ue[ue.pixelRatio=144]="pixelRatio",ue[ue.tabFocusMode=145]="tabFocusMode",ue[ue.layoutInfo=146]="layoutInfo",ue[ue.wrappingInfo=147]="wrappingInfo",ue[ue.defaultColorDecorators=148]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new s(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(11942,null)})),acceptSuggestionOnEnter:Ne(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(11943,null),""],markdownDescription:c.localize(11944,null)})),accessibilitySupport:Ne(new k),accessibilityPageSize:Ne(new o(je.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11945,null),tags:["accessibility"]})),ariaLabel:Ne(new l(je.ariaLabel,"ariaLabel",c.localize(11946,null))),ariaRequired:Ne(new s(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new s(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(11947,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11948,null),c.localize(11949,null),""],description:c.localize(11950,null)})),autoClosingComments:Ne(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11951,null),c.localize(11952,null),""],description:c.localize(11953,null)})),autoClosingDelete:Ne(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(11954,null),""],description:c.localize(11955,null)})),autoClosingOvertype:Ne(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(11956,null),""],description:c.localize(11957,null)})),autoClosingQuotes:Ne(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11958,null),c.localize(11959,null),""],description:c.localize(11960,null)})),autoIndent:Ne(new D(je.autoIndent,"autoIndent",S.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(11961,null),c.localize(11962,null),c.localize(11963,null),c.localize(11964,null),c.localize(11965,null)],description:c.localize(11966,null)})),automaticLayout:Ne(new s(je.automaticLayout,"automaticLayout",!1)),autoSurround:Ne(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(11967,null),c.localize(11968,null),c.localize(11969,null),""],description:c.localize(11970,null)})),bracketPairColorization:Ne(new Oe),bracketPairGuides:Ne(new He),stickyTabStops:Ne(new s(je.stickyTabStops,"stickyTabStops",!1,{description:c.localize(11971,null)})),codeLens:Ne(new s(je.codeLens,"codeLens",!0,{description:c.localize(11972,null)})),codeLensFontFamily:Ne(new l(je.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(11973,null)})),codeLensFontSize:Ne(new o(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(11974,null)})),colorDecorators:Ne(new s(je.colorDecorators,"colorDecorators",!0,{description:c.localize(11975,null)})),colorDecoratorActivatedOn:Ne(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(11976,null),c.localize(11977,null),c.localize(11978,null)],description:c.localize(11979,null)})),colorDecoratorsLimit:Ne(new o(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(11980,null)})),columnSelection:Ne(new s(je.columnSelection,"columnSelection",!1,{description:c.localize(11981,null)})),comments:Ne(new A),contextmenu:Ne(new s(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new s(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(11982,null)})),cursorBlinking:Ne(new D(je.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:c.localize(11983,null)})),cursorSmoothCaretAnimation:Ne(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(11984,null),c.localize(11985,null),c.localize(11986,null)],description:c.localize(11987,null)})),cursorStyle:Ne(new D(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:c.localize(11988,null)})),cursorSurroundingLines:Ne(new o(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11989,null)})),cursorSurroundingLinesStyle:Ne(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(11990,null),c.localize(11991,null)],markdownDescription:c.localize(11992,null)})),cursorWidth:Ne(new o(je.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(11993,null)})),disableLayerHinting:Ne(new s(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new s(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new s(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Ne(new s(je.dragAndDrop,"dragAndDrop",!0,{description:c.localize(11994,null)})),emptySelectionClipboard:Ne(new z),dropIntoEditor:Ne(new ht),stickyScroll:Ne(new q),experimentalWhitespaceRendering:Ne(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(11995,null),c.localize(11996,null),c.localize(11997,null)],description:c.localize(11998,null)})),extraEditorClassName:Ne(new l(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Ne(new d(je.fastScrollSensitivity,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:c.localize(11999,null)})),find:Ne(new M),fixedOverflowWidgets:Ne(new s(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Ne(new s(je.folding,"folding",!0,{description:c.localize(12e3,null)})),foldingStrategy:Ne(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(12001,null),c.localize(12002,null)],description:c.localize(12003,null)})),foldingHighlight:Ne(new s(je.foldingHighlight,"foldingHighlight",!0,{description:c.localize(12004,null)})),foldingImportsByDefault:Ne(new s(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(12005,null)})),foldingMaximumRegions:Ne(new o(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(12006,null)})),unfoldOnClickAfterEndOfLine:Ne(new s(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(12007,null)})),fontFamily:Ne(new l(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(12008,null)})),fontInfo:Ne(new ie),fontLigatures2:Ne(new U),fontSize:Ne(new B),fontWeight:Ne(new Y),fontVariations:Ne(new V),formatOnPaste:Ne(new s(je.formatOnPaste,"formatOnPaste",!1,{description:c.localize(12009,null)})),formatOnType:Ne(new s(je.formatOnType,"formatOnType",!1,{description:c.localize(12010,null)})),glyphMargin:Ne(new s(je.glyphMargin,"glyphMargin",!0,{description:c.localize(12011,null)})),gotoLocation:Ne(new J),hideCursorInOverviewRuler:Ne(new s(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(12012,null)})),hover:Ne(new _),inDiffEditor:Ne(new s(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Ne(new d(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>d.clamp(ue,-5,20),{description:c.localize(12013,null)})),lightbulb:Ne(new Q),lineDecorationsWidth:Ne(new we),lineHeight:Ne(new ee),lineNumbers:Ne(new Ae),lineNumbersMinChars:Ne(new o(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new s(je.linkedEditing,"linkedEditing",!1,{description:c.localize(12014,null)})),links:Ne(new s(je.links,"links",!0,{description:c.localize(12015,null)})),matchBrackets:Ne(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(12016,null)})),minimap:Ne(new ae),mouseStyle:Ne(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new d(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:c.localize(12017,null)})),mouseWheelZoom:Ne(new s(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:C.$k?c.localize(12018,null):c.localize(12019,null)})),multiCursorMergeOverlapping:Ne(new s(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(12020,null)})),multiCursorModifier:Ne(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],oe,{markdownEnumDescriptions:[c.localize(12021,null),c.localize(12022,null)],markdownDescription:c.localize(12023,null)})),multiCursorPaste:Ne(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(12024,null),c.localize(12025,null)],markdownDescription:c.localize(12026,null)})),multiCursorLimit:Ne(new o(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(12027,null)})),occurrencesHighlight:Ne(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(12028,null),c.localize(12029,null),c.localize(12030,null)],markdownDescription:c.localize(12031,null)})),overviewRulerBorder:Ne(new s(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(12032,null)})),overviewRulerLanes:Ne(new o(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Ne(new x),pasteAs:Ne(new ct),parameterHints:Ne(new ne),peekWidgetDefaultFocus:Ne(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(12033,null),c.localize(12034,null)],description:c.localize(12035,null)})),placeholder:Ne(new be),definitionLinkOpensInPeek:Ne(new s(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(12036,null)})),quickSuggestions:Ne(new Fe),quickSuggestionsDelay:Ne(new o(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(12037,null)})),readOnly:Ne(new s(je.readOnly,"readOnly",!1)),readOnlyMessage:Ne(new W),renameOnType:Ne(new s(je.renameOnType,"renameOnType",!1,{description:c.localize(12038,null),markdownDeprecationMessage:c.localize(12039,null)})),renderControlCharacters:Ne(new s(je.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(12040,null),restricted:!0})),renderFinalNewline:Ne(new E(je.renderFinalNewline,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:c.localize(12041,null)})),renderLineHighlight:Ne(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(12042,null)],description:c.localize(12043,null)})),renderLineHighlightOnlyWhenFocus:Ne(new s(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(12044,null)})),renderValidationDecorations:Ne(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(12045,null),c.localize(12046,null),c.localize(12047,null),""],description:c.localize(12048,null)})),revealHorizontalRightPadding:Ne(new o(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new s(je.roundedSelection,"roundedSelection",!0,{description:c.localize(12049,null)})),rulers:Ne(new Ce),scrollbar:Ne(new X),scrollBeyondLastColumn:Ne(new o(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(12050,null)})),scrollBeyondLastLine:Ne(new s(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(12051,null)})),scrollPredominantAxis:Ne(new s(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(12052,null)})),selectionClipboard:Ne(new s(je.selectionClipboard,"selectionClipboard",!0,{description:c.localize(12053,null),included:C.$l})),selectionHighlight:Ne(new s(je.selectionHighlight,"selectionHighlight",!0,{description:c.localize(12054,null)})),selectOnLineNumbers:Ne(new s(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(12055,null),c.localize(12056,null),c.localize(12057,null)],description:c.localize(12058,null)})),showUnused:Ne(new s(je.showUnused,"showUnused",!0,{description:c.localize(12059,null)})),showDeprecated:Ne(new s(je.showDeprecated,"showDeprecated",!0,{description:c.localize(12060,null)})),inlayHints:Ne(new se),snippetSuggestions:Ne(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(12061,null),c.localize(12062,null),c.localize(12063,null),c.localize(12064,null)],description:c.localize(12065,null)})),smartSelect:Ne(new nt),smoothScrolling:Ne(new s(je.smoothScrolling,"smoothScrolling",!1,{description:c.localize(12066,null)})),stopRenderingLineAfter:Ne(new o(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Ne(new _e),inlineSuggest:Ne(new de),inlineEdit:Ne(new ve),inlineCompletionsAccessibilityVerbose:Ne(new s(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(12067,null)})),suggestFontSize:Ne(new o(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(12068,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new o(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(12069,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new s(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(12070,null)})),suggestSelection:Ne(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(12071,null),c.localize(12072,null),c.localize(12073,null)],description:c.localize(12074,null)})),tabCompletion:Ne(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(12075,null),c.localize(12076,null),c.localize(12077,null)],description:c.localize(12078,null)})),tabIndex:Ne(new o(je.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Ne(new Z),unusualLineTerminators:Ne(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(12079,null),c.localize(12080,null),c.localize(12081,null)],description:c.localize(12082,null)})),useShadowDOM:Ne(new s(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Ne(new s(je.useTabStops,"useTabStops",!0,{description:c.localize(12083,null)})),wordBreak:Ne(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(12084,null),c.localize(12085,null)],description:c.localize(12086,null)})),wordSegmenterLocales:Ne(new st),wordSeparators:Ne(new l(je.wordSeparators,"wordSeparators",b.$lt,{description:c.localize(12087,null)})),wordWrap:Ne(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(12088,null),c.localize(12089,null),c.localize(12090,null),c.localize(12091,null)],description:c.localize(12092,null)})),wordWrapBreakAfterCharacters:Ne(new l(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new l(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new o(je.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(12093,null)})),wordWrapOverride1:Ne(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new j),defaultColorDecorators:Ne(new s(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(12094,null)})),pixelRatio:Ne(new pe),tabFocusMode:Ne(new s(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(12095,null)})),layoutInfo:Ne(new re),wrappingInfo:Ne(new gt),wrappingIndent:Ne(new at),wrappingStrategy:Ne(new Se)}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[216],Ie([1,0,22,43,8,5,107,10,24]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$$w=e.$0w=e.$9w=void 0,e.$_w=P,e.$ax=w,h=Ut(h),e.$9w=(0,R.$Ei)("dialogService");var c;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(c||(c={}));class I{a(m){return this.d(m,c.Confirmation)}b(m){return this.d(m,c.Prompt)}c(m){return this.d(m,c.Input)}d(m,$){const f=[];switch($){case c.Confirmation:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,C.localize)(11529,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,C.localize)(11530,null));break}case c.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&f.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?f.push((0,C.localize)(11531,null)):typeof i.cancelButton=="string"?f.push(i.cancelButton):i.cancelButton.label?f.push(i.cancelButton.label):f.push((0,C.localize)(11532,null))),f.length===0&&f.push((0,C.localize)(11533,null));break}case c.Input:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,C.localize)(11534,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,C.localize)(11535,null));break}}return f}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===h.default.Info?"info":m===h.default.Error?"error":m===h.default.Warning?"warning":"none"}f(m,$,f){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let s=i[$]?.run({checkboxChecked:f});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:f}}}e.$0w=I,e.$$w=(0,R.$Ei)("fileDialogService");var S;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(S||(e.ConfirmResult=S={}));const u=10;function P(a){const m=[];return m.push(...a.slice(0,u).map($=>typeof $=="string"?$:(0,r.$ch)($))),a.length>u&&(a.length-u===1?m.push((0,C.localize)(11536,null)):m.push((0,C.localize)(11537,null,a.length-u))),m.push(""),m.join(`
`)}function w(a,m){const $=(0,b.$do)(a);let f=($.buttons??[]).map(o=>(0,L.$6w)(o)),i=(a.buttons||[]).map((o,n)=>n),s=0,t=$.cancelId??f.length-1;if(f.length>1){const o=typeof t=="number"?f[t]:void 0;if(T.$l||T.$k){if(typeof o=="string"&&f.length>1&&t!==1){f.splice(t,1),f.splice(1,0,o);const n=i[t];i.splice(t,1),i.splice(1,0,n),t=1}T.$l&&f.length>1&&(f=f.reverse(),i=i.reverse(),s=f.length-1,typeof o=="string"&&(t=s-1))}else if(T.$j&&typeof o=="string"&&f.length>1&&t!==f.length-1){f.splice(t,1),f.push(o);const n=i[t];i.splice(t,1),i.push(n),t=f.length-1}}return $.buttons=f,$.defaultId=s,$.cancelId=t,$.noLink=!0,$.title=$.title||m.nameLong,{options:$,buttonIndeces:i}}}),define(ke[144],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=void 0,e.$Li=(0,r.$Ei)("environmentService"),e.$Mi=(0,r.$Fi)(e.$Li)}),define(ke[217],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=e.$E0b=void 0,e.$E0b=(0,r.$Ei)("externalTerminal"),e.$F0b="Terminal.app"}),define(ke[218],Ie([1,0,56,59,14,16,10,104,33,109,8,217]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=e.$tgc=void 0,r=qe(r),R=qe(R),L=qe(L),b=qe(b),c=qe(c),I=qe(I);const u=I.localize(11379,null);class P{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends P{static{this.b="cmd.exe"}openTerminal(t,o){return this.spawnTerminal(r,t,c.$xm(),o)}spawnTerminal(t,o,n,d){const l=o.windowsExec||w.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const g=R.$nc(l,".exe").toLowerCase();if(g==="cmder")return t.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return l.indexOf(" ")>=0&&E.push(l),E.push(l),g==="wt"&&E.push("-d ."),new Promise((D,y)=>{const k=$(process),A=t.spawn(n,E,{cwd:d,env:k,detached:!0});A.on("error",y),A.on("exit",()=>D())})}async runInTerminal(t,o,n,d,l){const g="windowsExec"in l&&l.windowsExec?l.windowsExec:w.getDefaultTerminalWindows(),E=await w.f();return new Promise((D,y)=>{const k=`"${o} - ${u}"`,A=`"${n.join('" "')}" & pause`,p=Object.assign({},$(process),d);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const v={cwd:o,env:p,windowsVerbatimArguments:!0};let F,N;R.$nc(g,".exe")==="wt"?(F=g,N=["-d",".",w.b,"/c",A]):E?(F=E,N=["-d",".",g,"/c",A]):(F=w.b,N=["/c","start",k,"/wait",g,"/c",`"${A}"`]),r.spawn(F,N,v).on("error",j=>{y(f(j))}),D(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await b.Promises.exists(t)?t:void 0}catch{return}}}e.$tgc=w,Je([h.$9h],w,"f",null);class a extends P{static{this.b="/usr/bin/osascript"}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.osxExec||S.$F0b;return new Promise((E,D)=>{if(g===S.$F0b||g==="iTerm.app"){const y=g===S.$F0b?"TerminalHelper":"iTermHelper",A=[C.$Yg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||u,"-w",o];for(const F of n)A.push("-a"),A.push(F);if(d){const F=Object.assign({},$(process),d);for(const N in F){const O=F[N];O===null?(A.push("-u"),A.push(N)):(A.push("-e"),A.push(`${N}=${O}`))}}let p="";const v=r.spawn(a.b,A);v.on("error",F=>{D(f(F))}),v.stderr.on("data",F=>{p+=F.toString()}),v.on("exit",F=>{if(F===0)E(void 0);else if(p){const N=p.split(`
`,1);D(new Error(N[0]))}else D(new Error(I.localize(11380,null,y,F)))})}else D(new Error(I.localize(11381,null,g)))})}spawnTerminal(t,o,n){const d=o.osxExec||S.$F0b;return new Promise((l,g)=>{const E=["-a",d];n&&E.push(n);const D=$(process),y=t.spawn("/usr/bin/open",E,{cwd:n,env:D});y.on("error",g),y.on("exit",()=>l())})}}e.$ugc=a;class m extends P{static{this.b=I.localize(11382,null)}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((E,D)=>{const y=[];g.then(k=>{k.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const A=`${i(n)}; echo; read -p "${m.b}" -n1;`;y.push(`''${A}''`);const p=Object.assign({},$(process),d);Object.keys(p).filter(O=>p[O]===null).forEach(O=>delete p[O]);const v={cwd:o,env:p};let F="";const N=r.spawn(k,y,v);N.on("error",O=>{D(f(O))}),N.stderr.on("data",O=>{F+=O.toString()}),N.on("exit",O=>{if(O===0)E(void 0);else if(F){const j=F.split(`
`,1);D(new Error(j[0]))}else D(new Error(I.localize(11383,null,k,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!L.$l)m.d=Promise.resolve("xterm");else{const t=await b.Promises.exists("/etc/debian_version");m.d=new Promise(o=>{t?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm")})}return m.d}spawnTerminal(t,o,n){const d=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,g)=>{d.then(E=>{const D=$(process),y=t.spawn(E,[],{cwd:n,env:D});y.on("error",g),y.on("exit",()=>l())})})}}e.$vgc=m;function $(s){const t={...s.env};return(0,T.$km)(t),t}function f(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(I.localize(11384,null,s.path)):s}function i(s){let t="";for(const o of s)o.indexOf(" ")>=0?t+='"'+o+'"':t+=o,t+=" ";return t}}),define(ke[27],Ie([1,0,84,16,12,17,2,8,5,10,14,49]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=u,e.$bl=m,e.$cl=f,e.$dl=i,e.$el=s,e.$fl=t,e.$gl=o,e.$hl=n,e.$il=d,e.$jl=l,e.$kl=g,e.$ml=y,e.$nl=k,e.$ol=A,e.$pl=p,e.$ql=v,e.$tl=z,e.$Fl=Y,e.$Gl=J,e.$Il=le,e.$_k=(0,b.$Ei)("fileService");function u(re){return re.create===!0}var P;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var w;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var a;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function m(re){const Se=re;return!!Se&&typeof Se.onDidChange=="function"}var $;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function f(re){return!!(re.capabilities&$.FileReadWrite)}function i(re){return!!(re.capabilities&$.FileFolderCopy)}function s(re){return!!(re.capabilities&$.FileClone)}function t(re){return!!(re.capabilities&$.FileOpenReadWriteClose)}function o(re){return!!(re.capabilities&$.FileReadStream)}function n(re){return f(re)?!!(re.capabilities&$.FileAtomicRead):!1}function d(re){return f(re)?!!(re.capabilities&$.FileAtomicWrite):!1}function l(re){return!!(re.capabilities&$.FileAtomicDelete)}function g(re){return!!(re.capabilities&$.Readonly)}var E;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(Se,me){const Q=new D(Se.toString(),me);return A(Q,me),Q}constructor(Se,me){super(Se),this.code=me}}e.$ll=D;function y(re,Se){return D.create(re,Se)}function k(re){return re||y((0,T.localize)(11338,null),E.Unknown)}function A(re,Se){return re.name=Se?`${Se} (FileSystemError)`:"FileSystemError",re}function p(re){if(!re)return E.Unknown;if(re instanceof D)return re.code;const Se=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Se)return E.Unknown;switch(Se[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function v(re){if(re instanceof M)return re.fileOperationResult;switch(p(re)){case E.FileNotFound:return ie.FILE_NOT_FOUND;case E.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case E.NoPermissions:return ie.FILE_PERMISSION_DENIED;case E.FileExists:return ie.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var F;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(Se,me,Q){this.resource=Se,this.operation=me,this.target=Q}isOperation(Se){return this.operation===Se}}e.$rl=N;var O;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class j{static{this.a=null}constructor(Se,me){this.c=me,this.b=void 0,this.d=new S.$T(()=>{const Q=r.$Ki.forUris(()=>this.c);return Q.fill(this.rawAdded.map(q=>[q,!0])),Q}),this.f=new S.$T(()=>{const Q=r.$Ki.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(q=>[q,!0])),Q}),this.g=new S.$T(()=>{const Q=r.$Ki.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(q=>[q,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of Se){switch(Q.type){case O.ADDED:this.rawAdded.push(Q.resource);break;case O.UPDATED:this.rawUpdated.push(Q.resource);break;case O.DELETED:this.rawDeleted.push(Q.resource);break}this.b!==j.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(Se,...me){return this.h(Se,{includeChildren:!1},...me)}affects(Se,...me){return this.h(Se,{includeChildren:!0},...me)}h(Se,me,...Q){if(!Se)return!1;const q=Q.length>0;return!!((!q||Q.includes(O.ADDED))&&(this.d.value.get(Se)||me.includeChildren&&this.d.value.findSuperstr(Se))||(!q||Q.includes(O.UPDATED))&&(this.f.value.get(Se)||me.includeChildren&&this.f.value.findSuperstr(Se))||(!q||Q.includes(O.DELETED))&&(this.g.value.findSubstr(Se)||me.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$sl=j;function z(re,Se,me){return!re||!Se||re===Se||Se.length>re.length?!1:(Se.charAt(Se.length-1)!==h.sep&&(Se+=h.sep),me?(0,C.$Gf)(re,Se):re.indexOf(Se)===0)}class M extends Error{constructor(Se,me,Q){super(Se),this.fileOperationResult=me,this.options=Q}}e.$ul=M;class U extends M{constructor(Se,me,Q,q){super(Se,me,q),this.fileOperationResult=me,this.size=Q}}e.$vl=U;class V extends M{constructor(Se,me,Q){super(Se,ie.FILE_NOT_MODIFIED_SINCE,Q),this.stat=me}}e.$wl=V;var ie;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var B;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$El="";function Y(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function J(re,Se){if(!Se.hasProvider(L.URI.from({scheme:re.scheme})))return new Promise(me=>{const Q=Se.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===re.scheme&&q.added&&(Q.dispose(),me())})})}class _{static{this.KB=1024}static{this.MB=_.KB*_.KB}static{this.GB=_.MB*_.KB}static{this.TB=_.GB*_.KB}static formatSize(Se){return(0,R.$ig)(Se)||(Se=0),Se<_.KB?(0,T.localize)(11339,null,Se.toFixed(0)):Se<_.MB?(0,T.localize)(11340,null,(Se/_.KB).toFixed(2)):Se<_.GB?(0,T.localize)(11341,null,(Se/_.MB).toFixed(2)):Se<_.TB?(0,T.localize)(11342,null,(Se/_.GB).toFixed(2)):(0,T.localize)(11343,null,(Se/_.TB).toFixed(2))}}e.$Hl=_;function le(re){const Se=typeof re=="string"||re?.scheme===I.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===I.Schemas.file?1024*_.MB:Se?10*_.MB:c.$p?50*_.MB:1024*_.MB}}),define(ke[219],Ie([1,0,21,13,8,27]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=L;async function L(I,S,u,P,w,a){let m;try{await T(I,S,u,P,w,a)}catch($){m=$}finally{m&&w.errorTransformer&&(m=w.errorTransformer(m)),typeof m<"u"&&u.error(m),u.end()}}async function T(I,S,u,P,w,a){b(a);const m=await I.open(S,{create:!1});try{b(a);let $=0,f=0,i=w&&typeof w.length=="number"?w.length:void 0,s=r.$Ne.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,o=0;do f=await I.read(m,t,s.buffer,o,s.byteLength-o),t+=f,o+=f,$+=f,typeof i=="number"&&(i-=f),o===s.byteLength&&(await u.write(P(s)),s=r.$Ne.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),o=0);while(f>0&&(typeof i!="number"||i>0)&&b(a)&&c($,w));if(o>0){let n=o;typeof i=="number"&&(n=Math.min(o,i)),u.write(P(s.slice(0,n)))}}catch($){throw(0,R.$nl)($)}finally{await I.close(m)}}function b(I){if(I.isCancellationRequested)throw(0,h.$5)();return!0}function c(I,S){if(typeof S?.limits?.size=="number"&&I>S.limits.size)throw(0,R.$ml)((0,C.localize)(11337,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[69],Ie([1,0,38,3,16,10,2,27]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0,e.$3q=b,e.$4q=c,e.$8q=P,e.$9q=w,e.$0q=a,e.$$q=m,e.$_q=f,e.$ar=i;function b(s){return typeof s.correlationId=="number"}function c(s){return s.recursive===!0}class I extends h.$Uc{static{this.a=5}constructor(t,o,n,d){super(),this.h=t,this.j=o,this.m=n,this.n=d,this.c=this.B(new h.$Vc),this.f=void 0,this.g=0}s(){const t=new h.$Tc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(o=>this.h(o))),t.add(this.b.onDidLogMessage(o=>this.j(o))),t.add(this.b.onDidError(o=>this.t(o.error,o.request)))}t(t,o){this.u(t,o)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,o){return!(!this.n.restartOnError||o||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$5q=I;class S extends I{constructor(t,o,n){super(t,o,n,{type:"node.js",restartOnError:!1})}}e.$6q=S;class u extends I{constructor(t,o,n){super(t,o,n,{type:"universal",restartOnError:!0})}}e.$7q=u;function P(s){return s.map(t=>({type:t.type,resource:L.URI.revive(t.resource),cId:t.cId}))}function w(s){const t=new $;for(const o of s)t.processEvent(o);return t.coalesce()}function a(s,t){return typeof t=="string"&&!t.startsWith(r.$vk)&&!(0,C.$ic)(t)?{base:s,pattern:t}:t}function m(s,t){const o=[];for(const n of t)o.push((0,r.$zk)(a(s,n)));return o}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return R.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const o=this.b.get(this.c(t));let n=!1;if(o){const d=o.type,l=t.type;o.resource.fsPath!==t.resource.fsPath&&(t.type===T.FileChangeType.DELETED||t.type===T.FileChangeType.ADDED)?n=!0:d===T.FileChangeType.ADDED&&l===T.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(o)):d===T.FileChangeType.DELETED&&l===T.FileChangeType.ADDED?o.type=T.FileChangeType.UPDATED:d===T.FileChangeType.ADDED&&l===T.FileChangeType.UPDATED||(o.type=l)}else n=!0;n&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],o=[];return Array.from(this.a).filter(n=>n.type!==T.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,d)=>n.resource.fsPath.length-d.resource.fsPath.length).filter(n=>o.some(d=>(0,T.$tl)(n.resource.fsPath,d,!R.$l))?!1:(o.push(n.resource.fsPath),!0)).concat(t)}}function f(s,t){if(typeof t=="number")switch(s.type){case T.FileChangeType.ADDED:return(t&T.FileChangeFilter.ADDED)===0;case T.FileChangeType.DELETED:return(t&T.FileChangeFilter.DELETED)===0;case T.FileChangeType.UPDATED:return(t&T.FileChangeFilter.UPDATED)===0}return!1}function i(s){if(typeof s=="number"){const t=[];return s&T.FileChangeFilter.ADDED&&t.push("Added"),s&T.FileChangeFilter.DELETED&&t.push("Deleted"),s&T.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ke[220],Ie([1,0,44,3,69,4,27,2,7]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class c extends h.$Uc{constructor(){super(),this.a=this.B(new R.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$4c),this.m=new Set,this.n=this.B(new b.$Ch(this.y())),this.r=5007,this.s=new b.$2h,this.R=!1,this.B(this.f(S=>this.t(S)))}t(S){this.u(S)&&this.z(S)}u(S){return(0,C.$3q)(S)}async watch(S){this.s.isSettled||this.s.complete(),this.s=new b.$2h;try{this.h.clear(),this.g.clear();for(const u of S)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(S){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),S?this.y():0)}y(){return 800}isSuspended(S){return typeof S.correlationId!="number"?!1:this.m.has(S.correlationId)?"polling":this.j.has(S.correlationId)}async z(S){if(this.j.has(S.correlationId))return;const u=new h.$Tc;this.j.set(S.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(S,u),this.w(!0))}C(S){this.j.deleteAndDispose(S.correlationId),this.m.delete(S.correlationId),this.w(!1)}D(S,u){this.F(S,u)?(this.P(`reusing an existing recursive watcher to monitor ${S.path}`),this.m.delete(S.correlationId)):(this.G(S,u),this.m.add(S.correlationId))}F(S,u){const P=this.O?.subscribe(S.path,(w,a)=>{u.isDisposed||(w?this.D(S,u):a?.type===L.FileChangeType.ADDED&&this.H(S))});return P?(u.add(P),!0):!1}G(S,u){let P=!1;const w=(a,m)=>{if(u.isDisposed)return;const $=this.I(a),f=this.I(m),i=P;P=$,!$&&(f||i)&&this.H(S)};this.P(`starting fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.watchFile)(S.path,{persistent:!1,interval:this.r},w)}catch(a){this.Q(`fs.watchFile() failed with error ${a} on path ${S.path} (correlationId: ${S.correlationId})`)}u.add((0,h.$Sc)(()=>{this.P(`stopping fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.unwatchFile)(S.path,w)}catch(a){this.Q(`fs.unwatchFile() failed with error ${a} on path ${S.path} (correlationId: ${S.correlationId})`)}}))}H(S){this.P(`detected ${S.path} exists again, resuming watcher (correlationId: ${S.correlationId})`);const u={resource:T.URI.file(S.path),type:L.FileChangeType.ADDED,cId:S.correlationId};this.a.fire([u]),this.J(u,S),this.C(S)}I(S){return S.ctimeMs===0&&S.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(S,u){if(this.R){const P=` >> normalized ${S.type===L.FileChangeType.ADDED?"[ADDED]":S.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`;this.L(P,u)}}L(S,u){this.R&&this.P(`${S}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(S){return`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, filter: ${(0,C.$ar)(S.filter)}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`}async setVerboseLogging(S){this.R=S}}e.$jr=c}),define(ke[221],Ie([1,0,44,7,20,31,3,81,16,10,22,2,108,33,27,69]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0,e.$pr=$;class m extends L.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,s,t,o,n,d){super(),this.s=i,this.t=s,this.u=t,this.w=o,this.y=n,this.z=d,this.c=this.B(new h.$Th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.u(l))),this.f=this.B(new h.$Sh(l=>this.M(l),m.b)),this.g=(0,a.$$q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$$q)(this.s.path,this.s.includes):void 0,this.j=(0,a.$3q)(this.s)?this.s.filter:void 0,this.m=new C.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const s=await r.promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,s.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let s=i.path;try{s=await P.Promises.realpath(i.path),i.path===s&&(s=await(0,u.$lr)(i.path,this.m.token)??i.path),i.path!==s&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${s})`)}catch{}return s}async G(i,s){const t=new L.$Tc;return this.H(i,s,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,s,t)),t}H(i,s,t){if(s)return!1;const o=S.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(d,l)=>{if(!t.isDisposed)if(d){const g=await this.G(i,s);t.isDisposed?g.dispose():t.add(g)}else l&&(typeof l.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:l.type,cId:this.s.correlationId},!0)});return n?(t.add(n),!0):!1}async I(i,s,t){if(c.$k&&(0,R.$Dg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new C.$we(this.m.token);t.add((0,L.$Sc)(()=>o.dispose(!0)));const n=new L.$Tc;t.add(n);try{const d=S.URI.file(this.s.path),l=(0,b.$nc)(i),g=(0,r.watch)(i);n.add((0,L.$Sc)(()=>{g.removeAllListeners(),g.close()})),this.Q(`Started watching: '${i}'`);const E=new Set;if(s)try{for(const y of await P.Promises.readdir(i))E.add(y)}catch(y){this.O(y)}if(o.token.isCancellationRequested)return;const D=new Map;n.add((0,L.$Sc)(()=>{for(const[,y]of D)y.dispose();D.clear()})),g.on("error",(y,k)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${y}, ${k})`),this.D())}),g.on("change",(y,k)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${k}`);let A="";if(k&&(A=k.toString(),c.$k&&(A=(0,T.$mm)(A))),!(!A||y!=="change"&&y!=="rename"))if(s)if(y==="rename"){D.get(A)?.dispose();const p=setTimeout(async()=>{if(D.delete(A),A===l&&!await P.Promises.exists(i)){this.J(d);return}if(o.token.isCancellationRequested)return;const v=await this.N((0,b.$jc)(i,A));if(o.token.isCancellationRequested)return;let F;v?E.has(A)?F=w.FileChangeType.UPDATED:(F=w.FileChangeType.ADDED,E.add(A)):(E.delete(A),F=w.FileChangeType.DELETED),this.L({resource:(0,I.$fh)(d,A),type:F,cId:this.s.correlationId})},m.a);D.set(A,(0,L.$Sc)(()=>clearTimeout(p)))}else{let p;E.has(A)?p=w.FileChangeType.UPDATED:(p=w.FileChangeType.ADDED,E.add(A)),this.L({resource:(0,I.$fh)(d,A),type:p,cId:this.s.correlationId})}else if(y==="rename"||A!==l){const p=setTimeout(async()=>{const v=await P.Promises.exists(i);o.token.isCancellationRequested||(v?(this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(i,!1))):this.J(d))},m.a);n.clear(),n.add((0,L.$Sc)(()=>clearTimeout(p)))}else this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){o.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${d.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:w.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,s=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===w.FileChangeType.ADDED?"[ADDED]":i.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!s&&this.g.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const s=(0,a.$9q)(i),t=[];for(const n of s){if((0,a.$_q)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.z)for(const n of t)this.R(` >> normalized ${n.type===w.FileChangeType.ADDED?"[ADDED]":n.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(c.$l)return P.Promises.exists(i);try{const s=(0,b.$nc)(i);return(await P.Promises.readdir((0,b.$mc)(i))).some(o=>o===s)}catch(s){return this.Q(s),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$or=m;async function $(f,i,s,t,o=512){const n=await P.Promises.open(f,"r"),d=Buffer.allocUnsafe(o),l=new C.$we(t);let g,E=!1;const D={path:f,excludes:[],recursive:!1},y=new m(D,void 0,k=>{(async()=>{for(const{type:A}of k)if(A===w.FileChangeType.UPDATED){if(E)return;E=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:p}=await P.Promises.read(n,d,0,o,null);if(!p||l.token.isCancellationRequested)break;i(d.slice(0,p))}}catch(p){g=new Error(p),l.dispose(!0)}finally{E=!1}}})()});return await y.ready,s(),new Promise((k,A)=>{l.token.onCancellationRequested(async()=>{y.dispose();try{await P.Promises.close(n)}catch(p){g=new Error(p)}g?A(g):k()})})}}),define(ke[222],Ie([1,0,4,38,220,10,221,31]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class b extends C.$jr{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const S=[],u=new Set(Array.from(this.watchers));for(const P of I){const w=this.W(P);w&&(0,h.$Dk)(w.request.excludes,P.excludes)&&(0,h.$Dk)(w.request.includes,P.includes)?u.delete(w):S.push(P)}S.length&&this.P(`Request to start watching: ${S.map(P=>this.M(P)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(P=>this.M(P.request)).join(",")}`);for(const P of u)this.Y(P);for(const P of S)this.X(P)}W(I){for(const S of this.watchers)if(typeof I.correlationId=="number"||typeof S.request.correlationId=="number"){if(S.request.correlationId===I.correlationId)return S}else if((0,T.$Cg)(S.request.path,I.path,!R.$l))return S}X(I){const S=new L.$or(I,this.O,P=>this.a.fire(P),()=>this.c.fire(I),P=>this.b.fire(P),this.R),u={request:I,instance:S};this.watchers.add(u)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const S=new Map;for(const u of I){const P=R.$l?u.path:u.path.toLowerCase();let w=S.get(u.correlationId);w||(w=new Map,S.set(u.correlationId,w)),w.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),w.set(P,u)}return Array.from(S.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const S of this.watchers)S.instance.setVerboseLogging(I)}P(I,S){this.R&&this.b.fire({type:"trace",message:this.bb(I,S)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,S){return S?`[File Watcher (node.js)] ${I} (${this.M(S.request)})`:`[File Watcher (node.js)] ${I}`}}e.$qr=b}),define(ke[223],Ie([1,0,69,222]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class C extends r.$6q{constructor(L,T,b){super(L,T,b),this.s()}r(L){return L.add(new h.$qr(void 0))}}e.$rr=C}),define(ke[224],Ie([1,0,14,86,192,69]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class L extends R.$7q{constructor(b,c,I){super(b,c,I),this.s()}r(b){const c=b.add(new C.$hr(r.$Yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(c.onDidProcessExit(({code:I,signal:S})=>this.t(`terminated by itself with code ${I}, signal: ${S} (ETERM)`))),h.ProxyChannel.toService((0,h.$li)(c.getChannel("watcher")))}}e.$ir=L}),define(ke[114],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class r{constructor(...C){this.a=new Map;for(const[R,L]of C)this.set(R,L)}set(C,R){const L=this.a.get(C);return this.a.set(C,R),L}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Ci=r}),define(ke[225],Ie([1,0,7,13,3,112,214,5,114,80]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;const I=!1;class S extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class u{constructor(m=new b.$Ci,$=!1,f,i=I){this.i=m,this.j=$,this.k=f,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Di,this),this._globalGraph=i?f?._globalGraph??new L.$ur(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Pc)(this.h),this.h.clear();for(const m of this.g)(0,C.$Oc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,$){this.m();const f=this,i=new class extends u{dispose(){f.h.delete(i),super.dispose()}}(m,this.j,this,this.l);return this.h.add(i),$?.add(i),i}invokeFunction(m,...$){this.m();const f=w.traceInvocation(this.l,m);let i=!1;try{return m({get:t=>{if(i)throw(0,h.$7)("service accessor is only valid during the invocation of its target method");const o=this.s(t,f);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...$)}finally{i=!0,f.stop()}}createInstance(m,...$){this.m();let f,i;return m instanceof R.$Bi?(f=w.traceCreation(this.l,m.ctor),i=this.o(m.ctor,m.staticArguments.concat($),f)):(f=w.traceCreation(this.l,m),i=this.o(m,$,f)),f.stop(),i}o(m,$=[],f){const i=T._util.getServiceDependencies(m).sort((o,n)=>o.index-n.index),s=[];for(const o of i){const n=this.s(o.id,f);n||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${o.id}.`,!1),s.push(n)}const t=i.length>0?i[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${$.length} static arguments`);const o=t-$.length;o>0?$=$.concat(new Array(o)):$=$.slice(0,t)}return Reflect.construct(m,$.concat(s))}q(m,$){if(this.i.get(m)instanceof R.$Bi)this.i.set(m,$);else if(this.k)this.k.q(m,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const $=this.i.get(m);return!$&&this.k?this.k.r(m):$}s(m,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const f=this.r(m);return f instanceof R.$Bi?this.u(m,f,$.branch(m,!0)):($.branch(m,!1),f)}u(m,$,f){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,$,f)}finally{this.t.delete(m)}}v(m,$,f){const i=new L.$ur(n=>n.id.toString());let s=0;const t=[{id:m,desc:$,_trace:f}],o=new Set;for(;t.length;){const n=t.pop();if(!o.has(String(n.id))){if(o.add(String(n.id)),i.lookupOrInsertNode(n),s++>1e3)throw new S(i);for(const d of T._util.getServiceDependencies(n.desc.ctor)){const l=this.r(d.id);if(l||this.y(`[createInstance] ${m} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(d.id)),l instanceof R.$Bi){const g={id:d.id,desc:l,_trace:n._trace.branch(d.id,!0)};i.insertEdge(n,g),t.push(g)}}}}for(;;){const n=i.roots();if(n.length===0){if(!i.isEmpty())throw new S(i);break}for(const{data:d}of n){if(this.r(d.id)instanceof R.$Bi){const g=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,g)}i.removeNode(d)}}return this.r(m)}w(m,$,f=[],i,s){if(this.i.get(m)instanceof R.$Bi)return this.x(m,$,f,i,s,this.g);if(this.k)return this.k.w(m,$,f,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(m,$,f=[],i,s,t){if(i){const o=new u(void 0,this.j,this,this.l);o.c=String(m);const n=new Map,d=new r.$Xh(()=>{const l=o.o($,f,s);for(const[g,E]of n){const D=l[g];if(typeof D=="function")for(const y of E)y.disposable=D.apply(l,y.listener)}return n.clear(),t.add(l),l});return new Proxy(Object.create(null),{get(l,g){if(!d.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let y=n.get(g);return y||(y=new c.$5c,n.set(g,y)),(A,p,v)=>{if(d.isInitialized)return d.value[g](A,p,v);{const F={listener:[A,p,v],disposable:void 0},N=y.push(F);return(0,C.$Sc)(()=>{N(),F.disposable?.dispose()})}}}if(g in l)return l[g];const E=d.value;let D=E[g];return typeof D!="function"||(D=D.bind(E),l[g]=D),D},set(l,g,E){return d.value[g]=E,!0},getPrototypeOf(l){return $.prototype}})}else{const o=this.o($,f,s);return t.add(o),o}}y(m,$){if($&&console.warn(m),this.j)throw new Error(m)}}e.$vr=u;var P;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(P||(P={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,$){return m?new w(P.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(m,$){return m?new w(P.Creation,$.name):w.c}static{this.f=0}constructor(m,$){this.type=m,this.name=$,this.g=Date.now(),this.h=[]}branch(m,$){const f=new w(P.Branch,m.toString());return this.h.push([m,$,f]),f}stop(){const m=Date.now()-this.g;w.f+=m;let $=!1;function f(s,t){const o=[],n=new Array(s+1).join("	");for(const[d,l,g]of t.h)if(l&&g){$=!0,o.push(`${n}CREATES -> ${d}`);const E=f(s+1,g);E&&o.push(E)}else o.push(`${n}uses -> ${d}`);return o.join(`
`)}const i=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(m>2||$)&&w.all.add(i.join(`
`))}}e.$wr=w}),define(ke[11],Ie([1,0,8,52,4,60,3,28,10,22,17,2,35,5]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=a,e.log=$,e.$nk=D,e.$ok=y,e.$pk=k,e.$qk=A,r=qe(r),e.$_j=(0,P.$Ei)("logService"),e.$ak=(0,P.$Ei)("loggerService");function w(){return new Date().toISOString()}function a(p){return(0,I.$ig)(p)}var m;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$ck=m.Info;function $(p,v,F){switch(v){case m.Trace:p.trace(F);break;case m.Debug:p.debug(F);break;case m.Info:p.info(F);break;case m.Warning:p.warn(F);break;case m.Error:p.error(F);break;case m.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function f(p,v=!1){let F="";for(let N=0;N<p.length;N++){let O=p[N];if(O instanceof Error&&(O=(0,h.$pj)(O,v)),typeof O=="object")try{O=JSON.stringify(O)}catch{}F+=(N>0?" ":"")+O}return F}class i extends L.$Uc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new C.$le),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==m.Off&&this.b<=v}}e.$ek=i;class s extends i{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...F){this.f(m.Trace)&&this.g(m.Trace,f([v,...F],!0))}debug(v,...F){this.f(m.Debug)&&this.g(m.Debug,f([v,...F]))}info(v,...F){this.f(m.Info)&&this.g(m.Info,f([v,...F]))}warn(v,...F){this.f(m.Warning)&&this.g(m.Warning,f([v,...F]))}error(v,...F){if(this.f(m.Error))if(v instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=v.stack,this.g(m.Error,f(N))}else this.g(m.Error,f([v,...F]))}flush(){}}e.$fk=s;class t extends i{constructor(v=e.$ck){super(),this.setLevel(v),this.g=!b.$j}trace(v,...F){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,v,...F):console.warn(`[main ${w()}]`,v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,v,...F):console.error(`[main ${w()}]`,v,...F))}flush(){}}e.$gk=t;class o extends i{constructor(v=e.$ck,F=!0){super(),this.g=F,this.setLevel(v)}trace(v,...F){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...F):console.log(v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...F):console.log(v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...F):console.log(v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...F):console.log(v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...F):console.error(v,...F))}flush(){}}e.$hk=o;class n extends i{constructor(v,F=e.$ck){super(),this.g=v,this.setLevel(F)}trace(v,...F){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(v),...F])}debug(v,...F){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(v),...F])}info(v,...F){this.f(m.Info)&&this.g.log(m.Info,[this.h(v),...F])}warn(v,...F){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(v),...F])}error(v,...F){this.f(m.Error)&&this.g.log(m.Error,[this.h(v),...F])}h(v){return typeof v=="string"?v:(0,h.$pj)(v,this.f(m.Trace))}flush(){}}e.$ik=n;class d extends i{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const F of this.g)F.setLevel(v);super.setLevel(v)}trace(v,...F){for(const N of this.g)N.trace(v,...F)}debug(v,...F){for(const N of this.g)N.debug(v,...F)}info(v,...F){for(const N of this.g)N.info(v,...F)}warn(v,...F){for(const N of this.g)N.warn(v,...F)}error(v,...F){for(const N of this.g)N.error(v,...F)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$jk=d;class l extends L.$Uc{constructor(v,F,N){if(super(),this.h=v,this.j=F,this.b=new T.$Ac,this.c=this.B(new C.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$le),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(v){return(0,I.$eg)(v)?[...this.b.values()].find(F=>F.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,F){const N=this.n(v),O=(0,I.$eg)(v)?v:F?.id??(0,R.$sj)(N.toString()).toString(16);let j=this.b.get(N)?.logger;const z=F?.logLevel==="always"?m.Trace:F?.logLevel;j||(j=this.s(N,z??this.getLogLevel(N)??this.h,{...F,id:O}));const M={logger:j,info:{resource:N,id:O,logLevel:z,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(M.info),this.b.set(N,M),j}n(v){return(0,I.$eg)(v)?(0,c.$fh)(this.j,`${v}.log`):v}setLogLevel(v,F){if(S.URI.isUri(v)){const N=v,O=F,j=this.b.get(N);j&&O!==j.info.logLevel&&(j.info.logLevel=O===this.h?void 0:O,j.logger?.setLevel(O),this.b.set(j.info.resource,j),this.f.fire([N,O]))}else{this.h=v;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,F){const N=this.m(v);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,F]))}getLogLevel(v){let F;return v&&(F=this.b.get(v)?.info.logLevel),F??this.h}registerLogger(v){const F=this.b.get(v.resource);F?F.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const F=this.b.get(v);F&&(F.logger&&F.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=l;class g{constructor(){this.onDidChangeLogLevel=new C.$le().event}setLevel(v){}getLevel(){return m.Info}trace(v,...F){}debug(v,...F){}info(v,...F){}warn(v,...F){}error(v,...F){}critical(v,...F){}dispose(){}flush(){}}e.$lk=g;class E extends g{}e.$mk=E;function D(p){if(p.verbose)return m.Trace;if(typeof p.logLevel=="string"){const v=A(p.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ck}function y(p){switch(p){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function k(p){switch(p){case m.Trace:return{original:"Trace",value:r.localize(11271,null)};case m.Debug:return{original:"Debug",value:r.localize(11272,null)};case m.Info:return{original:"Info",value:r.localize(11273,null)};case m.Warning:return{original:"Warning",value:r.localize(11274,null)};case m.Error:return{original:"Error",value:r.localize(11275,null)};case m.Off:return{original:"Off",value:r.localize(11276,null)}}}function A(p){switch(p){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$rk=new u.$Vj("logLevel",y(m.Info))}),define(ke[226],Ie([1,0,18,7,13,4,31,3,16,69,11]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class S extends T.$Uc{constructor(P,w){super(),this.a=P,this.b=w,this.c=this.B(new R.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Ch(0)),this.w=[],this.y=this.B(new h.$Ch(0))}watch(P,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(P,w):this.z(P,w)}n(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Sb)(this.j,a);return this.r(),(0,T.$Sc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,C.$Y)(P))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,c.$8q)(w)),w=>this.G(w),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const w of this.j)(0,c.$4q)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const w of this.j)(0,c.$4q)(w)&&P.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Sb)(this.w,a);return this.C(),(0,T.$Sc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,C.$Y)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,c.$8q)(P)),P=>this.G(P),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,b.$hc)(P.fsPath)}J(P){const w=this.I(P);return(0,L.$Gg)(w)}}e.$br=S}),define(ke[227],Ie([1,0,44,7,28,21,4,31,3,16,10,22,105,33,8,27,219,226,224,223]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class s extends $.$br{static{this.L=!1}constructor(o,n){super(o,n),this.onDidChangeCapabilities=L.Event.None,this.P=new C.$Ac(d=>S.$9g.getComparisonKey(d)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(o){try{const{stat:n,symbolicLink:d}=await P.SymlinkSupport.stat(this.I(o));return{type:this.O(n,d),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:a.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const n=await P.Promises.readdir(this.I(o),{withFileTypes:!0}),d=[];return await Promise.all(n.map(async l=>{try{let g;l.isSymbolicLink()?g=(await this.stat((0,S.$fh)(o,l.name))).type:g=this.O(l),d.push([l.name,g])}catch(g){this.a.trace(g)}})),d}catch(n){throw this.hb(n)}}O(o,n){let d;return n?.dangling?d=a.FileType.Unknown:o.isFile()?d=a.FileType.File:o.isDirectory()?d=a.FileType.Directory:d=a.FileType.Unknown,n&&(d|=a.FileType.SymbolicLink),d}async Q(o){const n=this.I(o);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let d;for(;d=this.P.get(o);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await d.wait();const l=new h.$Dh;return this.P.set(o,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(o)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(o)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(o,n){let d;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(o)})`),d=await this.Q(o));const l=this.I(o);return await r.promises.readFile(l)}catch(l){throw this.hb(l)}finally{d?.dispose()}}R(o){s.L&&this.a.trace(o)}readFileStream(o,n,d){const l=(0,u.$Be)(g=>R.$Ne.concat(g.map(E=>R.$Ne.wrap(E))).buffer);return(0,m.$1q)(this,o,l,g=>g.buffer,{...n,bufferSize:256*1024},d),l}async writeFile(o,n,d){return d?.atomic!==!1&&d?.atomic?.postfix&&await this.S(o)?this.U(o,(0,S.$fh)((0,S.$eh)(o),`${(0,S.$ch)(o)}${d.atomic.postfix}`),n,d):this.W(o,n,d)}async S(o){try{const n=this.I(o),{symbolicLink:d}=await P.SymlinkSupport.stat(n);if(d)return!1}catch{}return!0}async U(o,n,d,l){const g=new b.$Tc;try{g.add(await this.Q(o)),g.add(await this.Q(n)),await this.W(n,d,l,!0);try{await this.rename(n,o,{overwrite:!0})}catch(E){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{g.dispose()}}async W(o,n,d,l){let g;try{const E=this.I(o);if(!d.create||!d.overwrite){if(await P.Promises.exists(E)){if(!d.overwrite)throw(0,a.$ml)((0,w.localize)(11328,null),a.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,a.$ml)((0,w.localize)(11329,null),a.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(o,{create:!0,unlock:d.unlock},l),await this.write(g,0,n,0,n.byteLength)}catch(E){throw await this.ib(o,E)}finally{typeof g=="number"&&await this.close(g)}}static{this.$=!0}static configureFlushOnWrite(o){s.$=o}async open(o,n,d){const l=this.I(o);let g;(0,a.$al)(n)&&!d&&(g=await this.Q(o));let E;try{if((0,a.$al)(n)&&n.unlock)try{const{stat:y}=await P.SymlinkSupport.stat(l);y.mode&128||await r.promises.chmod(l,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let D;if((0,a.$al)(n)){if(I.$j)try{await r.promises.truncate(l,0),D="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}D||(D="w")}else D="r";E=await P.Promises.open(l,D)}catch(D){throw g?.dispose(),(0,a.$al)(n)?await this.ib(o,D):this.hb(D)}if(this.X.set(E,0),(0,a.$al)(n)&&this.Z.set(E,o),g){const D=this.Y.get(E);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${l})`),this.Y.set(E,g),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${l})`),D.dispose())}return E}async close(o){const n=this.Y.get(o);try{if(this.X.delete(o),this.Z.delete(o)&&s.$)try{await P.Promises.fdatasync(o)}catch(d){s.configureFlushOnWrite(!1),this.a.error(d)}return await P.Promises.close(o)}catch(d){throw this.hb(d)}finally{n&&(this.Y.get(o)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.Y.delete(o)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),n.dispose())}}async read(o,n,d,l,g){const E=this.ab(o,n);let D=null;try{D=(await P.Promises.read(o,d,l,g,E)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(o,E,D)}return D}ab(o,n){return n===this.X.get(o)?null:n}bb(o,n,d){const l=this.X.get(o);typeof l=="number"&&(typeof n=="number"||(typeof d=="number"?this.X.set(o,l+d):this.X.delete(o)))}async write(o,n,d,l,g){return(0,h.$Yh)(()=>this.cb(o,n,d,l,g),100,3)}async cb(o,n,d,l,g){const E=this.ab(o,n);let D=null;try{D=(await P.Promises.write(o,d,l,g,E)).bytesWritten}catch(y){throw await this.ib(this.Z.get(o),y)}finally{this.bb(o,E,D)}return D}async mkdir(o){try{await r.promises.mkdir(this.I(o))}catch(n){throw this.hb(n)}}async delete(o,n){try{const d=this.I(o);if(n.recursive){let l;n?.atomic!==!1&&n.atomic.postfix&&(l=(0,c.$jc)((0,c.$mc)(d),`${(0,c.$nc)(d)}${n.atomic.postfix}`)),await P.Promises.rm(d,P.RimRafMode.MOVE,l)}else try{await r.promises.unlink(d)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let g=!1;try{const{stat:E,symbolicLink:D}=await P.SymlinkSupport.stat(d);g=E.isDirectory()&&!D}catch{}if(g)await r.promises.rmdir(d);else throw l}else throw l}}catch(d){throw this.hb(d)}}async rename(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"move",d.overwrite),await P.Promises.rename(l,g)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(11330,null,(0,c.$nc)(l),(0,c.$nc)((0,c.$mc)(g)),E.toString()))),this.hb(E)}}async copy(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"copy",d.overwrite),await P.Promises.copy(l,g,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(11331,null,(0,c.$nc)(l),(0,c.$nc)((0,c.$mc)(g)),E.toString()))),this.hb(E)}}async db(o,n,d,l){const g=this.I(o),E=this.I(n);let D=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(D=(0,T.$Cg)(g,E,!0)),D){if(d==="copy")throw(0,a.$ml)((0,w.localize)(11332,null),a.FileSystemProviderErrorCode.FileExists);if(d==="move")return}const k=await this.N(o);if(!k)throw(0,a.$ml)((0,w.localize)(11333,null),a.FileSystemProviderErrorCode.FileNotFound);const A=await this.N(n);if(A){if(!l)throw(0,a.$ml)((0,w.localize)(11334,null),a.FileSystemProviderErrorCode.FileExists);k.type&a.FileType.File&&A.type&a.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,n){return this.eb(o,n,!1)}async eb(o,n,d){const l=this.I(o),g=this.I(n),E=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Cg)(l,g,!E))return;const D=new b.$Tc;try{D.add(await this.Q(o)),D.add(await this.Q(n)),d&&await r.promises.mkdir((0,c.$mc)(g),{recursive:!0}),await r.promises.copyFile(l,g)}catch(y){if(y.code==="ENOENT"&&!d)return this.eb(o,n,!0);throw this.hb(y)}finally{D.dispose()}}t(o,n,d){return new f.$ir(l=>o(l),l=>n(l),d)}F(o,n,d){return new i.$rr(l=>o(l),l=>n(l),d)}hb(o){if(o instanceof a.$ll)return o;let n=o,d;switch(o.code){case"ENOENT":d=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,d=a.FileSystemProviderErrorCode.Unknown;break;default:d=a.FileSystemProviderErrorCode.Unknown}return(0,a.$ml)(n,d)}async ib(o,n){let d=this.hb(n);if(o&&d.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await P.SymlinkSupport.stat(this.I(o));l.mode&128||(d=(0,a.$ml)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return d}}e.$sr=s}),define(ke[228],Ie([1,0,3,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=void 0;class C extends r.$Uc{constructor(L,T=[]){super(),this.a=new h.$jk([L,...T]),this.B(L.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...T){this.a.trace(L,...T)}debug(L,...T){this.a.debug(L,...T)}info(L,...T){this.a.info(L,...T)}warn(L,...T){this.a.warn(L,...T)}error(L,...T){this.a.error(L,...T)}flush(){this.a.flush()}}e.$HR=C}),define(ke[229],Ie([1,0,27,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wR=void 0;var C;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(C||(C={}));async function R(c,I,S,u,P){try{const w=await new Promise((m,$)=>{$e(["@vscode/spdlog"],m,$)}).then(qe);w.setFlushOn(C.Trace);const a=await w.createAsyncRotatingLogger(c,I,S,u);return P?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(w){console.error(w)}return null}function L(c,I,S){switch(I){case h.LogLevel.Trace:c.trace(S);break;case h.LogLevel.Debug:c.debug(S);break;case h.LogLevel.Info:c.info(S);break;case h.LogLevel.Warning:c.warn(S);break;case h.LogLevel.Error:c.error(S);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function T(c,I){switch(I){case h.LogLevel.Trace:c.setLevel(C.Trace);break;case h.LogLevel.Debug:c.setLevel(C.Debug);break;case h.LogLevel.Info:c.setLevel(C.Info);break;case h.LogLevel.Warning:c.setLevel(C.Warning);break;case h.LogLevel.Error:c.setLevel(C.Error);break;case h.LogLevel.Off:c.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class b extends h.$fk{constructor(I,S,u,P,w){super(),this.m=[],this.setLevel(w),this.n=this.s(I,S,u,P),this.B(this.onDidChangeLogLevel(a=>{this.r&&T(this.r,a)}))}async s(I,S,u,P){const w=u?6:1,a=30/w*r.$Hl.MB,m=await R(I,S,a,w,P);if(m){this.r=m,T(this.r,this.getLevel());for(const{level:$,message:f}of this.m)L(this.r,$,f);this.m=[]}}g(I,S){this.r?L(this.r,I,S):this.getLevel()<=I&&this.m.push({level:I,message:S})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$wR=b});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[145],Ie([1,0,43,8,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=Ut(r);var R;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(b){function c(w,a){return a-w}b.compare=c;const I=Object.create(null);I[b.Error]=(0,h.localize)(11268,null),I[b.Warning]=(0,h.localize)(11269,null),I[b.Info]=(0,h.localize)(11270,null);function S(w){return I[w]||""}b.toString=S;function u(w){switch(w){case r.default.Error:return b.Error;case r.default.Warning:return b.Warning;case r.default.Info:return b.Info;case r.default.Ignore:return b.Hint}}b.fromSeverity=u;function P(w){switch(w){case b.Error:return r.default.Error;case b.Warning:return r.default.Warning;case b.Info:return r.default.Info;case b.Hint:return r.default.Ignore}}b.toSeverity=P}(L||(e.MarkerSeverity=L={}));var T;(function(b){const c="";function I(u){return S(u,!0)}b.makeKey=I;function S(u,P){const w=[c];return u.source?w.push(u.source.replace("\xA6","\\\xA6")):w.push(c),u.code?typeof u.code=="string"?w.push(u.code.replace("\xA6","\\\xA6")):w.push(u.code.value.replace("\xA6","\\\xA6")):w.push(c),u.severity!==void 0&&u.severity!==null?w.push(L.toString(u.severity)):w.push(c),u.message&&P?w.push(u.message.replace("\xA6","\\\xA6")):w.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?w.push(u.startLineNumber.toString()):w.push(c),u.startColumn!==void 0&&u.startColumn!==null?w.push(u.startColumn.toString()):w.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?w.push(u.endLineNumber.toString()):w.push(c),u.endColumn!==void 0&&u.endColumn!==null?w.push(u.endColumn.toString()):w.push(c),w.push(c),w.join("\xA6")}b.makeKeyOptionalMessage=S})(T||(e.IMarkerData=T={})),e.$Fu=(0,C.$Ei)("markerService")});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[230],Ie([1,0,4,43,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$uw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$sw=e.Severity=void 0,e.$tw=T,h=Ut(h),e.Severity=h.default,e.$sw=(0,C.$Ei)("notificationService");var R;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function T(S){if(S){const u=S;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var b;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(b||(e.NotificationsFilter=b={}));class c{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$uw=c;class I{infinite(){}done(){}total(u){}worked(u){}}e.$vw=I}),define(ke[231],Ie([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const R=C.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(ke[115],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,r.$Ei)("productService"),e.$tk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function($e,e){return function(r,h){e(r,h,$e)}};define(ke[89],Ie([1,0,7,20,3,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.ProgressLocation=e.$ww=void 0,e.$ww=(0,R.$Ei)("progressService");var L;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$xw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$yw=T;class b{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const P=this.d;this.d=()=>{P?.(),u()}}):Promise.resolve()}}e.$zw=b;let c=class extends C.$Uc{constructor(u,P){super(),this.a=new r.$2h,P.withProgress(u,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,C.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Aw=c,e.$Aw=c=Je([Ve(1,e.$ww)],c);class I extends C.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new C.$Tc)}start(u){this.stop();const P=++this.a,w=new h.$we;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,C.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Sc)(()=>w.cancel())),this.b.add((0,C.$Sc)(()=>this.c?this.c.done():void 0)),{id:P,token:w.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Bw=I,e.$Cw=(0,R.$Ei)("editorProgressService")}),define(ke[36],Ie([1,0,65,17]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,r=qe(r),h=qe(h);class C{constructor(){this.a=new Map}add(L,T){r.ok(h.$eg(L)),r.ok(h.$gg(T)),r.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,T)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$qo=new C}),define(ke[116],Ie([1,0,4,177,36]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,C=qe(C),e.$ro={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class L{constructor(){this.b=new r.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,I){this.a[R(c)]=I,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const I=this.a[c];return I?(0,h.$7j)(I):void 0}hasSchemaContent(c){return!!this.a[c]}}const T=new L;C.$qo.add(e.$ro.JSONContribution,T)}),define(ke[70],Ie([1,0,18,4,17,8,45,116,36]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=a,e.$Ho=m,e.$Io=$,e.$Jo=i,e.$Ko=s,e.$Lo=t,e.$Mo=o,C=qe(C),R=qe(R);var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$vo={Configuration:"base.contributions.configuration"};var I;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const S=b.$qo.as(T.$ro.JSONContribution);class u{constructor(){this.a=[],this.i=new Set,this.j=new h.$le,this.onDidSchemaChange=this.j.event,this.k=new h.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:R.localize(11564,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},S.registerSchema(e.$Co,this.h),this.z()}registerConfiguration(d,l=!0){this.registerConfigurations([d],l)}registerConfigurations(d,l=!0){const g=new Set;this.r(d,l,g),S.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:g})}deregisterConfigurations(d){const l=new Set;this.s(d,l),S.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:l})}updateConfigurations({add:d,remove:l}){const g=new Set;this.s(l,g),this.r(d,!1,g),S.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:g})}registerDefaultConfigurations(d){const l=new Set;this.l(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}l(d,l){this.a.push(...d);const g=[];for(const{overrides:E,source:D}of d)for(const y in E){l.add(y);const k=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),A=E[y];if(k.configurationDefaultOverrides.push({value:A,source:D}),e.$Fo.test(y)){const p=this.o(y,A,D,k.configurationDefaultOverrideValue);if(!p)continue;k.configurationDefaultOverrideValue=p,this.n(y,p,D),g.push(...a(y))}else{const p=this.p(y,A,D,k.configurationDefaultOverrideValue);if(!p)continue;k.configurationDefaultOverrideValue=p;const v=this.e[y];v&&(this.A(y,v),this.w(y,v))}}this.q(g)}deregisterDefaultConfigurations(d){const l=new Set;this.m(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}m(d,l){for(const g of d){const E=this.a.indexOf(g);E!==-1&&this.a.splice(E,1)}for(const{overrides:g,source:E}of d)for(const D in g){const y=this.b.get(D);if(!y)continue;const k=y.configurationDefaultOverrides.findIndex(A=>E?A.source?.id===E.id:A.value===g[D]);if(k!==-1){if(y.configurationDefaultOverrides.splice(k,1),y.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Fo.test(D)){let A;for(const p of y.configurationDefaultOverrides)A=this.o(D,p.value,p.source,A);A&&!C.$rg(A.value)?(y.configurationDefaultOverrideValue=A,this.n(D,A,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let A;for(const v of y.configurationDefaultOverrides)A=this.p(D,v.value,v.source,A);y.configurationDefaultOverrideValue=A;const p=this.e[D];p&&(this.A(D,p),this.w(D,p))}l.add(D)}}this.y()}n(d,l,g){const E={type:"object",default:l.value,description:R.localize(11565,null,(0,L.$ij)(d)),$ref:e.$Co,defaultDefaultValue:l.value,source:g,defaultValueSource:g};this.e[d]=E,this.c.properties[d]=E}o(d,l,g,E){const D=E?.value||{},y=E?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const k of Object.keys(l)){const A=l[k];if(C.$gg(A)&&(C.$lg(D[k])||C.$gg(D[k]))){if(D[k]={...D[k]??{},...A},g)for(const v in A)y.set(`${k}.${v}`,g)}else D[k]=A,g?y.set(k,g):y.delete(k)}return{value:D,source:y}}p(d,l,g,E){const D=this.e[d],y=E?.value??D?.defaultDefaultValue;let k=g;if(C.$gg(l)&&(D!==void 0&&D.type==="object"||D===void 0&&(C.$lg(y)||C.$gg(y)))){if(k=E?.source??new Map,!(k instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const p in l)g&&k.set(`${d}.${p}`,g);l={...C.$gg(y)?y:{},...l}}return{value:l,source:k}}deltaConfiguration(d){let l=!1;const g=new Set;d.removedDefaults&&(this.m(d.removedDefaults,g),l=!0),d.addedDefaults&&(this.l(d.addedDefaults,g),l=!0),d.removedConfigurations&&this.s(d.removedConfigurations,g),d.addedConfigurations&&this.r(d.addedConfigurations,!1,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...d){this.j.fire()}registerOverrideIdentifiers(d){this.q(d),this.j.fire()}q(d){for(const l of d)this.i.add(l);this.y()}r(d,l,g){d.forEach(E=>{this.u(E,l,E.extensionInfo,E.restrictedProperties,void 0,g),this.d.push(E),this.v(E)})}s(d,l){const g=E=>{if(E.properties)for(const D in E.properties){l.add(D);const y=this.e[D];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>g(D))};for(const E of d){g(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u(d,l=!0,g,E,D=I.WINDOW,y){D=C.$ng(d.scope)?D:d.scope;const k=d.properties;if(k)for(const p in k){const v=k[p];if(l&&i(p,v)){delete k[p];continue}if(v.source=g,v.defaultDefaultValue=k[p].default,this.A(p,v),e.$Fo.test(p)?v.scope=void 0:(v.scope=C.$ng(v.scope)?D:v.scope,v.restricted=C.$ng(v.restricted)?!!E?.includes(p):v.restricted),k[p].hasOwnProperty("included")&&!k[p].included){this.g[p]=k[p],delete k[p];continue}else this.e[p]=k[p],k[p].policy?.name&&this.f.set(k[p].policy.name,p);!k[p].deprecationMessage&&k[p].markdownDeprecationMessage&&(k[p].deprecationMessage=k[p].markdownDeprecationMessage),y.add(p)}const A=d.allOf;if(A)for(const p of A)this.u(p,l,g,E,D,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const d=new Map;for(const[l,g]of this.b)g.configurationDefaultOverrideValue&&d.set(l,g.configurationDefaultOverrideValue);return d}v(d){const l=g=>{const E=g.properties;if(E)for(const y in E)this.w(y,E[y]);g.allOf?.forEach(l)};l(d)}w(d,l){switch(e.$wo.properties[d]=l,l.scope){case I.APPLICATION:e.$xo.properties[d]=l;break;case I.MACHINE:e.$yo.properties[d]=l;break;case I.MACHINE_OVERRIDABLE:e.$zo.properties[d]=l;break;case I.WINDOW:e.$Ao.properties[d]=l;break;case I.RESOURCE:e.$Bo.properties[d]=l;break;case I.LANGUAGE_OVERRIDABLE:e.$Bo.properties[d]=l,this.h.properties[d]=l;break}}x(d,l){switch(delete e.$wo.properties[d],l.scope){case I.APPLICATION:delete e.$xo.properties[d];break;case I.MACHINE:delete e.$yo.properties[d];break;case I.MACHINE_OVERRIDABLE:delete e.$zo.properties[d];break;case I.WINDOW:delete e.$Ao.properties[d];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[d],delete this.h.properties[d];break}}y(){for(const d of this.i.values()){const l=`[${d}]`,g={type:"object",description:R.localize(11566,null),errorMessage:R.localize(11567,null),$ref:e.$Co};this.A(l,g),e.$wo.properties[l]=g,e.$xo.properties[l]=g,e.$yo.properties[l]=g,e.$zo.properties[l]=g,e.$Ao.properties[l]=g,e.$Bo.properties[l]=g}}z(){const d={type:"object",description:R.localize(11568,null),errorMessage:R.localize(11569,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=d,e.$xo.patternProperties[e.$Eo]=d,e.$yo.patternProperties[e.$Eo]=d,e.$zo.patternProperties[e.$Eo]=d,e.$Ao.patternProperties[e.$Eo]=d,e.$Bo.patternProperties[e.$Eo]=d,this.j.fire()}A(d,l){const g=this.b.get(d)?.configurationDefaultOverrideValue;let E,D;g&&(!l.disallowConfigurationDefault||!g.source)&&(E=g.value,D=g.source),C.$lg(E)&&(E=l.defaultDefaultValue,D=void 0),C.$lg(E)&&(E=$(l.type)),l.default=E,l.defaultValueSource=D}}const P="\\[([^\\]]+)\\]",w=new RegExp(P,"g");e.$Eo=`^(${P})+$`,e.$Fo=new RegExp(e.$Eo);function a(n){const d=[];if(e.$Fo.test(n)){let l=w.exec(n);for(;l?.length;){const g=l[1].trim();g&&d.push(g),l=w.exec(n)}}return(0,r.$Lb)(d)}function m(n){return n.reduce((d,l)=>`${d}[${l}]`,"")}function $(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new u;b.$qo.add(e.$vo.Configuration,f);function i(n,d){return n.trim()?e.$Fo.test(n)?R.localize(11571,null,n):f.getConfigurationProperties()[n]!==void 0?R.localize(11572,null,n):d.policy?.name&&f.getPolicyConfigurations().get(d.policy?.name)!==void 0?R.localize(11573,null,n,d.policy?.name,f.getPolicyConfigurations().get(d.policy?.name)):null:R.localize(11570,null)}function s(){const n=[],d=f.getConfigurationProperties();for(const l of Object.keys(d))n.push([l,d[l].scope]);return n.push(["launch",I.RESOURCE]),n.push(["task",I.RESOURCE]),n}function t(n){const d={};for(const l of n){const g=l.properties;if(C.$gg(g))for(const E in g)d[E]=g[E];l.allOf&&Object.assign(d,t(l.allOf))}return d}function o(n){switch(n){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(ke[232],Ie([1,0,18,4,176,3,28,24,17,2,45,70,27,36]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$Ro=s,r=qe(r),C=qe(C),T=qe(T),b=qe(b);function w(d){return Object.isFrozen(d)?d:T.$eo(d)}class a{static createEmptyModel(l){return new a({},[],[],void 0,l)}constructor(l,g,E,D,y){this.b=l,this.c=g,this.d=E,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(g=>{if(g instanceof a)return g;const E=new m("",this.f);return E.parseRaw(g),E.configurationModel});this.g=l.reduce((g,E)=>E===g?E:g.merge(E),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,I.$gj)(this.contents,l):this.contents}inspect(l,g){const E=this;return{get value(){return w(E.rawConfiguration.getValue(l))},get override(){return g?w(E.rawConfiguration.getOverrideValue(l,g)):void 0},get merged(){return w(g?E.rawConfiguration.override(g).getValue(l):E.rawConfiguration.getValue(l))},get overrides(){const D=[];for(const{contents:y,identifiers:k,keys:A}of E.rawConfiguration.overrides){const p=new a(y,A,[],void 0,E.f).getValue(l);p!==void 0&&D.push({identifiers:k,value:p})}return D.length?w(D):void 0}}}getOverrideValue(l,g){const E=this.j(g);return E?l?(0,I.$gj)(E,l):E:void 0}getKeysForOverrideIdentifier(l){const g=[];for(const E of this.overrides)E.identifiers.includes(l)&&g.push(...E.keys);return r.$Lb(g)}getAllOverrideIdentifiers(){const l=[];for(const g of this.overrides)l.push(...g.identifiers);return r.$Lb(l)}override(l){let g=this.a.get(l);return g||(g=this.h(l),this.a.set(l,g)),g}merge(...l){const g=T.$do(this.contents),E=T.$do(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const k of l)if(y.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(g,k.contents);for(const A of k.overrides){const[p]=E.filter(v=>r.$tb(v.identifiers,A.identifiers));p?(this.i(p.contents,A.contents),p.keys.push(...A.keys),p.keys=r.$Lb(p.keys)):E.push(T.$do(A))}for(const A of k.keys)D.indexOf(A)===-1&&D.push(A)}return new a(g,D,E,y.every(k=>k instanceof a)?void 0:y,this.f)}h(l){const g=this.j(l);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const E={};for(const D of r.$Lb([...Object.keys(this.contents),...Object.keys(g)])){let y=this.contents[D];const k=g[D];k&&(typeof y=="object"&&typeof k=="object"?(y=T.$do(y),this.i(y,k)):y=k),E[D]=y}return new a(E,this.keys,this.overrides,void 0,this.f)}i(l,g){for(const E of Object.keys(g)){if(E in l&&b.$gg(l[E])&&b.$gg(g[E])){this.i(l[E],g[E]);continue}l[E]=T.$do(g[E])}}j(l){let g=null,E=null;const D=y=>{y&&(E?this.i(E,y):E=T.$do(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===l?g=y.contents:y.identifiers.includes(l)&&D(y.contents);return D(g),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,g){this.k(l,g,!0)}setValue(l,g){this.k(l,g,!1)}removeValue(l){const g=this.keys.indexOf(l);g!==-1&&(this.keys.splice(g,1),(0,I.$fj)(this.contents,l),S.$Fo.test(l)&&this.overrides.splice(this.overrides.findIndex(E=>r.$tb(E.identifiers,(0,S.$Go)(l))),1))}k(l,g,E){if((0,I.$ej)(this.contents,l,g,D=>this.f.error(D)),E=E||this.keys.indexOf(l)===-1,E&&this.keys.push(l),S.$Fo.test(l)){const D=(0,S.$Go)(l),y={identifiers:D,keys:Object.keys(this.contents[l]),contents:(0,I.$dj)(this.contents[l],A=>this.f.error(A))},k=this.overrides.findIndex(A=>r.$tb(A.identifiers,D));k!==-1?this.overrides[k]=y:this.overrides.push(y)}}}e.$No=a;class m{constructor(l,g){this.f=l,this.g=g,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,g){if(!b.$ng(l)){const E=this.h(l);this.parseRaw(E,g)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,g){this.a=l;const{contents:E,keys:D,overrides:y,restricted:k,hasExcludedProperties:A}=this.i(l,g);this.b=new a(E,D,y,A?[l]:void 0,this.g),this.c=k||[]}h(l){let g={},E=null,D=[];const y=[],k=[];function A(v){Array.isArray(D)?D.push(v):E!==null&&(D[E]=v)}const p={onObjectBegin:()=>{const v={};A(v),y.push(D),D=v,E=null},onObjectProperty:v=>{E=v},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const v=[];A(v),y.push(D),D=v,E=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:A,onError:(v,F,N)=>{k.push({error:v,offset:F,length:N})}};if(l)try{C.$5n(l,p),g=D[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return g}i(l,g){const E=P.$qo.as(S.$vo.Configuration).getConfigurationProperties(),D=this.j(l,E,!0,g);l=D.raw;const y=(0,I.$dj)(l,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),k=Object.keys(l),A=this.l(l,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:y,keys:k,overrides:A,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(l,g,E,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:y};const k={},A=[];for(const p in l)if(S.$Fo.test(p)&&E){const v=this.j(l[p],g,!1,D);k[p]=v.raw,y=y||v.hasExcludedProperties,A.push(...v.restricted)}else{const v=g[p],F=v?typeof v.scope<"u"?v.scope:S.ConfigurationScope.WINDOW:void 0;v?.restricted&&A.push(p),!D.exclude?.includes(p)&&(D.include?.includes(p)||(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&v?.restricted))?k[p]=l[p]:y=!0}return{raw:k,restricted:A,hasExcludedProperties:y}}l(l,g){const E=[];for(const D of Object.keys(l))if(S.$Fo.test(D)){const y={};for(const k in l[D])y[k]=l[D][k];E.push({identifiers:(0,S.$Go)(D),keys:Object.keys(y),contents:(0,I.$dj)(y,g)})}return E}}e.$Oo=m;class $ extends R.$Uc{constructor(l,g,E,D,y){super(),this.c=l,this.f=g,this.g=D,this.h=y,this.b=this.B(new h.$le),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),y),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(u.FileOperation.CREATE)||k.isOperation(u.FileOperation.COPY)||k.isOperation(u.FileOperation.DELETE)||k.isOperation(u.FileOperation.WRITE))&&E.isEqual(k.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Po=$;class f{constructor(l,g,E,D,y,k,A,p,v,F,N,O,j){this.a=l,this.b=g,this.c=E,this.overrideIdentifiers=D,this.d=y,this.f=k,this.g=A,this.h=p,this.i=v,this.j=F,this.k=N,this.l=O,this.m=j}get value(){return w(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,g,E,D,y,k,A,p,v,F){this.j=l,this.l=g,this.m=E,this.n=D,this.p=y,this.q=k,this.r=A,this.s=p,this.t=v,this.u=F,this.h=null,this.i=new L.$Ac,this.v=null}getValue(l,g,E){return this.w(l,g,E).getValue(l)}updateValue(l,g,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=a.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,g===void 0?D.removeValue(l):D.setValue(l,g),E.resource||(this.h=null)}inspect(l,g,E){const D=this.w(l,g,E),y=this.A(g.resource,E),k=g.resource?this.t.get(g.resource)||this.s:this.s,A=new Set;for(const p of D.overrides)for(const v of p.identifiers)D.getOverrideValue(l,v)!==void 0&&A.add(v);return new f(l,g,D.getValue(l),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,y||void 0,k)}keys(l){const g=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,g){this.r.set(l,g),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,g){const E=[];if(!g){const{added:D,updated:y,removed:k}=o(this.j,l);g=[...D,...y,...k]}for(const D of g)for(const y of(0,S.$Go)(D)){const k=this.j.getKeysForOverrideIdentifier(y),A=l.getKeysForOverrideIdentifier(y),p=[...A.filter(v=>k.indexOf(v)===-1),...k.filter(v=>A.indexOf(v)===-1),...k.filter(v=>!T.$ho(this.j.override(y).getValue(v),l.override(y).getValue(v)))];E.push([y,p])}return this.updateDefaultConfiguration(l),{keys:g,overrides:E}}compareAndUpdatePolicyConfiguration(l){const{added:g,updated:E,removed:D}=o(this.l,l),y=[...g,...E,...D];return y.length&&this.updatePolicyConfiguration(l),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.applicationConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateApplicationConfiguration(l),{keys:k,overrides:y}}compareAndUpdateLocalUserConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.localUserConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateLocalUserConfiguration(l),{keys:k,overrides:y}}compareAndUpdateRemoteUserConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.remoteUserConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateRemoteUserConfiguration(l),{keys:k,overrides:y}}compareAndUpdateWorkspaceConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.workspaceConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateWorkspaceConfiguration(l),{keys:k,overrides:y}}compareAndUpdateFolderConfiguration(l,g){const E=this.folderConfigurations.get(l),{added:D,updated:y,removed:k,overrides:A}=o(E,g),p=[...D,...y,...k];return(p.length||!E)&&this.updateFolderConfiguration(l,g),{keys:p,overrides:A}}compareAndDeleteFolderConfiguration(l){const g=this.folderConfigurations.get(l);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:E,updated:D,removed:y,overrides:k}=o(g,void 0);return{keys:[...E,...D,...y],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,g,E){let D=this.x(g,E);return g.overrideIdentifier&&(D=D.override(g.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(D=D.merge(this.l)),D}x({resource:l},g){let E=this.y();if(g&&l){const D=g.getFolder(l);D&&(E=this.z(D.uri)||E);const y=this.t.get(l);y&&(E=E.merge(y))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let g=this.i.get(l);if(!g){const E=this.y(),D=this.r.get(l);D?(g=E.merge(D),this.i.set(l,g)):g=E}return g}A(l,g){if(g&&l){const E=g.getFolder(l);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,g)=>{const{contents:E,overrides:D,keys:y}=this.r.get(g);return l.push([g,{contents:E,overrides:D,keys:y}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(g=>l.add(g)),this.userConfiguration.keys.forEach(g=>l.add(g)),this.q.keys.forEach(g=>l.add(g)),this.r.forEach(g=>g.keys.forEach(E=>l.add(E))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.q.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.r.forEach(g=>g.getAllOverrideIdentifiers().forEach(E=>l.add(E))),[...l.values()]}D(l){const g=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.q.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(l).forEach(D=>g.add(D))),[...g.values()]}static parse(l,g){const E=this.E(l.defaults,g),D=this.E(l.policy,g),y=this.E(l.application,g),k=this.E(l.user,g),A=this.E(l.workspace,g),p=l.folders.reduce((v,F)=>(v.set(c.URI.revive(F[0]),this.E(F[1],g)),v),new L.$Ac);return new i(E,D,y,k,a.createEmptyModel(g),A,p,a.createEmptyModel(g),new L.$Ac,g)}static E(l,g){return new a(l.contents,l.keys,l.overrides,void 0,g)}}e.$Qo=i;function s(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const l=new Set,g=new Map;for(const D of d)D.keys.forEach(y=>l.add(y)),D.overrides.forEach(([y,k])=>{const A=(0,L.$xc)(g,y,new Set);k.forEach(p=>A.add(p))});const E=[];return g.forEach((D,y)=>E.push([y,[...D.values()]])),{keys:[...l.values()],overrides:E}}class t{constructor(l,g,E,D,y){this.change=l,this.f=g,this.g=E,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of l.keys)this.affectedKeys.add(k);for(const[,k]of l.overrides)for(const A of k)this.affectedKeys.add(A);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,g){const E=this.a+l,D=this.d.indexOf(E);if(D<0)return!1;const y=D+E.length;if(y>=this.d.length)return!1;const k=this.d.charCodeAt(y);if(k!==this.b&&k!==this.c)return!1;if(g){const A=this.previousConfiguration?this.previousConfiguration.getValue(l,g,this.f?.workspace):void 0,p=this.g.getValue(l,g,this.h);return!T.$ho(A,p)}return!0}}e.$So=t;function o(d,l){const{added:g,removed:E,updated:D}=n(l?.rawConfiguration,d?.rawConfiguration),y=[],k=d?.getAllOverrideIdentifiers()||[],A=l?.getAllOverrideIdentifiers()||[];if(l){const p=A.filter(v=>!k.includes(v));for(const v of p)y.push([v,l.getKeysForOverrideIdentifier(v)])}if(d){const p=k.filter(v=>!A.includes(v));for(const v of p)y.push([v,d.getKeysForOverrideIdentifier(v)])}if(l&&d){for(const p of k)if(A.includes(p)){const v=n({contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)},{contents:l.getOverrideValue(void 0,p)||{},keys:l.getKeysForOverrideIdentifier(p)});y.push([p,[...v.added,...v.removed,...v.updated]])}}return{added:g,removed:E,updated:D,overrides:y}}function n(d,l){const g=d?l?d.keys.filter(y=>l.keys.indexOf(y)===-1):[...d.keys]:[],E=l?d?l.keys.filter(y=>d.keys.indexOf(y)===-1):[...l.keys]:[],D=[];if(d&&l){for(const y of l.keys)if(d.keys.indexOf(y)!==-1){const k=(0,I.$gj)(l.contents,y),A=(0,I.$gj)(d.contents,y);T.$ho(k,A)||D.push(y)}}return{added:g,removed:E,updated:D}}}),define(ke[233],Ie([1,0,21,4,3,68]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Axb=e.$yxb=e.$xxb=void 0,e.$zxb=T;const L=(c,I,S)=>{const u=new Uint8Array(16);for(let a=0;a<16;a++)u[a]=Math.round(Math.random()*256);const P=(0,r.$8e)(r.$Ne.wrap(u));return[`GET ws://localhost${c}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$xxb=L,e.$yxb=r.$Ne.fromString(`\r
\r
`);async function T(c,I,S,u,P){c.write(r.$Ne.fromString((0,e.$xxb)(I,S,u)));const w=new C.$Tc;try{return await new Promise((a,m)=>{let $;w.add(c.onData(f=>{$?$=r.$Ne.concat([$,f],$.byteLength+f.byteLength):$=f;const i=$.indexOf(e.$yxb);if(i===-1)return;a(c),c.pauseData();const s=$.slice(i+e.$yxb.byteLength);s.byteLength&&P.onData.fire(s)})),w.add(c.onClose(f=>m(f??new Error("socket closed")))),w.add(c.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw c.dispose(),a}finally{w.dispose()}}class b extends C.$Uc{constructor(I,S){super(),this.g=I,this.a=this.B(new h.$oe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$le),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(u=>this.a.fire(u))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,S){R.SocketDiagnostics.traceSocketEvent(this,this.g,I,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Axb=b}),define(ke[71],Ie([1,0,13,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=c,e.$Ql=(0,h.$Ei)("remoteAuthorityResolverService");var C;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class R{constructor(S){this.id=S,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=R;class L{constructor(S,u){this.host=S,this.port=u,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=L;var T;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class b extends r.$ab{static isNotAvailable(S){return S instanceof b&&S._code===T.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof b&&S._code===T.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof b&&S._code===T.NoResolverFound}static isInvalidAuthority(S){return S instanceof b&&S._code===T.InvalidAuthority}static isHandled(S){return S instanceof b&&S.isHandled}constructor(S,u=T.Unknown,P){super(S),this._message=S,this._code=u,this._detail=P,this.isHandled=u===T.NotAvailable&&P===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Tl=b;function c(I){const S=I.indexOf("+");return S===-1?I:I.substring(0,S)}}),define(ke[234],Ie([1,0,7,21,20,13,4,3,14,61,42,32,68,71]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=y,e.$1l=k,e.$2l=p,c=qe(c);const w=30*1e3;var a;(function(me){me[me.Management=1]="Management",me[me.ExtensionHost=2]="ExtensionHost",me[me.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(me){switch(me){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function $(me){const Q=new C.$we;return setTimeout(()=>Q.cancel(),me),Q.token}function f(me,Q){if(me.isCancellationRequested||Q.isCancellationRequested)return C.CancellationToken.Cancelled;const q=new C.$we;return me.onCancellationRequested(()=>q.cancel()),Q.onCancellationRequested(()=>q.cancel()),q.token}class i{get didTimeout(){return this.c==="timedout"}constructor(Q){this.c="pending",this.d=new T.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$xh)(),Q.isCancellationRequested?this.h():this.d.add(Q.onCancellationRequested(()=>this.h()))}registerDisposable(Q){this.c==="pending"?this.d.add(Q):Q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Q))}reject(Q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Q))}}function s(me,Q){const q=new i(Q);return q.registerDisposable(me.onControlMessage(se=>{const we=JSON.parse(se.toString()),ee=Y(we);ee?q.reject(ee):q.resolve(we)})),q.promise}function t(me,Q,q,se,we,ee,ae,oe){const x=new i(oe),ne=I.$fe.create(!1);return me.info(`Creating a socket (${ae})...`),c.mark(`code/willCreateSocket/${ee}`),Q.connect(q,se,we,ae).then(pe=>{x.didTimeout?(c.mark(`code/didCreateSocketError/${ee}`),me.info(`Creating a socket (${ae}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(c.mark(`code/didCreateSocketOK/${ee}`),me.info(`Creating a socket (${ae}) was successful after ${ne.elapsed()} ms.`),x.resolve(pe))},pe=>{c.mark(`code/didCreateSocketError/${ee}`),me.info(`Creating a socket (${ae}) returned an error after ${ne.elapsed()} ms.`),me.error(pe),x.reject(pe)}),x.promise}function o(me,Q){const q=new i(Q);return me.then(se=>{q.didTimeout||q.resolve(se)},se=>{q.didTimeout||q.reject(se)}),q.promise}async function n(me,Q,q,se){const we=re(me,Q);me.logService.trace(`${we} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await t(me.logService,me.remoteSocketFactoryService,me.connectTo,b.$Rg.getServerRootPath(),`reconnectionToken=${me.reconnectionToken}&reconnection=${me.reconnectionProtocol?"true":"false"}`,m(Q),`renderer-${m(Q)}-${me.reconnectionToken}`,se)}catch(pe){throw me.logService.error(`${we} socketFactory.connect() failed or timed out. Error:`),me.logService.error(pe),pe}me.logService.trace(`${we} 2/6. socketFactory.connect() was successful.`);let ae,oe;me.reconnectionProtocol?(me.reconnectionProtocol.beginAcceptReconnection(ee,null),ae=me.reconnectionProtocol,oe=!1):(ae=new u.$si({socket:ee}),oe=!0),me.logService.trace(`${we} 3/6. sending AuthRequest control message.`);const x=await o(me.signService.createNewMessage((0,S.$1g)()),se),ne={type:"auth",auth:me.connectionToken||"00000000000000000000",data:x.data};ae.sendControl(h.$Ne.fromString(JSON.stringify(ne)));try{const pe=await s(ae,f(se,$(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(me.logService.trace(`${we} 4/6. received SignRequest control message.`),!await o(me.signService.validate(x,pe.signedData),se)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const Fe=await o(me.signService.sign(pe.data),se),ze={type:"connectionType",commit:me.commit,signedData:Fe,desiredConnectionType:Q};return q&&(ze.args=q),me.logService.trace(`${we} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(h.$Ne.fromString(JSON.stringify(ze))),{protocol:ae,ownsProtocol:oe}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(me.logService.error(`${we} the handshake timed out. Error:`),me.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(me.logService.error(`${we} received error control message when negotiating connection. Error:`),me.logService.error(pe)),oe&&B(ae),pe}}async function d(me,Q,q,se){const we=Date.now(),ee=re(me,Q),{protocol:ae,ownsProtocol:oe}=await n(me,Q,q,se),x=new i(se);return x.registerDisposable(ae.onControlMessage(ne=>{const pe=JSON.parse(ne.toString()),be=Y(pe);be?(me.logService.error(`${ee} received error control message when negotiating connection. Error:`),me.logService.error(be),oe&&B(ae),x.reject(be)):(me.reconnectionProtocol?.endAcceptReconnection(),me.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${Se(we)}!`),x.resolve({protocol:ae,firstMessage:pe}))})),x.promise}async function l(me,Q){const{protocol:q}=await d(me,a.Management,void 0,Q);return{protocol:q}}async function g(me,Q,q){const{protocol:se,firstMessage:we}=await d(me,a.ExtensionHost,Q,q),ee=we&&we.debugPort;return{protocol:se,debugPort:ee}}async function E(me,Q,q){const se=Date.now(),we=re(me,a.Tunnel),{protocol:ee}=await n(me,a.Tunnel,Q,q);return me.logService.trace(`${we} 6/6. handshake finished, connection is up and running after ${Se(se)}!`),ee}async function D(me,Q,q){const{connectTo:se,connectionToken:we}=await me.addressProvider.getAddress();return{commit:me.commit,quality:me.quality,connectTo:se,connectionToken:we,reconnectionToken:Q,reconnectionProtocol:q,remoteSocketFactoryService:me.remoteSocketFactoryService,signService:me.signService,logService:me.logService}}async function y(me,Q,q){return A(me,async se=>{const{protocol:we}=await l(se,C.CancellationToken.None);return new V(me,Q,q,se.reconnectionToken,we)})}async function k(me,Q){return A(me,async q=>{const{protocol:se,debugPort:we}=await g(q,Q,C.CancellationToken.None);return new ie(me,Q,q.reconnectionToken,se,we)})}async function A(me,Q){for(let se=1;;se++)try{const we=(0,S.$1g)(),ee=await D(me,we,null);return await Q(ee)}catch(we){if(se<5)me.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),me.logService.error(we);else throw me.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),me.logService.error(we),U.triggerPermanentFailure(0,0,P.$Tl.isHandled(we)),we}}async function p(me,Q,q){const se=await D(me,(0,S.$1g)(),null);return await E(se,{host:Q,port:q},C.CancellationToken.None)}function v(me){return(0,r.$rh)(Q=>new Promise((q,se)=>{const we=setTimeout(q,me*1e3);Q.onCancellationRequested(()=>{clearTimeout(we),q()})}))}var F;(function(me){me[me.ConnectionLost=0]="ConnectionLost",me[me.ReconnectionWait=1]="ReconnectionWait",me[me.ReconnectionRunning=2]="ReconnectionRunning",me[me.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",me[me.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(Q,q){this.reconnectionToken=Q,this.millisSinceLastIncomingData=q,this.type=F.ConnectionLost}}e.$3l=N;class O{constructor(Q,q,se,we){this.reconnectionToken=Q,this.millisSinceLastIncomingData=q,this.durationSeconds=se,this.c=we,this.type=F.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=O;class j{constructor(Q,q,se){this.reconnectionToken=Q,this.millisSinceLastIncomingData=q,this.attempt=se,this.type=F.ReconnectionRunning}}e.$5l=j;class z{constructor(Q,q,se){this.reconnectionToken=Q,this.millisSinceLastIncomingData=q,this.attempt=se,this.type=F.ConnectionGain}}e.$6l=z;class M{constructor(Q,q,se,we){this.reconnectionToken=Q,this.millisSinceLastIncomingData=q,this.attempt=se,this.handled=we,this.type=F.ReconnectionPermanentFailure}}e.$7l=M;class U extends T.$Uc{static triggerPermanentFailure(Q,q,se){this._permanentFailure=!0,this.f=Q,this.g=q,this.h=se,this.j.forEach(we=>we.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Q=>Q.y())}static debugPauseSocketWriting(){this.j.forEach(Q=>Q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(Q,q,se,we,ee){super(),this.t=Q,this.u=q,this.reconnectionToken=se,this.protocol=we,this.w=ee,this.m=this.B(new L.$le),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(we.onSocketClose(ae=>{const oe=le(this.t,this.reconnectionToken,!0);ae?ae.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${oe} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this.u.logService.error(ae.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this.u.logService.error(ae.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(we.onSocketTimeout(ae=>{const oe=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,T.$Sc)(()=>{const ae=U.j.indexOf(this);ae>=0&&U.j.splice(ae,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Q=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const we=se<q.length?q[se]:q[q.length-1];try{if(we>0){const ae=v(we);this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),we,ae)),this.u.logService.info(`${Q} waiting for ${we} seconds before reconnecting...`);try{await ae}catch{}}if(this.n){this.u.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${Q} resolving connection...`);const ee=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Q} connecting to ${ee.connectTo}...`),await this.G(ee,$(w)),this.u.logService.info(`${Q} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(P.$Tl.isTemporarilyNotAvailable(ee)){this.u.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this.u.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((0,R.$3)(ee)){this.u.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if(ee instanceof P.$Tl){this.u.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,P.$Tl.isHandled(ee));break}this.u.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(Q,q,se){this.w?U.triggerPermanentFailure(Q,q,se):this.D(Q,q,se)}D(Q,q,se){this.m.fire(new M(this.reconnectionToken,Q,q,se)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=U;class V extends U{constructor(Q,q,se,we,ee){super(a.Management,Q,we,ee,!0),this.client=this.B(new u.$qi(ee,{remoteAuthority:q,clientId:se},Q.ipcLogger))}async G(Q,q){await l(Q,q)}}e.$9l=V;class ie extends U{constructor(Q,q,se,we,ee){super(a.ExtensionHost,Q,se,we,!1),this.H=q,this.debugPort=ee}async G(Q,q){await g(Q,this.H,q)}}e.$0l=ie;function B(me){try{me.acceptDisconnect();const Q=me.getSocket();me.dispose(),Q.dispose()}catch(Q){(0,R.$Y)(Q)}}function Y(me){if(me&&me.type==="error"){const Q=new Error(`Connection error: ${me.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function J(me,Q){for(;me.length<Q;)me+=" ";return me}function _(me,Q){return`[remote-connection][${J(m(me),13)}][${Q.substr(0,5)}\u2026]`}function le(me,Q,q){return`${_(me,Q)}[${q?"reconnect":"initial"}]`}function re(me,Q){return`${le(Q,me.reconnectionToken,!!me.reconnectionProtocol)}[${me.connectTo}]`}function Se(me){return`${Date.now()-me} ms`}}),define(ke[90],Ie([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=h,e.$hn=C,e.$in=R,e.$jn=L;function h(b){return b.scheme===r.Schemas.vscodeRemote?b.authority:void 0}function C(b){if(!b)return;const c=b.indexOf("+");return c<0?b:b.substr(0,c)}function R(b){const{host:c,port:I}=T(b);if(typeof I>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:I}}function L(b,c){let{host:I,port:S}=T(b);return typeof S>"u"&&(S=c),{host:I,port:S}}function T(b){const c=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const I=b.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const S=b.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:b,port:void 0}}}),define(ke[23],Ie([1,0,12,5,90]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=R,e.$tn=S,e.$un=u,e.$vn=P,e.$wn=w,e.$xn=a,e.$yn=m,r=qe(r),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function R($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$pn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function($){$[$.System=0]="System",$[$.User=1]="User"})(L||(e.ExtensionType=L={}));var T;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class b{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,i){if(typeof f>"u"||f===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof f=="string"||typeof i=="string"){const s=typeof f=="string"?f:f.value,t=typeof i=="string"?i:i.value;return r.$Ff(s,t)}return f._lower===i._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$qn=b;class c{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const i of f)this.add(i)}add(f){this.c.add(b.toKey(f))}delete(f){return this.c.delete(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}}e.$rn=c;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(b.toKey(f))}get(f){return this.c.get(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}set(f,i){this.c.set(b.toKey(f),i)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=I;function S($){return u($)}function u($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function P($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function w($,f){if(f){const i=`onResolveRemoteAuthority:${(0,C.$hn)(f)}`;return!!$.activationEvents?.includes(i)}return!1}function a($){return $.map(f=>{const[i,s]=f.split("@");return{proposalName:i,version:s?parseInt(s):void 0}})}function m($){return $.map(f=>f.split("@")[0])}e.$zn=(0,h.$Ei)("IBuiltinExtensionsScannerService")}),define(ke[146],Ie([1,0,10,8,23,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.ExtensionManagementErrorCode=e.$lp=e.ExtensionGalleryErrorCode=e.$kp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0,e.$ep=T,e.$fp=b,e.$gp=c,e.$hp=I,e.$ip=S,e.$jp=u,e.$0o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$o=new RegExp(e.$0o),e.$_o="__web_extension",e.$ap="skipWalkthrough",e.$bp="extensionInstallSource",e.$cp="dependecyOrPackExtensionInstall",e.$dp="clientTargetPlatform";var L;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function T(t){switch(t){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function b(t){switch(t){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function c(t,o){switch(t){case r.Platform.Windows:return o==="x64"?C.TargetPlatform.WIN32_X64:o==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Linux:return o==="x64"?C.TargetPlatform.LINUX_X64:o==="arm64"?C.TargetPlatform.LINUX_ARM64:o==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?C.TargetPlatform.ALPINE_X64:o==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Mac:return o==="x64"?C.TargetPlatform.DARWIN_X64:o==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Web:return C.TargetPlatform.WEB}}function I(t,o){return o===C.TargetPlatform.WEB&&!t.includes(C.TargetPlatform.WEB)}function S(t,o,n){return I(o,n)?!1:t===C.TargetPlatform.UNDEFINED||t===C.TargetPlatform.UNIVERSAL?!0:t===C.TargetPlatform.UNKNOWN?!1:t===n}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var P;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var w;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var a;(function(t){t.Install="install",t.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$kp=(0,R.$Ei)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class f extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$lp=f;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class s extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$mp=s,e.$np=(0,R.$Ei)("extensionManagementService"),e.$op="extensionsIdentifiers/disabled",e.$pp="extensionsIdentifiers/enabled",e.$qp=(0,R.$Ei)("IGlobalExtensionEnablementService"),e.$rp=(0,R.$Ei)("IExtensionTipsService"),e.$sp=(0,h.localize2)(11454,"Extensions"),e.$tp=(0,h.localize2)(11455,"Preferences")}),define(ke[147],Ie([1,0,13,23]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=e.$WG=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(L,T){this.a.set(L,T)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const T=Object.create(null);for(const b of L){const c=this.readActivationEvents(b);c.length>0&&(T[h.$qn.toKey(b.identifier)]=c)}return T}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const T=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let b=0;b<T.length;b++)T[b]==="onUri"&&(T[b]=`onUri:${h.$qn.toKey(L.identifier)}`);if(!L.contributes)return T;for(const b in L.contributes){const c=this.a.get(b);if(!c)continue;const I=L.contributes[b],S=Array.isArray(I)?I:[I];try{c(S,T)}catch(u){(0,r.$Y)(u)}}return T}}e.$WG=C,e.$XG=new C});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[235],Ie([1,0,22,43,8,361,23,143]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=I,e.$Zp=S,e.$1p=u,e.$2p=P,e.$3p=w,e.$4p=a,e.$5p=m,e.$6p=$,h=Ut(h),C=qe(C),R=qe(R);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function I(s){return s=s.trim(),s==="*"||b.test(s)}function S(s){if(!I(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=s.match(b);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(s){if(!s)return null;const t=s.majorBase,o=s.majorMustEqual,n=s.minorBase;let d=s.minorMustEqual;const l=s.patchBase;let g=s.patchMustEqual;s.hasCaret&&(t===0||(d=!1),g=!1);let E=0;if(s.preRelease){const D=c.exec(s.preRelease);if(D){const[,y,k,A]=D;E=Date.UTC(Number(y),Number(k)-1,Number(A))}}return{majorBase:t,majorMustEqual:o,minorBase:n,minorMustEqual:d,patchBase:l,patchMustEqual:g,isMinimum:s.hasGreaterEquals,notBefore:E}}function P(s,t,o){let n;typeof s=="string"?n=u(S(s)):n=s;let d;t instanceof Date?d=t.getTime():typeof t=="string"&&(d=new Date(t).getTime());let l;if(typeof o=="string"?l=u(S(o)):l=o,!n||!l)return!1;const g=n.majorBase,E=n.minorBase,D=n.patchBase;let y=l.majorBase,k=l.minorBase,A=l.patchBase;const p=l.notBefore;let v=l.majorMustEqual,F=l.minorMustEqual,N=l.patchMustEqual;return l.isMinimum?g>y?!0:g<y?!1:E>k?!0:E<k||d&&d<p?!1:D>=A:(g===1&&y===0&&(!v||!F||!N)&&(y=1,k=0,A=0,v=!0,F=!1,N=!1),g<y?!1:g>y?!v:E<k?!1:E>k?!F:D<A?!1:D>A?!N:!(d&&d<p))}function w(s,t,o,n,d,l){const g=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return g.push([h.default.Error,C.localize(11385,null)]),g;if(typeof n.name!="string")return g.push([h.default.Error,C.localize(11386,null,"name")]),g;if(typeof n.version!="string")return g.push([h.default.Error,C.localize(11387,null,"version")]),g;if(!n.engines)return g.push([h.default.Error,C.localize(11388,null,"engines")]),g;if(typeof n.engines.vscode!="string")return g.push([h.default.Error,C.localize(11389,null,"engines.vscode")]),g;if(typeof n.extensionDependencies<"u"&&!i(n.extensionDependencies))return g.push([h.default.Error,C.localize(11390,null,"extensionDependencies")]),g;if(typeof n.activationEvents<"u"){if(!i(n.activationEvents))return g.push([h.default.Error,C.localize(11391,null,"activationEvents")]),g;if(typeof n.main>"u"&&typeof n.browser>"u")return g.push([h.default.Error,C.localize(11392,null,"activationEvents","main","browser")]),g}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&g.push([h.default.Warning,C.localize(11393,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return g.push([h.default.Error,C.localize(11394,null,"main")]),g;{const y=(0,r.$fh)(o,n.main);(0,r.$_g)(y,o)||g.push([h.default.Warning,C.localize(11395,null,y.path,o.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return g.push([h.default.Error,C.localize(11396,null,"browser")]),g;{const y=(0,r.$fh)(o,n.browser);(0,r.$_g)(y,o)||g.push([h.default.Warning,C.localize(11397,null,y.path,o.path)])}}if(!R.valid(n.version))return g.push([h.default.Error,C.localize(11398,null)]),g;const E=[];if(!a(s,t,n,d,E))for(const y of E)g.push([h.default.Error,y]);if(l&&n.enabledApiProposals?.length){const y=[];if(!$([...n.enabledApiProposals],y))for(const k of y)g.push([h.default.Error,k])}return g}function a(s,t,o,n,d){return n||typeof o.main>"u"&&typeof o.browser>"u"?!0:f(s,t,o.engines.vscode,d)}function m(s,t,o){return s==="*"||f(t,o,s)}function $(s,t){if(s.length===0)return!0;const o=Array.isArray(t)?t:void 0,n=(o?void 0:t)??T.allApiProposals,d=[],l=(0,L.$xn)(s);for(const{proposalName:g,version:E}of l){const D=n[g];D&&E&&D.version!==E&&d.push(C.localize(11399,null,g))}return o?.push(...d),d.length===0}function f(s,t,o,n=[]){const d=u(S(o));if(!d)return n.push(C.localize(11400,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return n.push(C.localize(11401,null,o)),!1}else if(!d.majorMustEqual)return n.push(C.localize(11402,null,o)),!1;return P(s,t,d)?!0:(n.push(C.localize(11403,null,s,o)),!1)}function i(s){if(!Array.isArray(s))return!1;for(let t=0,o=s.length;t<o;t++)if(typeof s[t]!="string")return!1;return!0}}),define(ke[236],Ie([1,0,3,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,h.$Ei)("remoteSocketFactoryService");class C{constructor(){this.a={}}register(L,T){return this.a[L]??=[],this.a[L].push(T),(0,r.$Sc)(()=>{const b=this.a[L]?.indexOf(T);typeof b=="number"&&b>=0&&this.a[L]?.splice(b,1)})}b(L){return(this.a[L.type]||[]).find(b=>b.supports(L))}connect(L,T,b,c){const I=this.b(L);if(!I)throw new Error(`No socket factory found for ${L}`);return I.connect(L,T,b,c)}}e.$Wl=C}),define(ke[237],Ie([1,0,21,13,3,8,70,5,11,36]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$9p=u,e.$0p=P,e.$$p=w,e.$_p=a,e.$aq=m,e.$bq=$,e.$7p=(0,T.$Ei)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class S extends C.$Uc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,R.localize)(11172,null),when:b.$rk.isEqualTo((0,b.$ok)(b.LogLevel.Trace)).serialize()})}async c(t,o,n){const d=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${d} - begin`,o.type,new I(o.headers??{}));try{const l=await n();return this.a.trace(`${d} - end`,o.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${d} - error`,o.type,(0,h.$9)(l)),l}}}e.$8p=S;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function P(s){return s.res.statusCode===204}async function w(s){return P(s)?null:(await(0,r.$Ze)(s.stream)).toString()}async function a(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return w(s)}async function m(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(P(s))return null;const o=(await(0,r.$Ze)(s.stream)).toString();try{return JSON.parse(o)}catch(n){throw n.message+=`:
`+o,n}}function $(s){i(s)}let f;function i(s){const t=c.$qo.as(L.$vo.Configuration),o=f;f={id:"http",order:15,title:(0,R.localize)(11173,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(11174,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(11175,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(11176,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(11177,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(11178,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(11179,null),(0,R.localize)(11180,null),(0,R.localize)(11181,null),(0,R.localize)(11182,null)],default:"override",description:(0,R.localize)(11183,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11184,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(11185,null),restricted:!0}}},t.updateConfigurations({add:[f],remove:o?[o]:[]})}i(L.ConfigurationScope.APPLICATION)}),define(ke[238],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(C){try{const R=await this.c();if(R){const L=String(r.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,R){if(!C.id)return!0;const L=this.b.get(C.id);if(!L)return!1;this.b.delete(C.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(C){try{return await this.d(C)}catch{}return C}}e.$Ecc=r}),define(ke[117],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,r.$Ei)(e.$Xl)}),define(ke[148],Ie([1,0,238]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class h extends r.$Ecc{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>$e(["vsda"],R,L))}}e.$Lhc=h}),define(ke[239],Ie([1,0,10,55,32]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=L,e.$vp=T;function R(b){if(r.$v===r.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function L(b,c,I,S,u,P,w,a,m,$){const f=Object.create(null);f["common.machineId"]=P,f["common.sqmId"]=w,f["common.devDeviceId"]=a,f.sessionID=(0,C.$1g)()+Date.now(),f.commitHash=S,f.version=u,f["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,r.$i)(r.$v),f["common.nodePlatform"]=h.$dc,f["common.nodeArch"]=I,f["common.product"]=$||"desktop",m&&(f["common.msftInternal"]=m);let i=0;const s=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),r.$m&&(f["common.snap"]="true");const t=R(c);return t&&(f["common.platformDetail"]=t),f}function T(b){const c=h.env.USERDNSDOMAIN;if(!c)return!1;const I=c.toLowerCase();return b.some(S=>I===S)}}),define(ke[149],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,r.$Ei)("telemetryService"),e.$_l=(0,r.$Ei)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var C;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(ke[91],Ie([1,0,24,17,90,239,149]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$Dp=I,e.$Ep=S,e.$Fp=u,e.$Gp=P,e.$Hp=a,e.$Ip=$,e.$Jp=f,e.$Kp=t;class T{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$wp=T;class b{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xp=b,e.$yp=new b;class c{async publicLog(n,d,l){}async publicLogError(n,d,l){}}e.$zp=c,e.$Ap="telemetry",e.$Bp="extensionTelemetryLog",e.$Cp={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!o.enableTelemetry)}function S(o,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const n=o.getValue(L.$hm),d=o.getValue(L.$im);if(o.getValue(L.$jm)===!1||d===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function P(o){const n={},d={},l={};m(o,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const E=l[g];typeof E=="number"?d[g]=E:typeof E=="boolean"?d[g]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${E.length}`),n[g]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(n[g]=E)}return{properties:n,measurements:d}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(o){if(!o)return"none";const n=(0,C.$hn)(o);return w.has(n)?n:"other"}function m(o,n,d=0,l){if(o)for(const g of Object.getOwnPropertyNames(o)){const E=o[g],D=l?l+g:g;Array.isArray(E)?n[D]=(0,r.$io)(E):E instanceof Date?n[D]=E.toISOString():(0,h.$gg)(E)?d<2?m(E,n,d+1,D+"."):n[D]=(0,r.$io)(E):n[D]=E}}function $(o,n){const d=o.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,R.$vp)(d)||l}function f(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,n){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const l=[];for(const y of n)for(;;){const k=y.exec(o);if(!k)break;l.push([k.index,y.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(d="";;){const y=E.exec(o);if(!y)break;const k=l.some(([A,p])=>y.index<p&&A<E.lastIndex);!g.test(y[0])&&!k&&(d+=o.substring(D,y.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<o.length&&(d+=o.substr(D)),d}function s(o){if(!o)return o;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of n)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function t(o,n){return(0,r.$fo)(o,d=>{if(d instanceof T||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,n);for(const g of n)l=l.replace(g,"");return l=s(l),l}})}}),define(ke[240],Ie([1,0,12,146,23,10,2,13,55,91]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Mp=void 0,e.$Lp=I,e.$Np=w,e.$Op=a,e.$Pp=m,e.$Qp=$,e.$Rp=f,e.$Sp=i,e.$Tp=s,e.$Vp=t,e.$Wp=n;function I(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,r.$Af)(d.id,l.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const g=l.manifest?l.manifest.version:l.version,E=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,g,E)}static parse(l){const g=S.exec(l);return g&&g[1]&&g[2]?new u({id:g[1]},g[2],g[4]||void 0):null}constructor(l,g,E=C.TargetPlatform.UNDEFINED){this.identifier=l,this.version=g,this.targetPlatform=E,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?I(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Mp=u;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(d){const l=P.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function a(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function $(d,l){return m(a(d??C.$mn,l))}function f(d,l){const g=[],E=D=>{for(const y of g)if(y.some(k=>I(l(k),l(D))))return y;return null};for(const D of d){const y=E(D);y?y.push(D):g.push([D])}return g}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function s(d){return{id:new c.$wp(d.identifier.id),name:new c.$wp(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Up=new C.$qn("pprice.better-merge");function t(d,l){const g=[],E=l.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&g.every(y=>!I(y.identifier,{id:D}))){const y=d.filter(k=>I(k.identifier,{id:D}));y.length===1&&(g.push(y[0]),E.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function o(d,l){if(!R.$l)return!1;let g;try{g=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){l.debug("Error while getting the os-release file.",(0,T.$9)(D))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(d,l){const g=await o(d,l),E=(0,h.$gp)(g?"alpine":R.$v,b.$ec);return l.debug("ComputeTargetPlatform:",E),E}}),define(ke[241],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=r,e.$Fs=h,e.$Gs=C,e.$Hs=R,e.$Is=L,e.$Js=T;function r(b){return[...b.entries()]}function h(b){return b?[...b.entries()]:[]}function C(b){return new Map(b)}function R(b){return new Map(b??[])}function L(b){return Array.from(b.entries()).map(c=>[c[0],r(c[1].map),h(c[1].descriptionMap)])}function T(b){return new Map(b.map(c=>[c[0],{map:C(c[1]),descriptionMap:R(c[2])}]))}}),define(ke[242],Ie([1,0,5,35,36]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$os=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ns=void 0,e.$ns=new h.$Vj("terminalTabFocusMode",!1,!0);var R;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var L;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var b;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(b||(e.WindowsShellType=b={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var S;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(S||(e.ProcessPropertyType=S={})),e.$os=(0,r.$Ei)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var P;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var w;(function(t){t.TerminalView="view",t.Editor="editor"})(w||(e.TerminalLocationString=w={}));var a;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var f;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ps={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(o){const n=this.b(o.remoteAuthority);if(this.a.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this.a.set(n,o)}getTerminalBackend(o){return this.a.get(this.b(o))}b(o){return o?.toLowerCase()??""}}C.$qo.add(e.$ps.Backend,new s),e.$qs=(0,r.$Ei)("localPtyService"),e.$rs=(0,r.$Ei)("terminalLogService")}),define(ke[243],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sxb=void 0;class r{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,R,L=5){const T=R(b=>{const c=typeof b=="string"?b:b.data;let I=this.a.get(C);if(I){I.data.push(c);return}const S=setTimeout(()=>this.flushBuffer(C),L);I={data:[c],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(C),T.dispose()}},this.a.set(C,I)});return T}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const R=this.a.get(C);R&&(this.a.delete(C),this.b(C,R.data.join("")))}}e.$Sxb=r}),define(ke[244],Ie([1,0,7,82,106,50,4,17,2,8,116,36]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hx=e.$Gx=e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.IconFontDefinition=e.IconContribution=e.$zx=void 0,e.$Ax=m,e.$Bx=$,S=qe(S),e.$zx={IconContribution:"base.contributions.icons"};var u;(function(t){function o(n,d){let l=n.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const g=a.getIcon(l.id);if(!g)return;l=g.defaults}return l}t.getDefinition=o})(u||(e.IconContribution=u={}));var P;(function(t){function o(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}t.toJSONObject=o;function n(d){const l=g=>(0,T.$eg)(g)?g:void 0;if(d&&Array.isArray(d.src)&&d.src.every(g=>(0,T.$eg)(g.format)&&(0,T.$eg)(g.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(g=>({format:g.format,location:b.URI.parse(g.location)}))}}t.fromJSONObject=n})(P||(e.IconFontDefinition=P={}));class w{constructor(){this.a=new L.$le,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(11104,null)},fontCharacter:{type:"string",description:(0,c.localize)(11105,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,n,d,l){const g=this.b[o];if(g){if(d&&!g.description){g.description=d,this.d.properties[o].markdownDescription=`${d} $(${o})`;const y=this.e.enum.indexOf(o);y!==-1&&(this.e.enumDescriptions[y]=d),this.a.fire()}return g}const E={id:o,description:d,defaults:n,deprecationMessage:l};this.b[o]=E;const D={$ref:"#/definitions/icons"};return l&&(D.deprecationMessage=l),d&&(D.markdownDescription=`${d}: $(${o})`),this.d.properties[o]=D,this.e.enum.push(o),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const n=this.e.enum.indexOf(o);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,n){const d=this.f[o];return d||(this.f[o]=n,this.a.fire(),n)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(g,E)=>g.id.localeCompare(E.id),n=g=>{for(;R.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(g=>this.b[g]);for(const g of l.filter(E=>!!E.description).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|${R.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const g of l.filter(E=>!R.ThemeIcon.isThemeIcon(E.defaults)).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|`);return d.join(`
`)}}const a=new w;S.$qo.add(e.$zx.IconContribution,a);function m(t,o,n,d){return a.registerIcon(t,o,n,d)}function $(){return a}function f(){const t=(0,C.$Zj)();for(const o in t){const n="\\"+t[o].toString(16);a.registerIcon(o,{fontCharacter:n})}}f(),e.$Cx="vscode://schemas/icons";const i=S.$qo.as(I.$ro.JSONContribution);i.registerSchema(e.$Cx,a.getIconSchema());const s=new r.$Qh(()=>i.notifySchemaChanged(e.$Cx),200);a.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$Dx=m("widget-close",h.$4j.close,(0,c.localize)(11106,null)),e.$Ex=m("goto-previous-location",h.$4j.arrowUp,(0,c.localize)(11107,null)),e.$Fx=m("goto-next-location",h.$4j.arrowDown,(0,c.localize)(11108,null)),e.$Gx=R.ThemeIcon.modify(h.$4j.sync,"spin"),e.$Hx=R.ThemeIcon.modify(h.$4j.loading,"spin")}),define(ke[92],Ie([1,0,4,3,10,2,45,5,11]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ow=e.$Nw=e.$Kw=e.$Iw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ew=e.$Dw=void 0,e.$Fw=S,e.$Gw=P,e.$Hw=w,e.$Jw=a,e.$Lw=m,e.$Mw=$,e.$Dw=(0,T.$Ei)("tunnelService"),e.$Ew=(0,T.$Ei)("sharedTunnelsService");var c;(function(s){s.Http="http",s.Https="https"})(c||(e.TunnelProtocol=c={}));var I;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(I||(e.TunnelPrivacyId=I={}));function S(s){return!!s.forwardPort}var u;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function P(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}function w(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const t=s.query.split("&");for(const o of t){const n=o.split("=")[1];if(/^https?:/.exec(n)){const d=P(R.URI.parse(n));if(d)return d}}}e.$Iw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(s){return e.$Iw.indexOf(s)>=0}e.$Kw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(s){return e.$Kw.indexOf(s)>=0}function $(s,t,o,n){if(o===C.OperatingSystem.Windows)return!1;if(o===C.OperatingSystem.Macintosh&&m(t)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(d?.length===4&&parseInt(d[1])>=18)return!1}return s<1024}class f{constructor(t,o,n){this.remoteAddress=t,this.localAddress=o,this.b=n,this.a=new r.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Nw=f;let i=class extends h.$Uc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new r.$le,this.onTunnelOpened=this.a.event,this.b=new r.$le,this.onTunnelClosed=this.b.event,this.c=new r.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const n of o){const d=Array.from(n.values());for(const l of d){const g=await l.value;g&&typeof g!="string"&&t.push(g)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(n=>typeof n!="string"?n?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,n,d,l){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:n,privacy:d,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(m(t)||a(t))&&(t=e.$Iw[0]);const n=this.D(t,o);if(n)return++n.refcount,n.value}openTunnel(t,o,n,d,l,g=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${n} on local port ${l}.`);const y=this.g??t;if(!y)return;if(o||(o="localhost"),d||(d=this.t),this.g&&this.n.has(n)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(y,o,n,d,l,g,E,D);return k?k.then(A=>{if(A){if(typeof A=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,n),A}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,n);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(A);return(A.tunnelRemoteHost!==o||A.tunnelRemotePort!==n)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&A.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const n=o.get(t.tunnelRemotePort);n&&(n.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,n))}}}}async y(t,o,n){if(n.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const d=n.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),d}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const n=this.f.get(t);if(n&&n.has(o)){const d=n.get(o);d.refcount=0,await this.y(t,o,d)}}z(t,o,n){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:n})}async C(t,o){const n=this.f.get(t);if(n){const d=n.get(o),l=d?await d.value:void 0;(!l||typeof l=="string")&&n.delete(o),n.size===0&&this.f.delete(t)}}D(t,o){const n=[t];a(t)?(n.push(...e.$Iw),n.push(...e.$Kw)):m(t)&&n.push(...e.$Kw);const d=n.map(l=>this.f.get(l));for(const l of d){const g=l?.get(o);if(g)return g}}canTunnel(t){return!!P(t)}G(t,o,n,d,l,g,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${n} on local port ${d}.`);const D=n;this.n.add(D);const y=d===void 0?n:d,k={elevationRequired:l?this.isPortPrivileged(y):!1},A={remoteAddress:{host:o,port:n},localAddressPort:d,privacy:g,public:g?g!==I.Private:void 0,protocol:E},p=t.forwardPort(A,k);return p?(this.z(o,n,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),p}};e.$Ow=i,e.$Ow=i=Je([Ve(0,b.$_j),Ve(1,L.$$i)],i)}),define(ke[245],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,r.$Ei)("IUriIdentityService")}),define(ke[246],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Pw=void 0,e.$Pw=(0,r.$Ei)("editSessionIdentityService");var h;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(ke[247],Ie([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=h,e.$fN=C,e.$gN=R,e.$hN=L,e.$iN=T;function h(b){return b.scheme!==r.Schemas.file&&b.scheme!==r.Schemas.vscodeRemote}function C(b){if(b.folders.length)return b.folders.every(c=>h(c.uri))?b.folders[0].uri:void 0;if(b.configuration&&h(b.configuration))return b.configuration}function R(b){return C(b)?.scheme}function L(b){return C(b)?.authority}function T(b){return C(b)!==void 0}}),define(ke[46],Ie([1,0,8,16,84,22,2,5,14]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Yi=e.$Xi=e.WorkbenchState=e.$Ri=e.$Qi=e.$Ni=void 0,e.$Oi=c,e.$Pi=I,e.$Si=S,e.$Ti=u,e.$Ui=P,e.$Vi=a,e.$Wi=m,e.$Zi=i,e.$5i=s,e.$6i=t,e.$8i=o,e.$9i=n,e.$0i=d,e.$Ni=(0,T.$Ei)("contextService");function c(l){const g=l;return typeof g?.id=="string"&&L.URI.isUri(g.uri)}function I(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Qi={id:"ext-dev"},e.$Ri={id:"empty-window"};function S(l,g){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,h.$nc)(l)}:g?e.$Qi:e.$Ri;const E=l;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function u(l){const g=l;return typeof g?.id=="string"&&L.URI.isUri(g.configPath)}function P(l){const g=l;if(g?.uri)return{id:g.id,uri:L.URI.revive(g.uri)};const E=l;if(E?.configPath)return{id:E.id,configPath:L.URI.revive(E.configPath)};if(l?.id)return{id:l.id}}var w;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function a(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function m(l){const g=l;return!!(g&&typeof g=="object"&&L.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class ${constructor(g,E,D,y,k){this.h=g,this.j=D,this.k=y,this.l=k,this.c=C.$Ki.forUris(this.l,()=>!0),this.folders=E}update(g){this.h=g.id,this.k=g.configuration,this.j=g.transient,this.l=g.l,this.folders=g.folders}get folders(){return this.g}set folders(g){this.g=g,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(g){this.k=g}getFolder(g){return g&&this.c.findSubstr(g)||null}n(){this.c=C.$Ki.forUris(this.l,()=>!0);for(const g of this.folders)this.c.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Xi=$;class f{constructor(g,E){this.raw=E,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.$fh)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Yi=f;function i(l){return new f({uri:l,index:0,name:(0,R.$bh)(l)},{uri:l.toString()})}e.$1i="code-workspace",e.$2i=`.${e.$1i}`,e.$3i=[{name:(0,r.localize)(10983,null),extensions:[e.$1i]}],e.$4i="workspace.json";function s(l,g){return R.$9g.isEqualOrParent(l,g.untitledWorkspacesHome)}function t(l){let g;return L.URI.isUri(l)?g=l:g=l.configuration,g?.scheme===b.Schemas.tmp}e.$7i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(l){return l.id===e.$7i}function n(l,g){return!s(l,g)&&!t(l)}function d(l){return(typeof l=="string"?(0,h.$oc)(l):(0,R.$dh)(l))===e.$2i}}),define(ke[150],Ie([1,0,60,4,3,22,2,8,144,27,5,11,46,28,245,7,32,12,17]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=s,e.$Ml=t,e.$Nl=o;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&L.URI.isUri(g.location)&&L.URI.isUri(g.globalStorageHome)&&L.URI.isUri(g.settingsResource)&&L.URI.isUri(g.keybindingsResource)&&L.URI.isUri(g.tasksResource)&&L.URI.isUri(g.snippetsHome)&&L.URI.isUri(g.extensionsResource))}e.$Ll=(0,I.$Ei)("IUserDataProfilesService");function t(l,g){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:L.URI.revive(l.location).with({scheme:g}),globalStorageHome:L.URI.revive(l.globalStorageHome).with({scheme:g}),settingsResource:L.URI.revive(l.settingsResource).with({scheme:g}),keybindingsResource:L.URI.revive(l.keybindingsResource).with({scheme:g}),tasksResource:L.URI.revive(l.tasksResource).with({scheme:g}),snippetsHome:L.URI.revive(l.snippetsHome).with({scheme:g}),extensionsResource:L.URI.revive(l.extensionsResource).with({scheme:g}),cacheHome:L.URI.revive(l.cacheHome).with({scheme:g}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function o(l,g,E,D,y,k){return{id:l,name:g,location:E,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:k&&y?.useDefaultFlags?.globalState?k.globalStorageHome:(0,R.$fh)(E,"globalStorage"),settingsResource:k&&y?.useDefaultFlags?.settings?k.settingsResource:(0,R.$fh)(E,"settings.json"),keybindingsResource:k&&y?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,R.$fh)(E,"keybindings.json"),tasksResource:k&&y?.useDefaultFlags?.tasks?k.tasksResource:(0,R.$fh)(E,"tasks.json"),snippetsHome:k&&y?.useDefaultFlags?.snippets?k.snippetsHome:(0,R.$fh)(E,"snippets"),extensionsResource:k&&y?.useDefaultFlags?.extensions?k.extensionsResource:(0,R.$fh)(E,"extensions.json"),cacheHome:(0,R.$fh)(D,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let n=class extends C.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(g,E,D,y){super(),this.t=g,this.u=E,this.w=D,this.y=y,this.f=!0,this.h=this.B(new h.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$Ac,workspaces:new P.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$fh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$fh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(g){this.f!==g&&(this.z=void 0,this.f=g)}isEnabled(){return this.f}get C(){if(!this.z){const g=this.D(),E=[g];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,f.$eg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}E.push(o((0,R.$ch)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},g))}}catch(k){this.y.error(k)}const D=new P.$Ac,y=new Map;if(E.length)try{const k=this.Q();if(k.workspaces)for(const[A,p]of Object.entries(k.workspaces)){const v=L.URI.parse(A),F=E.find(N=>N.id===p);F&&D.set(v,F)}if(k.emptyWindows)for(const[A,p]of Object.entries(k.emptyWindows)){const v=E.find(F=>F.id===p);v&&y.set(A,v)}}catch(k){this.y.error(k)}this.z={profiles:E,workspaces:D,emptyWindows:y}}return this.z}D(){const g=o("__default__profile__",(0,T.localize)(11030,null),this.t.userRoamingDataHome,this.g);return{...g,extensionsResource:this.S()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const E="Temp",D=new RegExp(`${(0,$.$hf)(E)}\\s(\\d+)`);let y=0;for(const A of this.profiles){const p=D.exec(A.name),v=p?parseInt(p[1]):0;y=v>y?v:y}const k=`${E} ${y+1}`;return this.createProfile((0,r.$sj)((0,m.$1g)()).toString(16),k,{transient:!0},g)}async createNamedProfile(g,E,D){return this.createProfile((0,r.$sj)((0,m.$1g)()).toString(16),g,E,D)}async createProfile(g,E,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(g,E,D);return y&&await this.setProfileForWorkspace(y,k),k}async F(g,E,D){if(!(0,f.$eg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(E);return y||(y=(async()=>{try{if(this.profiles.find(v=>v.name===E||v.id===g))throw new Error(`Profile with ${E} name already exists`);const A=o(g,E,(0,R.$fh)(this.profilesHome,g),this.g,D,this.defaultProfile);await this.u.createFolder(A.location);const p=[];return this.j.fire({profile:A,join(v){p.push(v)}}),await a.Promises.settled(p),this.I([A],[],[]),A}finally{this.r.delete(E)}})(),this.r.set(E,y)),y}async updateProfile(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===g.id);if(!D)throw new Error(`Profile '${g.name}' does not exist`);return D=o(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(y=>y.id===g.id);if(!E)throw new Error(`Profile '${g.name}' does not exist`);const D=[];this.m.fire({profile:E,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(y){(0,c.$ql)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(g,D)}unsetWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(g,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const g=await this.u.resolve(this.profilesHome);await Promise.all((g.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const g=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(g.map(E=>this.removeProfile(E)))}getProfileForWorkspace(g){const E=this.G(g),D=L.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,u.$Oi)(g)?this.s.folders.get(g.uri):(0,u.$Ti)(g)?this.s.workspaces.get(g.configPath):this.s.emptyWindows.get(g.id))}G(g){return(0,u.$Oi)(g)?g.uri:(0,u.$Ti)(g)?g.configPath:g.id}H(g){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,g.location)))}I(g,E,D){const y=[...this.profiles,...g],k=[],A=this.s.profiles;this.s.profiles=[];for(let p of y){if(p.isDefault||E.some(F=>p.id===F.id))continue;p=D.find(F=>p.id===F.id)??p;const v=A.find(F=>p.id===F.id);if(p.isTransient)this.s.profiles.push(p);else{if(v){for(const[F,N]of this.s.emptyWindows.entries())if(p.id===N.id){this.L({id:F},p);break}for(const[F,N]of this.s.workspaces.entries())if(p.id===N.id){this.L({id:"",configPath:F},p);break}for(const[F,N]of this.s.folders.entries())if(p.id===N.id){this.L({id:"",uri:F},p);break}}k.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(k),this.z=void 0,this.J(g,E,D)}J(g,E,D){this.h.fire({added:g,removed:E,updated:D,all:this.profiles})}L(g,E,D){if(D=E?.isTransient?!0:D,D)(0,u.$Oi)(g)?(this.s.folders.delete(g.uri),E&&this.s.folders.set(g.uri,E)):(0,u.$Ti)(g)?(this.s.workspaces.delete(g.configPath),E&&this.s.workspaces.set(g.configPath,E)):(this.s.emptyWindows.delete(g.id),E&&this.s.emptyWindows.set(g.id,E));else{this.L(g,void 0,!0);const y=this.G(g);L.URI.isUri(y)?(this.C.workspaces.delete(y),E&&this.C.workspaces.set(y,E)):(this.C.emptyWindows.delete(y),E&&this.C.emptyWindows.set(y,E)),this.M()}}M(){const g={};for(const[D,y]of this.C.workspaces.entries())g[D.toString()]=y.id;const E={};for(const[D,y]of this.C.emptyWindows.entries())E[D.toString()]=y.id;this.R({workspaces:g,emptyWindows:E}),this.z=void 0}N(g){const E={},D=this.D();if(g.workspaces)for(const[k,A]of Object.entries(g.workspaces)){const p=L.URI.parse(A);E[k]=this.w.extUri.isEqual(p,D.location)?D.id:this.w.extUri.basename(p)}const y={};if(g.emptyWindows)for(const[k,A]of Object.entries(g.emptyWindows)){const p=L.URI.parse(A);y[k]=this.w.extUri.isEqual(p,D.location)?D.id:this.w.extUri.basename(p)}return{workspaces:E,emptyWindows:y}}O(){return[]}P(g){throw new Error("not implemented")}Q(){return{}}R(g){throw new Error("not implemented")}S(){}};e.$Ol=n,e.$Ol=n=Je([Ve(0,b.$Li),Ve(1,c.$_k),Ve(2,w.$Jl),Ve(3,S.$_j)],n);class d extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(g){this.a=g}Q(){return this.X}R(g){this.X=g}}e.$Pl=d}),define(ke[151],Ie([1,0,7,4,3,61,17,193,5,150]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$jq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hq=e.$gq=e.$fq=void 0,e.$iq=P,e.$kq=a,e.$mq=$,e.$fq="__$__isNewStorageMarker",e.$gq="__$__targetStorageMarker",e.$hq=(0,b.$Ei)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var u;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function P(f){const i=f.get(e.$gq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends C.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new h.$oe),this.c=this.B(new h.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$le),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,t){return h.Event.filter(this.b.event,o=>o.scope===i&&(s===void 0||o.key===s),t)}n(){this.j.value=(0,r.$Uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:t,external:o}=s;if(t===e.$gq){switch(i){case S.APPLICATION:this.H=void 0;break;case S.PROFILE:this.F=void 0;break;case S.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,s,t){return this.P(s)?.get(i,t)}getBoolean(i,s,t){return this.P(s)?.getBoolean(i,t)}getNumber(i,s,t){return this.P(s)?.getNumber(i,t)}getObject(i,s,t){return this.P(s)?.getObject(i,t)}storeAll(i,s){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,s)})}store(i,s,t,o,n=!1){if((0,L.$ng)(s)){this.remove(i,t,n);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,s,n)})}remove(i,s,t=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const t=[],o=this.J(i);for(const n of Object.keys(o))o[n]===s&&t.push(n);return t}z(i,s,t,o=!1){const n=this.J(s);typeof t=="number"?n[i]!==t&&(n[i]=t,this.P(s)?.set(e.$gq,JSON.stringify(n),o)):typeof n[i]=="number"&&(delete n[i],this.P(s)?.set(e.$gq,JSON.stringify(n),o))}get D(){return this.C||(this.C=this.L(S.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(S.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(S.APPLICATION)),this.H}J(i){switch(i){case S.APPLICATION:return this.I;case S.PROFILE:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?P(s):Object.create(null)}isNew(i){return this.getBoolean(e.$fq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const s=this.P(S.APPLICATION),t=this.P(S.PROFILE),o=this.P(S.WORKSPACE);switch(i){case I.NONE:await r.Promises.settled([s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(S.APPLICATION)?.items??new Map,s=this.P(S.PROFILE)?.items??new Map,t=this.P(S.WORKSPACE)?.items??new Map;return $(i,s,t,this.Q(S.APPLICATION)??"",this.Q(S.PROFILE)??"",this.Q(S.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(I.NONE),(0,c.$Kl)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||a(s)&&a(i))}N(i,s,t){this.y(()=>{const o=new Set;for(const[n,d]of i)o.add(n),s.get(n)!==d&&this.u(t,{key:n,external:!0});for(const[n]of s.items)o.has(n)||this.u(t,{key:n,external:!0})})}}e.$jq=w;function a(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class m extends w{constructor(){super(),this.U=this.B(new T.$dq(new T.$eq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$dq(new T.$eq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$dq(new T.$eq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(S.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(S.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(S.APPLICATION,i)))}P(i){switch(i){case S.APPLICATION:return this.U;case S.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case S.APPLICATION:return"inMemory (application)";case S.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$lq=m;async function $(f,i,s,t,o,n){const d=v=>{try{return JSON.parse(v)}catch{return v}},l=new Map,g=new Map;f.forEach((v,F)=>{l.set(F,v),g.set(F,d(v))});const E=new Map,D=new Map;i.forEach((v,F)=>{E.set(F,v),D.set(F,d(v))});const y=new Map,k=new Map;s.forEach((v,F)=>{y.set(F,v),k.set(F,d(v))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const A=[];if(l.forEach((v,F)=>{A.push({key:F,value:v})}),console.table(A),console.groupEnd(),console.log(g),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const v=[];E.forEach((F,N)=>{v.push({key:N,value:F})}),console.table(v),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${n})`);const p=[];y.forEach((v,F)=>{p.push({key:F,value:v})}),console.table(p),console.groupEnd(),console.log(k)}}),define(ke[118],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0;class r{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const R=this.c++;return this.b.set(R,C),this.e(),R}get(C,R){return this.b.has(C)?this.b.get(C)[R]:void 0}delete(C){this.b.delete(C),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$epc=r}),define(ke[62],Ie([1,0,14,22,27,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=e.$jpc=void 0;class L{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$7g(b=>{const c=this.b.get(b.scheme);return!(c===void 0||c&C.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(b,c){c===null?this.b.delete(b.scheme):this.b.set(b.scheme,c)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$jpc=L,e.$kpc=(0,R.$Ei)("IExtHostFileSystemInfo")}),define(ke[29],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=void 0,e.$xQ=(0,r.$Ei)("IExtHostInitDataService")}),define(ke[248],Ie([1,0,8,11,228,29]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0;let L=class extends C.$HR{constructor(b,c,I){const S=I.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",u=I.remote.isRemote?(0,r.localize)(10783,null):b?(0,r.localize)(10784,null):(0,r.localize)(10785,null);super(c.createLogger(S,{name:u}))}};e.$src=L,e.$src=L=Je([Ve(1,h.$ak),Ve(2,R.$xQ)],L)}),define(ke[249],Ie([1,0,7]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=e.$2pc=void 0;class h{constructor(L,T,b){this.h=new Map,this.a=L,this.b=T,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new r.$Qh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of c.values())I.complete()}catch(I){for(const S of c.values())S.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,T){let b=this.f[L];return typeof b>"u"&&(b=T),b}update(L,T){this.f[L]=T;const b=this.h.get(L);if(b!==void 0)return b.p;const c=new r.$2h;return this.h.set(L,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$2pc=h;class C extends h{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,T){super(L.identifier.value,!0,T),this.j=L}}e.$3pc=C}),define(ke[250],Ie([1,0,4,2]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=void 0;class C{constructor(L){this.c=L,this.a=new r.$le,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$le,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,T,b,c){const S=this.c.getNotebookDocument(h.URI.revive(L)).acceptModelChanged(T.value,b,c);this.b.fire(S)}$acceptDirtyStateChanged(L,T){this.c.getNotebookDocument(h.URI.revive(L)).acceptDirty(T)}$acceptModelSaved(L){const T=this.c.getNotebookDocument(h.URI.revive(L));this.a.fire(T.apiNotebook)}}e.$Wqc=C}),define(ke[19],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=void 0,e.$hQ=(0,r.$Ei)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$iQ=h}),define(ke[251],Ie([1,0,23,4,3]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;class R{#e;constructor(T,b){this.disposables=new C.$Tc,this.a=r.$qn.toKey(T.identifier),this.#e=b,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,c=>c.extensionId===this.a),c=>({key:c.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,b){return this.#e.store(this.a,T,b)}delete(T){return this.#e.delete(this.a,T)}}e.$_pc=R}),define(ke[72],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=e.$zpc=void 0,e.$zpc=(0,r.$Ei)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Apc=h}),define(ke[252],Ie([1,0,253,362,363,67,2,11,364]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1rc=I,r=qe(r),h=qe(h),C=qe(C),R=qe(R);const c=!1;function I(i,s,t,o,n,d){const l=d.environment.useHostProxy,g=typeof l=="boolean"?l:!d.remote.isRemote,E={resolveProxy:k=>i.resolveProxy(k),lookupProxyAuthorization:m.bind(void 0,i,o,n,s,{},{},d.remote.isRemote,g),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>s.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>u(s),addCertificatesV2:()=>P(s),log:o,getLogLevel:()=>{const k=o.getLevel();switch(k){case T.LogLevel.Trace:return b.LogLevel.Trace;case T.LogLevel.Debug:return b.LogLevel.Debug;case T.LogLevel.Info:return b.LogLevel.Info;case T.LogLevel.Warning:return b.LogLevel.Warning;case T.LogLevel.Error:return b.LogLevel.Error;case T.LogLevel.Off:return b.LogLevel.Off;default:return A(k)}function A(p){return o.error("Unknown log level",p),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:g,loadAdditionalCertificates:async()=>{const k=[];if(d.remote.isRemote&&k.push((0,b.loadSystemCertificates)({log:o})),g){o.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const A=i.loadCertificates();A.then(p=>o.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",p.length)),k.push(A)}return d.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(o.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),k.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(k)).flat()},env:process.env},D=(0,b.createProxyResolver)(E),y=S(E,D);return a(t,y)}function S(i,s){function t(o,n){return Object.assign(o.default||o,n)}return{http:t(r,(0,b.createHttpPatch)(i,r,s)),https:t(h,(0,b.createHttpPatch)(i,h,s)),net:t(R,(0,b.createNetPatch)(i,R)),tls:t(C,(0,b.createTlsPatch)(i,C))}}function u(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}function P(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}const w=new Map;function a(i,s){return i.getExtensionPathIndex().then(t=>{const o=globalThis._VSCODE_NODE_MODULES.module,n=o._load;o._load=function(l,g,E){if(l==="net")return s.net;if(l==="tls")return s.tls;if(l!=="http"&&l!=="https")return n.apply(this,arguments);const D=t.findSubstr(L.URI.file(g.filename));let y=w.get(D);if(y||w.set(D,y={}),!y[l]){const k=s[l];y[l]={...k}}return y[l]}})}async function m(i,s,t,o,n,d,l,g,E,D,y){const k=n[E];D&&(n[E]=D),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${E}`,`proxyAuthenticate:${D}`,`proxyAuthenticateCache:${k}`);const A=D||k,p=Array.isArray(A)?A:typeof A=="string"?[A]:[];if(f(t,p,l),p.some(F=>/^(Negotiate|Kerberos)( |$)/i.test(F))&&!y.kerberosRequested){y.kerberosRequested=!0;try{const F=await new Promise((M,U)=>{$e(["kerberos"],M,U)}).then(qe),N=new URL(E),O=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${N.hostname}`:`HTTP@${N.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${E}`,`spn:${O}`),"Negotiate "+await(await F.initializeClient(O)).step("")}catch(F){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",F)}if(l&&g){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup on host",`proxyURL:${E}`);const F=await i.lookupKerberosAuthorization(E);if(F)return"Negotiate "+F}}const v=p.find(F=>/^Basic( |$)/i.test(F));if(v)try{const F=d[E];if(F)if(y.basicAuthCacheUsed)s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication deleting cached credentials",`proxyURL:${E}`),delete d[E];else return s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication using cached credentials",`proxyURL:${E}`),y.basicAuthCacheUsed=!0,F;y.basicAuthAttempt=(y.basicAuthAttempt||0)+1;const N=/ realm="([^"]+)"/i.exec(v)?.[1];s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication lookup",`proxyURL:${E}`,`realm:${N}`);const O=new URL(E),j={scheme:"basic",host:O.hostname,port:Number(O.port),realm:N||"",isProxy:!0,attempt:y.basicAuthAttempt},z=await i.lookupAuthorization(j);if(z){s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received credentials",`proxyURL:${E}`,`realm:${N}`);const M="Basic "+Buffer.from(`${z.username}:${z.password}`).toString("base64");return d[E]=M,M}else s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received no credentials",`proxyURL:${E}`,`realm:${N}`)}catch(F){s.error("ProxyResolver#lookupProxyAuthorization Basic authentication failed",F)}}let $=!1;function f(i,s,t){$||!s.length||($=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(o=>o.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(ke[254],Ie([1,0,138]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=C;function h(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function C(R){return new r.$Ln(h(R))}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[152],Ie([1,0,8,17,2,3,5,36,27,14,52,211,43]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$pG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$fG=e.EditorInputCapabilities=e.$eG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=void 0,e.$8F=a,e.$9F=m,e.$0F=$,e.$$F=f,e.$_F=i,e.$aG=s,e.$bG=t,e.$cG=o,e.$dG=n,e.$gG=y,e.$hG=A,e.$iG=p,e.$jG=v,e.$kG=F,e.$lG=N,e.$mG=O,e.$nG=j,e.$oG=B,e.$qG=_,e.$rG=re,e.$sG=Se,e.$tG=me,u=Ut(u),e.$3F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$4F={id:"default",displayName:(0,r.localize)(12426,null),providerDisplayName:(0,r.localize)(12427,null)},e.$5F="workbench.editor.sidebysideEditor",e.$6F="workbench.editors.textDiffEditor",e.$7F="workbench.editors.binaryResourceDiffEditor";var P;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var w;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function a(Q){const q=Q;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function m(Q){const q=Q;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function $(Q,q,se){for(const we of se.visibleEditorPanes)if(we.group.id===q&&Q.matches(we.input))return we.getViewState()}function f(Q){if(y(Q))return!1;const q=Q;return C.URI.isUri(q?.resource)}function i(Q){if(y(Q))return!1;const q=Q;return q?.original!==void 0&&q.modified!==void 0}function s(Q){if(y(Q))return!1;const q=Q;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(Q){if(y(Q)||i(Q))return!1;const q=Q;return q?.primary!==void 0&&q.secondary!==void 0}function o(Q){if(y(Q))return!1;const q=Q;return q?q.resource===void 0||q.resource.scheme===c.Schemas.untitled||q.forceUntitled===!0:!1}function n(Q){if(y(Q))return!1;const q=Q;return C.URI.isUri(q?.base?.resource)&&C.URI.isUri(q?.input1?.resource)&&C.URI.isUri(q?.input2?.resource)&&C.URI.isUri(q?.result?.resource)}var d;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class g{constructor(){this.a=new Map}registerSource(q,se){let we=this.a.get(q);return we||(we={source:q,label:se},this.a.set(q,we)),we.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$eG=new g;var E;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors",Q[Q.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends R.$Uc{}e.$fG=D;function y(Q){return Q instanceof D}function k(Q){const q=Q;return C.URI.isUri(q?.preferredResource)}function A(Q){const q=Q;return y(q?.primary)&&y(q?.secondary)}function p(Q){const q=Q;return y(q?.modified)&&y(q?.original)}function v(Q,q,se,we,ee){return me(we,[(0,S.$oj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(12428,null),run:()=>{const ae={...se,limits:{size:Number.MAX_VALUE}};Q.openEditor(q,ae)}}),(0,S.$oj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(12429,null),run:()=>ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function F(Q){return y(Q?.editor)}function N(Q){const q=Q;return F(Q)&&q?.group!==void 0}function O(Q){const q=Q;return typeof q?.groupId=="number"&&y(q.editor)}function j(Q){return typeof Q?.groupId=="number"}var z;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LABEL=2]="GROUP_LABEL",Q[Q.GROUP_LOCKED=3]="GROUP_LOCKED",Q[Q.EDITORS_SELECTION=4]="EDITORS_SELECTION",Q[Q.EDITOR_OPEN=5]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=6]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=7]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=9]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=11]="EDITOR_PIN",Q[Q.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Q[Q.EDITOR_STICKY=13]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=14]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var U;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class V{getOriginalUri(q,se){if(!q)return;if(n(q))return e.$pG.getOriginalUri(q.result,se);if(se?.supportSideBySide){const{primary:ee,secondary:ae}=this.a(q);if(ee&&ae){if(se?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ee,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===U.ANY)return this.getOriginalUri(ee,{filterByScheme:se.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:se.filterByScheme});q=se.supportSideBySide===U.PRIMARY?ee:ae}}if(i(q)||s(q)||t(q)||n(q))return;const we=k(q)?q.preferredResource:q.resource;return!we||!se||!se.filterByScheme?we:this.b(we,se.filterByScheme)}a(q){return A(q)||t(q)?{primary:q.primary,secondary:q.secondary}:p(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,se){if(!q)return;if(n(q))return e.$pG.getCanonicalUri(q.result,se);if(se?.supportSideBySide){const{primary:ee,secondary:ae}=this.a(q);if(ee&&ae){if(se?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ee,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===U.ANY)return this.getCanonicalUri(ee,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:se.filterByScheme});q=se.supportSideBySide===U.PRIMARY?ee:ae}}if(i(q)||s(q)||t(q)||n(q))return;const we=q.resource;return!we||!se||!se.filterByScheme?we:this.b(we,se.filterByScheme)}b(q,se){if(Array.isArray(se)){if(se.some(we=>q.scheme===we))return q}else if(se===q.scheme)return q}}var ie;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.KEYBOARD=1]="KEYBOARD",Q[Q.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function B(Q,q,se,we){if(!Q.isSticky(q))return!1;switch(we.preventPinnedEditorClose){case"keyboardAndMouse":return se===ie.MOUSE||se===ie.KEYBOARD;case"mouse":return se===ie.MOUSE;case"keyboard":return se===ie.KEYBOARD}return!1}e.$pG=new V;var Y;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class J{constructor(){this.c=new Map,this.d=new Map}start(q){const se=this.a=q.get(L.$Di);for(const[we,ee]of this.c)this.e(we,ee,se);this.c.clear()}e(q,se,we){const ee=we.createInstance(se);this.d.set(q,ee)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,h.$pg)(this.b)}registerEditorSerializer(q,se){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,se,this.a):this.c.set(q,se),(0,R.$Sc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}T.$qo.add(e.$3F.EditorFactory,new J);async function _(Q,q,se){return!Q||!Q.length?[]:await Promise.all(Q.map(async we=>{const ee=C.URI.revive(we.fileUri);if(!ee){se.info("Cannot resolve the path because it is not valid.",we);return}if(!await q.canHandleResource(ee)){se.info("Cannot resolve the path because it cannot be handled",we);return}let oe=we.exists,x=we.type;if(typeof oe!="boolean"||typeof x!="number")try{x=(await q.stat(ee)).isDirectory?b.FileType.Directory:b.FileType.Unknown,oe=!0}catch(pe){se.error(pe),oe=!1}if(!oe&&we.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",we);return}if(x===b.FileType.Directory){se.info("Cannot resolve the path because it is a directory",we);return}const ne={...we.options,pinned:!0};return oe?{resource:ee,options:ne}:{resource:ee,options:ne,forceUntitled:!0}}))}var le;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function re(Q){const q=Q;if(!q)return!1;const se=q;if(se.modified)return re(se.modified);const we=q;return!!(we.contributionsState&&we.viewState&&Array.isArray(we.cursorState))}function Se(Q){return(0,I.$qj)(Q)}function me(Q,q,se){const we=(0,I.$rj)(Q,q);return we.forceMessage=se?.forceMessage,we.forceSeverity=se?.forceSeverity,we.allowDialog=se?.allowDialog,we}}),define(ke[255],Ie([1,0,4,8,5,3,28,36,24,82,244]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BG=e.$AG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$zG=e.ViewContentGroups=e.$xG=e.ViewContainerLocation=e.Extensions=e.$wG=e.$vG=e.$uG=void 0,e.$yG=P,e.$uG="views",e.$vG=(0,h.localize)(12266,null),e.$wG=(0,I.$Ax)("default-view-icon",c.$4j.window,(0,h.localize)(12267,null));var S;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$xG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function P(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class w extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new r.$le),this.onDidRegister=this.c.event,this.f=this.B(new r.$le),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(n,d,l){const g=this.get(n.id);if(g)return g;const E=n;return E.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,L.$xc)(this.g,d,[]).push(E),l?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:d}),E}deregisterViewContainer(n){for(const d of this.g.keys()){const l=this.g.get(d),g=l?.indexOf(n);if(g!==-1){l?.splice(g,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:n,viewContainerLocation:d});return}}}get(n){return this.all.filter(d=>d.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(d=>this.getViewContainerLocation(d)===n)}}T.$qo.add(S.ViewContainersRegistry,new w);var a;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(a||(e.ViewContentGroups=a={}));function m(o,n){const d=o.group??a.More,l=n.group??a.More;return d!==l?d.localeCompare(l):(o.order??5)-(n.order??5)}class $ extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new r.$le),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$le),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$le),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$le),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Hc}registerViews(n,d){this.registerViews2([{views:n,viewContainer:d}])}registerViews2(n){n.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(n)}deregisterViews(n,d){const l=this.s(n,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(n,d){for(const l of this.m.keys())if(l!==d){const g=this.s(n,l);g.length&&(this.r(g,d),this.g.fire({views:g,from:l,to:d}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const d of this.j){const l=(this.m.get(d)||[]).filter(g=>g.id===n)[0];if(l)return l}return null}getViewContainer(n){for(const d of this.j)if((this.m.get(d)||[]).filter(g=>g.id===n)[0])return d;return null}registerViewWelcomeContent(n,d){return this.n.add(n,d),this.h.fire(n),(0,R.$Sc)(()=>{this.n.delete(n,d),this.h.fire(n)})}registerViewWelcomeContent2(n,d){const l=new Map;for(const[g,E]of d)this.n.add(n,E),l.set(g,(0,R.$Sc)(()=>{this.n.delete(n,E),this.h.fire(n)}));return this.h.fire(n),l}getViewWelcomeContent(n){const d=[];return this.n.forEach(n,l=>d.push(l)),d.sort(m)}r(n,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const g of n){if(this.getView(g.id)!==null)throw new Error((0,h.localize)(12268,null,g.id));l.push(g)}}s(n,d){const l=this.m.get(d);if(!l)return[];const g=[],E=[];for(const D of l)n.includes(D)?g.push(D):E.push(D);return g.length&&(E.length?this.m.set(d,E):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),g}}T.$qo.add(S.ViewsRegistry,new $),e.$zG=(0,C.$Ei)("viewDescriptorService");var f;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(f||(e.ViewVisibilityState=f={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class s{constructor(n,d){this.c=!1,this.d=!1,(0,b.$go)(this,n),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const g=await d(l);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$AG=s;class t extends Error{constructor(n){super((0,h.localize)(12269,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$BG=t}),define(ke[256],Ie([1,0,8,35]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=void 0,e.$FG=new h.$Vj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(8391,null)}),e.$GG=new h.$Vj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(8392,null)}),e.$HG=new h.$Vj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(8393,null)}),e.$IG=new h.$Vj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(8394,null)}),e.$JG=new h.$Vj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(8395,null)}),e.$KG=new h.$Vj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(8396,null)}),e.$LG=new h.$Vj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(8397,null)}),e.$MG=new h.$Vj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(8398,null)}),e.$NG=new h.$Vj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8399,null)}),e.$OG=new h.$Vj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(8400,null)}),e.$PG=new h.$Vj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(8401,null)}),e.$QG=new h.$Vj("inChat",!1,{type:"boolean",description:(0,r.localize)(8402,null)}),e.$RG=new h.$Vj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(8403,null)}),e.$SG=new h.$Vj("chatCursorAtTop",!1),e.$TG=new h.$Vj("chatInputHasAgent",!1),e.$UG=new h.$Vj("chatLocation",void 0),e.$VG=new h.$Vj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(8404,null)})}),define(ke[153],Ie([1,0,131,7,20,4,39,3,51,182,12,35,23,5,11,115,237,151,256]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.ChatAgentLocation=void 0,e.$ZH=d,e.$1H=l;var s;(function(g){g.Panel="panel",g.Terminal="terminal",g.Notebook="notebook",g.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(g){function E(D){switch(D){case"panel":return g.Panel;case"terminal":return g.Terminal;case"notebook":return g.Notebook;case"editor":return g.Editor}return g.Panel}g.fromRaw=E}(s||(e.ChatAgentLocation=s={})),e.$UH=(0,P.$Ei)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new R.$le,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=f.$RG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const k=this,A=D.slashCommands;D={...D,get slashCommands(){return A.filter(v=>!v.when||k.f.contextMatchesRules(S.$Cj.deserialize(v.when)))}};const p={data:D};return this.b.set(E,p),(0,T.$Sc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const y=this.b.get(E);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new o(y.data,D)),(0,T.$Sc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const y={data:E,impl:D};return this.b.set(E.id,y),this.d.fire(new o(E,D)),(0,T.$Sc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,y){return await this.g.get(E)?.(D,y)??[]}updateAgent(E,D){const y=this.b.get(E);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new o(y.data,y.impl))}getDefaultAgent(E){return(0,r.$eb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return L.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(S.$Cj.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=L.Iterable.find(this.b.values(),y=>d(y.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new o(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(y=>y.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,y,k,A){const p=this.b.get(E);if(!p?.impl)throw new Error(`No activated agent with id "${E}"`);return await p.impl.invoke(D,y,k,A)}async getFollowups(E,D,y,k,A){const p=this.b.get(E);if(!p?.impl)throw new Error(`No activated agent with id "${E}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(D,y,k,A):[]}};e.$VH=t,e.$VH=t=Je([Ve(0,S.$Wj)],t);class o{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,y,k){return this.d.invoke(E,D,y,k)}async provideFollowups(E,D,y,k){return this.d.provideFollowups?this.d.provideFollowups(E,D,y,k):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$WH=o,e.$XH=(0,P.$Ei)("chatAgentNameService");let n=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,y,k){if(this.g=D,this.h=y,this.i=k,this.e=(0,c.$6d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const A=k.get(i.b,$.StorageScope.APPLICATION);try{this.e.set(JSON.parse(A??"{}"),void 0)}catch{k.remove(i.b,$.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,h.$Fh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.$aq)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(i.b,JSON.stringify(y),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),y=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&y}l(E,D){return this.e.map(k=>k[E.toLowerCase()]).map(k=>k?k.some(A=>(0,I.$Ff)(A,A.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$YH=n,e.$YH=n=i=Je([Ve(0,a.$sk),Ve(1,m.$7p),Ve(2,w.$_j),Ve(3,$.$hq)],n);function d(g){return`${g.extensionId.value}.${g.id}`}function l(g){const E="name"in g?g:{...g,name:g.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new u.$qn("")),(0,b.$bi)(E)}}),define(ke[257],Ie([1,0,2,30,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tH=e.$sH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$qH=R,e.$rH=L;function R(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof r.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(h.$Nt.isIRange)}function L(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(R)}var T;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(T||(e.ChatResponseReferencePartStatusKind=T={}));var b;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(b||(e.ChatAgentVoteDirection=b={}));var c;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(c||(e.ChatCopyKind=c={})),e.$sH=(0,C.$Ei)("IChatService"),e.$tH="accessibility.voice.keywordActivation"}),define(ke[154],Ie([1,0,4,7,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5tb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$le,this.o=new r.$le,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,b,c,I){const S={command:T};if(b&&Object.keys(b).length>0&&(S.arguments=b),this.u("request",S),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const P=this.f.get(S.seq);if(P){this.f.delete(S.seq);const w={type:"response",seq:0,request_seq:S.seq,success:!1,command:T,message:(0,C.localize)(7487,null,I,T)};P(w)}},I)}return c&&this.f.set(S.seq,c),S.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,b){return T.type!=="event"||b.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,h.$Fh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const b=T,c=this.f.get(b.request_seq);c&&(this.f.delete(b.request_seq),c(b));break}}}}u(T,b){b.type=T,b.seq=this.d++,this.sendMessage(b)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((b,c)=>T.set(c,b)),await(0,h.$Fh)(500),T.forEach((b,c)=>{b({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$5tb=R}),define(ke[119],Ie([1,0,2,8,35,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$NK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$LK=e.MemoryRangeType=e.State=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=void 0,e.$KK=b,e.$MK=I,h=qe(h),e.$yJ="workbench.view.debug",e.$zJ="workbench.debug.variablesView",e.$AJ="workbench.debug.watchExpressionsView",e.$BJ="workbench.debug.callStackView",e.$CJ="workbench.debug.loadedScriptsView",e.$DJ="workbench.debug.breakPointsView",e.$EJ="workbench.debug.disassemblyView",e.$FJ="workbench.panel.repl",e.$GJ="workbench.panel.repl.view",e.$HJ=new C.$Vj("debugType",void 0,{type:"string",description:h.localize(7424,null)}),e.$IJ=new C.$Vj("debugConfigurationType",void 0,{type:"string",description:h.localize(7425,null)}),e.$JJ=new C.$Vj("debugState","inactive",{type:"string",description:h.localize(7426,null)}),e.$KJ="debugUx",e.$LJ=new C.$Vj(e.$KJ,"default",{type:"string",description:h.localize(7427,null)}),e.$MJ=new C.$Vj("hasDebugged",!1,{type:"boolean",description:h.localize(7428,null)}),e.$NJ=new C.$Vj("inDebugMode",!1,{type:"boolean",description:h.localize(7429,null)}),e.$OJ=new C.$Vj("inDebugRepl",!1,{type:"boolean",description:h.localize(7430,null)}),e.$PJ=new C.$Vj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7431,null)}),e.$QJ=new C.$Vj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(7432,null)}),e.$RJ=new C.$Vj("breakpointsFocused",!0,{type:"boolean",description:h.localize(7433,null)}),e.$SJ=new C.$Vj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(7434,null)}),e.$TJ=new C.$Vj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(7435,null)}),e.$UJ=new C.$Vj("variablesFocused",!0,{type:"boolean",description:h.localize(7436,null)}),e.$VJ=new C.$Vj("expressionSelected",!1,{type:"boolean",description:h.localize(7437,null)}),e.$WJ=new C.$Vj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(7438,null)}),e.$XJ=new C.$Vj("callStackItemType",void 0,{type:"string",description:h.localize(7439,null)}),e.$YJ=new C.$Vj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(7440,null)}),e.$ZJ=new C.$Vj("callStackItemStopped",!1,{type:"boolean",description:h.localize(7441,null)}),e.$1J=new C.$Vj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(7442,null)}),e.$2J=new C.$Vj("watchItemType",void 0,{type:"string",description:h.localize(7443,null)}),e.$3J=new C.$Vj("canViewMemory",void 0,{type:"boolean",description:h.localize(7444,null)}),e.$4J=new C.$Vj("breakpointItemType",void 0,{type:"string",description:h.localize(7445,null)}),e.$5J=new C.$Vj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(7446,null)}),e.$6J=new C.$Vj("breakpointHasModes",!1,{type:"boolean",description:h.localize(7447,null)}),e.$7J=new C.$Vj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(7448,null)}),e.$8J=new C.$Vj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(7449,null)}),e.$9J=new C.$Vj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(7450,null)}),e.$0J=new C.$Vj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(7451,null)}),e.$$J=new C.$Vj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(7452,null)}),e.$_J=new C.$Vj("stepBackSupported",!1,{type:"boolean",description:h.localize(7453,null)}),e.$aK=new C.$Vj("restartFrameSupported",!1,{type:"boolean",description:h.localize(7454,null)}),e.$bK=new C.$Vj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(7455,null)}),e.$cK=new C.$Vj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(7456,null)}),e.$dK=new C.$Vj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(7457,null)}),e.$eK=new C.$Vj("breakpointsExist",!1,{type:"boolean",description:h.localize(7458,null)}),e.$fK=new C.$Vj("debuggersAvailable",!1,{type:"boolean",description:h.localize(7459,null)}),e.$gK=new C.$Vj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(7460,null)}),e.$hK=new C.$Vj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(7461,null)}),e.$iK=new C.$Vj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(7462,null)}),e.$jK=new C.$Vj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(7463,null)}),e.$kK=new C.$Vj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(7464,null)}),e.$lK=new C.$Vj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(7465,null)}),e.$mK=new C.$Vj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(7466,null)}),e.$nK=new C.$Vj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(7467,null)}),e.$oK=new C.$Vj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(7468,null)}),e.$pK=new C.$Vj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(7469,null)}),e.$qK=new C.$Vj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(7470,null)}),e.$rK=new C.$Vj("variableIsReadonly",!1,{type:"boolean",description:h.localize(7471,null)}),e.$sK=new C.$Vj("variableValue",!1,{type:"string",description:h.localize(7472,null)}),e.$tK=new C.$Vj("variableType",!1,{type:"string",description:h.localize(7473,null)}),e.$uK=new C.$Vj("variableInterfaces",!1,{type:"array",description:h.localize(7474,null)}),e.$vK=new C.$Vj("variableName",!1,{type:"string",description:h.localize(7475,null)}),e.$wK=new C.$Vj("variableLanguage",!1,{type:"string",description:h.localize(7476,null)}),e.$xK=new C.$Vj("variableExtensionId",!1,{type:"string",description:h.localize(7477,null)}),e.$yK=new C.$Vj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(7478,null)}),e.$zK=new C.$Vj("multiSessionRepl",!1,{type:"boolean",description:h.localize(7479,null)}),e.$AK=new C.$Vj("multiSessionDebug",!1,{type:"boolean",description:h.localize(7480,null)}),e.$BK=new C.$Vj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(7481,null)}),e.$CK=new C.$Vj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(7482,null)}),e.$DK=new C.$Vj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(7483,null)}),e.$EK=new C.$Vj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(7484,null)});const L=i=>h.localize(7485,null,i);e.$FK=L,e.$GK="editor.contrib.debug",e.$HK="editor.contrib.breakpoint",e.$IK="debug",e.$JK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(7486,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function b(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var c;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$LK="vscode-debug-memory";function I(i){const s=i.presentationHint??i.source.presentationHint;return s==="deemphasize"||s==="subtle"}var S;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var P;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$NK=(0,R.$Ei)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var $;(function(i){i.deserialize=s=>s,i.serialize=s=>s})($||(e.IDebugVisualizationTreeItem=$={}));var f;(function(i){i.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:r.URI.revive(s.iconPath.light),dark:r.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),i.serialize=s=>s})(f||(e.IDebugVisualization=f={}))}),define(ke[258],Ie([1,0,12,2,16,24,14,30,20,18]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fI=void 0,e.$6H=S,e.$7H=u,e.$8H=P,e.$9H=w,e.$0H=a,e.$$H=m,e.$_H=$,e.$aI=i,e.$bI=o,e.$cI=n,e.$dI=l,e.$eI=E;const I=/{([^}]+)}/g;function S(y,k,A){return y.replace(I,function(p,v){return k&&v.length>0&&v[0]!=="_"?p:A&&A.hasOwnProperty(v)?A[v]:p})}function u(y){const k={};for(const A of Object.keys(y))A.startsWith("!")||(k[A]=y[A]);return k}function P(y){return y.configuration.request==="attach"&&!w(y)&&(!y.parentSession||P(y.parentSession))}function w(y){let k=y.configuration.type;if(k)return k==="vslsShare"&&(k=y.configuration.adapterProxy.configuration.type),(0,r.$Ff)(k,"extensionhost")||(0,r.$Ff)(k,"pwa-extensionhost")?y:y.parentSession?w(y.parentSession):void 0}function a(y){return y.type&&(y.label||y.program||y.runtime)}function m(y,k,A){let p,v=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(y);){const O=N.index+1,j=O+N[0].length;if(O<=k&&j>=A){p=N[0],v=O;break}}if(p){const O=/(\w|\p{L})+/gu;let j=null;for(;(j=O.exec(p))&&!(j.index+1+v+j[0].length>=A););j&&(p=p.substring(0,O.lastIndex))}return p?{start:v,end:v+p.length-1}:{start:0,end:0}}async function $(y,k,A,p){if(y.evaluatableExpressionProvider.has(k)){const v=y.evaluatableExpressionProvider.ordered(k),F=(0,c.$Gb)(await Promise.all(v.map(async N=>{try{return await N.provideEvaluatableExpression(k,A,p??b.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const O=F[0].range;return N||(N=k.getLineContent(A.lineNumber).substring(O.startColumn-1,O.endColumn-1)),{range:O,matchingExpression:N}}}else{const v=k.getLineContent(A.lineNumber),{start:F,end:N}=m(v,A.column,A.column),O=v.substring(F-1,N);return{matchingExpression:O,range:new T.$Nt(A.lineNumber,F,A.lineNumber,F+O.length)}}return null}const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(f))}function s(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return h.URI.parse(y.path);if((0,C.$ic)(y.path))return h.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const k=h.URI.revive(y.path);if(k)return k.scheme===L.Schemas.file?k.fsPath:k.toString()}return y.path}function o(y,k){const A=k?s:t,p=(0,R.$do)(y);return d(p,(v,F)=>{v&&F&&(F.path=A(F))}),p}function n(y,k){const A=k?s:t,p=(0,R.$do)(y);return d(p,(v,F)=>{!v&&F&&(F.path=A(F))}),p}function d(y,k){switch(y.type){case"event":{const A=y;switch(A.event){case"output":k(!1,A.body.source);break;case"loadedSource":k(!1,A.body.source);break;case"breakpoint":k(!1,A.body.breakpoint.source);break;default:break}break}case"request":{const A=y;switch(A.command){case"setBreakpoints":k(!0,A.arguments.source);break;case"breakpointLocations":k(!0,A.arguments.source);break;case"source":k(!0,A.arguments.source);break;case"gotoTargets":k(!0,A.arguments.source);break;case"launchVSCode":A.arguments.args.forEach(p=>k(!1,p));break;default:break}break}case"response":{const A=y;if(A.success&&A.body)switch(A.command){case"stackTrace":A.body.stackFrames.forEach(p=>k(!1,p.source));break;case"loadedSources":A.body.sources.forEach(p=>k(!1,p));break;case"scopes":A.body.scopes.forEach(p=>k(!1,p.source));break;case"setFunctionBreakpoints":A.body.breakpoints.forEach(p=>k(!1,p.source));break;case"setBreakpoints":A.body.breakpoints.forEach(p=>k(!1,p.source));break;case"disassemble":A.body?.instructions.forEach(v=>k(!1,v.location));break;default:break}break}}}function l(y){return y.filter(k=>!k.presentation?.hidden).sort((k,A)=>k.presentation?A.presentation?k.presentation.group?A.presentation.group?k.presentation.group!==A.presentation.group?k.presentation.group.localeCompare(A.presentation.group):g(k.presentation.order,A.presentation.order):-1:A.presentation.group?1:g(k.presentation.order,A.presentation.order):-1:A.presentation?1:0)}function g(y,k){return typeof y!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:y-k}async function E(y,k){const A=y.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(A!=="none"&&(await k.saveAll(),A==="allEditorsInActiveGroup")){const p=k.activeEditorPane;p&&p.input.resource?.scheme===L.Schemas.untitled&&await k.save({editor:p.input,groupId:p.group.id})}await y.reloadConfiguration()}const D=(y,k)=>!y||!k?y===k:y.name===k.name&&y.path===k.path&&y.sourceReference===k.sourceReference;e.$fI=D}),define(ke[259],Ie([1,0,56,67,24,16,10,12,33,8,154]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Crc=e.$Brc=e.$Arc=e.$zrc=e.$yrc=void 0,r=qe(r),h=qe(h),C=qe(C),R=qe(R),L=qe(L),T=qe(T),c=qe(c);class S extends I.$5tb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t($,f){this.l=f,this.p=Buffer.allocUnsafe(0),this.r=-1,$.on("data",i=>this.v(i))}sendMessage($){if(this.l){const f=JSON.stringify($);this.l.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${S.a}${f}`,"utf8")}}v($){for(this.p=Buffer.concat([this.p,$]);;){if(this.r>=0){if(this.p.length>=this.r){const f=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(i){this.n.fire(new Error((i.message||i)+`
`+f))}continue}}else{const f=this.p.indexOf(S.a);if(f!==-1){const s=this.p.toString("utf8",0,f).split(S.b);for(const t of s){const o=t.split(S.i);o[0]==="Content-Length"&&(this.r=Number(o[1]))}this.p=this.p.slice(f+S.a.length);continue}}break}}}e.$yrc=S;class u extends S{startSession(){return new Promise(($,f)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),$(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.x.on("error",s=>{i?this.n.fire(s):f(s)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$zrc=u;class P extends u{constructor($){super(),this.z=$}y($){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",$)}}e.$Arc=P;class w extends u{constructor($){super(),this.z=$}y($){return h.createConnection(this.z.path,$)}}e.$Brc=w;class a extends S{constructor($,f){super(),this.y=$,this.z=f}async startSession(){const $=this.y.command,f=this.y.args,i=this.y.options||{};try{if($)if(R.$ic($)){if(!await b.Promises.exists($))throw new Error(c.localize(7347,null,$))}else $.indexOf("/")<0&&$.indexOf("\\")<0;else throw new Error(c.localize(7348,null,this.z));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=C.$go(C.$do(process.env),i.env)),$==="node")if(Array.isArray(f)&&f.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:s,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(o.cwd=i.cwd);const n=r.fork(f[0],f.slice(1),o);if(!n.pid)throw new Error(c.localize(7349,null,f[0]));this.x=n}else throw new Error(c.localize(7350,null));else{const t={env:s};i.cwd&&(t.cwd=i.cwd),this.x=r.spawn($,f,t)}this.x.on("error",t=>{this.n.fire(t)}),this.x.on("exit",(t,o)=>{this.o.fire(t)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",t=>{this.n.fire(t)}),this.x.stdin.on("error",t=>{this.n.fire(t)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.x?(await this.w(),L.$j?new Promise(($,f)=>{const i=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,t,o){if(s)return f(s)});i.on("exit",$),i.on("error",f)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A($,f){if(!$)return;const i=Object.create(null);$.runtime&&($.runtime.indexOf("./")===0?i.runtime=R.$jc(f,$.runtime):i.runtime=$.runtime),$.runtimeArgs&&(i.runtimeArgs=$.runtimeArgs),$.program&&(R.$ic($.program)?i.program=$.program:i.program=R.$jc(f,$.program)),$.args&&(i.args=$.args);const s=$;return s.win&&(i.win=a.A(s.win,f)),s.winx86&&(i.winx86=a.A(s.winx86,f)),s.windows&&(i.windows=a.A(s.windows,f)),s.osx&&(i.osx=a.A(s.osx,f)),s.linux&&(i.linux=a.A(s.linux,f)),i}static platformAdapterExecutable($,f){let i=Object.create(null);f=f.toLowerCase();for(const l of $)if(l.contributes){const g=l.contributes.debuggers;g&&g.length>0&&g.filter(E=>typeof E.type=="string"&&T.$Ff(E.type,f)).forEach(E=>{const D=a.A(E,l.extensionLocation.fsPath);i=C.$go(i,D,l.isBuiltin)})}let s;L.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:L.$j?s=i.win||i.windows:L.$k?s=i.osx:L.$l&&(s=i.linux),s=s||i;const t=s.program||i.program,o=s.args||i.args,n=s.runtime||i.runtime,d=s.runtimeArgs||i.runtimeArgs;if(n)return{type:"executable",command:n,args:(d||[]).concat(typeof t=="string"?[t]:[]).concat(o||[])};if(t)return{type:"executable",command:t,args:o||[]}}}e.$Crc=a}),define(ke[260],Ie([1,0,56,31,10]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=L,e.$Erc=b,r=qe(r),C=qe(C);function R(c,I){return new Promise((S,u)=>{let P="";const w=r.spawn(c,I);w.pid&&w.stdout.on("data",a=>{P+=a.toString()}),w.on("error",a=>{u(a)}),w.on("close",a=>{S(P)})})}async function L(c){if(c)if(C.$j){const I=await new Promise((S,u)=>{$e(["@vscode/windows-process-tree"],S,u)}).then(qe);return new Promise(S=>{I.getProcessTree(c,u=>{S(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(c)]).then(I=>{const S=I.trim();return!(S.length===0||S.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var T;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(T||(T={}));function b(c,I,S,u,P){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=T.powershell:c.indexOf("cmd.exe")>=0?w=T.cmd:c.indexOf("bash")>=0?w=T.bash:C.$j?w=T.cmd:w=T.bash;let a,m=" ";switch(w){case T.powershell:if(a=$=>($=$.replace(/\'/g,"''"),$.length>0&&$.charAt($.length-1)==="\\"?`'${$}\\'`:`'${$}'`),u){const $=(0,h.$Jg)(u);$&&(m+=`${$}:; `),m+=`cd ${a(u)}; `}if(P)for(const $ in P){const f=P[$];f===null?m+=`Remove-Item env:${$}; `:m+=`\${env:${$}}='${f}'; `}if(I.length>0){const $=I.shift(),f=S?$:a($);m+=f[0]==="'"?`& ${f} `:`${f} `;for(const i of I)m+=i==="<"||i===">"||S?i:a(i),m+=" "}break;case T.cmd:if(a=$=>($=$.replace(/\"/g,'""'),$=$.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>$.includes(f))||$.length===0?`"${$}"`:$),u){const $=(0,h.$Jg)(u);$&&(m+=`${$}: && `),m+=`cd ${a(u)} && `}if(P){m+='cmd /C "';for(const $ in P){let f=P[$];f===null?m+=`set "${$}=" && `:(f=f.replace(/[&^|<>]/g,i=>`^${i}`),m+=`set "${$}=${f}" && `)}}for(const $ of I)m+=$==="<"||$===">"||S?$:a($),m+=" ";P&&(m+='"');break;case T.bash:{a=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),f.length===0?'""':f);const $=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(u&&(m+=`cd ${a(u)} ; `),P){m+="/usr/bin/env";for(const f in P){const i=P[f];i===null?m+=` -u ${$(f)}`:m+=` ${$(`${f}=${i}`)}`}m+=" "}for(const f of I)m+=f==="<"||f===">"||S?f:a(f),m+=" ";break}}return m}}),define(ke[261],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VK=e.CellExecutionUpdateType=void 0;var h;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$VK=(0,r.$Ei)("INotebookExecutionService")}),define(ke[262],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$YK=e.ProxyKernelState=e.$XK=void 0,e.$XK=100;var h;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$YK=(0,r.$Ei)("INotebookKernelService"),e.$ZK=(0,r.$Ei)("INotebookKernelHistoryService")}),define(ke[263],Ie([1,0,3,30,58,208,111]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d1b=void 0;class T extends r.$Uc{constructor(c,I,S){super(),this._source=c,this.b=I,this.c=S,this.a=void 0}f(c){const I=c.getLineCount();return new h.$Nt(1,1,I,this.g(c,I))}g(c,I){if(I<1||I>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const c=new R.$vD;c.acceptChunk(this._source);const I=c.finish(!0),{textBuffer:S,disposable:u}=I.create(C.DefaultEndOfLine.LF);this.b=S,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const I=new R.$vD;I.acceptChunk(c);const S=I.finish(!0),{textBuffer:u,disposable:P}=S.create(C.DefaultEndOfLine.LF);return this.B(P),u})),this.a}findInInputs(c){const S=new L.$jD(c,!1,!1,null).parseSearchRequest();if(!S)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,S,!0,5e3)}findInOutputs(c){const S=new L.$jD(c,!1,!1,null).parseSearchRequest();return S?this.outputTextBuffers.map(u=>{const P=u.findMatchesLineByLine(this.f(u),S,!0,5e3);if(P.length!==0)return{textBuffer:u,matches:P}}).filter(u=>!!u):[]}}e.$d1b=T}),define(ke[73],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5I=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class C{static fromExtHostTestItem(L,T,b=L.parent){if(L._isRoot)return new C([T]);const c=[L.id];for(let I=b;I&&I.id!==T;I=I.parent)c.push(I.id);return c.push(T),new C(c.reverse())}static isRoot(L){return!L.includes(r.Delimiter)}static root(L){const T=L.indexOf(r.Delimiter);return T===-1?L:L.slice(0,T)}static fromString(L){return new C(L.split(r.Delimiter))}static join(L,T){return new C([...L.path,T])}static joinToString(L,T){return L.toString()+r.Delimiter+T}static parentId(L){const T=L.lastIndexOf(r.Delimiter);return T===-1?void 0:L.slice(0,T)}static localId(L){const T=L.lastIndexOf(r.Delimiter);return T===-1?L:L.slice(T+r.Delimiter.length)}static isChild(L,T){return T[L.length]===r.Delimiter&&T.startsWith(L)}static compare(L,T){return L===T?h.IsSame:C.isChild(L,T)?h.IsChild:C.isChild(T,L)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(L,T){if(L===0)return 0;let b=0;for(;b<L-1;){for(let c=1;c<L;c++){const I=T(c-1),S=T(c);if(I.path[b]!==S.path[b])return b}b++}return b}constructor(L,T=L.length){if(this.path=L,this.d=T,L.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new C(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new C(this.path,L)}compare(L){if(typeof L=="string")return C.compare(this.toString(),L);for(let T=0;T<L.d&&T<this.d;T++)if(L.path[T]!==this.path[T])return h.Disconnected;return L.d>this.d?h.IsChild:L.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+=r.Delimiter,this.c+=this.path[L]}return this.c}}e.$5I=C}),define(ke[74],Ie([1,0,2,57,30,73]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$aJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$_I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$$I=e.$0I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$9I=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$8I=e.$7I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$6I=e.TestResultState=void 0;var L;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$6I={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var T;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var b;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$7I=[b.Run,b.Debug,b.Coverage,b.HasNonDefaultProfile,b.HasConfigurable,b.SupportsContinuousRun];const c=M=>"runId"in M;e.$8I=c;var I;(function(M){M.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),M.deserialize=(U,V)=>({range:C.$Nt.lift(V.range),uri:U.asCanonicalUri(r.URI.revive(V.uri))})})(I||(e.IRichLocation=I={}));var S;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(S||(e.TestMessageType=S={}));var u;(function(M){M.serialize=U=>({label:U.label,uri:U.uri?.toJSON(),position:U.position?.toJSON()}),M.deserialize=(U,V)=>({label:V.label,uri:V.uri?U.asCanonicalUri(r.URI.revive(V.uri)):void 0,position:V.position?h.$Mt.lift(V.position):void 0})})(u||(e.ITestMessageStackFrame=u={}));var P;(function(M){M.serialize=U=>({message:U.message,type:S.Error,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&I.serialize(U.location),stackTrace:U.stackTrace?.map(u.serialize)}),M.deserialize=(U,V)=>({message:V.message,type:S.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&I.deserialize(U,V.location),stackTrace:V.stackTrace&&V.stackTrace.map(ie=>u.deserialize(U,ie))})})(P||(e.ITestErrorMessage=P={}));const w=(M,U)=>`${U?"s":"e"}${M}`;e.$9I=w;var a;(function(M){M.serialize=U=>({message:U.message,type:S.Output,offset:U.offset,length:U.length,location:U.location&&I.serialize(U.location)}),M.deserialize=(U,V)=>({message:V.message,type:S.Output,offset:V.offset,length:V.length,location:V.location&&I.deserialize(U,V.location)})})(a||(e.ITestOutputMessage=a={}));var m;(function(M){M.serialize=U=>U.type===S.Error?P.serialize(U):a.serialize(U),M.deserialize=(U,V)=>V.type===S.Error?P.deserialize(U,V):a.deserialize(U,V),M.isDiffable=U=>U.type===S.Error&&U.actual!==void 0&&U.expected!==void 0})(m||(e.ITestMessage=m={}));var $;(function(M){M.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),M.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(m.serialize)}),M.deserialize=(U,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(ie=>m.deserialize(U,ie))})})($||(e.ITestTaskState=$={}));const f="\0",i=(M,U)=>M+f+U;e.$0I=i;const s=M=>{const U=M.indexOf(f);return{ctrlId:M.slice(0,U),tagId:M.slice(U+1)}};e.$$I=s;var t;(function(M){M.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),M.deserialize=(U,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?U.asCanonicalUri(r.URI.revive(V.uri)):void 0,range:V.range?C.$Nt.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(t||(e.ITestItem=t={}));var o;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var n;(function(M){M.serialize=U=>({expand:U.expand,item:t.serialize(U.item)}),M.deserialize=(U,V)=>({controllerId:R.$5I.root(V.item.extId),expand:V.expand,item:t.deserialize(U,V.item)})})(n||(e.InternalTestItem=n={}));var d;(function(M){M.serialize=U=>{let V;return U.item&&(V={},U.item.label!==void 0&&(V.label=U.item.label),U.item.tags!==void 0&&(V.tags=U.item.tags),U.item.busy!==void 0&&(V.busy=U.item.busy),U.item.uri!==void 0&&(V.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(V.range=U.item.range?.toJSON()),U.item.description!==void 0&&(V.description=U.item.description),U.item.error!==void 0&&(V.error=U.item.error),U.item.sortText!==void 0&&(V.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:V}},M.deserialize=U=>{let V;return U.item&&(V={},U.item.label!==void 0&&(V.label=U.item.label),U.item.tags!==void 0&&(V.tags=U.item.tags),U.item.busy!==void 0&&(V.busy=U.item.busy),U.item.range!==void 0&&(V.range=U.item.range?C.$Nt.lift(U.item.range):null),U.item.description!==void 0&&(V.description=U.item.description),U.item.error!==void 0&&(V.error=U.item.error),U.item.sortText!==void 0&&(V.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:V}}})(d||(e.ITestItemUpdate=d={}));const l=(M,U)=>{U.expand!==void 0&&(M.expand=U.expand),U.item!==void 0&&(M.item=M.item?Object.assign(M.item,U.item):U.item)};e.$_I=l;var g;(function(M){M.serializeWithoutMessages=U=>({...n.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map($.serializeWithoutMessages)}),M.serialize=U=>({...n.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map($.serialize)}),M.deserialize=(U,V)=>({...n.deserialize(U,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(ie=>$.deserialize(U,ie)),retired:!0})})(g||(e.TestResultItem=g={}));var E;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(U,V)=>{U.covered+=V.covered,U.total+=V.total}})(E||(e.ICoverageCount=E={}));var D;(function(M){M.serialize=U=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,testIds:U.testIds,uri:U.uri.toJSON()}),M.deserialize=(U,V)=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testIds:V.testIds,uri:U.asCanonicalUri(r.URI.revive(V.uri))}),M.empty=(U,V)=>({id:U,uri:V,statement:E.empty()})})(D||(e.IFileCoverage=D={}));function y(M){return{...M,location:M.location?.toJSON()}}function k(M){return M.location=M.location?h.$Mt.isIPosition(M.location)?h.$Mt.lift(M.location):C.$Nt.lift(M.location):void 0,M}e.$aJ=3;var A;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(A||(e.DetailType=A={}));var p;(function(M){M.serialize=U=>U.type===A.Declaration?F.serialize(U):N.serialize(U),M.deserialize=U=>U.type===A.Declaration?F.deserialize(U):N.deserialize(U)})(p||(e.CoverageDetails=p={}));var v;(function(M){M.serialize=y,M.deserialize=k})(v||(e.IBranchCoverage=v={}));var F;(function(M){M.serialize=y,M.deserialize=k})(F||(e.IDeclarationCoverage=F={}));var N;(function(M){M.serialize=U=>({...y(U),branches:U.branches?.map(v.serialize)}),M.deserialize=U=>({...k(U),branches:U.branches?.map(v.deserialize)})})(N||(e.IStatementCoverage=N={}));var O;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var j;(function(M){M.deserialize=(U,V)=>V.op===O.Add?{op:V.op,item:n.deserialize(U,V.item)}:V.op===O.Update?{op:V.op,item:d.deserialize(V.item)}:V.op===O.DocumentSynced?{op:V.op,uri:U.asCanonicalUri(r.URI.revive(V.uri)),docv:V.docv}:V,M.serialize=U=>U.op===O.Add?{op:U.op,item:n.serialize(U.item)}:U.op===O.Update?{op:U.op,item:d.serialize(U.item)}:U})(j||(e.TestsDiffOp=j={}));class z{constructor(U){this.k=U,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(U){const V=this.w();for(const ie of U)switch(ie.op){case O.Add:this.l(n.deserialize(this.k,ie.item),V);break;case O.Update:this.p(d.deserialize(ie.item),V);break;case O.Remove:this.q(ie.itemId,V);break;case O.Retire:this.v(ie.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(ie.amount);break;case O.AddTag:this.c.set(ie.tag.id,ie.tag);break;case O.RemoveTag:this.c.delete(ie.id);break}V.complete?.()}l(U,V){const ie=R.$5I.parentId(U.item.extId)?.toString();let B;if(!ie)B=this.x(U),this.g.add(B),this.f.set(U.item.extId,B);else if(this.f.has(ie)){const Y=this.f.get(ie);Y.children.add(U.item.extId),B=this.x(U,Y),this.f.set(U.item.extId,B)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return V.add?.(B),U.expand===o.BusyExpanding&&this.h++,B}p(U,V){const ie=this.f.get(U.extId);if(ie)return U.expand!==void 0&&(ie.expand===o.BusyExpanding&&this.h--,U.expand===o.BusyExpanding&&this.h++),(0,e.$_I)(ie,U),V.update?.(ie),ie}q(U,V){const ie=this.f.get(U);if(!ie)return;const B=R.$5I.parentId(ie.item.extId)?.toString();B?this.f.get(B).children.delete(ie.item.extId):this.g.delete(ie);const Y=[[U]];for(;Y.length;)for(const J of Y.pop()){const _=this.f.get(J);_&&(Y.push(_.children),this.f.delete(J),V.remove?.(_,_!==ie),_.expand===o.BusyExpanding&&this.h--)}}v(U){}updatePendingRoots(U){this.j+=U}w(){return{}}}e.$bJ=z}),define(ke[264],Ie([1,0,137,8,74]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$IGb=e.$HGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(S){S.ViewletId="workbench.view.extension.test",S.ExplorerViewId="workbench.view.testing",S.OutputPeekContributionId="editor.contrib.testingOutputPeek",S.DecorationsContributionId="editor.contrib.testingDecorations",S.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",S.CoverageViewId="workbench.view.testCoverage",S.ResultsPanelId="workbench.panel.testResults",S.ResultsViewId="workbench.panel.testResults.view",S.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var L;(function(S){S.List="list",S.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var T;(function(S){S.ByLocation="location",S.ByStatus="status",S.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const b={[C.TestResultState.Errored]:(0,h.localize)(3168,null),[C.TestResultState.Failed]:(0,h.localize)(3169,null),[C.TestResultState.Passed]:(0,h.localize)(3170,null),[C.TestResultState.Queued]:(0,h.localize)(3171,null),[C.TestResultState.Running]:(0,h.localize)(3172,null),[C.TestResultState.Skipped]:(0,h.localize)(3173,null),[C.TestResultState.Unset]:(0,h.localize)(3174,null)},c=(S,u)=>(0,h.localize)(3175,null,(0,r.$Yk)(S),b[u]);e.$HGb=c,e.$IGb={[C.TestRunProfileBitset.Debug]:(0,h.localize)(3176,null),[C.TestRunProfileBitset.Run]:(0,h.localize)(3177,null),[C.TestRunProfileBitset.Coverage]:(0,h.localize)(3178,null)};var I;(function(S){S.CancelTestRefreshAction="testing.cancelTestRefresh",S.CancelTestRunAction="testing.cancelRun",S.ClearTestResultsAction="testing.clearTestResults",S.CollapseAllAction="testing.collapseAll",S.ConfigureTestProfilesAction="testing.configureProfile",S.ContinousRunUsingForTest="testing.continuousRunUsingForTest",S.CoverageAtCursor="testing.coverageAtCursor",S.CoverageByUri="testing.coverage.uri",S.CoverageClear="testing.coverage.close",S.CoverageCurrentFile="testing.coverageCurrentFile",S.CoverageFilterToTest="testing.coverageFilterToTest",S.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",S.CoverageLastRun="testing.coverageLastRun",S.CoverageSelectedAction="testing.coverageSelected",S.CoverageToggleToolbar="testing.coverageToggleToolbar",S.CoverageViewChangeSorting="testing.coverageViewChangeSorting",S.DebugAction="testing.debug",S.DebugAllAction="testing.debugAll",S.DebugAtCursor="testing.debugAtCursor",S.DebugByUri="testing.debug.uri",S.DebugCurrentFile="testing.debugCurrentFile",S.DebugFailedTests="testing.debugFailTests",S.DebugLastRun="testing.debugLastRun",S.DebugSelectedAction="testing.debugSelected",S.FilterAction="workbench.actions.treeView.testExplorer.filter",S.GetExplorerSelection="_testing.getExplorerSelection",S.GetSelectedProfiles="testing.getSelectedProfiles",S.GoToTest="testing.editFocusedTest",S.HideTestAction="testing.hideTest",S.OpenCoverage="testing.openCoverage",S.OpenOutputPeek="testing.openOutputPeek",S.RefreshTestsAction="testing.refreshTests",S.ReRunFailedTests="testing.reRunFailTests",S.ReRunLastRun="testing.reRunLastRun",S.RunAction="testing.run",S.RunAllAction="testing.runAll",S.RunAllWithCoverageAction="testing.coverageAll",S.RunAtCursor="testing.runAtCursor",S.RunByUri="testing.run.uri",S.RunCurrentFile="testing.runCurrentFile",S.RunSelectedAction="testing.runSelected",S.RunUsingProfileAction="testing.runUsing",S.RunWithCoverageAction="testing.coverage",S.SearchForTestExtension="testing.searchForTestExtension",S.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",S.ShowMostRecentOutputAction="testing.showMostRecentOutput",S.StartContinousRun="testing.startContinuousRun",S.StopContinousRun="testing.stopContinuousRun",S.TestingSortByDurationAction="testing.sortByDuration",S.TestingSortByLocationAction="testing.sortByLocation",S.TestingSortByStatusAction="testing.sortByStatus",S.TestingViewAsListAction="testing.viewAsList",S.TestingViewAsTreeAction="testing.viewAsTree",S.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",S.ToggleInlineTestOutput="testing.toggleInlineTestOutput",S.UnhideAllTestsAction="testing.unhideAllTests",S.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(ke[120],Ie([1,0,7,4,3,65,74,73]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.TestItemEventOp=void 0;var b;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const c=(f,i)=>f===i,S=Object.entries({range:(f,i)=>f===i?!0:!f||!i?!1:f.equalsRange(i),busy:c,label:c,description:c,error:c,sortText:c,tags:(f,i)=>!(f.length!==i.length||f.some(s=>!i.includes(s)))}),u=(f,i)=>{let s;for(const[t,o]of S)o(f[t],i[t])||(s?s[t]=i[t]:s={[t]:i[t]});return s};class P extends C.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new r.$Qh(()=>this.flushDiff(),200)),this.g=this.B(new h.$le),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case L.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===L.TestDiffOpType.DocumentSynced&&s.uri===i.uri){s.docv=i.docv;return}break}case L.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===L.TestDiffOpType.Update&&s.item.extId===i.item.extId){(0,L.$_I)(s.item,i.item);return}if(s.op===L.TestDiffOpType.Add&&s.item.item.extId===i.item.extId){(0,L.$_I)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||s>t.expandLevels)&&(t.expandLevels=s),t.expand===L.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,s-1):o.wait().then(()=>this.L(t,s-1))}else if(t.expand===L.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,s-1)):this.L(t,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,s){switch(s.op){case b.RemoveChild:this.O(T.$5I.joinToString(i.fullId,s.id));break;case b.Upsert:this.z(s.item,i);break;case b.Bulk:for(const t of s.ops)this.w(i,t);break;case b.SetTags:this.C(s.new,s.old,i.fullId.toString());break;case b.UpdateCanResolveChildren:this.J(i);break;case b.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:s.update}});break;case b.DocumentSynced:this.y(i.actual.uri);break;default:(0,R.$ed)(s)}}y(i){i&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,s){const t=T.$5I.fromExtHostTestItem(i,this.root.id,s?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==s?.actual&&this.s.getChildren(o.parent).delete(i.id);let n=this.tree.get(t.toString());if(!n){n={fullId:t,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(i,s),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(i)}}),this.I(i,n,s);return}if(n.actual===i){this.H(i,n,s);return}if(n.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,s);const d=this.s.getChildren(n.actual),l=n.actual,g=u(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,n.actual=i,n.resolveBarrier=void 0,n.expand=L.TestItemExpandState.NotExpandable,g&&(g.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,t.toString()),delete g.tags),this.w(n,{op:b.SetProp,update:g})),this.I(i,n,s);for(const[D,y]of d)this.s.getChildren(i).get(y.id)||this.O(T.$5I.joinToString(t,y.id));const E=n.expandLevels;E!==void 0&&queueMicrotask(()=>{n.expand===L.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(n.actual.uri)}C(i,s,t){const o=new Set(s.map(n=>n.id));for(const n of i)o.delete(n.id)||this.D(n);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(n=>(0,L.$0I)(this.s.controllerId,n.id))}}}),o.forEach(this.F,this)}D(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.$0I)(this.s.controllerId,i.id)}}))}F(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.$0I)(this.s.controllerId,i)}))}G(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}H(i,s,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=n=>this.w(s,n),this.J(s)}I(i,s,t){this.H(i,s,t);for(const[o,n]of this.s.getChildren(i))this.z(n,s)}J(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:s=i.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:s=L.TestItemExpandState.NotExpandable,s!==i.expand&&(i.expand=s,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:s}}),s===L.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,s){if(s<0)return;const t=[];for(const[o,n]of this.s.getChildren(i.actual)){const d=this.expand(T.$5I.joinToString(i.fullId,n.id),s);(0,r.$qh)(d)&&t.push(d)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const n=new r.$Dh;return n.open(),n}i.expand=L.TestItemExpandState.BusyExpanding,this.N(i);const s=i.resolveBarrier=new r.$Dh,t=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(n){t(n)}return(0,r.$qh)(o)?o.catch(t).then(()=>{s.open(),this.J(i)}):(s.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:i});const t=[s];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const n of o.actual.tags)this.F(n.id);this.tree.delete(o.fullId.toString());for(const[n,d]of this.s.getChildren(o.actual))t.push(this.tree.get(T.$5I.joinToString(o.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$0P=P;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$$P=w;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$_P=a;class m extends Error{constructor(i,s,t){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${t}".`)}}e.$aQ=m;const $=(f,i,s)=>{let t=new Map;return{get size(){return t.size},forEach(o,n){for(const d of t.values())o.call(n,d,this)},[Symbol.iterator](){return t.entries()},replace(o){const n=new Map,d=new Set(t.keys()),l={op:b.Bulk,ops:[]};for(const g of o){if(!(g instanceof s))throw new a(g.id);const E=i(g).controllerId;if(E!==f.controllerId)throw new m(g.id,E,f.controllerId);if(n.has(g.id))throw new w(g.id);n.set(g.id,g),d.delete(g.id),l.ops.push({op:b.Upsert,item:g})}for(const g of d.keys())l.ops.push({op:b.RemoveChild,id:g});f.listener?.(l),t=n},add(o){if(!(o instanceof s))throw new a(o.id);t.set(o.id,o),f.listener?.({op:b.Upsert,item:o})},delete(o){t.delete(o)&&f.listener?.({op:b.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$bQ=$}),define(ke[155],Ie([1,0,120]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=void 0;const h=new WeakMap,C=(L,T)=>{const b={controllerId:T};return h.set(L,b),b};e.$cQ=C;const R=L=>{const T=h.get(L);if(!T)throw new r.$_P(L?.id||"<unknown>");return T};e.$dQ=R}),define(ke[121],Ie([1,0,26,14,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BDb=e.$ADb=e.$zDb=void 0,e.$CDb=R,e.$DDb=T,e.$zDb="vscode-cdn.net",e.$ADb=`vscode-resource.${e.$zDb}`,e.$BDb=`'self' https://*.${e.$zDb}`;function R(b,c){return b.scheme===h.Schemas.http||b.scheme===h.Schemas.https?b:(c&&c.authority&&c.isRemote&&b.scheme===h.Schemas.file&&(b=C.URI.from({scheme:h.Schemas.vscodeRemote,authority:c.authority,path:b.path})),C.URI.from({scheme:h.Schemas.https,authority:`${b.scheme}+${L(b.authority)}.${e.$ADb}`,path:b.path,fragment:b.fragment,query:b.query}))}function L(b){return b.replace(/./g,c=>{const I=c.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?c:"-"+I.toString(16).padStart(4,"0")})}function T(b){return b.replace(/-([0-9a-f]{4})/g,(c,I)=>String.fromCharCode(parseInt(I,16)))}}),define(ke[265],Ie([1,0,4,3,121]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=void 0;class R{constructor(T,b,c){this.d=T,this.e=b,this.f=c,this.a=0,this.b=new h.$Tc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const I=b.getVisibleTextEditors();for(const S of this.c.values())I.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,b,c,I,S){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){u=i;break}if(!u)throw new Error("not a visible editor");const P=this,w=this.a++,a=new r.$le,m=new r.$le,$=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$CDb)(i,P.f)}get cspSource(){return C.$BDb}set options(i){this.b=i,P.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,P.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return P.d.$postMessage(w,i)}},f=new class{constructor(){this.editor=T,this.line=b,this.height=c,this.webview=$,this.onDidDispose=m.event}dispose(){P.c.has(w)&&(P.c.delete(w),P.d.$disposeEditorInset(w),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(w,u.id,u.value.document.uri,b+1,c,I||{},S.identifier,S.extensionLocation),this.c.set(w,{editor:T,inset:f,onDidReceiveMessage:a}),f}$onDidDispose(T){const b=this.c.get(T);b&&b.inset.dispose()}$onDidReceiveMessage(T,b){this.c.get(T)?.onDidReceiveMessage.fire(b)}}e.$xpc=R}),define(ke[156],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=void 0,e.$JM="__",e.$KM=(0,r.$Ei)("IAuthenticationService"),e.$LM=(0,r.$Ei)("IAuthenticationExtensionsService")}),define(ke[266],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Q=e.VariableKind=e.$8Q=void 0,e.$8Q=(0,r.$Ei)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class C extends Error{constructor(L,T){super(T),this.variable=L}}e.$9Q=C}),define(ke[267],Ie([1,0,16,55,17,24,10,107,8,266,12]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=void 0,r=qe(r),h=qe(h),C=qe(C),R=qe(R);class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,w,a,m){this.h=new Map,this.a=P,this.b=w,this.g=a,m&&(this.c=m.then($=>this.i($)))}i(P){if(L.$j){const w=Object.create(null);return Object.keys(P).forEach(a=>{w[a.toLowerCase()]=P[a]}),w}return P}resolveWithEnvironment(P,w,a){return this.l({env:this.i(P),userHome:void 0},w?w.uri:void 0,a)}async resolveAsync(P,w){const a={env:await this.c,userHome:await this.g};return this.l(a,P?P.uri:void 0,w)}async j(P,w,a,m){const $=R.$do(w);L.$j&&$.windows?Object.keys($.windows).forEach(i=>$[i]=$.windows[i]):L.$k&&$.osx?Object.keys($.osx).forEach(i=>$[i]=$.osx[i]):L.$l&&$.linux&&Object.keys($.linux).forEach(i=>$[i]=$.linux[i]),delete $.windows,delete $.osx,delete $.linux;const f={env:await this.c,userHome:await this.g};return this.l(f,P?P.uri:void 0,$,a,m)}async resolveAnyAsync(P,w,a){return this.j(P,w,a)}async resolveAnyMap(P,w,a){const m=new Map;return{newConfig:await this.j(P,w,a,m),resolvedVariables:m}}resolveWithInteractionReplace(P,w,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,w,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,w){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,w)}async l(P,w,a,m,$){if(C.$eg(a))return this.m(P,w,a,m,$);if(Array.isArray(a))return Promise.all(a.map(f=>this.l(P,w,f,m,$)));if(C.$gg(a)){const f=Object.create(null),i=await Promise.all(Object.keys(a).map(async s=>[await this.m(P,w,s,m,$),await this.l(P,w,a[s],m,$)]));for(const[s,t]of i)f[s]=t;return f}return a}m(P,w,a,m,$){return(0,I.$xf)(a,S.VARIABLE_REGEXP,async(f,i)=>{if(i.includes(S.VARIABLE_LHS))return f;let s=await this.o(P,f,i,w,m);return $?.set(i,s),s!==f&&C.$eg(s)&&s.match(S.VARIABLE_REGEXP)&&(s=await this.m(P,w,s,m,$)),s})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,w,a,m,$){let f;const i=a.split(":");i.length>1&&(a=i[0],f=i[1]);const s=n=>{const d=this.a.getFilePath();if(d)return(0,T.$Zw)(d);throw new c.$9Q(n,(0,b.localize)(2066,null,w))},t=n=>{const d=s(n);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,T.$Zw)(l)}throw new c.$9Q(n,(0,b.localize)(2067,null,w,r.$nc(d)))},o=n=>{if(f){const d=this.a.getFolderUri(f);if(d)return d;throw new c.$9Q(n,(0,b.localize)(2068,null,w,f))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new c.$9Q(n,(0,b.localize)(2069,null,w)):new c.$9Q(n,(0,b.localize)(2070,null,w))};switch(a){case"env":if(f){if(P.env){const n=P.env[L.$j?f.toLowerCase():f];if(C.$eg(n))return n}return""}throw new c.$9Q(c.VariableKind.Env,(0,b.localize)(2071,null,w));case"config":if(f){const n=this.a.getConfigurationValue(m,f);if(C.$ng(n))throw new c.$9Q(c.VariableKind.Config,(0,b.localize)(2072,null,w,f));if(C.$gg(n))throw new c.$9Q(c.VariableKind.Config,(0,b.localize)(2073,null,w,f));return n}throw new c.$9Q(c.VariableKind.Config,(0,b.localize)(2074,null,w));case"command":return this.p(c.VariableKind.Command,w,f,$,"command");case"input":return this.p(c.VariableKind.Input,w,f,$,"input");case"extensionInstallFolder":if(f){const n=await this.a.getExtension(f);if(!n)throw new c.$9Q(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(2075,null,w,f));return this.n(n.extensionLocation)}throw new c.$9Q(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(2076,null,w));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,T.$Zw)(this.n(o(c.VariableKind.WorkspaceFolder)));case"cwd":return m||f?(0,T.$Zw)(this.n(o(c.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Zw)(r.$nc(this.n(o(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new c.$9Q(c.VariableKind.UserHome,(0,b.localize)(2077,null,w))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new c.$9Q(c.VariableKind.LineNumber,(0,b.localize)(2078,null,w))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new c.$9Q(c.VariableKind.SelectedText,(0,b.localize)(2079,null,w))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$nc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||f?r.$lc(this.n(o(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const n=r.$mc(s(c.VariableKind.RelativeFileDirname));if(m||f){const d=r.$lc(this.n(o(c.VariableKind.RelativeFileDirname)),n);return d.length===0?".":d}return n}case"fileDirname":return r.$mc(s(c.VariableKind.FileDirname));case"fileExtname":return r.$oc(s(c.VariableKind.FileExtname));case"fileBasename":return r.$nc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=r.$nc(s(c.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-r.$oc(n).length)}case"fileDirnameBasename":return r.$nc(r.$mc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||w}case"execInstallFolder":{const n=this.a.getAppRoot();return n||w}case"pathSeparator":case"/":return r.sep;default:try{const n=f?`${a}:${f}`:a;return this.p(c.VariableKind.Unknown,w,n,$,void 0)}catch{return w}}}}p(P,w,a,m,$){if(a&&m){const f=$===void 0?m[a]:m[$+":"+a];if(typeof f=="string")return f;throw new c.$9Q(P,(0,b.localize)(2080,null,w))}return w}}e.$lR=S}),define(ke[157],Ie([1,0,5,152]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$sE=void 0,e.$tE=c,e.$uE=u,e.$vE=P,e.$sE=(0,r.$Ei)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var T;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var b;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function c(w){const a=w;return(0,h.$gG)(a?.editor)&&(0,h.$gG)(a?.replacement)}var I;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var S;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function u(w){const a=w;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function P(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?C.DOWN:C.RIGHT}}),define(ke[268],Ie([1,0,5,157]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zE=e.$yE=e.$xE=e.$wE=void 0,e.$AE=C,e.$wE=(0,r.$Ei)("editorService"),e.$xE=-1,e.$yE=-2,e.$zE=-3;function C(R){const L=R;return typeof R=="number"||(0,h.$uE)(L)}}),define(ke[158],Ie([1,0,5,144]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=void 0,e.$5M=(0,r.$Fi)(h.$Li)}),define(ke[159],Ie([1,0,23,4,16,3,7]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=e.$Fdc=e.$Edc=e.$Ddc=void 0,C=qe(C);class T{constructor(f,i){this.versionId=f,this.removedDueToLooping=i}}e.$Ddc=T;class b{static isHostExtension(f,i,s){if(i.getExtensionDescription(f))return!1;const t=s.getExtensionDescription(f);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(f,i){this.j=f,this.c=new h.$le,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new r.$sn,this.g=[],this.h=new Map;for(const f of this.e){if(this.f.has(f.identifier)){console.error("Extension `"+f.identifier.value+"` is already registered");continue}this.f.set(f.identifier,f),this.g.push(f);const i=this.j.readActivationEvents(f);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(f)}}set(f){return this.e=f,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(f,i){this.e=m(this.e,i),this.e=this.e.concat(f);const s=b.l(this.e);return this.e=m(this.e,s.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,s)}static l(f){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const g=i.getArcs(d);for(let E=0;E<g.length;E++)if(!l.has(g[E]))return!1;return!0}getNodes(){return this.e}},s=new r.$sn;for(const d of f)if(s.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(r.$qn.toKey(d.identifier),r.$qn.toKey(l));const t=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>t.add(d));const o=i.getNodes().filter(d=>!t.has(d));let n;do{n=!1;for(let d=0;d<o.length;d++){const l=o[d];i.hasOnlyGoodArcs(l,t)&&(o.splice(d,1),d--,t.add(l),n=!0)}}while(n);return o.map(d=>s.get(d))}containsActivationEvent(f){return this.h.has(f)}containsExtension(f){return this.f.has(f)}getExtensionDescriptionsForActivationEvent(f){const i=this.h.get(f);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(f){const i=this.f.get(f);return i||void 0}getExtensionDescriptionByUUID(f){for(const i of this.g)if(i.uuid===f)return i}getExtensionDescriptionByIdOrUUID(f,i){return this.getExtensionDescription(f)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Edc=b;class c{constructor(f,i){this.versionId=f,this.extensions=i}}e.$Fdc=c;class I{constructor(f){this.d=new P,this.c=new b(f,[])}async acquireLock(f){const i=await this.d.acquire(f);return new S(this,i)}deltaExtensions(f,i,s){if(!f.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(f){return this.c.containsActivationEvent(f)}containsExtension(f){return this.c.containsExtension(f)}getExtensionDescriptionsForActivationEvent(f){return this.c.getExtensionDescriptionsForActivationEvent(f)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(f){return this.c.getExtensionDescription(f)}getExtensionDescriptionByUUID(f){return this.c.getExtensionDescriptionByUUID(f)}getExtensionDescriptionByIdOrUUID(f,i){return this.c.getExtensionDescriptionByIdOrUUID(f,i)}}e.$Gdc=I;class S extends R.$Uc{constructor(f,i){super(),this.f=f,this.c=!1,this.B(i)}isAcquiredFor(f){return!this.c&&this.f===f}}e.$Hdc=S;class u{constructor(f){this.name=f;const i=(0,L.$xh)();this.promise=i.promise,this.c=i.resolve}resolve(f){this.c(f)}}class P{constructor(){this.c=[],this.d=!1}async acquire(f){const i=new u(f);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const f=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${f.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};f.resolve((0,R.$Sc)(t))}}var w;(function($){$[$.Builtin=0]="Builtin",$[$.User=1]="User",$[$.Dev=2]="Dev"})(w||(w={}));function a($,f){const i=$.isBuiltin?w.Builtin:$.isUnderDevelopment?w.Dev:w.User,s=f.isBuiltin?w.Builtin:f.isUnderDevelopment?w.Dev:w.User;if(i!==s)return i-s;const t=C.$gc.basename($.extensionLocation.path),o=C.$gc.basename(f.extensionLocation.path);return t<o?-1:t>o?1:0}function m($,f){const i=new r.$rn(f);return $.filter(s=>!i.has(s.identifier))}}),define(ke[269],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.ExtHostConnectionType=void 0,e.$en=T,e.$fn=b;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(S){this.pipeName=S,this.type=r.IPC}serialize(S){S[h.ENV_KEY]=this.pipeName}}e.$bn=h;class C{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(S){S[C.ENV_KEY]="1"}}e.$cn=C;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(S){S[R.ENV_KEY]="1"}}e.$dn=R;function L(I){delete I[h.ENV_KEY],delete I[C.ENV_KEY],delete I[R.ENV_KEY]}function T(I,S){L(S),I.serialize(S)}function b(I){if(I[h.ENV_KEY])return c(I,new h(I[h.ENV_KEY]));if(I[C.ENV_KEY])return c(I,new C);if(I[R.ENV_KEY])return c(I,new R);throw new Error("No connection information defined in environment!")}function c(I,S){return L(I),S}}),define(ke[93],Ie([1,0,21]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$An=L,e.$Bn=T;var h;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(h||(e.UIKind=h={}));var C;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var R;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(c){const I=r.$Ne.alloc(1);switch(c){case R.Initialized:I.writeUInt8(1,0);break;case R.Ready:I.writeUInt8(2,0);break;case R.Terminate:I.writeUInt8(3,0);break}return I}function T(c,I){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return I===R.Initialized;case 2:return I===R.Ready;case 3:return I===R.Terminate;default:return!1}}var b;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ke[94],Ie([1,0,5,4,149,11,29,93,90,91,24,2,3,8]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BQ=e.$zQ=e.$yQ=void 0,e.$AQ=m;let w=class extends u.$Uc{constructor(f,i){super(),this.s=f,this.t=i,this.a=this.B(new h.$le),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$le),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=C.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=S.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:c.$Bp,name:(0,P.localize)(10778,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(s=>{(0,R.$bk)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===C.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=C.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=C.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=C.TelemetryLevel.USAGE:!1}}instantiateLogger(f,i,s){const t=this.getTelemetryDetails(),o=new a(i,s,f,this.n,this.j,this.getBuiltInCommonProperties(f),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),n=this.r.get(f.identifier.value)??[];return this.r.set(f.identifier.value,[...n,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(f,i,s){this.f=f,this.g=i,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(f){const i=Object.create(null);switch(i["common.extname"]=`${f.publisher}.${f.name}`,i["common.extversion"]=f.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$hn)((0,c.$Hp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const i=this.getTelemetryDetails();this.r.forEach((s,t)=>{const o=s.filter(n=>!n.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(s=>{for(const t of s)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(f,i){const t=this.r.get(f.value)?.filter(n=>!n.isDisposed);if(!t)return this.r.delete(f.value),!1;let o=!1;for(const n of t)n.ignoreUnhandledExtHostErrors||(n.logError(i),o=!0);return o}};e.$yQ=w,e.$yQ=w=Je([Ve(0,L.$xQ),Ve(1,R.$ak)],w);class a{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,i,s,t,o,n,d){this.g=s,this.h=t,this.i=o,this.j=n,this.a=new h.$le,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(f,i){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let i="properties"in f?f.properties??{}:f;return i=(0,c.$Kp)(i,[]),this.c&&(i=(0,I.$go)(i,this.c)),this.b||(i=(0,I.$go)(i,this.j)),"properties"in f?f.properties=i:f=i,f}k(f,i){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(f,i),this.h.trace(f,i))}logUsage(f,i){this.d.isUsageEnabled&&this.k(f,i)}logError(f,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof f=="string")this.k(f,i);else{const s={name:f.name,message:f.message,stack:f.stack,cause:f.cause},t=(0,c.$Kp)(s,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const f=this,i={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.$zQ=a;function m($){const f=Date.now()-new Date($).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.$BQ=(0,r.$Ei)("IExtHostTelemetry")}),define(ke[25],Ie([1,0,4,2,240,147,23,5]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kH=e.ActivationKind=e.$hH=e.$gH=e.$dH=e.ExtensionHostStartup=e.$cH=e.$bH=e.$aH=e.$_G=void 0,e.$eH=u,e.$fH=P,e.$iH=$,e.$jH=f,e.$_G=Object.freeze({identifier:new L.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$aH="extensions.webWorker",e.$bH=(0,T.$Ei)("extensionService");class b{constructor(t){this.dependency=t}}e.$cH=b;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,n){this.c=t,this.d=o.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$XG.createActivationEventsMap(this.d)}}set(t,o,n){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const d=[],l=[],g=[],E=[],D=S(this.d),y=S(o),k=(N,O)=>N.extensionLocation.toString()===O.extensionLocation.toString()||N.isBuiltin===O.isBuiltin||N.isUserBuiltin===O.isUserBuiltin||N.isUnderDevelopment===O.isUnderDevelopment;for(const N of this.d){const O=y.get(N.identifier);if(!O){d.push(N.identifier),D.delete(N.identifier);continue}if(!k(N,O)){d.push(N.identifier),D.delete(N.identifier);continue}}for(const N of o){const O=D.get(N.identifier);if(!O){l.push(N);continue}if(!k(O,N)){d.push(O.identifier),D.delete(O.identifier);continue}}const A=new L.$rn(this.e),p=new L.$rn(n);for(const N of this.e)p.has(N)||g.push(N);for(const N of n)A.has(N)||E.push(N);const v=R.$XG.createActivationEventsMap(l),F={versionId:t,toRemove:d,toAdd:l,addActivationEvents:v,myToRemove:g,myToAdd:E};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:n,myToRemove:d,myToAdd:l}=t,g=new L.$rn(o),E=new L.$rn(d);for(let D=0;D<this.d.length;D++)g.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of n)this.d.push(D);for(const D of l)this.e.push(D);return this.f=null,t}containsExtension(t){for(const o of this.e)if(L.$qn.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const n=R.$XG.readActivationEvents(o);for(const d of n)t.add(d)}return t}}e.$dH=I;function S(s){const t=new L.$sn;for(const o of s)t.set(o.identifier,o);return t}function u(s,t){return s.enabledApiProposals?s.enabledApiProposals.includes(t):!1}function P(s,t){if(!u(s,t))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class w{constructor(t,o,n,d){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=n,this.activationReason=d}}e.$gH=w;class a{constructor(t,o){this.description=t,this.value=o}}e.$hH=a;var m;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function $(s){return{type:s.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,C.$Qp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function f(s,t){const o=(0,C.$Op)(s.manifest.publisher,s.manifest.name);return{id:o,identifier:new L.$qn(o),isBuiltin:s.type===L.ExtensionType.System,isUserBuiltin:s.type===L.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!t,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$kH=i}),define(ke[270],Ie([1,0,13,3,159,23,25,11,7]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=e.$Xpc=e.$Wpc=e.$Vpc=e.$Upc=e.$Tpc=void 0,r=qe(r);class c{static{this.NONE=new c(!1,-1,-1,-1)}constructor(f,i,s,t){this.startup=f,this.codeLoadingTime=i,this.activateCallTime=s,this.activateResolvedTime=t}}e.$Tpc=c;class I{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,i){return f===-1||i===-1?-1:i-f}build(){return new c(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Upc=I;class S{constructor(f,i,s,t,o,n){this.activationFailed=f,this.activationFailedError=i,this.activationTimes=s,this.module=t,this.exports=o,this.disposable=n}}e.$Vpc=S;class u extends S{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,h.$Uc.None)}}e.$Wpc=u;class P extends S{constructor(){super(!1,null,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Uc.None)}}e.$Xpc=P;class w extends S{constructor(f){super(!0,f,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Uc.None)}}let a=class{constructor(f,i,s,t){this.g=t,this.a=f,this.b=i,this.c=s,this.d=new R.$sn,this.f=Object.create(null)}dispose(){for(const[f,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const f=[];for(const[i,s]of this.d)f.push(s.wait());await Promise.all(f)}isActivated(f){const i=this.d.get(f);return!!(i&&i.value)}getActivatedExtension(f){const i=this.d.get(f);if(!i||!i.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return i.value}async activateByEvent(f,i){if(this.f[f])return;const s=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(s.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,i){const s=this.a.getExtensionDescription(f);if(!s)throw new Error(`Extension '${f.value}' is not known`);return this.h([{id:s.identifier,reason:i}])}async h(f){const i=f.filter(s=>!this.isActivated(s.id)).map(s=>this.j(s));await Promise.all(i.map(s=>s.wait()))}j(f){if(this.d.has(f.id))return this.d.get(f.id);if(this.l(f.id))return this.k(f,null,[],null);const i=this.a.getExtensionDescription(f.id);if(!i){const o=new Error(`Cannot activate unknown extension '${f.id.value}'`),n=this.k(f,null,[],new w(o));return this.c.onExtensionActivationError(f.id,o,new L.$cH(f.id.value)),n}const s=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const n=this.d.get(o);if(n){s.push(n);continue}if(this.l(o)){s.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:f.reason}));continue}const d=this.a.getExtensionDescription(o);if(d){if(!d.main&&!d.browser)continue;s.push(this.j({id:d.identifier,reason:f.reason}));continue}const l=i.displayName||i.identifier.value,g=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${o}'`),E=this.k(f,i.displayName,[],new w(g));return this.c.onExtensionActivationError(i.identifier,g,new L.$cH(o)),E}return this.k(f,i.displayName,s,null)}k(f,i,s,t){const o=new m(f.id,i,f.reason,s,t,this.c,this.g);return this.d.set(f.id,o),o}l(f){return C.$Edc.isHostExtension(f,this.a,this.b)}m(f){const i=this.b.getExtensionDescription(f);return i?!i.main&&!i.browser:!1}};e.$Ypc=a,e.$Ypc=a=Je([Ve(3,T.$_j)],a);let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,i,s,t,o,n,d){this.c=f,this.d=i,this.f=s,this.g=t,this.h=o,this.j=n,this.k=d,this.a=new b.$Dh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const i=this.g[f];if(i.value&&!i.value.activationFailed){this.g.splice(f,1),f--;continue}if(i.value&&i.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);s.detail=i.value.activationFailedError,this.h=new w(s),this.j.onExtensionActivationError(this.c,s,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const i=new Error;if(f&&f.name&&(i.name=f.name),f&&f.message?i.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(i.stack=f.stack),this.h=new w(i),this.b&&r.$3(f))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};m=Je([Ve(6,T.$_j)],m)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[160],Ie([1,0,8,13,43,146,116,36,23,115,147,143]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=void 0,r=qe(r),C=Ut(C);const u=T.$qo.as(L.$ro.JSONContribution);class P{constructor(t,o,n){this.a=t,this.b=o,this.c=n}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(C.default.Error,t)}warn(t){this.d(C.default.Warning,t)}info(t){this.d(C.default.Info,t)}}e.$6G=P;class w{static a(t){const o=new b.$rn;for(let n=0,d=t.length;n<d;n++)o.add(t[n].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new w(o,[]);if(!o||!o.length)return new w([],t);const n=this.a(t),d=this.a(o),l=o.filter(E=>!n.has(E.description.identifier)),g=t.filter(E=>!d.has(E.description.identifier));return new w(l,g)}constructor(t,o){this.added=t,this.removed=o}}e.$7G=w;class a{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=w.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$Y)(t)}}}e.$8G=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(1831,null),r.localize(1832,null)]},$="vscode://schemas/vscode-extensions";e.$9G={properties:{engines:{type:"object",description:r.localize(1833,null),properties:{vscode:{type:"string",description:r.localize(1834,null),default:"^1.22.0"}}},publisher:{description:r.localize(1835,null),type:"string"},displayName:{description:r.localize(1836,null),type:"string"},categories:{description:r.localize(1837,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$pn},{type:"string",const:"Languages",deprecationMessage:r.localize(1838,null)}]}},galleryBanner:{type:"object",description:r.localize(1839,null),properties:{color:{description:r.localize(1840,null),type:"string"},theme:{description:r.localize(1841,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(1842,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(1843,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(1844,null)},enabledApiProposals:{markdownDescription:r.localize(1845,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals).map(s=>s),markdownEnumDescriptions:Object.values(S.allApiProposals).map(s=>s.proposal)}},api:{markdownDescription:r.localize(1846,null),type:"string",enum:["none"],enumDescriptions:[r.localize(1847,null)]},activationEvents:{description:r.localize(1848,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(1849,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(1850,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(1851,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(1852,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(1853,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(1854,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(1855,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(1856,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(1857,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(1858,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(1859,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(1860,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(1861,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(1862,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(1863,null)},{label:"onUri",body:"onUri",description:r.localize(1864,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(1865,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(1866,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(1867,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(1868,null)},{label:"onRenderer",description:r.localize(1869,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(1870,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(1871,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(1872,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(1873,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:r.localize(1874,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:r.localize(1875,null)},{label:"*",description:r.localize(1876,null),body:"*"}]}},badges:{type:"array",description:r.localize(1877,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(1878,null)},href:{type:"string",description:r.localize(1879,null)},description:{type:"string",description:r.localize(1880,null)}}}},markdown:{type:"string",description:r.localize(1881,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(1882,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(1883,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$0o}},extensionPack:{description:r.localize(1884,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$0o}},extensionKind:{description:r.localize(1885,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(1886,null)},{body:["workspace"],description:r.localize(1887,null)},{body:["ui","workspace"],description:r.localize(1888,null)},{body:["workspace","ui"],description:r.localize(1889,null)},{body:[],description:r.localize(1890,null)}]},capabilities:{description:r.localize(1891,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(1892,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(1893,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1894,null),r.localize(1895,null),r.localize(1896,null)]},description:{type:"string",markdownDescription:r.localize(1897,null)}}},untrustedWorkspaces:{description:r.localize(1898,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(1899,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1900,null),r.localize(1901,null),r.localize(1902,null)]},restrictedConfigurations:{description:r.localize(1903,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(1904,null)}}}}},sponsor:{description:r.localize(1905,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(1906,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(1907,null),type:"string"},"vscode:uninstall":{description:r.localize(1908,null),type:"string"}}},icon:{type:"string",description:r.localize(1909,null)},l10n:{type:"string",description:r.localize(1910,null)},pricing:{type:"string",markdownDescription:r.localize(1911,null),enum:["Free","Trial"],default:"Free"}}};class f{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new a(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$XG.register(t.extensionPoint,t.activationEventsGenerator),e.$9G.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema($,e.$9G),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$0G=f;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$qo.add(i.ExtensionsRegistry,new f),e.$$G=T.$qo.as(i.ExtensionsRegistry),u.registerSchema($,e.$9G),u.registerSchema(c.$tk,{properties:{extensionEnabledApiProposals:{description:r.localize(1912,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals).map(s=>s.proposal)}}]}}}})}),define(ke[271],Ie([1,0,4,39,3,12,8,23,5,11,25,160]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nH=e.$mH=e.$lH=e.ChatMessageRole=void 0;var u;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$lH=(0,b.$Ei)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(8381,null)}}};e.$mH=S.$$G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(8382,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(a,m)=>{for(const $ of a)m.push(`onLanguageModelChat:${$.vendor}`)}});let w=class{constructor(m,$){this.e=m,this.f=$,this.a=new C.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$le),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$mH.setHandler(f=>{this.c.clear();for(const s of f){if(!(0,I.$eH)(s.description,"chatProvider")){s.collector.error((0,L.localize)(8383,null));continue}for(const t of h.Iterable.wrap(s.value)){if(this.c.has(t.vendor)){s.collector.error((0,L.localize)(8384,null,t.vendor));continue}if((0,R.$cf)(t.vendor)){s.collector.error((0,L.localize)(8385,null));continue}if(t.vendor.trim()!==t.vendor){s.collector.error((0,L.localize)(8386,null));continue}this.c.add(t.vendor)}}const i=[];for(const[s,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(s),i.push(s));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const f=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(f)}const $=[];for(const[f,i]of this.b)(m.vendor===void 0||i.metadata.vendor===m.vendor)&&(m.family===void 0||i.metadata.family===m.family)&&(m.version===void 0||i.metadata.version===m.version)&&(m.identifier===void 0||i.metadata.id===m.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(s=>T.$qn.equals(s,m.extension)))&&$.push(f);return this.f.trace("[LM] selected language models",m,$),$}registerLanguageModelChat(m,$){if(this.f.trace("[LM] registering language model chat",m,$.metadata),!this.c.has($.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${$.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,$),this.d.fire({added:[{identifier:m,metadata:$.metadata}]}),(0,C.$Sc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,$.metadata))})}async sendChatRequest(m,$,f,i,s){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(f,$,i,s)}computeTokenLength(m,$,f){const i=this.b.get(m);if(!i)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return i.provideTokenCount($,f)}};e.$nH=w,e.$nH=w=Je([Ve(0,I.$bH),Ve(1,c.$_j)],w)}),define(ke[272],Ie([1,0,8,17,24,160,35,4]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=void 0,r=qe(r),h=qe(h),C=qe(C);const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(3898,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(3899,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(3900,null),default:""}}};var c;(function(u){function P(w,a,m){if(!w)return;const $=h.$eg(w.type)?w.type:void 0;if(!$||$.length===0){m.error(r.localize(3901,null));return}const f=[];if(Array.isArray(w.required))for(const i of w.required)h.$eg(i)&&f.push(i);return{extensionId:a.value,taskType:$,required:f,properties:w.properties?C.$do(w.properties):{},when:w.when?L.$Cj.deserialize(w.when):void 0}}u.from=P})(c||(c={}));const I=R.$$G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,P)=>{for(const w of u)w.type&&P.push(`onTaskType:${w.type}`)},jsonSchema:{description:r.localize(3902,null),type:"array",items:b}});class S{constructor(){this.d=new T.$le,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,w)=>{I.setHandler((a,m)=>{this.c=void 0;try{for(const $ of m.removed){const f=$.value;for(const i of f)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const $ of m.added){const f=$.value;for(const i of f){const s=c.from(i,$.description.identifier,$.collector);s&&(this.a[s.taskType]=s)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const w of this.all()){const a={type:"object",additionalProperties:!1};w.required.length>0&&(a.required=w.required.slice(0)),w.properties!==void 0?a.properties=C.$do(w.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[w.taskType]},P.push(a)}this.c={oneOf:P}}return this.c}}e.$SI=new S}),define(ke[273],Ie([1,0,8,17,22,24,35,272,45]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$3I=e.JsonSchemaVersion=e.ExecutionEngine=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$WI=e.ShellQuoting=e.$VI=e.$UI=e.$TI=void 0,r=qe(r),h=qe(h),C=qe(C),R=qe(R),e.$TI="settings",e.$UI=new L.$Vj("taskRunning",!1,r.localize(3886,null)),e.$VI=r.localize2(3888,"Tasks");var c;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$WI="$customized",function(M){function U(V){if(!V)return M.Strong;switch(V.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=U}(c||(e.ShellQuoting=c={}));var I;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var S;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(S||(e.RevealKind=S={})),function(M){function U(V){switch(V.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=U}(S||(e.RevealKind=S={}));var u;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(M){function U(V){switch(V.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=U}(u||(e.RevealProblemKind=u={}));var P;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(P||(e.PanelKind=P={})),function(M){function U(V){switch(V.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=U}(P||(e.PanelKind=P={}));var w;(function(M){M.defaults={echo:!0,reveal:S.Always,revealProblems:u.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var a;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(M){function U(ie){switch(ie.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=U;function V(ie){switch(ie){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=V}(a||(e.RuntimeType=a={}));var m;(function(M){function U(V){return h.$eg(V)?V:V.value}M.value=U})(m||(e.CommandString=m={}));var $;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function U(ie){return ie===M.Clean._id||ie===M.Build._id||ie===M.Rebuild._id||ie===M.Test._id}M.is=U;function V(ie){if(ie!==void 0)return h.$eg(ie)?U(ie)?{_id:ie,isDefault:!1}:void 0:ie}M.from=V})($||(e.TaskGroup=$={}));var f;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(f||(e.TaskScope=f={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function U(V){switch(V){case M.User:return b.ConfigurationTarget.USER;case M.WorkspaceFile:return b.ConfigurationTarget.WORKSPACE;default:return b.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var s;(function(M){M.parallel="parallel",M.sequence="sequence"})(s||(e.DependsOrder=s={}));var t;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class n{constructor(U,V,ie,B,Y,J){this._label="",this._id=U,V&&(this._label=V),ie&&(this.type=ie),this.runOptions=B,this.configurationProperties=Y,this._source=J}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,V=!1){if(U===void 0)return!1;if(h.$eg(U))return U===this._label||U===this.configurationProperties.identifier||V&&U===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$XI=n;class d extends n{constructor(U,V,ie,B,Y,J,_,le){super(U,ie,void 0,_,le,V),this.command={},this._source=V,this.hasDefinedMatchers=J,Y&&(this.command=Y)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case a.Shell:V="shell";break;case a.Process:V="process";break;case a.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(U){return U instanceof d}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$TI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const ie={type:e.$WI,folder:U,id:V};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$ch(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new d(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$YI=d;class l extends n{constructor(U,V,ie,B,Y,J,_){super(U,ie,B,J,_,V),this._source=V,this.configures=Y}static is(U){return U instanceof l}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$ch(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$TI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const ie={type:e.$WI,folder:U,id:V};return JSON.stringify(ie)}}e.$ZI=l;class g extends n{constructor(U,V,ie,B,Y,J,_,le,re){super(U,ie,B,le,re,V),this.defines=Y,this.hasDefinedMatchers=_,this.command=J,this.icon=re.icon,this.hide=re.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof g}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===f.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new g(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$1I=g;class E extends n{constructor(U,V,ie,B,Y,J){super(U,ie,B,Y,J,V),this._source=V}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new E(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$2I=E;var D;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(M){M._default=M.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class k{constructor(U){this.c=new Map;for(let V=0;V<U.length;V++)this.c.set(U[V].uri.toString(),V)}compare(U,V){const ie=U.getWorkspaceFolder(),B=V.getWorkspaceFolder();if(ie&&B){let Y=this.c.get(ie.uri.toString());Y=Y===void 0?0:Y+1;let J=this.c.get(B.uri.toString());return J=J===void 0?0:J+1,Y===J?U._label.localeCompare(V._label):Y-J}else return!ie&&B?-1:ie&&!B?1:0}}e.$3I=k;var A;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(A||(e.TaskEventKind=A={}));var p;(function(M){M.SingleRun="singleRun",M.Background="background"})(p||(e.TaskRunType=p={}));var v;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var F;(function(M){function U(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?p.Background:p.SingleRun,group:le.configurationProperties.group,__task:le}}function V(le,re,Se){return{...U(le),kind:A.Start,terminalId:re,resolvedVariables:Se}}M.start=V;function ie(le,re,Se){return{...U(le),kind:A.ProcessStarted,terminalId:re,processId:Se}}M.processStarted=ie;function B(le,re,Se){return{...U(le),kind:A.ProcessEnded,terminalId:re,exitCode:Se}}M.processEnded=B;function Y(le,re,Se){return{...U(le),kind:A.Terminated,exitReason:Se,terminalId:re}}M.terminated=Y;function J(le,re,Se){return{...U(re),kind:le,terminalId:Se}}M.general=J;function _(){return{kind:A.Changed}}M.changed=_})(F||(e.TaskEvent=F={}));var N;(function(M){function U(ie){const B=Object.keys(ie).sort();let Y="";for(const J of B){let _=ie[J];_ instanceof Object?_=U(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),Y+=J+","+_+","}return Y}function V(ie){const Y={_key:U(ie),type:ie.taskType};return Object.assign(Y,ie),Y}M.create=V})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(O||(e.TaskSettingId=O={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(M){function U(V,ie){const B=T.$SI.get(V.type);if(B===void 0){const le=R.$do(V);return delete le._key,N.create(le)}const Y=Object.create(null);Y.type=B.taskType;const J=new Set;B.required.forEach(le=>J.add(le));const _=B.properties;for(const le of Object.keys(_)){const re=V[le];if(re!=null)Y[le]=re;else if(J.has(le)){const Se=_[le];if(Se.default!==void 0)Y[le]=R.$do(Se.default);else switch(Se.type){case"boolean":Y[le]=!1;break;case"number":case"integer":Y[le]=0;break;case"string":Y[le]="";break;default:ie.error(r.localize(3887,null,JSON.stringify(V,void 0,0),le));return}}}return N.create(Y)}M.createTaskIdentifier=U})(z||(e.TaskDefinition=z={}))}),define(ke[274],Ie([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,T)=>{this.b=L,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,r.$Y)(L))}then(L,T){return this.j().then(L,T)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$Idc=h;class C extends h{constructor(){super(),this.h=!0,this.i=new r.$4}}e.$Jdc=C}),define(ke[53],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=e.$Tw=void 0,e.$Uw=C,e.$Vw=R;class r{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++r.count}}e.$Tw=r;const h=[];function C(T){const b=new r(T);return h[b.nid]=b,b}function R(T){return h[T].sid}class L{constructor(b){this.value=b}}e.$Ww=L}),define(ke[6],Ie([1,0,53]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=e.$HN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$GN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var C;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var T;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var b;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var c;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class S{static{this.a=0}static mixin(m){return m._id=S.a++,m}}e.$GN=S;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var P;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$HN={MainThreadAuthentication:(0,r.$Uw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Uw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Uw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Uw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Uw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Uw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.$Uw)("MainThreadChatSkills"),MainThreadClipboard:(0,r.$Uw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Uw)("MainThreadCommands"),MainThreadComments:(0,r.$Uw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Uw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Uw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Uw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Uw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Uw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Uw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Uw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Uw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Uw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Uw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Uw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Uw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Uw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Uw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Uw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Uw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Uw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Uw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Uw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Uw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Uw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Uw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Uw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Uw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Uw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Uw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Uw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Uw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Uw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Uw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Uw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Uw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Uw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Uw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Uw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Uw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Uw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Uw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Uw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Uw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Uw)("MainThreadSCM"),MainThreadSearch:(0,r.$Uw)("MainThreadSearch"),MainThreadShare:(0,r.$Uw)("MainThreadShare"),MainThreadTask:(0,r.$Uw)("MainThreadTask"),MainThreadWindow:(0,r.$Uw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Uw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Uw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Uw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Uw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Uw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Uw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Uw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Uw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Uw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Uw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Uw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Uw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Uw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Uw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Uw)("MainThreadAiEmbeddingVector")},e.$IN={ExtHostCommands:(0,r.$Uw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Uw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Uw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Uw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Uw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Uw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Uw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Uw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Uw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Uw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Uw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Uw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Uw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Uw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Uw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Uw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Uw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Uw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Uw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Uw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Uw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Uw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Uw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Uw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Uw)("ExtHostSCM"),ExtHostSearch:(0,r.$Uw)("ExtHostSearch"),ExtHostTask:(0,r.$Uw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Uw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Uw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Uw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Uw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Uw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Uw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Uw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Uw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Uw)("ExtHostProgress"),ExtHostComments:(0,r.$Uw)("ExtHostComments"),ExtHostSecretState:(0,r.$Uw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Uw)("ExtHostStorage"),ExtHostUrls:(0,r.$Uw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Uw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Uw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Uw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Uw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Uw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Uw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Uw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Uw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Uw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Uw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Uw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Uw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Uw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.$Uw)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.$Uw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Uw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Uw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Uw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Uw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Uw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Uw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Uw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Uw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Uw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Uw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Uw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Uw)("ExtHostLocalization")}}),define(ke[95],Ie([1,0,5,11,6,19]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=e.$hpc=e.$gpc=void 0,C=qe(C),e.$gpc=(0,r.$Ei)("IExtHostApiDeprecationService");let L=class{constructor(b,c){this.c=c,this.a=new Set,this.b=b.getProxy(C.$HN.MainThreadTelemetry)}report(b,c,I){const S=this.d(b,c);this.a.has(S)||(this.a.add(S),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:b}))}d(b,c){return`${b}-${c.identifier.value}`}};e.$hpc=L,e.$hpc=L=Je([Ve(0,R.$hQ),Ve(1,h.$_j)],L),e.$ipc=Object.freeze(new class{report(T,b,c){}})}),define(ke[275],Ie([1,0,6]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=void 0;class h{constructor(R){const L=R.getProxy(r.$HN.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(T){return L.$writeText(T)}})}}e.$vpc=h}),define(ke[276],Ie([1,0,24,6,29,19]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=void 0;let L=class{constructor(I,S){this.a=I.getProxy(h.$HN.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,S){const u=this,P=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,S,P,arguments)}})}e(I,S,u,P){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:b(P,this.b)}),this.c&&this.f(I,u,P)}};e.$rrc=L,e.$rrc=L=Je([Ve(0,R.$hQ),Ve(1,C.$xQ)],L);const T=1e5;function b(c,I){const S=[];if(c.length)for(let u=0;u<c.length;u++){let P=c[u];if(typeof P>"u")P="undefined";else if(P instanceof Error){const w=P;w.stack?P=w.stack:P=w.toString()}S.push(P)}if(I){const u=new Error().stack;u&&S.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$io)(S);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(ke[277],Ie([1,0,2,6,25]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;class R{constructor(T){this.a=T.getProxy(h.$HN.MainThreadDialogs)}showOpenDialog(T,b){return b?.allowUIResources&&(0,C.$fH)(T,"showLocal"),this.a.$showOpenDialog(b).then(c=>c?c.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(b=>b?r.URI.revive(b):void 0)}}e.$xqc=R}),define(ke[278],Ie([1,0,20,4,3,6]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0;class L{constructor(b){this.b=new Map,this.c=new h.$le,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=b.getProxy(R.$HN.MainThreadEmbeddings)}registerEmbeddingsProvider(b,c,I){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,c),this.b.set(S,{id:c,provider:I}),(0,C.$Sc)(()=>{this.d.delete(c),this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(b,c,I){I??=r.CancellationToken.None;let S=!1;typeof c=="string"&&(c=[c],S=!0);const u=await this.a.$computeEmbeddings(b,c,I);if(u.length!==c.length)throw new Error;if(S){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(b,c,I){const S=this.b.get(b);if(!S)return[];const u=await S.provider.provideEmbeddings(c,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(b){this.d=new Set(b),this.c.fire()}}e.$Aqc=L}),define(ke[279],Ie([1,0,3,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=void 0;class C{constructor(L){this.b=0,this.a=L.getProxy(h.$HN.MainThreadLabelService)}$registerResourceLabelFormatter(L){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,L),(0,r.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Rqc=C}),define(ke[122],Ie([1,0,10,12,2,5,11,6,29,19]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=e.$aqc=void 0;let I=class{constructor(u,P,w){this.f=w,this.d=new Map,this.a=P.getProxy(T.$HN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$h}getMessage(u,P){const{message:w,args:a,comment:m}=P;if(this.c)return(0,h.$ef)(w,a??{});let $=w;m&&m.length>0&&($+=`/${Array.isArray(m)?m.join(""):m}`);const f=this.d.get(u)?.contents[$];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${$}`),(0,h.$ef)(f??w,a??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let P;const w=await this.g(u);if(!w){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(w),m=JSON.parse(a);P=u.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${u.identifier.value} from ${w}: ${a.message}`);return}P&&this.d.set(u.identifier.value,{contents:P,uri:w})}async g(u){if(u.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(P)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$aqc=I,e.$aqc=I=Je([Ve(0,b.$xQ),Ve(1,c.$hQ),Ve(2,L.$_j)],I),e.$bqc=(0,R.$Ei)("IExtHostLocalizationService")}),define(ke[161],Ie([1,0,11,6,29,19,2,51]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qrc=void 0;let b=class extends r.$kk{constructor(S,u){super(u.logLevel,u.logsLocation,u.loggers.map(P=>(0,T.$bi)(P))),this.r=S.getProxy(h.$HN.MainThreadLogger)}$setLogLevel(S,u){u?this.setLogLevel(L.URI.revive(u),S):this.setLogLevel(S)}setVisibility(S,u){super.setVisibility(S,u),this.r.$setVisibility(S,u)}s(S,u,P){return new c(this.r,S,u,P)}};e.$qrc=b,e.$qrc=b=Je([Ve(0,R.$hQ),Ve(1,C.$xQ)],b);class c extends r.$fk{constructor(S,u,P,w){super(w?.logLevel==="always"),this.r=S,this.s=u,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(u,w).then(()=>{this.u(this.n),this.m=!0})}g(S,u){const P=[[S,u]];this.m?this.u(P):this.n.push(...P)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(ke[123],Ie([1,0,6,5,3,19,21]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=e.$cqc=void 0,e.$cqc=(0,h.$Ei)("IExtHostManagedSockets");let T=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(r.$HN.MainThreadManagedSockets)}setFactory(S,u){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(S,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const u=++this.b,P=await this.c.makeConnection(),w=new C.$Tc;return this.d.set(u,new c(u,P,w)),w.add((0,C.$Sc)(()=>this.d.delete(u))),w.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),w.dispose()})),w.add(P.onDidClose(a=>{this.a.$onDidManagedSocketClose(u,a?.stack??a?.message),w.dispose()})),w.add(P.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(u,L.$Ne.wrap(a)))),u}$remoteSocketWrite(S,u){this.d.get(S)?.actual.send(u.buffer)}$remoteSocketEnd(S){const u=this.d.get(S);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$dqc=T,e.$dqc=T=Je([Ve(0,R.$hQ)],T);class b{constructor(S,u){this.socketFactoryId=S,this.makeConnection=u}}class c extends C.$Uc{constructor(S,u,P){super(),this.socketId=S,this.actual=u,this.B(P)}}}),define(ke[280],Ie([1,0,6,11,25]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=void 0;function R(T){return T&&T.title}let L=class{constructor(b,c){this.b=c,this.a=b.getProxy(r.$HN.MainThreadMessageService)}showMessage(b,c,I,S,u){const P={source:{identifier:b.identifier,label:b.displayName||b.name}};let w;typeof S=="string"||R(S)?w=[S,...u]:(P.modal=S?.modal,P.useCustom=S?.useCustom,P.detail=S?.detail,w=u),P.useCustom&&(0,C.$fH)(b,"resolvers");const a=[];let m=!1;for(let $=0;$<w.length;$++){const f=w[$];if(typeof f=="string")a.push({title:f,handle:$,isCloseAffordance:!1});else if(typeof f=="object"){const{title:i,isCloseAffordance:s}=f;a.push({title:i,isCloseAffordance:!!s,handle:$}),s&&(m?this.b.warn(`[${b.identifier}] Only one message item can have 'isCloseAffordance':`,f):m=!0)}else this.b.warn(`[${b.identifier}] Invalid message item:`,f)}return this.a.$showMessage(c,I,P,a).then($=>{if(typeof $=="number")return w[$]})}};e.$Uqc=L,e.$Uqc=L=Je([Ve(1,h.$_j)],L)}),define(ke[281],Ie([1,0,3,17,2,25,6]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0;class T{constructor(c){this.b=new Map,this.a=c.getProxy(L.$HN.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,I,S){if((0,R.$fH)(c,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,S),this.a.$registerProfileContentHandler(I,S.name,S.description,c.identifier.value),(0,r.$Sc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(c,I,S,u){const P=this.b.get(c);if(!P)throw new Error(`Unknown handler with id: ${c}`);return P.saveProfile(I,S,u)}async $readProfile(c,I,S){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,h.$eg)(I)?I:C.URI.revive(I),S)}}e.$4qc=T}),define(ke[124],Ie([1,0,6,4,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$0pc=void 0;class R{constructor(T){this.b=new h.$le,this.onDidChangePassword=this.b.event,this.a=T.getProxy(r.$HN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,b){return this.a.$getPassword(T,b)}store(T,b,c){return this.a.$setPassword(T,b,c)}delete(T,b){return this.a.$deletePassword(T,b)}}e.$0pc=R,e.$$pc=(0,C.$Ei)("IExtHostSecretState")}),define(ke[282],Ie([1,0,20,3,6]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0;class R{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(C.$HN.MainThreadSpeech)}async $createSpeechToTextSession(T,b,c){const I=this.c.get(T);if(!I)return;const S=new h.$Tc,u=new r.$we;this.d.set(b,u);const P=await I.provideSpeechToTextSession(u.token,c?{language:c}:void 0);P&&(S.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,w)})),S.add(u.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,b,c){const I=this.c.get(T);if(!I)return;const S=new h.$Tc,u=new r.$we;this.d.set(b,u);const P=await I.provideTextToSpeechSession(u.token,c?{language:c}:void 0);P&&(this.f.set(b,P),S.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(b,w)})),S.add(u.token.onCancellationRequested(()=>S.dispose())))}async $synthesizeSpeech(T,b){this.f.get(T)?.synthesize(b)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,b){const c=this.c.get(T);if(!c)return;const I=new h.$Tc,S=new r.$we;this.d.set(b,S);const u=await c.provideKeywordRecognitionSession(S.token);u&&(I.add(u.onDidChange(P=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(b,P)})),I.add(S.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,b,c){const I=R.a++;return this.c.set(I,c),this.b.$registerProvider(I,b,{extension:T,displayName:T.value}),(0,h.$Sc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$$qc=R}),define(ke[125],Ie([1,0,6,4,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=e.$Zpc=void 0;class R{constructor(T,b){this.c=b,this.b=new h.$le,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(r.$HN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,b){this.a.$registerExtensionStorageKeysToSync(T,b)}async initializeExtensionStorage(T,b,c){const I=await this.a.$initializeExtensionStorage(T,b);let S;return I&&(S=this.d(T,b,I)),S||c}setValue(T,b,c){return this.a.$setValue(T,b,c)}$acceptValue(T,b,c){const I=this.d(T,b,c);I&&this.b.fire({shared:T,key:b,value:I})}d(T,b,c){try{return JSON.parse(c)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${T}): ${I}`)}}}e.$Zpc=R,e.$1pc=(0,C.$Ei)("IExtHostStorage")}),define(ke[283],Ie([1,0,3,14,2,6]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0;class L{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor(b){this.c=new Map,this.b=b.getProxy(R.$HN.MainThreadUriOpeners)}registerExternalUriOpener(b,c,I,S){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=S.schemes.find(P=>!L.a.has(P));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,I),this.b.$registerUriOpener(c,S.schemes,b,S.label),(0,r.$Sc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(b,c,I){const S=this.c.get(b);if(!S)throw new Error(`Unknown opener with id: ${b}`);const u=C.URI.revive(c);return S.canOpenExternalUri(u,I)}async $openUri(b,c,I){const S=this.c.get(b);if(!S)throw new Error(`Unknown opener id: '${b}'`);return S.openExternalUri(C.URI.revive(c.resolvedUri),{sourceUri:C.URI.revive(c.sourceUri)},I)}}e.$krc=L}),define(ke[284],Ie([1,0,6,2,3,13,23]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lrc=void 0;class T{static{this.a=0}constructor(c){this.c=new L.$rn,this.d=new Map,this.b=c.getProxy(r.$HN.MainThreadUrls)}registerUriHandler(c,I){const S=c.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const u=T.a++;return this.c.add(S),this.d.set(u,I),this.b.$registerUriHandler(u,S,c.displayName||c.name),(0,C.$Sc)(()=>{this.c.delete(S),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,I){const S=this.d.get(c);if(!S)return Promise.resolve(void 0);try{S.handleUri(h.URI.revive(I))}catch(u){(0,R.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(c){return h.URI.revive(await this.b.$createAppUri(c))}}e.$lrc=T}),define(ke[285],Ie([1,0,21,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rtb=R,e.$Stb=T,h=qe(h);class C{constructor(){this.buffers=[]}add(c){let I=this.buffers.indexOf(c);return I<0&&(I=this.buffers.length,this.buffers.push(c)),I}}function R(b,c){if(c.serializeBuffersForPostMessage){const I=new C,u=JSON.stringify(b,(w,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a)};if(ArrayBuffer.isView(a)){const m=L(a);if(m)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a.buffer),view:{type:m,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),P=I.buffers.map(w=>{const a=new Uint8Array(w);return r.$Ne.wrap(a)});return{message:u,buffers:P}}else return{message:JSON.stringify(b),buffers:[]}}function L(b){switch(b.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(b,c){const I=c.map(P=>{const w=new ArrayBuffer(P.byteLength);return new Uint8Array(w).set(P.buffer),w}),S=c.length?(P,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const a=w,{index:m}=a,$=I[m];if(a.view)switch(a.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array($,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array($,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray($,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array($,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array($,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array($,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array($,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array($,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array($,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array($,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array($,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return $}return w}:void 0;return{message:JSON.parse(b,S),arrayBuffers:I}}}),define(ke[96],Ie([1,0,4,3,14,24,2,235,285,121,6]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=e.$Kpc=void 0,e.$Lpc=u,e.$Npc=a,e.$Opc=m,R=qe(R),I=qe(I);class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(s,t,o,n,d,l,g){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$le,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$le,this._onDidDispose=this.#h.event,this.#e=s,this.#t=t,this.#o=o,this.#n=n,this.#s=d,this.#r=l,this.#u=u(l),this.#d=P(l),this.#i=g}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#l=!0,(0,c.$CDb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===C.Schemas.https||s.scheme===C.Schemas.http){let t=s.toString();return t.endsWith("/")||(t+="/"),t+" "+c.$BDb}return c.$BDb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),R.$ho(this.#o,s)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const t=(0,b.$Rtb)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const t=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,D)=>{const y=L.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),k=(0,c.$CDb)(y,{isRemote:t,authority:o}).toString();return`${d}${k}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,D)=>{const y=L.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),k=(0,c.$CDb)(y,{isRemote:t,authority:o}).toString();return`${d}${k}${D}`})}}e.$Kpc=S;function u(i){try{const s=(0,T.$1p)((0,T.$Zp)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function P(i){try{const s=(0,T.$1p)((0,T.$Zp)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class w extends h.$Uc{constructor(s,t,o,n,d){super(),this.c=t,this.f=o,this.g=n,this.h=d,this.b=new Map,this.a=s.getProxy(I.$HN.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,t,o){const n=this.j(s);if(n){const{message:d}=(0,b.$Stb)(t,o.value);n._onMessageEmitter.fire(d)}}$onMissingCsp(s,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,t,o){const n=new S(s,this.a,$(t),this.c,this.f,o,this.h);this.b.set(s,n);const d=n._onDidDispose(()=>{d.dispose(),this.deleteWebview(s)});return n}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$Mpc=w;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,s,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||f(i,s)}}function $(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>L.URI.from(s))}}function f(i,s){return[...(s?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(ke[162],Ie([1,0,4,14,12,2,5,19,6]),function($e,e,r,h,C,R,L,T,b){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=e.$nrc=void 0;let I=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$le,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy(b.$HN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:w})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,P){P!==this.d[u]&&(this.d={...this.d,[u]:P},this.c.fire(this.d))}openUri(u,P){let w;if(typeof u=="string"){w=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,C.$cf)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,w,P)}async asExternalUri(u,P){if((0,C.$cf)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(u,P);return R.URI.from(w)}};e.$nrc=I,e.$nrc=I=c=Je([Ve(0,T.$hQ)],I),e.$orc=(0,L.$Ei)("IExtHostWindow")}),define(ke[286],Ie([1,0,276,29,19,93]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3rc=void 0;const L=1024*1024;let T=class extends r.$rrc{constructor(c,I){super(c,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,I,S){const u=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),I.apply(console,S),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(c,I){const S=process[c],u=S.write;let P="";Object.defineProperty(S,"write",{set:()=>{},get:()=>(w,a,m)=>{if(!this.g){P+=w.toString(a);const $=P.length>L?P.length:P.lastIndexOf(`
`);$!==-1&&(console[I](P.slice(0,$)),P=P.slice($+1))}u.call(S,w,a,m)}})}};e.$3rc=T,e.$3rc=T=Je([Ve(0,C.$hQ),Ve(1,h.$xQ)],T)}),define(ke[287],Ie([1,0,161,14,229,32]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csc=void 0;class L extends r.$qrc{s(b,c,I){return b.scheme===h.Schemas.file?new C.$wR(I?.name||(0,R.$1g)(),b.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,c):super.s(b,c,I)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$csc=L}),define(ke[288],Ie([1,0,7,21,20,26,13,4,3,40,138,274,53]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Kdc=f,e.$Ldc=i,L=qe(L);function w(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const a="$$ref$$",m={[a]:-1};class ${constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function f(F,N=null,O=!1){const j=[];return{jsonString:(O?w:JSON.stringify)(F,(M,U)=>{if(typeof U>"u")return m;if(typeof U=="object"){if(U instanceof h.$Ne){const V=j.push(U)-1;return{[a]:V}}if(N)return N(M,U)}return U}),referencedBuffers:j}}function i(F,N,O){return JSON.parse(F,(j,z)=>{if(z){const M=z[a];if(typeof M=="number")return N[M];if(O&&z.$mid===c.MarshalledId.Uri)return O.transformIncoming(z)}return z})}function s(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,O)=>O&&O.$mid===c.MarshalledId.Uri?F.transformOutgoing(O):O:null}var o;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var n;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(n||(e.ResponsiveState=n={}));const d=()=>{},l=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class E extends b.$Uc{static{P=l}static{this.a=3*1e3}constructor(N,O=null,j=null){super(),this[P]=!0,this.b=this.B(new T.$le),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=j,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,M=u.$Tw.count;z<M;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=n.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Qh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(L.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(n.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(n.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,I.$On)(N,this.g):N}getProxy(N){const{nid:O,sid:j}=N;return this.s[O]||(this.s[O]=this.J(O,j)),this.s[O]}J(N,O){const j={get:(z,M)=>(typeof M=="string"&&!z[M]&&M.charCodeAt(0)===R.CharCode.DollarSign&&(z[M]=(...U)=>this.U(N,M,U)),M===g?O:z[M])};return new Proxy(Object.create(null),j)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,j=N.length;O<j;O++){const z=N[O];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,j=y.read(N,0),z=j.readUInt8(),M=j.readUInt32();switch(z){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:U,method:V,args:ie}=A.deserializeRequestJSONArgs(j);this.g&&(ie=(0,I.$On)(ie,this.g)),this.M(O,M,U,V,ie,z===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:U,method:V,args:ie}=A.deserializeRequestMixedArgs(j);this.g&&(ie=(0,I.$On)(ie,this.g)),this.M(O,M,U,V,ie,z===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(O,M,o.LocalSide,"ack"),this.G(M);break}case p.Cancel:{this.N(O,M);break}case p.ReplyOKEmpty:{this.O(O,M,void 0);break}case p.ReplyOKJSON:{let U=A.deserializeReplyOKJSON(j);this.g&&(U=(0,I.$On)(U,this.g)),this.O(O,M,U);break}case p.ReplyOKJSONWithBuffers:{const U=A.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(O,M,U);break}case p.ReplyOKVSBuffer:{const U=A.deserializeReplyOKVSBuffer(j);this.O(O,M,U);break}case p.ReplyErrError:{let U=A.deserializeReplyErrError(j);this.g&&(U=(0,I.$On)(U,this.g)),this.P(O,M,U);break}case p.ReplyErrEmpty:{this.P(O,M,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,j,z,M,U){this.f?.logIncoming(N,O,o.OtherSide,`receiveRequest ${(0,u.$Vw)(j)}.${z}(`,M);const V=String(O);let ie,B;if(U){const J=new C.$we;M.push(J.token),ie=this.Q(j,z,M),B=()=>J.cancel()}else ie=this.Q(j,z,M),B=d;this.u[V]=B;const Y=A.serializeAcknowledged(O);this.f?.logOutgoing(Y.byteLength,O,o.OtherSide,"ack"),this.c.send(Y),ie.then(J=>{delete this.u[V];const _=A.serializeReplyOK(O,J,this.h);this.f?.logOutgoing(_.byteLength,O,o.OtherSide,"reply:",J),this.c.send(_)},J=>{delete this.u[V];const _=A.serializeReplyErr(O,J);this.f?.logOutgoing(_.byteLength,O,o.OtherSide,"replyErr:",J),this.c.send(_)})}N(N,O){this.f?.logIncoming(N,O,o.OtherSide,"receiveCancel");const j=String(O);this.u[j]?.()}O(N,O,j){this.f?.logIncoming(N,O,o.LocalSide,"receiveReply:",j);const z=String(O);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z],M.resolveOk(j)}P(N,O,j){this.f?.logIncoming(N,O,o.LocalSide,"receiveReplyErr:",j);const z=String(O);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z];let U;j&&(j.$isError?(U=new Error,U.name=j.name,U.message=j.message,U.stack=j.stack):U=j),M.resolveErr(U)}Q(N,O,j){try{return Promise.resolve(this.S(N,O,j))}catch(z){return Promise.reject(z)}}S(N,O,j){const z=this.m[N];if(!z)throw new Error("Unknown actor "+(0,u.$Vw)(N));const M=z[O];if(typeof M!="function")throw new Error("Unknown method "+O+" on actor "+(0,u.$Vw)(N));return M.apply(z,j)}U(N,O,j){if(this.j)return new S.$Jdc;let z=null;if(j.length>0&&C.CancellationToken.isCancellationToken(j[j.length-1])&&(z=j.pop()),z&&z.isCancellationRequested)return Promise.reject(L.$5());const M=A.serializeRequestArguments(j,this.h),U=++this.t,V=String(U),ie=new S.$Idc,B=new b.$Tc;z&&B.add(z.onCancellationRequested(()=>{const J=A.serializeCancel(U);this.f?.logOutgoing(J.byteLength,U,o.LocalSide,"cancel"),this.c.send(A.serializeCancel(U))})),this.w[V]=new D(ie,B),this.F(U);const Y=A.serializeRequest(U,N,O,M,!!z);return this.f?.logOutgoing(Y.byteLength,U,o.LocalSide,`request: ${(0,u.$Vw)(N)}.${O}(`,j),this.c.send(Y),ie}}e.$Mdc=E;class D{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class y{static alloc(N,O,j){const z=new y(h.$Ne.alloc(j+1+4),0);return z.writeUInt8(N),z.writeUInt32(O),z}static read(N,O){return new y(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let j=0,z=N.length;j<z;j++){const M=N[j];switch(O+=1,M.type){case v.String:O+=this.sizeLongString(M.value);break;case v.VSBuffer:O+=this.sizeVSBuffer(M.value);break;case v.SerializedObjectWithBuffers:O+=this.sizeUInt32,O+=this.sizeLongString(M.value);for(let U=0;U<M.buffers.length;++U)O+=this.sizeVSBuffer(M.buffers[U]);break;case v.Undefined:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,j=N.length;O<j;O++){const z=N[O];switch(z.type){case v.String:this.writeUInt8(v.String),this.writeLongString(z.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(z.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let M=0;M<z.buffers.length;++M)this.writeBuffer(z.buffers[M]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let j=0;j<N;j++)switch(this.readUInt8()){case v.String:O[j]=this.readLongString();break;case v.VSBuffer:O[j]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const M=this.readUInt32(),U=this.readLongString(),V=[];for(let ie=0;ie<M;++ie)V.push(this.readVSBuffer());O[j]=new u.$Ww(i(U,V,null));break}case v.Undefined:O[j]=void 0;break}return O}}var k;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(k||(k={}));class A{static a(N){for(let O=0,j=N.length;O<j;O++)if(N[O]instanceof h.$Ne||N[O]instanceof u.$Ww||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const j=[];for(let z=0,M=N.length;z<M;z++){const U=N[z];if(U instanceof h.$Ne)j[z]={type:v.VSBuffer,value:U};else if(typeof U>"u")j[z]={type:v.Undefined};else if(U instanceof u.$Ww){const{jsonString:V,referencedBuffers:ie}=f(U.value,O);j[z]={type:v.SerializedObjectWithBuffers,value:h.$Ne.fromString(V),buffers:ie}}else j[z]={type:v.String,value:h.$Ne.fromString(s(U,O))}}return{type:k.Mixed,args:j}}return{type:k.Simple,args:s(N,O)}}static serializeRequest(N,O,j,z,M){switch(z.type){case k.Simple:return this.b(N,O,j,z.args,M);case k.Mixed:return this.c(N,O,j,z.args,M)}}static b(N,O,j,z,M){const U=h.$Ne.fromString(j),V=h.$Ne.fromString(z);let ie=0;ie+=y.sizeUInt8(),ie+=y.sizeShortString(U),ie+=y.sizeLongString(V);const B=y.alloc(M?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,N,ie);return B.writeUInt8(O),B.writeShortString(U),B.writeLongString(V),B.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),j=N.readShortString(),z=N.readLongString();return{rpcId:O,method:j,args:JSON.parse(z)}}static c(N,O,j,z,M){const U=h.$Ne.fromString(j);let V=0;V+=y.sizeUInt8(),V+=y.sizeShortString(U),V+=y.sizeMixedArray(z);const ie=y.alloc(M?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,N,V);return ie.writeUInt8(O),ie.writeShortString(U),ie.writeMixedArray(z),ie.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),j=N.readShortString(),z=N.readMixedArray(),M=new Array(z.length);for(let U=0,V=z.length;U<V;U++){const ie=z[U];typeof ie=="string"?M[U]=JSON.parse(ie):M[U]=ie}return{rpcId:O,method:j,args:M}}static serializeAcknowledged(N){return y.alloc(p.Acknowledged,N,0).buffer}static serializeCancel(N){return y.alloc(p.Cancel,N,0).buffer}static serializeReplyOK(N,O,j){if(typeof O>"u")return this.d(N);if(O instanceof h.$Ne)return this.e(N,O);if(O instanceof u.$Ww){const{jsonString:z,referencedBuffers:M}=f(O.value,j,!0);return this.g(N,z,M)}else return this.f(N,w(O,j))}static d(N){return y.alloc(p.ReplyOKEmpty,N,0).buffer}static e(N,O){let j=0;j+=y.sizeVSBuffer(O);const z=y.alloc(p.ReplyOKVSBuffer,N,j);return z.writeVSBuffer(O),z.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const j=h.$Ne.fromString(O);let z=0;z+=y.sizeLongString(j);const M=y.alloc(p.ReplyOKJSON,N,z);return M.writeLongString(j),M.buffer}static g(N,O,j){const z=h.$Ne.fromString(O);let M=0;M+=y.sizeUInt32,M+=y.sizeLongString(z);for(const V of j)M+=y.sizeVSBuffer(V);const U=y.alloc(p.ReplyOKJSONWithBuffers,N,M);U.writeUInt32(j.length),U.writeLongString(z);for(const V of j)U.writeBuffer(V);return U.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const j=N.readUInt32(),z=N.readLongString(),M=[];for(let U=0;U<j;++U)M.push(N.readVSBuffer());return new u.$Ww(i(z,M,O))}static serializeReplyErr(N,O){const j=O?w(L.$1(O),null):void 0;if(typeof j!="string")return this.h(N);const z=h.$Ne.fromString(j);let M=0;M+=y.sizeLongString(z);const U=y.alloc(p.ReplyErrError,N,M);return U.writeLongString(z),U.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return y.alloc(p.ReplyErrEmpty,N,0).buffer}}var p;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var v;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(v||(v={}))}),define(ke[289],Ie([1,0,21,28,14,88,5]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sL=e.$pL=void 0,e.$qL=I,e.$rL=S,e.$pL=(0,L.$Ei)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${T.join("")}]+`),c=7;function I(P){if(P.scheme!==C.Schemas.vscodeNotebookCell)return;const w=P.fragment.indexOf("s");if(w<0)return;const a=parseInt(P.fragment.substring(0,w).replace(b,""),c),m=(0,r.$7e)(P.fragment.substring(w+1)).toString();if(!isNaN(a))return{handle:a,notebook:P.with({scheme:m,fragment:null})}}function S(P,w){const a=w.toString(c),$=`${a.length<T.length?T[a.length-1]:"z"}${a}s${(0,r.$8e)(r.$Ne.fromString(P.scheme),!0,!0)}`;return P.with({scheme:C.Schemas.vscodeNotebookCell,fragment:$})}class u{constructor(){this.a=new h.$Ac}getNotebook(w){if(w.scheme===C.Schemas.vscodeNotebookCell){const a=I(w);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$sL=u,(0,R.$Qs)(e.$pL,u,R.InstantiationType.Delayed)}),define(ke[126],Ie([1,0,21,38,39,103,14,16,10,35,289]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$JL=e.CellStatusbarAlignment=e.$IL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$FL=e.$EL=e.$CL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$BL=e.$AL=e.$zL=e.$yL=e.CellKind=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=void 0,e.$DL=n,e.$GL=g,e.$HL=E,e.$KL=k,e.$LL=p,h=qe(h),e.$tL="workbench.editor.notebook",e.$uL="workbench.editor.notebookTextDiffEditor",e.$vL="workbench.editor.interactive",e.$wL="workbench.editor.repl",e.$xL="replNotebook.input.execute";var S;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(S||(e.CellKind=S={})),e.$yL=["application/json","application/javascript","text/html","image/svg+xml",R.$0s.latex,R.$0s.markdown,"image/png","image/jpeg",R.$0s.text],e.$zL=[R.$0s.latex,R.$0s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$0s.text],e.$AL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$BL="_notAvailable";var u;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var P;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var w;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var a;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var $;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})($||(e.NotebookCellsChangeType=$={}));var f;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var i;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(V){V.scheme=L.Schemas.vscodeNotebookCell;function ie(re,Se){return(0,I.$rL)(re,Se)}V.generate=ie;function B(re){return(0,I.$qL)(re)}V.parse=B;function Y(re,Se){return re.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${Se??""},${re.scheme!==L.Schemas.file?re.scheme:""}`})}V.generateCellOutputUri=Y;function J(re){if(re.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const Se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!Se)return;const me=Se[1]&&Se[1]!==""?Se[1]:void 0,Q=Se[2];return{outputId:me,notebook:re.with({scheme:Q||L.Schemas.file,fragment:null})}}V.parseCellOutputUri=J;function _(re,Se,me){return V.generate(re,Se).with({scheme:me})}V.generateCellPropertyUri=_;function le(re,Se){if(re.scheme===Se)return V.parse(re.with({scheme:V.scheme}))}V.parseCellPropertyUri=le})(s||(e.CellUri=s={}));const t=V=>b.$j?V.replace(/\//g,"\\"):V;class o{constructor(ie=[],B=e.$yL){this.e=B,this.d=[...new Set(ie)].map(Y=>({pattern:Y,matches:h.$zk(t(Y))}))}sort(ie){const B=new Map(C.Iterable.map(ie,J=>[J,t(J)]));let Y=[];for(const{matches:J}of this.d)for(const[_,le]of B)if(J(le)){Y.push(_),B.delete(_);break}return B.size&&(Y=Y.concat([...B.keys()].sort((J,_)=>this.e.indexOf(J)-this.e.indexOf(_)))),Y}prioritize(ie,B){const Y=this.f(ie);if(Y===-1){this.d.unshift({pattern:ie,matches:h.$zk(t(ie))});return}const J=new Set(B.map(le=>this.f(le,Y)));J.delete(-1);const _=Array.from(J).sort();this.d.splice(Y+1,0,..._.map(le=>this.d[le]));for(let le=_.length-1;le>=0;le--)this.d.splice(_[le],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,B=this.d.length){const Y=t(ie);for(let J=0;J<B;J++)if(this.d[J].matches(Y))return J;return-1}}e.$CL=o;function n(V,ie,B,Y=(J,_)=>J===_){const J=[];function _(Se,me,Q){if(me===0&&Q.length===0)return;const q=J[J.length-1];q&&q.start+q.deleteCount===Se?(q.deleteCount+=me,q.toInsert.push(...Q)):J.push({start:Se,deleteCount:me,toInsert:Q})}let le=0,re=0;for(;;){if(le===V.length){_(le,0,ie.slice(re));break}if(re===ie.length){_(le,V.length-le,[]);break}const Se=V[le],me=ie[re];if(Y(Se,me)){le+=1,re+=1;continue}B(me)?(_(le,1,[]),le+=1):(_(le,0,[me]),re+=1)}return J}e.$EL=new c.$Vj("notebookEditorCursorAtBoundary","none"),e.$FL=new c.$Vj("notebookEditorCursorAtLineBoundary","none");var d;(function(V){V.default="default",V.option="option"})(d||(e.NotebookEditorPriority=d={}));var l;(function(V){V.Cells="cells",V.Text="text",V.None="none"})(l||(e.NotebookFindScopeType=l={}));function g(V){const ie=V;return!!((typeof ie.include=="string"||h.$Ak(ie.include))&&(typeof ie.exclude=="string"||h.$Ak(ie.exclude)))}function E(V,ie,B){if(Array.isArray(V.viewType)&&V.viewType.indexOf(ie)>=0||V.viewType===ie)return!0;if(V.filenamePattern){const Y=g(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,J=g(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(h.$yk(Y,(0,T.$nc)(B.fsPath).toLowerCase()))return!(J&&h.$yk(J,(0,T.$nc)(B.fsPath).toLowerCase()))}return!1}e.$IL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class y{static{this.d="notebook/"}static create(ie){return`${y.d}${ie}`}static parse(ie){if(ie.startsWith(y.d))return ie.substring(y.d.length)}}e.$JL=y;function k(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}const A=new TextDecoder;function p(V){const ie=[];let B=!1;for(const le of V)(ie.length===0||B)&&(ie.push(le),B=!0);let Y=N(ie);const J=r.$Ne.concat(ie.map(le=>r.$Ne.wrap(le))),_=U(J);return Y=Y||_.byteLength!==J.byteLength,{data:_,didCompression:Y}}e.$ML="\x1B[A";const v=e.$ML.split("").map(V=>V.charCodeAt(0)),F=10;function N(V){let ie=!1;return V.forEach((B,Y)=>{if(Y===0||B.length<e.$ML.length)return;const J=V[Y-1],_=B.subarray(0,e.$ML.length);if(_[0]===v[0]&&_[1]===v[1]&&_[2]===v[2]){const le=J.lastIndexOf(F);if(le===-1)return;ie=!0,V[Y-1]=J.subarray(0,le),V[Y]=B.subarray(e.$ML.length)}}),ie}function O(V){let ie=V;do V=ie,ie=V.replace(/[^\n]\x08/gm,"");while(ie.length<V.length);return V}function j(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const ie=V.match(/^(.*)\r+/m)[1];let B=V.match(/\r+(.*)$/m)[1];B=B+ie.slice(B.length,ie.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return V}const z=8,M=13;function U(V){return!V.buffer.includes(z)&&!V.buffer.includes(M)?V:r.$Ne.fromString(j(O(A.decode(V.buffer))))}}),define(ke[9],Ie([1,0,18,13,85,28,103,12,17,2,32,23,27,71,126]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w){"use strict";var a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$9P=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.LanguageModelChatMessageRole=e.$ZP=e.$YP=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$IP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$vP=e.$uP=e.$tP=e.$sP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.TestRunProfileKind=e.TestResultState=e.$lP=e.$kP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$jP=e.NotebookVariablesRequestKind=e.$iP=e.$hP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$gP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.ColorThemeKind=e.$aP=e.$_O=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$$O=e.QuickInputButtonLocation=e.$0O=e.DebugConsoleMode=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$4O=e.$3O=e.FileChangeType=e.$2O=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$1O=e.$ZO=e.$YO=e.$XO=e.InlineCompletionTriggerKind=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$KO=e.ConfigurationTarget=e.$JO=e.$IO=e.$HO=e.$GO=e.DocumentPasteTriggerKind=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$zO=e.ViewBadge=e.ProgressLocation=e.$yO=e.$xO=e.TaskScope=e.ShellQuoting=e.$wO=e.$vO=e.$uO=e.TaskPanelKind=e.TaskRevealKind=e.$tO=e.TerminalLocation=e.$sO=e.$rO=e.$qO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$pO=e.$oO=e.$nO=e.$mO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$kO=e.$jO=e.$iO=e.$hO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$gO=e.$fO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.LanguageStatusSeverity=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.CodeActionTriggerKind=e.$6N=e.$5N=e.SymbolTag=e.SymbolKind=e.$4N=e.$3N=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.DiagnosticSeverity=e.DiagnosticTag=e.$WN=e.$VN=e.FileEditType=e.$UN=e.$TN=e.$SN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$RN=e.$QN=e.$PN=e.$MN=e.$LN=e.$KN=e.$JN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$NN=M,e.$ON=U,e.$lO=mt,e.$LO=Ni,e.$rP=Cn;function p(K){return Object.assign(K,{apply:function(...ge){if(ge.length===0)return Reflect.construct(K,[]);{const Le=ge.length===1?[]:ge[1];return Reflect.construct(K,Le,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(K,[]);{const[Le,...Ze]=ge;return Reflect.construct(K,Ze,Le.constructor)}}})}var v;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var F;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=a=class{static from(...G){let ge=G;return new a(function(){if(ge){for(const Le of ge)Le&&typeof Le.dispose=="function"&&Le.dispose();ge=void 0}})}#e;constructor(G){this.#e=G}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$JN=N,e.$JN=N=a=Je([p],N);let O=m=class{static Min(...G){if(G.length===0)throw new TypeError;let ge=G[0];for(let Le=1;Le<G.length;Le++){const Ze=G[Le];Ze.isBefore(ge)&&(ge=Ze)}return ge}static Max(...G){if(G.length===0)throw new TypeError;let ge=G[0];for(let Le=1;Le<G.length;Le++){const Ze=G[Le];Ze.isAfter(ge)&&(ge=Ze)}return ge}static isPosition(G){if(!G)return!1;if(G instanceof m)return!0;const{line:ge,character:Le}=G;return typeof ge=="number"&&typeof Le=="number"}static of(G){if(G instanceof m)return G;if(this.isPosition(G))return new m(G.line,G.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(G,ge){if(G<0)throw(0,h.$6)("line must be non-negative");if(ge<0)throw(0,h.$6)("character must be non-negative");this.c=G,this.e=ge}isBefore(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<G.e}isBeforeOrEqual(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<=G.e}isAfter(G){return!this.isBeforeOrEqual(G)}isAfterOrEqual(G){return!this.isBefore(G)}isEqual(G){return this.c===G.c&&this.e===G.e}compareTo(G){return this.c<G.c?-1:this.c>G.line?1:this.e<G.e?-1:this.e>G.e?1:0}translate(G,ge=0){if(G===null||ge===null)throw(0,h.$6)();let Le;return typeof G>"u"?Le=0:typeof G=="number"?Le=G:(Le=typeof G.lineDelta=="number"?G.lineDelta:0,ge=typeof G.characterDelta=="number"?G.characterDelta:0),Le===0&&ge===0?this:new m(this.line+Le,this.character+ge)}with(G,ge=this.character){if(G===null||ge===null)throw(0,h.$6)();let Le;return typeof G>"u"?Le=this.line:typeof G=="number"?Le=G:(Le=typeof G.line=="number"?G.line:this.line,ge=typeof G.character=="number"?G.character:this.character),Le===this.line&&ge===this.character?this:new m(Le,ge)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$KN=O,e.$KN=O=m=Je([p],O);let j=$=class{static isRange(G){return G instanceof $?!0:G?O.isPosition(G.start)&&O.isPosition(G.end):!1}static of(G){if(G instanceof $)return G;if(this.isRange(G))return new $(G.start,G.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(G,ge,Le,Ze){let ot,$t;if(typeof G=="number"&&typeof ge=="number"&&typeof Le=="number"&&typeof Ze=="number"?(ot=new O(G,ge),$t=new O(Le,Ze)):O.isPosition(G)&&O.isPosition(ge)&&(ot=O.of(G),$t=O.of(ge)),!ot||!$t)throw new Error("Invalid arguments");ot.isBefore($t)?(this.c=ot,this.e=$t):(this.c=$t,this.e=ot)}contains(G){return $.isRange(G)?this.contains(G.start)&&this.contains(G.end):O.isPosition(G)?!(O.of(G).isBefore(this.c)||this.e.isBefore(G)):!1}isEqual(G){return this.c.isEqual(G.c)&&this.e.isEqual(G.e)}intersection(G){const ge=O.Max(G.start,this.c),Le=O.Min(G.end,this.e);if(!ge.isAfter(Le))return new $(ge,Le)}union(G){if(this.contains(G))return this;if(G.contains(this))return G;const ge=O.Min(G.start,this.c),Le=O.Max(G.end,this.end);return new $(ge,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(G,ge=this.end){if(G===null||ge===null)throw(0,h.$6)();let Le;return G?O.isPosition(G)?Le=G:(Le=G.start||this.start,ge=G.end||this.end):Le=this.start,Le.isEqual(this.c)&&ge.isEqual(this.end)?this:new $(Le,ge)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return M(this)}};e.$LN=j,e.$LN=j=$=Je([p],j);let z=f=class extends j{static isSelection(G){return G instanceof f?!0:G?j.isRange(G)&&O.isPosition(G.anchor)&&O.isPosition(G.active)&&typeof G.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(G,ge,Le,Ze){let ot,$t;if(typeof G=="number"&&typeof ge=="number"&&typeof Le=="number"&&typeof Ze=="number"?(ot=new O(G,ge),$t=new O(Le,Ze)):O.isPosition(G)&&O.isPosition(ge)&&(ot=O.of(G),$t=O.of(ge)),!ot||!$t)throw new Error("Invalid arguments");super(ot,$t),this.f=ot,this.g=$t}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return U(this)}};e.$MN=z,e.$MN=z=f=Je([p],z);function M(K){return K.isEmpty?`[${K.start.line}:${K.start.character})`:`[${K.start.line}:${K.start.character} -> ${K.end.line}:${K.end.character})`}function U(K){let G=M(K);return K.isEmpty||(K.active.isEqual(K.start)?G=`|${G}`:G=`${G}|`),G}const V=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,h.$6)("connectionToken")};class ie{static isResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.host=="string"&&typeof G.port=="number"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,ge,Le){if(typeof G!="string"||G.length===0)throw(0,h.$6)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,h.$6)("port");typeof Le<"u"&&V(Le),this.host=G,this.port=Math.round(ge),this.connectionToken=Le}}e.$PN=ie;class B{static isManagedResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.makeConnection=="function"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,ge){this.makeConnection=G,this.connectionToken=ge,typeof ge<"u"&&V(ge)}}e.$QN=B;class Y extends Error{static NotAvailable(G,ge){return new Y(G,P.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(G){return new Y(G,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(G,ge=P.RemoteAuthorityResolverErrorCode.Unknown,Le){super(G),this._message=G,this._code=ge,this._detail=Le,Object.setPrototypeOf(this,Y.prototype)}}e.$RN=Y;var J;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(J||(e.EndOfLine=J={}));var _;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(_||(e.EnvironmentVariableMutatorType=_={}));let le=i=class{static isTextEdit(G){return G instanceof i?!0:G?j.isRange(G)&&typeof G.newText=="string":!1}static replace(G,ge){return new i(G,ge)}static insert(G,ge){return i.replace(new j(G,G),ge)}static delete(G){return i.replace(G,"")}static setEndOfLine(G){const ge=new i(new j(new O(0,0),new O(0,0)),"");return ge.newEol=G,ge}get range(){return this.c}set range(G){if(G&&!j.isRange(G))throw(0,h.$6)("range");this.c=G}get newText(){return this.e||""}set newText(G){if(G&&typeof G!="string")throw(0,h.$6)("newText");this.e=G}get newEol(){return this.f}set newEol(G){if(G&&typeof G!="number")throw(0,h.$6)("newEol");this.f=G}constructor(G,ge){this.c=G,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$SN=le,e.$SN=le=i=Je([p],le);let re=s=class{static isNotebookCellEdit(G){return G instanceof s?!0:G?vi.isNotebookRange(G)&&Array.isArray(G.newCells):!1}static replaceCells(G,ge){return new s(G,ge)}static insertCells(G,ge){return new s(new vi(G,G),ge)}static deleteCells(G){return new s(G,[])}static updateCellMetadata(G,ge){const Le=new s(new vi(G,G),[]);return Le.newCellMetadata=ge,Le}static updateNotebookMetadata(G){const ge=new s(new vi(0,0),[]);return ge.newNotebookMetadata=G,ge}constructor(G,ge){this.range=G,this.newCells=ge}};e.$TN=re,e.$TN=re=s=Je([p],re);class Se{static isSnippetTextEdit(G){return G instanceof Se?!0:G?j.isRange(G.range)&&q.isSnippetString(G.snippet):!1}static replace(G,ge){return new Se(G,ge)}static insert(G,ge){return Se.replace(new j(G,G),ge)}constructor(G,ge){this.range=G,this.snippet=ge}}e.$UN=Se;var me;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(me||(e.FileEditType=me={}));let Q=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(G,ge,Le,Ze){this.c.push({_type:me.File,from:G,to:ge,options:Le,metadata:Ze})}createFile(G,ge,Le){this.c.push({_type:me.File,from:void 0,to:G,options:ge,metadata:Le})}deleteFile(G,ge,Le){this.c.push({_type:me.File,from:G,to:void 0,options:ge,metadata:Le})}e(G,ge,Le){this.c.push({_type:me.Cell,metadata:Le,uri:G,edit:{editType:w.CellEditType.DocumentMetadata,metadata:ge},notebookMetadata:ge})}f(G,ge,Le,Ze){const ot=ge.start,$t=ge.end;(ot!==$t||Le.length>0)&&this.c.push({_type:me.CellReplace,uri:G,index:ot,count:$t-ot,cells:Le,metadata:Ze})}g(G,ge,Le,Ze){this.c.push({_type:me.Cell,metadata:Ze,uri:G,edit:{editType:w.CellEditType.Metadata,index:ge,metadata:Le}})}replace(G,ge,Le,Ze){this.c.push({_type:me.Text,uri:G,edit:new le(ge,Le),metadata:Ze})}insert(G,ge,Le,Ze){this.replace(G,new j(ge,ge),Le,Ze)}delete(G,ge,Le){this.replace(G,ge,"",Le)}has(G){return this.c.some(ge=>ge._type===me.Text&&ge.uri.toString()===G.toString())}set(G,ge){if(ge)for(const Le of ge){if(!Le)continue;let Ze,ot;Array.isArray(Le)?(Ze=Le[0],ot=Le[1]):Ze=Le,re.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(G,Ze.range.start,Ze.newCellMetadata,ot):Ze.newNotebookMetadata?this.e(G,Ze.newNotebookMetadata,ot):this.f(G,Ze.range,Ze.newCells,ot):Se.isSnippetTextEdit(Ze)?this.c.push({_type:me.Snippet,uri:G,range:Ze.range,edit:Ze.snippet,metadata:ot}):this.c.push({_type:me.Text,uri:G,edit:Ze,metadata:ot})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case me.Text:case me.Snippet:case me.Cell:case me.CellReplace:Ze.uri.toString()===G.toString()&&(this.c[Le]=void 0);break}}(0,r.$Hb)(this.c)}}get(G){const ge=[];for(const Le of this.c)Le._type===me.Text&&Le.uri.toString()===G.toString()&&ge.push(Le.edit);return ge}entries(){const G=new R.$Ac;for(const ge of this.c)if(ge._type===me.Text){let Le=G.get(ge.uri);Le||(Le=[ge.uri,[]],G.set(ge.uri,Le)),Le[1].push(ge.edit)}return[...G.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$VN=Q,e.$VN=Q=Je([p],Q);let q=t=class{static isSnippetString(G){return G instanceof t?!0:G?typeof G.value=="string":!1}static c(G){return G.replace(/\$|}|\\/g,"\\$&")}constructor(G){this.e=1,this.value=G||""}appendText(G){return this.value+=t.c(G),this}appendTabstop(G=this.e++){return this.value+="$",this.value+=G,this}appendPlaceholder(G,ge=this.e++){if(typeof G=="function"){const Le=new t;Le.e=this.e,G(Le),this.e=Le.e,G=Le.value}else G=t.c(G);return this.value+="${",this.value+=ge,this.value+=":",this.value+=G,this.value+="}",this}appendChoice(G,ge=this.e++){const Le=G.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(G,ge){if(typeof ge=="function"){const Le=new t;Le.e=this.e,ge(Le),this.e=Le.e,ge=Le.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=G,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$WN=q,e.$WN=q=t=Je([p],q);var se;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(se||(e.DiagnosticTag=se={}));var we;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(we||(e.DiagnosticSeverity=we={}));let ee=o=class{static isLocation(G){return G instanceof o?!0:G?j.isRange(G.range)&&c.URI.isUri(G.uri):!1}constructor(G,ge){if(this.uri=G,ge)if(j.isRange(ge))this.range=j.of(ge);else if(O.isPosition(ge))this.range=new j(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$XN=ee,e.$XN=ee=o=Je([p],ee);let ae=class{static is(G){return G?typeof G.message=="string"&&G.location&&j.isRange(G.location.range)&&c.URI.isUri(G.location.uri):!1}constructor(G,ge){this.location=G,this.message=ge}static isEqual(G,ge){return G===ge?!0:!G||!ge?!1:G.message===ge.message&&G.location.range.isEqual(ge.location.range)&&G.location.uri.toString()===ge.location.uri.toString()}};e.$YN=ae,e.$YN=ae=Je([p],ae);let oe=class{constructor(G,ge,Le=we.Error){if(!j.isRange(G))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=G,this.message=ge,this.severity=Le}toJSON(){return{severity:we[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(G,ge){return G===ge?!0:!G||!ge?!1:G.message===ge.message&&G.severity===ge.severity&&G.code===ge.code&&G.severity===ge.severity&&G.source===ge.source&&G.range.isEqual(ge.range)&&(0,r.$tb)(G.tags,ge.tags)&&(0,r.$tb)(G.relatedInformation,ge.relatedInformation,ae.isEqual)}};e.$ZN=oe,e.$ZN=oe=Je([p],oe);let x=class{constructor(G,ge){if(!G)throw new Error("Illegal argument, contents must be defined");Array.isArray(G)?this.contents=G:this.contents=[G],this.range=ge}};e.$1N=x,e.$1N=x=Je([p],x);let ne=class extends x{constructor(G,ge,Le,Ze){super(G,ge),this.canIncreaseVerbosity=Le,this.canDecreaseVerbosity=Ze}};e.$2N=ne,e.$2N=ne=Je([p],ne);var pe;(function(K){K[K.Increase=0]="Increase",K[K.Decrease=1]="Decrease"})(pe||(e.HoverVerbosityAction=pe={}));var be;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(be||(e.DocumentHighlightKind=be={}));let Fe=class{constructor(G,ge=be.Text){this.range=G,this.kind=ge}toJSON(){return{range:this.range,kind:be[this.kind]}}};e.$3N=Fe,e.$3N=Fe=Je([p],Fe);let ze=class{constructor(G,ge){this.uri=G,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(G=>G.toJSON())}}};e.$4N=ze,e.$4N=ze=Je([p],ze);var Ae;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Ae||(e.SymbolKind=Ae={}));var De;(function(K){K[K.Deprecated=1]="Deprecated"})(De||(e.SymbolTag=De={}));let Ce=n=class{static validate(G){if(!G.name)throw new Error("name must not be falsy")}constructor(G,ge,Le,Ze,ot){this.name=G,this.kind=ge,this.containerName=ot,typeof Le=="string"&&(this.containerName=Le),Ze instanceof ee?this.location=Ze:Le instanceof j&&(this.location=new ee(Ze,Le)),n.validate(this)}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};e.$5N=Ce,e.$5N=Ce=n=Je([p],Ce);let W=d=class{static validate(G){if(!G.name)throw new Error("name must not be falsy");if(!G.range.contains(G.selectionRange))throw new Error("selectionRange must be contained in fullRange");G.children?.forEach(d.validate)}constructor(G,ge,Le,Ze,ot){this.name=G,this.detail=ge,this.kind=Le,this.range=Ze,this.selectionRange=ot,this.children=[],d.validate(this)}};e.$6N=W,e.$6N=W=d=Je([p],W);var H;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(H||(e.CodeActionTriggerKind=H={}));let X=class{constructor(G,ge){this.title=G,this.kind=ge}};e.$7N=X,e.$7N=X=Je([p],X);let Z=class{static{l=this}static{this.c="."}constructor(G){this.value=G}append(G){return new l(this.value?this.value+l.c+G:G)}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+l.c)}};e.$8N=Z,e.$8N=Z=l=Je([p],Z),Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorMove=Z.Refactor.append("move"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll"),Z.Notebook=Z.Empty.append("notebook");let de=class{constructor(G,ge){if(this.range=G,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$9N=de,e.$9N=de=Je([p],de);class ve{constructor(G,ge,Le,Ze,ot,$t){this.kind=G,this.name=ge,this.detail=Le,this.uri=Ze,this.range=ot,this.selectionRange=$t}}e.$0N=ve;class Oe{constructor(G,ge){this.fromRanges=ge,this.from=G}}e.$$N=Oe;class He{constructor(G,ge){this.fromRanges=ge,this.to=G}}e.$_N=He;var Ke;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Ke||(e.LanguageStatusSeverity=Ke={}));let _e=class{constructor(G,ge){this.range=G,this.command=ge}get isResolved(){return!!this.command}};e.$aO=_e,e.$aO=_e=Je([p],_e);let nt=g=class{#e;static isMarkdownString(G){return G instanceof g?!0:G&&G.appendCodeblock&&G.appendMarkdown&&G.appendText&&G.value!==void 0}constructor(G,ge=!1){this.#e=new C.$3k(G,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(G){this.#e.value=G}get isTrusted(){return this.#e.isTrusted}set isTrusted(G){this.#e.isTrusted=G}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(G){this.#e.supportThemeIcons=G}get supportHtml(){return this.#e.supportHtml}set supportHtml(G){this.#e.supportHtml=G}get baseUri(){return this.#e.baseUri}set baseUri(G){this.#e.baseUri=G}appendText(G){return this.#e.appendText(G),this}appendMarkdown(G){return this.#e.appendMarkdown(G),this}appendCodeblock(G,ge){return this.#e.appendCodeblock(ge??"",G),this}};e.$bO=nt,e.$bO=nt=g=Je([p],nt);let st=class{constructor(G,ge){this.label=G,this.documentation=ge}};e.$cO=st,e.$cO=st=Je([p],st);let rt=class{constructor(G,ge){this.label=G,this.documentation=ge,this.parameters=[]}};e.$dO=rt,e.$dO=rt=Je([p],rt);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$eO=at,e.$eO=at=Je([p],at);var gt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(gt||(e.SignatureHelpTriggerKind=gt={}));var ht;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ht||(e.InlayHintKind=ht={}));let ct=class{constructor(G){this.value=G}};e.$fO=ct,e.$fO=ct=Je([p],ct);let Pe=class{constructor(G,ge,Le){this.position=G,this.label=ge,this.kind=Le}};e.$gO=Pe,e.$gO=Pe=Je([p],Pe);var Be;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Ye;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Ye||(e.CompletionItemKind=Ye={}));var Ne;(function(K){K[K.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let je=class{constructor(G,ge){this.label=G,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&Ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$hO=je,e.$hO=je=Je([p],je);let ue=class{constructor(G=[],ge=!1){this.items=G,this.isIncomplete=ge}};e.$iO=ue,e.$iO=ue=Je([p],ue);let he=class{constructor(G,ge,Le){this.insertText=G,this.range=ge,this.command=Le}};e.$jO=he,e.$jO=he=Je([p],he);let ce=class{constructor(G){this.commands=void 0,this.suppressSuggestions=void 0,this.items=G}};e.$kO=ce,e.$kO=ce=Je([p],ce);var Xe;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(Xe||(e.PartialAcceptTriggerKind=Xe={}));var et;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(et||(e.ViewColumn=et={}));var ut;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ut||(e.StatusBarAlignment=ut={}));function mt(K,G){return`${S.$qn.toKey(K)}.${G}`}var Dt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(Dt||(e.TextEditorLineNumbersStyle=Dt={}));var Ft;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Ft||(e.TextDocumentSaveReason=Ft={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var ei;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(ei||(e.TextEditorSelectionChangeKind=ei={}));var oi;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var Rt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Rt||(e.DecorationRangeBehavior=Rt={})),function(K){function G(ge){switch(ge){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=G}(ei||(e.TextEditorSelectionChangeKind=ei={}));var tt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(tt||(e.SyntaxTokenType=tt={})),function(K){function G(ge){switch(ge){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=G}(tt||(e.SyntaxTokenType=tt={}));let jt=class{constructor(G,ge){if(ge&&!c.URI.isUri(ge))throw(0,h.$6)("target");if(!j.isRange(G)||G.isEmpty)throw(0,h.$6)("range");this.range=G,this.target=ge}};e.$mO=jt,e.$mO=jt=Je([p],jt);let hi=class{constructor(G,ge,Le,Ze){this.red=G,this.green=ge,this.blue=Le,this.alpha=Ze}};e.$nO=hi,e.$nO=hi=Je([p],hi);let pt=class{constructor(G,ge){if(ge&&!(ge instanceof hi))throw(0,h.$6)("color");if(!j.isRange(G)||G.isEmpty)throw(0,h.$6)("range");this.range=G,this.color=ge}};e.$oO=pt,e.$oO=pt=Je([p],pt);let yt=class{constructor(G){if(!G||typeof G!="string")throw(0,h.$6)("label");this.label=G}};e.$pO=yt,e.$pO=yt=Je([p],yt);var ti;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ii;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var qt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));var bt;(function(K){K[K.Low=0]="Low",K[K.Medium=1]="Medium",K[K.High=2]="High"})(bt||(e.TerminalShellExecutionCommandLineConfidence=bt={}));class zt{constructor(G,ge,Le){if(this.startIndex=G,this.length=ge,this.tooltip=Le,typeof G!="number"||G<0)throw(0,h.$6)("startIndex");if(typeof ge!="number"||ge<1)throw(0,h.$6)("length");if(Le!==void 0&&typeof Le!="string")throw(0,h.$6)("tooltip")}}e.$qO=zt;class ni{constructor(G){this.uri=G}}e.$rO=ni;class ai{constructor(G){this.terminalCommand=G}}e.$sO=ai;var xe;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class ci{constructor(G){if(this.options=G,typeof G!="object")throw(0,h.$6)("options")}}e.$tO=ci;var di;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var fi;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let vt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(G){switch(G){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(G,ge){if(this.label=ge,typeof G!="string"||typeof ge!="string")throw(0,h.$6)("name");this.c=G}get id(){return this.c}};e.$uO=vt,e.$uO=vt=E=Je([p],vt);function Mt(K){let G="";for(let ge=0;ge<K.length;ge++)G+=K[ge].replace(/,/g,",,")+",";return G}let Lt=class{constructor(G,ge,Le){if(typeof G!="string")throw(0,h.$6)("process");this.e=[],this.c=G,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Le):this.f=ge)}get process(){return this.c}set process(G){if(typeof G!="string")throw(0,h.$6)("process");this.c=G}get args(){return this.e}set args(G){Array.isArray(G)||(G=[]),this.e=G}get options(){return this.f}set options(G){this.f=G}computeId(){const G=[];if(G.push("process"),this.c!==void 0&&G.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)G.push(ge);return Mt(G)}};e.$vO=Lt,e.$vO=Lt=Je([p],Lt);let Gt=class{constructor(G,ge,Le){if(this.f=[],Array.isArray(ge)){if(!G)throw(0,h.$6)("command can't be undefined or null");if(typeof G!="string"&&typeof G.value!="string")throw(0,h.$6)("command");this.e=G,this.f=ge,this.g=Le}else{if(typeof G!="string")throw(0,h.$6)("commandLine");this.c=G,this.g=ge}}get commandLine(){return this.c}set commandLine(G){if(typeof G!="string")throw(0,h.$6)("commandLine");this.c=G}get command(){return this.e?this.e:""}set command(G){if(typeof G!="string"&&typeof G.value!="string")throw(0,h.$6)("command");this.e=G}get args(){return this.f}set args(G){this.f=G||[]}get options(){return this.g}set options(G){this.g=G}computeId(){const G=[];if(G.push("shell"),this.c!==void 0&&G.push(this.c),this.e!==void 0&&G.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)G.push(typeof ge=="string"?ge:ge.value);return Mt(G)}};e.$wO=Gt,e.$wO=Gt=Je([p],Gt);var ri;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var Qt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Qt||(e.TaskScope=Qt={}));class li{constructor(G){this.c=G}computeId(){return"customExecution"+(0,I.$1g)()}set callback(G){this.c=G}get callback(){return this.c}}e.$xO=li;let Wt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(G,ge,Le,Ze,ot,$t){this.k=!1,this.l=this.definition=G;let Et;typeof ge=="string"?(this.o=this.name=ge,this.w=this.source=Le,this.execution=Ze,Et=ot,this.k=!0):ge===Qt.Global||ge===Qt.Workspace?(this.target=ge,this.o=this.name=Le,this.w=this.source=Ze,this.execution=ot,Et=$t):(this.target=ge,this.o=this.name=Le,this.w=this.source=Ze,this.execution=ot,Et=$t),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(G){this.j=G}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Gt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof li?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,I.$1g)()}}get definition(){return this.l}set definition(G){if(G==null)throw(0,h.$6)("Kind can't be undefined or null");this.B(),this.l=G}get scope(){return this.m}set target(G){this.B(),this.m=G}get name(){return this.o}set name(G){if(typeof G!="string")throw(0,h.$6)("name");this.B(),this.o=G}get execution(){return this.q}set execution(G){G===null&&(G=void 0),this.B(),this.q=G;const ge=this.l.type;(D.g===ge||D.e===ge||D.f===ge||D.c===ge)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(G){if(Array.isArray(G))this.B(),this.r=G,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(G){G!==!0&&G!==!1&&(G=!1),this.B(),this.u=G}get source(){return this.w}set source(G){if(typeof G!="string"||G.length===0)throw(0,h.$6)("source must be a string of length > 0");this.B(),this.w=G}get group(){return this.x}set group(G){G===null&&(G=void 0),this.B(),this.x=G}get detail(){return this.A}set detail(G){G===null&&(G=void 0),this.A=G}get presentationOptions(){return this.y}set presentationOptions(G){G==null&&(G=Object.create(null)),this.B(),this.y=G}get runOptions(){return this.z}set runOptions(G){G==null&&(G=Object.create(null)),this.B(),this.z=G}};e.$yO=Wt,e.$yO=Wt=D=Je([p],Wt);var Kt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Kt||(e.ProgressLocation=Kt={}));var Jt;(function(K){function G(ge){const Le=ge;return(0,b.$ig)(Le.value)?Le.tooltip&&!(0,b.$eg)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=G})(Jt||(e.ViewBadge=Jt={}));let Nt=y=class{static isTreeItem(G,ge){const Le=G;if(Le.checkboxState!==void 0){const Ze=(0,b.$ig)(Le.checkboxState)?Le.checkboxState:(0,b.$gg)(Le.checkboxState)&&(0,b.$ig)(Le.checkboxState.state)?Le.checkboxState.state:void 0,ot=!(0,b.$ig)(Le.checkboxState)&&(0,b.$gg)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==It.Checked&&Ze!==It.Unchecked||ot!==void 0&&!(0,b.$eg)(ot))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(G instanceof y)return!0;if(Le.label!==void 0&&!(0,b.$eg)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,b.$eg)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,b.$eg)(Le.iconPath)&&!c.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,b.$eg)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,b.$eg)(Ze.light)&&!c.URI.isUri(Ze.light)&&!(0,b.$eg)(Ze.dark)&&!c.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,b.$eg)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!c.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,b.$eg)(Le.tooltip)&&!(Le.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<wt.None&&Le.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,b.$eg)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(G,ge=wt.None){this.collapsibleState=ge,c.URI.isUri(G)?this.resourceUri=G:this.label=G}};e.$zO=Nt,e.$zO=Nt=y=Je([p],Nt);var wt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var It;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(G){this.value=G}};e.$AO=Yt,e.$AO=Yt=Je([p],Yt);class Pt extends Yt{}e.$BO=Pt;class gi extends Pt{#e;constructor(G){super(""),this.#e=G}asFile(){return this.#e}}e.$CO=gi;class xt{constructor(G,ge,Le,Ze){this.name=G,this.uri=ge,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$DO=xt;let Di=class{#e=new Map;constructor(G){for(const[ge,Le]of G??[]){const Ze=this.#e.get(this.#t(ge));Ze?Ze.push(Le):this.#e.set(this.#t(ge),[Le])}}get(G){return this.#e.get(this.#t(G))?.[0]}set(G,ge){this.#e.set(this.#t(G),[ge])}forEach(G,ge){for(const[Le,Ze]of this.#e)for(const ot of Ze)G.call(ge,ot,Le,this)}*[Symbol.iterator](){for(const[G,ge]of this.#e)for(const Le of ge)yield[G,Le]}#t(G){return G.toLowerCase()}};e.$EO=Di,e.$EO=Di=Je([p],Di);let pi=class{constructor(G,ge,Le){this.insertText=G,this.title=ge,this.kind=Le}};e.$FO=pi,e.$FO=pi=Je([p],pi);var Ri;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(Ri||(e.DocumentPasteTriggerKind=Ri={}));class Tt{static{this.c="."}constructor(G){this.value=G}append(...G){return new Tt((this.value?[this.value,...G]:G).join(Tt.c))}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+Tt.c)}}e.$GO=Tt,Tt.Empty=new Tt("");class Oi{constructor(G,ge,Le){this.title=ge,this.insertText=G,this.kind=Le}}e.$HO=Oi;let ui=class{constructor(G,ge){this.id=G,this.color=ge}static isThemeIcon(G){return typeof G.id!="string"?(console.log("INVALID ThemeIcon, invalid id",G.id),!1):!0}};e.$IO=ui,e.$IO=ui=Je([p],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let Ct=class{constructor(G){this.id=G}};e.$JO=Ct,e.$JO=Ct=Je([p],Ct);var Ti;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Ti||(e.ConfigurationTarget=Ti={}));let ki=class{get base(){return this.c}set base(G){this.c=G,this.e=c.URI.file(G)}get baseUri(){return this.e}set baseUri(G){this.e=G,this.c=G.fsPath}constructor(G,ge){if(typeof G!="string"&&(!G||!c.URI.isUri(G)&&!c.URI.isUri(G.uri)))throw(0,h.$6)("base");if(typeof ge!="string")throw(0,h.$6)("pattern");typeof G=="string"?this.baseUri=c.URI.file(G):c.URI.isUri(G)?this.baseUri=G:this.baseUri=G.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$KO=ki,e.$KO=ki=Je([p],ki);const yi=new WeakMap;function Ni(K,G){yi.set(K,G)}let bi=class{constructor(G,ge,Le,Ze,ot){this.enabled=typeof G=="boolean"?G:!0,typeof ge=="string"&&(this.condition=ge),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze),typeof ot=="string"&&(this.mode=ot)}get id(){return this.c||(this.c=yi.get(this)??(0,I.$1g)()),this.c}};e.$MO=bi,e.$MO=bi=Je([p],bi);let Vt=class extends bi{constructor(G,ge,Le,Ze,ot,$t){if(super(ge,Le,Ze,ot,$t),G===null)throw(0,h.$6)("location");this.location=G}};e.$NO=Vt,e.$NO=Vt=Je([p],Vt);let Te=class extends bi{constructor(G,ge,Le,Ze,ot,$t){super(ge,Le,Ze,ot,$t),this.functionName=G}};e.$OO=Te,e.$OO=Te=Je([p],Te);let Me=class extends bi{constructor(G,ge,Le,Ze,ot,$t,Et,Zt){if(super(Ze,ot,$t,Et,Zt),!ge)throw(0,h.$6)("dataId");this.label=G,this.dataId=ge,this.canPersist=Le}};e.$PO=Me,e.$PO=Me=Je([p],Me);let Ee=class{constructor(G,ge,Le){this.command=G,this.args=ge||[],this.options=Le}};e.$QO=Ee,e.$QO=Ee=Je([p],Ee);let te=class{constructor(G,ge){this.port=G,this.host=ge}};e.$RO=te,e.$RO=te=Je([p],te);let Re=class{constructor(G){this.path=G}};e.$SO=Re,e.$SO=Re=Je([p],Re);let Ge=class{constructor(G){this.implementation=G}};e.$TO=Ge,e.$TO=Ge=Je([p],Ge);class it{constructor(G,ge,Le){this.session=G,this.threadId=ge,this.frameId=Le}}e.$UO=it;class Qe{constructor(G,ge){this.session=G,this.threadId=ge}}e.$VO=Qe;let ft=class{constructor(G,ge){this.range=G,this.expression=ge}};e.$WO=ft,e.$WO=ft=Je([p],ft);var At;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(At||(e.InlineCompletionTriggerKind=At={}));let Xt=class{constructor(G,ge){this.range=G,this.text=ge}};e.$XO=Xt,e.$XO=Xt=Je([p],Xt);let si=class{constructor(G,ge,Le=!0){this.range=G,this.variableName=ge,this.caseSensitiveLookup=Le}};e.$YO=si,e.$YO=si=Je([p],si);let Bt=class{constructor(G,ge){this.range=G,this.expression=ge}};e.$ZO=Bt,e.$ZO=Bt=Je([p],Bt);let _t=class{constructor(G,ge){this.frameId=G,this.stoppedLocation=ge}};e.$1O=_t,e.$1O=_t=Je([p],_t);var qi;(function(K){K[K.AIGenerated=1]="AIGenerated"})(qi||(e.NewSymbolNameTag=qi={}));var nn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(nn||(e.NewSymbolNameTriggerKind=nn={}));class Wi{constructor(G,ge){this.newSymbolName=G,this.tags=ge}}e.$2O=Wi;var Fi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Vi=k=class extends Error{static FileExists(G){return new k(G,u.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(G){return new k(G,u.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(G){return new k(G,u.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(G){return new k(G,u.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(G){return new k(G,u.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(G){return new k(G,u.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(G,ge=u.FileSystemProviderErrorCode.Unknown,Le){super(c.URI.isUri(G)?G.toString(!0):G),this.code=Le?.name??"Unknown",(0,u.$ol)(this,ge),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$3O=Vi,e.$3O=Vi=k=Je([p],Vi);let Hi=class{constructor(G,ge,Le){this.start=G,this.end=ge,this.kind=Le}};e.$4O=Hi,e.$4O=Hi=Je([p],Hi);var Ii;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var rn;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(rn||(e.CommentThreadCollapsibleState=rn={}));var sn;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(sn||(e.CommentMode=sn={}));var Mi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var on;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(on||(e.CommentThreadState=on={}));var ji;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(ji||(e.CommentThreadApplicability=ji={}));var Gi;(function(K){K[K.Reply=1]="Reply",K[K.Comment=2]="Comment"})(Gi||(e.CommentThreadFocus=Gi={}));class En{constructor(G,ge=[]){this.tokenTypes=G,this.tokenModifiers=ge}}e.$5O=En;function an(K){return typeof K>"u"||(0,b.$fg)(K)}class Yi{constructor(G){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,G){this.m=!0;for(let ge=0,Le=G.tokenTypes.length;ge<Le;ge++)this.k.set(G.tokenTypes[ge],ge);for(let ge=0,Le=G.tokenModifiers.length;ge<Le;ge++)this.l.set(G.tokenModifiers[ge],ge)}}push(G,ge,Le,Ze,ot){if(typeof G=="number"&&typeof ge=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof ot=="number"||typeof ot>"u"))return typeof ot>"u"&&(ot=0),this.q(G,ge,Le,Ze,ot);if(j.isRange(G)&&typeof ge=="string"&&an(Le))return this.o(G,ge,Le);throw(0,h.$6)()}o(G,ge,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(G.start.line!==G.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ge))throw new Error("`tokenType` is not in the provided legend");const Ze=G.start.line,ot=G.start.character,$t=G.end.character-G.start.character,Et=this.k.get(ge);let Zt=0;if(Le)for(const $i of Le){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const Ei=this.l.get($i);Zt|=1<<Ei>>>0}this.q(Ze,ot,$t,Et,Zt)}q(G,ge,Le,Ze,ot){if(this.f&&(G<this.c||G===this.c&&ge<this.e)){this.f=!1;const Zt=this.g.length/5|0;let $i=0,Ei=0;for(let Si=0;Si<Zt;Si++){let Ai=this.g[5*Si],en=this.g[5*Si+1];Ai===0?(Ai=$i,en+=Ei):Ai+=$i,this.g[5*Si]=Ai,this.g[5*Si+1]=en,$i=Ai,Ei=en}}let $t=G,Et=ge;this.f&&this.j>0&&($t-=this.c,$t===0&&(Et-=this.e)),this.g[this.j++]=$t,this.g[this.j++]=Et,this.g[this.j++]=Le,this.g[this.j++]=Ze,this.g[this.j++]=ot,this.c=G,this.e=ge}static r(G){const ge=[],Le=G.length/5|0;for(let Et=0;Et<Le;Et++)ge[Et]=Et;ge.sort((Et,Zt)=>{const $i=G[5*Et],Ei=G[5*Zt];if($i===Ei){const Si=G[5*Et+1],Ai=G[5*Zt+1];return Si-Ai}return $i-Ei});const Ze=new Uint32Array(G.length);let ot=0,$t=0;for(let Et=0;Et<Le;Et++){const Zt=5*ge[Et],$i=G[Zt+0],Ei=G[Zt+1],Si=G[Zt+2],Ai=G[Zt+3],en=G[Zt+4],Hn=$i-ot,Nr=Hn===0?Ei-$t:Ei,tn=5*Et;Ze[tn+0]=Hn,Ze[tn+1]=Nr,Ze[tn+2]=Si,Ze[tn+3]=Ai,Ze[tn+4]=en,ot=$i,$t=Ei}return Ze}build(G){return this.f?new Pi(new Uint32Array(this.g),G):new Pi(Yi.r(this.g),G)}}e.$6O=Yi;class Pi{constructor(G,ge){this.resultId=ge,this.data=G}}e.$7O=Pi;class yn{constructor(G,ge,Le){this.start=G,this.deleteCount=ge,this.data=Le}}e.$8O=yn;class Sn{constructor(G,ge){this.resultId=ge,this.edits=G}}e.$9O=Sn;var cn;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(cn||(e.DebugConsoleMode=cn={}));class Ki{constructor(G){this.name=G}}e.$0O=Ki;var Qi;(function(K){K[K.Title=1]="Title",K[K.Inline=2]="Inline"})(Qi||(e.QuickInputButtonLocation=Qi={}));let We=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.$$O=We,e.$$O=We=Je([p],We);var wi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(wi||(e.QuickPickItemKind=wi={}));var Ji;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Ji||(e.InputBoxValidationSeverity=Ji={}));var lt;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(lt||(e.ExtensionKind=lt={}));class kt{static validate(G){if(typeof G.badge=="string"){let ge=(0,T.$Pf)(G.badge,0);if(ge<G.badge.length&&(ge+=(0,T.$Pf)(G.badge,ge)),G.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(G.badge&&!ui.isThemeIcon(G.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!G.color&&!G.badge&&!G.tooltip)throw new Error("The decoration is empty");return!0}constructor(G,ge,Le){this.badge=G,this.tooltip=ge,this.color=Le}}e.$_O=kt;let Xi=class{constructor(G){this.kind=G}};e.$aP=Xi,e.$aP=Xi=Je([p],Xi);var ln;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(ln||(e.ColorThemeKind=ln={}));class vi{static isNotebookRange(G){return G instanceof vi?!0:G?typeof G.start=="number"&&typeof G.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(G,ge){if(G<0)throw(0,h.$6)("start must be positive");if(ge<0)throw(0,h.$6)("end must be positive");G<=ge?(this.c=G,this.e=ge):(this.c=ge,this.e=G)}with(G){let ge=this.c,Le=this.e;return G.start!==void 0&&(ge=G.start),G.end!==void 0&&(Le=G.end),ge===this.c&&Le===this.e?this:new vi(ge,Le)}}e.$bP=vi;class Bi{static validate(G){if(typeof G.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof G.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof G.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(G){return Array.isArray(G)&&G.every(ge=>Bi.isNotebookCellData(ge))}static isNotebookCellData(G){return!0}constructor(G,ge,Le,Ze,ot,$t,Et){this.kind=G,this.value=ge,this.languageId=Le,this.mime=Ze,this.outputs=ot??[],this.metadata=$t,this.executionSummary=Et,Bi.validate(this)}}e.$cP=Bi;class zi{constructor(G){this.cells=G}}e.$dP=zi;class mi{static isNotebookCellOutputItem(G){return G instanceof mi?!0:G?typeof G.mime=="string"&&G.data instanceof Uint8Array:!1}static error(G){const ge={name:G.name,message:G.message,stack:G.stack};return mi.json(ge,"application/vnd.code.notebook.error")}static stdout(G){return mi.text(G,"application/vnd.code.notebook.stdout")}static stderr(G){return mi.text(G,"application/vnd.code.notebook.stderr")}static bytes(G,ge="application/octet-stream"){return new mi(G,ge)}static#e=new TextEncoder;static text(G,ge=L.$0s.text){const Le=mi.#e.encode(String(G));return new mi(Le,ge)}static json(G,ge="text/x-json"){const Le=JSON.stringify(G,void 0,"	");return mi.text(Le,ge)}constructor(G,ge){this.data=G,this.mime=ge;const Le=(0,L.$bt)(ge,!0);if(!Le)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$eP=mi;class Ui{static isNotebookCellOutput(G){return G instanceof Ui?!0:!G||typeof G!="object"?!1:typeof G.id=="string"&&Array.isArray(G.items)}static ensureUniqueMimeTypes(G,ge=!1){const Le=new Set,Ze=new Set;for(let ot=0;ot<G.length;ot++){const $t=G[ot],Et=(0,L.$bt)($t.mime);if(!Le.has(Et)||(0,w.$KL)(Et)){Le.add(Et);continue}Ze.add(ot),ge&&console.warn(`DUPLICATED mime type '${$t.mime}' will be dropped`)}return Ze.size===0?G:G.filter((ot,$t)=>!Ze.has($t))}constructor(G,ge,Le){this.items=Ui.ensureUniqueMimeTypes(G,!0),typeof ge=="string"?(this.id=ge,this.metadata=Le):(this.id=(0,I.$1g)(),this.metadata=ge??Le)}}e.$fP=Ui;var un;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(un||(e.NotebookCellKind=un={}));var Zi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Zi||(e.NotebookCellExecutionState=Zi={}));var hn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(hn||(e.NotebookCellStatusBarAlignment=hn={}));var dn;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(dn||(e.NotebookEditorRevealType=dn={}));class Dn{constructor(G,ge){this.text=G,this.alignment=ge}}e.$gP=Dn;var fn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(fn||(e.NotebookControllerAffinity=fn={}));var gn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(gn||(e.NotebookControllerAffinity2=gn={}));class kn{constructor(G,ge=[]){this.uri=G,this.provides=(0,r.$1b)(ge)}}e.$hP=kn;class In{constructor(G){this.label=G}}e.$iP=In;var mn;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(mn||(e.NotebookVariablesRequestKind=mn={}));let xi=class{constructor(G,ge){this.label=G,this.timestamp=ge}};e.$jP=xi,e.$jP=xi=Je([p],xi);var $n;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})($n||(e.ExtensionMode=$n={}));var pn;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(pn||(e.ExtensionRuntime=pn={}));var fe;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(fe||(e.StandardTokenType=fe={}));class ye{constructor(G,ge){this.ranges=G,this.wordPattern=ge}}e.$kP=ye;class Ue{constructor(G){this.c=G}get autoForwardAction(){return this.c}}e.$lP=Ue;var dt;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(dt||(e.TestResultState=dt={}));var St;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(St||(e.TestRunProfileKind=St={}));let Ot=class{constructor(G=void 0,ge=void 0,Le=void 0,Ze=!1,ot=!0){this.include=G,this.exclude=ge,this.profile=Le,this.continuous=Ze,this.preserveFocus=ot}};e.$mP=Ot,e.$mP=Ot=Je([p],Ot);let Ci=A=class{static diff(G,ge,Le){const Ze=new A(G);return Ze.expectedOutput=ge,Ze.actualOutput=Le,Ze}constructor(G){this.message=G}};e.$nP=Ci,e.$nP=Ci=A=Je([p],Ci);let _i=class{constructor(G){this.id=G}};e.$oP=_i,e.$oP=_i=Je([p],_i);class Kn{constructor(G,ge,Le){this.label=G,this.file=ge,this.position=Le}}e.$pP=Kn;class bn{constructor(G,ge){this.covered=G,this.total=ge,Cn(this)}}e.$qP=bn;function Cn(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Pn{static fromDetails(G,ge){const Le=new bn(0,0),Ze=new bn(0,0),ot=new bn(0,0);for(const Et of ge)if("branches"in Et){Le.total+=1,Le.covered+=Et.executed?1:0;for(const Zt of Et.branches)Ze.total+=1,Ze.covered+=Zt.executed?1:0}else ot.total+=1,ot.covered+=Et.executed?1:0;const $t=new Pn(G,Le,Ze.total>0?Ze:void 0,ot.total>0?ot:void 0);return $t.detailedCoverage=ge,$t}constructor(G,ge,Le,Ze,ot=[]){this.uri=G,this.statementCoverage=ge,this.branchCoverage=Le,this.declarationCoverage=Ze,this.fromTests=ot}}e.$sP=Pn;class Qn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,ge,Le=[]){this.executed=G,this.location=ge,this.branches=Le}}e.$tP=Qn;class Jn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,ge,Le){this.executed=G,this.location=ge,this.label=Le}}e.$uP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,ge,Le){this.name=G,this.executed=ge,this.location=Le}}e.$vP=Xn;var An;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(An||(e.ExternalUriOpenerPriority=An={}));var Rn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(Rn||(e.WorkspaceTrustState=Rn={}));var Tn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Zn{constructor(G,ge,Le,Ze,ot,$t){this.kind=G,this.name=ge,this.detail=Le,this.uri=Ze,this.range=ot,this.selectionRange=$t}}e.$wP=Zn;class xn{constructor(G){this.uri=G}}e.$xP=xn;class _n{constructor(G,ge){this.original=G,this.modified=ge}}e.$yP=_n;class er{constructor(G,ge,Le,Ze){this.base=G,this.input1=ge,this.input2=Le,this.result=Ze}}e.$zP=er;class tr{constructor(G,ge){this.uri=G,this.viewType=ge}}e.$AP=tr;class ir{constructor(G){this.viewType=G}}e.$BP=ir;class nr{constructor(G,ge){this.uri=G,this.notebookType=ge}}e.$CP=nr;class rr{constructor(G,ge,Le){this.original=G,this.modified=ge,this.notebookType=Le}}e.$DP=rr;class sr{constructor(){}}e.$EP=sr;class or{constructor(G,ge){this.uri=G,this.inputBoxUri=ge}}e.$FP=or;class ar{constructor(){}}e.$GP=ar;class cr{constructor(G){this.textDiffs=G}}e.$HP=cr;var Ln;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(Ln||(e.InteractiveSessionVoteDirection=Ln={}));var On;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(On||(e.ChatCopyKind=On={}));var Nn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Nn||(e.ChatVariableLevel=Nn={}));class lr{constructor(G,ge,Le){this.id=G,this.label=ge,this.values=Le}}e.$IP=lr;var Fn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Fn||(e.InteractiveEditorResponseFeedbackKind=Fn={}));var Mn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Mn||(e.ChatResultFeedbackKind=Mn={}));class ur{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new nt(G):G}}e.$JP=ur;class hr{constructor(G,ge){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new nt(G):G,this.vulnerabilities=ge}}e.$KP=hr;class dr{constructor(G,ge){this.participant=G,this.command=ge}}e.$LP=dr;class fr{constructor(G,ge,Le,Ze){this.title=G,this.message=ge,this.data=Le,this.buttons=Ze}}e.$MP=fr;class gr{constructor(G,ge){this.value=G,this.baseUri=ge}}e.$NP=gr;class mr{constructor(G,ge){this.value=G,this.title=ge}}e.$OP=mr;class $r{constructor(G){this.value=G}}e.$PP=$r;class pr{constructor(G,ge){this.value=G,this.task=ge}}e.$QP=pr;class br{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new nt(G):G}}e.$RP=br;class wr{constructor(G){this.value=G}}e.$SP=wr;class vr{constructor(G,ge,Le){this.value=G,this.iconPath=ge,this.options=Le}}e.$TP=vr;class Er{constructor(G,ge,Le){this.value=G,this.license=ge,this.snippet=Le}}e.$UP=Er;class yr{constructor(G,ge){this.uri=G,this.edits=Array.isArray(ge)?ge:[ge]}}e.$VP=yr;class Sr{constructor(G,ge,Le,Ze){this.prompt=G,this.command=ge,this.references=Le,this.participant=Ze}}e.$WP=Sr;class Dr{constructor(G,ge,Le,Ze){this.response=G,this.result=ge,this.participant=Le,this.command=Ze}}e.$XP=Dr;var jn;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(jn||(e.ChatLocation=jn={}));var Bn;(function(K){K[K.Complete=1]="Complete",K[K.Partial=2]="Partial",K[K.Omitted=3]="Omitted"})(Bn||(e.ChatResponseReferencePartStatusKind=Bn={}));class kr{constructor(G,ge,Le){this.document=G,this.selection=ge,this.wholeRange=Le}}e.$YP=kr;class Ir{constructor(G){this.cell=G}}e.$ZP=Ir;var wn;(function(K){K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.System=3]="System"})(wn||(e.LanguageModelChatMessageRole=wn={}));class Pr{constructor(G,ge,Le){this.name=G,this.content=ge,this.isError=Le??!1}}e.$1P=Pr;class vn{static User(G,ge){const Le=new vn(wn.User,typeof G=="string"?G:"",ge);return Le.content2=G,Le}static Assistant(G,ge){return new vn(wn.Assistant,G,ge)}constructor(G,ge,Le){this.role=G,this.content=ge,this.content2=ge,this.name=Le}}e.$2P=vn;class Cr{constructor(G,ge){this.name=G,this.parameters=ge}}e.$3P=Cr;class Ar{constructor(G){this.value=G}}e.$4P=Ar;class Rr{constructor(G){this.content=G}}e.$5P=Rr;class Tr{constructor(G,ge){this.content=G,this.name=ge}}e.$6P=Tr;class Lr{constructor(G,ge){this.content=G,this.name=ge}}e.$7P=Lr;class Li extends Error{static NotFound(G){return new Li(G,Li.NotFound.name)}static NoPermissions(G){return new Li(G,Li.NoPermissions.name)}static Blocked(G){return new Li(G,Li.Blocked.name)}constructor(G,ge,Le){super(G,{cause:Le}),this.name="LanguageModelError",this.code=ge??""}}e.$8P=Li;var zn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(zn||(e.RelatedInformationType=zn={}));var Un;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped",K[K.Error=5]="Error"})(Un||(e.SpeechToTextStatus=Un={}));var qn;(function(K){K[K.Started=1]="Started",K[K.Stopped=2]="Stopped",K[K.Error=3]="Error"})(qn||(e.TextToSpeechStatus=qn={}));var Wn;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(Wn||(e.KeywordRecognitionStatus=Wn={}));class Or{constructor(G,ge){this.text=G,this.range=ge}}e.$9P=Or;var Vn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(ke[290],Ie([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=void 0;class C{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$HN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,T,b){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(L);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(T,b)??[]}getRelatedInformation(L,T,b){return this.c.$getAiRelatedInformation(T,b)}registerRelatedInformationProvider(L,T,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiRelatedInformationProvider(c,T),new h.$JN(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$fpc=C}),define(ke[127],Ie([1,0,4,6,9,23,156,5,19]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$qpc=void 0,e.$qpc=(0,T.$Ei)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new r.$le,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(h.$HN.MainThreadAuthentication)}async getSession(u,P,w,a={}){const m=R.$qn.toKey(u.identifier),$=[...w].sort().join(" ");return await this.d.getOrCreate(`${m} ${P} ${$}`,async()=>{await this.a.$ensureProvider(P);const f=u.displayName||u.name;return this.a.$getSession(P,w,m,f,a)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,P){const w=this.b.get(u);return w?w.provider.removeSession(P):this.a.$removeSession(u,P)}registerAuthenticationProvider(u,P,w,a){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:P,provider:w,options:a??{supportsMultipleAccounts:!1}});const m=w.onDidChangeSessions($=>this.a.$sendDidChangeSessions(u,$));return this.a.$registerAuthenticationProvider(u,P,a?.supportsMultipleAccounts??!1),new C.$JN(()=>{m.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,P,w){const a=this.b.get(u);if(a)return await a.provider.createSession(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,P){const w=this.b.get(u);if(w)return await w.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,P,w){const a=this.b.get(u);if(a)return await a.provider.getSessions(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,P){return u.startsWith(L.$JM)||this.c.fire({provider:{id:u,label:P}}),Promise.resolve()}};e.$rpc=c,e.$rpc=c=Je([Ve(0,b.$hQ)],c);class I{constructor(){this.a=new Map}getOrCreate(u,P){const w=this.a.get(u);if(w)return w;const a=P().finally(()=>this.a.delete(u));return this.a.set(u,a),a}}}),define(ke[163],Ie([1,0,2,6,9,5,19,11,18,12,16,25]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=e.$vqc=void 0;let P=class{static{u=this}static{this.c=0}static{this.d=250}constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(h.$HN.MainThreadDecorations)}registerFileDecorationProvider(a,m){const $=u.c++;this.f.set($,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider($,m.identifier.value);const f=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange($,null);return}const s=(0,b.$1b)(i);if(s.length<=u.d){this.g.$onDidChange($,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,s.length);const t=s.map(d=>({uri:d,rank:(0,c.$if)(d.path,"/")})),o=(0,b.$yb)(t,(d,l)=>d.rank-l.rank||(0,c.$yf)(d.uri.path,l.uri.path)),n=[];e:for(const d of o){let l;for(const g of d){const E=(0,I.$mc)(g.uri.path);if(l!==E&&(l=E,n.push(g.uri)>=u.d))break e}}this.g.$onDidChange($,n)});return new C.$JN(()=>{f?.dispose(),this.g.$unregisterDecorationProvider($),this.f.delete($)})}async $provideDecorations(a,m,$){if(!this.f.has(a))return Object.create(null);const f=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(a);return await Promise.all(m.map(async t=>{try{const{uri:o,id:n}=t,d=await Promise.resolve(i.provideFileDecoration(r.URI.revive(o),$));if(!d)return;try{C.$_O.validate(d),d.badge&&typeof d.badge!="string"&&(0,S.$fH)(s,"codiconDecoration"),f[n]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(o){this.h.error(o)}})),f}};e.$vqc=P,e.$vqc=P=u=Je([Ve(0,L.$hQ),Ve(1,T.$_j)],P),e.$wqc=(0,R.$Ei)("IExtHostDecorations")}),define(ke[291],Ie([1,0,13,2,9,6,14,20,12]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0;class c{static{this.a=0}constructor(S,u,P){this.d=u,this.e=P,this.b=new Map,this.c=S.getProxy(R.$HN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,u){if(Object.keys(L.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const P=c.a++;this.b.set(P,u),this.c.$registerTextContentProvider(P,S);let w;if(typeof u.onDidChange=="function"){let a;w=u.onDidChange(async m=>{if(m.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const $=this.$provideTextDocumentContent(P,m).then(async f=>{if(!f&&typeof f!="string")return;const i=this.d.getDocument(m);if(!i)return;const s=(0,b.$sf)(f);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(m,f)}).catch(r.$Y).finally(()=>{a===$&&(a=void 0)});a=$})}return new C.$JN(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(S,u){const P=this.b.get(S);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$yqc=c}),define(ke[164],Ie([1,0,65,14,12,206,140,9,18]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=e.$kQ=void 0,e.$jQ=I;const c=new Map;function I(w,a){a?c.set(w,a):c.delete(w)}function S(w){return c.get(w)}class u extends R.$ow{constructor(a,m,$,f,i,s,t){super(m,$,f,i),this.c=a,this.m=s,this.q=t,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,b.$tb)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===h.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,$){return a.y(m,$)},[Symbol.for("debug.description")](){return`TextDocument(${a.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const $=this.g,f=m.start.line,i=m.end.line,s=[];s.push(this.f[f].substring(m.start.character));for(let t=f+1;t<i;t++)s.push(this.f[t]);return s.push(this.f[i].substring(0,m.end.character)),s.join($)}t(a){let m;if(a instanceof T.$KN?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new P(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),$=this.f[m.index].length;return new T.$KN(m.index,Math.min(m.remainder,$))}w(a){if(!(a instanceof T.$LN))throw new Error("Invalid argument");const m=this.x(a.start),$=this.x(a.end);return m===a.start&&$===a.end?a:new T.$LN(m.line,m.character,$.line,$.character)}x(a){if(!(a instanceof T.$KN))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:$}=a,f=!1;if(m<0)m=0,$=0,f=!0;else if(m>=this.f.length)m=this.f.length-1,$=this.f[m].length,f=!0;else{const i=this.f[m].length;$<0?($=0,f=!0):$>i&&($=i,f=!0)}return f?new T.$KN(m,$):a}y(a,m){const $=this.x(a);if(!m)m=S(this.m);else if((0,C.$rf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const f=(0,L.$pt)($.character+1,(0,L.$nt)(m),this.f[$.line],0);if(f)return new T.$LN($.line,f.startColumn-1,$.line,f.endColumn-1)}}e.$kQ=u;class P{constructor(a,m,$){this.a=a,this.b=m,this.c=$}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$LN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$LN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$lQ=P}),define(ke[292],Ie([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=void 0;class C{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$HN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,T,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(L);if(!c)throw new Error("Embedding vector provider not found");const I=await c.provideEmbeddingVector(T,b);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(L,T,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiEmbeddingVectorProvider(T,c),new h.$JN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$Bqc=C}),define(ke[75],Ie([1,0,6,27,9,21,5,19,62,3,7,22,14]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=e.$Gpc=void 0,h=qe(h);let w=P=class{constructor(m,$){this.b=new Map,this.c=new I.$Nh,this.a=m.getProxy(r.$HN.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(i){try{let s;const t=f.b.get(i.scheme);return t?(await f.a.$ensureActivation(i.scheme),s=await t.impl.stat(i)):s=await f.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===h.FilePermission.Readonly?1:void 0}}catch(s){P.e(s)}},async readDirectory(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await f.a.$readdir(i)}catch(s){return P.e(s)}},async createDirectory(i){try{const s=f.b.get(i.scheme);return s&&!s.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(s.impl,s.extUri,i)):await f.a.$mkdir(i)}catch(s){return P.e(s)}},async readFile(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await f.a.$readFile(i)).buffer}catch(s){return P.e(s)}},async writeFile(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(t.impl,t.extUri,t.extUri.dirname(i)),await f.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await f.a.$writeFile(i,R.$Ne.wrap(s))}catch(t){return P.e(t)}},async delete(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly&&!s?.useTrash?(await f.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...s})):await f.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(t){return P.e(t)}},async rename(i,s,t){try{return await f.a.$rename(i,s,{overwrite:!1,...t})}catch(o){return P.e(o)}},async copy(i,s,t){try{return await f.a.$copy(i,s,{overwrite:!1,...t})}catch(o){return P.e(o)}},isWritableFileSystem(i){const s=$.getCapabilities(i);if(typeof s=="number")return!(s&h.FileSystemProviderCapabilities.Readonly)}})}async d(m,$,f){const i=[];for(;!$.isEqual(f,$.dirname(f));)try{if(!((await m.stat(f)).type&h.FileType.Directory))throw C.$3O.FileExists(`Unable to create folder '${f.scheme===u.Schemas.file?f.fsPath:f.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(h.$pl(s)!==h.FileSystemProviderErrorCode.FileNotFound)throw s;i.push($.basename(f)),f=$.dirname(f)}for(let s=i.length-1;s>=0;s--){f=$.joinPath(f,i[s]);try{await m.createDirectory(f)}catch(t){if(h.$pl(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e(m){if(m instanceof C.$3O)throw m;if(m instanceof h.$ll)switch(m.code){case h.FileSystemProviderErrorCode.FileExists:throw C.$3O.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$3O.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$3O.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$3O.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$3O.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$3O.Unavailable(m.message);default:throw new C.$3O(m.message,m.name)}if(!(m instanceof Error))throw new C.$3O(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw C.$3O.Unavailable(m.message);switch(m.name){case h.FileSystemProviderErrorCode.FileExists:throw C.$3O.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$3O.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$3O.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$3O.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$3O.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$3O.Unavailable(m.message);default:throw new C.$3O(m.message,m.name)}}addFileSystemProvider(m,$,f){return this.b.set(m,{impl:$,extUri:f?.isCaseSensitive?S.$8g:S.$0g,isReadonly:!!f?.isReadonly}),(0,c.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??S.$8g}};e.$Gpc=w,e.$Gpc=w=P=Je([Ve(0,T.$hQ),Ve(1,b.$kpc)],w),e.$Hpc=(0,L.$Ei)("IExtHostConsumerFileSystem")}),define(ke[97],Ie([1,0,5,29,11,75,2]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=e.$Ipc=void 0,e.$Ipc=(0,r.$Ei)("IExtensionStoragePaths");let T=class{constructor(c,I,S){this.d=I,this.f=S,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return L.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,I=await this.g(c);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(L.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(c){if(this.c)return L.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return L.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Jpc=T,e.$Jpc=T=Je([Ve(0,h.$xQ),Ve(1,C.$_j),Ve(2,R.$Hpc)],T)}),define(ke[293],Ie([1,0,9,19,4]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0;let R=class{constructor(T){this.a=new r.$aP(r.ColorThemeKind.Dark),this.b=new C.$le}get activeColorTheme(){return this.a}$onColorThemeChange(T){let b;switch(T){case"light":b=r.ColorThemeKind.Light;break;case"hcDark":b=r.ColorThemeKind.HighContrast;break;case"hcLight":b=r.ColorThemeKind.HighContrastLight;break;default:b=r.ColorThemeKind.Dark}this.a=new r.$aP(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$grc=R,e.$grc=R=Je([Ve(0,h.$hQ)],R)}),define(ke[76],Ie([1,0,20,4,3,8,5,11,92,6,29,19,9]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fGb=e.$eGb=e.TunnelDtoConverter=void 0,R=qe(R),u=qe(u);class P extends b.$Nw{}var w;(function(m){function $(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=$;function f(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==b.TunnelPrivacyId.ConstantPrivate&&i.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=f})(w||(e.TunnelDtoConverter=w={})),e.$eGb=(0,L.$Ei)("IExtHostTunnelService");let a=class extends C.$Uc{constructor($,f,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$le,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=$.getProxy(c.$HN.MainThreadTunnelService)}async openTunnel($,f){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${$.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const i=await this.a.$openTunnel(f,$.displayName);if(i){const s=new P(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider($,f){$.portRange===void 0&&$.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:$,provider:f}),this.a.$registerPortsAttributesProvider($,i),new u.$JN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes($,f,i,s,t){const o=[];for(const d of $){const l=this.r.get(d);if(!l)return[];o.push(...await Promise.all(f.map(async g=>{let E;try{E=await l.provider.providePortAttributes({port:g,pid:i,commandLine:s},t)}catch{E=await l.provider.providePortAttributes(g,i,s,t)}return{providedAttributes:E,port:g}})))}const n=o.filter(d=>!!d.providedAttributes);return n.length>0?n.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder($){}registerTunnelProvider($,f){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,t)=>await $.provideTunnel(s,t,r.CancellationToken.None)??void 0;const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,privacyOptions:f.tunnelFeatures?.privacyOptions,protocol:f.tunnelFeatures.protocol===void 0?!0:f.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory($,f){if($){$.candidatePortSource!==void 0&&this.a.$setCandidatePortSource($.candidatePortSource),$.showCandidatePort&&(this.f=$.showCandidatePort,this.a.$setCandidateFilter());const i=$.tunnelFactory??(f?this.w(f):void 0);if(i){this.b=i;let s=$.tunnelFeatures?.privacyOptions??[];$.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:R.localize(10774,null),themeIcon:"lock"},{id:"public",label:R.localize(10775,null),themeIcon:"eye"}]);const t=$.tunnelFeatures?{elevation:!!$.tunnelFeatures?.elevation,public:!!$.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,C.$Sc)(()=>{this.b=void 0})}w($){}async $closeTunnel($,f){if(this.g.has($.host)){const i=this.g.get($.host);i.has($.port)&&(f&&i.get($.port).disposeListener.dispose(),await i.get($.port).tunnel.dispose(),i.delete($.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort($,f){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b($,f);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has($.remoteAddress.host)||this.g.set($.remoteAddress.host,new Map);const t=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get($.remoteAddress.host).set($.remoteAddress.port,{tunnel:s,disposeListener:t}),w.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter($){const f=await Promise.all($.map(s=>this.f(s.host,s.port,s.detail??""))),i=$.filter((s,t)=>f[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${$.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$fGb=a,e.$fGb=a=Je([Ve(0,S.$hQ),Ve(1,I.$xQ),Ve(2,T.$_j)],a)}),define(ke[15],Ie([1,0,18,21,190,79,85,28,178,51,103,24,183,22,50,17,2,113,30,110,87,58,145,89,155,152,153,271,119,126,73,74,268,9]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$eQ=_,e.$fQ=re,e.$gQ=Se,L=qe(L),f=qe(f),i=qe(i),s=qe(s),E=qe(E),y=qe(y),v=qe(v);var F;(function(Te){function Me(te){const{selectionStartLineNumber:Re,selectionStartColumn:Ge,positionLineNumber:it,positionColumn:Qe}=te,ft=new v.$KN(Re-1,Ge-1),At=new v.$KN(it-1,Qe-1);return new v.$MN(ft,At)}Te.to=Me;function Ee(te){const{anchor:Re,active:Ge}=te;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ge.line+1,positionColumn:Ge.character+1}}Te.from=Ee})(F||(e.Selection=F={}));var N;(function(Te){function Me(te){if(!te)return;const{start:Re,end:Ge}=te;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ge.line+1,endColumn:Ge.character+1}}Te.from=Me;function Ee(te){if(!te)return;const{startLineNumber:Re,startColumn:Ge,endLineNumber:it,endColumn:Qe}=te;return new v.$LN(Re-1,Ge-1,it-1,Qe-1)}Te.to=Ee})(N||(e.Range=N={}));var O;(function(Te){function Me(te){return{uri:te.uri,range:N.from(te.range)}}Te.from=Me;function Ee(te){return new v.$XN(m.URI.revive(te.uri),N.to(te.range))}Te.to=Ee})(O||(e.Location=O={}));var j;(function(Te){function Me(Ee){switch(Ee){case i.StandardTokenType.Comment:return v.StandardTokenType.Comment;case i.StandardTokenType.Other:return v.StandardTokenType.Other;case i.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case i.StandardTokenType.String:return v.StandardTokenType.String}}Te.to=Me})(j||(e.TokenType=j={}));var z;(function(Te){function Me(te){return new v.$KN(te.lineNumber-1,te.column-1)}Te.to=Me;function Ee(te){return{lineNumber:te.line+1,column:te.character+1}}Te.from=Ee})(z||(e.Position=z={}));var M;(function(Te){function Me(Re,Ge,it){return(0,r.$Gb)((0,r.$1b)(Re).map(Qe=>Ee(Qe,Ge,it)))}Te.from=Me;function Ee(Re,Ge,it){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:it?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:te(Re.scheme,Ge),pattern:et.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:it?.isBuiltin}}function te(Re,Ge){return Ge&&typeof Re=="string"?Ge.transformOutgoingScheme(Re):Re}})(M||(e.DocumentSelector=M={}));var U;(function(Te){function Me(te){switch(te){case v.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}Te.from=Me;function Ee(te){switch(te){case o.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Te.to=Ee})(U||(e.DiagnosticTag=U={}));var V;(function(Te){function Me(te){let Re;return te.code&&((0,a.$eg)(te.code)||(0,a.$ig)(te.code)?Re=String(te.code):Re={value:String(te.code.value),target:te.code.target}),{...N.from(te.range),message:te.message,source:te.source,code:Re,severity:B.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(ie.from),tags:Array.isArray(te.tags)?(0,r.$Gb)(te.tags.map(U.from)):void 0}}Te.from=Me;function Ee(te){const Re=new v.$ZN(N.to(te),te.message,B.to(te.severity));return Re.source=te.source,Re.code=(0,a.$eg)(te.code)?te.code:te.code?.value,Re.relatedInformation=te.relatedInformation&&te.relatedInformation.map(ie.to),Re.tags=te.tags&&(0,r.$Gb)(te.tags.map(U.to)),Re}Te.to=Ee})(V||(e.Diagnostic=V={}));var ie;(function(Te){function Me(te){return{...N.from(te.location.range),message:te.message,resource:te.location.uri}}Te.from=Me;function Ee(te){return new v.$YN(new v.$XN(te.resource,N.to(te)),te.message)}Te.to=Ee})(ie||(e.DiagnosticRelatedInformation=ie={}));var B;(function(Te){function Me(te){switch(te){case v.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Te.from=Me;function Ee(te){switch(te){case o.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Te.to=Ee})(B||(e.DiagnosticSeverity=B={}));var Y;(function(Te){function Me(te){return typeof te=="number"&&te>=v.ViewColumn.One?te-1:te===v.ViewColumn.Beside?p.$yE:p.$xE}Te.from=Me;function Ee(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=Ee})(Y||(e.ViewColumn=Y={}));function J(Te){return typeof Te.range<"u"}function _(Te){return Te.length===0?!0:!!J(Te[0])}var le;(function(Te){function Me(Qe){return Qe.map(Te.from)}Te.fromMany=Me;function Ee(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function te(Qe){let ft;if(Ee(Qe)){const{language:Bt,value:_t}=Qe;ft={value:"```"+Bt+`
`+_t+"\n```\n"}}else v.$bO.isMarkdownString(Qe)?ft={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ft={value:Qe}:ft={value:""};const At=Object.create(null);ft.uris=At;const Xt=Bt=>{try{let _t=m.URI.parse(Bt,!0);_t=_t.with({query:Re(_t.query,At)}),At[Bt]=_t}catch{}return""},si=new b.marked.Renderer;return si.link=Xt,si.image=Bt=>typeof Bt=="string"?Xt(L.$$k(Bt).href):"",(0,b.marked)(ft.value,{renderer:si}),ft}Te.from=te;function Re(Qe,ft){if(!Qe)return Qe;let At;try{At=(0,c.$ai)(Qe)}catch{}if(!At)return Qe;let Xt=!1;return At=(0,S.$fo)(At,si=>{if(m.URI.isUri(si)){const Bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[Bt]=si,Xt=!0,Bt}else return}),Xt?JSON.stringify(At):Qe}function Ge(Qe){const ft=new v.$bO(Qe.value,Qe.supportThemeIcons);return ft.isTrusted=Qe.isTrusted,ft.supportHtml=Qe.supportHtml,ft.baseUri=Qe.baseUri?m.URI.from(Qe.baseUri):void 0,ft}Te.to=Ge;function it(Qe){if(Qe)return typeof Qe=="string"?Qe:Te.from(Qe)}Te.fromStrict=it})(le||(e.MarkdownString=le={}));function re(Te){return _(Te)?Te.map(Me=>({range:N.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?le.fromMany(Me.hoverMessage):Me.hoverMessage?le.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Te.map(Me=>({range:N.from(Me)}))}function Se(Te){return typeof Te>"u"?Te:typeof Te=="string"?m.URI.file(Te):Te}var me;(function(Te){function Me(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?Se(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Te.from=Me})(me||(e.ThemableDecorationAttachmentRenderOptions=me={}));var Q;(function(Te){function Me(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?Se(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?me.from(Ee.before):void 0,after:Ee.after?me.from(Ee.after):void 0}}Te.from=Me})(Q||(e.ThemableDecorationRenderOptions=Q={}));var q;(function(Te){function Me(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case v.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Te.from=Me})(q||(e.DecorationRangeBehavior=q={}));var se;(function(Te){function Me(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?q.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?Q.from(Ee.light):void 0,dark:Ee.dark?Q.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?Se(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?me.from(Ee.before):void 0,after:Ee.after?me.from(Ee.after):void 0}}Te.from=Me})(se||(e.DecorationRenderOptions=se={}));var we;(function(Te){function Me(te){return{text:te.newText,eol:te.newEol&&je.from(te.newEol),range:N.from(te.range)}}Te.from=Me;function Ee(te){const Re=new v.$SN(N.to(te.range),te.text);return Re.newEol=typeof te.eol>"u"?void 0:je.to(te.eol),Re}Te.to=Ee})(we||(e.TextEdit=we={}));var ee;(function(Te){function Me(te,Re){const Ge={edits:[]};if(te instanceof v.$VN){const it=new T.$Bc;for(const Qe of te._allEntries())Qe._type===v.FileEditType.File&&m.URI.isUri(Qe.to)&&Qe.from===void 0&&it.add(Qe.to);for(const Qe of te._allEntries())if(Qe._type===v.FileEditType.File){let ft;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ft={type:"base64",value:(0,h.$8e)(h.$Ne.wrap(Qe.options.contents))}:ft={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ge.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ft},metadata:Qe.metadata})}else Qe._type===v.FileEditType.Text?Ge.edits.push({resource:Qe.uri,textEdit:we.from(Qe.edit),versionId:it.has(Qe.uri)?void 0:Re?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Snippet?Ge.edits.push({resource:Qe.uri,textEdit:{range:N.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:it.has(Qe.uri)?void 0:Re?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Cell?Ge.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===v.FileEditType.CellReplace&&Ge.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:y.CellEditType.Replace,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Rt.from)}})}return Ge}Te.from=Me;function Ee(te){const Re=new v.$VN,Ge=new T.$Ac;for(const it of te.edits)if(it.textEdit){const Qe=it,ft=m.URI.revive(Qe.resource),At=N.to(Qe.textEdit.range),Xt=Qe.textEdit.text,si=Qe.textEdit.insertAsSnippet;let Bt;si?Bt=v.$UN.replace(At,new v.$WN(Xt)):Bt=v.$SN.replace(At,Xt);const _t=Ge.get(ft);_t?_t.push(Bt):Ge.set(ft,[Bt])}else Re.renameFile(m.URI.revive(it.oldResource),m.URI.revive(it.newResource),it.options);for(const[it,Qe]of Ge)Re.set(it,Qe);return Re}Te.to=Ee})(ee||(e.WorkspaceEdit=ee={}));var ae;(function(Te){const Me=Object.create(null);Me[v.SymbolKind.File]=s.SymbolKind.File,Me[v.SymbolKind.Module]=s.SymbolKind.Module,Me[v.SymbolKind.Namespace]=s.SymbolKind.Namespace,Me[v.SymbolKind.Package]=s.SymbolKind.Package,Me[v.SymbolKind.Class]=s.SymbolKind.Class,Me[v.SymbolKind.Method]=s.SymbolKind.Method,Me[v.SymbolKind.Property]=s.SymbolKind.Property,Me[v.SymbolKind.Field]=s.SymbolKind.Field,Me[v.SymbolKind.Constructor]=s.SymbolKind.Constructor,Me[v.SymbolKind.Enum]=s.SymbolKind.Enum,Me[v.SymbolKind.Interface]=s.SymbolKind.Interface,Me[v.SymbolKind.Function]=s.SymbolKind.Function,Me[v.SymbolKind.Variable]=s.SymbolKind.Variable,Me[v.SymbolKind.Constant]=s.SymbolKind.Constant,Me[v.SymbolKind.String]=s.SymbolKind.String,Me[v.SymbolKind.Number]=s.SymbolKind.Number,Me[v.SymbolKind.Boolean]=s.SymbolKind.Boolean,Me[v.SymbolKind.Array]=s.SymbolKind.Array,Me[v.SymbolKind.Object]=s.SymbolKind.Object,Me[v.SymbolKind.Key]=s.SymbolKind.Key,Me[v.SymbolKind.Null]=s.SymbolKind.Null,Me[v.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Me[v.SymbolKind.Struct]=s.SymbolKind.Struct,Me[v.SymbolKind.Event]=s.SymbolKind.Event,Me[v.SymbolKind.Operator]=s.SymbolKind.Operator,Me[v.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function Ee(Re){return typeof Me[Re]=="number"?Me[Re]:s.SymbolKind.Property}Te.from=Ee;function te(Re){for(const Ge in Me)if(Me[Ge]===Re)return Number(Ge);return v.SymbolKind.Property}Te.to=te})(ae||(e.SymbolKind=ae={}));var oe;(function(Te){function Me(te){switch(te){case v.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}Te.from=Me;function Ee(te){switch(te){case s.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Te.to=Ee})(oe||(e.SymbolTag=oe={}));var x;(function(Te){function Me(te){return{name:te.name,kind:ae.from(te.kind),tags:te.tags&&te.tags.map(oe.from),containerName:te.containerName,location:ze.from(te.location)}}Te.from=Me;function Ee(te){const Re=new v.$5N(te.name,ae.to(te.kind),te.containerName,ze.to(te.location));return Re.tags=te.tags&&te.tags.map(oe.to),Re}Te.to=Ee})(x||(e.WorkspaceSymbol=x={}));var ne;(function(Te){function Me(te){const Re={name:te.name||"!!MISSING: name!!",detail:te.detail,range:N.from(te.range),selectionRange:N.from(te.selectionRange),kind:ae.from(te.kind),tags:te.tags?.map(oe.from)??[]};return te.children&&(Re.children=te.children.map(Me)),Re}Te.from=Me;function Ee(te){const Re=new v.$6N(te.name,te.detail,ae.to(te.kind),N.to(te.range),N.to(te.selectionRange));return(0,r.$Kb)(te.tags)&&(Re.tags=te.tags.map(oe.to)),te.children&&(Re.children=te.children.map(Ee)),Re}Te.to=Ee})(ne||(e.DocumentSymbol=ne={}));var pe;(function(Te){function Me(te){const Re=new v.$0N(ae.to(te.kind),te.name,te.detail||"",m.URI.revive(te.uri),N.to(te.range),N.to(te.selectionRange));return Re._sessionId=te._sessionId,Re._itemId=te._itemId,Re}Te.to=Me;function Ee(te,Re,Ge){if(Re=Re??te._sessionId,Ge=Ge??te._itemId,Re===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ge,name:te.name,detail:te.detail,kind:ae.from(te.kind),uri:te.uri,range:N.from(te.range),selectionRange:N.from(te.selectionRange),tags:te.tags?.map(oe.from)}}Te.from=Ee})(pe||(e.CallHierarchyItem=pe={}));var be;(function(Te){function Me(Ee){return new v.$$N(pe.to(Ee.from),Ee.fromRanges.map(te=>N.to(te)))}Te.to=Me})(be||(e.CallHierarchyIncomingCall=be={}));var Fe;(function(Te){function Me(Ee){return new v.$_N(pe.to(Ee.to),Ee.fromRanges.map(te=>N.to(te)))}Te.to=Me})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var ze;(function(Te){function Me(te){return{range:te.range&&N.from(te.range),uri:te.uri}}Te.from=Me;function Ee(te){return new v.$XN(m.URI.revive(te.uri),N.to(te.range))}Te.to=Ee})(ze||(e.location=ze={}));var Ae;(function(Te){function Me(te){const Re=te,Ge=te;return{originSelectionRange:Re.originSelectionRange?N.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ge.uri,range:N.from(Re.targetRange?Re.targetRange:Ge.range),targetSelectionRange:Re.targetSelectionRange?N.from(Re.targetSelectionRange):void 0}}Te.from=Me;function Ee(te){return{targetUri:m.URI.revive(te.uri),targetRange:N.to(te.range),targetSelectionRange:te.targetSelectionRange?N.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?N.to(te.originSelectionRange):void 0}}Te.to=Ee})(Ae||(e.DefinitionLink=Ae={}));var De;(function(Te){function Me(te){return{range:N.from(te.range),contents:le.fromMany(te.contents),canIncreaseVerbosity:te.canIncreaseVerbosity,canDecreaseVerbosity:te.canDecreaseVerbosity}}Te.from=Me;function Ee(te){const Re=te.contents.map(le.to),Ge=N.to(te.range),it=te.canIncreaseVerbosity,Qe=te.canDecreaseVerbosity;return new v.$2N(Re,Ge,it,Qe)}Te.to=Ee})(De||(e.Hover=De={}));var Ce;(function(Te){function Me(te){return{range:N.from(te.range),expression:te.expression}}Te.from=Me;function Ee(te){return new v.$WO(N.to(te.range),te.expression)}Te.to=Ee})(Ce||(e.EvaluatableExpression=Ce={}));var W;(function(Te){function Me(te){if(te instanceof v.$XO)return{type:"text",range:N.from(te.range),text:te.text};if(te instanceof v.$YO)return{type:"variable",range:N.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof v.$ZO)return{type:"expression",range:N.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Me;function Ee(te){switch(te.type){case"text":return{range:N.to(te.range),text:te.text};case"variable":return{range:N.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:N.to(te.range),expression:te.expression}}}Te.to=Ee})(W||(e.InlineValue=W={}));var H;(function(Te){function Me(te){return{frameId:te.frameId,stoppedLocation:N.from(te.stoppedLocation)}}Te.from=Me;function Ee(te){return new v.$1O(te.frameId,N.to(te.stoppedLocation))}Te.to=Ee})(H||(e.InlineValueContext=H={}));var X;(function(Te){function Me(te){return{range:N.from(te.range),kind:te.kind}}Te.from=Me;function Ee(te){return new v.$3N(N.to(te.range),te.kind)}Te.to=Ee})(X||(e.DocumentHighlight=X={}));var Z;(function(Te){function Me(te){return{uri:te.uri,highlights:te.highlights.map(X.from)}}Te.from=Me;function Ee(te){return new v.$4N(m.URI.revive(te.uri),te.highlights.map(X.to))}Te.to=Ee})(Z||(e.MultiDocumentHighlight=Z={}));var de;(function(Te){function Me(Ee){switch(Ee){case s.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Te.to=Me})(de||(e.CompletionTriggerKind=de={}));var ve;(function(Te){function Me(Ee){return{triggerKind:de.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Te.to=Me})(ve||(e.CompletionContext=ve={}));var Oe;(function(Te){function Me(te){switch(te){case v.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}Te.from=Me;function Ee(te){switch(te){case s.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Te.to=Ee})(Oe||(e.CompletionItemTag=Oe={}));var He;(function(Te){const Me=new Map([[v.CompletionItemKind.Method,s.CompletionItemKind.Method],[v.CompletionItemKind.Function,s.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,s.CompletionItemKind.Field],[v.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[v.CompletionItemKind.Class,s.CompletionItemKind.Class],[v.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[v.CompletionItemKind.Module,s.CompletionItemKind.Module],[v.CompletionItemKind.Property,s.CompletionItemKind.Property],[v.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[v.CompletionItemKind.Value,s.CompletionItemKind.Value],[v.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,s.CompletionItemKind.Text],[v.CompletionItemKind.Color,s.CompletionItemKind.Color],[v.CompletionItemKind.File,s.CompletionItemKind.File],[v.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[v.CompletionItemKind.Event,s.CompletionItemKind.Event],[v.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[v.CompletionItemKind.User,s.CompletionItemKind.User]]);function Ee(Ge){return Me.get(Ge)??s.CompletionItemKind.Property}Te.from=Ee;const te=new Map([[s.CompletionItemKind.Method,v.CompletionItemKind.Method],[s.CompletionItemKind.Function,v.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,v.CompletionItemKind.Field],[s.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[s.CompletionItemKind.Class,v.CompletionItemKind.Class],[s.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[s.CompletionItemKind.Module,v.CompletionItemKind.Module],[s.CompletionItemKind.Property,v.CompletionItemKind.Property],[s.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[s.CompletionItemKind.Value,v.CompletionItemKind.Value],[s.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,v.CompletionItemKind.Text],[s.CompletionItemKind.Color,v.CompletionItemKind.Color],[s.CompletionItemKind.File,v.CompletionItemKind.File],[s.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[s.CompletionItemKind.Event,v.CompletionItemKind.Event],[s.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,v.CompletionItemKind.User],[s.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Re(Ge){return te.get(Ge)??v.CompletionItemKind.Property}Te.to=Re})(He||(e.CompletionItemKind=He={}));var Ke;(function(Te){function Me(Ee,te){const Re=new v.$hO(Ee.label);return Re.insertText=Ee.insertText,Re.kind=He.to(Ee.kind),Re.tags=Ee.tags?.map(Oe.to),Re.detail=Ee.detail,Re.documentation=L.$5k(Ee.documentation)?le.to(Ee.documentation):Ee.documentation,Re.sortText=Ee.sortText,Re.filterText=Ee.filterText,Re.preselect=Ee.preselect,Re.commitCharacters=Ee.commitCharacters,f.$Nt.isIRange(Ee.range)?Re.range=N.to(Ee.range):typeof Ee.range=="object"&&(Re.range={inserting:N.to(Ee.range.insert),replacing:N.to(Ee.range.replace)}),Re.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Re.insertText=new v.$WN(Ee.insertText):(Re.insertText=Ee.insertText,Re.textEdit=Re.range instanceof v.$LN?new v.$SN(Re.range,Re.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Re.additionalTextEdits=Ee.additionalTextEdits.map(Ge=>we.to(Ge))),Re.command=te&&Ee.command?te.fromInternal(Ee.command):void 0,Re}Te.to=Me})(Ke||(e.CompletionItem=Ke={}));var _e;(function(Te){function Me(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:le.fromStrict(te.documentation)}}Te.from=Me;function Ee(te){return{label:te.label,documentation:L.$5k(te.documentation)?le.to(te.documentation):te.documentation}}Te.to=Ee})(_e||(e.ParameterInformation=_e={}));var nt;(function(Te){function Me(te){return{label:te.label,documentation:le.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(_e.from):[],activeParameter:te.activeParameter}}Te.from=Me;function Ee(te){return{label:te.label,documentation:L.$5k(te.documentation)?le.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(_e.to):[],activeParameter:te.activeParameter}}Te.to=Ee})(nt||(e.SignatureInformation=nt={}));var st;(function(Te){function Me(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(nt.from):[]}}Te.from=Me;function Ee(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(nt.to):[]}}Te.to=Ee})(st||(e.SignatureHelp=st={}));var rt;(function(Te){function Me(Ee,te){const Re=new v.$gO(z.to(te.position),typeof te.label=="string"?te.label:te.label.map(at.to.bind(void 0,Ee)),te.kind&&gt.to(te.kind));return Re.textEdits=te.textEdits&&te.textEdits.map(we.to),Re.tooltip=L.$5k(te.tooltip)?le.to(te.tooltip):te.tooltip,Re.paddingLeft=te.paddingLeft,Re.paddingRight=te.paddingRight,Re}Te.to=Me})(rt||(e.InlayHint=rt={}));var at;(function(Te){function Me(Ee,te){const Re=new v.$fO(te.label);return Re.tooltip=L.$5k(te.tooltip)?le.to(te.tooltip):te.tooltip,s.Command.is(te.command)&&(Re.command=Ee.fromInternal(te.command)),te.location&&(Re.location=ze.to(te.location)),Re}Te.to=Me})(at||(e.InlayHintLabelPart=at={}));var gt;(function(Te){function Me(te){return te}Te.from=Me;function Ee(te){return te}Te.to=Ee})(gt||(e.InlayHintKind=gt={}));var ht;(function(Te){function Me(te){return{range:N.from(te.range),url:te.target,tooltip:te.tooltip}}Te.from=Me;function Ee(te){let Re;if(te.url)try{Re=typeof te.url=="string"?m.URI.parse(te.url,!0):m.URI.revive(te.url)}catch{}const Ge=new v.$mO(N.to(te.range),Re);return Ge.tooltip=te.tooltip,Ge}Te.to=Ee})(ht||(e.DocumentLink=ht={}));var ct;(function(Te){function Me(te){const Re=new v.$pO(te.label);return te.textEdit&&(Re.textEdit=we.to(te.textEdit)),te.additionalTextEdits&&(Re.additionalTextEdits=te.additionalTextEdits.map(Ge=>we.to(Ge))),Re}Te.to=Me;function Ee(te){return{label:te.label,textEdit:te.textEdit?we.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Re=>we.from(Re)):void 0}}Te.from=Ee})(ct||(e.ColorPresentation=ct={}));var Pe;(function(Te){function Me(te){return new v.$nO(te[0],te[1],te[2],te[3])}Te.to=Me;function Ee(te){return[te.red,te.green,te.blue,te.alpha]}Te.from=Ee})(Pe||(e.Color=Pe={}));var Be;(function(Te){function Me(te){return{range:N.from(te.range)}}Te.from=Me;function Ee(te){return new v.$9N(N.to(te.range))}Te.to=Ee})(Be||(e.SelectionRange=Be={}));var Ye;(function(Te){function Me(Ee){switch(Ee){case l.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Te.to=Me})(Ye||(e.TextDocumentSaveReason=Ye={}));var Ne;(function(Te){function Me(te){switch(te){case v.TextEditorLineNumbersStyle.Off:return $.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return $.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return $.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return $.RenderLineNumbersType.On}}Te.from=Me;function Ee(te){switch(te){case $.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case $.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case $.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case $.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Te.to=Ee})(Ne||(e.TextEditorLineNumbersStyle=Ne={}));var je;(function(Te){function Me(te){if(te===v.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(te===v.EndOfLine.LF)return t.EndOfLineSequence.LF}Te.from=Me;function Ee(te){if(te===t.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(te===t.EndOfLineSequence.LF)return v.EndOfLine.LF}Te.to=Ee})(je||(e.EndOfLine=je={}));var ue;(function(Te){function Me(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case v.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case v.ProgressLocation.Window:return n.ProgressLocation.Window;case v.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Te.from=Me})(ue||(e.ProgressLocation=ue={}));var he;(function(Te){function Me(te){const Re={start:te.start+1,end:te.end+1};return te.kind&&(Re.kind=ce.from(te.kind)),Re}Te.from=Me;function Ee(te){const Re={start:te.start-1,end:te.end-1};return te.kind&&(Re.kind=ce.to(te.kind)),Re}Te.to=Ee})(he||(e.FoldingRange=he={}));var ce;(function(Te){function Me(te){if(te)switch(te){case v.FoldingRangeKind.Comment:return s.$Ou.Comment;case v.FoldingRangeKind.Imports:return s.$Ou.Imports;case v.FoldingRangeKind.Region:return s.$Ou.Region}}Te.from=Me;function Ee(te){if(te)switch(te.value){case s.$Ou.Comment.value:return v.FoldingRangeKind.Comment;case s.$Ou.Imports.value:return v.FoldingRangeKind.Imports;case s.$Ou.Region.value:return v.FoldingRangeKind.Region}}Te.to=Ee})(ce||(e.FoldingRangeKind=ce={}));var Xe;(function(Te){function Me(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?N.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?l.$4F.id:void 0}}Te.from=Me})(Xe||(e.TextEditorOpenOptions=Xe={}));var et;(function(Te){function Me(Ge){return Ge instanceof v.$KO?Ge.toJSON():typeof Ge=="string"?Ge:Ee(Ge)||te(Ge)?new v.$KO(Ge.baseUri??Ge.base,Ge.pattern).toJSON():Ge}Te.from=Me;function Ee(Ge){const it=Ge;return it?m.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function te(Ge){const it=Ge;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Re(Ge){return typeof Ge=="string"?Ge:new v.$KO(m.URI.revive(Ge.baseUri),Ge.pattern)}Te.to=Re})(et||(e.GlobPattern=et={}));var ut;(function(Te){function Me(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Me);if(typeof Ee=="string")return Ee;{const te=Ee;return{language:te.language,scheme:te.scheme,pattern:et.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Te.from=Me})(ut||(e.LanguageSelector=ut={}));var mt;(function(Te){function Me(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Re=>Array.isArray(Re)&&Re.every(Ge=>Ge&&typeof Ge=="object"&&"uri"in Ge&&m.URI.isUri(Ge.uri)&&"version"in Ge&&typeof Ge.version=="number"&&"ranges"in Ge&&Array.isArray(Ge.ranges)&&Ge.ranges.every(it=>it instanceof v.$LN)))}Te.is=Me;function Ee(te){return{documents:te.documents.map(Re=>Re.map(Ge=>({uri:m.URI.from(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(it=>N.from(it))})))}}Te.from=Ee})(mt||(e.MappedEditsContext=mt={}));var Dt;(function(Te){function Me(te){return{start:te.start,end:te.end}}Te.from=Me;function Ee(te){return new v.$bP(te.start,te.end)}Te.to=Ee})(Dt||(e.NotebookRange=Dt={}));var Ft;(function(Te){function Me(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Te.to=Me;function Ee(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Te.from=Ee})(Ft||(e.NotebookCellExecutionSummary=Ft={}));var Ht;(function(Te){function Me(Ee){if(Ee===y.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(Ee===y.NotebookCellExecutionState.Pending)return;if(Ee===y.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Te.to=Me})(Ht||(e.NotebookCellExecutionState=Ht={}));var ei;(function(Te){function Me(te){switch(te){case v.NotebookCellKind.Markup:return y.CellKind.Markup;case v.NotebookCellKind.Code:default:return y.CellKind.Code}}Te.from=Me;function Ee(te){switch(te){case y.CellKind.Markup:return v.NotebookCellKind.Markup;case y.CellKind.Code:default:return v.NotebookCellKind.Code}}Te.to=Ee})(ei||(e.NotebookCellKind=ei={}));var oi;(function(Te){function Me(te){const Re={metadata:te.metadata??Object.create(null),cells:[]};for(const Ge of te.cells)v.$cP.validate(Ge),Re.cells.push(Rt.from(Ge));return Re}Te.from=Me;function Ee(te){const Re=new v.$dP(te.cells.map(Rt.to));return(0,a.$rg)(te.metadata)||(Re.metadata=te.metadata),Re}Te.to=Ee})(oi||(e.NotebookData=oi={}));var Rt;(function(Te){function Me(te){return{cellKind:ei.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ft.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(jt.from):[]}}Te.from=Me;function Ee(te){return new v.$cP(ei.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(jt.to):void 0,te.metadata,te.internalMetadata?Ft.to(te.internalMetadata):void 0)}Te.to=Ee})(Rt||(e.NotebookCellData=Rt={}));var tt;(function(Te){function Me(te){return{mime:te.mime,valueBytes:h.$Ne.wrap(te.data)}}Te.from=Me;function Ee(te){return new v.$eP(te.valueBytes.buffer,te.mime)}Te.to=Ee})(tt||(e.NotebookCellOutputItem=tt={}));var jt;(function(Te){function Me(te){return{outputId:te.id,items:te.items.map(tt.from),metadata:te.metadata}}Te.from=Me;function Ee(te){const Re=te.items.map(tt.to);return new v.$fP(Re,te.outputId,te.metadata)}Te.to=Ee})(jt||(e.NotebookCellOutput=jt={}));var hi;(function(Te){function Me(Re){return te(Re)?{include:et.from(Re.include)??void 0,exclude:et.from(Re.exclude)??void 0}:et.from(Re)??void 0}Te.from=Me;function Ee(Re){return te(Re)?{include:et.to(Re.include),exclude:et.to(Re.exclude)}:et.to(Re)}Te.to=Ee;function te(Re){const Ge=Re;return Ge?!(0,a.$ng)(Ge.include)&&!(0,a.$ng)(Ge.exclude):!1}})(hi||(e.NotebookExclusiveDocumentPattern=hi={}));var pt;(function(Te){function Me(Ee,te,Re){const Ge=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===v.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:te.toInternal(Ge,Re),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Te.from=Me})(pt||(e.NotebookStatusBarItem=pt={}));var yt;(function(Te){function Me(Ee,te,Re){const Ge=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:te.toInternal(Ge,Re),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Te.from=Me})(yt||(e.NotebookKernelSourceAction=yt={}));var ti;(function(Te){function Me(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Te.from=Me})(ti||(e.NotebookDocumentContentOptions=ti={}));var ii;(function(Te){function Me(te){return{uri:te.uri,provides:te.provides}}Te.from=Me;function Ee(te){return new v.$hP(m.URI.revive(te.uri),te.provides)}Te.to=Ee})(ii||(e.NotebookRendererScript=ii={}));var qt;(function(Te){function Me(te){return{message:le.fromStrict(te.message)||"",type:A.TestMessageType.Error,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:N.from(te.location.range),uri:te.location.uri},stackTrace:te.stackTrace?.map(Re=>({label:Re.label,position:Re.position&&z.from(Re.position),uri:Re.file&&m.URI.revive(Re.file).toJSON()}))}}Te.from=Me;function Ee(te){const Re=new v.$nP(typeof te.message=="string"?te.message:le.to(te.message));return Re.actualOutput=te.actual,Re.expectedOutput=te.expected,Re.contextValue=te.contextValue,Re.location=te.location?ze.to(te.location):void 0,Re}Te.to=Ee})(qt||(e.TestMessage=qt={}));var bt;(function(Te){Te.namespace=A.$0I,Te.denamespace=A.$$I})(bt||(e.TestTag=bt={}));var zt;(function(Te){function Me(te){const Re=(0,d.$dQ)(te).controllerId;return{extId:k.$5I.fromExtHostTestItem(te,Re).toString(),label:te.label,uri:m.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Ge=>bt.namespace(Re,Ge.id)),range:f.$Nt.lift(N.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&le.fromStrict(te.error)||null}}Te.from=Me;function Ee(te){return{parent:void 0,error:void 0,id:k.$5I.fromString(te.extId).localId,label:te.label,uri:m.URI.revive(te.uri),tags:(te.tags||[]).map(Re=>{const{tagId:Ge}=bt.denamespace(Re);return new v.$oP(Ge)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Te.toPlain=Ee})(zt||(e.TestItem=zt={})),function(Te){function Me(te){return{id:te.id}}Te.from=Me;function Ee(te){return new v.$oP(te.id)}Te.to=Ee}(bt||(e.TestTag=bt={}));var ni;(function(Te){const Me=(te,Re)=>{const Ge=te.value;if(!Ge)return;const it={...zt.toPlain(Ge.item),parent:Re,taskStates:Ge.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ft=>ft.type===A.TestMessageType.Error).map(qt.to)})),children:[]};if(te.children)for(const Qe of te.children.values()){const ft=Me(Qe,it);ft&&it.children.push(ft)}return it};function Ee(te){const Re=new u.$4I;for(const Qe of te.items)Re.insert(k.$5I.fromString(Qe.item.extId).path,Qe);const Ge=[Re.nodes],it=[];for(;Ge.length;)for(const Qe of Ge.pop())Qe.value?it.push(Qe):Qe.children&&Ge.push(Qe.children.values());return{completedAt:te.completedAt,results:it.map(Qe=>Me(Qe)).filter(a.$mg)}}Te.to=Ee})(ni||(e.TestResults=ni={}));var ai;(function(Te){function Me(Ge){return{covered:Ge.covered,total:Ge.total}}function Ee(Ge){return"line"in Ge?z.from(Ge):N.from(Ge)}function te(Ge){if(typeof Ge.executed=="number"&&Ge.executed<0)throw new Error(`Invalid coverage count ${Ge.executed}`);return"branches"in Ge?{count:Ge.executed,location:Ee(Ge.location),type:A.DetailType.Statement,branches:Ge.branches.length?Ge.branches.map(it=>({count:it.executed,location:it.location&&Ee(it.location),label:it.label})):void 0}:{type:A.DetailType.Declaration,name:Ge.name,count:Ge.executed,location:Ee(Ge.location)}}Te.fromDetails=te;function Re(Ge,it,Qe){return v.$rP(Qe.statementCoverage),v.$rP(Qe.branchCoverage),v.$rP(Qe.declarationCoverage),{id:it,uri:Qe.uri,statement:Me(Qe.statementCoverage),branch:Qe.branchCoverage&&Me(Qe.branchCoverage),declaration:Qe.declarationCoverage&&Me(Qe.declarationCoverage),testIds:Qe instanceof v.$sP&&Qe.fromTests.length?Qe.fromTests.map(ft=>k.$5I.fromExtHostTestItem(ft,Ge).toString()):void 0}}Te.fromFile=Re})(ai||(e.TestCoverage=ai={}));var xe;(function(Te){function Me(Ee){switch(Ee){case s.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Te.to=Me})(xe||(e.CodeActionTriggerKind=xe={}));var ci;(function(Te){function Me(te){const Re=new v.$wP(ae.to(te.kind),te.name,te.detail||"",m.URI.revive(te.uri),N.to(te.range),N.to(te.selectionRange));return Re._sessionId=te._sessionId,Re._itemId=te._itemId,Re}Te.to=Me;function Ee(te,Re,Ge){if(Re=Re??te._sessionId,Ge=Ge??te._itemId,Re===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ge,kind:ae.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:N.from(te.range),selectionRange:N.from(te.selectionRange),tags:te.tags?.map(oe.from)}}Te.from=Ee})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(Te){function Me(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Te.from=Me})(di||(e.ViewBadge=di={}));var fi;(function(Te){function Me(Ge,it,Qe){const ft=it.fileData;return ft?new v.$CO(new v.$DO(ft.name,m.URI.revive(ft.uri),ft.id,(0,R.$cb)(()=>Qe(ft.id)))):Ge===I.$0s.uriList&&it.uriListData?new v.$BO(Re(it.uriListData)):new v.$BO(it.asString)}Te.to=Me;async function Ee(Ge,it){const Qe=await it.asString();if(Ge===I.$0s.uriList)return{asString:Qe,fileData:void 0,uriListData:te(Qe)};const ft=it.asFile();return{asString:Qe,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Te.from=Ee;function te(Ge){return C.$su.split(Ge).map(it=>{if(it.startsWith("#"))return it;try{return m.URI.parse(it)}catch{}return it})}function Re(Ge){return C.$su.create(Ge.map(it=>typeof it=="string"?it:m.URI.revive(it)))}})(fi||(e.DataTransferItem=fi={}));var vt;(function(Te){function Me(te,Re){const Ge=te.items.map(([it,Qe])=>[it,fi.to(it,Qe,Re)]);return new v.$EO(Ge)}Te.toDataTransfer=Me;async function Ee(te){const Re={items:[]},Ge=[];for(const[it,Qe]of te)Ge.push((async()=>{Re.items.push([it,await fi.from(it,Qe)])})());return await Promise.all(Ge),Re}Te.from=Ee})(vt||(e.DataTransfer=vt={}));var Mt;(function(Te){function Me(te,Re){return{kind:"reply",agentId:te.participant??Re?.agentId??"",subCommand:te.command??Re?.command,message:te.prompt,title:te.label}}Te.from=Me;function Ee(te){return{prompt:te.message,label:te.title,participant:te.agentId,command:te.subCommand}}Te.to=Ee})(Mt||(e.ChatFollowup=Mt={}));var Lt;(function(Te){function Me(te){switch(te){case E.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Te.to=Me;function Ee(te){switch(te){case v.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}Te.from=Ee})(Lt||(e.LanguageModelChatMessageRole=Lt={}));var Gt;(function(Te){function Me(te){let Re="",Ge;te.content.type==="text"?Re=te.content.value:Ge=new v.$1P(te.content.name,te.content.value,te.content.isError);const it=Lt.to(te.role),Qe=new v.$2P(it,Re,te.name);return Ge!==void 0&&(Qe.content2=Ge),Qe}Te.to=Me;function Ee(te){const Re=Lt.from(te.role),Ge=te.name;let it;return te.content2 instanceof v.$1P?it={type:"function_result",name:te.content2.name,value:te.content2.content,isError:te.content2.isError}:it={type:"text",value:te.content},{role:Re,name:Ge,content:it}}Te.from=Ee})(Gt||(e.LanguageModelChatMessage=Gt={}));var ri;(function(Te){function Me(te){return{kind:"markdownContent",content:le.from(te.value)}}Te.from=Me;function Ee(te){return new v.$JP(le.to(te.content))}Te.to=Ee})(ri||(e.ChatResponseMarkdownPart=ri={}));var Qt;(function(Te){function Me(te){return{kind:"markdownVuln",content:le.from(te.value),vulnerabilities:te.vulnerabilities}}Te.from=Me;function Ee(te){return new v.$KP(le.to(te.content),te.vulnerabilities)}Te.to=Ee})(Qt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Qt={}));var li;(function(Te){function Me(te){return{kind:"agentDetection",agentId:te.participant,command:te.command}}Te.from=Me;function Ee(te){return new v.$LP(te.agentId,te.command)}Te.to=Ee})(li||(e.ChatResponseDetectedParticipantPart=li={}));var Wt;(function(Te){function Me(Ee){return{kind:"confirmation",title:Ee.title,message:Ee.message,data:Ee.data,buttons:Ee.buttons}}Te.from=Me})(Wt||(e.ChatResponseConfirmationPart=Wt={}));var Kt;(function(Te){function Me(te){const{value:Re,baseUri:Ge}=te;function it(Qe,ft){return Qe.map(At=>{const Xt=m.URI.joinPath(ft,At.name);return{label:At.name,uri:Xt,children:At.children&&it(At.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,P.$ch)(Ge),uri:Ge,children:it(Re,Ge)}}}Te.from=Me;function Ee(te){const Re=(0,c.$bi)(te.treeData);function Ge(ft){return ft.map(At=>({name:At.label,children:At.children&&Ge(At.children)}))}const it=Re.uri,Qe=Re.children?Ge(Re.children):[];return new v.$NP(Qe,it)}Te.to=Ee})(Kt||(e.ChatResponseFilesPart=Kt={}));var Jt;(function(Te){function Me(te){const Re=Ge=>m.URI.isUri(Ge);return{kind:"inlineReference",name:te.title,inlineReference:Re(te.value)?te.value:O.from(te.value)}}Te.from=Me;function Ee(te){const Re=(0,c.$bi)(te);return new v.$OP(m.URI.isUri(Re.inlineReference)?Re.inlineReference:O.to(Re.inlineReference),te.name)}Te.to=Ee})(Jt||(e.ChatResponseAnchorPart=Jt={}));var Nt;(function(Te){function Me(te){return{kind:"progressMessage",content:le.from(te.value)}}Te.from=Me;function Ee(te){return new v.$PP(te.content.value)}Te.to=Ee})(Nt||(e.ChatResponseProgressPart=Nt={}));var wt;(function(Te){function Me(te){return{kind:"warning",content:le.from(te.value)}}Te.from=Me;function Ee(te){return new v.$RP(te.content.value)}Te.to=Ee})(wt||(e.ChatResponseWarningPart=wt={}));var It;(function(Te){function Me(Ee){return{kind:"progressTask",content:le.from(Ee.value)}}Te.from=Me})(It||(e.ChatTask=It={}));var Yt;(function(Te){function Me(Ee){return{kind:"progressTaskResult",content:typeof Ee=="string"?le.from(Ee):void 0}}Te.from=Me})(Yt||(e.ChatTaskResult=Yt={}));var Pt;(function(Te){function Me(te,Re,Ge){return{kind:"command",command:Re.toInternal(te.value,Ge)??{command:te.value.command,title:te.value.title}}}Te.from=Me;function Ee(te,Re){return new v.$SP(Re.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}Te.to=Ee})(Pt||(e.ChatResponseCommandButtonPart=Pt={}));var gi;(function(Te){function Me(te){return{kind:"textEdit",uri:te.uri,edits:te.edits.map(Re=>we.from(Re))}}Te.from=Me;function Ee(te){return new v.$VP(m.URI.revive(te.uri),te.edits.map(Re=>we.to(Re)))}Te.to=Ee})(gi||(e.ChatResponseTextEditPart=gi={}));var xt;(function(Te){function Me(te){const Re=w.ThemeIcon.isThemeIcon(te.iconPath)?te.iconPath:m.URI.isUri(te.iconPath)?{light:m.URI.revive(te.iconPath)}:te.iconPath&&"light"in te.iconPath&&"dark"in te.iconPath&&m.URI.isUri(te.iconPath.light)&&m.URI.isUri(te.iconPath.dark)?{light:m.URI.revive(te.iconPath.light),dark:m.URI.revive(te.iconPath.dark)}:void 0;return"variableName"in te.value?{kind:"reference",reference:{variableName:te.value.variableName,value:m.URI.isUri(te.value.value)||!te.value.value?te.value.value:O.from(te.value.value)},iconPath:Re,options:te.options}:{kind:"reference",reference:m.URI.isUri(te.value)?te.value:O.from(te.value),iconPath:Re,options:te.options}}Te.from=Me;function Ee(te){const Re=(0,c.$bi)(te),Ge=it=>m.URI.isUri(it)?it:O.to(it);return new v.$TP("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&Ge(Re.reference.value)}:Ge(Re.reference))}Te.to=Ee})(xt||(e.ChatResponseReferencePart=xt={}));var Di;(function(Te){function Me(Ee){return{kind:"codeCitation",value:Ee.value,license:Ee.license,snippet:Ee.snippet}}Te.from=Me})(Di||(e.ChatResponseCodeCitationPart=Di={}));var pi;(function(Te){function Me(Re,Ge,it){return Re instanceof v.$JP?ri.from(Re):Re instanceof v.$OP?Jt.from(Re):Re instanceof v.$TP?xt.from(Re):Re instanceof v.$PP?Nt.from(Re):Re instanceof v.$NP?Kt.from(Re):Re instanceof v.$SP?Pt.from(Re,Ge,it):Re instanceof v.$VP?gi.from(Re):Re instanceof v.$KP?Qt.from(Re):Re instanceof v.$LP?li.from(Re):Re instanceof v.$RP?wt.from(Re):Re instanceof v.$MP?Wt.from(Re):Re instanceof v.$UP?Di.from(Re):{kind:"markdownContent",content:le.from("")}}Te.from=Me;function Ee(Re,Ge){switch(Re.kind){case"reference":return xt.to(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return te(Re,Ge)}}Te.to=Ee;function te(Re,Ge){switch(Re.kind){case"markdownContent":return ri.to(Re);case"inlineReference":return Jt.to(Re);case"progressMessage":return;case"treeData":return Kt.to(Re);case"command":return Pt.to(Re,Ge)}}Te.toContent=te})(pi||(e.ChatResponsePart=pi={}));var Ri;(function(Te){function Me(Ee,te){return{prompt:Ee.message,command:Ee.command,attempt:Ee.attempt??0,enableCommandDetection:Ee.enableCommandDetection??!0,references:Ee.variables.variables.map(Oi.to),location:Tt.to(Ee.location),acceptedConfirmationData:Ee.acceptedConfirmationData,rejectedConfirmationData:Ee.rejectedConfirmationData,location2:te}}Te.to=Me})(Ri||(e.ChatAgentRequest=Ri={}));var Tt;(function(Te){function Me(te){switch(te){case g.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case g.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case g.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case g.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Te.to=Me;function Ee(te){switch(te){case v.ChatLocation.Notebook:return g.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return g.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return g.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return g.ChatAgentLocation.Editor}}Te.from=Ee})(Tt||(e.ChatLocation=Tt={}));var Oi;(function(Te){function Me(Ee){const te=Ee.value;if(!te)throw new Error("Invalid value reference");return{id:Ee.id,name:Ee.name,range:Ee.range&&[Ee.range.start,Ee.range.endExclusive],value:(0,m.$vc)(te)?m.URI.revive(te):te&&typeof te=="object"&&"uri"in te&&"range"in te&&(0,m.$vc)(te.uri)?O.to((0,c.$bi)(te)):te,modelDescription:Ee.modelDescription}}Te.to=Me})(Oi||(e.ChatAgentValueReference=Oi={}));var ui;(function(Te){function Me(Ee,te,Re){return{id:Ee.id,label:Ee.label,fullName:Ee.fullName,icon:Ee.icon?.id,value:Ee.values[0].value,insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation,command:te.toInternal(Ee.command,Re)}}Te.from=Me})(ui||(e.ChatAgentCompletionItem=ui={}));var Ct;(function(Te){function Me(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Te.to=Me})(Ct||(e.ChatAgentResult=Ct={}));var Ti;(function(Te){function Me(Ee,te,Re){if(te.action.kind==="vote")return;const Ge=Ct.to(Ee);if(te.action.kind==="command"){const it=te.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Re.fromInternal(it)??{command:it.id,title:it.title}}},result:Ge}}else return te.action.kind==="followUp"?{action:{kind:"followUp",followup:Mt.to(te.action.followup)},result:Ge}:te.action.kind==="inlineChat"?{action:{kind:"editor",accepted:te.action.action==="accepted"},result:Ge}:{action:te.action,result:Ge}}Te.to=Me})(Ti||(e.ChatAgentUserActionEvent=Ti={}));var ki;(function(Te){function Me(Ee,te,Re){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:te.toInternal(Ee,Re)}Te.from=Me})(ki||(e.TerminalQuickFix=ki={}));var yi;(function(Te){function Me(Ee){return{kind:Ni.to(Ee.kind)}}Te.to=Me})(yi||(e.PartialAcceptInfo=yi={}));var Ni;(function(Te){function Me(Ee){switch(Ee){case s.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Te.to=Me})(Ni||(e.PartialAcceptTriggerKind=Ni={}));var bi;(function(Te){function Me(Ee,te){return{id:te,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:Ee.contextValue}}Te.from=Me})(bi||(e.DebugTreeItem=bi={}));var Vt;(function(Te){function Me(Ee){return{name:Ee.name,description:Ee.description,parametersSchema:Ee.parametersSchema}}Te.to=Me})(Vt||(e.LanguageModelToolDescription=Vt={}))}),define(ke[294],Ie([1,0,6,19,15,53]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=void 0;let L=class{constructor(b,c){this.a=b.getProxy(r.$HN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>c.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,c,I){const S=new R.$Ww(C.WorkspaceEdit.from(b,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,I?.isRefactoring??!1)}};e.$spc=L,e.$spc=L=Je([Ve(0,h.$hQ)],L)}),define(ke[295],Ie([1,0,18,7,52,4,39,3,51,42,17,2,23,6,15,9,153,257,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=void 0,w=qe(w),a=qe(a);class i{constructor(n,d,l,g,E){this.j=n,this.k=d,this.l=l,this.m=g,this.n=E,this.b=c.$fe.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let d=function(g){if(n.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,g),E}};const n=this;this.b.reset();const l=(g,E)=>{if(typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,g),y={report:k=>{D?.then(A=>{A&&(a.$bO.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseWarningPart.from(k),A):this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseReferencePart.from(k),A))})}};Promise.all([D,E?.(y)]).then(([k,A])=>{k!==void 0&&A!==void 0&&this.l.$handleProgressChunk(this.k.requestId,w.ChatTaskResult.from(A),k)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){d(this.markdown);const E=new a.$JP(g),D=w.ChatResponseMarkdownPart.from(E);return l(D),this},markdownWithVulnerabilities(g,E){d(this.markdown),E&&(0,f.$fH)(n.j,"chatParticipantAdditions");const D=new a.$KP(g,E),y=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return l(y),this},filetree(g,E){d(this.filetree);const D=new a.$NP(g,E),y=w.ChatResponseFilesPart.from(D);return l(y),this},anchor(g,E){d(this.anchor);const D=new a.$OP(g,E),y=w.ChatResponseAnchorPart.from(D);return l(y),this},button(g){d(this.anchor);const E=new a.$SP(g),D=w.ChatResponseCommandButtonPart.from(E,n.m,n.n);return l(D),this},progress(g,E){d(this.progress);const D=new a.$QP(g,E),y=E?w.ChatTask.from(D):w.ChatResponseProgressPart.from(D);return l(y,E),this},warning(g){d(this.progress),(0,f.$fH)(n.j,"chatParticipantAdditions");const E=new a.$RP(g),D=w.ChatResponseWarningPart.from(E);return l(D),this},reference(g,E){return this.reference2(g,E)},reference2(g,E,D){if(d(this.reference),"variableName"in g&&(0,f.$fH)(n.j,"chatParticipantAdditions"),"variableName"in g&&!g.value){const y=n.k.variables.variables.find(k=>k.name===g.variableName);if(y){let k;if(y.references?.length)k=y.references.map(A=>({kind:"reference",reference:{variableName:g.variableName,value:A.reference}}));else{const A=new a.$TP(g,E,D);k=[w.ChatResponseReferencePart.from(A)]}return k.forEach(A=>l(A)),this}}else{const y=new a.$TP(g,E,D),k=w.ChatResponseReferencePart.from(y);l(k)}return this},codeCitation(g,E,D){d(this.codeCitation),(0,f.$fH)(n.j,"chatParticipantAdditions");const y=new a.$UP(g,E,D),k=w.ChatResponseCodeCitationPart.from(y);l(k)},textEdit(g,E){d(this.textEdit),(0,f.$fH)(n.j,"chatParticipantAdditions");const D=new a.$VP(g,E),y=w.ChatResponseTextEditPart.from(D);return l(y),this},detectedParticipant(g,E){d(this.detectedParticipant),(0,f.$fH)(n.j,"chatParticipantAdditions");const D=new a.$LP(g,E),y=w.ChatResponseDetectedParticipantPart.from(D);return l(y),this},confirmation(g,E,D,y){d(this.confirmation),(0,f.$fH)(n.j,"chatParticipantAdditions");const k=new a.$MP(g,E,D,y),A=w.ChatResponseConfirmationPart.from(k);return l(A),this},push(g){if(d(this.push),(g instanceof a.$VP||g instanceof a.$KP||g instanceof a.$LP||g instanceof a.$RP||g instanceof a.$MP||g instanceof a.$UP)&&(0,f.$fH)(n.j,"chatParticipantAdditions"),g instanceof a.$TP)this.reference2(g.value,g.iconPath,g.options);else{const E=w.ChatResponsePart.from(g,n.m,n.n);l(E)}return this}}}return this.g}}class s extends T.$Uc{static{this.b=0}constructor(n,d,l,g){super(),this.n=d,this.s=l,this.t=g,this.c=new Map,this.j=this.B(new T.$4c),this.m=this.B(new T.$4c),this.g=n.getProxy(P.$HN.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,d,l){const g=s.b++,E=new t(n,d,this.g,g,l);return this.c.set(g,E),this.g.$registerAgent(g,n.identifier,d,{},void 0),E.apiAgent}createDynamicChatAgent(n,d,l,g){const E=s.b++,D=new t(n,d,this.g,E,g);return this.c.set(E,D),this.g.$registerAgent(E,n.identifier,d,{isSticky:!0},l),D.apiAgent}async $invokeAgent(n,d,l,g){const E=this.c.get(n);if(!E)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);const D=(0,b.$bi)(d);let y=this.j.get(D.sessionId);y||(y=new T.$Tc,this.j.set(D.sessionId,y));const k=new i(E.extension,D,this.g,this.s.converter,y);try{const A=await this.u(D.agentId,l);let p;if(D.locationData?.type===m.ChatAgentLocation.Editor){const F=this.t.getDocument(D.locationData.document);p=new a.$YP(F,w.Selection.to(D.locationData.selection),w.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===m.ChatAgentLocation.Notebook){const F=this.t.getDocument(D.locationData.sessionInputUri);p=new a.$ZP(F)}else D.locationData?.type,m.ChatAgentLocation.Terminal;const v=E.invoke(w.ChatAgentRequest.to(D,p),{history:A},k.apiObject,g);return await(0,h.$sh)(Promise.resolve(v).then(F=>{if(F?.metadata)try{JSON.stringify(F.metadata)}catch(O){const j=`result.metadata MUST be JSON.stringify-able. Got error: ${O.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${j}`,E.extension),{errorDetails:{message:j},timings:k.timings}}let N;return F?.errorDetails&&(N={...F.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,f.$fH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:k.timings,metadata:F?.metadata}}),g)}catch(A){return this.n.error(A,E.extension),A instanceof a.$8P&&A.cause&&(A=A.cause),{errorDetails:{message:(0,C.$pj)(A),responseIsIncomplete:!0}}}finally{k.close()}}async u(n,d){const l=[];for(const g of d.history){const E=w.ChatAgentResult.to(g.result),D=n===g.request.agentId?E:{...E,metadata:void 0};l.push(new a.$WP(g.request.message,g.request.command,g.request.variables.variables.map(w.ChatAgentValueReference.to),g.request.agentId));const y=(0,r.$Gb)(g.response.map(k=>w.ChatResponsePart.toContent(k,this.s.converter)));l.push(new a.$XP(y,D,g.request.agentId,g.request.command))}return l}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,d,l,g,E){const D=this.c.get(d);if(!D)return Promise.resolve([]);const y=(0,b.$bi)(n),k=await this.u(D.id,g),A=w.ChatAgentResult.to(l);return(await D.provideFollowups(A,{history:k},E)).filter(p=>{const v=!p.participant||L.Iterable.some(this.c.values(),F=>F.id===p.participant&&u.$qn.equals(F.extension.identifier,D.extension.identifier));return v||this.n.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),v}).map(p=>w.ChatFollowup.from(p,y))}$acceptFeedback(n,d,l,g){const E=this.c.get(n);if(!E)return;const D=w.ChatAgentResult.to(d);let y;switch(l){case $.ChatAgentVoteDirection.Down:y=a.ChatResultFeedbackKind.Unhelpful;break;case $.ChatAgentVoteDirection.Up:y=a.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(g?{result:D,kind:y,reportIssue:g}:{result:D,kind:y}))}$acceptAction(n,d,l){const g=this.c.get(n);if(!g||l.action.kind==="vote")return;const E=w.ChatAgentUserActionEvent.to(d,l,this.s.converter);E&&g.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(n,d,l){const g=this.c.get(n);if(!g)return[];let E=this.m.get(n);return E?E.clear():(E=new T.$Tc,this.m.set(n,E)),(await g.invokeCompletionProvider(d,l)).map(y=>w.ChatAgentCompletionItem.from(y,this.s.converter,E))}async $provideWelcomeMessage(n,d,l){const g=this.c.get(n);if(g)return await g.provideWelcomeMessage(w.ChatLocation.to(d),l)}async $provideSampleQuestions(n,d,l){const g=this.c.get(n);if(g)return(await g.provideSampleQuestions(w.ChatLocation.to(d),l)).map(E=>w.ChatFollowup.from(E,void 0))}}e.$tpc=s;class t{constructor(n,d,l,g,E){this.extension=n,this.id=d,this.w=l,this.x=g,this.y=E,this.m=new R.$le,this.n=new R.$le}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,d){return this.q?await this.q.provider.provideCompletionItems(n,d)??[]:[]}async provideFollowups(n,d,l){if(!this.b)return[];const g=await this.b.provideFollowups(n,d,l);return g?g.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(n,d){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(n,d);return l?l.map(g=>typeof g=="string"?g:w.MarkdownString.from(g)):[]}async provideSampleQuestions(n,d){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(n,d);return l||[]}get apiAgent(){let n=!1,d=!1;const l=()=>{n||d||(d=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof S.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof a.$IO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:w.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),d=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(E){g.c=E,l()},get requestHandler(){return g.y},set requestHandler(E){(0,I.$og)(typeof E=="function","Invalid request handler"),g.y=E},get followupProvider(){return g.b},set followupProvider(E){g.b=E,l()},get isDefault(){return(0,f.$fH)(g.extension,"defaultChatParticipant"),g.d},set isDefault(E){(0,f.$fH)(g.extension,"defaultChatParticipant"),g.d=E,l()},get helpTextPrefix(){return(0,f.$fH)(g.extension,"defaultChatParticipant"),g.g},set helpTextPrefix(E){(0,f.$fH)(g.extension,"defaultChatParticipant"),g.g=E,l()},get helpTextVariablesPrefix(){return(0,f.$fH)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(E){(0,f.$fH)(g.extension,"defaultChatParticipant"),g.j=E,l()},get helpTextPostfix(){return(0,f.$fH)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(E){(0,f.$fH)(g.extension,"defaultChatParticipant"),g.k=E,l()},get isSecondary(){return(0,f.$fH)(g.extension,"defaultChatParticipant"),g.l},set isSecondary(E){(0,f.$fH)(g.extension,"defaultChatParticipant"),g.l=E,l()},get supportIssueReporting(){return(0,f.$fH)(g.extension,"chatParticipantPrivate"),g.o},set supportIssueReporting(E){(0,f.$fH)(g.extension,"chatParticipantPrivate"),g.o=E,l()},get onDidReceiveFeedback(){return g.m.event},set participantVariableProvider(E){if((0,f.$fH)(g.extension,"chatParticipantAdditions"),g.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");g.w.$registerAgentCompletionsProvider(g.x,g.id,E.triggerCharacters)}else g.w.$unregisterAgentCompletionsProvider(g.x,g.id)},get participantVariableProvider(){return(0,f.$fH)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(E){(0,f.$fH)(g.extension,"defaultChatParticipant"),g.s=E,l()},get welcomeMessageProvider(){return(0,f.$fH)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,f.$eH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){g.t=E,l()},get requester(){return g.t},set supportsSlowReferences(E){(0,f.$fH)(g.extension,"chatParticipantPrivate"),g.u=E,l()},get supportsSlowReferences(){return(0,f.$fH)(g.extension,"chatParticipantPrivate"),g.u},dispose(){n=!0,g.b=void 0,g.m.dispose(),g.w.$unregisterAgent(g.x)}}}invoke(n,d,l,g){return this.y(n,d,l,g)}}}),define(ke[296],Ie([1,0,13,3,50,6,15,9,25]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=void 0,L=qe(L),T=qe(T);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$HN.MainThreadChatVariables)}async $resolveVariable(u,P,w,a){const m=this.b.get(u);if(m)try{if(m.resolver.resolve2){(0,b.$fH)(m.extension,"chatParticipantAdditions");const $=new I(P,this.c),f=await m.resolver.resolve2(m.data.name,{prompt:w},$.apiObject,a);if(f&&f[0])return f[0].value}else{const $=await m.resolver.resolve(m.data.name,{prompt:w},a);if($&&$[0])return $[0].value}}catch($){(0,r.$Z)($)}}registerVariableResolver(u,P,w,a,m,$,f,i,s){const t=c.a++,o=s?C.ThemeIcon.fromId(s):void 0;return this.b.set(t,{extension:u,data:{id:P,name:w,description:a,modelDescription:m,icon:o},resolver:f}),this.c.$registerVariable(t,{id:P,name:w,description:a,modelDescription:m,isSlow:$,fullName:i,icon:o}),(0,h.$Sc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$upc=c;class I{constructor(u,P){this.c=u,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(a){if(u.a){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,a),m}};const u=this,w=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){P(this.progress);const m=new T.$PP(a),$=L.ChatResponseProgressPart.from(m);return w($),this},reference(a){P(this.reference);const m=new T.$TP(a),$=L.ChatResponseReferencePart.from(m);return w($),this},push(a){return P(this.push),a instanceof T.$TP?w(L.ChatResponseReferencePart.from(a)):a instanceof T.$PP&&w(L.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(ke[297],Ie([1,0,7,59,4,3,40,2,87,23,15,9,6,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=w,b=qe(b),I=qe(I),S=qe(S);function w(a,m,$){const f=a.getProxy(u.$HN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$sn,m.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===L.MarshalledId.CommentController){const k=this.b.get(y.handle);return k?k.value:y}else if(y&&y.$mid===L.MarshalledId.CommentThread){const k=y,A=this.b.get(k.commentControlHandle);if(!A)return k;const p=A.getCommentThread(k.commentThreadHandle);return p?p.value:k}else if(y&&(y.$mid===L.MarshalledId.CommentThreadReply||y.$mid===L.MarshalledId.CommentThreadInstance)){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);return A?y.$mid===L.MarshalledId.CommentThreadInstance?A.value:{thread:A.value,text:y.text}:y}else if(y&&y.$mid===L.MarshalledId.CommentNode){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const p=y.commentUniqueId,v=A.getCommentByUniqueId(p);return v||y}else if(y&&y.$mid===L.MarshalledId.CommentThreadNode){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const p=y.text,v=y.commentUniqueId,F=A.getCommentByUniqueId(v);return F?(typeof F.body=="string"?F.body=p:F.body=new S.$bO(p),F):y}return y}})}createCommentController(y,k,A){const p=i.a++,v=new t(y,p,k,A);this.b.set(v.handle,v);const F=this.c.get(y.identifier)||[];return F.push(v),this.c.set(y.identifier,F),v.value}async $createCommentThreadTemplate(y,k,A,p){const v=this.b.get(y);v&&v.$createCommentThreadTemplate(k,A,p)}async $setActiveComment(y,k){const A=this.b.get(y);A&&A.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(y,k,A){const p=this.b.get(y);p&&p.$updateCommentThreadTemplate(k,A)}$deleteCommentThread(y,k){this.b.get(y)?.$deleteCommentThread(k)}async $provideCommentingRanges(y,k,A){const p=this.b.get(y);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const v=await $.ensureDocumentData(T.URI.revive(k));return(0,r.$wh)(async()=>{const F=await p.commentingRangeProvider.provideCommentingRanges(v.document,A);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(O=>I.Range.from(O)),fileComments:F.fileComments}),N})}$toggleReaction(y,k,A,p,v){const F=this.b.get(y);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,r.$wh)(()=>{const N=F.getCommentThread(k);if(N){const O=N.getCommentByUniqueId(p.uniqueIdInThread);if(F!==void 0&&O&&F.reactionHandler)return F.reactionHandler(O,d(v))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,P.$fH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,k,A,p,v,F,N,O,j){this.m=k,this.n=A,this.o=p,this.p=v,this.q=F,this.extensionDescription=N,this.r=O,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$le,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${y}.${this.handle}`),f.$createCommentThread(k,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(M=>o(this,M,this.k,this.extensionDescription)),N.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{f.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},reveal:(M,U)=>z.reveal(M,U),hide:()=>z.hide(),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const y=A=>Object.prototype.hasOwnProperty.call(this.b,A),k={};y("range")&&(k.range=I.Range.from(this.p)),y("label")&&(k.label=this.label),y("contextValue")&&(k.contextValue=this.contextValue??null),y("comments")&&(k.comments=this.q.map(A=>o(this,A,this.k,this.extensionDescription))),y("collapsibleState")&&(k.collapseState=l(this.g)),y("canReply")&&(k.canReply=this.canReply),y("state")&&(k.state=g(this.h)),y("applicability")&&(k.applicability=E(this.h)),y("isTemplate")&&(k.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(y){for(const k of this.k){const A=k[0],p=k[1];if(y===p)return A}}async reveal(y,k){(0,P.$fH)(this.extensionDescription,"commentReveal");let A;y&&y.body!==void 0?A=y:k=k??y;let p=A?this.k.get(A):void 0;p??=this.k.get(this.q[0]);let v=!0,F=!1;return k?.focus===S.CommentThreadFocus.Reply?(F=!0,v=!1):k?.focus===S.CommentThreadFocus.Comment&&(v=!1),f.$revealCommentThread(this.m,this.handle,p,{preserveFocus:v,focusReply:F})}async hide(){return f.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Je([(0,h.$0h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,P.$fH)(this.h,"commentingRangeHint"),f.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$fH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$fH)(this.h,"activeComment"),this.f}constructor(y,k,A,p){this.h=y,this.i=k,this.j=A,this.k=p,this.a=new Map,f.$registerCommentController(this.handle,A,p,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(F){v.options=F},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(F){v.commentingRangeProvider=F},get reactionHandler(){return v.reactionHandler},set reactionHandler(F){v.reactionHandler=F},get activeCommentThread(){return v.activeCommentThread},createCommentThread(F,N,O){return v.createCommentThread(F,N,O).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(y,k,A){k===void 0&&(0,P.$fH)(this.h,"fileComments");const p=new s(this.id,this.handle,void 0,y,k,A,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const k=this.a.get(y.commentThreadHandle);k&&(this.e=y.uniqueIdInThread?k.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(y,k,A){const p=new s(this.id,this.handle,void 0,T.URI.revive(y),I.Range.to(k),[],this.h,!0,A);return p.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(y,k){const A=this.a.get(y);A&&(A.range=I.Range.to(k))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function o(D,y,k,A){let p=k.get(y);return p||(p=++D.commentHandle,k.set(y,p)),y.state!==void 0&&(0,P.$fH)(A,"commentsDraftState"),y.reactions?.some(v=>v.reactors!==void 0)&&(0,P.$fH)(A,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:p,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(v=>n(v)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function n(D){return{label:D.label,iconPath:D.iconPath?I.$gQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function d(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function l(D){if(D!==void 0)switch(D){case S.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case S.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function g(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case S.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case S.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function E(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case S.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case S.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new i}}),define(ke[298],Ie([1,0,20,60,3,14,22,2,15,96,118,6,9]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0,b=qe(b),S=qe(S),u=qe(u);class P{constructor(n,d){this.document=n,this.b=d,this.a=1,this.c=new I.$epc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,d){await this.f(n).undo(),d||this.disposeBackup()}async redo(n,d){await this.f(n).redo(),d||this.disposeBackup()}disposeEdits(n){for(const d of n)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=t(this.document.uri)+this.a++;return(0,L.$fh)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const d=this.c.get(n,0);if(!d)throw new Error("No edit found");return d}}class w{constructor(){this.a=new Map}get(n,d){return this.a.get(this.b(n,d))}add(n,d,l){const g=this.b(n,d.uri);if(this.a.has(g))throw new Error(`Document already exists for viewType:${n} resource:${d.uri}`);const E=new P(d,l);return this.a.set(g,E),E}delete(n,d){const l=this.b(n,d.uri);this.a.delete(l)}b(n,d){return`${n}@@@${d}`}}var a;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(n,d,l){return this.b(n,{type:a.Text,extension:d,provider:l})}addCustomProvider(n,d,l){return this.b(n,{type:a.Custom,extension:d,provider:l})}get(n){return this.a.get(n)}b(n,d){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,d),new u.$JN(()=>this.a.delete(n))}}class ${constructor(n,d,l,g,E){this.d=d,this.f=l,this.g=g,this.h=E,this.b=new m,this.c=new w,this.a=n.getProxy(S.$HN.MainThreadCustomEditors)}registerCustomEditorProvider(n,d,l,g){const E=new C.$Tc;return i(l)?(E.add(this.b.addTextProvider(d,n,l)),this.a.$registerTextEditorProvider((0,c.$Npc)(n),d,g.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$Lpc)(n))):(E.add(this.b.addCustomProvider(d,n,l)),f(l)&&E.add(l.onDidChangeCustomDocument(D=>{const y=this.i(d,D.document.uri);if(s(D)){const k=y.addEdit(D);this.a.$onDidEdit(D.document.uri,d,k,D.label)}else this.a.$onContentChange(D.document.uri,d)})),this.a.$registerCustomEditorProvider((0,c.$Npc)(n),d,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,c.$Lpc)(n))),u.$JN.from(E,new u.$JN(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(n,d,l,g,E){const D=this.b.get(d);if(!D)throw new Error(`No provider found for '${d}'`);if(D.type!==a.Custom)throw new Error(`Invalid provide type for '${d}'`);const y=T.URI.revive(n),k=await D.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:g?.buffer},E);let A;return f(D.provider)&&this.f&&(A=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(d,k,A),{editable:f(D.provider)}}async $disposeCustomDocument(n,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==a.Custom)throw new Error(`Invalid provider type for '${d}'`);const g=T.URI.revive(n),{document:E}=this.i(d,g);this.c.delete(d,E),E.dispose()}async $resolveCustomEditor(n,d,l,g,E,D){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const k=b.ViewColumn.to(E),A=this.g.createNewWebview(d,g.contentOptions,y.extension),p=this.h.createNewWebviewPanel(d,l,g.title,k,g.options,A,g.active),v=T.URI.revive(n);switch(y.type){case a.Custom:{const{document:F}=this.i(l,v);return y.provider.resolveCustomEditor(F,p,D)}case a.Text:{const F=this.d.getDocument(v);return y.provider.resolveCustomTextEditor(F,p,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,d,l){this.i(d,n).disposeEdits(l)}async $onMoveCustomEditor(n,d,l){const g=this.b.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const E=this.h.getWebviewPanel(n);if(!E)throw new Error("No webview found");const D=T.URI.revive(d),y=this.d.getDocument(D);await g.provider.moveCustomTextEditor(y,E,r.CancellationToken.None)}async $undo(n,d,l,g){return this.i(d,n).undo(l,g)}async $redo(n,d,l,g){return this.i(d,n).redo(l,g)}async $revert(n,d,l){const g=this.i(d,n);await this.j(d).revertCustomDocument(g.document,l),g.disposeBackup()}async $onSave(n,d,l){const g=this.i(d,n);await this.j(d).saveCustomDocument(g.document,l),g.disposeBackup()}async $onSaveAs(n,d,l,g){const E=this.i(d,n);return this.j(d).saveCustomDocumentAs(E.document,T.URI.revive(l),g)}async $backup(n,d,l){const g=this.i(d,n),D=await this.j(d).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},l);return g.updateBackup(D),D.id}i(n,d){const l=this.c.get(n,T.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(n){const l=this.b.get(n)?.provider;if(!l||!f(l))throw new Error("Custom document is not editable");return l}}e.$Qpc=$;function f(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function s(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const n=o.scheme===R.Schemas.file||o.scheme===R.Schemas.untitled?o.fsPath:o.toString();return(0,h.$sj)(n)+""}}),define(ke[299],Ie([1,0,8,145,2,6,9,15,4,11,28,62]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$lpc=void 0,T=qe(T);class P{#e;#t;#i;constructor(m,$,f,i,s,t,o,n){this.d=m,this.e=$,this.f=f,this.g=i,this.h=s,this.c=!1,this.f=Math.max(i,f),this.#i=new I.$Ac(d=>t.getComparisonKey(d)),this.#e=o,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,$){if(!m){this.clear();return}this.j();let f=[];if(C.URI.isUri(m)){if(!$){this.delete(m);return}this.#i.set(m,$.slice()),f=[m]}else if(Array.isArray(m)){f=[];let t;m=[...m].sort(P.k);for(const o of m){const[n,d]=o;if((!t||n.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=n,f.push(n),this.#i.set(n,[])),d)this.#i.get(n)?.push(...d);else{const l=this.#i.get(n);l&&(l.length=0)}}}if(this.#t.fire(f),!this.#e)return;const i=[];let s=0;for(const t of f){let o=[];const n=this.#i.get(t);if(n)if(n.length>this.g){o=[];const d=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const g of n)if(g.severity===d[l]&&o.push({...T.Diagnostic.from(g),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(10791,null,n.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=n.map(d=>({...T.Diagnostic.from(d),modelVersionId:this.h(t)}));if(i.push([t,o]),s+=o.length,s>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,$){this.j();for(const[f,i]of this)m.call($,f,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const $=this.#i.get(m);return Array.isArray($)?Object.freeze($.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,$){return m[0].toString()<$[0].toString()?-1:m[0].toString()>$[0].toString()?1:0}}e.$lpc=P;let w=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(m){const $=new I.$Ac;for(const f of m)$.set(f,f);return{uris:Object.freeze(Array.from($.values()))}}constructor(m,$,f,i){this.j=$,this.k=f,this.l=i,this.g=new Map,this.h=new b.$pe({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,u._mapper),this.f=m.getProxy(R.$HN.MainThreadDiagnostics)}createDiagnosticCollection(m,$){const{g:f,f:i,h:s,j:t,k:o,l:n}=this,d=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,E)}dispose(){i.dispose()}};let l;if(!$)$="_generated_diagnostic_collection_name_#"+u.c++,l=$;else if(!f.has($))l=$;else{this.j.warn(`DiagnosticCollection with name '${$}' does already exist.`);do l=$+u.c++;while(f.has(l))}return new class extends P{constructor(){super($,l,u.e,u.d,E=>n.getDocument(E)?.version,o.extUri,d,s),f.set(l,this)}dispose(){super.dispose(),f.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const $=new Map,f=[];for(const i of this.g.values())i.forEach((s,t)=>{let o=$.get(s.toString());typeof o>"u"&&(o=f.length,$.set(s.toString(),o),f.push([s,[]])),f[o][1]=f[o][1].concat(...t)});return f}}m(m){let $=[];for(const f of this.g.values())f.has(m)&&($=$.concat(f.get(m)));return $}$acceptMarkersChange(m){if(!this.n){const $="_generated_mirror",f=new P($,$,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set($,f),this.n=f}for(const[$,f]of m)this.n.set(C.URI.revive($),f.map(T.Diagnostic.to))}};e.$mpc=w,e.$mpc=w=u=Je([Ve(1,c.$_j),Ve(2,S.$kpc)],w)}),define(ke[300],Ie([1,0,2,13,9,15,80,53]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;class b{constructor(I,S,u,P={timeout:1500,errors:3}){this.c=I,this.d=S,this.f=u,this.g=P,this.a=new L.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(S,u,P)=>{const a={dispose:this.a.push([S,u,I])};return Array.isArray(P)&&P.push(a),a}}async $participateInSave(I,S){const u=r.URI.revive(I);let P=!1;const w=setTimeout(()=>P=!0,this.g.timeout),a=[];try{for(const m of[...this.a]){if(P)break;const $=this.d.getDocument(u),f=await this.h(m,{document:$,reason:R.TextDocumentSaveReason.to(S)});a.push(f)}}finally{clearTimeout(w)}return a}h([I,S,u],P){const w=this.b.get(I);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(u,I,S,P).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this.b.get(I);this.b.set(I,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,S,u,P){const w=[],a=Date.now(),{document:m,reason:$}=P,{version:f}=m,i=Object.freeze({document:m,reason:$,waitUntil(s){if(Object.isFrozen(w))throw(0,h.$7)("waitUntil can not be called async");w.push(Promise.resolve(s))}});try{S.apply(u,[i])}catch(s){return Promise.reject(s)}return Object.freeze(w),new Promise((s,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(w).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(o),s(n)}).catch(n=>{clearTimeout(o),t(n)})}).then(s=>{const t={edits:[]};for(const o of s)if(Array.isArray(o)&&o.every(n=>n instanceof C.$SN))for(const{newText:n,newEol:d,range:l}of o)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:n,eol:d&&R.EndOfLine.from(d)}});if(t.edits.length!==0)return f===m.version?this.f.$tryApplyWorkspaceEdit(new T.$Ww(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$zqc=b}),define(ke[301],Ie([1,0,4,3,2,6,164,15,17,24,9]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=void 0,T=qe(T);class S{constructor(P,w){this.a=new r.$le,this.b=new r.$le,this.c=new r.$le,this.d=new r.$le,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Tc,this.h=new Map,this.f=P.getProxy(R.$HN.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const w=this.g.getDocument(P);if(w)return w}getDocument(P){const w=this.getDocumentData(P);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return w.document}ensureDocumentData(P){const w=this.g.getDocument(P);if(w)return Promise.resolve(w);let a=this.h.get(P.toString());return a||(a=this.f.$tryOpenDocument(P).then(m=>{this.h.delete(P.toString());const $=C.URI.revive(m);return(0,b.$pg)(this.g.getDocument($))},m=>(this.h.delete(P.toString()),Promise.reject(m))),this.h.set(P.toString(),a)),a}createDocumentData(P){return this.f.$tryCreateDocument(P).then(w=>C.URI.revive(w))}$acceptModelLanguageChanged(P,w){const a=C.URI.revive(P),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(w),this.a.fire(m.document)}$acceptModelSaved(P){const w=C.URI.revive(P),a=this.g.getDocument(w);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(P,w){const a=C.URI.revive(P),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(w),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,w,a){const m=C.URI.revive(P),$=this.g.getDocument(m);if(!$)throw new Error("unknown document");$._acceptIsDirty(a),$.onEvents(w);let f;w.isUndoing?f=I.TextDocumentChangeReason.Undo:w.isRedoing&&(f=I.TextDocumentChangeReason.Redo),this.c.fire((0,c.$eo)({document:$.document,contentChanges:w.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:f}))}setWordDefinitionFor(P,w){(0,L.$jQ)(P,w)}}e.$npc=S}),define(ke[77],Ie([1,0,78,4,17,2,5,6,19,15,9]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=e.$Rpc=void 0,c=qe(c),e.$Rpc=(0,L.$Ei)("IExtHostEditorTabs");class S{constructor(m,$,f){this.e=f,this.d=$,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze($)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new I.$xP(R.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new I.$yP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new I.$zP(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new I.$AP(R.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new I.$BP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new I.$CP(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new I.$DP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new I.$EP;case T.TabInputKind.InteractiveEditorInput:return new I.$FP(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new I.$GP;case T.TabInputKind.MultiDiffEditorInput:return new I.$HP(this.b.input.diffEditors.map(m=>new I.$yP(R.URI.revive(m.original),R.URI.revive(m.modified))));default:return}}}class u{constructor(m,$){this.c=[],this.d="",this.b=m,this.e=$;for(const f of m.tabs)f.isActive&&(this.d=f.id),this.c.push(new S(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return c.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(f=>f.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(f=>f.apiObject))}};this.a=Object.freeze($)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===T.TabModelOperationKind.TAB_OPEN){const f=new S(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,f),m.tabDto.isActive&&(this.d=f.tabId),f}else if(m.kind===T.TabModelOperationKind.TAB_CLOSE){const f=this.c.splice(m.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(m.kind===T.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(m.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,f),f}const $=this.c.find(f=>f.tabId===m.tabDto.id);if(!$)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),$.acceptDtoUpdate(m.tabDto),$}activeTabId(){return this.d}}let P=class{constructor(m){this.b=new h.$le,this.c=new h.$le,this.e=[],this.a=m.getProxy(T.$HN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,$={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(f=>f.apiObject))},get activeTabGroup(){const f=m.d;return(0,C.$pg)(m.e.find(s=>s.groupId===f)?.apiObject)},close:async(f,i)=>{const s=Array.isArray(f)?f:[f];return s.length?w(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze($)}return this.f}$acceptEditorTabModel(m){const $=new Set(this.e.map(d=>d.groupId)),f=new Set(m.map(d=>d.groupId)),i=(0,r.$d)($,f),s=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),t=[],o=[];this.e=m.map(d=>{const l=new u(d,()=>this.d);return i.added.includes(l.groupId)?t.push(l.apiObject):o.push(l.apiObject),l});const n=(0,C.$pg)(m.find(d=>d.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:t,closed:s,changed:o}))}$acceptTabGroupUpdate(m){const $=this.e.find(f=>f.groupId===m.groupId);if(!$)throw new Error("Update Group IPC call received before group creation.");$.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[$.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const $=this.e.find(i=>i.groupId===m.groupId);if(!$)throw new Error("Update Tabs IPC call received before group creation.");const f=$.acceptTabOperation(m);switch(m.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(m){for(const $ of this.e)for(const f of $.tabs)if(f.apiObject===m)return f}h(m){return this.e.find($=>$.apiObject===m)}async i(m,$){const f=[];for(const i of m){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");f.push(s.tabId)}return this.a.$closeTab(f,$)}async j(m,$){const f=[];for(const i of m){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");f.push(s.groupId)}return this.a.$closeGroup(f,$)}};e.$Spc=P,e.$Spc=P=Je([Ve(0,b.$hQ)],P);function w(a){return a.tabs!==void 0}}),define(ke[302],Ie([1,0,2,6,27,3,9,15,203,12,26,21,25,85]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0,C=qe(C),T=qe(T);class w{constructor(){this.a=[]}add($){this.b=void 0,this.a.push($)}delete($){const f=this.a.indexOf($);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const $=this.a.sort(),f=[];let i,s,t=b.State.LastKnownState,o=b.State.LastKnownState;for(const n of $){let d=i?(0,c.$Hf)(i,n):0;for(d===0?s=b.State.Start:s=o;d<n.length;d++)d+1===n.length?(t=o,o=b.State.BeforeColon):o+=1,f.push([s,n.toUpperCase().charCodeAt(d),o]),f.push([s,n.toLowerCase().charCodeAt(d),o]),s=o;i=n,o=t}f.push([b.State.BeforeColon,I.CharCode.Colon,b.State.AfterColon]),f.push([b.State.AfterColon,I.CharCode.Slash,b.State.End]),this.b=new b.$C4(f)}}provideDocumentLinks($){this.c();const f=[],i=b.$D4.computeLinks({getLineContent(s){return $.lineAt(s-1).text},getLineCount(){return $.lineCount}},this.b);for(const s of i){const t=T.DocumentLink.to(s);t.target&&f.push(t)}return f}}class a{constructor($,f){this.i=f,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=$.getProxy(h.$HN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider($,f,i,s={}){if(a.j(i),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider($,"*",this.b));const t=this.h++;this.b.add(f),this.d.add(f),this.c.set(t,i);let o=C.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(o+=C.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(o+=C.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=C.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$fH)($,"fsChunks"),o+=C.FileSystemProviderCapabilities.FileOpenReadWriteClose);let n;s.isReadonly&&(0,P.$5k)(s.isReadonly)&&s.isReadonly.value!==""&&(n={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(t,f,o,n).catch(l=>{console.error(`FAILED to register filesystem provider of ${$.identifier.value}-extension for the scheme ${f}`),console.error(l)});const d=i.onDidChangeFile(l=>{const g=[];for(const E of l){const{uri:D,type:y}=E;if(D.scheme!==f)continue;let k;switch(y){case L.FileChangeType.Changed:k=C.FileChangeType.UPDATED;break;case L.FileChangeType.Created:k=C.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:k=C.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:D,type:k})}this.a.$onFileSystemChange(t,g)});return(0,R.$Sc)(()=>{d.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(t),this.a.$unregisterProvider(t)})}static j($){if(!$)throw new Error("MISSING provider");if(typeof $.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof $.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof $.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof $.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof $.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof $.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof $.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof $.rename!="function")throw new Error("Provider does NOT implement rename")}static k($){const{type:f,ctime:i,mtime:s,size:t,permissions:o}=$;return{type:f,ctime:i,mtime:s,size:t,permissions:o}}$stat($,f){return Promise.resolve(this.l($).stat(r.URI.revive(f))).then(i=>a.k(i))}$readdir($,f){return Promise.resolve(this.l($).readDirectory(r.URI.revive(f)))}$readFile($,f){return Promise.resolve(this.l($).readFile(r.URI.revive(f))).then(i=>S.$Ne.wrap(i))}$writeFile($,f,i,s){return Promise.resolve(this.l($).writeFile(r.URI.revive(f),i.buffer,s))}$delete($,f,i){return Promise.resolve(this.l($).delete(r.URI.revive(f),i))}$rename($,f,i,s){return Promise.resolve(this.l($).rename(r.URI.revive(f),r.URI.revive(i),s))}$copy($,f,i,s){const t=this.l($);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive(f),r.URI.revive(i),s))}$mkdir($,f){return Promise.resolve(this.l($).createDirectory(r.URI.revive(f)))}$watch($,f,i,s){const t=this.l($).watch(r.URI.revive(i),s);this.f.set(f,t)}$unwatch($,f){const i=this.f.get(f);i&&(i.dispose(),this.f.delete(f))}$open($,f,i){const s=this.l($);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(r.URI.revive(f),i))}$close($,f){const i=this.l($);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(f))}$read($,f,i,s){const t=this.l($);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=S.$Ne.alloc(s);return Promise.resolve(t.read(f,i,o.buffer,0,s)).then(n=>o.slice(0,n))}$write($,f,i,s){const t=this.l($);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(f,i,s.buffer,0,s.byteLength))}l($){const f=this.c.get($);if(!f){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return f}}e.$Cqc=a}),define(ke[303],Ie([1,0,4,38,2,6,15,9,27,49]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0,L=qe(L);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,a,m,$,f,i){this.a=Math.random(),this.b=new r.$le,this.c=new r.$le,this.d=new r.$le,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const s=(0,h.$zk)(f),t=typeof f=="string",o=i?.correlate,n=$(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(o&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const l of d.created){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.b.fire(g)}if(!i?.ignoreChangeEvents)for(const l of d.changed){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.c.fire(g)}if(!i?.ignoreDeleteEvents)for(const l of d.deleted){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=T.$JN.from(this.i(w,m,f,i,i?.correlate),this.b,this.c,this.d,n)}i(w,a,m,$,f){const i=T.$JN.from();if(typeof m=="string"||$?.ignoreChangeEvents&&$?.ignoreCreateEvents&&$?.ignoreDeleteEvents)return i;const s=w.getProxy(R.$HN.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(h.$vk)||m.pattern.includes(h.$wk))&&(t=!0);let o;return f&&($?.ignoreChangeEvents||$?.ignoreCreateEvents||$?.ignoreDeleteEvents)&&(o=b.FileChangeFilter.UPDATED|b.FileChangeFilter.ADDED|b.FileChangeFilter.DELETED,$?.ignoreChangeEvents&&(o&=~b.FileChangeFilter.UPDATED),$?.ignoreCreateEvents&&(o&=~b.FileChangeFilter.ADDED),$?.ignoreDeleteEvents&&(o&=~b.FileChangeFilter.DELETED)),s.$watch(a.identifier.value,this.a,m.baseUri,{recursive:t,excludes:$?.excludes??[],filter:o},!!f),T.$JN.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class S{constructor(w){this.a=w,this.session=this.a.session,this.b=new c.$T(()=>this.a.created.map(C.URI.revive)),this.c=new c.$T(()=>this.a.changed.map(C.URI.revive)),this.d=new c.$T(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(w,a,m){this.j=w,this.k=a,this.l=m,this.a=new r.$le,this.b=new r.$le,this.c=new r.$le,this.d=new r.$le,this.g=new r.$ne,this.h=new r.$ne,this.i=new r.$ne,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,a,m,$){return new I(this.j,w,a,this.a.event,L.GlobPattern.from(m),$)}$onFileEvent(w){this.a.fire(new S(w))}$onDidRunFileOperation(w,a){switch(w){case b.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map(m=>({oldUri:C.URI.revive(m.source),newUri:C.URI.revive(m.target)}))}));break;case b.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map(m=>C.URI.revive(m.target))}));break;case b.FileOperation.CREATE:case b.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map(m=>C.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,a){return(m,$,f)=>{const i=function(t){m.call($,t)};return i.extension=w,a.event(i,void 0,f)}}async $onWillRunFileOperation(w,a,m,$){switch(w){case b.FileOperation.MOVE:return await this.n(this.g,{files:a.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))},m,$);case b.FileOperation.DELETE:return await this.n(this.i,{files:a.map(f=>C.URI.revive(f.target))},m,$);case b.FileOperation.CREATE:case b.FileOperation.COPY:return await this.n(this.h,{files:a.map(f=>C.URI.revive(f.target))},m,$)}}async n(w,a,m,$){const f=new Set,i=[];if(await w.fireAsync(a,$,async(t,o)=>{const n=Date.now(),d=await Promise.resolve(t);d instanceof T.$VN&&(i.push([o.extension,d]),f.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-n>m&&this.k.warn("SLOW file-participant",o.extension.identifier)}),$.isCancellationRequested||i.length===0)return;const s={edits:[]};for(const[,t]of i){const{edits:o}=L.WorkspaceEdit.from(t,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(o)}return{edit:s,extensionNames:Array.from(f)}}}e.$Dqc=u}),define(ke[304],Ie([1,0,18,7,20,13,132,3,24,42,12,17,2,30,196,87,142,8,23,15,9,25,118,6]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=void 0,a=qe(a),i=qe(i),n=qe(n);class d{constructor(W,H){this.d=W,this.e=H}async provideDocumentSymbols(W,H){const X=this.d.getDocument(W),Z=await this.e.provideDocumentSymbols(X,H);if(!(0,r.$Jb)(Z))return Z[0]instanceof s.$6N?Z.map(i.DocumentSymbol.from):d.f(Z)}static f(W){W=W.slice(0).sort((Z,de)=>{let ve=Z.location.range.start.compareTo(de.location.range.start);return ve===0&&(ve=de.location.range.end.compareTo(Z.location.range.end)),ve});const H=[],X=[];for(const Z of W){const de={name:Z.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Z.kind),tags:Z.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:i.Range.from(Z.location.range),selectionRange:i.Range.from(Z.location.range),children:[]};for(;;){if(X.length===0){X.push(de),H.push(de);break}const ve=X[X.length-1];if(P.$Nt.containsRange(ve.range,de.range)&&!P.$Nt.equalsRange(ve.range,de.range)){ve.children?.push(de),X.push(de);break}X.pop()}}return H}}class l{constructor(W,H,X,Z,de,ve){this.f=W,this.g=H,this.h=X,this.j=Z,this.k=de,this.l=ve,this.d=new o.$epc("CodeLens"),this.e=new Map}async provideCodeLenses(W,H){const X=this.f.getDocument(W),Z=await this.h.provideCodeLenses(X,H);if(!Z||H.isCancellationRequested)return;const de=this.d.add(Z),ve=new T.$Tc;this.e.set(de,ve);const Oe={cacheId:de,lenses:[]};for(let He=0;He<Z.length;He++)Oe.lenses.push({cacheId:[de,He],range:i.Range.from(Z[He].range),command:this.g.toInternal(Z[He].command,ve)});return Oe}async resolveCodeLens(W,H){const X=W.cacheId&&this.d.get(...W.cacheId);if(!X)return;let Z;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?Z=X:Z=await this.h.resolveCodeLens(X,H),Z||(Z=X),H.isCancellationRequested)return;const de=W.cacheId&&this.e.get(W.cacheId[0]);if(de){if(!Z.command){const ve=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ve),this.l.error(ve);return}return W.command=this.g.toInternal(Z.command,de),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function g(Ce){return Array.isArray(Ce)?Ce.map(i.DefinitionLink.from):Ce?[i.DefinitionLink.from(Ce)]:[]}class E{constructor(W,H){this.d=W,this.e=H}async provideDefinition(W,H,X){const Z=this.d.getDocument(W),de=i.Position.to(H),ve=await this.e.provideDefinition(Z,de,X);return g(ve)}}class D{constructor(W,H){this.d=W,this.e=H}async provideDeclaration(W,H,X){const Z=this.d.getDocument(W),de=i.Position.to(H),ve=await this.e.provideDeclaration(Z,de,X);return g(ve)}}class y{constructor(W,H){this.d=W,this.e=H}async provideImplementation(W,H,X){const Z=this.d.getDocument(W),de=i.Position.to(H),ve=await this.e.provideImplementation(Z,de,X);return g(ve)}}class k{constructor(W,H){this.d=W,this.e=H}async provideTypeDefinition(W,H,X){const Z=this.d.getDocument(W),de=i.Position.to(H),ve=await this.e.provideTypeDefinition(Z,de,X);return g(ve)}}class A{static{this.f=10}constructor(W,H){this.g=W,this.h=H,this.d=0,this.e=new Map}async provideHover(W,H,X,Z){const de=this.g.getDocument(W),ve=i.Position.to(H);let Oe;if(X&&X.verbosityRequest){const nt=X.verbosityRequest.previousHover.id,st=this.e.get(nt);if(!st)throw new Error(`Hover with id ${nt} not found`);const rt={verbosityDelta:X.verbosityRequest.verbosityDelta,previousHover:st};Oe=await this.h.provideHover(de,ve,Z,rt)}else Oe=await this.h.provideHover(de,ve,Z);if(!Oe||(0,r.$Jb)(Oe.contents))return;Oe.range||(Oe.range=de.getWordRangeAtPosition(ve)),Oe.range||(Oe.range=new s.$LN(ve,ve));const He=i.Hover.from(Oe),Ke=this.d;if(this.e.size===A.f){const nt=Math.min(...this.e.keys());this.e.delete(nt)}return this.e.set(Ke,Oe),this.d+=1,{...He,id:Ke}}releaseHover(W){this.e.delete(W)}}class p{constructor(W,H){this.d=W,this.e=H}async provideEvaluatableExpression(W,H,X){const Z=this.d.getDocument(W),de=i.Position.to(H),ve=await this.e.provideEvaluatableExpression(Z,de,X);if(ve)return i.EvaluatableExpression.from(ve)}}class v{constructor(W,H){this.d=W,this.e=H}async provideInlineValues(W,H,X,Z){const de=this.d.getDocument(W),ve=await this.e.provideInlineValues(de,i.Range.to(H),i.InlineValueContext.to(X),Z);if(Array.isArray(ve))return ve.map(Oe=>i.InlineValue.from(Oe))}}class F{constructor(W,H){this.d=W,this.e=H}async provideDocumentHighlights(W,H,X){const Z=this.d.getDocument(W),de=i.Position.to(H),ve=await this.e.provideDocumentHighlights(Z,de,X);if(Array.isArray(ve))return ve.map(i.DocumentHighlight.from)}}class N{constructor(W,H){this.d=W,this.e=H}async provideMultiDocumentHighlights(W,H,X,Z){const de=this.d.getDocument(W),ve=X.map(Ke=>this.d.getDocument(Ke)),Oe=i.Position.to(H),He=await this.e.provideMultiDocumentHighlights(de,Oe,ve,Z);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class O{constructor(W,H){this.d=W,this.e=H}async provideLinkedEditingRanges(W,H,X){const Z=this.d.getDocument(W),de=i.Position.to(H),ve=await this.e.provideLinkedEditingRanges(Z,de,X);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,r.$Gb)(ve.ranges.map(i.Range.from)),wordPattern:ve.wordPattern}}}class j{constructor(W,H){this.d=W,this.e=H}async provideReferences(W,H,X,Z){const de=this.d.getDocument(W),ve=i.Position.to(H),Oe=await this.e.provideReferences(de,ve,X,Z);if(Array.isArray(Oe))return Oe.map(i.location.from)}}class z{static{this.d=1e3}constructor(W,H,X,Z,de,ve,Oe){this.g=W,this.h=H,this.j=X,this.k=Z,this.l=de,this.m=ve,this.n=Oe,this.e=new o.$epc("CodeAction"),this.f=new Map}async provideCodeActions(W,H,X,Z){const de=this.g.getDocument(W),ve=w.$Pt.isISelection(H)?i.Selection.to(H):i.Range.to(H),Oe=[];for(const rt of this.j.getDiagnostics(W))if(ve.intersection(rt.range)&&Oe.push(rt)>z.d)break;const He={diagnostics:Oe,only:X.only?new s.$8N(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},Ke=await this.k.provideCodeActions(de,ve,He,Z);if(!(0,r.$Kb)(Ke)||Z.isCancellationRequested)return;const _e=this.e.add(Ke),nt=new T.$Tc;this.f.set(_e,nt);const st=[];for(let rt=0;rt<Ke.length;rt++){const at=Ke[rt];if(at)if(z.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,nt)});else{He.only&&(at.kind?He.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const gt=at.ranges??[];st.push({cacheId:[_e,rt],title:at.title,command:at.command&&this.h.toInternal(at.command,nt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$eH)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$eH)(this.m,"codeActionRanges")?(0,r.$Gb)(gt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:_e,actions:st}}async resolveCodeAction(W,H){const[X,Z]=W,de=this.e.get(X,Z);if(!de||z.o(de))return{};if(!this.k.resolveCodeAction)return{};const ve=await this.k.resolveCodeAction(de,H)??de;let Oe;ve.edit&&(Oe=i.WorkspaceEdit.from(ve.edit,void 0));let He;if(ve.command){const Ke=this.f.get(X);Ke&&(He=this.h.toInternal(ve.command,Ke))}return{edit:Oe,command:He}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}class M{constructor(W,H,X,Z,de){this.e=W,this.f=H,this.g=X,this.h=Z,this.j=de,this.d=new o.$epc("DocumentPasteEdit")}async prepareDocumentPaste(W,H,X,Z){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(W),ve=H.map(Ke=>i.Range.to(Ke)),Oe=i.DataTransfer.toDataTransfer(X,()=>{throw new R.$0});if(await this.g.prepareDocumentPaste(de,ve,Oe,Z),Z.isCancellationRequested)return;const He=Array.from(Oe).filter(([,Ke])=>!(Ke instanceof s.$BO));return i.DataTransfer.from(He)}async providePasteEdits(W,H,X,Z,de,ve){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(H),He=X.map(st=>i.Range.to(st)),Ke=i.DataTransfer.toDataTransfer(Z,async st=>(await this.e.$resolvePasteFileData(this.h,W,st)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,He,Ke,{only:de.only?new s.$GO(de.only):void 0,triggerKind:de.triggerKind},ve);if(!_e||ve.isCancellationRequested)return[];const nt=this.d.add(_e);return _e.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,$.localize)(10787,null,this.j.displayName||this.j.name),kind:st.kind,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolvePasteEdit(W,H){const[X,Z]=W,de=this.d.get(X,Z);if(!de||!this.g.resolveDocumentPasteEdit)return{};const ve=await this.g.resolveDocumentPasteEdit(de,H)??de;return{additionalEdit:ve.additionalEdit?i.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}releasePasteEdits(W){this.d.delete(W)}}class U{constructor(W,H){this.d=W,this.e=H}async provideDocumentFormattingEdits(W,H,X){const Z=this.d.getDocument(W),de=await this.e.provideDocumentFormattingEdits(Z,H,X);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class V{constructor(W,H){this.d=W,this.e=H}async provideDocumentRangeFormattingEdits(W,H,X,Z){const de=this.d.getDocument(W),ve=i.Range.to(H),Oe=await this.e.provideDocumentRangeFormattingEdits(de,ve,X,Z);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,H,X,Z){(0,S.$og)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(W),ve=H.map(i.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(de,ve,X,Z);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}}class ie{constructor(W,H){this.d=W,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,H,X,Z,de){const ve=this.d.getDocument(W),Oe=i.Position.to(H),He=await this.e.provideOnTypeFormattingEdits(ve,Oe,X,Z,de);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class B{constructor(W,H){this.e=W,this.f=H,this.d=new o.$epc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,H){const X=await this.e.provideWorkspaceSymbols(W,H);if(!(0,r.$Kb)(X))return{symbols:[]};const Z=this.d.add(X),de={cacheId:Z,symbols:[]};for(let ve=0;ve<X.length;ve++){const Oe=X[ve];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}de.symbols.push({...i.WorkspaceSymbol.from(Oe),cacheId:[Z,ve]})}return de}async resolveWorkspaceSymbol(W,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const X=this.d.get(...W.cacheId);if(X){const Z=await this.e.resolveWorkspaceSymbol(X,H);return Z&&(0,b.$go)(W,i.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class Y{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,H,X){this.d=W,this.e=H,this.f=X}async provideRenameEdits(W,H,X,Z){const de=this.d.getDocument(W),ve=i.Position.to(H);try{const Oe=await this.e.provideRenameEdits(de,ve,X,Z);return Oe?i.WorkspaceEdit.from(Oe):void 0}catch(Oe){const He=Y.g(Oe);return He?{rejectReason:He,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(W,H,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(W),de=i.Position.to(H);try{const ve=await this.e.prepareRename(Z,de,X);let Oe,He;if(s.$LN.isRange(ve)?(Oe=ve,He=Z.getText(ve)):(0,S.$gg)(ve)&&(Oe=ve.range,He=ve.placeholder),!Oe||!He)return;if(Oe.start.line>de.line||Oe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Oe),text:He}}catch(ve){const Oe=Y.g(ve);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(ve)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class J{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(W,H,X){this.e=W,this.f=H,this.g=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(W,H,X,Z){const de=this.e.getDocument(W),ve=i.Range.to(H);try{const Oe=J.d[X],He=await this.f.provideNewSymbolNames(de,ve,Oe,Z);return He?He.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Oe){this.g.error(J.h(Oe)??JSON.stringify(Oe,null,"	"));return}}static h(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class _{constructor(W,H){this.resultId=W,this.tokens=H}}class le{constructor(W,H){this.f=W,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,H,X){const Z=this.f.getDocument(W),de=H!==0?this.d.get(H):null;let ve=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,de.resultId,X):await this.g.provideDocumentSemanticTokens(Z,X);return de&&this.d.delete(H),ve?(ve=le.h(ve),this.o(le.n(de,ve),ve)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return le.j(W)?le.k(W)?W:new s.$7O(new Uint32Array(W.data),W.resultId):le.l(W)?le.m(W)?W:new s.$9O(W.edits.map(H=>new s.$8O(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const H of W.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(W,H){if(!le.j(H)||!W||!W.tokens)return H;const X=W.tokens,Z=X.length,de=H.data,ve=de.length;let Oe=0;const He=Math.min(Z,ve);for(;Oe<He&&X[Oe]===de[Oe];)Oe++;if(Oe===Z&&Oe===ve)return new s.$9O([],H.resultId);let Ke=0;const _e=He-Oe;for(;Ke<_e&&X[Z-Ke-1]===de[ve-Ke-1];)Ke++;return new s.$9O([{start:Oe,deleteCount:Z-Oe-Ke,data:de.subarray(Oe,ve-Ke)}],H.resultId)}o(W,H){if(le.j(W)){const X=this.e++;return this.d.set(X,new _(W.resultId,W.data)),(0,m.$Udb)({id:X,type:"full",data:W.data})}if(le.l(W)){const X=this.e++;return le.j(H)?this.d.set(X,new _(H.resultId,H.data)):this.d.set(X,new _(W.resultId)),(0,m.$Udb)({id:X,type:"delta",deltas:(W.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class re{constructor(W,H){this.d=W,this.e=H}async provideDocumentRangeSemanticTokens(W,H,X){const Z=this.d.getDocument(W),de=await this.e.provideDocumentRangeSemanticTokens(Z,i.Range.to(H),X);return de?this.f(de):null}f(W){return(0,m.$Udb)({id:0,type:"full",data:W.data})}}class Se{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,H,X,Z,de){this.f=W,this.g=H,this.h=X,this.j=Z,this.k=de,this.d=new o.$epc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,H,X,Z){const de=this.f.getDocument(W),ve=i.Position.to(H),Oe=de.getWordRangeAtPosition(ve)||new s.$LN(ve,ve),He=Oe.with({end:ve}),Ke=new c.$fe,_e=await this.h.provideCompletionItems(de,ve,Z,i.CompletionContext.to(X));if(!_e||Z.isCancellationRequested)return;const nt=Array.isArray(_e)?new s.$iO(_e):_e,st=Se.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),rt=new T.$Tc;this.e.set(st,rt);const at=[],gt={x:st,[n.ISuggestResultDtoField.completions]:at,[n.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Oe),insert:i.Range.from(He)},[n.ISuggestResultDtoField.isIncomplete]:nt.isIncomplete||void 0,[n.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ht=0;ht<nt.items.length;ht++){const ct=nt.items[ht],Pe=this.l(ct,[st,ht],He,Oe);at.push(Pe)}return gt}async resolveCompletionItem(W,H){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...W);if(!X)return;const Z=this.l(X,W),de=await this.h.resolveCompletionItem(X,H);if(!de)return;const ve=this.l(de,W);return(Z[n.ISuggestDataDtoField.insertText]!==ve[n.ISuggestDataDtoField.insertText]||Z[n.ISuggestDataDtoField.insertTextRules]!==ve[n.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Z[n.ISuggestDataDtoField.commandIdent]!==ve[n.ISuggestDataDtoField.commandIdent]||Z[n.ISuggestDataDtoField.commandId]!==ve[n.ISuggestDataDtoField.commandId]||!(0,b.$ho)(Z[n.ISuggestDataDtoField.commandArguments],ve[n.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Z,[n.ISuggestDataDtoField.documentation]:ve[n.ISuggestDataDtoField.documentation],[n.ISuggestDataDtoField.detail]:ve[n.ISuggestDataDtoField.detail],[n.ISuggestDataDtoField.additionalTextEdits]:ve[n.ISuggestDataDtoField.additionalTextEdits],[n.ISuggestDataDtoField.insertText]:ve[n.ISuggestDataDtoField.insertText],[n.ISuggestDataDtoField.insertTextRules]:ve[n.ISuggestDataDtoField.insertTextRules],[n.ISuggestDataDtoField.commandIdent]:ve[n.ISuggestDataDtoField.commandIdent],[n.ISuggestDataDtoField.commandId]:ve[n.ISuggestDataDtoField.commandId],[n.ISuggestDataDtoField.commandArguments]:ve[n.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,H,X,Z){const de=this.e.get(H[0]);if(!de)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(W.command,de),Oe={x:H,[n.ISuggestDataDtoField.label]:W.label,[n.ISuggestDataDtoField.kind]:W.kind!==void 0?i.CompletionItemKind.from(W.kind):void 0,[n.ISuggestDataDtoField.kindModifier]:W.tags&&W.tags.map(i.CompletionItemTag.from),[n.ISuggestDataDtoField.detail]:W.detail,[n.ISuggestDataDtoField.documentation]:typeof W.documentation>"u"?void 0:i.MarkdownString.fromStrict(W.documentation),[n.ISuggestDataDtoField.sortText]:W.sortText!==W.label?W.sortText:void 0,[n.ISuggestDataDtoField.filterText]:W.filterText!==W.label?W.filterText:void 0,[n.ISuggestDataDtoField.preselect]:W.preselect||void 0,[n.ISuggestDataDtoField.insertTextRules]:W.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[n.ISuggestDataDtoField.commitCharacters]:W.commitCharacters?.join(""),[n.ISuggestDataDtoField.additionalTextEdits]:W.additionalTextEdits&&W.additionalTextEdits.map(i.TextEdit.from),[n.ISuggestDataDtoField.commandIdent]:ve?.$ident,[n.ISuggestDataDtoField.commandId]:ve?.id,[n.ISuggestDataDtoField.commandArguments]:ve?.$ident?void 0:ve?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe[n.ISuggestDataDtoField.insertText]=W.textEdit.newText):typeof W.insertText=="string"?Oe[n.ISuggestDataDtoField.insertText]=W.insertText:W.insertText instanceof s.$WN&&(Oe[n.ISuggestDataDtoField.insertText]=W.insertText.value,Oe[n.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let He;return W.textEdit?He=W.textEdit.range:W.range&&(He=W.range),s.$LN.isRange(He)?Oe[n.ISuggestDataDtoField.range]=i.Range.from(He):He&&(!X?.isEqual(He.inserting)||!Z?.isEqual(He.replacing))&&(Oe[n.ISuggestDataDtoField.range]={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Oe}}class me{async provideInlineCompletions(W,H,X,Z){}async provideInlineEdits(W,H,X,Z){}disposeCompletions(W){}handleDidShowCompletionItem(W,H,X){}handlePartialAccept(W,H,X,Z){}}class Q extends me{constructor(W,H,X,Z){super(),this.f=W,this.g=H,this.h=X,this.j=Z,this.d=new se,this.e=(0,t.$eH)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$eH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,H,X,Z){const de=this.g.getDocument(W),ve=i.Position.to(H),Oe=await this.h.provideInlineCompletionItems(de,ve,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Z);if(!Oe||Z.isCancellationRequested)return;const He=Array.isArray(Oe)?Oe:Oe.items,Ke=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new T.$Tc),gt=this.j.toInternal(rt.command,nt));const ht=rt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(nt||(nt=new T.$Tc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(W,H,X,Z){if(!this.h.provideInlineEdits)return;(0,t.$fH)(this.f,"inlineCompletionsAdditions");const de=this.g.getDocument(W),ve=i.Range.to(H),Oe=await this.h.provideInlineEdits(de,ve,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind],userPrompt:X.userPrompt},Z);if(!Oe||Z.isCancellationRequested)return;const He=Array.isArray(Oe)?Oe:Oe.items,Ke=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new T.$Tc),gt=this.j.toInternal(rt.command,nt));const ht=rt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(nt||(nt=new T.$Tc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,H,X){const Z=this.d.get(W)?.items[H];Z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Z,X)}handlePartialAccept(W,H,X,Z){const de=this.d.get(W)?.items[H];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,X),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(Z)))}}class q{async provideInlineEdits(W,H,X){const Z=this.f.getDocument(W),de=await this.g.provideInlineEdit(Z,{triggerKind:this.e[H.triggerKind]},X);if(!de||X.isCancellationRequested)return;let ve;const Oe=this.d.createReferenceId({dispose(){ve?.dispose()},item:de});let He;de.accepted&&(ve||(ve=new T.$Tc),He=this.h.toInternal(de.accepted,ve));let Ke;return de.rejected&&(ve||(ve=new T.$Tc),Ke=this.h.toInternal(de.rejected,ve)),{pid:Oe,text:de.text,range:i.Range.from(de.range),accepted:He,rejected:Ke}}disposeEdit(W){this.d.disposeReferenceId(W)?.dispose()}constructor(W,H,X,Z){this.f=H,this.g=X,this.h=Z,this.d=new se,this.e={[a.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const H=this.e++;return this.d.set(H,W),H}disposeReferenceId(W){const H=this.d.get(W);return this.d.delete(W),H}get(W){return this.d.get(W)}}class we{constructor(W,H){this.e=W,this.f=H,this.d=new o.$epc("SignatureHelp")}async provideSignatureHelp(W,H,X,Z){const de=this.e.getDocument(W),ve=i.Position.to(H),Oe=this.g(X),He=await this.f.provideSignatureHelp(de,ve,Z,Oe);if(He){const Ke=this.d.add([He]);return{...i.SignatureHelp.from(He),id:Ke}}}g(W){let H;if(W.activeSignatureHelp){const X=i.SignatureHelp.to(W.activeSignatureHelp),Z=this.d.get(W.activeSignatureHelp.id,0);Z?(H=Z,H.activeSignature=X.activeSignature,H.activeParameter=X.activeParameter):H=X}return{...W,activeSignatureHelp:H}}releaseSignatureHelp(W){this.d.delete(W)}}class ee{constructor(W,H,X,Z,de){this.f=W,this.g=H,this.h=X,this.j=Z,this.k=de,this.d=new o.$epc("InlayHints"),this.e=new Map}async provideInlayHints(W,H,X){const Z=this.f.getDocument(W),de=i.Range.to(H),ve=await this.h.provideInlayHints(Z,de,X);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`);return}if(X.isCancellationRequested)return;const Oe=this.d.add(ve);this.e.set(Oe,new T.$Tc);const He={hints:[],cacheId:Oe};for(let Ke=0;Ke<ve.length;Ke++)this.l(ve[Ke],de)&&He.hints.push(this.m(ve[Ke],[Oe,Ke]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`),He}async resolveInlayHint(W,H){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...W);if(!X)return;const Z=await this.h.resolveInlayHint(X,H);if(Z&&this.l(Z))return this.m(Z,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,H){return W.label.length===0||Array.isArray(W.label)&&W.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(H&&!H.contains(W.position))}m(W,H){const X=this.e.get(H[0]);if(!X)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:H,tooltip:i.MarkdownString.fromStrict(W.tooltip),position:i.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(i.TextEdit.from),kind:W.kind&&i.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")Z.label=W.label;else{const de=[];Z.label=de;for(const ve of W.label){if(!ve.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:ve.value,tooltip:i.MarkdownString.fromStrict(ve.tooltip)};s.$XN.isLocation(ve.location)&&(Oe.location=i.location.from(ve.location)),ve.command&&(Oe.command=this.g.toInternal(ve.command,X)),de.push(Oe)}}return Z}}class ae{constructor(W,H){this.e=W,this.f=H,this.d=new o.$epc("DocumentLink")}async provideLinks(W,H){const X=this.e.getDocument(W),Z=await this.f.provideDocumentLinks(X,H);if(!(!Array.isArray(Z)||Z.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(ae.g).map(i.DocumentLink.from)};{const de=this.d.add(Z),ve={links:[],cacheId:de};for(let Oe=0;Oe<Z.length;Oe++){if(!ae.g(Z[Oe]))continue;const He=i.DocumentLink.from(Z[Oe]);He.cacheId=[de,Oe],ve.links.push(He)}return ve}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,H){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...W);if(!X)return;const Z=await this.f.resolveDocumentLink(X,H);if(!(!Z||!ae.g(Z)))return i.DocumentLink.from(Z)}releaseLinks(W){this.d.delete(W)}}class oe{constructor(W,H){this.d=W,this.e=H}async provideColors(W,H){const X=this.d.getDocument(W),Z=await this.e.provideDocumentColors(X,H);return Array.isArray(Z)?Z.map(ve=>({color:i.Color.from(ve.color),range:i.Range.from(ve.range)})):[]}async provideColorPresentations(W,H,X){const Z=this.d.getDocument(W),de=i.Range.to(H.range),ve=i.Color.to(H.color),Oe=await this.e.provideColorPresentations(ve,{document:Z,range:de},X);if(Array.isArray(Oe))return Oe.map(i.ColorPresentation.from)}}class x{constructor(W,H){this.d=W,this.e=H}async provideFoldingRanges(W,H,X){const Z=this.d.getDocument(W),de=await this.e.provideFoldingRanges(Z,H,X);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class ne{constructor(W,H,X){this.d=W,this.e=H,this.f=X}async provideSelectionRanges(W,H,X){const Z=this.d.getDocument(W),de=H.map(i.Position.to),ve=await this.e.provideSelectionRanges(Z,de,X);if(!(0,r.$Kb)(ve))return[];if(ve.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let He=0;He<de.length;He++){const Ke=[];Oe.push(Ke);let _e=de[He],nt=ve[He];for(;;){if(!nt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(nt)),!nt.parent)break;_e=nt.range,nt=nt.parent}}return Oe}}class pe{constructor(W,H){this.f=W,this.g=H,this.d=new L.$mQ(""),this.e=new Map}async prepareSession(W,H,X){const Z=this.f.getDocument(W),de=i.Position.to(H),ve=await this.g.prepareCallHierarchy(Z,de,X);if(!ve)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ve)?ve.map(He=>this.h(Oe,He)):[this.h(Oe,ve)]}async provideCallsTo(W,H,X){const Z=this.j(W,H);if(!Z)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Z,X);if(de)return de.map(ve=>({from:this.h(W,ve.from),fromRanges:ve.fromRanges.map(Oe=>i.Range.from(Oe))}))}async provideCallsFrom(W,H,X){const Z=this.j(W,H);if(!Z)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Z,X);if(de)return de.map(ve=>({to:this.h(W,ve.to),fromRanges:ve.fromRanges.map(Oe=>i.Range.from(Oe))}))}releaseSession(W){this.e.delete(W)}h(W,H){const X=this.e.get(W),Z=i.CallHierarchyItem.from(H,W,X.size.toString(36));return X.set(Z._itemId,H),Z}j(W,H){return this.e.get(W)?.get(H)}}class be{constructor(W,H){this.f=W,this.g=H,this.d=new L.$mQ(""),this.e=new Map}async prepareSession(W,H,X){const Z=this.f.getDocument(W),de=i.Position.to(H),ve=await this.g.prepareTypeHierarchy(Z,de,X);if(!ve)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ve)?ve.map(He=>this.h(Oe,He)):[this.h(Oe,ve)]}async provideSupertypes(W,H,X){const Z=this.j(W,H);if(!Z)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Z,X);if(de)return de.map(ve=>this.h(W,ve))}async provideSubtypes(W,H,X){const Z=this.j(W,H);if(!Z)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Z,X);if(de)return de.map(ve=>this.h(W,ve))}releaseSession(W){this.e.delete(W)}h(W,H){const X=this.e.get(W),Z=i.TypeHierarchyItem.from(H,W,X.size.toString(36));return X.set(Z._itemId,H),Z}j(W,H){return this.e.get(W)?.get(H)}}class Fe{constructor(W,H,X,Z,de){this.e=W,this.f=H,this.g=X,this.h=Z,this.j=de,this.d=new o.$epc("DocumentDropEdit")}async provideDocumentOnDropEdits(W,H,X,Z,de){const ve=this.f.getDocument(H),Oe=i.Position.to(X),He=i.DataTransfer.toDataTransfer(Z,async st=>(await this.e.$resolveDocumentOnDropFileData(this.h,W,st)).buffer),Ke=await this.g.provideDocumentDropEdits(ve,Oe,He,de);if(!Ke)return;const _e=(0,r.$1b)(Ke),nt=this.d.add(_e);return _e.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,$.localize)(10788,null,this.j.displayName||this.j.name),kind:st.kind?.value,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolveDropEdit(W,H){const[X,Z]=W,de=this.d.get(X,Z);if(!de||!this.g.resolveDocumentDropEdit)return{};const ve=await this.g.resolveDocumentDropEdit(de,H)??de;return{additionalEdit:ve.additionalEdit?i.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}releaseDropEdits(W){this.d.delete(W)}}class ze{constructor(W,H){this.d=W,this.e=H}async provideMappedEdits(W,H,X,Z){const de=u.URI.revive(W),ve=this.d.getDocument(de),Oe=X.documents.map(_e=>_e.map(nt=>({uri:u.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(st=>i.Range.to(st))}))),He={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(ve,H,He,Z);return Ke?i.WorkspaceEdit.from(Ke):null}}class Ae{constructor(W,H){this.adapter=W,this.extension=H}}class De{static{this.d=0}constructor(W,H,X,Z,de,ve,Oe,He){this.g=H,this.h=X,this.j=Z,this.k=de,this.l=ve,this.m=Oe,this.n=He,this.f=new Map,this.e=W.getProxy(n.$HN.MainThreadLanguageFeatures)}o(W,H){return i.DocumentSelector.from(W,this.g,H)}p(W){return new s.$JN(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return De.d++}async s(W,H,X,Z,de,ve=!1){const Oe=this.f.get(W);if(!Oe||!(Oe.adapter instanceof H))return Z;const He=Date.now();ve||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Ke=X(Oe.adapter,Oe.extension);return Promise.resolve(Ke).catch(_e=>{(0,R.$3)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{ve||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),C.CancellationToken.isCancellationToken(de)?(0,h.$th)(Ke,de):Ke}t(W,H){const X=this.q();return this.f.set(X,new Ae(W,H)),X}static u(W){return W.displayName||W.name}static w(W){return W.identifier.value}registerDocumentSymbolProvider(W,H,X,Z){const de=this.t(new d(this.h,X),W),ve=Z&&Z.label||De.u(W);return this.e.$registerDocumentSymbolProvider(de,this.o(H,W),ve),this.p(de)}$provideDocumentSymbols(W,H,X){return this.s(W,d,Z=>Z.provideDocumentSymbols(u.URI.revive(H),X),void 0,X)}registerCodeLensProvider(W,H,X){const Z=this.q(),de=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new Ae(new l(this.h,this.j.converter,X,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(Z,this.o(H,W),de);let ve=this.p(Z);if(de!==void 0){const Oe=X.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(de));ve=s.$JN.from(ve,Oe)}return ve}$provideCodeLenses(W,H,X){return this.s(W,l,Z=>Z.provideCodeLenses(u.URI.revive(H),X),void 0,X)}$resolveCodeLens(W,H,X){return this.s(W,l,Z=>Z.resolveCodeLens(H,X),void 0,void 0)}$releaseCodeLenses(W,H){this.s(W,l,X=>Promise.resolve(X.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(W,H,X){const Z=this.t(new E(this.h,X),W);return this.e.$registerDefinitionSupport(Z,this.o(H,W)),this.p(Z)}$provideDefinition(W,H,X,Z){return this.s(W,E,de=>de.provideDefinition(u.URI.revive(H),X,Z),[],Z)}registerDeclarationProvider(W,H,X){const Z=this.t(new D(this.h,X),W);return this.e.$registerDeclarationSupport(Z,this.o(H,W)),this.p(Z)}$provideDeclaration(W,H,X,Z){return this.s(W,D,de=>de.provideDeclaration(u.URI.revive(H),X,Z),[],Z)}registerImplementationProvider(W,H,X){const Z=this.t(new y(this.h,X),W);return this.e.$registerImplementationSupport(Z,this.o(H,W)),this.p(Z)}$provideImplementation(W,H,X,Z){return this.s(W,y,de=>de.provideImplementation(u.URI.revive(H),X,Z),[],Z)}registerTypeDefinitionProvider(W,H,X){const Z=this.t(new k(this.h,X),W);return this.e.$registerTypeDefinitionSupport(Z,this.o(H,W)),this.p(Z)}$provideTypeDefinition(W,H,X,Z){return this.s(W,k,de=>de.provideTypeDefinition(u.URI.revive(H),X,Z),[],Z)}registerHoverProvider(W,H,X,Z){const de=this.t(new A(this.h,X),W);return this.e.$registerHoverProvider(de,this.o(H,W)),this.p(de)}$provideHover(W,H,X,Z,de){return this.s(W,A,ve=>ve.provideHover(u.URI.revive(H),X,Z,de),void 0,de)}$releaseHover(W,H){this.s(W,A,X=>Promise.resolve(X.releaseHover(H)),void 0,void 0)}registerEvaluatableExpressionProvider(W,H,X,Z){const de=this.t(new p(this.h,X),W);return this.e.$registerEvaluatableExpressionProvider(de,this.o(H,W)),this.p(de)}$provideEvaluatableExpression(W,H,X,Z){return this.s(W,p,de=>de.provideEvaluatableExpression(u.URI.revive(H),X,Z),void 0,Z)}registerInlineValuesProvider(W,H,X,Z){const de=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new v(this.h,X),W);this.e.$registerInlineValuesProvider(ve,this.o(H,W),de);let Oe=this.p(ve);if(de!==void 0){const He=X.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(de));Oe=s.$JN.from(Oe,He)}return Oe}$provideInlineValues(W,H,X,Z,de){return this.s(W,v,ve=>ve.provideInlineValues(u.URI.revive(H),X,Z,de),void 0,de)}registerDocumentHighlightProvider(W,H,X){const Z=this.t(new F(this.h,X),W);return this.e.$registerDocumentHighlightProvider(Z,this.o(H,W)),this.p(Z)}registerMultiDocumentHighlightProvider(W,H,X){const Z=this.t(new N(this.h,X),W);return this.e.$registerMultiDocumentHighlightProvider(Z,this.o(H,W)),this.p(Z)}$provideDocumentHighlights(W,H,X,Z){return this.s(W,F,de=>de.provideDocumentHighlights(u.URI.revive(H),X,Z),void 0,Z)}$provideMultiDocumentHighlights(W,H,X,Z,de){return this.s(W,N,ve=>ve.provideMultiDocumentHighlights(u.URI.revive(H),X,Z.map(Oe=>u.URI.revive(Oe)),de),void 0,de)}registerLinkedEditingRangeProvider(W,H,X){const Z=this.t(new O(this.h,X),W);return this.e.$registerLinkedEditingRangeProvider(Z,this.o(H,W)),this.p(Z)}$provideLinkedEditingRanges(W,H,X,Z){return this.s(W,O,async de=>{const ve=await de.provideLinkedEditingRanges(u.URI.revive(H),X,Z);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?De.y(ve.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(W,H,X){const Z=this.t(new j(this.h,X),W);return this.e.$registerReferenceSupport(Z,this.o(H,W)),this.p(Z)}$provideReferences(W,H,X,Z,de){return this.s(W,j,ve=>ve.provideReferences(u.URI.revive(H),X,Z,de),void 0,de)}registerCodeActionProvider(W,H,X,Z){const de=new T.$Tc,ve=this.t(new z(this.h,this.j.converter,this.k,X,this.l,W,this.m),W);return this.e.$registerCodeActionSupport(ve,this.o(H,W),{providedKinds:Z?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:Z?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,de)}))},De.u(W),De.w(W),!!X.resolveCodeAction),de.add(this.p(ve)),de}$provideCodeActions(W,H,X,Z,de){return this.s(W,z,ve=>ve.provideCodeActions(u.URI.revive(H),X,Z,de),void 0,de)}$resolveCodeAction(W,H,X){return this.s(W,z,Z=>Z.resolveCodeAction(H,X),{},void 0)}$releaseCodeActions(W,H){this.s(W,z,X=>Promise.resolve(X.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(W,H,X){const Z=this.t(new U(this.h,X),W);return this.e.$registerDocumentFormattingSupport(Z,this.o(H,W),W.identifier,W.displayName||W.name),this.p(Z)}$provideDocumentFormattingEdits(W,H,X,Z){return this.s(W,U,de=>de.provideDocumentFormattingEdits(u.URI.revive(H),X,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(W,H,X){const Z=typeof X.provideDocumentRangesFormattingEdits=="function",de=this.t(new V(this.h,X),W);return this.e.$registerRangeFormattingSupport(de,this.o(H,W),W.identifier,W.displayName||W.name,Z),this.p(de)}$provideDocumentRangeFormattingEdits(W,H,X,Z,de){return this.s(W,V,ve=>ve.provideDocumentRangeFormattingEdits(u.URI.revive(H),X,Z,de),void 0,de)}$provideDocumentRangesFormattingEdits(W,H,X,Z,de){return this.s(W,V,ve=>ve.provideDocumentRangesFormattingEdits(u.URI.revive(H),X,Z,de),void 0,de)}registerOnTypeFormattingEditProvider(W,H,X,Z){const de=this.t(new ie(this.h,X),W);return this.e.$registerOnTypeFormattingSupport(de,this.o(H,W),Z,W.identifier),this.p(de)}$provideOnTypeFormattingEdits(W,H,X,Z,de,ve){return this.s(W,ie,Oe=>Oe.provideOnTypeFormattingEdits(u.URI.revive(H),X,Z,de,ve),void 0,ve)}registerWorkspaceSymbolProvider(W,H){const X=this.t(new B(H,this.l),W);return this.e.$registerNavigateTypeSupport(X,typeof H.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(W,H,X){return this.s(W,B,Z=>Z.provideWorkspaceSymbols(H,X),{symbols:[]},X)}$resolveWorkspaceSymbol(W,H,X){return this.s(W,B,Z=>Z.resolveWorkspaceSymbol(H,X),void 0,void 0)}$releaseWorkspaceSymbols(W,H){this.s(W,B,X=>X.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(W,H,X){const Z=this.t(new Y(this.h,X,this.l),W);return this.e.$registerRenameSupport(Z,this.o(H,W),Y.supportsResolving(X)),this.p(Z)}$provideRenameEdits(W,H,X,Z,de){return this.s(W,Y,ve=>ve.provideRenameEdits(u.URI.revive(H),X,Z,de),void 0,de)}$resolveRenameLocation(W,H,X,Z){return this.s(W,Y,de=>de.resolveRenameLocation(u.URI.revive(H),X,Z),void 0,Z)}registerNewSymbolNamesProvider(W,H,X){const Z=this.t(new J(this.h,X,this.l),W);return this.e.$registerNewSymbolNamesProvider(Z,this.o(H,W)),this.p(Z)}$supportsAutomaticNewSymbolNamesTriggerKind(W){return this.s(W,J,H=>H.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(W,H,X,Z,de){return this.s(W,J,ve=>ve.provideNewSymbolNames(u.URI.revive(H),X,Z,de),void 0,de)}registerDocumentSemanticTokensProvider(W,H,X,Z){const de=this.t(new le(this.h,X),W),ve=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(H,W),Z,ve);let Oe=this.p(de);if(ve){const He=X.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(ve));Oe=s.$JN.from(Oe,He)}return Oe}$provideDocumentSemanticTokens(W,H,X,Z){return this.s(W,le,de=>de.provideDocumentSemanticTokens(u.URI.revive(H),X,Z),null,Z)}$releaseDocumentSemanticTokens(W,H){this.s(W,le,X=>X.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,H,X,Z){const de=this.t(new re(this.h,X),W);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(H,W),Z),this.p(de)}$provideDocumentRangeSemanticTokens(W,H,X,Z){return this.s(W,re,de=>de.provideDocumentRangeSemanticTokens(u.URI.revive(H),X,Z),null,Z)}registerCompletionItemProvider(W,H,X,Z){const de=this.t(new Se(this.h,this.j.converter,X,this.m,W),W);return this.e.$registerCompletionsProvider(de,this.o(H,W),Z,Se.supportsResolving(X),W.identifier),this.p(de)}$provideCompletionItems(W,H,X,Z,de){return this.s(W,Se,ve=>ve.provideCompletionItems(u.URI.revive(H),X,Z,de),void 0,de)}$resolveCompletionItem(W,H,X){return this.s(W,Se,Z=>Z.resolveCompletionItem(H,X),void 0,X)}$releaseCompletionItems(W,H){this.s(W,Se,X=>X.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(W,H,X,Z){const de=new Q(W,this.h,X,this.j.converter),ve=this.t(de,W);return this.e.$registerInlineCompletionsSupport(ve,this.o(H,W),de.supportsHandleEvents,f.$qn.toKey(W.identifier.value),Z?.yieldTo?.map(Oe=>f.$qn.toKey(Oe))||[]),this.p(ve)}$provideInlineCompletions(W,H,X,Z,de){return this.s(W,me,ve=>ve.provideInlineCompletions(u.URI.revive(H),X,Z,de),void 0,de)}$provideInlineEdits(W,H,X,Z,de){return this.s(W,me,ve=>ve.provideInlineEdits(u.URI.revive(H),X,Z,de),void 0,de)}$handleInlineCompletionDidShow(W,H,X,Z){this.s(W,me,async de=>{de.handleDidShowCompletionItem(H,X,Z)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,H,X,Z,de){this.s(W,me,async ve=>{ve.handlePartialAccept(H,X,Z,de)},void 0,void 0)}$freeInlineCompletionsList(W,H){this.s(W,me,async X=>{X.disposeCompletions(H)},void 0,void 0)}registerInlineEditProvider(W,H,X){const Z=new q(W,this.h,X,this.j.converter),de=this.t(Z,W);return this.e.$registerInlineEditProvider(de,this.o(H,W),W.identifier),this.p(de)}$provideInlineEdit(W,H,X,Z){return this.s(W,q,de=>de.provideInlineEdits(u.URI.revive(H),X,Z),void 0,Z)}$freeInlineEdit(W,H){this.s(W,q,async X=>{X.disposeEdit(H)},void 0,void 0)}registerSignatureHelpProvider(W,H,X,Z){const de=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,ve=this.t(new we(this.h,X),W);return this.e.$registerSignatureHelpProvider(ve,this.o(H,W),de),this.p(ve)}$provideSignatureHelp(W,H,X,Z,de){return this.s(W,we,ve=>ve.provideSignatureHelp(u.URI.revive(H),X,Z,de),void 0,de)}$releaseSignatureHelp(W,H){this.s(W,we,X=>X.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(W,H,X){const Z=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ee(this.h,this.j.converter,X,this.l,W),W);this.e.$registerInlayHintsProvider(de,this.o(H,W),typeof X.resolveInlayHint=="function",Z,De.u(W));let ve=this.p(de);if(Z!==void 0){const Oe=X.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(Z));ve=s.$JN.from(ve,Oe)}return ve}$provideInlayHints(W,H,X,Z){return this.s(W,ee,de=>de.provideInlayHints(u.URI.revive(H),X,Z),void 0,Z)}$resolveInlayHint(W,H,X){return this.s(W,ee,Z=>Z.resolveInlayHint(H,X),void 0,X)}$releaseInlayHints(W,H){this.s(W,ee,X=>X.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(W,H,X){const Z=this.t(new ae(this.h,X),W);return this.e.$registerDocumentLinkProvider(Z,this.o(H,W),typeof X.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(W,H,X){return this.s(W,ae,Z=>Z.provideLinks(u.URI.revive(H),X),void 0,X,H.scheme==="output")}$resolveDocumentLink(W,H,X){return this.s(W,ae,Z=>Z.resolveLink(H,X),void 0,void 0,!0)}$releaseDocumentLinks(W,H){this.s(W,ae,X=>X.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(W,H,X){const Z=this.t(new oe(this.h,X),W);return this.e.$registerDocumentColorProvider(Z,this.o(H,W)),this.p(Z)}$provideDocumentColors(W,H,X){return this.s(W,oe,Z=>Z.provideColors(u.URI.revive(H),X),[],X)}$provideColorPresentations(W,H,X,Z){return this.s(W,oe,de=>de.provideColorPresentations(u.URI.revive(H),X,Z),void 0,Z)}registerFoldingRangeProvider(W,H,X){const Z=this.q(),de=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new Ae(new x(this.h,X),W)),this.e.$registerFoldingRangeProvider(Z,this.o(H,W),W.identifier,de);let ve=this.p(Z);if(de!==void 0){const Oe=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));ve=s.$JN.from(ve,Oe)}return ve}$provideFoldingRanges(W,H,X,Z){return this.s(W,x,de=>de.provideFoldingRanges(u.URI.revive(H),X,Z),void 0,Z)}registerSelectionRangeProvider(W,H,X){const Z=this.t(new ne(this.h,X,this.l),W);return this.e.$registerSelectionRangeProvider(Z,this.o(H,W)),this.p(Z)}$provideSelectionRanges(W,H,X,Z){return this.s(W,ne,de=>de.provideSelectionRanges(u.URI.revive(H),X,Z),[],Z)}registerCallHierarchyProvider(W,H,X){const Z=this.t(new pe(this.h,X),W);return this.e.$registerCallHierarchyProvider(Z,this.o(H,W)),this.p(Z)}$prepareCallHierarchy(W,H,X,Z){return this.s(W,pe,de=>Promise.resolve(de.prepareSession(u.URI.revive(H),X,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(W,H,X,Z){return this.s(W,pe,de=>de.provideCallsTo(H,X,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(W,H,X,Z){return this.s(W,pe,de=>de.provideCallsFrom(H,X,Z),void 0,Z)}$releaseCallHierarchy(W,H){this.s(W,pe,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(W,H,X){const Z=this.t(new be(this.h,X),W);return this.e.$registerTypeHierarchyProvider(Z,this.o(H,W)),this.p(Z)}$prepareTypeHierarchy(W,H,X,Z){return this.s(W,be,de=>Promise.resolve(de.prepareSession(u.URI.revive(H),X,Z)),void 0,Z)}$provideTypeHierarchySupertypes(W,H,X,Z){return this.s(W,be,de=>de.provideSupertypes(H,X,Z),void 0,Z)}$provideTypeHierarchySubtypes(W,H,X,Z){return this.s(W,be,de=>de.provideSubtypes(H,X,Z),void 0,Z)}$releaseTypeHierarchy(W,H){this.s(W,be,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(W,H,X,Z){const de=this.q();return this.f.set(de,new Ae(new Fe(this.e,this.h,X,de,W),W)),this.e.$registerDocumentOnDropEditProvider(de,this.o(H,W),(0,t.$eH)(W,"documentPaste")&&Z?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:Z.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(W,H,X,Z,de,ve){return this.s(W,Fe,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(H,u.URI.revive(X),Z,de,ve)),void 0,void 0)}$resolveDropEdit(W,H,X){return this.s(W,Fe,Z=>Z.resolveDropEdit(H,X),{},void 0)}$releaseDocumentOnDropEdits(W,H){this.s(W,Fe,X=>Promise.resolve(X.releaseDropEdits(H)),void 0,void 0)}registerMappedEditsProvider(W,H,X){const Z=this.t(new ze(this.h,X),W);return this.e.$registerMappedEditsProvider(Z,this.o(H,W),W.displayName??W.name),this.p(Z)}$provideMappedEdits(W,H,X,Z,de){return this.s(W,ze,ve=>Promise.resolve(ve.provideMappedEdits(H,X,Z,de)),null,de)}registerDocumentPasteEditProvider(W,H,X,Z){const de=this.q();return this.f.set(de,new Ae(new M(this.e,this.h,X,de,W),W)),this.e.$registerPasteEditProvider(de,this.o(H,W),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:Z.providedPasteEditKinds?.map(ve=>ve.value),copyMimeTypes:Z.copyMimeTypes,pasteMimeTypes:Z.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(W,H,X,Z,de){return this.s(W,M,ve=>ve.prepareDocumentPaste(u.URI.revive(H),X,Z,de),void 0,de)}$providePasteEdits(W,H,X,Z,de,ve,Oe){return this.s(W,M,He=>He.providePasteEdits(H,u.URI.revive(X),Z,de,ve,Oe),void 0,Oe)}$resolvePasteEdit(W,H,X){return this.s(W,M,Z=>Z.resolvePasteEdit(H,X),{},void 0)}$releasePasteEdits(W,H){this.s(W,M,X=>Promise.resolve(X.releasePasteEdits(H)),void 0,void 0)}static y(W){return{pattern:W.source,flags:W.flags}}static z(W){return{decreaseIndentPattern:De.y(W.decreaseIndentPattern),increaseIndentPattern:De.y(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?De.y(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?De.y(W.unIndentedLinePattern):void 0}}static B(W){return{beforeText:De.y(W.beforeText),afterText:W.afterText?De.y(W.afterText):void 0,previousLineText:W.previousLineText?De.y(W.previousLineText):void 0,action:W.action}}static C(W){return W.map(De.B)}static D(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(H=>s.SyntaxTokenType.toString(H)):void 0}}static E(W){return W.map(De.D)}setLanguageConfiguration(W,H,X){const{wordPattern:Z}=X;if(Z&&(0,I.$rf)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor(H,Z):this.h.setWordDefinitionFor(H,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const de=this.q(),ve={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?De.y(X.wordPattern):void 0,indentationRules:X.indentationRules?De.z(X.indentationRules):void 0,onEnterRules:X.onEnterRules?De.C(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?De.E(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,H,ve),this.p(de)}$setWordDefinitions(W){for(const H of W)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.$opc=De}),define(ke[305],Ie([1,0,3,6,15]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=void 0,C=qe(C);class R{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(h.$HN.MainThreadLanguageModelTools),this.b.$getTools().then(b=>{for(const c of b)this.c.set(c.name,c)})}async invokeTool(T,b,c){return await this.b.$invokeTool(T,b,c)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.name,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values()).map(T=>C.LanguageModelToolDescription.to(T))}async $invokeTool(T,b,c){const I=this.a.get(T);if(!I)throw new Error(`Unknown tool ${T}`);return await I.tool.invoke(b,c)}registerTool(T,b,c){return this.a.set(b,{extension:T,tool:c}),this.b.$registerTool(b),(0,r.$Sc)(()=>{this.a.delete(b),this.b.$unregisterTool(b)})}}e.$Sqc=R}),define(ke[128],Ie([1,0,7,20,52,13,4,39,3,8,23,5,11,89,6,127,19,15,9,156,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=e.$8pc=void 0,$=qe($),f=qe(f),e.$8pc=(0,S.$Ei)("IExtHostLanguageModels");class o{constructor(g,E){this.option=g,this.stream=new r.$8h,this.stream=E??new r.$8h}}class n{constructor(){this.a=new Map,this.b=new r.$8h,this.c=!1;const g=this;this.apiObject={get stream(){return g.b.asyncIterable},get text(){return r.$5h.map(g.b.asyncIterable,E=>{if(E instanceof f.$4P)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,g]of this.a)yield g.stream;else yield this.b}handleFragment(g){if(this.c)return;let E=this.a.get(g.index);E||(this.a.size===0?E=new o(g.index,this.b):E=new o(g.index),this.a.set(g.index,E));let D;g.part.type==="text"?D=new f.$4P(g.part.value):D=new f.$3P(g.part.name,g.part.parameters),E.stream.emitOne(D)}reject(g){this.c=!0;for(const E of this.d())E.reject(g)}resolve(){this.c=!0;for(const g of this.d())g.resolve()}}let d=class{static{t=this}static{this.a=1}constructor(g,E,D){this.j=E,this.k=D,this.c=new L.$le,this.d=new L.$le,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$sn,this.i=new Map,this.s=new Set,this.b=g.getProxy(w.$HN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(g,E,D,y){const k=t.a++;this.f.set(k,{extension:g.identifier,provider:D,languageModelId:E});let A;y.auth&&(A={providerLabel:g.displayName||g.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${I.$qn.toKey(g.identifier)}/${k}/${E}`,{extension:g.identifier,id:E,vendor:y.vendor??I.$qn.toKey(g.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:A,targetExtensions:y.extensions});const p=D.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:F,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new I.$qn(v),F,N)});return(0,b.$Sc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),p?.dispose()})}async $startChatRequest(g,E,D,y,k,A){const p=this.f.get(g);if(!p)throw new Error("Provider not found");const v=new P.$yw(async N=>{if(A.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let O;if(N.part instanceof f.$3P?O={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof f.$4P&&(O={type:"text",value:N.part.value}),!O){this.j.warn(`[CHAT](${p.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:O})});let F;if(p.provider.provideLanguageModelResponse2)F=Promise.resolve(p.provider.provideLanguageModelResponse2(y.map($.LanguageModelChatMessage.to),k,I.$qn.toKey(D),v,A));else{const N=new P.$yw(async O=>{v.report({index:O.index,part:new f.$4P(O.part)})});F=Promise.resolve(p.provider.provideLanguageModelResponse(y.map($.LanguageModelChatMessage.to),k?.modelOptions??{},I.$qn.toKey(D),N,A))}F.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,R.$1)(N))})}$provideTokenLength(g,E,D){const y=this.f.get(g);return y?Promise.resolve(y.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(g){if(g.added)for(const{identifier:E,metadata:D}of g.added)this.g.set(E,{metadata:D,apiObjects:new I.$sn});if(g.removed)for(const E of g.removed){this.g.delete(E);for(const[D,y]of this.i)y.languageModelId===E&&(y.res.reject(new R.$4),this.i.delete(D))}g.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(g,E){const D=await this.b.$selectChatModels({...E,extension:g.identifier}),y=[],k=this;for(const A of D){const p=this.g.get(A);if(!p)continue;this.o(g.identifier,p.metadata)&&await this.q(p.metadata);let v=p.apiObjects.get(g.identifier);v||(v={id:A,vendor:p.metadata.vendor,family:p.metadata.family,version:p.metadata.version,name:p.metadata.name,maxInputTokens:p.metadata.maxInputTokens,countTokens(F,N){if(!k.g.has(A))throw f.$8P.NotFound(A);return k.r(A,F,N??h.CancellationToken.None)},sendRequest(F,N,O){if(!k.g.has(A))throw f.$8P.NotFound(A);return k.l(g,A,F,N??{},O??h.CancellationToken.None)}},Object.freeze(v),p.apiObjects.set(g.identifier,v)),y.push(v)}return y}async l(g,E,D,y,k){const A=this.m(g,D),p=g.identifier,v=this.g.get(E)?.metadata;if(!v||!this.g.has(E))throw f.$8P.NotFound(`Language model '${E}' is unknown.`);if(this.o(p,v)&&(!await this.n(g,{identifier:v.extension,displayName:v.auth.providerLabel},y.justification,!1)||!this.h.get(p)?.has(v.extension)))throw f.$8P.NoPermissions(`Language model '${E}' cannot be used by '${p.value}'.`);try{const F=Math.random()*1e6|0,N=new n;this.i.set(F,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(p,E,F,A,y,k)}catch(O){throw this.i.delete(F),O}return N.apiObject}catch(F){throw F.name===f.$8P.name?F:new f.$8P(`Language model '${E}' errored: ${(0,C.$pj)(F)}`,"Unknown",F)}}m(g,E){const D=[];for(const y of E)y.role===f.LanguageModelChatMessageRole.System&&(0,s.$fH)(g,"languageModelSystem"),y.content2 instanceof f.$1P&&(0,s.$fH)(g,"lmTools"),D.push($.LanguageModelChatMessage.from(y));return D}async $acceptResponsePart(g,E){const D=this.i.get(g);D&&D.res.handleFragment(E)}async $acceptResponseDone(g,E){const D=this.i.get(g);D&&(this.i.delete(g),E?D.res.reject((0,R.$2)(E)):D.res.resolve())}async n(g,E,D,y){const k=i.$JM+E.identifier.value;if(await this.k.getSession(g,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0;if(y)return!1;try{const p=D?(0,c.localize)(10786,null,E.displayName,D):void 0;return await this.k.getSession(g,k,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(g,E){return!!E.auth&&!I.$qn.equals(E.extension,g)}async q(g){if(g.auth)for(const E of this.s)try{await this.n(E,{identifier:g.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(g,E,D){if(!this.g.get(g))throw f.$8P.NotFound(`Language model '${g}' is unknown.`);const k=T.Iterable.find(this.f.values(),A=>A.languageModelId===g);return k?k.provider.provideTokenCount(E,D):this.b.$countTokens(g,typeof E=="string"?E:$.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(g){const E=new Array;for(const{from:D,to:y,enabled:k}of g){const A=this.h.get(D)??new I.$rn;if(A.has(y)!==k){k?A.add(y):A.delete(y),this.h.set(D,A);const v={from:D,to:y};E.push(v),this.c.fire(v)}}}createLanguageModelAccessInformation(g){this.s.add(g);const E=this,D=L.Event.signal(L.Event.filter(this.c.event,k=>I.$qn.equals(k.from,g.identifier))),y=L.Event.signal(this.d.event);return{get onDidChange(){return L.Event.any(D,y)},canSendRequest(k){let A;e:for(const[v,F]of E.g)for(const N of F.apiObjects.values())if(N===k){A=F.metadata;break e}if(!A)return;if(!E.o(g.identifier,A))return!0;const p=E.h.get(g.identifier);if(p)return p.has(A.extension)}}}};e.$9pc=d,e.$9pc=d=t=Je([Ve(0,m.$hQ),Ve(1,u.$_j),Ve(2,a.$qpc)],d)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[306],Ie([1,0,6,15,9,43,7,3,25]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=void 0,h=qe(h),R=Ut(R);class c{constructor(S,u,P,w){this.c=u,this.d=P,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(r.$HN.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,u){await this.a.$changeLanguage(S,u);const P=this.c.getDocumentData(S);if(!P)throw new Error(`document '${S.toString()}' NOT found`);return P.document}async tokenAtPosition(S,u){const P=S.version,w=h.Position.from(u),a=await this.a.$tokensAtPosition(S.uri,w),m={type:C.StandardTokenType.Other,range:S.getWordRangeAtPosition(u)??new C.$LN(u.line,u.character,u.line,u.character)};if(!a)return m;const $={range:h.Range.to(a.range),type:h.TokenType.to(a.type)};return!$.range.contains(u)||P!==S.version?m:$}createLanguageStatusItem(S,u,P){const w=this.f++,a=this.a,m=this.g,$=`${S.identifier.value}/${u}`;if(m.has($))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);m.add($);const f={selector:P,id:u,name:S.displayName??S.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new T.$Tc,t=()=>{if(i?.dispose(),!m.has($)){console.warn(`LanguageStatusItem (${u}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,L.$Gh)(()=>{s.clear(),this.a.$setLanguageStatus(w,{id:$,name:f.name??S.displayName??S.name,source:S.displayName??S.name,selector:h.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===C.LanguageStatusSeverity.Error?R.default.Error:f.severity===C.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:f.command&&this.d.toInternal(f.command,s),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},o={dispose(){s.dispose(),i?.dispose(),a.$removeLanguageStatus(w),m.delete($)},get id(){return f.id},get name(){return f.name},set name(n){f.name=n,t()},get selector(){return f.selector},set selector(n){f.selector=n,t()},get text(){return f.text},set text(n){f.text=n,t()},set text2(n){(0,b.$fH)(S,"languageStatusText"),f.text=n,t()},get text2(){return(0,b.$fH)(S,"languageStatusText"),f.text},get detail(){return f.detail},set detail(n){f.detail=n,t()},get severity(){return f.severity},set severity(n){f.severity=n,t()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(n){f.accessibilityInformation=n,t()},get command(){return f.command},set command(n){f.command=n,t()},get busy(){return f.busy},set busy(n){f.busy=n,t()}};return t(),o}}e.$Tqc=c}),define(ke[307],Ie([1,0,14,2,15,9,126]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=e.$Eqc=void 0,C=qe(C),L=qe(L);class T{constructor(S,u,P,w){this.start=S,this.deletedCount=u,this.deletedItems=P,this.items=w}asApiEvent(){return{range:new R.$bP(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,u,P){this.notebook=S,this.h=u,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(C.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return S.g},set mime(w){S.g=w},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(P)}return this.f}setOutputs(S){this.a=S.map(C.NotebookCellOutput.to)}setOutputItems(S,u,P){const w=P.map(C.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===S);if(a&&(u||(a.items.length=0),a.items.push(...w),a.items.length>1&&a.items.every(m=>L.$KL(m.mime)))){const m=new Map,$=[];a.items.forEach(f=>{let i;m.has(f.mime)?i=m.get(f.mime):(i=[],m.set(f.mime,i),$.push(f.mime)),i.push(f.data)}),a.items.length=0,$.forEach(f=>{const i=L.$LL(m.get(f));a.items.push({mime:f,data:i.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$Eqc=b;class c{static{this.a=0}constructor(S,u,P,w,a){this.k=S,this.l=u,this.m=P,this.uri=w,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,u={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===r.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(P){return P=S.n(P),S.b[P].apiCell},getCells(P){return(P?S.p(P):S.b).map(a=>a.apiCell)},save(){return S.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,u,P){this.g=S.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:P});const w={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},a=[];for(const $ of S.rawEvents)$.kind===L.NotebookCellsChangeType.ModelChange?this.r($.changes,!1,w.contentChanges):$.kind===L.NotebookCellsChangeType.Move?this.s($.index,$.length,$.newIdx,w.contentChanges):$.kind===L.NotebookCellsChangeType.Output?(this.t($.index,$.outputs),a.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===L.NotebookCellsChangeType.OutputItem?(this.u($.index,$.outputId,$.append,$.outputItems),a.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v($.index,$.language),a.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document})):$.kind===L.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document}):$.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w($.index,$.mime):$.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x($.index,$.metadata),a.push({cell:this.b[$.index].apiCell,metadata:this.b[$.index].apiCell.metadata})):$.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y($.index,$.internalMetadata),a.push({cell:this.b[$.index].apiCell,executionSummary:this.b[$.index].apiCell.executionSummary}));const m=new Map;for(let $=0;$<a.length;$++){const f=a[$],i=m.get(f.cell);if(i===void 0){const s=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});m.set(f.cell,s-1)}else w.cellChanges[i]={...w.cellChanges[i],...f}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let u=S.start|0,P=S.end|0;return u<0&&(u=0),P>this.b.length&&(P=this.b.length),S.with({start:u,end:P})}p(S){S=this.o(S);const u=[];for(let P=S.start;P<S.end;P++)u.push(this.b[P]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,u,P){if(this.j)return;const w=[],a=[],m=[];if(S.reverse().forEach($=>{const i=$[2].map(o=>{const n=new b(this,this.l,o);return u||a.push(b.asModelAddData(o)),n}),s=new T($[0],$[1],[],i),t=this.b.splice($[0],$[1],...i);for(const o of t)m.push(o.uri),s.deletedItems.push(o.apiCell);w.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),P)for(const $ of w)P.push($.asApiEvent())}s(S,u,P,w){const a=this.b.splice(S,u);this.b.splice(P,0,...a);const m=[new T(S,u,a.map($=>$.apiCell),[]),new T(P,0,[],a)];for(const $ of m)w.push($.asApiEvent())}t(S,u){this.b[S].setOutputs(u)}u(S,u,P,w){this.b[S].setOutputItems(u,P,w)}v(S,u){const P=this.b[S];P.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(P.uri,u)}w(S,u){const P=this.b[S];P.apiCell.mime=u}x(S,u){this.b[S].setMetadata(u)}y(S,u){this.b[S].setInternalMetadata(u)}getCellFromApiCell(S){return this.b.find(u=>u.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(u=>u.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$Fqc=c}),define(ke[308],Ie([1,0,4,2,15,9,53]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=void 0;class T{constructor(c,I,S,u={timeout:1500,errors:3}){this.b=c,this.c=I,this.d=S,this.f=u,this.a=new r.$ne}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(I,S,u)=>{const P=function(a){I.call(S,a)};return P.extension=c,this.a.event(P,void 0,u)}}async $participateInSave(c,I,S){const u=h.URI.revive(c),P=this.c.getNotebookDocument(u);if(!P)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:C.TextDocumentSaveReason.to(I)},S,async(m,$)=>{const f=Date.now(),i=await await Promise.resolve(m);Date.now()-f>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier),!S.isCancellationRequested&&i&&(i instanceof R.$VN?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(w.length===0)return!0;const a={edits:[]};for(const m of w){const{edits:$}=C.WorkspaceEdit.from(m);a.edits=a.edits.concat($)}return this.d.$tryApplyWorkspaceEdit(new L.$Ww(a))}}e.$Vqc=T}),define(ke[165],Ie([1,0,13,15,9]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=void 0,h=qe(h),C=qe(C);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,b,c,I,S,u){this.id=T,this.f=b,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=I,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(b){this.selections=[b]},get selections(){return T.a},set selections(b){if(!Array.isArray(b)||!b.every(C.$bP.isNotebookRange))throw(0,r.$6)("selections");T.a=b,T.g(b)},get visibleRanges(){return T.b},revealRange(b,c){T.f.$tryRevealRange(T.id,h.NotebookRange.from(b),c??C.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(h.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Gqc=R}),define(ke[309],Ie([1,0,4,11,15]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=void 0,C=qe(C);let R=class{constructor(T,b){this.c=T,this.d=b,this.a=new r.$le,this.b=new r.$le,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,b);const c=this.d.getEditorById(T);b.visibleRanges&&c._acceptVisibleRanges(b.visibleRanges.ranges.map(C.NotebookRange.to)),b.selections&&c._acceptSelections(b.selections.selections.map(C.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const b in T)this.d.getEditorById(b)._acceptViewColumn(C.ViewColumn.to(T[b]))}};e.$Xqc=R,e.$Xqc=R=Je([Ve(0,h.$_j)],R)}),define(ke[310],Ie([1,0,4,6,165]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0;class R{constructor(T,b){this.c=b,this.a=new Map,this.b=T.getProxy(h.$HN.MainThreadNotebookRenderers)}$postRendererMessage(T,b,c){const I=this.c.getEditorById(T);this.a.get(b)?.fire({editor:I.apiEditor,message:c})}createRendererMessaging(T,b){if(!T.contributes?.notebookRenderer?.some(I=>I.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(I,S,u)=>this.d(b).event(I,S,u),postMessage:(I,S)=>{C.$Gqc.apiEditorsToExtHost.has(I)&&([I,S]=[S,I]);const u=S&&C.$Gqc.apiEditorsToExtHost.get(S);return this.b.$postMessage(u?.id,b,I)}}}d(T){let b=this.a.get(T);return b||(b=new r.$le({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(T)}}),this.a.set(T,b),b)}}e.$1qc=R}),define(ke[311],Ie([1,0,15,89,20,59,13]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0;class T{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,u,P){const w=this.b++,{title:a,location:m,cancellable:$}=u,f={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(w,{location:r.ProgressLocation.from(m),title:a,source:f,cancellable:$},S.isUnderDevelopment?void 0:S.identifier.value).catch(L.$Z),this.d(w,P,!!$)}d(S,u,P){let w;P&&(w=new C.$we,this.c.set(S,w));const a=$=>{this.a.$progressEnd($),this.c.delete($),w?.dispose()};let m;try{m=u(new c(this.a,S),P&&w?w.token:C.CancellationToken.None)}catch($){throw a(S),$}return m.then($=>a(S),$=>a(S)),m}$acceptProgressCanceled(S){const u=this.c.get(S);u&&(u.cancel(),this.c.delete(S))}}e.$5qc=T;function b(I,S){return I.message=S.message,typeof S.increment=="number"&&(typeof I.increment=="number"?I.increment+=S.increment:I.increment=S.increment),I}class c extends h.$yw{constructor(S,u){super(P=>this.throttledReport(P)),this.c=S,this.d=u}throttledReport(S){this.c.$progressReport(this.d,S)}}Je([(0,R.$$h)(100,(I,S)=>b(I,S),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(ke[312],Ie([1,0,2,6,7,15]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0;class L{static{this.a=0}constructor(b,c){this.d=c,this.c=new Map,this.b=b.getProxy(h.$HN.MainThreadQuickDiff)}$provideOriginalResource(b,c,I){const S=r.URI.revive(c),u=this.c.get(b);return u?(0,C.$wh)(()=>u.provideOriginalResource(S,I)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider(b,c,I,S){const u=L.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from(b,this.d),I,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$6qc=L});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[313],Ie([1,0,20,4,3,6,2,9,13,18,43,50,25,15]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=w,I=Ut(I);function w(a,m,$){const f=a.getProxy(R.$HN.MainThreadQuickOpen);class i{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,k,A=r.CancellationToken.None){this.c=void 0;const p=Promise.resolve(y),v=++this.f,F=f.$show(v,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},A),N={},O=F.then(()=>N);return Promise.race([O,p]).then(j=>{if(j===N)return;const z=(0,u.$eH)(D,"quickPickItemTooltip");return p.then(M=>{const U=[];for(let V=0;V<M.length;V++){const ie=M[V];if(typeof ie=="string")U.push({label:ie,handle:V});else if(ie.kind===T.QuickPickItemKind.Separator)U.push({type:"separator",label:ie.label});else{ie.tooltip&&!z&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const B=ie.iconPath?d(ie.iconPath):void 0;U.push({label:ie.label,iconPath:B?.iconPath,iconClass:B?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:z?P.MarkdownString.fromStrict(ie.tooltip):void 0,handle:V})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=V=>{k.onDidSelectItem(M[V])}),f.$setItems(v,U),F.then(V=>{if(typeof V=="number")return M[V];if(Array.isArray(V))return V.map(ie=>M[ie])})})}).then(void 0,j=>{if(!(0,b.$3)(j))return f.$setError(v,j),Promise.reject(j)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=r.CancellationToken.None){return this.d=D?.validateInput,f.$input(D,typeof this.d=="function",y).then(void 0,k=>{if(!(0,b.$3)(k))return Promise.reject(k)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let k;switch(y.severity){case T.InputBoxValidationSeverity.Info:k=I.default.Info;break;case T.InputBoxValidationSeverity.Warning:k=I.default.Warning;break;case T.InputBoxValidationSeverity.Error:k=I.default.Error;break;default:k=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:k}}async showWorkspaceFolderPick(D,y=r.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!k)return;const A=await this.a.getWorkspaceFolders2();if(A)return A.find(p=>p.uri.toString()===k.uri.toString())}createQuickPick(D){const y=new l(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new g(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const k=this.e.get(D);k instanceof l&&k._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const k=this.e.get(D);k instanceof l&&k._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,k){const A=this.e.get(D);A instanceof l&&A._fireDidTriggerItemButton(y,k)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class s{static{this.a=1}constructor(D,y){this.x=D,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$le,this.q=new h.$le,this.r=new h.$le,this.s=new h.$le,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const y=(0,u.$eH)(this.x,"quickInputButtonLocation");!y&&D.some(k=>k.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((k,A)=>{const p=k===T.$$O.Back?-1:A;this.o.set(p,k)}),this.z({buttons:D.map((k,A)=>({...d(k.iconPath),tooltip:k.tooltip,handle:k===T.$$O.Back?-1:A,location:y?k.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const k=D[y];this.u[y]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof T.$IO)return{id:E.id};const D=n(E),y=o(E);return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof y=="string"?L.URI.file(y):y}}function o(E){return typeof E=="object"&&"light"in E?E.light:E}function n(E){return typeof E=="object"&&"dark"in E?E.dark:E}function d(E){const D=t(E);let y,k;return"id"in D?k=S.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:k}}class l extends s{constructor(D,y){super(D,y),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$le,this.L=[],this.M=new h.$le,this.N=new h.$le,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((A,p)=>{this.C.set(p,A),this.D.set(A,p)});const y=(0,u.$eH)(this.x,"quickPickItemTooltip"),k=[];for(let A=0;A<D.length;A++){const p=D[A];if(p.kind===T.QuickPickItemKind.Separator)k.push({type:"separator",label:p.label});else{p.tooltip&&!y&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const v=p.iconPath?d(p.iconPath):void 0;k.push({handle:A,label:p.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:y?P.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((F,N)=>({...d(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,c.$Gb)(D.map(k=>this.C.get(k)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,c.$Gb)(D.map(k=>this.C.get(k)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const k=this.C.get(D);if(!k||!k.buttons||!k.buttons.length)return;const A=k.buttons[y];A&&this.N.fire({button:A,item:k})}}class g extends s{constructor(D,y){super(D,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:I.default.Error}):this.z({validationMessage:D.message,severity:D.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(m,$)}}),define(ke[314],Ie([1,0,2,4,59,3,7,6,18,134,11,23,40,50,15,25,14,10]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=e.$8qc=void 0;function i(N){return N instanceof r.URI}function s(N,O){return N.scheme===m.Schemas.file&&O.scheme===m.Schemas.file&&$.$l?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||P.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function o(N){if(N){if(r.URI.isUri(N))return N;if(P.ThemeIcon.isThemeIcon(N))return N;{const O=N;return{light:O.light,dark:O.dark}}}else return}function n(N){const O=o(N.icon),j=N.labels?.map(z=>({title:z.title,icon:o(z.icon)}));return{...N,icon:O,labels:j}}function d(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const j=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,z=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,c.$Jr)(j,z)}function l(N,O){let j=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(j=d(N,O),j!==0)return j;if(N.light&&O.light)j=d(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(j!==0)return j;if(N.dark&&O.dark)j=d(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return j}function g(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let j=0;j<N.arguments.length;j++){const z=N.arguments[j],M=O.arguments[j];if(z!==M&&!(i(z)&&i(M)&&s(z,M)))return z<M?-1:1}return 0}function E(N,O){let j=(0,c.$Jr)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(j!==0)return j;if(N.command&&O.command)j=g(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(j!==0)return j;if(N.decorations&&O.decorations)j=l(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)j=(0,c.$Jr)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)j=(0,c.$Jr)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return j}function D(N,O){for(let j=0;j<N.length;j++)if(N[j]!==O[j])return!1;return!0}function y(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?D(N.arguments,O.arguments):N.arguments===O.arguments)}function k(N,O){return(0,b.$tb)(N,O,y)}class A{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.m,O),this.o(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.m,O),this.f=O}get validateInput(){return(0,a.$fH)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,a.$fH)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.m,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.m,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.m,O))}get document(){return(0,a.$fH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(O,j,z,M,U){this.k=O,this.m=M,this.n=U,this.d="",this.e=new h.$le,this.f="",this.h=!0,this.j=!0,this.#t=j,this.#e=z}showValidationMessage(O,j){(0,a.$fH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,O,j)}$onInputBoxValueChange(O){this.o(O)}o(O){this.d=O,this.e.fire(O)}}e.$8qc=A;class p{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(O){this.w=O,this.s.$updateGroupLabel(this.u,this.handle,O)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(O){this.q=O,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,j,z,M,U,V,ie){this.s=O,this.t=j,this.u=z,this.v=M,this.w=U,this.multiDiffEditorEnableViewChanges=V,this.x=ie,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$le,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$le,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=p.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,j){const z=this.h.get(O);return z?(0,L.$wh)(()=>this.t.executeCommand(z.command,...z.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(E),z=(0,b.$Cb)(this.p,O,E).map(V=>{const ie=V.toInsert.map(B=>{const Y=this.e++;this.g.set(Y,B);const J=B.resourceUri;let _;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"||B.command.command==="vscode.changes"){const ne=new R.$Tc;_=this.t.converter.toInternal(B.command,ne),this.j.set(Y,ne)}else this.h.set(Y,B.command);const le=(0,a.$eH)(this.x,"scmMultiDiffEditor"),re=le?B.multiDiffEditorOriginalUri:void 0,Se=le?B.multiFileDiffEditorModifiedUri:void 0,me=t(B.decorations),Q=B.decorations&&t(B.decorations.light)||me,q=B.decorations&&t(B.decorations.dark)||me,se=[Q,q],we=B.decorations&&B.decorations.tooltip||"",ee=B.decorations&&!!B.decorations.strikeThrough,ae=B.decorations&&!!B.decorations.faded,oe=B.contextValue||"";return{rawResource:[Y,J,se,we,ee,ae,oe,_,re,Se],handle:Y}});return{start:V.start,deleteCount:V.deleteCount,toInsert:ie}}),M=z.map(({start:V,deleteCount:ie,toInsert:B})=>[V,ie,B.map(Y=>Y.rawResource)]),U=z.reverse();for(const{start:V,deleteCount:ie,toInsert:B}of U){const Y=B.map(_=>_.handle),J=this.o.splice(V,ie,...Y);for(const _ of J)this.g.delete(_),this.h.delete(_),this.j.get(_)?.dispose(),this.j.delete(_)}return this.p=O,M}dispose(){this.m=!0,this.n.fire()}}class v{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.x,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let j;(0,a.$eH)(this.y,"quickDiffProvider")&&(j=O?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!O,quickDiffLabel:j})}get historyProvider(){return(0,a.$fH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(O){(0,a.$fH)(this.y,"scmHistoryProvider"),this.j=O,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.m=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(O){O!==this.n&&(this.n=O,this.#e.$updateSourceControl(this.x,{commitTemplate:O}))}get acceptInputCommand(){return this.p}set acceptInputCommand(O){this.o.value=new R.$Tc,this.p=O;const j=this.z.converter.toInternal(O,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,a.$fH)(this.y,"scmActionButton"),this.s}set actionButton(O){(0,a.$fH)(this.y,"scmActionButton"),this.q.value=new R.$Tc,this.s=O;const j=O!==void 0?{command:this.z.converter.toInternal(O.command,this.q.value),secondaryCommands:O.secondaryCommands?.map(z=>z.map(M=>this.z.converter.toInternal(M,this.q.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(O){if(this.u&&O&&k(this.u,O))return;this.t.value=new R.$Tc,this.u=O;const j=(O||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(O,j,z,M,U,V,ie){this.y=O,this.z=M,this.A=U,this.B=V,this.C=ie,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.n=void 0,this.o=new R.$Vc,this.p=void 0,this.q=new R.$Vc,this.t=new R.$Vc,this.u=void 0,this.v=!1,this.w=new h.$le,this.onDidChangeSelection=this.w.event,this.x=v.d++,this.D=new Map,this.E=new Set,this.#e=z;const B=r.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:ie?`rootUri=${encodeURIComponent(ie.toString())}`:void 0});this.f=new A(O,j,this.#e,this.x,B),this.#e.$registerSourceControl(this.x,U,V,ie,B)}createResourceGroup(O,j,z){const M=(0,a.$eH)(this.y,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,U=new p(this.#e,this.z,this.x,O,j,M,this.y),V=h.Event.once(U.onDidDispose)(()=>this.D.delete(U));return this.D.set(U,V),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const O=[],j=[];for(const[z,M]of this.D){M.dispose();const U=z.onDidUpdateResourceStates(()=>{this.E.add(z),this.eventuallyUpdateResourceStates()});h.Event.once(z.onDidDispose)(()=>{this.E.delete(z),U.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),O.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const V=z._takeResourceStateSnapshot();V.length>0&&j.push([z.handle,V]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,O,j),this.D.clear()}eventuallyUpdateResourceStates(){const O=[];this.E.forEach(j=>{const z=j._takeResourceStateSnapshot();z.length!==0&&O.push([j.handle,z])}),O.length>0&&this.#e.$spliceResourceStates(this.x,O),this.E.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.v=O,this.w.fire(O)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,C.$0h)(100)],v.prototype,"eventuallyAddResourceGroups",null),Je([(0,C.$0h)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{f=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,j,z,M){this.m=j,this.n=z,this.o=M,this.g=new Map,this.h=new S.$sn,this.j=new h.$le,this.e=O.getProxy(T.$HN.MainThreadSCM),this.f=O.getProxy(T.$HN.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===u.MarshalledId.ScmResource){const V=this.g.get(U.sourceControlHandle);if(!V)return U;const ie=V.getResourceGroup(U.groupHandle);return ie?ie.getResourceState(U.handle):U}else if(U&&U.$mid===u.MarshalledId.ScmResourceGroup){const V=this.g.get(U.sourceControlHandle);return V?V.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===u.MarshalledId.ScmProvider){const V=this.g.get(U.handle);return V||U}return U}})}createSourceControl(O,j,z,M){this.o.trace("ExtHostSCM#createSourceControl",O.identifier.value,j,z,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const U=f.d++,V=new v(O,this.n,this.e,this.m,j,z,M);this.g.set(U,V);const ie=this.h.get(O.identifier)||[];return ie.push(V),this.h.set(O.identifier,ie),V}getLastInputBox(O){this.o.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const j=this.h.get(O.identifier),z=j&&j[j.length-1];return z&&z.inputBox}$provideOriginalResource(O,j,z){const M=r.URI.revive(j);this.o.trace("ExtHostSCM#$provideOriginalResource",O,M.toString());const U=this.g.get(O);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$wh)(()=>U.quickDiffProvider.provideOriginalResource(M,z)).then(V=>V||null)}$onInputBoxValueChange(O,j){this.o.trace("ExtHostSCM#$onInputBoxValueChange",O);const z=this.g.get(O);return z&&z.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(O,j,z,M){this.o.trace("ExtHostSCM#$executeResourceCommand",O,j,z);const U=this.g.get(O);if(!U)return Promise.resolve(void 0);const V=U.getResourceGroup(j);return V?V.$executeResourceCommand(z,M):Promise.resolve(void 0)}$validateInput(O,j,z){this.o.trace("ExtHostSCM#$validateInput",O);const M=this.g.get(O);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,L.$wh)(()=>M.inputBox.validateInput(j,z)).then(U=>{if(!U)return Promise.resolve(void 0);const V=w.MarkdownString.fromStrict(U.message);return V?Promise.resolve([V,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,j,z,M){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,z,M)??void 0}async $resolveHistoryItemGroupCommonAncestor2(O,j,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(j,z)??void 0}async $provideHistoryItems(O,j,z,M){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(j,z,M))?.map(ie=>n(ie))??void 0}async $provideHistoryItems2(O,j,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems2(j,z))?.map(V=>n(V))??void 0}async $provideHistoryItemSummary(O,j,z,M){const U=this.g.get(O)?.historyProvider;if(typeof U?.provideHistoryItemSummary!="function")return;const V=await U.provideHistoryItemSummary(j,z,M);return V?n(V):void 0}async $provideHistoryItemChanges(O,j,z,M){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(j,z,M)??void 0}};e.$9qc=F,e.$9qc=F=f=Je([Ve(3,I.$_j)],F)}),define(ke[315],Ie([1,0,6,15,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0;class R{static{this.a=0}constructor(T,b){this.d=b,this.c=new Map,this.b=T.getProxy(r.$HN.MainThreadShare)}async $provideShare(T,b,c){return await this.c.get(T)?.provideShare({selection:h.Range.to(b.selection),resourceUri:C.URI.revive(b.resourceUri)},c)??void 0}registerShareProvider(T,b){const c=R.a++;return this.c.set(c,b),this.b.$registerShareProvider(c,h.DocumentSelector.from(T,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$0qc=R}),define(ke[316],Ie([1,0,9,6,8,3,15,17]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=e.$_qc=void 0;class b{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$JO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$JO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,P,w,a,m,$=r.StatusBarAlignment.Left,f){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=u,this.#t=P,m&&a){this.c=(0,r.$lO)(a.identifier,m);const i=w.get(this.c);i&&($=i.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,f=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(b.a++);this.e=a,this.f=m,this.g=$,this.h=this.u(f)}u(u){if((0,T.$ig)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!b.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let P;this.m?P=this.m:P=(0,C.localize)(10779,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=b.b.get(this.o.id));const a=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,P,this.k,a,this.r?.internal,w,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$_qc=b;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(10780,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const P={message:u};return this.b.unshift(P),this.c(),new r.$JN(()=>{const w=this.b.indexOf(P);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,P){this.e=new Map,this.a=u.getProxy(h.$HN.MainThreadStatusBar),this.b=P,this.c=new c(this)}$acceptStaticEntries(u){for(const P of u)this.e.set(P.entryId,P)}createStatusBarEntry(u,P,w,a){return new b(this.a,this.b,this.e,u,P,w,a)}setStatusBarMessage(u,P){const w=this.c.setMessage(u);let a;return typeof P=="number"?a=setTimeout(()=>w.dispose(),P):typeof P<"u"&&P.then(()=>w.dispose(),()=>w.dispose()),new r.$JN(()=>{w.dispose(),clearTimeout(a)})}}e.$arc=I}),define(ke[166],Ie([1,0,30,155,73,120,74,15,2]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wQ=e.$vQ=e.$uQ=e.$tQ=void 0,r=qe(r),T=qe(T);const c=(i,s,t,o)=>{let n=s;return{enumerable:!0,configurable:!1,get(){return n},set(d){if(!t(n,d)){const l=n;n=d,i.listener?.(o(d,l))}}}},I=(i,s)=>i===s,S={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,s)=>!(i.length!==s.length||i.some(t=>!s.find(o=>t.id===o.id)))},u=i=>s=>({op:R.TestItemEventOp.SetProp,update:i(s)}),P=(i,s)=>({range:(()=>{let t;const o=u(n=>({range:r.$Nt.lift(T.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return t},set(n){i.listener?.({op:R.TestItemEventOp.DocumentSynced}),S.range(t,n)||(t=n,i.listener?.(o(n)))}}})(),label:c(i,s,S.label,u(t=>({label:t}))),description:c(i,void 0,S.description,u(t=>({description:t}))),sortText:c(i,void 0,S.sortText,u(t=>({sortText:t}))),canResolveChildren:c(i,!1,S.canResolveChildren,t=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(i,!1,S.busy,u(t=>({busy:t}))),error:c(i,void 0,S.error,u(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:c(i,[],S.tags,(t,o)=>({op:R.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:o.map(T.TestTag.from)}))}),w=i=>{const s=C.$5I.fromString(i.extId),t=new m(s.controllerId,s.localId,i.label,b.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>T.TestTag.to({id:(0,L.$$I)(o).tagId})),t},a=i=>{let s;for(const t of i.tests){const o=w(t.item);(0,h.$dQ)(o).parent=s,s=o}return s};e.$tQ=a;class m{constructor(s,t,o,n){if(t.includes(C.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const d=(0,h.$cQ)(this,s);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof $?void 0:d.parent}},children:{value:(0,R.$bQ)(d,h.$dQ,m),enumerable:!0,writable:!1},...P(d,o)})}}e.$uQ=m;class $ extends m{constructor(s,t){super(s,s,t,void 0),this._isRoot=!0}}e.$vQ=$;class f extends R.$0P{constructor(s,t,o){super({controllerId:s,getDocumentVersion:n=>n&&o.getDocument(n)?.version,getApiFor:h.$dQ,getChildren:n=>n.children,root:new $(s,t),toITestItem:T.TestItem.from})}}e.$wQ=f}),define(ke[34],Ie([1,0,17,9,15,24,6,18,11,51,30,57,2,3,5,19,166,21,53,52,42,91,94,32]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=e.$GQ=e.$FQ=e.$EQ=e.$DQ=e.$CQ=void 0,h=qe(h),C=qe(C);let d=class{#e;#t;#i;constructor(k,A,p){this.b=new Map,this.c=new Map,this.#e=k.getProxy(L.$HN.MainThreadCommands),this.d=A,this.#i=p,this.#t=k.getProxy(L.$HN.MainThreadTelemetry),this.converter=new l(this,v=>{const F=this.c.get(v);return F?.result===E.Void?F:void 0},A),this.f=[{processArgument(v){return(0,c.$bi)(v)}},{processArgument(v){return(0,R.$fo)(v,function(F){if(I.$Nt.isIRange(F))return C.Range.to(F);if(S.$Mt.isIPosition(F))return C.Position.to(F);if(I.$Nt.isIRange(F.range)&&u.URI.isUri(F.uri))return C.location.to(F);if(F instanceof $.$Ne)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const A=this.registerCommand(!1,k.id,async(...p)=>{const v=k.args.map((N,O)=>{if(!N.validate(p[O]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${typeof p[O]=="object"?JSON.stringify(p[O],null,"	"):p[O]} `);return N.convert(p[O])}),F=await this.executeCommand(k.internalId,...v);return k.result.convert(F,p,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new h.$JN(()=>{A.dispose(),this.c.delete(k.id)})}registerCommand(k,A,p,v,F,N){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:p,thisArg:v,metadata:F,extension:N}),k&&this.#e.$registerCommand(A),new h.$JN(()=>{this.b.delete(A)&&k&&this.#e.$unregisterCommand(A)})}executeCommand(k,...A){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,A,!0)}async g(k,A,p){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,A,!1);{let v=!1;const F=(0,R.$fo)(A,function(N){if(N instanceof h.$KN)return C.Position.from(N);if(N instanceof h.$LN)return C.Range.from(N);if(N instanceof h.$XN)return C.location.from(N);if(h.$bP.isNotebookRange(N))return C.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,$.$Ne.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,$.$Ne.wrap(N);if(N instanceof $.$Ne)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,v?new f.$Ww(F):F,p);return(0,c.$bi)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,A,!1);throw N}}}async h(k,A,p){const v=this.b.get(k);if(!v)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:O}=v;if(O?.args)for(let z=0;z<O.args.length;z++)try{(0,r.$vg)(A[z],O.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${O.args[z].name}' - ${O.args[z].description}`)}const j=s.$fe.create();try{return await F.apply(N,A)}catch(z){if(k===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...A);M&&(k=M.command)}if(this.d.error(z,k,v.extension?.identifier),!p)throw z;if(v.extension?.identifier){const M=this.#i.onExtensionError(v.extension.identifier,z);this.d.trace("forwarded error to extension?",M,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$pj)(z)),this.id=k,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,k,j.elapsed())}}j(k,A,p){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$wp(A),duration:p})}$executeContributedCommand(k,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const p=this.b.get(k);return p?(A=A.map(v=>this.f.reduce((F,N)=>N.processArgument(F,p.extension?.identifier),v)),this.h(k,A,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(A=>(k&&(A=A.filter(p=>p[0]!=="_")),A))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[A,p]of this.b){const{metadata:v}=p;v&&(k[A]=v)}return Promise.resolve(k)}};e.$CQ=d,e.$CQ=d=Je([Ve(0,a.$hQ),Ve(1,b.$_j),Ve(2,o.$BQ)],d),e.$DQ=(0,w.$Ei)("IExtHostCommands");class l{constructor(k,A,p){this.d=k,this.f=A,this.g=p,this.delegatingCommandId=`__vsc${(0,n.$1g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,A){if(!k)return;const p={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return p;const v=this.f(k.command);if(v)p.id=v.internalId,p.arguments=v.args.map((F,N)=>F.convert(k.arguments&&k.arguments[N]));else if((0,T.$Kb)(k.arguments)){const F=`${k.command} /${++this.c}`;this.b.set(F,k),A.add((0,P.$Sc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),p.$ident=F,p.id=this.delegatingCommandId,p.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return p}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const A=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$EQ=l;class g{static{this.Uri=new g("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new g("position","A position in a text document",k=>h.$KN.isPosition(k),C.Position.from)}static{this.Range=new g("range","A range in a text document",k=>h.$LN.isRange(k),C.Range.from)}static{this.Selection=new g("selection","A selection in a text document",k=>h.$MN.isSelection(k),C.Selection.from)}static{this.Number=new g("number","",k=>typeof k=="number",k=>k)}static{this.String=new g("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=g.Arr(g.String)}static Arr(k){return new g(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,A=>Array.isArray(A)&&A.every(p=>k.validate(p)),A=>A.map(p=>k.convert(p)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",k=>k instanceof h.$0N,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",k=>k instanceof h.$wP,C.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VS Code TestItem",k=>k instanceof m.$uQ,C.TestItem.from)}constructor(k,A,p,v){this.name=k,this.description=A,this.validate=p,this.convert=v}optional(){return new g(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,A){return new g(k??this.name,A??this.description,this.validate,this.convert)}}e.$FQ=g;class E{static{this.Void=new E("no result",k=>k)}constructor(k,A){this.description=k,this.convert=A}}e.$GQ=E;class D{constructor(k,A,p,v,F){this.id=k,this.internalId=A,this.description=p,this.args=v,this.result=F}}e.$HQ=D}),define(ke[317],Ie([1,0,18,14,2,87,142,35,34,15,9]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=void 0,R=qe(R),c=qe(c),I=qe(I);const S=[new b.$HQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to an array of DocumentHighlight-instances.",P(c.DocumentHighlight.to))),new b.$HQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$FQ.Uri],new b.$GQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,r.$Jb)(a))return;class $ extends I.$5N{static to(i){const s=new $(i.name,c.SymbolKind.to(i.kind),i.containerName||"",new I.$XN(m[0],c.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=c.Range.to(i.selectionRange),s.children=i.children?i.children.map($.to):[],s}}return a.map($.to)})),new b.$HQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$FQ.Uri,new b.$FQ("options","Formatting options",a=>!0,a=>a)],new b.$GQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$HQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$FQ.Uri,b.$FQ.Range,new b.$FQ("options","Formatting options",a=>!0,a=>a)],new b.$GQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$HQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$FQ.Uri,b.$FQ.Position,new b.$FQ("ch","Trigger character",a=>typeof a=="string",a=>a),new b.$FQ("options","Formatting options",a=>!0,a=>a)],new b.$GQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$HQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$HQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$HQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$HQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$HQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to an array of Location-instances.",P(c.location.to))),new b.$HQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new b.$HQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$FQ.Uri,new b.$FQ("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>I.$KN.isPosition(m)),a=>a.map(c.Position.from))],new b.$GQ("A promise that resolves to an array of ranges.",a=>a.map(m=>{let $;for(const f of m.reverse())$=new I.$9N(c.Range.to(f),$);return $}))),new b.$HQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$FQ.String.with("query","Search string")],new b.$GQ("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(c.WorkspaceSymbol.to))),new b.$HQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(c.CallHierarchyItem.to))),new b.$HQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$FQ.CallHierarchyItem],new b.$GQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(c.CallHierarchyIncomingCall.to))),new b.$HQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$FQ.CallHierarchyItem],new b.$GQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(c.CallHierarchyOutgoingCall.to))),new b.$HQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:c.Range.to(a.range),placeholder:a.text}})),new b.$HQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$FQ.Uri,b.$FQ.Position,b.$FQ.String.with("newName","The new symbol name")],new b.$GQ("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return c.WorkspaceEdit.to(a)}})),new b.$HQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$FQ.Uri,b.$FQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$GQ("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(c.DocumentLink.to))),new b.$HQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$FQ.Uri],new b.$GQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$5O(a.tokenTypes,a.tokenModifiers)})),new b.$HQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$FQ.Uri],new b.$GQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,L.$Vdb)(a);if(m.type==="full")return new I.$7O(m.data,void 0)})),new b.$HQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$FQ.Uri,b.$FQ.Range.optional()],new b.$GQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$5O(a.tokenTypes,a.tokenModifiers)})),new b.$HQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$FQ.Uri,b.$FQ.Range],new b.$GQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,L.$Vdb)(a);if(m.type==="full")return new I.$7O(m.data,void 0)})),new b.$HQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$FQ.Uri,b.$FQ.Position,b.$FQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$FQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$GQ("A promise that resolves to a CompletionList-instance.",(a,m,$)=>{if(!a)return new I.$iO([]);const f=a.suggestions.map(i=>c.CompletionItem.to(i,$));return new I.$iO(f,a.incomplete)})),new b.$HQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$FQ.Uri,b.$FQ.Position,b.$FQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$GQ("A promise that resolves to SignatureHelp.",a=>{if(a)return c.SignatureHelp.to(a)})),new b.$HQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$FQ.Uri,b.$FQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$GQ("A promise that resolves to an array of CodeLens-instances.",(a,m,$)=>P(f=>new I.$aO(c.Range.to(f.range),f.command&&$.fromInternal(f.command)))(a))),new b.$HQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$FQ.Uri,new b.$FQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>I.$LN.isRange(a),a=>I.$MN.isSelection(a)?c.Selection.from(a):c.Range.from(a)),b.$FQ.String.with("kind","Code action kind to return code actions for").optional(),b.$FQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$GQ("A promise that resolves to an array of Command-instances.",(a,m,$)=>P(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return $.fromInternal(f.command)}else{const i=new I.$7N(f.title,f.kind?new I.$8N(f.kind):void 0);return f.edit&&(i.edit=c.WorkspaceEdit.to(f.edit)),f.command&&(i.command=$.fromInternal(f.command)),i.isPreferred=f.isPreferred,i}})(a))),new b.$HQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$FQ.Uri],new b.$GQ("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new I.$oO(c.Range.to(m.range),c.Color.to(m.color))):[])),new b.$HQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$FQ("color","The color to show and insert",a=>a instanceof I.$nO,c.Color.from),new b.$FQ("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:c.Range.from(a.range)}))],new b.$GQ("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(c.ColorPresentation.to):[])),new b.$HQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$FQ.Uri,b.$FQ.Range],new b.$GQ("A promise that resolves to an array of Inlay objects",(a,m,$)=>a.map(c.InlayHint.to.bind(void 0,$)))),new b.$HQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$FQ.Uri],new b.$GQ("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(c.FoldingRange.to)})),new b.$HQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$GQ("A promise that resolves to an array of NotebookContentProvider static info objects.",P(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>c.NotebookExclusiveDocumentPattern.to(m))})))),new b.$HQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$FQ.Uri,b.$FQ.Range,new b.$FQ("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof I.$LN,a=>c.InlineValueContext.from(a))],new b.$GQ("A promise that resolves to an array of InlineValue objects",a=>a.map(c.InlineValue.to))),new b.$HQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$FQ("uriOrString","Uri-instance or string (only http/https)",a=>C.URI.isUri(a)||typeof a=="string"&&(0,h.$Og)(a,h.Schemas.http,h.Schemas.https),a=>a),new b.$FQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional(),b.$FQ.String.with("label","").optional()],b.$GQ.Void),new b.$HQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$FQ.Uri.with("resource","Resource to open"),b.$FQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$FQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional()],b.$GQ.Void),new b.$HQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$FQ.Uri.with("left","Left-hand side resource of the diff editor"),b.$FQ.Uri.with("right","Right-hand side resource of the diff editor"),b.$FQ.String.with("title","Human readable title for the diff editor").optional(),new b.$FQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)]).optional()],b.$GQ.Void),new b.$HQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$FQ.String.with("title","Human readable title for the changes editor"),new b.$FQ("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[$,f,i]=m;if(!C.URI.isUri($)||!C.URI.isUri(f)&&f!==void 0&&f!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],b.$GQ.Void),new b.$HQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$FQ.Uri,b.$FQ.Position],new b.$GQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$HQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$FQ.TypeHierarchyItem],new b.$GQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$HQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$FQ.TypeHierarchyItem],new b.$GQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$HQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$FQ.TestItem],b.$GQ.Void),new b.$HQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$FQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$GQ.Void),new b.$HQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$FQ.String.with("name","The context key name"),new b.$FQ("value","The context key value",()=>!0,a=>a)],b.$GQ.Void),new b.$HQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$FQ.Uri,b.$FQ.StringArray,new b.$FQ("MappedEditsContext","Mapped Edits Context",a=>c.MappedEditsContext.is(a),a=>c.MappedEditsContext.from(a))],new b.$GQ("A promise that resolves to a workspace edit or null",a=>a?c.WorkspaceEdit.to(a):null)),new b.$HQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$FQ("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?c.Range.from(a.initialRange):void 0,initialSelection:I.$MN.isSelection(a.initialSelection)?c.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?c.Position.from(a.position):void 0}})],b.$GQ.Void)];class u{static register(m){S.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",T.$Dj)}}e.$ppc=u;function P(a){return m=>{if(Array.isArray(m))return m.map(a)}}function w(a){if(!Array.isArray(a))return;const m=[];for(const $ of a)R.$Ku($)?m.push(c.DefinitionLink.to($)):m.push(c.location.to($));return m}}),define(ke[318],Ie([1,0,2,34]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=void 0;class C{constructor(L,T,b,c,I){this.a=T,this.b=b,this.c=c;const S=new h.$HQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$FQ("showOptions","Show Options",u=>!0,u=>u),new h.$FQ("resource","Interactive resource Uri",u=>!0,u=>u),new h.$FQ("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$FQ("title","Interactive editor title",u=>!0,u=>u)],new h.$GQ("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const P=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:P.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(L,T,b,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:b,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$Qqc=C}),define(ke[319],Ie([1,0,18,7,20,4,3,28,2,23,11,6,34,15,9,121,261,25,53,262]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=void 0,e.$Zqc=g,P=qe(P);let s=class{constructor(D,y,k,A,p){this.m=y,this.n=k,this.o=A,this.q=p,this.b=new T.$Ac,this.c=new T.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$le,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(S.$HN.MainThreadNotebookKernels);const v=new u.$HQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$FQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],u.$GQ.Void),F=new u.$HQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$FQ.Uri],new u.$GQ("A promise that resolves to an array of variables",(N,O)=>N.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(F)}createNotebookController(D,y,k,A,p,v){for(const re of this.j.values())if(re.controller.id===y&&c.$qn.equals(D.identifier,re.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${D.identifier.value}, ${y}`);const O=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${D.identifier}'`);let j=!1;const z=new R.$le,M=new R.$le,U={id:g(D.identifier,y),notebookType:k,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:A||D.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let V=p??O,ie,B;this.a.$addKernel(F,U).catch(re=>{console.log(re),j=!0});let Y=0;const J=()=>{if(j)return;const re=++Y;Promise.resolve().then(()=>{re===Y&&this.a.$updateKernel(F,U)})},_=new T.$Ac,le={get id(){return y},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return U.label},set label(re){U.label=re??D.displayName??D.name,J()},get detail(){return U.detail??""},set detail(re){U.detail=re,J()},get description(){return U.description??""},set description(re){U.description=re,J()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(re){U.supportedLanguages=re,J()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(re){U.supportsExecutionOrder=re,J()},get rendererScripts(){return U.preloads?U.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(re){V=re??O},get interruptHandler(){return ie},set interruptHandler(re){ie=re,U.supportsInterrupt=!!re,J()},set variableProvider(re){(0,$.$fH)(D,"notebookVariableProvider"),B=re,U.hasVariableProvider=!!re,re?.onDidChangeVariables(Se=>N.a.$variablesUpdated(Se.uri)),J()},get variableProvider(){return B},createNotebookCellExecution(re){if(j)throw new Error("notebook controller is DISPOSED");if(!_.has(re.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return N._createNotebookCellExecution(re,g(D.identifier,this.id))},createNotebookExecution(re){if((0,$.$fH)(D,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!_.has(re.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return N._createNotebookExecution(re,g(D.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${F}], DISPOSED`),j=!0,this.j.delete(F),z.dispose(),M.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(re,Se){Se===w.NotebookControllerAffinity2.Hidden&&(0,$.$fH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,re.uri,Se)},onDidReceiveMessage:M.event,postMessage(re,Se){return(0,$.$fH)(D,"notebookMessaging"),N.a.$postMessage(F,Se&&N.n.getIdByEditor(Se),re)},asWebviewUri(re){return(0,$.$fH)(D,"notebookMessaging"),(0,a.$CDb)(re,N.m.remote)}};return this.j.set(F,{extensionId:D.identifier,controller:le,onDidReceiveMessage:M,onDidChangeSelection:z,associatedNotebooks:_}),le}getIdByController(D){for(const[y,k]of this.j)if(k.controller===D)return g(k.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const k=this.g++,A=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(k,y);const p={dispose:()=>{this.f.delete(k),A.a.$removeKernelDetectionTask(k)}};return this.f.set(k,p),p}registerKernelSourceActionProvider(D,y,k){const A=this.i++,p=typeof k.onDidChangeNotebookKernelSourceActions=="function"?A:void 0,v=this;this.h.set(A,k),this.q.trace(`NotebookKernelSourceActionProvider[${A}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(A,A,y);let F;return p!==void 0&&(F=k.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(A),v.a.$removeKernelSourceActionProvider(A,A),F?.dispose()}}}async $provideKernelSourceActions(D,y){const k=this.h.get(D);if(k){const A=new L.$Tc;return(await k.provideNotebookKernelSourceActions(y)??[]).map(v=>P.NotebookKernelSourceAction.from(v,this.o.converter,A))}return[]}$acceptNotebookAssociation(D,y,k){const A=this.j.get(D);if(A){const p=this.n.getNotebookDocument(b.URI.revive(y));k?A.associatedNotebooks.set(p.uri,!0):A.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,p.uri.toString(),k),A.onDidChangeSelection.fire({selected:k,notebook:p.apiNotebook})}}async $executeCells(D,y,k){const A=this.j.get(D);if(!A)return;const p=this.n.getNotebookDocument(b.URI.revive(y)),v=[];for(const F of k){const N=p.getCell(F);N&&v.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,p.uri.toString(),v.length),await A.controller.executeHandler.call(A.controller,v,p.apiNotebook,A.controller)}catch(F){this.q.error(`NotebookController[${D}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(D,y,k){const A=this.j.get(D);if(!A)return;const p=this.n.getNotebookDocument(b.URI.revive(y));if(A.controller.interruptHandler)await A.controller.interruptHandler.call(A.controller,p.apiNotebook);else for(const v of k){const F=p.getCell(v);F&&this.b.get(F.uri)?.cancel()}if(A.controller.interruptHandler){const v=this.c.get(p.uri);this.c.delete(p.uri),k.length&&Array.isArray(v)&&v.length&&v.forEach(F=>F.dispose())}}async $provideVariables(D,y,k,A,p,v,F){const N=this.j.get(D);if(!N)return;const O=this.n.getNotebookDocument(b.URI.revive(k)),j=N.controller.variableProvider;if(!j)return;let z;if(A!==void 0){if(z=this.s[A],!z)return}else this.s={};const M=p==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,U=j.provideVariables(O.apiNotebook,z,M,v,F);let V=0;for await(const ie of U){if(F.isCancellationRequested)return;const B={id:this.r++,name:ie.variable.name,value:ie.variable.value,type:ie.variable.type,interfaces:ie.variable.interfaces,language:ie.variable.language,expression:ie.variable.expression,hasNamedChildren:ie.hasNamedChildren,indexedChildrenCount:ie.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[B.id]=ie.variable,this.a.$receiveVariable(y,B),V++>=i.$XK)return}}$acceptKernelMessageFromRenderer(D,y,k){const A=this.j.get(D);if(!A)return;const p=this.n.getEditorById(y);A.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:k}))}$cellExecutionChanged(D,y,k){const p=this.n.getNotebookDocument(b.URI.revive(D)).getCell(y);if(p){const v=k?P.NotebookCellExecutionState.to(k):w.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:p.apiCell,state:v})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const A=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!A)throw new Error("invalid cell");if(this.b.has(A.uri))throw new Error(`duplicate execution for ${A.uri}`);const p=new o(y,A,this.a);this.b.set(A.uri,p);const v=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),v.dispose(),this.b.delete(A.uri))});return p.asApiObject()}_createNotebookExecution(D,y){const k=this.n.getNotebookDocument(D.uri),A=D.getCells().find(F=>{const N=k.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(A)throw new Error(`duplicate cell execution for ${A.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const p=new d(y,k,this.a),v=p.onDidChangeState(()=>{p.state===n.Resolved&&(p.dispose(),v.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[p,v]),p.asApiObject()}};e.$Yqc=s,e.$Yqc=s=Je([Ve(4,I.$_j)],s);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class o extends L.$Uc{static{this.a=0}get state(){return this.f}constructor(D,y,k){super(),this.m=y,this.n=k,this.b=o.a++,this.c=new R.$le,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$we),this.h=new l(10,A=>this.s(A)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new f.$Ww(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const k=w.$fP.ensureUniqueMimeTypes(y.items,!0);return k===y.items?P.NotebookCellOutput.from(y):P.NotebookCellOutput.from({items:k,id:y.id,metadata:y.metadata})})}async z(D,y,k){const A=this.w(y),p=this.y((0,r.$1b)(D));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:A,append:k,outputs:p})}async C(D,y,k){return D=w.$fP.ensureUniqueMimeTypes((0,r.$1b)(D),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:D.map(P.NotebookCellOutputItem.from),outputId:y.id,append:k})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(k){D.j=k,D.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(k){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,A,p){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const v=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;D.n.$completeExecution(D.b,new f.$Ww({runEndTime:A,lastRunSuccess:k,error:v}))},clearOutput(k){return D.t(),D.z([],k,!1)},appendOutput(k,A){return D.t(),D.z(k,A,!0)},replaceOutput(k,A){return D.t(),D.z(k,A,!1)},appendOutputItems(k,A){return D.t(),D.C(k,A,!0)},replaceOutputItems(k,A){return D.t(),D.C(k,A,!1)}})}}var n;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(n||(n={}));class d extends L.$Uc{static{this.a=0}get state(){return this.f}constructor(D,y,k){super(),this.h=y,this.j=k,this.b=d.a++,this.c=new R.$le,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new C.$we),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new h.$2h,this.b=Date.now(),(0,h.$Fh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function g(E,D){return`${E.value}/${D}`}}),define(ke[47],Ie([1,0,4,6,5,2,19,3,9,8,13,241,20,32,242,243,50,7,15,34,40]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=e.$6pc=e.$5pc=e.$4pc=void 0,e.$4pc=(0,C.$Ei)("IExtHostTerminalService");class t extends T.$Uc{constructor(p,v,F,N){super(),this.u=p,this._id=v,this.w=F,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$le),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const O=this;this.value={get name(){return O.y||""},get processId(){return O.b},get creationOptions(){return O.w},get exitStatus(){return O.j},get state(){return O.m},get selection(){return O.n},get shellIntegration(){return O.shellIntegration},sendText(j,z=!0){O.C(),O.u.$sendText(O._id,j,z)},show(j){O.C(),O.u.$show(O._id,j)},hide(){O.C(),O.u.$hide(O._id)},dispose(){O.a||(O.a=!0,O.u.$dispose(O._id))},get dimensions(){if(!(O.f===void 0||O.h===void 0))return{columns:O.f,rows:O.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??v?.cwd??void 0,env:p.env??void 0,icon:D(p.iconPath)??void 0,color:m.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(p.location,v?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,v,F,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:m.ThemeColor.isThemeColor(O)?O.id:void 0,location:v?.location||this.z(p,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,v){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in p?{viewColumn:f.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,v){this.j=Object.freeze({code:p,reason:v})}setDimensions(p,v){return p===this.f&&v===this.h||p===0||v===0?!1:(this.f=p,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(v=>{v!==p&&(this.b=Promise.resolve(p))})}}e.$5pc=t;class o{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new r.$le,this.onProcessData=this.a.event,this.b=new r.$le,this.d=new r.$le,this.onDidChangeProperty=this.d.event,this.f=new r.$le,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,v){this.g.setDimensions?.({columns:p,rows:v})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:w.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:w.ProcessPropertyType.Title,value:v})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,d=class extends T.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,v,F){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$le,this.onDidCloseTerminal=this.H.event,this.I=new r.$le,this.onDidOpenTerminal=this.I.event,this.J=new r.$le,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$le,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$le,this.onDidChangeTerminalState=this.M.event,this.N=new r.$le,this.onDidChangeShell=this.N.event,this.O=new r.$le({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$le({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(h.$HN.MainThreadTerminalService),this.y=new a.$Sxb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:N=>{const O=j=>{const z=j;return this.getTerminalById(z.instanceId)?.value};switch(N?.$mid){case s.MarshalledId.TerminalContext:return O(N);default:{if(Array.isArray(N))for(let j=0;j<N.length&&N[j].$mid===s.MarshalledId.TerminalContext;j++)N[j]=O(N[j]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,v){const F=new t(this.a,(0,P.$1g)(),p,p.name),N=new o(p.pty);return F.createExtensionTerminal(p.location,v,this.R(p,v).resolvedExtHostIdentifier,D(p.iconPath),y(p.color)).then(O=>{const j=this.S(O,N);this.h[O]=j}),this.f.push(F),F.value}R(p,v){if(v=v||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const F=p.location.parentTerminal;if(F){const N=this.f.find(O=>O.value===F);N&&(v.resolvedExtHostIdentifier=N._id)}}else p.location&&typeof p.location!="object"?v.location=p.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(p,v){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const N=new o(v),O=this.S(p,N);this.h[p]=O}async $acceptActiveTerminalChanged(p){const v=this.b;if(p===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(p);F&&(this.b=F,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,v){const F=this.getTerminalById(p);F&&this.O.fire({terminal:F.value,data:v})}async $acceptTerminalDimensions(p,v,F){const N=this.getTerminalById(p);N&&N.setDimensions(v,F)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(p,v){const F=this.getTerminalById(p);F&&this.P.fire({terminal:F.value,...v})}async $acceptTerminalMaximumDimensions(p,v,F){this.g.get(p)?.resize(v,F)}async $acceptTerminalTitleChange(p,v){const F=this.getTerminalById(p);F&&(F.name=v)}async $acceptTerminalClosed(p,v,F){const N=this.X(this.f,p);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(v,F),this.H.fire(O.value)}}$acceptTerminalOpened(p,v,F,N){if(v){const z=this.X(this.f,v);if(z!==null){this.f[z]._id=p,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:R.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},j=new t(this.a,p,O,F);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(p,v){this.getTerminalById(p)?._setProcessId(v)}async $startExtensionTerminal(p,v){const F=this.getTerminalById(p);if(!F)return{message:(0,c.localize)(10777,null,p)};F.isOpen||await new Promise(O=>{const j=this.onDidOpenTerminal(async z=>{z===F.value&&(j.dispose(),O())})});const N=this.g.get(p);N?N.startSendingEvents(v):this.j[p]={initialDimensions:v}}S(p,v){const F=new T.$Tc;F.add(v.onProcessReady(O=>this.a.$sendProcessReady(p,O.pid,O.cwd,O.windowsPty))),F.add(v.onDidChangeProperty(O=>this.a.$sendProcessProperty(p,O))),this.y.startBuffering(p,v.onProcessData),F.add(v.onProcessExit(O=>this.U(p,O))),this.g.set(p,v);const N=this.j[p];return N&&v instanceof o&&(v.startSendingEvents(N.initialDimensions),delete this.j[p]),F}$acceptProcessAckDataEvent(p,v){this.g.get(p)?.acknowledgeDataEvent(v)}$acceptProcessInput(p,v){this.g.get(p)?.input(v)}$acceptTerminalInteraction(p){const v=this.getTerminalById(p);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(p,v){this.getTerminalById(p)?.setSelection(v)}$acceptProcessResize(p,v,F){try{this.g.get(p)?.resize(v,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(p,v){this.g.get(p)?.shutdown(v)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(p,{type:w.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(v=>this.a.$sendProcessProperty(p,{type:w.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new b.$JN(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,v,F){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,F),this.a.$registerProfileProvider(v,p.identifier.value),new b.$JN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(p,v,F){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,F),this.a.$registerQuickFixProvider(p,v),new b.$JN(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,v){const F=new u.$we().token;if(F.isCancellationRequested)return;const N=this.D.get(p);if(!N)return;const O=await N.provideTerminalQuickFixes(v,F);if(O===null||Array.isArray(O)&&O.length===0)return;const j=new T.$Tc;if(this.w.value=j,!Array.isArray(O))return O?f.TerminalQuickFix.from(O,this.Q.converter,j):void 0;const z=[];for(const M of O){const U=f.TerminalQuickFix.from(M,this.Q.converter,j);U&&z.push(U)}return z}async $createContributedProfileTerminal(p,v){const F=new u.$we().token;let N=await this.C.get(p)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,v);return}this.createTerminalFromOptions(N.options,v)}}async $provideLinks(p,v){const F=this.getTerminalById(p);if(!F)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const O=new u.$we;this.G.set(p,O);const j=[],z={terminal:F.value,line:v},M=[];for(const ie of this.z)M.push($.Promises.withAsyncBody(async B=>{O.token.onCancellationRequested(()=>B({provider:ie,links:[]}));const Y=await ie.provideTerminalLinks(z,O.token)||[];O.token.isCancellationRequested||B({provider:ie,links:Y})}));const U=await Promise.all(M);if(O.token.isCancellationRequested)return[];const V=new Map;for(const ie of U)ie&&ie.links.length>0&&j.push(...ie.links.map(B=>{const Y={id:n++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return V.set(Y.id,{provider:ie.provider,link:B}),Y}));return this.F.set(p,V),j}$activateLink(p,v){const F=this.F.get(p)?.get(v);F&&F.provider.handleTerminalLink(F.link)}U(p,v){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const F=this.h[p];F&&(F.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,v)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const v=this.f.findIndex(F=>F.value===p);return v>=0?v:null}W(p,v){const F=this.X(p,v);return F!==null?p[F]:null}X(p,v){const F=p.findIndex(N=>N._id===v);return F>=0?F:null}getEnvironmentVariableCollection(p){let v=this.n.get(p.identifier.value);return v||(v=this.B(new l),this.Z(p.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(p,v){const F=(0,S.$Es)(v.map),N=(0,S.$Fs)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(p,v.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(p){p.forEach(v=>{const F=v[0],N=this.B(new l(v[1]));this.Z(F,N)})}$acceptDefaultProfile(p,v){const F=this.s;this.s=p,this.u=v,F?.path!==p.path&&this.N.fire(p.path)}Z(p,v){this.n.set(p,v),this.B(v.onDidChangeCollection(()=>{this.Y(p,v)}))}};e.$6pc=d,e.$6pc=d=Je([Ve(1,i.$DQ),Ve(2,L.$hQ)],d);class l extends T.$Uc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$le,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const v=this.j(p);let F=this.a.get(v);return F||(F=new g(this,p),this.a.set(v,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}g(p,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(p,v.scope),N=this.map.get(F),O=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==v.value||N.type!==v.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const j=this.h(p,v.scope),z={variable:p,...v,options:O};this.map.set(j,z),this.f.fire()}}get(p,v){const F=this.h(p,v),N=this.map.get(F);return N?k(N):void 0}h(p,v){const F=this.j(v);return F.length?`${p}:::${F}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const v=new Map;for(const[F,N]of this.map)this.j(N.scope)===this.j(p)&&v.set(N.variable,k(N));return v}delete(p,v){const F=this.h(p,v);this.map.delete(F),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[v,F]of this.map)F.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(v);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,v){const F=this.j(v),N=this.descriptionMap.get(F);if(!N||N.description!==p){let O;typeof p=="string"?O=p:O=p?.value.split(`

`)[0];const j={description:O,scope:v};this.descriptionMap.set(F,j),this.f.fire()}}getDescription(p){const v=this.j(p);return this.descriptionMap.get(v)?.description}n(p){const v=this.j(p);this.descriptionMap.delete(v)}}class g{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,v){this.b=p,this.d=v,this.a=new r.$le}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,v,F){this.b.replace(p,v,F,this.d)}append(p,v,F){this.b.append(p,v,F,this.d)}prepend(p,v,F){this.b.prepend(p,v,F,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,v){this.b.getVariableMap(this.d).forEach((F,N)=>p.call(v,N,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends d{constructor(p,v){super(!1,p,v)}createTerminal(p,v,F){throw new I.$$}createTerminalFromOptions(p,v){throw new I.$$}};e.$7pc=E,e.$7pc=E=Je([Ve(0,i.$DQ),Ve(1,L.$hQ)],E);function D(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function y(A){return m.ThemeColor.isThemeColor(A)?A:void 0}function k(A){const p={...A};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[167],Ie([1,0,9,3,5,6,19,47,4,2,7]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=void 0,e.$erc=(0,C.$Ei)("IExtHostTerminalShellIntegration");let S=class extends h.$Uc{constructor(m,$){super(),this.h=$,this.b=new Map,this.c=new b.$le,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new b.$le,this.onDidStartTerminalShellExecution=this.f.event,this.g=new b.$le,this.onDidEndTerminalShellExecution=this.g.event,this.a=m.getProxy(R.$HN.MainThreadTerminalShellIntegration),this.B((0,h.$Sc)(()=>{for(const[f,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(m){const $=this.h.getTerminalById(m);if(!$)return;const f=$.value;let i=this.b.get(m);i||(i=new u($.value,this.f),this.b.set(m,i),i.store.add($.onWillDispose(()=>this.b.get(m)?.dispose())),i.store.add(i.onDidRequestShellExecution(s=>this.a.$executeCommand(m,s))),i.store.add(i.onDidRequestEndExecution(s=>this.g.fire(s))),i.store.add(i.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),$.shellIntegration=i.value),this.c.fire({terminal:f,shellIntegration:i.value})}$shellExecutionStart(m,$,f,i,s){this.b.has(m)||this.$shellIntegrationChange(m);const t={value:$,confidence:f,isTrusted:i};this.b.get(m)?.startShellExecution(t,c.URI.revive(s))}$shellExecutionEnd(m,$,f,i,s){const t={value:$,confidence:f,isTrusted:i};this.b.get(m)?.endShellExecution(t,s)}$shellExecutionData(m,$){this.b.get(m)?.emitData($)}$cwdChange(m,$){this.b.get(m)?.setCwd(c.URI.revive($))}$closeTerminal(m){this.b.get(m)?.dispose(),this.b.delete(m)}};e.$frc=S,e.$frc=S=Je([Ve(0,L.$hQ),Ve(1,T.$4pc)],S);class u extends h.$Uc{get currentExecution(){return this.a}constructor(m,$){super(),this.j=m,this.m=$,this.b=!1,this.store=this.B(new h.$Tc),this.f=this.B(new b.$le),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new b.$le),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new b.$le),this.onDidRequestEndExecution=this.h.event;const f=this;this.value={get cwd(){return f.c},executeCommand(i,s){let t=i;s&&(t+=` "${s.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),f.g.fire(t);const o={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},n=f.startShellExecution(o,f.c,!0).value;return f.b=!0,n}}}startShellExecution(m,$,f){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new P(m,$??this.c);f?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,$){this.a&&(this.a.endExecution(m),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:$}),this.a=void 0)}setCwd(m){let $=!1;c.URI.isUri(this.c)?$=!c.URI.isUri(m)||this.c.toString()!==m.toString():this.c!==m&&($=!0),$&&(this.c=m,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(m,$){this.c=m,this.cwd=$,this.b=!1;const f=this;this.value={get commandLine(){return f.c},get cwd(){return f.cwd},read(){return f.d()}}}d(){if(!this.a){if(this.b)return I.$5h.EMPTY;this.a=new w}return this.a.createIterable()}emitData(m){this.a?.emitData(m)}endExecution(m){m&&(this.c=m),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends h.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Dh);const m=this.a;return new I.$5h(async f=>{this.b.push(f),await m.wait()})}emitData(m){for(const $ of this.b)$.emitOne(m)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[168],Ie([1,0,65,13,132,15,9]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=e.$oQ=void 0,R=qe(R);class T{static{this.c=new C.$mQ("TextEditorDecorationType")}constructor(u,P,w){const a=T.c.nextId();u.$registerTextEditorDecorationType(P.identifier,a,R.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:a,dispose(){u.$removeTextEditorDecorationType(a)}})}}e.$oQ=T;class b{constructor(u,P){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,P){this.k();let w=null;if(u instanceof L.$KN)w=new L.$LN(u,u);else if(u instanceof L.$LN)w=u;else throw new Error("Unrecognized location");this.l(w,P,!1)}insert(u,P){this.k(),this.l(new L.$LN(u,u),P,!0)}delete(u){this.k();let P=null;if(u instanceof L.$LN)P=u;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(u,P,w){const a=this.c.validateRange(u);this.g.push({range:a,text:P,forceMoveMarkers:w})}setEndOfLine(u){if(this.k(),u!==L.EndOfLine.LF&&u!==L.EndOfLine.CRLF)throw(0,h.$6)("endOfLine");this.h=u}}class c{constructor(u,P,w,a){this.c=u,this.d=P,this._accept(w),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize($){m.n($)},get indentSize(){return m.g},set indentSize($){m.p($)},get insertSpaces(){return m.j},set insertSpaces($){m.s($)},get cursorStyle(){return m.k},set cursorStyle($){m.t($)},get lineNumbers(){return m.l},set lineNumbers($){m.u($)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}n(u){const P=this.m(u);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}p(u){const P=this.o(u);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const P=this.q(u);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const P={};let w=!1;if(typeof u.tabSize<"u"){const a=this.m(u.tabSize);a==="auto"?(w=!0,P.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,w=!0,P.tabSize=a)}if(typeof u.indentSize<"u"){const a=this.o(u.indentSize);a==="tabSize"?(w=!0,P.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,w=!0,P.indentSize=a)}if(typeof u.insertSpaces<"u"){const a=this.q(u.insertSpaces);a==="auto"?(w=!0,P.insertSpaces=a):this.j!==a&&(this.j=a,w=!0,P.insertSpaces=a)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,w=!0,P.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,w=!0,P.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(u,P){P.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(w)})}}e.$pQ=c;class I{constructor(u,P,w,a,m,$,f,i){this.id=u,this.j=P,this.k=w,this.g=!1,this.h=new Set,this.c=m,this.d=new c(this.j,this.id,$,w),this.e=f,this.f=i;const s=this;this.value=Object.freeze({get document(){return a.value},set document(t){throw new h.$8("document")},get selection(){return s.c&&s.c[0]},set selection(t){if(!(t instanceof L.$MN))throw(0,h.$6)("selection");s.c=[t],s.l()},get selections(){return s.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof L.$MN)))throw(0,h.$6)("selections");s.c=t,s.l()},get visibleRanges(){return s.e},set visibleRanges(t){throw new h.$8("visibleRanges")},get options(){return s.d.value},set options(t){s.g||s.d.assign(t)},get viewColumn(){return s.f},set viewColumn(t){throw new h.$8("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new b(a.value,o);return t(n),s.m(n)},insertSnippet(t,o,n={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!o||Array.isArray(o)&&o.length===0)d=s.c.map(l=>R.Range.from(l));else if(o instanceof L.$KN){const{lineNumber:l,column:g}=R.Position.from(o);d=[{startLineNumber:l,startColumn:g,endLineNumber:l,endColumn:g}]}else if(o instanceof L.$LN)d=[R.Range.from(o)];else{d=[];for(const l of o)if(l instanceof L.$LN)d.push(R.Range.from(l));else{const{lineNumber:g,column:E}=R.Position.from(l);d.push({startLineNumber:g,startColumn:E,endLineNumber:g,endColumn:E})}}return P.$tryInsertSnippet(u,a.value.version,t.value,d,n)},setDecorations(t,o){const n=o.length===0;n&&!s.h.has(t.key)||(n?s.h.delete(t.key):s.h.add(t.key),s.n(()=>{if(R.$eQ(o))return P.$trySetDecorations(u,t.key,R.$fQ(o));{const d=new Array(4*o.length);for(let l=0,g=o.length;l<g;l++){const E=o[l];d[4*l]=E.start.line+1,d[4*l+1]=E.start.character+1,d[4*l+2]=E.end.line+1,d[4*l+3]=E.end.character+1}return P.$trySetDecorationsFast(u,t.key,d)}}))},revealRange(t,o){s.n(()=>P.$tryRevealRange(u,R.Range.from(t),o||L.TextEditorRevealType.Default))},show(t){P.$tryShowEditor(u,R.ViewColumn.from(t))},hide(){P.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const P=u.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const w=P.edits.map(m=>m.range);w.sort((m,$)=>m.end.line===$.end.line?m.end.character===$.end.character?m.start.line===$.start.line?m.start.character-$.start.character:m.start.line-$.start.line:m.end.character-$.end.character:m.end.line-$.end.line);for(let m=0,$=w.length-1;m<$;m++){const f=w[m].end;if(w[m+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=P.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,a,{setEndOfLine:typeof P.setEndOfLine=="number"?R.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$qQ=I}),define(ke[63],Ie([1,0,65,4,3,2,5,6,164,19,168,15,11,28,14,39,49]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=void 0,r=qe(r),S=qe(S);class ${constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(s,t){this.h=s,this.i=t,this.a=null,this.b=new Map,this.c=new P.$Ac,this.d=new h.$le,this.e=new h.$le,this.f=new h.$le,this.g=new h.$le,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const t=[],o=[],n=[];if(s.removedDocuments)for(const d of s.removedDocuments){const l=R.URI.revive(d),g=this.c.get(l);g?.unref()&&(this.c.delete(l),t.push(g.value))}if(s.addedDocuments)for(const d of s.addedDocuments){const l=R.URI.revive(d.uri);let g=this.c.get(l);if(g&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);g||(g=new $(new b.$kQ(this.h.getProxy(T.$HN.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,g),o.push(g.value)),g.ref()}if(s.removedEditors)for(const d of s.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&n.push(l)}if(s.addedEditors)for(const d of s.addedEditors){const l=R.URI.revive(d.documentUri);r.ok(this.c.has(l),`document '${l}' does not exist`),r.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const g=this.c.get(l).value,E=new I.$qQ(d.id,this.h.getProxy(T.$HN.MainThreadTextEditors),this.i,new m.$T(()=>g.document),d.selections.map(S.Selection.to),d.options,d.visibleRanges.map(D=>S.Range.to(D)),typeof d.editorPosition=="number"?S.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,E)}s.newActiveEditor!==void 0&&(r.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,C.$Pc)(t),(0,C.$Pc)(n),s.removedDocuments&&this.e.fire(t),s.addedDocuments&&this.d.fire(o),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return a.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const t=this.b.get(this.a);return s?t:t?.value}allEditors(){return[...this.b.values()]}};e.$rQ=f,e.$rQ=f=Je([Ve(0,c.$hQ),Ve(1,u.$_j)],f),e.$sQ=(0,L.$Ei)("IExtHostDocumentsAndEditors")}),define(ke[98],Ie([1,0,7,21,20,4,79,60,3,40,17,32,5,11,6,34,63,19,166,15,9,264,73,120,74,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=e.$nqc=e.$mqc=e.$lqc=void 0,i=qe(i);let g=0;const E=new WeakMap;e.$lqc=(0,u.$Ei)("IExtHostTesting");let D=class extends b.$Uc{constructor(B,Y,J,_){super(),this.C=Y,this.D=J,this.F=_,this.f=this.B(new R.$le),this.g=new Map,this.w=this.B(new R.$le),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=B.getProxy(w.$HN.MainThreadTesting),this.m=new j(this.h),this.j=new p(this.h,Y),J.registerArgumentProcessor({processArgument:le=>{switch(le?.$mid){case c.MarshalledId.TestItemContext:{const re=le,Se=re.tests[re.tests.length-1].item.extId;return this.g.get(o.$5I.root(Se))?.collection.tree.get(Se)?.actual??(0,f.$tQ)(le)}case c.MarshalledId.TestMessageMenuArgs:{const{test:re,message:Se}=le,me=re.item.extId;return{test:this.g.get(o.$5I.root(me))?.collection.tree.get(me)?.actual??(0,f.$tQ)({$mid:c.MarshalledId.TestItemContext,tests:[re]}),message:i.TestMessage.to(Se)}}default:return le}}}),J.registerCommand(!1,"testing.getExplorerSelection",async()=>{const le=await J.executeCommand(t.TestCommandId.GetExplorerSelection),re=Se=>{const me=this.g.get(o.$5I.root(Se));if(me)return o.$5I.isRoot(Se)?me.controller:me.collection.tree.get(Se)?.actual};return{include:le?.include.map(re).filter(I.$mg)||[],exclude:le?.exclude.map(re).filter(I.$mg)||[]}})}createTestController(B,Y,J,_){if(this.g.has(Y))throw new Error(`Attempt to insert a duplicate controller with ID "${Y}"`);const le=new b.$Tc,re=le.add(new f.$wQ(Y,J,this.F));re.root.label=J;const Se=new Map,me=new Set,Q=this.h,q={items:re.root.children,get label(){return J},set label(we){J=we,re.root.label=we,Q.$updateController(Y,{label:J})},get refreshHandler(){return _},set refreshHandler(we){_=we,Q.$updateController(Y,{canRefresh:!!we})},get id(){return Y},createRunProfile:(we,ee,ae,oe,x,ne)=>{let pe=(0,T.$sj)(we);for(;Se.has(pe);)pe++;return new M(this.h,Se,me,this.w.event,Y,pe,we,ee,ae,oe,x,ne)},createTestItem(we,ee,ae){return new f.$uQ(Y,we,ee,ae)},createTestRun:(we,ee,ae=!0)=>this.j.createTestRun(B,Y,re,we,ee,ae),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const ee=we instanceof Array?we:[we];this.h.$markTestRetired(ee.map(ae=>o.$5I.fromExtHostTestItem(ae,Y).toString()))}},set resolveHandler(we){re.resolveHandler=we},get resolveHandler(){return re.resolveHandler},dispose:()=>{le.dispose()}};Q.$registerTestController(Y,J,!!_),le.add((0,b.$Sc)(()=>Q.$unregisterTestController(Y)));const se={controller:q,collection:re,profiles:Se,extension:B,activeProfiles:me};return this.g.set(Y,se),le.add((0,b.$Sc)(()=>this.g.delete(Y))),le.add(re.onDidGenerateDiff(we=>Q.$publishDiff(Y,we.map(d.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(B,Y=C.CancellationToken.None){const J=v(B);if(!J)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const _=this.g.get(J.controllerId);if(!_)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:B.preserveFocus??!0,group:U[J.kind],targets:[{testIds:B.include?.map(le=>o.$5I.fromExtHostTestItem(le,_.collection.root.id).toString())??[_.collection.root.id],profileId:J.profileId,controllerId:J.controllerId}],exclude:B.exclude?.map(le=>le.id)},Y)}registerTestFollowupProvider(B){return this.y.add(B),{dispose:()=>{this.y.delete(B)}}}$syncTests(){for(const{collection:B}of this.g.values())B.flushDiff();return Promise.resolve()}async $getCoverageDetails(B,Y,J){return(await this.j.getCoverageDetails(B,Y,J))?.map(i.TestCoverage.fromDetails)}async $disposeRun(B){this.j.disposeTestRun(B)}$configureRunProfile(B,Y){this.g.get(B)?.profiles.get(Y)?.configureHandler?.()}$setDefaultRunProfiles(B){const Y=new Map;for(const[J,_]of Object.entries(B)){const le=this.g.get(J);if(!le)continue;const re=new Map,Se=_.filter(Q=>!le.activeProfiles.has(Q)),me=[...le.activeProfiles].filter(Q=>!_.includes(Q));for(const Q of Se)re.set(Q,!0),le.activeProfiles.add(Q);for(const Q of me)re.set(Q,!1),le.activeProfiles.delete(Q);re.size&&Y.set(J,re)}this.w.fire(Y)}async $refreshTests(B,Y){await this.g.get(B)?.controller.refreshHandler?.(Y)}$publishTestResults(B){this.results=Object.freeze(B.map(Y=>{const J=i.TestResults.to(Y);return E.set(J,Y.id),J}).concat(this.results).sort((Y,J)=>J.completedAt-Y.completedAt).slice(0,32)),this.f.fire()}async $expandTest(B,Y){const J=this.g.get(o.$5I.fromString(B).controllerId)?.collection;J&&(await J.expand(B,Y<0?1/0:Y),J.flushDiff())}$acceptDiff(B){this.m.applyDiff(B.map(Y=>d.TestsDiffOp.deserialize({asCanonicalUri:J=>J},Y)))}async $runControllerTests(B,Y){return Promise.all(B.map(J=>this.G(J,!1,Y)))}async $startContinuousRun(B,Y){const J=new C.$we(Y),_=await Promise.all(B.map(le=>this.G(le,!0,J.token)));return!Y.isCancellationRequested&&!_.some(le=>le.error)&&await new Promise(le=>Y.onCancellationRequested(le)),J.dispose(!0),_}async $provideTestFollowups(B,Y){const J=this.results.find(re=>E.get(re)===B.resultId),_=J&&V(o.$5I.fromString(B.extId),J?.results);if(!_)return[];let le=[];return await Promise.all([...this.y].map(async re=>{try{const Se=await re.provideFollowup(J,_,B.taskIndex,B.messageIndex,Y);Se&&(le=le.concat(Se))}catch(Se){this.C.error("Error thrown while providing followup for test message",Se)}})),Y.isCancellationRequested?[]:le.map(re=>{const Se=g++;return this.z.set(Se,re),{title:re.title,id:Se}})}$disposeTestFollowups(B){for(const Y of B)this.z.delete(Y)}$executeTestFollowup(B){const Y=this.z.get(B);return Y?this.D.executeCommand(Y.command,...Y.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(B){B===void 0?this.j.cancelAllRuns():this.j.cancelRunById(B)}getMetadataForRun(B){for(const Y of this.j.trackers){const J=Y.getTaskIdForRun(B);if(J)return{taskId:J,runId:Y.id}}}async G(B,Y,J){const _=this.g.get(B.controllerId);if(!_)return{};const{collection:le,profiles:re,extension:Se}=_,me=re.get(B.profileId);if(!me)return{};const Q=B.testIds.map(ee=>le.tree.get(ee)).filter(I.$mg),q=B.excludeExtIds.map(ee=>_.collection.tree.get(ee)).filter(I.$mg).filter(ee=>Q.some(ae=>ae.fullId.compare(ee.fullId)===o.TestPosition.IsChild));if(!Q.length)return{};const se=new s.$mP(Q.some(ee=>ee.actual instanceof f.$vQ)?void 0:Q.map(ee=>ee.actual),q.map(ee=>ee.actual),me,Y),we=(0,d.$8I)(B)&&this.j.prepareForMainThreadTestRun(Se,se,F.fromInternal(B,_.collection),me,J);try{return await me.runHandler(se,J),{}}catch(ee){return{error:String(ee)}}finally{we&&we.hasRunningTasks&&!J.isCancellationRequested&&await R.Event.toPromise(we.onEnd)}}};e.$mqc=D,e.$mqc=D=Je([Ve(0,$.$hQ),Ve(1,P.$_j),Ve(2,a.$DQ),Ve(3,m.$sQ)],D);const y=1e4;var k;(function(ie){ie[ie.Running=0]="Running",ie[ie.Cancelling=1]="Cancelling",ie[ie.Ended=2]="Ended"})(k||(k={}));class A extends b.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(B,Y,J,_,le,re){super(),this.z=B,this.C=Y,this.D=J,this.F=_,this.G=le,this.c=k.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$le),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new C.$we(re));const Se=this.B(new r.$Qh(()=>this.H(),y));this.B(this.j.token.onCancellationRequested(()=>Se.schedule()));const me=new R.$le;this.w=me.event,this.B((0,b.$Sc)(()=>{me.fire(),me.dispose()}))}getTaskIdForRun(B){for(const[Y,{run:J}]of this.g)if(J===B)return Y}cancel(){this.c===k.Running?(this.j.cancel(),this.c=k.Cancelling):this.c===k.Cancelling&&this.H()}async getCoverageDetails(B,Y,J){const[,_]=o.$5I.fromString(B).path,le=this.y.get(B);if(!le)return[];const{report:re,extIds:Se}=le,me=this.g.get(_);if(!me)throw new Error("unreachable: run task was not found");let Q;if(Y&&re instanceof s.$sP){const se=Se.indexOf(Y);if(se===-1)return[];Q=re.fromTests[se]}return await(Q?this.F?.loadDetailedCoverageForTest?.(me.run,re,Q,J):this.F?.loadDetailedCoverage?.(me.run,re,J))??[]}createRun(B){const Y=this.z.id,J=this.z.controllerId,_=(0,S.$1g)(),le=Q=>(q,...se)=>{if(Se){this.D.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.J(q),Q(q,...se)},re=(Q,q)=>{const se=q instanceof Array?q.map(i.TestMessage.from):[i.TestMessage.from(q)];if(Q.uri&&Q.range){const we={range:i.Range.from(Q.range),uri:Q.uri};for(const ee of se)ee.location=ee.location||we}this.C.$appendTestMessagesInRun(Y,_,o.$5I.fromExtHostTestItem(Q,J).toString(),se)};let Se=!1;const me={isPersisted:this.z.isPersisted,token:this.j.token,name:B,onDidDispose:this.w,addCoverage:Q=>{if(Se)return;const q=Q instanceof s.$sP?Q.fromTests:[];if(q.length){(0,l.$fH)(this.G,"attributableCoverage");for(const ee of q)this.J(ee)}const se=Q.uri.toString(),we=new o.$5I([Y,_,se]).toString();this.y.set(we,{report:Q,extIds:q.map(ee=>o.$5I.fromExtHostTestItem(ee,J).toString())}),this.C.$appendCoverage(Y,_,i.TestCoverage.fromFile(J,we,Q))},enqueued:le(Q=>{this.C.$updateTestStateInRun(Y,_,o.$5I.fromExtHostTestItem(Q,J).toString(),d.TestResultState.Queued)}),skipped:le(Q=>{this.C.$updateTestStateInRun(Y,_,o.$5I.fromExtHostTestItem(Q,J).toString(),d.TestResultState.Skipped)}),started:le(Q=>{this.C.$updateTestStateInRun(Y,_,o.$5I.fromExtHostTestItem(Q,J).toString(),d.TestResultState.Running)}),errored:le((Q,q,se)=>{re(Q,q),this.C.$updateTestStateInRun(Y,_,o.$5I.fromExtHostTestItem(Q,J).toString(),d.TestResultState.Errored,se)}),failed:le((Q,q,se)=>{re(Q,q),this.C.$updateTestStateInRun(Y,_,o.$5I.fromExtHostTestItem(Q,J).toString(),d.TestResultState.Failed,se)}),passed:le((Q,q)=>{this.C.$updateTestStateInRun(Y,_,o.$5I.fromExtHostTestItem(Q,this.z.controllerId).toString(),d.TestResultState.Passed,q)}),appendOutput:(Q,q,se)=>{Se||(se&&this.J(se),this.C.$appendOutputToRun(Y,_,h.$Ne.fromString(Q),q&&i.location.from(q),se&&o.$5I.fromExtHostTestItem(se,J).toString()))},end:()=>{Se||(Se=!0,this.C.$finishedTestRunTask(Y,_),--this.f||this.I())}};return this.f++,this.g.set(_,{run:me}),this.C.$startedTestRunTask(Y,{id:_,ctrlId:this.z.controllerId,name:B,running:!0}),me}H(){for(const{run:B}of this.g.values())B.end()}I(){this.c!==k.Ended&&(this.c=k.Ended,this.m.fire())}J(B){if(!(B instanceof f.$uQ))throw new n.$_P(B.id);if(this.h.has(o.$5I.fromExtHostTestItem(B,this.z.controllerId).toString()))return;const Y=[],J=this.z.colllection.root;for(;;){const _=i.TestItem.from(B);if(Y.unshift(_),this.h.has(_.extId)||(this.h.add(_.extId),B===J))break;B=B.parent||J}this.C.$addTestsToRun(this.z.controllerId,this.z.id,Y)}dispose(){this.I(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(B,Y){this.g=B,this.h=Y,this.c=new Map,this.f=new Map}getCoverageDetails(B,Y,J){const _=o.$5I.root(B);return this.f.get(_)?.getCoverageDetails(B,Y,J)||[]}disposeTestRun(B){this.f.get(B)?.dispose(),this.f.delete(B);for(const[Y,{id:J}]of this.c)J===B&&this.c.delete(Y)}prepareForMainThreadTestRun(B,Y,J,_,le){return this.j(Y,J,_,B,le)}cancelRunById(B){this.f.get(B)?.cancel()}cancelAllRuns(){for(const B of this.c.values())B.cancel()}createTestRun(B,Y,J,_,le,re){const Se=this.c.get(_);if(Se)return Se.createRun(le);const me=F.fromPublic(Y,J,_,re),Q=v(_);this.g.$startedExtensionTestRun({controllerId:Y,continuous:!!_.continuous,profile:Q&&{group:U[Q.kind],id:Q.profileId},exclude:_.exclude?.map(se=>o.$5I.fromExtHostTestItem(se,J.root.id).toString())??[],id:me.id,include:_.include?.map(se=>o.$5I.fromExtHostTestItem(se,J.root.id).toString())??[J.root.id],preserveFocus:_.preserveFocus??!0,persist:re});const q=this.j(_,me,_.profile,B);return R.Event.once(q.onEnd)(()=>{this.g.$finishedExtensionTestRun(me.id)}),q.createRun(le)}j(B,Y,J,_,le){const re=new A(Y,this.g,this.h,J,_,le);return this.c.set(B,re),this.f.set(re.id,re),re}}e.$nqc=p;const v=ie=>{if(ie.profile){if(!(ie.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ie.profile}};class F{static fromPublic(B,Y,J,_){return new F(B,(0,S.$1g)(),_,Y)}static fromInternal(B,Y){return new F(B.controllerId,B.runId,!0,Y)}constructor(B,Y,J,_){this.controllerId=B,this.id=Y,this.isPersisted=J,this.colllection=_}}e.$oqc=F;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(B){this.j=B,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(B){this.c.add(B)}update(B){Object.assign(B.revived,i.TestItem.toPlain(B.item)),this.c.has(B)||this.f.add(B)}remove(B){if(this.c.has(B)){this.c.delete(B);return}this.f.delete(B);const Y=o.$5I.parentId(B.item.extId);if(Y&&this.h.has(Y.toString())){this.h.add(B.item.extId);return}this.g.add(B)}getChangeEvent(){const{c:B,f:Y,g:J}=this;return{get added(){return[...B].map(_=>_.revived)},get updated(){return[...Y].map(_=>_.revived)},get removed(){return[...J].map(_=>_.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class O extends d.$bJ{constructor(){super(...arguments),this.y=new R.$le,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(B){return this.f.get(B)}getMirroredTestDataByReference(B){return this.f.get(B.id)}x(B,Y){return{...B,revived:i.TestItem.toPlain(B.item),depth:Y?Y.depth+1:0,children:new Set}}w(){return new N(this.y)}}class j{constructor(B){this.f=B}checkout(){this.c||(this.c=this.g());const B=this.c;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(Y=>Y.revived)},dispose:(0,L.$cb)(()=>{--B.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(B){return this.c?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.c?.tests.apply(B)}g(){const B=new O({asCanonicalUri:Y=>Y});return this.f.$subscribeToDiffs(),{observers:0,tests:B}}}const z=(ie,B,Y,J)=>{Y?Object.assign(Y,J):B.$updateTestRunConfig(ie.controllerId,ie.profileId,J)};class M{#e;#t;#i;#n;#s;get label(){return this.f}set label(B){B!==this.f&&(this.f=B,z(this,this.#e,this.#n,{label:B}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(B){B!==this.g&&(this.g=B,z(this,this.#e,this.#n,{supportsContinuousRun:B}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(B){B!==this.isDefault&&(B?this.#t.add(this.profileId):this.#t.delete(this.profileId),z(this,this.#e,this.#n,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,z(this,this.#e,this.#n,{tag:B?i.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.c}set configureHandler(B){B!==this.c&&(this.c=B,z(this,this.#e,this.#n,{hasConfigurationHandler:!!B}))}get onDidChangeDefault(){return R.Event.chain(this.#i,B=>B.map(Y=>Y.get(this.controllerId)?.get(this.profileId)).filter(I.$mg))}constructor(B,Y,J,_,le,re,Se,me,Q,q=!1,se=void 0,we=!1){this.controllerId=le,this.profileId=re,this.f=Se,this.kind=me,this.runHandler=Q,this._tag=se,this.g=we,this.#e=B,this.#s=Y,this.#t=J,this.#i=_,Y.set(re,this);const ee=U[me];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${me}`);q&&J.add(re),this.#n={profileId:re,controllerId:le,tag:se?i.TestTag.namespace(this.controllerId,se.id):null,label:Se,group:ee,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:we},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$pqc=M;const U={[s.TestRunProfileKind.Coverage]:d.TestRunProfileBitset.Coverage,[s.TestRunProfileKind.Debug]:d.TestRunProfileBitset.Debug,[s.TestRunProfileKind.Run]:d.TestRunProfileBitset.Run};function V(ie,B){for(let Y=0;Y<ie.path.length;Y++){const J=B.find(_=>_.id===ie.path[Y]);if(!J)return;if(Y===ie.path.length-1)return J;B=J.children}}}),define(ke[320],Ie([1,0,18,4,3,6,168,15,9]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=void 0,r=qe(r),T=qe(T);class c extends C.$Uc{constructor(S,u){super(),this.m=u,this.a=new h.$le,this.b=new h.$le,this.c=new h.$le,this.f=new h.$le,this.g=new h.$le,this.h=new h.$le,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=S.getProxy(R.$HN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(S){const u=this.m.allEditors();return S?u:u.map(P=>P.value)}async showTextDocument(S,u,P){let w;typeof u=="number"?w={position:T.ViewColumn.from(u),preserveFocus:P}:typeof u=="object"?w={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:w={preserveFocus:!1};const a=await this.j.$tryShowTextDocument(S.uri,w),m=a&&this.m.getEditor(a);if(m)return m.value;throw a?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,u){return new L.$oQ(this.j,S,u).value}$acceptEditorPropertiesChanged(S,u){const P=this.m.getEditor(S);if(!P)throw new Error("unknown text editor");if(u.options&&P._acceptOptions(u.options),u.selections){const w=u.selections.selections.map(T.Selection.to);P._acceptSelections(w)}if(u.visibleRanges){const w=r.$Gb(u.visibleRanges.map(T.Range.to));P._acceptVisibleRanges(w)}if(u.options&&this.b.fire({textEditor:P.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const w=b.TextEditorSelectionChangeKind.fromValue(u.selections.source),a=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:P.value,selections:a,kind:w})}if(u.visibleRanges){const w=r.$Gb(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:P.value,visibleRanges:w})}}$acceptEditorPositionData(S){for(const u in S){const P=this.m.getEditor(u);if(!P)throw new Error("Unknown text editor");const w=T.ViewColumn.to(S[u]);P.value.viewColumn!==w&&(P._acceptViewColumn(w),this.f.fire({textEditor:P.value,viewColumn:w}))}}getDiffInformation(S){return Promise.resolve(this.j.$getDiffInformation(S))}}e.$wpc=c}),define(ke[321],Ie([1,0,2,5,6,3,9,15,23,40,17]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=e.$hrc=void 0,e.$hrc=(0,h.$Ei)("IExtHostTimeline");class S{constructor(w,a){this.b=new Map,this.c=new Map,this.a=w.getProxy(C.$HN.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(m,$)=>{if(m&&m.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(m.source)&&b.$qn.equals($,this.b.get(m.source)?.extension)){const f=m.uri===void 0?void 0:r.URI.revive(m.uri);return this.c.get(m.source)?.get(u(f))?.get(m.handle)}else return;return m}})}async $getTimeline(w,a,m,$){return this.b.get(w)?.provider.provideTimeline(r.URI.revive(a),m,$)}registerTimelineProvider(w,a,m,$){const f=new R.$Tc,i=this.d(a.id,$,f).bind(this);let s;a.onDidChange&&(s=a.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:a.id}),this));const t=this.c;return this.f({...a,scheme:w,onDidChange:void 0,async provideTimeline(o,n,d){n?.resetCache&&(f.clear(),t.get(a.id)?.clear());const l=await a.provideTimeline(o,n,d);if(l==null)return;const g=i(o,n);return{...l,source:a.id,items:l.items.map(g)}},dispose(){for(const o of t.values())o.get(a.id)?.clear();s?.dispose(),f.dispose()}},m)}d(w,a,m){return($,f)=>{let i;if(f?.cacheResults){let s=this.c.get(w);s===void 0&&(s=new Map,this.c.set(w,s));const t=u($);i=s.get(t),i===void 0&&(i=new Map,s.set(t,i))}return s=>{const{iconPath:t,...o}=s,n=`${w}|${s.id??s.timestamp}`;i?.set(n,s);let d,l,g;s.iconPath&&(t instanceof L.$IO?g={id:t.id,color:t.color}:r.URI.isUri(t)?(d=t,l=t):{light:d,dark:l}=t);let E;return L.$bO.isMarkdownString(o.tooltip)?E=T.MarkdownString.from(o.tooltip):(0,I.$eg)(o.tooltip)?E=o.tooltip:L.$bO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(o.detail)):(0,I.$eg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=o.detail),{...o,id:o.id??void 0,handle:n,source:w,command:s.command?a.toInternal(s.command,m):void 0,icon:d,iconDark:l,themeIcon:g,tooltip:E,accessibilityInformation:s.accessibilityInformation}}}}f(w,a){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:a}),(0,R.$Sc)(()=>{for(const $ of this.c.values())$.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$irc=S;function u(P){return P?.toString()}}),define(ke[322],Ie([1,0,8,22,2,4,3,255,7,9,17,18,15,85,20,209,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0,c=qe(c);function $(s,t){if((0,I.$eg)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let o;return Array.isArray(s.highlights)&&(o=s.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),o=o.length?o:void 0),{label:s.label,highlights:o}}}class f extends L.$Uc{constructor(t,o,n){super(),this.f=t,this.g=o,this.h=n,this.a=new Map,this.b=new a.$L_;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(g=>d(g)?this.r(g):g):l})}registerTreeDataProvider(t,o,n){const d=this.createTreeView(t,{treeDataProvider:o},n);return{dispose:()=>d.dispose()}}createTreeView(t,o,n){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=o.dragAndDropController?.dropMimeTypes??[],l=o.dragAndDropController?.dragMimeTypes??[],g=!!o.dragAndDropController?.handleDrag,E=!!o.dragAndDropController?.handleDrop,D=this.m(t,o,n),y={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:g,hasHandleDrop:E,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,y),A={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,m.$fH)(n,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,m.$fH)(n,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(p){(0,P.$5k)(p)&&(0,m.$fH)(n,"treeViewMarkdownMessage"),D.message=p},get title(){return D.title},set title(p){D.title=p},get description(){return D.description},set description(p){D.description=p},get badge(){return D.badge},set badge(p){p!==void 0&&c.ViewBadge.isViewBadge(p)?D.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(D.badge=void 0)},reveal:(p,v)=>D.reveal(p,v),dispose:async()=>{await k,this.a.delete(t),D.dispose()}};return this.B(A),A}$getChildren(t,o){const n=this.a.get(t);return n?n.getChildren(o):Promise.reject(new T.$BG(t))}async $handleDrop(t,o,n,d,l,g,E,D){const y=this.a.get(t);if(!y)return Promise.reject(new T.$BG(t));const k=u.DataTransfer.toDataTransfer(n,async A=>(await this.f.$resolveDropFileData(t,o,A)).buffer);return E===t&&D&&await this.j(k,y,D,l,g),y.onDrop(k,d,l)}async j(t,o,n,d,l){const g=this.b.removeDragOperationTransfer(l);if(g)(await g)?.forEach((E,D)=>{E&&t.set(D,E)});else if(l&&o.handleDrag){const E=o.handleDrag(n,t,d);this.b.addDragOperationTransfer(l,E),await E}return t}async $handleDrag(t,o,n,d){const l=this.a.get(t);if(!l)return Promise.reject(new T.$BG(t));const g=await this.j(new c.$EO,l,o,d,n);if(!(!g||d.isCancellationRequested))return u.DataTransfer.from(g)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new T.$BG(t);return o.hasResolve}$resolve(t,o,n){const d=this.a.get(t);if(!d)throw new T.$BG(t);return d.resolveTreeItem(o,n)}$setExpanded(t,o,n){const d=this.a.get(t);if(!d)throw new T.$BG(t);d.setExpanded(o,n)}$setSelectionAndFocus(t,o,n){const d=this.a.get(t);if(!d)throw new T.$BG(t);d.setSelectionAndFocus(o,n)}$setVisible(t,o){const n=this.a.get(t);if(!n){if(!o)return;throw new T.$BG(t)}n.setVisible(o)}$changeCheckboxState(t,o){const n=this.a.get(t);if(!n)throw new T.$BG(t);n.setCheckboxState(o)}m(t,o,n){const d=this.B(new i(t,o,this.f,this.g.converter,this.h,n));return this.a.set(t,d),d}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$jrc=f;class i extends L.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$ng)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,n,d,l,g){if(super(),this.I=t,this.J=n,this.L=d,this.M=l,this.N=g,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$le),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$le),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$le),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$le),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$le),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$le),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$le),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$we,g.contributes&&g.contributes.views)for(const k in g.contributes.views)for(const A of g.contributes.views[k])A.id===t&&(this.P=A.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let E,D;const y=R.Event.debounce(this.F.event,(k,A)=>(k||(k={message:!1,elements:[]}),A.element!==!1&&(E||(E=new Promise(p=>D=p),this.G=this.G.then(()=>E)),Array.isArray(A.element)?k.elements.push(...A.element):k.elements.push(A.element)),A.message&&(k.message=!0),k),200,!0);this.B(y(({message:k,elements:A})=>{A.length&&(this.H=this.H.then(()=>{const p=D;return E=null,this.$(A).then(()=>p())})),k&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let n=this.X(t);return n||(n=await this.Y(o)),n?n.map(d=>d.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const n=(0,I.$ng)(o.select)?!0:o.select,d=(0,I.$ng)(o.focus)?!1:o.focus,l=(0,I.$ng)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(g=>this.W(t,g[g.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:g.map(D=>D.item)},{select:n,focus:d,expand:l})),g=>this.M.error(g)):this.J.$reveal(this.I,void 0,{select:n,focus:d,expand:l})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const n=this.getExtensionElement(t);n&&(o?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(t,o){const n=!(0,S.$tb)(this.s,t);this.s=t;const d=this.t!==o;this.t=o,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async n=>{const d=this.getExtensionElement(n.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);o.forEach(n=>{n.treeItem.checkboxState=n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(n=>[n.extensionItem,n.newState])})}async handleDrag(t,o,n){const d=[];for(const l of t){const g=this.getExtensionElement(l);g&&d.push(g)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,o,n),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,n){const d=o?this.getExtensionElement(o):void 0;if(!(!d&&o||!this.g?.handleDrop))return(0,b.$wh)(()=>this.g?.handleDrop?this.g.handleDrop(d,t,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const n=this.j.get(t);if(n){const d=this.m.get(n);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,n,o)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(n=>this.W(o,n[n.length-1]).then(d=>(n.push(d),n))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,b.$wh)(()=>this.f.getParent(t))}W(t,o){const n=this.m.get(t);return n?Promise.resolve(n):(0,b.$wh)(()=>this.f.getTreeItem(t)).then(d=>this.kb(t,d,o,!0)).then(d=>this.getChildren(o?o.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const g=this.m.get(l);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const n=this.getExtensionElement(t);o=n?this.m.get(n):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new w.$we(this.Z.token);try{const n=t?this.m.get(t):void 0,d=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const l=(0,S.$Gb)(d||[]),g=await Promise.all((0,S.$Gb)(l).map(D=>this.f.getTreeItem(D)));if(o.token.isCancellationRequested)return;const E=g.map((D,y)=>D?this.db(l[y],D,n):null);return(0,S.$Gb)(E)}finally{o.dispose()}}$(t){if(t.some(n=>!n))return this.Z.dispose(!0),this.Z=new w.$we,this.tb(),this.J.$refresh(this.I);{const n=this.ab(t);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(t){const o=new Set,n=t.map(l=>this.m.get(l));for(const l of n)if(l&&!o.has(l.item.handle)){let g=l;for(;g&&g.parent&&n.findIndex(E=>g&&g.parent&&E&&E.item.handle===g.parent.item.handle)===-1;){const E=this.j.get(g.parent.item.handle);g=E?this.m.get(E):void 0}g&&!g.parent&&o.add(l.item.handle)}const d=[];return o.forEach(l=>{const g=this.j.get(l);if(g){const E=this.m.get(g);E&&(!E.parent||!o.has(E.parent.item.handle))&&d.push(l)}}),d}bb(t){const o={};return Promise.all(t.map(n=>this.cb(n).then(d=>{d&&(o[n]=d.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const n=this.m.get(o);if(n)return this.rb(o),(0,b.$wh)(()=>this.f.getTreeItem(o)).then(d=>{if(d){const l=this.ib(o,d,n.parent);return this.pb(o,l,n,n.parent),n.dispose(),l}return null})}return Promise.resolve(null)}db(t,o,n){const d=this.ib(t,o,n);if(o.id&&this.j.has(d.item.handle))throw new Error((0,r.localize)(10776,null,o.id));return this.ob(t,d),this.qb(d,n),d}eb(t){return c.$bO.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,n,d;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,n=t.checkboxState.tooltip,d=t.checkboxState.accessibilityInformation),{isChecked:o===c.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:d}}hb(t){if(!c.$zO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,n){this.hb(o);const d=this.B(new L.$Tc),l=this.kb(t,o,n),g=this.lb(o);return{item:{handle:l,parentHandle:n?n.item.handle:void 0,label:$(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(d,o.command),contextValue:o.contextValue,icon:g,iconDark:this.mb(o)||g,themeIcon:this.jb(o),collapsibleState:(0,I.$ng)(o.collapsibleState)?c.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:n,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(t){return t.iconPath instanceof c.$IO?t.iconPath:void 0}kb(t,{id:o,label:n,resourceUri:d},l,g){if(o)return`${i.b}/${o}`;const E=$(n,this.N),D=l?l.item.handle:i.a;let y=E?E.label:d?(0,h.$ch)(d):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,A=this.X(l)||[];let p,v=0;do{if(p=`${D}/${v}:${y}`,g||!this.j.has(p)||k===p)break;v++}while(v<=A.length);return p}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$IO))return typeof t.iconPath=="string"||C.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$IO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return C.URI.isUri(t)?t:C.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,n,d){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(t,o);const l=this.X(d)||[],g=l.filter(E=>E.item.handle===n.item.handle)[0];g&&l.splice(l.indexOf(g),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[323],Ie([1,0,4,3,2,32,15,96,6,9]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0,L=qe(L),b=qe(b),c=qe(c);class I extends h.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(w,a,m,$){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$le),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$le),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=a,this.#n=m,this.#i=$.viewType,this.#s=$.panelOptions,this.#o=$.viewColumn,this.#r=$.title,this.#l=$.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,C.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(w){this.#u||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#l=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:L.ViewColumn.from(w),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class S extends h.$Uc{static c(){return(0,R.$1g)()}constructor(w,a,m){super(),this.j=a,this.m=m,this.g=new Map,this.h=new Map,this.f=w.getProxy(b.$HN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,a,m,$,f={}){const i=typeof $=="object"?$.viewColumn:$,s={viewColumn:L.ViewColumn.from(i),preserveFocus:typeof $=="object"&&!!$.preserveFocus},t=(0,T.$Lpc)(w),o=S.c();this.f.$createWebviewPanel((0,T.$Npc)(w),o,a,{title:m,panelOptions:u(f),webviewOptions:(0,T.$Opc)(w,this.m,f),serializeBuffersForPostMessage:t},s);const n=this.j.createNewWebview(o,f,w);return this.createNewWebviewPanel(o,a,m,i,f,n,!0)}$onDidChangeWebviewPanelViewStates(w){const a=Object.keys(w);a.sort((m,$)=>{const f=w[m],i=w[$];return f.active?1:i.active?-1:+f.visible-+i.visible});for(const m of a){const $=this.getWebviewPanel(m);if(!$)continue;const f=w[m];$._updateViewState({active:f.active,visible:f.visible,viewColumn:L.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,a,m){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:m,extension:w}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,T.$Lpc)(w)}),new c.$JN(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(w,a,m,$){const f=this.h.get(a);if(!f)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:s}=f,t=this.j.createNewWebview(w,m.webviewOptions,s),o=this.createNewWebviewPanel(w,a,m.title,$,m.panelOptions,t,m.active);await i.deserializeWebviewPanel(o,m.state)}createNewWebviewPanel(w,a,m,$,f,i,s){const t=new I(w,this.f,i,{viewType:a,title:m,viewColumn:$,panelOptions:f,active:s});return this.g.set(w,t),t}getWebviewPanel(w){return this.g.get(w)}}e.$Ppc=S;function u(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(ke[324],Ie([1,0,4,3,96,15,6,9]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=void 0,L=qe(L),T=qe(T);class b extends h.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,u,P,w,a,m){super(),this.#s=!1,this.#l=this.B(new r.$le),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$le),this.onDidDispose=this.#u.event,this.#i=P,this.#a=w,this.#e=S,this.#t=u,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(S,u){this.d=u,this.b=new Map,this.c=new Map,this.a=S.getProxy(L.$HN.MainThreadWebviewViews)}registerWebviewViewProvider(S,u,P,w){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:P,extension:S}),this.a.$registerWebviewViewProvider((0,C.$Npc)(S),u,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Lpc)(S)}),new T.$JN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(S,u,P,w,a){const m=this.b.get(u);if(!m)throw new Error(`No view provider found for '${u}'`);const{provider:$,extension:f}=m,i=this.d.createNewWebview(S,{},f),s=new b(S,this.a,u,P,i,!0);this.c.set(S,s),await $.resolveWebviewView(s,{state:w},a)}async $onDidChangeWebviewViewVisibility(S,u){this.e(S)._setVisible(u)}async $disposeWebviewView(S){const u=this.e(S);this.c.delete(S),u.dispose(),this.d.deleteWebview(S)}e(S){const u=this.c.get(S);if(!u)throw new Error("No webview found");return u}}e.$mrc=c}),define(ke[325],Ie([1,0,75,14,11,227,27,10]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rc=void 0;let b=class{constructor(S,u){S.addFileSystemProvider(h.Schemas.file,new c(u),{isCaseSensitive:T.$l})}};e.$4rc=b,e.$4rc=b=Je([Ve(0,r.$Hpc),Ve(1,C.$_j)],b);class c{constructor(S){this.b=S,this.a=new R.$sr(this.b)}async stat(S){const u=await this.a.stat(S);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(S){return this.a.readdir(S)}createDirectory(S){return this.a.mkdir(S)}readFile(S){return this.a.readFile(S)}writeFile(S,u,P){return this.a.writeFile(S,u,{...P,unlock:!1,atomic:!1})}delete(S,u){return this.a.delete(S,{...u,useTrash:!1,atomic:!1})}rename(S,u,P){return this.a.rename(S,u,P)}copy(S,u,P){return this.a.copy(S,u,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(S,u){throw new Error("Method not implemented.")}}}),define(ke[326],Ie([1,0,16,66,32,34,3,6,2,19]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rc=void 0;let I=class extends L.$Uc{constructor(u,P){super();const w=u.getProxy(T.$HN.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=b.URI.file((0,r.$jc)((0,h.tmpdir)(),(0,C.$1g)()));return await w.$download(a,m),m})}};e.$2rc=I,e.$2rc=I=Je([Ve(0,c.$hQ),Ve(1,R.$DQ)],I)}),define(ke[327],Ie([1,0,44,16,2,97,3,14,7,33]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bsc=void 0,r=qe(r),h=qe(h);class I extends R.$Jpc{constructor(){super(...arguments),this.i=null}async g(o){const n=await super.g(o);if(n.scheme!==T.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const d=n.fsPath;let l=0;do{let g;l===0?g=d:g=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await S(g);const E=h.$jc(g,"vscode.lock"),D=await a(this.d,E,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),C.URI.file(g);l++}while(l<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$bsc=I;async function S(t){try{await r.promises.stat(t);return}catch{}try{await r.promises.mkdir(t,{recursive:!0})}catch{}}const u=1e3,P=10*60*1e3;class w extends L.$Uc{constructor(o,n){super(),this.b=o,this.c=n,this.a=this.B(new b.$Ph),this.a.cancelAndSet(async()=>{const d=await m(o,n);(!d||d.pid!==process.pid)&&(o.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await r.promises.utimes(n,new Date,new Date)}catch(l){o.error(l),o.info(`Lock '${n}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(o){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+o};await c.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function a(t,o,n){try{const l={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(o,JSON.stringify(l),{flag:"wx"})}catch(l){t.error(l)}const d=await m(t,o);return!d||d.pid!==process.pid?n?(t.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),i(t,o)):(t.info(`Lock '${o}': Lock acquired.`),new w(t,o))}async function m(t,o){let n;try{n=await r.promises.readFile(o)}catch(d){return t.error(d),null}try{return JSON.parse(String(n))}catch(d){return t.error(d),null}}async function $(t,o){let n;try{n=await r.promises.stat(o)}catch(d){return t.error(d),0}return n.mtime.getTime()}function f(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,o){const n=await m(t,o);if(!n)return t.info(`Lock '${o}': Could not read pid of lock holder.`),s(t,o);if(n.willReleaseAt){let D=n.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${o}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${o}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,b.$Fh)(Math.min(100,D)),await $(t,o)===0)return s(t,o);D=n.willReleaseAt-Date.now()}return s(t,o)}}if(!f(n.pid))return t.info(`Lock '${o}': The pid ${n.pid} appears to be gone.`),s(t,o);const d=await $(t,o),l=Date.now()-d;if(l<=P)return t.info(`Lock '${o}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;t.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,b.$Fh)(2e3);const g=await $(t,o),E=Date.now()-g;return E<=P?(t.info(`Lock '${o}': The lock does not look stale, elapsed: ${E} ms, giving up.`),null):(t.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),s(t,o))}async function s(t,o){t.info(`Lock '${o}': Deleting a stale lock.`);try{await r.promises.unlink(o)}catch{}return a(t,o,!0)}}),define(ke[328],Ie([1,0,32,19,47,34]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=void 0;let L=class extends C.$6pc{constructor(b,c){super(!0,b,c)}createTerminal(b,c,I){return this.createTerminalFromOptions({name:b,shellPath:c,shellArgs:I})}createTerminalFromOptions(b,c){const I=new C.$5pc(this.a,(0,r.$1g)(),b,b.name);return this.f.push(I),I.create(b,this.R(b,c)),I.value}};e.$wrc=L,e.$wrc=L=Je([Ve(0,R.$DQ),Ve(1,h.$hQ)],L)}),define(ke[329],Ie([1,0,4,36,35,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.OutputChannelUpdateMode=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=void 0,e.$PM="text/x-code-output",e.$QM="output",e.$RM="Log",e.$SM="text/x-code-log-output",e.$TM="log",e.$UM="workbench.panel.output",e.$VM=new C.$Vj("inOutput",!1),e.$WM=new C.$Vj("activeLogOutput",!1),e.$XM=new C.$Vj("activeLogOutput.levelSettable",!1),e.$YM=new C.$Vj("activeLogOutput.level",""),e.$ZM=new C.$Vj("activeLogOutput.levelIsDefault",!1),e.$1M=new C.$Vj("outputView.scrollLock",!1),e.$2M=(0,R.$Ei)("outputService");var L;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$3M={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new r.$le,this.onDidRegisterChannel=this.b.event,this.c=new r.$le,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(I=>c.push(I)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}h.$qo.add(e.$3M.OutputChannels,new T),e.$4M=new C.$Vj("activeOutputChannel","")}),define(ke[169],Ie([1,0,6,5,19,23,11,329,75,29,62,212,21,17,27,4,3]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=e.$2qc=void 0;class $ extends L.$fk{get disposed(){return this.n}constructor(t,o,n,d,l){super(),this.id=t,this.name=o,this.r=n,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=u.$Ne.fromString(o).byteLength,(0,L.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class f extends ${appendLine(t){this.append(t)}}let i=class{constructor(t,o,n,d,l,g){this.i=o,this.j=n,this.k=d,this.l=l,this.m=g,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(r.$HN.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,S.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,n]of this.g)n.visible=o===this.h}createOutputChannel(t,o,n){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const d=typeof o=="object"&&o.log,l=(0,P.$eg)(o)?o:void 0;if((0,P.$eg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const E=this.i.environment.extensionLogLevel?.find(([y])=>R.$qn.equals(n.identifier,y))?.[1];E&&(g=(0,L.$qk)(E));const D=d?this.o(t,g,n):this.n(t,l,n);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),d?this.r(t,g??this.m.getLevel(),D):this.q(t,D)}async n(t,o,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,l,o,n.identifier.value);return new $(E,t,g,this.a,n)}async o(t,o,n){const d=await this.p(n),l=t.replace(/[\\/:\*\?"<>\|]/g,""),g=this.k.extUri.joinPath(d,`${l}.log`),E=`${n.identifier.value}.${l}`,D=this.l.createLogger(g,{id:E,name:t,logLevel:o,extensionId:n.identifier.value});return new f(E,t,D,this.a,n)}p(t){let o=this.d.get(t.identifier.value);if(!o){const n=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(n)}catch(d){if((0,w.$pl)(d)!==w.FileSystemProviderErrorCode.FileExists)throw d}return n})())}return o}q(t,o){let n=!1;const d=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return t},append(l){d(),o.then(g=>g.append(l))},appendLine(l){d(),o.then(g=>g.appendLine(l))},clear(){d(),o.then(l=>l.clear())},replace(l){d(),o.then(g=>g.replace(l))},show(l,g){d(),o.then(E=>E.show(l,g))},hide(){d(),o.then(l=>l.hide())},dispose(){n=!0,o.then(l=>l.dispose())}}}r(t,o,n){const d=new m.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},g=d.add(new a.$le);function E(D){o=D,g.fire(D)}return n.then(D=>{d.add(D),D.logLevel!==o&&E(D.logLevel),d.add(D.onDidChangeLogLevel(y=>E(y)))}),{...this.q(t,n),get logLevel(){return o},onDidChangeLogLevel:g.event,trace(D,...y){l(),n.then(k=>k.trace(D,...y))},debug(D,...y){l(),n.then(k=>k.debug(D,...y))},info(D,...y){l(),n.then(k=>k.info(D,...y))},warn(D,...y){l(),n.then(k=>k.warn(D,...y))},error(D,...y){l(),n.then(k=>k.error(D,...y))},dispose(){d.dispose()}}}};e.$2qc=i,e.$2qc=i=Je([Ve(0,C.$hQ),Ve(1,c.$xQ),Ve(2,b.$Hpc),Ve(3,I.$kpc),Ve(4,L.$ak),Ve(5,L.$_j)],i),e.$3qc=(0,h.$Ei)("IExtHostOutputService")}),define(ke[170],Ie([1,0,5,7]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,r.$Ei)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let R=1/0;for(let T=0;T<this.maxSampleCount;T++){const b=await C.getRoundTripTime();if(b===void 0)return;R=Math.min(R,b/2),await(0,h.$Fh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((T,b)=>T+b,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((T,b)=>T+b,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[330],Ie([1,0,8,70,36,46,45,3,4,170,10,24,7,150]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=void 0,e.$bL=Object.freeze({id:"application",order:100,title:(0,r.localize)(12500,null),type:"object"}),e.$cL=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(12501,null),type:"object"}),e.$dL=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(12502,null),type:"object",order:7}),e.$eL=Object.freeze({id:"problems",title:(0,r.localize)(12503,null),type:"object",order:101}),e.$fL=Object.freeze({id:"window",order:8,title:(0,r.localize)(12504,null),type:"object"}),e.$gL={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new b.$le,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const a=new w;C.$qo.add(e.$gL.ConfigurationMigration,a);let m=class extends T.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,t){super(),this.a=s,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const n of o.added)await this.f(n,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(s){await this.f(void 0,s);for(const t of this.b.getWorkspace().folders)await this.f(t,s)}async f(s,t){await Promise.all([t.map(o=>this.g(o,s?.uri))])}async g(s,t){const o=this.a.inspect(s.key,{resource:t}),n=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[d,l]of n){const g=o[d];if(!g)continue;const E=[];if(g.value!==void 0){const D=await this.h(s,d,g.value,t,void 0);for(const y of D??[])E.push([y,[]])}for(const{identifiers:D,value:y}of g.overrides??[])if(y!==void 0){const k=await this.h(s,d,y,t,D);for(const A of k??[])E.push([A,D])}E.length&&await Promise.allSettled(E.map(async([[D,y],k])=>this.a.updateValue(D,y.value,{resource:t,overrideIdentifiers:k},l)))}}async h(s,t,o,n,d){const l=E=>{const y=this.a.inspect(E,{resource:n})[t];if(y)return d?y.overrides?.find(({identifiers:k})=>(0,S.$ho)(k,d))?.value:y.value},g=await s.migrateFn(o,l);return Array.isArray(g)?g:[[s.key,g]]}};e.$hL=m,e.$hL=m=Je([Ve(0,L.$$i),Ve(1,R.$Ni)],m);let $=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.b=s,this.a=new u.$2h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;C.$qo.as(h.$vo.Configuration).registerConfiguration({...e.$dL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(12505,null)},default:[],markdownDescription:(0,r.localize)(12506,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(12507,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$iL=$,e.$iL=$=Je([Ve(0,c.$Vm)],$),e.$jL="window.newWindowProfile";let f=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,t){super(),this.c=s,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==L.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$jL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const s=C.$qo.as(h.$vo.Configuration),t={...e.$fL,properties:{[e.$jL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,r.localize)(12508,null)],description:(0,r.localize)(12509,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?s.updateConfigurations({add:[t],remove:[this.a]}):s.registerConfiguration(t),this.a=t}h(){const s=this.f.getValue(e.$jL);this.b=s?this.c.profiles.find(t=>t.name===s):void 0}j(){const s=this.f.getValue(e.$jL);if(!s)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;s!==t?.name&&this.f.updateValue(e.$jL,t?.name)}};e.$kL=f,e.$kL=f=Je([Ve(0,P.$Ll),Ve(1,L.$$i)],f)}),define(ke[331],Ie([1,0,38,14,16,22,8,330,70,5,36]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$mL=e.$lL=void 0,e.$nL=a,e.$oL=m,r=qe(r),e.$lL=(0,c.$Ei)("editorResolverService"),e.$mL="workbench.editorAssociations";const S=I.$qo.as(b.$vo.Configuration),u={...T.$cL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(2013,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(u);var P;(function($){$.builtin="builtin",$.option="option",$.exclusive="exclusive",$.default="default"})(P||(e.RegisteredEditorPriority=P={}));var w;(function($){$[$.ABORT=1]="ABORT",$[$.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function a($){switch($){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function m($,f){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(f.scheme))return!1;const t=typeof $=="string"&&$.indexOf(C.$gc.sep)>=0?`${f.scheme}:${f.path}`:(0,R.$ch)(f);return r.$yk(typeof $=="string"?$.toLowerCase():$,t.toLowerCase())}}),define(ke[332],Ie([1,0,31,14,16,10,22,2,5,247,46,158,170]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=void 0,e.$jN=(0,b.$Ei)("pathService");let w=P=class{constructor(m,$,f,i){this.d=m,this.e=$,this.f=f,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??m})()}hasValidBasename(m,$,f){return typeof $=="string"||typeof $>"u"?this.a.then(i=>this.h(m,i,$)):this.h(m,$,f)}h(m,$,f){return m.scheme===h.Schemas.file||m.scheme===h.Schemas.vscodeRemote?(0,r.$Bg)(f??(0,L.$ch)(m),$===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,$){if(m.remoteAuthority)return h.Schemas.vscodeRemote;const f=(0,c.$gN)($.getWorkspace());if(f)return f;const i=$.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=$.getWorkspace().configuration;return s?s.scheme:h.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===R.OperatingSystem.Windows?C.$fc:C.$gc)}async fileURI(m){let $="";if(await this.a===R.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?($=m.substring(2),m="/"):($=m.substring(2,i),m=m.substring(i)||"/")}return T.URI.from({scheme:h.Schemas.file,authority:$,path:m,query:"",fragment:""})}};e.$kN=w,e.$kN=w=P=Je([Ve(1,u.$Vm),Ve(2,S.$5M),Ve(3,I.$Ni)],w)}),define(ke[333],Ie([1,0,8,59,4,60,3,2,45,216,11,71,151,92,46,158,25,20,17,24,35]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.$cN=e.OnPortForward=e.$0M=e.$9M=e.TunnelSource=e.TunnelCloseReason=e.$7M=e.$6M=void 0,e.$8M=l,e.$$M=D,e.$_M=y,e.$aN=k,e.$bN=p,r=qe(r);const t=10*1e3,o="remote.tunnels.toRestore",n="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$6M="onTunnel",e.$7M=new s.$Vj("forwardedPortsViewEnabled",!1,r.localize(1627,null));function l(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}var g;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(g||(e.TunnelCloseReason=g={}));var E;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(E||(e.TunnelSource=E={})),e.$9M={source:E.User,description:r.localize(1628,null)},e.$0M={source:E.Auto,description:r.localize(1629,null)};function D(N,O,j){const z=N.get(k(O,j));if(z)return z;if((0,P.$Jw)(O))for(const M of P.$Iw){const U=k(M,j);if(N.has(U))return N.get(U)}else if((0,P.$Lw)(O))for(const M of P.$Kw){const U=k(M,j);if(N.has(U))return N.get(U)}}function y(N,O,j){const z=D(N,O,j);if(z)return z;const M=(0,P.$Lw)(O)?"localhost":(0,P.$Jw)(O)?"0.0.0.0":void 0;if(M)return D(N,M,j)}function k(N,O){return N+":"+O}var A;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(A||(e.OnPortForward=A={}));function p(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class v extends L.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new C.$le,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(j=>{(j.affectsConfiguration(v.c)||j.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,j,z){let M=this.w(O,j,z,this.j,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const V=this.j[M];V.key===O?(U.onAutoForward=V.onAutoForward??U.onAutoForward,U.elevateIfNeeded=V.elevateIfNeeded!==void 0?V.elevateIfNeeded:U.elevateIfNeeded,U.label=V.label??U.label,U.requireLocalPort=V.requireLocalPort,U.protocol=V.protocol):(U.onAutoForward=U.onAutoForward??V.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:V.elevateIfNeeded,U.label=U.label??V.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??V.protocol),M=this.w(O,j,z,this.j,M+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,f.$eg)(O.host)&&(0,f.$ig)(O.port)}w(O,j,z,M,U){if(U>=M.length)return-1;const V=!(0,P.$Jw)(j)&&!(0,P.$Lw)(j),B=M.slice(U).findIndex(Y=>(0,f.$ig)(Y.key)?V?!1:Y.key===O:this.t(Y.key)?V?!1:O>=Y.key.start&&O<=Y.key.end:this.u(Y.key)?O===Y.key.port&&j===Y.key.host:z?Y.key.test(z):!1);return B>=0?B+U:-1}y(){const O=this.r.getValue(v.c);if(!O||!(0,f.$gg)(O))return[];const j=[];for(const M in O){if(M===void 0)continue;const U=O[M];let V;if(Number(M))V=Number(M);else if((0,f.$eg)(M))if(v.g.test(M)){const ie=M.match(v.g);V={start:Number(ie[1]),end:Number(ie[2])}}else if(v.h.test(M)){const ie=M.match(v.h);V={host:ie[1],port:Number(ie[2])}}else{let ie;try{ie=RegExp(M)}catch{}ie&&(V=ie)}V&&j.push({key:V,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const z=this.r.getValue(v.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(j)}z(O){function j(z,M){return(0,f.$ig)(z.key)?z.key:M.t(z.key)?z.key.start:M.u(z.key)?z.key.port:Number.MAX_VALUE}return O.sort((z,M)=>j(z,this)-j(M,this))}C(){return this.m}static providedActionToAction(O){switch(O){case P.ProvidedOnAutoForward.Notify:return A.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return A.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return A.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return A.OpenPreview;case P.ProvidedOnAutoForward.Silent:return A.Silent;case P.ProvidedOnAutoForward.Ignore:return A.Ignore;default:return}}async addAttributes(O,j,z){const U=this.r.inspect(v.c).userRemoteValue;let V;!U||!(0,f.$gg)(U)?V={}:V=(0,i.$do)(U),V[`${O}`]||(V[`${O}`]={});for(const ie in j)V[`${O}`][ie]=j[ie];return this.r.updateValue(v.c,V,z)}}e.$cN=v;let F=class extends L.$Uc{constructor(O,j,z,M,U,V,ie,B,Y,J){super(),this.H=O,this.I=j,this.J=z,this.L=M,this.M=U,this.N=V,this.O=ie,this.P=B,this.Q=Y,this.R=J,this.c=new Map,this.g=new C.$le,this.onForwardPort=this.g.event,this.h=new C.$le,this.onClosePort=this.h.event,this.j=new C.$le,this.onPortName=this.j.event,this.n=new C.$le,this.onCandidatesChanged=this.n.event,this.t=new C.$le,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new C.$le,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const le=await this.getAttributes(_.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of _)if(re.localAddress){const Se=k(re.tunnelRemoteHost,re.tunnelRemotePort),me=y(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(Se,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:le?.get(re.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(re.localAddress,le?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,name:le?.get(re.tunnelRemotePort)?.label,runningProcess:me?.detail,hasRunningProcess:!!me,pid:me?.pid,privacy:re.privacy,source:e.$9M}),this.f.set(Se,re)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const le=k(_.tunnelRemoteHost,_.tunnelRemotePort);if(!y(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!y(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!y(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const re=y(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),Se=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(le,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:Se?.protocol??P.TunnelProtocol.Http,localUri:await this.X(_.localAddress,Se),localPort:_.tunnelLocalPort,name:Se?.label,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:_.privacy,source:e.$9M})}await this.cb(),this.f.set(le,_),this.g.fire(this.forwarded.get(le))})),this.B(this.H.onTunnelClosed(_=>this.W(_,g.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$6M))?(this.R.createKey(e.$7M.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,j){const z=k(O.host,O.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(O))}X(O,j){if(O.startsWith("http"))return T.URI.parse(O);const z=j?.protocol??"http";return T.URI.parse(`${z}://${O}`)}async Y(O){const j=this.N.getWorkspace(),z=j.configuration?(0,R.$sj)(j.configuration.path):j.folders.length>0?(0,R.$sj)(j.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${O}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(o)}async $(){return this.Y(n)}async ab(){const O=this.I.get(o,u.StorageScope.WORKSPACE);if(O)return this.I.remove(o,u.StorageScope.WORKSPACE),await this.cb(),O;const j=await this.Z();if(j)return this.I.get(j,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const j=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(z=>z.remotePort).join(", ")}`);for(const z of j){const M=y(this.detected,z.remoteHost,z.remotePort);z.source.source!==E.Extension&&!M||z.source.source===E.Extension&&M?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===E.Extension&&!M&&this.D.set(k(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Z();this.w=this.B(new L.$Tc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===O&&(this.s=Promise.resolve(this.I.get(O,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const O=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(j=>j.startsWith(n));for(const j of O){const z=this.I.getNumber(j,u.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const M=j.replace(n,o);this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(M,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=Array.from(this.forwarded.values()),j=O.map(V=>({remoteHost:V.remoteHost,remotePort:V.remotePort,localPort:V.localPort,name:V.name,localAddress:V.localAddress,localUri:V.localUri,protocol:V.protocol,source:V.source}));let z;O.length>0&&(z=JSON.stringify(j));const M=await this.Z(),U=await this.$();!z&&M&&U?(this.I.remove(M,u.StorageScope.PROFILE),this.I.remove(U,u.StorageScope.PROFILE)):z!==this.y&&M&&U&&(this.I.store(M,z,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(U,Date.now()+d,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=z}}async eb(O,j,z){if(!O.tunnelLocalPort||!z?.requireLocalPort||O.tunnelLocalPort===j)return;const M=new Date;if(this.db.getTime()+t>M.getTime())return;this.db=M;const U=r.localize(1630,null,j,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(U)}async forward(O,j){return!this.z&&this.L.remoteAuthority&&await C.Event.toPromise(this.C.event),this.fb(O,j)}async fb(O,j){await this.Q.activateByEvent(e.$6M);const z=y(this.forwarded,O.remote.host,O.remote.port);j=j??(j!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const M=O.local!==void 0?O.local:O.remote.port;let U;if(z)return this.hb(z,O,j);{const V=this.L.remoteAuthority,ie=V?{getAddress:async()=>(await this.M.resolveAuthority(V)).authority}:void 0,B=k(O.remote.host,O.remote.port);this.c.set(B,!0),O=this.gb(B,O);const Y=await this.H.openTunnel(ie,O.remote.host,O.remote.port,void 0,M,O.elevateIfNeeded?O.elevateIfNeeded:j?.elevateIfNeeded,O.privacy,j?.protocol);if(typeof Y=="string")U=Y;else if(Y&&Y.localAddress){const J=y(this.m??new Map,O.remote.host,O.remote.port),_=Y.protocol?Y.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:j?.protocol??P.TunnelProtocol.Http,le={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:j?.label??O.name,closeable:!0,localAddress:Y.localAddress,protocol:_,localUri:await this.X(Y.localAddress,j),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:O.source??e.$9M,privacy:Y.privacy};return this.forwarded.set(B,le),this.f.set(B,Y),this.c.delete(B),await this.cb(),await this.eb(Y,M,j),this.g.fire(le),Y}this.c.delete(B)}return U}gb(O,j){const z=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(z){const M=z.get(O);z.delete(O),M&&(j.name=M.name??j.name,j.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(O,j,z){const M=z?.label??j.name;let U;(function(ie){ie[ie.None=0]="None",ie[ie.Fire=1]="Fire",ie[ie.Reopen=2]="Reopen"})(U||(U={}));let V=U.None;switch(M!==O.name&&(O.name=M,V=U.Fire),(z?.protocol||O.protocol!==P.TunnelProtocol.Http)&&z?.protocol!==O.protocol&&(j.source=O.source,V=U.Reopen),j.privacy&&O.privacy!==j.privacy&&(V=U.Reopen),V){case U.Fire:{this.g.fire();break}case U.Reopen:await this.close(O.remoteHost,O.remotePort,g.User),await this.fb(j,z)}return y(this.f,j.remote.host,j.remote.port)}async name(O,j,z){const M=y(this.forwarded,O,j),U=k(O,j);if(M){M.name=z,await this.cb(),this.j.fire({host:O,port:j});return}else this.detected.has(U)&&(this.detected.get(U).name=z,this.j.fire({host:O,port:j}))}async close(O,j,z){const M=k(O,j),U=this.forwarded.get(M);return z===g.AutoForwardEnd&&U&&U.source.source===E.Auto&&this.F.set(M,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.H.closeTunnel(O,j),this.W({host:O,port:j},z)}address(O,j){const z=k(O,j);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const j of O){const z=y(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),M=typeof j.localAddress=="string"?j.localAddress:k(j.localAddress.host,j.localAddress.port);this.detected.set(k(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:M,protocol:P.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:E.Extension,description:r.localize(1631,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,M,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let j=O;this.r&&(j=await this.r(O));const z=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(M=>M.port).join(", ")}`),this.n.fire(z)}ib(O){const j=this.m??new Map,z=new Map;return this.m=z,O.forEach(M=>{const U=k(M.host,M.port);z.set(U,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),j.has(U)&&j.delete(U);const V=y(this.forwarded,M.host,M.port);V&&(V.runningProcess=M.detail,V.hasRunningProcess=!0,V.pid=M.pid)}),j.forEach((M,U)=>{const V=l(U);if(!V)return;const ie=y(this.forwarded,V.host,V.port);ie&&(ie.runningProcess=void 0,ie.hasRunningProcess=!1,ie.pid=void 0);const B=y(this.detected,V.host,V.port);B&&(B.runningProcess=void 0,B.hasRunningProcess=!1,B.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const O=Array.from(this.forwarded.values()),j=await this.getAttributes(O.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(j)for(const z of O){const M=j.get(z.remotePort);(M?.protocol||z.protocol!==P.TunnelProtocol.Http)&&M?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},M),M&&M.label&&M.label!==z.name&&await this.name(z.remoteHost,z.remotePort,M.label)}}async getAttributes(O,j=!0){const z=new Map,M=new Map;O.forEach(Y=>{const J=y(this.m??new Map,P.$Iw[0],Y.port)??Y;if(J){z.set(Y.port,J);const _=p(J)?J.pid:void 0;M.has(_)||M.set(_,[]),M.get(_)?.push(Y.port)}});const U=new Map;if(O.forEach(Y=>{const J=this.configPortsAttributes.getAttributes(Y.port,Y.host,z.get(Y.port)?.detail);J&&U.set(Y.port,J)}),this.G.length===0||!j)return U.size>0?U:void 0;const V=await Promise.all(this.G.flatMap(Y=>Array.from(M.entries()).map(J=>{const _=J[1],le=z.get(_[0]);return Y.providePortAttributes(_,le?.pid,le?.detail,$.CancellationToken.None)}))),ie=new Map;if(V.forEach(Y=>Y.forEach(J=>{J&&ie.set(J.port,J)})),!U&&!ie)return;const B=new Map;return O.forEach(Y=>{const J=U.get(Y.port),_=ie.get(Y.port);B.set(Y.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??v.providedActionToAction(_?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),B}addAttributesProvider(O){this.G.push(O)}};e.$dN=F,Je([(0,h.$0h)(1e3)],F.prototype,"cb",null),e.$dN=F=Je([Ve(0,P.$Dw),Ve(1,u.$hq),Ve(2,b.$$i),Ve(3,a.$5M),Ve(4,S.$Ql),Ve(5,w.$Ni),Ve(6,I.$_j),Ve(7,c.$9w),Ve(8,m.$bH),Ve(9,s.$Wj)],F)}),define(ke[99],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.$XL=e.$WL=e.TextSearchCompleteMessageType=e.$VL=e.$UL=void 0;class r{constructor(I,S){this.line=I,this.character=S}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,S){return new r(0,0)}with(I){return new r(0,0)}}e.$UL=r;class h{constructor(I,S,u,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(I,S),this.end=new r(u,P)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new h(0,0,0,0)}with(I){return new h(0,0,0,0)}}e.$VL=h;var C;(function(c){c[c.Information=1]="Information",c[c.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}));class R{constructor(I,S,u){this.uri=I,this.ranges=S,this.previewText=u}}e.$WL=R;class L{constructor(I,S,u){this.uri=I,this.text=S,this.lineNumber=u}}e.$XL=L;var T;(function(c){c[c.none=1]="none",c[c.filesExclude=2]="filesExclude",c[c.searchAndFilesExclude=3]="searchAndFilesExclude"})(T||(e.ExcludeSettingOptions=T={}));var b;(function(c){c[c.Information=1]="Information",c[c.Warning=2]="Warning"})(b||(e.TextSearchCompleteMessageTypeNew=b={}))}),define(ke[37],Ie([1,0,18,38,24,31,12,5,16,13,99,7]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$jM=e.$cM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$_L=e.$$L=e.$0L=e.$9L=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.TextSearchCompleteMessageType=void 0,e.$6L=$,e.$7L=f,e.$8L=i,e.$aM=D,e.$bM=y,e.$dM=p,e.$eM=v,e.$fM=F,e.$gM=N,e.$hM=O,e.$iM=j,e.$kM=M,e.$mM=ie,e.$nM=B,h=qe(h),C=qe(C),R=qe(R),b=qe(b),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$YL="workbench.view.search",e.$ZL="workbench.panel.search",e.$1L="workbench.view.search",e.$2L="search-result",e.$3L="search.exclude",e.$4L=2e4;const u="\u27EA ",P=" characters skipped \u27EB",w=(u.length+P.length+5)*2;e.$5L=(0,T.$Ei)("searchService");var a;(function(J){J[J.file=0]="file",J[J.text=1]="text",J[J.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.aiText=3]="aiText"})(m||(e.QueryType=m={}));function $(J){return!!J.preview}function f(J){return!!J.resource}function i(J){return!!J.message}var s;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class t{constructor(_){this.resource=_,this.results=[]}}e.$9L=t;class o{constructor(_,le,re,Se){this.ranges=le,this.webviewIndex=Se;const me=Array.isArray(le)?le:[le];if(re&&re.matchLines===1&&n(me)){_=(0,L.$0f)(_,re.matchLines);let Q="",q=0,se=0;const we=Math.floor(re.charsPerLine/5),ee=[];for(const ae of me){const oe=Math.max(ae.startColumn-we,0),x=ae.startColumn+re.charsPerLine;if(oe>se+we+w){const ne=u+(oe-se)+P;Q+=ne+_.slice(oe,x),q+=oe-(se+ne.length)}else Q+=_.slice(se,x);ee.push(new l(0,ae.startColumn-q,ae.endColumn-q)),se=x}this.preview={text:Q,matches:Array.isArray(this.ranges)?ee:ee[0]}}else{const Q=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:_,matches:(0,r.$Zb)(le,q=>new d(q.startLineNumber-Q,q.startColumn,q.endLineNumber-Q,q.endColumn))}}}}e.$0L=o;function n(J){const _=J[0].startLineNumber;for(const le of J)if(le.startLineNumber!==_||le.endLineNumber!==_)return!1;return!0}class d{constructor(_,le,re,Se){this.startLineNumber=_,this.startColumn=le,this.endLineNumber=re,this.endColumn=Se}}e.$$L=d;class l extends d{constructor(_,le,re){super(_,le,_,re)}}e.$_L=l;var g;(function(J){J.List="list",J.Tree="tree"})(g||(e.ViewMode=g={}));var E;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(J,_=!0){const le=J&&J.files&&J.files.exclude,re=_&&J&&J.search&&J.search.exclude;if(!le&&!re)return;if(!le||!re)return le||re||void 0;let Se=Object.create(null);return Se=C.$go(Se,C.$do(le)),Se=C.$go(Se,C.$do(re),!0),Se}function y(J,_){return J.excludePattern&&h.$yk(J.excludePattern,_)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&h.$yk(J.includePattern,_)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(le=>{const re=le.folder.fsPath;if(R.$Dg(_,re)){const Se=b.$lc(re,_);return!le.includePattern||!!h.$yk(le.includePattern,Se)}else return!1}):!1:!0}var k;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class A extends Error{constructor(_,le){super(_),this.code=le}}e.$cM=A;function p(J){const _=J.message;if((0,c.$3)(J))return new A(_,k.canceled);try{const le=JSON.parse(_);return new A(le.message,le.code)}catch{return new A(_,k.other)}}function v(J){const _={message:J.message,code:J.code};return new Error(JSON.stringify(_))}function F(J){return J.type==="error"?!0:J.type==="success"}function N(J){return J.type==="success"}function O(J){return!!J.path}function j(J,_,le=!0){const re=J.searchPath?J.searchPath:J.relativePath;return le?(0,L.$7f)(re,_):h.$yk(_,re)}class z{constructor(_){this.path=_,this.results=[]}addMatch(_){this.results.push(_)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$jM=z;function M(J,_){const le={...J||{},..._||{}};return Object.keys(le).filter(re=>{const Se=le[re];return typeof Se=="boolean"&&Se})}class U{constructor(_,le){this.c=null,this.a={..._.excludePattern||{},...le.excludePattern||{}},this.b=h.$zk(this.a);let re=_.includePattern;le.includePattern&&(re?re={...re,...le.includePattern}:re=le.includePattern),re&&(this.c=h.$zk(re))}matchesExcludesSync(_,le,re){return!!(this.b&&this.b(_,le,re))}includedInQuerySync(_,le,re){return!(this.b&&this.b(_,le,re)||this.c&&!this.c(_,le,re))}includedInQuery(_,le,re){const Se=this.b(_,le,re),me=()=>this.c?!!this.c(_,le,re):!0;return(0,S.$qh)(Se)?Se.then(Q=>Q?!1:me()):me()}hasSiblingExcludeClauses(){return V(this.a)}}e.$lM=U;function V(J){for(const _ in J)if(typeof J[_]!="boolean")return!0;return!1}function ie(J){if(!J)return;let _;return le=>(_||(_=(J()||Promise.resolve([])).then(re=>re?Y(re):{})),_.then(re=>!!re[le]))}function B(J){if(!J)return;let _;return le=>{if(!_){const re=J();_=re?Y(re):{}}return!!_[le]}}function Y(J){const _={};for(const le of J)_[le]=!0;return _}}),define(ke[48],Ie([1,0,18,7,20,4,3,84,14,133,22,12,2,8,27,5,11,230,46,62,29,19,15,9,72,37,6,51]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=e.$Bpc=void 0;function D(O,j,z){return new I.$7g(M=>p(M,z)).isEqual(O,j)}function y(O,j,z){return D(O.uri,j.uri,z)?0:(0,S.$yf)(O.uri.toString(),j.uri.toString())}function k(O,j,z){return O.index!==j.index?O.index<j.index?-1:1:D(O.uri,j.uri,z)?(0,S.$yf)(O.name,j.name):(0,S.$yf)(O.uri.toString(),j.uri.toString())}function A(O,j,z,M){const U=O.slice(0).sort((ie,B)=>z(ie,B,M)),V=j.slice(0).sort((ie,B)=>z(ie,B,M));return(0,r.$Db)(U,V,(ie,B)=>z(ie,B,M))}function p(O,j){const z=j.getCapabilities(O.scheme);return!(z&&z&w.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends f.$Xi{static toExtHostWorkspace(j,z,M,U){if(!j)return{workspace:null,added:[],removed:[]};const{id:V,name:ie,folders:B,configuration:Y,transient:J,isUntitled:_}=j,le=[],re=z;z?B.forEach((q,se)=>{const we=u.URI.revive(q.uri),ee=v.o(M||z,we,U);ee?(ee.name=q.name,ee.index=q.index,le.push(ee)):le.push({uri:we,name:q.name,index:se})}):le.push(...B.map(({uri:q,name:se,index:we})=>({uri:u.URI.revive(q),name:se,index:we}))),le.sort((q,se)=>q.index<se.index?-1:1);const Se=new v(V,ie,le,!!J,Y?u.URI.revive(Y):null,!!_,q=>p(q,U)),{added:me,removed:Q}=A(re?re.workspaceFolders:[],Se.workspaceFolders,y,U);return{workspace:Se,added:me,removed:Q}}static o(j,z,M){for(let U=0;U<j.folders.length;U++){const V=j.workspaceFolders[U];if(D(V.uri,z,M))return V}}constructor(j,z,M,U,V,ie,B){super(j,M.map(Y=>new f.$Yi(Y)),U,V,B),this.t=z,this.u=ie,this.q=[],this.s=T.$Ki.forUris(B,()=>!0),M.forEach(Y=>{this.q.push(Y),this.s.set(Y.uri,Y)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,I.$eh)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let F=class{constructor(j,z,M,U,V){this.c=new R.$le,this.onDidChangeWorkspace=this.c.event,this.g=new R.$le,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$ne,this.C=new Map,this.h=U,this.s=M,this.t=V,this.j=new c.$Mm,this.k=new h.$Dh,this.o=j.getProxy(g.$HN.MainThreadWorkspace),this.q=j.getProxy(g.$HN.MainThreadMessageService);const ie=z.workspace;this.l=ie?new v(ie.id,ie.name,[],!!ie.transient,ie.configuration?u.URI.revive(ie.configuration):null,!!ie.isUntitled,B=>p(B,M)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:b.Schemas.untitled,path:(0,I.$ch)((0,I.$eh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,M,...U){const V=[];if(Array.isArray(U)&&U.forEach(_=>{u.URI.isUri(_.uri)&&!V.some(le=>D(le.uri,_.uri,this.s))&&V.push({uri:_.uri,name:_.name||(0,I.$bh)(_.uri)})}),this.n||[z,M].some(_=>typeof _!="number"||_<0)||M===0&&V.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(z+M>ie.length)return!1;const B=ie.slice(0);B.splice(z,M,...V.map(_=>({uri:_.uri,name:_.name||(0,I.$bh)(_.uri),index:void 0})));for(let _=0;_<B.length;_++){const le=B[_];if(B.some((re,Se)=>Se!==_&&D(le.uri,re.uri,this.s)))return!1}B.forEach((_,le)=>_.index=le);const{added:Y,removed:J}=A(ie,B,k,this.s);if(Y.length===0&&J.length===0)return!1;if(this.o){const _=j.displayName||j.name;this.o.$updateWorkspaceFolders(_,z,M,V).then(void 0,le=>{this.n=void 0;const re={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage($.Severity.Error,(0,P.localize)(10773,null,_,le.toString()),re,[])})}return this.y(B),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let M,U="";if(typeof j=="string"?(M=u.URI.file(j),U=j):typeof j<"u"&&(M=j,U=j.fsPath),!M)return U;const V=this.getWorkspaceFolder(M,!0);if(!V)return U;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ie=(0,I.$hh)(V.uri,M);return z&&V.name&&(ie=`${V.name}/${ie}`),ie}y(j){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:M,removed:U}=v.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:U}))}findFiles(j,z,M,U,V=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ie="",B=!0;return z===null?B=!1:z!==void 0&&(typeof z=="string"?ie=z:ie=z.pattern),this.z(j,void 0,{exclude:ie,maxResults:M,useDefaultExcludes:B,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},V)}findFiles2(j,z={},M,U=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,z,U)}async z(j,z,M,U=C.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const V=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ie={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:V,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let B;if(j){const{includePattern:Y,folder:J}=N(o.GlobPattern.from(j));B=J,ie.includePattern=Y}else{const{includePattern:Y,folder:J}=N(o.GlobPattern.from(z));B=J,ie.filePattern=Y}return this.o.$startFileSearch(B??null,ie,U).then(Y=>Array.isArray(Y)?Y.map(J=>u.URI.revive(J)):[])}async findTextInFiles(j,z,M,U,V=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),B=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:Y,folder:J}=N(o.GlobPattern.from(z.include)),_=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,le={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:B,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:Y,excludePattern:_},re=!1;if(this.u[ie]=Se=>{if(re)return;const me=u.URI.revive(Se.resource);Se.results.forEach(Q=>{const q=(0,E.$bi)(Q);(0,l.$6L)(q)?M({uri:me,preview:{text:q.preview.text,matches:(0,r.$Zb)(q.preview.matches,se=>new n.$LN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$Zb)(q.ranges,se=>new n.$LN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):M({uri:me,text:q.text,lineNumber:q.lineNumber})})},V.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(j,J??null,le,ie,V);return delete this.u[ie],Se||{}}catch(Se){throw delete this.u[ie],Se}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return u.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return u.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}lookupAuthorization(j){return this.o.$lookupAuthorization(j)}lookupKerberosAuthorization(j){return this.o.$lookupKerberosAuthorization(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const M=this.t.transformOutgoingScheme(j),U=this.A++;return this.o.$registerEditSessionIdentityProvider(U,M),(0,L.$Sc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const U=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!U),!U)return;const V=await U.provideEditSessionIdentity(M,z);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(j,z,M,U){this.h.info("Getting edit session identifier for workspaceFolder",j);const V=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const ie=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!ie),!ie)return;const B=await ie.provideEditSessionIdentityMatch?.(z,M,U);if(this.h.info("Provider returned edit session identifier match result: ",B),!!B)return B}getOnWillCreateEditSessionIdentityEvent(j){return(z,M,U)=>{const V=function(B){z.call(M,B)};return V.extension=j,this.B.event(V,void 0,U)}}async $onWillCreateEditSessionIdentity(j,z,M){const U=await this.resolveWorkspaceFolder(u.URI.revive(j));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:U},z,async(V,ie)=>{const B=Date.now();await Promise.resolve(V),Date.now()-B>M&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const M=this.t.transformOutgoingScheme(j),U=this.A++;return this.o.$registerCanonicalUriProvider(U,M),(0,L.$Sc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(j,z,M){const U=this.C.get(j.scheme);if(!U)return;const V=await U.provideCanonicalUri?.(u.URI.revive(j),z,M);if(V)return V}async $provideCanonicalUri(j,z,M){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:z},M)}};e.$Bpc=F,e.$Bpc=F=Je([Ve(0,t.$hQ),Ve(1,s.$xQ),Ve(2,i.$kpc),Ve(3,m.$_j),Ve(4,d.$zpc)],F),e.$Cpc=(0,a.$Ei)("IExtHostWorkspace");function N(O){let j,z;return O&&(typeof O=="string"?j=O:(j=O.pattern,z=u.URI.revive(O.baseUri))),{includePattern:j,folder:z}}}),define(ke[41],Ie([1,0,24,4,48,6,9,45,232,70,17,7,5,19,11,2]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=e.$Epc=e.$Dpc=void 0;function m(d,l){if(l){const g=l.split(".");let E=d;for(let D=0;E&&D<g.length;D++)E=E[g[D]];return E}}function $(d){return d instanceof a.URI}function f(d){return d&&d.uri instanceof a.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function s(d){return d&&d.uri instanceof a.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function t(d){if($(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(s(d))return{resource:d.uri};if(d===null)return{resource:null}}let o=class{constructor(l,g,E){this.a=l.getProxy(R.$HN.MainThreadConfiguration),this.c=g,this.b=E,this.d=new S.$Dh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new n(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,g){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(l,g))}};e.$Dpc=o,e.$Dpc=o=Je([Ve(0,P.$hQ),Ve(1,C.$Cpc),Ve(2,w.$_j)],o);class n{constructor(l,g,E,D){this.a=new h.$le,this.b=l,this.f=D,this.c=g,this.e=b.$Qo.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,g){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Qo.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(g,E))}getConfiguration(l,g,E){const D=t(g)||{},y=this.g(l?m(this.e.getValue(void 0,D,this.c.workspace),l):this.e.getValue(void 0,D,this.c.workspace));l&&this.h(l,D,E?.identifier);function k(p){if(p==null)return null;if(typeof p=="boolean")return p?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(p){case L.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const A={has(p){return typeof m(y,p)<"u"},get:(p,v)=>{this.h(l?`${l}.${p}`:p,D,E?.identifier);let F=m(y,p);if(typeof F>"u")F=v;else{let N;const O=(j,z)=>{if((0,I.$gg)(j)){let M;const U=()=>{N=N||(0,r.$do)(y),M=M||m(N,z)};return new Proxy(j,{get:(V,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return U(),()=>M;if(N)return M=M||m(N,z),M[ie];const B=V[ie];return typeof ie=="string"?O(B,`${z}.${ie}`):B},set:(V,ie,B)=>(U(),M&&(M[ie]=B),!0),deleteProperty:(V,ie)=>(U(),M&&delete M[ie],!0),defineProperty:(V,ie,B)=>(U(),M&&Object.defineProperty(M,ie,B),!0)})}return Array.isArray(j)?(0,r.$do)(j):j};F=O(F,p)}return F},update:(p,v,F,N)=>{p=l?`${l}.${p}`:p;const O=k(F);return v!==void 0?this.b.$updateConfigurationOption(O,p,v,D,N):this.b.$removeConfigurationOption(O,p,D,N)},inspect:p=>{p=l?`${l}.${p}`:p;const v=this.e.inspect(p,D,this.c.workspace);if(v)return{key:p,defaultValue:(0,r.$do)(v.policy?.value??v.default?.value),globalValue:(0,r.$do)(v.user?.value??v.application?.value),workspaceValue:(0,r.$do)(v.workspace?.value),workspaceFolderValue:(0,r.$do)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$do)(v.default?.override),globalLanguageValue:(0,r.$do)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$do)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$do)(v.workspaceFolder?.override),languageIds:(0,r.$do)(v.overrideIdentifiers)}}};return typeof y=="object"&&(0,r.$go)(A,y,!1),Object.freeze(A)}g(l){const g=E=>(0,I.$gg)(E)?new Proxy(E,{get:(D,y)=>g(D[y]),set:(D,y,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return g(l)}h(l,g,E){const D=c.$Fo.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),y=E?`[${E.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof g?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){g?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,g){const E=new b.$So(l,g,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>E.affectsConfiguration(D,t(y))})}k(l){return l.reduce((g,E)=>(g.set(E[0],E[1]),g),new Map)}}e.$Epc=n,e.$Fpc=(0,u.$Ei)("IExtHostConfiguration")}),define(ke[100],Ie([1,0,2,7,4,6,9,48,63,41,20,47,19,29,5,14,10,11,95,273,13]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=e.$crc=e.$brc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,L=qe(L),m=qe(m);var t;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(t||(t={}));var o;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(o||(o={}));var n;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(n||(n={}));var d;(function(N){function O(M){if(M){const U=M;return U&&!!U.process}else return!1}N.is=O;function j(M){if(M==null)return;const U={process:M.process,args:M.args};return M.options&&(U.options=n.from(M.options)),U}N.from=j;function z(M){if(M!=null)return new L.$vO(M.process,M.args,M.options)}N.to=z})(d||(d={}));var l;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(l||(l={}));var g;(function(N){function O(M){if(M){const U=M;return U&&(!!U.commandLine||!!U.command)}else return!1}N.is=O;function j(M){if(M==null)return;const U={};return M.commandLine!==void 0?U.commandLine=M.commandLine:(U.command=M.command,U.args=M.args),M.options&&(U.options=l.from(M.options)),U}N.from=j;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new L.$wO(M.commandLine,M.options):new L.$wO(M.command,M.args?M.args:[],M.options)}N.to=z})(g||(g={}));var E;(function(N){function O(M){if(M){const U=M;return U&&U.customExecution==="customExecution"}else return!1}N.is=O;function j(M){return{customExecution:"customExecution"}}N.from=j;function z(M,U){return U.get(M)}N.to=z})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function O(j,z){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=i.$TI),{id:j._id,workspaceFolder:M}}N.from=O})(D||(e.TaskHandleDTO=D={}));var y;(function(N){function O(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=O})(y||(y={}));var k;(function(N){function O(M,U){if(M==null)return[];const V=[];for(const ie of M){const B=j(ie,U);B&&V.push(B)}return V}N.fromMany=O;function j(M,U){if(M==null)return;let V;M.execution instanceof L.$vO?V=d.from(M.execution):M.execution instanceof L.$wO?V=g.from(M.execution):M.execution&&M.execution instanceof L.$xO&&(V=E.from(M.execution));const ie=t.from(M.definition);let B;return M.scope?typeof M.scope=="number"?B=M.scope:B=M.scope.uri:B=L.TaskScope.Workspace,!ie||!B?void 0:{_id:M._id,definition:ie,name:M.name,source:{extensionId:U.identifier.value,label:M.source,scope:B},execution:V,isBackground:M.isBackground,group:y.from(M.group),presentationOptions:o.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=j;async function z(M,U,V){if(M==null)return;let ie;d.is(M.execution)?ie=d.to(M.execution):g.is(M.execution)?ie=g.to(M.execution):E.is(M.execution)&&(ie=E.to(M._id,V));const B=t.to(M.definition);let Y;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Y=M.source.scope:Y=await U.resolveWorkspaceFolder(r.URI.revive(M.source.scope)):Y=L.TaskScope.Workspace),!B||!Y)return;const J=new L.$yO(B,Y,M.name,M.source.label,ie,M.problemMatchers);return M.isBackground!==void 0&&(J.isBackground=M.isBackground),M.group!==void 0&&(J.group=L.$uO.from(M.group._id),J.group&&M.group.isDefault&&(J.group=new L.$uO(J.group.id,J.group.label),M.group.isDefault===!0&&(J.group.isDefault=M.group.isDefault))),M.presentationOptions&&(J.presentationOptions=o.to(M.presentationOptions)),M._id&&(J._id=M._id),M.detail&&(J.detail=M.detail),J}N.to=z})(k||(e.TaskDTO=k={}));var A;(function(N){function O(z){return z}N.from=O;function j(z){if(z)return Object.assign(Object.create(null),z)}N.to=j})(A||(A={}));class p{#e;constructor(O,j,z){this._id=j,this.a=z,this.#e=O}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}let v=class{constructor(O,j,z,M,U,V,ie,B){this.q=new C.$le,this.r=new C.$le,this.s=new C.$le,this.u=new C.$le,this.a=O.getProxy(R.$HN.MainThreadTask),this.b=z,this.c=M,this.d=U,this.e=V,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=B,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(O,j,z){if(!z)return new L.$JN(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:z,extension:O}),this.a.$registerTaskProvider(M,j),new L.$JN(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(O,j){this.a.$registerTaskSystem(O,j)}fetchTasks(O){return this.a.$fetchTasks(A.from(O)).then(async j=>{const z=[];for(const M of j){const U=await k.to(M,this.b,this.m);U&&z.push(U)}return z})}get taskExecutions(){const O=[];return this.k.forEach(j=>O.push(j)),O}terminateTask(O){if(!(O instanceof p))throw new Error("No valid task execution provided");return this.a.$terminateTask(O._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(O,j,z){const M=this.m.get(O.id);M&&(this.o.set(O.id,M),this.e.attachPtyToTerminal(j,await M.callback(z))),this.p=O.id,this.q.fire({execution:await this.z(O)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(O){if(!this.l.has(O.id))return;const j=await this.z(O);this.l.delete(O.id),this.k.delete(O.id),this.B(O),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(O){const j=await this.z(O.id);this.s.fire({execution:j,processId:O.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(O){const j=await this.z(O.id);this.u.fire({execution:j,exitCode:O.exitCode})}$provideTasks(O,j){const z=this.j.get(O);if(!z)return Promise.reject(new Error("no handler found"));const M=[],U=(0,h.$wh)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(V=>this.v(j,M,z,V));return new Promise(V=>{U.then(ie=>{Promise.all(M).then(()=>{V(ie)})})})}async $resolveTask(O,j){const z=this.j.get(O);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await k.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const U=await z.provider.resolveTask(M,I.CancellationToken.None);if(!U)return;this.A(U,z);const V=k.from(U,z.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(V.execution)&&await this.y(V,U,!0),await this.w(V)}x(){return this.h++}async y(O,j,z){const M=await this.a.$createTaskId(O);!z&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(O,j){if(typeof O=="string"){const U=this.l.get(O);if(!U)throw new s.$ab("Unexpected: The specified task is missing an execution");return U}const z=this.l.get(O.id);if(z)return z;let M;return j?M=Promise.resolve(new p(this,O.id,j)):M=k.to(O.task,this.b,this.m).then(U=>{if(!U)throw new s.$ab("Unexpected: Task does not exist.");return new p(this,O.id,U)}),this.l.set(O.id,M),M.then(U=>(this.k.set(O.id,U),U))}A(O,j){O._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(O){this.o.get(O.id)&&this.o.delete(O.id),this.n.has(O.id)&&this.p!==O.id&&(this.m.delete(O.id),this.n.delete(O.id));const z=this.n.values();let M=z.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=z.next()}};e.$brc=v,e.$brc=v=Je([Ve(0,u.$hQ),Ve(1,P.$xQ),Ve(2,T.$Cpc),Ve(3,b.$sQ),Ve(4,c.$Fpc),Ve(5,S.$4pc),Ve(6,$.$_j),Ve(7,f.$gpc)],v);let F=class extends v{constructor(O,j,z,M,U,V,ie,B){super(O,j,z,M,U,V,ie,B),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$i(m.Platform.Web)})}async executeTask(O,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=k.from(j,O);if(z===void 0)throw new Error("Task is not valid");if(E.is(z.execution))await this.y(z,j,!1);else throw new s.$$;const M=await this.z(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(U=>{throw new Error(U)}),M}v(O,j,z,M){const U=[];if(M)for(const V of M){if(this.A(V,z),!V.definition||!O[V.definition.type]){const B=V.source?V.source:"No task source";this.f.warn(`The task [${B}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`)}const ie=k.from(V,z.extension);ie&&E.is(ie.execution)?(U.push(ie),j.push(this.y(ie,V,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:z.extension}}async w(O){if(E.is(O.execution))return O;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(O,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,j,z){}};e.$crc=F,e.$crc=F=Je([Ve(0,u.$hQ),Ve(1,P.$xQ),Ve(2,T.$Cpc),Ve(3,b.$sQ),Ve(4,c.$Fpc),Ve(5,S.$4pc),Ve(6,$.$_j),Ve(7,f.$gpc)],F),e.$drc=(0,w.$Ei)("IExtHostTask")}),define(ke[334],Ie([1,0,37,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=void 0,e.$tM=C,e.$vM=R;function C(L){return"cellResults"in L}e.$uM="rawCell#";function R(L,T){let b=-1;const c=[];let I=[];return L.forEach(u=>{u.range.startLineNumber!==b&&I.length>0&&(c.push([...I]),I=[]),I.push(u),b=u.range.endLineNumber}),I.length>0&&c.push([...I]),c.map(u=>{const P=[],w=u[0].range.startLineNumber,a=u[u.length-1].range.endLineNumber;for(let m=w;m<=a;m++)P.push(T.getLineContent(m));return new r.$0L(P.join(`
`)+`
`,u.map(m=>new h.$Nt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[335],Ie([1,0,8,21,4,3,28,40,12,17,2,27,118,6,34,15,9,53,307,165,24,14,37,263,334,331]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0,S=qe(S),a=qe(a),m=qe(m);class g{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,k,A,p,v,F){this.q=k,this.r=A,this.s=p,this.t=v,this.u=F,this.f=new Map,this.g=new L.$Ac,this.h=new Map,this.j=new C.$le,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$le,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$le,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$le,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$epc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(P.$HN.MainThreadNotebook),this.c=D.getProxy(P.$HN.MainThreadNotebookDocuments),this.d=D.getProxy(P.$HN.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const O=N.notebookEditor?.notebookUri,j=N.cell.handle,M=this.g.get(O)?.getCell(j);if(M)return M.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const O=N.uri,j=this.g.get(O);if(j)return j.apiNotebook}return N}}),g.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,k]of this.h)if(k.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const k=this.g.get(D);if(!k&&!y)throw new Error(`NO notebook document for '${D}'`);return k}static w(D,y){if(!y)return;const k=y.filenamePattern.map(A=>a.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(y.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:k,priority:y.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,y,k){const A=g.a++,p=typeof k.onDidChangeCellStatusBarItems=="function"?g.a++:void 0;this.f.set(A,k),this.b.$registerNotebookCellStatusBarItemProvider(A,p,y);let v;return p!==void 0&&(v=k.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(p))),new m.$JN(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,p),v?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&a.NotebookData.from(D.content)});return I.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const k=await this.c.$tryOpenNotebook(D),A=this.g.get(I.URI.revive(k));return(0,c.$pg)(A?.apiNotebook)}async showNotebookDocument(D,y){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let k;typeof y=="object"?k={position:a.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(a.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:k={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,k),p=A&&this.h.get(A)?.apiEditor;if(p)return p;throw A?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,k,A){const p=this.f.get(D),v=I.URI.revive(y),F=this.g.get(v);if(!F||!p)return;const N=F.getCellFromIndex(k);if(!N)return;const O=await p.provideCellStatusBarItems(N.apiCell,A);if(!O)return;const j=new R.$Tc,z=this.p.add([j]),U=(Array.isArray(O)?O:[O]).map(V=>a.NotebookStatusBarItem.from(V,this.i,j));return{cacheId:z,items:U}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,k,A,p){if((0,b.$cf)(y))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:y,serializer:k,options:A}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},y,a.NotebookDocumentContentOptions.from(A),g.w(D,p)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,y,k){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const p=await A.serializer.deserializeNotebook(y.buffer,k);return new $.$Ww(a.NotebookData.from(p))}async $notebookToData(D,y,k){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const p=await A.serializer.serializeNotebook(a.NotebookData.to(y.value),k);return h.$Ne.wrap(p)}async $saveNotebook(D,y,k,A,p){const v=I.URI.revive(y),F=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${k}, ${v.toString()})`),!F)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new S.$ul((0,r.localize)(10781,null,this.A(v)),S.FileOperationResult.FILE_PERMISSION_DENIED);const O={metadata:(0,s.$lo)(N.apiNotebook.metadata,V=>!(F.options?.transientDocumentMetadata??{})[V]),cells:[]};for(const V of N.apiNotebook.getCells()){const ie=new m.$cP(V.kind,V.document.getText(),V.document.languageId,V.mime,F.options?.transientOutputs?[]:[...V.outputs],V.metadata,V.executionSummary);ie.metadata=(0,s.$lo)(V.metadata,B=>!(F.options?.transientCellMetadata??{})[B]),O.cells.push(ie)}if(await this.z(v,A),p.isCancellationRequested)throw new Error("canceled");const j=await F.serializer.serializeNotebook(O,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${v.toString()}`),await this.s.value.writeFile(v,j),this.D(`Finished write versionId: ${k} ${v.toString()}`);const z=this.s.getFileSystemProviderExtUri(v.scheme),M=await this.s.value.stat(v),U={name:z.basename(v),isFile:(M.type&S.FileType.File)!==0,isDirectory:(M.type&S.FileType.Directory)!==0,isSymbolicLink:(M.type&S.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&S.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((M.permissions??0)&S.FilePermission.Locked),etag:S.$Fl({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${v.toString()})`),U}async $searchInNotebooks(D,y,k,A,p){const v=this.y.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const F=new L.$Bc;await(async(M,U,V)=>{await Promise.all(M.map(async ie=>await Promise.all(ie.filenamePatterns.map(B=>{const Y={_reason:V._reason,folderQueries:V.folderQueries,includePattern:V.includePattern,excludePattern:V.excludePattern,maxResults:V.maxResults,type:o.QueryType.File,filePattern:B};return this.t.doInternalFileSearchWithCustomCallback(Y,U,J=>{J.forEach(_=>{F.has(_)||A.some(re=>ie.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Se=>(0,l.$oL)(Se,_)))||F.add(_)})}).catch(J=>{if(J.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw J})}))))})(k,p,y);const O=new L.$Ac;let j=!1;const z=Array.from(F).map(async M=>{const U=[];try{if(p.isCancellationRequested)return;if(y.maxResults&&[...O.values()].reduce((Y,J)=>Y+J.cellResults.length,0)>y.maxResults){j=!0;return}const V=[],ie=this.g.get(M);if(ie)ie.apiNotebook.getCells().forEach(J=>V.push({input:J.document.getText(),outputs:J.outputs.flatMap(_=>_.items.map(le=>le.data.toString()))}));else{const Y=await this.s.value.readFile(M),J=h.$Ne.fromString(Y.toString()),_=await v.deserializeNotebook(J.buffer,p);if(p.isCancellationRequested)return;a.NotebookData.from(_).cells.forEach(re=>V.push({input:re.source,outputs:re.outputs.flatMap(Se=>Se.items.map(me=>me.valueBytes.toString()))}))}if(p.isCancellationRequested)return;V.forEach((Y,J)=>{const _=y.contentPattern.pattern,le=new n.$d1b(Y.input,void 0,Y.outputs),re=le.findInInputs(_),Se=le.findInOutputs(_),me=Se.flatMap(Q=>(0,d.$vM)(Q.matches,Q.textBuffer)).map((Q,q)=>(Q.webviewIndex=q,Q));if(re.length>0||Se.length>0){const Q={index:J,contentResults:(0,d.$vM)(re,le.inputTextBuffer),webviewResults:me};U.push(Q)}});const B={resource:M,cellResults:U};O.set(M,B);return}catch{return}});return await Promise.all(z),{limitHit:j,results:[...O.values()]}}async z(D,y){const k=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==S.$El&&typeof k.mtime=="number"&&typeof k.size=="number"&&y.mtime<k.mtime&&y.etag!==S.$Fl({mtime:y.mtime,size:k.size}))throw new S.$ul((0,r.localize)(10782,null),S.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,y,k){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const A=new i.$Gqc(y,this.d,D,k.visibleRanges.map(a.NotebookRange.to),k.selections.map(a.NotebookRange.to),typeof k.viewColumn=="number"?a.ViewColumn.to(k.viewColumn):void 0);this.h.set(y,A)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const k of D.value.removedDocuments){const A=I.URI.revive(k),p=this.g.get(A);p&&(p.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(p.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===A.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const k=[];for(const A of D.value.addedDocuments){const p=I.URI.revive(A.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const v=new f.$Fqc(this.c,this.q,this.r,p,A);k.push(...A.cells.map(F=>f.$Eqc.asModelAddData(F))),this.g.get(p)?.dispose(),this.g.set(p,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const k of D.value.addedEditors){if(this.h.has(k.id))return;const A=I.URI.revive(k.documentUri),p=this.g.get(A);p&&this.B(p,k.id,k)}const y=[];if(D.value.removedEditors)for(const k of D.value.removedEditors){const A=this.h.get(k);A&&(this.h.delete(k),this.k?.id===A.id&&(this.k=void 0),y.push(A))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const k=new Set;this.l.forEach(A=>k.add(A.id));for(const A of this.h.values()){const p=k.has(A.id);A._acceptVisibility(p)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=w.$FQ.String.with("notebookType","A notebook type"),k=new w.$HQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new w.$FQ("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>h.$Ne.wrap(p))],new w.$GQ("Notebook Data",p=>a.NotebookData.to(p.value))),A=new w.$HQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new w.$FQ("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new $.$Ww(a.NotebookData.from(p)))],new w.$GQ("Bytes",p=>p.buffer));D.registerApiCommand(k),D.registerApiCommand(A)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Pqc=g}),define(ke[336],Ie([1,0,16,20,52,38,22,42,37]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=void 0,r=qe(r),R=qe(R),L=qe(L);class c{constructor(u,P,w){this.k=u,this.l=P,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$zk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$zk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const P=this.k.folderQueries||[];return new Promise((w,a)=>{const m=$=>{this.f++,u($)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach($=>{const f=$.toString(),i=r.$nc(f);this.j&&this.j(f,i)||this.v(m,{base:$,basename:i})}),Promise.all(P.map($=>this.p($,m))).then($=>{w({limitHit:this.e,stats:$[0]||void 0})},$=>{a(new Error((0,C.$pj)($)))})})}async p(u,P){const w=new h.$we,a=this.q(u),m=this.r(),$=new b.$lM(this.k,u),f=!$.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=T.$fe.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,w.token),t=i.elapsed(),o=T.$fe.create();return this.g&&!this.e||(s&&s.forEach(n=>{const d=r.$gc.relative(u.folder.path,n.path);if(f){const l=r.$nc(n.path);this.v(P,{base:u.folder,relativePath:d,basename:l});return}this.s(m,u.folder,d,P)}),this.g&&!this.e)?null:(this.u(m,$,P),{providerTime:t,postProcessTime:o.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(u){const P=(0,b.$kM)(this.k.includePattern,u.includePattern),w=(0,b.$kM)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:w,includes:P,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},P,w,a){if(w===this.a){const $=r.$nc(this.a);this.v(a,{base:P,relativePath:this.a,basename:$})}function m($){const f=r.$nc($),i=r.$mc($);let s=u[i];s||(s=u[i]=[],m(i)),s.push({base:P,relativePath:$,basename:f})}m(w)}u({rootEntries:u,pathToEntries:P},w,a){const m=this,$=this.a;function f(i){const s=(0,b.$nM)(()=>i.map(t=>t.basename));for(let t=0,o=i.length;t<o;t++){const n=i[t],{relativePath:d,basename:l}=n;if(w.matchesExcludesSync(d,l,$!==l?s:void 0))continue;const g=P[d];if(g)f(g);else{if(d===$)continue;m.v(a,n)}if(m.e)break}}f(u)}v(u,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(P))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,P,w,a){const m=this.c(u.cacheKey),$=new c(u,P,m&&m.token);let f=0;const i=s=>{f+=s.length,w(s.map(t=>this.d(t)))};return this.e($,I.a,i,a).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$we),this.b.get(u)}d(u){return u.relativePath?{resource:L.$fh(u.base,u.relativePath)}:{resource:u.base}}e(u,P,w,a){const m=a.onCancellationRequested(()=>{u.cancel()}),$=i=>{i&&(f.push(i),P>0&&f.length>=P&&(w(f),f=[]))};let f=[];return u.search($).then(i=>(f.length&&w(f),m.dispose(),i),i=>(f.length&&w(f),m.dispose(),Promise.reject(i)))}}e.$Hqc=I}),define(ke[337],Ie([1,0,18,78,38,107,28,14,16,22,12,17,2,111,8,45,11,46,157,332,37]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0,e.$mN=y,r=qe(r),h=qe(h),C=qe(C),b=qe(b),I=qe(I),w=qe(w);let t=class{constructor(A,p,v,F,N){this.a=A,this.b=p,this.c=v,this.d=F,this.e=N}text(A,p,v={}){A=this.f(A,v);const F=this.a.getValue(),N=p&&p.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(p?.map($.$Zi),v),type:s.QueryType.Text,contentPattern:A,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(A,p){const v=this.a.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F={...A,wordSeparators:v.editor.wordSeparators};return this.j(A,p)&&(F.isCaseSensitive=!0),this.k(A)&&(F.isMultiline=!0),p.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=p.notebookSearchConfig.includeMarkupInput),p.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=p.notebookSearchConfig.includeMarkupPreview),p.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=p.notebookSearchConfig.includeCodeInput),p.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=p.notebookSearchConfig.includeOutput),F}file(A,p={}){return{...this.h(A,p),type:s.QueryType.File,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey,shouldGlobMatchFilePattern:p.shouldGlobSearch}}g(A,p){return A?(A=Array.isArray(A)?A.map(g):g(A),p?this.parseSearchPaths(A):{pattern:n(...Array.isArray(A)?A:[A])}):{}}h(A=[],p={}){const v=this.g(p.includePattern,p.expandPatterns),F=this.g(p.excludePattern,p.expandPatterns),N=A.length>1,O=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(M=>this.q(M,p,F)):A.map(M=>this.r(M,p,F,N))).filter(M=>!!M),j={_reason:p._reason,folderQueries:O,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:F.pattern,includePattern:v.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const M=r.$Gb(this.c.groups.flatMap(ie=>ie.editors.map(B=>B.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const U=M.filter(ie=>(0,s.$bM)(j,ie.fsPath)),V=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...j,...V}}const z=p.extraFileResources&&p.extraFileResources.filter(M=>(0,s.$bM)(j,M.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(A){const p=[],v=new L.$Ac,F={};let N=!1;return A.forEach(O=>{if(O.scheme===T.Schemas.walkThrough)return;if((0,c.$jh)(O)){const z=this.b.getWorkspaceFolder(O)?.uri??O.with({path:b.$mc(O.fsPath)});let M=v.get(z);M||(N=!0,M={folder:z,includePattern:{}},p.push(M),v.set(z,M));const U=b.$lc(z.fsPath,O.fsPath);(0,S.$pg)(M.includePattern)[U.replace(/\\/g,"/")]=!0}else O.fsPath&&(N=!0,F[O.fsPath]=!0)}),{folderQueries:p,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(A,p){if(p.isSmartCase){if(A.isRegExp){if(I.$8f(A.pattern,!0))return!0}else if(I.$8f(A.pattern))return!0}return!!A.isCaseSensitive}k(A){return A.isMultiline||A.isRegExp&&(0,P.$kD)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const p=V=>b.$ic(V)||/^\.\.?([\/\\]|$)/.test(V),F=(Array.isArray(A)?A:d(A)).map(V=>{const ie=this.e.resolvedUserHome;return ie?(0,R.$2w)(V,ie.scheme===T.Schemas.file?ie.fsPath:ie.path):V}),N=h.$c(F,V=>p(V)?"searchPaths":"exprSegments"),O=(N.exprSegments||[]).map(V=>I.$nf(V,"/")).map(V=>I.$nf(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),l(V))),j={},z=this.m(N.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const M=O.flat(),U=n(...M);return U&&(j.pattern=U),j}l(A,p){return p.disregardExcludeSettings?void 0:(0,s.$aM)(A,!p.disregardSearchExcludeSettings)}m(A){if(!A||!A.length)return[];const p=A.flatMap(F=>{let{pathPortion:N,globPortion:O}=o(F);return O&&(O=E(O)),this.n(N).flatMap(z=>this.o(z,O))}),v=new Map;return p.forEach(F=>{const N=F.searchPath.toString(),O=v.get(N);O?F.pattern&&(O.pattern=O.pattern||{},O.pattern[F.pattern]=!0):v.set(N,{searchPath:F.searchPath,pattern:F.pattern?n(F.pattern):void 0})}),Array.from(v.values())}n(A){if(b.$ic(A)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==T.Schemas.file?[{searchPath:p[0].uri.with({path:A})}]:[{searchPath:u.URI.file(b.$hc(A))}]}if(this.b.getWorkbenchState()===$.WorkbenchState.FOLDER){const p=this.b.getWorkspace().folders[0].uri;if(A=g(A),A.startsWith("../")||A===".."){const F=b.$gc.resolve(p.path,A);return[{searchPath:p.with({path:F})}]}const v=E(A);return[{searchPath:p,pattern:v}]}else{if(A==="./"||A===".\\")return[];{const p=A.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const O=p.match(new RegExp(`^${I.$hf(N.name)}(?:/(.*)|$)`));return O?{match:O,folder:N}:null}).filter(S.$mg);if(F.length)return F.map(N=>{const O=N.match[1];return{searchPath:N.folder.uri,pattern:O&&E(O)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),O=N?N[1]:A,j=w.localize(1621,null,O);throw new Error(j)}}}}o(A,p){const v=A.pattern&&p?`${A.pattern}/${p}`:A.pattern||p,F=[{searchPath:A.searchPath,pattern:v}];return v&&!v.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:v+"/**"}),F}q(A,p,v){const F=this.r((0,$.$Zi)(A.searchPath),p,v,!1);return F?{...F,includePattern:A.pattern}:null}r(A,p,v,F){let N;const O=u.URI.isUri(A)?A:A.uri;if(v.searchPaths){const V=v.searchPaths.filter(ie=>(0,c.$$g)(ie.searchPath,O))[0];if(V&&!V.pattern)return null;V&&(N=V.pattern)}const j=this.a.getValue({resource:O}),M={...this.l(j,p)||{},...N||{}},U=u.URI.isUri(A)?(0,c.$ch)(A):A.name;return{folder:O,folderName:F?U:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!j.search.followSymlinks}}};e.$lN=t,e.$lN=t=Je([Ve(0,a.$$i),Ve(1,$.$Ni),Ve(2,f.$sE),Ve(3,m.$_j),Ve(4,i.$jN)],t);function o(k){const A=k.match(/[\*\{\}\(\)\[\]\?]/);if(A){const p=A.index,v=k.substr(0,p).match(/[/|\\][^/\\]*$/);if(v){let F=k.substr(0,v.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:k.substr((v.index||0)+1)}}}return{pathPortion:k}}function n(...k){return k.length?k.reduce((A,p)=>(A[p]=!0,A),Object.create(null)):void 0}function d(k){return C.$xk(k,",").map(A=>A.trim()).filter(A=>!!A.length)}function l(k){return[`**/${k}/**`,`**/${k}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function g(k){return k.replace(/\\/g,"/")}function E(k){return g(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(k){return k.replace(/([?*[\]])/g,"[$1]")}function y(k,A){k=r.$Lb(k,F=>F.toString());const p=[],v=A.getWorkspace();return k&&k.forEach(F=>{let N;if(A.getWorkbenchState()===$.WorkbenchState.FOLDER)N=(0,c.$hh)(v.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const O=A.getWorkspaceFolder(F);if(O){const j=O.name;if(v.folders.filter(M=>M.name===j).length===1){const M=(0,c.$hh)(O.uri,F);M===""?N=`./${O.name}`:N=`./${O.name}/${M}`}else N=F.fsPath}}N&&p.push(D(N))}),p}}),define(ke[338],Ie([1,0,22,2,20,13,5,337,37,46,7]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yyb=u,e.$zyb=a,r=qe(r),R=qe(R);const S=7e3;function u(m,$){const f=$.activationEvents;if(!f)return Promise.resolve(void 0);const i=[],s=[];for(const g of f)if(/^workspaceContains:/.test(g)){const E=g.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||m.forceUsingSearch?s.push(E):i.push(E)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$xh)(),n=g=>o({activationEvent:g}),d=Promise.all(i.map(g=>P(m,g,n))).then(()=>{}),l=w(m,$.identifier,s,n);return Promise.all([d,l]).then(()=>{o(void 0)}),t}async function P(m,$,f){for(const i of m.folders)if(await m.exists(r.$fh(h.URI.revive(i),$))){f(`workspaceContains:${$}`);return}}async function w(m,$,f,i){if(f.length===0)return Promise.resolve(void 0);const s=new C.$we,t=m.checkExists(m.folders,f,s.token),o=setTimeout(async()=>{s.cancel(),m.logService.info(`Not activating extension '${$.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},S);let n=!1;try{n=await t}catch(d){R.$3(d)||R.$Y(d)}s.dispose(),clearTimeout(o),n&&i(`workspaceContains:${f.join(",")}`)}function a(m,$,f,i){const s=m.get(L.$Di),t=m.get(b.$5L),n=s.createInstance(T.$lN).file($.map(d=>(0,c.$Zi)(h.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return t.fileSearch(n,i).then(d=>!!d.limitHit,d=>R.$3(d)?!1:Promise.reject(d))}}),define(ke[54],Ie([1,0,8,16,61,22,7,3,84,2,11,6,41,270,125,48,25,159,13,23,21,249,9,71,5,29,97,19,114,76,47,128,4,338,124,251,14,122,42,10,123]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A,p,v,F,N,O,j,z,M,U){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=e.$hqc=e.$gqc=e.$fqc=e.$eqc=void 0,r=qe(r),h=qe(h),C=qe(C),f=qe(f),e.$eqc=(0,d.$Ei)("IHostUtils");let ie=V=class extends T.$Uc{constructor(Q,q,se,we,ee,ae,oe,x,ne,pe,be,Fe,ze){super(),this.Y=Fe,this.Z=ze,this.a=this.B(new p.$le),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=se,this.f=oe,this.j=we,this.m=ee,this.s=ae,this.t=ne,this.u=pe,this.w=be,this.y=this.g.getProxy(S.$HN.MainThreadWorkspace),this.z=this.g.getProxy(S.$HN.MainThreadTelemetry),this.C=this.g.getProxy(S.$HN.MainThreadExtensionService),this.D=new L.$Dh,this.F=new L.$Dh,this.G=new L.$Dh,this.H=new L.$Dh,this.I=new Se(this.f.extensions.activationEvents),this.L=new $.$Edc(this.I,this.f.extensions.allExtensions);const Ae=new i.$rn(this.f.extensions.myExtensions);this.J=new $.$Edc(this.I,le(this.L,Ae)),M.$u&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new w.$Zpc(this.g,this.s),this.N=new F.$0pc(this.g),this.O=x,this.h=this.q.add(Q.createChild(new D.$Ci([w.$1pc,this.M],[F.$$pc,this.N]))),this.P=this.B(new P.$Ypc(this.J,this.L,{onExtensionActivationError:(De,Ce,W)=>{this.C.$onExtensionActivationError(De,f.$1(Ce),W)},actualActivateExtension:async(De,Ce)=>{if($.$Edc.isHostExtension(De,this.J,this.L))return await this.C.$activateExtension(De,Ce),new P.$Xpc;const W=this.J.getExtensionDescription(De);return this.fb(W,Ce)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Q){f.$Y(Q)}}async $(){this.O.onWillDeactivateAll();let Q=[];try{Q=this.J.getAllExtensionDescriptions().map(ee=>ee.identifier).filter(ee=>this.isActivated(ee)).map(ee=>this.eb(ee))}catch{}await Promise.all(Q)}terminate(Q,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Q}`),this.s.flush(),this.u.dispose(),this.P.dispose(),f.setUnexpectedErrorHandler(we=>{this.s.error(we)}),this.g.dispose();const se=this.$();Promise.race([(0,L.$Fh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Q){return this.G.isOpen()?this.P.isActivated(Q):!1}async getExtension(Q){const q=await this.C.$getExtension(Q);return q&&{...q,identifier:new i.$qn(q.identifier.value),extensionLocation:c.URI.revive(q.extensionLocation)}}ab(Q,q){return this.P.activateByEvent(Q,q)}bb(Q,q){return this.P.activateById(Q,q)}activateByIdWithErrors(Q,q){return this.bb(Q,q).then(()=>{const se=this.P.getActivatedExtension(Q);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Q=>this.J)}getExtensionExports(Q){if(this.G.isOpen())return this.P.getActivatedExtension(Q).exports;try{return this.P.getActivatedExtension(Q).exports}catch{return null}}async cb(Q){if(Q.scheme===O.Schemas.file&&this.c.fsRealpath){const q=Q.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const se=await this.R.get(q);return c.URI.file(se)}return Q}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Q=>new re(Q))),this.Q}async db(Q){const q=b.$Ki.forUris(se=>R.$9g.ignorePathCasing(se));return await Promise.all(Q.map(async se=>{if(this.wb(se)){const we=await this.cb(se.extensionLocation);q.set(we,se)}})),q}eb(Q){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Q))return q;const se=this.P.getActivatedExtension(Q);if(!se)return q;try{typeof se.module.deactivate=="function"&&(q=Promise.resolve(se.module.deactivate()).then(void 0,we=>(this.s.error(we),Promise.resolve(void 0))))}catch(we){this.s.error(`An error occurred when deactivating the extension '${Q.value}':`),this.s.error(we)}try{se.disposable.dispose()}catch(we){this.s.error(`An error occurred when disposing the subscriptions for extension '${Q.value}':`),this.s.error(we)}return q}async fb(Q,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Q.identifier):await this.C.$onWillActivateExtension(Q.identifier),this.hb(Q,q).then(se=>{const we=se.activationTimes;return this.C.$onDidActivateExtension(Q.identifier,we.codeLoadingTime,we.activateCallTime,we.activateResolvedTime,q),this.gb(Q,q,"success",we),se},se=>{throw this.gb(Q,q,"failure"),se})}gb(Q,q,se,we){const ee=Y(Q,q);this.z.$publicLog2("extensionActivationTimes",{...ee,...we||{},outcome:se})}hb(Q,q){const se=Y(Q,q);this.z.$publicLog2("activatePlugin",se);const we=this.wb(Q);if(!we)return Promise.resolve(new P.$Wpc(P.$Tpc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Q.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const ee=new T.$Tc,ae=new P.$Upc(q.startup);return Promise.all([this.xb(Q,(0,R.$fh)(Q.extensionLocation,we),ae),this.ib(Q,ee)]).then(oe=>(C.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),V.jb(this.s,Q.identifier,oe[0],oe[1],ee,ae))).then(oe=>(C.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),oe))}ib(Q,q){const se=this.Z.createLanguageModelAccessInformation(Q),we=q.add(new t.$3pc(Q,this.M)),ee=q.add(new t.$2pc(Q.identifier.value,!1,this.M)),ae=q.add(new N.$_pc(Q,this.N)),oe=Q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,x=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([we.whenReady,ee.whenReady,this.O.whenReady]).then(()=>{const ne=this;let pe,be;const Fe=(0,m.$eH)(Q,"ipc")?this.f.messagePorts?.get(i.$qn.toKey(Q.identifier)):void 0;return Object.freeze({globalState:we,workspaceState:ee,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return se},get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(ze){return h.$jc(Q.extensionLocation.fsPath,ze)},get storagePath(){return ne.O.workspaceValue(Q)?.fsPath},get globalStoragePath(){return ne.O.globalValue(Q).fsPath},get logPath(){return h.$jc(ne.f.logsLocation.fsPath,Q.identifier.value)},get logUri(){return c.URI.joinPath(ne.f.logsLocation,Q.identifier.value)},get storageUri(){return ne.O.workspaceValue(Q)},get globalStorageUri(){return ne.O.globalValue(Q)},get extensionMode(){return oe},get extension(){return pe===void 0&&(pe=new _(ne,Q.identifier,Q,x,!1)),pe},get extensionRuntime(){return(0,m.$fH)(Q,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne.u.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!be){if(!Fe)return;const ze=p.Event.buffer(p.Event.fromDOMEventEmitter(Fe,"message",Ae=>Ae.data));Fe.start(),be={onDidReceiveMessage:ze,postMessage:Fe.postMessage.bind(Fe)}}return be}})})}static jb(Q,q,se,we,ee,ae){return se=se||{activate:void 0,deactivate:void 0},this.kb(Q,q,se,we,ae).then(oe=>new P.$Vpc(!1,null,ae.build(),se,oe,(0,T.$Sc)(()=>{ee.dispose(),(0,T.$Pc)(we.subscriptions)})))}static kb(Q,q,se,we,ee){if(typeof se.activate=="function")try{ee.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${q.value}`);const ae=typeof global=="object"?global:self,oe=se.activate.apply(ae,[we]);return ee.activateCallStop(),ee.activateResolveStart(),Promise.resolve(oe).then(x=>(ee.activateResolveStop(),x))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(se)}lb(Q,q){this.bb(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:q}).then(void 0,se=>{this.s.error(se)})}mb(Q,q=0){const we=Date.now();(0,M.$C)(()=>{for(let ee=q;ee<Q.length;ee+=1){const ae=Q[ee];for(const oe of ae.activationEvents??[])if(oe==="onStartupFinished")if(Date.now()-we>50){this.mb(Q,ee);break}else this.lb(ae,oe)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Q=>{const q=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(q)this.mb(se);else for(const we of se)if(we.activationEvents)for(const ee of we.activationEvents)ee==="onStartupFinished"&&this.lb(we,ee)})}ob(){const Q=this.ab("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.pb(ae.added)));const q=this.j.workspace?this.j.workspace.folders:[],se=this.pb(q),we=this.rb(),ee=Promise.all([we,Q,se]).then(()=>{});return Promise.race([ee,(0,L.$Fh)(1e4)]).then(()=>{this.nb()}),ee}pb(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(Q,q))).then(()=>{})}async qb(Q,q){if(this.isActivated(q.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,we={logService:this.s,folders:Q.map(ae=>ae.uri),forceUsingSearch:se||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,oe,x)=>this.y.$checkExists(ae,oe,x)},ee=await(0,v.$yyb)(we,q);if(ee)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ee.activationEvent}).then(void 0,ae=>this.s.error(ae))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Q){throw console.error(Q),Q}}async sb(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:q}=this.f.environment;if(!Q||!q)throw new Error(r.localize(10789,null));const se=await this.xb(null,q,new P.$Upc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(10790,null,q.toString()));return new Promise((we,ee)=>{const ae=(ne,pe)=>{ne?(M.$u&&this.s.error("Test runner called back with error",ne),ee(ne)):(M.$u&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),we(typeof pe=="number"&&pe>0?1:0))},oe=(0,R.$6g)(q),x=se.run(oe,ae);x&&x.then&&x.then(()=>{M.$u&&this.s.info("Test runner finished successfully."),we(0)}).catch(ne=>{M.$u&&this.s.error("Test runner finished with error",ne),ee(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Fh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,q){return this.S[Q]=q,(0,T.$Sc)(()=>{delete this.S[Q]})}async getRemoteExecServer(Q){const{resolver:q}=await this.ub(Q);return q?.resolveExecServer?.(Q,{resolveAttempt:0})}async ub(Q){const q=Q.indexOf("+");if(q===-1)throw new o.$RN("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=Q.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(Q,q){const se=z.$fe.create(!1),we=()=>`[resolveAuthority(${(0,n.$Ul)(Q)},${q})][${se.elapsed()}ms] `,ee=H=>this.s.info(`${we()}${H}`),ae=H=>this.s.warn(`${we()}${H}`),oe=(H,X=void 0)=>this.s.error(`${we()}${H}`,X),x=H=>{if(H instanceof o.$RN)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},ne=async H=>{ee(`activating resolver for ${H}...`);const{resolver:X,authorityPrefix:Z}=await this.ub(H);if(!X)throw oe(`no resolver for ${Z}`),new o.$RN(`No remote extension installed to resolve ${Z}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:Z,remoteAuthority:H}},pe=Q.split(/@|%40/g).reverse();ee(`activating remote resolvers ${pe.join(" -> ")}`);let be;try{be=await Promise.all(pe.map(ne)).catch(async H=>{if(!(H instanceof o.$RN)||H._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return ae(`resolving nested authorities failed: ${H.message}`),[await ne(Q)]})}catch(H){return x(H)}const Fe=new L.$Ph;Fe.cancelAndSet(()=>ee("waiting..."),1e3);let ze,Ae;for(const[H,{authorityPrefix:X,resolver:Z,remoteAuthority:de}]of be.entries())try{if(H===be.length-1)ee("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${X}`),ze=await Z.resolve(de,{resolveAttempt:q,execServer:Ae}),C.mark(`code/extHost/didResolveAuthorityOK/${X}`),ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Z,o.$QN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ee(`invoking resolveExecServer() for ${de}`),C.mark(`code/extHost/willResolveExecServer/${X}`),Ae=await Z.resolveExecServer?.(de,{resolveAttempt:q,execServer:Ae}),!Ae)throw new o.$RN(`Exec server was not available for ${de}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(ve){return C.mark(`code/extHost/didResolveAuthorityError/${X}`),oe("returned an error",ve),Fe.dispose(),x(ve)}Fe.dispose();const De={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Ce={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ee(`returned ${o.$QN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let W;if(o.$QN.isManagedResolvedAuthority(ze)){const H=q;this.Y.setFactory(H,ze.makeConnection),W={authority:Q,connectTo:new n.$Rl(H),connectionToken:ze.connectionToken}}else W={authority:Q,connectTo:new n.$Sl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:W,options:Ce,tunnelInformation:De}}}async $getCanonicalURI(Q,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Ul)(Q)})`);const{resolver:se}=await this.ub(Q);if(!se)return null;const we=c.URI.revive(q);if(typeof se.getCanonicalURI>"u")return we;const ee=await(0,L.$wh)(()=>se.getCanonicalURI(we));return ee||we}async $startExtensionHost(Q){Q.toAdd.forEach(ae=>ae.extensionLocation=c.URI.revive(ae.extensionLocation));const{globalRegistry:q,myExtensions:se}=B(this.I,this.L,this.J,Q),we=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(q.getAllExtensionDescriptions()),this.J.set(se),M.$u&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.tb()}$activateByEvent(Q,q){return q===m.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(Q,!1)):this.G.wait().then(se=>this.ab(Q,!1))}async $activate(Q,q){return await this.G.wait(),this.J.getExtensionDescription(Q)?(await this.bb(Q,q),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(ae=>ae.extensionLocation=c.URI.revive(ae.extensionLocation));const{globalRegistry:q,myExtensions:se}=B(this.I,this.L,this.J,Q),we=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(q.getAllExtensionDescriptions()),this.J.set(se),M.$u&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const q=s.$Ne.alloc(Q),se=Math.random()%256;for(let we=0;we<Q;we++)q.writeUInt8(se,we);return q}async $updateRemoteConnectionData(Q){this.X=Q,this.a.fire()}};e.$fqc=ie,e.$fqc=ie=V=Je([Ve(0,d.$Di),Ve(1,e.$eqc),Ve(2,E.$hQ),Ve(3,a.$Cpc),Ve(4,u.$Fpc),Ve(5,I.$_j),Ve(6,l.$xQ),Ve(7,g.$Ipc),Ve(8,y.$eGb),Ve(9,k.$4pc),Ve(10,j.$bqc),Ve(11,U.$cqc),Ve(12,A.$8pc)],ie);function B(me,Q,q,se){me.addActivationEvents(se.addActivationEvents);const we=new $.$Edc(me,Q.getAllExtensionDescriptions());we.deltaExtensions(se.toAdd,se.toRemove);const ee=new i.$rn(q.getAllExtensionDescriptions().map(oe=>oe.identifier));for(const oe of se.myToRemove)ee.delete(oe);for(const oe of se.myToAdd)ee.add(oe);const ae=le(we,ee);return{globalRegistry:we,myExtensions:ae}}function Y(me,Q){return{id:me.identifier.value,name:me.name,extensionVersion:me.version,publisherDisplayName:me.publisher,activationEvents:me.activationEvents?me.activationEvents.join(","):null,isBuiltin:me.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}function J(me){return me.getAllExtensionDescriptions().map(Q=>Q.identifier.value).join(",")}e.$gqc=(0,d.$Ei)("IExtHostExtensionService");class _{#e;#t;#i;constructor(Q,q,se,we,ee){this.#e=Q,this.#t=q,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$hc((0,R.$6g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=we,this.isFromDifferentExtensionHost=ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$hqc=_;function le(me,Q){return me.getAllExtensionDescriptions().filter(q=>Q.has(q.identifier))}class re{constructor(Q){this.a=Q}setSearchTree(Q){this.a=Q}findSubstr(Q){return this.a.findSubstr(Q)}forEach(Q){return this.a.forEach(Q)}}e.$iqc=re;class Se{constructor(Q){this.a=new i.$sn,this.addActivationEvents(Q)}readActivationEvents(Q){return this.a.get(Q.identifier)??[]}addActivationEvents(Q){for(const q of Object.keys(Q))this.a.set(q,Q[q])}}}),define(ke[339],Ie([1,0,61,2,6,41,25,23,19,29,5,54,11,12]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=void 0,r=qe(r);let a=class{constructor(s,t,o,n,d,l,g){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.h=l,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new $(this.c,t,this.d,s,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(f,t,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const t of s.nodeModuleName)this.a.set(t,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(t=>s.alternativeModuleName(t))}};e.$trc=a,e.$trc=a=Je([Ve(2,I.$Di),Ve(3,R.$Fpc),Ve(4,S.$gqc),Ve(5,c.$xQ),Ve(6,u.$_j)],a);let m=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&w.a.size){const t=(0,P.$hf)(this.c(s.environment.appRoot.fsPath)),o="[a-z0-9_.-]",n=`@${o}+\\/${o}+|${o}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${d}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const t=this.b.exec(this.c(s));if(!t)return;const[,o,n,d]=t,l=w.a.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),o+l+d}c(s){return s.replace(/\\/g,"/")}};m=w=Je([Ve(0,c.$xQ)],m);class ${constructor(s,t,o,n,d){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.nodeModuleName="vscode",this.a=new T.$sn}load(s,t){const o=this.d.findSubstr(t);if(o){let n=this.a.get(o.identifier);return n||(n=this.c(o,this.e,this.f),this.a.set(o.identifier,n)),n}if(!this.b){let n="";this.d.forEach((d,l)=>n+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this.b=this.c(L.$_G,this.e,this.f)}return this.b}}let f=class{constructor(s,t,o){this.e=s,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(C.$HN.MainThreadTelemetry);const n=o.getProxy(C.$HN.MainThreadWindow);this.c=(d,l)=>{const g=h.URI.parse(d);return l?this.g(d,l):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,d,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?n.$openUri(g,d,{}):this.g(d,l)}}load(s,t,o){const n=this.e.findSubstr(t);return n&&(this.a=n.identifier.value,this.h()),this.b=o(s),this.c}g(s,t){return this.i(),this.b(s,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=Je([Ve(2,b.$hQ)],f)}),define(ke[64],Ie([1,0,49,3,16,55,5,63,77,54,9,48,267,41]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0,C=qe(C),R=qe(R),e.$jqc=(0,L.$Ei)("IExtHostVariableResolverProvider");class w extends u.$lR{constructor($,f,i,s,t,o,n){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const g=s.tabGroups.all.find(E=>E.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof I.$yP||g.input instanceof I.$DP)return g.input.modified;if(g.input instanceof I.$xP||g.input instanceof I.$CP||g.input instanceof I.$AP)return g.input.uri}}}super({getFolderUri:l=>{const g=o.folders.filter(E=>E.name===l);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(l,g)=>t.getConfiguration(void 0,l).get(g),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return C.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const l=d();if(l){const g=f.getWorkspaceFolder(l);if(g)return C.$hc(g.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>$.getExtension(l)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let a=class extends h.$Uc{constructor($,f,i,s,t){super(),this.b=$,this.c=f,this.g=i,this.h=s,this.j=t,this.a=new r.$T(async()=>{const o=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,o,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$kqc=a,e.$kqc=a=Je([Ve(0,c.$gqc),Ve(1,S.$Cpc),Ve(2,T.$sQ),Ve(3,P.$Fpc),Ve(4,b.$Rpc)],a)}),define(ke[101],Ie([1,0,7,4,2,3,23,5,6,77,54,19,9,48,154,119,258,41,64,50,34,15,18,98]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=e.$tqc=e.$sqc=e.$rqc=e.$qqc=void 0,t=qe(t),e.$qqc=(0,T.$Ei)("IExtHostDebugService");let d=class extends R.$Uc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(A,p,v,F,N,O,j,z){super(),this.Y=p,this.Z=v,this.$=F,this.ab=N,this.bb=O,this.cb=j,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$le),this.z=this.B(new h.$le),this.C=this.B(new h.$le),this.F=this.B(new h.$le),this.u=A.getProxy(b.$HN.MainThreadDebugService),this.I=this.B(new h.$le),this.L=this.B(new h.$le),this.G=new g(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(M=>{this.B(M.onDidChange(U=>{this.fb(M)})),this.fb(M)})}async $getVisualizerTreeItem(A,p){const v=this.gb(p);if(!v)return;const F=await this.Q.get(A)?.getTreeItem?.(v);return F?this.eb(A,F):void 0}registerDebugVisualizationTree(A,p,v){const F=L.$qn.toKey(A.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(N,v),this.u.$registerDebugVisualizerTree(N,!!v.editItem),(0,R.$Sc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(A,p){const v=this.S.get(p)?.item;return v?(await this.Q.get(A)?.getChildren?.(v))?.map(N=>this.eb(A,N))||[]:[]}async $editVisualizerTreeItem(A,p){const v=this.S.get(A);if(!v)return;const F=await this.Q.get(v.provider)?.editItem?.(v.item,p);return this.eb(v.provider,F||v.item)}$disposeVisualizedTree(A){const p=this.S.get(A);if(!p)return;const v=[p.children];for(const F of v)if(F)for(const N of F)v.push(this.S.get(N)?.children),this.S.delete(N)}eb(A,p){let v=this.R.get(p);return v||(v=this.O++,this.R.set(p,v),this.S.set(v,{provider:A,item:p})),t.DebugTreeItem.from(p,v)}asDebugSourceUri(A,p){const v=A;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let F=`debug:${encodeURIComponent(v.path||"")}`,N="?";return p&&(F+=`${N}session=${encodeURIComponent(p.id)}`,N="&"),F+=`${N}ref=${v.sourceReference}`,C.URI.parse(F)}else{if(v.path)return C.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(A){const p=[];for(const v of A.getAllExtensionDescriptions())if(v.contributes){const F=v.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,m.$0H)(N)&&p.push(N.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const A=[];return this.H.forEach(p=>A.push(p)),A}async $resolveDebugVisualizer(A,p){const v=this.W.get(A);if(!v)throw new Error(`No debug visualizer found with id '${A}'`);let{v:F,provider:N,extensionId:O}=v;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,p)||F,v.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(O,F.visualization)}async $executeDebugVisualizerCommand(A){const p=this.W.get(A);if(!p)throw new Error(`No debug visualizer found with id '${A}'`);const v=p.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(A){const p=this.w.get(A.sessionId);return p&&{session:p.api,variable:A.variable,containerId:A.containerId,frameId:A.frameId,threadId:A.threadId}}async $provideDebugVisualizers(A,p,v,F){const N=this.gb(v),O=this.ub(A,p),j=this.P.get(O);if(!N||!j)return[];const z=await j.provideDebugVisualization(N,F);return z?z.map(M=>{const U=++this.X;this.W.set(U,{v:M,provider:j,extensionId:A});const V=M.iconPath?this.wb(M.iconPath):void 0;return{id:U,name:M.name,iconClass:V?.iconClass,iconPath:V?.iconPath,visualization:this.vb(A,M.visualization)}}):[]}$disposeDebugVisualizers(A){for(const p of A)this.W.delete(p)}registerDebugVisualizationProvider(A,p,v){if(!A.contributes?.debugVisualizers?.some(O=>O.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const F=L.$qn.toKey(A.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(N,v),this.u.$registerDebugVisualizer(F,p),(0,R.$Sc)(()=>{this.u.$unregisterDebugVisualizer(F,p),this.P.delete(p)})}addBreakpoints(A){const p=A.filter(N=>{const O=N.id;return this.H.has(O)?!1:(this.H.set(O,N),!0)});this.rb(p,[],[]);const v=[],F=new Map;for(const N of p)if(N instanceof u.$NO){let O=F.get(N.location.uri.toString());O||(O={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),O),v.push(O)),O.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.$OO&&v.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(A){const p=A.filter(O=>this.H.delete(O.id));this.rb([],p,[]);const v=p.filter(O=>O instanceof u.$NO).map(O=>O.id),F=p.filter(O=>O instanceof u.$OO).map(O=>O.id),N=p.filter(O=>O instanceof u.$PO).map(O=>O.id);return this.u.$unregisterBreakpoints(v,F,N)}startDebugging(A,p,v){const F=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(A?A.uri:void 0,p,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(A){return this.u.$stopDebugging(A?A.id:void 0)}registerDebugConfigurationProvider(A,p,v){if(!p)return new u.$JN(()=>{});const F=this.f++;return this.g.push({type:A,handle:F,provider:p}),this.u.$registerDebugConfigurationProvider(A,v,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,F),new u.$JN(()=>{this.g=this.g.filter(N=>N.provider!==p),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(A,p,v){if(!v)return new u.$JN(()=>{});if(!this.nb(A,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:p,handle:F,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(p,F),new u.$JN(()=>{this.j=this.j.filter(N=>N.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(A,p){if(!p)return new u.$JN(()=>{});const v=this.m++;return this.n.push({type:A,handle:v,factory:p}),new u.$JN(()=>{this.n=this.n.filter(F=>F.factory!==p)})}async $runInTerminal(A,p){return Promise.resolve(void 0)}async $substituteVariables(A,p){let v;const F=await this.tb(A);return F&&(v={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,p)}hb(A,p){if(A.type==="implementation")return new D(A.implementation)}ib(){}async $startDASession(A,p){const v=this,F=await this.sb(p);return this.pb(this.kb(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const O=this.jb(N),j=this.hb(O,F);if(!j)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const z=j;return this.M.set(A,z),this.ob(F).then(M=>(M&&this.N.set(A,M),z.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const V=U,ie={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const B=await this.U.sign(V.arguments.value);ie.body={signature:B},z.sendResponse(ie)}else throw new Error("no signer")}catch(B){ie.success=!1,ie.message=B.message,z.sendResponse(ie)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(U),U=(0,m.$cI)(U,!0),v.u.$acceptDAMessage(A,U)}),z.onError(U=>{M&&M.onError&&M.onError(U),this.u.$acceptDAError(A,U.name,U.message,U.stack)}),z.onExit(U=>{M&&M.onExit&&M.onExit(U??void 0,void 0),this.u.$acceptDAExit(A,U??void 0,void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),z.startSession()))})}$sendDAMessage(A,p){p=(0,m.$bI)(p,!1);const v=this.N.get(A);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(p),this.M.get(A)?.sendMessage(p)}$stopDASession(A){const p=this.N.get(A);this.N.delete(A),p&&p.onWillStopSession&&p.onWillStopSession();const v=this.M.get(A);return this.M.delete(A),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(A){const p=[],v=[],F=[];if(A.added)for(const N of A.added){const O=N.id;if(O&&!this.H.has(O)){let j;if(N.type==="function")j=new u.$OO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")j=new u.$PO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const z=C.URI.revive(N.uri);j=new u.$NO(new u.$XN(z,new u.$KN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.$LO)(j,O),this.H.set(O,j),p.push(j)}}if(A.removed)for(const N of A.removed){const O=this.H.get(N);O&&(this.H.delete(N),v.push(O))}if(A.changed){for(const N of A.changed)if(N.id){const O=this.H.get(N.id);if(O){if(O instanceof u.$OO&&N.type==="function"){const j=O;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.functionName=N.functionName}else if(O instanceof u.$NO&&N.type==="source"){const j=O;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.location=new u.$XN(C.URI.revive(N.uri),new u.$KN(N.line,N.character))}F.push(O)}}}this.rb(p,v,F)}async $acceptStackFrameFocus(A){let p;if(A){const v=await this.sb(A.sessionId);A.kind==="thread"?p=new u.$VO(v.api,A.threadId):p=new u.$UO(v.api,A.threadId,A.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(A,p,v){return(0,r.$wh)(async()=>{const F=this.mb(A);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(p);return F.provideDebugConfigurations(N,v)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(A,p,v,F){return(0,r.$wh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.tb(p);return N.resolveDebugConfiguration(O,v,F)})}$resolveDebugConfigurationWithSubstitutedVariables(A,p,v,F){return(0,r.$wh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.tb(p);return N.resolveDebugConfigurationWithSubstitutedVariables(O,v,F)})}async $provideDebugAdapter(A,p){const v=this.lb(A);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(p);return this.pb(v,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(A){const p=await this.sb(A);this.y.fire(p.api)}async $acceptDebugSessionTerminated(A){const p=await this.sb(A);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(A){this.D=A?await this.sb(A):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(A,p){(await this.sb(A))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(A,p){const F={session:(await this.sb(A)).api,event:p.event,body:p.body};this.F.fire(F)}jb(A){if(A instanceof u.$QO)return{type:"executable",command:A.command,args:A.args,options:A.options};if(A instanceof u.$RO)return{type:"server",port:A.port,host:A.host};if(A instanceof u.$SO)return{type:"pipeServer",path:A.path};if(A instanceof u.$TO)return{type:"implementation",implementation:A.implementation};throw new Error("convertToDto unexpected type")}kb(A){const p=this.j.filter(v=>v.type===A);if(p.length>0)return p[0].factory}lb(A){const p=this.j.filter(v=>v.handle===A);if(p.length>0)return p[0].factory}mb(A){const p=this.g.filter(v=>v.handle===A);if(p.length>0)return p[0].provider}nb(A,p){if(A.contributes){const v=A.contributes.debuggers;if(v&&v.length>0){for(const F of v)if(F.label&&F.type&&F.type===p)return!0}}return!1}ob(A){const v=A.configuration.type,F=this.n.filter(N=>N.type===v||N.type==="*").map(N=>(0,r.$wh)(()=>N.factory.createDebugAdapterTracker(A.api)).then(O=>O,O=>null));return Promise.race([Promise.all(F).then(N=>{const O=(0,o.$Gb)(N);if(O.length>0)return new E(O)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(A,p){const v=p.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$RO(v));if(A){const N=await this.Z.getExtensionRegistry();return(0,r.$wh)(()=>A.createDebugAdapterDescriptor(p.api,this.qb(p,N))).then(O=>{if(O)return O})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,F))}qb(A,p){}rb(A,p,v){(A.length>0||p.length>0||v.length>0)&&this.I.fire(Object.freeze({added:A,removed:p,changed:v}))}async sb(A){if(A)if(typeof A=="string"){const p=this.w.get(A);if(p)return p}else{let p=this.w.get(A.id);if(!p){const v=await this.tb(A.folderUri),F=A.parent?this.w.get(A.parent):void 0;p=new l(this.u,A.id,A.type,A.name,v,A.configuration,F?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(A){if(A){const p=C.URI.revive(A);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(A,p){return`${A}\0${p}`}vb(A,p){if(p){if("title"in p&&"command"in p)return{type:a.DebugVisualizationType.Command};if("treeId"in p)return{type:a.DebugVisualizationType.Tree,id:`${A}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(A){const p=this.xb(A);let v,F;return"id"in p?F=i.ThemeIcon.asClassName(p):v=p,{iconPath:v,iconClass:F}}xb(A){if(A instanceof u.$IO)return{id:A.id};const p=typeof A=="object"&&"dark"in A?A.dark:A,v=typeof A=="object"&&"light"in A?A.light:A;return{dark:typeof p=="string"?C.URI.file(p):p,light:typeof v=="string"?C.URI.file(v):v}}};e.$rqc=d,e.$rqc=d=Je([Ve(0,S.$hQ),Ve(1,P.$Cpc),Ve(2,I.$gqc),Ve(3,$.$Fpc),Ve(4,c.$Rpc),Ve(5,f.$jqc),Ve(6,s.$DQ),Ve(7,n.$lqc)],d);class l{constructor(A,p,v,F,N,O,j){this.f=A,this.g=p,this.h=v,this.j=F,this.k=N,this.l=O,this.m=j}get api(){const A=this;return this.d??=Object.freeze({id:A.g,type:A.h,get name(){return A.j},set name(p){A.j=p,A.f.$setDebugSessionName(A.g,p)},parentSession:A.m,workspaceFolder:A.k,configuration:A.l,customRequest(p,v){return A.f.$customDebugAdapterRequest(A.g,p,v)},getDebugProtocolBreakpoint(p){return A.f.$getDebugProtocolBreakpoint(A.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(A){this.j=A}get configuration(){return this.l}}e.$sqc=l;class g{constructor(A){this.value=Object.freeze({append(p){A.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$tqc=g;class E{constructor(A){this.d=A}onWillStartSession(){this.d.forEach(A=>A.onWillStartSession?A.onWillStartSession():void 0)}onWillReceiveMessage(A){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(A):void 0)}onDidSendMessage(A){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(A):void 0)}onWillStopSession(){this.d.forEach(A=>A.onWillStopSession?A.onWillStopSession():void 0)}onError(A){this.d.forEach(p=>p.onError?p.onError(A):void 0)}onExit(A,p){this.d.forEach(v=>v.onExit?v.onExit(A,p):void 0)}}class D extends w.$5tb{constructor(A){super(),this.h=A,A.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(A){this.h.handleMessage(A)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends d{constructor(A,p,v,F,N,O,j,z){super(A,p,v,F,N,O,j,z)}};e.$uqc=y,e.$uqc=y=Je([Ve(0,S.$hQ),Ve(1,P.$Cpc),Ve(2,I.$gqc),Ve(3,$.$Fpc),Ve(4,c.$Rpc),Ve(5,f.$jqc),Ve(6,s.$DQ),Ve(7,n.$lqc)],y)}),define(ke[340],Ie([1,0,13,61,2,6,288,11,88,114,29,225,19,72,54,94]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=e.$urc=void 0,r=qe(r),h=qe(h);class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(T.$_j),o=i.get(u.$hQ).getProxy(R.$HN.MainThreadErrors);r.setUnexpectedErrorHandler(n=>{s.error(n);const d=r.$1(n);o.$onUnexpectedError(d)})}static async installFullHandler(i){const s=i.get(T.$_j),t=i.get(u.$hQ),o=i.get(w.$gqc),n=i.get(a.$BQ),d=t.getProxy(R.$HN.MainThreadExtensionService),l=t.getProxy(R.$HN.MainThreadErrors),g=await o.getExtensionPathIndex(),E=new WeakMap;function D(A,p){if(E.has(A))return E.get(A).stack;let v="",F,N;for(const j of p)v+=`
	at ${j.toString()}`,N=j.getFileName(),!F&&N&&(F=g.findSubstr(C.URI.file(N)));const O=`${A.name||"Error"}: ${A.message||""}${v}`;return E.set(A,{extensionIdentifier:F?.identifier,stack:O}),O}const y=Symbol("prepareStackTrace wrapped");let k=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(A){if(A===D||!A||A[y]){k=A||D;return}k=function(p,v){return D(p,v),A.call(Error,p,v)},Object.assign(k,{[y]:!0})}}),r.setUnexpectedErrorHandler(A=>{s.error(A);const p=r.$1(A),v=E.get(A);if(!v?.extensionIdentifier){l.$onUnexpectedError(p);return}d.$onExtensionRuntimeError(v.extensionIdentifier,p);const F=n.onExtensionError(v.extensionIdentifier,A);s.trace("forwarded error to extension?",F,v)})}}e.$urc=m;class ${constructor(i,s,t,o,n){this.a=t,this.b=new L.$Mdc(i,null,o),s=$.e(s,this.b);const d=new c.$Ci(...(0,b.$Rs)());d.set(I.$xQ,{_serviceBrand:void 0,...s,messagePorts:n}),d.set(u.$hQ,new u.$iQ(this.b)),d.set(P.$zpc,new P.$Apc(o)),d.set(w.$eqc,t);const l=new S.$vr(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(g=>g.get(T.$_j)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction(g=>g.get(w.$gqc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(R.$HN.MainThreadExtensionService);return C.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=C.URI.revive(s.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=C.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>C.URI.revive(s.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=C.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$vrc=$}),define(ke[341],Ie([1,0,7,10,8,218,148,101,77,54,19,47,9,64,48,259,260,41,34,98]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Frc=void 0,h=qe(h),C=qe(C);let s=class extends T.$rqc{constructor(l,g,E,D,y,k,A,p,v){super(l,g,E,D,k,A,p,v),this.Ab=y,this.yb=new n}hb(l,g){switch(l.type){case"server":return new a.$Arc(l);case"pipeServer":return new a.$Brc(l);case"executable":return new a.$Crc(l,g.type)}return super.hb(l,g)}qb(l,g){const E=a.$Crc.platformAdapterExecutable(g.getAllExtensionDescriptions(),l.type);if(E)return new u.$QO(E.command,E.args,E.options)}ib(){return new L.$Lhc}async $runInTerminal(l,g){if(l.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(z=>{this.yb.onTerminalClosed(z)})));const E=await this.$.getConfigProvider(),D=this.Ab.getDefaultShell(!0),y=this.Ab.getDefaultShellArgs(!0),k=l.title||C.localize(10760,null),A=JSON.stringify({shell:D,shellArgs:y});let p=await this.yb.checkout(A,k),v,F=!1;if(p)v=l.cwd;else{const z={shellPath:D,shellArgs:y,cwd:l.cwd,name:k,iconPath:new u.$IO("debug")};F=!0,p=this.Ab.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(p,A)}p.show(!0);const N=await p.processId;F?await new Promise(z=>setTimeout(z,1e3)):(p.state.isInteractedWith&&(p.sendText(""),await(0,r.$Fh)(200)),E.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?p.sendText("cls"):D.indexOf("bash")>=0?p.sendText("clear"):h.$j?p.sendText("cls"):p.sendText("clear")));const O=(0,m.$Erc)(D,l.args,!!l.argsCanBeInterpretedByShell,v,l.env);p.sendText(O);const j=this.onDidTerminateDebugSession(z=>{z.id===g&&(this.yb.free(p),j.dispose())});return N}else if(l.kind==="external")return o(l,await this.$.getConfigProvider());return super.$runInTerminal(l,g)}};e.$Frc=s,e.$Frc=s=Je([Ve(0,I.$hQ),Ve(1,w.$Cpc),Ve(2,c.$gqc),Ve(3,$.$Fpc),Ve(4,S.$4pc),Ve(5,b.$Rpc),Ve(6,P.$jqc),Ve(7,f.$DQ),Ve(8,i.$lqc)],s);let t;function o(d,l){if(!t)if(h.$j)t=new R.$tgc;else if(h.$k)t=new R.$ugc;else if(h.$l)t=new R.$vgc;else throw new Error("external terminals not supported on this platform");const g=l.getConfiguration("terminal");return t.runInTerminal(d.title,d.cwd,d.args,d.env||{},g.external||{})}class n{constructor(){this.b=new Map}static{this.a=1e3}async checkout(l,g,E=!1){const y=[...this.b.entries()].map(([k,A])=>(0,r.$rh)(async p=>{if(k.name!==g||A.lastUsedAt!==-1&&await(0,m.$Drc)(await k.processId))return null;const v=Date.now();return A.lastUsedAt+n.a>v||p.isCancellationRequested?null:A.config!==l?(E&&k.dispose(),null):(A.lastUsedAt=v,k)}));return await(0,r.$Jh)(y,k=>!!k)}insert(l,g){this.b.set(l,{lastUsedAt:Date.now(),config:g})}free(l){const g=this.b.get(l);g&&(g.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}}),define(ke[342],Ie([1,0,16,2,109,48,63,41,46,47,19,29,100,14,11,95,22,66,64]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xrc=void 0,r=qe(r),m=qe(m);let i=class extends u.$brc{constructor(t,o,n,d,l,g,E,D,y){super(t,o,n,d,l,g,E,D),this.C=n,this.D=y,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,o){const n=o;if(!o.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const d=u.TaskHandleDTO.from(n,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const g=await this.z(l,o);return this.a.$executeTask(d).catch(()=>{}),g}else{const d=u.TaskDTO.from(o,t);if(d===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(d.execution)&&await this.y(d,o,!1);const l=await this.z(await this.a.$getTaskExecution(d),o);return this.a.$executeTask(d).catch(()=>{}),l}}v(t,o,n,d){const l=[];if(d)for(const g of d){this.A(g,n),(!g.definition||!t[g.definition.type])&&this.f.warn(`The task [${g.source}, ${g.name}] uses an undefined task type. The task will be ignored in the future.`);const E=u.TaskDTO.from(g,n.extension);E&&(l.push(E),u.CustomExecutionDTO.is(E.execution)&&o.push(this.y(E,g,!0)))}return{tasks:l,extension:n.extension}}async w(t){return t}async G(t){let o=t&&t.length>0?t[0]:void 0;if(!o){const n=h.URI.file((0,$.homedir)());o=new b.$Yi({uri:n,name:m.$ch(n),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,o){const n=h.URI.revive(t),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(n),g=await this.b.getWorkspaceFolders2()??[],E=await this.D.getResolver(),D=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(g);for(const y of o.variables)d.variables[y]=await E.resolveAsync(D,y);if(o.process!==void 0){let y;if(o.process.path!==void 0){y=o.process.path.split(r.$tc);for(let k=0;k<y.length;k++)y[k]=await E.resolveAsync(D,y[k])}d.process=await C.win32.findExecutable(await E.resolveAsync(D,o.process.name),o.process.cwd!==void 0?await E.resolveAsync(D,o.process.cwd):void 0,y)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(t,o,n){return C.win32.findExecutable(t,o,n)}};e.$xrc=i,e.$xrc=i=Je([Ve(0,I.$hQ),Ve(1,S.$xQ),Ve(2,R.$Cpc),Ve(3,L.$sQ),Ve(4,T.$Fpc),Ve(5,c.$4pc),Ve(6,w.$_j),Ve(7,a.$gpc),Ve(8,f.$jqc)],i)}),define(ke[343],Ie([1,0,66,64]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=void 0;class C extends h.$kqc{m(){return(0,r.homedir)()}}e.$dsc=C}),define(ke[171],Ie([1,0,18,7,20,52,14,16,22,2,37]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=e.$Jqc=e.$Iqc=void 0,e.$Kqc=a,T=qe(T),b=qe(b);class S{constructor(f,i,s){this.d=f,this.e=i,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(f,i){const s=this.g.folderQueries||[],t=new C.$we(i);return new Promise((o,n)=>{this.a=new P(f);let d=!1;const l=(g,E)=>{if(!d&&!this.b){const D=this.h(g);a(g)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,d=!0,t.cancel(),g=this.j(g,this.g.maxResults-this.c));const y=this.h(g);this.c+=y,(y>0||!a(g))&&this.a.add(g,E)}};Promise.all(s.map((g,E)=>this.k(g,D=>l(D,E),t.token))).then(g=>{t.dispose(),this.a.flush();const E=g.some(D=>!!D&&!!D.limitHit);o({limitHit:this.b||E,messages:g.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},g=>{t.dispose();const E=(0,R.$pj)(g);n(new Error(E))})})}h(f){return a(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,i){const s=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:s.slice(0,i),preview:{matches:t.slice(0,i),text:f.preview.text},uri:f.uri}}async k(f,i,s){const t=new I.$lM(this.g,f),o=[],n={report:g=>{if(!this.l(g))return;const E=f.folder.scheme===L.Schemas.file?(0,I.$mM)(()=>this.e.readdir(b.$eh(g.uri))):void 0,D=b.$hh(f.folder,g.uri);if(D){const y=t.includedInQuery(D,T.$nc(D),E);(0,h.$qh)(y)?o.push(y.then(k=>{k&&i(g)})):y&&i(g)}}},d=this.n(f);let l;return this.d.query.type===I.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,n,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),d,n,s),o.length&&await Promise.all(o),l}l(f){if(a(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const i=(0,I.$kM)(this.g.includePattern,f.includePattern),s=(0,I.$kM)(this.g.excludePattern,f.excludePattern),t={folder:c.URI.from(f.folder),excludes:s,includes:i,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.e.toCanonicalName(f.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$4L,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Iqc=S;function u($){return{isCaseSensitive:$.isCaseSensitive||!1,isRegExp:$.isRegExp||!1,isWordMatch:$.isWordMatch||!1,isMultiline:$.isMultiline||!1,pattern:$.pattern}}class P{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(f,i){this.d&&(this.b!==i||!b.$$g(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:f.uri,results:[]}),this.d.results.push(w(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.$Jqc=P;function w($){return a($)?{preview:{matches:(0,r.$Zb)($.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:$.preview.text},ranges:(0,r.$Zb)($.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:$.text,lineNumber:$.lineNumber}}function a($){return!!$.preview}class m{static{this.a=4e3}static{this.b=50}constructor(f,i){this.g=f,this.h=i,this.c=0,this.d=[],this.e=0}addItem(f,i){f&&this.j(f,i)}addItems(f,i){f&&this.k(f,i)}j(f,i){this.d.push(f),this.e+=i,this.l()}k(f,i){this.d=this.d.concat(f),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Lqc=m}),define(ke[102],Ie([1,0,3,6,5,336,19,72,11,2,171]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=e.$Mqc=void 0,e.$Oqc=u,e.$Mqc=(0,C.$Ei)("IExtHostSearch");let S=class{constructor(a,m,$){this.n=a,this.o=m,this.q=$,this.c=this.n.getProxy(h.$HN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$Hqc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const $=this.d++;return this.e.set($,m),this.c.$registerTextSearchProvider($,this.s(a)),(0,r.$Sc)(()=>{this.g.delete(a),this.e.delete($),this.c.$unregisterProvider($)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const $=this.d++;return this.h.set($,m),this.c.$registerAITextSearchProvider($,this.s(a)),(0,r.$Sc)(()=>{this.i.delete(a),this.h.delete($),this.c.$unregisterProvider($)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const $=this.d++;return this.j.set($,m),this.c.$registerFileSearchProvider($,this.s(a)),(0,r.$Sc)(()=>{this.k.delete(a),this.j.delete($),this.c.$unregisterProvider($)})}$provideFileSearchResults(a,m,$,f){const i=u($),s=this.j.get(a);if(s)return this.l.fileSearch(i,s,t=>{this.c.$handleFileMatch(a,m,t.map(o=>o.resource))},f);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,$){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,$,f){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${a}`);const s=u($);return this.t(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$provideAITextSearchResults(a,m,$,f){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${a}`);const s=u($);return this.v(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$enableExtensionHostSearch(){}t(a,m){return new I.$Iqc({query:a,provider:m},{readdir:$=>Promise.resolve([]),toCanonicalName:$=>$},"textSearchProvider")}v(a,m){return new I.$Iqc({query:a,provider:m},{readdir:$=>Promise.resolve([]),toCanonicalName:$=>$},"aiTextSearchProvider")}};e.$Nqc=S,e.$Nqc=S=Je([Ve(0,L.$hQ),Ve(1,T.$zpc),Ve(2,b.$_j)],S);function u(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(P),extraFileResources:w.extraFileResources&&w.extraFileResources.map(a=>c.URI.revive(a))}}function P(w){return{...w,folder:c.URI.revive(w.folder)}}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[344],Ie([1,0,7,20,13,4,3,14,43,2,113,201,202,58,23,27,11,90,91,246,6,290,317,95,127,294,295,296,275,265,34,297,41,298,101,163,299,277,291,300,301,63,77,278,292,54,302,75,303,62,29,318,279,304,305,128,306,122,123,280,335,308,250,309,319,310,169,281,311,312,313,19,314,102,124,315,282,316,125,97,100,94,47,167,98,320,293,321,322,76,15,9,283,72,284,96,323,324,162,48,119,93,25,99]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A,p,v,F,N,O,j,z,M,U,V,ie,B,Y,J,_,le,re,Se,me,Q,q,se,we,ee,ae,oe,x,ne,pe,be,Fe,ze,Ae,De,Ce,W,H,X,Z,de,ve,Oe,He,Ke,_e,nt,st,rt,at,gt,ht,ct,Pe,Be,Ye,Ne,je,ue,he,ce,Xe,et,ut,mt,Dt,Ft,Ht,ei,oi,Rt,tt,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=hi,C=qe(C),b=Ut(b),u=qe(u),a=qe(a),he=qe(he),ce=qe(ce);function hi(pt){const yt=pt.get(me.$xQ),ti=pt.get(Se.$kpc),ii=pt.get(le.$Hpc),qt=pt.get(J.$gqc),bt=pt.get(ei.$Cpc),zt=pt.get(gt.$BQ),ni=pt.get(p.$Fpc),ai=pt.get(et.$zpc),xe=pt.get(de.$hQ),ci=pt.get(st.$1pc),di=pt.get(rt.$Ipc),fi=pt.get(m.$ak),vt=pt.get(m.$_j),Mt=pt.get(ue.$eGb),Lt=pt.get(n.$gpc),Gt=pt.get(Ht.$orc),ri=pt.get(He.$$pc),Qt=pt.get(ie.$Rpc),li=pt.get(x.$cqc),Wt=pt.get(d.$qpc),Kt=pt.get(ee.$8pc);xe.set(s.$IN.ExtHostFileSystemInfo,ti),xe.set(s.$IN.ExtHostLogLevelServiceShape,fi),xe.set(s.$IN.ExtHostWorkspace,bt),xe.set(s.$IN.ExtHostConfiguration,ni),xe.set(s.$IN.ExtHostExtensionService,qt),xe.set(s.$IN.ExtHostStorage,ci),xe.set(s.$IN.ExtHostTunnelService,Mt),xe.set(s.$IN.ExtHostWindow,Gt),xe.set(s.$IN.ExtHostSecretState,ri),xe.set(s.$IN.ExtHostTelemetry,zt),xe.set(s.$IN.ExtHostEditorTabs,Qt),xe.set(s.$IN.ExtHostManagedSockets,li),xe.set(s.$IN.ExtHostAuthentication,Wt),xe.set(s.$IN.ExtHostChatProvider,Kt);const Jt=xe.set(s.$IN.ExtHostDecorations,pt.get(N.$wqc)),Nt=xe.set(s.$IN.ExtHostDocumentsAndEditors,pt.get(V.$sQ)),wt=xe.set(s.$IN.ExtHostCommands,pt.get(k.$DQ)),It=xe.set(s.$IN.ExtHostTerminalService,pt.get(ht.$4pc)),Yt=xe.set(s.$IN.ExtHostTerminalShellIntegration,pt.get(ct.$erc)),Pt=xe.set(s.$IN.ExtHostDebugService,pt.get(F.$qqc)),gi=xe.set(s.$IN.ExtHostSearch,pt.get(Oe.$Mqc)),xt=xe.set(s.$IN.ExtHostTask,pt.get(at.$drc)),Di=xe.set(s.$IN.ExtHostOutputService,pt.get(Ce.$3qc)),pi=xe.set(s.$IN.ExtHostLocalization,pt.get(oe.$bqc)),Ri=xe.set(s.$IN.ExtHostUrls,new ut.$lrc(xe)),Tt=xe.set(s.$IN.ExtHostDocuments,new U.$npc(xe,Nt)),Oi=xe.set(s.$IN.ExtHostDocumentContentProviders,new z.$yqc(xe,Nt,vt)),ui=xe.set(s.$IN.ExtHostDocumentSaveParticipant,new M.$zqc(vt,Tt,xe.getProxy(s.$HN.MainThreadBulkEdits))),Ct=xe.set(s.$IN.ExtHostNotebook,new pe.$Pqc(xe,wt,Nt,Tt,ii,gi,vt)),Ti=xe.set(s.$IN.ExtHostNotebookDocuments,new Fe.$Wqc(Ct)),ki=xe.set(s.$IN.ExtHostNotebookEditors,new ze.$Xqc(vt,Ct)),yi=xe.set(s.$IN.ExtHostNotebookKernels,new Ae.$Yqc(xe,yt,Ct,wt,vt)),Ni=xe.set(s.$IN.ExtHostNotebookRenderers,new De.$1qc(xe,Ct)),bi=xe.set(s.$IN.ExtHostNotebookDocumentSaveParticipant,new be.$Vqc(vt,Ct,xe.getProxy(s.$HN.MainThreadBulkEdits))),Vt=xe.set(s.$IN.ExtHostEditors,new Be.$wpc(xe,Nt)),Te=xe.set(s.$IN.ExtHostTreeViews,new je.$jrc(xe.getProxy(s.$HN.MainThreadTreeViews),wt,vt)),Me=xe.set(s.$IN.ExtHostEditorInsets,new y.$xpc(xe.getProxy(s.$HN.MainThreadEditorInsets),Vt,yt.remote)),Ee=xe.set(s.$IN.ExtHostDiagnostics,new O.$mpc(xe,vt,ti,Nt)),te=xe.set(s.$IN.ExtHostLanguages,new ae.$Tqc(xe,Tt,wt.converter,ai)),Re=xe.set(s.$IN.ExtHostLanguageFeatures,new se.$opc(xe,ai,Tt,wt,Ee,vt,Lt,zt)),Ge=xe.set(s.$IN.ExtHostFileSystem,new _.$Cqc(xe,Re)),it=xe.set(s.$IN.ExtHostFileSystemEventService,new re.$Dqc(xe,vt,Nt)),Qe=xe.set(s.$IN.ExtHostQuickOpen,(0,Z.$7qc)(xe,bt,wt)),ft=xe.set(s.$IN.ExtHostSCM,new ve.$9qc(xe,wt,Tt,vt)),At=xe.set(s.$IN.ExtHostQuickDiff,new X.$6qc(xe,ai)),Xt=xe.set(s.$IN.ExtHostShare,new Ke.$0qc(xe,ai)),si=xe.set(s.$IN.ExtHostComments,(0,A.$ypc)(xe,wt,Tt)),Bt=xe.set(s.$IN.ExtHostProgress,new H.$5qc(xe.getProxy(s.$HN.MainThreadProgress))),_t=xe.set(s.$IN.ExtHostLabelService,new q.$Rqc(xe)),qi=xe.set(s.$IN.ExtHostTheming,new Ye.$grc(xe)),nn=xe.set(s.$IN.ExtHostTimeline,new Ne.$irc(xe,wt)),Wi=xe.set(s.$IN.ExtHostWebviews,new mt.$Mpc(xe,yt.remote,bt,vt,Lt)),Fi=xe.set(s.$IN.ExtHostWebviewPanels,new Dt.$Ppc(xe,Wi,bt)),Vi=xe.set(s.$IN.ExtHostCustomEditors,new v.$Qpc(xe,Tt,di,Wi,Fi)),Hi=xe.set(s.$IN.ExtHostWebviewViews,new Ft.$mrc(xe,Wi)),Ii=xe.set(s.$IN.ExtHostTesting,pt.get(Pe.$lqc)),rn=xe.set(s.$IN.ExtHostUriOpeners,new Xe.$krc(xe)),sn=xe.set(s.$IN.ExtHostProfileContentHandlers,new W.$4qc(xe));xe.set(s.$IN.ExtHostInteractive,new Q.$Qqc(xe,Ct,Nt,wt,vt));const Mi=xe.set(s.$IN.ExtHostChatAgents2,new g.$tpc(xe,vt,wt,Tt)),on=xe.set(s.$IN.ExtHostChatVariables,new E.$upc(xe)),ji=xe.set(s.$IN.ExtHostLanguageModelTools,new we.$Sqc(xe)),Gi=xe.set(s.$IN.ExtHostAiRelatedInformation,new t.$fpc(xe)),En=xe.set(s.$IN.ExtHostAiEmbeddingVector,new Y.$Bqc(xe)),an=xe.set(s.$IN.ExtHostStatusBar,new nt.$arc(xe,wt.converter)),Yi=xe.set(s.$IN.ExtHostSpeech,new _e.$$qc(xe)),Pi=xe.set(s.$IN.ExtHostEmbeddings,new B.$Aqc(xe)),yn=Object.values(s.$IN);xe.assertRegistered(yn);const Sn=new l.$spc(xe,Nt),cn=new D.$vpc(xe),Ki=new ne.$Uqc(xe,vt),Qi=new j.$xqc(xe);return o.$ppc.register(wt),function(We,wi,Ji){function lt(fe){return(ye,Ue,dt)=>{const St=fe(Ot=>{try{ye.call(Ue,Ot)}catch(Ci){C.$Z(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Ci.toString()}`,{cause:Ci})),zt.onExtensionError(We.identifier,Ci)}});return dt?.push(St),St}}const kt=function(){let fe=!We.isUnderDevelopment;function ye(){fe||(vt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Ue(dt){if(Array.isArray(dt))dt.forEach(Ue);else if(typeof dt=="string")ye();else{const St=dt;typeof St.scheme>"u"&&ye(),typeof St.exclusive=="boolean"&&(0,tt.$fH)(We,"documentFiltersExclusive")}return dt}}(),Xi={getSession(fe,ye,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,tt.$fH)(We,"authLearnMore"),Ue?.account&&(0,tt.$fH)(We,"authGetSessions"),Wt.getSession(We,fe,ye,Ue)},getAccounts(fe){return(0,tt.$fH)(We,"authGetSessions"),Wt.getAccounts(fe)},async hasSession(fe,ye){return(0,tt.$fH)(We,"authSession"),!!await Wt.getSession(We,fe,ye,{silent:!0})},get onDidChangeSessions(){return lt(Wt.onDidChangeSessions)},registerAuthenticationProvider(fe,ye,Ue,dt){return Wt.registerAuthenticationProvider(fe,ye,Ue,dt)}},ln={registerCommand(fe,ye,Ue){return wt.registerCommand(!0,fe,ye,Ue,void 0,We)},registerTextEditorCommand(fe,ye,Ue){return wt.registerCommand(!0,fe,(...dt)=>{const St=Vt.getActiveTextEditor();if(!St){vt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return St.edit(Ot=>{ye.apply(Ue,[St,Ot,...dt])}).then(Ot=>{Ot||vt.warn("Edits from command "+fe+" were not applied.")},Ot=>{vt.warn("An error occurred while running command "+fe,Ot)})},void 0,void 0,We)},registerDiffInformationCommand:(fe,ye,Ue)=>((0,tt.$fH)(We,"diffCommand"),wt.registerCommand(!0,fe,async(...dt)=>{const St=Nt.activeEditor(!0);if(!St){vt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Ot=await Vt.getDiffInformation(St.id);ye.apply(Ue,[Ot,...dt])},void 0,void 0,We)),executeCommand(fe,...ye){return wt.executeCommand(fe,...ye)},getCommands(fe=!1){return wt.getCommands(fe)}},vi={get machineId(){return yt.telemetryInfo.machineId},get sessionId(){return yt.telemetryInfo.sessionId},get language(){return yt.environment.appLanguage},get appName(){return yt.environment.appName},get appRoot(){return yt.environment.appRoot?.fsPath??""},get appHost(){return yt.environment.appHost},get uriScheme(){return yt.environment.appUriScheme},get clipboard(){return cn.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return lt(It.onDidChangeShell)},get isTelemetryEnabled(){return zt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(zt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$fH)(We,"telemetry"),zt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$fH)(We,"telemetry"),lt(zt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,gt.$AQ)(yt.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,ye){return gt.$zQ.validateSender(fe),zt.instantiateLogger(We,fe,ye)},openExternal(fe,ye){return Gt.openUri(fe,{allowTunneling:!!yt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===yt.environment.appUriScheme)return Ri.createAppUri(fe);try{return await Gt.asExternalUri(fe,{allowTunneling:!!yt.remote.authority})}catch(ye){if((0,T.$Ng)(fe,T.Schemas.http)||(0,T.$Ng)(fe,T.Schemas.https))return fe;throw ye}},get remoteName(){return(0,$.$hn)(yt.remote.authority)},get remoteAuthority(){return(0,tt.$fH)(We,"resolvers"),yt.remote.authority},get uiKind(){return yt.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return lt(vt.onDidChangeLogLevel)},get appQuality(){return(0,tt.$fH)(We,"resolvers"),yt.quality},get appCommit(){return(0,tt.$fH)(We,"resolvers"),yt.commit}};yt.environment.extensionTestsLocationURI||Object.freeze(vi);const Bi={createTestController(fe,ye,Ue){return Ii.createTestController(We,fe,ye,Ue)},createTestObserver(){return(0,tt.$fH)(We,"testObserver"),Ii.createTestObserver()},runTests(fe){return(0,tt.$fH)(We,"testObserver"),Ii.runTests(fe)},registerTestFollowupProvider(fe){return(0,tt.$fH)(We,"testObserver"),Ii.registerTestFollowupProvider(fe)},get onDidChangeTestResults(){return(0,tt.$fH)(We,"testObserver"),lt(Ii.onResultsChanged)},get testResults(){return(0,tt.$fH)(We,"testObserver"),Ii.results}},zi=yt.remote.isRemote?ce.ExtensionKind.Workspace:ce.ExtensionKind.UI,mi={getExtension(fe,ye){(0,tt.$eH)(We,"extensionsAny")||(ye=!1);const Ue=wi.mine.getExtensionDescription(fe);if(Ue)return new J.$hqc(qt,We.identifier,Ue,zi,!1);if(ye){const dt=wi.all.getExtensionDescription(fe);if(dt)return new J.$hqc(qt,We.identifier,dt,zi,!0)}},get all(){const fe=[];for(const ye of wi.mine.getAllExtensionDescriptions())fe.push(new J.$hqc(qt,We.identifier,ye,zi,!1));return fe},get allAcrossExtensionHosts(){(0,tt.$fH)(We,"extensionsAny");const fe=new w.$rn(wi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of wi.all.getAllExtensionDescriptions()){const dt=!fe.has(Ue.identifier);ye.push(new J.$hqc(qt,We.identifier,Ue,zi,dt))}return ye},get onDidChange(){return(0,tt.$eH)(We,"extensionsAny")?lt(R.Event.any(wi.mine.onDidChange,wi.all.onDidChange)):lt(wi.mine.onDidChange)}},Ui={createDiagnosticCollection(fe){return Ee.createDiagnosticCollection(We.identifier,fe)},get onDidChangeDiagnostics(){return lt(Ee.onDidChangeDiagnostics)},getDiagnostics:fe=>Ee.getDiagnostics(fe),getLanguages(){return te.getLanguages()},setTextDocumentLanguage(fe,ye){return te.changeLanguage(fe.uri,ye)},match(fe,ye){const Ue=he.LanguageSelector.from(fe);let dt;return(0,S.$wu)(Ue)&&(dt=Ct.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Ot=>Ot.document===ye))?.apiNotebook),(0,S.$vu)(Ue,ye.uri,ye.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(fe,ye,Ue){return Re.registerCodeActionProvider(We,kt(fe),ye,Ue)},registerDocumentPasteEditProvider(fe,ye,Ue){return(0,tt.$fH)(We,"documentPaste"),Re.registerDocumentPasteEditProvider(We,kt(fe),ye,Ue)},registerCodeLensProvider(fe,ye){return Re.registerCodeLensProvider(We,kt(fe),ye)},registerDefinitionProvider(fe,ye){return Re.registerDefinitionProvider(We,kt(fe),ye)},registerDeclarationProvider(fe,ye){return Re.registerDeclarationProvider(We,kt(fe),ye)},registerImplementationProvider(fe,ye){return Re.registerImplementationProvider(We,kt(fe),ye)},registerTypeDefinitionProvider(fe,ye){return Re.registerTypeDefinitionProvider(We,kt(fe),ye)},registerHoverProvider(fe,ye){return Re.registerHoverProvider(We,kt(fe),ye,We.identifier)},registerEvaluatableExpressionProvider(fe,ye){return Re.registerEvaluatableExpressionProvider(We,kt(fe),ye,We.identifier)},registerInlineValuesProvider(fe,ye){return Re.registerInlineValuesProvider(We,kt(fe),ye,We.identifier)},registerDocumentHighlightProvider(fe,ye){return Re.registerDocumentHighlightProvider(We,kt(fe),ye)},registerMultiDocumentHighlightProvider(fe,ye){return Re.registerMultiDocumentHighlightProvider(We,kt(fe),ye)},registerLinkedEditingRangeProvider(fe,ye){return Re.registerLinkedEditingRangeProvider(We,kt(fe),ye)},registerReferenceProvider(fe,ye){return Re.registerReferenceProvider(We,kt(fe),ye)},registerRenameProvider(fe,ye){return Re.registerRenameProvider(We,kt(fe),ye)},registerNewSymbolNamesProvider(fe,ye){return(0,tt.$fH)(We,"newSymbolNamesProvider"),Re.registerNewSymbolNamesProvider(We,kt(fe),ye)},registerDocumentSymbolProvider(fe,ye,Ue){return Re.registerDocumentSymbolProvider(We,kt(fe),ye,Ue)},registerWorkspaceSymbolProvider(fe){return Re.registerWorkspaceSymbolProvider(We,fe)},registerDocumentFormattingEditProvider(fe,ye){return Re.registerDocumentFormattingEditProvider(We,kt(fe),ye)},registerDocumentRangeFormattingEditProvider(fe,ye){return Re.registerDocumentRangeFormattingEditProvider(We,kt(fe),ye)},registerOnTypeFormattingEditProvider(fe,ye,Ue,...dt){return Re.registerOnTypeFormattingEditProvider(We,kt(fe),ye,[Ue].concat(dt))},registerDocumentSemanticTokensProvider(fe,ye,Ue){return Re.registerDocumentSemanticTokensProvider(We,kt(fe),ye,Ue)},registerDocumentRangeSemanticTokensProvider(fe,ye,Ue){return Re.registerDocumentRangeSemanticTokensProvider(We,kt(fe),ye,Ue)},registerSignatureHelpProvider(fe,ye,Ue,...dt){return typeof Ue=="object"?Re.registerSignatureHelpProvider(We,kt(fe),ye,Ue):Re.registerSignatureHelpProvider(We,kt(fe),ye,typeof Ue>"u"?[]:[Ue,...dt])},registerCompletionItemProvider(fe,ye,...Ue){return Re.registerCompletionItemProvider(We,kt(fe),ye,Ue)},registerInlineCompletionItemProvider(fe,ye,Ue){return ye.handleDidShowCompletionItem&&(0,tt.$fH)(We,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,tt.$fH)(We,"inlineCompletionsAdditions"),Ue&&(0,tt.$fH)(We,"inlineCompletionsAdditions"),Re.registerInlineCompletionsProvider(We,kt(fe),ye,Ue)},registerInlineEditProvider(fe,ye){return(0,tt.$fH)(We,"inlineEdit"),Re.registerInlineEditProvider(We,kt(fe),ye)},registerDocumentLinkProvider(fe,ye){return Re.registerDocumentLinkProvider(We,kt(fe),ye)},registerColorProvider(fe,ye){return Re.registerColorProvider(We,kt(fe),ye)},registerFoldingRangeProvider(fe,ye){return Re.registerFoldingRangeProvider(We,kt(fe),ye)},registerSelectionRangeProvider(fe,ye){return Re.registerSelectionRangeProvider(We,fe,ye)},registerCallHierarchyProvider(fe,ye){return Re.registerCallHierarchyProvider(We,fe,ye)},registerTypeHierarchyProvider(fe,ye){return Re.registerTypeHierarchyProvider(We,fe,ye)},setLanguageConfiguration:(fe,ye)=>Re.setLanguageConfiguration(We,fe,ye),getTokenInformationAtPosition(fe,ye){return(0,tt.$fH)(We,"tokenInformation"),te.tokenAtPosition(fe,ye)},registerInlayHintsProvider(fe,ye){return Re.registerInlayHintsProvider(We,fe,ye)},createLanguageStatusItem(fe,ye){return te.createLanguageStatusItem(We,fe,ye)},registerDocumentDropEditProvider(fe,ye,Ue){return Re.registerDocumentOnDropEditProvider(We,fe,ye,(0,tt.$eH)(We,"documentPaste")?Ue:void 0)}},un={get activeTextEditor(){return Vt.getActiveTextEditor()},get visibleTextEditors(){return Vt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(fe,ye,Ue){c.URI.isUri(fe)&&fe.scheme===T.Schemas.vscodeRemote&&!fe.authority&&Lt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await(c.URI.isUri(fe)?Promise.resolve(Zi.openTextDocument(fe)):Promise.resolve(fe));return Vt.showTextDocument(dt,ye,Ue)},createTextEditorDecorationType(fe){return Vt.createTextEditorDecorationType(We,fe)},onDidChangeActiveTextEditor(fe,ye,Ue){return lt(Vt.onDidChangeActiveTextEditor)(fe,ye,Ue)},onDidChangeVisibleTextEditors(fe,ye,Ue){return lt(Vt.onDidChangeVisibleTextEditors)(fe,ye,Ue)},onDidChangeTextEditorSelection(fe,ye,Ue){return lt(Vt.onDidChangeTextEditorSelection)(fe,ye,Ue)},onDidChangeTextEditorOptions(fe,ye,Ue){return lt(Vt.onDidChangeTextEditorOptions)(fe,ye,Ue)},onDidChangeTextEditorVisibleRanges(fe,ye,Ue){return lt(Vt.onDidChangeTextEditorVisibleRanges)(fe,ye,Ue)},onDidChangeTextEditorViewColumn(fe,ye,Ue){return lt(Vt.onDidChangeTextEditorViewColumn)(fe,ye,Ue)},onDidCloseTerminal(fe,ye,Ue){return lt(It.onDidCloseTerminal)(fe,ye,Ue)},onDidOpenTerminal(fe,ye,Ue){return lt(It.onDidOpenTerminal)(fe,ye,Ue)},onDidChangeActiveTerminal(fe,ye,Ue){return lt(It.onDidChangeActiveTerminal)(fe,ye,Ue)},onDidChangeTerminalDimensions(fe,ye,Ue){return(0,tt.$fH)(We,"terminalDimensions"),lt(It.onDidChangeTerminalDimensions)(fe,ye,Ue)},onDidChangeTerminalState(fe,ye,Ue){return lt(It.onDidChangeTerminalState)(fe,ye,Ue)},onDidWriteTerminalData(fe,ye,Ue){return(0,tt.$fH)(We,"terminalDataWriteEvent"),lt(It.onDidWriteTerminalData)(fe,ye,Ue)},onDidExecuteTerminalCommand(fe,ye,Ue){return(0,tt.$fH)(We,"terminalExecuteCommandEvent"),lt(It.onDidExecuteTerminalCommand)(fe,ye,Ue)},onDidChangeTerminalShellIntegration(fe,ye,Ue){return(0,tt.$fH)(We,"terminalShellIntegration"),lt(Yt.onDidChangeTerminalShellIntegration)(fe,ye,Ue)},onDidStartTerminalShellExecution(fe,ye,Ue){return(0,tt.$fH)(We,"terminalShellIntegration"),lt(Yt.onDidStartTerminalShellExecution)(fe,ye,Ue)},onDidEndTerminalShellExecution(fe,ye,Ue){return(0,tt.$fH)(We,"terminalShellIntegration"),lt(Yt.onDidEndTerminalShellExecution)(fe,ye,Ue)},get state(){return Gt.getState()},onDidChangeWindowState(fe,ye,Ue){return lt(Gt.onDidChangeWindowState)(fe,ye,Ue)},showInformationMessage(fe,...ye){return Ki.showMessage(We,b.default.Info,fe,ye[0],ye.slice(1))},showWarningMessage(fe,...ye){return Ki.showMessage(We,b.default.Warning,fe,ye[0],ye.slice(1))},showErrorMessage(fe,...ye){return Ki.showMessage(We,b.default.Error,fe,ye[0],ye.slice(1))},showQuickPick(fe,ye,Ue){return Qe.showQuickPick(We,fe,ye,Ue)},showWorkspaceFolderPick(fe){return Qe.showWorkspaceFolderPick(fe)},showInputBox(fe,ye){return Qe.showInput(fe,ye)},showOpenDialog(fe){return Qi.showOpenDialog(We,fe)},showSaveDialog(fe){return Qi.showSaveDialog(fe)},createStatusBarItem(fe,ye,Ue){let dt,St,Ot;return typeof fe=="string"?(dt=fe,St=ye,Ot=Ue):(St=fe,Ot=ye),an.createStatusBarEntry(We,dt,St,Ot)},setStatusBarMessage(fe,ye){return an.setStatusBarMessage(fe,ye)},withScmProgress(fe){return Lt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Bt.withProgress(We,{location:ce.ProgressLocation.SourceControl},(ye,Ue)=>fe({report(dt){}}))},withProgress(fe,ye){return Bt.withProgress(We,fe,ye)},createOutputChannel(fe,ye){return Di.createOutputChannel(fe,ye,We)},createWebviewPanel(fe,ye,Ue,dt){return Fi.createWebviewPanel(We,fe,ye,Ue,dt)},createWebviewTextEditorInset(fe,ye,Ue,dt){return(0,tt.$fH)(We,"editorInsets"),Me.createWebviewEditorInset(fe,ye,Ue,dt,We)},createTerminal(fe,ye,Ue){return typeof fe=="object"?"pty"in fe?It.createExtensionTerminal(fe):It.createTerminalFromOptions(fe):It.createTerminal(fe,ye,Ue)},registerTerminalLinkProvider(fe){return It.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,ye){return It.registerProfileProvider(We,fe,ye)},registerTerminalQuickFixProvider(fe,ye){return(0,tt.$fH)(We,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(fe,We.identifier.value,ye)},registerTreeDataProvider(fe,ye){return Te.registerTreeDataProvider(fe,ye,We)},createTreeView(fe,ye){return Te.createTreeView(fe,ye,We)},registerWebviewPanelSerializer:(fe,ye)=>Fi.registerWebviewPanelSerializer(We,fe,ye),registerCustomEditorProvider:(fe,ye,Ue={})=>Vi.registerCustomEditorProvider(We,fe,ye,Ue),registerFileDecorationProvider(fe){return Jt.registerFileDecorationProvider(fe,We)},registerUriHandler(fe){return Ri.registerUriHandler(We,fe)},createQuickPick(){return Qe.createQuickPick(We)},createInputBox(){return Qe.createInputBox(We)},get activeColorTheme(){return qi.activeColorTheme},onDidChangeActiveColorTheme(fe,ye,Ue){return lt(qi.onDidChangeActiveColorTheme)(fe,ye,Ue)},registerWebviewViewProvider(fe,ye,Ue){return Hi.registerWebviewViewProvider(We,fe,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,ye,Ue){return lt(Ct.onDidChangeActiveNotebookEditor)(fe,ye,Ue)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,ye,Ue){return lt(ki.onDidChangeNotebookEditorSelection)(fe,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(fe,ye,Ue){return lt(ki.onDidChangeNotebookEditorVisibleRanges)(fe,ye,Ue)},showNotebookDocument(fe,ye){return Ct.showNotebookDocument(fe,ye)},registerExternalUriOpener(fe,ye,Ue){return(0,tt.$fH)(We,"externalUriOpener"),rn.registerExternalUriOpener(We.identifier,fe,ye,Ue)},registerProfileContentHandler(fe,ye){return(0,tt.$fH)(We,"profileContentHandlers"),sn.registerProfileContentHandler(We,fe,ye)},registerQuickDiffProvider(fe,ye,Ue,dt){return(0,tt.$fH)(We,"quickDiffProvider"),At.registerQuickDiffProvider(kt(fe),ye,Ue,dt)},get tabGroups(){return Qt.tabGroups},registerShareProvider(fe,ye){return(0,tt.$fH)(We,"shareProvider"),Xt.registerShareProvider(kt(fe),ye)}},Zi={get rootPath(){return Lt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(fe){throw new C.$8("rootPath")},getWorkspaceFolder(fe){return bt.getWorkspaceFolder(fe)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(fe){throw new C.$8("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(fe){throw new C.$8("workspaceFile")},updateWorkspaceFolders:(fe,ye,...Ue)=>bt.updateWorkspaceFolders(We,fe,ye||0,...Ue),onDidChangeWorkspaceFolders:function(fe,ye,Ue){return lt(bt.onDidChangeWorkspace)(fe,ye,Ue)},asRelativePath:(fe,ye)=>bt.getRelativePath(fe,ye),findFiles:(fe,ye,Ue,dt)=>bt.findFiles(fe,ye,Ue,We.identifier,dt),findFiles2:(fe,ye,Ue)=>((0,tt.$fH)(We,"findFiles2"),bt.findFiles2(fe,ye,We.identifier,Ue)),findFiles2New:(fe,ye,Ue)=>((0,tt.$fH)(We,"findFiles2New"),Promise.resolve([])),findTextInFiles:(fe,ye,Ue,dt)=>{(0,tt.$fH)(We,"findTextInFiles");let St,Ot;return typeof ye=="object"?(St=ye,Ot=Ue):(St={},Ot=ye,dt=Ue),bt.findTextInFiles(fe,St||{},Ot,We.identifier,dt)},findTextInFilesNew:(fe,ye,Ue)=>((0,tt.$fH)(We,"findTextInFilesNew"),{results:r.$5h.fromArray([]),complete:Promise.resolve({limitHit:!1})}),save:fe=>bt.save(fe),saveAs:fe=>bt.saveAs(fe),saveAll:fe=>bt.saveAll(fe),applyEdit(fe,ye){return Sn.applyWorkspaceEdit(fe,We,ye)},createFileSystemWatcher:(fe,ye,Ue,dt)=>{let St;return typeof ye=="boolean"?St={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!dt,correlate:!1}:ye&&((0,tt.$fH)(We,"createFileSystemWatcher"),St={...ye,correlate:!0}),it.createFileSystemWatcher(bt,We,fe,St)},get textDocuments(){return Tt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new C.$8("textDocuments")},openTextDocument(fe){let ye;const Ue=fe;if(typeof fe=="string")ye=Promise.resolve(c.URI.file(fe));else if(c.URI.isUri(fe))ye=Promise.resolve(fe);else if(!Ue||typeof Ue=="object")ye=Tt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(dt=>(dt.scheme===T.Schemas.vscodeRemote&&!dt.authority&&Lt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Tt.ensureDocumentData(dt).then(St=>St.document)))},onDidOpenTextDocument:(fe,ye,Ue)=>lt(Tt.onDidAddDocument)(fe,ye,Ue),onDidCloseTextDocument:(fe,ye,Ue)=>lt(Tt.onDidRemoveDocument)(fe,ye,Ue),onDidChangeTextDocument:(fe,ye,Ue)=>lt(Tt.onDidChangeDocument)(fe,ye,Ue),onDidSaveTextDocument:(fe,ye,Ue)=>lt(Tt.onDidSaveDocument)(fe,ye,Ue),onWillSaveTextDocument:(fe,ye,Ue)=>lt(ui.getOnWillSaveTextDocumentEvent(We))(fe,ye,Ue),get notebookDocuments(){return Ct.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,ye){let Ue;if(c.URI.isUri(fe))Ue=fe,await Ct.openNotebookDocument(fe);else if(typeof fe=="string")Ue=c.URI.revive(await Ct.createNotebookDocument({viewType:fe,content:ye}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(fe,ye,Ue){return lt(Ti.onDidSaveNotebookDocument)(fe,ye,Ue)},onDidChangeNotebookDocument(fe,ye,Ue){return lt(Ti.onDidChangeNotebookDocument)(fe,ye,Ue)},onWillSaveNotebookDocument(fe,ye,Ue){return lt(bi.getOnWillSaveNotebookDocumentEvent(We))(fe,ye,Ue)},get onDidOpenNotebookDocument(){return lt(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,ye,Ue,dt){return Ct.registerNotebookSerializer(We,fe,ye,Ue,(0,tt.$eH)(We,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(fe,ye,Ue)=>lt(Ji.onDidChangeConfiguration)(fe,ye,Ue),getConfiguration(fe,ye){return ye=arguments.length===1?void 0:ye,Ji.getConfiguration(fe,ye,We)},registerTextDocumentContentProvider(fe,ye){return Oi.registerTextDocumentContentProvider(fe,ye)},registerTaskProvider:(fe,ye)=>(Lt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),xt.registerTaskProvider(We,fe,ye)),registerFileSystemProvider(fe,ye,Ue){return(0,L.$Rc)(Ge.registerFileSystemProvider(We,fe,ye,Ue),ii.addFileSystemProvider(fe,ye,Ue))},get fs(){return ii.value},registerFileSearchProvider:(fe,ye)=>((0,tt.$fH)(We,"fileSearchProvider"),gi.registerFileSearchProvider(fe,ye)),registerTextSearchProvider:(fe,ye)=>((0,tt.$fH)(We,"textSearchProvider"),gi.registerTextSearchProvider(fe,ye)),registerAITextSearchProvider:(fe,ye)=>((0,tt.$fH)(We,"aiTextSearchProvider"),(0,tt.$fH)(We,"textSearchProvider"),gi.registerAITextSearchProvider(fe,ye)),registerFileSearchProviderNew:(fe,ye)=>((0,tt.$fH)(We,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(fe,ye)=>((0,tt.$fH)(We,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(fe,ye)=>((0,tt.$fH)(We,"aiTextSearchProviderNew"),(0,tt.$fH)(We,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(fe,ye)=>((0,tt.$fH)(We,"resolvers"),qt.registerRemoteAuthorityResolver(fe,ye)),registerResourceLabelFormatter:fe=>((0,tt.$fH)(We,"resolvers"),_t.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,tt.$fH)(We,"resolvers"),qt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,ye,Ue)=>lt(it.onDidCreateFile)(fe,ye,Ue),onDidDeleteFiles:(fe,ye,Ue)=>lt(it.onDidDeleteFile)(fe,ye,Ue),onDidRenameFiles:(fe,ye,Ue)=>lt(it.onDidRenameFile)(fe,ye,Ue),onWillCreateFiles:(fe,ye,Ue)=>lt(it.getOnWillCreateFileEvent(We))(fe,ye,Ue),onWillDeleteFiles:(fe,ye,Ue)=>lt(it.getOnWillDeleteFileEvent(We))(fe,ye,Ue),onWillRenameFiles:(fe,ye,Ue)=>lt(it.getOnWillRenameFileEvent(We))(fe,ye,Ue),openTunnel:fe=>((0,tt.$fH)(We,"tunnels"),Mt.openTunnel(We,fe).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,tt.$fH)(We,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(fe,ye,Ue)=>((0,tt.$fH)(We,"tunnels"),lt(Mt.onDidChangeTunnels)(fe,ye,Ue)),registerPortAttributesProvider:(fe,ye)=>((0,tt.$fH)(We,"portsAttributes"),Mt.registerPortsAttributesProvider(fe,ye)),registerTunnelProvider:(fe,ye)=>((0,tt.$fH)(We,"tunnelFactory"),Mt.registerTunnelProvider(fe,ye)),registerTimelineProvider:(fe,ye)=>((0,tt.$fH)(We,"timeline"),nn.registerTimelineProvider(fe,ye,We.identifier,wt.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:fe=>((0,tt.$fH)(We,"workspaceTrust"),bt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,ye,Ue)=>lt(bt.onDidGrantWorkspaceTrust)(fe,ye,Ue),registerEditSessionIdentityProvider:(fe,ye)=>((0,tt.$fH)(We,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(fe,ye)),onWillCreateEditSessionIdentity:(fe,ye,Ue)=>((0,tt.$fH)(We,"editSessionIdentityProvider"),lt(bt.getOnWillCreateEditSessionIdentityEvent(We))(fe,ye,Ue)),registerCanonicalUriProvider:(fe,ye)=>((0,tt.$fH)(We,"canonicalUriProvider"),bt.registerCanonicalUriProvider(fe,ye)),getCanonicalUri:(fe,ye,Ue)=>((0,tt.$fH)(We,"canonicalUriProvider"),bt.provideCanonicalUri(fe,ye,Ue))},hn={get inputBox(){return Lt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(We)},createSourceControl(fe,ye,Ue){return ft.createSourceControl(We,fe,ye,Ue)}},dn={createCommentController(fe,ye){return si.createCommentController(We,fe,ye)}},Dn={get activeDebugSession(){return Pt.activeDebugSession},get activeDebugConsole(){return Pt.activeDebugConsole},get breakpoints(){return Pt.breakpoints},get activeStackItem(){return Pt.activeStackItem},registerDebugVisualizationProvider(fe,ye){return(0,tt.$fH)(We,"debugVisualization"),Pt.registerDebugVisualizationProvider(We,fe,ye)},registerDebugVisualizationTreeProvider(fe,ye){return(0,tt.$fH)(We,"debugVisualization"),Pt.registerDebugVisualizationTree(We,fe,ye)},onDidStartDebugSession(fe,ye,Ue){return lt(Pt.onDidStartDebugSession)(fe,ye,Ue)},onDidTerminateDebugSession(fe,ye,Ue){return lt(Pt.onDidTerminateDebugSession)(fe,ye,Ue)},onDidChangeActiveDebugSession(fe,ye,Ue){return lt(Pt.onDidChangeActiveDebugSession)(fe,ye,Ue)},onDidReceiveDebugSessionCustomEvent(fe,ye,Ue){return lt(Pt.onDidReceiveDebugSessionCustomEvent)(fe,ye,Ue)},onDidChangeBreakpoints(fe,ye,Ue){return lt(Pt.onDidChangeBreakpoints)(fe,ye,Ue)},onDidChangeActiveStackItem(fe,ye,Ue){return lt(Pt.onDidChangeActiveStackItem)(fe,ye,Ue)},registerDebugConfigurationProvider(fe,ye,Ue){return Pt.registerDebugConfigurationProvider(fe,ye,Ue||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,ye){return Pt.registerDebugAdapterDescriptorFactory(We,fe,ye)},registerDebugAdapterTrackerFactory(fe,ye){return Pt.registerDebugAdapterTrackerFactory(fe,ye)},startDebugging(fe,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Pt.startDebugging(fe,ye,{parentSession:Ue}):Pt.startDebugging(fe,ye,Ue||{})},stopDebugging(fe){return Pt.stopDebugging(fe)},addBreakpoints(fe){return Pt.addBreakpoints(fe)},removeBreakpoints(fe){return Pt.removeBreakpoints(fe)},asDebugSourceUri(fe,ye){return Pt.asDebugSourceUri(fe,ye)}},fn={registerTaskProvider:(fe,ye)=>xt.registerTaskProvider(We,fe,ye),fetchTasks:fe=>xt.fetchTasks(fe),executeTask:fe=>xt.executeTask(We,fe),get taskExecutions(){return xt.taskExecutions},onDidStartTask:(fe,ye,Ue)=>lt(xt.onDidStartTask)(fe,ye,Ue),onDidEndTask:(fe,ye,Ue)=>lt(xt.onDidEndTask)(fe,ye,Ue),onDidStartTaskProcess:(fe,ye,Ue)=>lt(xt.onDidStartTaskProcess)(fe,ye,Ue),onDidEndTaskProcess:(fe,ye,Ue)=>lt(xt.onDidEndTaskProcess)(fe,ye,Ue)},gn={createNotebookController(fe,ye,Ue,dt,St){return yi.createNotebookController(We,fe,ye,Ue,dt,(0,tt.$eH)(We,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(fe,ye)=>Ct.registerNotebookCellStatusBarItemProvider(We,fe,ye),createRendererMessaging(fe){return Ni.createRendererMessaging(We,fe)},createNotebookControllerDetectionTask(fe){return(0,tt.$fH)(We,"notebookKernelSource"),yi.createNotebookControllerDetectionTask(We,fe)},registerKernelSourceActionProvider(fe,ye){return(0,tt.$fH)(We,"notebookKernelSource"),yi.registerKernelSourceActionProvider(We,fe,ye)},onDidChangeNotebookCellExecutionState(fe,ye,Ue){return(0,tt.$fH)(We,"notebookCellExecutionState"),lt(yi.onDidChangeNotebookCellExecutionState)(fe,ye,Ue)}},kn={t(...fe){if(typeof fe[0]=="string"){const ye=fe.shift(),Ue=!fe||typeof fe[0]!="object"?fe:fe[0];return pi.getMessage(We.identifier.value,{message:ye,args:Ue})}return pi.getMessage(We.identifier.value,fe[0])},get bundle(){return pi.getBundle(We.identifier.value)},get uri(){return pi.getBundleUri(We.identifier.value)}},In={_version:1,transferActiveChat(fe){return(0,tt.$fH)(We,"interactive"),Mi.transferActiveChat(fe)}},mn={getRelatedInformation(fe,ye){return(0,tt.$fH)(We,"aiRelatedInformation"),Gi.getRelatedInformation(We,fe,ye)},registerRelatedInformationProvider(fe,ye){return(0,tt.$fH)(We,"aiRelatedInformation"),Gi.registerRelatedInformationProvider(We,fe,ye)},registerEmbeddingVectorProvider(fe,ye){return(0,tt.$fH)(We,"aiRelatedInformation"),En.registerEmbeddingVectorProvider(We,fe,ye)}},xi={_version:1,registerChatResponseProvider(fe,ye,Ue){return(0,tt.$fH)(We,"chatProvider"),Kt.registerLanguageModel(We,fe,ye,Ue)},registerChatVariableResolver(fe,ye,Ue,dt,St,Ot,Ci,_i){return(0,tt.$fH)(We,"chatVariableResolver"),on.registerVariableResolver(We,fe,ye,Ue,dt,St,Ot,Ci,_i?.id)},registerMappedEditsProvider(fe,ye){return(0,tt.$fH)(We,"mappedEditsProvider"),Re.registerMappedEditsProvider(We,fe,ye)},createChatParticipant(fe,ye){return Mi.createChatAgent(We,fe,ye)},createDynamicChatParticipant(fe,ye,Ue){return(0,tt.$fH)(We,"chatParticipantPrivate"),Mi.createDynamicChatAgent(We,fe,ye,Ue)}},$n={selectChatModels:fe=>Kt.selectLanguageModels(We,fe??{}),onDidChangeChatModels:(fe,ye,Ue)=>Kt.onDidChangeProviders(fe,ye,Ue),registerChatModelProvider:(fe,ye,Ue)=>((0,tt.$fH)(We,"chatProvider"),Kt.registerLanguageModel(We,fe,ye,Ue)),get embeddingModels(){return(0,tt.$fH)(We,"embeddings"),Pi.embeddingsModels},onDidChangeEmbeddingModels:(fe,ye,Ue)=>((0,tt.$fH)(We,"embeddings"),Pi.onDidChange(fe,ye,Ue)),registerEmbeddingsProvider(fe,ye){return(0,tt.$fH)(We,"embeddings"),Pi.registerEmbeddingsProvider(We,fe,ye)},async computeEmbeddings(fe,ye,Ue){return(0,tt.$fH)(We,"embeddings"),Pi.computeEmbeddings(fe,ye,Ue)},registerTool(fe,ye){return(0,tt.$fH)(We,"lmTools"),ji.registerTool(We,fe,ye)},invokeTool(fe,ye,Ue){return(0,tt.$fH)(We,"lmTools"),ji.invokeTool(fe,ye,Ue)},get tools(){return(0,tt.$fH)(We,"lmTools"),ji.tools}},pn={registerSpeechProvider(fe,ye){return(0,tt.$fH)(We,"speech"),Yi.registerProvider(We.identifier,fe,ye)}};return{version:yt.version,ai:mn,authentication:Xi,commands:ln,comments:dn,chat:xi,debug:Dn,env:vi,extensions:mi,interactive:In,l10n:kn,languages:Ui,lm:$n,notebooks:gn,scm:hn,speech:pn,tasks:fn,tests:Bi,window:un,workspace:Zi,Breakpoint:ce.$MO,TerminalOutputAnchor:ce.TerminalOutputAnchor,ChatResultFeedbackKind:ce.ChatResultFeedbackKind,ChatVariableLevel:ce.ChatVariableLevel,ChatCompletionItem:ce.$IP,CallHierarchyIncomingCall:ce.$$N,CallHierarchyItem:ce.$0N,CallHierarchyOutgoingCall:ce.$_N,CancellationError:C.$4,CancellationTokenSource:h.$we,CandidatePortSource:s.CandidatePortSource,CodeAction:ce.$7N,CodeActionKind:ce.$8N,CodeActionTriggerKind:ce.CodeActionTriggerKind,CodeLens:ce.$aO,Color:ce.$nO,ColorInformation:ce.$oO,ColorPresentation:ce.$pO,ColorThemeKind:ce.ColorThemeKind,CommentMode:ce.CommentMode,CommentState:ce.CommentState,CommentThreadCollapsibleState:ce.CommentThreadCollapsibleState,CommentThreadState:ce.CommentThreadState,CommentThreadApplicability:ce.CommentThreadApplicability,CommentThreadFocus:ce.CommentThreadFocus,CompletionItem:ce.$hO,CompletionItemKind:ce.CompletionItemKind,CompletionItemTag:ce.CompletionItemTag,CompletionList:ce.$iO,CompletionTriggerKind:ce.CompletionTriggerKind,ConfigurationTarget:ce.ConfigurationTarget,CustomExecution:ce.$xO,DebugAdapterExecutable:ce.$QO,DebugAdapterInlineImplementation:ce.$TO,DebugAdapterNamedPipeServer:ce.$SO,DebugAdapterServer:ce.$RO,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ce.DebugConsoleMode,DebugVisualization:ce.$0O,DecorationRangeBehavior:ce.DecorationRangeBehavior,Diagnostic:ce.$ZN,DiagnosticRelatedInformation:ce.$YN,DiagnosticSeverity:ce.DiagnosticSeverity,DiagnosticTag:ce.DiagnosticTag,Disposable:ce.$JN,DocumentHighlight:ce.$3N,DocumentHighlightKind:ce.DocumentHighlightKind,MultiDocumentHighlight:ce.$4N,DocumentLink:ce.$mO,DocumentSymbol:ce.$6N,EndOfLine:ce.EndOfLine,EnvironmentVariableMutatorType:ce.EnvironmentVariableMutatorType,EvaluatableExpression:ce.$WO,InlineValueText:ce.$XO,InlineValueVariableLookup:ce.$YO,InlineValueEvaluatableExpression:ce.$ZO,InlineCompletionTriggerKind:ce.InlineCompletionTriggerKind,EventEmitter:R.$le,ExtensionKind:ce.ExtensionKind,ExtensionMode:ce.ExtensionMode,ExternalUriOpenerPriority:ce.ExternalUriOpenerPriority,FileChangeType:ce.FileChangeType,FileDecoration:ce.$_O,FileDecoration2:ce.$_O,FileSystemError:ce.$3O,FileType:a.FileType,FilePermission:a.FilePermission,FoldingRange:ce.$4O,FoldingRangeKind:ce.FoldingRangeKind,FunctionBreakpoint:ce.$OO,InlineCompletionItem:ce.$jO,InlineCompletionList:ce.$kO,Hover:ce.$1N,VerboseHover:ce.$2N,HoverVerbosityAction:ce.HoverVerbosityAction,IndentAction:u.IndentAction,Location:ce.$XN,MarkdownString:ce.$bO,OverviewRulerLane:P.OverviewRulerLane,ParameterInformation:ce.$cO,PortAutoForwardAction:ce.PortAutoForwardAction,Position:ce.$KN,ProcessExecution:ce.$vO,ProgressLocation:ce.ProgressLocation,QuickInputButtonLocation:ce.QuickInputButtonLocation,QuickInputButtons:ce.$$O,Range:ce.$LN,RelativePattern:ce.$KO,Selection:ce.$MN,SelectionRange:ce.$9N,SemanticTokens:ce.$7O,SemanticTokensBuilder:ce.$6O,SemanticTokensEdit:ce.$8O,SemanticTokensEdits:ce.$9O,SemanticTokensLegend:ce.$5O,ShellExecution:ce.$wO,ShellQuoting:ce.ShellQuoting,SignatureHelp:ce.$eO,SignatureHelpTriggerKind:ce.SignatureHelpTriggerKind,SignatureInformation:ce.$dO,SnippetString:ce.$WN,SourceBreakpoint:ce.$NO,StandardTokenType:ce.StandardTokenType,StatusBarAlignment:ce.StatusBarAlignment,SymbolInformation:ce.$5N,SymbolKind:ce.SymbolKind,SymbolTag:ce.SymbolTag,Task:ce.$yO,TaskGroup:ce.$uO,TaskPanelKind:ce.TaskPanelKind,TaskRevealKind:ce.TaskRevealKind,TaskScope:ce.TaskScope,TerminalLink:ce.$qO,TerminalQuickFixTerminalCommand:ce.$sO,TerminalQuickFixOpener:ce.$rO,TerminalLocation:ce.TerminalLocation,TerminalProfile:ce.$tO,TerminalExitReason:ce.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:ce.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:ce.TextDocumentSaveReason,TextEdit:ce.$SN,SnippetTextEdit:ce.$UN,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:ce.TextEditorLineNumbersStyle,TextEditorRevealType:ce.TextEditorRevealType,TextEditorSelectionChangeKind:ce.TextEditorSelectionChangeKind,SyntaxTokenType:ce.SyntaxTokenType,TextDocumentChangeReason:ce.TextDocumentChangeReason,ThemeColor:ce.$JO,ThemeIcon:ce.$IO,TreeItem:ce.$zO,TreeItemCheckboxState:ce.TreeItemCheckboxState,TreeItemCollapsibleState:ce.TreeItemCollapsibleState,TypeHierarchyItem:ce.$wP,UIKind:Rt.UIKind,Uri:c.URI,ViewColumn:ce.ViewColumn,WorkspaceEdit:ce.$VN,DocumentPasteTriggerKind:ce.DocumentPasteTriggerKind,DocumentDropEdit:ce.$FO,DocumentDropOrPasteEditKind:ce.$GO,DocumentPasteEdit:ce.$HO,InlayHint:ce.$gO,InlayHintLabelPart:ce.$fO,InlayHintKind:ce.InlayHintKind,RemoteAuthorityResolverError:ce.$RN,ResolvedAuthority:ce.$PN,ManagedResolvedAuthority:ce.$QN,SourceControlInputBoxValidationType:ce.SourceControlInputBoxValidationType,ExtensionRuntime:ce.ExtensionRuntime,TimelineItem:ce.$jP,NotebookRange:ce.$bP,NotebookCellKind:ce.NotebookCellKind,NotebookCellExecutionState:ce.NotebookCellExecutionState,NotebookCellData:ce.$cP,NotebookData:ce.$dP,NotebookRendererScript:ce.$hP,NotebookCellStatusBarAlignment:ce.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ce.NotebookEditorRevealType,NotebookCellOutput:ce.$fP,NotebookCellOutputItem:ce.$eP,NotebookCellStatusBarItem:ce.$gP,NotebookControllerAffinity:ce.NotebookControllerAffinity,NotebookControllerAffinity2:ce.NotebookControllerAffinity2,NotebookEdit:ce.$TN,NotebookKernelSourceAction:ce.$iP,NotebookVariablesRequestKind:ce.NotebookVariablesRequestKind,PortAttributes:ce.$lP,LinkedEditingRanges:ce.$kP,TestResultState:ce.TestResultState,TestRunRequest:ce.$mP,TestMessage:ce.$nP,TestMessage2:ce.$nP,TestMessageStackFrame:ce.$pP,TestTag:ce.$oP,TestRunProfileKind:ce.TestRunProfileKind,TextSearchCompleteMessageType:jt.TextSearchCompleteMessageType,DataTransfer:ce.$EO,DataTransferItem:ce.$AO,TestCoverageCount:ce.$qP,FileCoverage:ce.$sP,FileCoverage2:ce.$sP,StatementCoverage:ce.$tP,BranchCoverage:ce.$uP,DeclarationCoverage:ce.$vP,WorkspaceTrustState:ce.WorkspaceTrustState,LanguageStatusSeverity:ce.LanguageStatusSeverity,QuickPickItemKind:ce.QuickPickItemKind,InputBoxValidationSeverity:ce.InputBoxValidationSeverity,TabInputText:ce.$xP,TabInputTextDiff:ce.$yP,TabInputTextMerge:ce.$zP,TabInputCustom:ce.$AP,TabInputNotebook:ce.$CP,TabInputNotebookDiff:ce.$DP,TabInputWebview:ce.$BP,TabInputTerminal:ce.$EP,TabInputInteractiveWindow:ce.$FP,TabInputChat:ce.$GP,TabInputTextMultiDiff:ce.$HP,TelemetryTrustedValue:f.$wp,LogLevel:m.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ce.InteractiveSessionVoteDirection,ChatCopyKind:ce.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ce.InteractiveEditorResponseFeedbackKind,DebugStackFrame:ce.$UO,DebugThread:ce.$VO,RelatedInformationType:ce.RelatedInformationType,SpeechToTextStatus:ce.SpeechToTextStatus,TextToSpeechStatus:ce.TextToSpeechStatus,PartialAcceptTriggerKind:ce.PartialAcceptTriggerKind,KeywordRecognitionStatus:ce.KeywordRecognitionStatus,ChatResponseMarkdownPart:ce.$JP,ChatResponseFileTreePart:ce.$NP,ChatResponseAnchorPart:ce.$OP,ChatResponseProgressPart:ce.$PP,ChatResponseProgressPart2:ce.$QP,ChatResponseReferencePart:ce.$TP,ChatResponseReferencePart2:ce.$TP,ChatResponseCodeCitationPart:ce.$UP,ChatResponseWarningPart:ce.$RP,ChatResponseTextEditPart:ce.$VP,ChatResponseMarkdownWithVulnerabilitiesPart:ce.$KP,ChatResponseCommandButtonPart:ce.$SP,ChatResponseDetectedParticipantPart:ce.$LP,ChatResponseConfirmationPart:ce.$MP,ChatResponseReferencePartStatusKind:ce.ChatResponseReferencePartStatusKind,ChatRequestTurn:ce.$WP,ChatResponseTurn:ce.$XP,ChatLocation:ce.ChatLocation,ChatRequestEditorData:ce.$YP,ChatRequestNotebookData:ce.$ZP,LanguageModelChatMessageRole:ce.LanguageModelChatMessageRole,LanguageModelChatMessage:ce.$2P,LanguageModelChatMessageFunctionResultPart:ce.$1P,LanguageModelChatResponseTextPart:ce.$4P,LanguageModelChatResponseFunctionUsePart:ce.$3P,LanguageModelError:ce.$8P,NewSymbolName:ce.$2O,NewSymbolNameTag:ce.NewSymbolNameTag,NewSymbolNameTriggerKind:ce.NewSymbolNameTriggerKind,InlineEdit:ce.$9P,InlineEditTriggerKind:ce.InlineEditTriggerKind,ExcludeSettingOptions:jt.ExcludeSettingOptions,TextSearchContextNew:jt.$XL,TextSearchMatchNew:jt.$WL,TextSearchCompleteMessageTypeNew:jt.TextSearchCompleteMessageTypeNew}}}}),define(ke[345],Ie([1,0,88,169,48,163,41,34,63,47,100,101,102,125,76,95,162,75,62,124,94,77,161,11,64,122,123,127,128,167,98]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Qs)(l.$bqc,l.$aqc,r.InstantiationType.Delayed),(0,r.$Qs)(n.$ak,o.$qrc,r.InstantiationType.Delayed),(0,r.$Qs)(a.$gpc,a.$hpc,r.InstantiationType.Delayed),(0,r.$Qs)(T.$DQ,T.$CQ,r.InstantiationType.Eager),(0,r.$Qs)(E.$qpc,E.$rpc,r.InstantiationType.Eager),(0,r.$Qs)(D.$8pc,D.$9pc,r.InstantiationType.Eager),(0,r.$Qs)(L.$Fpc,L.$Dpc,r.InstantiationType.Eager),(0,r.$Qs)($.$Hpc,$.$Gpc,r.InstantiationType.Eager),(0,r.$Qs)(k.$lqc,k.$mqc,r.InstantiationType.Eager),(0,r.$Qs)(S.$qqc,S.$uqc,r.InstantiationType.Eager),(0,r.$Qs)(R.$wqc,R.$vqc,r.InstantiationType.Eager),(0,r.$Qs)(b.$sQ,b.$rQ,r.InstantiationType.Eager),(0,r.$Qs)(g.$cqc,g.$dqc,r.InstantiationType.Eager),(0,r.$Qs)(f.$kpc,f.$jpc,r.InstantiationType.Eager),(0,r.$Qs)(h.$3qc,h.$2qc,r.InstantiationType.Delayed),(0,r.$Qs)(u.$Mqc,u.$Nqc,r.InstantiationType.Eager),(0,r.$Qs)(P.$1pc,P.$Zpc,r.InstantiationType.Eager),(0,r.$Qs)(I.$drc,I.$crc,r.InstantiationType.Eager),(0,r.$Qs)(c.$4pc,c.$7pc,r.InstantiationType.Eager),(0,r.$Qs)(y.$erc,y.$frc,r.InstantiationType.Eager),(0,r.$Qs)(w.$eGb,w.$fGb,r.InstantiationType.Eager),(0,r.$Qs)(m.$orc,m.$nrc,r.InstantiationType.Eager),(0,r.$Qs)(C.$Cpc,C.$Bpc,r.InstantiationType.Eager),(0,r.$Qs)(i.$$pc,i.$0pc,r.InstantiationType.Eager),(0,r.$Qs)(s.$BQ,s.$yQ,r.InstantiationType.Eager),(0,r.$Qs)(t.$Rpc,t.$Spc,r.InstantiationType.Eager),(0,r.$Qs)(d.$jqc,d.$kqc,r.InstantiationType.Eager)}),define(ke[129],Ie([1,0,18,11,37,99]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=void 0,e.$Grc=L,e.$Hrc=T,R=qe(R);function L(S){return S.startsWith("**")||S.startsWith("/")?S:`/${S}`}function T(S,u,P,w){const a=(0,r.$Zb)(P,b),m=new C.$0L(u,a,w),$=m.preview.matches;return{ranges:(0,r.$Zb)(a,c),uri:S,preview:{text:m.preview.text,matches:(0,r.$Zb)($,c)}}}function b(S){return new C.$$L(S.start.line,S.start.character,S.end.line,S.end.character)}function c(S){return new R.$VL(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn)}let I=class{constructor(u,P){this.a=u,this.b=P}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$Irc=I,e.$Irc=I=Je([Ve(1,h.$_j)],I)}),define(ke[346],Ie([1,0,56,16,81,31,10,12,129,347]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jrc=S,e.$Krc=m,e.$Lrc=f,r=qe(r),h=qe(h),R=qe(R),T=qe(T);const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function S(i,s,t,o,n){const d=u(i,s,t,o,n),l=s.folder.fsPath;return{cmd:r.spawn(I,d.args,{cwd:l}),rgDiskPath:I,siblingClauses:d.siblingClauses,rgArgs:d,cwd:l}}function u(i,s,t,o,n){const d=["--files","--hidden","--case-sensitive","--no-require-git"];w([s],t,!1).forEach(g=>{const E=(0,b.$Grc)(g);if(d.push("-g",E),L.$k){const D=(0,C.$nm)(E);D!==E&&d.push("-g",D)}});const l=P([s],o,void 0,!1);return l.globArgs.forEach(g=>{const E=`!${(0,b.$Grc)(g)}`;if(d.push("-g",E),L.$k){const D=(0,C.$nm)(E);D!==E&&d.push("-g",D)}}),s.disregardIgnoreFiles!==!1?d.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),s.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),n&&d.push("--threads",`${n}`),d.push("--no-config"),s.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:l.siblingClauses}}function P(i,s,t,o=!0){const n=[];let d={};return i.forEach(l=>{const g=Object.assign({},l.excludePattern||{},s||{}),E=a(g,o?l.folder.fsPath:void 0,t);n.push(...E.globArgs),E.siblingClauses&&(d=Object.assign(d,E.siblingClauses))}),{globArgs:n,siblingClauses:d}}function w(i,s,t=!0){const o=[];return i.forEach(n=>{const d=Object.assign({},s||{},n.includePattern||{}),l=a(d,t?n.folder.fsPath:void 0);o.push(...l.globArgs)}),o}function a(i,s,t){const o=[],n={};return Object.keys(i).forEach(d=>{if(t&&t.has(d)||!d)return;const l=i[d];d=$(s?m(s,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),o.push(f(d))):l&&l.when&&(n[d]=l)}),{globArgs:o,siblingClauses:n}}function m(i,s){return h.$ic(s)?s:h.$jc(i,s)}function $(i){return i=T.$nf(i,"\\"),T.$nf(i,"/")}function f(i){return R.$zg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[348],Ie([1,0,56,44,16,349,18,52,38,81,31,10,42,12,17,33,37,346,136]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrc=e.$Mrc=void 0,r=qe(r),h=qe(h),C=qe(C),L=qe(L),b=qe(b),c=qe(c),S=qe(S),P=qe(P),w=qe(w);const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class s{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&b.$zk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,f.$Qr)(this.b).normalizedLowercase),this.u=l.excludePattern&&b.$zk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(g=>{const E=Object.assign({},g.excludePattern||{},this.a.excludePattern||{}),D=g.folder.fsPath;l.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==D).forEach(y=>{(0,I.$Dg)(y,D)&&(E[C.$lc(D,y)]=!0)}),this.t.set(D,new o(E,D))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,g,E,D,y,k){if(this.m=u.$fe.create(!1),this.l)return k(null,this.j);g.forEach(A=>{const p=C.$nc(A.fsPath);this.u&&this.u(A.fsPath,p)||this.J(D,{relativePath:A.fsPath,searchPath:void 0})}),this.r=u.$fe.create(!1),this.w(l,(A,p)=>{this.x(this.y,this,A,E,D,y,v=>{if(v){const F=(0,T.$pj)(v);console.error(F),this.q.push(F),p(v,void 0)}else p(null,void 0)})},(A,p)=>{this.m.stop();const v=A?L.$Gb(A)[0]:null;k(v,this.j)})}w(l,g,E){const D=new Array(l.length),y=new Array(l.length);let k=!1,A=0;if(l.length===0)return E(null,[]);l.forEach((p,v)=>{g(p,(F,N)=>{if(F?(k=!0,D[v]=null,y[v]=F):(D[v]=N,y[v]=null),++A===l.length)return E(k?y:null,D)})})}x(l,g,...E){try{l.apply(g,E)}catch(D){E[E.length-1](D)}}y(l,g,E,D,y){const k=l.folder.fsPath,A=S.$k,p=()=>j&&j.kill();i.add(p);let v=V=>{i.delete(p),v=()=>{},y(V)},F="";const N=this.D(),O=(0,$.$Jrc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression,g),j=O.cmd,z=!Object.keys(O.siblingClauses).length,M=O.rgArgs.args.map(V=>V.match(/^-/)?V:`'${V}'`).join(" ");let U=`${O.rgDiskPath} ${M}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),D({message:U}),this.s=0,this.z(j,"utf8",D,(V,ie,B)=>{if(V){v(V);return}if(this.j){v();return}const J=(F+(A?c.$mm(ie||""):ie)).split(`
`);if(B){const _=J.length;J[_-1]=J[_-1].trim(),J[_-1]||J.pop()}else F=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=J.length,z){for(const _ of J)if(this.J(E,{base:k,relativePath:_,searchPath:this.N(l,_)}),this.j){p();break}(B||this.j)&&v();return}this.G(l,N,k,J,E),B&&(this.H(N,k,E),v())})}spawnFindCmd(l){const g=this.t.get(l.folder.fsPath),E=g.getBasenameTerms(),D=g.getPathTerms(),y=["-L","."];if(E.length||D.length){y.push("-not","(","(");for(const k of E)y.push("-name",k),y.push("-o");for(const k of D)y.push("-path",k),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),r.spawn("find",y,{cwd:l.folder.fsPath})}readStdout(l,g,E){let D="";this.z(l,g,()=>{},(y,k,A)=>{if(y){E(y);return}D+=k,A&&E(null,D)})}z(l,g,E,D){let y=(p,v,F)=>{(p||F)&&(y=()=>{},this.r?.stop()),D(p,v,F)},k=!1;l.stdout?(this.A(l.stdout,g,y),l.stdout.once("data",()=>k=!0)):E({message:"stdout is null"});let A;l.stderr?A=this.B(l.stderr):E({message:"stderr is null"}),l.on("error",p=>{y(p)}),l.on("close",p=>{let v;!k&&(v=this.C(A,g))&&n(v)?y(new Error(`command failed with error code ${p}: ${this.C(A,g)}`)):(this.g&&p===0&&(this.j=!0),y(null,"",!0))})}A(l,g,E){const D=new R.StringDecoder(g);return l.on("data",y=>{E(null,D.write(y))}),D}B(l){const g=[];return l.on("data",E=>{g.push(E)}),g}C(l,g){const E=new R.StringDecoder(g);return l.map(D=>E.write(D)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:g},E,D,y){D.indexOf(this.b)!==-1&&this.J(y,{base:E,relativePath:this.b,searchPath:this.N(l,this.b)});const k=A=>{const p=C.$nc(A),v=C.$mc(A);let F=g[v];F||(F=g[v]=[],k(v)),F.push({base:E,relativePath:A,basename:p,searchPath:this.N(l,A)})};D.forEach(k)}H({rootEntries:l,pathToEntries:g},E,D){const y=this,k=this.t.get(E),A=this.b;function p(v){y.o++;const F=(0,m.$nM)(()=>v.map(N=>N.basename));for(let N=0,O=v.length;N<O;N++){const j=v[N],{relativePath:z,basename:M}=j;if(k.test(z,M,A!==M?F:void 0))continue;const U=g[z];if(U)p(U);else{if(y.p++,z===A)continue;y.J(D,j)}if(y.j)break}}p(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,g,E,D,y){const k=l.folder,A=(0,m.$nM)(()=>E);this.w(E,(p,v)=>{if(this.l||this.j)return v(null);const F=g?[g,p].join(C.sep):p;if(this.t.get(l.folder.fsPath).test(F,p,this.a.filePattern!==p?A:void 0))return v(null);const N=[k.fsPath,F].join(C.sep);h.lstat(N,(O,j)=>{if(O||this.l||this.j)return v(null);this.L(N,j,(z,M)=>z||this.l||this.j?v(null):M.isDirectory()?(this.o++,this.M(N,j,(U,V)=>U||this.l||this.j||(V=V||"",this.v[V])?v(null):(this.v[V]=!0,a.Promises.readdir(N).then(ie=>{if(this.l||this.j)return v(null);this.I(l,F,ie,D,B=>v(B||null))},ie=>{v(null)})))):(this.p++,F===this.b||this.h&&w.$ig(M.size)&&M.size>this.h||this.J(D,{base:k.fsPath,relativePath:F,searchPath:this.N(l,F)}),v(null,void 0)))})},p=>{const v=p&&L.$Gb(p);return y(v&&v.length>0?v[0]:void 0)})}J(l,g){this.K(g)&&(!this.d||this.d(g.relativePath,C.$nc(g.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(g))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$iM)(l,this.c);if(this.b)return(0,m.$iM)(l,this.b,!1)}return!0}L(l,g,E){return g.isSymbolicLink()?h.stat(l,E):E(null,g)}M(l,g,E){return g.isSymbolicLink()?h.realpath(l,(D,y)=>D?E(D):E(null,y)):E(null,l)}N(l,g){return l.folderName?C.$jc(l.folderName,g):g}}e.$Mrc=s;class t{constructor(l,g){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.d=g,this.c=new s(l)}search(l,g,E){this.c.walk(this.a,this.b,this.d,l,g,(D,y)=>{E(D,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Nrc=t;class o{constructor(l,g){this.expression=l,this.c=g,this.d(l)}d(l){let g,E;Object.keys(l).filter(D=>l[D]).forEach(D=>{C.$ic(D)?(g=g||b.$uk(),g[D]=l[D]):(E=E||b.$uk(),E[D]=l[D])}),this.a=g&&b.$zk(g,{trimForExclusions:!0}),this.b=E&&b.$zk(E,{trimForExclusions:!0})}test(l,g,E){return this.b&&this.b(l,g,E)||this.a&&this.a(C.$jc(this.c,l),g,E)}getBasenameTerms(){const l=[];return this.a&&l.push(...b.$Bk(this.a)),this.b&&l.push(...b.$Bk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...b.$Ck(this.a)),this.b&&l.push(...b.$Ck(this.b)),l}}function n(d){const l=d.trim().split(`
`),g=l[0].trim();if(g.startsWith("Error parsing regex"))return g;if(g.startsWith("regex parse error"))return P.$9f(l[l.length-1].trim());if(g.startsWith("error parsing glob")||g.startsWith("unsupported encoding"))return g.charAt(0).toUpperCase()+g.substr(1);if(g==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(g.startsWith("Literal "))return g}}),define(ke[350],Ie([1,0,105,21,189,20,18]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UE=e.$TE=e.$LE=e.DecodeStreamErrorKind=e.$KE=e.$JE=e.$IE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$HE=T,e.$ME=a,e.$NE=m,e.$OE=$,e.$PE=f,e.$QE=i,e.$RE=E,e.$SE=D,e.$DE="utf8",e.$EE="utf8bom",e.$FE="utf16be",e.$GE="utf16le";function T(y){return[e.$DE,e.$EE,e.$FE,e.$GE].some(k=>k===y)}e.$IE=[254,255],e.$JE=[255,254],e.$KE=[239,187,191];const b=512,c=512,I=512*8,S=512*128;var u;(function(y){y[y.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class P extends Error{constructor(k,A){super(k),this.decodeStreamErrorKind=A}}e.$LE=P;class w{static async create(k){let A;if(k!==e.$DE)A=(await(0,C.$BE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(f(k));else{const p=new TextDecoder;A={write(v){return p.decode(v,{stream:!0})},end(){return p.decode()}}}return new w(A)}constructor(k){this.a=k}write(k){return this.a.write(k)}end(){return this.a.end()}}function a(y,k){const A=k.minBytesRequiredForDetection??k.guessEncoding?I:c;return new Promise((p,v)=>{const F=(0,r.$Be)(U=>U.join("")),N=[];let O=0,j;const z=new R.$we,M=async()=>{try{const U=await D({buffer:h.$Ne.concat(N),bytesRead:O},k.guessEncoding,k.candidateGuessEncodings);if(U.seemsBinary&&k.acceptTextOnly)throw new P("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);U.encoding=await k.overwriteEncoding(U.encoding),j=await w.create(U.encoding);const V=j.write(h.$Ne.concat(N).buffer);F.write(V),N.length=0,O=0,p({stream:F,detected:U})}catch(U){z.cancel(),F.destroy(),v(U)}};(0,r.$Fe)(y,{onData:async U=>{j?F.write(j.write(U.buffer)):(N.push(U),O+=U.byteLength,O>=A&&(y.pause(),await M(),setTimeout(()=>y.resume())))},onError:U=>F.error(U),onEnd:async()=>{j||await M(),F.end(j?.end())}},z.token)})}async function m(y,k,A){const v=(await(0,C.$BE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(f(k),A);let F=!1,N=!1;return{read(){if(N)return null;const O=y.read();if(typeof O!="string"){if(N=!0,!F&&A?.addBOM)switch(k){case e.$DE:case e.$EE:return h.$Ne.wrap(Uint8Array.from(e.$KE));case e.$FE:return h.$Ne.wrap(Uint8Array.from(e.$IE));case e.$GE:return h.$Ne.wrap(Uint8Array.from(e.$JE))}const j=v.end();return j&&j.length>0?(F=!0,h.$Ne.wrap(j)):null}return F=!0,h.$Ne.wrap(v.write(O))}}}async function $(y){return(await(0,C.$BE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(f(y))}function f(y){return y===e.$EE||y===null?e.$DE:y}function i(y,k){if(!y||k<e.$IE.length)return null;const A=y.readUInt8(0),p=y.readUInt8(1);if(A===e.$IE[0]&&p===e.$IE[1])return e.$FE;if(A===e.$JE[0]&&p===e.$JE[1])return e.$GE;if(k<e.$KE.length)return null;const v=y.readUInt8(2);return A===e.$KE[0]&&p===e.$KE[1]&&v===e.$KE[2]?e.$EE:null}const s=["ascii","utf-16","utf-32"];async function t(y,k){const A=await(0,C.$BE)("jschardet","dist/jschardet.min.js"),p=y.slice(0,S),v=g(p.buffer);k&&(k=(0,L.$Gb)(k.map(O=>l(O))),k.length===0&&(k=void 0));const F=A.detect(v,k?{detectEncodings:k}:void 0);if(!F||!F.encoding)return null;const N=F.encoding.toLowerCase();return 0<=s.indexOf(N)?null:d(F.encoding)}const o={ibm866:"cp866",big5:"cp950"};function n(y){return y.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function d(y){const k=n(y);return o[k]||k}function l(y){const k=n(y);return e.$UE[k].guessableName}function g(y){let k="";for(let A=0;A<y.length;A++)k+=String.fromCharCode(y[A]);return k}function E(y){switch(y){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const k=y.match(/windows(\d+)/);return k?"windows-"+k[1]:y}}}function D({buffer:y,bytesRead:k},A,p){let v=i(y,k),F=!1;if(v!==e.$FE&&v!==e.$GE&&y){let N=!0,O=!0,j=!1;for(let z=0;z<k&&z<b;z++){const M=z%2===1,U=y.readUInt8(z)===0;if(U&&(j=!0),N&&(M&&!U||!M&&U)&&(N=!1),O&&(M&&U||!M&&!U)&&(O=!1),U&&!N&&!O)break}j&&(N?v=e.$GE:O?v=e.$FE:F=!0)}return A&&!F&&!v&&y?t(y.slice(0,k),p).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:F,encoding:v}}e.$TE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$UE=(()=>{const y={};for(const k in e.$TE)e.$TE[k].guessableName&&(y[k]=e.$TE[k]);return y})()}),define(ke[172],Ie([1,0,350,33,171]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrc=void 0,h=qe(h);class R extends C.$Iqc{constructor(T,b,c=h,I="searchProcess"){super({query:T,provider:b},{readdir:S=>c.Promises.readdir(S.fsPath),toCanonicalName:S=>(0,r.$RE)(S)},I)}}e.$Vrc=R}),define(ke[173],Ie([1,0,56,365,349,18,78,38,12,2,37,99,366,347,129]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=e.$Orc=void 0,e.$Qrc=o,e.$Rrc=d,e.$Src=g,e.$Trc=E,e.$Urc=y,r=qe(r);const a=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(A,p){this.a=A,this.b=p}provideTextSearchResults(A,p,v,F){return this.a.appendLine(`provideTextSearchResults ${A.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((N,O)=>{F.onCancellationRequested(()=>J());const j={...p,numThreads:this.b},z=o(A,j),M=p.folder.fsPath,U=z.map(me=>me.match(/^-/)?me:`'${me}'`).join(" ");this.a.appendLine(`${a} ${U}
 - cwd: ${M}`);let V=r.spawn(a,z,{cwd:M});V.on("error",me=>{console.error(me),this.a.appendLine("Error: "+(me&&me.message)),O((0,I.$eM)(new I.$cM(me&&me.message,I.SearchErrorCode.rgProcessError)))});let ie=!1;const B=new i(p.maxResults,p.folder,p.previewOptions);B.on("result",me=>{ie=!0,le="",v.report(me)});let Y=!1;const J=()=>{Y=!0,V?.kill(),B?.cancel()};let _=!1;B.on("hitLimit",()=>{_=!0,J()});let le="";V.stdout.on("data",me=>{B.handleData(me),ie||(le+=me)});let re=!1;V.stdout.once("data",()=>re=!0);let Se="";V.stderr.on("data",me=>{const Q=me.toString();this.a.appendLine(Q),Se.length+Q.length<1e6&&(Se+=Q)}),V.on("close",()=>{if(this.a.appendLine(re?"Got data from stdout":"No data from stdout"),this.a.appendLine(ie?"Got result from parser":"No result from parser"),le&&this.a.appendLine(`Got data without result: ${le}`),this.a.appendLine(""),Y)N({limitHit:_});else{B.flush(),V=null;let me;Se&&!re&&(me=$(Se))?O((0,I.$eM)(new I.$cM(me.message,me.code))):N({limitHit:_})}})})}}e.$Orc=m;function $(k){const A=k.split(`
`),p=A[0].trim();if(A.some(F=>F.startsWith("regex parse error")))return new I.$cM(f(A),I.SearchErrorCode.regexParseError);const v=p.match(/grep config error: unknown encoding: (.*)/);if(v)return new I.$cM(`Unknown encoding: ${v[1]}`,I.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new I.$cM(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new I.$cM(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new I.$cM(p,I.SearchErrorCode.regexParseError)}function f(k){const A=["Regex parse error"],p=k.filter(v=>v.startsWith("PCRE2:"));if(p.length>=1){const v=p[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const F=v.split(":")[1];A.push(":"+F)}}return A.join("")}class i extends h.EventEmitter{constructor(A,p,v){super(),this.g=A,this.h=p,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new C.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(A,p){return super.on(A,p),this}handleData(A){if(this.b)return;const p=typeof A=="string"?A:this.d.write(A);this.k(p)}k(A){let p=A.indexOf(`
`);const v=this.a+A;if(p>=0)p+=this.a.length;else{this.a=v;return}let F=0;for(;p>=0;)this.m(v.substring(F,p).trim()),F=p+1,p=v.indexOf(`
`,F);this.a=v.substring(F)}m(A){if(this.b||!A)return;let p;try{p=JSON.parse(A)}catch{throw new Error(`malformed line from rg: ${A}`)}if(p.type==="match"){const v=s(p.data.path),F=c.URI.joinPath(this.h,v),N=this.n(p.data,F);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const v=s(p.data.path),F=c.URI.joinPath(this.h,v);this.o(p.data,F).forEach(O=>this.p(O))}}n(A,p){const v=A.line_number-1,F=s(A.lines),N=Buffer.from(F);let O=0,j=0,z=v;A.submatches.length===0&&A.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const M=(0,R.$Gb)(A.submatches.map((U,V)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=s(U.match),B=N.slice(O,U.start).toString(),Y=t(B),J=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+j,_=t(ie),le=Y.numLines+z,re=_.numLines+le,Se=_.numLines>0?_.lastLineLength:_.lastLineLength+J;return O=U.end,j=Se,z=re,new S.$VL(le,J,re,Se)}));return(0,w.$Hrc)(p,F,M,this.j)}o(A,p){const v=s(A.lines),F=A.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((N,O)=>({text:N,uri:p,lineNumber:F+O}))}p(A){this.emit("result",A)}}e.$Prc=i;function s(k){return k.bytes?Buffer.from(k.bytes,"base64").toString():k.text}function t(k){const A=/\n/g;let p=0,v=-1,F;for(;F=A.exec(k);)p++,v=F.index;const N=v>=0?k.length-v-1:k.length;return{numLines:p,lastLineLength:N}}function o(k,A){const p=["--hidden","--no-require-git"];p.push(k.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:F}=(0,L.$c)(A.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const O=new Set;F.forEach(j=>{O.add(j)}),p.push("-g","!*"),O.forEach(j=>{n(j).map(w.$Grc).forEach(z=>{p.push("-g",z)})})}v&&v.length&&v.forEach(O=>{p.push("-g",O)}),A.excludes.map(w.$Grc).forEach(O=>p.push("-g",`!${O}`)),A.maxFileSize&&p.push("--max-filesize",A.maxFileSize+""),A.useIgnoreFiles?A.useParentIgnoreFiles||p.push("--no-ignore-parent"):p.push("--no-ignore"),A.followSymlinks&&p.push("--follow"),A.encoding&&A.encoding!=="utf8"&&p.push("--encoding",A.encoding),A.numThreads&&p.push("--threads",`${A.numThreads}`),k.pattern==="--"&&(k.isRegExp=!0,k.pattern="\\-\\-"),k.isMultiline&&!k.isRegExp&&(k.pattern=(0,b.$hf)(k.pattern),k.isRegExp=!0),A.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),k.isRegExp&&(k.pattern=d(k.pattern),p.push("--engine","auto"));let N;if(k.isWordMatch){const j=(0,b.$qf)(k.pattern,!!k.isRegExp,{wholeWord:k.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",j)}else if(k.isRegExp){let O=g(k.pattern);O=E(O),p.push("--regexp",O)}else N=k.pattern,p.push("--fixed-strings");return p.push("--no-config"),A.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),k.isMultiline&&p.push("--multiline"),A.beforeContext&&p.push("--before-context",A.beforeContext+""),A.afterContext&&p.push("--after-context",A.afterContext+""),p.push("--"),N&&p.push(N),p.push("."),p}function n(k){return y(k).flatMap(p=>{const v=(0,T.$xk)(p,"/");return v.map((F,N)=>v.slice(0,N+1).join("/"))})}function d(k){const A=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;k.match(A);)k=k.replace(A,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;k.match(p);)k=k.replace(p,"$1\\x{$2}");return k}const l=k=>k.type==="Assertion"&&k.kind==="lookbehind";function g(k){let A;try{A=new u.RegExpParser().parsePattern(k)}catch{return k}let p="",v=0;const F=(j,z,M)=>{p+=k.slice(v,j)+M,v=z},N=[];return new u.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const z=N[0];if(!z)F(j.start,j.end,"\\r?\\n");else if(!N.some(l))if(z.type==="CharacterClass")if(z.negate){const M=k.slice(z.start+2,j.start)+k.slice(j.end,z.end-1);z.parent?.type==="Quantifier"?F(z.start,z.end,M?`[^${M}]`:"."):F(z.start,z.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=k.slice(z.start+1,j.start)+k.slice(j.end,z.end-1);F(z.start,z.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else z.type==="Quantifier"&&F(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){N.unshift(j)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(j){N.unshift(j)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(j){N.unshift(j)},onCharacterClassLeave(){N.shift()},onAssertionEnter(j){l(j)&&N.push(j)},onAssertionLeave(j){N[0]===j&&N.shift()}}).visit(A),p+=k.slice(v),p}function E(k){return k.replace(/\n/g,"\\r?\\n")}function D(k){let A=!1,p=!1,v="",F="";for(let N=0;N<k.length;N++){const O=k[N];switch(O){case"\\":p?(A?F+="\\"+O:v+="\\"+O,p=!1):p=!0;break;case"{":if(p)A?F+=O:v+=O,p=!1;else{if(A)return{strInBraces:v+"{"+F+"{"+k.substring(N+1)};A=!0}break;case"}":if(p)A?F+=O:v+=O,p=!1;else{if(A)return{fixedStart:v,strInBraces:F,fixedEnd:k.substring(N+1)};v+=O}break;default:A?F+=(p?"\\":"")+O:v+=(p?"\\":"")+O,p=!1;break}}return{strInBraces:v+(A?"{"+F:"")}}function y(k){const{fixedStart:A,strInBraces:p,fixedEnd:v}=D(k);if(A===void 0||v===void 0)return[p];let F=(0,T.$xk)(p,",");F.length||(F=[""]);const N=y(v);return F.flatMap(O=>{const j=A+O;return N.map(z=>j+z)})}}),define(ke[351],Ie([1,0,20,173,89,14]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yrc=void 0;class L{constructor(c,I){this.b=c,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(c,I,S,u){const P=await this.c(),w=new h.$Orc(this.b,P),a={...I,numThreads:P};if(I.folder.scheme===R.Schemas.vscodeUserData){const m={...a,folder:I.folder.with({scheme:R.Schemas.file})},$=new C.$yw(f=>S.report({...f,uri:f.uri.with({scheme:I.folder.scheme})}));return this.d(u,f=>w.provideTextSearchResults(c,m,$,f))}else return this.d(u,m=>w.provideTextSearchResults(c,a,S,m))}async d(c,I){const S=T(c);this.a.add(S);const u=await I(S.token);return this.a.delete(S),u}e(){this.a.forEach(c=>c.cancel())}}e.$Yrc=L;function T(b){const c=new r.$we;return b.onCancellationRequested(()=>c.cancel()),c}}),define(ke[352],Ie([1,0,33,173,172]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=void 0,r=qe(r);class R{constructor(b,c){this.a=b,this.b=c}search(b,c,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const S={appendLine(P){I({message:P})}},u=new C.$Vrc(this.a,new h.$Orc(S,this.b),r);return new Promise((P,w)=>u.search(a=>{c(a.map(L))},b).then(a=>P({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),w))}}e.$Wrc=R;function L(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((b,c)=>{if(c.ranges){const I=c;return b+(Array.isArray(I.ranges)?I.ranges.length:1)}else return b+1},0)}}}),define(ke[353],Ie([1,0,18,7,13,4,136,16,42,2,27,37,348,352]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xrc=void 0,r=qe(r);class w{static{this.a=512}constructor(s="searchProcess",t){this.d=s,this.f=t,this.b=Object.create(null)}fileSearch(s){let t;const o=$(s),n=new R.$le({onDidAddFirstListener:()=>{t=(0,h.$rh)(async d=>{const l=await this.f?.();return this.doFileSearchWithEngine(u.$Nrc,o,g=>n.fire(g),d,w.a,l)}),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}textSearch(s){let t;const o=$(s),n=new R.$le({onDidAddFirstListener:()=>{t=(0,h.$rh)(d=>this.g(o,l=>n.fire(l),d)),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}async g(s,t,o){s.maxFileSize=this.h().maxFileSize;const n=await this.f?.();return new P.$Wrc(s,n).search(o,t,t)}h(){return{maxFileSize:16*I.$Hl.GB}}doFileSearch(s,t,o,n){return this.doFileSearchWithEngine(u.$Nrc,s,o,n,w.a,t)}doFileSearchWithEngine(s,t,o,n,d=w.a,l){let g=0;const E=y=>{Array.isArray(y)?(g+=y.length,o(y.map(k=>this.j(k)))):y.relativePath?(g++,o(this.j(y))):o(y)};if(t.sortByScore){let y=this.n(t,E,n);if(!y){const k=t.maxResults?Object.assign({},t,{maxResults:null}):t,A=new s(k,l);y=this.k(A,t,o,E,n)}return new Promise((k,A)=>{y.then(([p,v])=>{const F=v.map(N=>this.j(N));this.q(F,o,d),k(p)},A)})}const D=new s(t,l);return this.s(D,E,d,n).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:g,sortingTime:void 0},messages:[]}))}j(s){return{path:s.base?(0,T.$jc)(s.base,s.relativePath):s.relativePath}}k(s,t,o,n,d){const l=new R.$le;let g=(0,h.$rh)(D=>{let y=[];const k=A=>{Array.isArray(A)?y=A:(n(A),l.fire(A))};return this.s(s,k,-1,D).then(A=>[A,y])}),E;if(t.cacheKey){E=this.l(t.cacheKey);const D={promise:g,event:l.event,resolved:!1};E.resultsToSearchCache[t.filePattern||""]=D,g.then(()=>{D.resolved=!0},y=>{delete E.resultsToSearchCache[t.filePattern||""]}),g=this.t(g)}return g.then(([D,y])=>{const k=E?E.scorerCache:Object.create(null),A=(typeof t.maxResults!="number"||t.maxResults>0)&&b.$fe.create(!1);return this.o(t,y,k,d).then(p=>{const v=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:p.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults},p]})})}l(s){const t=this.b[s];return t||(this.b[s]=new a)}n(s,t,o){const n=s.cacheKey&&this.b[s.cacheKey];if(!n)return;const d=this.r(n,s.filePattern||"",t,o);if(d)return d.then(([l,g,E])=>{const D=b.$fe.create(!1);return this.o(s,g,n.scorerCache,o).then(y=>{const k=D.elapsed(),A={fromCache:!0,detailStats:E,type:this.d,resultCount:g.length,sortingTime:k};return[{type:"success",limitHit:l.limitHit||typeof s.maxResults=="number"&&g.length>s.maxResults,stats:A,messages:[]},y]})})}o(s,t,o,n){const d=(0,L.$Qr)(s.filePattern||""),l=(E,D)=>(0,L.$Pr)(E,D,d,!0,m,o),g=typeof s.maxResults=="number"?s.maxResults:S.$4L;return r.$Fb(t,l,g,1e4,n)}q(s,t,o){if(o&&o>0)for(let n=0;n<s.length;n+=o)t(s.slice(n,n+o));else t(s)}r(s,t,o,n){const d=b.$fe.create(!1),l=t.indexOf(T.sep)>=0;let g;for(const k in s.resultsToSearchCache)if(t.startsWith(k)){if(l&&k.indexOf(T.sep)<0&&k!=="")continue;const A=s.resultsToSearchCache[k];g={promise:this.t(A.promise),event:A.event,resolved:A.resolved};break}if(!g)return null;const E=d.elapsed(),D=b.$fe.create(!1),y=g.event(o);return n&&n.onCancellationRequested(()=>{y.dispose()}),g.promise.then(([k,A])=>{if(n&&n.isCancellationRequested)throw(0,C.$5)();const p=[],v=(0,L.$Qr)(t).normalizedLowercase;for(const F of A)(0,S.$iM)(F,v)&&p.push(F);return[k,p,{cacheWasResolved:g.resolved,cacheLookupTime:E,cacheFilterTime:D.elapsed(),cacheEntryCount:A.length}]})}s(s,t,o,n){return new Promise((d,l)=>{let g=[];n?.onCancellationRequested(()=>s.cancel()),s.search(E=>{E&&(o?(g.push(E),o>0&&g.length>=o&&(t(g),g=[])):t(E))},E=>{t(E)},(E,D)=>{g.length&&t(g),E?(t({message:"Search finished. Error: "+E.message}),l(E)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),d(D))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}t(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,o){return s.then(t,o)}catch(t){return this.then(void 0,t)}finally(t){return s.finally(t)}}}}e.$Xrc=w;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,T.$nc)(i.relativePath)}getItemDescription(i){return(0,T.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function $(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(f),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>c.URI.revive(s))}}function f(i){return{...i,folder:c.URI.revive(i.folder)}}}),define(ke[354],Ie([1,0,3,14,2,33,11,41,29,19,102,72,37,353,351,129,172]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zrc=void 0,R=qe(R);let $=class extends I.$Nqc{constructor(i,s,t,o,n){super(i,t,n),this.D=o,this.w=R,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Tc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new a.$Irc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new w.$Yrc(d,this.getNumThreadsCached))),s.remote.isRemote&&s.remote.authority&&this.F(),o.getConfigProvider().then(l=>{this.C||this.B.add(l.onDidChangeConfiguration(this.E))})}E(i){i.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const i=new a.$Irc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new w.$Yrc(i,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new P.$Xrc("fileSearchProvider",this.getNumThreadsCached)))}G(i,s){const t=this.d++;return this.y=s,this.x=t,this.c.$registerFileSearchProvider(t,this.s(i)),(0,r.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(i,s,t,o){const n=(0,I.$Oqc)(t);if(i===this.x){const d=Date.now();return this.H(i,s,n,o).then(l=>{const g=Date.now()-d;return this.q.debug(`Ext host file search time: ${g}ms`),l})}return super.$provideFileSearchResults(i,s,t,o)}async doInternalFileSearchWithCustomCallback(i,s,t){const o=d=>{if((0,u.$hM)(d)&&(d=[d]),Array.isArray(d)){t(d.map(l=>C.URI.file(l.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const n=await this.getNumThreadsCached();return this.y.doFileSearch(i,n,o,s)}async H(i,s,t,o){return this.doInternalFileSearchWithCustomCallback(t,o,n=>{this.c.$handleFileMatch(i,s,n)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,s){return new m.$Vrc(i,s,void 0,"textSearchProvider")}};e.$Zrc=$,e.$Zrc=$=Je([Ve(0,c.$hQ),Ve(1,b.$xQ),Ve(2,S.$zpc),Ve(3,T.$Fpc),Ve(4,L.$_j)],$)}),define(ke[130],Ie([1,0,367,67,66,368,21,13,4,3,16,10,32,86,68]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$vi=e.$ui=e.$ti=void 0,e.$wi=l,e.$xi=g,e.$zi=y,e.$Ai=k;const a=3e4;class m{traceSocketEvent(p,v){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,v)}constructor(p,v=""){this.f=!0,this.debugLabel=v,this.socket=p,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent(w.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,T.$Y)(N)}},this.socket.on("error",this.a);let F;this.b=N=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Close,{hadError:N}),this.f=!1,F&&clearTimeout(F)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,F=setTimeout(()=>p.destroy(),a)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const v=F=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Read,F),p(L.$Ne.wrap(F))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(p){const v=F=>{p({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:F,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(p){const v=()=>{p()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(w.SocketDiagnosticsEventType.Write,p),this.socket.write(p.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,T.$Y)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,T.$Y)(v)}}end(){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((p,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),p();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),p()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$ti=m;var $;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var f;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(f||(f={}));class i extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,v){this.socket.traceSocketEvent(p,v)}constructor(p,v,F,N){super(),this.f=this.B(new b.$le),this.g=this.B(new b.$le),this.h=!1,this.j={state:f.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:F?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new s(this,v,F,N,this.f,(O,j)=>this.m(O,j))),this.B(this.a.onError(O=>{console.error(O),(0,T.$Y)(O),this.g.fire({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:O})})),this.b=new w.$oi,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let v=0;for(;v<p.byteLength;)this.a.writeMessage(p.slice(v,Math.min(v+$.MaxWebSocketMessageLength,p.byteLength)),{compressed:!0,opcode:2}),v+=$.MaxWebSocketMessageLength}m(p,{compressed:v,opcode:F}){if(this.h)return;this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,p);let N=$.MinHeaderByteSize;p.byteLength<126?N+=0:p.byteLength<2**16?N+=2:N+=8;const O=L.$Ne.alloc(N),j=v?64:0,z=F&15;if(O.writeUInt8(128|j|z,0),p.byteLength<126)O.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){O.writeUInt8(126,1);let M=1;O.writeUInt8(p.byteLength>>>8&255,++M),O.writeUInt8(p.byteLength>>>0&255,++M)}else{O.writeUInt8(127,1);let M=1;O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(p.byteLength>>>24&255,++M),O.writeUInt8(p.byteLength>>>16&255,++M),O.writeUInt8(p.byteLength>>>8&255,++M),O.writeUInt8(p.byteLength>>>0&255,++M)}this.socket.write(L.$Ne.concat([O,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const v=this.b.peek(this.j.readLen),F=v.readUInt8(0),N=(F&128)>>>7,O=(F&64)>>>6,j=F&15,z=v.readUInt8(1),M=(z&128)>>>7,U=z&127;this.j.state=f.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(M?4:0)+(U===126?2:0)+(U===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const v=this.b.read(this.j.readLen),F=v.readUInt8(1),N=(F&128)>>>7;let O=F&127,j=1;O===126?O=v.readUInt8(++j)*2**8+v.readUInt8(++j):O===127&&(O=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let z=0;N&&(z=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=f.ReadBody,this.j.readLen=O,this.j.mask=z,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),n(v,this.j.mask),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=f.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$ui=i;class s extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Ne.alloc(0)}constructor(p,v,F,N,O,j){super(),this.n=p,this.r=O,this.s=j,this.a=this.B(new b.$le),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$le),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$le),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new t(this.n,N,F,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(p,v){this.g.push({data:p,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:v}=this.g.shift();if(this.f&&v.compressed){const F=await this.w(this.f,p);this.s(F,v)}else this.s(p,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,v){return new Promise((F,N)=>{p.write(v),p.flush(O=>F(O))})}acceptFrame(p,v,F){this.h.push({data:p,isCompressed:v,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const v=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,v,F){return new Promise((N,O)=>{p.write(v),F&&p.write(L.$Ne.fromByteArray([0,0,255,255])),p.flush(j=>N(j))})}}class t extends c.$Uc{get recordedInflateBytes(){return this.j?L.$Ne.concat(this.f):L.$Ne.alloc(0)}constructor(p,v,F,N){super(),this.h=p,this.j=v,this.a=this.B(new b.$le),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateError,{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateData,O),this.g.push(L.$Ne.wrap(O))}),F&&(this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialWrite,F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateWrite,p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=L.$Ne.concat(this.g);this.g.length=0,p(v)})}}class o extends c.$Uc{constructor(p,v){super(),this.g=p,this.a=this.B(new b.$le),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateData,F),this.f.push(L.$Ne.wrap(F))})}write(p){this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateWrite,p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=L.$Ne.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),p(v)})}}function n(A,p){if(p===0)return;const v=A.byteLength>>>2;for(let M=0;M<v;M++){const U=A.readUInt32BE(M*4);A.writeUInt32BE(U^p,M*4)}const F=v*4,N=A.byteLength-F,O=p>>>24&255,j=p>>>16&255,z=p>>>8&255;N>=1&&A.writeUInt8(A.readUInt8(F)^O,F),N>=2&&A.writeUInt8(A.readUInt8(F+1)^j,F+1),N>=3&&A.writeUInt8(A.readUInt8(F+2)^z,F+2)}e.$vi=process.env.XDG_RUNTIME_DIR;const d={[S.Platform.Linux]:107,[S.Platform.Mac]:103};function l(){const A=(0,u.$1g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const p=process.platform!=="darwin"&&e.$vi?e.$vi:(0,C.tmpdir)(),v=(0,I.$jc)(p,`vscode-ipc-${A}.sock`);return E(v),v}function g(A,p,v){const N=(0,r.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${v}-${p}-sock`;const O=v.substr(0,4),j=p.substr(0,6);let z;return process.platform!=="darwin"&&e.$vi&&!process.env.VSCODE_PORTABLE?z=(0,I.$jc)(e.$vi,`vscode-${N}-${O}-${j}.sock`):z=(0,I.$jc)(A,`${O}-${j}.sock`),E(z),z}function E(A){const p=d[S.$v];typeof p=="number"&&A.length>=p&&console.warn(`WARNING: IPC handle "${A}" is longer than ${p} chars, try a shorter --user-data-dir`)}class D extends P.$ii{static b(p){const v=b.Event.fromNodeEventEmitter(p,"connection");return b.Event.map(v,F=>({protocol:new w.$pi(new m(F,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(F,"close"))}))}constructor(p){super(D.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$yi=D;function y(A){return new Promise((p,v)=>{const F=(0,h.createServer)();F.on("error",v),F.listen(A,()=>{F.removeListener("error",v),p(new D(F))})})}function k(A,p){return new Promise((v,F)=>{const N=(0,h.createConnection)(A,()=>{N.removeListener("error",F),v(w.$qi.fromSocket(new m(N,`ipc-client${p}`),p))});N.once("error",F)})}}),define(ke[355],Ie([1,0,67,66,191,130,7,3,10,45,11,115,234,236,117,92,21]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=e.$Hhc=e.$Ghc=void 0,r=qe(r),h=qe(h);async function $(o,n,d,l,g){let E;for(let D=3;D&&(E?.dispose(),E=await new f(o,n,d,l,g).waitForReady(),!(g&&C.$4g[g]||!C.$4g[E.tunnelLocalPort]));D--);return E}class f extends T.$Uc{constructor(n,d,l,g,E){super(),this.m=d,this.n=E,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=r.createServer(),this.c=new L.$Dh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=g,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,d=(0,a.$Lw)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,C.$5g)(n,2,1e3,d),g=null;return this.b.listen(l,this.m),await this.c.wait(),g=this.b.address(),g||(l=0,this.b.listen(l,this.m),await this.c.wait(),g=this.b.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async r(n){n.pause();const d=(0,a.$Jw)(this.tunnelRemoteHost)||(0,a.$Lw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,u.$2l)(this.a,d,this.tunnelRemotePort),g=l.getSocket(),E=l.readEntireBuffer();l.dispose(),E.byteLength>0&&n.write(E.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),g.end()}),n.on("close",()=>g.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),g instanceof R.$ti?g.socket.destroy():g.end()}),g instanceof R.$ti?this.t(n,g):this.s(n,g),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),g.end()})}s(n,d){d.onClose(()=>n.destroy()),d.onEnd(()=>n.end()),d.onData(l=>n.write(l.buffer)),n.on("data",l=>d.write(m.$Ne.wrap(l))),n.resume()}t(n,d){const l=d.socket;l.on("end",()=>n.end()),l.on("close",()=>n.end()),l.on("error",()=>{n.destroy()}),l.pipe(n),n.pipe(l)}}e.$Ghc=f;let i=class extends a.$Ow{constructor(n,d,l,g,E){super(d,E),this.H=n,this.I=l,this.J=g}isPortPrivileged(n){return(0,a.$Mw)(n,this.t,b.OS,h.release())}F(n,d,l,g,E,D,y,k){const A=this.D(d,l);if(A)return++A.refcount,A.value;if((0,a.$Fw)(n))return this.G(n,d,l,E,D,y,k);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${E}.`);const p={commit:this.J.commit,quality:this.J.quality,addressProvider:n,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=$(p,g,d,l,E);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,l,v),v}}};e.$Hhc=i,e.$Hhc=i=Je([Ve(0,P.$Vl),Ve(1,I.$_j),Ve(2,w.$Yl),Ve(3,S.$sk),Ve(4,c.$$i)],i);let s=class extends i{constructor(n,d,l,g,E){super(n,d,l,g,E)}};e.$Ihc=s,e.$Ihc=s=Je([Ve(0,P.$Vl),Ve(1,I.$_j),Ve(2,w.$Yl),Ve(3,S.$sk),Ve(4,c.$$i)],s);let t=class extends T.$Uc{constructor(n,d,l,g,E){super(),this.b=n,this.c=d,this.f=l,this.g=g,this.h=E,this.a=new Map}async openTunnel(n,d,l,g,E,D,y,k,A){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${g} on local port ${D}.`),!this.a.has(n)){const p=new s(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(n,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(d,l,g,E,D,y,k,A)}};e.$Jhc=t,e.$Jhc=t=Je([Ve(0,P.$Vl),Ve(1,I.$_j),Ve(2,S.$sk),Ve(3,w.$Yl),Ve(4,c.$$i)],t)}),define(ke[356],Ie([1,0,130,253,44,34,2,11,46]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=e.$IQ=void 0,h=qe(h),C=qe(C);class c{constructor(u,P,w){this.b=u,this.c=P,this.f=w,this.a=h.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(P.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,P){const w=(m,$)=>{P.writeHead(m,{"content-type":"application/json"}),P.end(JSON.stringify($||null),f=>f&&this.c.error(f))},a=[];u.setEncoding("utf8"),u.on("data",m=>a.push(m)),u.on("end",async()=>{try{const m=JSON.parse(a.join(""));let $;switch(m.type){case"open":$=await this.i(m);break;case"openExternal":$=await this.j(m);break;case"status":$=await this.l(m);break;case"extensionManagement":$=await this.k(m);break;default:w(404,`Unknown message type: ${m.type}`);break}w(200,$)}catch(m){const $=m instanceof Error?m.message:JSON.stringify(m);w(500,$),this.c.error("Error while processing pipe request",m)}})}async i(u){const{fileURIs:P,folderURIs:w,forceNewWindow:a,diffMode:m,mergeMode:$,addMode:f,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:t,remoteAuthority:o}=u,n=[];if(Array.isArray(w))for(const E of w)try{n.push({folderUri:L.URI.parse(E)})}catch{}if(Array.isArray(P))for(const E of P)try{(0,b.$0i)(E)?n.push({workspaceUri:L.URI.parse(E)}):n.push({fileUri:L.URI.parse(E)})}catch{}const d=t?L.URI.file(t):void 0,g={forceNewWindow:a,diffMode:m,mergeMode:$,addMode:f,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!d&&!f,waitMarkerFileURI:d,remoteAuthority:o};this.b.executeCommand("_remoteCLI.windowOpen",n,g)}async j(u){for(const P of u.uris){const w=L.URI.parse(P),a=w.scheme==="file"?w:P;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(u){const P=a=>a?.map(m=>/\.vsix$/i.test(m)?L.URI.parse(m):m),w={list:u.list,install:P(u.install),uninstall:P(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&C.existsSync(this.f)&&C.unlinkSync(this.f)}}e.$IQ=c;let I=class extends c{constructor(u,P){super(u,P,(0,r.$wi)())}};e.$JQ=I,e.$JQ=I=Je([Ve(0,R.$DQ),Ve(1,T.$_j)],I)}),define(ke[357],Ie([1,0,61,344,339,252,54,326,2,14,9,356,108,286,325]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5rc=void 0,r=qe(r);class a extends C.$trc{j(){const f=this,i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(d,l,g){return d=o(d),f.a.has(d)?f.a.get(d).load(d,b.URI.file((0,u.$nr)(l.filename)),E=>s.apply(this,[E,l,g])):s.apply(this,arguments)};const t=i._resolveLookupPaths;i._resolveLookupPaths=(n,d)=>t.call(this,o(n),d);const o=n=>{for(const d of f.b){const l=d(n);if(l){n=l;break}}return n}}}class m extends L.$fqc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$3rc);const f=this.h.invokeFunction(h.$prc);if(this.h.createInstance(T.$2rc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(S.$JQ);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(w.$4rc),await this.h.createInstance(a,f,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,R.$1rc)(this.j,s,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(f){return f.main}async xb(f,i,s){if(i.scheme!==c.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let t=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const o=f?.identifier.value;f&&await this.w.initializeLocalizedMessages(f);try{o&&r.mark(`code/extHost/willLoadExtensionCode/${o}`),t=$e.__$__nodeRequire(i.fsPath)}finally{o&&r.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}return t}async $setRemoteEnvironment(f){if(this.f.remote.isRemote)for(const i in f){const s=f[i];s===null?delete process.env[i]:process.env[i]=s}}}e.$5rc=m}),define(ke[358],Ie([1,0,44,56,21,4,3,133,10,22,2,33,68,11,233,71,117,92,355,29,19,76,333]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$asc=void 0,e.$6rc=n,e.$7rc=d,e.$8rc=l,e.$9rc=g,e.$0rc=D,e.$$rc=y,e.$_rc=k,r=qe(r),c=qe(c),S=qe(S);function n(v){const F=v.trim().split(`
`),N=[];return F.forEach(j=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);z&&z.length>=3&&N.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),N.reduce((j,z)=>(j[z.socket]=z,j),{})}function d(...v){const F=[].concat(...v.map(g));return[...new Map(F.filter(N=>N.st==="0A").map(N=>{const O=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:l(O[0]),port:parseInt(O[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function l(v){let F="";if(v.length===8)for(let N=v.length-2;N>=0;N-=2)F+=parseInt(v.substr(N,2),16),N!==0&&(F+=".");else for(let N=0;N<v.length;N+=8){const O=v.substring(N,N+8);let j="";for(let z=8;z>=2;z-=2)j+=O.substring(z-2,z),(z===6||z===2)&&(j=parseInt(j,16).toString(16),F+=`${j}`,j="",N+z!==v.length-6&&(F+=":"))}return F}function g(v){const F=v.trim().split(`
`),N=F.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return F.map(j=>j.trim().split(/\s+/).reduce((z,M,U)=>(z[N[U]||U]=M,z),{}))}function E(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function D(v){const F=v.trim().split(`
`),N=[];return F.forEach(O=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);j&&j.length>=4&&N.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),N}async function y(v,F,N){const O=N.reduce((z,M)=>(z[M.pid]=M,z),{}),j=[];return v.forEach(({socket:z,ip:M,port:U})=>{const V=F[z]?F[z].pid:void 0,ie=V?O[V]?.cmd:void 0;V&&ie&&!E(ie)&&j.push({host:M,port:U,detail:ie,pid:V})}),j}function k(v,F,N){const O=new Map,j=D(F);for(const z of v){const M=N.get(z.port);if(M){O.set(z.port,M);continue}const U=j.find(V=>V.cmd.includes(`${z.port}`));if(U){let V=U,ie;do ie=j.find(B=>B.ppid===V.pid),ie&&(V=ie);while(ie);O.set(z.port,{host:z.ip,port:z.port,pid:V.pid,detail:V.cmd,ppid:V.ppid})}else O.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return O}let A=class extends t.$fGb{constructor(F,N,O,j){super(F,N,O),this.D=N,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,b.$l&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(F){if(F&&this.C)return;this.C=F;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new T.$Nm;let j=0;for(;this.C;){const z=new Date().getTime(),M=(await this.I()).filter(ie=>(0,$.$Jw)(ie.host)||(0,$.$Lw)(ie.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(ie=>ie.port).join(", ")}`);const U=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${U} ms.`),j++>3&&O.update(U),(!N||JSON.stringify(N)!==JSON.stringify(M))&&(N=M,await this.a.$onFoundNewCandidates(N));const V=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${V} ms.`),await new Promise(ie=>setTimeout(()=>ie(),V))}}G(F){return Math.max(F*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(F=>F.port).join(", ")}`)}async I(){let F="",N="";try{F=await r.promises.readFile("/proc/net/tcp","utf8"),N=await r.promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=d(F,N),j=await new Promise(J=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(_,le,re)=>{J(le)})}),z=n(j),M=await S.Promises.readdir("/proc"),U=[];for(const J of M)try{const _=Number(J),le=c.$fh(I.URI.file("/proc"),J);if((await r.promises.stat(le.fsPath)).isDirectory()&&!isNaN(_)){const Se=await r.promises.readlink(c.$fh(le,"cwd").fsPath),me=await r.promises.readFile(c.$fh(le,"cmdline").fsPath,"utf8");U.push({pid:_,cwd:Se,cmd:me})}}catch{}const V=[],ie=O.filter(J=>{const _=z[J.socket];return _||V.push(J),_}),B=y(ie,z,U);let Y;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${V.length}`),V.length>0){const J=await new Promise(_=>{(0,h.exec)("ps -F -A -l | grep root",(le,re,Se)=>{_(re)})});this.z=k(V,J,this.z),Y=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Y.map(_=>_.port).join(", ")}`)}return B.then(J=>Y?J.concat(Y):J)}w(F){return async N=>{const O=new f.$Ghc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,M,U,V){const ie=await F.makeConnection();return p.connect(ie,M,U,V)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new a.$Rl(0),connectionToken:F.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await O.waitForReady();const j=new R.$le;return{localAddress:(0,o.$8M)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{O.dispose(),j.fire(),j.dispose()}}}}};e.$asc=A,e.$asc=A=Je([Ve(0,s.$hQ),Ve(1,i.$xQ),Ve(2,P.$_j),Ve(3,m.$Yl)],A);class p extends w.$Axb{static connect(F,N,O,j){const z=new L.$Tc,M={onClose:z.add(new R.$le),onData:z.add(new R.$le),onEnd:z.add(new R.$le)};z.add(F.onDidReceiveMessage(V=>M.onData.fire(C.$Ne.wrap(V)))),z.add(F.onDidEnd(()=>M.onEnd.fire())),z.add(F.onDidClose(V=>M.onClose.fire({type:u.SocketCloseEventType.NodeSocketCloseEvent,error:V,hadError:!!V})));const U=new p(F,j,M);return U.B(z),(0,w.$zxb)(U,N,O,j,M)}constructor(F,N,O){super(N,O),this.n=F}write(F){this.n.send(F.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[359],Ie([1,0,88,328,342,341,354,357,358,101,54,102,100,47,76,97,327,287,11,343,64,248,112,117,148]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Qs)(I.$gqc,T.$5rc,r.InstantiationType.Eager),(0,r.$Qs)(f.$ak,$.$csc,r.InstantiationType.Delayed),(0,r.$Qs)(f.$_j,new o.$Bi(t.$src,[!1],!0)),(0,r.$Qs)(n.$Yl,d.$Lhc,r.InstantiationType.Delayed),(0,r.$Qs)(a.$Ipc,m.$bsc,r.InstantiationType.Eager),(0,r.$Qs)(c.$qqc,R.$Frc,r.InstantiationType.Eager),(0,r.$Qs)(S.$Mqc,L.$Zrc,r.InstantiationType.Eager),(0,r.$Qs)(u.$drc,C.$xrc,r.InstantiationType.Eager),(0,r.$Qs)(P.$4pc,h.$wrc,r.InstantiationType.Eager),(0,r.$Qs)(w.$eGb,b.$asc,r.InstantiationType.Eager),(0,r.$Qs)(s.$jqc,i.$dsc,r.InstantiationType.Eager)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[369],Ie([1,0,370,67,7,21,13,61,108,33,68,130,113,231,340,254,269,93,345,359]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ut(r),h=qe(h),T=qe(T),P=Ut(P),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const f=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const E=globalThis._VSCODE_NODE_MODULES.module,D=E._load;E._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const i=process.exit.bind(process),s=process.on.bind(process);function t(E){process.exit=function(D){if(E)i(D);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,y){D==="uncaughtException"&&(y=function(){try{return y.call(void 0,arguments)}catch{}}),s(D,y)}}let o=function(E){i()};function n(){const E=(0,m.$fn)(process.env);if(E.type===m.ExtHostConnectionType.MessagePort)return new Promise((D,y)=>{const k=A=>{const p=A[0],v=new I.$ri;p.on("message",F=>v.fire(R.$Ne.wrap(F.data))),p.on("close",()=>{o("renderer closed the MessagePort")}),p.start(),D({onMessage:v.event,send:F=>p.postMessage(F.buffer)})};process.parentPort.on("message",A=>k(A.ports))});if(E.type===m.ExtHostConnectionType.Socket)return new Promise((D,y)=>{let k=null;const A=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=I.ProtocolConstants.ReconnectionGraceTime,v=I.ProtocolConstants.ReconnectionShortGraceTime,F=new C.$Rh(()=>o("renderer disconnected for too long (1)"),p),N=new C.$Rh(()=>o("renderer disconnected for too long (2)"),v);process.on("message",(j,z)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const M=R.$Ne.wrap(Buffer.from(j.initialDataChunk,"base64"));let U;if(j.skipWebSocketFrames)U=new S.$ti(z,"extHost-socket");else{const V=R.$Ne.wrap(Buffer.from(j.inflateBytes,"base64"));U=new S.$ui(new S.$ti(z,"extHost-socket"),j.permessageDeflate,V,!1)}k?(F.cancel(),N.cancel(),k.beginAcceptReconnection(U,M),k.endAcceptReconnection(),k.sendResume()):(clearTimeout(A),k=new I.$si({socket:U,initialChunk:M}),k.sendResume(),k.onDidDispose(()=>o("renderer disconnected")),D(k),k.onSocketClose(()=>{F.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;F.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const D=E.pipeName;return new Promise((y,k)=>{const A=h.createConnection(D,()=>{A.removeListener("error",k);const p=new I.$si({socket:new S.$ti(A,"extHost-renderer")});p.sendResume(),y(p)});A.once("error",k),A.on("close",()=>{o("renderer closed the socket")})})}}async function d(){const E=await n();return new class{constructor(){this.a=new I.$ri,this.onMessage=this.a.event,this.b=!1,this.d=E.onMessage(D=>{(0,$.$Bn)(D,$.MessageType.Terminate)?(this.b=!0,this.d.dispose(),o("received terminate message from renderer")):this.a.fire(D)})}send(D){this.b||E.send(D)}async drain(){if(E.drain)return E.drain()}}}function l(E){return new Promise(D=>{const y=E.onMessage(k=>{y.dispose();const A=JSON.parse(k.toString()),p=A.commit,v=P.default.commit;if(p&&v&&p!==v&&i($.ExtensionHostExitCode.VersionMismatch),A.parentPid){let F=0;setInterval(function(){try{process.kill(A.parentPid,0),F=0}catch(O){O&&O.code==="EPERM"?(F++,F>=3&&o(`parent process ${A.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):o(`parent process ${A.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(A.parentPid)}catch(O){(0,L.$Y)(O)}}E.send((0,$.$An)($.MessageType.Initialized)),D({protocol:E,initData:A})});E.send((0,$.$An)($.MessageType.Ready))})}async function g(){const E=[];process.on("unhandledRejection",(F,N)=>{E.push(N),setTimeout(()=>{const O=E.indexOf(N);O>=0&&N.catch(j=>{E.splice(O,1),(0,L.$3)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),F&&(0,L.$Y)(F))})},1e3)}),process.on("rejectionHandled",F=>{const N=E.indexOf(F);N>=0&&E.splice(N,1)}),process.on("uncaughtException",function(F){(0,L.$X)(F)||(0,L.$Y)(F)}),T.mark("code/extHost/willConnectToRenderer");const D=await d();T.mark("code/extHost/didConnectToRenderer");const y=await l(D);T.mark("code/extHost/didWaitForInitData");const{initData:k}=y;t(!!k.environment.extensionTestsLocationURI),k.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,k.environment.skipWorkspaceStorageLock=(0,u.boolean)(f.skipWorkspaceStorageLock,!1);const A=new class{constructor(){this.pid=process.pid}exit(N){i(N)}fsExists(N){return c.Promises.exists(N)}fsRealpath(N){return(0,b.$mr)(N)}};let p=null;k.remote.authority&&f.transformURIs&&(p=(0,a.$Us)(k.remote.authority));const v=new w.$vrc(y.protocol,k,A,p);o=F=>v.terminate(F)}g().catch(E=>console.log(E))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/97d1b933ada0ca69bea107f7a89e029991277ccc/core/vs/workbench/api/node/extensionHostProcess.js.map
