/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Oe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ne=function(be){for(var e=[],v=0,R=be.length;v<R;v++)e[v]=Oe[be[v]];return e};define(Oe[71],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=R,e.$0h=P,e.$$h=O;function v(T){return(A,$,s)=>{let k=null,y=null;if(typeof s.value=="function"?(k="value",y=s.value):typeof s.get=="function"&&(k="get",y=s.get),!y)throw new Error("not supported");s[k]=T(y,$)}}function R(T,A,$){let s=null,k=null;if(typeof $.value=="function"?(s="value",k=$.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(s="get",k=$.get),!k)throw new Error("not supported");const y=`$memoize$${A}`;$[s]=function(...a){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,a)}),this[y]}}function P(T,A,$){return v((s,k)=>{const y=`$debounce$${k}`,a=`$debounce$result$${k}`;return function(...S){this[a]||(this[a]=$?$():void 0),clearTimeout(this[y]),A&&(this[a]=A(this[a],...S),S=[this[a]]),this[y]=setTimeout(()=>{s.apply(this,S),this[a]=$?$():void 0},T)}})}function O(T,A,$){return v((s,k)=>{const y=`$throttle$timer$${k}`,a=`$throttle$result$${k}`,S=`$throttle$lastRun$${k}`,d=`$throttle$pending$${k}`;return function(...r){if(this[a]||(this[a]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),A&&(this[a]=A(this[a],...r)),this[d])return;const o=this[S]+T;o<=Date.now()?(this[S]=Date.now(),s.apply(this,[this[a]]),this[a]=$?$():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),s.apply(this,[this[a]]),this[a]=$?$():void 0},o-Date.now()))}})}});var Qn=this&&this.__createBinding||(Object.create?function(be,e,v,R){R===void 0&&(R=v);var P=Object.getOwnPropertyDescriptor(e,v);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(be,R,P)}:function(be,e,v,R){R===void 0&&(R=v),be[R]=e[v]}),Kn=this&&this.__setModuleDefault||(Object.create?function(be,e){Object.defineProperty(be,"default",{enumerable:!0,value:e})}:function(be,e){be.default=e}),We=this&&this.__importStar||function(be){if(be&&be.__esModule)return be;var e={};if(be!=null)for(var v in be)v!=="default"&&Object.prototype.hasOwnProperty.call(be,v)&&Qn(e,be,v);return Kn(e,be),e};define(Oe[135],Ne([1,0,17]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=P,e.$8c=O,e.$9c=T,e.$0c=A,e.$$c=$,e.$_c=s,v=We(v);const R=(S,d)=>S===d;e.$6c=R;function P(S=e.$6c){return(d,r)=>v.$tb(d,r,S)}function O(){return(S,d)=>JSON.stringify(S)===JSON.stringify(d)}function T(){return(S,d)=>S.equals(d)}function A(S,d,r){if(r!==void 0){const o=S;return o==null||d===void 0||d===null?d===o:r(o,d)}else{const o=S;return(c,l)=>c==null||l===void 0||l===null?l===c:o(c,l)}}function $(S,d){if(S===d)return!0;if(Array.isArray(S)&&Array.isArray(d)){if(S.length!==d.length)return!1;for(let r=0;r<S.length;r++)if(!$(S[r],d[r]))return!1;return!0}if(S&&typeof S=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=S,o=d,c=Object.keys(r),l=Object.keys(o),i=new Set(l);if(c.length!==l.length)return!1;for(const n of c)if(!i.has(n)||!$(r[n],o[n]))return!1;return!0}return!1}function s(S){return JSON.stringify(a(S))}let k=0;const y=new WeakMap;function a(S){if(Array.isArray(S))return S.map(a);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const d=S,r=Object.create(null);for(const o of Object.keys(d).sort())r[o]=a(d[o]);return r}else{let d=y.get(S);return d===void 0&&(d=k++,y.set(S,d)),d+"----2b76a038c20c4bcc"}return S}}),define(Oe[96],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$mQ=void 0;class v{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$mQ=v,e.$nQ=new v("id#")}),define(Oe[136],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=T,e.$Wn=y,e.$Xn=a,e.$Yn=S,e.$Zn=d,e.$1n=r,e.$2n=o,e.$3n=c,e.$4n=l,e.$5n=i,e.$6n=n;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function T(t,g=!1){let u=0;const m=t.length;let p="",h=0,E=R.Unknown,D=v.None;function w(F){let W=0,K=0;for(;W<F;){const L=t.charCodeAt(u);if(L>=k._0&&L<=k._9)K=K*16+L-k._0;else if(L>=k.A&&L<=k.F)K=K*16+L-k.A+10;else if(L>=k.a&&L<=k.f)K=K*16+L-k.a+10;else break;u++,W++}return W<F&&(K=-1),K}function I(F){u=F,p="",h=0,E=R.Unknown,D=v.None}function C(){const F=u;if(t.charCodeAt(u)===k._0)u++;else for(u++;u<t.length&&s(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===k.dot)if(u++,u<t.length&&s(t.charCodeAt(u)))for(u++;u<t.length&&s(t.charCodeAt(u));)u++;else return D=v.UnexpectedEndOfNumber,t.substring(F,u);let W=u;if(u<t.length&&(t.charCodeAt(u)===k.E||t.charCodeAt(u)===k.e))if(u++,(u<t.length&&t.charCodeAt(u)===k.plus||t.charCodeAt(u)===k.minus)&&u++,u<t.length&&s(t.charCodeAt(u))){for(u++;u<t.length&&s(t.charCodeAt(u));)u++;W=u}else D=v.UnexpectedEndOfNumber;return t.substring(F,W)}function f(){let F="",W=u;for(;;){if(u>=m){F+=t.substring(W,u),D=v.UnexpectedEndOfString;break}const K=t.charCodeAt(u);if(K===k.doubleQuote){F+=t.substring(W,u),u++;break}if(K===k.backslash){if(F+=t.substring(W,u),u++,u>=m){D=v.UnexpectedEndOfString;break}switch(t.charCodeAt(u++)){case k.doubleQuote:F+='"';break;case k.backslash:F+="\\";break;case k.slash:F+="/";break;case k.b:F+="\b";break;case k.f:F+="\f";break;case k.n:F+=`
`;break;case k.r:F+="\r";break;case k.t:F+="	";break;case k.u:{const Q=w(4);Q>=0?F+=String.fromCharCode(Q):D=v.InvalidUnicode;break}default:D=v.InvalidEscapeCharacter}W=u;continue}if(K>=0&&K<=31)if($(K)){F+=t.substring(W,u),D=v.UnexpectedEndOfString;break}else D=v.InvalidCharacter;u++}return F}function b(){if(p="",D=v.None,h=u,u>=m)return h=m,E=R.EOF;let F=t.charCodeAt(u);if(A(F)){do u++,p+=String.fromCharCode(F),F=t.charCodeAt(u);while(A(F));return E=R.Trivia}if($(F))return u++,p+=String.fromCharCode(F),F===k.carriageReturn&&t.charCodeAt(u)===k.lineFeed&&(u++,p+=`
`),E=R.LineBreakTrivia;switch(F){case k.openBrace:return u++,E=R.OpenBraceToken;case k.closeBrace:return u++,E=R.CloseBraceToken;case k.openBracket:return u++,E=R.OpenBracketToken;case k.closeBracket:return u++,E=R.CloseBracketToken;case k.colon:return u++,E=R.ColonToken;case k.comma:return u++,E=R.CommaToken;case k.doubleQuote:return u++,p=f(),E=R.StringLiteral;case k.slash:{const W=u-1;if(t.charCodeAt(u+1)===k.slash){for(u+=2;u<m&&!$(t.charCodeAt(u));)u++;return p=t.substring(W,u),E=R.LineCommentTrivia}if(t.charCodeAt(u+1)===k.asterisk){u+=2;const K=m-1;let L=!1;for(;u<K;){if(t.charCodeAt(u)===k.asterisk&&t.charCodeAt(u+1)===k.slash){u+=2,L=!0;break}u++}return L||(u++,D=v.UnexpectedEndOfComment),p=t.substring(W,u),E=R.BlockCommentTrivia}return p+=String.fromCharCode(F),u++,E=R.Unknown}case k.minus:if(p+=String.fromCharCode(F),u++,u===m||!s(t.charCodeAt(u)))return E=R.Unknown;case k._0:case k._1:case k._2:case k._3:case k._4:case k._5:case k._6:case k._7:case k._8:case k._9:return p+=C(),E=R.NumericLiteral;default:for(;u<m&&M(F);)u++,F=t.charCodeAt(u);if(h!==u){switch(p=t.substring(h,u),p){case"true":return E=R.TrueKeyword;case"false":return E=R.FalseKeyword;case"null":return E=R.NullKeyword}return E=R.Unknown}return p+=String.fromCharCode(F),u++,E=R.Unknown}}function M(F){if(A(F)||$(F))return!1;switch(F){case k.closeBrace:case k.closeBracket:case k.openBrace:case k.openBracket:case k.doubleQuote:case k.colon:case k.comma:case k.slash:return!1}return!0}function N(){let F;do F=b();while(F>=R.LineCommentTrivia&&F<=R.Trivia);return F}return{setPosition:I,getPosition:()=>u,scan:g?N:b,getToken:()=>E,getTokenValue:()=>p,getTokenOffset:()=>h,getTokenLength:()=>u-h,getTokenError:()=>D}}function A(t){return t===k.space||t===k.tab||t===k.verticalTab||t===k.formFeed||t===k.nonBreakingSpace||t===k.ogham||t>=k.enQuad&&t<=k.zeroWidthSpace||t===k.narrowNoBreakSpace||t===k.mathematicalSpace||t===k.ideographicSpace||t===k.byteOrderMark}function $(t){return t===k.lineFeed||t===k.carriageReturn||t===k.lineSeparator||t===k.paragraphSeparator}function s(t){return t>=k._0&&t<=k._9}var k;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(k||(k={}));function y(t,g){const u=[],m=new Object;let p;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(w,I,C,f){h.value=w,h.offset=I,h.length=C,h.type=f,h.colonOffset=void 0,p=h}try{i(t,{onObjectBegin:(w,I)=>{if(g<=w)throw m;p=void 0,E=g>w,u.push("")},onObjectProperty:(w,I,C)=>{if(g<I||(D(w,I,C,"property"),u[u.length-1]=w,g<=I+C))throw m},onObjectEnd:(w,I)=>{if(g<=w)throw m;p=void 0,u.pop()},onArrayBegin:(w,I)=>{if(g<=w)throw m;p=void 0,u.push(0)},onArrayEnd:(w,I)=>{if(g<=w)throw m;p=void 0,u.pop()},onLiteralValue:(w,I,C)=>{if(g<I||(D(w,I,C,n(w)),g<=I+C))throw m},onSeparator:(w,I,C)=>{if(g<=I)throw m;if(w===":"&&p&&p.type==="property")p.colonOffset=I,E=!1,p=void 0;else if(w===","){const f=u[u.length-1];typeof f=="number"?u[u.length-1]=f+1:(E=!0,u[u.length-1]=""),p=void 0}}})}catch(w){if(w!==m)throw w}return{path:u,previousNode:p,isAtPropertyKey:E,matches:w=>{let I=0;for(let C=0;I<w.length&&C<u.length;C++)if(w[I]===u[C]||w[I]==="*")I++;else if(w[I]!=="**")return!1;return I===w.length}}}function a(t,g=[],u=O.DEFAULT){let m=null,p=[];const h=[];function E(w){Array.isArray(p)?p.push(w):m!==null&&(p[m]=w)}return i(t,{onObjectBegin:()=>{const w={};E(w),h.push(p),p=w,m=null},onObjectProperty:w=>{m=w},onObjectEnd:()=>{p=h.pop()},onArrayBegin:()=>{const w=[];E(w),h.push(p),p=w,m=null},onArrayEnd:()=>{p=h.pop()},onLiteralValue:E,onError:(w,I,C)=>{g.push({error:w,offset:I,length:C})}},u),p[0]}function S(t,g=[],u=O.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(w){m.type==="property"&&(m.length=w-m.offset,m=m.parent)}function h(w){return m.children.push(w),w}i(t,{onObjectBegin:w=>{m=h({type:"object",offset:w,length:-1,parent:m,children:[]})},onObjectProperty:(w,I,C)=>{m=h({type:"property",offset:I,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:w,offset:I,length:C,parent:m})},onObjectEnd:(w,I)=>{m.length=w+I-m.offset,m=m.parent,p(w+I)},onArrayBegin:(w,I)=>{m=h({type:"array",offset:w,length:-1,parent:m,children:[]})},onArrayEnd:(w,I)=>{m.length=w+I-m.offset,m=m.parent,p(w+I)},onLiteralValue:(w,I,C)=>{h({type:n(w),offset:I,length:C,parent:m,value:w}),p(I+C)},onSeparator:(w,I,C)=>{m.type==="property"&&(w===":"?m.colonOffset=I:w===","&&p(I))},onError:(w,I,C)=>{g.push({error:w,offset:I,length:C})}},u);const D=m.children[0];return D&&delete D.parent,D}function d(t,g){if(!t)return;let u=t;for(const m of g)if(typeof m=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let p=!1;for(const h of u.children)if(Array.isArray(h.children)&&h.children[0].value===m){u=h.children[1],p=!0;break}if(!p)return}else{const p=m;if(u.type!=="array"||p<0||!Array.isArray(u.children)||p>=u.children.length)return;u=u.children[p]}return u}function r(t){if(!t.parent||!t.parent.children)return[];const g=r(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;g.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&g.push(u)}return g}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const g=Object.create(null);for(const u of t.children){const m=u.children[1];m&&(g[u.children[0].value]=o(m))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,g,u=!1){return g>=t.offset&&g<t.offset+t.length||u&&g===t.offset+t.length}function l(t,g,u=!1){if(c(t,g,u)){const m=t.children;if(Array.isArray(m))for(let p=0;p<m.length&&m[p].offset<=g;p++){const h=l(m[p],g,u);if(h)return h}return t}}function i(t,g,u=O.DEFAULT){const m=T(t,!1);function p(ce){return ce?()=>ce(m.getTokenOffset(),m.getTokenLength()):()=>!0}function h(ce){return ce?we=>ce(we,m.getTokenOffset(),m.getTokenLength()):()=>!0}const E=p(g.onObjectBegin),D=h(g.onObjectProperty),w=p(g.onObjectEnd),I=p(g.onArrayBegin),C=p(g.onArrayEnd),f=h(g.onLiteralValue),b=h(g.onSeparator),M=p(g.onComment),N=h(g.onError),F=u&&u.disallowComments,W=u&&u.allowTrailingComma;function K(){for(;;){const ce=m.scan();switch(m.getTokenError()){case v.InvalidUnicode:L(P.InvalidUnicode);break;case v.InvalidEscapeCharacter:L(P.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:L(P.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:F||L(P.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:L(P.UnexpectedEndOfString);break;case v.InvalidCharacter:L(P.InvalidCharacter);break}switch(ce){case R.LineCommentTrivia:case R.BlockCommentTrivia:F?L(P.InvalidCommentToken):M();break;case R.Unknown:L(P.InvalidSymbol);break;case R.Trivia:case R.LineBreakTrivia:break;default:return ce}}}function L(ce,we=[],ae=[]){if(N(ce),we.length+ae.length>0){let Ie=m.getToken();for(;Ie!==R.EOF;){if(we.indexOf(Ie)!==-1){K();break}else if(ae.indexOf(Ie)!==-1)break;Ie=K()}}}function Q(ce){const we=m.getTokenValue();return ce?f(we):D(we),K(),!0}function X(){switch(m.getToken()){case R.NumericLiteral:{let ce=0;try{ce=JSON.parse(m.getTokenValue()),typeof ce!="number"&&(L(P.InvalidNumberFormat),ce=0)}catch{L(P.InvalidNumberFormat)}f(ce);break}case R.NullKeyword:f(null);break;case R.TrueKeyword:f(!0);break;case R.FalseKeyword:f(!1);break;default:return!1}return K(),!0}function ue(){return m.getToken()!==R.StringLiteral?(L(P.PropertyNameExpected,[],[R.CloseBraceToken,R.CommaToken]),!1):(Q(!1),m.getToken()===R.ColonToken?(b(":"),K(),oe()||L(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken])):L(P.ColonExpected,[],[R.CloseBraceToken,R.CommaToken]),!0)}function ee(){E(),K();let ce=!1;for(;m.getToken()!==R.CloseBraceToken&&m.getToken()!==R.EOF;){if(m.getToken()===R.CommaToken){if(ce||L(P.ValueExpected,[],[]),b(","),K(),m.getToken()===R.CloseBraceToken&&W)break}else ce&&L(P.CommaExpected,[],[]);ue()||L(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken]),ce=!0}return w(),m.getToken()!==R.CloseBraceToken?L(P.CloseBraceExpected,[R.CloseBraceToken],[]):K(),!0}function me(){I(),K();let ce=!1;for(;m.getToken()!==R.CloseBracketToken&&m.getToken()!==R.EOF;){if(m.getToken()===R.CommaToken){if(ce||L(P.ValueExpected,[],[]),b(","),K(),m.getToken()===R.CloseBracketToken&&W)break}else ce&&L(P.CommaExpected,[],[]);oe()||L(P.ValueExpected,[],[R.CloseBracketToken,R.CommaToken]),ce=!0}return C(),m.getToken()!==R.CloseBracketToken?L(P.CloseBracketExpected,[R.CloseBracketToken],[]):K(),!0}function oe(){switch(m.getToken()){case R.OpenBracketToken:return me();case R.OpenBraceToken:return ee();case R.StringLiteral:return Q(!0);default:return X()}}return K(),m.getToken()===R.EOF?u.allowEmptyContent?!0:(L(P.ValueExpected,[],[]),!1):oe()?(m.getToken()!==R.EOF&&L(P.EndOfFileExpected,[],[]),!0):(L(P.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Oe[137],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=v;function v(O){let T=!1;const A=new Map,$=new Map;if(P(O,r=>{if(O===r)return!0;const o=JSON.stringify(r);if(o.length<30)return!0;const c=A.get(o);if(!c){const l={schemas:[r]};return A.set(o,l),$.set(r,l),!0}return c.schemas.push(r),$.set(r,c),T=!0,!1}),A.clear(),!T)return JSON.stringify(O);let k="$defs";for(;O.hasOwnProperty(k);)k+="_";const y=[];function a(r){return JSON.stringify(r,(o,c)=>{if(c!==r){const l=$.get(c);if(l&&l.schemas.length>1)return l.id||(l.id=`_${y.length}`,y.push(l.schemas[0])),{$ref:`#/${k}/${l.id}`}}return c})}const S=a(O),d=[];for(let r=0;r<y.length;r++)d.push(`"_${r}":${a(y[r])}`);return d.length?`${S.substring(0,S.length-1)},"${k}":{${d.join(",")}}}`:S}function R(O){return typeof O=="object"&&O!==null}function P(O,T){if(!O||typeof O!="object")return;const A=(...S)=>{for(const d of S)R(d)&&y.push(d)},$=(...S)=>{for(const d of S)if(R(d))for(const r in d){const o=d[r];R(o)&&y.push(o)}},s=(...S)=>{for(const d of S)if(Array.isArray(d))for(const r of d)R(r)&&y.push(r)},k=S=>{if(Array.isArray(S))for(const d of S)R(d)&&y.push(d);else R(S)&&y.push(S)},y=[O];let a=y.pop();for(;a;)T(a)&&(A(a.additionalItems,a.additionalProperties,a.not,a.contains,a.propertyNames,a.if,a.then,a.else,a.unevaluatedItems,a.unevaluatedProperties),$(a.definitions,a.$defs,a.properties,a.patternProperties,a.dependencies,a.dependentSchemas),s(a.anyOf,a.allOf,a.oneOf,a.prefixItems),k(a.items)),a=y.pop()}}),function(be,e){typeof define=="function"&&define.amd?define(Oe[138],Ne([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(le,ve){for(var de=0;de<ve.length;de++){var J=ve[de];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(le,J.key,J)}}function v(le,ve,de){return ve&&e(le.prototype,ve),de&&e(le,de),Object.defineProperty(le,"prototype",{writable:!1}),le}function R(le,ve){if(le){if(typeof le=="string")return P(le,ve);var de=Object.prototype.toString.call(le).slice(8,-1);if(de==="Object"&&le.constructor&&(de=le.constructor.name),de==="Map"||de==="Set")return Array.from(le);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return P(le,ve)}}function P(le,ve){(ve==null||ve>le.length)&&(ve=le.length);for(var de=0,J=new Array(ve);de<ve;de++)J[de]=le[de];return J}function O(le,ve){var de=typeof Symbol<"u"&&le[Symbol.iterator]||le["@@iterator"];if(de)return(de=de.call(le)).next.bind(de);if(Array.isArray(le)||(de=R(le))||ve&&le&&typeof le.length=="number"){de&&(le=de);var J=0;return function(){return J>=le.length?{done:!0}:{done:!1,value:le[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=T();function A(le){be.defaults=le}var $=/[&<>"']/,s=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ve){return a[ve]};function d(le,ve){if(ve){if($.test(le))return le.replace(s,S)}else if(k.test(le))return le.replace(y,S);return le}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(le){return le.replace(r,function(ve,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var c=/(^|[^\[])\^/g;function l(le,ve){le=typeof le=="string"?le:le.source,ve=ve||"";var de={replace:function(x,pe){return pe=pe.source||pe,pe=pe.replace(c,"$1"),le=le.replace(x,pe),de},getRegex:function(){return new RegExp(le,ve)}};return de}var i=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(le,ve,de){if(le){var J;try{J=decodeURIComponent(o(de)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ve&&!n.test(de)&&(de=h(ve,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var g={},u=/^[^:]+:\/*[^/]*$/,m=/^([^:]+:)[\s\S]*$/,p=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(le,ve){g[" "+le]||(u.test(le)?g[" "+le]=le+"/":g[" "+le]=I(le,"/",!0)),le=g[" "+le];var de=le.indexOf(":")===-1;return ve.substring(0,2)==="//"?de?ve:le.replace(m,"$1")+ve:ve.charAt(0)==="/"?de?ve:le.replace(p,"$1")+ve:le+ve}var E={exec:function(){}};function D(le){for(var ve=1,de,J;ve<arguments.length;ve++){de=arguments[ve];for(J in de)Object.prototype.hasOwnProperty.call(de,J)&&(le[J]=de[J])}return le}function w(le,ve){var de=le.replace(/\|/g,function(pe,$e,Ae){for(var Ue=!1,ke=$e;--ke>=0&&Ae[ke]==="\\";)Ue=!Ue;return Ue?"|":" |"}),J=de.split(/ \|/),x=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ve)J.splice(ve);else for(;J.length<ve;)J.push("");for(;x<J.length;x++)J[x]=J[x].trim().replace(/\\\|/g,"|");return J}function I(le,ve,de){var J=le.length;if(J===0)return"";for(var x=0;x<J;){var pe=le.charAt(J-x-1);if(pe===ve&&!de)x++;else if(pe!==ve&&de)x++;else break}return le.slice(0,J-x)}function C(le,ve){if(le.indexOf(ve[1])===-1)return-1;for(var de=le.length,J=0,x=0;x<de;x++)if(le[x]==="\\")x++;else if(le[x]===ve[0])J++;else if(le[x]===ve[1]&&(J--,J<0))return x;return-1}function f(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(le,ve){if(ve<1)return"";for(var de="";ve>1;)ve&1&&(de+=le),ve>>=1,le+=le;return de+le}function M(le,ve,de,J){var x=ve.href,pe=ve.title?d(ve.title):null,$e=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){J.state.inLink=!0;var Ae={type:"link",raw:de,href:x,title:pe,text:$e,tokens:J.inlineTokens($e)};return J.state.inLink=!1,Ae}return{type:"image",raw:de,href:x,title:pe,text:d($e)}}function N(le,ve){var de=le.match(/^(\s+)(?:```)/);if(de===null)return ve;var J=de[1];return ve.split(`
`).map(function(x){var pe=x.match(/^\s+/);if(pe===null)return x;var $e=pe[0];return $e.length>=J.length?x.slice(J.length):x}).join(`
`)}var F=function(){function le(de){this.options=de||be.defaults}var ve=le.prototype;return ve.space=function(J){var x=this.rules.block.newline.exec(J);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},ve.code=function(J){var x=this.rules.block.code.exec(J);if(x){var pe=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:I(pe,`
`)}}},ve.fences=function(J){var x=this.rules.block.fences.exec(J);if(x){var pe=x[0],$e=N(pe,x[3]||"");return{type:"code",raw:pe,lang:x[2]?x[2].trim():x[2],text:$e}}},ve.heading=function(J){var x=this.rules.block.heading.exec(J);if(x){var pe=x[2].trim();if(/#$/.test(pe)){var $e=I(pe,"#");(this.options.pedantic||!$e||/ $/.test($e))&&(pe=$e.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ve.hr=function(J){var x=this.rules.block.hr.exec(J);if(x)return{type:"hr",raw:x[0]}},ve.blockquote=function(J){var x=this.rules.block.blockquote.exec(J);if(x){var pe=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ve.list=function(J){var x=this.rules.block.list.exec(J);if(x){var pe,$e,Ae,Ue,ke,Pe,Te,j,B,H,V,re,ge=x[1].trim(),Ce=ge.length>1,ze={type:"list",raw:"",ordered:Ce,start:Ce?+ge.slice(0,-1):"",loose:!1,items:[]};ge=Ce?"\\d{1,9}\\"+ge.slice(-1):"\\"+ge,this.options.pedantic&&(ge=Ce?ge:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(re=!1,!(!(x=Qe.exec(J))||this.rules.block.hr.test(J)));){if(pe=x[0],J=J.substring(pe.length),j=x[2].split(`
`,1)[0],B=J.split(`
`,1)[0],this.options.pedantic?(Ue=2,V=j.trimLeft()):(Ue=x[2].search(/[^ ]/),Ue=Ue>4?1:Ue,V=j.slice(Ue),Ue+=x[1].length),Pe=!1,!j&&/^ *$/.test(B)&&(pe+=B+`
`,J=J.substring(B.length+1),re=!0),!re)for(var _e=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");J&&(H=J.split(`
`,1)[0],j=H,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(j)||et.test(j)||_e.test(j)||tt.test(J)));){if(j.search(/[^ ]/)>=Ue||!j.trim())V+=`
`+j.slice(Ue);else if(!Pe)V+=`
`+j;else break;!Pe&&!j.trim()&&(Pe=!0),pe+=H+`
`,J=J.substring(H.length+1)}ze.loose||(Te?ze.loose=!0:/\n *\n *$/.test(pe)&&(Te=!0)),this.options.gfm&&($e=/^\[[ xX]\] /.exec(V),$e&&(Ae=$e[0]!=="[ ] ",V=V.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:pe,task:!!$e,checked:Ae,loose:!1,text:V}),ze.raw+=pe}ze.items[ze.items.length-1].raw=pe.trimRight(),ze.items[ze.items.length-1].text=V.trimRight(),ze.raw=ze.raw.trimRight();var rt=ze.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,ze.items[ke].tokens=this.lexer.blockTokens(ze.items[ke].text,[]);var ft=ze.items[ke].tokens.filter(function(st){return st.type==="space"}),lt=ft.every(function(st){for(var ct=st.raw.split(""),gt=0,$t=O(ct),qe;!(qe=$t()).done;){var je=qe.value;if(je===`
`&&(gt+=1),gt>1)return!0}return!1});!ze.loose&&ft.length&&lt&&(ze.loose=!0,ze.items[ke].loose=!0)}return ze}},ve.html=function(J){var x=this.rules.block.html.exec(J);if(x){var pe={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var $e=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);pe.type="paragraph",pe.text=$e,pe.tokens=this.lexer.inline($e)}return pe}},ve.def=function(J){var x=this.rules.block.def.exec(J);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var pe=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:x[0],href:x[2],title:x[3]}}},ve.table=function(J){var x=this.rules.block.table.exec(J);if(x){var pe={type:"table",header:w(x[1]).map(function(Te){return{text:Te}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=x[0];var $e=pe.align.length,Ae,Ue,ke,Pe;for(Ae=0;Ae<$e;Ae++)/^ *-+: *$/.test(pe.align[Ae])?pe.align[Ae]="right":/^ *:-+: *$/.test(pe.align[Ae])?pe.align[Ae]="center":/^ *:-+ *$/.test(pe.align[Ae])?pe.align[Ae]="left":pe.align[Ae]=null;for($e=pe.rows.length,Ae=0;Ae<$e;Ae++)pe.rows[Ae]=w(pe.rows[Ae],pe.header.length).map(function(Te){return{text:Te}});for($e=pe.header.length,Ue=0;Ue<$e;Ue++)pe.header[Ue].tokens=this.lexer.inline(pe.header[Ue].text);for($e=pe.rows.length,Ue=0;Ue<$e;Ue++)for(Pe=pe.rows[Ue],ke=0;ke<Pe.length;ke++)Pe[ke].tokens=this.lexer.inline(Pe[ke].text);return pe}}},ve.lheading=function(J){var x=this.rules.block.lheading.exec(J);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},ve.paragraph=function(J){var x=this.rules.block.paragraph.exec(J);if(x){var pe=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:pe,tokens:this.lexer.inline(pe)}}},ve.text=function(J){var x=this.rules.block.text.exec(J);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},ve.escape=function(J){var x=this.rules.inline.escape.exec(J);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},ve.tag=function(J){var x=this.rules.inline.tag.exec(J);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},ve.link=function(J){var x=this.rules.inline.link.exec(J);if(x){var pe=x[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var $e=I(pe.slice(0,-1),"\\");if((pe.length-$e.length)%2===0)return}else{var Ae=C(x[2],"()");if(Ae>-1){var Ue=x[0].indexOf("!")===0?5:4,ke=Ue+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,ke).trim(),x[3]=""}}var Pe=x[2],Te="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);j&&(Pe=j[1],Te=j[3])}else Te=x[3]?x[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(pe)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),M(x,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},ve.reflink=function(J,x){var pe;if((pe=this.rules.inline.reflink.exec(J))||(pe=this.rules.inline.nolink.exec(J))){var $e=(pe[2]||pe[1]).replace(/\s+/g," ");if($e=x[$e.toLowerCase()],!$e||!$e.href){var Ae=pe[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return M(pe,$e,pe[0],this.lexer)}},ve.emStrong=function(J,x,pe){pe===void 0&&(pe="");var $e=this.rules.inline.emStrong.lDelim.exec(J);if($e&&!($e[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=$e[1]||$e[2]||"";if(!Ae||Ae&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Ue=$e[0].length-1,ke,Pe,Te=Ue,j=0,B=$e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,x=x.slice(-1*J.length+Ue);($e=B.exec(x))!=null;)if(ke=$e[1]||$e[2]||$e[3]||$e[4]||$e[5]||$e[6],!!ke){if(Pe=ke.length,$e[3]||$e[4]){Te+=Pe;continue}else if(($e[5]||$e[6])&&Ue%3&&!((Ue+Pe)%3)){j+=Pe;continue}if(Te-=Pe,!(Te>0)){if(Pe=Math.min(Pe,Pe+Te+j),Math.min(Ue,Pe)%2){var H=J.slice(1,Ue+$e.index+Pe);return{type:"em",raw:J.slice(0,Ue+$e.index+Pe+1),text:H,tokens:this.lexer.inlineTokens(H)}}var V=J.slice(2,Ue+$e.index+Pe-1);return{type:"strong",raw:J.slice(0,Ue+$e.index+Pe+1),text:V,tokens:this.lexer.inlineTokens(V)}}}}}},ve.codespan=function(J){var x=this.rules.inline.code.exec(J);if(x){var pe=x[2].replace(/\n/g," "),$e=/[^ ]/.test(pe),Ae=/^ /.test(pe)&&/ $/.test(pe);return $e&&Ae&&(pe=pe.substring(1,pe.length-1)),pe=d(pe,!0),{type:"codespan",raw:x[0],text:pe}}},ve.br=function(J){var x=this.rules.inline.br.exec(J);if(x)return{type:"br",raw:x[0]}},ve.del=function(J){var x=this.rules.inline.del.exec(J);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},ve.autolink=function(J,x){var pe=this.rules.inline.autolink.exec(J);if(pe){var $e,Ae;return pe[2]==="@"?($e=d(this.options.mangle?x(pe[1]):pe[1]),Ae="mailto:"+$e):($e=d(pe[1]),Ae=$e),{type:"link",raw:pe[0],text:$e,href:Ae,tokens:[{type:"text",raw:$e,text:$e}]}}},ve.url=function(J,x){var pe;if(pe=this.rules.inline.url.exec(J)){var $e,Ae;if(pe[2]==="@")$e=d(this.options.mangle?x(pe[0]):pe[0]),Ae="mailto:"+$e;else{var Ue;do Ue=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Ue!==pe[0]);$e=d(pe[0]),pe[1]==="www."?Ae="http://"+$e:Ae=$e}return{type:"link",raw:pe[0],text:$e,href:Ae,tokens:[{type:"text",raw:$e,text:$e}]}}},ve.inlineText=function(J,x){var pe=this.rules.inline.text.exec(J);if(pe){var $e;return this.lexer.state.inRawBlock?$e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):d(pe[0]):pe[0]:$e=d(this.options.smartypants?x(pe[0]):pe[0]),{type:"text",raw:pe[0],text:$e}}},le}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=l(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=l(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=l(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=l(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=l(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=l(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=D({},W),W.gfm=D({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=l(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=l(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=D({},W.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:l(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=l(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=l(W._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=l(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=l(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=l(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=l(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=l(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=l(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=l(K.reflink).replace("label",K._label).replace("ref",W._label).getRegex(),K.nolink=l(K.nolink).replace("ref",W._label).getRegex(),K.reflinkSearch=l(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=D({},K),K.pedantic=D({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=D({},K.normal,{escape:l(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),K.gfm.url=l(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=D({},K.gfm,{br:l(K.br).replace("{2,}","*").getRegex(),text:l(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(le){var ve="",de,J,x=le.length;for(de=0;de<x;de++)J=le.charCodeAt(de),Math.random()>.5&&(J="x"+J.toString(16)),ve+="&#"+J+";";return ve}var X=function(){function le(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||be.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:W.normal,inline:K.normal};this.options.pedantic?(J.block=W.pedantic,J.inline=K.pedantic):this.options.gfm&&(J.block=W.gfm,this.options.breaks?J.inline=K.breaks:J.inline=K.gfm),this.tokenizer.rules=J}le.lex=function(J,x){var pe=new le(x);return pe.lex(J)},le.lexInline=function(J,x){var pe=new le(x);return pe.inlineTokens(J)};var ve=le.prototype;return ve.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},ve.blockTokens=function(J,x){var pe=this;x===void 0&&(x=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(Te,j,B){return j+"    ".repeat(B.length)});for(var $e,Ae,Ue,ke;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return($e=Te.call({lexer:pe},J,x))?(J=J.substring($e.raw.length),x.push($e),!0):!1}))){if($e=this.tokenizer.space(J)){J=J.substring($e.raw.length),$e.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push($e);continue}if($e=this.tokenizer.code(J)){J=J.substring($e.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+$e.raw,Ae.text+=`
`+$e.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push($e);continue}if($e=this.tokenizer.fences(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.heading(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.hr(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.blockquote(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.list(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.html(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.def(J)){J=J.substring($e.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+$e.raw,Ae.text+=`
`+$e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[$e.tag]||(this.tokens.links[$e.tag]={href:$e.href,title:$e.title});continue}if($e=this.tokenizer.table(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.lheading(J)){J=J.substring($e.raw.length),x.push($e);continue}if(Ue=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,j=J.slice(1),B=void 0;pe.options.extensions.startBlock.forEach(function(H){B=H.call({lexer:this},j),typeof B=="number"&&B>=0&&(Te=Math.min(Te,B))}),Te<1/0&&Te>=0&&(Ue=J.substring(0,Te+1))}(),this.state.top&&($e=this.tokenizer.paragraph(Ue))){Ae=x[x.length-1],ke&&Ae.type==="paragraph"?(Ae.raw+=`
`+$e.raw,Ae.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push($e),ke=Ue.length!==J.length,J=J.substring($e.raw.length);continue}if($e=this.tokenizer.text(J)){J=J.substring($e.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+$e.raw,Ae.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push($e);continue}if(J){var Pe="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,x},ve.inline=function(J,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:J,tokens:x}),x},ve.inlineTokens=function(J,x){var pe=this;x===void 0&&(x=[]);var $e,Ae,Ue,ke=J,Pe,Te,j;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)B.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(Te||(j=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(V){return($e=V.call({lexer:pe},J,x))?(J=J.substring($e.raw.length),x.push($e),!0):!1}))){if($e=this.tokenizer.escape(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.tag(J)){J=J.substring($e.raw.length),Ae=x[x.length-1],Ae&&$e.type==="text"&&Ae.type==="text"?(Ae.raw+=$e.raw,Ae.text+=$e.text):x.push($e);continue}if($e=this.tokenizer.link(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring($e.raw.length),Ae=x[x.length-1],Ae&&$e.type==="text"&&Ae.type==="text"?(Ae.raw+=$e.raw,Ae.text+=$e.text):x.push($e);continue}if($e=this.tokenizer.emStrong(J,ke,j)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.codespan(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.br(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.del(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.autolink(J,Q)){J=J.substring($e.raw.length),x.push($e);continue}if(!this.state.inLink&&($e=this.tokenizer.url(J,Q))){J=J.substring($e.raw.length),x.push($e);continue}if(Ue=J,this.options.extensions&&this.options.extensions.startInline&&function(){var V=1/0,re=J.slice(1),ge=void 0;pe.options.extensions.startInline.forEach(function(Ce){ge=Ce.call({lexer:this},re),typeof ge=="number"&&ge>=0&&(V=Math.min(V,ge))}),V<1/0&&V>=0&&(Ue=J.substring(0,V+1))}(),$e=this.tokenizer.inlineText(Ue,L)){J=J.substring($e.raw.length),$e.raw.slice(-1)!=="_"&&(j=$e.raw.slice(-1)),Te=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=$e.raw,Ae.text+=$e.text):x.push($e);continue}if(J){var H="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return x},v(le,null,[{key:"rules",get:function(){return{block:W,inline:K}}}]),le}(),ue=function(){function le(de){this.options=de||be.defaults}var ve=le.prototype;return ve.code=function(J,x,pe){var $e=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(J,$e);Ae!=null&&Ae!==J&&(pe=!0,J=Ae)}return J=J.replace(/\n$/,"")+`
`,$e?'<pre><code class="'+this.options.langPrefix+d($e,!0)+'">'+(pe?J:d(J,!0))+`</code></pre>
`:"<pre><code>"+(pe?J:d(J,!0))+`</code></pre>
`},ve.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ve.html=function(J){return J},ve.heading=function(J,x,pe,$e){if(this.options.headerIds){var Ae=this.options.headerPrefix+$e.slug(pe);return"<h"+x+' id="'+Ae+'">'+J+"</h"+x+`>
`}return"<h"+x+">"+J+"</h"+x+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(J,x,pe){var $e=x?"ol":"ul",Ae=x&&pe!==1?' start="'+pe+'"':"";return"<"+$e+Ae+`>
`+J+"</"+$e+`>
`},ve.listitem=function(J){return"<li>"+J+`</li>
`},ve.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(J){return"<p>"+J+`</p>
`},ve.table=function(J,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+x+`</table>
`},ve.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ve.tablecell=function(J,x){var pe=x.header?"th":"td",$e=x.align?"<"+pe+' align="'+x.align+'">':"<"+pe+">";return $e+J+("</"+pe+`>
`)},ve.strong=function(J){return"<strong>"+J+"</strong>"},ve.em=function(J){return"<em>"+J+"</em>"},ve.codespan=function(J){return"<code>"+J+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(J){return"<del>"+J+"</del>"},ve.link=function(J,x,pe){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return pe;var $e='<a href="'+d(J)+'"';return x&&($e+=' title="'+x+'"'),$e+=">"+pe+"</a>",$e},ve.image=function(J,x,pe){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return pe;var $e='<img src="'+J+'" alt="'+pe+'"';return x&&($e+=' title="'+x+'"'),$e+=this.options.xhtml?"/>":">",$e},ve.text=function(J){return J},le}(),ee=function(){function le(){}var ve=le.prototype;return ve.strong=function(J){return J},ve.em=function(J){return J},ve.codespan=function(J){return J},ve.del=function(J){return J},ve.html=function(J){return J},ve.text=function(J){return J},ve.link=function(J,x,pe){return""+pe},ve.image=function(J,x,pe){return""+pe},ve.br=function(){return""},le}(),me=function(){function le(){this.seen={}}var ve=le.prototype;return ve.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(J,x){var pe=J,$e=0;if(this.seen.hasOwnProperty(pe)){$e=this.seen[J];do $e++,pe=J+"-"+$e;while(this.seen.hasOwnProperty(pe))}return x||(this.seen[J]=$e,this.seen[pe]=0),pe},ve.slug=function(J,x){x===void 0&&(x={});var pe=this.serialize(J);return this.getNextSafeSlug(pe,x.dryrun)},le}(),oe=function(){function le(de){this.options=de||be.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new me}le.parse=function(J,x){var pe=new le(x);return pe.parse(J)},le.parseInline=function(J,x){var pe=new le(x);return pe.parseInline(J)};var ve=le.prototype;return ve.parse=function(J,x){x===void 0&&(x=!0);var pe="",$e,Ae,Ue,ke,Pe,Te,j,B,H,V,re,ge,Ce,ze,Qe,_e,tt,nt,et,rt=J.length;for($e=0;$e<rt;$e++){if(V=J[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[V.type]&&(et=this.options.extensions.renderers[V.type].call({parser:this},V),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(V.type))){pe+=et||"";continue}switch(V.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(V.tokens),V.depth,o(this.parseInline(V.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(V.text,V.lang,V.escaped);continue}case"table":{for(B="",j="",ke=V.header.length,Ae=0;Ae<ke;Ae++)j+=this.renderer.tablecell(this.parseInline(V.header[Ae].tokens),{header:!0,align:V.align[Ae]});for(B+=this.renderer.tablerow(j),H="",ke=V.rows.length,Ae=0;Ae<ke;Ae++){for(Te=V.rows[Ae],j="",Pe=Te.length,Ue=0;Ue<Pe;Ue++)j+=this.renderer.tablecell(this.parseInline(Te[Ue].tokens),{header:!1,align:V.align[Ue]});H+=this.renderer.tablerow(j)}pe+=this.renderer.table(B,H);continue}case"blockquote":{H=this.parse(V.tokens),pe+=this.renderer.blockquote(H);continue}case"list":{for(re=V.ordered,ge=V.start,Ce=V.loose,ke=V.items.length,H="",Ae=0;Ae<ke;Ae++)Qe=V.items[Ae],_e=Qe.checked,tt=Qe.task,ze="",Qe.task&&(nt=this.renderer.checkbox(_e),Ce?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=nt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=nt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:nt}):ze+=nt),ze+=this.parse(Qe.tokens,Ce),H+=this.renderer.listitem(ze,tt,_e);pe+=this.renderer.list(H,re,ge);continue}case"html":{pe+=this.renderer.html(V.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(V.tokens));continue}case"text":{for(H=V.tokens?this.parseInline(V.tokens):V.text;$e+1<rt&&J[$e+1].type==="text";)V=J[++$e],H+=`
`+(V.tokens?this.parseInline(V.tokens):V.text);pe+=x?this.renderer.paragraph(H):H;continue}default:{var ft='Token with "'+V.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return pe},ve.parseInline=function(J,x){x=x||this.renderer;var pe="",$e,Ae,Ue,ke=J.length;for($e=0;$e<ke;$e++){if(Ae=J[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(Ue=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){pe+=Ue||"";continue}switch(Ae.type){case"escape":{pe+=x.text(Ae.text);break}case"html":{pe+=x.html(Ae.text);break}case"link":{pe+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{pe+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{pe+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{pe+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{pe+=x.codespan(Ae.text);break}case"br":{pe+=x.br();break}case"del":{pe+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{pe+=x.text(Ae.text);break}default:{var Pe='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return pe},le}();function ce(le,ve,de){if(typeof le>"u"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof ve=="function"&&(de=ve,ve=null),ve=D({},ce.defaults,ve||{}),f(ve),de){var J=ve.highlight,x;try{x=X.lex(le,ve)}catch(ke){return de(ke)}var pe=function(Pe){var Te;if(!Pe)try{ve.walkTokens&&ce.walkTokens(x,ve.walkTokens),Te=oe.parse(x,ve)}catch(j){Pe=j}return ve.highlight=J,Pe?de(Pe):de(null,Te)};if(!J||J.length<3||(delete ve.highlight,!x.length))return pe();var $e=0;ce.walkTokens(x,function(ke){ke.type==="code"&&($e++,setTimeout(function(){J(ke.text,ke.lang,function(Pe,Te){if(Pe)return pe(Pe);Te!=null&&Te!==ke.text&&(ke.text=Te,ke.escaped=!0),$e--,$e===0&&pe()})},0))}),$e===0&&pe();return}function Ae(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var Ue=X.lex(le,ve);if(ve.walkTokens){if(ve.async)return Promise.all(ce.walkTokens(Ue,ve.walkTokens)).then(function(){return oe.parse(Ue,ve)}).catch(Ae);ce.walkTokens(Ue,ve.walkTokens)}return oe.parse(Ue,ve)}catch(ke){Ae(ke)}}ce.options=ce.setOptions=function(le){return D(ce.defaults,le),A(ce.defaults),ce},ce.getDefaults=T,ce.defaults=be.defaults,ce.use=function(){for(var le=arguments.length,ve=new Array(le),de=0;de<le;de++)ve[de]=arguments[de];var J=D.apply(void 0,[{}].concat(ve)),x=ce.defaults.extensions||{renderers:{},childTokens:{}},pe;ve.forEach(function($e){if($e.extensions&&(pe=!0,$e.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var ke=x.renderers?x.renderers[Ue.name]:null;ke?x.renderers[Ue.name]=function(){for(var Pe=arguments.length,Te=new Array(Pe),j=0;j<Pe;j++)Te[j]=arguments[j];var B=Ue.renderer.apply(this,Te);return B===!1&&(B=ke.apply(this,Te)),B}:x.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[Ue.level]?x[Ue.level].unshift(Ue.tokenizer):x[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?x.startBlock?x.startBlock.push(Ue.start):x.startBlock=[Ue.start]:Ue.level==="inline"&&(x.startInline?x.startInline.push(Ue.start):x.startInline=[Ue.start]))}Ue.childTokens&&(x.childTokens[Ue.name]=Ue.childTokens)})),$e.renderer&&function(){var Ue=ce.defaults.renderer||new ue,ke=function(j){var B=Ue[j];Ue[j]=function(){for(var H=arguments.length,V=new Array(H),re=0;re<H;re++)V[re]=arguments[re];var ge=$e.renderer[j].apply(Ue,V);return ge===!1&&(ge=B.apply(Ue,V)),ge}};for(var Pe in $e.renderer)ke(Pe);J.renderer=Ue}(),$e.tokenizer&&function(){var Ue=ce.defaults.tokenizer||new F,ke=function(j){var B=Ue[j];Ue[j]=function(){for(var H=arguments.length,V=new Array(H),re=0;re<H;re++)V[re]=arguments[re];var ge=$e.tokenizer[j].apply(Ue,V);return ge===!1&&(ge=B.apply(Ue,V)),ge}};for(var Pe in $e.tokenizer)ke(Pe);J.tokenizer=Ue}(),$e.walkTokens){var Ae=ce.defaults.walkTokens;J.walkTokens=function(Ue){var ke=[];return ke.push($e.walkTokens.call(this,Ue)),Ae&&(ke=ke.concat(Ae.call(this,Ue))),ke}}pe&&(J.extensions=x),ce.setOptions(J)})},ce.walkTokens=function(le,ve){for(var de=[],J=function(){var Ae=pe.value;switch(de=de.concat(ve.call(ce,Ae)),Ae.type){case"table":{for(var Ue=O(Ae.header),ke;!(ke=Ue()).done;){var Pe=ke.value;de=de.concat(ce.walkTokens(Pe.tokens,ve))}for(var Te=O(Ae.rows),j;!(j=Te()).done;)for(var B=j.value,H=O(B),V;!(V=H()).done;){var re=V.value;de=de.concat(ce.walkTokens(re.tokens,ve))}break}case"list":{de=de.concat(ce.walkTokens(Ae.items,ve));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ae.type]?ce.defaults.extensions.childTokens[Ae.type].forEach(function(ge){de=de.concat(ce.walkTokens(Ae[ge],ve))}):Ae.tokens&&(de=de.concat(ce.walkTokens(Ae.tokens,ve)))}},x=O(le),pe;!(pe=x()).done;)J();return de},ce.parseInline=function(le,ve){if(typeof le>"u"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");ve=D({},ce.defaults,ve||{}),f(ve);try{var de=X.lexInline(le,ve);return ve.walkTokens&&ce.walkTokens(de,ve.walkTokens),oe.parseInline(de,ve)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+d(J.message+"",!0)+"</pre>";throw J}},ce.Parser=oe,ce.parser=oe.parse,ce.Renderer=ue,ce.TextRenderer=ee,ce.Lexer=X,ce.lexer=X.lex,ce.Tokenizer=F,ce.Slugger=me,ce.parse=ce;var we=ce.options,ae=ce.setOptions,Ie=ce.use,Fe=ce.walkTokens,Y=ce.parseInline,q=ce,ne=oe.parse,ye=X.lex;be.Lexer=X,be.Parser=oe,be.Renderer=ue,be.Slugger=me,be.TextRenderer=ee,be.Tokenizer=F,be.getDefaults=T,be.lexer=ye,be.marked=ce,be.options=we,be.parse=q,be.parseInline=Y,be.parser=ne,be.setOptions=ae,be.use=Ie,be.walkTokens=Fe,Object.defineProperty(be,"__esModule",{value:!0})}),define(Oe[139],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=v;function v(r){const o=O(r);if(o&&o.length>0)return new Uint32Array(o)}let R=0;const P=new Uint32Array(10);function O(r){if(R=0,T(r,y,$.InitialConsonant),R>0||(T(r,a,$.Vowel),R>0)||(T(r,S,$.FinalConsonant),R>0)||(T(r,d,$.CompatibilityJamo),R))return P.subarray(0,R);if(r>=44032&&r<=55203){const o=r-44032,c=o%588,l=Math.floor(o/588),i=Math.floor(c/28),n=c%28-1;if(l<y.length?T(l,y,0):$.InitialConsonant+l-$.CompatibilityJamo<d.length&&T($.InitialConsonant+l,d,$.CompatibilityJamo),i<a.length?T(i,a,0):$.Vowel+i-$.CompatibilityJamo<d.length&&T($.Vowel+i-$.CompatibilityJamo,d,$.CompatibilityJamo),n>=0&&(n<S.length?T(n,S,0):$.FinalConsonant+n-$.CompatibilityJamo<d.length&&T($.FinalConsonant+n-$.CompatibilityJamo,d,$.CompatibilityJamo)),R>0)return P.subarray(0,R)}}function T(r,o,c){r>=c&&r<c+o.length&&A(o[r-c])}function A(r){r!==s.NUL&&(P[R++]=r&255,r>>8&&(P[R++]=r>>8&255),r>>16&&(P[R++]=r>>16&255))}var $;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var s;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(s||(s={}));var k;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(k||(k={}));const y=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),a=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,k.hk,k.ho,k.hl,s.y,s.n,k.nj,k.np,k.nl,s.b,s.m,k.ml,s.l]),S=new Uint16Array([s.r,s.R,k.rt,s.s,k.sw,k.sg,s.e,s.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,s.a,s.q,k.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),d=new Uint16Array([s.r,s.R,k.rt,s.s,k.sw,k.sg,s.e,s.E,s.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,s.a,s.q,s.Q,k.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,k.hk,k.ho,k.hl,s.y,s.n,k.nj,k.np,k.nl,s.b,s.m,k.ml,s.l])}),define(Oe[140],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=v,e.rot=R,e.$Pm=A;function v($,s,k){return Math.min(Math.max($,s),k)}function R($,s){return(s+$%s)%s}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=P;class O{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=O;class T{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const k=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=T;function A($,s,k,y,a,S,d,r){const o=d-k,c=r-y,l=a-k,i=S-y,n=$-k,t=s-y,g=o*o+c*c,u=o*l+c*i,m=o*n+c*t,p=l*l+i*i,h=l*n+i*t,E=1/(g*p-u*u),D=(p*m-u*h)*E,w=(g*h-u*m)*E;return D>=0&&w>=0&&D+w<1}}),define(Oe[141],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=O,e.$cd=a;class v{constructor(d,r,o){this.owner=d,this.debugNameSource=r,this.referenceFn=o}getDebugName(d){return O(d,this)}}e.$ad=v;const R=new Map,P=new WeakMap;function O(S,d){const r=P.get(S);if(r)return r;const o=T(S,d);if(o){let c=R.get(o)??0;c++,R.set(o,c);const l=c===1?o:`${o}#${c}`;return P.set(S,l),l}}function T(S,d){const r=P.get(S);if(r)return r;const o=d.owner?k(d.owner)+".":"";let c;const l=d.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(c=l(),c!==void 0)return o+c}else return o+l;const i=d.referenceFn;if(i!==void 0&&(c=a(i),c!==void 0))return o+c;if(d.owner!==void 0){const n=A(d.owner,S);if(n!==void 0)return o+n}}function A(S,d){for(const r in S)if(S[r]===d)return r}const $=new Map,s=new WeakMap;function k(S){const d=s.get(S);if(d)return d;const r=y(S);let o=$.get(r)??0;o++,$.set(r,o);const c=o===1?r:`${r}#${o}`;return s.set(S,c),c}function y(S){const d=S.constructor;return d?d.name:"Object"}function a(S){const d=S.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(Oe[142],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0,e.$Kd=R,e.$Ld=P;let v;function R(r){v=r}function P(){return v}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return T([A(S("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[A(" "),s(k(o.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),s(k(o.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),s(k(o.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(o,c){console.log(...this.b([$("observable value changed"),s(o.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(o){if(o.size!==0)return s(" (changed deps: "+[...o].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(l,i)=>(this.d.get(o).add(l),c.apply(o,[l,i]))}handleDerivedRecomputed(o,c){const l=this.d.get(o);console.log(...this.b([$("derived recomputed"),s(o.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(l),{data:[{fn:o._debugNameData.referenceFn??o._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(o,c){console.log(...this.b([$("observable from event triggered"),s(o.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(l,i)=>(this.d.get(o).add(l),c.apply(o,[l,i]))}handleAutorunTriggered(o){const c=this.d.get(o);console.log(...this.b([$("autorun"),s(o.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:o._debugNameData.referenceFn??o._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let c=o.getDebugName();c===void 0&&(c=""),console.log(...this.b([$("transaction"),s(c,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Md=O;function T(r){const o=new Array,c=[];let l="";function i(t){if("length"in t)for(const g of t)g&&i(g);else"text"in t?(l+=`%c${t.text}`,o.push(t.style),t.data&&c.push(...t.data)):"data"in t&&c.push(...t.data)}i(r);const n=[l,...o];return n.push(...c),n}function A(r){return s(r,{color:"black"})}function $(r){return s(d(`${r}: `,10),{color:"black",bold:!0})}function s(r,o={color:"black"}){function c(i){return Object.entries(i).reduce((n,[t,g])=>`${n}${t}:${g};`,"")}const l={color:o.color};return o.strikeThrough&&(l["text-decoration"]="line-through"),o.bold&&(l["font-weight"]="bold"),{text:r,style:c(l)}}function k(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?y(r,o):a(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function y(r,o){let c="[ ",l=!0;for(const i of r){if(l||(c+=", "),c.length-5>o){c+="...";break}l=!1,c+=`${k(i,o-c.length)}`}return c+=" ]",c}function a(r,o){let c="{ ",l=!0;for(const[i,n]of Object.entries(r)){if(l||(c+=", "),c.length-5>o){c+="...";break}l=!1,c+=`${i}: ${k(n,o-c.length)}`}return c+=" }",c}function S(r,o){let c="";for(let l=1;l<=o;l++)c+=r;return c}function d(r,o){for(;r.length<o;)r+=" ";return r}}),define(Oe[143],Ne([1,0,135,141,142]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=e.$7d=e.$5d=e.$Zd=e.$Yd=void 0,e.$Vd=T,e.$Wd=$,e.$Xd=k,e.$1d=S,e.$2d=r,e.$3d=o,e.$4d=c,e.$6d=i,e.$8d=t;let O;function T(u){O=u}let A;function $(u){A=u}let s;function k(u){s=u}class y{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,p){const h=p===void 0?void 0:m,E=p===void 0?m:p;return s({owner:h,debugName:()=>{const D=(0,R.$cd)(E);if(D!==void 0)return D;const I=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(I)return`${this.debugName}.${I[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},m=>this.read(m).read(m))}recomputeInitiallyAndOnChange(m,p){return m.add(O(this,p)),this}keepObserved(m){return m.add(A(this)),this}get a(){return this.get()}}e.$Yd=y;class a extends y{constructor(){super(...arguments),this.b=new Set}addObserver(m){const p=this.b.size;this.b.add(m),p===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Zd=a;function S(u,m){const p=new l(u,m);try{u(p)}finally{p.finish()}}let d;function r(u){if(d)u(d);else{const m=new l(u,void 0);d=m;try{u(m)}finally{m.finish(),d=void 0}}}async function o(u,m){const p=new l(u,m);try{await u(p)}finally{p.finish()}}function c(u,m,p){u?m(u):S(m,p)}class l{constructor(m,p){this._fn=m,this.b=p,this.a=[],(0,P.$Ld)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,R.$cd)(this._fn)}updateObserver(m,p){this.a.push({observer:m,observable:p}),m.beginUpdate(p)}finish(){const m=this.a;for(let p=0;p<m.length;p++){const{observer:h,observable:E}=m[p];h.endUpdate(E)}this.a=null,(0,P.$Ld)()?.handleEndTransaction()}}e.$5d=l;function i(u,m){let p;return typeof u=="string"?p=new R.$ad(void 0,u,void 0):p=new R.$ad(u,void 0,void 0),new n(p,m,v.$6c)}class n extends a{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,p,h){super(),this.e=m,this.g=h,this.d=p}get(){return this.d}set(m,p,h){if(h===void 0&&this.g(this.d,m))return;let E;p||(p=E=new l(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(m),(0,P.$Ld)()?.handleObservableChanged(this,{oldValue:D,newValue:m,change:h,didChange:!0,hadValue:!0});for(const w of this.b)p.updateObserver(w,this),w.handleChange(this,h)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}e.$7d=n;function t(u,m){let p;return typeof u=="string"?p=new R.$ad(void 0,u,void 0):p=new R.$ad(u,void 0,void 0),new g(p,m,v.$6c)}class g extends n{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}e.$9d=g}),function(){function be(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function T($){O.push($,Date.now())}function A(){const $=[];for(let s=0;s<O.length;s+=2)$.push({name:O[s],startTime:O[s+1]});return $}return{mark:T,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))O.push({name:T.name,startTime:Math.round(P+T.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(Oe[144],Ne([1,0,39]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=void 0;const R=Symbol("unset");class P{constructor(){this.a=new T,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert($,s,k){this.d($,y=>y._value=s,k)}mutate($,s){this.d($,k=>k._value=s(k._value===R?void 0:k._value))}mutatePath($,s){this.d($,()=>{},k=>s(k))}delete($){const s=this.c($);if(!s)return;let k=s.length-1;const y=s[k].node._value;if(y!==R){for(this.b--,s[k].node._value=R;k>0;k--){const{node:a,part:S}=s[k];if(a.children?.size||a._value!==R)break;s[k-1].node.children.delete(S)}return y}}*deleteRecursive($){const s=this.c($);if(!s)return;const k=s[s.length-1].node;for(let y=s.length-1;y>0;y--){const a=s[y-1];if(a.node.children.delete(s[y].part),a.node.children.size>0||a.node._value!==R)break}for(const y of O(k))y._value!==R&&(this.b--,yield y._value)}find($){let s=this.a;for(const k of $){const y=s.children?.get(k);if(!y)return;s=y}return s._value===R?void 0:s._value}hasKeyOrParent($){let s=this.a;for(const k of $){const y=s.children?.get(k);if(!y)return!1;if(y._value!==R)return!0;s=y}return!1}hasKeyOrChildren($){let s=this.a;for(const k of $){const y=s.children?.get(k);if(!y)return!1;s=y}return!0}hasKey($){let s=this.a;for(const k of $){const y=s.children?.get(k);if(!y)return!1;s=y}return s._value!==R}c($){const s=[{part:"",node:this.a}];let k=0;for(const y of $){const a=s[k].node.children?.get(y);if(!a)return;s.push({part:y,node:a}),k++}return s}d($,s,k){let y=this.a;for(const d of $){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const r=new T;y.children.set(d,r),y=r}else{const r=new T;y.children=new Map([[d,r]]),y=r}k?.(y)}const a=y._value===R?0:1;s(y);const S=y._value===R?0:1;this.b+=S-a}*values(){for(const{_value:$}of O(this.a))$!==R&&(yield $)}}e.$4I=P;function*O(A){const $=[A];for(;$.length>0;){const s=$.pop();if(yield s,s.children)for(const k of s.children.values())$.push(k)}}class T{constructor(){this._value=R}get value(){return this._value===R?void 0:this._value}set value($){this._value=$===void 0?R:$}}}),define(Oe[145],Ne([1,0,48,19]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=A,e.$Ar=$,e.$Br=s,e.$Cr=k,e.$Dr=y,e.$Er=a,e.$Fr=S,e.$Gr=d,e.$Hr=r,e.$Ir=o,e.$Jr=h,e.$Kr=E,e.$Lr=D;const P=new v.$T(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),O=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(w,I,C=!1){const f=w||"",b=I||"",M=P.value.collator.compare(f,b);return P.value.collatorIsNumeric&&M===0&&f!==b?f<b?-1:1:M}function $(w,I){const C=O.value.collator;return w=w||"",I=I||"",n(C,w,I)}function s(w,I){const C=O.value.collator;return w=w||"",I=I||"",m(w,I)||n(C,w,I)}function k(w,I){const C=O.value.collator;return w=w||"",I=I||"",u(w,I)||n(C,w,I)}function y(w,I){return w=w||"",I=I||"",w===I?0:w<I?-1:1}function a(w,I){const[C,f]=l(w),[b,M]=l(I);let N=P.value.collator.compare(f,M);if(N===0){if(P.value.collatorIsNumeric&&f!==M)return f<M?-1:1;if(N=P.value.collator.compare(C,b),P.value.collatorIsNumeric&&N===0&&C!==b)return C<b?-1:1}return N}function S(w,I){w=w||"",I=I||"";const C=i(w),f=i(I),b=O.value.collator,M=T.value.collator;return n(M,C,f)||n(b,w,I)}function d(w,I){w=w||"",I=I||"";const C=i(w),f=i(I),b=O.value.collator,M=T.value.collator;return n(M,C,f)||m(w,I)||n(b,w,I)}function r(w,I){w=w||"",I=I||"";const C=i(w),f=i(I),b=O.value.collator,M=T.value.collator;return n(M,C,f)||u(w,I)||n(b,w,I)}function o(w,I){w=w||"",I=I||"";const C=i(w).toLowerCase(),f=i(I).toLowerCase();return C!==f?C<f?-1:1:w!==I?w<I?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function l(w,I=!1){const C=w?c.exec(w):[];let f=[C&&C[1]||"",C&&C[3]||""];return I&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(w){const I=w?c.exec(w):[];return I&&I[1]&&I[1].charAt(0)!=="."&&I[3]||""}function n(w,I,C){const f=w.compare(I,C);return f!==0?f:I.length!==C.length?I.length<C.length?-1:1:0}function t(w){const I=w.charAt(0);return I.toLocaleUpperCase()!==I}function g(w){const I=w.charAt(0);return I.toLocaleLowerCase()!==I}function u(w,I){return t(w)&&g(I)?-1:g(w)&&t(I)?1:0}function m(w,I){return g(w)&&t(I)?-1:t(w)&&g(I)?1:0}function p(w,I,C=!1){return C||(w=w&&w.toLowerCase(),I=I&&I.toLowerCase()),w===I?0:w<I?-1:1}function h(w,I,C=!1){const f=w.split(R.sep),b=I.split(R.sep),M=f.length-1,N=b.length-1;let F,W;for(let K=0;;K++){if(F=M===K,W=N===K,F&&W)return A(f[K],b[K],C);if(F)return-1;if(W)return 1;const L=p(f[K],b[K],C);if(L!==0)return L}}function E(w,I,C){const f=w.toLowerCase(),b=I.toLowerCase(),M=D(w,I,C);if(M)return M;const N=f.endsWith(C),F=b.endsWith(C);if(N!==F)return N?-1:1;const W=A(f,b);return W!==0?W:f.localeCompare(b)}function D(w,I,C){const f=w.toLowerCase(),b=I.toLowerCase(),M=f.startsWith(C),N=b.startsWith(C);if(M!==N)return M?-1:1;if(M&&N){if(f.length<b.length)return-1;if(f.length>b.length)return 1}return 0}}),define(Oe[72],Ne([1,0,19]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$$s=O,e.$_s=T,e.$at=A,e.$bt=s,e.$0s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(k){const y=(0,v.$oc)(k),a=R[y.toLowerCase()];return a!==void 0?a:T(k)}function T(k){const y=(0,v.$oc)(k);return P[y.toLowerCase()]}function A(k){for(const y in P)if(P[y]===k)return y}const $=/^(.+)\/(.+?)(;.+)?$/;function s(k,y){const a=$.exec(k);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:y?void 0:k}}),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var R in v)(typeof exports=="object"?exports:be)[R]=v[R]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function v(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return be[R].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=be,v.c=e,v.d=function(R,P,O){v.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:O})},v.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},v.t=function(R,P){if(1&P&&(R=v(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(v.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var T in R)v.d(O,T,function(A){return R[A]}.bind(null,T));return O},v.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return v.d(P,"a",P),P},v.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},v.p="",v(v.s=0)}([function(be,e,v){(function(R){var P;e=be.exports=Ie,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],$=e.src=[],s=0,k=s++;$[k]="0|[1-9]\\d*";var y=s++;$[y]="[0-9]+";var a=s++;$[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=s++;$[S]="("+$[k]+")\\.("+$[k]+")\\.("+$[k]+")";var d=s++;$[d]="("+$[y]+")\\.("+$[y]+")\\.("+$[y]+")";var r=s++;$[r]="(?:"+$[k]+"|"+$[a]+")";var o=s++;$[o]="(?:"+$[y]+"|"+$[a]+")";var c=s++;$[c]="(?:-("+$[r]+"(?:\\."+$[r]+")*))";var l=s++;$[l]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var i=s++;$[i]="[0-9A-Za-z-]+";var n=s++;$[n]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var t=s++,g="v?"+$[S]+$[c]+"?"+$[n]+"?";$[t]="^"+g+"$";var u="[v=\\s]*"+$[d]+$[l]+"?"+$[n]+"?",m=s++;$[m]="^"+u+"$";var p=s++;$[p]="((?:<|>)?=?)";var h=s++;$[h]=$[y]+"|x|X|\\*";var E=s++;$[E]=$[k]+"|x|X|\\*";var D=s++;$[D]="[v=\\s]*("+$[E]+")(?:\\.("+$[E]+")(?:\\.("+$[E]+")(?:"+$[c]+")?"+$[n]+"?)?)?";var w=s++;$[w]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[l]+")?"+$[n]+"?)?)?";var I=s++;$[I]="^"+$[p]+"\\s*"+$[D]+"$";var C=s++;$[C]="^"+$[p]+"\\s*"+$[w]+"$";var f=s++;$[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=s++;$[b]="(?:~>?)";var M=s++;$[M]="(\\s*)"+$[b]+"\\s+",A[M]=new RegExp($[M],"g");var N=s++;$[N]="^"+$[b]+$[D]+"$";var F=s++;$[F]="^"+$[b]+$[w]+"$";var W=s++;$[W]="(?:\\^)";var K=s++;$[K]="(\\s*)"+$[W]+"\\s+",A[K]=new RegExp($[K],"g");var L=s++;$[L]="^"+$[W]+$[D]+"$";var Q=s++;$[Q]="^"+$[W]+$[w]+"$";var X=s++;$[X]="^"+$[p]+"\\s*("+u+")$|^$";var ue=s++;$[ue]="^"+$[p]+"\\s*("+g+")$|^$";var ee=s++;$[ee]="(\\s*)"+$[p]+"\\s*("+u+"|"+$[D]+")",A[ee]=new RegExp($[ee],"g");var me=s++;$[me]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var oe=s++;$[oe]="^\\s*("+$[w]+")\\s+-\\s+("+$[w]+")\\s*$";var ce=s++;$[ce]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)P(we,$[we]),A[we]||(A[we]=new RegExp($[we]));function ae(B,H){if(B instanceof Ie)return B;if(typeof B!="string"||B.length>O||!(H?A[m]:A[t]).test(B))return null;try{return new Ie(B,H)}catch{return null}}function Ie(B,H){if(B instanceof Ie){if(B.loose===H)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Ie))return new Ie(B,H);P("SemVer",B,H),this.loose=H;var V=B.trim().match(H?A[m]:A[t]);if(!V)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+V[1],this.minor=+V[2],this.patch=+V[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");V[4]?this.prerelease=V[4].split(".").map(function(re){if(/^[0-9]+$/.test(re)){var ge=+re;if(ge>=0&&ge<T)return ge}return re}):this.prerelease=[],this.build=V[5]?V[5].split("."):[],this.format()}e.parse=ae,e.valid=function(B,H){var V=ae(B,H);return V?V.version:null},e.clean=function(B,H){var V=ae(B.trim().replace(/^[=v]+/,""),H);return V?V.version:null},e.SemVer=Ie,Ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ie.prototype.toString=function(){return this.version},Ie.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof Ie||(B=new Ie(B,this.loose)),this.compareMain(B)||this.comparePre(B)},Ie.prototype.compareMain=function(B){return B instanceof Ie||(B=new Ie(B,this.loose)),Y(this.major,B.major)||Y(this.minor,B.minor)||Y(this.patch,B.patch)},Ie.prototype.comparePre=function(B){if(B instanceof Ie||(B=new Ie(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var H=0;do{var V=this.prerelease[H],re=B.prerelease[H];if(P("prerelease compare",H,V,re),V===void 0&&re===void 0)return 0;if(re===void 0)return 1;if(V===void 0)return-1;if(V!==re)return Y(V,re)}while(++H)},Ie.prototype.inc=function(B,H){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var V=this.prerelease.length;--V>=0;)typeof this.prerelease[V]=="number"&&(this.prerelease[V]++,V=-2);V===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,H,V,re){typeof V=="string"&&(re=V,V=void 0);try{return new Ie(B,V).inc(H,re).version}catch{return null}},e.diff=function(B,H){if(le(B,H))return null;var V=ae(B),re=ae(H);if(V.prerelease.length||re.prerelease.length){for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return"pre"+ge;return"prerelease"}for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return ge},e.compareIdentifiers=Y;var Fe=/^[0-9]+$/;function Y(B,H){var V=Fe.test(B),re=Fe.test(H);return V&&re&&(B=+B,H=+H),V&&!re?-1:re&&!V?1:B<H?-1:B>H?1:0}function q(B,H,V){return new Ie(B,V).compare(new Ie(H,V))}function ne(B,H,V){return q(B,H,V)>0}function ye(B,H,V){return q(B,H,V)<0}function le(B,H,V){return q(B,H,V)===0}function ve(B,H,V){return q(B,H,V)!==0}function de(B,H,V){return q(B,H,V)>=0}function J(B,H,V){return q(B,H,V)<=0}function x(B,H,V,re){var ge;switch(H){case"===":typeof B=="object"&&(B=B.version),typeof V=="object"&&(V=V.version),ge=B===V;break;case"!==":typeof B=="object"&&(B=B.version),typeof V=="object"&&(V=V.version),ge=B!==V;break;case"":case"=":case"==":ge=le(B,V,re);break;case"!=":ge=ve(B,V,re);break;case">":ge=ne(B,V,re);break;case">=":ge=de(B,V,re);break;case"<":ge=ye(B,V,re);break;case"<=":ge=J(B,V,re);break;default:throw new TypeError("Invalid operator: "+H)}return ge}function pe(B,H){if(B instanceof pe){if(B.loose===H)return B;B=B.value}if(!(this instanceof pe))return new pe(B,H);P("comparator",B,H),this.loose=H,this.parse(B),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,H){return Y(H,B)},e.major=function(B,H){return new Ie(B,H).major},e.minor=function(B,H){return new Ie(B,H).minor},e.patch=function(B,H){return new Ie(B,H).patch},e.compare=q,e.compareLoose=function(B,H){return q(B,H,!0)},e.rcompare=function(B,H,V){return q(H,B,V)},e.sort=function(B,H){return B.sort(function(V,re){return e.compare(V,re,H)})},e.rsort=function(B,H){return B.sort(function(V,re){return e.rcompare(V,re,H)})},e.gt=ne,e.lt=ye,e.eq=le,e.neq=ve,e.gte=de,e.lte=J,e.cmp=x,e.Comparator=pe;var $e={};function Ae(B,H){if(B instanceof Ae)return B.loose===H?B:new Ae(B.raw,H);if(B instanceof pe)return new Ae(B.value,H);if(!(this instanceof Ae))return new Ae(B,H);if(this.loose=H,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(V){return this.parseRange(V.trim())},this).filter(function(V){return V.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function Ue(B){return!B||B.toLowerCase()==="x"||B==="*"}function ke(B,H,V,re,ge,Ce,ze,Qe,_e,tt,nt,et,rt){return((H=Ue(V)?"":Ue(re)?">="+V+".0.0":Ue(ge)?">="+V+"."+re+".0":">="+H)+" "+(Qe=Ue(_e)?"":Ue(tt)?"<"+(+_e+1)+".0.0":Ue(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Qe)).trim()}function Pe(B,H){for(var V=0;V<B.length;V++)if(!B[V].test(H))return!1;if(H.prerelease.length){for(V=0;V<B.length;V++)if(P(B[V].semver),B[V].semver!==$e&&B[V].semver.prerelease.length>0){var re=B[V].semver;if(re.major===H.major&&re.minor===H.minor&&re.patch===H.patch)return!0}return!1}return!0}function Te(B,H,V){try{H=new Ae(H,V)}catch{return!1}return H.test(B)}function j(B,H,V,re){var ge,Ce,ze,Qe,_e;switch(B=new Ie(B,re),H=new Ae(H,re),V){case">":ge=ne,Ce=J,ze=ye,Qe=">",_e=">=";break;case"<":ge=ye,Ce=de,ze=ne,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(B,H,re))return!1;for(var tt=0;tt<H.set.length;++tt){var nt=H.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===$e&&(ft=new pe(">=0.0.0")),et=et||ft,rt=rt||ft,ge(ft.semver,et.semver,re)?et=ft:ze(ft.semver,rt.semver,re)&&(rt=ft)}),et.operator===Qe||et.operator===_e||(!rt.operator||rt.operator===Qe)&&Ce(B,rt.semver)||rt.operator===_e&&ze(B,rt.semver))return!1}return!0}pe.prototype.parse=function(B){var H=this.loose?A[X]:A[ue],V=B.match(H);if(!V)throw new TypeError("Invalid comparator: "+B);this.operator=V[1],this.operator==="="&&(this.operator=""),V[2]?this.semver=new Ie(V[2],this.loose):this.semver=$e},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===$e||(typeof B=="string"&&(B=new Ie(B,this.loose)),x(B,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(B,H){if(!(B instanceof pe))throw new TypeError("a Comparator is required");var V;if(this.operator==="")return V=new Ae(B.value,H),Te(this.value,V,H);if(B.operator==="")return V=new Ae(this.value,H),Te(B.semver,V,H);var re=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ce=this.semver.version===B.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Qe=x(this.semver,"<",B.semver,H)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),_e=x(this.semver,">",B.semver,H)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return re||ge||Ce&&ze||Qe||_e},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(B){var H=this.loose;B=B.trim(),P("range",B,H);var V=H?A[oe]:A[me];B=B.replace(V,ke),P("hyphen replace",B),B=B.replace(A[ee],"$1$2$3"),P("comparator trim",B,A[ee]),B=(B=(B=B.replace(A[M],"$1~")).replace(A[K],"$1^")).split(/\s+/).join(" ");var re=H?A[X]:A[ue],ge=B.split(" ").map(function(Ce){return function(ze,Qe){return P("comp",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){P("caret",et,rt);var ft=rt?A[Q]:A[L];return et.replace(ft,function(lt,st,ct,gt,$t){var qe;return P("caret",et,lt,st,ct,gt,$t),Ue(st)?qe="":Ue(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(gt)?qe=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":$t?(P("replaceCaret pr",$t),$t.charAt(0)!=="-"&&($t="-"+$t),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+$t+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+$t+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+$t+" <"+(+st+1)+".0.0"):(P("no pr"),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+" <"+(+st+1)+".0.0"),P("caret return",qe),qe})}(nt,tt)}).join(" ")}(ze,Qe),P("caret",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?A[F]:A[N];return et.replace(ft,function(lt,st,ct,gt,$t){var qe;return P("tilde",et,lt,st,ct,gt,$t),Ue(st)?qe="":Ue(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(gt)?qe=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":$t?(P("replaceTilde pr",$t),$t.charAt(0)!=="-"&&($t="-"+$t),qe=">="+st+"."+ct+"."+gt+$t+" <"+st+"."+(+ct+1)+".0"):qe=">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0",P("tilde return",qe),qe})}(nt,tt)}).join(" ")}(ze,Qe),P("tildes",ze),ze=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?A[C]:A[I];return et.replace(ft,function(lt,st,ct,gt,$t,qe){P("xRange",et,lt,st,ct,gt,$t,qe);var je=Ue(ct),te=je||Ue(gt),_=te||Ue($t);return st==="="&&_&&(st=""),je?lt=st===">"||st==="<"?"<0.0.0":"*":st&&_?(te&&(gt=0),_&&($t=0),st===">"?(st=">=",te?(ct=+ct+1,gt=0,$t=0):_&&(gt=+gt+1,$t=0)):st==="<="&&(st="<",te?ct=+ct+1:gt=+gt+1),lt=st+ct+"."+gt+"."+$t):te?lt=">="+ct+".0.0 <"+(+ct+1)+".0.0":_&&(lt=">="+ct+"."+gt+".0 <"+ct+"."+(+gt+1)+".0"),P("xRange return",lt),lt})}(nt,tt)}).join(" ")}(ze,Qe),P("xrange",ze),ze=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(A[ce],"")}(ze,Qe),P("stars",ze),ze}(Ce,H)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ce){return!!Ce.match(re)})),ge=ge.map(function(Ce){return new pe(Ce,H)})},Ae.prototype.intersects=function(B,H){if(!(B instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(V){return V.every(function(re){return B.set.some(function(ge){return ge.every(function(Ce){return re.intersects(Ce,H)})})})})},e.toComparators=function(B,H){return new Ae(B,H).set.map(function(V){return V.map(function(re){return re.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new Ie(B,this.loose));for(var H=0;H<this.set.length;H++)if(Pe(this.set[H],B))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(B,H,V){var re=null,ge=null;try{var Ce=new Ae(H,V)}catch{return null}return B.forEach(function(ze){Ce.test(ze)&&(re&&ge.compare(ze)!==-1||(ge=new Ie(re=ze,V)))}),re},e.minSatisfying=function(B,H,V){var re=null,ge=null;try{var Ce=new Ae(H,V)}catch{return null}return B.forEach(function(ze){Ce.test(ze)&&(re&&ge.compare(ze)!==1||(ge=new Ie(re=ze,V)))}),re},e.validRange=function(B,H){try{return new Ae(B,H).range||"*"}catch{return null}},e.ltr=function(B,H,V){return j(B,H,"<",V)},e.gtr=function(B,H,V){return j(B,H,">",V)},e.outside=j,e.prerelease=function(B,H){var V=ae(B,H);return V&&V.prerelease.length?V.prerelease:null},e.intersects=function(B,H,V){return B=new Ae(B,V),H=new Ae(H,V),B.intersects(H)},e.coerce=function(B){if(B instanceof Ie)return B;if(typeof B!="string")return null;var H=B.match(A[f]);return H==null?null:ae((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,v(1))},function(be,e){var v,R,P=be.exports={};function O(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function A(o){if(v===setTimeout)return setTimeout(o,0);if((v===O||!v)&&setTimeout)return v=setTimeout,setTimeout(o,0);try{return v(o,0)}catch{try{return v.call(null,o,0)}catch{return v.call(this,o,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:O}catch{v=O}try{R=typeof clearTimeout=="function"?clearTimeout:T}catch{R=T}})();var $,s=[],k=!1,y=-1;function a(){k&&$&&(k=!1,$.length?s=$.concat(s):y=-1,s.length&&S())}function S(){if(!k){var o=A(a);k=!0;for(var c=s.length;c;){for($=s,s=[];++y<c;)$&&$[y].run();y=-1,c=s.length}$=null,k=!1,function(l){if(R===clearTimeout)return clearTimeout(l);if((R===T||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(l);try{R(l)}catch{try{return R.call(null,l)}catch{return R.call(this,l)}}}(o)}}function d(o,c){this.fun=o,this.array=c}function r(){}P.nextTick=function(o){var c=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)c[l-1]=arguments[l];s.push(new d(o,c)),s.length!==1||k||A(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Oe[146],Ne([1,0,6,4]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=e.$ct=e.ScrollbarVisibility=void 0;var P;(function(S){S[S.Auto=1]="Auto",S[S.Hidden=2]="Hidden",S[S.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(d,r,o,c,l,i,n){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,o=o|0,c=c|0,l=l|0,i=i|0,n=n|0),this.rawScrollLeft=c,this.rawScrollTop=n,r<0&&(r=0),c+r>o&&(c=o-r),c<0&&(c=0),l<0&&(l=0),n+l>i&&(n=i-l),n<0&&(n=0),this.width=r,this.scrollWidth=o,this.scrollLeft=c,this.height=l,this.scrollHeight=i,this.scrollTop=n}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const o=this.width!==d.width,c=this.scrollWidth!==d.scrollWidth,l=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,n=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:c,scrollLeftChanged:l,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$ct=O;class T extends R.$Uc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$le),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const o=this.g.withScrollDimensions(d,r);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let c;r?c=new k(this.h.from,o,this.h.startTime,this.h.duration):c=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=c}else{const o=this.g.withScrollPosition(d);this.h=k.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,r)))}}e.$dt=T;class A{constructor(d,r,o){this.scrollLeft=d,this.scrollTop=r,this.isDone=o}}e.$et=A;function $(S,d){const r=d-S;return function(o){return S+r*a(o)}}function s(S,d,r){return function(o){return o<r?S(o/r):d((o-r)/(1-r))}}class k{constructor(d,r,o,c){this.from=d,this.to=r,this.duration=c,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,o){if(Math.abs(d-r)>2.5*o){let l,i;return d<r?(l=d+.75*o,i=r-.75*o):(l=d-.75*o,i=r+.75*o),s($(d,l),$(i,r),.33)}return $(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const o=this.c(r),c=this.d(r);return new A(o,c,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,o){return k.start(d,r,o)}static start(d,r,o){o=o+10;const c=Date.now()-10;return new k(d,r,c,o)}}e.$ft=k;function y(S){return Math.pow(S,3)}function a(S){return 1-y(1-S)}}),define(Oe[147],Ne([1,0,13,4]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=P,e.$ze=O,e.$Ae=T,e.$Be=A,e.$Ce=s,e.$De=k,e.$Ee=y,e.$Fe=a,e.$Ge=S,e.$He=d,e.$Ie=r,e.$Je=o,e.$Ke=c,e.$Le=l,e.$Me=i;function P(n){const t=n;return t?typeof t.read=="function":!1}function O(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(g=>typeof g=="function"):!1}function T(n){const t=n;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function A(n,t){return new $(n,t)}class ${constructor(t,g){this.e=t,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(g=>g(t))}h(t){this.c.error.length===0?(0,v.$Y)(t):this.c.error.slice(0).forEach(g=>g(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,g){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(t,g){if(this.a.destroyed)return;let u;switch(t){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const m=u.indexOf(g);m>=0&&u.splice(m,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(n,t){const g=[];let u;for(;(u=n.read())!==null;)g.push(u);return t(g)}function k(n,t,g){const u=[];let m;for(;(m=n.read())!==null&&u.length<g;)u.push(m);return m===null&&u.length>0?t(u):{read:()=>{if(u.length>0)return u.shift();if(typeof m<"u"){const p=m;return m=void 0,p}return n.read()}}}function y(n,t){return new Promise((g,u)=>{const m=[];a(n,{onData:p=>{t&&m.push(p)},onError:p=>{t?u(p):g(void 0)},onEnd:()=>{g(t?t(m):void 0)}})})}function a(n,t,g){n.on("error",u=>{g?.isCancellationRequested||t.onError(u)}),n.on("end",()=>{g?.isCancellationRequested||t.onEnd()}),n.on("data",u=>{g?.isCancellationRequested||t.onData(u)})}function S(n,t){return new Promise((g,u)=>{const m=new R.$Tc,p=[],h=w=>{if(p.push(w),p.length>t)return m.dispose(),n.pause(),g({stream:n,buffer:p,ended:!1})},E=w=>(m.dispose(),u(w)),D=()=>(m.dispose(),g({stream:n,buffer:p,ended:!0}));m.add((0,R.$Sc)(()=>n.removeListener("error",E))),n.on("error",E),m.add((0,R.$Sc)(()=>n.removeListener("end",D))),n.on("end",D),m.add((0,R.$Sc)(()=>n.removeListener("data",h))),n.on("data",h)})}function d(n,t){const g=A(t);return g.end(n),g}function r(){const n=A(()=>{throw new Error("not supported")});return n.end(),n}function o(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function c(n,t,g){const u=A(g);return a(n,{onData:m=>u.write(t.data(m)),onError:m=>u.error(t.error?t.error(m):m),onEnd:()=>u.end()}),u}function l(n,t,g){let u=!1;return{read:()=>{const m=t.read();return u?m:(u=!0,m!==null?g([n,m]):n)}}}function i(n,t,g){let u=!1;const m=A(g);return a(t,{onData:p=>u?m.write(p):(u=!0,m.write(g([n,p]))),onError:p=>m.error(p),onEnd:()=>{u||(u=!0,m.write(n)),m.end()}}),m}}),define(Oe[22],Ne([1,0,48,147]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=s,e.$Pe=k,e.$Qe=y,e.$Re=a,e.$Se=S,e.$Te=d,e.$Ue=r,e.$Ve=o,e.$We=c,e.$Xe=l,e.$Ye=i,e.$Ze=n,e.$1e=t,e.$2e=g,e.$3e=u,e.$4e=m,e.$5e=p,e.$6e=h,e.$7e=E,e.$8e=I,R=We(R);const P=typeof Buffer<"u",O=new v.$T(()=>new Uint8Array(256));let T,A;class ${static alloc(f){return P?new $(Buffer.allocUnsafe(f)):new $(new Uint8Array(f))}static wrap(f){return P&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new $(f)}static fromString(f,b){return!(b?.dontUseNodeBuffer||!1)&&P?new $(Buffer.from(f)):(T||(T=new TextEncoder),new $(T.encode(f)))}static fromByteArray(f){const b=$.alloc(f.length);for(let M=0,N=f.length;M<N;M++)b.buffer[M]=f[M];return b}static concat(f,b){if(typeof b>"u"){b=0;for(let F=0,W=f.length;F<W;F++)b+=f[F].byteLength}const M=$.alloc(b);let N=0;for(let F=0,W=f.length;F<W;F++){const K=f[F];M.set(K,N),N+=K.byteLength}return M}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=$.alloc(this.byteLength);return f.set(this),f}toString(){return P?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(f,b){return new $(this.buffer.subarray(f,b))}set(f,b){if(f instanceof $)this.buffer.set(f.buffer,b);else if(f instanceof Uint8Array)this.buffer.set(f,b);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),b);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return a(this.buffer,f)}writeUInt32BE(f,b){S(this.buffer,f,b)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,b){r(this.buffer,f,b)}readUInt8(f){return o(this.buffer,f)}writeUInt8(f,b){c(this.buffer,f,b)}indexOf(f,b=0){return s(this.buffer,f instanceof $?f.buffer:f,b)}}e.$Ne=$;function s(C,f,b=0){const M=f.byteLength,N=C.byteLength;if(M===0)return 0;if(M===1)return C.indexOf(f[0]);if(M>N-b)return-1;const F=O.value;F.fill(f.length);for(let Q=0;Q<f.length;Q++)F[f[Q]]=f.length-Q-1;let W=b+f.length-1,K=W,L=-1;for(;W<N;)if(C[W]===f[K]){if(K===0){L=W;break}W--,K--}else W+=Math.max(f.length-K,F[C[W]]),K=f.length-1;return L}function k(C,f){return C[f+0]<<0>>>0|C[f+1]<<8>>>0}function y(C,f,b){C[b+0]=f&255,f=f>>>8,C[b+1]=f&255}function a(C,f){return C[f]*2**24+C[f+1]*2**16+C[f+2]*2**8+C[f+3]}function S(C,f,b){C[b+3]=f,f=f>>>8,C[b+2]=f,f=f>>>8,C[b+1]=f,f=f>>>8,C[b]=f}function d(C,f){return C[f+0]<<0>>>0|C[f+1]<<8>>>0|C[f+2]<<16>>>0|C[f+3]<<24>>>0}function r(C,f,b){C[b+0]=f&255,f=f>>>8,C[b+1]=f&255,f=f>>>8,C[b+2]=f&255,f=f>>>8,C[b+3]=f&255}function o(C,f){return C[f]}function c(C,f,b){C[b]=f}function l(C){return R.$Ce(C,f=>$.concat(f))}function i(C){return R.$Je(C)}function n(C){return R.$Ee(C,f=>$.concat(f))}async function t(C){return C.ended?$.concat(C.buffer):$.concat([...C.buffer,await n(C.stream)])}function g(C){return R.$He(C,f=>$.concat(f))}function u(C){return R.$Ke(C,{data:f=>typeof f=="string"?$.fromString(f):$.wrap(f)},f=>$.concat(f))}function m(C){return R.$Be(f=>$.concat(f),C)}function p(C,f){return R.$Le(C,f,b=>$.concat(b))}function h(C,f){return R.$Me(C,f,b=>$.concat(b))}function E(C){let f=0,b=0,M=0;const N=new Uint8Array(Math.floor(C.length/4*3)),F=K=>{switch(b){case 3:N[M++]=f|K,b=0;break;case 2:N[M++]=f|K>>>2,f=K<<6,b=3;break;case 1:N[M++]=f|K>>>4,f=K<<4,b=2;break;default:f=K<<2,b=1}};for(let K=0;K<C.length;K++){const L=C.charCodeAt(K);if(L>=65&&L<=90)F(L-65);else if(L>=97&&L<=122)F(L-97+26);else if(L>=48&&L<=57)F(L-48+52);else if(L===43||L===45)F(62);else if(L===47||L===95)F(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${C[K]}`)}}const W=M;for(;b>0;)F(0);return $.wrap(N).slice(0,W)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:C},f=!0,b=!1){const M=b?w:D;let N="";const F=C.byteLength%3;let W=0;for(;W<C.byteLength-F;W+=3){const K=C[W+0],L=C[W+1],Q=C[W+2];N+=M[K>>>2],N+=M[(K<<4|L>>>4)&63],N+=M[(L<<2|Q>>>6)&63],N+=M[Q&63]}if(F===1){const K=C[W+0];N+=M[K>>>2],N+=M[K<<4&63],f&&(N+="==")}else if(F===2){const K=C[W+0],L=C[W+1];N+=M[K>>>2],N+=M[(K<<4|L>>>4)&63],N+=M[L<<2&63],f&&(N+="=")}return N}}),define(Oe[148],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(Oe[34],Ne([1,0,97]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$5j=P;var R;(function(T){function A($){return $&&typeof $=="object"&&typeof $.id=="string"}T.isThemeColor=A})(R||(e.ThemeColor=R={}));function P(T){return{id:T}}var O;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function $(l){const i=A.exec(l.id);if(!i)return $(v.$4j.error);const[,n,t]=i,g=["codicon","codicon-"+n];return t&&g.push("codicon-modifier-"+t.substring(1)),g}T.asClassNameArray=$;function s(l){return $(l).join(" ")}T.asClassName=s;function k(l){return"."+$(l).join(".")}T.asCSSSelector=k;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||R.isThemeColor(l.color))}T.isThemeIcon=y;const a=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function S(l){const i=a.exec(l);if(!i)return;const[,n]=i;return{id:n}}T.fromString=S;function d(l){return{id:l}}T.fromId=d;function r(l,i){let n=l.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}T.modify=r;function o(l){const i=l.id.lastIndexOf("~");if(i!==-1)return l.id.substring(i+1)}T.getModifier=o;function c(l,i){return l.id===i.id&&l.color?.id===i.color?.id}T.isEqual=c})(O||(e.ThemeIcon=O={}))}),define(Oe[51],Ne([1,0,27,19,20,12,14]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=A,e.$xg=$,e.$yg=s,e.$zg=k,e.$Ag=y,e.$Bg=r,e.$Cg=o,e.$Dg=c,e.$Eg=l,e.$Fg=i,e.$Gg=n,e.$Hg=t,e.$Ig=g,e.$Jg=u,e.$Kg=m,e.$Lg=p,e.$Mg=D;function A(w){return w===v.CharCode.Slash||w===v.CharCode.Backslash}function $(w){return w.replace(/[\\/]/g,R.$gc.sep)}function s(w){return w.indexOf("/")===-1&&(w=$(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function k(w,I=R.$gc.sep){if(!w)return"";const C=w.length,f=w.charCodeAt(0);if(A(f)){if(A(w.charCodeAt(1))&&!A(w.charCodeAt(2))){let M=3;const N=M;for(;M<C&&!A(w.charCodeAt(M));M++);if(N!==M&&!A(w.charCodeAt(M+1))){for(M+=1;M<C;M++)if(A(w.charCodeAt(M)))return w.slice(0,M+1).replace(/[\\/]/g,I)}}return I}else if(l(f)&&w.charCodeAt(1)===v.CharCode.Colon)return A(w.charCodeAt(2))?w.slice(0,2)+I:w.slice(0,2);let b=w.indexOf("://");if(b!==-1){for(b+=3;b<C;b++)if(A(w.charCodeAt(b)))return w.slice(0,b+1)}return""}function y(w){if(!P.$j||!w||w.length<5)return!1;let I=w.charCodeAt(0);if(I!==v.CharCode.Backslash||(I=w.charCodeAt(1),I!==v.CharCode.Backslash))return!1;let C=2;const f=C;for(;C<w.length&&(I=w.charCodeAt(C),I!==v.CharCode.Backslash);C++);return!(f===C||(I=w.charCodeAt(C+1),isNaN(I)||I===v.CharCode.Backslash))}const a=/[\\/:\*\?"<>\|]/g,S=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(w,I=P.$j){const C=I?a:S;return!(!w||w.length===0||/^\s+$/.test(w)||(C.lastIndex=0,C.test(w))||I&&d.test(w)||w==="."||w===".."||I&&w[w.length-1]==="."||I&&w.length!==w.trim().length||w.length>255)}function o(w,I,C){const f=w===I;return!C||f?f:!w||!I?!1:(0,O.$Ff)(w,I)}function c(w,I,C,f=R.sep){if(w===I)return!0;if(!w||!I||I.length>w.length)return!1;if(C){if(!(0,O.$Gf)(w,I))return!1;if(I.length===w.length)return!0;let M=I.length;return I.charAt(I.length-1)===f&&M--,w.charAt(M)===f}return I.charAt(I.length-1)!==f&&(I+=f),w.indexOf(I)===0}function l(w){return w>=v.CharCode.A&&w<=v.CharCode.Z||w>=v.CharCode.a&&w<=v.CharCode.z}function i(w,I){return P.$j&&w.endsWith(":")&&(w+=R.sep),(0,R.$ic)(w)||(w=(0,R.$jc)(I,w)),w=(0,R.$hc)(w),n(w)}function n(w){return P.$j?(w=(0,O.$nf)(w,R.sep),w.endsWith(":")&&(w+=R.sep)):(w=(0,O.$nf)(w,R.sep),w||(w=R.sep)),w}function t(w){const I=(0,R.$hc)(w);return P.$j?w.length>3?!1:g(I)&&(w.length===2||I.charCodeAt(2)===v.CharCode.Backslash):I===R.$gc.sep}function g(w,I=P.$j){return I?l(w.charCodeAt(0))&&w.charCodeAt(1)===v.CharCode.Colon:!1}function u(w,I=P.$j){return g(w,I)?w[0]:void 0}function m(w,I,C){return I.length>w.length?-1:w===I?0:(C&&(w=w.toLowerCase(),I=I.toLowerCase()),w.indexOf(I))}function p(w){const I=w.split(":");let C,f,b;for(const M of I){const N=Number(M);(0,T.$ig)(N)?f===void 0?f=N:b===void 0&&(b=N):C=C?[C,M].join(":"):M}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:f!==void 0?f:void 0,column:b!==void 0?b:f!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(w,I,C=8){let f="";for(let M=0;M<C;M++){let N;M===0&&P.$j&&!I&&(C===3||C===4)?N=E:N=h,f+=N.charAt(Math.floor(Math.random()*N.length))}let b;return I?b=`${I}-${f}`:b=f,w?(0,R.$jc)(w,b):b}}),define(Oe[149],Ne([1,0,27,28,139,12]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=T,e.$Ik=$,e.$Jk=s,e.$Kk=a,e.$Lk=D,e.$Mk=w,e.$Nk=N,e.$Ok=F,e.$Pk=W,e.$Qk=K,e.$Rk=ne,e.$Tk=de,e.$Uk=pe,e.$Vk=$e,O=We(O);function T(...ke){return function(Pe,Te){for(let j=0,B=ke.length;j<B;j++){const H=ke[j](Pe,Te);if(H)return H}return null}}e.$Gk=A.bind(void 0,!1),e.$Hk=A.bind(void 0,!0);function A(ke,Pe,Te){if(!Te||Te.length<Pe.length)return null;let j;return ke?j=O.$Gf(Te,Pe):j=Te.indexOf(Pe)===0,j?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function $(ke,Pe){const Te=Pe.toLowerCase().indexOf(ke.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ke.length}]}function s(ke,Pe){return k(ke.toLowerCase(),Pe.toLowerCase(),0,0)}function k(ke,Pe,Te,j){if(Te===ke.length)return[];if(j===Pe.length)return null;if(ke[Te]===Pe[j]){let B=null;return(B=k(ke,Pe,Te+1,j+1))?t({start:j,end:j+1},B):null}return k(ke,Pe,Te,j+1)}function y(ke){return v.CharCode.a<=ke&&ke<=v.CharCode.z}function a(ke){return v.CharCode.A<=ke&&ke<=v.CharCode.Z}function S(ke){return v.CharCode.Digit0<=ke&&ke<=v.CharCode.Digit9}function d(ke){return ke===v.CharCode.Space||ke===v.CharCode.Tab||ke===v.CharCode.LineFeed||ke===v.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>r.add(ke.charCodeAt(0)));function o(ke){return d(ke)||r.has(ke)}function c(ke,Pe){return ke===Pe||o(ke)&&o(Pe)}const l=new Map;function i(ke){if(l.has(ke))return l.get(ke);let Pe;const Te=(0,P.$Ek)(ke);return Te&&(Pe=Te),l.set(ke,Pe),Pe}function n(ke){return y(ke)||a(ke)||S(ke)}function t(ke,Pe){return Pe.length===0?Pe=[ke]:ke.end===Pe[0].start?Pe[0].start=ke.start:Pe.unshift(ke),Pe}function g(ke,Pe){for(let Te=Pe;Te<ke.length;Te++){const j=ke.charCodeAt(Te);if(a(j)||S(j)||Te>0&&!n(ke.charCodeAt(Te-1)))return Te}return ke.length}function u(ke,Pe,Te,j){if(Te===ke.length)return[];if(j===Pe.length)return null;if(ke[Te]!==Pe[j].toLowerCase())return null;{let B=null,H=j+1;for(B=u(ke,Pe,Te+1,j+1);!B&&(H=g(Pe,H))<Pe.length;)B=u(ke,Pe,Te+1,H),H++;return B===null?null:t({start:j,end:j+1},B)}}function m(ke){let Pe=0,Te=0,j=0,B=0,H=0;for(let ze=0;ze<ke.length;ze++)H=ke.charCodeAt(ze),a(H)&&Pe++,y(H)&&Te++,n(H)&&j++,S(H)&&B++;const V=Pe/ke.length,re=Te/ke.length,ge=j/ke.length,Ce=B/ke.length;return{upperPercent:V,lowerPercent:re,alphaPercent:ge,numericPercent:Ce}}function p(ke){const{upperPercent:Pe,lowerPercent:Te}=ke;return Te===0&&Pe>.6}function h(ke){const{upperPercent:Pe,lowerPercent:Te,alphaPercent:j,numericPercent:B}=ke;return Te>.2&&Pe<.8&&j>.6&&B<.2}function E(ke){let Pe=0,Te=0,j=0,B=0;for(let H=0;H<ke.length;H++)j=ke.charCodeAt(H),a(j)&&Pe++,y(j)&&Te++,d(j)&&B++;return(Pe===0||Te===0)&&B===0?ke.length<=30:Pe<=5}function D(ke,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!E(ke))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Te=m(Pe);if(!h(Te)){if(!p(Te))return null;Pe=Pe.toLowerCase()}let j=null,B=0;for(ke=ke.toLowerCase();B<Pe.length&&(j=u(ke,Pe,0,B))===null;)B=g(Pe,B+1);return j}function w(ke,Pe,Te=!1){if(!Pe||Pe.length===0)return null;let j=null,B=0;for(ke=ke.toLowerCase(),Pe=Pe.toLowerCase();B<Pe.length&&(j=I(ke,Pe,0,B,Te),j===null);)B=C(Pe,B+1);return j}function I(ke,Pe,Te,j,B){let H=0;if(Te===ke.length)return[];if(j===Pe.length)return null;if(!c(ke.charCodeAt(Te),Pe.charCodeAt(j))){const ge=i(ke.charCodeAt(Te));if(!ge)return null;for(let Ce=0;Ce<ge.length;Ce++)if(!c(ge[Ce],Pe.charCodeAt(j+Ce)))return null;H+=ge.length-1}let V=null,re=j+H+1;if(V=I(ke,Pe,Te+1,re,B),!B)for(;!V&&(re=C(Pe,re))<Pe.length;)V=I(ke,Pe,Te+1,re,B),re++;if(!V)return null;if(ke.charCodeAt(Te)!==Pe.charCodeAt(j)){const ge=i(ke.charCodeAt(Te));if(!ge)return V;for(let Ce=0;Ce<ge.length;Ce++)if(ge[Ce]!==Pe.charCodeAt(j+Ce))return V}return t({start:j,end:j+H+1},V)}function C(ke,Pe){for(let Te=Pe;Te<ke.length;Te++)if(o(ke.charCodeAt(Te))||Te>0&&o(ke.charCodeAt(Te-1)))return Te;return ke.length}const f=T(e.$Hk,D,$),b=T(e.$Hk,D,s),M=new R.$Dc(1e4);function N(ke,Pe,Te=!1){if(typeof ke!="string"||typeof Pe!="string")return null;let j=M.get(ke);j||(j=new RegExp(O.$of(ke),"i"),M.set(ke,j));const B=j.exec(Pe);return B?[{start:B.index,end:B.index+B[0].length}]:Te?b(ke,Pe):f(ke,Pe)}function F(ke,Pe){const Te=de(ke,ke.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?K(Te):null}function W(ke,Pe,Te,j,B,H){const V=Math.min(13,ke.length);for(;Te<V;Te++){const re=de(ke,Pe,Te,j,B,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return re}return[0,H]}function K(ke){if(typeof ke>"u")return[];const Pe=[],Te=ke[1];for(let j=ke.length-1;j>1;j--){const B=ke[j]+Te,H=Pe[Pe.length-1];H&&H.end===B?H.end=B+1:Pe.push({start:B,end:B+1})}return Pe}const L=128;function Q(){const ke=[],Pe=[];for(let Te=0;Te<=L;Te++)Pe[Te]=0;for(let Te=0;Te<=L;Te++)ke.push(Pe.slice(0));return ke}function X(ke){const Pe=[];for(let Te=0;Te<=ke;Te++)Pe[Te]=0;return Pe}const ue=X(2*L),ee=X(2*L),me=Q(),oe=Q(),ce=Q(),we=!1;function ae(ke,Pe,Te,j,B){function H(re,ge,Ce=" "){for(;re.length<ge;)re=Ce+re;return re}let V=` |   |${j.split("").map(re=>H(re,3)).join("|")}
`;for(let re=0;re<=Te;re++)re===0?V+=" |":V+=`${Pe[re-1]}|`,V+=ke[re].slice(0,B+1).map(ge=>H(ge.toString(),3)).join("|")+`
`;return V}function Ie(ke,Pe,Te,j){ke=ke.substr(Pe),Te=Te.substr(j),console.log(ae(oe,ke,ke.length,Te,Te.length)),console.log(ae(ce,ke,ke.length,Te,Te.length)),console.log(ae(me,ke,ke.length,Te,Te.length))}function Fe(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;const Te=ke.codePointAt(Pe);switch(Te){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Yf(Te)}}function Y(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;switch(ke.charCodeAt(Pe)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function q(ke,Pe,Te){return Pe[ke]!==Te[ke]}function ne(ke,Pe,Te,j,B,H,V=!1){for(;Pe<Te&&B<H;)ke[Pe]===j[B]&&(V&&(ue[Pe]=B),Pe+=1),B+=1;return Pe===Te}var ye;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var le;(function(ke){ke.Default=[-100,0];function Pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ke.isDefault=Pe})(le||(e.FuzzyScore=le={}));class ve{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Te){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Te}}e.$Sk=ve;function de(ke,Pe,Te,j,B,H,V=ve.default){const re=ke.length>L?L:ke.length,ge=j.length>L?L:j.length;if(Te>=re||H>=ge||re-Te>ge-H||!ne(Pe,Te,re,B,H,ge,!0))return;J(re,ge,Te,H,Pe,B);let Ce=1,ze=1,Qe=Te,_e=H;const tt=[!1];for(Ce=1,Qe=Te;Qe<re;Ce++,Qe++){const lt=ue[Qe],st=ee[Qe],ct=Qe+1<re?ee[Qe+1]:ge;for(ze=lt-H+1,_e=lt;_e<ct;ze++,_e++){let gt=Number.MIN_SAFE_INTEGER,$t=!1;_e<=st&&(gt=x(ke,Pe,Qe,Te,j,B,_e,ge,H,me[Ce-1][ze-1]===0,tt));let qe=0;gt!==Number.MAX_SAFE_INTEGER&&($t=!0,qe=gt+oe[Ce-1][ze-1]);const je=_e>lt,te=je?oe[Ce][ze-1]+(me[Ce][ze-1]>0?-5:0):0,_=_e>lt+1&&me[Ce][ze-1]>0,Z=_?oe[Ce][ze-2]+(me[Ce][ze-2]>0?-5:0):0;if(_&&(!je||Z>=te)&&(!$t||Z>=qe))oe[Ce][ze]=Z,ce[Ce][ze]=ye.LeftLeft,me[Ce][ze]=0;else if(je&&(!$t||te>=qe))oe[Ce][ze]=te,ce[Ce][ze]=ye.Left,me[Ce][ze]=0;else if($t)oe[Ce][ze]=qe,ce[Ce][ze]=ye.Diag,me[Ce][ze]=me[Ce-1][ze-1]+1;else throw new Error("not possible")}}if(we&&Ie(ke,Te,j,H),!tt[0]&&!V.firstMatchCanBeWeak)return;Ce--,ze--;const nt=[oe[Ce][ze],H];let et=0,rt=0;for(;Ce>=1;){let lt=ze;do{const st=ce[Ce][lt];if(st===ye.LeftLeft)lt=lt-2;else if(st===ye.Left)lt=lt-1;else break}while(lt>=1);et>1&&Pe[Te+Ce-1]===B[H+ze-1]&&!q(lt+H-1,j,B)&&et+1>me[Ce][lt]&&(lt=ze),lt===ze?et++:et=1,rt||(rt=lt),Ce--,ze=lt-1,nt.push(ze)}ge-H===re&&V.boostFullMatch&&(nt[0]+=2);const ft=rt-re;return nt[0]-=ft,nt}function J(ke,Pe,Te,j,B,H){let V=ke-1,re=Pe-1;for(;V>=Te&&re>=j;)B[V]===H[re]&&(ee[V]=re,V--),re--}function x(ke,Pe,Te,j,B,H,V,re,ge,Ce,ze){if(Pe[Te]!==H[V])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return V===Te-j?Qe=ke[Te]===B[V]?7:5:q(V,B,H)&&(V===0||!q(V-1,B,H))?(Qe=ke[Te]===B[V]?7:5,_e=!0):Fe(H,V)&&(V===0||!Fe(H,V-1))?Qe=5:(Fe(H,V-1)||Y(H,V-1))&&(Qe=5,_e=!0),Qe>1&&Te===j&&(ze[0]=!0),_e||(_e=q(V,B,H)||Fe(H,V-1)||Y(H,V-1)),Te===j?V>ge&&(Qe-=_e?3:5):Ce?Qe+=_e?2:0:Qe+=_e?0:1,V+1===re&&(Qe-=_e?3:5),Qe}function pe(ke,Pe,Te,j,B,H,V){return Ae(ke,Pe,Te,j,B,H,!0,V)}function $e(ke,Pe,Te,j,B,H,V){return Ae(ke,Pe,Te,j,B,H,!1,V)}function Ae(ke,Pe,Te,j,B,H,V,re){let ge=de(ke,Pe,Te,j,B,H,re);if(ge&&!V)return ge;if(ke.length>=3){const Ce=Math.min(7,ke.length-1);for(let ze=Te+1;ze<Ce;ze++){const Qe=Ue(ke,ze);if(Qe){const _e=de(Qe,Qe.toLowerCase(),Te,j,B,H,re);_e&&(_e[0]-=3,(!ge||_e[0]>ge[0])&&(ge=_e))}}}return ge}function Ue(ke,Pe){if(Pe+1>=ke.length)return;const Te=ke[Pe],j=ke[Pe+1];if(Te!==j)return ke.slice(0,Pe)+j+Te+ke.slice(Pe+2)}}),define(Oe[98],Ne([1,0,149,12,34]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=$,e.$Xk=k,e.$Yk=a,e.$Zk=S,e.$1k=r,e.$2k=o;const O="$(",T=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${T.source}`,"g");function $(c){return c.replace(A,(l,i)=>i?l:`\\${l}`)}const s=new RegExp(`\\\\${T.source}`,"g");function k(c){return c.replace(s,l=>`\\${l}`)}const y=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function a(c){return c.indexOf(O)===-1?c:c.replace(y,(l,i,n,t)=>n?l:i||t||"")}function S(c){return c?c.replace(/\$\((.*?)\)/g,(l,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(c){d.lastIndex=0;let l="";const i=[];let n=0;for(;;){const t=d.lastIndex,g=d.exec(c),u=c.substring(t,g?.index);if(u.length>0){l+=u;for(let m=0;m<u.length;m++)i.push(n)}if(!g)break;n+=g[0].length}return{text:l,iconOffsets:i}}function o(c,l,i=!1){const{text:n,iconOffsets:t}=l;if(!t||t.length===0)return(0,v.$Nk)(c,n,i);const g=(0,R.$mf)(n," "),u=n.length-g.length,m=(0,v.$Nk)(c,g,i);if(m)for(const p of m){const h=t[p.start+u]+u;p.start+=h,p.end+=h}return m}}),define(Oe[35],Ne([1,0,12]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=We(v);var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const O="error",T="warning",A="warn",$="info",s="ignore";function k(a){return a?v.$Ff(O,a)?P.Error:v.$Ff(T,a)||v.$Ff(A,a)?P.Warning:v.$Ff($,a)?P.Info:P.Ignore:P.Ignore}P.fromValue=k;function y(a){switch(a){case P.Error:return O;case P.Warning:return T;case P.Info:return $;default:return s}}P.toString=y}(R||(R={})),e.default=R}),define(Oe[58],Ne([1,0,17,27,12]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return r-o}value(){return this.b[this.c]}}e.$Gi=O;class T{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===R.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$zf)(d,this.b,0,d.length,this.c,this.d):(0,P.$Bf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=T;class A{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const o=this.b.charCodeAt(r);if(!(o===R.CharCode.Slash||this.f&&o===R.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===R.CharCode.Slash||this.f&&r===R.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$zf)(d,this.b,0,d.length,this.d,this.e):(0,P.$Bf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=A;var $;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})($||($={}));class s{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new A(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push($.Path)),this.g(d)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===$.Scheme)return(0,P.$Af)(d,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,P.$Af)(d,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(d);if(this.d[this.e]===$.Query)return(0,P.$yf)(d,this.c.query);if(this.d[this.e]===$.Fragment)return(0,P.$yf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Ji=s;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(y||(y={}));class a{static forUris(d=()=>!1,r=()=>!1){return new a(new s(d,r))}static forPaths(d=!1){return new a(new A(void 0,!d))}static forStrings(){return new a(new O)}static forConfigKeys(){return new a(new T)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const o=r.slice(0);(0,v.$Vb)(o);for(const c of o)this.set(c,d)}else{const o=d.slice(0);(0,v.$Vb)(o);for(const c of o)this.set(c[0],c[1])}}set(d,r){const o=this.b.reset(d);let c;this.c||(this.c=new k,this.c.segment=o.value());const l=[];for(c=this.c;;){const n=o.cmp(c.segment);if(n>0)c.left||(c.left=new k,c.left.segment=o.value()),l.push([y.Left,c]),c=c.left;else if(n<0)c.right||(c.right=new k,c.right.segment=o.value()),l.push([y.Right,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new k,c.mid.segment=o.value()),l.push([y.Mid,c]),c=c.mid;else break}const i=c.value;c.value=r,c.key=d;for(let n=l.length-1;n>=0;n--){const t=l[n][1];t.updateHeight();const g=t.balanceFactor();if(g<-1||g>1){const u=l[n][0],m=l[n+1][0];if(u===y.Right&&m===y.Right)l[n][1]=t.rotateLeft();else if(u===y.Left&&m===y.Left)l[n][1]=t.rotateRight();else if(u===y.Right&&m===y.Left)t.right=l[n+1][1]=l[n+1][1].rotateRight(),l[n][1]=t.rotateLeft();else if(u===y.Left&&m===y.Right)t.left=l[n+1][1]=l[n+1][1].rotateLeft(),l[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(l[n-1][0]){case y.Left:l[n-1][1].left=l[n][1];break;case y.Right:l[n-1][1].right=l[n][1];break;case y.Mid:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let o=this.c;for(;o;){const c=r.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const o=this.b.reset(d),c=[];let l=this.c;for(;l;){const i=o.cmp(l.segment);if(i>0)c.push([y.Left,l]),l=l.left;else if(i<0)c.push([y.Right,l]),l=l.right;else if(o.hasNext())o.next(),c.push([y.Mid,l]),l=l.mid;else break}if(l){if(r?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const i=this.f(l.right);if(i.key){const{key:n,value:t,segment:g}=i;this.e(i.key,!1),l.key=n,l.value=t,l.segment=g}}else{const i=l.left??l.right;if(c.length>0){const[n,t]=c[c.length-1];switch(n){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const n=c[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),c[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),c[i][1]=n.rotateRight()),i>0)switch(c[i-1][0]){case y.Left:c[i-1][1].left=c[i][1];break;case y.Right:c[i-1][1].right=c[i][1];break;case y.Mid:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let o=this.c,c;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(d){return this.g(d,!1)}g(d,r){const o=this.b.reset(d);let c=this.c;for(;c;){const l=o.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this.h(c.mid):r?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,o]of this)d(o,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Ki=a}),define(Oe[40],Ne([1,0,22,2,36]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=O,e.$ai=T,e.$bi=$;function O(s){return JSON.stringify(s,A)}function T(s){let k=JSON.parse(s);return k=$(k),k}function A(s,k){return k instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:k.source,flags:k.flags}:k}function $(s,k=0){if(!s||k>200)return s;if(typeof s=="object"){switch(s.$mid){case P.MarshalledId.Uri:return R.URI.revive(s);case P.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case P.MarshalledId.Date:return new Date(s.source)}if(s instanceof v.$Ne||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let y=0;y<s.length;++y)s[y]=$(s[y],k+1);else for(const y in s)Object.hasOwnProperty.call(s,y)&&(s[y]=$(s[y],k+1))}return s}}),define(Oe[15],Ne([1,0,13,20,12,2,19]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=$,e.$Og=s,e.$Sg=y,v=We(v),R=We(R),T=We(T);var A;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(A||(e.Schemas=A={}));function $(d,r){return O.URI.isUri(d)?(0,P.$Ff)(d.scheme,r):(0,P.$Gf)(d,r+":")}function s(d,...r){return r.some(o=>$(d,o))}e.$Pg="vscode-tkn",e.$Qg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=y(r,o)}getServerRootPath(){return this.f}get g(){return T.$gc.join(this.f,A.vscodeRemoteResource)}set(r,o,c){this.a[r]=o,this.b[r]=c}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(t){return v.$Y(t),r}const o=r.authority;let c=this.a[o];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const l=this.b[o],i=this.c[o];let n=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(n+=`&${e.$Qg}=${encodeURIComponent(i)}`),O.URI.from({scheme:R.$p?this.d:A.vscodeRemoteResource,authority:`${c}:${l}`,path:this.g,query:n})}}e.$Rg=new k;function y(d,r){return T.$gc.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class a{static{this.a=e.$Xg}asBrowserUri(r){const o=this.b(r,be);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===A.vscodeRemote?e.$Rg.rewrite(r):r.scheme===A.file&&(R.$n||R.$r===`${A.vscodeFileResource}://${a.a}`)?r.with({scheme:A.vscodeFileResource,authority:r.authority||a.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,be);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===A.vscodeFileResource?r.with({scheme:A.file,authority:r.authority!==a.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return O.URI.isUri(r)?r:O.URI.parse(o.toUrl(r))}}e.$Yg=new a;var S;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function c(i){let n;typeof i=="string"?n=new URL(i).searchParams:i instanceof URL?n=i.searchParams:O.URI.isUri(i)&&(n=new URL(i.toString(!0)).searchParams);const t=n?.get(o);if(t)return r.get(t)}d.getHeadersFromQuery=c;function l(i,n,t){if(!globalThis.crossOriginIsolated)return;const g=n&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(o,g):i[o]=g}d.addSearchParam=l})(S||(e.COI=S={}))}),define(Oe[23],Ne([1,0,27,51,15,19,20,12,2]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=s,e.$oh=y,e.$ph=S,R=We(R),O=We(O);function s(d){return(0,$.$wc)(d,!0)}class k{constructor(r){this.a=r}compare(r,o,c=!1){return r===o?0:(0,A.$yf)(this.getComparisonKey(r,c),this.getComparisonKey(o,c))}isEqual(r,o,c=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,c)===this.getComparisonKey(o,c)}getComparisonKey(r,o=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,o,c=!1){if(r.scheme===o.scheme){if(r.scheme===P.Schemas.file)return R.$Dg(s(r),s(o),this.a(r))&&r.query===o.query&&(c||r.fragment===o.fragment);if((0,e.$kh)(r.authority,o.authority))return R.$Dg(r.path,o.path,this.a(r),"/")&&r.query===o.query&&(c||r.fragment===o.fragment)}return!1}joinPath(r,...o){return $.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.$ch)(r)||r.authority}basename(r){return O.$gc.basename(r.path)}extname(r){return O.$gc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===P.Schemas.file?o=$.URI.file(O.$mc(s(r))).path:(o=O.$gc.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===P.Schemas.file?o=$.URI.file(O.$hc(s(r))).path:o=O.$gc.normalize(r.path),r.with({path:o})}relativePath(r,o){if(r.scheme!==o.scheme||!(0,e.$kh)(r.authority,o.authority))return;if(r.scheme===P.Schemas.file){const i=O.$lc(s(r),s(o));return T.$j?R.$xg(i):i}let c=r.path||"/";const l=o.path||"/";if(this.a(r)){let i=0;for(const n=Math.min(c.length,l.length);i<n&&!(c.charCodeAt(i)!==l.charCodeAt(i)&&c.charAt(i).toLowerCase()!==l.charAt(i).toLowerCase());i++);c=l.substr(0,i)+c.substr(i)}return O.$gc.relative(c,l)}resolvePath(r,o){if(r.scheme===P.Schemas.file){const c=$.URI.file(O.$kc(s(r),o));return r.with({authority:c.authority,path:c.path})}return o=R.$yg(o),r.with({path:O.$gc.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||r!==void 0&&o!==void 0&&(0,A.$Ff)(r,o)}hasTrailingPathSeparator(r,o=O.sep){if(r.scheme===P.Schemas.file){const c=s(r);return c.length>R.$zg(c).length&&c[c.length-1]===o}else{const c=r.path;return c.length>1&&c.charCodeAt(c.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=O.sep){return(0,e.$lh)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=O.sep){let c=!1;if(r.scheme===P.Schemas.file){const l=s(r);c=l!==void 0&&l.length===R.$zg(l).length&&l[l.length-1]===o}else{o="/";const l=r.path;c=l.length===1&&l.charCodeAt(l.length-1)===v.CharCode.Slash}return!c&&!(0,e.$lh)(r,o)?r.with({path:r.path+"/"}):r}}e.$7g=k,e.$8g=new k(()=>!1),e.$9g=new k(d=>d.scheme===P.Schemas.file?!T.$l:!0),e.$0g=new k(d=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function y(d,r){const o=[];for(let c=0;c<d.length;c++){const l=r(d[c]);d.some((i,n)=>n===c?!1:(0,e.$_g)(l,r(i)))||o.push(d[c])}return o}var a;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(o){const c=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(n=>{const[t,g]=n.split(":");t&&g&&c.set(t,g)});const i=o.path.substring(0,o.path.indexOf(";"));return i&&c.set(d.META_DATA_MIME,i),c}d.parseMetaData=r})(a||(e.DataUri=a={}));function S(d,r,o){if(r){let c=d.path;return c&&c[0]!==O.$gc.sep&&(c=O.$gc.sep+c),d.with({scheme:o,authority:r,path:c})}return d.with({scheme:o})}}),define(Oe[10],Ne([1,0,21,13,6,4,23,20,148,48]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=k,e.$rh=y,e.$sh=a,e.$th=S,e.$uh=d,e.$vh=r,e.$wh=o,e.$xh=c,e.$Fh=E,e.$Gh=D,e.$Hh=w,e.$Ih=I,e.$Jh=C,e.$Yh=me,e.$7h=le;function k(de){return!!de&&typeof de.then=="function"}function y(de){const J=new v.$we,x=de(J.token),pe=new Promise(($e,Ae)=>{const Ue=J.token.onCancellationRequested(()=>{Ue.dispose(),Ae(new R.$4)});Promise.resolve(x).then(ke=>{Ue.dispose(),J.dispose(),$e(ke)},ke=>{Ue.dispose(),J.dispose(),Ae(ke)})});return new class{cancel(){J.cancel(),J.dispose()}then($e,Ae){return pe.then($e,Ae)}catch($e){return this.then(void 0,$e)}finally($e){return pe.finally($e)}}}function a(de,J,x){return new Promise((pe,$e)=>{const Ae=J.onCancellationRequested(()=>{Ae.dispose(),pe(x)});de.then(pe,$e).finally(()=>Ae.dispose())})}function S(de,J){return new Promise((x,pe)=>{const $e=J.onCancellationRequested(()=>{$e.dispose(),pe(new R.$4)});de.then(x,pe).finally(()=>$e.dispose())})}async function d(de){let J=-1;const x=de.map((pe,$e)=>pe.then(Ae=>(J=$e,Ae)));try{return await Promise.race(x)}finally{de.forEach((pe,$e)=>{$e!==J&&pe.cancel()})}}function r(de,J,x){let pe;const $e=setTimeout(()=>{pe?.(void 0),x?.()},J);return Promise.race([de.finally(()=>clearTimeout($e)),new Promise(Ae=>pe=Ae)])}function o(de){return new Promise((J,x)=>{const pe=de();k(pe)?pe.then(J,x):J(pe)})}function c(){let de,J;return{promise:new Promise((pe,$e)=>{de=pe,J=$e}),resolve:de,reject:J}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const x=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(x,x).then(pe)})}return new Promise((x,pe)=>{this.b.then(x,pe)})}return this.a=J(),new Promise((x,pe)=>{this.a.then($e=>{this.a=null,x($e)},$e=>{this.a=null,pe($e)})})}dispose(){this.f=!0}}e.$yh=l;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$zh=i;class n{constructor(){this.a=new Map}queue(J,x){const $e=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(J)===$e&&this.a.delete(J)});return this.a.set(J,$e),$e}}e.$Ah=n;const t=(de,J)=>{let x=!0;const pe=setTimeout(()=>{x=!1,J()},de);return{isTriggered:()=>x,dispose:()=>{clearTimeout(pe),x=!1}}},g=de=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,de())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class u{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,x=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise(($e,Ae)=>{this.d=$e,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=x===$.$ge?g(pe):t(x,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=u;class m{constructor(J){this.a=new u(J),this.b=new l}trigger(J,x){return this.a.trigger(()=>this.b.queue(J),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=m;class p{constructor(){this.a=!1,this.b=new Promise((J,x)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=p;class h extends p{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Eh=h;function E(de,J){return J?new Promise((x,pe)=>{const $e=setTimeout(()=>{Ae.dispose(),x()},de),Ae=J.onCancellationRequested(()=>{clearTimeout($e),Ae.dispose(),pe(new R.$4)})}):y(x=>E(de,x))}function D(de,J=0,x){const pe=setTimeout(()=>{de(),x&&$e.dispose()},J),$e=(0,O.$Sc)(()=>{clearTimeout(pe),x?.deleteAndLeak($e)});return x?.add($e),$e}function w(de){const J=[];let x=0;const pe=de.length;function $e(){return x<pe?de[x++]():null}function Ae(Ue){Ue!=null&&J.push(Ue);const ke=$e();return ke?ke.then(Ae):Promise.resolve(J)}return Promise.resolve(null).then(Ae)}function I(de,J=pe=>!!pe,x=null){let pe=0;const $e=de.length,Ae=()=>{if(pe>=$e)return Promise.resolve(x);const Ue=de[pe++];return Promise.resolve(Ue()).then(Pe=>J(Pe)?Promise.resolve(Pe):Ae())};return Ae()}function C(de,J=pe=>!!pe,x=null){if(de.length===0)return Promise.resolve(x);let pe=de.length;const $e=()=>{pe=-1;for(const Ae of de)Ae.cancel?.()};return new Promise((Ae,Ue)=>{for(const ke of de)ke.then(Pe=>{--pe>=0&&J(Pe)?($e(),Ae(Pe)):pe===0&&Ae(x)}).catch(Pe=>{--pe>=0&&($e(),Ue(Pe))})})}class f{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new P.$le}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,pe)=>{this.g.push({factory:J,c:x,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const x=J.factory();x.then(J.c,J.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=f;class b extends f{constructor(){super(1)}}e.$Lh=b;class M{constructor(){this.a=new oe,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Mh=M;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ae;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,x=T.$8g){const pe=x.getComparisonKey(J);return this.a.get(pe)?.size??0}queueFor(J,x,pe=T.$8g){const $e=pe.getComparisonKey(J);let Ae=this.a.get($e);if(!Ae){Ae=new b;const Ue=this.f++,ke=P.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(Ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(Ue,ke),this.a.set($e,Ae)}return Ae.queue(x)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=N;class F{constructor(J,x){this.b=!1,this.a=-1,typeof J=="function"&&typeof x=="number"&&this.setIfNotSet(J,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,x){if(this.b)throw new R.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},x)}setIfNotSet(J,x){if(this.b)throw new R.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},x))}}e.$Oh=F;class W{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,x,pe=globalThis){if(this.f)throw new R.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const $e=pe.setInterval(()=>{J()},x);this.d=(0,O.$Sc)(()=>{pe.clearInterval($e),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=W;class K{constructor(J,x){this.b=-1,this.a=J,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=K;class L{constructor(J,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=J,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=L;class Q extends K{constructor(J,x){super(J,x),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Sh=Q;class X extends O.$Uc{constructor(J,x){super(),this.g=J,this.h=x,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of J)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(de,J)=>{(0,A.$C)(()=>{if(x)return;const pe=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Vh=(de,J,x)=>{const pe=de.requestIdleCallback(J,typeof x=="number"?{timeout:x}:void 0);let $e=!1;return{dispose(){$e||($e=!0,de.cancelIdleCallback(pe))}}},e.$Uh=de=>(0,e.$Vh)(globalThis,de)}();class ue{constructor(J,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Vh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=ue;class ee extends ue{constructor(J){super(globalThis,J)}}e.$Xh=ee;async function me(de,J,x){let pe;for(let $e=0;$e<x;$e++)try{return await de()}catch(Ae){pe=Ae,await E(J)}throw pe}class oe{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,x,pe){return this.a={taskId:J,cancel:()=>pe?.(),promise:x},x.then(()=>this.d(J),()=>this.d(J)),x}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:x,resolve:pe,reject:$e}=c();this.b={run:J,promise:x,promiseResolve:pe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=oe;class ce{constructor(J,x=()=>Date.now()){this.d=J,this.f=x,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$1h=ce;var we;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(we||(we={}));class ae{get isRejected(){return this.d?.outcome===we.Rejected}get isResolved(){return this.d?.outcome===we.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===we.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((J,x)=>{this.a=J,this.b=x})}complete(J){return new Promise(x=>{this.a(J),this.d={outcome:we.Resolved,value:J},x()})}error(J){return new Promise(x=>{this.b(J),this.d={outcome:we.Rejected,value:J},x()})}cancel(){return this.error(new R.$4)}}e.$2h=ae;var Ie;(function(de){async function J(pe){let $e;const Ae=await Promise.all(pe.map(Ue=>Ue.then(ke=>ke,ke=>{$e||($e=ke)})));if(typeof $e<"u")throw $e;return Ae}de.settled=J;function x(pe){return new Promise(async($e,Ae)=>{try{await pe($e,Ae)}catch(Ue){Ae(Ue)}})}de.withAsyncBody=x})(Ie||(e.Promises=Ie={}));class Fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new R.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=Fe;class Y{constructor(J){this.b=J,this.a=new s.$T(()=>new Fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=Y;var q;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(q||(q={}));class ne{static fromArray(J){return new ne(x=>{x.emitMany(J)})}static fromPromise(J){return new ne(async x=>{x.emitMany(await J)})}static fromPromises(J){return new ne(async x=>{await Promise.all(J.map(async pe=>x.emitOne(await pe)))})}static merge(J){return new ne(async x=>{await Promise.all(J.map(async pe=>{for await(const $e of pe)x.emitOne($e)}))})}static{this.EMPTY=ne.fromArray([])}constructor(J,x){this.a=q.Initial,this.b=[],this.d=null,this.f=x,this.g=new P.$le,queueMicrotask(async()=>{const pe={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(J(pe)),this.k()}catch($e){this.l($e)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,x){return new ne(async pe=>{for await(const $e of J)pe.emitOne(x($e))})}map(J){return ne.map(this,J)}static filter(J,x){return new ne(async pe=>{for await(const $e of J)x($e)&&pe.emitOne($e)})}filter(J){return ne.filter(this,J)}static coalesce(J){return ne.filter(J,x=>!!x)}coalesce(){return ne.coalesce(this)}static async toPromise(J){const x=[];for await(const pe of J)x.push(pe);return x}toPromise(){return ne.toPromise(this)}h(J){this.a===q.Initial&&(this.b.push(J),this.g.fire())}j(J){this.a===q.Initial&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(J){this.a===q.Initial&&(this.a=q.DoneError,this.d=J,this.g.fire())}}e.$5h=ne;class ye extends ne{constructor(J,x){super(x),this.m=J}cancel(){this.m.cancel()}}e.$6h=ye;function le(de){const J=new v.$we,x=de(J.token);return new ye(J,async pe=>{const $e=J.token.onCancellationRequested(()=>{$e.dispose(),J.dispose(),pe.reject(new R.$4)});try{for await(const Ae of x){if(J.token.isCancellationRequested)return;pe.emitOne(Ae)}$e.dispose(),J.dispose()}catch(Ae){$e.dispose(),J.dispose(),pe.reject(Ae)}})}class ve{constructor(J){this.a=new ae,this.b=new ne($e=>{if(x){$e.reject(x);return}return pe&&$e.emitMany(pe),this.d=Ae=>$e.reject(Ae),this.f=Ae=>$e.emitOne(Ae),this.a.p},J);let x,pe;this.f=$e=>{pe||(pe=[]),pe.push($e)},this.d=$e=>{x||(x=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$8h=ve}),define(Oe[41],Ne([1,0,17,10,27,51,28,19,20,12]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=k,e.$xk=r,e.$yk=M,e.$zk=N,e.$Ak=F,e.$Bk=W,e.$Ck=K,e.$Dk=ue;function k(){return Object.create(null)}e.$vk="**",e.$wk="/";const y="[/\\\\]",a="[^/\\\\]",S=/\//g;function d(ee,me){switch(ee){case 0:return"";case 1:return`${a}*?`;default:return`(?:${y}|${a}+${y}${me?`|${y}${a}+`:""})*?`}}function r(ee,me){if(!ee)return[];const oe=[];let ce=!1,we=!1,ae="";for(const Ie of ee){switch(Ie){case me:if(!ce&&!we){oe.push(ae),ae="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":we=!0;break;case"]":we=!1;break}ae+=Ie}return ae&&oe.push(ae),oe}function o(ee){if(!ee)return"";let me="";const oe=r(ee,e.$wk);if(oe.every(ce=>ce===e.$vk))me=".*";else{let ce=!1;oe.forEach((we,ae)=>{if(we===e.$vk){if(ce)return;me+=d(2,ae===oe.length-1)}else{let Ie=!1,Fe="",Y=!1,q="";for(const ne of we){if(ne!=="}"&&Ie){Fe+=ne;continue}if(Y&&(ne!=="]"||!q)){let ye;ne==="-"?ye=ne:(ne==="^"||ne==="!")&&!q?ye="^":ne===e.$wk?ye="":ye=(0,s.$hf)(ne),q+=ye;continue}switch(ne){case"{":Ie=!0;continue;case"[":Y=!0;continue;case"}":{const le=`(?:${r(Fe,",").map(ve=>o(ve)).join("|")})`;me+=le,Ie=!1,Fe="";break}case"]":{me+="["+q+"]",Y=!1,q="";break}case"?":me+=a;continue;case"*":me+=d(1);continue;default:me+=(0,s.$hf)(ne)}}ae<oe.length-1&&(oe[ae+1]!==e.$vk||ae+2<oe.length)&&(me+=y)}ce=we===e.$vk})}return me}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new T.$Dc(1e4),m=function(){return!1},p=function(){return null};function h(ee,me){if(!ee)return p;let oe;typeof ee!="string"?oe=ee.pattern:oe=ee,oe=oe.trim();const ce=`${oe}_${!!me.trimForExclusions}`;let we=u.get(ce);if(we)return E(we,ee);let ae;return c.test(oe)?we=w(oe.substr(4),oe):(ae=l.exec(D(oe,me)))?we=I(ae[1],oe):(me.trimForExclusions?n:i).test(oe)?we=C(oe,me):(ae=t.exec(D(oe,me)))?we=f(ae[1].substr(1),oe,!0):(ae=g.exec(D(oe,me)))?we=f(ae[1],oe,!1):we=b(oe),u.set(ce,we),E(we,ee)}function E(ee,me){if(typeof me=="string")return ee;const oe=function(ce,we){return(0,O.$Dg)(ce,me.base,!$.$l)?ee((0,s.$mf)(ce.substr(me.base.length),A.sep),we):null};return oe.allBasenames=ee.allBasenames,oe.allPaths=ee.allPaths,oe.basenames=ee.basenames,oe.patterns=ee.patterns,oe}function D(ee,me){return me.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function w(ee,me){return function(oe,ce){return typeof oe=="string"&&oe.endsWith(ee)?me:null}}function I(ee,me){const oe=`/${ee}`,ce=`\\${ee}`,we=function(Ie,Fe){return typeof Ie!="string"?null:Fe?Fe===ee?me:null:Ie===ee||Ie.endsWith(oe)||Ie.endsWith(ce)?me:null},ae=[ee];return we.basenames=ae,we.patterns=[me],we.allBasenames=ae,we}function C(ee,me){const oe=X(ee.slice(1,-1).split(",").map(Fe=>h(Fe,me)).filter(Fe=>Fe!==p),ee),ce=oe.length;if(!ce)return p;if(ce===1)return oe[0];const we=function(Fe,Y){for(let q=0,ne=oe.length;q<ne;q++)if(oe[q](Fe,Y))return ee;return null},ae=oe.find(Fe=>!!Fe.allBasenames);ae&&(we.allBasenames=ae.allBasenames);const Ie=oe.reduce((Fe,Y)=>Y.allPaths?Fe.concat(Y.allPaths):Fe,[]);return Ie.length&&(we.allPaths=Ie),we}function f(ee,me,oe){const ce=A.sep===A.$gc.sep,we=ce?ee:ee.replace(S,A.sep),ae=A.sep+we,Ie=A.$gc.sep+ee;let Fe;return oe?Fe=function(Y,q){return typeof Y=="string"&&(Y===we||Y.endsWith(ae)||!ce&&(Y===ee||Y.endsWith(Ie)))?me:null}:Fe=function(Y,q){return typeof Y=="string"&&(Y===we||!ce&&Y===ee)?me:null},Fe.allPaths=[(oe?"*/":"./")+ee],Fe}function b(ee){try{const me=new RegExp(`^${o(ee)}$`);return function(oe){return me.lastIndex=0,typeof oe=="string"&&me.test(oe)?ee:null}}catch{return p}}function M(ee,me,oe){return!ee||typeof me!="string"?!1:N(ee)(me,void 0,oe)}function N(ee,me={}){if(!ee)return m;if(typeof ee=="string"||F(ee)){const oe=h(ee,me);if(oe===p)return m;const ce=function(we,ae){return!!oe(we,ae)};return oe.allBasenames&&(ce.allBasenames=oe.allBasenames),oe.allPaths&&(ce.allPaths=oe.allPaths),ce}return L(ee,me)}function F(ee){const me=ee;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}function W(ee){return ee.allBasenames||[]}function K(ee){return ee.allPaths||[]}function L(ee,me){const oe=X(Object.getOwnPropertyNames(ee).map(Fe=>Q(Fe,ee[Fe],me)).filter(Fe=>Fe!==p)),ce=oe.length;if(!ce)return p;if(!oe.some(Fe=>!!Fe.requiresSiblings)){if(ce===1)return oe[0];const Fe=function(ne,ye){let le;for(let ve=0,de=oe.length;ve<de;ve++){const J=oe[ve](ne,ye);if(typeof J=="string")return J;(0,R.$qh)(J)&&(le||(le=[]),le.push(J))}return le?(async()=>{for(const ve of le){const de=await ve;if(typeof de=="string")return de}return null})():null},Y=oe.find(ne=>!!ne.allBasenames);Y&&(Fe.allBasenames=Y.allBasenames);const q=oe.reduce((ne,ye)=>ye.allPaths?ne.concat(ye.allPaths):ne,[]);return q.length&&(Fe.allPaths=q),Fe}const we=function(Fe,Y,q){let ne,ye;for(let le=0,ve=oe.length;le<ve;le++){const de=oe[le];de.requiresSiblings&&q&&(Y||(Y=(0,A.$nc)(Fe)),ne||(ne=Y.substr(0,Y.length-(0,A.$oc)(Fe).length)));const J=de(Fe,Y,ne,q);if(typeof J=="string")return J;(0,R.$qh)(J)&&(ye||(ye=[]),ye.push(J))}return ye?(async()=>{for(const le of ye){const ve=await le;if(typeof ve=="string")return ve}return null})():null},ae=oe.find(Fe=>!!Fe.allBasenames);ae&&(we.allBasenames=ae.allBasenames);const Ie=oe.reduce((Fe,Y)=>Y.allPaths?Fe.concat(Y.allPaths):Fe,[]);return Ie.length&&(we.allPaths=Ie),we}function Q(ee,me,oe){if(me===!1)return p;const ce=h(ee,oe);if(ce===p)return p;if(typeof me=="boolean")return ce;if(me){const we=me.when;if(typeof we=="string"){const ae=(Ie,Fe,Y,q)=>{if(!q||!ce(Ie,Fe))return null;const ne=we.replace("$(basename)",()=>Y),ye=q(ne);return(0,R.$qh)(ye)?ye.then(le=>le?ee:null):ye?ee:null};return ae.requiresSiblings=!0,ae}}return ce}function X(ee,me){const oe=ee.filter(Fe=>!!Fe.basenames);if(oe.length<2)return ee;const ce=oe.reduce((Fe,Y)=>{const q=Y.basenames;return q?Fe.concat(q):Fe},[]);let we;if(me){we=[];for(let Fe=0,Y=ce.length;Fe<Y;Fe++)we.push(me)}else we=oe.reduce((Fe,Y)=>{const q=Y.patterns;return q?Fe.concat(q):Fe},[]);const ae=function(Fe,Y){if(typeof Fe!="string")return null;if(!Y){let ne;for(ne=Fe.length;ne>0;ne--){const ye=Fe.charCodeAt(ne-1);if(ye===P.CharCode.Slash||ye===P.CharCode.Backslash)break}Y=Fe.substr(ne)}const q=ce.indexOf(Y);return q!==-1?we[q]:null};ae.basenames=ce,ae.patterns=we,ae.allBasenames=ce;const Ie=ee.filter(Fe=>!Fe.basenames);return Ie.push(ae),Ie}function ue(ee,me){return(0,v.$tb)(ee,me,(oe,ce)=>typeof oe=="string"&&typeof ce=="string"?oe===ce:typeof oe!="string"&&typeof ce!="string"?oe.base===ce.base&&oe.pattern===ce.pattern:!1)}}),define(Oe[59],Ne([1,0,13,98,23,12,2]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=s,e.$5k=k,e.$6k=y,e.$7k=a,e.$8k=S,e.$9k=d,e.$0k=r,e.$$k=o;var A;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class ${constructor(l="",i=!1){if(this.value=l,typeof this.value!="string")throw(0,v.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(l,i=A.Paragraph){return this.value+=a(this.supportThemeIcons?(0,R.$Wk)(l):l).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===A.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,i){return this.value+=`
${S(i,l)}
`,this}appendLink(l,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(l),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(l,i){const n=new RegExp((0,O.$hf)(i),"g");return l.replace(n,(t,g)=>l.charAt(g-1)!=="\\"?`\\${t}`:t)}}e.$3k=$;function s(c){return k(c)?!c.value:Array.isArray(c)?c.every(s):!0}function k(c){return c instanceof $?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function y(c,l){return c===l?!0:!c||!l?!1:c.value===l.value&&c.isTrusted===l.isTrusted&&c.supportThemeIcons===l.supportThemeIcons&&c.supportHtml===l.supportHtml&&(c.baseUri===l.baseUri||!!c.baseUri&&!!l.baseUri&&(0,P.$$g)(T.URI.from(c.baseUri),T.URI.from(l.baseUri)))}function a(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(c,l){const i=c.match(/^`+/gm)?.reduce((t,g)=>t.length>g.length?t:g).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${l}`,c,`${"`".repeat(n)}`].join(`
`)}function d(c){return c.replace(/"/g,"&quot;")}function r(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(c){const l=[],i=c.split("|").map(t=>t.trim());c=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),g=/width=(\d+)/.exec(n),u=t?t[1]:"",m=g?g[1]:"",p=isFinite(parseInt(m)),h=isFinite(parseInt(u));p&&l.push(`width="${m}"`),h&&l.push(`height="${u}"`)}return{href:c,dimensions:l}}}),define(Oe[99],Ne([1,0,17,51,19,20,23,12]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yw=$,e.$Zw=k,e.$1w=a,e.$2w=S,e.$3w=c,e.$4w=i,e.$5w=n,e.$6w=t,e.$7w=g,e.$8w=u;function $(p,h){const{os:E,tildify:D,relative:w}=h;if(w){const f=s(p,w,E);if(typeof f=="string")return f}let I=p.fsPath;if(E===O.OperatingSystem.Windows&&!O.$j?I=I.replace(/\//g,"\\"):E!==O.OperatingSystem.Windows&&O.$j&&(I=I.replace(/\\/g,"/")),E!==O.OperatingSystem.Windows&&D?.userHome){const f=D.userHome.fsPath;let b;p.scheme!==D.userHome.scheme&&p.path[0]===P.$gc.sep&&p.path[1]!==P.$gc.sep?b=D.userHome.with({path:p.path}).fsPath:b=I,I=a(b,f,E)}return(E===O.OperatingSystem.Windows?P.$fc:P.$gc).normalize(k(I,E===O.OperatingSystem.Windows))}function s(p,h,E){const D=E===O.OperatingSystem.Windows?P.$fc:P.$gc,w=E===O.OperatingSystem.Linux?T.$8g:T.$0g,I=h.getWorkspace(),C=(0,v.$Nb)(I.folders);if(!C)return;p.scheme!==C.uri.scheme&&p.path[0]===P.$gc.sep&&p.path[1]!==P.$gc.sep&&(p=C.uri.with({path:p.path}));const f=h.getWorkspaceFolder(p);if(!f)return;let b;if(w.isEqual(f.uri,p)?b="":b=w.relativePath(f.uri,p)??"",b&&(b=D.normalize(b)),I.folders.length>1&&!h.noPrefix){const M=f.name?f.name:w.basenameOrAuthority(f.uri);b=b?`${M} \u2022 ${b}`:M}return b}function k(p,h=O.$j){return(0,R.$Ig)(p,h)?p.charAt(0).toUpperCase()+p.slice(1):p}let y=Object.create(null);function a(p,h,E=O.OS){if(E===O.OperatingSystem.Windows||!p||!h)return p;let D=y.original===h?y.normalized:void 0;D||(D=h,O.$j&&(D=(0,R.$xg)(D)),D=`${(0,A.$nf)(D,P.$gc.sep)}${P.$gc.sep}`,y={original:h,normalized:D});let w=p;return O.$j&&(w=(0,R.$xg)(w)),(E===O.OperatingSystem.Linux?w.startsWith(D):(0,A.$Gf)(w,D))?`~/${w.substr(D.length)}`:p}function S(p,h){return p.replace(/^~($|\/|\\)/,`${h}$1`)}const d="\u2026",r="\\\\",o="~";function c(p,h=P.sep){const E=new Array(p.length);let D=!1;for(let w=0;w<p.length;w++){const I=p[w];if(I===""){E[w]=`.${h}`;continue}if(!I){E[w]=I;continue}D=!0;let C="",f=I;f.indexOf(r)===0?(C=f.substr(0,f.indexOf(r)+r.length),f=f.substr(f.indexOf(r)+r.length)):f.indexOf(h)===0?(C=f.substr(0,f.indexOf(h)+h.length),f=f.substr(f.indexOf(h)+h.length)):f.indexOf(o)===0&&(C=f.substr(0,f.indexOf(o)+o.length),f=f.substr(f.indexOf(o)+o.length));const b=f.split(h);for(let M=1;D&&M<=b.length;M++)for(let N=b.length-M;D&&N>=0;N--){D=!1;let F=b.slice(N,N+M).join(h);for(let W=0;!D&&W<p.length;W++)if(W!==w&&p[W]&&p[W].indexOf(F)>-1){const K=N+M===b.length,L=N>0&&p[W].indexOf(h)>-1?h+F:F,Q=p[W].endsWith(L);D=!K||Q}if(!D){let W="";(b[0].endsWith(":")||C!=="")&&(N===1&&(N=0,M++,F=b[0]+h+F),N>0&&(W=b[0]+h),W=C+W),N>0&&(W=W+d+h),W=W+F,N+M<b.length&&(W=W+h+d),E[w]=W}}D&&(E[w]=I)}return E}var l;(function(p){p[p.TEXT=0]="TEXT",p[p.VARIABLE=1]="VARIABLE",p[p.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function i(p,h=Object.create(null)){const E=[];let D=!1,w="";for(const I of p)if(I==="$"||D&&I==="{")w&&E.push({value:w,type:l.TEXT}),w="",D=!0;else if(I==="}"&&D){const C=h[w];if(typeof C=="string")C.length&&E.push({value:C,type:l.VARIABLE});else if(C){const f=E[E.length-1];(!f||f.type!==l.SEPARATOR)&&E.push({value:C.label,type:l.SEPARATOR})}w="",D=!1}else w+=I;return w&&!D&&E.push({value:w,type:l.TEXT}),E.filter((I,C)=>{if(I.type===l.SEPARATOR){const f=E[C-1],b=E[C+1];return[f,b].every(M=>M&&(M.type===l.VARIABLE||M.type===l.TEXT)&&M.value.length>0)}return!0}).map(I=>I.value).join("")}function n(p,h){return O.$k||h?p.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$k?"&":"&&"):p.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(p,h){return O.$k||h?p.replace(/\(&&\w\)|&&/g,""):O.$j?p.replace(/&&|&/g,E=>E==="&"?"&&":"&"):p.replace(/&&/g,"_")}function g(p){return p.replace(/&/g,"&&")}function u(p){if(p.endsWith("]")){const h=p.lastIndexOf(" [",p.length-2);if(h!==-1){const E=m(p.substring(0,h)),D=p.substring(h);return{name:E.name+D,parentPath:E.parentPath}}}return m(p)}function m(p){const h=p.indexOf("/")!==-1?P.$gc:P.$fc,E=h.basename(p),D=h.dirname(p);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(Oe[150],Ne([1,0,22,36,2]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=$,e.$On=k,e.$Pn=y;function O(a){return a.toJSON()}class T{constructor(S){this.a=S}transformIncoming(S){const d=this.a.transformIncoming(S);return d===S?S:O(P.URI.from(d))}transformOutgoing(S){const d=this.a.transformOutgoing(S);return d===S?S:O(P.URI.from(d))}transformOutgoingURI(S){const d=this.a.transformOutgoing(S);return d===S?S:P.URI.from(d)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.$Ln=T,e.$Mn=new class{transformIncoming(a){return a}transformOutgoing(a){return a}transformOutgoingURI(a){return a}transformOutgoingScheme(a){return a}};function A(a,S,d){if(!a||d>200)return null;if(typeof a=="object"){if(a instanceof P.URI)return S.transformOutgoing(a);for(const r in a)if(Object.hasOwnProperty.call(a,r)){const o=A(a[r],S,d+1);o!==null&&(a[r]=o)}}return null}function $(a,S){const d=A(a,S,0);return d===null?a:d}function s(a,S,d,r){if(!a||r>200)return null;if(typeof a=="object"){if(a.$mid===R.MarshalledId.Uri)return d?P.URI.revive(S.transformIncoming(a)):S.transformIncoming(a);if(a instanceof v.$Ne)return null;for(const o in a)if(Object.hasOwnProperty.call(a,o)){const c=s(a[o],S,d,r+1);c!==null&&(a[o]=c)}}return null}function k(a,S){const d=s(a,S,!1,0);return d===null?a:d}function y(a,S){const d=s(a,S,!0,0);return d===null?a:d}}),define(Oe[37],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=R;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return v.test(P)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(A){for(let $=0;$<A.length;$++)A[$]=Math.floor(Math.random()*256);return A};const O=new Uint8Array(16),T=[];for(let A=0;A<256;A++)T.push(A.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let $=0,s="";return s+=T[O[$++]],s+=T[O[$++]],s+=T[O[$++]],s+=T[O[$++]],s+="-",s+=T[O[$++]],s+=T[O[$++]],s+="-",s+=T[O[$++]],s+=T[O[$++]],s+="-",s+=T[O[$++]],s+=T[O[$++]],s+="-",s+=T[O[$++]],s+=T[O[$++]],s+=T[O[$++]],s+=T[O[$++]],s+=T[O[$++]],s+=T[O[$++]],s}}()}),define(Oe[151],Ne([1,0,17,39,37]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.$qu=void 0,e.$ou=O,e.$pu=T,e.$ru=s;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function T(y,a,S){const d={id:(0,P.$1g)(),name:y,uri:a,data:S};return{asString:async()=>"",asFile:()=>d,value:void 0}}class A{constructor(){this.a=new Map}get size(){let a=0;for(const S of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const S=[...this.a.keys()];return R.Iterable.some(this,([d,r])=>r.asFile())&&S.push("files"),k($(a),S)}get(a){return this.a.get(this.b(a))?.[0]}append(a,S){const d=this.a.get(a);d?d.push(S):this.a.set(this.b(a),[S])}replace(a,S){this.a.set(this.b(a),[S])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,S]of this.a)for(const d of S)yield[a,d]}b(a){return $(a)}}e.$qu=A;function $(y){return y.toLowerCase()}function s(y,a){return k($(y),a.map($))}function k(y,a){if(y==="*/*")return a.length>0;if(a.includes(y))return!0;const S=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[d,r,o]=S;return o==="*"?a.some(c=>c.startsWith(r+"/")):!1}e.$su=Object.freeze({create:y=>(0,v.$Lb)(y.map(a=>a.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$su.split(y).filter(a=>!a.startsWith("#"))})}),define(Oe[152],Ne([1,0,10,6,4,40,14]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.StorageState=e.StorageHint=void 0,e.$cq=$;var A;(function(a){a[a.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",a[a.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function $(a){const S=a;return S?.changed instanceof Map||S?.deleted instanceof Set}var s;(function(a){a[a.None=0]="None",a[a.Initialized=1]="Initialized",a[a.Closed=2]="Closed"})(s||(e.StorageState=s={}));class k extends P.$Uc{static{this.a=100}constructor(S,d=Object.create(null)){super(),this.r=S,this.s=d,this.b=this.B(new R.$oe),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new v.$Ch(k.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((d,r)=>this.w(r,d)),S.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(S,d){if(this.c===s.Closed)return;let r=!1;(0,T.$ng)(d)?r=this.f.delete(S):this.f.get(S)!==d&&(this.f.set(S,d),r=!0),r&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,d){const r=this.f.get(S);return(0,T.$ng)(r)?d:r}getBoolean(S,d){const r=this.get(S);return(0,T.$ng)(r)?d:r==="true"}getNumber(S,d){const r=this.get(S);return(0,T.$ng)(r)?d:parseInt(r,10)}getObject(S,d){const r=this.get(S);return(0,T.$ng)(r)?d:(0,O.$ai)(r)}async set(S,d,r=!1){if(this.c===s.Closed)return;if((0,T.$ng)(d))return this.delete(S,r);const o=(0,T.$gg)(d)||Array.isArray(d)?(0,O.$_h)(d):String(d);if(this.f.get(S)!==o)return this.f.set(S,o),this.j.set(S,o),this.h.delete(S),this.b.fire({key:S,external:r}),this.D()}async delete(S,d=!1){if(!(this.c===s.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:d}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===s.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===A.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===A.STORAGE_IN_MEMORY}}e.$dq=k;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((d,r)=>this.a.set(r,d)),S.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$eq=y}),define(Oe[153],Ne([1,0,27]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$yu=P;var R;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(R||(e.StringEOL=R={}));function P(O){let T=0,A=0,$=0,s=R.Unknown;for(let k=0,y=O.length;k<y;k++){const a=O.charCodeAt(k);a===v.CharCode.CarriageReturn?(T===0&&(A=k),T++,k+1<y&&O.charCodeAt(k+1)===v.CharCode.LineFeed?(s|=R.CRLF,k++):s|=R.Invalid,$=k+1):a===v.CharCode.LineFeed&&(s|=R.LF,T===0&&(A=k),T++,$=k+1)}return T===0&&(A=O.length),[T,A,O.length-$,s]}}),define(Oe[154],Ne([1,0,12,20,22]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=void 0,e.$bu=k,e.$cu=y,v=We(v),R=We(R),P=We(P);let O;function T(){return O||(O=new TextDecoder("UTF-16LE")),O}let A;function $(){return A||(A=new TextDecoder("UTF-16BE")),A}let s;function k(){return s||(s=R.$E()?T():$()),s}function y(d,r,o){const c=new Uint16Array(d.buffer,r,o);return o>0&&(c[0]===65279||c[0]===65534)?a(d,r,o):T().decode(c)}function a(d,r,o){const c=[];let l=0;for(let i=0;i<o;i++){const n=P.$Pe(d,r);r+=2,c[l++]=String.fromCharCode(n)}return c.join("")}class S{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return k().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||v.$Jf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let c=0;c<o;c++)this.b[this.d++]=r.charCodeAt(c)}}e.$du=S}),define(Oe[155],Ne([1,0,22,154]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=void 0,e.$fu=T,v=We(v);function P($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,k,y,a){this.oldPosition=s,this.oldText=k,this.newPosition=y,this.newText=a}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,k,y){const a=k.length;v.$Se(s,a,y),y+=4;for(let S=0;S<a;S++)v.$Qe(s,k.charCodeAt(S),y),y+=2;return y}static d(s,k){const y=v.$Re(s,k);return k+=4,(0,R.$cu)(s,k,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(s,k){return v.$Se(s,this.oldPosition,k),k+=4,v.$Se(s,this.newPosition,k),k+=4,k=O.c(s,this.oldText,k),k=O.c(s,this.newText,k),k}static read(s,k,y){const a=v.$Re(s,k);k+=4;const S=v.$Re(s,k);k+=4;const d=O.d(s,k);k+=O.a(d);const r=O.d(s,k);return k+=O.a(r),y.push(new O(a,d,S,r)),k}}e.$eu=O;function T($,s){return $===null||$.length===0?s:new A($,s).compress()}class A{constructor(s,k){this.a=s,this.c=k,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,k=0,y=this.n(s),a=this.l(k);for(;s<this.f||k<this.h;){if(y===null){this.k(a),a=this.l(++k);continue}if(a===null){this.m(y),y=this.n(++s);continue}if(a.oldEnd<=y.newPosition){this.k(a),a=this.l(++k);continue}if(y.newEnd<=a.oldPosition){this.m(y),y=this.n(++s);continue}if(a.oldPosition<y.newPosition){const[c,l]=A.r(a,y.newPosition-a.oldPosition);this.k(c),a=l;continue}if(y.newPosition<a.oldPosition){const[c,l]=A.q(y,a.oldPosition-y.newPosition);this.m(c),y=l;continue}let r,o;if(a.oldEnd===y.newEnd)r=y,o=a,y=this.n(++s),a=this.l(++k);else if(a.oldEnd<y.newEnd){const[c,l]=A.q(y,a.oldLength);r=c,o=a,y=l,a=this.l(++k)}else{const[c,l]=A.r(a,y.newLength);r=y,o=c,y=this.n(++s),a=l}this.d[this.e++]=new O(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const S=A.s(this.d);return A.t(S)}k(s){this.d[this.e++]=A.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=A.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,k){return new O(k.oldPosition-s,k.oldText,k.newPosition,k.newText)}static p(s,k){return new O(k.oldPosition,k.oldText,k.newPosition+s,k.newText)}static q(s,k){const y=s.newText.substr(0,k),a=s.newText.substr(k);return[new O(s.oldPosition,s.oldText,s.newPosition,y),new O(s.oldEnd,"",s.newPosition+k,a)]}static r(s,k){const y=s.oldText.substr(0,k),a=s.oldText.substr(k);return[new O(s.oldPosition,y,s.newPosition,s.newText),new O(s.oldPosition+k,a,s.newEnd,"")]}static s(s){if(s.length===0)return s;const k=[];let y=0,a=s[0];for(let S=1;S<s.length;S++){const d=s[S];a.oldEnd===d.oldPosition?a=new O(a.oldPosition,a.oldText+d.oldText,a.newPosition,a.newText+d.newText):(k[y++]=a,a=d)}return k[y++]=a,k}static t(s){if(s.length===0)return s;const k=[];let y=0;for(let a=0;a<s.length;a++){const S=s[a];S.oldText!==S.newText&&(k[y++]=S)}return k}}}),define(Oe[156],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0,e.$kt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Oe[157],Ne([1,0,41,19]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vu=P,e.$wu=O;function P(T,A,$,s,k,y){if(Array.isArray(T)){let a=0;for(const S of T){const d=P(S,A,$,s,k,y);if(d===10)return d;d>a&&(a=d)}return a}else{if(typeof T=="string")return s?T==="*"?5:T===$?10:0:0;if(T){const{language:a,pattern:S,scheme:d,hasAccessToAllModels:r,notebookType:o}=T;if(!s&&!r)return 0;o&&k&&(A=k);let c=0;if(d)if(d===A.scheme)c=10;else if(d==="*")c=5;else return 0;if(a)if(a===$)c=10;else if(a==="*")c=Math.max(c,5);else return 0;if(o)if(o===y)c=10;else if(o==="*"&&y!==void 0)c=Math.max(c,5);else return 0;if(S){let l;if(typeof S=="string"?l=S:l={...S,base:(0,R.$hc)(S.base)},l===A.fsPath||(0,v.$yk)(l,A.fsPath))c=10;else return 0}return c}else return 0}}function O(T){return typeof T=="string"?!1:Array.isArray(T)?T.some(O):!!T.notebookType}}),define(Oe[158],Ne([1,0,27,159]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=e.$Vu=e.IndentAction=void 0;var P;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let k=0,y=s.notIn.length;k<y;k++)switch(s.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case R.StandardTokenType.Other:return!0;case R.StandardTokenType.Comment:return this.c;case R.StandardTokenType.String:return this.b;case R.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,k){if(s.getTokenCount()===0)return!0;const y=s.findTokenIndexAtOffset(k-2),a=s.getStandardTokenType(y);return this.isOK(a)}g(s,k){for(let y=s;y<=k;y++){const a=String.fromCharCode(y);if(!this.open.includes(a)&&!this.close.includes(a))return a}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Vu=O;class T{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of s)A(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),A(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),A(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),A(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&A(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$Wu=T;function A($,s,k){$.has(s)?$.get(s).push(k):$.set(s,[k])}}),define(Oe[160],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=e.NodeColor=e.$_C=void 0,e.$bD=P,e.$cD=O,e.$dD=s,e.$eD=k,e.$fD=y,e.$gD=a,e.$hD=S,e.$iD=d;class v{constructor(o,c){this.piece=o,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$aD)return P(this.right);let o=this;for(;o.parent!==e.$aD&&o.parent.left!==o;)o=o.parent;return o.parent===e.$aD?e.$aD:o.parent}prev(){if(this.left!==e.$aD)return O(this.left);let o=this;for(;o.parent!==e.$aD&&o.parent.right!==o;)o=o.parent;return o.parent===e.$aD?e.$aD:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$_C=v;var R;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(R||(e.NodeColor=R={})),e.$aD=new v(null,R.Black),e.$aD.parent=e.$aD,e.$aD.left=e.$aD,e.$aD.right=e.$aD,e.$aD.color=R.Black;function P(r){for(;r.left!==e.$aD;)r=r.left;return r}function O(r){for(;r.right!==e.$aD;)r=r.right;return r}function T(r){return r===e.$aD?0:r.size_left+r.piece.length+T(r.right)}function A(r){return r===e.$aD?0:r.lf_left+r.piece.lineFeedCnt+A(r.right)}function $(){e.$aD.parent=e.$aD}function s(r,o){const c=o.right;c.size_left+=o.size_left+(o.piece?o.piece.length:0),c.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=c.left,c.left!==e.$aD&&(c.left.parent=o),c.parent=o.parent,o.parent===e.$aD?r.root=c:o.parent.left===o?o.parent.left=c:o.parent.right=c,c.left=o,o.parent=c}function k(r,o){const c=o.left;o.left=c.right,c.right!==e.$aD&&(c.right.parent=o),c.parent=o.parent,o.size_left-=c.size_left+(c.piece?c.piece.length:0),o.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),o.parent===e.$aD?r.root=c:o===o.parent.right?o.parent.right=c:o.parent.left=c,c.right=o,o.parent=c}function y(r,o){let c,l;if(o.left===e.$aD?(l=o,c=l.right):o.right===e.$aD?(l=o,c=l.left):(l=P(o.right),c=l.right),l===r.root){r.root=c,c.color=R.Black,o.detach(),$(),r.root.parent=e.$aD;return}const i=l.color===R.Red;if(l===l.parent.left?l.parent.left=c:l.parent.right=c,l===o?(c.parent=l.parent,d(r,c)):(l.parent===o?c.parent=l:c.parent=l.parent,d(r,c),l.left=o.left,l.right=o.right,l.parent=o.parent,l.color=o.color,o===r.root?r.root=l:o===o.parent.left?o.parent.left=l:o.parent.right=l,l.left!==e.$aD&&(l.left.parent=l),l.right!==e.$aD&&(l.right.parent=l),l.size_left=o.size_left,l.lf_left=o.lf_left,d(r,l)),o.detach(),c.parent.left===c){const t=T(c),g=A(c);if(t!==c.parent.size_left||g!==c.parent.lf_left){const u=t-c.parent.size_left,m=g-c.parent.lf_left;c.parent.size_left=t,c.parent.lf_left=g,S(r,c.parent,u,m)}}if(d(r,c.parent),i){$();return}let n;for(;c!==r.root&&c.color===R.Black;)c===c.parent.left?(n=c.parent.right,n.color===R.Red&&(n.color=R.Black,c.parent.color=R.Red,s(r,c.parent),n=c.parent.right),n.left.color===R.Black&&n.right.color===R.Black?(n.color=R.Red,c=c.parent):(n.right.color===R.Black&&(n.left.color=R.Black,n.color=R.Red,k(r,n),n=c.parent.right),n.color=c.parent.color,c.parent.color=R.Black,n.right.color=R.Black,s(r,c.parent),c=r.root)):(n=c.parent.left,n.color===R.Red&&(n.color=R.Black,c.parent.color=R.Red,k(r,c.parent),n=c.parent.left),n.left.color===R.Black&&n.right.color===R.Black?(n.color=R.Red,c=c.parent):(n.left.color===R.Black&&(n.right.color=R.Black,n.color=R.Red,s(r,n),n=c.parent.left),n.color=c.parent.color,c.parent.color=R.Black,n.left.color=R.Black,k(r,c.parent),c=r.root));c.color=R.Black,$()}function a(r,o){for(d(r,o);o!==r.root&&o.parent.color===R.Red;)if(o.parent===o.parent.parent.left){const c=o.parent.parent.right;c.color===R.Red?(o.parent.color=R.Black,c.color=R.Black,o.parent.parent.color=R.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,s(r,o)),o.parent.color=R.Black,o.parent.parent.color=R.Red,k(r,o.parent.parent))}else{const c=o.parent.parent.left;c.color===R.Red?(o.parent.color=R.Black,c.color=R.Black,o.parent.parent.color=R.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,k(r,o)),o.parent.color=R.Black,o.parent.parent.color=R.Red,s(r,o.parent.parent))}r.root.color=R.Black}function S(r,o,c,l){for(;o!==r.root&&o!==e.$aD;)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=l),o=o.parent}function d(r,o){let c=0,l=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,c=T(o.left)-o.size_left,l=A(o.left)-o.lf_left,o.size_left+=c,o.lf_left+=l;o!==r.root&&(c!==0||l!==0);)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=l),o=o.parent}}}),define(Oe[100],Ne([1,0,27,101,32,52,160,102]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=e.$sD=e.$rD=void 0,e.$pD=y,e.$qD=a;const $=65535;function s(l){let i;return l[l.length-1]<65536?i=new Uint16Array(l.length):i=new Uint32Array(l.length),i.set(l,0),i}class k{constructor(i,n,t,g,u){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=g,this.isBasicASCII=u}}function y(l,i=!0){const n=[0];let t=1;for(let g=0,u=l.length;g<u;g++){const m=l.charCodeAt(g);m===v.CharCode.CarriageReturn?g+1<u&&l.charCodeAt(g+1)===v.CharCode.LineFeed?(n[t++]=g+2,g++):n[t++]=g+1:m===v.CharCode.LineFeed&&(n[t++]=g+1)}return i?s(n):n}function a(l,i){l.length=0,l[0]=0;let n=1,t=0,g=0,u=0,m=!0;for(let h=0,E=i.length;h<E;h++){const D=i.charCodeAt(h);D===v.CharCode.CarriageReturn?h+1<E&&i.charCodeAt(h+1)===v.CharCode.LineFeed?(u++,l[n++]=h+2,h++):(t++,l[n++]=h+1):D===v.CharCode.LineFeed?(g++,l[n++]=h+1):m&&D!==v.CharCode.Tab&&(D<32||D>126)&&(m=!1)}const p=new k(s(l),t,g,u,m);return l.length=0,p}class S{constructor(i,n,t,g,u){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=g,this.length=u}}e.$rD=S;class d{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$sD=d;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==T.$aD&&i.iterate(i.root,t=>(t!==T.$aD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let g=0;g<t.length;g++){const u=t[g];if(u.node.parent===null||u.nodeStartOffset>=i){t[g]=null,n=!0;continue}}if(n){const g=[];for(const u of t)u!==null&&g.push(u);this.b=g}}}class c{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=T.$aD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let g=null;for(let u=0,m=i.length;u<m;u++)if(i[u].buffer.length>0){i[u].lineStarts||(i[u].lineStarts=y(i[u].buffer));const p=new S(u+1,{line:0,column:0},{line:i[u].lineStarts.length-1,column:i[u].buffer.length-i[u].lineStarts[i[u].lineStarts.length-1]},i[u].lineStarts.length-1,i[u].buffer.length);this.a.push(i[u]),g=this.S(g,p)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=$,t=n-Math.floor(n/3),g=t*2;let u="",m=0;const p=[];if(this.iterate(this.root,h=>{const E=this.R(h),D=E.length;if(m<=t||m+D<g)return u+=E,m+=D,!0;const w=u.replace(/\r\n|\r|\n/g,i);return p.push(new d(w,y(w))),u=E,m=D,!0}),m>0){const h=u.replace(/\r\n|\r|\n/g,i);p.push(new d(h,y(h)))}this.create(p,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,g=>{if(g===T.$aD)return!0;const u=this.R(g),m=u.length,p=i.G(n),h=i.G(n+m),E=i.getValueInRange2(p,h);return n+=m,u===E})}getOffsetAt(i,n){let t=0,g=this.root;for(;g!==T.$aD;)if(g.left!==T.$aD&&g.lf_left+1>=i)g=g.left;else if(g.lf_left+g.piece.lineFeedCnt+1>=i){t+=g.size_left;const u=this.B(g,i-g.lf_left-2);return t+=u+n-1}else i-=g.lf_left+g.piece.lineFeedCnt,t+=g.size_left+g.piece.length,g=g.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const g=i;for(;n!==T.$aD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const u=this.A(n,i-n.size_left);if(t+=n.lf_left+u.index,u.index===0){const m=this.getOffsetAt(t+1,1),p=g-m;return new R.$Mt(t+1,p+1)}return new R.$Mt(t+1,u.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===T.$aD){const u=this.getOffsetAt(t+1,1),m=g-i-u;return new R.$Mt(t+1,m+1)}else n=n.right;return new R.$Mt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),g=this.H(i.endLineNumber,i.endColumn),u=this.getValueInRange2(t,g);return n?n!==this.d||!this.f?u.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?u:u.replace(/\r\n|\r|\n/g,n):u}getValueInRange2(i,n){if(i.node===n.node){const p=i.node,h=this.a[p.piece.bufferIndex].buffer,E=this.u(p.piece.bufferIndex,p.piece.start);return h.substring(E+i.remainder,E+n.remainder)}let t=i.node;const g=this.a[t.piece.bufferIndex].buffer,u=this.u(t.piece.bufferIndex,t.piece.start);let m=g.substring(u+i.remainder,u+t.piece.length);for(t=t.next();t!==T.$aD;){const p=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){m+=p.substring(h,h+n.remainder);break}else m+=p.substr(h,t.piece.length);t=t.next()}return m}getLinesContent(){const i=[];let n=0,t="",g=!1;return this.iterate(this.root,u=>{if(u===T.$aD)return!0;const m=u.piece;let p=m.length;if(p===0)return!0;const h=this.a[m.bufferIndex].buffer,E=this.a[m.bufferIndex].lineStarts,D=m.start.line,w=m.end.line;let I=E[D]+m.start.column;if(g&&(h.charCodeAt(I)===v.CharCode.LineFeed&&(I++,p--),i[n++]=t,t="",g=!1,p===0))return!0;if(D===w)return!this.f&&h.charCodeAt(I+p-1)===v.CharCode.CarriageReturn?(g=!0,t+=h.substr(I,p-1)):t+=h.substr(I,p),!0;t+=this.f?h.substring(I,Math.max(I,E[D+1]-this.e)):h.substring(I,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let C=D+1;C<w;C++)t=this.f?h.substring(E[C],E[C+1]-this.e):h.substring(E[C],E[C+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&h.charCodeAt(E[w]+m.end.column-1)===v.CharCode.CarriageReturn?(g=!0,m.end.column===0?n--:t=h.substr(E[w],m.end.column-1)):t=h.substr(E[w],m.end.column),!0}),g&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],g=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(g)}else{const n=this.a[i.node.piece.bufferIndex],g=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(g)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===T.$aD)return"";const g=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start);return g.buffer.substring(u,u+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],g=this.u(n.node.piece.bufferIndex,n.node.piece.start),u=g+n.remainder,m=g+n.node.piece.length;return t.buffer.substring(u,m)}}findMatchesInNode(i,n,t,g,u,m,p,h,E,D,w){const I=this.a[i.piece.bufferIndex],C=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,u),b=this.u(i.piece.bufferIndex,m);let M;const N={line:0,column:0};let F,W;n._wordSeparators?(F=I.buffer.substring(f,b),W=K=>K+f,n.reset(0)):(F=I.buffer,W=K=>K,n.reset(f));do if(M=n.next(F),M){if(W(M.index)>=b)return D;this.s(i,W(M.index)-C,N);const K=this.t(i.piece.bufferIndex,u,N),L=N.line===u.line?N.column-u.column+g:N.column+1,Q=L+M[0].length;if(w[D++]=(0,A.$lD)(new P.$Nt(t+K,L,t+K,Q),M,h),W(M.index)+M[0].length>=b||D>=E)return D}while(M);return D}findMatchesLineByLine(i,n,t,g){const u=[];let m=0;const p=new A.$oD(n.wordSeparators,n.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(h.node,h.remainder);const w=this.s(E.node,E.remainder);if(h.node===E.node)return this.findMatchesInNode(h.node,p,i.startLineNumber,i.startColumn,D,w,n,t,g,m,u),u;let I=i.startLineNumber,C=h.node;for(;C!==E.node;){const b=this.t(C.piece.bufferIndex,D,C.piece.end);if(b>=1){const N=this.a[C.piece.bufferIndex].lineStarts,F=this.u(C.piece.bufferIndex,C.piece.start),W=N[D.line+b],K=I===i.startLineNumber?i.startColumn:1;if(m=this.findMatchesInNode(C,p,I,K,D,this.s(C,W-F),n,t,g,m,u),m>=g)return u;I+=b}const M=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const N=this.getLineContent(I).substring(M,i.endColumn-1);return m=this.n(n,p,N,i.endLineNumber,M,m,u,t,g),u}if(m=this.n(n,p,this.getLineContent(I).substr(M),I,M,m,u,t,g),m>=g)return u;I++,h=this.H(I,1),C=h.node,D=this.s(h.node,h.remainder)}if(I===i.endLineNumber){const b=I===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(I).substring(b,i.endColumn-1);return m=this.n(n,p,M,i.endLineNumber,b,m,u,t,g),u}const f=I===i.startLineNumber?i.startColumn:1;return m=this.findMatchesInNode(E.node,p,I,f,D,w,n,t,g,m,u),u}n(i,n,t,g,u,m,p,h,E){const D=i.wordSeparators;if(!h&&i.simpleSearch){const I=i.simpleSearch,C=I.length,f=t.length;let b=-C;for(;(b=t.indexOf(I,b+C))!==-1;)if((!D||(0,A.$nD)(D,t,f,b,C))&&(p[m++]=new O.$dw(new P.$Nt(g,b+1+u,g,b+1+C+u),null),m>=E))return m;return m}let w;n.reset(0);do if(w=n.next(t),w&&(p[m++]=(0,A.$lD)(new P.$Nt(g,w.index+1+u,g,w.index+1+w[0].length+u),w,h),m>=E))return m;while(w);return m}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==T.$aD){const{node:g,remainder:u,nodeStartOffset:m}=this.G(i),p=g.piece,h=p.bufferIndex,E=this.s(g,u);if(g.piece.bufferIndex===0&&p.end.line===this.g.line&&p.end.column===this.g.column&&m+p.length===i&&n.length<$){this.F(g,n),this.y();return}if(m===i)this.o(n,g),this.h.validate(i);else if(m+g.piece.length>i){const D=[];let w=new S(p.bufferIndex,E,p.end,this.t(p.bufferIndex,E,p.end),this.u(h,p.end)-this.u(h,E));if(this.K()&&this.M(n)&&this.I(g,u)===10){const b={line:w.start.line+1,column:0};w=new S(w.bufferIndex,b,w.end,this.t(w.bufferIndex,b,w.end),w.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(g,u-1)===13){const b=this.s(g,u-1);this.C(g,b),n="\r"+n,g.piece.length===0&&D.push(g)}else this.C(g,E);else this.C(g,E);const I=this.w(n);w.length>0&&this.S(g,w);let C=g;for(let f=0;f<I.length;f++)C=this.S(C,I[f]);this.v(D)}else this.q(n,g)}else{const g=this.w(n);let u=this.T(null,g[0]);for(let m=1;m<g.length;m++)u=this.S(u,g[m])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===T.$aD)return;const t=this.G(i),g=this.G(i+n),u=t.node,m=g.node;if(u===m){const I=this.s(u,t.remainder),C=this.s(u,g.remainder);if(t.nodeStartOffset===i){if(n===u.piece.length){const f=u.next();(0,T.$fD)(this,u),this.N(f),this.y();return}this.D(u,C),this.h.validate(i),this.N(u),this.y();return}if(t.nodeStartOffset+u.piece.length===i+n){this.C(u,I),this.O(u),this.y();return}this.E(u,I,C),this.y();return}const p=[],h=this.s(u,t.remainder);this.C(u,h),this.h.validate(i),u.piece.length===0&&p.push(u);const E=this.s(m,g.remainder);this.D(m,E),m.piece.length===0&&p.push(m);const D=u.next();for(let I=D;I!==T.$aD&&I!==m;I=I.next())p.push(I);const w=u.piece.length===0?u.prev():u;this.v(p),this.O(w),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const m=n.piece,p={line:m.start.line+1,column:0},h=new S(m.bufferIndex,p,m.end,this.t(m.bufferIndex,p,m.end),m.length-1);n.piece=h,i+=`
`,(0,T.$hD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const g=this.w(i);let u=this.T(n,g[g.length-1]);for(let m=g.length-2;m>=0;m--)u=this.T(u,g[m]);this.N(u),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),g=this.S(n,t[0]);let u=g;for(let m=1;m<t.length;m++)u=this.S(u,t[m]);this.N(g)}s(i,n,t){const g=i.piece,u=i.piece.bufferIndex,m=this.a[u].lineStarts,h=m[g.start.line]+g.start.column+n;let E=g.start.line,D=g.end.line,w=0,I=0,C=0;for(;E<=D&&(w=E+(D-E)/2|0,C=m[w],w!==D);)if(I=m[w+1],h<C)D=w-1;else if(h>=I)E=w+1;else break;return t?(t.line=w,t.column=h-C,null):{line:w,column:h-C}}t(i,n,t){if(t.column===0)return t.line-n.line;const g=this.a[i].lineStarts;if(t.line===g.length-1)return t.line-n.line;const u=g[t.line+1],m=g[t.line]+t.column;if(u>m+1)return t.line-n.line;const p=m-1;return this.a[i].buffer.charCodeAt(p)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,T.$fD)(this,i[n])}w(i){if(i.length>$){const D=[];for(;i.length>$;){const I=i.charCodeAt($-1);let C;I===v.CharCode.CarriageReturn||I>=55296&&I<=56319?(C=i.substring(0,$-1),i=i.substring($-1)):(C=i.substring(0,$),i=i.substring($));const f=y(C);D.push(new S(this.a.length,{line:0,column:0},{line:f.length-1,column:C.length-f[f.length-1]},f.length-1,C.length)),this.a.push(new d(C,f))}const w=y(i);return D.push(new S(this.a.length,{line:0,column:0},{line:w.length-1,column:i.length-w[w.length-1]},w.length-1,i.length)),this.a.push(new d(i,w)),D}let n=this.a[0].buffer.length;const t=y(i,!1);let g=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},g=this.g;for(let D=0;D<t.length;D++)t[D]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let D=0;D<t.length;D++)t[D]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const u=this.a[0].buffer.length,m=this.a[0].lineStarts.length-1,p=u-this.a[0].lineStarts[m],h={line:m,column:p},E=new S(0,g,h,this.t(0,g,h),u-n);return this.g=h,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,g="";const u=this.h.get2(i);if(u){t=u.node;const m=this.B(t,i-u.nodeStartLineNumber-1),p=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(u.nodeStartLineNumber+t.piece.lineFeedCnt===i)g=p.substring(h+m,h+t.piece.length);else{const E=this.B(t,i-u.nodeStartLineNumber);return p.substring(h+m,h+E-n)}}else{let m=0;const p=i;for(;t!==T.$aD;)if(t.left!==T.$aD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const h=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);return m+=t.size_left,this.h.set({node:t,nodeStartOffset:m,nodeStartLineNumber:p-(i-1-t.lf_left)}),D.substring(w+h,w+E-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const h=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);g=E.substring(D+h,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,m+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==T.$aD;){const m=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const p=this.B(t,0),h=this.u(t.piece.bufferIndex,t.piece.start);return g+=m.substring(h,h+p-n),g}else{const p=this.u(t.piece.bufferIndex,t.piece.start);g+=m.substr(p,t.piece.length)}t=t.next()}return g}y(){let i=this.root,n=1,t=0;for(;i!==T.$aD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,g=this.s(i,n),u=g.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const m=this.t(i.piece.bufferIndex,t.start,g);if(m!==u)return{index:m,remainder:0}}return{index:u,remainder:g.column}}B(i,n){if(n<0)return 0;const t=i.piece,g=this.a[t.bufferIndex].lineStarts,u=t.start.line+n+1;return u>t.end.line?g[t.end.line]+t.end.column-g[t.start.line]-t.start.column:g[u]-g[t.start.line]-t.start.column}C(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.end),m=n,p=this.u(t.bufferIndex,m),h=this.t(t.bufferIndex,t.start,m),E=h-g,D=p-u,w=t.length+D;i.piece=new S(t.bufferIndex,t.start,m,h,w),(0,T.$hD)(this,i,D,E)}D(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.start),m=n,p=this.t(t.bufferIndex,m,t.end),h=this.u(t.bufferIndex,m),E=p-g,D=u-h,w=t.length+D;i.piece=new S(t.bufferIndex,m,t.end,p,w),(0,T.$hD)(this,i,D,E)}E(i,n,t){const g=i.piece,u=g.start,m=g.end,p=g.length,h=g.lineFeedCnt,E=n,D=this.t(g.bufferIndex,g.start,E),w=this.u(g.bufferIndex,n)-this.u(g.bufferIndex,u);i.piece=new S(g.bufferIndex,g.start,E,D,w),(0,T.$hD)(this,i,w-p,D-h);const I=new S(g.bufferIndex,t,m,this.t(g.bufferIndex,t,m),this.u(g.bufferIndex,m)-this.u(g.bufferIndex,t)),C=this.S(i,I);this.N(C)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),g=this.a[0].buffer.length;this.a[0].buffer+=n;const u=y(n,!1);for(let C=0;C<u.length;C++)u[C]+=g;if(t){const C=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:g-C}}this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1));const m=this.a[0].lineStarts.length-1,p=this.a[0].buffer.length-this.a[0].lineStarts[m],h={line:m,column:p},E=i.piece.length+n.length,D=i.piece.lineFeedCnt,w=this.t(0,i.piece.start,h),I=w-D;i.piece=new S(i.piece.bufferIndex,i.piece.start,h,w,E),this.g=h,(0,T.$hD)(this,i,n.length,I)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let g=0;for(;n!==T.$aD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){g+=n.size_left;const u={node:n,remainder:i-n.size_left,nodeStartOffset:g};return this.h.set(u),u}else i-=n.size_left+n.piece.length,g+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,g=0;for(;t!==T.$aD;)if(t.left!==T.$aD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.B(t,i-t.lf_left-2),m=this.B(t,i-t.lf_left-1);return g+=t.size_left,{node:t,remainder:Math.min(u+n-1,m),nodeStartOffset:g}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.B(t,i-t.lf_left-2);if(u+n-1<=t.piece.length)return{node:t,remainder:u+n-1,nodeStartOffset:g};n-=t.piece.length-u;break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==T.$aD;){if(t.piece.lineFeedCnt>0){const u=this.B(t,0),m=this.J(t);return{node:t,remainder:Math.min(n-1,u),nodeStartOffset:m}}else if(t.piece.length>=n-1){const u=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:u}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(g)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===T.$aD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,g=n.start.line,u=t[g]+n.start.column;return g===t.length-1||t[g+1]>u+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(u)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===T.$aD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],g=this.a[i.piece.bufferIndex].lineStarts;let u;i.piece.end.column===0?u={line:i.piece.end.line-1,column:g[i.piece.end.line]-g[i.piece.end.line-1]-1}:u={line:i.piece.end.line,column:i.piece.end.column-1};const m=i.piece.length-1,p=i.piece.lineFeedCnt-1;i.piece=new S(i.piece.bufferIndex,i.piece.start,u,p,m),(0,T.$hD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const h={line:n.piece.start.line+1,column:0},E=n.piece.length-1,D=this.t(n.piece.bufferIndex,h,n.piece.end);n.piece=new S(n.piece.bufferIndex,h,n.piece.end,D,E),(0,T.$hD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const w=this.w(`\r
`);this.S(i,w[0]);for(let I=0;I<t.length;I++)(0,T.$fD)(this,t[I])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,T.$fD)(this,t);else{const g=t.piece,u={line:g.start.line+1,column:0},m=g.length-1,p=this.t(g.bufferIndex,u,g.end);t.piece=new S(g.bufferIndex,u,g.end,p,m),(0,T.$hD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===T.$aD)return n(T.$aD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===T.$aD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,g=this.u(t.bufferIndex,t.start),u=this.u(t.bufferIndex,t.end);return n.buffer.substring(g,u)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),g=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,g)}S(i,n){const t=new T.$_C(n,T.NodeColor.Red);if(t.left=T.$aD,t.right=T.$aD,t.parent=T.$aD,t.size_left=0,t.lf_left=0,this.root===T.$aD)this.root=t,t.color=T.NodeColor.Black;else if(i.right===T.$aD)i.right=t,t.parent=i;else{const u=(0,T.$bD)(i.right);u.left=t,t.parent=u}return(0,T.$gD)(this,t),t}T(i,n){const t=new T.$_C(n,T.NodeColor.Red);if(t.left=T.$aD,t.right=T.$aD,t.parent=T.$aD,t.size_left=0,t.lf_left=0,this.root===T.$aD)this.root=t,t.color=T.NodeColor.Black;else if(i.left===T.$aD)i.left=t,t.parent=i;else{const g=(0,T.$cD)(i.left);g.right=t,t.parent=g}return(0,T.$gD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$tD=c}),define(Oe[161],Ne([1,0,6,12,32,52,100,153,155,4]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uD=void 0,R=We(R);class k extends s.$Uc{constructor(a,S,d,r,o,c,l){super(),this.m=this.B(new v.$le),this.onDidChangeContent=this.m.event,this.f=S,this.j=!c,this.g=r,this.h=o,this.c=new T.$tD(a,d,l)}equals(a){return!(a instanceof k)||this.f!==a.f||this.getEOL()!==a.getEOL()?!1:this.c.equal(a.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(a){return this.c.createSnapshot(a?this.f:"")}getOffsetAt(a,S){return this.c.getOffsetAt(a,S)}getPositionAt(a){return this.c.getPositionAt(a)}getRangeAt(a,S){const d=a+S,r=this.getPositionAt(a),o=this.getPositionAt(d);return new P.$Nt(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return"";const d=this.n(S);return this.c.getValueInRange(a,d)}getValueLengthInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return 0;if(a.startLineNumber===a.endLineNumber)return a.endColumn-a.startColumn;const d=this.getOffsetAt(a.startLineNumber,a.startColumn),r=this.getOffsetAt(a.endLineNumber,a.endColumn);let o=0;const c=this.n(S),l=this.getEOL();if(c.length!==l.length){const i=c.length-l.length,n=a.endLineNumber-a.startLineNumber;o=i*n}return r-d+o}getCharacterCountInRange(a,S=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=a.startLineNumber,o=a.endLineNumber;for(let c=r;c<=o;c++){const l=this.getLineContent(c),i=c===r?a.startColumn-1:0,n=c===o?a.endColumn-1:l.length;for(let t=i;t<n;t++)R.$Jf(l.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(S).length*(o-r),d}return this.getValueLengthInRange(a,S)}getNearestChunk(a){return this.c.getNearestChunk(a)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(a){return this.c.getLineContent(a)}getLineCharCode(a,S){return this.c.getLineCharCode(a,S)}getCharCode(a){return this.c.getCharCode(a)}getLineLength(a){return this.c.getLineLength(a)}getLineMinColumn(a){return 1}getLineMaxColumn(a){return this.getLineLength(a)+1}getLineFirstNonWhitespaceColumn(a){const S=R.$uf(this.getLineContent(a));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(a){const S=R.$wf(this.getLineContent(a));return S===-1?0:S+2}n(a){switch(a){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(a){this.c.setEOL(a)}applyEdits(a,S,d){let r=this.g,o=this.h,c=this.j,l=!0,i=[];for(let h=0;h<a.length;h++){const E=a[h];l&&E._isTracked&&(l=!1);const D=E.range;if(E.text){let b=!0;c||(b=!R.$Uf(E.text),c=b),!r&&b&&(r=R.$Tf(E.text)),!o&&b&&(o=R.$Wf(E.text))}let w="",I=0,C=0,f=0;if(E.text){let b;[I,C,f,b]=(0,A.$yu)(E.text);const M=this.getEOL(),N=M===`\r
`?A.StringEOL.CRLF:A.StringEOL.LF;b===A.StringEOL.Unknown||b===N?w=E.text:w=E.text.replace(/\r\n|\r|\n/g,M)}i[h]={sortIndex:h,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:w,eolCount:I,firstLineLength:C,lastLineLength:f,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(k.u);let n=!1;for(let h=0,E=i.length-1;h<E;h++){const D=i[h].range.getEndPosition(),w=i[h+1].range.getStartPosition();if(w.isBeforeOrEqual(D)){if(w.isBefore(D))throw new Error("Overlapping ranges are not allowed!");n=!0}}l&&(i=this.s(i));const t=d||S?k._getInverseEditRanges(i):[],g=[];if(S)for(let h=0;h<i.length;h++){const E=i[h],D=t[h];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let w=D.startLineNumber;w<=D.endLineNumber;w++){let I="";w===D.startLineNumber&&(I=this.getLineContent(E.range.startLineNumber),R.$uf(I)!==-1)||g.push({lineNumber:w,oldContent:I})}}let u=null;if(d){let h=0;u=[];for(let E=0;E<i.length;E++){const D=i[E],w=t[E],I=this.getValueInRange(D.range),C=D.rangeOffset+h;h+=D.text.length-I.length,u[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:w,text:I,textChange:new $.$eu(D.rangeOffset,I,C,D.text)}}n||u.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=r,this.h=o,this.j=c;const m=this.t(i);let p=null;if(S&&g.length>0){g.sort((h,E)=>E.lineNumber-h.lineNumber),p=[];for(let h=0,E=g.length;h<E;h++){const D=g[h].lineNumber;if(h>0&&g[h-1].lineNumber===D)continue;const w=g[h].oldContent,I=this.getLineContent(D);I.length===0||I===w||R.$uf(I)!==-1||p.push(D)}}return this.m.fire(),new O.$hw(u,m,p)}s(a){return a.length<1e3?a:[this._toSingleEditOperation(a)]}_toSingleEditOperation(a){let S=!1;const d=a[0].range,r=a[a.length-1].range,o=new P.$Nt(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let c=d.startLineNumber,l=d.startColumn;const i=[];for(let m=0,p=a.length;m<p;m++){const h=a[m],E=h.range;S=S||h.forceMoveMarkers,i.push(this.getValueInRange(new P.$Nt(c,l,E.startLineNumber,E.startColumn))),h.text.length>0&&i.push(h.text),c=E.endLineNumber,l=E.endColumn}const n=i.join(""),[t,g,u]=(0,A.$yu)(n);return{sortIndex:0,identifier:a[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,O.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:g,lastLineLength:u,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(a){a.sort(k.w);const S=[];for(let d=0;d<a.length;d++){const r=a[d],o=r.range.startLineNumber,c=r.range.startColumn,l=r.range.endLineNumber,i=r.range.endColumn;if(o===l&&c===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new P.$Nt(o,c,l,i);S.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return S}findMatchesLineByLine(a,S,d,r){return this.c.findMatchesLineByLine(a,S,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(a,S){const d=a.startLineNumber,r=a.startColumn,[o,c,l]=(0,A.$yu)(S);let i;if(S.length>0){const n=o+1;n===1?i=new P.$Nt(d,r,d,r+c):i=new P.$Nt(d,r,d+n-1,l+1)}else i=new P.$Nt(d,r,d,r);return i}static _getInverseEditRanges(a){const S=[];let d=0,r=0,o=null;for(let c=0,l=a.length;c<l;c++){const i=a[c];let n,t;o?o.range.endLineNumber===i.range.startLineNumber?(n=d,t=r+(i.range.startColumn-o.range.endColumn)):(n=d+(i.range.startLineNumber-o.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let g;if(i.text.length>0){const u=i.eolCount+1;u===1?g=new P.$Nt(n,t,n,t+i.firstLineLength):g=new P.$Nt(n,t,n+u-1,i.lastLineLength+1)}else g=new P.$Nt(n,t,n,t);d=g.endLineNumber,r=g.endColumn,S.push(g),o=i}return S}static u(a,S){const d=P.$Nt.compareRangesUsingEnds(a.range,S.range);return d===0?a.sortIndex-S.sortIndex:d}static w(a,S){const d=P.$Nt.compareRangesUsingEnds(a.range,S.range);return d===0?S.sortIndex-a.sortIndex:-d}}e.$uD=k}),define(Oe[162],Ne([1,0,27,12,52,100,161]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vD=void 0,R=We(R);class A{constructor(k,y,a,S,d,r,o,c,l){this.a=k,this.b=y,this.c=a,this.d=S,this.e=d,this.f=r,this.g=o,this.h=c,this.j=l}k(k){const y=this.c+this.d+this.e,a=this.c+this.e;return y===0?k===P.DefaultEndOfLine.LF?`
`:`\r
`:a>y/2?`\r
`:`
`}create(k){const y=this.k(k),a=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,r=a.length;d<r;d++){const o=a[d].buffer.replace(/\r\n|\r|\n/g,y),c=(0,O.$pD)(o);a[d]=new O.$sD(o,c)}const S=new T.$uD(a,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(k){return this.a[0].buffer.substr(0,k).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(k){if(k.length===0)return;this.a.length===0&&R.$5f(k)&&(this.b=R.$4f,k=k.substr(1));const y=k.charCodeAt(k.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(k.substr(0,k.length-1),!1),this.c=!0,this.d=y):(this.m(k,!1),this.c=!1,this.d=y)}m(k,y){!y&&k.length===0||(this.c?this.n(String.fromCharCode(this.d)+k):this.n(k))}n(k){const y=(0,O.$qD)(this.e,k);this.a.push(new O.$sD(k,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=R.$Tf(k)),this.k||(this.k=R.$Wf(k)))}finish(k=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,k)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const k=this.a[this.a.length-1];k.buffer+=String.fromCharCode(this.d);const y=(0,O.$pD)(k.buffer);k.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$vD=$}),define(Oe[103],Ne([1,0,22,20]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udb=$,e.$Vdb=k,R=We(R);var P;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(P||(P={}));function O(y){for(let a=0,S=y.length;a<S;a+=4){const d=y[a+0],r=y[a+1],o=y[a+2],c=y[a+3];y[a+0]=c,y[a+1]=o,y[a+2]=r,y[a+3]=d}}function T(y){const a=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return R.$E()||O(a),v.$Ne.wrap(a)}function A(y){const a=y.buffer;if(R.$E()||O(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const S=new Uint8Array(a.byteLength);return S.set(a),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(y){const a=new Uint32Array(s(y));let S=0;if(a[S++]=y.id,y.type==="full")a[S++]=P.Full,a[S++]=y.data.length,a.set(y.data,S),S+=y.data.length;else{a[S++]=P.Delta,a[S++]=y.deltas.length;for(const d of y.deltas)a[S++]=d.start,a[S++]=d.deleteCount,d.data?(a[S++]=d.data.length,a.set(d.data,S),S+=d.data.length):a[S++]=0}return T(a)}function s(y){let a=0;if(a+=2,y.type==="full")a+=1+y.data.length;else{a+=1,a+=3*y.deltas.length;for(const S of y.deltas)S.data&&(a+=S.data.length)}return a}function k(y){const a=A(y);let S=0;const d=a[S++];if(a[S++]===P.Full){const l=a[S++],i=a.subarray(S,S+l);return S+=l,{id:d,type:"full",data:i}}const o=a[S++],c=[];for(let l=0;l<o;l++){const i=a[S++],n=a[S++],t=a[S++];let g;t>0&&(g=a.subarray(S,S+t),S+=t),c[l]={start:i,deleteCount:n,data:g}}return{id:d,type:"delta",deltas:c}}}),define(Oe[163],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_=e.$L_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const T=this.a.get(O);return this.a.delete(O),T}}addDragOperationTransfer(O,T){this.a.set(O,T)}}e.$L_=v;class R{constructor(O){this.identifier=O}}e.$M_=R}),define(Oe[164],Ne([1,0,6,4,9]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=void 0,e.$oj=k,P=We(P);class O extends R.$Uc{constructor(a,S="",d="",r=!0,o){super(),this.j=this.B(new v.$le),this.onDidChange=this.j.event,this.z=!0,this.m=a,this.n=S,this.w=d,this.z=r,this.D=o}get id(){return this.m}get label(){return this.n}set label(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.j.fire({label:a}))}get tooltip(){return this.u||""}set tooltip(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.j.fire({tooltip:a}))}get class(){return this.w}set class(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.j.fire({class:a}))}get enabled(){return this.z}set enabled(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.j.fire({enabled:a}))}get checked(){return this.C}set checked(a){this.J(a)}J(a){this.C!==a&&(this.C=a,this.j.fire({checked:a}))}async run(a,S){this.D&&await this.D(a)}}e.$jj=O;class T extends R.$Uc{constructor(){super(...arguments),this.f=this.B(new v.$le),this.onWillRun=this.f.event,this.m=this.B(new v.$le),this.onDidRun=this.m.event}async run(a,S){if(!a.enabled)return;this.f.fire({action:a});let d;try{await this.u(a,S)}catch(r){d=r}this.m.fire({action:a,error:d})}async u(a,S){await a.run(S)}}e.$kj=T;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let S=[];for(const d of a)d.length&&(S.length?S=[...S,new A,...d]:S=d);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$lj=A;class ${get actions(){return this.a}constructor(a,S,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=S,this.class=r,this.a=d}async run(){}}e.$mj=$;class s extends O{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,P.localize(13003,null),void 0,!1)}}e.$nj=s;function k(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...a)=>y.run(...a)}}}),define(Oe[165],Ne([1,0,9]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=s,e.$2m=k,e.$3m=y;const R=60,P=R*60,O=P*24,T=O*7,A=O*30,$=O*365;function s(a,S,d,r){typeof a!="number"&&(a=a.getTime());const o=Math.round((new Date().getTime()-a)/1e3);if(o<-30)return(0,v.localize)(12940,null,s(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,v.localize)(12941,null);let c;return o<R?(c=o,S?c===1?d?(0,v.localize)(12942,null,c):(0,v.localize)(12943,null,c):d?(0,v.localize)(12944,null,c):(0,v.localize)(12945,null,c):c===1?d?(0,v.localize)(12946,null,c):(0,v.localize)(12947,null,c):d?(0,v.localize)(12948,null,c):(0,v.localize)(12949,null,c)):o<P?(c=Math.floor(o/R),S?c===1?d?(0,v.localize)(12950,null,c):(0,v.localize)(12951,null,c):d?(0,v.localize)(12952,null,c):(0,v.localize)(12953,null,c):c===1?d?(0,v.localize)(12954,null,c):(0,v.localize)(12955,null,c):d?(0,v.localize)(12956,null,c):(0,v.localize)(12957,null,c)):o<O?(c=Math.floor(o/P),S?c===1?d?(0,v.localize)(12958,null,c):(0,v.localize)(12959,null,c):d?(0,v.localize)(12960,null,c):(0,v.localize)(12961,null,c):c===1?d?(0,v.localize)(12962,null,c):(0,v.localize)(12963,null,c):d?(0,v.localize)(12964,null,c):(0,v.localize)(12965,null,c)):o<T?(c=Math.floor(o/O),S?c===1?(0,v.localize)(12966,null,c):(0,v.localize)(12967,null,c):c===1?(0,v.localize)(12968,null,c):(0,v.localize)(12969,null,c)):o<A?(c=Math.floor(o/T),S?c===1?d?(0,v.localize)(12970,null,c):(0,v.localize)(12971,null,c):d?(0,v.localize)(12972,null,c):(0,v.localize)(12973,null,c):c===1?d?(0,v.localize)(12974,null,c):(0,v.localize)(12975,null,c):d?(0,v.localize)(12976,null,c):(0,v.localize)(12977,null,c)):o<$?(c=Math.floor(o/A),S?c===1?d?(0,v.localize)(12978,null,c):(0,v.localize)(12979,null,c):d?(0,v.localize)(12980,null,c):(0,v.localize)(12981,null,c):c===1?d?(0,v.localize)(12982,null,c):(0,v.localize)(12983,null,c):d?(0,v.localize)(12984,null,c):(0,v.localize)(12985,null,c)):(c=Math.floor(o/$),S?c===1?d?(0,v.localize)(12986,null,c):(0,v.localize)(12987,null,c):d?(0,v.localize)(12988,null,c):(0,v.localize)(12989,null,c):c===1?d?(0,v.localize)(12990,null,c):(0,v.localize)(12991,null,c):d?(0,v.localize)(12992,null,c):(0,v.localize)(12993,null,c))}function k(a,S){const d=Math.abs(a/1e3);return d<1?S?(0,v.localize)(12994,null,a):(0,v.localize)(12995,null,a):d<R?S?(0,v.localize)(12996,null,Math.round(a)/1e3):(0,v.localize)(12997,null,Math.round(a)/1e3):d<P?S?(0,v.localize)(12998,null,Math.round(a/(1e3*R))):(0,v.localize)(12999,null,Math.round(a/(1e3*R))):d<O?S?(0,v.localize)(13e3,null,Math.round(a/(1e3*P))):(0,v.localize)(13001,null,Math.round(a/(1e3*P))):(0,v.localize)(13002,null,Math.round(a/(1e3*O)))}function y(a){return a.getFullYear()+"-"+String(a.getMonth()+1).padStart(2,"0")+"-"+String(a.getDate()).padStart(2,"0")+"T"+String(a.getHours()).padStart(2,"0")+":"+String(a.getMinutes()).padStart(2,"0")+":"+String(a.getSeconds()).padStart(2,"0")+"."+(a.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Oe[42],Ne([1,0,17,14,9]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=$,e.$qj=s,e.$rj=k,v=We(v),R=We(R),P=We(P);function O(y,a){return a&&(y.stack||y.stacktrace)?P.localize(12934,null,A(y),T(y.stack)||T(y.stacktrace)):A(y)}function T(y){return Array.isArray(y)?y.join(`
`):y}function A(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(12935,null,y.message):y.message||P.localize(12936,null)}function $(y=null,a=!1){if(!y)return P.localize(12937,null);if(Array.isArray(y)){const S=v.$Gb(y),d=$(S[0],a);return S.length>1?P.localize(12938,null,d,S.length):d}if(R.$eg(y))return y;if(y.detail){const S=y.detail;if(S.error)return O(S.error,a);if(S.exception)return O(S.exception,a)}return y.stack?O(y,a):y.message?y.message:P.localize(12939,null)}function s(y){const a=y;return a instanceof Error&&Array.isArray(a.actions)}function k(y,a){let S;return typeof y=="string"?S=new Error(y):S=y,S.actions=a,S}}),define(Oe[166],Ne([1,0,27,13,9]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var O;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(O||(e.TokenType=O={}));function T(...k){switch(k.length){case 1:return(0,P.localize)(11538,null,k[0]);case 2:return(0,P.localize)(11539,null,k[0],k[1]);case 3:return(0,P.localize)(11540,null,k[0],k[1],k[2]);default:return}}const A=(0,P.localize)(11541,null),$=(0,P.localize)(11542,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return y.isTripleEq?"===":"==";case O.NotEq:return y.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return y.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return y.lexeme;case O.QuotedStr:return y.lexeme;case O.Error:return y.lexeme;case O.EOF:return"EOF";default:throw(0,R.$7)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(O.LParen);break;case v.CharCode.CloseParen:this.k(O.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:a})}else this.k(O.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:a})}else this.h(v.CharCode.Tilde)?this.k(O.RegexOp):this.l(T("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?O.LtEq:O.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?O.GtEq:O.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(O.And):this.l(T("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(O.Or):this.l(T("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const a=this.d,S=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:S};this.g.push({offset:a,lexeme:S,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const a=this.c.substring(this.d,this.e),S=s.b.get(a);S?this.k(S):this.f.push({type:O.Str,lexeme:a,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,a=!1,S=!1;for(;;){if(y>=this.c.length){this.e=y,this.l($);return}const r=this.c.charCodeAt(y);if(a)a=!1;else if(r===v.CharCode.Slash&&!S){y++;break}else r===v.CharCode.OpenSquareBracket?S=!0:r===v.CharCode.Backslash?a=!0:r===v.CharCode.CloseSquareBracket&&(S=!1);y++}for(;y<this.c.length&&s.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=s}),define(Oe[104],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Oe[73],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class v{constructor(P,O=[],T=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=T}}e.$Bi=v}),define(Oe[60],Ne([1,0,73]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Qs=O,e.$Rs=T;const R=[];var P;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(A,$,s){$ instanceof v.$Bi||($=new v.$Bi($,[],!!s)),R.push([A,$])}function T(){return R}}),define(Oe[167],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;class v{constructor(O,T){this.key=O,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$tr=v;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const T of this.a.values())T.outgoing.size===0&&O.push(T);return O}insertEdge(O,T){const A=this.lookupOrInsertNode(O),$=this.lookupOrInsertNode(T);A.outgoing.set($.key,$),$.incoming.set(A.key,A)}removeNode(O){const T=this.b(O);this.a.delete(T);for(const A of this.a.values())A.outgoing.delete(T),A.incoming.delete(T)}lookupOrInsertNode(O){const T=this.b(O);let A=this.a.get(T);return A||(A=new v(T,O),this.a.set(T,A)),A}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[T,A]of this.a)O.push(`${T}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,T]of this.a){const A=new Set([O]),$=this.c(T,A);if($)return $}}c(O,T){for(const[A,$]of O.outgoing){if(T.has(A))return[...T,A].join(" -> ");T.add(A);const s=this.c($,T);if(s)return s;T.delete(A)}}}e.$ur=R}),define(Oe[3],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=P,e.$Fi=O;var v;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function A($){return $[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=A})(v||(e._util=v={})),e.$Di=P("instantiationService");function R(T,A,$){A[v.DI_TARGET]===A?A[v.DI_DEPENDENCIES].push({id:T,index:$}):(A[v.DI_DEPENDENCIES]=[{id:T,index:$}],A[v.DI_TARGET]=A)}function P(T){if(v.serviceIds.has(T))return v.serviceIds.get(T);const A=function($,s,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(A,$,k)};return A.toString=()=>T,v.serviceIds.set(T,A),A}function O(T){return T}}),define(Oe[43],Ne([1,0,14,2,3]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$$i=void 0,e.$_i=O,e.$aj=T,e.$bj=$,e.$cj=s,e.$dj=k,e.$ej=y,e.$fj=a,e.$gj=d,e.$hj=r,e.$ij=o,v=We(v),e.$$i=(0,P.$Ei)("configurationService");function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof R.URI)}function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof R.URI)}var A;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function $(c){switch(c){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function s(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function k(c,l){const i=Object.create(null);for(const n in c)y(i,n,c[n],l);return i}function y(c,l,i,n){const t=l.split("."),g=t.pop();let u=c;for(let m=0;m<t.length;m++){const p=t[m];let h=u[p];switch(typeof h){case"undefined":h=u[p]=Object.create(null);break;case"object":if(h===null){n(`Ignoring ${l} as ${t.slice(0,m+1).join(".")} is null`);return}break;default:n(`Ignoring ${l} as ${t.slice(0,m+1).join(".")} is ${JSON.stringify(h)}`);return}u=h}if(typeof u=="object"&&u!==null)try{u[g]=i}catch{n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}else n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}function a(c,l){const i=l.split(".");S(c,i)}function S(c,l){const i=l.shift();if(l.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const n=c[i];typeof n=="object"&&!Array.isArray(n)&&(S(n,l),Object.keys(n).length===0&&delete c[i])}}function d(c,l,i){function n(u,m){let p=u;for(const h of m){if(typeof p!="object"||p===null)return;p=p[h]}return p}const t=l.split("."),g=n(c,t);return typeof g>"u"?i:g}function r(c,l,i){Object.keys(l).forEach(n=>{n!=="__proto__"&&(n in c?v.$gg(c[n])&&v.$gg(l[n])?r(c[n],l[n],i):i&&(c[n]=l[n]):c[n]=l[n])})}function o(c){return c.replace(/[\[\]]/g,"")}}),define(Oe[31],Ne([1,0,27,20,12,166,3,9,13]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=k,e.$Dj=m,e.$Ej=p,e.$Xj=ae;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",R.$k),s.set("isLinux",R.$l),s.set("isWindows",R.$j),s.set("isWeb",R.$p),s.set("isMacNative",R.$k&&!R.$p),s.set("isEdge",R.$I),s.set("isFirefox",R.$G),s.set("isChrome",R.$F),s.set("isSafari",R.$H);function k(Y,q){if(s.get(Y)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(Y,q)}const y=Object.prototype.hasOwnProperty;var a;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(a||(e.ContextKeyExprType=a={}));const S={regexParsingWithErrorRecovery:!0},d=(0,A.localize)(11552,null),r=(0,A.localize)(11553,null),o=(0,A.localize)(11554,null),c=(0,A.localize)(11555,null),l=(0,A.localize)(11556,null),i=(0,A.localize)(11557,null),n=(0,A.localize)(11558,null),t=(0,A.localize)(11559,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=S){this.k=q,this.d=new O.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const ye=this.D(),le=ye.type===O.TokenType.Str?i:void 0;throw this.h.push({message:l,offset:ye.offset,lexeme:O.$zj.getLexeme(ye),additionalInfo:le}),g.c}return ne}catch(ne){if(ne!==g.c)throw ne;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(O.TokenType.Or);){const ne=this.o();q.push(ne)}return q.length===1?q[0]:u.or(...q)}o(){const q=[this.s()];for(;this.y(O.TokenType.And);){const ne=this.s();q.push(ne)}return q.length===1?q[0]:u.and(...q)}s(){if(this.y(O.TokenType.Neg)){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),E.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const ne=this.l();return this.A(O.TokenType.RParen,c),ne?.negate()}case O.TokenType.Str:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),u.true();case O.TokenType.False:return this.z(),u.false();case O.TokenType.LParen:{this.z();const ne=this.l();return this.A(O.TokenType.RParen,c),ne}case O.TokenType.Str:{const ne=q.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),le.type!==O.TokenType.RegexStr)throw this.B("REGEX",le);const ve=le.lexeme,de=ve.lastIndexOf("/"),J=de===ve.length-1?void 0:this.w(ve.substring(de+1));let x;try{x=new RegExp(ve.substring(1,de),J)}catch{throw this.B("REGEX",le)}return Q.create(ne,x)}switch(le.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const ve=[le.lexeme];this.z();let de=this.D(),J=0;for(let Ue=0;Ue<le.lexeme.length;Ue++)le.lexeme.charCodeAt(Ue)===v.CharCode.OpenParen?J++:le.lexeme.charCodeAt(Ue)===v.CharCode.CloseParen&&J--;for(;!this.E()&&de.type!==O.TokenType.And&&de.type!==O.TokenType.Or;){switch(de.type){case O.TokenType.LParen:J++;break;case O.TokenType.RParen:J--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ue=0;Ue<de.lexeme.length;Ue++)de.lexeme.charCodeAt(Ue)===v.CharCode.OpenParen?J++:le.lexeme.charCodeAt(Ue)===v.CharCode.CloseParen&&J--}if(J<0)break;ve.push(O.$zj.getLexeme(de)),this.z(),de=this.D()}const x=ve.join(""),pe=x.lastIndexOf("/"),$e=pe===x.length-1?void 0:this.w(x.substring(pe+1));let Ae;try{Ae=new RegExp(x.substring(1,pe),$e)}catch{throw this.B("REGEX",le)}return u.regex(ne,Ae)}case O.TokenType.QuotedStr:{const ve=le.lexeme;this.z();let de=null;if(!(0,P.$cf)(ve)){const J=ve.indexOf("/"),x=ve.lastIndexOf("/");if(J!==x&&J>=0){const pe=ve.slice(J+1,x),$e=ve[x+1]==="i"?"i":"";try{de=new RegExp(pe,$e)}catch{throw this.B("REGEX",le)}}}if(de===null)throw this.B("REGEX",le);return Q.create(ne,de)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,o);const le=this.u();return u.notIn(ne,le)}switch(this.D().type){case O.TokenType.Eq:{this.z();const le=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.equals(ne,le);switch(le){case"true":return u.has(ne);case"false":return u.not(ne);default:return u.equals(ne,le)}}case O.TokenType.NotEq:{this.z();const le=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.notEquals(ne,le);switch(le){case"true":return u.not(ne);case"false":return u.has(ne);default:return u.notEquals(ne,le)}}case O.TokenType.Lt:return this.z(),K.create(ne,this.u());case O.TokenType.LtEq:return this.z(),L.create(ne,this.u());case O.TokenType.Gt:return this.z(),F.create(ne,this.u());case O.TokenType.GtEq:return this.z(),W.create(ne,this.u());case O.TokenType.In:return this.z(),u.in(ne,this.u());default:return u.has(ne)}}case O.TokenType.EOF:throw this.h.push({message:n,offset:q.offset,lexeme:"",additionalInfo:t}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),q.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ne){if(this.C(q))return this.z();throw this.B(ne,this.D())}B(q,ne,ye){const le=(0,A.localize)(11560,null,q,O.$zj.getLexeme(ne)),ve=ne.offset,de=O.$zj.getLexeme(ne);return this.h.push({message:le,offset:ve,lexeme:de,additionalInfo:ye}),g.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Bj=g;class u{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(q){return w.create(q)}static equals(q,ne){return I.create(q,ne)}static notEquals(q,ne){return b.create(q,ne)}static regex(q,ne){return Q.create(q,ne)}static in(q,ne){return C.create(q,ne)}static notIn(q,ne){return f.create(q,ne)}static not(q){return M.create(q)}static and(...q){return ee.create(q,null,!0)}static or(...q){return me.create(q,null,!0)}static greater(q,ne){return F.create(q,ne)}static greaterEquals(q,ne){return W.create(q,ne)}static smaller(q,ne){return K.create(q,ne)}static smallerEquals(q,ne){return L.create(q,ne)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Cj=u;function m(Y){const q=new g({regexParsingWithErrorRecovery:!1});return Y.map(ne=>(q.parse(ne),q.lexingErrors.length>0?q.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,A.localize)(11561,null,ye.additionalInfo):(0,A.localize)(11562,null),offset:ye.offset,length:ye.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}function p(Y,q){const ne=Y?Y.substituteConstants():void 0,ye=q?q.substituteConstants():void 0;return!ne&&!ye?!0:!ne||!ye?!1:ne.equals(ye)}function h(Y,q){return Y.cmp(q)}class E{static{this.INSTANCE=new E}constructor(){this.type=a.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return D.INSTANCE}}e.$Fj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=a.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return E.INSTANCE}}e.$Gj=D;class w{static create(q,ne=null){const ye=s.get(q);return typeof ye=="boolean"?ye?D.INSTANCE:E.INSTANCE:new w(q,ne)}constructor(q,ne){this.key=q,this.c=ne,this.type=a.Defined}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=s.get(this.key);return typeof q=="boolean"?q?D.INSTANCE:E.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Hj=w;class I{static create(q,ne,ye=null){if(typeof ne=="boolean")return ne?w.create(q,ye):M.create(q,ye);const le=s.get(q);return typeof le=="boolean"?ne===(le?"true":"false")?D.INSTANCE:E.INSTANCE:new I(q,ne,ye)}constructor(q,ne,ye){this.c=q,this.d=ne,this.f=ye,this.type=a.Equals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?D.INSTANCE:E.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Ij=I;class C{static create(q,ne){return new C(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=a.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:we(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.f),ye=q.getValue(this.d);return Array.isArray(ne)?ne.includes(ye):typeof ye=="string"&&typeof ne=="object"&&ne!==null?y.call(ne,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Jj=C;class f{static create(q,ne){return new f(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=a.NotIn,this.c=C.create(q,ne)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=f;class b{static create(q,ne,ye=null){if(typeof ne=="boolean")return ne?M.create(q,ye):w.create(q,ye);const le=s.get(q);return typeof le=="boolean"?ne===(le?"true":"false")?E.INSTANCE:D.INSTANCE:new b(q,ne,ye)}constructor(q,ne,ye){this.c=q,this.d=ne,this.f=ye,this.type=a.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?E.INSTANCE:D.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Lj=b;class M{static create(q,ne=null){const ye=s.get(q);return typeof ye=="boolean"?ye?E.INSTANCE:D.INSTANCE:new M(q,ne)}constructor(q,ne){this.c=q,this.d=ne,this.type=a.Not}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=s.get(this.c);return typeof q=="boolean"?q?E.INSTANCE:D.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Mj=M;function N(Y,q){if(typeof Y=="string"){const ne=parseFloat(Y);isNaN(ne)||(Y=ne)}return typeof Y=="string"||typeof Y=="number"?q(Y):E.INSTANCE}class F{static create(q,ne,ye=null){return N(ne,le=>new F(q,le,ye))}constructor(q,ne,ye){this.c=q,this.d=ne,this.f=ye,this.type=a.Greater}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Nj=F;class W{static create(q,ne,ye=null){return N(ne,le=>new W(q,le,ye))}constructor(q,ne,ye){this.c=q,this.d=ne,this.f=ye,this.type=a.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Oj=W;class K{static create(q,ne,ye=null){return N(ne,le=>new K(q,le,ye))}constructor(q,ne,ye){this.c=q,this.d=ne,this.f=ye,this.type=a.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Pj=K;class L{static create(q,ne,ye=null){return N(ne,le=>new L(q,le,ye))}constructor(q,ne,ye){this.c=q,this.d=ne,this.f=ye,this.type=a.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Qj=L;class Q{static create(q,ne){return new Q(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=a.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ne=this.f?this.f.source:"",ye=q.f?q.f.source:"";return ne<ye?-1:ne>ye?1:0}equals(q){if(q.type===this.type){const ne=this.f?this.f.source:"",ye=q.f?q.f.source:"";return this.d===q.d&&ne===ye}return!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$Rj=Q;class X{static create(q){return new X(q)}constructor(q){this.c=q,this.type=a.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new X(this.c.map(q))}negate(){return this.c}}e.$Sj=X;function ue(Y){let q=null;for(let ne=0,ye=Y.length;ne<ye;ne++){const le=Y[ne].substituteConstants();if(Y[ne]!==le&&q===null){q=[];for(let ve=0;ve<ne;ve++)q[ve]=Y[ve]}q!==null&&(q[ne]=le)}return q===null?Y:q}class ee{static create(q,ne,ye){return ee.d(q,ne,ye)}constructor(q,ne){this.expr=q,this.c=ne,this.type=a.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const le=h(this.expr[ne],q.expr[ne]);if(le!==0)return le}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=ue(this.expr);return q===this.expr?this:ee.create(q,this.c,!1)}evaluate(q){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].evaluate(q))return!1;return!0}static d(q,ne,ye){const le=[];let ve=!1;for(const de of q)if(de){if(de.type===a.True){ve=!0;continue}if(de.type===a.False)return E.INSTANCE;if(de.type===a.And){le.push(...de.expr);continue}le.push(de)}if(le.length===0&&ve)return D.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(h);for(let de=1;de<le.length;de++)le[de-1].equals(le[de])&&(le.splice(de,1),de--);if(le.length===1)return le[0];for(;le.length>1;){const de=le[le.length-1];if(de.type!==a.Or)break;le.pop();const J=le.pop(),x=le.length===0,pe=me.create(de.expr.map($e=>ee.create([$e,J],null,ye)),null,x);pe&&(le.push(pe),le.sort(h))}if(le.length===1)return le[0];if(ye){for(let de=0;de<le.length;de++)for(let J=de+1;J<le.length;J++)if(le[de].negate().equals(le[J]))return E.INSTANCE;if(le.length===1)return le[0]}return new ee(le,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new ee(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());this.c=me.create(q,this,!0)}return this.c}}e.$Tj=ee;class me{static create(q,ne,ye){return me.d(q,ne,ye)}constructor(q,ne){this.expr=q,this.c=ne,this.type=a.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const le=h(this.expr[ne],q.expr[ne]);if(le!==0)return le}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=ue(this.expr);return q===this.expr?this:me.create(q,this.c,!1)}evaluate(q){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(this.expr[ne].evaluate(q))return!0;return!1}static d(q,ne,ye){let le=[],ve=!1;if(q){for(let de=0,J=q.length;de<J;de++){const x=q[de];if(x){if(x.type===a.False){ve=!0;continue}if(x.type===a.True)return D.INSTANCE;if(x.type===a.Or){le=le.concat(x.expr);continue}le.push(x)}}if(le.length===0&&ve)return E.INSTANCE;le.sort(h)}if(le.length!==0){if(le.length===1)return le[0];for(let de=1;de<le.length;de++)le[de-1].equals(le[de])&&(le.splice(de,1),de--);if(le.length===1)return le[0];if(ye){for(let de=0;de<le.length;de++)for(let J=de+1;J<le.length;J++)if(le[de].negate().equals(le[J]))return D.INSTANCE;if(le.length===1)return le[0]}return new me(le,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new me(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());for(;q.length>1;){const ne=q.shift(),ye=q.shift(),le=[];for(const ve of Fe(ne))for(const de of Fe(ye))le.push(ee.create([ve,de],null,!1));q.unshift(me.create(le,null,!1))}this.c=me.create(q,this,!0)}return this.c}}e.$Uj=me;class oe extends w{static{this.d=[]}static all(){return oe.d.values()}constructor(q,ne,ye){super(q,null),this.f=ne,typeof ye=="object"?oe.d.push({...ye,key:q}):ye!==!0&&oe.d.push({key:q,description:ye,type:ne!=null?typeof ne:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return I.create(this.key,q)}notEqualsTo(q){return b.create(this.key,q)}}e.$Vj=oe,e.$Wj=(0,T.$Ei)("contextKeyService");function ce(Y,q){return Y<q?-1:Y>q?1:0}function we(Y,q,ne,ye){return Y<ne?-1:Y>ne?1:q<ye?-1:q>ye?1:0}function ae(Y,q){if(Y.type===a.False||q.type===a.True)return!0;if(Y.type===a.Or)return q.type===a.Or?Ie(Y.expr,q.expr):!1;if(q.type===a.Or){for(const ne of q.expr)if(ae(Y,ne))return!0;return!1}if(Y.type===a.And){if(q.type===a.And)return Ie(q.expr,Y.expr);for(const ne of Y.expr)if(ae(ne,q))return!0;return!1}return Y.equals(q)}function Ie(Y,q){let ne=0,ye=0;for(;ne<Y.length&&ye<q.length;){const le=Y[ne].cmp(q[ye]);if(le<0)return!1;le===0&&ne++,ye++}return ne===Y.length}function Fe(Y){return Y.type===a.Or?Y.expr:[Y]}}),define(Oe[168],Ne([1,0,31,3]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$rt=e.AccessibilitySupport=e.$qt=void 0,e.$st=O,e.$qt=(0,R.$Ei)("accessibilityService");var P;(function(T){T[T.Unknown=0]="Unknown",T[T.Disabled=1]="Disabled",T[T.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$rt=new v.$Vj("accessibilityModeEnabled",!1);function O(T){return T&&typeof T=="object"&&typeof T.label=="string"&&(typeof T.role>"u"||typeof T.role=="string")}e.$tt="ACCESSIBLE_VIEW_SHOWN_"}),define(Oe[105],Ne([1,0,17,25,20,146,280,156,169,9,168]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=u,e.stringSet=h,e.cursorStyleToString=N,e.filterValidationDecorations=Pe,v=We(v),R=We(R),P=We(P),s=We(s);var y;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class a{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=a;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class d{constructor(_,Z,Xe,xe){this.id=_,this.name=Z,this.defaultValue=Xe,this.schema=xe}applyUpdate(_,Z){return o(_,Z)}compute(_,Z,Xe){return Xe}}class r{constructor(_,Z){this.newValue=_,this.didChange=Z}}e.ApplyUpdateResult=r;function o(te,_){if(typeof te!="object"||typeof _!="object"||!te||!_)return new r(_,te!==_);if(Array.isArray(te)||Array.isArray(_)){const Xe=Array.isArray(te)&&Array.isArray(_)&&v.$tb(te,_);return new r(_,!Xe)}let Z=!1;for(const Xe in _)if(_.hasOwnProperty(Xe)){const xe=o(te[Xe],_[Xe]);xe.didChange&&(te[Xe]=xe.newValue,Z=!0)}return new r(te,Z)}class c{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,Z){return o(_,Z)}validate(_){return this.defaultValue}}class l{constructor(_,Z,Xe,xe){this.id=_,this.name=Z,this.defaultValue=Xe,this.schema=xe}applyUpdate(_,Z){return o(_,Z)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,Z,Xe){return Xe}}function i(te,_){return typeof te>"u"?_:te==="false"?!1:!!te}class n extends l{constructor(_,Z,Xe,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Xe),super(_,Z,Xe,xe)}validate(_){return i(_,this.defaultValue)}}function t(te,_,Z,Xe){if(typeof te>"u")return _;let xe=parseInt(te,10);return isNaN(xe)?_:(xe=Math.max(Z,xe),xe=Math.min(Xe,xe),xe|0)}class g extends l{static clampedInt(_,Z,Xe,xe){return t(_,Z,Xe,xe)}constructor(_,Z,Xe,xe,ht,bt=void 0){typeof bt<"u"&&(bt.type="integer",bt.default=Xe,bt.minimum=xe,bt.maximum=ht),super(_,Z,Xe,bt),this.minimum=xe,this.maximum=ht}validate(_){return g.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function u(te,_,Z,Xe){if(typeof te>"u")return _;const xe=m.float(te,_);return m.clamp(xe,Z,Xe)}class m extends l{static clamp(_,Z,Xe){return _<Z?Z:_>Xe?Xe:_}static float(_,Z){if(typeof _=="number")return _;if(typeof _>"u")return Z;const Xe=parseFloat(_);return isNaN(Xe)?Z:Xe}constructor(_,Z,Xe,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Xe),super(_,Z,Xe,ht),this.validationFn=xe}validate(_){return this.validationFn(m.float(_,this.defaultValue))}}class p extends l{static string(_,Z){return typeof _!="string"?Z:_}constructor(_,Z,Xe,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Xe),super(_,Z,Xe,xe)}validate(_){return p.string(_,this.defaultValue)}}function h(te,_,Z,Xe){return typeof te!="string"?_:Xe&&te in Xe?Xe[te]:Z.indexOf(te)===-1?_:te}class E extends l{constructor(_,Z,Xe,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Xe),super(_,Z,Xe,ht),this.c=xe}validate(_){return h(_,this.defaultValue,this.c)}}class D extends d{constructor(_,Z,Xe,xe,ht,bt,Ft=void 0){typeof Ft<"u"&&(Ft.type="string",Ft.enum=ht,Ft.default=xe),super(_,Z,Xe,Ft),this.c=ht,this.d=bt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function w(te){switch(te){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class I extends d{constructor(){super(je.accessibilitySupport,"accessibilitySupport",k.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(11728,null),s.localize(11729,null),s.localize(11730,null)],default:"auto",tags:["accessibility"],description:s.localize(11731,null)})}validate(_){switch(_){case"auto":return k.AccessibilitySupport.Unknown;case"off":return k.AccessibilitySupport.Disabled;case"on":return k.AccessibilitySupport.Enabled}return this.defaultValue}compute(_,Z,Xe){return Xe===k.AccessibilitySupport.Unknown?_.accessibilitySupport:Xe}}class C extends d{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:s.localize(11732,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:s.localize(11733,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{insertSpace:i(Z.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Z.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function b(te){switch(te){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var M;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function N(te){switch(te){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function F(te){switch(te){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class W extends c{constructor(){super(je.editorClassName)}compute(_,Z,Xe){const xe=["monaco-editor"];return Z.get(je.extraEditorClassName)&&xe.push(Z.get(je.extraEditorClassName)),_.extraEditorClassName&&xe.push(_.extraEditorClassName),Z.get(je.mouseStyle)==="default"?xe.push("mouse-default"):Z.get(je.mouseStyle)==="copy"&&xe.push("mouse-copy"),Z.get(je.showUnused)&&xe.push("showUnused"),Z.get(je.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class K extends n{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(11734,null)})}compute(_,Z,Xe){return Xe&&_.emptySelectionClipboard}}class L extends d{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:s.localize(11735,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[s.localize(11736,null),s.localize(11737,null),s.localize(11738,null)],description:s.localize(11739,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[s.localize(11740,null),s.localize(11741,null),s.localize(11742,null)],description:s.localize(11743,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:s.localize(11744,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:s.localize(11745,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:s.localize(11746,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{cursorMoveOnType:i(Z.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":h(Z.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":h(Z.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Z.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Z.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Z.loop,this.defaultValue.loop)}}}class Q extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",Q.OFF,{anyOf:[{type:"boolean",description:s.localize(11747,null)},{type:"string",description:s.localize(11748,null)}],description:s.localize(11749,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?Q.OFF:_==="true"?Q.ON:_:_?Q.ON:Q.OFF}}e.EditorFontLigatures=Q;class X extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",X.OFF,{anyOf:[{type:"boolean",description:s.localize(11750,null)},{type:"string",description:s.localize(11751,null)}],description:s.localize(11752,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?X.OFF:_==="true"?X.TRANSLATE:_:_?X.TRANSLATE:X.OFF}compute(_,Z,Xe){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=X;class ue extends c{constructor(){super(je.fontInfo)}compute(_,Z,Xe){return _.fontInfo}}class ee extends l{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(11753,null)})}validate(_){const Z=m.float(_,this.defaultValue);return Z===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(Z,6,100)}compute(_,Z,Xe){return _.fontInfo.fontSize}}class me extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:me.d,maximum:me.e,errorMessage:s.localize(11754,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:me.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(11755,null)})}validate(_){return _==="normal"||_==="bold"?_:String(g.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,me.d,me.e))}}class oe extends d{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Z={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[s.localize(11756,null),s.localize(11757,null),s.localize(11758,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(11759,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(11760,null),...Z},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(11761,null),...Z},"editor.gotoLocation.multipleDeclarations":{description:s.localize(11762,null),...Z},"editor.gotoLocation.multipleImplementations":{description:s.localize(11763,null),...Z},"editor.gotoLocation.multipleReferences":{description:s.localize(11764,null),...Z},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Xe,description:s.localize(11765,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Xe,description:s.localize(11766,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Xe,description:s.localize(11767,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Xe,description:s.localize(11768,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Xe,description:s.localize(11769,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{multiple:h(Z.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Z.multipleDefinitions??h(Z.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Z.multipleTypeDefinitions??h(Z.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Z.multipleDeclarations??h(Z.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Z.multipleImplementations??h(Z.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Z.multipleReferences??h(Z.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(Z.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(Z.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(Z.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(Z.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(Z.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends d{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:s.localize(11770,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:s.localize(11771,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:s.localize(11772,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:s.localize(11773,null)},"editor.hover.above":{type:"boolean",default:_.above,description:s.localize(11774,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{enabled:i(Z.enabled,this.defaultValue.enabled),delay:g.clampedInt(Z.delay,this.defaultValue.delay,0,1e4),sticky:i(Z.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(Z.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Z.above,this.defaultValue.above)}}}var we;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(we||(e.RenderMinimap=we={}));class ae extends c{constructor(){super(je.layoutInfo)}compute(_,Z,Xe){return ae.computeLayout(Z,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const Z=_.height/_.lineHeight,Xe=Math.floor(_.paddingTop/_.lineHeight);let xe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(xe=Math.max(xe,Z-1));const ht=(Xe+_.viewLineCount+xe)/(_.pixelRatio*_.height),bt=Math.floor(_.viewLineCount/ht);return{typicalViewportLineCount:Z,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:bt}}static c(_,Z){const Xe=_.outerWidth,xe=_.outerHeight,ht=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:we.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const bt=Z.stableMinimapLayoutInput,Ft=bt&&_.outerHeight===bt.outerHeight&&_.lineHeight===bt.lineHeight&&_.typicalHalfwidthCharacterWidth===bt.typicalHalfwidthCharacterWidth&&_.pixelRatio===bt.pixelRatio&&_.scrollBeyondLastLine===bt.scrollBeyondLastLine&&_.paddingTop===bt.paddingTop&&_.paddingBottom===bt.paddingBottom&&_.minimap.enabled===bt.minimap.enabled&&_.minimap.side===bt.minimap.side&&_.minimap.size===bt.minimap.size&&_.minimap.showSlider===bt.minimap.showSlider&&_.minimap.renderCharacters===bt.minimap.renderCharacters&&_.minimap.maxColumn===bt.minimap.maxColumn&&_.minimap.scale===bt.minimap.scale&&_.verticalScrollbarWidth===bt.verticalScrollbarWidth&&_.isViewportWrapping===bt.isViewportWrapping,Ht=_.lineHeight,_t=_.typicalHalfwidthCharacterWidth,ei=_.scrollBeyondLastLine,oi=_.minimap.renderCharacters;let Rt=ht>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Ye=_.minimap.maxColumn,Mt=_.minimap.size,hi=_.minimap.side,mt=_.verticalScrollbarWidth,Et=_.viewLineCount,ti=_.remainingWidth,ii=_.isViewportWrapping,jt=oi?2:3;let pt=Math.floor(ht*xe);const zt=pt/ht;let ni=!1,ai=!1,Ge=jt*Rt,ci=Rt/ht,di=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:Kt,extraLinesBeforeFirstLine:li,extraLinesBeyondLastLine:Bt,desiredRatio:Qt,minimapLineCount:Gt}=ae.computeContainedMinimapLineCount({viewLineCount:Et,scrollBeyondLastLine:ei,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:xe,lineHeight:Ht,pixelRatio:ht});if(Et/Gt>1)ni=!0,ai=!0,Rt=1,Ge=1,ci=Rt/ht;else{let wt=!1,kt=Rt+1;if(Mt==="fit"){const Vt=Math.ceil((li+Et+Bt)*Ge);ii&&Ft&&ti<=Z.stableFitRemainingWidth?(wt=!0,kt=Z.stableFitMaxMinimapScale):wt=Vt>pt}if(Mt==="fill"||wt){ni=!0;const Vt=Rt;Ge=Math.min(Ht*ht,Math.max(1,Math.floor(1/Qt))),ii&&Ft&&ti<=Z.stableFitRemainingWidth&&(kt=Z.stableFitMaxMinimapScale),Rt=Math.min(kt,Math.max(1,Math.floor(Ge/jt))),Rt>Vt&&(di=Math.min(2,Rt/Vt)),ci=Rt/ht/di,pt=Math.ceil(Math.max(Kt,li+Et+Bt)*Ge),ii?(Z.stableMinimapLayoutInput=_,Z.stableFitRemainingWidth=ti,Z.stableFitMaxMinimapScale=Rt):(Z.stableMinimapLayoutInput=null,Z.stableFitRemainingWidth=0)}}}const fi=Math.floor(Ye*ci),vt=Math.min(fi,Math.max(0,Math.floor((ti-mt-2)*ci/(_t+ci)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(ht*vt);const Tt=Lt/ht;Lt=Math.floor(Lt*di);const Wt=oi?we.Text:we.Blocks,ri=hi==="left"?0:Xe-vt-mt;return{renderMinimap:Wt,minimapLeft:ri,minimapWidth:vt,minimapHeightIsEditorHeight:ni,minimapIsSampling:ai,minimapScale:Rt,minimapLineHeight:Ge,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:zt}}static computeLayout(_,Z){const Xe=Z.outerWidth|0,xe=Z.outerHeight|0,ht=Z.lineHeight|0,bt=Z.lineNumbersDigitCount|0,Ft=Z.typicalHalfwidthCharacterWidth,Ht=Z.maxDigitWidth,_t=Z.pixelRatio,ei=Z.viewLineCount,oi=_.get(je.wordWrapOverride2),Rt=oi==="inherit"?_.get(je.wordWrapOverride1):oi,Ye=Rt==="inherit"?_.get(je.wordWrap):Rt,Mt=_.get(je.wordWrapColumn),hi=Z.isDominatedByLongLines,mt=_.get(je.glyphMargin),Et=_.get(je.lineNumbers).renderType!==Ue.Off,ti=_.get(je.lineNumbersMinChars),ii=_.get(je.scrollBeyondLastLine),jt=_.get(je.padding),pt=_.get(je.minimap),zt=_.get(je.scrollbar),ni=zt.verticalScrollbarSize,ai=zt.verticalHasArrows,Ge=zt.arrowSize,ci=zt.horizontalScrollbarSize,di=_.get(je.folding),fi=_.get(je.showFoldingControls)!=="never";let vt=_.get(je.lineDecorationsWidth);di&&fi&&(vt+=16);let Lt=0;if(Et){const gi=Math.max(bt,ti);Lt=Math.round(gi*Ht)}let Tt=0;mt&&(Tt=ht*Z.glyphMarginDecorationLaneCount);let Wt=0,ri=Wt+Tt,Kt=ri+Lt,li=Kt+vt;const Bt=Xe-Tt-Lt-vt;let Qt=!1,Gt=!1,Nt=-1;Rt==="inherit"&&hi?(Qt=!0,Gt=!0):Ye==="on"||Ye==="bounded"?Gt=!0:Ye==="wordWrapColumn"&&(Nt=Mt);const wt=ae.c({outerWidth:Xe,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Ft,pixelRatio:_t,scrollBeyondLastLine:ii,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:pt,verticalScrollbarWidth:ni,viewLineCount:ei,remainingWidth:Bt,isViewportWrapping:Gt},Z.memory||new S);wt.renderMinimap!==we.None&&wt.minimapLeft===0&&(Wt+=wt.minimapWidth,ri+=wt.minimapWidth,Kt+=wt.minimapWidth,li+=wt.minimapWidth);const kt=Bt-wt.minimapWidth,Vt=Math.max(1,Math.floor((kt-ni-2)/Ft)),It=ai?Ge:0;return Gt&&(Nt=Math.max(1,Vt),Ye==="bounded"&&(Nt=Math.min(Nt,Mt))),{width:Xe,height:xe,glyphMarginLeft:Wt,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:Lt,decorationsLeft:Kt,decorationsWidth:vt,contentLeft:li,contentWidth:kt,minimap:wt,viewportColumn:Vt,isWordWrapMinified:Qt,isViewportWrapping:Gt,wrappingColumn:Nt,verticalScrollbarWidth:ni,horizontalScrollbarHeight:ci,overviewRuler:{top:It,width:ni,height:xe-2*It,right:0}}}}e.EditorLayoutInfoComputer=ae;class Ie extends d{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(11775,null),s.localize(11776,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(11777,null)}})}validate(_){return h(_,"simple",["simple","advanced"])}compute(_,Z,Xe){return Z.get(je.accessibilitySupport)===k.AccessibilitySupport.Enabled?"advanced":Xe}}var Fe;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(Fe||(e.ShowLightbulbIconMode=Fe={}));class Y extends d{constructor(){const _={enabled:Fe.On};super(je.lightbulb,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Fe.Off,Fe.OnCode,Fe.On],default:_.enabled,enumDescriptions:[s.localize(11778,null),s.localize(11779,null),s.localize(11780,null)],description:s.localize(11781,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:h(_.enabled,this.defaultValue.enabled,[Fe.Off,Fe.OnCode,Fe.On])}}}class q extends d{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:s.localize(11782,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:20,description:s.localize(11783,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:s.localize(11784,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:s.localize(11785,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{enabled:i(Z.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(Z.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(Z.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Z.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends d{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:s.localize(11786,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(11787,null),s.localize(11788,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(11789,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(11790,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:s.localize(11791,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:s.localize(11792,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:s.localize(11793,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return typeof Z.enabled=="boolean"&&(Z.enabled=Z.enabled?"on":"off"),{enabled:h(Z.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(Z.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(Z.fontFamily,this.defaultValue.fontFamily),padding:i(Z.padding,this.defaultValue.padding)}}}class ye extends d{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):g.clampedInt(_,this.defaultValue,0,1e3)}compute(_,Z,Xe){return Xe<0?g.clampedInt(-Xe*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class le extends m{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>m.clamp(_,0,150),{markdownDescription:s.localize(11794,null)})}compute(_,Z,Xe){return _.fontInfo.lineHeight}}class ve extends d{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:s.localize(11795,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:s.localize(11796,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(11797,null),s.localize(11798,null),s.localize(11799,null)],default:_.size,description:s.localize(11800,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:s.localize(11801,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:s.localize(11802,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(11803,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:s.localize(11804,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:s.localize(11805,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:_.showRegionSectionHeaders,description:s.localize(11806,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:_.showMarkSectionHeaders,description:s.localize(11807,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:_.sectionHeaderFontSize,description:s.localize(11808,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:_.sectionHeaderLetterSpacing,description:s.localize(11809,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{enabled:i(Z.enabled,this.defaultValue.enabled),autohide:i(Z.autohide,this.defaultValue.autohide),size:h(Z.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Z.side,this.defaultValue.side,["right","left"]),showSlider:h(Z.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Z.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(Z.scale,1,1,3),maxColumn:g.clampedInt(Z.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Z.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Z.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:m.clamp(Z.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:m.clamp(Z.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function de(te){return te==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class J extends d{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(11810,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(11811,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{top:g.clampedInt(Z.top,0,0,1e3),bottom:g.clampedInt(Z.bottom,0,0,1e3)}}}class x extends d{constructor(){const _={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:s.localize(11812,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:s.localize(11813,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{enabled:i(Z.enabled,this.defaultValue.enabled),cycle:i(Z.cycle,this.defaultValue.cycle)}}}class pe extends c{constructor(){super(je.pixelRatio)}compute(_,Z,Xe){return _.pixelRatio}}class $e extends d{constructor(){super(je.placeholder,"placeholder",void 0)}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_:this.defaultValue}}class Ae extends d{constructor(){const _={other:"on",comments:"off",strings:"off"},Z=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(11814,null),s.localize(11815,null),s.localize(11816,null)]}];super(je.quickSuggestions,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Z,default:_.strings,description:s.localize(11817,null)},comments:{anyOf:Z,default:_.comments,description:s.localize(11818,null)},other:{anyOf:Z,default:_.other,description:s.localize(11819,null)}},default:_,markdownDescription:s.localize(11820,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const _t=_?"on":"off";return{comments:_t,strings:_t,other:_t}}if(!_||typeof _!="object")return this.defaultValue;const{other:Z,comments:Xe,strings:xe}=_,ht=["on","inline","off"];let bt,Ft,Ht;return typeof Z=="boolean"?bt=Z?"on":"off":bt=h(Z,this.defaultValue.other,ht),typeof Xe=="boolean"?Ft=Xe?"on":"off":Ft=h(Xe,this.defaultValue.comments,ht),typeof xe=="boolean"?Ht=xe?"on":"off":Ht=h(xe,this.defaultValue.strings,ht),{other:bt,comments:Ft,strings:Ht}}}var Ue;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class ke extends d{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(11821,null),s.localize(11822,null),s.localize(11823,null),s.localize(11824,null)],default:"on",description:s.localize(11825,null)})}validate(_){let Z=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(Z=Ue.Custom,Xe=_):_==="interval"?Z=Ue.Interval:_==="relative"?Z=Ue.Relative:_==="on"?Z=Ue.On:Z=Ue.Off),{renderType:Z,renderFn:Xe}}}function Pe(te){const _=te.get(je.renderValidationDecorations);return _==="editable"?te.get(je.readOnly):_!=="on"}class Te extends d{constructor(){const _=[],Z={type:"number",description:s.localize(11826,null)};super(je.rulers,"rulers",_,{type:"array",items:{anyOf:[Z,{type:["object"],properties:{column:Z,color:{type:"string",description:s.localize(11827,null),format:"color-hex"}}}]},default:_,description:s.localize(11828,null)})}validate(_){if(Array.isArray(_)){const Z=[];for(const Xe of _)if(typeof Xe=="number")Z.push({column:g.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const xe=Xe;Z.push({column:g.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Z.sort((Xe,xe)=>Xe.column-xe.column),Z}return this.defaultValue}}class j extends d{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function B(te,_){if(typeof te!="string")return _;switch(te){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class H extends d{constructor(){const _={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(11829,null),s.localize(11830,null),s.localize(11831,null)],default:"auto",description:s.localize(11832,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(11833,null),s.localize(11834,null),s.localize(11835,null)],default:"auto",description:s.localize(11836,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:s.localize(11837,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:s.localize(11838,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:s.localize(11839,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:s.localize(11840,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_,Xe=g.clampedInt(Z.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=g.clampedInt(Z.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(Z.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(Z.vertical,this.defaultValue.vertical),horizontal:B(Z.horizontal,this.defaultValue.horizontal),useShadows:i(Z.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Z.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Z.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Z.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Z.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:g.clampedInt(Z.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:g.clampedInt(Z.verticalSliderSize,xe,0,1e3),scrollByPage:i(Z.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Z.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends d{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:s.localize(11841,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:s.localize(11842,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:s.localize(11843,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:s.localize(11844,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:s.localize(11845,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:s.localize(11846,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:s.localize(11847,null)}})}applyUpdate(_,Z){let Xe=!1;Z.allowedCharacters&&_&&(R.$ho(_.allowedCharacters,Z.allowedCharacters)||(_={..._,allowedCharacters:Z.allowedCharacters},Xe=!0)),Z.allowedLocales&&_&&(R.$ho(_.allowedLocales,Z.allowedLocales)||(_={..._,allowedLocales:Z.allowedLocales},Xe=!0));const xe=super.applyUpdate(_,Z);return Xe?new r(xe.newValue,!0):xe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{nonBasicASCII:Qe(Z.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Z.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Z.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Qe(Z.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Qe(Z.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,Z){if(typeof _!="object"||!_)return Z;const Xe={};for(const[xe,ht]of Object.entries(_))ht===!0&&(Xe[xe]=!0);return Xe}}class re extends d{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:s.localize(11848,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(11849,null),s.localize(11850,null),s.localize(11851,null)],description:s.localize(11852,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:s.localize(11853,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:_.fontFamily,description:s.localize(11854,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{enabled:i(Z.enabled,this.defaultValue.enabled),mode:h(Z.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Z.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Z.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Z.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:p.string(Z.fontFamily,this.defaultValue.fontFamily)}}}class ge extends d{constructor(){const _={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",_,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:_.enabled,description:s.localize(11855,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(11856,null),s.localize(11857,null),s.localize(11858,null)],description:s.localize(11859,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:_.fontFamily,description:s.localize(11860,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{enabled:i(Z.enabled,this.defaultValue.enabled),showToolbar:h(Z.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:p.string(Z.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Z.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ce extends d{constructor(){const _={enabled:A.$kt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$kt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:s.localize(11861,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:s.localize(11862,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{enabled:i(Z.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Z.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ze extends d{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(11863,null),s.localize(11864,null),s.localize(11865,null)],default:_.bracketPairs,description:s.localize(11866,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(11867,null),s.localize(11868,null),s.localize(11869,null)],default:_.bracketPairsHorizontal,description:s.localize(11870,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:s.localize(11871,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:s.localize(11872,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(11873,null),s.localize(11874,null),s.localize(11875,null)],default:_.highlightActiveIndentation,description:s.localize(11876,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{bracketPairs:Qe(Z.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Qe(Z.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Z.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Z.indentation,this.defaultValue.indentation),highlightActiveIndentation:Qe(Z.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Qe(te,_,Z){const Xe=Z.indexOf(te);return Xe===-1?_:Z[Xe]}class _e extends d{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(11877,null),s.localize(11878,null)],default:_.insertMode,description:s.localize(11879,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:s.localize(11880,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:s.localize(11881,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:s.localize(11882,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(11883,null),s.localize(11884,null),s.localize(11885,null),s.localize(11886,null)],default:_.selectionMode,markdownDescription:s.localize(11887,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:s.localize(11888,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:s.localize(11889,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:s.localize(11890,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:s.localize(11891,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:s.localize(11892,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(11893,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(11894,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(11895,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(11896,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(11897,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(11898,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(11899,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(11900,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(11901,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(11902,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(11903,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(11904,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(11905,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(11906,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(11907,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(11908,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(11909,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(11910,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(11911,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(11912,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(11913,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(11914,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(11915,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(11916,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(11917,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(11918,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(11919,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(11920,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(11921,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(11922,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(11923,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(11924,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{insertMode:h(Z.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Z.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Z.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Z.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Z.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Z.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Z.showIcons,this.defaultValue.showIcons),showStatusBar:i(Z.showStatusBar,this.defaultValue.showStatusBar),preview:i(Z.preview,this.defaultValue.preview),previewMode:h(Z.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Z.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Z.showMethods,this.defaultValue.showMethods),showFunctions:i(Z.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Z.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Z.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Z.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Z.showFields,this.defaultValue.showFields),showVariables:i(Z.showVariables,this.defaultValue.showVariables),showClasses:i(Z.showClasses,this.defaultValue.showClasses),showStructs:i(Z.showStructs,this.defaultValue.showStructs),showInterfaces:i(Z.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Z.showModules,this.defaultValue.showModules),showProperties:i(Z.showProperties,this.defaultValue.showProperties),showEvents:i(Z.showEvents,this.defaultValue.showEvents),showOperators:i(Z.showOperators,this.defaultValue.showOperators),showUnits:i(Z.showUnits,this.defaultValue.showUnits),showValues:i(Z.showValues,this.defaultValue.showValues),showConstants:i(Z.showConstants,this.defaultValue.showConstants),showEnums:i(Z.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Z.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Z.showKeywords,this.defaultValue.showKeywords),showWords:i(Z.showWords,this.defaultValue.showWords),showColors:i(Z.showColors,this.defaultValue.showColors),showFiles:i(Z.showFiles,this.defaultValue.showFiles),showReferences:i(Z.showReferences,this.defaultValue.showReferences),showFolders:i(Z.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Z.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Z.showSnippets,this.defaultValue.showSnippets),showUsers:i(Z.showUsers,this.defaultValue.showUsers),showIssues:i(Z.showIssues,this.defaultValue.showIssues)}}}class tt extends d{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(11925,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(11926,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(_.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const _=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",_,{anyOf:[{description:s.localize(11927,null),type:"string"},{description:s.localize(11928,null),type:"array",items:{type:"string"}}]})}validate(_){if(typeof _=="string"&&(_=[_]),Array.isArray(_)){const Z=[];for(const Xe of _)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Z.push(Xe)}catch{}return Z}return this.defaultValue}}var et;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends d{constructor(){super(je.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(11929,null),s.localize(11930,null),s.localize(11931,null),s.localize(11932,null)],description:s.localize(11933,null),default:"same"}})}validate(_){switch(_){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(_,Z,Xe){return Z.get(je.accessibilitySupport)===k.AccessibilitySupport.Enabled?et.None:Xe}}class ft extends c{constructor(){super(je.wrappingInfo)}compute(_,Z,Xe){const xe=Z.get(je.layoutInfo);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class lt extends d{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:s.localize(11934,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(11935,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(11936,null),s.localize(11937,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{enabled:i(Z.enabled,this.defaultValue.enabled),showDropSelector:h(Z.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:s.localize(11938,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(11939,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(11940,null),s.localize(11941,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Z=_;return{enabled:i(Z.enabled,this.defaultValue.enabled),showPasteSelector:h(Z.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",$t="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?gt:P.$l?$t:ct,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function qe(te){return e.editorOptionsRegistry[te.id]=te,te}var je;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.placeholder=88]="placeholder",te[te.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",te[te.quickSuggestions=90]="quickSuggestions",te[te.quickSuggestionsDelay=91]="quickSuggestionsDelay",te[te.readOnly=92]="readOnly",te[te.readOnlyMessage=93]="readOnlyMessage",te[te.renameOnType=94]="renameOnType",te[te.renderControlCharacters=95]="renderControlCharacters",te[te.renderFinalNewline=96]="renderFinalNewline",te[te.renderLineHighlight=97]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=99]="renderValidationDecorations",te[te.renderWhitespace=100]="renderWhitespace",te[te.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",te[te.roundedSelection=102]="roundedSelection",te[te.rulers=103]="rulers",te[te.scrollbar=104]="scrollbar",te[te.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=106]="scrollBeyondLastLine",te[te.scrollPredominantAxis=107]="scrollPredominantAxis",te[te.selectionClipboard=108]="selectionClipboard",te[te.selectionHighlight=109]="selectionHighlight",te[te.selectOnLineNumbers=110]="selectOnLineNumbers",te[te.showFoldingControls=111]="showFoldingControls",te[te.showUnused=112]="showUnused",te[te.snippetSuggestions=113]="snippetSuggestions",te[te.smartSelect=114]="smartSelect",te[te.smoothScrolling=115]="smoothScrolling",te[te.stickyScroll=116]="stickyScroll",te[te.stickyTabStops=117]="stickyTabStops",te[te.stopRenderingLineAfter=118]="stopRenderingLineAfter",te[te.suggest=119]="suggest",te[te.suggestFontSize=120]="suggestFontSize",te[te.suggestLineHeight=121]="suggestLineHeight",te[te.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",te[te.suggestSelection=123]="suggestSelection",te[te.tabCompletion=124]="tabCompletion",te[te.tabIndex=125]="tabIndex",te[te.unicodeHighlighting=126]="unicodeHighlighting",te[te.unusualLineTerminators=127]="unusualLineTerminators",te[te.useShadowDOM=128]="useShadowDOM",te[te.useTabStops=129]="useTabStops",te[te.wordBreak=130]="wordBreak",te[te.wordSegmenterLocales=131]="wordSegmenterLocales",te[te.wordSeparators=132]="wordSeparators",te[te.wordWrap=133]="wordWrap",te[te.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=136]="wordWrapColumn",te[te.wordWrapOverride1=137]="wordWrapOverride1",te[te.wordWrapOverride2=138]="wordWrapOverride2",te[te.wrappingIndent=139]="wrappingIndent",te[te.wrappingStrategy=140]="wrappingStrategy",te[te.showDeprecated=141]="showDeprecated",te[te.inlayHints=142]="inlayHints",te[te.editorClassName=143]="editorClassName",te[te.pixelRatio=144]="pixelRatio",te[te.tabFocusMode=145]="tabFocusMode",te[te.layoutInfo=146]="layoutInfo",te[te.wrappingInfo=147]="wrappingInfo",te[te.defaultColorDecorators=148]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:qe(new n(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(11942,null)})),acceptSuggestionOnEnter:qe(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(11943,null),""],markdownDescription:s.localize(11944,null)})),accessibilitySupport:qe(new I),accessibilityPageSize:qe(new g(je.accessibilityPageSize,"accessibilityPageSize",10,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(11945,null),tags:["accessibility"]})),ariaLabel:qe(new p(je.ariaLabel,"ariaLabel",s.localize(11946,null))),ariaRequired:qe(new n(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:qe(new n(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(11947,null),tags:["accessibility"]})),autoClosingBrackets:qe(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(11948,null),s.localize(11949,null),""],description:s.localize(11950,null)})),autoClosingComments:qe(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(11951,null),s.localize(11952,null),""],description:s.localize(11953,null)})),autoClosingDelete:qe(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(11954,null),""],description:s.localize(11955,null)})),autoClosingOvertype:qe(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(11956,null),""],description:s.localize(11957,null)})),autoClosingQuotes:qe(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(11958,null),s.localize(11959,null),""],description:s.localize(11960,null)})),autoIndent:qe(new D(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[s.localize(11961,null),s.localize(11962,null),s.localize(11963,null),s.localize(11964,null),s.localize(11965,null)],description:s.localize(11966,null)})),automaticLayout:qe(new n(je.automaticLayout,"automaticLayout",!1)),autoSurround:qe(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(11967,null),s.localize(11968,null),s.localize(11969,null),""],description:s.localize(11970,null)})),bracketPairColorization:qe(new Ce),bracketPairGuides:qe(new ze),stickyTabStops:qe(new n(je.stickyTabStops,"stickyTabStops",!1,{description:s.localize(11971,null)})),codeLens:qe(new n(je.codeLens,"codeLens",!0,{description:s.localize(11972,null)})),codeLensFontFamily:qe(new p(je.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(11973,null)})),codeLensFontSize:qe(new g(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(11974,null)})),colorDecorators:qe(new n(je.colorDecorators,"colorDecorators",!0,{description:s.localize(11975,null)})),colorDecoratorActivatedOn:qe(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(11976,null),s.localize(11977,null),s.localize(11978,null)],description:s.localize(11979,null)})),colorDecoratorsLimit:qe(new g(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(11980,null)})),columnSelection:qe(new n(je.columnSelection,"columnSelection",!1,{description:s.localize(11981,null)})),comments:qe(new C),contextmenu:qe(new n(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:qe(new n(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(11982,null)})),cursorBlinking:qe(new D(je.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:s.localize(11983,null)})),cursorSmoothCaretAnimation:qe(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(11984,null),s.localize(11985,null),s.localize(11986,null)],description:s.localize(11987,null)})),cursorStyle:qe(new D(je.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:s.localize(11988,null)})),cursorSurroundingLines:qe(new g(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(11989,null)})),cursorSurroundingLinesStyle:qe(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(11990,null),s.localize(11991,null)],markdownDescription:s.localize(11992,null)})),cursorWidth:qe(new g(je.cursorWidth,"cursorWidth",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(11993,null)})),disableLayerHinting:qe(new n(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:qe(new n(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:qe(new n(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:qe(new n(je.dragAndDrop,"dragAndDrop",!0,{description:s.localize(11994,null)})),emptySelectionClipboard:qe(new K),dropIntoEditor:qe(new lt),stickyScroll:qe(new q),experimentalWhitespaceRendering:qe(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(11995,null),s.localize(11996,null),s.localize(11997,null)],description:s.localize(11998,null)})),extraEditorClassName:qe(new p(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:qe(new m(je.fastScrollSensitivity,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:s.localize(11999,null)})),find:qe(new L),fixedOverflowWidgets:qe(new n(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:qe(new n(je.folding,"folding",!0,{description:s.localize(12e3,null)})),foldingStrategy:qe(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(12001,null),s.localize(12002,null)],description:s.localize(12003,null)})),foldingHighlight:qe(new n(je.foldingHighlight,"foldingHighlight",!0,{description:s.localize(12004,null)})),foldingImportsByDefault:qe(new n(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(12005,null)})),foldingMaximumRegions:qe(new g(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(12006,null)})),unfoldOnClickAfterEndOfLine:qe(new n(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(12007,null)})),fontFamily:qe(new p(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(12008,null)})),fontInfo:qe(new ue),fontLigatures2:qe(new Q),fontSize:qe(new ee),fontWeight:qe(new me),fontVariations:qe(new X),formatOnPaste:qe(new n(je.formatOnPaste,"formatOnPaste",!1,{description:s.localize(12009,null)})),formatOnType:qe(new n(je.formatOnType,"formatOnType",!1,{description:s.localize(12010,null)})),glyphMargin:qe(new n(je.glyphMargin,"glyphMargin",!0,{description:s.localize(12011,null)})),gotoLocation:qe(new oe),hideCursorInOverviewRuler:qe(new n(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(12012,null)})),hover:qe(new ce),inDiffEditor:qe(new n(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:qe(new m(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>m.clamp(te,-5,20),{description:s.localize(12013,null)})),lightbulb:qe(new Y),lineDecorationsWidth:qe(new ye),lineHeight:qe(new le),lineNumbers:qe(new ke),lineNumbersMinChars:qe(new g(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:qe(new n(je.linkedEditing,"linkedEditing",!1,{description:s.localize(12014,null)})),links:qe(new n(je.links,"links",!0,{description:s.localize(12015,null)})),matchBrackets:qe(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(12016,null)})),minimap:qe(new ve),mouseStyle:qe(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:qe(new m(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:s.localize(12017,null)})),mouseWheelZoom:qe(new n(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$k?s.localize(12018,null):s.localize(12019,null)})),multiCursorMergeOverlapping:qe(new n(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(12020,null)})),multiCursorModifier:qe(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[s.localize(12021,null),s.localize(12022,null)],markdownDescription:s.localize(12023,null)})),multiCursorPaste:qe(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(12024,null),s.localize(12025,null)],markdownDescription:s.localize(12026,null)})),multiCursorLimit:qe(new g(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(12027,null)})),occurrencesHighlight:qe(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(12028,null),s.localize(12029,null),s.localize(12030,null)],markdownDescription:s.localize(12031,null)})),overviewRulerBorder:qe(new n(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(12032,null)})),overviewRulerLanes:qe(new g(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:qe(new J),pasteAs:qe(new st),parameterHints:qe(new x),peekWidgetDefaultFocus:qe(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(12033,null),s.localize(12034,null)],description:s.localize(12035,null)})),placeholder:qe(new $e),definitionLinkOpensInPeek:qe(new n(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(12036,null)})),quickSuggestions:qe(new Ae),quickSuggestionsDelay:qe(new g(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(12037,null)})),readOnly:qe(new n(je.readOnly,"readOnly",!1)),readOnlyMessage:qe(new j),renameOnType:qe(new n(je.renameOnType,"renameOnType",!1,{description:s.localize(12038,null),markdownDeprecationMessage:s.localize(12039,null)})),renderControlCharacters:qe(new n(je.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(12040,null),restricted:!0})),renderFinalNewline:qe(new E(je.renderFinalNewline,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:s.localize(12041,null)})),renderLineHighlight:qe(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(12042,null)],description:s.localize(12043,null)})),renderLineHighlightOnlyWhenFocus:qe(new n(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(12044,null)})),renderValidationDecorations:qe(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:qe(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(12045,null),s.localize(12046,null),s.localize(12047,null),""],description:s.localize(12048,null)})),revealHorizontalRightPadding:qe(new g(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:qe(new n(je.roundedSelection,"roundedSelection",!0,{description:s.localize(12049,null)})),rulers:qe(new Te),scrollbar:qe(new H),scrollBeyondLastColumn:qe(new g(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(12050,null)})),scrollBeyondLastLine:qe(new n(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(12051,null)})),scrollPredominantAxis:qe(new n(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(12052,null)})),selectionClipboard:qe(new n(je.selectionClipboard,"selectionClipboard",!0,{description:s.localize(12053,null),included:P.$l})),selectionHighlight:qe(new n(je.selectionHighlight,"selectionHighlight",!0,{description:s.localize(12054,null)})),selectOnLineNumbers:qe(new n(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:qe(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(12055,null),s.localize(12056,null),s.localize(12057,null)],description:s.localize(12058,null)})),showUnused:qe(new n(je.showUnused,"showUnused",!0,{description:s.localize(12059,null)})),showDeprecated:qe(new n(je.showDeprecated,"showDeprecated",!0,{description:s.localize(12060,null)})),inlayHints:qe(new ne),snippetSuggestions:qe(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(12061,null),s.localize(12062,null),s.localize(12063,null),s.localize(12064,null)],description:s.localize(12065,null)})),smartSelect:qe(new tt),smoothScrolling:qe(new n(je.smoothScrolling,"smoothScrolling",!1,{description:s.localize(12066,null)})),stopRenderingLineAfter:qe(new g(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:qe(new _e),inlineSuggest:qe(new re),inlineEdit:qe(new ge),inlineCompletionsAccessibilityVerbose:qe(new n(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(12067,null)})),suggestFontSize:qe(new g(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(12068,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:qe(new g(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(12069,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:qe(new n(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(12070,null)})),suggestSelection:qe(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(12071,null),s.localize(12072,null),s.localize(12073,null)],description:s.localize(12074,null)})),tabCompletion:qe(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(12075,null),s.localize(12076,null),s.localize(12077,null)],description:s.localize(12078,null)})),tabIndex:qe(new g(je.tabIndex,"tabIndex",0,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:qe(new V),unusualLineTerminators:qe(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(12079,null),s.localize(12080,null),s.localize(12081,null)],description:s.localize(12082,null)})),useShadowDOM:qe(new n(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:qe(new n(je.useTabStops,"useTabStops",!0,{description:s.localize(12083,null)})),wordBreak:qe(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(12084,null),s.localize(12085,null)],description:s.localize(12086,null)})),wordSegmenterLocales:qe(new nt),wordSeparators:qe(new p(je.wordSeparators,"wordSeparators",$.$lt,{description:s.localize(12087,null)})),wordWrap:qe(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(12088,null),s.localize(12089,null),s.localize(12090,null),s.localize(12091,null)],description:s.localize(12092,null)})),wordWrapBreakAfterCharacters:qe(new p(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:qe(new p(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:qe(new g(je.wordWrapColumn,"wordWrapColumn",80,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(12093,null)})),wordWrapOverride1:qe(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:qe(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:qe(new W),defaultColorDecorators:qe(new n(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(12094,null)})),pixelRatio:qe(new pe),tabFocusMode:qe(new n(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(12095,null)})),layoutInfo:qe(new ae),wrappingInfo:qe(new ft),wrappingIndent:qe(new rt),wrappingStrategy:qe(new Ie)}}),define(Oe[106],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=void 0,e.$Li=(0,v.$Ei)("environmentService"),e.$Mi=(0,v.$Fi)(e.$Li)}),define(Oe[29],Ne([1,0,58,19,12,14,2,9,3,20,15,48]),function(be,e,v,R,P,O,T,A,$,s,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=a,e.$bl=o,e.$cl=l,e.$dl=i,e.$el=n,e.$fl=t,e.$gl=g,e.$hl=u,e.$il=m,e.$jl=p,e.$kl=h,e.$ml=w,e.$nl=I,e.$ol=C,e.$pl=f,e.$ql=b,e.$tl=K,e.$Fl=me,e.$Gl=oe,e.$Il=we,e.$_k=(0,$.$Ei)("fileService");function a(ae){return ae.create===!0}var S;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var d;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(ae){const Ie=ae;return!!Ie&&typeof Ie.onDidChange=="function"}var c;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function l(ae){return!!(ae.capabilities&c.FileReadWrite)}function i(ae){return!!(ae.capabilities&c.FileFolderCopy)}function n(ae){return!!(ae.capabilities&c.FileClone)}function t(ae){return!!(ae.capabilities&c.FileOpenReadWriteClose)}function g(ae){return!!(ae.capabilities&c.FileReadStream)}function u(ae){return l(ae)?!!(ae.capabilities&c.FileAtomicRead):!1}function m(ae){return l(ae)?!!(ae.capabilities&c.FileAtomicWrite):!1}function p(ae){return!!(ae.capabilities&c.FileAtomicDelete)}function h(ae){return!!(ae.capabilities&c.Readonly)}var E;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(Ie,Fe){const Y=new D(Ie.toString(),Fe);return C(Y,Fe),Y}constructor(Ie,Fe){super(Ie),this.code=Fe}}e.$ll=D;function w(ae,Ie){return D.create(ae,Ie)}function I(ae){return ae||w((0,A.localize)(11338,null),E.Unknown)}function C(ae,Ie){return ae.name=Ie?`${Ie} (FileSystemError)`:"FileSystemError",ae}function f(ae){if(!ae)return E.Unknown;if(ae instanceof D)return ae.code;const Ie=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Ie)return E.Unknown;switch(Ie[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function b(ae){if(ae instanceof L)return ae.fileOperationResult;switch(f(ae)){case E.FileNotFound:return ue.FILE_NOT_FOUND;case E.FileIsADirectory:return ue.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ue.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ue.FILE_WRITE_LOCKED;case E.NoPermissions:return ue.FILE_PERMISSION_DENIED;case E.FileExists:return ue.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ue.FILE_TOO_LARGE;default:return ue.FILE_OTHER_ERROR}}var M;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class N{constructor(Ie,Fe,Y){this.resource=Ie,this.operation=Fe,this.target=Y}isOperation(Ie){return this.operation===Ie}}e.$rl=N;var F;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class W{static{this.a=null}constructor(Ie,Fe){this.c=Fe,this.b=void 0,this.d=new y.$T(()=>{const Y=v.$Ki.forUris(()=>this.c);return Y.fill(this.rawAdded.map(q=>[q,!0])),Y}),this.f=new y.$T(()=>{const Y=v.$Ki.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(q=>[q,!0])),Y}),this.g=new y.$T(()=>{const Y=v.$Ki.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(q=>[q,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Ie){switch(Y.type){case F.ADDED:this.rawAdded.push(Y.resource);break;case F.UPDATED:this.rawUpdated.push(Y.resource);break;case F.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==W.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(Ie,...Fe){return this.h(Ie,{includeChildren:!1},...Fe)}affects(Ie,...Fe){return this.h(Ie,{includeChildren:!0},...Fe)}h(Ie,Fe,...Y){if(!Ie)return!1;const q=Y.length>0;return!!((!q||Y.includes(F.ADDED))&&(this.d.value.get(Ie)||Fe.includeChildren&&this.d.value.findSuperstr(Ie))||(!q||Y.includes(F.UPDATED))&&(this.f.value.get(Ie)||Fe.includeChildren&&this.f.value.findSuperstr(Ie))||(!q||Y.includes(F.DELETED))&&(this.g.value.findSubstr(Ie)||Fe.includeChildren&&this.g.value.findSuperstr(Ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ie){return this.b===Ie}hasCorrelation(){return typeof this.b=="number"}}e.$sl=W;function K(ae,Ie,Fe){return!ae||!Ie||ae===Ie||Ie.length>ae.length?!1:(Ie.charAt(Ie.length-1)!==R.sep&&(Ie+=R.sep),Fe?(0,P.$Gf)(ae,Ie):ae.indexOf(Ie)===0)}class L extends Error{constructor(Ie,Fe,Y){super(Ie),this.fileOperationResult=Fe,this.options=Y}}e.$ul=L;class Q extends L{constructor(Ie,Fe,Y,q){super(Ie,Fe,q),this.fileOperationResult=Fe,this.size=Y}}e.$vl=Q;class X extends L{constructor(Ie,Fe,Y){super(Ie,ue.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Fe}}e.$wl=X;var ue;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var ee;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$El="";function me(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function oe(ae,Ie){if(!Ie.hasProvider(T.URI.from({scheme:ae.scheme})))return new Promise(Fe=>{const Y=Ie.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===ae.scheme&&q.added&&(Y.dispose(),Fe())})})}class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Ie){return(0,O.$ig)(Ie)||(Ie=0),Ie<ce.KB?(0,A.localize)(11339,null,Ie.toFixed(0)):Ie<ce.MB?(0,A.localize)(11340,null,(Ie/ce.KB).toFixed(2)):Ie<ce.GB?(0,A.localize)(11341,null,(Ie/ce.MB).toFixed(2)):Ie<ce.TB?(0,A.localize)(11342,null,(Ie/ce.GB).toFixed(2)):(0,A.localize)(11343,null,(Ie/ce.TB).toFixed(2))}}e.$Hl=ce;function we(ae){const Ie=typeof ae=="string"||ae?.scheme===k.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===k.Schemas.file?1024*ce.MB:Ie?10*ce.MB:s.$p?50*ce.MB:1024*ce.MB}}),define(Oe[74],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class v{constructor(...P){this.a=new Map;for(const[O,T]of P)this.set(O,T)}set(P,O){const T=this.a.get(P);return this.a.set(P,O),T}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ci=v}),define(Oe[170],Ne([1,0,10,13,4,73,167,3,74,171]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;const k=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class a{constructor(o=new $.$Ci,c=!1,l,i=k){this.i=o,this.j=c,this.k=l,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(A.$Di,this),this._globalGraph=i?l?._globalGraph??new T.$ur(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,P.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,c){this.m();const l=this,i=new class extends a{dispose(){l.h.delete(i),super.dispose()}}(o,this.j,this,this.l);return this.h.add(i),c?.add(i),i}invokeFunction(o,...c){this.m();const l=d.traceInvocation(this.l,o);let i=!1;try{return o({get:t=>{if(i)throw(0,R.$7)("service accessor is only valid during the invocation of its target method");const g=this.s(t,l);if(!g)throw new Error(`[invokeFunction] unknown service '${t}'`);return g}},...c)}finally{i=!0,l.stop()}}createInstance(o,...c){this.m();let l,i;return o instanceof O.$Bi?(l=d.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(c),l)):(l=d.traceCreation(this.l,o),i=this.o(o,c,l)),l.stop(),i}o(o,c=[],l){const i=A._util.getServiceDependencies(o).sort((g,u)=>g.index-u.index),n=[];for(const g of i){const u=this.s(g.id,l);u||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${g.id}.`,!1),n.push(u)}const t=i.length>0?i[0].index:c.length;if(c.length!==t){console.trace(`[createInstance] First service dependency of ${o.name} at position ${t+1} conflicts with ${c.length} static arguments`);const g=t-c.length;g>0?c=c.concat(new Array(g)):c=c.slice(0,t)}return Reflect.construct(o,c.concat(n))}q(o,c){if(this.i.get(o)instanceof O.$Bi)this.i.set(o,c);else if(this.k)this.k.q(o,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const c=this.i.get(o);return!c&&this.k?this.k.r(o):c}s(o,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const l=this.r(o);return l instanceof O.$Bi?this.u(o,l,c.branch(o,!0)):(c.branch(o,!1),l)}u(o,c,l){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,c,l)}finally{this.t.delete(o)}}v(o,c,l){const i=new T.$ur(u=>u.id.toString());let n=0;const t=[{id:o,desc:c,_trace:l}],g=new Set;for(;t.length;){const u=t.pop();if(!g.has(String(u.id))){if(g.add(String(u.id)),i.lookupOrInsertNode(u),n++>1e3)throw new y(i);for(const m of A._util.getServiceDependencies(u.desc.ctor)){const p=this.r(m.id);if(p||this.y(`[createInstance] ${o} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(u.id),String(m.id)),p instanceof O.$Bi){const h={id:m.id,desc:p,_trace:u._trace.branch(m.id,!0)};i.insertEdge(u,h),t.push(h)}}}}for(;;){const u=i.roots();if(u.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:m}of u){if(this.r(m.id)instanceof O.$Bi){const h=this.w(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.q(m.id,h)}i.removeNode(m)}}return this.r(o)}w(o,c,l=[],i,n){if(this.i.get(o)instanceof O.$Bi)return this.x(o,c,l,i,n,this.g);if(this.k)return this.k.w(o,c,l,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(o,c,l=[],i,n,t){if(i){const g=new a(void 0,this.j,this,this.l);g.c=String(o);const u=new Map,m=new v.$Xh(()=>{const p=g.o(c,l,n);for(const[h,E]of u){const D=p[h];if(typeof D=="function")for(const w of E)w.disposable=D.apply(p,w.listener)}return u.clear(),t.add(p),p});return new Proxy(Object.create(null),{get(p,h){if(!m.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let w=u.get(h);return w||(w=new s.$5c,u.set(h,w)),(C,f,b)=>{if(m.isInitialized)return m.value[h](C,f,b);{const M={listener:[C,f,b],disposable:void 0},N=w.push(M);return(0,P.$Sc)(()=>{N(),M.disposable?.dispose()})}}}if(h in p)return p[h];const E=m.value;let D=E[h];return typeof D!="function"||(D=D.bind(E),p[h]=D),D},set(p,h,E){return m.value[h]=E,!0},getPrototypeOf(p){return c.prototype}})}else{const g=this.o(c,l,n);return t.add(g),g}}y(o,c){if(c&&console.warn(o),this.j)throw new Error(o)}}e.$vr=a;var S;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(S||(S={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(S.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,c){return o?new d(S.Invocation,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,c){return o?new d(S.Creation,c.name):d.c}static{this.f=0}constructor(o,c){this.type=o,this.name=c,this.g=Date.now(),this.h=[]}branch(o,c){const l=new d(S.Branch,o.toString());return this.h.push([o,c,l]),l}stop(){const o=Date.now()-this.g;d.f+=o;let c=!1;function l(n,t){const g=[],u=new Array(n+1).join("	");for(const[m,p,h]of t.h)if(p&&h){c=!0,g.push(`${u}CREATES -> ${m}`);const E=l(n+1,h);E&&g.push(E)}else g.push(`${u}uses -> ${m}`);return g.join(`
`)}const i=[`${this.type===S.Creation?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||c)&&d.all.add(i.join(`
`))}}e.$wr=d}),define(Oe[11],Ne([1,0,9,42,6,75,4,28,20,23,14,2,31,3]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=r,e.log=c,e.$nk=D,e.$ok=w,e.$pk=I,e.$qk=C,v=We(v),e.$_j=(0,S.$Ei)("logService"),e.$ak=(0,S.$Ei)("loggerService");function d(){return new Date().toISOString()}function r(f){return(0,k.$ig)(f)}var o;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$ck=o.Info;function c(f,b,M){switch(b){case o.Trace:f.trace(M);break;case o.Debug:f.debug(M);break;case o.Info:f.info(M);break;case o.Warning:f.warn(M);break;case o.Error:f.error(M);break;case o.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function l(f,b=!1){let M="";for(let N=0;N<f.length;N++){let F=f[N];if(F instanceof Error&&(F=(0,R.$pj)(F,b)),typeof F=="object")try{F=JSON.stringify(F)}catch{}M+=(N>0?" ":"")+F}return M}class i extends T.$Uc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new P.$le),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==o.Off&&this.b<=b}}e.$ek=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...M){this.f(o.Trace)&&this.g(o.Trace,l([b,...M],!0))}debug(b,...M){this.f(o.Debug)&&this.g(o.Debug,l([b,...M]))}info(b,...M){this.f(o.Info)&&this.g(o.Info,l([b,...M]))}warn(b,...M){this.f(o.Warning)&&this.g(o.Warning,l([b,...M]))}error(b,...M){if(this.f(o.Error))if(b instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=b.stack,this.g(o.Error,l(N))}else this.g(o.Error,l([b,...M]))}flush(){}}e.$fk=n;class t extends i{constructor(b=e.$ck){super(),this.setLevel(b),this.g=!$.$j}trace(b,...M){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...M):console.log(`[main ${d()}]`,b,...M))}debug(b,...M){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...M):console.log(`[main ${d()}]`,b,...M))}info(b,...M){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...M):console.log(`[main ${d()}]`,b,...M))}warn(b,...M){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,b,...M):console.warn(`[main ${d()}]`,b,...M))}error(b,...M){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,b,...M):console.error(`[main ${d()}]`,b,...M))}flush(){}}e.$gk=t;class g extends i{constructor(b=e.$ck,M=!0){super(),this.g=M,this.setLevel(b)}trace(b,...M){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...M):console.log(b,...M))}debug(b,...M){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...M):console.log(b,...M))}info(b,...M){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...M):console.log(b,...M))}warn(b,...M){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...M):console.log(b,...M))}error(b,...M){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...M):console.error(b,...M))}flush(){}}e.$hk=g;class u extends i{constructor(b,M=e.$ck){super(),this.g=b,this.setLevel(M)}trace(b,...M){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(b),...M])}debug(b,...M){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(b),...M])}info(b,...M){this.f(o.Info)&&this.g.log(o.Info,[this.h(b),...M])}warn(b,...M){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(b),...M])}error(b,...M){this.f(o.Error)&&this.g.log(o.Error,[this.h(b),...M])}h(b){return typeof b=="string"?b:(0,R.$pj)(b,this.f(o.Trace))}flush(){}}e.$ik=u;class m extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const M of this.g)M.setLevel(b);super.setLevel(b)}trace(b,...M){for(const N of this.g)N.trace(b,...M)}debug(b,...M){for(const N of this.g)N.debug(b,...M)}info(b,...M){for(const N of this.g)N.info(b,...M)}warn(b,...M){for(const N of this.g)N.warn(b,...M)}error(b,...M){for(const N of this.g)N.error(b,...M)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$jk=m;class p extends T.$Uc{constructor(b,M,N){if(super(),this.h=b,this.j=M,this.b=new A.$Ac,this.c=this.B(new P.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$le),this.onDidChangeVisibility=this.g.event,N)for(const F of N)this.b.set(F.resource,{logger:void 0,info:F})}m(b){return(0,k.$eg)(b)?[...this.b.values()].find(M=>M.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,M){const N=this.n(b),F=(0,k.$eg)(b)?b:M?.id??(0,O.$sj)(N.toString()).toString(16);let W=this.b.get(N)?.logger;const K=M?.logLevel==="always"?o.Trace:M?.logLevel;W||(W=this.s(N,K??this.getLogLevel(N)??this.h,{...M,id:F}));const L={logger:W,info:{resource:N,id:F,logLevel:K,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(L.info),this.b.set(N,L),W}n(b){return(0,k.$eg)(b)?(0,s.$fh)(this.j,`${b}.log`):b}setLogLevel(b,M){if(y.URI.isUri(b)){const N=b,F=M,W=this.b.get(N);W&&F!==W.info.logLevel&&(W.info.logLevel=F===this.h?void 0:F,W.logger?.setLevel(F),this.b.set(W.info.resource,W),this.f.fire([N,F]))}else{this.h=b;for(const[N,F]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,M){const N=this.m(b);N&&M!==!N.info.hidden&&(N.info.hidden=!M,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,M]))}getLogLevel(b){let M;return b&&(M=this.b.get(b)?.info.logLevel),M??this.h}registerLogger(b){const M=this.b.get(b.resource);M?M.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const M=this.b.get(b);M&&(M.logger&&M.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=p;class h{constructor(){this.onDidChangeLogLevel=new P.$le().event}setLevel(b){}getLevel(){return o.Info}trace(b,...M){}debug(b,...M){}info(b,...M){}warn(b,...M){}error(b,...M){}critical(b,...M){}dispose(){}flush(){}}e.$lk=h;class E extends h{}e.$mk=E;function D(f){if(f.verbose)return o.Trace;if(typeof f.logLevel=="string"){const b=C(f.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ck}function w(f){switch(f){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function I(f){switch(f){case o.Trace:return{original:"Trace",value:v.localize(11271,null)};case o.Debug:return{original:"Debug",value:v.localize(11272,null)};case o.Info:return{original:"Info",value:v.localize(11273,null)};case o.Warning:return{original:"Warning",value:v.localize(11274,null)};case o.Error:return{original:"Error",value:v.localize(11275,null)};case o.Off:return{original:"Off",value:v.localize(11276,null)}}}function C(f){switch(f){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$rk=new a.$Vj("logLevel",w(o.Info))}),define(Oe[172],Ne([1,0,4,11]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=void 0;class P extends v.$Uc{constructor(T,A=[]){super(),this.a=new R.$jk([T,...A]),this.B(T.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...A){this.a.trace(T,...A)}debug(T,...A){this.a.debug(T,...A)}info(T,...A){this.a.info(T,...A)}warn(T,...A){this.a.warn(T,...A)}error(T,...A){this.a.error(T,...A)}flush(){this.a.flush()}}e.$HR=P});var xt=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[107],Ne([1,0,35,9,3]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=xt(v);var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var T;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function($){function s(d,r){return r-d}$.compare=s;const k=Object.create(null);k[$.Error]=(0,R.localize)(11268,null),k[$.Warning]=(0,R.localize)(11269,null),k[$.Info]=(0,R.localize)(11270,null);function y(d){return k[d]||""}$.toString=y;function a(d){switch(d){case v.default.Error:return $.Error;case v.default.Warning:return $.Warning;case v.default.Info:return $.Info;case v.default.Ignore:return $.Hint}}$.fromSeverity=a;function S(d){switch(d){case $.Error:return v.default.Error;case $.Warning:return v.default.Warning;case $.Info:return v.default.Info;case $.Hint:return v.default.Ignore}}$.toSeverity=S}(T||(e.MarkerSeverity=T={}));var A;(function($){const s="";function k(a){return y(a,!0)}$.makeKey=k;function y(a,S){const d=[s];return a.source?d.push(a.source.replace("\xA6","\\\xA6")):d.push(s),a.code?typeof a.code=="string"?d.push(a.code.replace("\xA6","\\\xA6")):d.push(a.code.value.replace("\xA6","\\\xA6")):d.push(s),a.severity!==void 0&&a.severity!==null?d.push(T.toString(a.severity)):d.push(s),a.message&&S?d.push(a.message.replace("\xA6","\\\xA6")):d.push(s),a.startLineNumber!==void 0&&a.startLineNumber!==null?d.push(a.startLineNumber.toString()):d.push(s),a.startColumn!==void 0&&a.startColumn!==null?d.push(a.startColumn.toString()):d.push(s),a.endLineNumber!==void 0&&a.endLineNumber!==null?d.push(a.endLineNumber.toString()):d.push(s),a.endColumn!==void 0&&a.endColumn!==null?d.push(a.endColumn.toString()):d.push(s),d.push(s),d.join("\xA6")}$.makeKeyOptionalMessage=y})(A||(e.IMarkerData=A={})),e.$Fu=(0,P.$Ei)("markerService")});var xt=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[173],Ne([1,0,6,35,3]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$uw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$sw=e.Severity=void 0,e.$tw=A,R=xt(R),e.Severity=R.default,e.$sw=(0,P.$Ei)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var T;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function A(y){if(y){const a=y;return typeof a.id=="string"&&typeof a.label=="string"}return!1}var $;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class s{constructor(){this.progress=new k,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(a){}updateMessage(a){}updateActions(a){}close(){}}e.$uw=s;class k{infinite(){}done(){}total(a){}worked(a){}}e.$vw=k}),define(Oe[108],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,v.$Ei)("productService"),e.$tk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(be,e,v,R){var P=arguments.length,O=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(be,e,v,R);else for(var A=be.length-1;A>=0;A--)(T=be[A])&&(O=(P<3?T(O):P>3?T(e,v,O):T(e,v))||O);return P>3&&O&&Object.defineProperty(e,v,O),O},Ve=this&&this.__param||function(be,e){return function(v,R){e(v,R,be)}};define(Oe[76],Ne([1,0,10,21,4,3]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.ProgressLocation=e.$ww=void 0,e.$ww=(0,O.$Ei)("progressService");var T;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.$xw=Object.freeze({total(){},worked(){},done(){}});class A{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(a){this.b=a}report(a){this.a=a,this.b(this.a)}}e.$yw=A;class ${get value(){return this.a}constructor(a){this.e=a}report(a){this.b?this.b.push(a):this.b=[a],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const a=this.b.shift();this.a=a,await this.e(this.a)}}finally{this.c=!1;const a=this.d;this.d=void 0,a?.()}}drain(){return this.c?new Promise(a=>{const S=this.d;this.d=()=>{S?.(),a()}}):Promise.resolve()}}e.$zw=$;let s=class extends P.$Uc{constructor(a,S){super(),this.a=new v.$2h,S.withProgress(a,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Sc)(()=>this.a.complete()))}report(a){this.b?this.b.report(a):this.c=a}};e.$Aw=s,e.$Aw=s=Je([Ve(1,e.$ww)],s);class k extends P.$Uc{constructor(a){super(),this.g=a,this.a=0,this.b=this.B(new P.$Tc)}start(a){this.stop();const S=++this.a,d=new R.$we;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},a),this.b.add((0,P.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Sc)(()=>d.cancel())),this.b.add((0,P.$Sc)(()=>this.c?this.c.done():void 0)),{id:S,token:d.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(a){this.a===a&&this.b.clear()}}e.$Bw=k,e.$Cw=(0,O.$Ei)("editorProgressService")}),define(Oe[30],Ne([1,0,61,14]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,v=We(v),R=We(R);class P{constructor(){this.a=new Map}add(T,A){v.ok(R.$eg(T)),v.ok(R.$gg(A)),v.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,A)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$qo=new P}),define(Oe[77],Ne([1,0,6,137,30]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,P=We(P),e.$ro={JSONContribution:"base.contributions.json"};function O($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class T{constructor(){this.b=new v.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,k){this.a[O(s)]=k,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const k=this.a[s];return k?(0,R.$7j)(k):void 0}hasSchemaContent(s){return!!this.a[s]}}const A=new T;P.$qo.add(e.$ro.JSONContribution,A)}),define(Oe[53],Ne([1,0,17,6,14,9,43,77,30]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=r,e.$Ho=o,e.$Io=c,e.$Jo=i,e.$Ko=n,e.$Lo=t,e.$Mo=g,P=We(P),O=We(O);var s;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$vo={Configuration:"base.contributions.configuration"};var k;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k||(e.ConfigurationScope=k={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const y=$.$qo.as(A.$ro.JSONContribution);class a{constructor(){this.a=[],this.i=new Set,this.j=new R.$le,this.onDidSchemaChange=this.j.event,this.k=new R.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:O.localize(11564,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Co,this.h),this.z()}registerConfiguration(m,p=!0){this.registerConfigurations([m],p)}registerConfigurations(m,p=!0){const h=new Set;this.r(m,p,h),y.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:h})}deregisterConfigurations(m){const p=new Set;this.s(m,p),y.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:p})}updateConfigurations({add:m,remove:p}){const h=new Set;this.s(p,h),this.r(m,!1,h),y.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:h})}registerDefaultConfigurations(m){const p=new Set;this.l(m,p),this.j.fire(),this.k.fire({properties:p,defaultsOverrides:!0})}l(m,p){this.a.push(...m);const h=[];for(const{overrides:E,source:D}of m)for(const w in E){p.add(w);const I=this.b.get(w)??this.b.set(w,{configurationDefaultOverrides:[]}).get(w),C=E[w];if(I.configurationDefaultOverrides.push({value:C,source:D}),e.$Fo.test(w)){const f=this.o(w,C,D,I.configurationDefaultOverrideValue);if(!f)continue;I.configurationDefaultOverrideValue=f,this.n(w,f,D),h.push(...r(w))}else{const f=this.p(w,C,D,I.configurationDefaultOverrideValue);if(!f)continue;I.configurationDefaultOverrideValue=f;const b=this.e[w];b&&(this.A(w,b),this.w(w,b))}}this.q(h)}deregisterDefaultConfigurations(m){const p=new Set;this.m(m,p),this.j.fire(),this.k.fire({properties:p,defaultsOverrides:!0})}m(m,p){for(const h of m){const E=this.a.indexOf(h);E!==-1&&this.a.splice(E,1)}for(const{overrides:h,source:E}of m)for(const D in h){const w=this.b.get(D);if(!w)continue;const I=w.configurationDefaultOverrides.findIndex(C=>E?C.source?.id===E.id:C.value===h[D]);if(I!==-1){if(w.configurationDefaultOverrides.splice(I,1),w.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Fo.test(D)){let C;for(const f of w.configurationDefaultOverrides)C=this.o(D,f.value,f.source,C);C&&!P.$rg(C.value)?(w.configurationDefaultOverrideValue=C,this.n(D,C,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let C;for(const b of w.configurationDefaultOverrides)C=this.p(D,b.value,b.source,C);w.configurationDefaultOverrideValue=C;const f=this.e[D];f&&(this.A(D,f),this.w(D,f))}p.add(D)}}this.y()}n(m,p,h){const E={type:"object",default:p.value,description:O.localize(11565,null,(0,T.$ij)(m)),$ref:e.$Co,defaultDefaultValue:p.value,source:h,defaultValueSource:h};this.e[m]=E,this.c.properties[m]=E}o(m,p,h,E){const D=E?.value||{},w=E?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const I of Object.keys(p)){const C=p[I];if(P.$gg(C)&&(P.$lg(D[I])||P.$gg(D[I]))){if(D[I]={...D[I]??{},...C},h)for(const b in C)w.set(`${I}.${b}`,h)}else D[I]=C,h?w.set(I,h):w.delete(I)}return{value:D,source:w}}p(m,p,h,E){const D=this.e[m],w=E?.value??D?.defaultDefaultValue;let I=h;if(P.$gg(p)&&(D!==void 0&&D.type==="object"||D===void 0&&(P.$lg(w)||P.$gg(w)))){if(I=E?.source??new Map,!(I instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const f in p)h&&I.set(`${m}.${f}`,h);p={...P.$gg(w)?w:{},...p}}return{value:p,source:I}}deltaConfiguration(m){let p=!1;const h=new Set;m.removedDefaults&&(this.m(m.removedDefaults,h),p=!0),m.addedDefaults&&(this.l(m.addedDefaults,h),p=!0),m.removedConfigurations&&this.s(m.removedConfigurations,h),m.addedConfigurations&&this.r(m.addedConfigurations,!1,h),this.j.fire(),this.k.fire({properties:h,defaultsOverrides:p})}notifyConfigurationSchemaUpdated(...m){this.j.fire()}registerOverrideIdentifiers(m){this.q(m),this.j.fire()}q(m){for(const p of m)this.i.add(p);this.y()}r(m,p,h){m.forEach(E=>{this.u(E,p,E.extensionInfo,E.restrictedProperties,void 0,h),this.d.push(E),this.v(E)})}s(m,p){const h=E=>{if(E.properties)for(const D in E.properties){p.add(D);const w=this.e[D];w?.policy?.name&&this.f.delete(w.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>h(D))};for(const E of m){h(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u(m,p=!0,h,E,D=k.WINDOW,w){D=P.$ng(m.scope)?D:m.scope;const I=m.properties;if(I)for(const f in I){const b=I[f];if(p&&i(f,b)){delete I[f];continue}if(b.source=h,b.defaultDefaultValue=I[f].default,this.A(f,b),e.$Fo.test(f)?b.scope=void 0:(b.scope=P.$ng(b.scope)?D:b.scope,b.restricted=P.$ng(b.restricted)?!!E?.includes(f):b.restricted),I[f].hasOwnProperty("included")&&!I[f].included){this.g[f]=I[f],delete I[f];continue}else this.e[f]=I[f],I[f].policy?.name&&this.f.set(I[f].policy.name,f);!I[f].deprecationMessage&&I[f].markdownDeprecationMessage&&(I[f].deprecationMessage=I[f].markdownDeprecationMessage),w.add(f)}const C=m.allOf;if(C)for(const f of C)this.u(f,p,h,E,D,w)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const m=new Map;for(const[p,h]of this.b)h.configurationDefaultOverrideValue&&m.set(p,h.configurationDefaultOverrideValue);return m}v(m){const p=h=>{const E=h.properties;if(E)for(const w in E)this.w(w,E[w]);h.allOf?.forEach(p)};p(m)}w(m,p){switch(e.$wo.properties[m]=p,p.scope){case k.APPLICATION:e.$xo.properties[m]=p;break;case k.MACHINE:e.$yo.properties[m]=p;break;case k.MACHINE_OVERRIDABLE:e.$zo.properties[m]=p;break;case k.WINDOW:e.$Ao.properties[m]=p;break;case k.RESOURCE:e.$Bo.properties[m]=p;break;case k.LANGUAGE_OVERRIDABLE:e.$Bo.properties[m]=p,this.h.properties[m]=p;break}}x(m,p){switch(delete e.$wo.properties[m],p.scope){case k.APPLICATION:delete e.$xo.properties[m];break;case k.MACHINE:delete e.$yo.properties[m];break;case k.MACHINE_OVERRIDABLE:delete e.$zo.properties[m];break;case k.WINDOW:delete e.$Ao.properties[m];break;case k.RESOURCE:case k.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[m],delete this.h.properties[m];break}}y(){for(const m of this.i.values()){const p=`[${m}]`,h={type:"object",description:O.localize(11566,null),errorMessage:O.localize(11567,null),$ref:e.$Co};this.A(p,h),e.$wo.properties[p]=h,e.$xo.properties[p]=h,e.$yo.properties[p]=h,e.$zo.properties[p]=h,e.$Ao.properties[p]=h,e.$Bo.properties[p]=h}}z(){const m={type:"object",description:O.localize(11568,null),errorMessage:O.localize(11569,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=m,e.$xo.patternProperties[e.$Eo]=m,e.$yo.patternProperties[e.$Eo]=m,e.$zo.patternProperties[e.$Eo]=m,e.$Ao.patternProperties[e.$Eo]=m,e.$Bo.patternProperties[e.$Eo]=m,this.j.fire()}A(m,p){const h=this.b.get(m)?.configurationDefaultOverrideValue;let E,D;h&&(!p.disallowConfigurationDefault||!h.source)&&(E=h.value,D=h.source),P.$lg(E)&&(E=p.defaultDefaultValue,D=void 0),P.$lg(E)&&(E=c(p.type)),p.default=E,p.defaultValueSource=D}}const S="\\[([^\\]]+)\\]",d=new RegExp(S,"g");e.$Eo=`^(${S})+$`,e.$Fo=new RegExp(e.$Eo);function r(u){const m=[];if(e.$Fo.test(u)){let p=d.exec(u);for(;p?.length;){const h=p[1].trim();h&&m.push(h),p=d.exec(u)}}return(0,v.$Lb)(m)}function o(u){return u.reduce((m,p)=>`${m}[${p}]`,"")}function c(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const l=new a;$.$qo.add(e.$vo.Configuration,l);function i(u,m){return u.trim()?e.$Fo.test(u)?O.localize(11571,null,u):l.getConfigurationProperties()[u]!==void 0?O.localize(11572,null,u):m.policy?.name&&l.getPolicyConfigurations().get(m.policy?.name)!==void 0?O.localize(11573,null,u,m.policy?.name,l.getPolicyConfigurations().get(m.policy?.name)):null:O.localize(11570,null)}function n(){const u=[],m=l.getConfigurationProperties();for(const p of Object.keys(m))u.push([p,m[p].scope]);return u.push(["launch",k.RESOURCE]),u.push(["task",k.RESOURCE]),u}function t(u){const m={};for(const p of u){const h=p.properties;if(P.$gg(h))for(const E in h)m[E]=h[E];p.allOf&&Object.assign(m,t(p.allOf))}return m}function g(u){switch(u){case"application":return k.APPLICATION;case"machine":return k.MACHINE;case"resource":return k.RESOURCE;case"machine-overridable":return k.MACHINE_OVERRIDABLE;case"language-overridable":return k.LANGUAGE_OVERRIDABLE;default:return k.WINDOW}}}),define(Oe[174],Ne([1,0,17,6,136,4,28,25,14,2,43,53,29,30]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$Ro=n,v=We(v),P=We(P),A=We(A),$=We($);function d(m){return Object.isFrozen(m)?m:A.$eo(m)}class r{static createEmptyModel(p){return new r({},[],[],void 0,p)}constructor(p,h,E,D,w){this.b=p,this.c=h,this.d=E,this.raw=D,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const p=this.raw.map(h=>{if(h instanceof r)return h;const E=new o("",this.f);return E.parseRaw(h),E.configurationModel});this.g=p.reduce((h,E)=>E===h?E:h.merge(E),p[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(p){return p?(0,k.$gj)(this.contents,p):this.contents}inspect(p,h){const E=this;return{get value(){return d(E.rawConfiguration.getValue(p))},get override(){return h?d(E.rawConfiguration.getOverrideValue(p,h)):void 0},get merged(){return d(h?E.rawConfiguration.override(h).getValue(p):E.rawConfiguration.getValue(p))},get overrides(){const D=[];for(const{contents:w,identifiers:I,keys:C}of E.rawConfiguration.overrides){const f=new r(w,C,[],void 0,E.f).getValue(p);f!==void 0&&D.push({identifiers:I,value:f})}return D.length?d(D):void 0}}}getOverrideValue(p,h){const E=this.j(h);return E?p?(0,k.$gj)(E,p):E:void 0}getKeysForOverrideIdentifier(p){const h=[];for(const E of this.overrides)E.identifiers.includes(p)&&h.push(...E.keys);return v.$Lb(h)}getAllOverrideIdentifiers(){const p=[];for(const h of this.overrides)p.push(...h.identifiers);return v.$Lb(p)}override(p){let h=this.a.get(p);return h||(h=this.h(p),this.a.set(p,h)),h}merge(...p){const h=A.$do(this.contents),E=A.$do(this.overrides),D=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const I of p)if(w.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.i(h,I.contents);for(const C of I.overrides){const[f]=E.filter(b=>v.$tb(b.identifiers,C.identifiers));f?(this.i(f.contents,C.contents),f.keys.push(...C.keys),f.keys=v.$Lb(f.keys)):E.push(A.$do(C))}for(const C of I.keys)D.indexOf(C)===-1&&D.push(C)}return new r(h,D,E,w.every(I=>I instanceof r)?void 0:w,this.f)}h(p){const h=this.j(p);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const E={};for(const D of v.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let w=this.contents[D];const I=h[D];I&&(typeof w=="object"&&typeof I=="object"?(w=A.$do(w),this.i(w,I)):w=I),E[D]=w}return new r(E,this.keys,this.overrides,void 0,this.f)}i(p,h){for(const E of Object.keys(h)){if(E in p&&$.$gg(p[E])&&$.$gg(h[E])){this.i(p[E],h[E]);continue}p[E]=A.$do(h[E])}}j(p){let h=null,E=null;const D=w=>{w&&(E?this.i(E,w):E=A.$do(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===p?h=w.contents:w.identifiers.includes(p)&&D(w.contents);return D(h),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(p,h){this.k(p,h,!0)}setValue(p,h){this.k(p,h,!1)}removeValue(p){const h=this.keys.indexOf(p);h!==-1&&(this.keys.splice(h,1),(0,k.$fj)(this.contents,p),y.$Fo.test(p)&&this.overrides.splice(this.overrides.findIndex(E=>v.$tb(E.identifiers,(0,y.$Go)(p))),1))}k(p,h,E){if((0,k.$ej)(this.contents,p,h,D=>this.f.error(D)),E=E||this.keys.indexOf(p)===-1,E&&this.keys.push(p),y.$Fo.test(p)){const D=(0,y.$Go)(p),w={identifiers:D,keys:Object.keys(this.contents[p]),contents:(0,k.$dj)(this.contents[p],C=>this.f.error(C))},I=this.overrides.findIndex(C=>v.$tb(C.identifiers,D));I!==-1?this.overrides[I]=w:this.overrides.push(w)}}}e.$No=r;class o{constructor(p,h){this.f=p,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(p,h){if(!$.$ng(p)){const E=this.h(p);this.parseRaw(E,h)}}reparse(p){this.a&&this.parseRaw(this.a,p)}parseRaw(p,h){this.a=p;const{contents:E,keys:D,overrides:w,restricted:I,hasExcludedProperties:C}=this.i(p,h);this.b=new r(E,D,w,C?[p]:void 0,this.g),this.c=I||[]}h(p){let h={},E=null,D=[];const w=[],I=[];function C(b){Array.isArray(D)?D.push(b):E!==null&&(D[E]=b)}const f={onObjectBegin:()=>{const b={};C(b),w.push(D),D=b,E=null},onObjectProperty:b=>{E=b},onObjectEnd:()=>{D=w.pop()},onArrayBegin:()=>{const b=[];C(b),w.push(D),D=b,E=null},onArrayEnd:()=>{D=w.pop()},onLiteralValue:C,onError:(b,M,N)=>{I.push({error:b,offset:M,length:N})}};if(p)try{P.$5n(p,f),h=D[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return h}i(p,h){const E=S.$qo.as(y.$vo.Configuration).getConfigurationProperties(),D=this.j(p,E,!0,h);p=D.raw;const w=(0,k.$dj)(p,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`)),I=Object.keys(p),C=this.l(p,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:w,keys:I,overrides:C,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(p,h,E,D){let w=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:p,restricted:[],hasExcludedProperties:w};const I={},C=[];for(const f in p)if(y.$Fo.test(f)&&E){const b=this.j(p[f],h,!1,D);I[f]=b.raw,w=w||b.hasExcludedProperties,C.push(...b.restricted)}else{const b=h[f],M=b?typeof b.scope<"u"?b.scope:y.ConfigurationScope.WINDOW:void 0;b?.restricted&&C.push(f),!D.exclude?.includes(f)&&(D.include?.includes(f)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&b?.restricted))?I[f]=p[f]:w=!0}return{raw:I,restricted:C,hasExcludedProperties:w}}l(p,h){const E=[];for(const D of Object.keys(p))if(y.$Fo.test(D)){const w={};for(const I in p[D])w[I]=p[D][I];E.push({identifiers:(0,y.$Go)(D),keys:Object.keys(w),contents:(0,k.$dj)(w,h)})}return E}}e.$Oo=o;class c extends O.$Uc{constructor(p,h,E,D,w){super(),this.c=p,this.f=h,this.g=D,this.h=w,this.b=this.B(new R.$le),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),w),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(a.FileOperation.CREATE)||I.isOperation(a.FileOperation.COPY)||I.isOperation(a.FileOperation.DELETE)||I.isOperation(a.FileOperation.WRITE))&&E.isEqual(I.resource,p)))(()=>this.b.fire()))}async loadConfiguration(){try{const p=await this.g.readFile(this.c);return this.a.parse(p.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(p){return p&&(this.f=p),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Po=c;class l{constructor(p,h,E,D,w,I,C,f,b,M,N,F,W){this.a=p,this.b=h,this.c=E,this.overrideIdentifiers=D,this.d=w,this.f=I,this.g=C,this.h=f,this.i=b,this.j=M,this.k=N,this.l=F,this.m=W}get value(){return d(this.c)}n(p){return p?.value!==void 0||p?.override!==void 0||p?.overrides!==void 0?p:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(p,h,E,D,w,I,C,f,b,M){this.j=p,this.l=h,this.m=E,this.n=D,this.p=w,this.q=I,this.r=C,this.s=f,this.t=b,this.u=M,this.h=null,this.i=new T.$Ac,this.v=null}getValue(p,h,E){return this.w(p,h,E).getValue(p)}updateValue(p,h,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=r.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,h===void 0?D.removeValue(p):D.setValue(p,h),E.resource||(this.h=null)}inspect(p,h,E){const D=this.w(p,h,E),w=this.A(h.resource,E),I=h.resource?this.t.get(h.resource)||this.s:this.s,C=new Set;for(const f of D.overrides)for(const b of f.identifiers)D.getOverrideValue(p,b)!==void 0&&C.add(b);return new l(p,h,D.getValue(p),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,w||void 0,I)}keys(p){const h=this.A(void 0,p);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(p){this.j=p,this.h=null,this.i.clear()}updatePolicyConfiguration(p){this.l=p}updateApplicationConfiguration(p){this.m=p,this.h=null,this.i.clear()}updateLocalUserConfiguration(p){this.n=p,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(p){this.p=p,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(p){this.q=p,this.h=null,this.i.clear()}updateFolderConfiguration(p,h){this.r.set(p,h),this.i.delete(p)}deleteFolderConfiguration(p){this.folderConfigurations.delete(p),this.i.delete(p)}compareAndUpdateDefaultConfiguration(p,h){const E=[];if(!h){const{added:D,updated:w,removed:I}=g(this.j,p);h=[...D,...w,...I]}for(const D of h)for(const w of(0,y.$Go)(D)){const I=this.j.getKeysForOverrideIdentifier(w),C=p.getKeysForOverrideIdentifier(w),f=[...C.filter(b=>I.indexOf(b)===-1),...I.filter(b=>C.indexOf(b)===-1),...I.filter(b=>!A.$ho(this.j.override(w).getValue(b),p.override(w).getValue(b)))];E.push([w,f])}return this.updateDefaultConfiguration(p),{keys:h,overrides:E}}compareAndUpdatePolicyConfiguration(p){const{added:h,updated:E,removed:D}=g(this.l,p),w=[...h,...E,...D];return w.length&&this.updatePolicyConfiguration(p),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(p){const{added:h,updated:E,removed:D,overrides:w}=g(this.applicationConfiguration,p),I=[...h,...E,...D];return I.length&&this.updateApplicationConfiguration(p),{keys:I,overrides:w}}compareAndUpdateLocalUserConfiguration(p){const{added:h,updated:E,removed:D,overrides:w}=g(this.localUserConfiguration,p),I=[...h,...E,...D];return I.length&&this.updateLocalUserConfiguration(p),{keys:I,overrides:w}}compareAndUpdateRemoteUserConfiguration(p){const{added:h,updated:E,removed:D,overrides:w}=g(this.remoteUserConfiguration,p),I=[...h,...E,...D];return I.length&&this.updateRemoteUserConfiguration(p),{keys:I,overrides:w}}compareAndUpdateWorkspaceConfiguration(p){const{added:h,updated:E,removed:D,overrides:w}=g(this.workspaceConfiguration,p),I=[...h,...E,...D];return I.length&&this.updateWorkspaceConfiguration(p),{keys:I,overrides:w}}compareAndUpdateFolderConfiguration(p,h){const E=this.folderConfigurations.get(p),{added:D,updated:w,removed:I,overrides:C}=g(E,h),f=[...D,...w,...I];return(f.length||!E)&&this.updateFolderConfiguration(p,h),{keys:f,overrides:C}}compareAndDeleteFolderConfiguration(p){const h=this.folderConfigurations.get(p);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(p);const{added:E,updated:D,removed:w,overrides:I}=g(h,void 0);return{keys:[...E,...D,...w],overrides:I}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(p,h,E){let D=this.x(h,E);return h.overrideIdentifier&&(D=D.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(p)!==void 0&&(D=D.merge(this.l)),D}x({resource:p},h){let E=this.y();if(h&&p){const D=h.getFolder(p);D&&(E=this.z(D.uri)||E);const w=this.t.get(p);w&&(E=E.merge(w))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(p){let h=this.i.get(p);if(!h){const E=this.y(),D=this.r.get(p);D?(h=E.merge(D),this.i.set(p,h)):h=E}return h}A(p,h){if(h&&p){const E=h.getFolder(p);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((p,h)=>{const{contents:E,overrides:D,keys:w}=this.r.get(h);return p.push([h,{contents:E,overrides:D,keys:w}]),p},[])}}allKeys(){const p=new Set;return this.j.keys.forEach(h=>p.add(h)),this.userConfiguration.keys.forEach(h=>p.add(h)),this.q.keys.forEach(h=>p.add(h)),this.r.forEach(h=>h.keys.forEach(E=>p.add(E))),[...p.values()]}B(){const p=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>p.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>p.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>p.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(E=>p.add(E))),[...p.values()]}D(p){const h=new Set;return this.j.getKeysForOverrideIdentifier(p).forEach(E=>h.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(p).forEach(E=>h.add(E)),this.q.getKeysForOverrideIdentifier(p).forEach(E=>h.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(p).forEach(D=>h.add(D))),[...h.values()]}static parse(p,h){const E=this.E(p.defaults,h),D=this.E(p.policy,h),w=this.E(p.application,h),I=this.E(p.user,h),C=this.E(p.workspace,h),f=p.folders.reduce((b,M)=>(b.set(s.URI.revive(M[0]),this.E(M[1],h)),b),new T.$Ac);return new i(E,D,w,I,r.createEmptyModel(h),C,f,r.createEmptyModel(h),new T.$Ac,h)}static E(p,h){return new r(p.contents,p.keys,p.overrides,void 0,h)}}e.$Qo=i;function n(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const p=new Set,h=new Map;for(const D of m)D.keys.forEach(w=>p.add(w)),D.overrides.forEach(([w,I])=>{const C=(0,T.$xc)(h,w,new Set);I.forEach(f=>C.add(f))});const E=[];return h.forEach((D,w)=>E.push([w,[...D.values()]])),{keys:[...p.values()],overrides:E}}class t{constructor(p,h,E,D,w){this.change=p,this.f=h,this.g=E,this.h=D,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const I of p.keys)this.affectedKeys.add(I);for(const[,I]of p.overrides)for(const C of I)this.affectedKeys.add(C);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(p,h){const E=this.a+p,D=this.d.indexOf(E);if(D<0)return!1;const w=D+E.length;if(w>=this.d.length)return!1;const I=this.d.charCodeAt(w);if(I!==this.b&&I!==this.c)return!1;if(h){const C=this.previousConfiguration?this.previousConfiguration.getValue(p,h,this.f?.workspace):void 0,f=this.g.getValue(p,h,this.h);return!A.$ho(C,f)}return!0}}e.$So=t;function g(m,p){const{added:h,removed:E,updated:D}=u(p?.rawConfiguration,m?.rawConfiguration),w=[],I=m?.getAllOverrideIdentifiers()||[],C=p?.getAllOverrideIdentifiers()||[];if(p){const f=C.filter(b=>!I.includes(b));for(const b of f)w.push([b,p.getKeysForOverrideIdentifier(b)])}if(m){const f=I.filter(b=>!C.includes(b));for(const b of f)w.push([b,m.getKeysForOverrideIdentifier(b)])}if(p&&m){for(const f of I)if(C.includes(f)){const b=u({contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)},{contents:p.getOverrideValue(void 0,f)||{},keys:p.getKeysForOverrideIdentifier(f)});w.push([f,[...b.added,...b.removed,...b.updated]])}}return{added:h,removed:E,updated:D,overrides:w}}function u(m,p){const h=m?p?m.keys.filter(w=>p.keys.indexOf(w)===-1):[...m.keys]:[],E=p?m?p.keys.filter(w=>m.keys.indexOf(w)===-1):[...p.keys]:[],D=[];if(m&&p){for(const w of p.keys)if(m.keys.indexOf(w)!==-1){const I=(0,k.$gj)(p.contents,w),C=(0,k.$gj)(m.contents,w);A.$ho(I,C)||D.push(w)}}return{added:h,removed:E,updated:D}}}),define(Oe[109],Ne([1,0,13,3]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=s,e.$Ql=(0,R.$Ei)("remoteAuthorityResolverService");var P;(function(k){k[k.WebSocket=0]="WebSocket",k[k.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(y){this.id=y,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=O;class T{constructor(y,a){this.host=y,this.port=a,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=T;var A;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound",k.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class $ extends v.$ab{static isNotAvailable(y){return y instanceof $&&y._code===A.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof $&&y._code===A.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof $&&y._code===A.NoResolverFound}static isInvalidAuthority(y){return y instanceof $&&y._code===A.InvalidAuthority}static isHandled(y){return y instanceof $&&y.isHandled}constructor(y,a=A.Unknown,S){super(y),this._message=y,this._code=a,this._detail=S,this.isHandled=a===A.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Tl=$;function s(k){const y=k.indexOf("+");return y===-1?k:k.substring(0,y)}}),define(Oe[62],Ne([1,0,15]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=R,e.$hn=P,e.$in=O,e.$jn=T;function R($){return $.scheme===v.Schemas.vscodeRemote?$.authority:void 0}function P($){if(!$)return;const s=$.indexOf("+");return s<0?$:$.substr(0,s)}function O($){const{host:s,port:k}=A($);if(typeof k>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:k}}function T($,s){let{host:k,port:y}=A($);return typeof y>"u"&&(y=s),{host:k,port:y}}function A($){const s=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const k=$.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const y=$.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:$,port:void 0}}}),define(Oe[18],Ne([1,0,12,3,62]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=O,e.$tn=y,e.$un=a,e.$vn=S,e.$wn=d,e.$xn=r,e.$yn=o,v=We(v),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function O(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$pn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(T||(e.ExtensionType=T={}));var A;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class ${constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,i){if(typeof l>"u"||l===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof l=="string"||typeof i=="string"){const n=typeof l=="string"?l:l.value,t=typeof i=="string"?i:i.value;return v.$Ff(n,t)}return l._lower===i._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$qn=$;class s{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const i of l)this.add(i)}add(l){this.c.add($.toKey(l))}delete(l){return this.c.delete($.toKey(l))}has(l){return this.c.has($.toKey(l))}}e.$rn=s;class k{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete($.toKey(l))}get(l){return this.c.get($.toKey(l))}has(l){return this.c.has($.toKey(l))}set(l,i){this.c.set($.toKey(l),i)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=k;function y(c){return a(c)}function a(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function S(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function d(c,l){if(l){const i=`onResolveRemoteAuthority:${(0,P.$hn)(l)}`;return!!c.activationEvents?.includes(i)}return!1}function r(c){return c.map(l=>{const[i,n]=l.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function o(c){return c.map(l=>l.split("@")[0])}e.$zn=(0,R.$Ei)("IBuiltinExtensionsScannerService")}),define(Oe[110],Ne([1,0,20,9,18,3]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.ExtensionManagementErrorCode=e.$lp=e.ExtensionGalleryErrorCode=e.$kp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0,e.$ep=A,e.$fp=$,e.$gp=s,e.$hp=k,e.$ip=y,e.$jp=a,e.$0o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$o=new RegExp(e.$0o),e.$_o="__web_extension",e.$ap="skipWalkthrough",e.$bp="extensionInstallSource",e.$cp="dependecyOrPackExtensionInstall",e.$dp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function A(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function $(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function s(t,g){switch(t){case v.Platform.Windows:return g==="x64"?P.TargetPlatform.WIN32_X64:g==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Linux:return g==="x64"?P.TargetPlatform.LINUX_X64:g==="arm64"?P.TargetPlatform.LINUX_ARM64:g==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return g==="x64"?P.TargetPlatform.ALPINE_X64:g==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Mac:return g==="x64"?P.TargetPlatform.DARWIN_X64:g==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Web:return P.TargetPlatform.WEB}}function k(t,g){return g===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function y(t,g,u){return k(g,u)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===u}function a(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var S;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var o;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$kp=(0,O.$Ei)("extensionGalleryService");var c;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(c||(e.ExtensionGalleryErrorCode=c={}));class l extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$lp=l;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$mp=n,e.$np=(0,O.$Ei)("extensionManagementService"),e.$op="extensionsIdentifiers/disabled",e.$pp="extensionsIdentifiers/enabled",e.$qp=(0,O.$Ei)("IGlobalExtensionEnablementService"),e.$rp=(0,O.$Ei)("IExtensionTipsService"),e.$sp=(0,R.localize2)(11454,"Extensions"),e.$tp=(0,R.localize2)(11455,"Preferences")}),define(Oe[111],Ne([1,0,13,18]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=e.$WG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(T,A){this.a.set(T,A)}readActivationEvents(T){return this.b.has(T)||this.b.set(T,this.c(T)),this.b.get(T)}createActivationEventsMap(T){const A=Object.create(null);for(const $ of T){const s=this.readActivationEvents($);s.length>0&&(A[R.$qn.toKey($.identifier)]=s)}return A}c(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const A=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let $=0;$<A.length;$++)A[$]==="onUri"&&(A[$]=`onUri:${R.$qn.toKey(T.identifier)}`);if(!T.contributes)return A;for(const $ in T.contributes){const s=this.a.get($);if(!s)continue;const k=T.contributes[$],y=Array.isArray(k)?k:[k];try{s(y,A)}catch(a){(0,v.$Y)(a)}}return A}}e.$WG=P,e.$XG=new P});var xt=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[175],Ne([1,0,23,35,9,281,18,104]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=k,e.$Zp=y,e.$1p=a,e.$2p=S,e.$3p=d,e.$4p=r,e.$5p=o,e.$6p=c,R=xt(R),P=We(P),O=We(O);const $=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function k(n){return n=n.trim(),n==="*"||$.test(n)}function y(n){if(!k(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match($);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function a(n){if(!n)return null;const t=n.majorBase,g=n.majorMustEqual,u=n.minorBase;let m=n.minorMustEqual;const p=n.patchBase;let h=n.patchMustEqual;n.hasCaret&&(t===0||(m=!1),h=!1);let E=0;if(n.preRelease){const D=s.exec(n.preRelease);if(D){const[,w,I,C]=D;E=Date.UTC(Number(w),Number(I)-1,Number(C))}}return{majorBase:t,majorMustEqual:g,minorBase:u,minorMustEqual:m,patchBase:p,patchMustEqual:h,isMinimum:n.hasGreaterEquals,notBefore:E}}function S(n,t,g){let u;typeof n=="string"?u=a(y(n)):u=n;let m;t instanceof Date?m=t.getTime():typeof t=="string"&&(m=new Date(t).getTime());let p;if(typeof g=="string"?p=a(y(g)):p=g,!u||!p)return!1;const h=u.majorBase,E=u.minorBase,D=u.patchBase;let w=p.majorBase,I=p.minorBase,C=p.patchBase;const f=p.notBefore;let b=p.majorMustEqual,M=p.minorMustEqual,N=p.patchMustEqual;return p.isMinimum?h>w?!0:h<w?!1:E>I?!0:E<I||m&&m<f?!1:D>=C:(h===1&&w===0&&(!b||!M||!N)&&(w=1,I=0,C=0,b=!0,M=!1,N=!1),h<w?!1:h>w?!b:E<I?!1:E>I?!M:D<C?!1:D>C?!N:!(m&&m<f))}function d(n,t,g,u,m,p){const h=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return h.push([R.default.Error,P.localize(11385,null)]),h;if(typeof u.name!="string")return h.push([R.default.Error,P.localize(11386,null,"name")]),h;if(typeof u.version!="string")return h.push([R.default.Error,P.localize(11387,null,"version")]),h;if(!u.engines)return h.push([R.default.Error,P.localize(11388,null,"engines")]),h;if(typeof u.engines.vscode!="string")return h.push([R.default.Error,P.localize(11389,null,"engines.vscode")]),h;if(typeof u.extensionDependencies<"u"&&!i(u.extensionDependencies))return h.push([R.default.Error,P.localize(11390,null,"extensionDependencies")]),h;if(typeof u.activationEvents<"u"){if(!i(u.activationEvents))return h.push([R.default.Error,P.localize(11391,null,"activationEvents")]),h;if(typeof u.main>"u"&&typeof u.browser>"u")return h.push([R.default.Error,P.localize(11392,null,"activationEvents","main","browser")]),h}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&h.push([R.default.Warning,P.localize(11393,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return h.push([R.default.Error,P.localize(11394,null,"main")]),h;{const w=(0,v.$fh)(g,u.main);(0,v.$_g)(w,g)||h.push([R.default.Warning,P.localize(11395,null,w.path,g.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return h.push([R.default.Error,P.localize(11396,null,"browser")]),h;{const w=(0,v.$fh)(g,u.browser);(0,v.$_g)(w,g)||h.push([R.default.Warning,P.localize(11397,null,w.path,g.path)])}}if(!O.valid(u.version))return h.push([R.default.Error,P.localize(11398,null)]),h;const E=[];if(!r(n,t,u,m,E))for(const w of E)h.push([R.default.Error,w]);if(p&&u.enabledApiProposals?.length){const w=[];if(!c([...u.enabledApiProposals],w))for(const I of w)h.push([R.default.Error,I])}return h}function r(n,t,g,u,m){return u||typeof g.main>"u"&&typeof g.browser>"u"?!0:l(n,t,g.engines.vscode,m)}function o(n,t,g){return n==="*"||l(t,g,n)}function c(n,t){if(n.length===0)return!0;const g=Array.isArray(t)?t:void 0,u=(g?void 0:t)??A.allApiProposals,m=[],p=(0,T.$xn)(n);for(const{proposalName:h,version:E}of p){const D=u[h];D&&E&&D.version!==E&&m.push(P.localize(11399,null,h))}return g?.push(...m),m.length===0}function l(n,t,g,u=[]){const m=a(y(g));if(!m)return u.push(P.localize(11400,null,g)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return u.push(P.localize(11401,null,g)),!1}else if(!m.majorMustEqual)return u.push(P.localize(11402,null,g)),!1;return S(n,t,m)?!0:(u.push(P.localize(11403,null,n,g)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,g=n.length;t<g;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Oe[176],Ne([1,0,22,13,4,9,53,3,11,30]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$9p=a,e.$0p=S,e.$$p=d,e.$_p=r,e.$aq=o,e.$bq=c,e.$7p=(0,A.$Ei)("requestService");class k{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const g in this.b)g.toLowerCase()==="authorization"||g.toLowerCase()==="proxy-authorization"?t[g]="*****":t[g]=this.b[g];this.a=t}return this.a}}class y extends P.$Uc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(11172,null),when:$.$rk.isEqualTo((0,$.$ok)($.LogLevel.Trace)).serialize()})}async c(t,g,u){const m=`${t} #${++this.b}: ${g.url}`;this.a.trace(`${m} - begin`,g.type,new k(g.headers??{}));try{const p=await u();return this.a.trace(`${m} - end`,g.type,p.res.statusCode,p.res.headers),p}catch(p){throw this.a.error(`${m} - error`,g.type,(0,R.$9)(p)),p}}}e.$8p=y;function a(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function S(n){return n.res.statusCode===204}async function d(n){return S(n)?null:(await(0,v.$Ze)(n.stream)).toString()}async function r(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);return d(n)}async function o(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);if(S(n))return null;const g=(await(0,v.$Ze)(n.stream)).toString();try{return JSON.parse(g)}catch(u){throw u.message+=`:
`+g,u}}function c(n){i(n)}let l;function i(n){const t=s.$qo.as(T.$vo.Configuration),g=l;l={id:"http",order:15,title:(0,O.localize)(11173,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(11174,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(11175,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(11176,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(11177,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(11178,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(11179,null),(0,O.localize)(11180,null),(0,O.localize)(11181,null),(0,O.localize)(11182,null)],default:"override",description:(0,O.localize)(11183,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11184,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(11185,null),restricted:!0}}},t.updateConfigurations({add:[l],remove:g?[g]:[]})}i(T.ConfigurationScope.APPLICATION)}),define(Oe[177],Ne([1,0,20,78,37]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=T,e.$vp=A;function O($){if(v.$v===v.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function T($,s,k,y,a,S,d,r,o,c){const l=Object.create(null);l["common.machineId"]=S,l["common.sqmId"]=d,l["common.devDeviceId"]=r,l.sessionID=(0,P.$1g)()+Date.now(),l.commitHash=y,l.version=a,l["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,v.$i)(v.$v),l["common.nodePlatform"]=R.$dc,l["common.nodeArch"]=k,l["common.product"]=c||"desktop",o&&(l["common.msftInternal"]=o);let i=0;const n=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$m&&(l["common.snap"]="true");const t=O(s);return t&&(l["common.platformDetail"]=t),l}function A($){const s=R.env.USERDNSDOMAIN;if(!s)return!1;const k=s.toLowerCase();return $.some(y=>k===y)}}),define(Oe[112],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,v.$Ei)("telemetryService"),e.$_l=(0,v.$Ei)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Oe[63],Ne([1,0,25,14,62,177,112]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$Dp=k,e.$Ep=y,e.$Fp=a,e.$Gp=S,e.$Hp=r,e.$Ip=c,e.$Jp=l,e.$Kp=t;class A{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$wp=A;class ${constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xp=$,e.$yp=new $;class s{async publicLog(u,m,p){}async publicLogError(u,m,p){}}e.$zp=s,e.$Ap="telemetry",e.$Bp="extensionTelemetryLog",e.$Cp={log:()=>null,flush:()=>Promise.resolve(null)};function k(g,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!g.enableTelemetry)}function y(g,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}function a(g){const u=g.getValue(T.$hm),m=g.getValue(T.$im);if(g.getValue(T.$jm)===!1||m===!1)return T.TelemetryLevel.NONE;switch(u??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function S(g){const u={},m={},p={};o(g,p);for(let h in p){h=h.length>150?h.substr(h.length-149):h;const E=p[h];typeof E=="number"?m[h]=E:typeof E=="boolean"?m[h]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${E.length}`),u[h]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(u[h]=E)}return{properties:u,measurements:m}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(g){if(!g)return"none";const u=(0,P.$hn)(g);return d.has(u)?u:"other"}function o(g,u,m=0,p){if(g)for(const h of Object.getOwnPropertyNames(g)){const E=g[h],D=p?p+h:h;Array.isArray(E)?u[D]=(0,v.$io)(E):E instanceof Date?u[D]=E.toISOString():(0,R.$gg)(E)?m<2?o(E,u,m+1,D+"."):u[D]=(0,v.$io)(E):u[D]=E}}function c(g,u){const m=g.msftInternalDomains||[],p=u.getValue("telemetry.internalTesting");return(0,O.$vp)(m)||p}function l(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}function i(g,u){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let m=g;const p=[];for(const w of u)for(;;){const I=w.exec(g);if(!I)break;p.push([I.index,w.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(m="";;){const w=E.exec(g);if(!w)break;const I=p.some(([C,f])=>w.index<f&&C<E.lastIndex);!h.test(w[0])&&!I&&(m+=g.substring(D,w.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<g.length&&(m+=g.substr(D)),m}function n(g){if(!g)return g;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of u)if(m.regex.test(g))return`<REDACTED: ${m.label}>`;return g}function t(g,u){return(0,v.$fo)(g,m=>{if(m instanceof A||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let p=m.replaceAll("%20"," ");p=i(p,u);for(const h of u)p=p.replace(h,"");return p=n(p),p}})}}),define(Oe[178],Ne([1,0,12,110,18,20,2,13,78,63]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Mp=void 0,e.$Lp=k,e.$Np=d,e.$Op=r,e.$Pp=o,e.$Qp=c,e.$Rp=l,e.$Sp=i,e.$Tp=n,e.$Vp=t,e.$Wp=u;function k(m,p){return m.uuid&&p.uuid?m.uuid===p.uuid:m.id===p.id?!0:(0,v.$Af)(m.id,p.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(p){const h=p.manifest?p.manifest.version:p.version,E=p.manifest?p.targetPlatform:p.properties.targetPlatform;return new a(p.identifier,h,E)}static parse(p){const h=y.exec(p);return h&&h[1]&&h[2]?new a({id:h[1]},h[2],h[4]||void 0):null}constructor(p,h,E=P.TargetPlatform.UNDEFINED){this.identifier=p,this.version=h,this.targetPlatform=E,this.id=p.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(p){return p instanceof a?k(this,p)&&this.version===p.version&&this.targetPlatform===p.targetPlatform:!1}}e.$Mp=a;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(m){const p=S.exec(m);return p&&p[1]?[o(p[1]),p[2]]:[o(m),void 0]}function r(m,p){return`${m}.${p}`}function o(m){return m.toLowerCase()}function c(m,p){return o(r(m??P.$mn,p))}function l(m,p){const h=[],E=D=>{for(const w of h)if(w.some(I=>k(p(I),p(D))))return w;return null};for(const D of m){const w=E(D);w?w.push(D):h.push([D])}return h}function i(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}function n(m){return{id:new s.$wp(m.identifier.id),name:new s.$wp(m.name),version:m.version,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,isPreReleaseVersion:m.properties.isPreReleaseVersion,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0),isSigned:m.isSigned,...m.telemetryData}}e.$Up=new P.$qn("pprice.better-merge");function t(m,p){const h=[],E=p.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&h.every(w=>!k(w.identifier,{id:D}))){const w=m.filter(I=>k(I.identifier,{id:D}));w.length===1&&(h.push(w[0]),E.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function g(m,p){if(!O.$l)return!1;let h;try{h=(await m.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await m.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){p.debug("Error while getting the os-release file.",(0,A.$9)(D))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(m,p){const h=await g(m,p),E=(0,R.$gp)(h?"alpine":O.$v,$.$ec);return p.debug("ComputeTargetPlatform:",E),E}}),define(Oe[179],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=v,e.$Fs=R,e.$Gs=P,e.$Hs=O,e.$Is=T,e.$Js=A;function v($){return[...$.entries()]}function R($){return $?[...$.entries()]:[]}function P($){return new Map($)}function O($){return new Map($??[])}function T($){return Array.from($.entries()).map(s=>[s[0],v(s[1].map),R(s[1].descriptionMap)])}function A($){return new Map($.map(s=>[s[0],{map:P(s[1]),descriptionMap:O(s[2])}]))}}),define(Oe[180],Ne([1,0,3,31,30]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$os=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ns=void 0,e.$ns=new R.$Vj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var A;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(A||(e.PosixShellType=A={}));var $;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})($||(e.WindowsShellType=$={}));var s;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(s||(e.TitleEventSource=s={}));var k;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(k||(e.TerminalIpcChannels=k={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$os=(0,v.$Ei)("ptyService");var a;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(a||(e.HeartbeatConstants=a={}));var S;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var o;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var c;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var l;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ps={Backend:"workbench.contributions.terminal.processBackend"};class n{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(g){const u=this.b(g.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,g)}getTerminalBackend(g){return this.a.get(this.b(g))}b(g){return g?.toLowerCase()??""}}P.$qo.add(e.$ps.Backend,new n),e.$qs=(0,v.$Ei)("localPtyService"),e.$rs=(0,v.$Ei)("terminalLogService")}),define(Oe[181],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sxb=void 0;class v{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,O,T=5){const A=O($=>{const s=typeof $=="string"?$:$.data;let k=this.a.get(P);if(k){k.data.push(s);return}const y=setTimeout(()=>this.flushBuffer(P),T);k={data:[s],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(P),A.dispose()}},this.a.set(P,k)});return A}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const O=this.a.get(P);O&&(this.a.delete(P),this.b(P,O.data.join("")))}}e.$Sxb=v}),define(Oe[182],Ne([1,0,10,97,282,34,6,14,2,9,77,30]),function(be,e,v,R,P,O,T,A,$,s,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hx=e.$Gx=e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.IconFontDefinition=e.IconContribution=e.$zx=void 0,e.$Ax=o,e.$Bx=c,y=We(y),e.$zx={IconContribution:"base.contributions.icons"};var a;(function(t){function g(u,m){let p=u.defaults;for(;O.ThemeIcon.isThemeIcon(p);){const h=r.getIcon(p.id);if(!h)return;p=h.defaults}return p}t.getDefinition=g})(a||(e.IconContribution=a={}));var S;(function(t){function g(m){return{weight:m.weight,style:m.style,src:m.src.map(p=>({format:p.format,location:p.location.toString()}))}}t.toJSONObject=g;function u(m){const p=h=>(0,A.$eg)(h)?h:void 0;if(m&&Array.isArray(m.src)&&m.src.every(h=>(0,A.$eg)(h.format)&&(0,A.$eg)(h.location)))return{weight:p(m.weight),style:p(m.style),src:m.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}t.fromJSONObject=u})(S||(e.IconFontDefinition=S={}));class d{constructor(){this.a=new T.$le,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(11104,null)},fontCharacter:{type:"string",description:(0,s.localize)(11105,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,u,m,p){const h=this.b[g];if(h){if(m&&!h.description){h.description=m,this.d.properties[g].markdownDescription=`${m} $(${g})`;const w=this.e.enum.indexOf(g);w!==-1&&(this.e.enumDescriptions[w]=m),this.a.fire()}return h}const E={id:g,description:m,defaults:u,deprecationMessage:p};this.b[g]=E;const D={$ref:"#/definitions/icons"};return p&&(D.deprecationMessage=p),m&&(D.markdownDescription=`${m}: $(${g})`),this.d.properties[g]=D,this.e.enum.push(g),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const u=this.e.enum.indexOf(g);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,u){const m=this.f[g];return m||(this.f[g]=u,this.a.fire(),u)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(h,E)=>h.id.localeCompare(E.id),u=h=>{for(;O.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.b).map(h=>this.b[h]);for(const h of p.filter(E=>!!E.description).sort(g))m.push(`|<i class="${u(h)}"></i>|${h.id}|${O.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const h of p.filter(E=>!O.ThemeIcon.isThemeIcon(E.defaults)).sort(g))m.push(`|<i class="${u(h)}"></i>|${h.id}|`);return m.join(`
`)}}const r=new d;y.$qo.add(e.$zx.IconContribution,r);function o(t,g,u,m){return r.registerIcon(t,g,u,m)}function c(){return r}function l(){const t=(0,P.$Zj)();for(const g in t){const u="\\"+t[g].toString(16);r.registerIcon(g,{fontCharacter:u})}}l(),e.$Cx="vscode://schemas/icons";const i=y.$qo.as(k.$ro.JSONContribution);i.registerSchema(e.$Cx,r.getIconSchema());const n=new v.$Qh(()=>i.notifySchemaChanged(e.$Cx),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Dx=o("widget-close",R.$4j.close,(0,s.localize)(11106,null)),e.$Ex=o("goto-previous-location",R.$4j.arrowUp,(0,s.localize)(11107,null)),e.$Fx=o("goto-next-location",R.$4j.arrowDown,(0,s.localize)(11108,null)),e.$Gx=O.ThemeIcon.modify(R.$4j.sync,"spin"),e.$Hx=O.ThemeIcon.modify(R.$4j.loading,"spin")}),define(Oe[183],Ne([1,0,6,4,20,2,43,3,11]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ow=e.$Nw=e.$Kw=e.$Iw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ew=e.$Dw=void 0,e.$Fw=y,e.$Gw=S,e.$Hw=d,e.$Jw=r,e.$Lw=o,e.$Mw=c,e.$Dw=(0,A.$Ei)("tunnelService"),e.$Ew=(0,A.$Ei)("sharedTunnelsService");var s;(function(n){n.Http="http",n.Https="https"})(s||(e.TunnelProtocol=s={}));var k;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(k||(e.TunnelPrivacyId=k={}));function y(n){return!!n.forwardPort}var a;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function S(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function d(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const g of t){const u=g.split("=")[1];if(/^https?:/.exec(u)){const m=S(O.URI.parse(u));if(m)return m}}}e.$Iw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Iw.indexOf(n)>=0}e.$Kw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(n){return e.$Kw.indexOf(n)>=0}function c(n,t,g,u){if(g===P.OperatingSystem.Windows)return!1;if(g===P.OperatingSystem.Macintosh&&o(t)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(m?.length===4&&parseInt(m[1])>=18)return!1}return n<1024}class l{constructor(t,g,u){this.remoteAddress=t,this.localAddress=g,this.b=u,this.a=new v.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Nw=l;let i=class extends R.$Uc{constructor(t,g){super(),this.r=t,this.s=g,this.a=new v.$le,this.onTunnelOpened=this.a.event,this.b=new v.$le,this.onTunnelClosed=this.b.event,this.c=new v.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],g=Array.from(this.f.values());for(const u of g){const m=Array.from(u.values());for(const p of m){const h=await p.value;h&&typeof h!="string"&&t.push(h)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:g}of t.values())await g.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,g,u,m,p){this.z(t,g,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:g,localAddress:u,privacy:m,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,g){(o(t)||r(t))&&(t=e.$Iw[0]);const u=this.D(t,g);if(u)return++u.refcount,u.value}openTunnel(t,g,u,m,p,h=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${u} on local port ${p}.`);const w=this.g??t;if(!w)return;if(g||(g="localhost"),m||(m=this.t),this.g&&this.n.has(u)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const I=this.F(w,g,u,m,p,h,E,D);return I?I.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(g,u),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(g,u);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.w(C);return(C.tunnelRemoteHost!==g||C.tunnelRemotePort!==u)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&C.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),I)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const g=this.f.get(t.tunnelRemoteHost);if(g){const u=g.get(t.tunnelRemotePort);u&&(u.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async y(t,g,u){if(u.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${g}.`);const m=u.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(g),m}}async closeTunnel(t,g){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${g} `);const u=this.f.get(t);if(u&&u.has(g)){const m=u.get(g);m.refcount=0,await this.y(t,g,m)}}z(t,g,u){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(g,{refcount:1,value:u})}async C(t,g){const u=this.f.get(t);if(u){const m=u.get(g),p=m?await m.value:void 0;(!p||typeof p=="string")&&u.delete(g),u.size===0&&this.f.delete(t)}}D(t,g){const u=[t];r(t)?(u.push(...e.$Iw),u.push(...e.$Kw)):o(t)&&u.push(...e.$Kw);const m=u.map(p=>this.f.get(p));for(const p of m){const h=p?.get(g);if(h)return h}}canTunnel(t){return!!S(t)}G(t,g,u,m,p,h,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${u} on local port ${m}.`);const D=u;this.n.add(D);const w=m===void 0?u:m,I={elevationRequired:p?this.isPortPrivileged(w):!1},C={remoteAddress:{host:g,port:u},localAddressPort:m,privacy:h,public:h?h!==k.Private:void 0,protocol:E},f=t.forwardPort(C,I);return f?(this.z(g,u,f),f.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),f}};e.$Ow=i,e.$Ow=i=Je([Ve(0,$.$_j),Ve(1,T.$$i)],i)}),define(Oe[184],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,v.$Ei)("IUriIdentityService")}),define(Oe[185],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Pw=void 0,e.$Pw=(0,v.$Ei)("editSessionIdentityService");var R;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Oe[186],Ne([1,0,15]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=R,e.$fN=P,e.$gN=O,e.$hN=T,e.$iN=A;function R($){return $.scheme!==v.Schemas.file&&$.scheme!==v.Schemas.vscodeRemote}function P($){if($.folders.length)return $.folders.every(s=>R(s.uri))?$.folders[0].uri:void 0;if($.configuration&&R($.configuration))return $.configuration}function O($){return P($)?.scheme}function T($){return P($)?.authority}function A($){return P($)!==void 0}}),define(Oe[49],Ne([1,0,9,19,58,23,2,3,15]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Yi=e.$Xi=e.WorkbenchState=e.$Ri=e.$Qi=e.$Ni=void 0,e.$Oi=s,e.$Pi=k,e.$Si=y,e.$Ti=a,e.$Ui=S,e.$Vi=r,e.$Wi=o,e.$Zi=i,e.$5i=n,e.$6i=t,e.$8i=g,e.$9i=u,e.$0i=m,e.$Ni=(0,A.$Ei)("contextService");function s(p){const h=p;return typeof h?.id=="string"&&T.URI.isUri(h.uri)}function k(p){return typeof p?.id=="string"&&!s(p)&&!a(p)}e.$Qi={id:"ext-dev"},e.$Ri={id:"empty-window"};function y(p,h){if(typeof p=="string"||typeof p>"u")return typeof p=="string"?{id:(0,R.$nc)(p)}:h?e.$Qi:e.$Ri;const E=p;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function a(p){const h=p;return typeof h?.id=="string"&&T.URI.isUri(h.configPath)}function S(p){const h=p;if(h?.uri)return{id:h.id,uri:T.URI.revive(h.uri)};const E=p;if(E?.configPath)return{id:E.id,configPath:T.URI.revive(E.configPath)};if(p?.id)return{id:p.id}}var d;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(p){const h=p;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function o(p){const h=p;return!!(h&&typeof h=="object"&&T.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class c{constructor(h,E,D,w,I){this.h=h,this.j=D,this.k=w,this.l=I,this.c=P.$Ki.forUris(this.l,()=>!0),this.folders=E}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=P.$Ki.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Xi=c;class l{constructor(h,E){this.raw=E,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,O.$fh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Yi=l;function i(p){return new l({uri:p,index:0,name:(0,O.$bh)(p)},{uri:p.toString()})}e.$1i="code-workspace",e.$2i=`.${e.$1i}`,e.$3i=[{name:(0,v.localize)(10983,null),extensions:[e.$1i]}],e.$4i="workspace.json";function n(p,h){return O.$9g.isEqualOrParent(p,h.untitledWorkspacesHome)}function t(p){let h;return T.URI.isUri(p)?h=p:h=p.configuration,h?.scheme===$.Schemas.tmp}e.$7i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function g(p){return p.id===e.$7i}function u(p,h){return!n(p,h)&&!t(p)}function m(p){return(typeof p=="string"?(0,R.$oc)(p):(0,O.$dh)(p))===e.$2i}}),define(Oe[113],Ne([1,0,75,6,4,23,2,9,106,29,3,11,49,28,184,10,37,12,14]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=n,e.$Ml=t,e.$Nl=g;var i;(function(p){p.Settings="settings",p.Keybindings="keybindings",p.Snippets="snippets",p.Tasks="tasks",p.Extensions="extensions",p.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(p){const h=p;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&T.URI.isUri(h.location)&&T.URI.isUri(h.globalStorageHome)&&T.URI.isUri(h.settingsResource)&&T.URI.isUri(h.keybindingsResource)&&T.URI.isUri(h.tasksResource)&&T.URI.isUri(h.snippetsHome)&&T.URI.isUri(h.extensionsResource))}e.$Ll=(0,k.$Ei)("IUserDataProfilesService");function t(p,h){return{id:p.id,isDefault:p.isDefault,name:p.name,shortName:p.shortName,icon:p.icon,location:T.URI.revive(p.location).with({scheme:h}),globalStorageHome:T.URI.revive(p.globalStorageHome).with({scheme:h}),settingsResource:T.URI.revive(p.settingsResource).with({scheme:h}),keybindingsResource:T.URI.revive(p.keybindingsResource).with({scheme:h}),tasksResource:T.URI.revive(p.tasksResource).with({scheme:h}),snippetsHome:T.URI.revive(p.snippetsHome).with({scheme:h}),extensionsResource:T.URI.revive(p.extensionsResource).with({scheme:h}),cacheHome:T.URI.revive(p.cacheHome).with({scheme:h}),useDefaultFlags:p.useDefaultFlags,isTransient:p.isTransient}}function g(p,h,E,D,w,I){return{id:p,name:h,location:E,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:I&&w?.useDefaultFlags?.globalState?I.globalStorageHome:(0,O.$fh)(E,"globalStorage"),settingsResource:I&&w?.useDefaultFlags?.settings?I.settingsResource:(0,O.$fh)(E,"settings.json"),keybindingsResource:I&&w?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,O.$fh)(E,"keybindings.json"),tasksResource:I&&w?.useDefaultFlags?.tasks?I.tasksResource:(0,O.$fh)(E,"tasks.json"),snippetsHome:I&&w?.useDefaultFlags?.snippets?I.snippetsHome:(0,O.$fh)(E,"snippets"),extensionsResource:I&&w?.useDefaultFlags?.extensions?I.extensionsResource:(0,O.$fh)(E,"extensions.json"),cacheHome:(0,O.$fh)(D,p),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let u=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,E,D,w){super(),this.t=h,this.u=E,this.w=D,this.y=w,this.f=!0,this.h=this.B(new R.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new S.$Ac,workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$fh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$fh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),E=[h];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,l.$eg)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}E.push(g((0,O.$ch)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},h))}}catch(I){this.y.error(I)}const D=new S.$Ac,w=new Map;if(E.length)try{const I=this.Q();if(I.workspaces)for(const[C,f]of Object.entries(I.workspaces)){const b=T.URI.parse(C),M=E.find(N=>N.id===f);M&&D.set(b,M)}if(I.emptyWindows)for(const[C,f]of Object.entries(I.emptyWindows)){const b=E.find(M=>M.id===f);b&&w.set(C,b)}}catch(I){this.y.error(I)}this.z={profiles:E,workspaces:D,emptyWindows:w}}return this.z}D(){const h=g("__default__profile__",(0,A.localize)(11030,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const E="Temp",D=new RegExp(`${(0,c.$hf)(E)}\\s(\\d+)`);let w=0;for(const C of this.profiles){const f=D.exec(C.name),b=f?parseInt(f[1]):0;w=b>w?b:w}const I=`${E} ${w+1}`;return this.createProfile((0,v.$sj)((0,o.$1g)()).toString(16),I,{transient:!0},h)}async createNamedProfile(h,E,D){return this.createProfile((0,v.$sj)((0,o.$1g)()).toString(16),h,E,D)}async createProfile(h,E,D,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(h,E,D);return w&&await this.setProfileForWorkspace(w,I),I}async F(h,E,D){if(!(0,l.$eg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(E);return w||(w=(async()=>{try{if(this.profiles.find(b=>b.name===E||b.id===h))throw new Error(`Profile with ${E} name already exists`);const C=g(h,E,(0,O.$fh)(this.profilesHome,h),this.g,D,this.defaultProfile);await this.u.createFolder(C.location);const f=[];return this.j.fire({profile:C,join(b){f.push(b)}}),await r.Promises.settled(f),this.I([C],[],[]),C}finally{this.r.delete(E)}})(),this.r.set(E,w)),w}async updateProfile(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(w=>w.id===h.id);if(!D)throw new Error(`Profile '${h.name}' does not exist`);return D=g(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(w=>w.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);const D=[];this.m.fire({profile:E,join(w){D.push(w)}});try{await Promise.allSettled(D)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(w){(0,s.$ql)(w)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(w=>w.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(h,D)}unsetWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(h.map(E=>this.removeProfile(E)))}getProfileForWorkspace(h){const E=this.G(h),D=T.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,a.$Oi)(h)?this.s.folders.get(h.uri):(0,a.$Ti)(h)?this.s.workspaces.get(h.configPath):this.s.emptyWindows.get(h.id))}G(h){return(0,a.$Oi)(h)?h.uri:(0,a.$Ti)(h)?h.configPath:h.id}H(h){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,h.location)))}I(h,E,D){const w=[...this.profiles,...h],I=[],C=this.s.profiles;this.s.profiles=[];for(let f of w){if(f.isDefault||E.some(M=>f.id===M.id))continue;f=D.find(M=>f.id===M.id)??f;const b=C.find(M=>f.id===M.id);if(f.isTransient)this.s.profiles.push(f);else{if(b){for(const[M,N]of this.s.emptyWindows.entries())if(f.id===N.id){this.L({id:M},f);break}for(const[M,N]of this.s.workspaces.entries())if(f.id===N.id){this.L({id:"",configPath:M},f);break}for(const[M,N]of this.s.folders.entries())if(f.id===N.id){this.L({id:"",uri:M},f);break}}I.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.P(I),this.z=void 0,this.J(h,E,D)}J(h,E,D){this.h.fire({added:h,removed:E,updated:D,all:this.profiles})}L(h,E,D){if(D=E?.isTransient?!0:D,D)(0,a.$Oi)(h)?(this.s.folders.delete(h.uri),E&&this.s.folders.set(h.uri,E)):(0,a.$Ti)(h)?(this.s.workspaces.delete(h.configPath),E&&this.s.workspaces.set(h.configPath,E)):(this.s.emptyWindows.delete(h.id),E&&this.s.emptyWindows.set(h.id,E));else{this.L(h,void 0,!0);const w=this.G(h);T.URI.isUri(w)?(this.C.workspaces.delete(w),E&&this.C.workspaces.set(w,E)):(this.C.emptyWindows.delete(w),E&&this.C.emptyWindows.set(w,E)),this.M()}}M(){const h={};for(const[D,w]of this.C.workspaces.entries())h[D.toString()]=w.id;const E={};for(const[D,w]of this.C.emptyWindows.entries())E[D.toString()]=w.id;this.R({workspaces:h,emptyWindows:E}),this.z=void 0}N(h){const E={},D=this.D();if(h.workspaces)for(const[I,C]of Object.entries(h.workspaces)){const f=T.URI.parse(C);E[I]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}const w={};if(h.emptyWindows)for(const[I,C]of Object.entries(h.emptyWindows)){const f=T.URI.parse(C);w[I]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}return{workspaces:E,emptyWindows:w}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Ol=u,e.$Ol=u=Je([Ve(0,$.$Li),Ve(1,s.$_k),Ve(2,d.$Jl),Ve(3,y.$_j)],u);class m extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Pl=m}),define(Oe[187],Ne([1,0,10,6,4,64,14,152,3,113]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$jq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hq=e.$gq=e.$fq=void 0,e.$iq=S,e.$kq=r,e.$mq=c,e.$fq="__$__isNewStorageMarker",e.$gq="__$__targetStorageMarker",e.$hq=(0,$.$Ei)("storageService");var k;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(k||(e.WillSaveStateReason=k={}));var y;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var a;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(a||(e.StorageTarget=a={}));function S(l){const i=l.get(e.$gq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends P.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new R.$oe),this.c=this.B(new R.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$le),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return R.Event.filter(this.b.event,g=>g.scope===i&&(n===void 0||g.key===n),t)}n(){this.j.value=(0,v.$Uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:g}=n;if(t===e.$gq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:g})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,g,u=!1){if((0,T.$ng)(n)){this.remove(i,t,u);return}this.y(()=>{this.z(i,t,g),this.P(t)?.set(i,n,u)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],g=this.J(i);for(const u of Object.keys(g))g[u]===n&&t.push(u);return t}z(i,n,t,g=!1){const u=this.J(n);typeof t=="number"?u[i]!==t&&(u[i]=t,this.P(n)?.set(e.$gq,JSON.stringify(u),g)):typeof u[i]=="number"&&(delete u[i],this.P(n)?.set(e.$gq,JSON.stringify(u),g))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?S(n):Object.create(null)}isNew(i){return this.getBoolean(e.$fq,i)===!0}async flush(i=k.NONE){this.f.fire({reason:i});const n=this.P(y.APPLICATION),t=this.P(y.PROFILE),g=this.P(y.WORKSPACE);switch(i){case k.NONE:await v.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await v.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,n=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return c(i,n,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(k.NONE),(0,s.$Kl)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const g=new Set;for(const[u,m]of i)g.add(u),n.get(u)!==m&&this.u(t,{key:u,external:!0});for(const[u]of n.items)g.has(u)||this.u(t,{key:u,external:!0})})}}e.$jq=d;function r(l){return l.isDefault||!!l.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new A.$dq(new A.$eq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new A.$dq(new A.$eq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new A.$dq(new A.$eq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$lq=o;async function c(l,i,n,t,g,u){const m=b=>{try{return JSON.parse(b)}catch{return b}},p=new Map,h=new Map;l.forEach((b,M)=>{p.set(M,b),h.set(M,m(b))});const E=new Map,D=new Map;i.forEach((b,M)=>{E.set(M,b),D.set(M,m(b))});const w=new Map,I=new Map;n.forEach((b,M)=>{w.set(M,b),I.set(M,m(b))}),console.group(t!==g?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const C=[];if(p.forEach((b,M)=>{C.push({key:M,value:b})}),console.table(C),console.groupEnd(),console.log(h),t!==g){console.group(`Storage: Profile (path: ${g}, profile specific)`);const b=[];E.forEach((M,N)=>{b.push({key:N,value:M})}),console.table(b),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${u})`);const f=[];w.forEach((b,M)=>{f.push({key:M,value:b})}),console.table(f),console.groupEnd(),console.log(I)}}),define(Oe[79],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0;class v{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const O=this.c++;return this.b.set(O,P),this.e(),O}get(P,O){return this.b.has(P)?this.b.get(P)[O]:void 0}delete(P){this.b.delete(P),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$epc=v}),define(Oe[50],Ne([1,0,15,23,29,3]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=e.$jpc=void 0;class T{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new R.$7g($=>{const s=this.b.get($.scheme);return!(s===void 0||s&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,s){s===null?this.b.delete($.scheme):this.b.set($.scheme,s)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$jpc=T,e.$kpc=(0,O.$Ei)("IExtHostFileSystemInfo")}),define(Oe[26],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=void 0,e.$xQ=(0,v.$Ei)("IExtHostInitDataService")}),define(Oe[188],Ne([1,0,9,11,172,26]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0;let T=class extends P.$HR{constructor($,s,k){const y=k.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",a=k.remote.isRemote?(0,v.localize)(10783,null):$?(0,v.localize)(10784,null):(0,v.localize)(10785,null);super(s.createLogger(y,{name:a}))}};e.$src=T,e.$src=T=Je([Ve(1,R.$ak),Ve(2,O.$xQ)],T)}),define(Oe[189],Ne([1,0,10]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=e.$2pc=void 0;class R{constructor(T,A,$){this.h=new Map,this.a=T,this.b=A,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new v.$Qh(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const k of s.values())k.complete()}catch(k){for(const y of s.values())y.error(k)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this.d}get(T,A){let $=this.f[T];return typeof $>"u"&&($=A),$}update(T,A){this.f[T]=A;const $=this.h.get(T);if($!==void 0)return $.p;const s=new v.$2h;return this.h.set(T,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$2pc=R;class P extends R{setKeysForSync(T){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},T)}constructor(T,A){super(T.identifier.value,!0,A),this.j=T}}e.$3pc=P}),define(Oe[190],Ne([1,0,6,2]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=void 0;class P{constructor(T){this.c=T,this.a=new v.$le,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$le,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(T,A,$,s){const y=this.c.getNotebookDocument(R.URI.revive(T)).acceptModelChanged(A.value,$,s);this.b.fire(y)}$acceptDirtyStateChanged(T,A){this.c.getNotebookDocument(R.URI.revive(T)).acceptDirty(A)}$acceptModelSaved(T){const A=this.c.getNotebookDocument(R.URI.revive(T));this.a.fire(A.apiNotebook)}}e.$Wqc=P}),define(Oe[16],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=void 0,e.$hQ=(0,v.$Ei)("IExtHostRpcService");class R{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$iQ=R}),define(Oe[191],Ne([1,0,18,6,4]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;class O{#e;constructor(A,$){this.disposables=new P.$Tc,this.a=v.$qn.toKey(A.identifier),this.#e=$,this.onDidChange=R.Event.map(R.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this.a),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(A){return this.#e.get(this.a,A)}store(A,$){return this.#e.store(this.a,A,$)}delete(A){return this.#e.delete(this.a,A)}}e.$_pc=O}),define(Oe[65],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=e.$zpc=void 0,e.$zpc=(0,v.$Ei)("IURITransformerService");class R{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.$Apc=R});var xt=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[114],Ne([1,0,9,14,2,4,3,30,29,15,42,164,35]),function(be,e,v,R,P,O,T,A,$,s,k,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$pG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$fG=e.EditorInputCapabilities=e.$eG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=void 0,e.$8F=r,e.$9F=o,e.$0F=c,e.$$F=l,e.$_F=i,e.$aG=n,e.$bG=t,e.$cG=g,e.$dG=u,e.$gG=w,e.$hG=C,e.$iG=f,e.$jG=b,e.$kG=M,e.$lG=N,e.$mG=F,e.$nG=W,e.$oG=ee,e.$qG=ce,e.$rG=ae,e.$sG=Ie,e.$tG=Fe,a=xt(a),e.$3F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$4F={id:"default",displayName:(0,v.localize)(12426,null),providerDisplayName:(0,v.localize)(12427,null)},e.$5F="workbench.editor.sidebysideEditor",e.$6F="workbench.editors.textDiffEditor",e.$7F="workbench.editors.binaryResourceDiffEditor";var S;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var d;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(Y){const q=Y;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function o(Y){const q=Y;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function c(Y,q,ne){for(const ye of ne.visibleEditorPanes)if(ye.group.id===q&&Y.matches(ye.input))return ye.getViewState()}function l(Y){if(w(Y))return!1;const q=Y;return P.URI.isUri(q?.resource)}function i(Y){if(w(Y))return!1;const q=Y;return q?.original!==void 0&&q.modified!==void 0}function n(Y){if(w(Y))return!1;const q=Y;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(Y){if(w(Y)||i(Y))return!1;const q=Y;return q?.primary!==void 0&&q.secondary!==void 0}function g(Y){if(w(Y))return!1;const q=Y;return q?q.resource===void 0||q.resource.scheme===s.Schemas.untitled||q.forceUntitled===!0:!1}function u(Y){if(w(Y))return!1;const q=Y;return P.URI.isUri(q?.base?.resource)&&P.URI.isUri(q?.input1?.resource)&&P.URI.isUri(q?.input2?.resource)&&P.URI.isUri(q?.result?.resource)}var m;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(m||(e.Verbosity=m={}));var p;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p||(e.SaveReason=p={}));class h{constructor(){this.a=new Map}registerSource(q,ne){let ye=this.a.get(q);return ye||(ye={source:q,label:ne},this.a.set(q,ye)),ye.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$eG=new h;var E;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends O.$Uc{}e.$fG=D;function w(Y){return Y instanceof D}function I(Y){const q=Y;return P.URI.isUri(q?.preferredResource)}function C(Y){const q=Y;return w(q?.primary)&&w(q?.secondary)}function f(Y){const q=Y;return w(q?.modified)&&w(q?.original)}function b(Y,q,ne,ye,le){return Fe(ye,[(0,y.$oj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(12428,null),run:()=>{const ve={...ne,limits:{size:Number.MAX_VALUE}};Y.openEditor(q,ve)}}),(0,y.$oj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(12429,null),run:()=>le.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}function M(Y){return w(Y?.editor)}function N(Y){const q=Y;return M(Y)&&q?.group!==void 0}function F(Y){const q=Y;return typeof q?.groupId=="number"&&w(q.editor)}function W(Y){return typeof Y?.groupId=="number"}var K;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(K||(e.EditorCloseContext=K={}));var L;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var Q;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(Q||(e.SideBySideEditor=Q={}));class X{getOriginalUri(q,ne){if(!q)return;if(u(q))return e.$pG.getOriginalUri(q.result,ne);if(ne?.supportSideBySide){const{primary:le,secondary:ve}=this.a(q);if(le&&ve){if(ne?.supportSideBySide===Q.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(ve,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===Q.ANY)return this.getOriginalUri(le,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(ve,{filterByScheme:ne.filterByScheme});q=ne.supportSideBySide===Q.PRIMARY?le:ve}}if(i(q)||n(q)||t(q)||u(q))return;const ye=I(q)?q.preferredResource:q.resource;return!ye||!ne||!ne.filterByScheme?ye:this.b(ye,ne.filterByScheme)}a(q){return C(q)||t(q)?{primary:q.primary,secondary:q.secondary}:f(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,ne){if(!q)return;if(u(q))return e.$pG.getCanonicalUri(q.result,ne);if(ne?.supportSideBySide){const{primary:le,secondary:ve}=this.a(q);if(le&&ve){if(ne?.supportSideBySide===Q.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(ve,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===Q.ANY)return this.getCanonicalUri(le,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(ve,{filterByScheme:ne.filterByScheme});q=ne.supportSideBySide===Q.PRIMARY?le:ve}}if(i(q)||n(q)||t(q)||u(q))return;const ye=q.resource;return!ye||!ne||!ne.filterByScheme?ye:this.b(ye,ne.filterByScheme)}b(q,ne){if(Array.isArray(ne)){if(ne.some(ye=>q.scheme===ye))return q}else if(ne===q.scheme)return q}}var ue;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ue||(e.EditorCloseMethod=ue={}));function ee(Y,q,ne,ye){if(!Y.isSticky(q))return!1;switch(ye.preventPinnedEditorClose){case"keyboardAndMouse":return ne===ue.MOUSE||ne===ue.KEYBOARD;case"mouse":return ne===ue.MOUSE;case"keyboard":return ne===ue.KEYBOARD}return!1}e.$pG=new X;var me;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(q){const ne=this.a=q.get(T.$Di);for(const[ye,le]of this.c)this.e(ye,le,ne);this.c.clear()}e(q,ne,ye){const le=ye.createInstance(ne);this.d.set(q,le)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,R.$pg)(this.b)}registerEditorSerializer(q,ne){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,ne,this.a):this.c.set(q,ne),(0,O.$Sc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}A.$qo.add(e.$3F.EditorFactory,new oe);async function ce(Y,q,ne){return!Y||!Y.length?[]:await Promise.all(Y.map(async ye=>{const le=P.URI.revive(ye.fileUri);if(!le){ne.info("Cannot resolve the path because it is not valid.",ye);return}if(!await q.canHandleResource(le)){ne.info("Cannot resolve the path because it cannot be handled",ye);return}let de=ye.exists,J=ye.type;if(typeof de!="boolean"||typeof J!="number")try{J=(await q.stat(le)).isDirectory?$.FileType.Directory:$.FileType.Unknown,de=!0}catch(pe){ne.error(pe),de=!1}if(!de&&ye.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",ye);return}if(J===$.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",ye);return}const x={...ye.options,pinned:!0};return de?{resource:le,options:x}:{resource:le,options:x,forceUntitled:!0}}))}var we;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(we||(e.EditorsOrder=we={}));function ae(Y){const q=Y;if(!q)return!1;const ne=q;if(ne.modified)return ae(ne.modified);const ye=q;return!!(ye.contributionsState&&ye.viewState&&Array.isArray(ye.cursorState))}function Ie(Y){return(0,k.$qj)(Y)}function Fe(Y,q,ne){const ye=(0,k.$rj)(Y,q);return ye.forceMessage=ne?.forceMessage,ye.forceSeverity=ne?.forceSeverity,ye.allowDialog=ne?.allowDialog,ye}}),define(Oe[192],Ne([1,0,6,9,3,4,28,30,25,97,182]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BG=e.$AG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$zG=e.ViewContentGroups=e.$xG=e.ViewContainerLocation=e.Extensions=e.$wG=e.$vG=e.$uG=void 0,e.$yG=S,e.$uG="views",e.$vG=(0,R.localize)(12266,null),e.$wG=(0,k.$Ax)("default-view-icon",s.$4j.window,(0,R.localize)(12267,null));var y;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var a;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(a||(e.ViewContainerLocation=a={})),e.$xG=[a.Sidebar,a.Panel,a.AuxiliaryBar];function S(g){switch(g){case a.Sidebar:return"sidebar";case a.Panel:return"panel";case a.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new v.$le),this.onDidRegister=this.c.event,this.f=this.B(new v.$le),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,m,p){const h=this.get(u.id);if(h)return h;const E=u;return E.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,T.$xc)(this.g,m,[]).push(E),p?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:m}),E}deregisterViewContainer(u){for(const m of this.g.keys()){const p=this.g.get(m),h=p?.indexOf(u);if(h!==-1){p?.splice(h,1),p.length===0&&this.g.delete(m),this.f.fire({viewContainer:u,viewContainerLocation:m});return}}}get(u){return this.all.filter(m=>m.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(p=>p?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(m=>this.getViewContainerLocation(m)===u)}}A.$qo.add(y.ViewContainersRegistry,new d);var r;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(g,u){const m=g.group??r.More,p=u.group??r.More;return m!==p?m.localeCompare(p):(g.order??5)-(u.order??5)}class c extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new v.$le),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$le),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$le),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$le),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new T.$Hc}registerViews(u,m){this.registerViews2([{views:u,viewContainer:m}])}registerViews2(u){u.forEach(({views:m,viewContainer:p})=>this.r(m,p)),this.c.fire(u)}deregisterViews(u,m){const p=this.s(u,m);p.length&&this.f.fire({views:p,viewContainer:m})}moveViews(u,m){for(const p of this.m.keys())if(p!==m){const h=this.s(u,p);h.length&&(this.r(h,m),this.g.fire({views:h,from:p,to:m}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const m of this.j){const p=(this.m.get(m)||[]).filter(h=>h.id===u)[0];if(p)return p}return null}getViewContainer(u){for(const m of this.j)if((this.m.get(m)||[]).filter(h=>h.id===u)[0])return m;return null}registerViewWelcomeContent(u,m){return this.n.add(u,m),this.h.fire(u),(0,O.$Sc)(()=>{this.n.delete(u,m),this.h.fire(u)})}registerViewWelcomeContent2(u,m){const p=new Map;for(const[h,E]of m)this.n.add(u,E),p.set(h,(0,O.$Sc)(()=>{this.n.delete(u,E),this.h.fire(u)}));return this.h.fire(u),p}getViewWelcomeContent(u){const m=[];return this.n.forEach(u,p=>m.push(p)),m.sort(o)}r(u,m){let p=this.m.get(m);p||(p=[],this.m.set(m,p),this.j.push(m));for(const h of u){if(this.getView(h.id)!==null)throw new Error((0,R.localize)(12268,null,h.id));p.push(h)}}s(u,m){const p=this.m.get(m);if(!p)return[];const h=[],E=[];for(const D of p)u.includes(D)?h.push(D):E.push(D);return h.length&&(E.length?this.m.set(m,E):(this.m.delete(m),this.j.splice(this.j.indexOf(m),1))),h}}A.$qo.add(y.ViewsRegistry,new c),e.$zG=(0,P.$Ei)("viewDescriptorService");var l;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(l||(e.ViewVisibilityState=l={}));var i;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(u,m){this.c=!1,this.d=!1,(0,$.$go)(this,u),this.d=!!m,this.resolve=async p=>{if(m&&!this.c){const h=await m(p);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$AG=n;class t extends Error{constructor(u){super((0,R.localize)(12269,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$BG=t}),define(Oe[193],Ne([1,0,9,31]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=void 0,e.$FG=new R.$Vj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(8391,null)}),e.$GG=new R.$Vj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(8392,null)}),e.$HG=new R.$Vj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(8393,null)}),e.$IG=new R.$Vj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(8394,null)}),e.$JG=new R.$Vj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(8395,null)}),e.$KG=new R.$Vj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(8396,null)}),e.$LG=new R.$Vj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(8397,null)}),e.$MG=new R.$Vj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(8398,null)}),e.$NG=new R.$Vj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8399,null)}),e.$OG=new R.$Vj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(8400,null)}),e.$PG=new R.$Vj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(8401,null)}),e.$QG=new R.$Vj("inChat",!1,{type:"boolean",description:(0,v.localize)(8402,null)}),e.$RG=new R.$Vj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(8403,null)}),e.$SG=new R.$Vj("chatCursorAtTop",!1),e.$TG=new R.$Vj("chatInputHasAgent",!1),e.$UG=new R.$Vj("chatLocation",void 0),e.$VG=new R.$Vj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(8404,null)})}),define(Oe[115],Ne([1,0,283,10,21,6,39,4,40,143,12,31,18,3,11,108,176,187,193]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.ChatAgentLocation=void 0,e.$ZH=m,e.$1H=p;var n;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(h){function E(D){switch(D){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=E}(n||(e.ChatAgentLocation=n={})),e.$UH=(0,S.$Ei)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new O.$le,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=l.$RG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const I=this,C=D.slashCommands;D={...D,get slashCommands(){return C.filter(b=>!b.when||I.f.contextMatchesRules(y.$Cj.deserialize(b.when)))}};const f={data:D};return this.b.set(E,f),(0,A.$Sc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const w=this.b.get(E);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return w.data.isDefault&&this.e.set(!0),w.impl=D,this.d.fire(new g(w.data,D)),(0,A.$Sc)(()=>{w.impl=void 0,this.d.fire(void 0),w.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const w={data:E,impl:D};return this.b.set(E.id,w),this.d.fire(new g(E,D)),(0,A.$Sc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,w){return await this.g.get(E)?.(D,w)??[]}updateAgent(E,D){const w=this.b.get(E);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);w.data.metadata={...w.data.metadata,...D},this.d.fire(new g(w.data,w.impl))}getDefaultAgent(E){return(0,v.$eb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(y.$Cj.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=T.Iterable.find(this.b.values(),w=>m(w.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new g(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(w=>w.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,w,I,C){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return await f.impl.invoke(D,w,I,C)}async getFollowups(E,D,w,I,C){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(D,w,I,C):[]}};e.$VH=t,e.$VH=t=Je([Ve(0,y.$Wj)],t);class g{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,w,I){return this.d.invoke(E,D,w,I)}async provideFollowups(E,D,w,I){return this.d.provideFollowups?this.d.provideFollowups(E,D,w,I):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$WH=g,e.$XH=(0,S.$Ei)("chatAgentNameService");let u=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,w,I){if(this.g=D,this.h=w,this.i=I,this.e=(0,s.$6d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const C=I.get(i.b,c.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{I.remove(i.b,c.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,R.$Fh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,o.$aq)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const w=D.restrictedChatParticipants;this.e.set(w,void 0),this.i.store(i.b,JSON.stringify(w),c.StorageScope.APPLICATION,c.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),w=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&w}l(E,D){return this.e.map(I=>I[E.toLowerCase()]).map(I=>I?I.some(C=>(0,k.$Ff)(C,C.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$YH=u,e.$YH=u=i=Je([Ve(0,r.$sk),Ve(1,o.$7p),Ve(2,d.$_j),Ve(3,c.$hq)],u);function m(h){return`${h.extensionId.value}.${h.id}`}function p(h){const E="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new a.$qn("")),(0,$.$bi)(E)}}),define(Oe[194],Ne([1,0,2,32,3]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tH=e.$sH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$qH=O,e.$rH=T;function O(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof v.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(R.$Nt.isIRange)}function T(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(O)}var A;(function(k){k[k.Complete=1]="Complete",k[k.Partial=2]="Partial",k[k.Omitted=3]="Omitted"})(A||(e.ChatResponseReferencePartStatusKind=A={}));var $;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})($||(e.ChatAgentVoteDirection=$={}));var s;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(s||(e.ChatCopyKind=s={})),e.$sH=(0,P.$Ei)("IChatService"),e.$tH="accessibility.voice.keywordActivation"}),define(Oe[195],Ne([1,0,6,10,9]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5tb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new v.$le,this.o=new v.$le,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(A){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=A}onEvent(A){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=A}onRequest(A){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.u("response",A)}sendRequest(A,$,s,k){const y={command:A};if($&&Object.keys($).length>0&&(y.arguments=$),this.u("request",y),typeof k=="number"){const a=setTimeout(()=>{clearTimeout(a);const S=this.f.get(y.seq);if(S){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:A,message:(0,P.localize)(7487,null,k,A)};S(d)}},k)}return s&&this.f.set(y.seq,s),y.seq}acceptMessage(A){this.k?this.k(A):(this.m.push(A),this.m.length===1&&this.s())}q(A,$){return A.type!=="event"||$.type!=="event"}async s(){let A;for(;this.m.length;){if((!A||this.q(this.m[0],A))&&await(0,R.$Fh)(0),A=this.m.shift(),!A)return;switch(A.type){case"event":this.j?.(A);break;case"request":this.g?.(A);break;case"response":{const $=A,s=this.f.get($.request_seq);s&&(this.f.delete($.request_seq),s($));break}}}}u(A,$){$.type=A,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach(($,s)=>A.set(s,$)),await(0,R.$Fh)(500),A.forEach(($,s)=>{$({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$5tb=O}),define(Oe[80],Ne([1,0,2,9,31,3]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$NK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$LK=e.MemoryRangeType=e.State=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=void 0,e.$KK=$,e.$MK=k,R=We(R),e.$yJ="workbench.view.debug",e.$zJ="workbench.debug.variablesView",e.$AJ="workbench.debug.watchExpressionsView",e.$BJ="workbench.debug.callStackView",e.$CJ="workbench.debug.loadedScriptsView",e.$DJ="workbench.debug.breakPointsView",e.$EJ="workbench.debug.disassemblyView",e.$FJ="workbench.panel.repl",e.$GJ="workbench.panel.repl.view",e.$HJ=new P.$Vj("debugType",void 0,{type:"string",description:R.localize(7424,null)}),e.$IJ=new P.$Vj("debugConfigurationType",void 0,{type:"string",description:R.localize(7425,null)}),e.$JJ=new P.$Vj("debugState","inactive",{type:"string",description:R.localize(7426,null)}),e.$KJ="debugUx",e.$LJ=new P.$Vj(e.$KJ,"default",{type:"string",description:R.localize(7427,null)}),e.$MJ=new P.$Vj("hasDebugged",!1,{type:"boolean",description:R.localize(7428,null)}),e.$NJ=new P.$Vj("inDebugMode",!1,{type:"boolean",description:R.localize(7429,null)}),e.$OJ=new P.$Vj("inDebugRepl",!1,{type:"boolean",description:R.localize(7430,null)}),e.$PJ=new P.$Vj("breakpointWidgetVisible",!1,{type:"boolean",description:R.localize(7431,null)}),e.$QJ=new P.$Vj("inBreakpointWidget",!1,{type:"boolean",description:R.localize(7432,null)}),e.$RJ=new P.$Vj("breakpointsFocused",!0,{type:"boolean",description:R.localize(7433,null)}),e.$SJ=new P.$Vj("watchExpressionsFocused",!0,{type:"boolean",description:R.localize(7434,null)}),e.$TJ=new P.$Vj("watchExpressionsExist",!1,{type:"boolean",description:R.localize(7435,null)}),e.$UJ=new P.$Vj("variablesFocused",!0,{type:"boolean",description:R.localize(7436,null)}),e.$VJ=new P.$Vj("expressionSelected",!1,{type:"boolean",description:R.localize(7437,null)}),e.$WJ=new P.$Vj("breakpointInputFocused",!1,{type:"boolean",description:R.localize(7438,null)}),e.$XJ=new P.$Vj("callStackItemType",void 0,{type:"string",description:R.localize(7439,null)}),e.$YJ=new P.$Vj("callStackSessionIsAttach",!1,{type:"boolean",description:R.localize(7440,null)}),e.$ZJ=new P.$Vj("callStackItemStopped",!1,{type:"boolean",description:R.localize(7441,null)}),e.$1J=new P.$Vj("callStackSessionHasOneThread",!1,{type:"boolean",description:R.localize(7442,null)}),e.$2J=new P.$Vj("watchItemType",void 0,{type:"string",description:R.localize(7443,null)}),e.$3J=new P.$Vj("canViewMemory",void 0,{type:"boolean",description:R.localize(7444,null)}),e.$4J=new P.$Vj("breakpointItemType",void 0,{type:"string",description:R.localize(7445,null)}),e.$5J=new P.$Vj("breakpointItemBytes",void 0,{type:"boolean",description:R.localize(7446,null)}),e.$6J=new P.$Vj("breakpointHasModes",!1,{type:"boolean",description:R.localize(7447,null)}),e.$7J=new P.$Vj("breakpointSupportsCondition",!1,{type:"boolean",description:R.localize(7448,null)}),e.$8J=new P.$Vj("loadedScriptsSupported",!1,{type:"boolean",description:R.localize(7449,null)}),e.$9J=new P.$Vj("loadedScriptsItemType",void 0,{type:"string",description:R.localize(7450,null)}),e.$0J=new P.$Vj("focusedSessionIsAttach",!1,{type:"boolean",description:R.localize(7451,null)}),e.$$J=new P.$Vj("focusedSessionIsNoDebug",!1,{type:"boolean",description:R.localize(7452,null)}),e.$_J=new P.$Vj("stepBackSupported",!1,{type:"boolean",description:R.localize(7453,null)}),e.$aK=new P.$Vj("restartFrameSupported",!1,{type:"boolean",description:R.localize(7454,null)}),e.$bK=new P.$Vj("stackFrameSupportsRestart",!1,{type:"boolean",description:R.localize(7455,null)}),e.$cK=new P.$Vj("jumpToCursorSupported",!1,{type:"boolean",description:R.localize(7456,null)}),e.$dK=new P.$Vj("stepIntoTargetsSupported",!1,{type:"boolean",description:R.localize(7457,null)}),e.$eK=new P.$Vj("breakpointsExist",!1,{type:"boolean",description:R.localize(7458,null)}),e.$fK=new P.$Vj("debuggersAvailable",!1,{type:"boolean",description:R.localize(7459,null)}),e.$gK=new P.$Vj("debugExtensionAvailable",!0,{type:"boolean",description:R.localize(7460,null)}),e.$hK=new P.$Vj("debugProtocolVariableMenuContext",void 0,{type:"string",description:R.localize(7461,null)}),e.$iK=new P.$Vj("debugSetVariableSupported",!1,{type:"boolean",description:R.localize(7462,null)}),e.$jK=new P.$Vj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:R.localize(7463,null)}),e.$kK=new P.$Vj("debugSetExpressionSupported",!1,{type:"boolean",description:R.localize(7464,null)}),e.$lK=new P.$Vj("breakWhenValueChangesSupported",!1,{type:"boolean",description:R.localize(7465,null)}),e.$mK=new P.$Vj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:R.localize(7466,null)}),e.$nK=new P.$Vj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:R.localize(7467,null)}),e.$oK=new P.$Vj("terminateDebuggeeSupported",!1,{type:"boolean",description:R.localize(7468,null)}),e.$pK=new P.$Vj("suspendDebuggeeSupported",!1,{type:"boolean",description:R.localize(7469,null)}),e.$qK=new P.$Vj("variableEvaluateNamePresent",!1,{type:"boolean",description:R.localize(7470,null)}),e.$rK=new P.$Vj("variableIsReadonly",!1,{type:"boolean",description:R.localize(7471,null)}),e.$sK=new P.$Vj("variableValue",!1,{type:"string",description:R.localize(7472,null)}),e.$tK=new P.$Vj("variableType",!1,{type:"string",description:R.localize(7473,null)}),e.$uK=new P.$Vj("variableInterfaces",!1,{type:"array",description:R.localize(7474,null)}),e.$vK=new P.$Vj("variableName",!1,{type:"string",description:R.localize(7475,null)}),e.$wK=new P.$Vj("variableLanguage",!1,{type:"string",description:R.localize(7476,null)}),e.$xK=new P.$Vj("variableExtensionId",!1,{type:"string",description:R.localize(7477,null)}),e.$yK=new P.$Vj("exceptionWidgetVisible",!1,{type:"boolean",description:R.localize(7478,null)}),e.$zK=new P.$Vj("multiSessionRepl",!1,{type:"boolean",description:R.localize(7479,null)}),e.$AK=new P.$Vj("multiSessionDebug",!1,{type:"boolean",description:R.localize(7480,null)}),e.$BK=new P.$Vj("disassembleRequestSupported",!1,{type:"boolean",description:R.localize(7481,null)}),e.$CK=new P.$Vj("disassemblyViewFocus",!1,{type:"boolean",description:R.localize(7482,null)}),e.$DK=new P.$Vj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:R.localize(7483,null)}),e.$EK=new P.$Vj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:R.localize(7484,null)});const T=i=>R.localize(7485,null,i);e.$FK=T,e.$GK="editor.contrib.debug",e.$HK="editor.contrib.breakpoint",e.$IK="debug",e.$JK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:R.localize(7486,null)};var A;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(A||(e.State=A={}));function $(i){switch(i){case A.Initializing:return"initializing";case A.Stopped:return"stopped";case A.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$LK="vscode-debug-memory";function k(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var a;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(a||(e.DebugConfigurationProviderTriggerKind=a={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$NK=(0,O.$Ei)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var c;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(c||(e.IDebugVisualizationTreeItem=c={}));var l;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:v.URI.revive(n.iconPath.light),dark:v.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(l||(e.IDebugVisualization=l={}))}),define(Oe[196],Ne([1,0,12,2,19,25,15,32,21,17]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fI=void 0,e.$6H=y,e.$7H=a,e.$8H=S,e.$9H=d,e.$0H=r,e.$$H=o,e.$_H=c,e.$aI=i,e.$bI=g,e.$cI=u,e.$dI=p,e.$eI=E;const k=/{([^}]+)}/g;function y(w,I,C){return w.replace(k,function(f,b){return I&&b.length>0&&b[0]!=="_"?f:C&&C.hasOwnProperty(b)?C[b]:f})}function a(w){const I={};for(const C of Object.keys(w))C.startsWith("!")||(I[C]=w[C]);return I}function S(w){return w.configuration.request==="attach"&&!d(w)&&(!w.parentSession||S(w.parentSession))}function d(w){let I=w.configuration.type;if(I)return I==="vslsShare"&&(I=w.configuration.adapterProxy.configuration.type),(0,v.$Ff)(I,"extensionhost")||(0,v.$Ff)(I,"pwa-extensionhost")?w:w.parentSession?d(w.parentSession):void 0}function r(w){return w.type&&(w.label||w.program||w.runtime)}function o(w,I,C){let f,b=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=M.exec(w);){const F=N.index+1,W=F+N[0].length;if(F<=I&&W>=C){f=N[0],b=F;break}}if(f){const F=/(\w|\p{L})+/gu;let W=null;for(;(W=F.exec(f))&&!(W.index+1+b+W[0].length>=C););W&&(f=f.substring(0,F.lastIndex))}return f?{start:b,end:b+f.length-1}:{start:0,end:0}}async function c(w,I,C,f){if(w.evaluatableExpressionProvider.has(I)){const b=w.evaluatableExpressionProvider.ordered(I),M=(0,s.$Gb)(await Promise.all(b.map(async N=>{try{return await N.provideEvaluatableExpression(I,C,f??$.CancellationToken.None)}catch{return}})));if(M.length>0){let N=M[0].expression;const F=M[0].range;return N||(N=I.getLineContent(C.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:N}}}else{const b=I.getLineContent(C.lineNumber),{start:M,end:N}=o(b,C.column,C.column),F=b.substring(M-1,N);return{matchingExpression:F,range:new A.$Nt(C.lineNumber,M,C.lineNumber,M+F.length)}}return null}const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(w){return!!(w&&w.match(l))}function n(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(i(w.path))return R.URI.parse(w.path);if((0,P.$ic)(w.path))return R.URI.file(w.path)}return w.path}function t(w){if(typeof w.path=="object"){const I=R.URI.revive(w.path);if(I)return I.scheme===T.Schemas.file?I.fsPath:I.toString()}return w.path}function g(w,I){const C=I?n:t,f=(0,O.$do)(w);return m(f,(b,M)=>{b&&M&&(M.path=C(M))}),f}function u(w,I){const C=I?n:t,f=(0,O.$do)(w);return m(f,(b,M)=>{!b&&M&&(M.path=C(M))}),f}function m(w,I){switch(w.type){case"event":{const C=w;switch(C.event){case"output":I(!1,C.body.source);break;case"loadedSource":I(!1,C.body.source);break;case"breakpoint":I(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=w;switch(C.command){case"setBreakpoints":I(!0,C.arguments.source);break;case"breakpointLocations":I(!0,C.arguments.source);break;case"source":I(!0,C.arguments.source);break;case"gotoTargets":I(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(f=>I(!1,f));break;default:break}break}case"response":{const C=w;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(f=>I(!1,f.source));break;case"loadedSources":C.body.sources.forEach(f=>I(!1,f));break;case"scopes":C.body.scopes.forEach(f=>I(!1,f.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(f=>I(!1,f.source));break;case"setBreakpoints":C.body.breakpoints.forEach(f=>I(!1,f.source));break;case"disassemble":C.body?.instructions.forEach(b=>I(!1,b.location));break;default:break}break}}}function p(w){return w.filter(I=>!I.presentation?.hidden).sort((I,C)=>I.presentation?C.presentation?I.presentation.group?C.presentation.group?I.presentation.group!==C.presentation.group?I.presentation.group.localeCompare(C.presentation.group):h(I.presentation.order,C.presentation.order):-1:C.presentation.group?1:h(I.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function h(w,I){return typeof w!="number"?typeof I!="number"?0:1:typeof I!="number"?-1:w-I}async function E(w,I){const C=w.getValue("debug.saveBeforeStart",{overrideIdentifier:I.activeTextEditorLanguageId});if(C!=="none"&&(await I.saveAll(),C==="allEditorsInActiveGroup")){const f=I.activeEditorPane;f&&f.input.resource?.scheme===T.Schemas.untitled&&await I.save({editor:f.input,groupId:f.group.id})}await w.reloadConfiguration()}const D=(w,I)=>!w||!I?w===I:w.name===I.name&&w.path===I.path&&w.sourceReference===I.sourceReference;e.$fI=D}),define(Oe[197],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VK=e.CellExecutionUpdateType=void 0;var R;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$VK=(0,v.$Ei)("INotebookExecutionService")}),define(Oe[198],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$YK=e.ProxyKernelState=e.$XK=void 0,e.$XK=100;var R;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(R||(e.ProxyKernelState=R={})),e.$YK=(0,v.$Ei)("INotebookKernelService"),e.$ZK=(0,v.$Ei)("INotebookKernelHistoryService")}),define(Oe[199],Ne([1,0,4,32,52,162,102]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d1b=void 0;class A extends v.$Uc{constructor(s,k,y){super(),this._source=s,this.b=k,this.c=y,this.a=void 0}f(s){const k=s.getLineCount();return new R.$Nt(1,1,k,this.g(s,k))}g(s,k){if(k<1||k>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const s=new O.$vD;s.acceptChunk(this._source);const k=s.finish(!0),{textBuffer:y,disposable:a}=k.create(P.DefaultEndOfLine.LF);this.b=y,this.B(a)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const k=new O.$vD;k.acceptChunk(s);const y=k.finish(!0),{textBuffer:a,disposable:S}=y.create(P.DefaultEndOfLine.LF);return this.B(S),a})),this.a}findInInputs(s){const y=new T.$jD(s,!1,!1,null).parseSearchRequest();if(!y)return[];const a=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(a,y,!0,5e3)}findInOutputs(s){const y=new T.$jD(s,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(a=>{const S=a.findMatchesLineByLine(this.f(a),y,!0,5e3);if(S.length!==0)return{textBuffer:a,matches:S}}).filter(a=>!!a):[]}}e.$d1b=A}),define(Oe[54],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5I=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(O){O.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var R;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class P{static fromExtHostTestItem(T,A,$=T.parent){if(T._isRoot)return new P([A]);const s=[T.id];for(let k=$;k&&k.id!==A;k=k.parent)s.push(k.id);return s.push(A),new P(s.reverse())}static isRoot(T){return!T.includes(v.Delimiter)}static root(T){const A=T.indexOf(v.Delimiter);return A===-1?T:T.slice(0,A)}static fromString(T){return new P(T.split(v.Delimiter))}static join(T,A){return new P([...T.path,A])}static joinToString(T,A){return T.toString()+v.Delimiter+A}static parentId(T){const A=T.lastIndexOf(v.Delimiter);return A===-1?void 0:T.slice(0,A)}static localId(T){const A=T.lastIndexOf(v.Delimiter);return A===-1?T:T.slice(A+v.Delimiter.length)}static isChild(T,A){return A[T.length]===v.Delimiter&&A.startsWith(T)}static compare(T,A){return T===A?R.IsSame:P.isChild(T,A)?R.IsChild:P.isChild(A,T)?R.IsParent:R.Disconnected}static getLengthOfCommonPrefix(T,A){if(T===0)return 0;let $=0;for(;$<T-1;){for(let s=1;s<T;s++){const k=A(s-1),y=A(s);if(k.path[$]!==y.path[$])return $}$++}return $}constructor(T,A=T.length){if(this.path=T,this.d=A,T.length===0||A<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let T=1;T<=this.d;T++)yield new P(this.path,T)}*idsToRoot(){for(let T=this.d;T>0;T--)yield new P(this.path,T)}compare(T){if(typeof T=="string")return P.compare(this.toString(),T);for(let A=0;A<T.d&&A<this.d;A++)if(T.path[A]!==this.path[A])return R.Disconnected;return T.d>this.d?R.IsChild:T.d<this.d?R.IsParent:R.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let T=1;T<this.d;T++)this.c+=v.Delimiter,this.c+=this.path[T]}return this.c}}e.$5I=P}),define(Oe[55],Ne([1,0,2,101,32,54]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$aJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$_I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$$I=e.$0I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$9I=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$8I=e.$7I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$6I=e.TestResultState=void 0;var T;(function(L){L[L.Unset=0]="Unset",L[L.Queued=1]="Queued",L[L.Running=2]="Running",L[L.Passed=3]="Passed",L[L.Failed=4]="Failed",L[L.Skipped=5]="Skipped",L[L.Errored=6]="Errored"})(T||(e.TestResultState=T={})),e.$6I={[T.Unset]:"unset",[T.Queued]:"queued",[T.Running]:"running",[T.Passed]:"passed",[T.Failed]:"failed",[T.Skipped]:"skipped",[T.Errored]:"errored"};var A;(function(L){L[L.Run=1]="Run",L[L.Debug=2]="Debug",L[L.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var $;(function(L){L[L.Run=2]="Run",L[L.Debug=4]="Debug",L[L.Coverage=8]="Coverage",L[L.HasNonDefaultProfile=16]="HasNonDefaultProfile",L[L.HasConfigurable=32]="HasConfigurable",L[L.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$7I=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const s=L=>"runId"in L;e.$8I=s;var k;(function(L){L.serialize=Q=>({range:Q.range.toJSON(),uri:Q.uri.toJSON()}),L.deserialize=(Q,X)=>({range:P.$Nt.lift(X.range),uri:Q.asCanonicalUri(v.URI.revive(X.uri))})})(k||(e.IRichLocation=k={}));var y;(function(L){L[L.Error=0]="Error",L[L.Output=1]="Output"})(y||(e.TestMessageType=y={}));var a;(function(L){L.serialize=Q=>({label:Q.label,uri:Q.uri?.toJSON(),position:Q.position?.toJSON()}),L.deserialize=(Q,X)=>({label:X.label,uri:X.uri?Q.asCanonicalUri(v.URI.revive(X.uri)):void 0,position:X.position?R.$Mt.lift(X.position):void 0})})(a||(e.ITestMessageStackFrame=a={}));var S;(function(L){L.serialize=Q=>({message:Q.message,type:y.Error,expected:Q.expected,actual:Q.actual,contextValue:Q.contextValue,location:Q.location&&k.serialize(Q.location),stackTrace:Q.stackTrace?.map(a.serialize)}),L.deserialize=(Q,X)=>({message:X.message,type:y.Error,expected:X.expected,actual:X.actual,contextValue:X.contextValue,location:X.location&&k.deserialize(Q,X.location),stackTrace:X.stackTrace&&X.stackTrace.map(ue=>a.deserialize(Q,ue))})})(S||(e.ITestErrorMessage=S={}));const d=(L,Q)=>`${Q?"s":"e"}${L}`;e.$9I=d;var r;(function(L){L.serialize=Q=>({message:Q.message,type:y.Output,offset:Q.offset,length:Q.length,location:Q.location&&k.serialize(Q.location)}),L.deserialize=(Q,X)=>({message:X.message,type:y.Output,offset:X.offset,length:X.length,location:X.location&&k.deserialize(Q,X.location)})})(r||(e.ITestOutputMessage=r={}));var o;(function(L){L.serialize=Q=>Q.type===y.Error?S.serialize(Q):r.serialize(Q),L.deserialize=(Q,X)=>X.type===y.Error?S.deserialize(Q,X):r.deserialize(Q,X),L.isDiffable=Q=>Q.type===y.Error&&Q.actual!==void 0&&Q.expected!==void 0})(o||(e.ITestMessage=o={}));var c;(function(L){L.serializeWithoutMessages=Q=>({state:Q.state,duration:Q.duration,messages:[]}),L.serialize=Q=>({state:Q.state,duration:Q.duration,messages:Q.messages.map(o.serialize)}),L.deserialize=(Q,X)=>({state:X.state,duration:X.duration,messages:X.messages.map(ue=>o.deserialize(Q,ue))})})(c||(e.ITestTaskState=c={}));const l="\0",i=(L,Q)=>L+l+Q;e.$0I=i;const n=L=>{const Q=L.indexOf(l);return{ctrlId:L.slice(0,Q),tagId:L.slice(Q+1)}};e.$$I=n;var t;(function(L){L.serialize=Q=>({extId:Q.extId,label:Q.label,tags:Q.tags,busy:Q.busy,children:void 0,uri:Q.uri?.toJSON(),range:Q.range?.toJSON()||null,description:Q.description,error:Q.error,sortText:Q.sortText}),L.deserialize=(Q,X)=>({extId:X.extId,label:X.label,tags:X.tags,busy:X.busy,children:void 0,uri:X.uri?Q.asCanonicalUri(v.URI.revive(X.uri)):void 0,range:X.range?P.$Nt.lift(X.range):null,description:X.description,error:X.error,sortText:X.sortText})})(t||(e.ITestItem=t={}));var g;(function(L){L[L.NotExpandable=0]="NotExpandable",L[L.Expandable=1]="Expandable",L[L.BusyExpanding=2]="BusyExpanding",L[L.Expanded=3]="Expanded"})(g||(e.TestItemExpandState=g={}));var u;(function(L){L.serialize=Q=>({expand:Q.expand,item:t.serialize(Q.item)}),L.deserialize=(Q,X)=>({controllerId:O.$5I.root(X.item.extId),expand:X.expand,item:t.deserialize(Q,X.item)})})(u||(e.InternalTestItem=u={}));var m;(function(L){L.serialize=Q=>{let X;return Q.item&&(X={},Q.item.label!==void 0&&(X.label=Q.item.label),Q.item.tags!==void 0&&(X.tags=Q.item.tags),Q.item.busy!==void 0&&(X.busy=Q.item.busy),Q.item.uri!==void 0&&(X.uri=Q.item.uri?.toJSON()),Q.item.range!==void 0&&(X.range=Q.item.range?.toJSON()),Q.item.description!==void 0&&(X.description=Q.item.description),Q.item.error!==void 0&&(X.error=Q.item.error),Q.item.sortText!==void 0&&(X.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:X}},L.deserialize=Q=>{let X;return Q.item&&(X={},Q.item.label!==void 0&&(X.label=Q.item.label),Q.item.tags!==void 0&&(X.tags=Q.item.tags),Q.item.busy!==void 0&&(X.busy=Q.item.busy),Q.item.range!==void 0&&(X.range=Q.item.range?P.$Nt.lift(Q.item.range):null),Q.item.description!==void 0&&(X.description=Q.item.description),Q.item.error!==void 0&&(X.error=Q.item.error),Q.item.sortText!==void 0&&(X.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:X}}})(m||(e.ITestItemUpdate=m={}));const p=(L,Q)=>{Q.expand!==void 0&&(L.expand=Q.expand),Q.item!==void 0&&(L.item=L.item?Object.assign(L.item,Q.item):Q.item)};e.$_I=p;var h;(function(L){L.serializeWithoutMessages=Q=>({...u.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(c.serializeWithoutMessages)}),L.serialize=Q=>({...u.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(c.serialize)}),L.deserialize=(Q,X)=>({...u.deserialize(Q,X),ownComputedState:X.ownComputedState,computedState:X.computedState,tasks:X.tasks.map(ue=>c.deserialize(Q,ue)),retired:!0})})(h||(e.TestResultItem=h={}));var E;(function(L){L.empty=()=>({covered:0,total:0}),L.sum=(Q,X)=>{Q.covered+=X.covered,Q.total+=X.total}})(E||(e.ICoverageCount=E={}));var D;(function(L){L.serialize=Q=>({id:Q.id,statement:Q.statement,branch:Q.branch,declaration:Q.declaration,testIds:Q.testIds,uri:Q.uri.toJSON()}),L.deserialize=(Q,X)=>({id:X.id,statement:X.statement,branch:X.branch,declaration:X.declaration,testIds:X.testIds,uri:Q.asCanonicalUri(v.URI.revive(X.uri))}),L.empty=(Q,X)=>({id:Q,uri:X,statement:E.empty()})})(D||(e.IFileCoverage=D={}));function w(L){return{...L,location:L.location?.toJSON()}}function I(L){return L.location=L.location?R.$Mt.isIPosition(L.location)?R.$Mt.lift(L.location):P.$Nt.lift(L.location):void 0,L}e.$aJ=3;var C;(function(L){L[L.Declaration=0]="Declaration",L[L.Statement=1]="Statement",L[L.Branch=2]="Branch"})(C||(e.DetailType=C={}));var f;(function(L){L.serialize=Q=>Q.type===C.Declaration?M.serialize(Q):N.serialize(Q),L.deserialize=Q=>Q.type===C.Declaration?M.deserialize(Q):N.deserialize(Q)})(f||(e.CoverageDetails=f={}));var b;(function(L){L.serialize=w,L.deserialize=I})(b||(e.IBranchCoverage=b={}));var M;(function(L){L.serialize=w,L.deserialize=I})(M||(e.IDeclarationCoverage=M={}));var N;(function(L){L.serialize=Q=>({...w(Q),branches:Q.branches?.map(b.serialize)}),L.deserialize=Q=>({...I(Q),branches:Q.branches?.map(b.deserialize)})})(N||(e.IStatementCoverage=N={}));var F;(function(L){L[L.Add=0]="Add",L[L.Update=1]="Update",L[L.DocumentSynced=2]="DocumentSynced",L[L.Remove=3]="Remove",L[L.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",L[L.Retire=5]="Retire",L[L.AddTag=6]="AddTag",L[L.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var W;(function(L){L.deserialize=(Q,X)=>X.op===F.Add?{op:X.op,item:u.deserialize(Q,X.item)}:X.op===F.Update?{op:X.op,item:m.deserialize(X.item)}:X.op===F.DocumentSynced?{op:X.op,uri:Q.asCanonicalUri(v.URI.revive(X.uri)),docv:X.docv}:X,L.serialize=Q=>Q.op===F.Add?{op:Q.op,item:u.serialize(Q.item)}:Q.op===F.Update?{op:Q.op,item:m.serialize(Q.item)}:Q})(W||(e.TestsDiffOp=W={}));class K{constructor(Q){this.k=Q,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(Q){const X=this.w();for(const ue of Q)switch(ue.op){case F.Add:this.l(u.deserialize(this.k,ue.item),X);break;case F.Update:this.p(m.deserialize(ue.item),X);break;case F.Remove:this.q(ue.itemId,X);break;case F.Retire:this.v(ue.itemId);break;case F.IncrementPendingExtHosts:this.updatePendingRoots(ue.amount);break;case F.AddTag:this.c.set(ue.tag.id,ue.tag);break;case F.RemoveTag:this.c.delete(ue.id);break}X.complete?.()}l(Q,X){const ue=O.$5I.parentId(Q.item.extId)?.toString();let ee;if(!ue)ee=this.x(Q),this.g.add(ee),this.f.set(Q.item.extId,ee);else if(this.f.has(ue)){const me=this.f.get(ue);me.children.add(Q.item.extId),ee=this.x(Q,me),this.f.set(Q.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(Q)}`);return}return X.add?.(ee),Q.expand===g.BusyExpanding&&this.h++,ee}p(Q,X){const ue=this.f.get(Q.extId);if(ue)return Q.expand!==void 0&&(ue.expand===g.BusyExpanding&&this.h--,Q.expand===g.BusyExpanding&&this.h++),(0,e.$_I)(ue,Q),X.update?.(ue),ue}q(Q,X){const ue=this.f.get(Q);if(!ue)return;const ee=O.$5I.parentId(ue.item.extId)?.toString();ee?this.f.get(ee).children.delete(ue.item.extId):this.g.delete(ue);const me=[[Q]];for(;me.length;)for(const oe of me.pop()){const ce=this.f.get(oe);ce&&(me.push(ce.children),this.f.delete(oe),X.remove?.(ce,ce!==ue),ce.expand===g.BusyExpanding&&this.h--)}}v(Q){}updatePendingRoots(Q){this.j+=Q}w(){return{}}}e.$bJ=K}),define(Oe[200],Ne([1,0,98,9,55]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$IGb=e.$HGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var T;(function(y){y.List="list",y.Tree="true"})(T||(e.TestExplorerViewMode=T={}));var A;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(A||(e.TestExplorerViewSorting=A={}));const $={[P.TestResultState.Errored]:(0,R.localize)(3168,null),[P.TestResultState.Failed]:(0,R.localize)(3169,null),[P.TestResultState.Passed]:(0,R.localize)(3170,null),[P.TestResultState.Queued]:(0,R.localize)(3171,null),[P.TestResultState.Running]:(0,R.localize)(3172,null),[P.TestResultState.Skipped]:(0,R.localize)(3173,null),[P.TestResultState.Unset]:(0,R.localize)(3174,null)},s=(y,a)=>(0,R.localize)(3175,null,(0,v.$Yk)(y),$[a]);e.$HGb=s,e.$IGb={[P.TestRunProfileBitset.Debug]:(0,R.localize)(3176,null),[P.TestRunProfileBitset.Run]:(0,R.localize)(3177,null),[P.TestRunProfileBitset.Coverage]:(0,R.localize)(3178,null)};var k;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(k||(e.TestCommandId=k={}))}),define(Oe[81],Ne([1,0,10,6,4,61,55,54]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.TestItemEventOp=void 0;var $;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const s=(l,i)=>l===i,y=Object.entries({range:(l,i)=>l===i?!0:!l||!i?!1:l.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(l,i)=>!(l.length!==i.length||l.some(n=>!i.includes(n)))}),a=(l,i)=>{let n;for(const[t,g]of y)g(l[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class S extends P.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Qh(()=>this.flushDiff(),200)),this.g=this.B(new R.$le),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case T.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===T.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case T.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===T.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,T.$_I)(n.item,i.item);return}if(n.op===T.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,T.$_I)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===T.TestItemExpandState.Expandable){const g=this.M(t);return g.isOpen()?this.L(t,n-1):g.wait().then(()=>this.L(t,n-1))}else if(t.expand===T.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case $.RemoveChild:this.O(A.$5I.joinToString(i.fullId,n.id));break;case $.Upsert:this.z(n.item,i);break;case $.Bulk:for(const t of n.ops)this.w(i,t);break;case $.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(i);break;case $.SetProp:this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case $.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$ed)(n)}}y(i){i&&this.pushDiff({op:T.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=A.$5I.fromExtHostTestItem(i,this.root.id,n?.actual),g=this.s.getApiFor(i);g.parent&&g.parent!==n?.actual&&this.s.getChildren(g.parent).delete(i.id);let u=this.tree.get(t.toString());if(!u){u={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:T.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,n),this.pushDiff({op:T.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,n);return}if(u.actual===i){this.H(i,u,n);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const m=this.s.getChildren(u.actual),p=u.actual,h=a(this.s.toITestItem(p),this.s.toITestItem(i));this.s.getApiFor(p).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=T.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(i.tags,p.tags,t.toString()),delete h.tags),this.w(u,{op:$.SetProp,update:h})),this.I(i,u,n);for(const[D,w]of m)this.s.getChildren(i).get(w.id)||this.O(A.$5I.joinToString(t,w.id));const E=u.expandLevels;E!==void 0&&queueMicrotask(()=>{u.expand===T.TestItemExpandState.Expandable&&(u.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(u.actual.uri)}C(i,n,t){const g=new Set(n.map(u=>u.id));for(const u of i)g.delete(u.id)||this.D(u);this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(u=>(0,T.$0I)(this.s.controllerId,u.id))}}}),g.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:T.TestDiffOpType.AddTag,tag:{id:(0,T.$0I)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:T.TestDiffOpType.RemoveTag,id:(0,T.$0I)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const g=this.s.getApiFor(i);g.parent=t?.actual,g.listener=u=>this.w(n,u),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[g,u]of this.s.getChildren(i))this.z(u,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?T.TestItemExpandState.Expanded:T.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?T.TestItemExpandState.Expandable:T.TestItemExpandState.NotExpandable:n=T.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===T.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[g,u]of this.s.getChildren(i.actual)){const m=this.expand(A.$5I.joinToString(i.fullId,u.id),n);(0,v.$qh)(m)&&t.push(m)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new v.$Dh;return u.open(),u}i.expand=T.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new v.$Dh,t=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let g;try{g=this.h(i.actual===this.root?void 0:i.actual)}catch(u){t(u)}return(0,v.$qh)(g)?g.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:T.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const g=t.pop();if(g){this.s.getApiFor(g.actual).listener=void 0;for(const u of g.actual.tags)this.F(u.id);this.tree.delete(g.fullId.toString());for(const[u,m]of this.s.getChildren(g.actual))t.push(this.tree.get(A.$5I.joinToString(g.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$0P=S;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$$P=d;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$_P=r;class o extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$aQ=o;const c=(l,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(g,u){for(const m of t.values())g.call(u,m,this)},[Symbol.iterator](){return t.entries()},replace(g){const u=new Map,m=new Set(t.keys()),p={op:$.Bulk,ops:[]};for(const h of g){if(!(h instanceof n))throw new r(h.id);const E=i(h).controllerId;if(E!==l.controllerId)throw new o(h.id,E,l.controllerId);if(u.has(h.id))throw new d(h.id);u.set(h.id,h),m.delete(h.id),p.ops.push({op:$.Upsert,item:h})}for(const h of m.keys())p.ops.push({op:$.RemoveChild,id:h});l.listener?.(p),t=u},add(g){if(!(g instanceof n))throw new r(g.id);t.set(g.id,g),l.listener?.({op:$.Upsert,item:g})},delete(g){t.delete(g)&&l.listener?.({op:$.RemoveChild,id:g})},get(g){return t.get(g)},toJSON(){return Array.from(t.values())}}};e.$bQ=c}),define(Oe[116],Ne([1,0,81]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=void 0;const R=new WeakMap,P=(T,A)=>{const $={controllerId:A};return R.set(T,$),$};e.$cQ=P;const O=T=>{const A=R.get(T);if(!A)throw new v.$_P(T?.id||"<unknown>");return A};e.$dQ=O}),define(Oe[82],Ne([1,0,27,15,2]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BDb=e.$ADb=e.$zDb=void 0,e.$CDb=O,e.$DDb=A,e.$zDb="vscode-cdn.net",e.$ADb=`vscode-resource.${e.$zDb}`,e.$BDb=`'self' https://*.${e.$zDb}`;function O($,s){return $.scheme===R.Schemas.http||$.scheme===R.Schemas.https?$:(s&&s.authority&&s.isRemote&&$.scheme===R.Schemas.file&&($=P.URI.from({scheme:R.Schemas.vscodeRemote,authority:s.authority,path:$.path})),P.URI.from({scheme:R.Schemas.https,authority:`${$.scheme}+${T($.authority)}.${e.$ADb}`,path:$.path,fragment:$.fragment,query:$.query}))}function T($){return $.replace(/./g,s=>{const k=s.charCodeAt(0);return k>=v.CharCode.a&&k<=v.CharCode.z||k>=v.CharCode.A&&k<=v.CharCode.Z||k>=v.CharCode.Digit0&&k<=v.CharCode.Digit9?s:"-"+k.toString(16).padStart(4,"0")})}function A($){return $.replace(/-([0-9a-f]{4})/g,(s,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Oe[201],Ne([1,0,6,4,82]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=void 0;class O{constructor(A,$,s){this.d=A,this.e=$,this.f=s,this.a=0,this.b=new R.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const k=$.getVisibleTextEditors();for(const y of this.c.values())k.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,$,s,k,y){let a;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===A){a=i;break}if(!a)throw new Error("not a visible editor");const S=this,d=this.a++,r=new v.$le,o=new v.$le,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$CDb)(i,S.f)}get cspSource(){return P.$BDb}set options(i){this.b=i,S.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return S.d.$postMessage(d,i)}},l=new class{constructor(){this.editor=A,this.line=$,this.height=s,this.webview=c,this.onDidDispose=o.event}dispose(){S.c.has(d)&&(S.c.delete(d),S.d.$disposeEditorInset(d),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(d,a.id,a.value.document.uri,$+1,s,k||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:A,inset:l,onDidReceiveMessage:r}),l}$onDidDispose(A){const $=this.c.get(A);$&&$.inset.dispose()}$onDidReceiveMessage(A,$){this.c.get(A)?.onDidReceiveMessage.fire($)}}e.$xpc=O}),define(Oe[117],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=void 0,e.$JM="__",e.$KM=(0,v.$Ei)("IAuthenticationService"),e.$LM=(0,v.$Ei)("IAuthenticationExtensionsService")}),define(Oe[202],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Q=e.VariableKind=e.$8Q=void 0,e.$8Q=(0,v.$Ei)("configurationResolverService");var R;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(R||(e.VariableKind=R={}));class P extends Error{constructor(T,A){super(A),this.variable=T}}e.$9Q=P}),define(Oe[203],Ne([1,0,19,78,14,25,20,99,9,202,12]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=void 0,v=We(v),R=We(R),P=We(P),O=We(O);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,d,r,o){this.h=new Map,this.a=S,this.b=d,this.g=r,o&&(this.c=o.then(c=>this.i(c)))}i(S){if(T.$j){const d=Object.create(null);return Object.keys(S).forEach(r=>{d[r.toLowerCase()]=S[r]}),d}return S}resolveWithEnvironment(S,d,r){return this.l({env:this.i(S),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(S,d){const r={env:await this.c,userHome:await this.g};return this.l(r,S?S.uri:void 0,d)}async j(S,d,r,o){const c=O.$do(d);T.$j&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):T.$k&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):T.$l&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,S?S.uri:void 0,c,r,o)}async resolveAnyAsync(S,d,r){return this.j(S,d,r)}async resolveAnyMap(S,d,r){const o=new Map;return{newConfig:await this.j(S,d,r,o),resolvedVariables:o}}resolveWithInteractionReplace(S,d,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,d,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,d){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,d)}async l(S,d,r,o,c){if(P.$eg(r))return this.m(S,d,r,o,c);if(Array.isArray(r))return Promise.all(r.map(l=>this.l(S,d,l,o,c)));if(P.$gg(r)){const l=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(S,d,n,o,c),await this.l(S,d,r[n],o,c)]));for(const[n,t]of i)l[n]=t;return l}return r}m(S,d,r,o,c){return(0,k.$xf)(r,y.VARIABLE_REGEXP,async(l,i)=>{if(i.includes(y.VARIABLE_LHS))return l;let n=await this.o(S,l,i,d,o);return c?.set(i,n),n!==l&&P.$eg(n)&&n.match(y.VARIABLE_REGEXP)&&(n=await this.m(S,d,n,o,c)),n})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,d,r,o,c){let l;const i=r.split(":");i.length>1&&(r=i[0],l=i[1]);const n=u=>{const m=this.a.getFilePath();if(m)return(0,A.$Zw)(m);throw new s.$9Q(u,(0,$.localize)(2066,null,d))},t=u=>{const m=n(u);if(this.a.getWorkspaceFolderPathForFile){const p=this.a.getWorkspaceFolderPathForFile();if(p)return(0,A.$Zw)(p)}throw new s.$9Q(u,(0,$.localize)(2067,null,d,v.$nc(m)))},g=u=>{if(l){const m=this.a.getFolderUri(l);if(m)return m;throw new s.$9Q(u,(0,$.localize)(2068,null,d,l))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new s.$9Q(u,(0,$.localize)(2069,null,d)):new s.$9Q(u,(0,$.localize)(2070,null,d))};switch(r){case"env":if(l){if(S.env){const u=S.env[T.$j?l.toLowerCase():l];if(P.$eg(u))return u}return""}throw new s.$9Q(s.VariableKind.Env,(0,$.localize)(2071,null,d));case"config":if(l){const u=this.a.getConfigurationValue(o,l);if(P.$ng(u))throw new s.$9Q(s.VariableKind.Config,(0,$.localize)(2072,null,d,l));if(P.$gg(u))throw new s.$9Q(s.VariableKind.Config,(0,$.localize)(2073,null,d,l));return u}throw new s.$9Q(s.VariableKind.Config,(0,$.localize)(2074,null,d));case"command":return this.p(s.VariableKind.Command,d,l,c,"command");case"input":return this.p(s.VariableKind.Input,d,l,c,"input");case"extensionInstallFolder":if(l){const u=await this.a.getExtension(l);if(!u)throw new s.$9Q(s.VariableKind.ExtensionInstallFolder,(0,$.localize)(2075,null,d,l));return this.n(u.extensionLocation)}throw new s.$9Q(s.VariableKind.ExtensionInstallFolder,(0,$.localize)(2076,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,A.$Zw)(this.n(g(s.VariableKind.WorkspaceFolder)));case"cwd":return o||l?(0,A.$Zw)(this.n(g(s.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.$Zw)(v.$nc(this.n(g(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new s.$9Q(s.VariableKind.UserHome,(0,$.localize)(2077,null,d))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new s.$9Q(s.VariableKind.LineNumber,(0,$.localize)(2078,null,d))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new s.$9Q(s.VariableKind.SelectedText,(0,$.localize)(2079,null,d))}case"file":return n(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$nc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||l?v.$lc(this.n(g(s.VariableKind.RelativeFile)),n(s.VariableKind.RelativeFile)):n(s.VariableKind.RelativeFile);case"relativeFileDirname":{const u=v.$mc(n(s.VariableKind.RelativeFileDirname));if(o||l){const m=v.$lc(this.n(g(s.VariableKind.RelativeFileDirname)),u);return m.length===0?".":m}return u}case"fileDirname":return v.$mc(n(s.VariableKind.FileDirname));case"fileExtname":return v.$oc(n(s.VariableKind.FileExtname));case"fileBasename":return v.$nc(n(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=v.$nc(n(s.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-v.$oc(u).length)}case"fileDirnameBasename":return v.$nc(v.$mc(n(s.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||d}case"execInstallFolder":{const u=this.a.getAppRoot();return u||d}case"pathSeparator":case"/":return v.sep;default:try{const u=l?`${r}:${l}`:r;return this.p(s.VariableKind.Unknown,d,u,c,void 0)}catch{return d}}}}p(S,d,r,o,c){if(r&&o){const l=c===void 0?o[r]:o[c+":"+r];if(typeof l=="string")return l;throw new s.$9Q(S,(0,$.localize)(2080,null,d))}return d}}e.$lR=y}),define(Oe[118],Ne([1,0,3,114]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$sE=void 0,e.$tE=s,e.$uE=a,e.$vE=S,e.$sE=(0,v.$Ei)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var A;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(A||(e.GroupsArrangement=A={}));var $;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function s(d){const r=d;return(0,R.$gG)(r?.editor)&&(0,R.$gG)(r?.replacement)}var k;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(k||(e.GroupsOrder=k={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function a(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function S(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Oe[204],Ne([1,0,3,118]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zE=e.$yE=e.$xE=e.$wE=void 0,e.$AE=P,e.$wE=(0,v.$Ei)("editorService"),e.$xE=-1,e.$yE=-2,e.$zE=-3;function P(O){const T=O;return typeof O=="number"||(0,R.$uE)(T)}}),define(Oe[205],Ne([1,0,3,106]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=void 0,e.$5M=(0,v.$Fi)(R.$Li)}),define(Oe[119],Ne([1,0,18,6,19,4,10]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=e.$Fdc=e.$Edc=e.$Ddc=void 0,P=We(P);class A{constructor(l,i){this.versionId=l,this.removedDueToLooping=i}}e.$Ddc=A;class ${static isHostExtension(l,i,n){if(i.getExtensionDescription(l))return!1;const t=n.getExtensionDescription(l);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(l,i){this.j=l,this.c=new R.$le,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new v.$sn,this.g=[],this.h=new Map;for(const l of this.e){if(this.f.has(l.identifier)){console.error("Extension `"+l.identifier.value+"` is already registered");continue}this.f.set(l.identifier,l),this.g.push(l);const i=this.j.readActivationEvents(l);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(l)}}set(l){return this.e=l,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(l,i){this.e=o(this.e,i),this.e=this.e.concat(l);const n=$.l(this.e);return this.e=o(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,n)}static l(l){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,p){this.addNode(m),this.addNode(p),this.c.has(m)?this.c.get(m).push(p):this.c.set(m,[p])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,p){const h=i.getArcs(m);for(let E=0;E<h.length;E++)if(!p.has(h[E]))return!1;return!0}getNodes(){return this.e}},n=new v.$sn;for(const m of l)if(n.set(m.identifier,m),m.extensionDependencies)for(const p of m.extensionDependencies)i.addArc(v.$qn.toKey(m.identifier),v.$qn.toKey(p));const t=new Set;i.getNodes().filter(m=>i.getArcs(m).length===0).forEach(m=>t.add(m));const g=i.getNodes().filter(m=>!t.has(m));let u;do{u=!1;for(let m=0;m<g.length;m++){const p=g[m];i.hasOnlyGoodArcs(p,t)&&(g.splice(m,1),m--,t.add(p),u=!0)}}while(u);return g.map(m=>n.get(m))}containsActivationEvent(l){return this.h.has(l)}containsExtension(l){return this.f.has(l)}getExtensionDescriptionsForActivationEvent(l){const i=this.h.get(l);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(l){const i=this.f.get(l);return i||void 0}getExtensionDescriptionByUUID(l){for(const i of this.g)if(i.uuid===l)return i}getExtensionDescriptionByIdOrUUID(l,i){return this.getExtensionDescription(l)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Edc=$;class s{constructor(l,i){this.versionId=l,this.extensions=i}}e.$Fdc=s;class k{constructor(l){this.d=new S,this.c=new $(l,[])}async acquireLock(l){const i=await this.d.acquire(l);return new y(this,i)}deltaExtensions(l,i,n){if(!l.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(l){return this.c.containsActivationEvent(l)}containsExtension(l){return this.c.containsExtension(l)}getExtensionDescriptionsForActivationEvent(l){return this.c.getExtensionDescriptionsForActivationEvent(l)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(l){return this.c.getExtensionDescription(l)}getExtensionDescriptionByUUID(l){return this.c.getExtensionDescriptionByUUID(l)}getExtensionDescriptionByIdOrUUID(l,i){return this.c.getExtensionDescriptionByIdOrUUID(l,i)}}e.$Gdc=k;class y extends O.$Uc{constructor(l,i){super(),this.f=l,this.c=!1,this.B(i)}isAcquiredFor(l){return!this.c&&this.f===l}}e.$Hdc=y;class a{constructor(l){this.name=l;const i=(0,T.$xh)();this.promise=i.promise,this.c=i.resolve}resolve(l){this.c(l)}}class S{constructor(){this.c=[],this.d=!1}async acquire(l){const i=new a(l);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const l=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${l.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};l.resolve((0,O.$Sc)(t))}}var d;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(d||(d={}));function r(c,l){const i=c.isBuiltin?d.Builtin:c.isUnderDevelopment?d.Dev:d.User,n=l.isBuiltin?d.Builtin:l.isUnderDevelopment?d.Dev:d.User;if(i!==n)return i-n;const t=P.$gc.basename(c.extensionLocation.path),g=P.$gc.basename(l.extensionLocation.path);return t<g?-1:t>g?1:0}function o(c,l){const i=new v.$rn(l);return c.filter(n=>!i.has(n.identifier))}}),define(Oe[83],Ne([1,0,22]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$An=T,e.$Bn=A;var R;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(R||(e.UIKind=R={}));var P;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function T(s){const k=v.$Ne.alloc(1);switch(s){case O.Initialized:k.writeUInt8(1,0);break;case O.Ready:k.writeUInt8(2,0);break;case O.Terminate:k.writeUInt8(3,0);break}return k}function A(s,k){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return k===O.Initialized;case 2:return k===O.Ready;case 3:return k===O.Terminate;default:return!1}}var $;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Oe[66],Ne([1,0,3,6,112,11,26,83,62,63,25,2,4,9]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BQ=e.$zQ=e.$yQ=void 0,e.$AQ=o;let d=class extends a.$Uc{constructor(l,i){super(),this.s=l,this.t=i,this.a=this.B(new R.$le),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$le),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$Bp,name:(0,S.localize)(10778,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,O.$bk)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(l,i,n){const t=this.getTelemetryDetails(),g=new r(i,n,l,this.n,this.j,this.getBuiltInCommonProperties(l),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),u=this.r.get(l.identifier.value)??[];return this.r.set(l.identifier.value,[...u,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(l,i,n){this.f=l,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(l){const i=Object.create(null);switch(i["common.extname"]=`${l.publisher}.${l.name}`,i["common.extversion"]=l.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,$.$hn)((0,s.$Hp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const g=n.filter(u=>!u.isDisposed);g.length===0?this.r.delete(t):this.r.set(t,g)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(l,i){const t=this.r.get(l.value)?.filter(u=>!u.isDisposed);if(!t)return this.r.delete(l.value),!1;let g=!1;for(const u of t)u.ignoreUnhandledExtHostErrors||(u.logError(i),g=!0);return g}};e.$yQ=d,e.$yQ=d=Je([Ve(0,T.$xQ),Ve(1,O.$ak)],d);class r{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,i,n,t,g,u,m){this.g=n,this.h=t,this.i=g,this.j=u,this.a=new R.$le,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=l,this.d={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(l,i){this.e&&(this.d={isUsageEnabled:l,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(l){let i="properties"in l?l.properties??{}:l;return i=(0,s.$Kp)(i,[]),this.c&&(i=(0,k.$go)(i,this.c)),this.b||(i=(0,k.$go)(i,this.j)),"properties"in l?l.properties=i:l=i,l}k(l,i){this.f&&(this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(l,i),this.h.trace(l,i))}logUsage(l,i){this.d.isUsageEnabled&&this.k(l,i)}logError(l,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof l=="string")this.k(l,i);else{const n={name:l.name,message:l.message,stack:l.stack,cause:l.cause},t=(0,s.$Kp)(n,[]),g=new Error(t.message,{cause:t.cause});g.stack=t.stack,g.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(g,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const l=this,i={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.d.isUsageEnabled},get isErrorsEnabled(){return l.d.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.a.event.bind(l)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let l=this.f;this.f=void 0,Promise.resolve(l.flush()).then(l=void 0),this.e=void 0}else this.f=void 0}}e.$zQ=r;function o(c){const l=Date.now()-new Date(c).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.$BQ=(0,v.$Ei)("IExtHostTelemetry")}),define(Oe[24],Ne([1,0,6,2,178,111,18,3]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kH=e.ActivationKind=e.$hH=e.$gH=e.$dH=e.ExtensionHostStartup=e.$cH=e.$bH=e.$aH=e.$_G=void 0,e.$eH=a,e.$fH=S,e.$iH=c,e.$jH=l,e.$_G=Object.freeze({identifier:new T.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:T.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$aH="extensions.webWorker",e.$bH=(0,A.$Ei)("extensionService");class ${constructor(t){this.dependency=t}}e.$cH=$;var s;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class k{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,g,u){this.c=t,this.d=g.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$XG.createActivationEventsMap(this.d)}}set(t,g,u){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const m=[],p=[],h=[],E=[],D=y(this.d),w=y(g),I=(N,F)=>N.extensionLocation.toString()===F.extensionLocation.toString()||N.isBuiltin===F.isBuiltin||N.isUserBuiltin===F.isUserBuiltin||N.isUnderDevelopment===F.isUnderDevelopment;for(const N of this.d){const F=w.get(N.identifier);if(!F){m.push(N.identifier),D.delete(N.identifier);continue}if(!I(N,F)){m.push(N.identifier),D.delete(N.identifier);continue}}for(const N of g){const F=D.get(N.identifier);if(!F){p.push(N);continue}if(!I(F,N)){m.push(F.identifier),D.delete(F.identifier);continue}}const C=new T.$rn(this.e),f=new T.$rn(u);for(const N of this.e)f.has(N)||h.push(N);for(const N of u)C.has(N)||E.push(N);const b=O.$XG.createActivationEventsMap(p),M={versionId:t,toRemove:m,toAdd:p,addActivationEvents:b,myToRemove:h,myToAdd:E};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:g,toAdd:u,myToRemove:m,myToAdd:p}=t,h=new T.$rn(g),E=new T.$rn(m);for(let D=0;D<this.d.length;D++)h.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of u)this.d.push(D);for(const D of p)this.e.push(D);return this.f=null,t}containsExtension(t){for(const g of this.e)if(T.$qn.equals(g,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const g of this.d){if(!this.containsExtension(g.identifier))continue;const u=O.$XG.readActivationEvents(g);for(const m of u)t.add(m)}return t}}e.$dH=k;function y(n){const t=new T.$sn;for(const g of n)t.set(g.identifier,g);return t}function a(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function S(n,t){if(!a(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class d{constructor(t,g,u,m){this.codeLoadingTime=t,this.activateCallTime=g,this.activateResolvedTime=u,this.activationReason=m}}e.$gH=d;class r{constructor(t,g){this.description=t,this.value=g}}e.$hH=r;var o;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function c(n){return{type:n.isBuiltin?T.ExtensionType.System:T.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,P.$Qp)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function l(n,t){const g=(0,P.$Op)(n.manifest.publisher,n.manifest.name);return{id:g,identifier:new T.$qn(g),isBuiltin:n.type===T.ExtensionType.System,isUserBuiltin:n.type===T.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,g){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,g){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$kH=i}),define(Oe[206],Ne([1,0,13,4,119,18,24,11,10]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=e.$Xpc=e.$Wpc=e.$Vpc=e.$Upc=e.$Tpc=void 0,v=We(v);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(l,i,n,t){this.startup=l,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$Tpc=s;class k{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,i){return l===-1||i===-1?-1:i-l}build(){return new s(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Upc=k;class y{constructor(l,i,n,t,g,u){this.activationFailed=l,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=g,this.disposable=u}}e.$Vpc=y;class a extends y{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,R.$Uc.None)}}e.$Wpc=a;class S extends y{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,R.$Uc.None)}}e.$Xpc=S;class d extends y{constructor(l){super(!0,l,s.NONE,{activate:void 0,deactivate:void 0},void 0,R.$Uc.None)}}let r=class{constructor(l,i,n,t){this.g=t,this.a=l,this.b=i,this.c=n,this.d=new O.$sn,this.f=Object.create(null)}dispose(){for(const[l,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const l=[];for(const[i,n]of this.d)l.push(n.wait());await Promise.all(l)}isActivated(l){const i=this.d.get(l);return!!(i&&i.value)}getActivatedExtension(l){const i=this.d.get(l);if(!i||!i.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return i.value}async activateByEvent(l,i){if(this.f[l])return;const n=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,i){const n=this.a.getExtensionDescription(l);if(!n)throw new Error(`Extension '${l.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(l){const i=l.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(l){if(this.d.has(l.id))return this.d.get(l.id);if(this.l(l.id))return this.k(l,null,[],null);const i=this.a.getExtensionDescription(l.id);if(!i){const g=new Error(`Cannot activate unknown extension '${l.id.value}'`),u=this.k(l,null,[],new d(g));return this.c.onExtensionActivationError(l.id,g,new T.$cH(l.id.value)),u}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const g of t){if(this.m(g))continue;const u=this.d.get(g);if(u){n.push(u);continue}if(this.l(g)){n.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:l.reason}));continue}const m=this.a.getExtensionDescription(g);if(m){if(!m.main&&!m.browser)continue;n.push(this.j({id:m.identifier,reason:l.reason}));continue}const p=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${g}'`),E=this.k(l,i.displayName,[],new d(h));return this.c.onExtensionActivationError(i.identifier,h,new T.$cH(g)),E}return this.k(l,i.displayName,n,null)}k(l,i,n,t){const g=new o(l.id,i,l.reason,n,t,this.c,this.g);return this.d.set(l.id,g),g}l(l){return P.$Edc.isHostExtension(l,this.a,this.b)}m(l){const i=this.b.getExtensionDescription(l);return i?!i.main&&!i.browser:!1}};e.$Ypc=r,e.$Ypc=r=Je([Ve(3,A.$_j)],r);let o=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,i,n,t,g,u,m){this.c=l,this.d=i,this.f=n,this.g=t,this.h=g,this.j=u,this.k=m,this.a=new $.$Dh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const i=this.g[l];if(i.value&&!i.value.activationFailed){this.g.splice(l,1),l--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new d(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const i=new Error;if(l&&l.name&&(i.name=l.name),l&&l.message?i.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(i.stack=l.stack),this.h=new d(i),this.b&&v.$3(l))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};o=Je([Ve(6,A.$_j)],o)});var xt=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[120],Ne([1,0,9,13,35,110,77,30,18,108,111,104]),function(be,e,v,R,P,O,T,A,$,s,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=void 0,v=We(v),P=xt(P);const a=A.$qo.as(T.$ro.JSONContribution);class S{constructor(t,g,u){this.a=t,this.b=g,this.c=u}d(t,g){this.a({type:t,message:g,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$6G=S;class d{static a(t){const g=new $.$rn;for(let u=0,m=t.length;u<m;u++)g.add(t[u].description.identifier);return g}static compute(t,g){if(!t||!t.length)return new d(g,[]);if(!g||!g.length)return new d([],t);const u=this.a(t),m=this.a(g),p=g.filter(E=>!u.has(E.description.identifier)),h=t.filter(E=>!m.has(E.description.identifier));return new d(p,h)}constructor(t,g){this.added=t,this.removed=g}}e.$7G=d;class r{constructor(t,g){this.name=t,this.defaultExtensionKind=g,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,R.$Y)(t)}}}e.$8G=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(1831,null),v.localize(1832,null)]},c="vscode://schemas/vscode-extensions";e.$9G={properties:{engines:{type:"object",description:v.localize(1833,null),properties:{vscode:{type:"string",description:v.localize(1834,null),default:"^1.22.0"}}},publisher:{description:v.localize(1835,null),type:"string"},displayName:{description:v.localize(1836,null),type:"string"},categories:{description:v.localize(1837,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$pn},{type:"string",const:"Languages",deprecationMessage:v.localize(1838,null)}]}},galleryBanner:{type:"object",description:v.localize(1839,null),properties:{color:{description:v.localize(1840,null),type:"string"},theme:{description:v.localize(1841,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(1842,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(1843,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(1844,null)},enabledApiProposals:{markdownDescription:v.localize(1845,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(y.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:v.localize(1846,null),type:"string",enum:["none"],enumDescriptions:[v.localize(1847,null)]},activationEvents:{description:v.localize(1848,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(1849,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(1850,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(1851,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(1852,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(1853,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(1854,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(1855,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(1856,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(1857,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(1858,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(1859,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(1860,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(1861,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(1862,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(1863,null)},{label:"onUri",body:"onUri",description:v.localize(1864,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(1865,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(1866,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(1867,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(1868,null)},{label:"onRenderer",description:v.localize(1869,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(1870,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(1871,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(1872,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(1873,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(1874,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(1875,null)},{label:"*",description:v.localize(1876,null),body:"*"}]}},badges:{type:"array",description:v.localize(1877,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(1878,null)},href:{type:"string",description:v.localize(1879,null)},description:{type:"string",description:v.localize(1880,null)}}}},markdown:{type:"string",description:v.localize(1881,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(1882,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(1883,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$0o}},extensionPack:{description:v.localize(1884,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$0o}},extensionKind:{description:v.localize(1885,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(1886,null)},{body:["workspace"],description:v.localize(1887,null)},{body:["ui","workspace"],description:v.localize(1888,null)},{body:["workspace","ui"],description:v.localize(1889,null)},{body:[],description:v.localize(1890,null)}]},capabilities:{description:v.localize(1891,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(1892,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(1893,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1894,null),v.localize(1895,null),v.localize(1896,null)]},description:{type:"string",markdownDescription:v.localize(1897,null)}}},untrustedWorkspaces:{description:v.localize(1898,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(1899,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1900,null),v.localize(1901,null),v.localize(1902,null)]},restrictedConfigurations:{description:v.localize(1903,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(1904,null)}}}}},sponsor:{description:v.localize(1905,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(1906,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(1907,null),type:"string"},"vscode:uninstall":{description:v.localize(1908,null),type:"string"}}},icon:{type:"string",description:v.localize(1909,null)},l10n:{type:"string",description:v.localize(1910,null)},pricing:{type:"string",markdownDescription:v.localize(1911,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const g=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,g),t.activationEventsGenerator&&k.$XG.register(t.extensionPoint,t.activationEventsGenerator),e.$9G.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,a.registerSchema(c,e.$9G),g}getExtensionPoints(){return Array.from(this.a.values())}}e.$0G=l;const i={ExtensionsRegistry:"ExtensionsRegistry"};A.$qo.add(i.ExtensionsRegistry,new l),e.$$G=A.$qo.as(i.ExtensionsRegistry),a.registerSchema(c,e.$9G),a.registerSchema(s.$tk,{properties:{extensionEnabledApiProposals:{description:v.localize(1912,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Oe[207],Ne([1,0,6,39,4,12,9,18,3,11,24,120]),function(be,e,v,R,P,O,T,A,$,s,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nH=e.$mH=e.$lH=e.ChatMessageRole=void 0;var a;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(a||(e.ChatMessageRole=a={})),e.$lH=(0,$.$Ei)("ILanguageModelsService");const S={type:"object",properties:{vendor:{type:"string",description:(0,T.localize)(8381,null)}}};e.$mH=y.$$G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,T.localize)(8382,null),oneOf:[S,{type:"array",items:S}]},activationEventsGenerator:(r,o)=>{for(const c of r)o.push(`onLanguageModelChat:${c.vendor}`)}});let d=class{constructor(o,c){this.e=o,this.f=c,this.a=new P.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$le),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$mH.setHandler(l=>{this.c.clear();for(const n of l){if(!(0,k.$eH)(n.description,"chatProvider")){n.collector.error((0,T.localize)(8383,null));continue}for(const t of R.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,T.localize)(8384,null,t.vendor));continue}if((0,O.$cf)(t.vendor)){n.collector.error((0,T.localize)(8385,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,T.localize)(8386,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const l=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(l)}const c=[];for(const[l,i]of this.b)(o.vendor===void 0||i.metadata.vendor===o.vendor)&&(o.family===void 0||i.metadata.family===o.family)&&(o.version===void 0||i.metadata.version===o.version)&&(o.identifier===void 0||i.metadata.id===o.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>A.$qn.equals(n,o.extension)))&&c.push(l);return this.f.trace("[LM] selected language models",o,c),c}registerLanguageModelChat(o,c){if(this.f.trace("[LM] registering language model chat",o,c.metadata),!this.c.has(c.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${c.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,c),this.d.fire({added:[{identifier:o,metadata:c.metadata}]}),(0,P.$Sc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,c.metadata))})}async sendChatRequest(o,c,l,i,n){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.sendChatRequest(l,c,i,n)}computeTokenLength(o,c,l){const i=this.b.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideTokenCount(c,l)}};e.$nH=d,e.$nH=d=Je([Ve(0,k.$bH),Ve(1,s.$_j)],d)}),define(Oe[208],Ne([1,0,9,14,25,120,31,6]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=void 0,v=We(v),R=We(R),P=We(P);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(3898,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(3899,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(3900,null),default:""}}};var s;(function(a){function S(d,r,o){if(!d)return;const c=R.$eg(d.type)?d.type:void 0;if(!c||c.length===0){o.error(v.localize(3901,null));return}const l=[];if(Array.isArray(d.required))for(const i of d.required)R.$eg(i)&&l.push(i);return{extensionId:r.value,taskType:c,required:l,properties:d.properties?P.$do(d.properties):{},when:d.when?T.$Cj.deserialize(d.when):void 0}}a.from=S})(s||(s={}));const k=O.$$G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,S)=>{for(const d of a)d.type&&S.push(`onTaskType:${d.type}`)},jsonSchema:{description:v.localize(3902,null),type:"array",items:$}});class y{constructor(){this.d=new A.$le,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,d)=>{k.setHandler((r,o)=>{this.c=void 0;try{for(const c of o.removed){const l=c.value;for(const i of l)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of o.added){const l=c.value;for(const i of l){const n=s.from(i,c.description.identifier,c.collector);n&&(this.a[n.taskType]=n)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=P.$do(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},S.push(r)}this.c={oneOf:S}}return this.c}}e.$SI=new y}),define(Oe[209],Ne([1,0,9,14,23,25,31,208,43]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$3I=e.JsonSchemaVersion=e.ExecutionEngine=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$WI=e.ShellQuoting=e.$VI=e.$UI=e.$TI=void 0,v=We(v),R=We(R),P=We(P),O=We(O),e.$TI="settings",e.$UI=new T.$Vj("taskRunning",!1,v.localize(3886,null)),e.$VI=v.localize2(3888,"Tasks");var s;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$WI="$customized",function(L){function Q(X){if(!X)return L.Strong;switch(X.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=Q}(s||(e.ShellQuoting=s={}));var k;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var y;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(y||(e.RevealKind=y={})),function(L){function Q(X){switch(X.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=Q}(y||(e.RevealKind=y={}));var a;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(a||(e.RevealProblemKind=a={})),function(L){function Q(X){switch(X.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=Q}(a||(e.RevealProblemKind=a={}));var S;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(S||(e.PanelKind=S={})),function(L){function Q(X){switch(X.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=Q}(S||(e.PanelKind=S={}));var d;(function(L){L.defaults={echo:!0,reveal:y.Always,revealProblems:a.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(L){function Q(ue){switch(ue.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=Q;function X(ue){switch(ue){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=X}(r||(e.RuntimeType=r={}));var o;(function(L){function Q(X){return R.$eg(X)?X:X.value}L.value=Q})(o||(e.CommandString=o={}));var c;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function Q(ue){return ue===L.Clean._id||ue===L.Build._id||ue===L.Rebuild._id||ue===L.Test._id}L.is=Q;function X(ue){if(ue!==void 0)return R.$eg(ue)?Q(ue)?{_id:ue,isDefault:!1}:void 0:ue}L.from=X})(c||(e.TaskGroup=c={}));var l;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var i;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function Q(X){switch(X){case L.User:return $.ConfigurationTarget.USER;case L.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}L.toConfigurationTarget=Q})(i||(e.TaskSourceKind=i={}));var n;(function(L){L.parallel="parallel",L.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var g;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class u{constructor(Q,X,ue,ee,me,oe){this._label="",this._id=Q,X&&(this._label=X),ue&&(this.type=ue),this.runOptions=ee,this.configurationProperties=me,this._source=oe}getDefinition(Q){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const Q={folder:this.d(),id:this._id};return JSON.stringify(Q)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(Q,X=!1){if(Q===void 0)return!1;if(R.$eg(Q))return Q===this._label||Q===this.configurationProperties.identifier||X&&Q===this._id;const ue=this.getDefinition(!0);return ue!==void 0&&ue._key===Q._key}getQualifiedLabel(){const Q=this.getWorkspaceFolder();return Q?`${this._label} (${Q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(Q){this.c===void 0&&(this.c=[]),Q&&(this.c=this.c.concat(Q))}get taskLoadMessages(){return this.c}}e.$XI=u;class m extends u{constructor(Q,X,ue,ee,me,oe,ce,we){super(Q,ue,void 0,ce,we,X),this.command={},this._source=X,this.hasDefinedMatchers=oe,me&&(this.command=me)}clone(){return new m(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(Q=!1){if(Q&&this._source.customizes!==void 0)return this._source.customizes;{let X;switch(this.command?this.command.runtime:void 0){case r.Shell:X="shell";break;case r.Process:X="process";break;case r.CustomExecution:X="customExecution";break;case void 0:X="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:X,_key:this._id,id:this._id}}}static is(Q){return Q instanceof m}getMapKey(){const Q=this._source.config.workspaceFolder;return Q?`${Q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$TI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const Q=this.d();if(!Q)return;let X=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(X+=this._source.kind);const ue={type:e.$WI,folder:Q,id:X};return JSON.stringify(ue)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ch(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(Q){return new m(Q._id,Q._source,Q._label,Q.type,Q.command,Q.hasDefinedMatchers,Q.runOptions,Q.configurationProperties)}}e.$YI=m;class p extends u{constructor(Q,X,ue,ee,me,oe,ce){super(Q,ue,ee,oe,ce,X),this._source=X,this.configures=me}static is(Q){return Q instanceof p}f(Q){return Q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ch(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$TI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const Q=this.d();if(!Q)return;let X=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(X+=this._source.kind);const ue={type:e.$WI,folder:Q,id:X};return JSON.stringify(ue)}}e.$ZI=p;class h extends u{constructor(Q,X,ue,ee,me,oe,ce,we,ae){super(Q,ue,ee,we,ae,X),this.defines=me,this.hasDefinedMatchers=ce,this.command=oe,this.icon=ae.icon,this.hide=ae.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(Q){return Q instanceof h}getMapKey(){const Q=this._source.workspaceFolder;return Q?`${this._source.scope.toString()}|${Q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===l.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const Q={type:"contributed",scope:this._source.scope,id:this._id};return Q.folder=this.d(),JSON.stringify(Q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(Q){return new h(Q._id,Q._source,Q._label,Q.type,Q.defines,Q.command,Q.hasDefinedMatchers,Q.runOptions,Q.configurationProperties)}}e.$1I=h;class E extends u{constructor(Q,X,ue,ee,me,oe){super(Q,ue,ee,me,oe,X),this._source=X}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(Q){return Q instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(Q){return new E(Q._id,Q._source,Q._label,Q.type,Q.runOptions,Q.configurationProperties)}}e.$2I=E;var D;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(L){L._default=L.Terminal}(D||(e.ExecutionEngine=D={}));var w;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class I{constructor(Q){this.c=new Map;for(let X=0;X<Q.length;X++)this.c.set(Q[X].uri.toString(),X)}compare(Q,X){const ue=Q.getWorkspaceFolder(),ee=X.getWorkspaceFolder();if(ue&&ee){let me=this.c.get(ue.uri.toString());me=me===void 0?0:me+1;let oe=this.c.get(ee.uri.toString());return oe=oe===void 0?0:oe+1,me===oe?Q._label.localeCompare(X._label):me-oe}else return!ue&&ee?-1:ue&&!ee?1:0}}e.$3I=I;var C;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(C||(e.TaskEventKind=C={}));var f;(function(L){L.SingleRun="singleRun",L.Background="background"})(f||(e.TaskRunType=f={}));var b;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var M;(function(L){function Q(we){return{taskId:we._id,taskName:we.configurationProperties.name,runType:we.configurationProperties.isBackground?f.Background:f.SingleRun,group:we.configurationProperties.group,__task:we}}function X(we,ae,Ie){return{...Q(we),kind:C.Start,terminalId:ae,resolvedVariables:Ie}}L.start=X;function ue(we,ae,Ie){return{...Q(we),kind:C.ProcessStarted,terminalId:ae,processId:Ie}}L.processStarted=ue;function ee(we,ae,Ie){return{...Q(we),kind:C.ProcessEnded,terminalId:ae,exitCode:Ie}}L.processEnded=ee;function me(we,ae,Ie){return{...Q(we),kind:C.Terminated,exitReason:Ie,terminalId:ae}}L.terminated=me;function oe(we,ae,Ie){return{...Q(ae),kind:we,terminalId:Ie}}L.general=oe;function ce(){return{kind:C.Changed}}L.changed=ce})(M||(e.TaskEvent=M={}));var N;(function(L){function Q(ue){const ee=Object.keys(ue).sort();let me="";for(const oe of ee){let ce=ue[oe];ce instanceof Object?ce=Q(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),me+=oe+","+ce+","}return me}function X(ue){const me={_key:Q(ue),type:ue.taskType};return Object.assign(me,ue),me}L.create=X})(N||(e.KeyedTaskIdentifier=N={}));var F;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var W;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var K;(function(L){function Q(X,ue){const ee=A.$SI.get(X.type);if(ee===void 0){const we=O.$do(X);return delete we._key,N.create(we)}const me=Object.create(null);me.type=ee.taskType;const oe=new Set;ee.required.forEach(we=>oe.add(we));const ce=ee.properties;for(const we of Object.keys(ce)){const ae=X[we];if(ae!=null)me[we]=ae;else if(oe.has(we)){const Ie=ce[we];if(Ie.default!==void 0)me[we]=O.$do(Ie.default);else switch(Ie.type){case"boolean":me[we]=!1;break;case"number":case"integer":me[we]=0;break;case"string":me[we]="";break;default:ue.error(v.localize(3887,null,JSON.stringify(X,void 0,0),we));return}}}return N.create(me)}L.createTaskIdentifier=Q})(K||(e.TaskDefinition=K={}))}),define(Oe[210],Ne([1,0,13]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((T,A)=>{this.b=T,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(T){this.f||this.h||(this.f=!0,this.g=T,this.a&&this.b(T))}resolveErr(T){this.f||this.h||(this.h=!0,this.i=T,this.a?this.d(T):(0,v.$Y)(T))}then(T,A){return this.j().then(T,A)}catch(T){return this.j().then(void 0,T)}finally(T){return this.j().finally(T)}}e.$Idc=R;class P extends R{constructor(){super(),this.h=!0,this.i=new v.$4}}e.$Jdc=P}),define(Oe[38],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=e.$Tw=void 0,e.$Uw=P,e.$Vw=O;class v{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++v.count}}e.$Tw=v;const R=[];function P(A){const $=new v(A);return R[$.nid]=$,$}function O(A){return R[A].sid}class T{constructor($){this.value=$}}e.$Ww=T}),define(Oe[5],Ne([1,0,38]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=e.$HN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$GN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var T;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var A;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var $;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var s;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var k;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(k||(e.CandidatePortSource=k={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$GN=y;var a;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var S;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$HN={MainThreadAuthentication:(0,v.$Uw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Uw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Uw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Uw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Uw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Uw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Uw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Uw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Uw)("MainThreadCommands"),MainThreadComments:(0,v.$Uw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Uw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Uw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Uw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Uw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Uw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Uw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Uw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Uw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Uw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Uw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Uw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Uw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Uw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Uw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Uw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Uw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Uw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Uw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Uw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Uw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Uw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Uw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Uw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Uw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Uw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Uw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Uw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Uw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Uw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Uw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Uw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Uw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Uw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Uw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Uw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Uw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Uw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Uw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Uw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Uw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Uw)("MainThreadSCM"),MainThreadSearch:(0,v.$Uw)("MainThreadSearch"),MainThreadShare:(0,v.$Uw)("MainThreadShare"),MainThreadTask:(0,v.$Uw)("MainThreadTask"),MainThreadWindow:(0,v.$Uw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Uw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Uw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Uw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Uw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Uw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Uw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Uw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Uw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Uw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Uw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Uw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Uw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Uw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Uw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Uw)("MainThreadAiEmbeddingVector")},e.$IN={ExtHostCommands:(0,v.$Uw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Uw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Uw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Uw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Uw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Uw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Uw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Uw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Uw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Uw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Uw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Uw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Uw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Uw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Uw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Uw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Uw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Uw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Uw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Uw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Uw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Uw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Uw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Uw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Uw)("ExtHostSCM"),ExtHostSearch:(0,v.$Uw)("ExtHostSearch"),ExtHostTask:(0,v.$Uw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Uw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Uw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Uw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Uw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Uw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Uw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Uw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Uw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Uw)("ExtHostProgress"),ExtHostComments:(0,v.$Uw)("ExtHostComments"),ExtHostSecretState:(0,v.$Uw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Uw)("ExtHostStorage"),ExtHostUrls:(0,v.$Uw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Uw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Uw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Uw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Uw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Uw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Uw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Uw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Uw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Uw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Uw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Uw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Uw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Uw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Uw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Uw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Uw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Uw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Uw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Uw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Uw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Uw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Uw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Uw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Uw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Uw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Uw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Uw)("ExtHostLocalization")}}),define(Oe[84],Ne([1,0,3,11,5,16]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=e.$hpc=e.$gpc=void 0,P=We(P),e.$gpc=(0,v.$Ei)("IExtHostApiDeprecationService");let T=class{constructor($,s){this.c=s,this.a=new Set,this.b=$.getProxy(P.$HN.MainThreadTelemetry)}report($,s,k){const y=this.d($,s);this.a.has(y)||(this.a.add(y),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${k}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:$}))}d($,s){return`${$}-${s.identifier.value}`}};e.$hpc=T,e.$hpc=T=Je([Ve(0,O.$hQ),Ve(1,R.$_j)],T),e.$ipc=Object.freeze(new class{report(A,$,s){}})}),define(Oe[211],Ne([1,0,5]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=void 0;class R{constructor(O){const T=O.getProxy(v.$HN.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(A){return T.$writeText(A)}})}}e.$vpc=R}),define(Oe[212],Ne([1,0,25,5,26,16]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=void 0;let T=class{constructor(k,y){this.a=k.getProxy(R.$HN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(k,y){const a=this,S=console[k];Object.defineProperty(console,k,{set:()=>{},get:()=>function(){a.e(k,y,S,arguments)}})}e(k,y,a,S){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:$(S,this.b)}),this.c&&this.f(k,a,S)}};e.$rrc=T,e.$rrc=T=Je([Ve(0,O.$hQ),Ve(1,P.$xQ)],T);const A=1e5;function $(s,k){const y=[];if(s.length)for(let a=0;a<s.length;a++){let S=s[a];if(typeof S>"u")S="undefined";else if(S instanceof Error){const d=S;d.stack?S=d.stack:S=d.toString()}y.push(S)}if(k){const a=new Error().stack;a&&y.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,v.$io)(y);return a.length>A?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Oe[213],Ne([1,0,2,5,24]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;class O{constructor(A){this.a=A.getProxy(R.$HN.MainThreadDialogs)}showOpenDialog(A,$){return $?.allowUIResources&&(0,P.$fH)(A,"showLocal"),this.a.$showOpenDialog($).then(s=>s?s.map(k=>v.URI.revive(k)):void 0)}showSaveDialog(A){return this.a.$showSaveDialog(A).then($=>$?v.URI.revive($):void 0)}}e.$xqc=O}),define(Oe[214],Ne([1,0,21,6,4,5]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0;class T{constructor($){this.b=new Map,this.c=new R.$le,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(O.$HN.MainThreadEmbeddings)}registerEmbeddingsProvider($,s,k){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,s),this.b.set(y,{id:s,provider:k}),(0,P.$Sc)(()=>{this.d.delete(s),this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings($,s,k){k??=v.CancellationToken.None;let y=!1;typeof s=="string"&&(s=[s],y=!0);const a=await this.a.$computeEmbeddings($,s,k);if(a.length!==s.length)throw new Error;if(y){if(a.length!==1)throw new Error;return a[0]}return a}async $provideEmbeddings($,s,k){const y=this.b.get($);if(!y)return[];const a=await y.provider.provideEmbeddings(s,k);return a||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$Aqc=T}),define(Oe[215],Ne([1,0,4,5]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=void 0;class P{constructor(T){this.b=0,this.a=T.getProxy(R.$HN.MainThreadLabelService)}$registerResourceLabelFormatter(T){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,T),(0,v.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.$Rqc=P}),define(Oe[85],Ne([1,0,20,12,2,3,11,5,26,16]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=e.$aqc=void 0;let k=class{constructor(a,S,d){this.f=d,this.d=new Map,this.a=S.getProxy(A.$HN.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===v.$h}getMessage(a,S){const{message:d,args:r,comment:o}=S;if(this.c)return(0,R.$ef)(d,r??{});let c=d;o&&o.length>0&&(c+=`/${Array.isArray(o)?o.join(""):o}`);const l=this.d.get(a)?.contents[c];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,R.$ef)(l??d,r??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let S;const d=await this.g(a);if(!d){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),o=JSON.parse(r);S=a.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${a.identifier.value} from ${d}: ${r.message}`);return}S&&this.d.set(a.identifier.value,{contents:S,uri:d})}async g(a){if(a.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return P.URI.revive(S)}return a.l10n?P.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$aqc=k,e.$aqc=k=Je([Ve(0,$.$xQ),Ve(1,s.$hQ),Ve(2,T.$_j)],k),e.$bqc=(0,O.$Ei)("IExtHostLocalizationService")}),define(Oe[216],Ne([1,0,11,5,26,16,2,40]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qrc=void 0;let $=class extends v.$kk{constructor(y,a){super(a.logLevel,a.logsLocation,a.loggers.map(S=>(0,A.$bi)(S))),this.r=y.getProxy(R.$HN.MainThreadLogger)}$setLogLevel(y,a){a?this.setLogLevel(T.URI.revive(a),y):this.setLogLevel(y)}setVisibility(y,a){super.setVisibility(y,a),this.r.$setVisibility(y,a)}s(y,a,S){return new s(this.r,y,a,S)}};e.$qrc=$,e.$qrc=$=Je([Ve(0,O.$hQ),Ve(1,P.$xQ)],$);class s extends v.$fk{constructor(y,a,S,d){super(d?.logLevel==="always"),this.r=y,this.s=a,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(a,d).then(()=>{this.u(this.n),this.m=!0})}g(y,a){const S=[[y,a]];this.m?this.u(S):this.n.push(...S)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Oe[86],Ne([1,0,5,3,4,16,22]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=e.$cqc=void 0,e.$cqc=(0,R.$Ei)("IExtHostManagedSockets");let A=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$HN.MainThreadManagedSockets)}setFactory(y,a){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(y,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const a=++this.b,S=await this.c.makeConnection(),d=new P.$Tc;return this.d.set(a,new s(a,S,d)),d.add((0,P.$Sc)(()=>this.d.delete(a))),d.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),d.dispose()})),d.add(S.onDidClose(r=>{this.a.$onDidManagedSocketClose(a,r?.stack??r?.message),d.dispose()})),d.add(S.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(a,T.$Ne.wrap(r)))),a}$remoteSocketWrite(y,a){this.d.get(y)?.actual.send(a.buffer)}$remoteSocketEnd(y){const a=this.d.get(y);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$dqc=A,e.$dqc=A=Je([Ve(0,O.$hQ)],A);class ${constructor(y,a){this.socketFactoryId=y,this.makeConnection=a}}class s extends P.$Uc{constructor(y,a,S){super(),this.socketId=y,this.actual=a,this.B(S)}}}),define(Oe[217],Ne([1,0,5,11,24]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=void 0;function O(A){return A&&A.title}let T=class{constructor($,s){this.b=s,this.a=$.getProxy(v.$HN.MainThreadMessageService)}showMessage($,s,k,y,a){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let d;typeof y=="string"||O(y)?d=[y,...a]:(S.modal=y?.modal,S.useCustom=y?.useCustom,S.detail=y?.detail,d=a),S.useCustom&&(0,P.$fH)($,"resolvers");const r=[];let o=!1;for(let c=0;c<d.length;c++){const l=d[c];if(typeof l=="string")r.push({title:l,handle:c,isCloseAffordance:!1});else if(typeof l=="object"){const{title:i,isCloseAffordance:n}=l;r.push({title:i,isCloseAffordance:!!n,handle:c}),n&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,l):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,l)}return this.a.$showMessage(s,k,S,r).then(c=>{if(typeof c=="number")return d[c]})}};e.$Uqc=T,e.$Uqc=T=Je([Ve(1,R.$_j)],T)}),define(Oe[218],Ne([1,0,4,14,2,24,5]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0;class A{constructor(s){this.b=new Map,this.a=s.getProxy(T.$HN.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,k,y){if((0,O.$fH)(s,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,y),this.a.$registerProfileContentHandler(k,y.name,y.description,s.identifier.value),(0,v.$Sc)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(s,k,y,a){const S=this.b.get(s);if(!S)throw new Error(`Unknown handler with id: ${s}`);return S.saveProfile(k,y,a)}async $readProfile(s,k,y){const a=this.b.get(s);if(!a)throw new Error(`Unknown handler with id: ${s}`);return a.readProfile((0,R.$eg)(k)?k:P.URI.revive(k),y)}}e.$4qc=A}),define(Oe[87],Ne([1,0,5,6,3]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$0pc=void 0;class O{constructor(A){this.b=new R.$le,this.onDidChangePassword=this.b.event,this.a=A.getProxy(v.$HN.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,$){return this.a.$getPassword(A,$)}store(A,$,s){return this.a.$setPassword(A,$,s)}delete(A,$){return this.a.$deletePassword(A,$)}}e.$0pc=O,e.$$pc=(0,P.$Ei)("IExtHostSecretState")}),define(Oe[219],Ne([1,0,21,4,5]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0;class O{static{this.a=1}constructor(A){this.c=new Map,this.d=new Map,this.f=new Map,this.b=A.getProxy(P.$HN.MainThreadSpeech)}async $createSpeechToTextSession(A,$,s){const k=this.c.get(A);if(!k)return;const y=new R.$Tc,a=new v.$we;this.d.set($,a);const S=await k.provideSpeechToTextSession(a.token,s?{language:s}:void 0);S&&(y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(A){this.d.get(A)?.dispose(!0),this.d.delete(A)}async $createTextToSpeechSession(A,$,s){const k=this.c.get(A);if(!k)return;const y=new R.$Tc,a=new v.$we;this.d.set($,a);const S=await k.provideTextToSpeechSession(a.token,s?{language:s}:void 0);S&&(this.f.set($,S),y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(A,$){this.f.get(A)?.synthesize($)}async $cancelTextToSpeechSession(A){this.d.get(A)?.dispose(!0),this.d.delete(A),this.f.delete(A)}async $createKeywordRecognitionSession(A,$){const s=this.c.get(A);if(!s)return;const k=new R.$Tc,y=new v.$we;this.d.set($,y);const a=await s.provideKeywordRecognitionSession(y.token);a&&(k.add(a.onDidChange(S=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),k.add(y.token.onCancellationRequested(()=>k.dispose())))}async $cancelKeywordRecognitionSession(A){this.d.get(A)?.dispose(!0),this.d.delete(A)}registerProvider(A,$,s){const k=O.a++;return this.c.set(k,s),this.b.$registerProvider(k,$,{extension:A,displayName:A.value}),(0,R.$Sc)(()=>{this.b.$unregisterProvider(k),this.c.delete(k)})}}e.$$qc=O}),define(Oe[88],Ne([1,0,5,6,3]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=e.$Zpc=void 0;class O{constructor(A,$){this.c=$,this.b=new R.$le,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(v.$HN.MainThreadStorage)}registerExtensionStorageKeysToSync(A,$){this.a.$registerExtensionStorageKeysToSync(A,$)}async initializeExtensionStorage(A,$,s){const k=await this.a.$initializeExtensionStorage(A,$);let y;return k&&(y=this.d(A,$,k)),y||s}setValue(A,$,s){return this.a.$setValue(A,$,s)}$acceptValue(A,$,s){const k=this.d(A,$,s);k&&this.b.fire({shared:A,key:$,value:k})}d(A,$,s){try{return JSON.parse(s)}catch(k){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${A}): ${k}`)}}}e.$Zpc=O,e.$1pc=(0,P.$Ei)("IExtHostStorage")}),define(Oe[220],Ne([1,0,4,15,2,5]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0;class T{static{this.a=new Set([R.Schemas.http,R.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(O.$HN.MainThreadUriOpeners)}registerExternalUriOpener($,s,k,y){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const a=y.schemes.find(S=>!T.a.has(S));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(s,k),this.b.$registerUriOpener(s,y.schemes,$,y.label),(0,v.$Sc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri($,s,k){const y=this.c.get($);if(!y)throw new Error(`Unknown opener with id: ${$}`);const a=P.URI.revive(s);return y.canOpenExternalUri(a,k)}async $openUri($,s,k){const y=this.c.get($);if(!y)throw new Error(`Unknown opener id: '${$}'`);return y.openExternalUri(P.URI.revive(s.resolvedUri),{sourceUri:P.URI.revive(s.sourceUri)},k)}}e.$krc=T}),define(Oe[221],Ne([1,0,5,2,4,13,18]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lrc=void 0;class A{static{this.a=0}constructor(s){this.c=new T.$rn,this.d=new Map,this.b=s.getProxy(v.$HN.MainThreadUrls)}registerUriHandler(s,k){const y=s.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const a=A.a++;return this.c.add(y),this.d.set(a,k),this.b.$registerUriHandler(a,y,s.displayName||s.name),(0,P.$Sc)(()=>{this.c.delete(y),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(s,k){const y=this.d.get(s);if(!y)return Promise.resolve(void 0);try{y.handleUri(R.URI.revive(k))}catch(a){(0,O.$Y)(a)}return Promise.resolve(void 0)}async createAppUri(s){return R.URI.revive(await this.b.$createAppUri(s))}}e.$lrc=A}),define(Oe[222],Ne([1,0,22,5]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rtb=O,e.$Stb=A,R=We(R);class P{constructor(){this.buffers=[]}add(s){let k=this.buffers.indexOf(s);return k<0&&(k=this.buffers.length,this.buffers.push(s)),k}}function O($,s){if(s.serializeBuffersForPostMessage){const k=new P,a=JSON.stringify($,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(r)};if(ArrayBuffer.isView(r)){const o=T(r);if(o)return{$$vscode_array_buffer_reference$$:!0,index:k.add(r.buffer),view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),S=k.buffers.map(d=>{const r=new Uint8Array(d);return v.$Ne.wrap(r)});return{message:a,buffers:S}}else return{message:JSON.stringify($),buffers:[]}}function T($){switch($.constructor.name){case"Int8Array":return R.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return R.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return R.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return R.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return R.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return R.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return R.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return R.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return R.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return R.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return R.WebviewMessageArrayBufferViewType.BigUint64Array}}function A($,s){const k=s.map(S=>{const d=new ArrayBuffer(S.byteLength);return new Uint8Array(d).set(S.buffer),d}),y=s.length?(S,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:o}=r,c=k[o];if(r.view)switch(r.view.type){case R.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(c,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(c,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(c,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(c,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(c,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(c,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(c,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(c,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(c,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(c,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(c,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return d}:void 0;return{message:JSON.parse($,y),arrayBuffers:k}}}),define(Oe[67],Ne([1,0,6,4,15,25,2,175,222,82,5]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=e.$Kpc=void 0,e.$Lpc=a,e.$Npc=r,e.$Opc=o,O=We(O),k=We(k);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,g,u,m,p,h){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$le,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$le,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=g,this.#n=u,this.#s=m,this.#r=p,this.#u=a(p),this.#d=S(p),this.#i=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,s.$CDb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===P.Schemas.https||n.scheme===P.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+s.$BDb}return s.$BDb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),O.$ho(this.#o,n)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,$.$Rtb)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,g=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,m,p,h,E,D)=>{const w=T.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),I=(0,s.$CDb)(w,{isRemote:t,authority:g}).toString();return`${m}${I}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,m,p,h,E,D)=>{const w=T.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),I=(0,s.$CDb)(w,{isRemote:t,authority:g}).toString();return`${m}${I}${D}`})}}e.$Kpc=y;function a(i){try{const n=(0,A.$1p)((0,A.$Zp)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function S(i){try{const n=(0,A.$1p)((0,A.$Zp)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class d extends R.$Uc{constructor(n,t,g,u,m){super(),this.c=t,this.f=g,this.g=u,this.h=m,this.b=new Map,this.a=n.getProxy(k.$HN.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,g){const u=this.j(n);if(u){const{message:m}=(0,$.$Stb)(t,g.value);u._onMessageEmitter.fire(m)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,g){const u=new y(n,this.a,c(t),this.c,this.f,g,this.h);this.b.set(n,u);const m=u._onDidDispose(()=>{m.dispose(),this.deleteWebview(n)});return u}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$Mpc=d;function r(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||l(i,n)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>T.URI.from(n))}}function l(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Oe[121],Ne([1,0,6,15,12,2,3,16,5]),function(be,e,v,R,P,O,T,A,$){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=e.$nrc=void 0;let k=class{static{s=this}static{this.a={focused:!0,active:!0}}getState(){const a=this.d;return{get focused(){return a.focused},get active(){return a.active}}}constructor(a){this.c=new v.$le,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=a.getProxy($.$HN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:d})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(a){this.onDidChangeWindowProperty("focused",a)}$onDidChangeWindowActive(a){this.onDidChangeWindowProperty("active",a)}onDidChangeWindowProperty(a,S){S!==this.d[a]&&(this.d={...this.d,[a]:S},this.c.fire(this.d))}openUri(a,S){let d;if(typeof a=="string"){d=a;try{a=O.URI.parse(a)}catch{return Promise.reject(`Invalid uri - '${a}'`)}}return(0,P.$cf)(a.scheme)?Promise.reject("Invalid scheme - cannot be empty"):a.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${a.scheme}'`):this.b.$openUri(a,d,S)}async asExternalUri(a,S){if((0,P.$cf)(a.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(a,S);return O.URI.from(d)}};e.$nrc=k,e.$nrc=k=s=Je([Ve(0,A.$hQ)],k),e.$orc=(0,T.$Ei)("IExtHostWindow")}),define(Oe[223],Ne([1,0,212,26,16]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Btc=void 0;let O=class extends v.$rrc{constructor(A,$){super(A,$)}f(A,$,s){$.apply(console,s)}};e.$Btc=O,e.$Btc=O=Je([Ve(0,P.$hQ),Ve(1,R.$xQ)],O)}),define(Oe[224],Ne([1,0,10,22,21,27,13,6,4,36,150,210,38]),function(be,e,v,R,P,O,T,A,$,s,k,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Kdc=l,e.$Ldc=i,T=We(T);function d(M,N){try{return JSON.stringify(M,N)}catch{return"null"}}const r="$$ref$$",o={[r]:-1};class c{constructor(N,F){this.jsonString=N,this.referencedBuffers=F}}function l(M,N=null,F=!1){const W=[];return{jsonString:(F?d:JSON.stringify)(M,(L,Q)=>{if(typeof Q>"u")return o;if(typeof Q=="object"){if(Q instanceof R.$Ne){const X=W.push(Q)-1;return{[r]:X}}if(N)return N(L,Q)}return Q}),referencedBuffers:W}}function i(M,N,F){return JSON.parse(M,(W,K)=>{if(K){const L=K[r];if(typeof L=="number")return N[L];if(F&&K.$mid===s.MarshalledId.Uri)return F.transformIncoming(K)}return K})}function n(M,N){return JSON.stringify(M,N)}function t(M){return M?(N,F)=>F&&F.$mid===s.MarshalledId.Uri?M.transformOutgoing(F):F:null}var g;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var u;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const m=()=>{},p=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class E extends $.$Uc{static{S=p}static{this.a=3*1e3}constructor(N,F=null,W=null){super(),this[S]=!0,this.b=this.B(new A.$le),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=F,this.g=W,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let K=0,L=a.$Tw.count;K<L;K++)this.m[K]=null,this.s[K]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=u.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Qh(()=>this.H(),1e3)),this.B(this.c.onMessage(K=>this.L(K)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const F=this.w[N];delete this.w[N],F.resolveErr(T.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(u.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(u.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,k.$On)(N,this.g):N}getProxy(N){const{nid:F,sid:W}=N;return this.s[F]||(this.s[F]=this.J(F,W)),this.s[F]}J(N,F){const W={get:(K,L)=>(typeof L=="string"&&!K[L]&&L.charCodeAt(0)===O.CharCode.DollarSign&&(K[L]=(...Q)=>this.U(N,L,Q)),L===h?F:K[L])};return new Proxy(Object.create(null),W)}set(N,F){return this.m[N.nid]=F,F}assertRegistered(N){for(let F=0,W=N.length;F<W;F++){const K=N[F];if(!this.m[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}L(N){if(this.j)return;const F=N.byteLength,W=w.read(N,0),K=W.readUInt8(),L=W.readUInt32();switch(K){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:Q,method:X,args:ue}=C.deserializeRequestJSONArgs(W);this.g&&(ue=(0,k.$On)(ue,this.g)),this.M(F,L,Q,X,ue,K===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:Q,method:X,args:ue}=C.deserializeRequestMixedArgs(W);this.g&&(ue=(0,k.$On)(ue,this.g)),this.M(F,L,Q,X,ue,K===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this.f?.logIncoming(F,L,g.LocalSide,"ack"),this.G(L);break}case f.Cancel:{this.N(F,L);break}case f.ReplyOKEmpty:{this.O(F,L,void 0);break}case f.ReplyOKJSON:{let Q=C.deserializeReplyOKJSON(W);this.g&&(Q=(0,k.$On)(Q,this.g)),this.O(F,L,Q);break}case f.ReplyOKJSONWithBuffers:{const Q=C.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(F,L,Q);break}case f.ReplyOKVSBuffer:{const Q=C.deserializeReplyOKVSBuffer(W);this.O(F,L,Q);break}case f.ReplyErrError:{let Q=C.deserializeReplyErrError(W);this.g&&(Q=(0,k.$On)(Q,this.g)),this.P(F,L,Q);break}case f.ReplyErrEmpty:{this.P(F,L,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,F,W,K,L,Q){this.f?.logIncoming(N,F,g.OtherSide,`receiveRequest ${(0,a.$Vw)(W)}.${K}(`,L);const X=String(F);let ue,ee;if(Q){const oe=new P.$we;L.push(oe.token),ue=this.Q(W,K,L),ee=()=>oe.cancel()}else ue=this.Q(W,K,L),ee=m;this.u[X]=ee;const me=C.serializeAcknowledged(F);this.f?.logOutgoing(me.byteLength,F,g.OtherSide,"ack"),this.c.send(me),ue.then(oe=>{delete this.u[X];const ce=C.serializeReplyOK(F,oe,this.h);this.f?.logOutgoing(ce.byteLength,F,g.OtherSide,"reply:",oe),this.c.send(ce)},oe=>{delete this.u[X];const ce=C.serializeReplyErr(F,oe);this.f?.logOutgoing(ce.byteLength,F,g.OtherSide,"replyErr:",oe),this.c.send(ce)})}N(N,F){this.f?.logIncoming(N,F,g.OtherSide,"receiveCancel");const W=String(F);this.u[W]?.()}O(N,F,W){this.f?.logIncoming(N,F,g.LocalSide,"receiveReply:",W);const K=String(F);if(!this.w.hasOwnProperty(K))return;const L=this.w[K];delete this.w[K],L.resolveOk(W)}P(N,F,W){this.f?.logIncoming(N,F,g.LocalSide,"receiveReplyErr:",W);const K=String(F);if(!this.w.hasOwnProperty(K))return;const L=this.w[K];delete this.w[K];let Q;W&&(W.$isError?(Q=new Error,Q.name=W.name,Q.message=W.message,Q.stack=W.stack):Q=W),L.resolveErr(Q)}Q(N,F,W){try{return Promise.resolve(this.S(N,F,W))}catch(K){return Promise.reject(K)}}S(N,F,W){const K=this.m[N];if(!K)throw new Error("Unknown actor "+(0,a.$Vw)(N));const L=K[F];if(typeof L!="function")throw new Error("Unknown method "+F+" on actor "+(0,a.$Vw)(N));return L.apply(K,W)}U(N,F,W){if(this.j)return new y.$Jdc;let K=null;if(W.length>0&&P.CancellationToken.isCancellationToken(W[W.length-1])&&(K=W.pop()),K&&K.isCancellationRequested)return Promise.reject(T.$5());const L=C.serializeRequestArguments(W,this.h),Q=++this.t,X=String(Q),ue=new y.$Idc,ee=new $.$Tc;K&&ee.add(K.onCancellationRequested(()=>{const oe=C.serializeCancel(Q);this.f?.logOutgoing(oe.byteLength,Q,g.LocalSide,"cancel"),this.c.send(C.serializeCancel(Q))})),this.w[X]=new D(ue,ee),this.F(Q);const me=C.serializeRequest(Q,N,F,L,!!K);return this.f?.logOutgoing(me.byteLength,Q,g.LocalSide,`request: ${(0,a.$Vw)(N)}.${F}(`,W),this.c.send(me),ue}}e.$Mdc=E;class D{constructor(N,F){this.a=N,this.b=F}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class w{static alloc(N,F,W){const K=new w(R.$Ne.alloc(W+1+4),0);return K.writeUInt8(N),K.writeUInt32(F),K}static read(N,F){return new w(N,F)}get buffer(){return this.a}constructor(N,F){this.a=N,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+N);return this.b+=N,F}static sizeMixedArray(N){let F=0;F+=1;for(let W=0,K=N.length;W<K;W++){const L=N[W];switch(F+=1,L.type){case b.String:F+=this.sizeLongString(L.value);break;case b.VSBuffer:F+=this.sizeVSBuffer(L.value);break;case b.SerializedObjectWithBuffers:F+=this.sizeUInt32,F+=this.sizeLongString(L.value);for(let Q=0;Q<L.buffers.length;++Q)F+=this.sizeVSBuffer(L.buffers[Q]);break;case b.Undefined:break}}return F}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let F=0,W=N.length;F<W;F++){const K=N[F];switch(K.type){case b.String:this.writeUInt8(b.String),this.writeLongString(K.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(K.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let L=0;L<K.buffers.length;++L)this.writeBuffer(K.buffers[L]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const F=new Array(N);for(let W=0;W<N;W++)switch(this.readUInt8()){case b.String:F[W]=this.readLongString();break;case b.VSBuffer:F[W]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const L=this.readUInt32(),Q=this.readLongString(),X=[];for(let ue=0;ue<L;++ue)X.push(this.readVSBuffer());F[W]=new a.$Ww(i(Q,X,null));break}case b.Undefined:F[W]=void 0;break}return F}}var I;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(I||(I={}));class C{static a(N){for(let F=0,W=N.length;F<W;F++)if(N[F]instanceof R.$Ne||N[F]instanceof a.$Ww||typeof N[F]>"u")return!0;return!1}static serializeRequestArguments(N,F){if(this.a(N)){const W=[];for(let K=0,L=N.length;K<L;K++){const Q=N[K];if(Q instanceof R.$Ne)W[K]={type:b.VSBuffer,value:Q};else if(typeof Q>"u")W[K]={type:b.Undefined};else if(Q instanceof a.$Ww){const{jsonString:X,referencedBuffers:ue}=l(Q.value,F);W[K]={type:b.SerializedObjectWithBuffers,value:R.$Ne.fromString(X),buffers:ue}}else W[K]={type:b.String,value:R.$Ne.fromString(n(Q,F))}}return{type:I.Mixed,args:W}}return{type:I.Simple,args:n(N,F)}}static serializeRequest(N,F,W,K,L){switch(K.type){case I.Simple:return this.b(N,F,W,K.args,L);case I.Mixed:return this.c(N,F,W,K.args,L)}}static b(N,F,W,K,L){const Q=R.$Ne.fromString(W),X=R.$Ne.fromString(K);let ue=0;ue+=w.sizeUInt8(),ue+=w.sizeShortString(Q),ue+=w.sizeLongString(X);const ee=w.alloc(L?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,N,ue);return ee.writeUInt8(F),ee.writeShortString(Q),ee.writeLongString(X),ee.buffer}static deserializeRequestJSONArgs(N){const F=N.readUInt8(),W=N.readShortString(),K=N.readLongString();return{rpcId:F,method:W,args:JSON.parse(K)}}static c(N,F,W,K,L){const Q=R.$Ne.fromString(W);let X=0;X+=w.sizeUInt8(),X+=w.sizeShortString(Q),X+=w.sizeMixedArray(K);const ue=w.alloc(L?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,N,X);return ue.writeUInt8(F),ue.writeShortString(Q),ue.writeMixedArray(K),ue.buffer}static deserializeRequestMixedArgs(N){const F=N.readUInt8(),W=N.readShortString(),K=N.readMixedArray(),L=new Array(K.length);for(let Q=0,X=K.length;Q<X;Q++){const ue=K[Q];typeof ue=="string"?L[Q]=JSON.parse(ue):L[Q]=ue}return{rpcId:F,method:W,args:L}}static serializeAcknowledged(N){return w.alloc(f.Acknowledged,N,0).buffer}static serializeCancel(N){return w.alloc(f.Cancel,N,0).buffer}static serializeReplyOK(N,F,W){if(typeof F>"u")return this.d(N);if(F instanceof R.$Ne)return this.e(N,F);if(F instanceof a.$Ww){const{jsonString:K,referencedBuffers:L}=l(F.value,W,!0);return this.g(N,K,L)}else return this.f(N,d(F,W))}static d(N){return w.alloc(f.ReplyOKEmpty,N,0).buffer}static e(N,F){let W=0;W+=w.sizeVSBuffer(F);const K=w.alloc(f.ReplyOKVSBuffer,N,W);return K.writeVSBuffer(F),K.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,F){const W=R.$Ne.fromString(F);let K=0;K+=w.sizeLongString(W);const L=w.alloc(f.ReplyOKJSON,N,K);return L.writeLongString(W),L.buffer}static g(N,F,W){const K=R.$Ne.fromString(F);let L=0;L+=w.sizeUInt32,L+=w.sizeLongString(K);for(const X of W)L+=w.sizeVSBuffer(X);const Q=w.alloc(f.ReplyOKJSONWithBuffers,N,L);Q.writeUInt32(W.length),Q.writeLongString(K);for(const X of W)Q.writeBuffer(X);return Q.buffer}static deserializeReplyOKJSON(N){const F=N.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(N,F){const W=N.readUInt32(),K=N.readLongString(),L=[];for(let Q=0;Q<W;++Q)L.push(N.readVSBuffer());return new a.$Ww(i(K,L,F))}static serializeReplyErr(N,F){const W=F?d(T.$1(F),null):void 0;if(typeof W!="string")return this.h(N);const K=R.$Ne.fromString(W);let L=0;L+=w.sizeLongString(K);const Q=w.alloc(f.ReplyErrError,N,L);return Q.writeLongString(K),Q.buffer}static deserializeReplyErrError(N){const F=N.readLongString();return JSON.parse(F)}static h(N){return w.alloc(f.ReplyErrEmpty,N,0).buffer}}var f;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var b;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(b||(b={}))}),define(Oe[225],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dtc=void 0;const v=function(O){const T=A=>{globalThis.removeEventListener("message",T);const $=A.data;Object.defineProperties(globalThis,{postMessage:{value(s,k){$.postMessage(s,k)}},onmessage:{get(){return $.onmessage},set(s){$.onmessage=s}}}),$.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",T)}.toString();class R extends EventTarget{constructor(O,T,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${v})('${T}'))`,s=new Blob([$],{type:"application/javascript"}),k=URL.createObjectURL(s),y=new MessageChannel,a=k,S={type:"_newWorker",id:a,port:y.port2,url:k,options:A};O(S,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:a}),URL.revokeObjectURL(k),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),y.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),y.port1.start()}}e.$Dtc=R}),define(Oe[226],Ne([1,0,22,28,15,60,3]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sL=e.$pL=void 0,e.$qL=k,e.$rL=y,e.$pL=(0,T.$Ei)("notebookDocumentService");const A=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${A.join("")}]+`),s=7;function k(S){if(S.scheme!==P.Schemas.vscodeNotebookCell)return;const d=S.fragment.indexOf("s");if(d<0)return;const r=parseInt(S.fragment.substring(0,d).replace($,""),s),o=(0,v.$7e)(S.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:S.with({scheme:o,fragment:null})}}function y(S,d){const r=d.toString(s),c=`${r.length<A.length?A[r.length-1]:"z"}${r}s${(0,v.$8e)(v.$Ne.fromString(S.scheme),!0,!0)}`;return S.with({scheme:P.Schemas.vscodeNotebookCell,fragment:c})}class a{constructor(){this.a=new R.$Ac}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const r=k(d);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$sL=a,(0,O.$Qs)(e.$pL,a,O.InstantiationType.Delayed)}),define(Oe[89],Ne([1,0,22,41,39,72,15,19,20,31,226]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$JL=e.CellStatusbarAlignment=e.$IL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$FL=e.$EL=e.$CL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$BL=e.$AL=e.$zL=e.$yL=e.CellKind=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=void 0,e.$DL=u,e.$GL=h,e.$HL=E,e.$KL=I,e.$LL=f,R=We(R),e.$tL="workbench.editor.notebook",e.$uL="workbench.editor.notebookTextDiffEditor",e.$vL="workbench.editor.interactive",e.$wL="workbench.editor.repl",e.$xL="replNotebook.input.execute";var y;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(y||(e.CellKind=y={})),e.$yL=["application/json","application/javascript","text/html","image/svg+xml",O.$0s.latex,O.$0s.markdown,"image/png","image/jpeg",O.$0s.text],e.$zL=[O.$0s.latex,O.$0s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$0s.text],e.$AL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$BL="_notAvailable";var a;(function(X){X[X.Running=1]="Running",X[X.Idle=2]="Idle"})(a||(e.NotebookRunState=a={}));var S;(function(X){X[X.Unconfirmed=1]="Unconfirmed",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var d;(function(X){X[X.Unconfirmed=1]="Unconfirmed",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(X){X[X.WithHardKernelDependency=0]="WithHardKernelDependency",X[X.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",X[X.Pure=2]="Pure",X[X.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(X){X.Always="always",X.Never="never",X.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var c;(function(X){X[X.ModelChange=1]="ModelChange",X[X.Move=2]="Move",X[X.ChangeCellLanguage=5]="ChangeCellLanguage",X[X.Initialize=6]="Initialize",X[X.ChangeCellMetadata=7]="ChangeCellMetadata",X[X.Output=8]="Output",X[X.OutputItem=9]="OutputItem",X[X.ChangeCellContent=10]="ChangeCellContent",X[X.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",X[X.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",X[X.ChangeCellMime=13]="ChangeCellMime",X[X.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var l;(function(X){X[X.Handle=0]="Handle",X[X.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var i;(function(X){X[X.Replace=1]="Replace",X[X.Output=2]="Output",X[X.Metadata=3]="Metadata",X[X.CellLanguage=4]="CellLanguage",X[X.DocumentMetadata=5]="DocumentMetadata",X[X.Move=6]="Move",X[X.OutputItems=7]="OutputItems",X[X.PartialMetadata=8]="PartialMetadata",X[X.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(X){X.scheme=T.Schemas.vscodeNotebookCell;function ue(ae,Ie){return(0,k.$rL)(ae,Ie)}X.generate=ue;function ee(ae){return(0,k.$qL)(ae)}X.parse=ee;function me(ae,Ie){return ae.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${Ie??""},${ae.scheme!==T.Schemas.file?ae.scheme:""}`})}X.generateCellOutputUri=me;function oe(ae){if(ae.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const Ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ae.fragment);if(!Ie)return;const Fe=Ie[1]&&Ie[1]!==""?Ie[1]:void 0,Y=Ie[2];return{outputId:Fe,notebook:ae.with({scheme:Y||T.Schemas.file,fragment:null})}}X.parseCellOutputUri=oe;function ce(ae,Ie,Fe){return X.generate(ae,Ie).with({scheme:Fe})}X.generateCellPropertyUri=ce;function we(ae,Ie){if(ae.scheme===Ie)return X.parse(ae.with({scheme:X.scheme}))}X.parseCellPropertyUri=we})(n||(e.CellUri=n={}));const t=X=>$.$j?X.replace(/\//g,"\\"):X;class g{constructor(ue=[],ee=e.$yL){this.e=ee,this.d=[...new Set(ue)].map(me=>({pattern:me,matches:R.$zk(t(me))}))}sort(ue){const ee=new Map(P.Iterable.map(ue,oe=>[oe,t(oe)]));let me=[];for(const{matches:oe}of this.d)for(const[ce,we]of ee)if(oe(we)){me.push(ce),ee.delete(ce);break}return ee.size&&(me=me.concat([...ee.keys()].sort((oe,ce)=>this.e.indexOf(oe)-this.e.indexOf(ce)))),me}prioritize(ue,ee){const me=this.f(ue);if(me===-1){this.d.unshift({pattern:ue,matches:R.$zk(t(ue))});return}const oe=new Set(ee.map(we=>this.f(we,me)));oe.delete(-1);const ce=Array.from(oe).sort();this.d.splice(me+1,0,...ce.map(we=>this.d[we]));for(let we=ce.length-1;we>=0;we--)this.d.splice(ce[we],1)}toArray(){return this.d.map(ue=>ue.pattern)}f(ue,ee=this.d.length){const me=t(ue);for(let oe=0;oe<ee;oe++)if(this.d[oe].matches(me))return oe;return-1}}e.$CL=g;function u(X,ue,ee,me=(oe,ce)=>oe===ce){const oe=[];function ce(Ie,Fe,Y){if(Fe===0&&Y.length===0)return;const q=oe[oe.length-1];q&&q.start+q.deleteCount===Ie?(q.deleteCount+=Fe,q.toInsert.push(...Y)):oe.push({start:Ie,deleteCount:Fe,toInsert:Y})}let we=0,ae=0;for(;;){if(we===X.length){ce(we,0,ue.slice(ae));break}if(ae===ue.length){ce(we,X.length-we,[]);break}const Ie=X[we],Fe=ue[ae];if(me(Ie,Fe)){we+=1,ae+=1;continue}ee(Fe)?(ce(we,1,[]),we+=1):(ce(we,0,[Fe]),ae+=1)}return oe}e.$EL=new s.$Vj("notebookEditorCursorAtBoundary","none"),e.$FL=new s.$Vj("notebookEditorCursorAtLineBoundary","none");var m;(function(X){X.default="default",X.option="option"})(m||(e.NotebookEditorPriority=m={}));var p;(function(X){X.Cells="cells",X.Text="text",X.None="none"})(p||(e.NotebookFindScopeType=p={}));function h(X){const ue=X;return!!((typeof ue.include=="string"||R.$Ak(ue.include))&&(typeof ue.exclude=="string"||R.$Ak(ue.exclude)))}function E(X,ue,ee){if(Array.isArray(X.viewType)&&X.viewType.indexOf(ue)>=0||X.viewType===ue)return!0;if(X.filenamePattern){const me=h(X.filenamePattern)?X.filenamePattern.include:X.filenamePattern,oe=h(X.filenamePattern)?X.filenamePattern.exclude:void 0;if(R.$yk(me,(0,A.$nc)(ee.fsPath).toLowerCase()))return!(oe&&R.$yk(oe,(0,A.$nc)(ee.fsPath).toLowerCase()))}return!1}e.$IL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class w{static{this.d="notebook/"}static create(ue){return`${w.d}${ue}`}static parse(ue){if(ue.startsWith(w.d))return ue.substring(w.d.length)}}e.$JL=w;function I(X){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(X)}const C=new TextDecoder;function f(X){const ue=[];let ee=!1;for(const we of X)(ue.length===0||ee)&&(ue.push(we),ee=!0);let me=N(ue);const oe=v.$Ne.concat(ue.map(we=>v.$Ne.wrap(we))),ce=Q(oe);return me=me||ce.byteLength!==oe.byteLength,{data:ce,didCompression:me}}e.$ML="\x1B[A";const b=e.$ML.split("").map(X=>X.charCodeAt(0)),M=10;function N(X){let ue=!1;return X.forEach((ee,me)=>{if(me===0||ee.length<e.$ML.length)return;const oe=X[me-1],ce=ee.subarray(0,e.$ML.length);if(ce[0]===b[0]&&ce[1]===b[1]&&ce[2]===b[2]){const we=oe.lastIndexOf(M);if(we===-1)return;ue=!0,X[me-1]=oe.subarray(0,we),X[me]=ee.subarray(e.$ML.length)}}),ue}function F(X){let ue=X;do X=ue,ue=X.replace(/[^\n]\x08/gm,"");while(ue.length<X.length);return X}function W(X){for(X=X.replace(/\r+\n/gm,`
`);X.search(/\r[^$]/g)>-1;){const ue=X.match(/^(.*)\r+/m)[1];let ee=X.match(/\r+(.*)$/m)[1];ee=ee+ue.slice(ee.length,ue.length),X=X.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return X}const K=8,L=13;function Q(X){return!X.buffer.includes(K)&&!X.buffer.includes(L)?X:v.$Ne.fromString(W(F(C.decode(X.buffer))))}}),define(Oe[7],Ne([1,0,17,13,59,28,72,12,14,2,37,18,29,109,89]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d){"use strict";var r,o,c,l,i,n,t,g,u,m,p,h,E,D,w,I,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$9P=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.LanguageModelChatMessageRole=e.$ZP=e.$YP=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$IP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$vP=e.$uP=e.$tP=e.$sP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.TestRunProfileKind=e.TestResultState=e.$lP=e.$kP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$jP=e.NotebookVariablesRequestKind=e.$iP=e.$hP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$gP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.ColorThemeKind=e.$aP=e.$_O=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$$O=e.QuickInputButtonLocation=e.$0O=e.DebugConsoleMode=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$4O=e.$3O=e.FileChangeType=e.$2O=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$1O=e.$ZO=e.$YO=e.$XO=e.InlineCompletionTriggerKind=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$KO=e.ConfigurationTarget=e.$JO=e.$IO=e.$HO=e.$GO=e.DocumentPasteTriggerKind=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$zO=e.ViewBadge=e.ProgressLocation=e.$yO=e.$xO=e.TaskScope=e.ShellQuoting=e.$wO=e.$vO=e.$uO=e.TaskPanelKind=e.TaskRevealKind=e.$tO=e.TerminalLocation=e.$sO=e.$rO=e.$qO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$pO=e.$oO=e.$nO=e.$mO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$kO=e.$jO=e.$iO=e.$hO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$gO=e.$fO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.LanguageStatusSeverity=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.CodeActionTriggerKind=e.$6N=e.$5N=e.SymbolTag=e.SymbolKind=e.$4N=e.$3N=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.DiagnosticSeverity=e.DiagnosticTag=e.$WN=e.$VN=e.FileEditType=e.$UN=e.$TN=e.$SN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$RN=e.$QN=e.$PN=e.$MN=e.$LN=e.$KN=e.$JN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$NN=L,e.$ON=Q,e.$lO=bt,e.$LO=Fi,e.$rP=Pn;function f(z){return Object.assign(z,{apply:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const Se=se.length===1?[]:se[1];return Reflect.construct(z,Se,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const[Se,...Ke]=se;return Reflect.construct(z,Ke,Se.constructor)}}})}var b;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var M;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let N=r=class{static from(...U){let se=U;return new r(function(){if(se){for(const Se of se)Se&&typeof Se.dispose=="function"&&Se.dispose();se=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$JN=N,e.$JN=N=r=Je([f],N);let F=o=class{static Min(...U){if(U.length===0)throw new TypeError;let se=U[0];for(let Se=1;Se<U.length;Se++){const Ke=U[Se];Ke.isBefore(se)&&(se=Ke)}return se}static Max(...U){if(U.length===0)throw new TypeError;let se=U[0];for(let Se=1;Se<U.length;Se++){const Ke=U[Se];Ke.isAfter(se)&&(se=Ke)}return se}static isPosition(U){if(!U)return!1;if(U instanceof o)return!0;const{line:se,character:Se}=U;return typeof se=="number"&&typeof Se=="number"}static of(U){if(U instanceof o)return U;if(this.isPosition(U))return new o(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,se){if(U<0)throw(0,R.$6)("line must be non-negative");if(se<0)throw(0,R.$6)("character must be non-negative");this.c=U,this.e=se}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,se=0){if(U===null||se===null)throw(0,R.$6)();let Se;return typeof U>"u"?Se=0:typeof U=="number"?Se=U:(Se=typeof U.lineDelta=="number"?U.lineDelta:0,se=typeof U.characterDelta=="number"?U.characterDelta:0),Se===0&&se===0?this:new o(this.line+Se,this.character+se)}with(U,se=this.character){if(U===null||se===null)throw(0,R.$6)();let Se;return typeof U>"u"?Se=this.line:typeof U=="number"?Se=U:(Se=typeof U.line=="number"?U.line:this.line,se=typeof U.character=="number"?U.character:this.character),Se===this.line&&se===this.character?this:new o(Se,se)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$KN=F,e.$KN=F=o=Je([f],F);let W=c=class{static isRange(U){return U instanceof c?!0:U?F.isPosition(U.start)&&F.isPosition(U.end):!1}static of(U){if(U instanceof c)return U;if(this.isRange(U))return new c(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,se,Se,Ke){let it,dt;if(typeof U=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof Ke=="number"?(it=new F(U,se),dt=new F(Se,Ke)):F.isPosition(U)&&F.isPosition(se)&&(it=F.of(U),dt=F.of(se)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(U){return c.isRange(U)?this.contains(U.start)&&this.contains(U.end):F.isPosition(U)?!(F.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const se=F.Max(U.start,this.c),Se=F.Min(U.end,this.e);if(!se.isAfter(Se))return new c(se,Se)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const se=F.Min(U.start,this.c),Se=F.Max(U.end,this.end);return new c(se,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,se=this.end){if(U===null||se===null)throw(0,R.$6)();let Se;return U?F.isPosition(U)?Se=U:(Se=U.start||this.start,se=U.end||this.end):Se=this.start,Se.isEqual(this.c)&&se.isEqual(this.end)?this:new c(Se,se)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return L(this)}};e.$LN=W,e.$LN=W=c=Je([f],W);let K=l=class extends W{static isSelection(U){return U instanceof l?!0:U?W.isRange(U)&&F.isPosition(U.anchor)&&F.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,se,Se,Ke){let it,dt;if(typeof U=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof Ke=="number"?(it=new F(U,se),dt=new F(Se,Ke)):F.isPosition(U)&&F.isPosition(se)&&(it=F.of(U),dt=F.of(se)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return Q(this)}};e.$MN=K,e.$MN=K=l=Je([f],K);function L(z){return z.isEmpty?`[${z.start.line}:${z.start.character})`:`[${z.start.line}:${z.start.character} -> ${z.end.line}:${z.end.character})`}function Q(z){let U=L(z);return z.isEmpty||(z.active.isEqual(z.start)?U=`|${U}`:U=`${U}|`),U}const X=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,R.$6)("connectionToken")};class ue{static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,se,Se){if(typeof U!="string"||U.length===0)throw(0,R.$6)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,R.$6)("port");typeof Se<"u"&&X(Se),this.host=U,this.port=Math.round(se),this.connectionToken=Se}}e.$PN=ue;class ee{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,se){this.makeConnection=U,this.connectionToken=se,typeof se<"u"&&X(se)}}e.$QN=ee;class me extends Error{static NotAvailable(U,se){return new me(U,S.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(U){return new me(U,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,se=S.RemoteAuthorityResolverErrorCode.Unknown,Se){super(U),this._message=U,this._code=se,this._detail=Se,Object.setPrototypeOf(this,me.prototype)}}e.$RN=me;var oe;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(oe||(e.EndOfLine=oe={}));var ce;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(ce||(e.EnvironmentVariableMutatorType=ce={}));let we=i=class{static isTextEdit(U){return U instanceof i?!0:U?W.isRange(U)&&typeof U.newText=="string":!1}static replace(U,se){return new i(U,se)}static insert(U,se){return i.replace(new W(U,U),se)}static delete(U){return i.replace(U,"")}static setEndOfLine(U){const se=new i(new W(new F(0,0),new F(0,0)),"");return se.newEol=U,se}get range(){return this.c}set range(U){if(U&&!W.isRange(U))throw(0,R.$6)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,R.$6)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,R.$6)("newEol");this.f=U}constructor(U,se){this.c=U,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$SN=we,e.$SN=we=i=Je([f],we);let ae=n=class{static isNotebookCellEdit(U){return U instanceof n?!0:U?vi.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,se){return new n(U,se)}static insertCells(U,se){return new n(new vi(U,U),se)}static deleteCells(U){return new n(U,[])}static updateCellMetadata(U,se){const Se=new n(new vi(U,U),[]);return Se.newCellMetadata=se,Se}static updateNotebookMetadata(U){const se=new n(new vi(0,0),[]);return se.newNotebookMetadata=U,se}constructor(U,se){this.range=U,this.newCells=se}};e.$TN=ae,e.$TN=ae=n=Je([f],ae);class Ie{static isSnippetTextEdit(U){return U instanceof Ie?!0:U?W.isRange(U.range)&&q.isSnippetString(U.snippet):!1}static replace(U,se){return new Ie(U,se)}static insert(U,se){return Ie.replace(new W(U,U),se)}constructor(U,se){this.range=U,this.snippet=se}}e.$UN=Ie;var Fe;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Fe||(e.FileEditType=Fe={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,se,Se,Ke){this.c.push({_type:Fe.File,from:U,to:se,options:Se,metadata:Ke})}createFile(U,se,Se){this.c.push({_type:Fe.File,from:void 0,to:U,options:se,metadata:Se})}deleteFile(U,se,Se){this.c.push({_type:Fe.File,from:U,to:void 0,options:se,metadata:Se})}e(U,se,Se){this.c.push({_type:Fe.Cell,metadata:Se,uri:U,edit:{editType:d.CellEditType.DocumentMetadata,metadata:se},notebookMetadata:se})}f(U,se,Se,Ke){const it=se.start,dt=se.end;(it!==dt||Se.length>0)&&this.c.push({_type:Fe.CellReplace,uri:U,index:it,count:dt-it,cells:Se,metadata:Ke})}g(U,se,Se,Ke){this.c.push({_type:Fe.Cell,metadata:Ke,uri:U,edit:{editType:d.CellEditType.Metadata,index:se,metadata:Se}})}replace(U,se,Se,Ke){this.c.push({_type:Fe.Text,uri:U,edit:new we(se,Se),metadata:Ke})}insert(U,se,Se,Ke){this.replace(U,new W(se,se),Se,Ke)}delete(U,se,Se){this.replace(U,se,"",Se)}has(U){return this.c.some(se=>se._type===Fe.Text&&se.uri.toString()===U.toString())}set(U,se){if(se)for(const Se of se){if(!Se)continue;let Ke,it;Array.isArray(Se)?(Ke=Se[0],it=Se[1]):Ke=Se,ae.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,it):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,it):this.f(U,Ke.range,Ke.newCells,it):Ie.isSnippetTextEdit(Ke)?this.c.push({_type:Fe.Snippet,uri:U,range:Ke.range,edit:Ke.snippet,metadata:it}):this.c.push({_type:Fe.Text,uri:U,edit:Ke,metadata:it})}else{for(let Se=0;Se<this.c.length;Se++){const Ke=this.c[Se];switch(Ke._type){case Fe.Text:case Fe.Snippet:case Fe.Cell:case Fe.CellReplace:Ke.uri.toString()===U.toString()&&(this.c[Se]=void 0);break}}(0,v.$Hb)(this.c)}}get(U){const se=[];for(const Se of this.c)Se._type===Fe.Text&&Se.uri.toString()===U.toString()&&se.push(Se.edit);return se}entries(){const U=new O.$Ac;for(const se of this.c)if(se._type===Fe.Text){let Se=U.get(se.uri);Se||(Se=[se.uri,[]],U.set(se.uri,Se)),Se[1].push(se.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$VN=Y,e.$VN=Y=Je([f],Y);let q=t=class{static isSnippetString(U){return U instanceof t?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=t.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,se=this.e++){if(typeof U=="function"){const Se=new t;Se.e=this.e,U(Se),this.e=Se.e,U=Se.value}else U=t.c(U);return this.value+="${",this.value+=se,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,se=this.e++){const Se=U.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(U,se){if(typeof se=="function"){const Se=new t;Se.e=this.e,se(Se),this.e=Se.e,se=Se.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$WN=q,e.$WN=q=t=Je([f],q);var ne;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var ye;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(ye||(e.DiagnosticSeverity=ye={}));let le=g=class{static isLocation(U){return U instanceof g?!0:U?W.isRange(U.range)&&s.URI.isUri(U.uri):!1}constructor(U,se){if(this.uri=U,se)if(W.isRange(se))this.range=W.of(se);else if(F.isPosition(se))this.range=new W(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$XN=le,e.$XN=le=g=Je([f],le);let ve=class{static is(U){return U?typeof U.message=="string"&&U.location&&W.isRange(U.location.range)&&s.URI.isUri(U.location.uri):!1}constructor(U,se){this.location=U,this.message=se}static isEqual(U,se){return U===se?!0:!U||!se?!1:U.message===se.message&&U.location.range.isEqual(se.location.range)&&U.location.uri.toString()===se.location.uri.toString()}};e.$YN=ve,e.$YN=ve=Je([f],ve);let de=class{constructor(U,se,Se=ye.Error){if(!W.isRange(U))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=U,this.message=se,this.severity=Se}toJSON(){return{severity:ye[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,se){return U===se?!0:!U||!se?!1:U.message===se.message&&U.severity===se.severity&&U.code===se.code&&U.severity===se.severity&&U.source===se.source&&U.range.isEqual(se.range)&&(0,v.$tb)(U.tags,se.tags)&&(0,v.$tb)(U.relatedInformation,se.relatedInformation,ve.isEqual)}};e.$ZN=de,e.$ZN=de=Je([f],de);let J=class{constructor(U,se){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=se}};e.$1N=J,e.$1N=J=Je([f],J);let x=class extends J{constructor(U,se,Se,Ke){super(U,se),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=Ke}};e.$2N=x,e.$2N=x=Je([f],x);var pe;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(pe||(e.HoverVerbosityAction=pe={}));var $e;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})($e||(e.DocumentHighlightKind=$e={}));let Ae=class{constructor(U,se=$e.Text){this.range=U,this.kind=se}toJSON(){return{range:this.range,kind:$e[this.kind]}}};e.$3N=Ae,e.$3N=Ae=Je([f],Ae);let Ue=class{constructor(U,se){this.uri=U,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(U=>U.toJSON())}}};e.$4N=Ue,e.$4N=Ue=Je([f],Ue);var ke;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(ke||(e.SymbolKind=ke={}));var Pe;(function(z){z[z.Deprecated=1]="Deprecated"})(Pe||(e.SymbolTag=Pe={}));let Te=u=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,se,Se,Ke,it){this.name=U,this.kind=se,this.containerName=it,typeof Se=="string"&&(this.containerName=Se),Ke instanceof le?this.location=Ke:Se instanceof W&&(this.location=new le(Ke,Se)),u.validate(this)}toJSON(){return{name:this.name,kind:ke[this.kind],location:this.location,containerName:this.containerName}}};e.$5N=Te,e.$5N=Te=u=Je([f],Te);let j=m=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(m.validate)}constructor(U,se,Se,Ke,it){this.name=U,this.detail=se,this.kind=Se,this.range=Ke,this.selectionRange=it,this.children=[],m.validate(this)}};e.$6N=j,e.$6N=j=m=Je([f],j);var B;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let H=class{constructor(U,se){this.title=U,this.kind=se}};e.$7N=H,e.$7N=H=Je([f],H);let V=class{static{p=this}static{this.c="."}constructor(U){this.value=U}append(U){return new p(this.value?this.value+p.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+p.c)}};e.$8N=V,e.$8N=V=p=Je([f],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let re=class{constructor(U,se){if(this.range=U,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$9N=re,e.$9N=re=Je([f],re);class ge{constructor(U,se,Se,Ke,it,dt){this.kind=U,this.name=se,this.detail=Se,this.uri=Ke,this.range=it,this.selectionRange=dt}}e.$0N=ge;class Ce{constructor(U,se){this.fromRanges=se,this.from=U}}e.$$N=Ce;class ze{constructor(U,se){this.fromRanges=se,this.to=U}}e.$_N=ze;var Qe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Qe||(e.LanguageStatusSeverity=Qe={}));let _e=class{constructor(U,se){this.range=U,this.command=se}get isResolved(){return!!this.command}};e.$aO=_e,e.$aO=_e=Je([f],_e);let tt=h=class{#e;static isMarkdownString(U){return U instanceof h?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,se=!1){this.#e=new P.$3k(U,{supportThemeIcons:se})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,se){return this.#e.appendCodeblock(se??"",U),this}};e.$bO=tt,e.$bO=tt=h=Je([f],tt);let nt=class{constructor(U,se){this.label=U,this.documentation=se}};e.$cO=nt,e.$cO=nt=Je([f],nt);let et=class{constructor(U,se){this.label=U,this.documentation=se,this.parameters=[]}};e.$dO=et,e.$dO=et=Je([f],et);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$eO=rt,e.$eO=rt=Je([f],rt);var ft;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(ft||(e.SignatureHelpTriggerKind=ft={}));var lt;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let st=class{constructor(U){this.value=U}};e.$fO=st,e.$fO=st=Je([f],st);let ct=class{constructor(U,se,Se){this.position=U,this.label=se,this.kind=Se}};e.$gO=ct,e.$gO=ct=Je([f],ct);var gt;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(gt||(e.CompletionTriggerKind=gt={}));var $t;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})($t||(e.CompletionItemKind=$t={}));var qe;(function(z){z[z.Deprecated=1]="Deprecated"})(qe||(e.CompletionItemTag=qe={}));let je=class{constructor(U,se){this.label=U,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&$t[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$hO=je,e.$hO=je=Je([f],je);let te=class{constructor(U=[],se=!1){this.items=U,this.isIncomplete=se}};e.$iO=te,e.$iO=te=Je([f],te);let _=class{constructor(U,se,Se){this.insertText=U,this.range=se,this.command=Se}};e.$jO=_,e.$jO=_=Je([f],_);let Z=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.$kO=Z,e.$kO=Z=Je([f],Z);var Xe;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(Xe||(e.PartialAcceptTriggerKind=Xe={}));var xe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(xe||(e.ViewColumn=xe={}));var ht;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ht||(e.StatusBarAlignment=ht={}));function bt(z,U){return`${y.$qn.toKey(z)}.${U}`}var Ft;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(Ft||(e.TextEditorLineNumbersStyle=Ft={}));var Ht;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var _t;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(_t||(e.TextEditorRevealType=_t={}));var ei;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(ei||(e.TextEditorSelectionChangeKind=ei={}));var oi;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var Rt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Rt||(e.DecorationRangeBehavior=Rt={})),function(z){function U(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(ei||(e.TextEditorSelectionChangeKind=ei={}));var Ye;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Ye||(e.SyntaxTokenType=Ye={})),function(z){function U(se){switch(se){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=U}(Ye||(e.SyntaxTokenType=Ye={}));let Mt=class{constructor(U,se){if(se&&!s.URI.isUri(se))throw(0,R.$6)("target");if(!W.isRange(U)||U.isEmpty)throw(0,R.$6)("range");this.range=U,this.target=se}};e.$mO=Mt,e.$mO=Mt=Je([f],Mt);let hi=class{constructor(U,se,Se,Ke){this.red=U,this.green=se,this.blue=Se,this.alpha=Ke}};e.$nO=hi,e.$nO=hi=Je([f],hi);let mt=class{constructor(U,se){if(se&&!(se instanceof hi))throw(0,R.$6)("color");if(!W.isRange(U)||U.isEmpty)throw(0,R.$6)("range");this.range=U,this.color=se}};e.$oO=mt,e.$oO=mt=Je([f],mt);let Et=class{constructor(U){if(!U||typeof U!="string")throw(0,R.$6)("label");this.label=U}};e.$pO=Et,e.$pO=Et=Je([f],Et);var ti;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ii;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var jt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(jt||(e.TerminalExitReason=jt={}));var pt;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(pt||(e.TerminalShellExecutionCommandLineConfidence=pt={}));class zt{constructor(U,se,Se){if(this.startIndex=U,this.length=se,this.tooltip=Se,typeof U!="number"||U<0)throw(0,R.$6)("startIndex");if(typeof se!="number"||se<1)throw(0,R.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,R.$6)("tooltip")}}e.$qO=zt;class ni{constructor(U){this.uri=U}}e.$rO=ni;class ai{constructor(U){this.terminalCommand=U}}e.$sO=ai;var Ge;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Ge||(e.TerminalLocation=Ge={}));class ci{constructor(U){if(this.options=U,typeof U!="object")throw(0,R.$6)("options")}}e.$tO=ci;var di;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var fi;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let vt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(U){switch(U){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(U,se){if(this.label=se,typeof U!="string"||typeof se!="string")throw(0,R.$6)("name");this.c=U}get id(){return this.c}};e.$uO=vt,e.$uO=vt=E=Je([f],vt);function Lt(z){let U="";for(let se=0;se<z.length;se++)U+=z[se].replace(/,/g,",,")+",";return U}let Tt=class{constructor(U,se,Se){if(typeof U!="string")throw(0,R.$6)("process");this.e=[],this.c=U,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=Se):this.f=se)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,R.$6)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const se of this.e)U.push(se);return Lt(U)}};e.$vO=Tt,e.$vO=Tt=Je([f],Tt);let Wt=class{constructor(U,se,Se){if(this.f=[],Array.isArray(se)){if(!U)throw(0,R.$6)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,R.$6)("command");this.e=U,this.f=se,this.g=Se}else{if(typeof U!="string")throw(0,R.$6)("commandLine");this.c=U,this.g=se}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,R.$6)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,R.$6)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)U.push(typeof se=="string"?se:se.value);return Lt(U)}};e.$wO=Wt,e.$wO=Wt=Je([f],Wt);var ri;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var Kt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Kt||(e.TaskScope=Kt={}));class li{constructor(U){this.c=U}computeId(){return"customExecution"+(0,k.$1g)()}set callback(U){this.c=U}get callback(){return this.c}}e.$xO=li;let Bt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(U,se,Se,Ke,it,dt){this.k=!1,this.l=this.definition=U;let yt;typeof se=="string"?(this.o=this.name=se,this.w=this.source=Se,this.execution=Ke,yt=it,this.k=!0):se===Kt.Global||se===Kt.Workspace?(this.target=se,this.o=this.name=Se,this.w=this.source=Ke,this.execution=it,yt=dt):(this.target=se,this.o=this.name=Se,this.w=this.source=Ke,this.execution=it,yt=dt),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(U){this.j=U}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Tt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Wt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof li?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,k.$1g)()}}get definition(){return this.l}set definition(U){if(U==null)throw(0,R.$6)("Kind can't be undefined or null");this.B(),this.l=U}get scope(){return this.m}set target(U){this.B(),this.m=U}get name(){return this.o}set name(U){if(typeof U!="string")throw(0,R.$6)("name");this.B(),this.o=U}get execution(){return this.q}set execution(U){U===null&&(U=void 0),this.B(),this.q=U;const se=this.l.type;(D.g===se||D.e===se||D.f===se||D.c===se)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(U){if(Array.isArray(U))this.B(),this.r=U,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.B(),this.u=U}get source(){return this.w}set source(U){if(typeof U!="string"||U.length===0)throw(0,R.$6)("source must be a string of length > 0");this.B(),this.w=U}get group(){return this.x}set group(U){U===null&&(U=void 0),this.B(),this.x=U}get detail(){return this.A}set detail(U){U===null&&(U=void 0),this.A=U}get presentationOptions(){return this.y}set presentationOptions(U){U==null&&(U=Object.create(null)),this.B(),this.y=U}get runOptions(){return this.z}set runOptions(U){U==null&&(U=Object.create(null)),this.B(),this.z=U}};e.$yO=Bt,e.$yO=Bt=D=Je([f],Bt);var Qt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var Gt;(function(z){function U(se){const Se=se;return(0,$.$ig)(Se.value)?Se.tooltip&&!(0,$.$eg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}z.isViewBadge=U})(Gt||(e.ViewBadge=Gt={}));let Nt=w=class{static isTreeItem(U,se){const Se=U;if(Se.checkboxState!==void 0){const Ke=(0,$.$ig)(Se.checkboxState)?Se.checkboxState:(0,$.$gg)(Se.checkboxState)&&(0,$.$ig)(Se.checkboxState.state)?Se.checkboxState.state:void 0,it=!(0,$.$ig)(Se.checkboxState)&&(0,$.$gg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==kt.Checked&&Ke!==kt.Unchecked||it!==void 0&&!(0,$.$eg)(it))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(U instanceof w)return!0;if(Se.label!==void 0&&!(0,$.$eg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,$.$eg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,$.$eg)(Se.iconPath)&&!s.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,$.$eg)(Se.iconPath.id))){const Ke=Se.iconPath;if(!Ke||!(0,$.$eg)(Ke.light)&&!s.URI.isUri(Ke.light)&&!(0,$.$eg)(Ke.dark)&&!s.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,$.$eg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!s.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,$.$eg)(Se.tooltip)&&!(Se.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<wt.None&&Se.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,$.$eg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(U,se=wt.None){this.collapsibleState=se,s.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.$zO=Nt,e.$zO=Nt=w=Je([f],Nt);var wt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var kt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let Vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.$AO=Vt,e.$AO=Vt=Je([f],Vt);class It extends Vt{}e.$BO=It;class gi extends It{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.$CO=gi;class Yt{constructor(U,se,Se,Ke){this.name=U,this.uri=se,this._itemId=Se,this.c=Ke}data(){return this.c()}}e.$DO=Yt;let Si=class{#e=new Map;constructor(U){for(const[se,Se]of U??[]){const Ke=this.#e.get(this.#t(se));Ke?Ke.push(Se):this.#e.set(this.#t(se),[Se])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,se){this.#e.set(this.#t(U),[se])}forEach(U,se){for(const[Se,Ke]of this.#e)for(const it of Ke)U.call(se,it,Se,this)}*[Symbol.iterator](){for(const[U,se]of this.#e)for(const Se of se)yield[U,Se]}#t(U){return U.toLowerCase()}};e.$EO=Si,e.$EO=Si=Je([f],Si);let $i=class{constructor(U,se,Se){this.insertText=U,this.title=se,this.kind=Se}};e.$FO=$i,e.$FO=$i=Je([f],$i);var Ai;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(Ai||(e.DocumentPasteTriggerKind=Ai={}));class At{static{this.c="."}constructor(U){this.value=U}append(...U){return new At((this.value?[this.value,...U]:U).join(At.c))}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+At.c)}}e.$GO=At,At.Empty=new At("");class Ni{constructor(U,se,Se){this.title=se,this.insertText=U,this.kind=Se}}e.$HO=Ni;let ui=class{constructor(U,se){this.id=U,this.color=se}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.$IO=ui,e.$IO=ui=Je([f],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let Ct=class{constructor(U){this.id=U}};e.$JO=Ct,e.$JO=Ct=Je([f],Ct);var Ti;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ti||(e.ConfigurationTarget=Ti={}));let ki=class{get base(){return this.c}set base(U){this.c=U,this.e=s.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,se){if(typeof U!="string"&&(!U||!s.URI.isUri(U)&&!s.URI.isUri(U.uri)))throw(0,R.$6)("base");if(typeof se!="string")throw(0,R.$6)("pattern");typeof U=="string"?this.baseUri=s.URI.file(U):s.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$KO=ki,e.$KO=ki=Je([f],ki);const Ei=new WeakMap;function Fi(z,U){Ei.set(z,U)}let wi=class{constructor(U,se,Se,Ke,it){this.enabled=typeof U=="boolean"?U:!0,typeof se=="string"&&(this.condition=se),typeof Se=="string"&&(this.hitCondition=Se),typeof Ke=="string"&&(this.logMessage=Ke),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Ei.get(this)??(0,k.$1g)()),this.c}};e.$MO=wi,e.$MO=wi=Je([f],wi);let qt=class extends wi{constructor(U,se,Se,Ke,it,dt){if(super(se,Se,Ke,it,dt),U===null)throw(0,R.$6)("location");this.location=U}};e.$NO=qt,e.$NO=qt=Je([f],qt);let De=class extends wi{constructor(U,se,Se,Ke,it,dt){super(se,Se,Ke,it,dt),this.functionName=U}};e.$OO=De,e.$OO=De=Je([f],De);let Re=class extends wi{constructor(U,se,Se,Ke,it,dt,yt,Xt){if(super(Ke,it,dt,yt,Xt),!se)throw(0,R.$6)("dataId");this.label=U,this.dataId=se,this.canPersist=Se}};e.$PO=Re,e.$PO=Re=Je([f],Re);let he=class{constructor(U,se,Se){this.command=U,this.args=se||[],this.options=Se}};e.$QO=he,e.$QO=he=Je([f],he);let G=class{constructor(U,se){this.port=U,this.host=se}};e.$RO=G,e.$RO=G=Je([f],G);let Ee=class{constructor(U){this.path=U}};e.$SO=Ee,e.$SO=Ee=Je([f],Ee);let Be=class{constructor(U){this.implementation=U}};e.$TO=Be,e.$TO=Be=Je([f],Be);class Ze{constructor(U,se,Se){this.session=U,this.threadId=se,this.frameId=Se}}e.$UO=Ze;class He{constructor(U,se){this.session=U,this.threadId=se}}e.$VO=He;let ut=class{constructor(U,se){this.range=U,this.expression=se}};e.$WO=ut,e.$WO=ut=Je([f],ut);var Pt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Pt||(e.InlineCompletionTriggerKind=Pt={}));let Jt=class{constructor(U,se){this.range=U,this.text=se}};e.$XO=Jt,e.$XO=Jt=Je([f],Jt);let si=class{constructor(U,se,Se=!0){this.range=U,this.variableName=se,this.caseSensitiveLookup=Se}};e.$YO=si,e.$YO=si=Je([f],si);let Ut=class{constructor(U,se){this.range=U,this.expression=se}};e.$ZO=Ut,e.$ZO=Ut=Je([f],Ut);let Zt=class{constructor(U,se){this.frameId=U,this.stoppedLocation=se}};e.$1O=Zt,e.$1O=Zt=Je([f],Zt);var qi;(function(z){z[z.AIGenerated=1]="AIGenerated"})(qi||(e.NewSymbolNameTag=qi={}));var nn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(nn||(e.NewSymbolNameTriggerKind=nn={}));class Wi{constructor(U,se){this.newSymbolName=U,this.tags=se}}e.$2O=Wi;var Li;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Vi=I=class extends Error{static FileExists(U){return new I(U,a.FileSystemProviderErrorCode.FileExists,I.FileExists)}static FileNotFound(U){return new I(U,a.FileSystemProviderErrorCode.FileNotFound,I.FileNotFound)}static FileNotADirectory(U){return new I(U,a.FileSystemProviderErrorCode.FileNotADirectory,I.FileNotADirectory)}static FileIsADirectory(U){return new I(U,a.FileSystemProviderErrorCode.FileIsADirectory,I.FileIsADirectory)}static NoPermissions(U){return new I(U,a.FileSystemProviderErrorCode.NoPermissions,I.NoPermissions)}static Unavailable(U){return new I(U,a.FileSystemProviderErrorCode.Unavailable,I.Unavailable)}constructor(U,se=a.FileSystemProviderErrorCode.Unknown,Se){super(s.URI.isUri(U)?U.toString(!0):U),this.code=Se?.name??"Unknown",(0,a.$ol)(this,se),Object.setPrototypeOf(this,I.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$3O=Vi,e.$3O=Vi=I=Je([f],Vi);let Hi=class{constructor(U,se,Se){this.start=U,this.end=se,this.kind=Se}};e.$4O=Hi,e.$4O=Hi=Je([f],Hi);var Ii;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var rn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(rn||(e.CommentThreadCollapsibleState=rn={}));var sn;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(sn||(e.CommentMode=sn={}));var Mi;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var on;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(on||(e.CommentThreadState=on={}));var Ui;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Ui||(e.CommentThreadApplicability=Ui={}));var Qi;(function(z){z[z.Reply=1]="Reply",z[z.Comment=2]="Comment"})(Qi||(e.CommentThreadFocus=Qi={}));class yn{constructor(U,se=[]){this.tokenTypes=U,this.tokenModifiers=se}}e.$5O=yn;function an(z){return typeof z>"u"||(0,$.$fg)(z)}class Ki{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,U){this.m=!0;for(let se=0,Se=U.tokenTypes.length;se<Se;se++)this.k.set(U.tokenTypes[se],se);for(let se=0,Se=U.tokenModifiers.length;se<Se;se++)this.l.set(U.tokenModifiers[se],se)}}push(U,se,Se,Ke,it){if(typeof U=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(U,se,Se,Ke,it);if(W.isRange(U)&&typeof se=="string"&&an(Se))return this.o(U,se,Se);throw(0,R.$6)()}o(U,se,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,it=U.start.character,dt=U.end.character-U.start.character,yt=this.k.get(se);let Xt=0;if(Se)for(const pi of Se){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const yi=this.l.get(pi);Xt|=1<<yi>>>0}this.q(Ke,it,dt,yt,Xt)}q(U,se,Se,Ke,it){if(this.f&&(U<this.c||U===this.c&&se<this.e)){this.f=!1;const Xt=this.g.length/5|0;let pi=0,yi=0;for(let Di=0;Di<Xt;Di++){let Ri=this.g[5*Di],en=this.g[5*Di+1];Ri===0?(Ri=pi,en+=yi):Ri+=pi,this.g[5*Di]=Ri,this.g[5*Di+1]=en,pi=Ri,yi=en}}let dt=U,yt=se;this.f&&this.j>0&&(dt-=this.c,dt===0&&(yt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=yt,this.g[this.j++]=Se,this.g[this.j++]=Ke,this.g[this.j++]=it,this.c=U,this.e=se}static r(U){const se=[],Se=U.length/5|0;for(let yt=0;yt<Se;yt++)se[yt]=yt;se.sort((yt,Xt)=>{const pi=U[5*yt],yi=U[5*Xt];if(pi===yi){const Di=U[5*yt+1],Ri=U[5*Xt+1];return Di-Ri}return pi-yi});const Ke=new Uint32Array(U.length);let it=0,dt=0;for(let yt=0;yt<Se;yt++){const Xt=5*se[yt],pi=U[Xt+0],yi=U[Xt+1],Di=U[Xt+2],Ri=U[Xt+3],en=U[Xt+4],Hn=pi-it,Fr=Hn===0?yi-dt:yi,tn=5*yt;Ke[tn+0]=Hn,Ke[tn+1]=Fr,Ke[tn+2]=Di,Ke[tn+3]=Ri,Ke[tn+4]=en,it=pi,dt=yi}return Ke}build(U){return this.f?new Ci(new Uint32Array(this.g),U):new Ci(Ki.r(this.g),U)}}e.$6O=Ki;class Ci{constructor(U,se){this.resultId=se,this.data=U}}e.$7O=Ci;class En{constructor(U,se,Se){this.start=U,this.deleteCount=se,this.data=Se}}e.$8O=En;class Dn{constructor(U,se){this.resultId=se,this.edits=U}}e.$9O=Dn;var cn;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(cn||(e.DebugConsoleMode=cn={}));class Gi{constructor(U){this.name=U}}e.$0O=Gi;var Ji;(function(z){z[z.Title=1]="Title",z[z.Inline=2]="Inline"})(Ji||(e.QuickInputButtonLocation=Ji={}));let Me=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.$$O=Me,e.$$O=Me=Je([f],Me);var bi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(bi||(e.QuickPickItemKind=bi={}));var Xi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var ot;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(ot||(e.ExtensionKind=ot={}));class St{static validate(U){if(typeof U.badge=="string"){let se=(0,A.$Pf)(U.badge,0);if(se<U.badge.length&&(se+=(0,A.$Pf)(U.badge,se)),U.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!ui.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,se,Se){this.badge=U,this.tooltip=se,this.color=Se}}e.$_O=St;let Yi=class{constructor(U){this.kind=U}};e.$aP=Yi,e.$aP=Yi=Je([f],Yi);var ln;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(ln||(e.ColorThemeKind=ln={}));class vi{static isNotebookRange(U){return U instanceof vi?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,se){if(U<0)throw(0,R.$6)("start must be positive");if(se<0)throw(0,R.$6)("end must be positive");U<=se?(this.c=U,this.e=se):(this.c=se,this.e=U)}with(U){let se=this.c,Se=this.e;return U.start!==void 0&&(se=U.start),U.end!==void 0&&(Se=U.end),se===this.c&&Se===this.e?this:new vi(se,Se)}}e.$bP=vi;class zi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(se=>zi.isNotebookCellData(se))}static isNotebookCellData(U){return!0}constructor(U,se,Se,Ke,it,dt,yt){this.kind=U,this.value=se,this.languageId=Se,this.mime=Ke,this.outputs=it??[],this.metadata=dt,this.executionSummary=yt,zi.validate(this)}}e.$cP=zi;class ji{constructor(U){this.cells=U}}e.$dP=ji;class mi{static isNotebookCellOutputItem(U){return U instanceof mi?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const se={name:U.name,message:U.message,stack:U.stack};return mi.json(se,"application/vnd.code.notebook.error")}static stdout(U){return mi.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return mi.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,se="application/octet-stream"){return new mi(U,se)}static#e=new TextEncoder;static text(U,se=T.$0s.text){const Se=mi.#e.encode(String(U));return new mi(Se,se)}static json(U,se="text/x-json"){const Se=JSON.stringify(U,void 0,"	");return mi.text(Se,se)}constructor(U,se){this.data=U,this.mime=se;const Se=(0,T.$bt)(se,!0);if(!Se)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$eP=mi;class Bi{static isNotebookCellOutput(U){return U instanceof Bi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,se=!1){const Se=new Set,Ke=new Set;for(let it=0;it<U.length;it++){const dt=U[it],yt=(0,T.$bt)(dt.mime);if(!Se.has(yt)||(0,d.$KL)(yt)){Se.add(yt);continue}Ke.add(it),se&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ke.size===0?U:U.filter((it,dt)=>!Ke.has(dt))}constructor(U,se,Se){this.items=Bi.ensureUniqueMimeTypes(U,!0),typeof se=="string"?(this.id=se,this.metadata=Se):(this.id=(0,k.$1g)(),this.metadata=se??Se)}}e.$fP=Bi;var un;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(un||(e.NotebookCellKind=un={}));var Zi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Zi||(e.NotebookCellExecutionState=Zi={}));var hn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(hn||(e.NotebookCellStatusBarAlignment=hn={}));var dn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(dn||(e.NotebookEditorRevealType=dn={}));class Sn{constructor(U,se){this.text=U,this.alignment=se}}e.$gP=Sn;var fn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(fn||(e.NotebookControllerAffinity=fn={}));var gn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(gn||(e.NotebookControllerAffinity2=gn={}));class kn{constructor(U,se=[]){this.uri=U,this.provides=(0,v.$1b)(se)}}e.$hP=kn;class In{constructor(U){this.label=U}}e.$iP=In;var mn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(mn||(e.NotebookVariablesRequestKind=mn={}));let xi=class{constructor(U,se){this.label=U,this.timestamp=se}};e.$jP=xi,e.$jP=xi=Je([f],xi);var pn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(pn||(e.ExtensionMode=pn={}));var $n;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})($n||(e.ExtensionRuntime=$n={}));var ie;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(ie||(e.StandardTokenType=ie={}));class fe{constructor(U,se){this.ranges=U,this.wordPattern=se}}e.$kP=fe;class Le{constructor(U){this.c=U}get autoForwardAction(){return this.c}}e.$lP=Le;var at;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(at||(e.TestResultState=at={}));var Dt;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(Dt||(e.TestRunProfileKind=Dt={}));let Ot=class{constructor(U=void 0,se=void 0,Se=void 0,Ke=!1,it=!0){this.include=U,this.exclude=se,this.profile=Se,this.continuous=Ke,this.preserveFocus=it}};e.$mP=Ot,e.$mP=Ot=Je([f],Ot);let Pi=C=class{static diff(U,se,Se){const Ke=new C(U);return Ke.expectedOutput=se,Ke.actualOutput=Se,Ke}constructor(U){this.message=U}};e.$nP=Pi,e.$nP=Pi=C=Je([f],Pi);let _i=class{constructor(U){this.id=U}};e.$oP=_i,e.$oP=_i=Je([f],_i);class Gn{constructor(U,se,Se){this.label=U,this.file=se,this.position=Se}}e.$pP=Gn;class wn{constructor(U,se){this.covered=U,this.total=se,Pn(this)}}e.$qP=wn;function Pn(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class Cn{static fromDetails(U,se){const Se=new wn(0,0),Ke=new wn(0,0),it=new wn(0,0);for(const yt of se)if("branches"in yt){Se.total+=1,Se.covered+=yt.executed?1:0;for(const Xt of yt.branches)Ke.total+=1,Ke.covered+=Xt.executed?1:0}else it.total+=1,it.covered+=yt.executed?1:0;const dt=new Cn(U,Se,Ke.total>0?Ke:void 0,it.total>0?it:void 0);return dt.detailedCoverage=se,dt}constructor(U,se,Se,Ke,it=[]){this.uri=U,this.statementCoverage=se,this.branchCoverage=Se,this.declarationCoverage=Ke,this.fromTests=it}}e.$sP=Cn;class Jn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,se,Se=[]){this.executed=U,this.location=se,this.branches=Se}}e.$tP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,se,Se){this.executed=U,this.location=se,this.label=Se}}e.$uP=Xn;class Yn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,se,Se){this.name=U,this.executed=se,this.location=Se}}e.$vP=Yn;var Rn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var An;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(An||(e.WorkspaceTrustState=An={}));var Tn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Zn{constructor(U,se,Se,Ke,it,dt){this.kind=U,this.name=se,this.detail=Se,this.uri=Ke,this.range=it,this.selectionRange=dt}}e.$wP=Zn;class xn{constructor(U){this.uri=U}}e.$xP=xn;class _n{constructor(U,se){this.original=U,this.modified=se}}e.$yP=_n;class er{constructor(U,se,Se,Ke){this.base=U,this.input1=se,this.input2=Se,this.result=Ke}}e.$zP=er;class tr{constructor(U,se){this.uri=U,this.viewType=se}}e.$AP=tr;class ir{constructor(U){this.viewType=U}}e.$BP=ir;class nr{constructor(U,se){this.uri=U,this.notebookType=se}}e.$CP=nr;class rr{constructor(U,se,Se){this.original=U,this.modified=se,this.notebookType=Se}}e.$DP=rr;class sr{constructor(){}}e.$EP=sr;class or{constructor(U,se){this.uri=U,this.inputBoxUri=se}}e.$FP=or;class ar{constructor(){}}e.$GP=ar;class cr{constructor(U){this.textDiffs=U}}e.$HP=cr;var On;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(On||(e.InteractiveSessionVoteDirection=On={}));var Nn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Fn;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Fn||(e.ChatVariableLevel=Fn={}));class lr{constructor(U,se,Se){this.id=U,this.label=se,this.values=Se}}e.$IP=lr;var Ln;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Ln||(e.InteractiveEditorResponseFeedbackKind=Ln={}));var Mn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(Mn||(e.ChatResultFeedbackKind=Mn={}));class ur{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new tt(U):U}}e.$JP=ur;class hr{constructor(U,se){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new tt(U):U,this.vulnerabilities=se}}e.$KP=hr;class dr{constructor(U,se){this.participant=U,this.command=se}}e.$LP=dr;class fr{constructor(U,se,Se,Ke){this.title=U,this.message=se,this.data=Se,this.buttons=Ke}}e.$MP=fr;class gr{constructor(U,se){this.value=U,this.baseUri=se}}e.$NP=gr;class mr{constructor(U,se){this.value=U,this.title=se}}e.$OP=mr;class pr{constructor(U){this.value=U}}e.$PP=pr;class $r{constructor(U,se){this.value=U,this.task=se}}e.$QP=$r;class wr{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new tt(U):U}}e.$RP=wr;class br{constructor(U){this.value=U}}e.$SP=br;class vr{constructor(U,se,Se){this.value=U,this.iconPath=se,this.options=Se}}e.$TP=vr;class yr{constructor(U,se,Se){this.value=U,this.license=se,this.snippet=Se}}e.$UP=yr;class Er{constructor(U,se){this.uri=U,this.edits=Array.isArray(se)?se:[se]}}e.$VP=Er;class Dr{constructor(U,se,Se,Ke){this.prompt=U,this.command=se,this.references=Se,this.participant=Ke}}e.$WP=Dr;class Sr{constructor(U,se,Se,Ke){this.response=U,this.result=se,this.participant=Se,this.command=Ke}}e.$XP=Sr;var Un;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(Un||(e.ChatLocation=Un={}));var zn;(function(z){z[z.Complete=1]="Complete",z[z.Partial=2]="Partial",z[z.Omitted=3]="Omitted"})(zn||(e.ChatResponseReferencePartStatusKind=zn={}));class kr{constructor(U,se,Se){this.document=U,this.selection=se,this.wholeRange=Se}}e.$YP=kr;class Ir{constructor(U){this.cell=U}}e.$ZP=Ir;var bn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(bn||(e.LanguageModelChatMessageRole=bn={}));class Cr{constructor(U,se,Se){this.name=U,this.content=se,this.isError=Se??!1}}e.$1P=Cr;class vn{static User(U,se){const Se=new vn(bn.User,typeof U=="string"?U:"",se);return Se.content2=U,Se}static Assistant(U,se){return new vn(bn.Assistant,U,se)}constructor(U,se,Se){this.role=U,this.content=se,this.content2=se,this.name=Se}}e.$2P=vn;class Pr{constructor(U,se){this.name=U,this.parameters=se}}e.$3P=Pr;class Rr{constructor(U){this.value=U}}e.$4P=Rr;class Ar{constructor(U){this.content=U}}e.$5P=Ar;class Tr{constructor(U,se){this.content=U,this.name=se}}e.$6P=Tr;class Or{constructor(U,se){this.content=U,this.name=se}}e.$7P=Or;class Oi extends Error{static NotFound(U){return new Oi(U,Oi.NotFound.name)}static NoPermissions(U){return new Oi(U,Oi.NoPermissions.name)}static Blocked(U){return new Oi(U,Oi.Blocked.name)}constructor(U,se,Se){super(U,{cause:Se}),this.name="LanguageModelError",this.code=se??""}}e.$8P=Oi;var jn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(jn||(e.RelatedInformationType=jn={}));var Bn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var qn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(qn||(e.TextToSpeechStatus=qn={}));var Wn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(Wn||(e.KeywordRecognitionStatus=Wn={}));class Nr{constructor(U,se){this.text=U,this.range=se}}e.$9P=Nr;var Vn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Oe[227],Ne([1,0,5,7]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=void 0;class P{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(v.$HN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,A,$){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(T);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(A,$)??[]}getRelatedInformation(T,A,$){return this.c.$getAiRelatedInformation(A,$)}registerRelatedInformationProvider(T,A,$){const s=this.b;return this.b++,this.a.set(s,$),this.c.$registerAiRelatedInformationProvider(s,A),new R.$JN(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$fpc=P}),define(Oe[90],Ne([1,0,6,5,7,18,117,3,16]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$qpc=void 0,e.$qpc=(0,A.$Ei)("IExtHostAuthentication");let s=class{constructor(a){this.b=new Map,this.c=new v.$le,this.onDidChangeSessions=this.c.event,this.d=new k,this.a=a.getProxy(R.$HN.MainThreadAuthentication)}async getSession(a,S,d,r={}){const o=O.$qn.toKey(a.identifier),c=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${S} ${c}`,async()=>{await this.a.$ensureProvider(S);const l=a.displayName||a.name;return this.a.$getSession(S,d,o,l,r)})}async getAccounts(a){return await this.a.$ensureProvider(a),await this.a.$getAccounts(a)}async removeSession(a,S){const d=this.b.get(a);return d?d.provider.removeSession(S):this.a.$removeSession(a,S)}registerAuthenticationProvider(a,S,d,r){if(this.b.get(a))throw new Error(`An authentication provider with id '${a}' is already registered.`);this.b.set(a,{label:S,provider:d,options:r??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(a,c));return this.a.$registerAuthenticationProvider(a,S,r?.supportsMultipleAccounts??!1),new P.$JN(()=>{o.dispose(),this.b.delete(a),this.a.$unregisterAuthenticationProvider(a)})}async $createSession(a,S,d){const r=this.b.get(a);if(r)return await r.provider.createSession(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $removeSession(a,S){const d=this.b.get(a);if(d)return await d.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $getSessions(a,S,d){const r=this.b.get(a);if(r)return await r.provider.getSessions(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}$onDidChangeAuthenticationSessions(a,S){return a.startsWith(T.$JM)||this.c.fire({provider:{id:a,label:S}}),Promise.resolve()}};e.$rpc=s,e.$rpc=s=Je([Ve(0,$.$hQ)],s);class k{constructor(){this.a=new Map}getOrCreate(a,S){const d=this.a.get(a);if(d)return d;const r=S().finally(()=>this.a.delete(a));return this.a.set(a,r),r}}}),define(Oe[122],Ne([1,0,2,5,7,3,16,11,17,12,19,24]),function(be,e,v,R,P,O,T,A,$,s,k,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=e.$vqc=void 0;let S=class{static{a=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(R.$HN.MainThreadDecorations)}registerFileDecorationProvider(r,o){const c=a.c++;this.f.set(c,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(c,o.identifier.value);const l=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const n=(0,$.$1b)(i);if(n.length<=a.d){this.g.$onDidChange(c,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,n.length);const t=n.map(m=>({uri:m,rank:(0,s.$if)(m.path,"/")})),g=(0,$.$yb)(t,(m,p)=>m.rank-p.rank||(0,s.$yf)(m.uri.path,p.uri.path)),u=[];e:for(const m of g){let p;for(const h of m){const E=(0,k.$mc)(h.uri.path);if(p!==E&&(p=E,u.push(h.uri)>=a.d))break e}}this.g.$onDidChange(c,u)});return new P.$JN(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(r,o,c){if(!this.f.has(r))return Object.create(null);const l=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(o.map(async t=>{try{const{uri:g,id:u}=t,m=await Promise.resolve(i.provideFileDecoration(v.URI.revive(g),c));if(!m)return;try{P.$_O.validate(m),m.badge&&typeof m.badge!="string"&&(0,y.$fH)(n,"codiconDecoration"),l[u]=[m.propagate,m.tooltip,m.badge,m.color]}catch(p){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${p}`)}}catch(g){this.h.error(g)}})),l}};e.$vqc=S,e.$vqc=S=a=Je([Ve(0,T.$hQ),Ve(1,A.$_j)],S),e.$wqc=(0,O.$Ei)("IExtHostDecorations")}),define(Oe[228],Ne([1,0,13,2,7,5,15,21,12]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0;class s{static{this.a=0}constructor(y,a,S){this.d=a,this.e=S,this.b=new Map,this.c=y.getProxy(O.$HN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,a){if(Object.keys(T.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const S=s.a++;this.b.set(S,a),this.c.$registerTextContentProvider(S,y);let d;if(typeof a.onDidChange=="function"){let r;d=a.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const c=this.$provideTextDocumentContent(S,o).then(async l=>{if(!l&&typeof l!="string")return;const i=this.d.getDocument(o);if(!i)return;const n=(0,$.$sf)(l);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(o,l)}).catch(v.$Y).finally(()=>{r===c&&(r=void 0)});r=c})}return new P.$JN(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,a){const S=this.b.get(y);return S?Promise.resolve(S.provideTextDocumentContent(R.URI.revive(a),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$yqc=s}),define(Oe[123],Ne([1,0,61,15,12,284,169,7,17]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=e.$kQ=void 0,e.$jQ=k;const s=new Map;function k(d,r){r?s.set(d,r):s.delete(d)}function y(d){return s.get(d)}class a extends O.$ow{constructor(r,o,c,l,i,n,t){super(o,c,l,i),this.c=r,this.m=n,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,$.$tb)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===R.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,c){return r.y(o,c)},[Symbol.for("debug.description")](){return`TextDocument(${r.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,v.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,v.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const c=this.g,l=o.start.line,i=o.end.line,n=[];n.push(this.f[l].substring(o.start.character));for(let t=l+1;t<i;t++)n.push(this.f[t]);return n.push(this.f[i].substring(0,o.end.character)),n.join(c)}t(r){let o;if(r instanceof A.$KN?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new S(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),c=this.f[o.index].length;return new A.$KN(o.index,Math.min(o.remainder,c))}w(r){if(!(r instanceof A.$LN))throw new Error("Invalid argument");const o=this.x(r.start),c=this.x(r.end);return o===r.start&&c===r.end?r:new A.$LN(o.line,o.character,c.line,c.character)}x(r){if(!(r instanceof A.$KN))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:c}=r,l=!1;if(o<0)o=0,c=0,l=!0;else if(o>=this.f.length)o=this.f.length-1,c=this.f[o].length,l=!0;else{const i=this.f[o].length;c<0?(c=0,l=!0):c>i&&(c=i,l=!0)}return l?new A.$KN(o,c):r}y(r,o){const c=this.x(r);if(!o)o=y(this.m);else if((0,P.$rf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const l=(0,T.$pt)(c.character+1,(0,T.$nt)(o),this.f[c.line],0);if(l)return new A.$LN(c.line,l.startColumn-1,c.line,l.endColumn-1)}}e.$kQ=a;class S{constructor(r,o,c){this.a=r,this.b=o,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.$LN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.$LN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$lQ=S}),define(Oe[229],Ne([1,0,5,7]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=void 0;class P{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(v.$HN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,A,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(T);if(!s)throw new Error("Embedding vector provider not found");const k=await s.provideEmbeddingVector(A,$);if(!k)throw new Error("Embedding vector provider returned undefined");return k}registerEmbeddingVectorProvider(T,A,$){const s=this.b;return this.b++,this.a.set(s,$),this.c.$registerAiEmbeddingVectorProvider(A,s),new R.$JN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$Bqc=P}),define(Oe[68],Ne([1,0,5,29,7,22,3,16,50,4,10,23,15]),function(be,e,v,R,P,O,T,A,$,s,k,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=e.$Gpc=void 0,R=We(R);let d=S=class{constructor(o,c){this.b=new Map,this.c=new k.$Nh,this.a=o.getProxy(v.$HN.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(i){try{let n;const t=l.b.get(i.scheme);return t?(await l.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await l.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===R.FilePermission.Readonly?1:void 0}}catch(n){S.e(n)}},async readDirectory(i){try{const n=l.b.get(i.scheme);return n?(await l.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await l.a.$readdir(i)}catch(n){return S.e(n)}},async createDirectory(i){try{const n=l.b.get(i.scheme);return n&&!n.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(n.impl,n.extUri,i)):await l.a.$mkdir(i)}catch(n){return S.e(n)}},async readFile(i){try{const n=l.b.get(i.scheme);return n?(await l.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await l.a.$readFile(i)).buffer}catch(n){return S.e(n)}},async writeFile(i,n){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(t.impl,t.extUri,t.extUri.dirname(i)),await l.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await l.a.$writeFile(i,O.$Ne.wrap(n))}catch(t){return S.e(t)}},async delete(i,n){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await l.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await l.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return S.e(t)}},async rename(i,n,t){try{return await l.a.$rename(i,n,{overwrite:!1,...t})}catch(g){return S.e(g)}},async copy(i,n,t){try{return await l.a.$copy(i,n,{overwrite:!1,...t})}catch(g){return S.e(g)}},isWritableFileSystem(i){const n=c.getCapabilities(i);if(typeof n=="number")return!(n&R.FileSystemProviderCapabilities.Readonly)}})}async d(o,c,l){const i=[];for(;!c.isEqual(l,c.dirname(l));)try{if(!((await o.stat(l)).type&R.FileType.Directory))throw P.$3O.FileExists(`Unable to create folder '${l.scheme===a.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(R.$pl(n)!==R.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(c.basename(l)),l=c.dirname(l)}for(let n=i.length-1;n>=0;n--){l=c.joinPath(l,i[n]);try{await o.createDirectory(l)}catch(t){if(R.$pl(t)!==R.FileSystemProviderErrorCode.FileExists)throw t}}}static e(o){if(o instanceof P.$3O)throw o;if(o instanceof R.$ll)switch(o.code){case R.FileSystemProviderErrorCode.FileExists:throw P.$3O.FileExists(o.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$3O.FileNotFound(o.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$3O.FileNotADirectory(o.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$3O.FileIsADirectory(o.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$3O.NoPermissions(o.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$3O.Unavailable(o.message);default:throw new P.$3O(o.message,o.name)}if(!(o instanceof Error))throw new P.$3O(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$3O.Unavailable(o.message);switch(o.name){case R.FileSystemProviderErrorCode.FileExists:throw P.$3O.FileExists(o.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$3O.FileNotFound(o.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$3O.FileNotADirectory(o.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$3O.FileIsADirectory(o.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$3O.NoPermissions(o.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$3O.Unavailable(o.message);default:throw new P.$3O(o.message,o.name)}}addFileSystemProvider(o,c,l){return this.b.set(o,{impl:c,extUri:l?.isCaseSensitive?y.$8g:y.$0g,isReadonly:!!l?.isReadonly}),(0,s.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$8g}};e.$Gpc=d,e.$Gpc=d=S=Je([Ve(0,A.$hQ),Ve(1,$.$kpc)],d),e.$Hpc=(0,T.$Ei)("IExtHostConsumerFileSystem")}),define(Oe[91],Ne([1,0,3,26,11,68,2]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=e.$Ipc=void 0,e.$Ipc=(0,v.$Ei)("IExtensionStoragePaths");let A=class{constructor(s,k,y){this.d=k,this.f=y,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(s){return T.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,k=await this.g(s);try{return await this.f.value.stat(k),this.d.trace("[ExtHostStorage] storage dir already exists",k),k}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",k),await this.f.value.createDirectory(k),await this.f.value.writeFile(T.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:T.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),k}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(s){if(this.c)return T.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return T.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Jpc=A,e.$Jpc=A=Je([Ve(0,R.$xQ),Ve(1,P.$_j),Ve(2,O.$Hpc)],A)}),define(Oe[230],Ne([1,0,7,16,6]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0;let O=class{constructor(A){this.a=new v.$aP(v.ColorThemeKind.Dark),this.b=new P.$le}get activeColorTheme(){return this.a}$onColorThemeChange(A){let $;switch(A){case"light":$=v.ColorThemeKind.Light;break;case"hcDark":$=v.ColorThemeKind.HighContrast;break;case"hcLight":$=v.ColorThemeKind.HighContrastLight;break;default:$=v.ColorThemeKind.Dark}this.a=new v.$aP($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$grc=O,e.$grc=O=Je([Ve(0,R.$hQ)],O)}),define(Oe[92],Ne([1,0,21,6,4,9,3,11,183,5,26,16,7]),function(be,e,v,R,P,O,T,A,$,s,k,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fGb=e.$eGb=e.TunnelDtoConverter=void 0,O=We(O),a=We(a);class S extends $.$Nw{}var d;(function(o){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=c;function l(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=l})(d||(e.TunnelDtoConverter=d={})),e.$eGb=(0,T.$Ei)("IExtHostTunnelService");let r=class extends P.$Uc{constructor(c,l,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$le,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(s.$HN.MainThreadTunnelService)}async openTunnel(c,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const i=await this.a.$openTunnel(l,c.displayName);if(i){const n=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,l){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:l}),this.a.$registerPortsAttributesProvider(c,i),new a.$JN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,l,i,n,t){const g=[];for(const m of c){const p=this.r.get(m);if(!p)return[];g.push(...await Promise.all(l.map(async h=>{let E;try{E=await p.provider.providePortAttributes({port:h,pid:i,commandLine:n},t)}catch{E=await p.provider.providePortAttributes(h,i,n,t)}return{providedAttributes:E,port:h}})))}const u=g.filter(m=>!!m.providedAttributes);return u.length>0?u.map(m=>({autoForwardAction:m.providedAttributes.autoForwardAction,port:m.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await c.provideTunnel(n,t,v.CancellationToken.None)??void 0;const i=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions,protocol:l.tunnelFeatures.protocol===void 0?!0:l.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,l){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(l?this.w(l):void 0);if(i){this.b=i;let n=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:O.localize(10774,null),themeIcon:"lock"},{id:"public",label:O.localize(10775,null),themeIcon:"eye"}]);const t=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Sc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,l){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(l&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:n,disposeListener:t}),d.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const l=await Promise.all(c.map(n=>this.f(n.host,n.port,n.detail??""))),i=c.filter((n,t)=>l[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$fGb=r,e.$fGb=r=Je([Ve(0,y.$hQ),Ve(1,k.$xQ),Ve(2,A.$_j)],r)}),define(Oe[8],Ne([1,0,17,22,151,231,59,28,138,40,72,25,144,23,34,14,2,105,32,159,93,52,107,76,116,114,115,207,80,89,54,55,204,7]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u,m,p,h,E,D,w,I,C,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$eQ=ce,e.$fQ=ae,e.$gQ=Ie,T=We(T),l=We(l),i=We(i),n=We(n),E=We(E),w=We(w),b=We(b);var M;(function(De){function Re(G){const{selectionStartLineNumber:Ee,selectionStartColumn:Be,positionLineNumber:Ze,positionColumn:He}=G,ut=new b.$KN(Ee-1,Be-1),Pt=new b.$KN(Ze-1,He-1);return new b.$MN(ut,Pt)}De.to=Re;function he(G){const{anchor:Ee,active:Be}=G;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}De.from=he})(M||(e.Selection=M={}));var N;(function(De){function Re(G){if(!G)return;const{start:Ee,end:Be}=G;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}De.from=Re;function he(G){if(!G)return;const{startLineNumber:Ee,startColumn:Be,endLineNumber:Ze,endColumn:He}=G;return new b.$LN(Ee-1,Be-1,Ze-1,He-1)}De.to=he})(N||(e.Range=N={}));var F;(function(De){function Re(G){return{uri:G.uri,range:N.from(G.range)}}De.from=Re;function he(G){return new b.$XN(o.URI.revive(G.uri),N.to(G.range))}De.to=he})(F||(e.Location=F={}));var W;(function(De){function Re(he){switch(he){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}De.to=Re})(W||(e.TokenType=W={}));var K;(function(De){function Re(G){return new b.$KN(G.lineNumber-1,G.column-1)}De.to=Re;function he(G){return{lineNumber:G.line+1,column:G.character+1}}De.from=he})(K||(e.Position=K={}));var L;(function(De){function Re(Ee,Be,Ze){return(0,v.$Gb)((0,v.$1b)(Ee).map(He=>he(He,Be,Ze)))}De.from=Re;function he(Ee,Be,Ze){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ze?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:G(Ee.scheme,Be),pattern:xe.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ze?.isBuiltin}}function G(Ee,Be){return Be&&typeof Ee=="string"?Be.transformOutgoingScheme(Ee):Ee}})(L||(e.DocumentSelector=L={}));var Q;(function(De){function Re(G){switch(G){case b.DiagnosticTag.Unnecessary:return g.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return g.MarkerTag.Deprecated}}De.from=Re;function he(G){switch(G){case g.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case g.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}De.to=he})(Q||(e.DiagnosticTag=Q={}));var X;(function(De){function Re(G){let Ee;return G.code&&((0,r.$eg)(G.code)||(0,r.$ig)(G.code)?Ee=String(G.code):Ee={value:String(G.code.value),target:G.code.target}),{...N.from(G.range),message:G.message,source:G.source,code:Ee,severity:ee.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(ue.from),tags:Array.isArray(G.tags)?(0,v.$Gb)(G.tags.map(Q.from)):void 0}}De.from=Re;function he(G){const Ee=new b.$ZN(N.to(G),G.message,ee.to(G.severity));return Ee.source=G.source,Ee.code=(0,r.$eg)(G.code)?G.code:G.code?.value,Ee.relatedInformation=G.relatedInformation&&G.relatedInformation.map(ue.to),Ee.tags=G.tags&&(0,v.$Gb)(G.tags.map(Q.to)),Ee}De.to=he})(X||(e.Diagnostic=X={}));var ue;(function(De){function Re(G){return{...N.from(G.location.range),message:G.message,resource:G.location.uri}}De.from=Re;function he(G){return new b.$YN(new b.$XN(G.resource,N.to(G)),G.message)}De.to=he})(ue||(e.DiagnosticRelatedInformation=ue={}));var ee;(function(De){function Re(G){switch(G){case b.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}De.from=Re;function he(G){switch(G){case g.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}De.to=he})(ee||(e.DiagnosticSeverity=ee={}));var me;(function(De){function Re(G){return typeof G=="number"&&G>=b.ViewColumn.One?G-1:G===b.ViewColumn.Beside?f.$yE:f.$xE}De.from=Re;function he(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=he})(me||(e.ViewColumn=me={}));function oe(De){return typeof De.range<"u"}function ce(De){return De.length===0?!0:!!oe(De[0])}var we;(function(De){function Re(He){return He.map(De.from)}De.fromMany=Re;function he(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function G(He){let ut;if(he(He)){const{language:Ut,value:Zt}=He;ut={value:"```"+Ut+`
`+Zt+"\n```\n"}}else b.$bO.isMarkdownString(He)?ut={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ut={value:He}:ut={value:""};const Pt=Object.create(null);ut.uris=Pt;const Jt=Ut=>{try{let Zt=o.URI.parse(Ut,!0);Zt=Zt.with({query:Ee(Zt.query,Pt)}),Pt[Ut]=Zt}catch{}return""},si=new $.marked.Renderer;return si.link=Jt,si.image=Ut=>typeof Ut=="string"?Jt(T.$$k(Ut).href):"",(0,$.marked)(ut.value,{renderer:si}),ut}De.from=G;function Ee(He,ut){if(!He)return He;let Pt;try{Pt=(0,s.$ai)(He)}catch{}if(!Pt)return He;let Jt=!1;return Pt=(0,y.$fo)(Pt,si=>{if(o.URI.isUri(si)){const Ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ut]=si,Jt=!0,Ut}else return}),Jt?JSON.stringify(Pt):He}function Be(He){const ut=new b.$bO(He.value,He.supportThemeIcons);return ut.isTrusted=He.isTrusted,ut.supportHtml=He.supportHtml,ut.baseUri=He.baseUri?o.URI.from(He.baseUri):void 0,ut}De.to=Be;function Ze(He){if(He)return typeof He=="string"?He:De.from(He)}De.fromStrict=Ze})(we||(e.MarkdownString=we={}));function ae(De){return ce(De)?De.map(Re=>({range:N.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?we.fromMany(Re.hoverMessage):Re.hoverMessage?we.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):De.map(Re=>({range:N.from(Re)}))}function Ie(De){return typeof De>"u"?De:typeof De=="string"?o.URI.file(De):De}var Fe;(function(De){function Re(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?Ie(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}De.from=Re})(Fe||(e.ThemableDecorationAttachmentRenderOptions=Fe={}));var Y;(function(De){function Re(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?Ie(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?Fe.from(he.before):void 0,after:he.after?Fe.from(he.after):void 0}}De.from=Re})(Y||(e.ThemableDecorationRenderOptions=Y={}));var q;(function(De){function Re(he){if(typeof he>"u")return he;switch(he){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}De.from=Re})(q||(e.DecorationRangeBehavior=q={}));var ne;(function(De){function Re(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?q.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?Y.from(he.light):void 0,dark:he.dark?Y.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?Ie(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?Fe.from(he.before):void 0,after:he.after?Fe.from(he.after):void 0}}De.from=Re})(ne||(e.DecorationRenderOptions=ne={}));var ye;(function(De){function Re(G){return{text:G.newText,eol:G.newEol&&je.from(G.newEol),range:N.from(G.range)}}De.from=Re;function he(G){const Ee=new b.$SN(N.to(G.range),G.text);return Ee.newEol=typeof G.eol>"u"?void 0:je.to(G.eol),Ee}De.to=he})(ye||(e.TextEdit=ye={}));var le;(function(De){function Re(G,Ee){const Be={edits:[]};if(G instanceof b.$VN){const Ze=new A.$Bc;for(const He of G._allEntries())He._type===b.FileEditType.File&&o.URI.isUri(He.to)&&He.from===void 0&&Ze.add(He.to);for(const He of G._allEntries())if(He._type===b.FileEditType.File){let ut;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ut={type:"base64",value:(0,R.$8e)(R.$Ne.wrap(He.options.contents))}:ut={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ut},metadata:He.metadata})}else He._type===b.FileEditType.Text?Be.edits.push({resource:He.uri,textEdit:ye.from(He.edit),versionId:Ze.has(He.uri)?void 0:Ee?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===b.FileEditType.Snippet?Be.edits.push({resource:He.uri,textEdit:{range:N.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ze.has(He.uri)?void 0:Ee?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===b.FileEditType.Cell?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(He.uri)}):He._type===b.FileEditType.CellReplace&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:w.CellEditType.Replace,index:He.index,count:He.count,cells:He.cells.map(Rt.from)}})}return Be}De.from=Re;function he(G){const Ee=new b.$VN,Be=new A.$Ac;for(const Ze of G.edits)if(Ze.textEdit){const He=Ze,ut=o.URI.revive(He.resource),Pt=N.to(He.textEdit.range),Jt=He.textEdit.text,si=He.textEdit.insertAsSnippet;let Ut;si?Ut=b.$UN.replace(Pt,new b.$WN(Jt)):Ut=b.$SN.replace(Pt,Jt);const Zt=Be.get(ut);Zt?Zt.push(Ut):Be.set(ut,[Ut])}else Ee.renameFile(o.URI.revive(Ze.oldResource),o.URI.revive(Ze.newResource),Ze.options);for(const[Ze,He]of Be)Ee.set(Ze,He);return Ee}De.to=he})(le||(e.WorkspaceEdit=le={}));var ve;(function(De){const Re=Object.create(null);Re[b.SymbolKind.File]=n.SymbolKind.File,Re[b.SymbolKind.Module]=n.SymbolKind.Module,Re[b.SymbolKind.Namespace]=n.SymbolKind.Namespace,Re[b.SymbolKind.Package]=n.SymbolKind.Package,Re[b.SymbolKind.Class]=n.SymbolKind.Class,Re[b.SymbolKind.Method]=n.SymbolKind.Method,Re[b.SymbolKind.Property]=n.SymbolKind.Property,Re[b.SymbolKind.Field]=n.SymbolKind.Field,Re[b.SymbolKind.Constructor]=n.SymbolKind.Constructor,Re[b.SymbolKind.Enum]=n.SymbolKind.Enum,Re[b.SymbolKind.Interface]=n.SymbolKind.Interface,Re[b.SymbolKind.Function]=n.SymbolKind.Function,Re[b.SymbolKind.Variable]=n.SymbolKind.Variable,Re[b.SymbolKind.Constant]=n.SymbolKind.Constant,Re[b.SymbolKind.String]=n.SymbolKind.String,Re[b.SymbolKind.Number]=n.SymbolKind.Number,Re[b.SymbolKind.Boolean]=n.SymbolKind.Boolean,Re[b.SymbolKind.Array]=n.SymbolKind.Array,Re[b.SymbolKind.Object]=n.SymbolKind.Object,Re[b.SymbolKind.Key]=n.SymbolKind.Key,Re[b.SymbolKind.Null]=n.SymbolKind.Null,Re[b.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,Re[b.SymbolKind.Struct]=n.SymbolKind.Struct,Re[b.SymbolKind.Event]=n.SymbolKind.Event,Re[b.SymbolKind.Operator]=n.SymbolKind.Operator,Re[b.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function he(Ee){return typeof Re[Ee]=="number"?Re[Ee]:n.SymbolKind.Property}De.from=he;function G(Ee){for(const Be in Re)if(Re[Be]===Ee)return Number(Be);return b.SymbolKind.Property}De.to=G})(ve||(e.SymbolKind=ve={}));var de;(function(De){function Re(G){switch(G){case b.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}De.from=Re;function he(G){switch(G){case n.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}De.to=he})(de||(e.SymbolTag=de={}));var J;(function(De){function Re(G){return{name:G.name,kind:ve.from(G.kind),tags:G.tags&&G.tags.map(de.from),containerName:G.containerName,location:Ue.from(G.location)}}De.from=Re;function he(G){const Ee=new b.$5N(G.name,ve.to(G.kind),G.containerName,Ue.to(G.location));return Ee.tags=G.tags&&G.tags.map(de.to),Ee}De.to=he})(J||(e.WorkspaceSymbol=J={}));var x;(function(De){function Re(G){const Ee={name:G.name||"!!MISSING: name!!",detail:G.detail,range:N.from(G.range),selectionRange:N.from(G.selectionRange),kind:ve.from(G.kind),tags:G.tags?.map(de.from)??[]};return G.children&&(Ee.children=G.children.map(Re)),Ee}De.from=Re;function he(G){const Ee=new b.$6N(G.name,G.detail,ve.to(G.kind),N.to(G.range),N.to(G.selectionRange));return(0,v.$Kb)(G.tags)&&(Ee.tags=G.tags.map(de.to)),G.children&&(Ee.children=G.children.map(he)),Ee}De.to=he})(x||(e.DocumentSymbol=x={}));var pe;(function(De){function Re(G){const Ee=new b.$0N(ve.to(G.kind),G.name,G.detail||"",o.URI.revive(G.uri),N.to(G.range),N.to(G.selectionRange));return Ee._sessionId=G._sessionId,Ee._itemId=G._itemId,Ee}De.to=Re;function he(G,Ee,Be){if(Ee=Ee??G._sessionId,Be=Be??G._itemId,Ee===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Be,name:G.name,detail:G.detail,kind:ve.from(G.kind),uri:G.uri,range:N.from(G.range),selectionRange:N.from(G.selectionRange),tags:G.tags?.map(de.from)}}De.from=he})(pe||(e.CallHierarchyItem=pe={}));var $e;(function(De){function Re(he){return new b.$$N(pe.to(he.from),he.fromRanges.map(G=>N.to(G)))}De.to=Re})($e||(e.CallHierarchyIncomingCall=$e={}));var Ae;(function(De){function Re(he){return new b.$_N(pe.to(he.to),he.fromRanges.map(G=>N.to(G)))}De.to=Re})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var Ue;(function(De){function Re(G){return{range:G.range&&N.from(G.range),uri:G.uri}}De.from=Re;function he(G){return new b.$XN(o.URI.revive(G.uri),N.to(G.range))}De.to=he})(Ue||(e.location=Ue={}));var ke;(function(De){function Re(G){const Ee=G,Be=G;return{originSelectionRange:Ee.originSelectionRange?N.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:Be.uri,range:N.from(Ee.targetRange?Ee.targetRange:Be.range),targetSelectionRange:Ee.targetSelectionRange?N.from(Ee.targetSelectionRange):void 0}}De.from=Re;function he(G){return{targetUri:o.URI.revive(G.uri),targetRange:N.to(G.range),targetSelectionRange:G.targetSelectionRange?N.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?N.to(G.originSelectionRange):void 0}}De.to=he})(ke||(e.DefinitionLink=ke={}));var Pe;(function(De){function Re(G){return{range:N.from(G.range),contents:we.fromMany(G.contents),canIncreaseVerbosity:G.canIncreaseVerbosity,canDecreaseVerbosity:G.canDecreaseVerbosity}}De.from=Re;function he(G){const Ee=G.contents.map(we.to),Be=N.to(G.range),Ze=G.canIncreaseVerbosity,He=G.canDecreaseVerbosity;return new b.$2N(Ee,Be,Ze,He)}De.to=he})(Pe||(e.Hover=Pe={}));var Te;(function(De){function Re(G){return{range:N.from(G.range),expression:G.expression}}De.from=Re;function he(G){return new b.$WO(N.to(G.range),G.expression)}De.to=he})(Te||(e.EvaluatableExpression=Te={}));var j;(function(De){function Re(G){if(G instanceof b.$XO)return{type:"text",range:N.from(G.range),text:G.text};if(G instanceof b.$YO)return{type:"variable",range:N.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof b.$ZO)return{type:"expression",range:N.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Re;function he(G){switch(G.type){case"text":return{range:N.to(G.range),text:G.text};case"variable":return{range:N.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:N.to(G.range),expression:G.expression}}}De.to=he})(j||(e.InlineValue=j={}));var B;(function(De){function Re(G){return{frameId:G.frameId,stoppedLocation:N.from(G.stoppedLocation)}}De.from=Re;function he(G){return new b.$1O(G.frameId,N.to(G.stoppedLocation))}De.to=he})(B||(e.InlineValueContext=B={}));var H;(function(De){function Re(G){return{range:N.from(G.range),kind:G.kind}}De.from=Re;function he(G){return new b.$3N(N.to(G.range),G.kind)}De.to=he})(H||(e.DocumentHighlight=H={}));var V;(function(De){function Re(G){return{uri:G.uri,highlights:G.highlights.map(H.from)}}De.from=Re;function he(G){return new b.$4N(o.URI.revive(G.uri),G.highlights.map(H.to))}De.to=he})(V||(e.MultiDocumentHighlight=V={}));var re;(function(De){function Re(he){switch(he){case n.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}De.to=Re})(re||(e.CompletionTriggerKind=re={}));var ge;(function(De){function Re(he){return{triggerKind:re.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}De.to=Re})(ge||(e.CompletionContext=ge={}));var Ce;(function(De){function Re(G){switch(G){case b.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}De.from=Re;function he(G){switch(G){case n.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}De.to=he})(Ce||(e.CompletionItemTag=Ce={}));var ze;(function(De){const Re=new Map([[b.CompletionItemKind.Method,n.CompletionItemKind.Method],[b.CompletionItemKind.Function,n.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,n.CompletionItemKind.Field],[b.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[b.CompletionItemKind.Class,n.CompletionItemKind.Class],[b.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[b.CompletionItemKind.Module,n.CompletionItemKind.Module],[b.CompletionItemKind.Property,n.CompletionItemKind.Property],[b.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[b.CompletionItemKind.Value,n.CompletionItemKind.Value],[b.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,n.CompletionItemKind.Text],[b.CompletionItemKind.Color,n.CompletionItemKind.Color],[b.CompletionItemKind.File,n.CompletionItemKind.File],[b.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[b.CompletionItemKind.Event,n.CompletionItemKind.Event],[b.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[b.CompletionItemKind.User,n.CompletionItemKind.User]]);function he(Be){return Re.get(Be)??n.CompletionItemKind.Property}De.from=he;const G=new Map([[n.CompletionItemKind.Method,b.CompletionItemKind.Method],[n.CompletionItemKind.Function,b.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,b.CompletionItemKind.Field],[n.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[n.CompletionItemKind.Class,b.CompletionItemKind.Class],[n.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[n.CompletionItemKind.Module,b.CompletionItemKind.Module],[n.CompletionItemKind.Property,b.CompletionItemKind.Property],[n.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[n.CompletionItemKind.Value,b.CompletionItemKind.Value],[n.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,b.CompletionItemKind.Text],[n.CompletionItemKind.Color,b.CompletionItemKind.Color],[n.CompletionItemKind.File,b.CompletionItemKind.File],[n.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[n.CompletionItemKind.Event,b.CompletionItemKind.Event],[n.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,b.CompletionItemKind.User],[n.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Ee(Be){return G.get(Be)??b.CompletionItemKind.Property}De.to=Ee})(ze||(e.CompletionItemKind=ze={}));var Qe;(function(De){function Re(he,G){const Ee=new b.$hO(he.label);return Ee.insertText=he.insertText,Ee.kind=ze.to(he.kind),Ee.tags=he.tags?.map(Ce.to),Ee.detail=he.detail,Ee.documentation=T.$5k(he.documentation)?we.to(he.documentation):he.documentation,Ee.sortText=he.sortText,Ee.filterText=he.filterText,Ee.preselect=he.preselect,Ee.commitCharacters=he.commitCharacters,l.$Nt.isIRange(he.range)?Ee.range=N.to(he.range):typeof he.range=="object"&&(Ee.range={inserting:N.to(he.range.insert),replacing:N.to(he.range.replace)}),Ee.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof he.insertTextRules<"u"&&he.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?Ee.insertText=new b.$WN(he.insertText):(Ee.insertText=he.insertText,Ee.textEdit=Ee.range instanceof b.$LN?new b.$SN(Ee.range,Ee.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Ee.additionalTextEdits=he.additionalTextEdits.map(Be=>ye.to(Be))),Ee.command=G&&he.command?G.fromInternal(he.command):void 0,Ee}De.to=Re})(Qe||(e.CompletionItem=Qe={}));var _e;(function(De){function Re(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:we.fromStrict(G.documentation)}}De.from=Re;function he(G){return{label:G.label,documentation:T.$5k(G.documentation)?we.to(G.documentation):G.documentation}}De.to=he})(_e||(e.ParameterInformation=_e={}));var tt;(function(De){function Re(G){return{label:G.label,documentation:we.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(_e.from):[],activeParameter:G.activeParameter}}De.from=Re;function he(G){return{label:G.label,documentation:T.$5k(G.documentation)?we.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(_e.to):[],activeParameter:G.activeParameter}}De.to=he})(tt||(e.SignatureInformation=tt={}));var nt;(function(De){function Re(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(tt.from):[]}}De.from=Re;function he(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(tt.to):[]}}De.to=he})(nt||(e.SignatureHelp=nt={}));var et;(function(De){function Re(he,G){const Ee=new b.$gO(K.to(G.position),typeof G.label=="string"?G.label:G.label.map(rt.to.bind(void 0,he)),G.kind&&ft.to(G.kind));return Ee.textEdits=G.textEdits&&G.textEdits.map(ye.to),Ee.tooltip=T.$5k(G.tooltip)?we.to(G.tooltip):G.tooltip,Ee.paddingLeft=G.paddingLeft,Ee.paddingRight=G.paddingRight,Ee}De.to=Re})(et||(e.InlayHint=et={}));var rt;(function(De){function Re(he,G){const Ee=new b.$fO(G.label);return Ee.tooltip=T.$5k(G.tooltip)?we.to(G.tooltip):G.tooltip,n.Command.is(G.command)&&(Ee.command=he.fromInternal(G.command)),G.location&&(Ee.location=Ue.to(G.location)),Ee}De.to=Re})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(De){function Re(G){return G}De.from=Re;function he(G){return G}De.to=he})(ft||(e.InlayHintKind=ft={}));var lt;(function(De){function Re(G){return{range:N.from(G.range),url:G.target,tooltip:G.tooltip}}De.from=Re;function he(G){let Ee;if(G.url)try{Ee=typeof G.url=="string"?o.URI.parse(G.url,!0):o.URI.revive(G.url)}catch{}const Be=new b.$mO(N.to(G.range),Ee);return Be.tooltip=G.tooltip,Be}De.to=he})(lt||(e.DocumentLink=lt={}));var st;(function(De){function Re(G){const Ee=new b.$pO(G.label);return G.textEdit&&(Ee.textEdit=ye.to(G.textEdit)),G.additionalTextEdits&&(Ee.additionalTextEdits=G.additionalTextEdits.map(Be=>ye.to(Be))),Ee}De.to=Re;function he(G){return{label:G.label,textEdit:G.textEdit?ye.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ee=>ye.from(Ee)):void 0}}De.from=he})(st||(e.ColorPresentation=st={}));var ct;(function(De){function Re(G){return new b.$nO(G[0],G[1],G[2],G[3])}De.to=Re;function he(G){return[G.red,G.green,G.blue,G.alpha]}De.from=he})(ct||(e.Color=ct={}));var gt;(function(De){function Re(G){return{range:N.from(G.range)}}De.from=Re;function he(G){return new b.$9N(N.to(G.range))}De.to=he})(gt||(e.SelectionRange=gt={}));var $t;(function(De){function Re(he){switch(he){case p.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case p.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case p.SaveReason.FOCUS_CHANGE:case p.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}De.to=Re})($t||(e.TextDocumentSaveReason=$t={}));var qe;(function(De){function Re(G){switch(G){case b.TextEditorLineNumbersStyle.Off:return c.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return c.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return c.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return c.RenderLineNumbersType.On}}De.from=Re;function he(G){switch(G){case c.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case c.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case c.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case c.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}De.to=he})(qe||(e.TextEditorLineNumbersStyle=qe={}));var je;(function(De){function Re(G){if(G===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(G===b.EndOfLine.LF)return t.EndOfLineSequence.LF}De.from=Re;function he(G){if(G===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(G===t.EndOfLineSequence.LF)return b.EndOfLine.LF}De.to=he})(je||(e.EndOfLine=je={}));var te;(function(De){function Re(he){if(typeof he=="object")return he.viewId;switch(he){case b.ProgressLocation.SourceControl:return u.ProgressLocation.Scm;case b.ProgressLocation.Window:return u.ProgressLocation.Window;case b.ProgressLocation.Notification:return u.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}De.from=Re})(te||(e.ProgressLocation=te={}));var _;(function(De){function Re(G){const Ee={start:G.start+1,end:G.end+1};return G.kind&&(Ee.kind=Z.from(G.kind)),Ee}De.from=Re;function he(G){const Ee={start:G.start-1,end:G.end-1};return G.kind&&(Ee.kind=Z.to(G.kind)),Ee}De.to=he})(_||(e.FoldingRange=_={}));var Z;(function(De){function Re(G){if(G)switch(G){case b.FoldingRangeKind.Comment:return n.$Ou.Comment;case b.FoldingRangeKind.Imports:return n.$Ou.Imports;case b.FoldingRangeKind.Region:return n.$Ou.Region}}De.from=Re;function he(G){if(G)switch(G.value){case n.$Ou.Comment.value:return b.FoldingRangeKind.Comment;case n.$Ou.Imports.value:return b.FoldingRangeKind.Imports;case n.$Ou.Region.value:return b.FoldingRangeKind.Region}}De.to=he})(Z||(e.FoldingRangeKind=Z={}));var Xe;(function(De){function Re(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?N.from(he.selection):void 0,override:typeof he.override=="boolean"?p.$4F.id:void 0}}De.from=Re})(Xe||(e.TextEditorOpenOptions=Xe={}));var xe;(function(De){function Re(Be){return Be instanceof b.$KO?Be.toJSON():typeof Be=="string"?Be:he(Be)||G(Be)?new b.$KO(Be.baseUri??Be.base,Be.pattern).toJSON():Be}De.from=Re;function he(Be){const Ze=Be;return Ze?o.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function G(Be){const Ze=Be;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ee(Be){return typeof Be=="string"?Be:new b.$KO(o.URI.revive(Be.baseUri),Be.pattern)}De.to=Ee})(xe||(e.GlobPattern=xe={}));var ht;(function(De){function Re(he){if(he){if(Array.isArray(he))return he.map(Re);if(typeof he=="string")return he;{const G=he;return{language:G.language,scheme:G.scheme,pattern:xe.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}De.from=Re})(ht||(e.LanguageSelector=ht={}));var bt;(function(De){function Re(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&o.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ze=>Ze instanceof b.$LN)))}De.is=Re;function he(G){return{documents:G.documents.map(Ee=>Ee.map(Be=>({uri:o.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ze=>N.from(Ze))})))}}De.from=he})(bt||(e.MappedEditsContext=bt={}));var Ft;(function(De){function Re(G){return{start:G.start,end:G.end}}De.from=Re;function he(G){return new b.$bP(G.start,G.end)}De.to=he})(Ft||(e.NotebookRange=Ft={}));var Ht;(function(De){function Re(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}De.to=Re;function he(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}De.from=he})(Ht||(e.NotebookCellExecutionSummary=Ht={}));var _t;(function(De){function Re(he){if(he===w.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(he===w.NotebookCellExecutionState.Pending)return;if(he===w.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}De.to=Re})(_t||(e.NotebookCellExecutionState=_t={}));var ei;(function(De){function Re(G){switch(G){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}De.from=Re;function he(G){switch(G){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}De.to=he})(ei||(e.NotebookCellKind=ei={}));var oi;(function(De){function Re(G){const Ee={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)b.$cP.validate(Be),Ee.cells.push(Rt.from(Be));return Ee}De.from=Re;function he(G){const Ee=new b.$dP(G.cells.map(Rt.to));return(0,r.$rg)(G.metadata)||(Ee.metadata=G.metadata),Ee}De.to=he})(oi||(e.NotebookData=oi={}));var Rt;(function(De){function Re(G){return{cellKind:ei.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Ht.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Mt.from):[]}}De.from=Re;function he(G){return new b.$cP(ei.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Mt.to):void 0,G.metadata,G.internalMetadata?Ht.to(G.internalMetadata):void 0)}De.to=he})(Rt||(e.NotebookCellData=Rt={}));var Ye;(function(De){function Re(G){return{mime:G.mime,valueBytes:R.$Ne.wrap(G.data)}}De.from=Re;function he(G){return new b.$eP(G.valueBytes.buffer,G.mime)}De.to=he})(Ye||(e.NotebookCellOutputItem=Ye={}));var Mt;(function(De){function Re(G){return{outputId:G.id,items:G.items.map(Ye.from),metadata:G.metadata}}De.from=Re;function he(G){const Ee=G.items.map(Ye.to);return new b.$fP(Ee,G.outputId,G.metadata)}De.to=he})(Mt||(e.NotebookCellOutput=Mt={}));var hi;(function(De){function Re(Ee){return G(Ee)?{include:xe.from(Ee.include)??void 0,exclude:xe.from(Ee.exclude)??void 0}:xe.from(Ee)??void 0}De.from=Re;function he(Ee){return G(Ee)?{include:xe.to(Ee.include),exclude:xe.to(Ee.exclude)}:xe.to(Ee)}De.to=he;function G(Ee){const Be=Ee;return Be?!(0,r.$ng)(Be.include)&&!(0,r.$ng)(Be.exclude):!1}})(hi||(e.NotebookExclusiveDocumentPattern=hi={}));var mt;(function(De){function Re(he,G,Ee){const Be=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===b.NotebookCellStatusBarAlignment.Left?w.CellStatusbarAlignment.Left:w.CellStatusbarAlignment.Right,command:G.toInternal(Be,Ee),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}De.from=Re})(mt||(e.NotebookStatusBarItem=mt={}));var Et;(function(De){function Re(he,G,Ee){const Be=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:G.toInternal(Be,Ee),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}De.from=Re})(Et||(e.NotebookKernelSourceAction=Et={}));var ti;(function(De){function Re(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}De.from=Re})(ti||(e.NotebookDocumentContentOptions=ti={}));var ii;(function(De){function Re(G){return{uri:G.uri,provides:G.provides}}De.from=Re;function he(G){return new b.$hP(o.URI.revive(G.uri),G.provides)}De.to=he})(ii||(e.NotebookRendererScript=ii={}));var jt;(function(De){function Re(G){return{message:we.fromStrict(G.message)||"",type:C.TestMessageType.Error,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:N.from(G.location.range),uri:G.location.uri},stackTrace:G.stackTrace?.map(Ee=>({label:Ee.label,position:Ee.position&&K.from(Ee.position),uri:Ee.file&&o.URI.revive(Ee.file).toJSON()}))}}De.from=Re;function he(G){const Ee=new b.$nP(typeof G.message=="string"?G.message:we.to(G.message));return Ee.actualOutput=G.actual,Ee.expectedOutput=G.expected,Ee.contextValue=G.contextValue,Ee.location=G.location?Ue.to(G.location):void 0,Ee}De.to=he})(jt||(e.TestMessage=jt={}));var pt;(function(De){De.namespace=C.$0I,De.denamespace=C.$$I})(pt||(e.TestTag=pt={}));var zt;(function(De){function Re(G){const Ee=(0,m.$dQ)(G).controllerId;return{extId:I.$5I.fromExtHostTestItem(G,Ee).toString(),label:G.label,uri:o.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>pt.namespace(Ee,Be.id)),range:l.$Nt.lift(N.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&we.fromStrict(G.error)||null}}De.from=Re;function he(G){return{parent:void 0,error:void 0,id:I.$5I.fromString(G.extId).localId,label:G.label,uri:o.URI.revive(G.uri),tags:(G.tags||[]).map(Ee=>{const{tagId:Be}=pt.denamespace(Ee);return new b.$oP(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}De.toPlain=he})(zt||(e.TestItem=zt={})),function(De){function Re(G){return{id:G.id}}De.from=Re;function he(G){return new b.$oP(G.id)}De.to=he}(pt||(e.TestTag=pt={}));var ni;(function(De){const Re=(G,Ee)=>{const Be=G.value;if(!Be)return;const Ze={...zt.toPlain(Be.item),parent:Ee,taskStates:Be.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ut=>ut.type===C.TestMessageType.Error).map(jt.to)})),children:[]};if(G.children)for(const He of G.children.values()){const ut=Re(He,Ze);ut&&Ze.children.push(ut)}return Ze};function he(G){const Ee=new a.$4I;for(const He of G.items)Ee.insert(I.$5I.fromString(He.item.extId).path,He);const Be=[Ee.nodes],Ze=[];for(;Be.length;)for(const He of Be.pop())He.value?Ze.push(He):He.children&&Be.push(He.children.values());return{completedAt:G.completedAt,results:Ze.map(He=>Re(He)).filter(r.$mg)}}De.to=he})(ni||(e.TestResults=ni={}));var ai;(function(De){function Re(Be){return{covered:Be.covered,total:Be.total}}function he(Be){return"line"in Be?K.from(Be):N.from(Be)}function G(Be){if(typeof Be.executed=="number"&&Be.executed<0)throw new Error(`Invalid coverage count ${Be.executed}`);return"branches"in Be?{count:Be.executed,location:he(Be.location),type:C.DetailType.Statement,branches:Be.branches.length?Be.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&he(Ze.location),label:Ze.label})):void 0}:{type:C.DetailType.Declaration,name:Be.name,count:Be.executed,location:he(Be.location)}}De.fromDetails=G;function Ee(Be,Ze,He){return b.$rP(He.statementCoverage),b.$rP(He.branchCoverage),b.$rP(He.declarationCoverage),{id:Ze,uri:He.uri,statement:Re(He.statementCoverage),branch:He.branchCoverage&&Re(He.branchCoverage),declaration:He.declarationCoverage&&Re(He.declarationCoverage),testIds:He instanceof b.$sP&&He.fromTests.length?He.fromTests.map(ut=>I.$5I.fromExtHostTestItem(ut,Be).toString()):void 0}}De.fromFile=Ee})(ai||(e.TestCoverage=ai={}));var Ge;(function(De){function Re(he){switch(he){case n.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}De.to=Re})(Ge||(e.CodeActionTriggerKind=Ge={}));var ci;(function(De){function Re(G){const Ee=new b.$wP(ve.to(G.kind),G.name,G.detail||"",o.URI.revive(G.uri),N.to(G.range),N.to(G.selectionRange));return Ee._sessionId=G._sessionId,Ee._itemId=G._itemId,Ee}De.to=Re;function he(G,Ee,Be){if(Ee=Ee??G._sessionId,Be=Be??G._itemId,Ee===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Be,kind:ve.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:N.from(G.range),selectionRange:N.from(G.selectionRange),tags:G.tags?.map(de.from)}}De.from=he})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(De){function Re(he){if(he)return{value:he.value,tooltip:he.tooltip}}De.from=Re})(di||(e.ViewBadge=di={}));var fi;(function(De){function Re(Be,Ze,He){const ut=Ze.fileData;return ut?new b.$CO(new b.$DO(ut.name,o.URI.revive(ut.uri),ut.id,(0,O.$cb)(()=>He(ut.id)))):Be===k.$0s.uriList&&Ze.uriListData?new b.$BO(Ee(Ze.uriListData)):new b.$BO(Ze.asString)}De.to=Re;async function he(Be,Ze){const He=await Ze.asString();if(Be===k.$0s.uriList)return{asString:He,fileData:void 0,uriListData:G(He)};const ut=Ze.asFile();return{asString:He,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}De.from=he;function G(Be){return P.$su.split(Be).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return o.URI.parse(Ze)}catch{}return Ze})}function Ee(Be){return P.$su.create(Be.map(Ze=>typeof Ze=="string"?Ze:o.URI.revive(Ze)))}})(fi||(e.DataTransferItem=fi={}));var vt;(function(De){function Re(G,Ee){const Be=G.items.map(([Ze,He])=>[Ze,fi.to(Ze,He,Ee)]);return new b.$EO(Be)}De.toDataTransfer=Re;async function he(G){const Ee={items:[]},Be=[];for(const[Ze,He]of G)Be.push((async()=>{Ee.items.push([Ze,await fi.from(Ze,He)])})());return await Promise.all(Be),Ee}De.from=he})(vt||(e.DataTransfer=vt={}));var Lt;(function(De){function Re(G,Ee){return{kind:"reply",agentId:G.participant??Ee?.agentId??"",subCommand:G.command??Ee?.command,message:G.prompt,title:G.label}}De.from=Re;function he(G){return{prompt:G.message,label:G.title,participant:G.agentId,command:G.subCommand}}De.to=he})(Lt||(e.ChatFollowup=Lt={}));var Tt;(function(De){function Re(G){switch(G){case E.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}De.to=Re;function he(G){switch(G){case b.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}De.from=he})(Tt||(e.LanguageModelChatMessageRole=Tt={}));var Wt;(function(De){function Re(G){let Ee="",Be;G.content.type==="text"?Ee=G.content.value:Be=new b.$1P(G.content.name,G.content.value,G.content.isError);const Ze=Tt.to(G.role),He=new b.$2P(Ze,Ee,G.name);return Be!==void 0&&(He.content2=Be),He}De.to=Re;function he(G){const Ee=Tt.from(G.role),Be=G.name;let Ze;return G.content2 instanceof b.$1P?Ze={type:"function_result",name:G.content2.name,value:G.content2.content,isError:G.content2.isError}:Ze={type:"text",value:G.content},{role:Ee,name:Be,content:Ze}}De.from=he})(Wt||(e.LanguageModelChatMessage=Wt={}));var ri;(function(De){function Re(G){return{kind:"markdownContent",content:we.from(G.value)}}De.from=Re;function he(G){return new b.$JP(we.to(G.content))}De.to=he})(ri||(e.ChatResponseMarkdownPart=ri={}));var Kt;(function(De){function Re(G){return{kind:"markdownVuln",content:we.from(G.value),vulnerabilities:G.vulnerabilities}}De.from=Re;function he(G){return new b.$KP(we.to(G.content),G.vulnerabilities)}De.to=he})(Kt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Kt={}));var li;(function(De){function Re(G){return{kind:"agentDetection",agentId:G.participant,command:G.command}}De.from=Re;function he(G){return new b.$LP(G.agentId,G.command)}De.to=he})(li||(e.ChatResponseDetectedParticipantPart=li={}));var Bt;(function(De){function Re(he){return{kind:"confirmation",title:he.title,message:he.message,data:he.data,buttons:he.buttons}}De.from=Re})(Bt||(e.ChatResponseConfirmationPart=Bt={}));var Qt;(function(De){function Re(G){const{value:Ee,baseUri:Be}=G;function Ze(He,ut){return He.map(Pt=>{const Jt=o.URI.joinPath(ut,Pt.name);return{label:Pt.name,uri:Jt,children:Pt.children&&Ze(Pt.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,S.$ch)(Be),uri:Be,children:Ze(Ee,Be)}}}De.from=Re;function he(G){const Ee=(0,s.$bi)(G.treeData);function Be(ut){return ut.map(Pt=>({name:Pt.label,children:Pt.children&&Be(Pt.children)}))}const Ze=Ee.uri,He=Ee.children?Be(Ee.children):[];return new b.$NP(He,Ze)}De.to=he})(Qt||(e.ChatResponseFilesPart=Qt={}));var Gt;(function(De){function Re(G){const Ee=Be=>o.URI.isUri(Be);return{kind:"inlineReference",name:G.title,inlineReference:Ee(G.value)?G.value:F.from(G.value)}}De.from=Re;function he(G){const Ee=(0,s.$bi)(G);return new b.$OP(o.URI.isUri(Ee.inlineReference)?Ee.inlineReference:F.to(Ee.inlineReference),G.name)}De.to=he})(Gt||(e.ChatResponseAnchorPart=Gt={}));var Nt;(function(De){function Re(G){return{kind:"progressMessage",content:we.from(G.value)}}De.from=Re;function he(G){return new b.$PP(G.content.value)}De.to=he})(Nt||(e.ChatResponseProgressPart=Nt={}));var wt;(function(De){function Re(G){return{kind:"warning",content:we.from(G.value)}}De.from=Re;function he(G){return new b.$RP(G.content.value)}De.to=he})(wt||(e.ChatResponseWarningPart=wt={}));var kt;(function(De){function Re(he){return{kind:"progressTask",content:we.from(he.value)}}De.from=Re})(kt||(e.ChatTask=kt={}));var Vt;(function(De){function Re(he){return{kind:"progressTaskResult",content:typeof he=="string"?we.from(he):void 0}}De.from=Re})(Vt||(e.ChatTaskResult=Vt={}));var It;(function(De){function Re(G,Ee,Be){return{kind:"command",command:Ee.toInternal(G.value,Be)??{command:G.value.command,title:G.value.title}}}De.from=Re;function he(G,Ee){return new b.$SP(Ee.fromInternal(G.command)??{command:G.command.id,title:G.command.title})}De.to=he})(It||(e.ChatResponseCommandButtonPart=It={}));var gi;(function(De){function Re(G){return{kind:"textEdit",uri:G.uri,edits:G.edits.map(Ee=>ye.from(Ee))}}De.from=Re;function he(G){return new b.$VP(o.URI.revive(G.uri),G.edits.map(Ee=>ye.to(Ee)))}De.to=he})(gi||(e.ChatResponseTextEditPart=gi={}));var Yt;(function(De){function Re(G){const Ee=d.ThemeIcon.isThemeIcon(G.iconPath)?G.iconPath:o.URI.isUri(G.iconPath)?{light:o.URI.revive(G.iconPath)}:G.iconPath&&"light"in G.iconPath&&"dark"in G.iconPath&&o.URI.isUri(G.iconPath.light)&&o.URI.isUri(G.iconPath.dark)?{light:o.URI.revive(G.iconPath.light),dark:o.URI.revive(G.iconPath.dark)}:void 0;return"variableName"in G.value?{kind:"reference",reference:{variableName:G.value.variableName,value:o.URI.isUri(G.value.value)||!G.value.value?G.value.value:F.from(G.value.value)},iconPath:Ee,options:G.options}:{kind:"reference",reference:o.URI.isUri(G.value)?G.value:F.from(G.value),iconPath:Ee,options:G.options}}De.from=Re;function he(G){const Ee=(0,s.$bi)(G),Be=Ze=>o.URI.isUri(Ze)?Ze:F.to(Ze);return new b.$TP("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&Be(Ee.reference.value)}:Be(Ee.reference))}De.to=he})(Yt||(e.ChatResponseReferencePart=Yt={}));var Si;(function(De){function Re(he){return{kind:"codeCitation",value:he.value,license:he.license,snippet:he.snippet}}De.from=Re})(Si||(e.ChatResponseCodeCitationPart=Si={}));var $i;(function(De){function Re(Ee,Be,Ze){return Ee instanceof b.$JP?ri.from(Ee):Ee instanceof b.$OP?Gt.from(Ee):Ee instanceof b.$TP?Yt.from(Ee):Ee instanceof b.$PP?Nt.from(Ee):Ee instanceof b.$NP?Qt.from(Ee):Ee instanceof b.$SP?It.from(Ee,Be,Ze):Ee instanceof b.$VP?gi.from(Ee):Ee instanceof b.$KP?Kt.from(Ee):Ee instanceof b.$LP?li.from(Ee):Ee instanceof b.$RP?wt.from(Ee):Ee instanceof b.$MP?Bt.from(Ee):Ee instanceof b.$UP?Si.from(Ee):{kind:"markdownContent",content:we.from("")}}De.from=Re;function he(Ee,Be){switch(Ee.kind){case"reference":return Yt.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return G(Ee,Be)}}De.to=he;function G(Ee,Be){switch(Ee.kind){case"markdownContent":return ri.to(Ee);case"inlineReference":return Gt.to(Ee);case"progressMessage":return;case"treeData":return Qt.to(Ee);case"command":return It.to(Ee,Be)}}De.toContent=G})($i||(e.ChatResponsePart=$i={}));var Ai;(function(De){function Re(he,G){return{prompt:he.message,command:he.command,attempt:he.attempt??0,enableCommandDetection:he.enableCommandDetection??!0,references:he.variables.variables.map(Ni.to),location:At.to(he.location),acceptedConfirmationData:he.acceptedConfirmationData,rejectedConfirmationData:he.rejectedConfirmationData,location2:G}}De.to=Re})(Ai||(e.ChatAgentRequest=Ai={}));var At;(function(De){function Re(G){switch(G){case h.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}De.to=Re;function he(G){switch(G){case b.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}De.from=he})(At||(e.ChatLocation=At={}));var Ni;(function(De){function Re(he){const G=he.value;if(!G)throw new Error("Invalid value reference");return{id:he.id,name:he.name,range:he.range&&[he.range.start,he.range.endExclusive],value:(0,o.$vc)(G)?o.URI.revive(G):G&&typeof G=="object"&&"uri"in G&&"range"in G&&(0,o.$vc)(G.uri)?F.to((0,s.$bi)(G)):G,modelDescription:he.modelDescription}}De.to=Re})(Ni||(e.ChatAgentValueReference=Ni={}));var ui;(function(De){function Re(he,G,Ee){return{id:he.id,label:he.label,fullName:he.fullName,icon:he.icon?.id,value:he.values[0].value,insertText:he.insertText,detail:he.detail,documentation:he.documentation,command:G.toInternal(he.command,Ee)}}De.from=Re})(ui||(e.ChatAgentCompletionItem=ui={}));var Ct;(function(De){function Re(he){return{errorDetails:he.errorDetails,metadata:he.metadata}}De.to=Re})(Ct||(e.ChatAgentResult=Ct={}));var Ti;(function(De){function Re(he,G,Ee){if(G.action.kind==="vote")return;const Be=Ct.to(he);if(G.action.kind==="command"){const Ze=G.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:Be}}else return G.action.kind==="followUp"?{action:{kind:"followUp",followup:Lt.to(G.action.followup)},result:Be}:G.action.kind==="inlineChat"?{action:{kind:"editor",accepted:G.action.action==="accepted"},result:Be}:{action:G.action,result:Be}}De.to=Re})(Ti||(e.ChatAgentUserActionEvent=Ti={}));var ki;(function(De){function Re(he,G,Ee){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:G.toInternal(he,Ee)}De.from=Re})(ki||(e.TerminalQuickFix=ki={}));var Ei;(function(De){function Re(he){return{kind:Fi.to(he.kind)}}De.to=Re})(Ei||(e.PartialAcceptInfo=Ei={}));var Fi;(function(De){function Re(he){switch(he){case n.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}De.to=Re})(Fi||(e.PartialAcceptTriggerKind=Fi={}));var wi;(function(De){function Re(he,G){return{id:G,label:he.label,description:he.description,canEdit:he.canEdit,collapsibleState:he.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:he.contextValue}}De.from=Re})(wi||(e.DebugTreeItem=wi={}));var qt;(function(De){function Re(he){return{name:he.name,description:he.description,parametersSchema:he.parametersSchema}}De.to=Re})(qt||(e.LanguageModelToolDescription=qt={}))}),define(Oe[232],Ne([1,0,5,16,8,38]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=void 0;let T=class{constructor($,s){this.a=$.getProxy(v.$HN.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>s.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,s,k){const y=new O.$Ww(P.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,k?.isRefactoring??!1)}};e.$spc=T,e.$spc=T=Je([Ve(0,R.$hQ)],T)}),define(Oe[233],Ne([1,0,17,10,42,6,39,4,40,69,14,2,18,5,8,7,115,194,24]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=void 0,d=We(d),r=We(r);class i{constructor(u,m,p,h,E){this.j=u,this.k=m,this.l=p,this.m=h,this.n=E,this.b=s.$fe.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let m=function(h){if(u.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,h),E}};const u=this;this.b.reset();const p=(h,E)=>{if(typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,h),w={report:I=>{D?.then(C=>{C&&(r.$bO.isMarkdownString(I.value)?this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseWarningPart.from(I),C):this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseReferencePart.from(I),C))})}};Promise.all([D,E?.(w)]).then(([I,C])=>{I!==void 0&&C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,d.ChatTaskResult.from(C),I)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){m(this.markdown);const E=new r.$JP(h),D=d.ChatResponseMarkdownPart.from(E);return p(D),this},markdownWithVulnerabilities(h,E){m(this.markdown),E&&(0,l.$fH)(u.j,"chatParticipantAdditions");const D=new r.$KP(h,E),w=d.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return p(w),this},filetree(h,E){m(this.filetree);const D=new r.$NP(h,E),w=d.ChatResponseFilesPart.from(D);return p(w),this},anchor(h,E){m(this.anchor);const D=new r.$OP(h,E),w=d.ChatResponseAnchorPart.from(D);return p(w),this},button(h){m(this.anchor);const E=new r.$SP(h),D=d.ChatResponseCommandButtonPart.from(E,u.m,u.n);return p(D),this},progress(h,E){m(this.progress);const D=new r.$QP(h,E),w=E?d.ChatTask.from(D):d.ChatResponseProgressPart.from(D);return p(w,E),this},warning(h){m(this.progress),(0,l.$fH)(u.j,"chatParticipantAdditions");const E=new r.$RP(h),D=d.ChatResponseWarningPart.from(E);return p(D),this},reference(h,E){return this.reference2(h,E)},reference2(h,E,D){if(m(this.reference),"variableName"in h&&(0,l.$fH)(u.j,"chatParticipantAdditions"),"variableName"in h&&!h.value){const w=u.k.variables.variables.find(I=>I.name===h.variableName);if(w){let I;if(w.references?.length)I=w.references.map(C=>({kind:"reference",reference:{variableName:h.variableName,value:C.reference}}));else{const C=new r.$TP(h,E,D);I=[d.ChatResponseReferencePart.from(C)]}return I.forEach(C=>p(C)),this}}else{const w=new r.$TP(h,E,D),I=d.ChatResponseReferencePart.from(w);p(I)}return this},codeCitation(h,E,D){m(this.codeCitation),(0,l.$fH)(u.j,"chatParticipantAdditions");const w=new r.$UP(h,E,D),I=d.ChatResponseCodeCitationPart.from(w);p(I)},textEdit(h,E){m(this.textEdit),(0,l.$fH)(u.j,"chatParticipantAdditions");const D=new r.$VP(h,E),w=d.ChatResponseTextEditPart.from(D);return p(w),this},detectedParticipant(h,E){m(this.detectedParticipant),(0,l.$fH)(u.j,"chatParticipantAdditions");const D=new r.$LP(h,E),w=d.ChatResponseDetectedParticipantPart.from(D);return p(w),this},confirmation(h,E,D,w){m(this.confirmation),(0,l.$fH)(u.j,"chatParticipantAdditions");const I=new r.$MP(h,E,D,w),C=d.ChatResponseConfirmationPart.from(I);return p(C),this},push(h){if(m(this.push),(h instanceof r.$VP||h instanceof r.$KP||h instanceof r.$LP||h instanceof r.$RP||h instanceof r.$MP||h instanceof r.$UP)&&(0,l.$fH)(u.j,"chatParticipantAdditions"),h instanceof r.$TP)this.reference2(h.value,h.iconPath,h.options);else{const E=d.ChatResponsePart.from(h,u.m,u.n);p(E)}return this}}}return this.g}}class n extends A.$Uc{static{this.b=0}constructor(u,m,p,h){super(),this.n=m,this.s=p,this.t=h,this.c=new Map,this.j=this.B(new A.$4c),this.m=this.B(new A.$4c),this.g=u.getProxy(S.$HN.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,m,p){const h=n.b++,E=new t(u,m,this.g,h,p);return this.c.set(h,E),this.g.$registerAgent(h,u.identifier,m,{},void 0),E.apiAgent}createDynamicChatAgent(u,m,p,h){const E=n.b++,D=new t(u,m,this.g,E,h);return this.c.set(E,D),this.g.$registerAgent(E,u.identifier,m,{isSticky:!0},p),D.apiAgent}async $invokeAgent(u,m,p,h){const E=this.c.get(u);if(!E)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);const D=(0,$.$bi)(m);let w=this.j.get(D.sessionId);w||(w=new A.$Tc,this.j.set(D.sessionId,w));const I=new i(E.extension,D,this.g,this.s.converter,w);try{const C=await this.u(D.agentId,p);let f;if(D.locationData?.type===o.ChatAgentLocation.Editor){const M=this.t.getDocument(D.locationData.document);f=new r.$YP(M,d.Selection.to(D.locationData.selection),d.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===o.ChatAgentLocation.Notebook){const M=this.t.getDocument(D.locationData.sessionInputUri);f=new r.$ZP(M)}else D.locationData?.type,o.ChatAgentLocation.Terminal;const b=E.invoke(d.ChatAgentRequest.to(D,f),{history:C},I.apiObject,h);return await(0,R.$sh)(Promise.resolve(b).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(F){const W=`result.metadata MUST be JSON.stringify-able. Got error: ${F.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${W}`,E.extension),{errorDetails:{message:W},timings:I.timings}}let N;return M?.errorDetails&&(N={...M.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,l.$fH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:I.timings,metadata:M?.metadata}}),h)}catch(C){return this.n.error(C,E.extension),C instanceof r.$8P&&C.cause&&(C=C.cause),{errorDetails:{message:(0,P.$pj)(C),responseIsIncomplete:!0}}}finally{I.close()}}async u(u,m){const p=[];for(const h of m.history){const E=d.ChatAgentResult.to(h.result),D=u===h.request.agentId?E:{...E,metadata:void 0};p.push(new r.$WP(h.request.message,h.request.command,h.request.variables.variables.map(d.ChatAgentValueReference.to),h.request.agentId));const w=(0,v.$Gb)(h.response.map(I=>d.ChatResponsePart.toContent(I,this.s.converter)));p.push(new r.$XP(w,D,h.request.agentId,h.request.command))}return p}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,m,p,h,E){const D=this.c.get(m);if(!D)return Promise.resolve([]);const w=(0,$.$bi)(u),I=await this.u(D.id,h),C=d.ChatAgentResult.to(p);return(await D.provideFollowups(C,{history:I},E)).filter(f=>{const b=!f.participant||T.Iterable.some(this.c.values(),M=>M.id===f.participant&&a.$qn.equals(M.extension.identifier,D.extension.identifier));return b||this.n.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),b}).map(f=>d.ChatFollowup.from(f,w))}$acceptFeedback(u,m,p,h){const E=this.c.get(u);if(!E)return;const D=d.ChatAgentResult.to(m);let w;switch(p){case c.ChatAgentVoteDirection.Down:w=r.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:w=r.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(h?{result:D,kind:w,reportIssue:h}:{result:D,kind:w}))}$acceptAction(u,m,p){const h=this.c.get(u);if(!h||p.action.kind==="vote")return;const E=d.ChatAgentUserActionEvent.to(m,p,this.s.converter);E&&h.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(u,m,p){const h=this.c.get(u);if(!h)return[];let E=this.m.get(u);return E?E.clear():(E=new A.$Tc,this.m.set(u,E)),(await h.invokeCompletionProvider(m,p)).map(w=>d.ChatAgentCompletionItem.from(w,this.s.converter,E))}async $provideWelcomeMessage(u,m,p){const h=this.c.get(u);if(h)return await h.provideWelcomeMessage(d.ChatLocation.to(m),p)}async $provideSampleQuestions(u,m,p){const h=this.c.get(u);if(h)return(await h.provideSampleQuestions(d.ChatLocation.to(m),p)).map(E=>d.ChatFollowup.from(E,void 0))}}e.$tpc=n;class t{constructor(u,m,p,h,E){this.extension=u,this.id=m,this.w=p,this.x=h,this.y=E,this.m=new O.$le,this.n=new O.$le}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,m){return this.q?await this.q.provider.provideCompletionItems(u,m)??[]:[]}async provideFollowups(u,m,p){if(!this.b)return[];const h=await this.b.provideFollowups(u,m,p);return h?h.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(u,m){if(!this.s)return[];const p=await this.s.provideWelcomeMessage(u,m);return p?p.map(h=>typeof h=="string"?h:d.MarkdownString.from(h)):[]}async provideSampleQuestions(u,m){if(!this.s||!this.s.provideSampleQuestions)return[];const p=await this.s.provideSampleQuestions(u,m);return p||[]}get apiAgent(){let u=!1,m=!1;const p=()=>{u||m||(m=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$IO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:d.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),m=!1}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(E){h.c=E,p()},get requestHandler(){return h.y},set requestHandler(E){(0,k.$og)(typeof E=="function","Invalid request handler"),h.y=E},get followupProvider(){return h.b},set followupProvider(E){h.b=E,p()},get isDefault(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.d},set isDefault(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.d=E,p()},get helpTextPrefix(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.g},set helpTextPrefix(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.g=E,p()},get helpTextVariablesPrefix(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.j=E,p()},get helpTextPostfix(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.k=E,p()},get isSecondary(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.l},set isSecondary(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.l=E,p()},get supportIssueReporting(){return(0,l.$fH)(h.extension,"chatParticipantPrivate"),h.o},set supportIssueReporting(E){(0,l.$fH)(h.extension,"chatParticipantPrivate"),h.o=E,p()},get onDidReceiveFeedback(){return h.m.event},set participantVariableProvider(E){if((0,l.$fH)(h.extension,"chatParticipantAdditions"),h.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,h.id,E.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x,h.id)},get participantVariableProvider(){return(0,l.$fH)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.s=E,p()},get welcomeMessageProvider(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,l.$eH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){h.t=E,p()},get requester(){return h.t},set supportsSlowReferences(E){(0,l.$fH)(h.extension,"chatParticipantPrivate"),h.u=E,p()},get supportsSlowReferences(){return(0,l.$fH)(h.extension,"chatParticipantPrivate"),h.u},dispose(){u=!0,h.b=void 0,h.m.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(u,m,p,h){return this.y(u,m,p,h)}}}),define(Oe[234],Ne([1,0,13,4,34,5,8,7,24]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=void 0,T=We(T),A=We(A);class s{static{this.a=0}constructor(a){this.b=new Map,this.c=a.getProxy(O.$HN.MainThreadChatVariables)}async $resolveVariable(a,S,d,r){const o=this.b.get(a);if(o)try{if(o.resolver.resolve2){(0,$.$fH)(o.extension,"chatParticipantAdditions");const c=new k(S,this.c),l=await o.resolver.resolve2(o.data.name,{prompt:d},c.apiObject,r);if(l&&l[0])return l[0].value}else{const c=await o.resolver.resolve(o.data.name,{prompt:d},r);if(c&&c[0])return c[0].value}}catch(c){(0,v.$Z)(c)}}registerVariableResolver(a,S,d,r,o,c,l,i,n){const t=s.a++,g=n?P.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:a,data:{id:S,name:d,description:r,modelDescription:o,icon:g},resolver:l}),this.c.$registerVariable(t,{id:S,name:d,description:r,modelDescription:o,isSlow:c,fullName:i,icon:g}),(0,R.$Sc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$upc=s;class k{constructor(a,S){this.c=a,this.d=S,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let S=function(r){if(a.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const a=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){S(this.progress);const o=new A.$PP(r),c=T.ChatResponseProgressPart.from(o);return d(c),this},reference(r){S(this.reference);const o=new A.$TP(r),c=T.ChatResponseReferencePart.from(o);return d(c),this},push(r){return S(this.push),r instanceof A.$TP?d(T.ChatResponseReferencePart.from(r)):r instanceof A.$PP&&d(T.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Oe[235],Ne([1,0,10,71,6,4,36,2,93,18,8,7,5,24]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=d,$=We($),k=We(k),y=We(y);function d(r,o,c){const l=r.getProxy(a.$HN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new s.$sn,o.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===T.MarshalledId.CommentController){const I=this.b.get(w.handle);return I?I.value:w}else if(w&&w.$mid===T.MarshalledId.CommentThread){const I=w,C=this.b.get(I.commentControlHandle);if(!C)return I;const f=C.getCommentThread(I.commentThreadHandle);return f?f.value:I}else if(w&&(w.$mid===T.MarshalledId.CommentThreadReply||w.$mid===T.MarshalledId.CommentThreadInstance)){const I=this.b.get(w.thread.commentControlHandle);if(!I)return w;const C=I.getCommentThread(w.thread.commentThreadHandle);return C?w.$mid===T.MarshalledId.CommentThreadInstance?C.value:{thread:C.value,text:w.text}:w}else if(w&&w.$mid===T.MarshalledId.CommentNode){const I=this.b.get(w.thread.commentControlHandle);if(!I)return w;const C=I.getCommentThread(w.thread.commentThreadHandle);if(!C)return w;const f=w.commentUniqueId,b=C.getCommentByUniqueId(f);return b||w}else if(w&&w.$mid===T.MarshalledId.CommentThreadNode){const I=this.b.get(w.thread.commentControlHandle);if(!I)return w;const C=I.getCommentThread(w.thread.commentThreadHandle);if(!C)return w;const f=w.text,b=w.commentUniqueId,M=C.getCommentByUniqueId(b);return M?(typeof M.body=="string"?M.body=f:M.body=new y.$bO(f),M):w}return w}})}createCommentController(w,I,C){const f=i.a++,b=new t(w,f,I,C);this.b.set(b.handle,b);const M=this.c.get(w.identifier)||[];return M.push(b),this.c.set(w.identifier,M),b.value}async $createCommentThreadTemplate(w,I,C,f){const b=this.b.get(w);b&&b.$createCommentThreadTemplate(I,C,f)}async $setActiveComment(w,I){const C=this.b.get(w);C&&C.$setActiveComment(I??void 0)}async $updateCommentThreadTemplate(w,I,C){const f=this.b.get(w);f&&f.$updateCommentThreadTemplate(I,C)}$deleteCommentThread(w,I){this.b.get(w)?.$deleteCommentThread(I)}async $provideCommentingRanges(w,I,C){const f=this.b.get(w);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const b=await c.ensureDocumentData(A.URI.revive(I));return(0,v.$wh)(async()=>{const M=await f.commentingRangeProvider.provideCommentingRanges(b.document,C);let N;return Array.isArray(M)?N={ranges:M,fileComments:!1}:M?N={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:N=M??void 0,N}).then(M=>{let N;return M&&(N={ranges:M.ranges.map(F=>k.Range.from(F)),fileComments:M.fileComments}),N})}$toggleReaction(w,I,C,f,b){const M=this.b.get(w);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,v.$wh)(()=>{const N=M.getCommentThread(I);if(N){const F=N.getCommentByUniqueId(f.uniqueIdInThread);if(M!==void 0&&F&&M.reactionHandler)return M.reactionHandler(F,m(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,S.$fH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,I,C,f,b,M,N,F,W){this.m=I,this.n=C,this.o=f,this.p=b,this.q=M,this.extensionDescription=N,this.r=F,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$le,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Vc,this.l.value=new O.$Tc,this.n===void 0&&(this.n=`${w}.${this.handle}`),l.$createCommentThread(I,this.handle,this.n,this.o,k.Range.from(this.p),this.q.map(L=>g(this,L,this.k,this.extensionDescription)),N.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{l.$deleteCommentThread(I,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(L){K.range=L},get comments(){return K.comments},set comments(L){K.comments=L},get collapsibleState(){return K.collapsibleState},set collapsibleState(L){K.collapsibleState=L},get canReply(){return K.canReply},set canReply(L){K.canReply=L},get contextValue(){return K.contextValue},set contextValue(L){K.contextValue=L},get label(){return K.label},set label(L){K.label=L},get state(){return K.state},set state(L){K.state=L},reveal:(L,Q)=>K.reveal(L,Q),hide:()=>K.hide(),dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Tc);const w=C=>Object.prototype.hasOwnProperty.call(this.b,C),I={};w("range")&&(I.range=k.Range.from(this.p)),w("label")&&(I.label=this.label),w("contextValue")&&(I.contextValue=this.contextValue??null),w("comments")&&(I.comments=this.q.map(C=>g(this,C,this.k,this.extensionDescription))),w("collapsibleState")&&(I.collapseState=p(this.g)),w("canReply")&&(I.canReply=this.canReply),w("state")&&(I.state=h(this.h)),w("applicability")&&(I.applicability=E(this.h)),w("isTemplate")&&(I.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(w){for(const I of this.k){const C=I[0],f=I[1];if(w===f)return C}}async reveal(w,I){(0,S.$fH)(this.extensionDescription,"commentReveal");let C;w&&w.body!==void 0?C=w:I=I??w;let f=C?this.k.get(C):void 0;f??=this.k.get(this.q[0]);let b=!0,M=!1;return I?.focus===y.CommentThreadFocus.Reply?(M=!0,b=!1):I?.focus===y.CommentThreadFocus.Comment&&(b=!1),l.$revealCommentThread(this.m,this.handle,f,{preserveFocus:b,focusReply:M})}async hide(){return l.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}Je([(0,R.$0h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,S.$fH)(this.h,"commentingRangeHint"),l.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,S.$fH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,S.$fH)(this.h,"activeComment"),this.f}constructor(w,I,C,f){this.h=w,this.i=I,this.j=C,this.k=f,this.a=new Map,l.$registerCommentController(this.handle,C,f,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(M){b.options=M},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(M){b.commentingRangeProvider=M},get reactionHandler(){return b.reactionHandler},set reactionHandler(M){b.reactionHandler=M},get activeCommentThread(){return b.activeCommentThread},createCommentThread(M,N,F){return b.createCommentThread(M,N,F).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(w,I,C){I===void 0&&(0,S.$fH)(this.h,"fileComments");const f=new n(this.id,this.handle,void 0,w,I,C,this.h,!1);return this.a.set(f.handle,f),f}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const I=this.a.get(w.commentThreadHandle);I&&(this.e=w.uniqueIdInThread?I.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=I)}$createCommentThreadTemplate(w,I,C){const f=new n(this.id,this.handle,void 0,A.URI.revive(w),k.Range.to(I),[],this.h,!0,C);return f.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(w,I){const C=this.a.get(w);C&&(C.range=k.Range.to(I))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function g(D,w,I,C){let f=I.get(w);return f||(f=++D.commentHandle,I.set(w,f)),w.state!==void 0&&(0,S.$fH)(C,"commentsDraftState"),w.reactions?.some(b=>b.reactors!==void 0)&&(0,S.$fH)(C,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:f,body:typeof w.body=="string"?w.body:k.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(b=>u(b)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function u(D){return{label:D.label,iconPath:D.iconPath?k.$gQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(w=>w.name):D.reactors}}function m(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?A.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(w=>({name:w}))}}function p(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(D){let w;if(typeof D=="object"?w=D.resolved:w=D,w!==void 0)switch(w){case y.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function E(D){let w;if(typeof D=="object"&&(w=D.applicability),w!==void 0)switch(w){case y.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new i}}),define(Oe[236],Ne([1,0,21,75,4,15,23,2,8,67,79,5,7]),function(be,e,v,R,P,O,T,A,$,s,k,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0,$=We($),y=We(y),a=We(a);class S{constructor(u,m){this.document=u,this.b=m,this.a=1,this.c=new k.$epc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,m){await this.f(u).undo(),m||this.disposeBackup()}async redo(u,m){await this.f(u).redo(),m||this.disposeBackup()}disposeEdits(u){for(const m of u)this.c.delete(m)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=t(this.document.uri)+this.a++;return(0,T.$fh)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const m=this.c.get(u,0);if(!m)throw new Error("No edit found");return m}}class d{constructor(){this.a=new Map}get(u,m){return this.a.get(this.b(u,m))}add(u,m,p){const h=this.b(u,m.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${u} resource:${m.uri}`);const E=new S(m,p);return this.a.set(h,E),E}delete(u,m){const p=this.b(u,m.uri);this.a.delete(p)}b(u,m){return`${u}@@@${m}`}}var r;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(u,m,p){return this.b(u,{type:r.Text,extension:m,provider:p})}addCustomProvider(u,m,p){return this.b(u,{type:r.Custom,extension:m,provider:p})}get(u){return this.a.get(u)}b(u,m){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,m),new a.$JN(()=>this.a.delete(u))}}class c{constructor(u,m,p,h,E){this.d=m,this.f=p,this.g=h,this.h=E,this.b=new o,this.c=new d,this.a=u.getProxy(y.$HN.MainThreadCustomEditors)}registerCustomEditorProvider(u,m,p,h){const E=new P.$Tc;return i(p)?(E.add(this.b.addTextProvider(m,u,p)),this.a.$registerTextEditorProvider((0,s.$Npc)(u),m,h.webviewOptions||{},{supportsMove:!!p.moveCustomTextEditor},(0,s.$Lpc)(u))):(E.add(this.b.addCustomProvider(m,u,p)),l(p)&&E.add(p.onDidChangeCustomDocument(D=>{const w=this.i(m,D.document.uri);if(n(D)){const I=w.addEdit(D);this.a.$onDidEdit(D.document.uri,m,I,D.label)}else this.a.$onContentChange(D.document.uri,m)})),this.a.$registerCustomEditorProvider((0,s.$Npc)(u),m,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,s.$Lpc)(u))),a.$JN.from(E,new a.$JN(()=>{this.a.$unregisterEditorProvider(m)}))}async $createCustomDocument(u,m,p,h,E){const D=this.b.get(m);if(!D)throw new Error(`No provider found for '${m}'`);if(D.type!==r.Custom)throw new Error(`Invalid provide type for '${m}'`);const w=A.URI.revive(u),I=await D.provider.openCustomDocument(w,{backupId:p,untitledDocumentData:h?.buffer},E);let C;return l(D.provider)&&this.f&&(C=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(m,I,C),{editable:l(D.provider)}}async $disposeCustomDocument(u,m){const p=this.b.get(m);if(!p)throw new Error(`No provider found for '${m}'`);if(p.type!==r.Custom)throw new Error(`Invalid provider type for '${m}'`);const h=A.URI.revive(u),{document:E}=this.i(m,h);this.c.delete(m,E),E.dispose()}async $resolveCustomEditor(u,m,p,h,E,D){const w=this.b.get(p);if(!w)throw new Error(`No provider found for '${p}'`);const I=$.ViewColumn.to(E),C=this.g.createNewWebview(m,h.contentOptions,w.extension),f=this.h.createNewWebviewPanel(m,p,h.title,I,h.options,C,h.active),b=A.URI.revive(u);switch(w.type){case r.Custom:{const{document:M}=this.i(p,b);return w.provider.resolveCustomEditor(M,f,D)}case r.Text:{const M=this.d.getDocument(b);return w.provider.resolveCustomTextEditor(M,f,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,m,p){this.i(m,u).disposeEdits(p)}async $onMoveCustomEditor(u,m,p){const h=this.b.get(p);if(!h)throw new Error(`No provider found for '${p}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${p}'`);const E=this.h.getWebviewPanel(u);if(!E)throw new Error("No webview found");const D=A.URI.revive(m),w=this.d.getDocument(D);await h.provider.moveCustomTextEditor(w,E,v.CancellationToken.None)}async $undo(u,m,p,h){return this.i(m,u).undo(p,h)}async $redo(u,m,p,h){return this.i(m,u).redo(p,h)}async $revert(u,m,p){const h=this.i(m,u);await this.j(m).revertCustomDocument(h.document,p),h.disposeBackup()}async $onSave(u,m,p){const h=this.i(m,u);await this.j(m).saveCustomDocument(h.document,p),h.disposeBackup()}async $onSaveAs(u,m,p,h){const E=this.i(m,u);return this.j(m).saveCustomDocumentAs(E.document,A.URI.revive(p),h)}async $backup(u,m,p){const h=this.i(m,u),D=await this.j(m).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},p);return h.updateBackup(D),D.id}i(u,m){const p=this.c.get(u,A.URI.revive(m));if(!p)throw new Error("No custom document found");return p}j(u){const p=this.b.get(u)?.provider;if(!p||!l(p))throw new Error("Custom document is not editable");return p}}e.$Qpc=c;function l(g){return!!g.onDidChangeCustomDocument}function i(g){return typeof g.resolveCustomTextEditor=="function"}function n(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function t(g){const u=g.scheme===O.Schemas.file||g.scheme===O.Schemas.untitled?g.fsPath:g.toString();return(0,R.$sj)(u)+""}}),define(Oe[237],Ne([1,0,9,107,2,5,7,8,6,11,28,50]),function(be,e,v,R,P,O,T,A,$,s,k,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$lpc=void 0,A=We(A);class S{#e;#t;#i;constructor(o,c,l,i,n,t,g,u){this.d=o,this.e=c,this.f=l,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,l),this.#i=new k.$Ac(m=>t.getComparisonKey(m)),this.#e=g,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,c){if(!o){this.clear();return}this.j();let l=[];if(P.URI.isUri(o)){if(!c){this.delete(o);return}this.#i.set(o,c.slice()),l=[o]}else if(Array.isArray(o)){l=[];let t;o=[...o].sort(S.k);for(const g of o){const[u,m]=g;if((!t||u.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=u,l.push(u),this.#i.set(u,[])),m)this.#i.get(u)?.push(...m);else{const p=this.#i.get(u);p&&(p.length=0)}}}if(this.#t.fire(l),!this.#e)return;const i=[];let n=0;for(const t of l){let g=[];const u=this.#i.get(t);if(u)if(u.length>this.g){g=[];const m=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(const h of u)if(h.severity===m[p]&&g.push({...A.Diagnostic.from(h),modelVersionId:this.h(t)})===this.g)break e;g.push({severity:R.MarkerSeverity.Info,message:(0,v.localize)(10791,null,u.length-this.g),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=u.map(m=>({...A.Diagnostic.from(m),modelVersionId:this.h(t)}));if(i.push([t,g]),n+=g.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,c){this.j();for(const[l,i]of this)o.call(c,l,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const c=this.#i.get(o);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,c){return o[0].toString()<c[0].toString()?-1:o[0].toString()>c[0].toString()?1:0}}e.$lpc=S;let d=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(o){const c=new k.$Ac;for(const l of o)c.set(l,l);return{uris:Object.freeze(Array.from(c.values()))}}constructor(o,c,l,i){this.j=c,this.k=l,this.l=i,this.g=new Map,this.h=new $.$pe({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,a._mapper),this.f=o.getProxy(O.$HN.MainThreadDiagnostics)}createDiagnosticCollection(o,c){const{g:l,f:i,h:n,j:t,k:g,l:u}=this,m=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,E)}dispose(){i.dispose()}};let p;if(!c)c="_generated_diagnostic_collection_name_#"+a.c++,p=c;else if(!l.has(c))p=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do p=c+a.c++;while(l.has(p))}return new class extends S{constructor(){super(c,p,a.e,a.d,E=>u.getDocument(E)?.version,g.extUri,m,n),l.set(p,this)}dispose(){super.dispose(),l.delete(p)}}}getDiagnostics(o){if(o)return this.m(o);{const c=new Map,l=[];for(const i of this.g.values())i.forEach((n,t)=>{let g=c.get(n.toString());typeof g>"u"&&(g=l.length,c.set(n.toString(),g),l.push([n,[]])),l[g][1]=l[g][1].concat(...t)});return l}}m(o){let c=[];for(const l of this.g.values())l.has(o)&&(c=c.concat(l.get(o)));return c}$acceptMarkersChange(o){if(!this.n){const c="_generated_mirror",l=new S(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,l),this.n=l}for(const[c,l]of o)this.n.set(P.URI.revive(c),l.map(A.Diagnostic.to))}};e.$mpc=d,e.$mpc=d=a=Je([Ve(1,s.$_j),Ve(2,y.$kpc)],d)}),define(Oe[238],Ne([1,0,2,13,7,8,171,38]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;class ${constructor(k,y,a,S={timeout:1500,errors:3}){this.c=k,this.d=y,this.f=a,this.g=S,this.a=new T.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(y,a,S)=>{const r={dispose:this.a.push([y,a,k])};return Array.isArray(S)&&S.push(r),r}}async $participateInSave(k,y){const a=v.URI.revive(k);let S=!1;const d=setTimeout(()=>S=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(S)break;const c=this.d.getDocument(a),l=await this.h(o,{document:c,reason:O.TextDocumentSaveReason.to(y)});r.push(l)}}finally{clearTimeout(d)}return r}h([k,y,a],S){const d=this.b.get(k);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(a,k,y,S).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(k);this.b.set(k,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,y,a,S){const d=[],r=Date.now(),{document:o,reason:c}=S,{version:l}=o,i=Object.freeze({document:o,reason:c,waitUntil(n){if(Object.isFrozen(d))throw(0,R.$7)("waitUntil can not be called async");d.push(Promise.resolve(n))}});try{y.apply(a,[i])}catch(n){return Promise.reject(n)}return Object.freeze(d),new Promise((n,t)=>{const g=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(g),n(u)}).catch(u=>{clearTimeout(g),t(u)})}).then(n=>{const t={edits:[]};for(const g of n)if(Array.isArray(g)&&g.every(u=>u instanceof P.$SN))for(const{newText:u,newEol:m,range:p}of g)t.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:p&&O.Range.from(p),text:u,eol:m&&O.EndOfLine.from(m)}});if(t.edits.length!==0)return l===o.version?this.f.$tryApplyWorkspaceEdit(new A.$Ww(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$zqc=$}),define(Oe[239],Ne([1,0,6,4,2,5,123,8,14,25,7]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=void 0,A=We(A);class y{constructor(S,d){this.a=new v.$le,this.b=new v.$le,this.c=new v.$le,this.d=new v.$le,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$Tc,this.h=new Map,this.f=S.getProxy(O.$HN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const d=this.g.getDocument(S);if(d)return d}getDocument(S){const d=this.getDocumentData(S);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return d.document}ensureDocumentData(S){const d=this.g.getDocument(S);if(d)return Promise.resolve(d);let r=this.h.get(S.toString());return r||(r=this.f.$tryOpenDocument(S).then(o=>{this.h.delete(S.toString());const c=P.URI.revive(o);return(0,$.$pg)(this.g.getDocument(c))},o=>(this.h.delete(S.toString()),Promise.reject(o))),this.h.set(S.toString(),r)),r}createDocumentData(S){return this.f.$tryCreateDocument(S).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(S,d){const r=P.URI.revive(S),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(S){const d=P.URI.revive(S),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(S,d){const r=P.URI.revive(S),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,d,r){const o=P.URI.revive(S),c=this.g.getDocument(o);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(d);let l;d.isUndoing?l=k.TextDocumentChangeReason.Undo:d.isRedoing&&(l=k.TextDocumentChangeReason.Redo),this.c.fire((0,s.$eo)({document:c.document,contentChanges:d.changes.map(i=>({range:A.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:l}))}setWordDefinitionFor(S,d){(0,T.$jQ)(S,d)}}e.$npc=y}),define(Oe[70],Ne([1,0,240,6,14,2,3,5,16,8,7]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=e.$Rpc=void 0,s=We(s),e.$Rpc=(0,T.$Ei)("IExtHostEditorTabs");class y{constructor(o,c,l){this.e=l,this.d=c,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case A.TabInputKind.TextInput:return new k.$xP(O.URI.revive(this.b.input.uri));case A.TabInputKind.TextDiffInput:return new k.$yP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case A.TabInputKind.TextMergeInput:return new k.$zP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case A.TabInputKind.CustomEditorInput:return new k.$AP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case A.TabInputKind.WebviewEditorInput:return new k.$BP(this.b.input.viewType);case A.TabInputKind.NotebookInput:return new k.$CP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case A.TabInputKind.NotebookDiffInput:return new k.$DP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case A.TabInputKind.TerminalEditorInput:return new k.$EP;case A.TabInputKind.InteractiveEditorInput:return new k.$FP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case A.TabInputKind.ChatEditorInput:return new k.$GP;case A.TabInputKind.MultiDiffEditorInput:return new k.$HP(this.b.input.diffEditors.map(o=>new k.$yP(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class a{constructor(o,c){this.c=[],this.d="",this.b=o,this.e=c;for(const l of o.tabs)l.isActive&&(this.d=l.id),this.c.push(new y(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return s.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(l=>l.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(l=>l.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===A.TabModelOperationKind.TAB_OPEN){const l=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,l),o.tabDto.isActive&&(this.d=l.tabId),l}else if(o.kind===A.TabModelOperationKind.TAB_CLOSE){const l=this.c.splice(o.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(o.kind===A.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(o.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,l),l}const c=this.c.find(l=>l.tabId===o.tabDto.id);if(!c)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(o.tabDto),c}activeTabId(){return this.d}}let S=class{constructor(o){this.b=new R.$le,this.c=new R.$le,this.e=[],this.a=o.getProxy(A.$HN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,c={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(l=>l.apiObject))},get activeTabGroup(){const l=o.d;return(0,P.$pg)(o.e.find(n=>n.groupId===l)?.apiObject)},close:async(l,i)=>{const n=Array.isArray(l)?l:[l];return n.length?d(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(o){const c=new Set(this.e.map(m=>m.groupId)),l=new Set(o.map(m=>m.groupId)),i=(0,v.$d)(c,l),n=this.e.filter(m=>i.removed.includes(m.groupId)).map(m=>m.apiObject),t=[],g=[];this.e=o.map(m=>{const p=new a(m,()=>this.d);return i.added.includes(p.groupId)?t.push(p.apiObject):g.push(p.apiObject),p});const u=(0,P.$pg)(o.find(m=>m.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:t,closed:n,changed:g}))}$acceptTabGroupUpdate(o){const c=this.e.find(l=>l.groupId===o.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const c=this.e.find(i=>i.groupId===o.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const l=c.acceptTabOperation(o);switch(o.kind){case A.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case A.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case A.TabModelOperationKind.TAB_MOVE:case A.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(o){for(const c of this.e)for(const l of c.tabs)if(l.apiObject===o)return l}h(o){return this.e.find(c=>c.apiObject===o)}async i(o,c){const l=[];for(const i of o){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");l.push(n.tabId)}return this.a.$closeTab(l,c)}async j(o,c){const l=[];for(const i of o){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");l.push(n.groupId)}return this.a.$closeGroup(l,c)}};e.$Spc=S,e.$Spc=S=Je([Ve(0,$.$hQ)],S);function d(r){return r.tabs!==void 0}}),define(Oe[241],Ne([1,0,2,5,29,4,7,8,285,12,27,22,24,59]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0,P=We(P),A=We(A);class d{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const l=this.a.indexOf(c);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),l=[];let i,n,t=$.State.LastKnownState,g=$.State.LastKnownState;for(const u of c){let m=i?(0,s.$Hf)(i,u):0;for(m===0?n=$.State.Start:n=g;m<u.length;m++)m+1===u.length?(t=g,g=$.State.BeforeColon):g+=1,l.push([n,u.toUpperCase().charCodeAt(m),g]),l.push([n,u.toLowerCase().charCodeAt(m),g]),n=g;i=u,g=t}l.push([$.State.BeforeColon,k.CharCode.Colon,$.State.AfterColon]),l.push([$.State.AfterColon,k.CharCode.Slash,$.State.End]),this.b=new $.$C4(l)}}provideDocumentLinks(c){this.c();const l=[],i=$.$D4.computeLinks({getLineContent(n){return c.lineAt(n-1).text},getLineCount(){return c.lineCount}},this.b);for(const n of i){const t=A.DocumentLink.to(n);t.target&&l.push(t)}return l}}class r{constructor(c,l){this.i=l,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(R.$HN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,l,i,n={}){if(r.j(i),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const t=this.h++;this.b.add(l),this.d.add(l),this.c.set(t,i);let g=P.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(g+=P.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(g+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(g+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,a.$fH)(c,"fsChunks"),g+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let u;n.isReadonly&&(0,S.$5k)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,l,g,u).catch(p=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${l}`),console.error(p)});const m=i.onDidChangeFile(p=>{const h=[];for(const E of p){const{uri:D,type:w}=E;if(D.scheme!==l)continue;let I;switch(w){case T.FileChangeType.Changed:I=P.FileChangeType.UPDATED;break;case T.FileChangeType.Created:I=P.FileChangeType.ADDED;break;case T.FileChangeType.Deleted:I=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:D,type:I})}this.a.$onFileSystemChange(t,h)});return(0,O.$Sc)(()=>{m.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:l,ctime:i,mtime:n,size:t,permissions:g}=c;return{type:l,ctime:i,mtime:n,size:t,permissions:g}}$stat(c,l){return Promise.resolve(this.l(c).stat(v.URI.revive(l))).then(i=>r.k(i))}$readdir(c,l){return Promise.resolve(this.l(c).readDirectory(v.URI.revive(l)))}$readFile(c,l){return Promise.resolve(this.l(c).readFile(v.URI.revive(l))).then(i=>y.$Ne.wrap(i))}$writeFile(c,l,i,n){return Promise.resolve(this.l(c).writeFile(v.URI.revive(l),i.buffer,n))}$delete(c,l,i){return Promise.resolve(this.l(c).delete(v.URI.revive(l),i))}$rename(c,l,i,n){return Promise.resolve(this.l(c).rename(v.URI.revive(l),v.URI.revive(i),n))}$copy(c,l,i,n){const t=this.l(c);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(l),v.URI.revive(i),n))}$mkdir(c,l){return Promise.resolve(this.l(c).createDirectory(v.URI.revive(l)))}$watch(c,l,i,n){const t=this.l(c).watch(v.URI.revive(i),n);this.f.set(l,t)}$unwatch(c,l){const i=this.f.get(l);i&&(i.dispose(),this.f.delete(l))}$open(c,l,i){const n=this.l(c);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(v.URI.revive(l),i))}$close(c,l){const i=this.l(c);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(l))}$read(c,l,i,n){const t=this.l(c);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const g=y.$Ne.alloc(n);return Promise.resolve(t.read(l,i,g.buffer,0,n)).then(u=>g.slice(0,u))}$write(c,l,i,n){const t=this.l(c);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(l,i,n.buffer,0,n.byteLength))}l(c){const l=this.c.get(c);if(!l){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return l}}e.$Cqc=r}),define(Oe[242],Ne([1,0,6,41,2,5,8,7,29,48]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0,T=We(T);class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,o,c,l,i){this.a=Math.random(),this.b=new v.$le,this.c=new v.$le,this.d=new v.$le,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,R.$zk)(l),t=typeof l=="string",g=i?.correlate,u=c(m=>{if(!(typeof m.session=="number"&&m.session!==this.a)&&!(g&&typeof m.session>"u")){if(!i?.ignoreCreateEvents)for(const p of m.created){const h=P.URI.revive(p);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const p of m.changed){const h=P.URI.revive(p);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const p of m.deleted){const h=P.URI.revive(p);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=A.$JN.from(this.i(d,o,l,i,i?.correlate),this.b,this.c,this.d,u)}i(d,r,o,c,l){const i=A.$JN.from();if(typeof o=="string"||c?.ignoreChangeEvents&&c?.ignoreCreateEvents&&c?.ignoreDeleteEvents)return i;const n=d.getProxy(O.$HN.MainThreadFileSystemEventService);let t=!1;(o.pattern.includes(R.$vk)||o.pattern.includes(R.$wk))&&(t=!0);let g;return l&&(c?.ignoreChangeEvents||c?.ignoreCreateEvents||c?.ignoreDeleteEvents)&&(g=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,c?.ignoreChangeEvents&&(g&=~$.FileChangeFilter.UPDATED),c?.ignoreCreateEvents&&(g&=~$.FileChangeFilter.ADDED),c?.ignoreDeleteEvents&&(g&=~$.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,o.baseUri,{recursive:t,excludes:c?.excludes??[],filter:g},!!l),A.$JN.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new s.$T(()=>this.a.created.map(P.URI.revive)),this.c=new s.$T(()=>this.a.changed.map(P.URI.revive)),this.d=new s.$T(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class a{constructor(d,r,o){this.j=d,this.k=r,this.l=o,this.a=new v.$le,this.b=new v.$le,this.c=new v.$le,this.d=new v.$le,this.g=new v.$ne,this.h=new v.$ne,this.i=new v.$ne,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,o,c){return new k(this.j,d,r,this.a.event,T.GlobPattern.from(o),c)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,r){switch(d){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(o=>({oldUri:P.URI.revive(o.source),newUri:P.URI.revive(o.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(o,c,l)=>{const i=function(t){o.call(c,t)};return i.extension=d,r.event(i,void 0,l)}}async $onWillRunFileOperation(d,r,o,c){switch(d){case $.FileOperation.MOVE:return await this.n(this.g,{files:r.map(l=>({oldUri:P.URI.revive(l.source),newUri:P.URI.revive(l.target)}))},o,c);case $.FileOperation.DELETE:return await this.n(this.i,{files:r.map(l=>P.URI.revive(l.target))},o,c);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:r.map(l=>P.URI.revive(l.target))},o,c)}}async n(d,r,o,c){const l=new Set,i=[];if(await d.fireAsync(r,c,async(t,g)=>{const u=Date.now(),m=await Promise.resolve(t);m instanceof A.$VN&&(i.push([g.extension,m]),l.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-u>o&&this.k.warn("SLOW file-participant",g.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:g}=T.WorkspaceEdit.from(t,{getTextDocumentVersion:u=>this.l.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(g)}return{edit:n,extensionNames:Array.from(l)}}}e.$Dqc=a}),define(Oe[243],Ne([1,0,17,10,21,13,96,4,25,69,12,14,2,32,286,93,103,9,18,8,7,24,79,5]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=void 0,r=We(r),i=We(i),u=We(u);class m{constructor(j,B){this.d=j,this.e=B}async provideDocumentSymbols(j,B){const H=this.d.getDocument(j),V=await this.e.provideDocumentSymbols(H,B);if(!(0,v.$Jb)(V))return V[0]instanceof n.$6N?V.map(i.DocumentSymbol.from):m.f(V)}static f(j){j=j.slice(0).sort((V,re)=>{let ge=V.location.range.start.compareTo(re.location.range.start);return ge===0&&(ge=re.location.range.end.compareTo(V.location.range.end)),ge});const B=[],H=[];for(const V of j){const re={name:V.name||"!!MISSING: name!!",kind:i.SymbolKind.from(V.kind),tags:V.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:i.Range.from(V.location.range),selectionRange:i.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(re),B.push(re);break}const ge=H[H.length-1];if(S.$Nt.containsRange(ge.range,re.range)&&!S.$Nt.equalsRange(ge.range,re.range)){ge.children?.push(re),H.push(re);break}H.pop()}}return B}}class p{constructor(j,B,H,V,re,ge){this.f=j,this.g=B,this.h=H,this.j=V,this.k=re,this.l=ge,this.d=new g.$epc("CodeLens"),this.e=new Map}async provideCodeLenses(j,B){const H=this.f.getDocument(j),V=await this.h.provideCodeLenses(H,B);if(!V||B.isCancellationRequested)return;const re=this.d.add(V),ge=new A.$Tc;this.e.set(re,ge);const Ce={cacheId:re,lenses:[]};for(let ze=0;ze<V.length;ze++)Ce.lenses.push({cacheId:[re,ze],range:i.Range.from(V[ze].range),command:this.g.toInternal(V[ze].command,ge)});return Ce}async resolveCodeLens(j,B){const H=j.cacheId&&this.d.get(...j.cacheId);if(!H)return;let V;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?V=H:V=await this.h.resolveCodeLens(H,B),V||(V=H),B.isCancellationRequested)return;const re=j.cacheId&&this.e.get(j.cacheId[0]);if(re){if(!V.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return j.command=this.g.toInternal(V.command,re),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function h(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class E{constructor(j,B){this.d=j,this.e=B}async provideDefinition(j,B,H){const V=this.d.getDocument(j),re=i.Position.to(B),ge=await this.e.provideDefinition(V,re,H);return h(ge)}}class D{constructor(j,B){this.d=j,this.e=B}async provideDeclaration(j,B,H){const V=this.d.getDocument(j),re=i.Position.to(B),ge=await this.e.provideDeclaration(V,re,H);return h(ge)}}class w{constructor(j,B){this.d=j,this.e=B}async provideImplementation(j,B,H){const V=this.d.getDocument(j),re=i.Position.to(B),ge=await this.e.provideImplementation(V,re,H);return h(ge)}}class I{constructor(j,B){this.d=j,this.e=B}async provideTypeDefinition(j,B,H){const V=this.d.getDocument(j),re=i.Position.to(B),ge=await this.e.provideTypeDefinition(V,re,H);return h(ge)}}class C{static{this.f=10}constructor(j,B){this.g=j,this.h=B,this.d=0,this.e=new Map}async provideHover(j,B,H,V){const re=this.g.getDocument(j),ge=i.Position.to(B);let Ce;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:nt};Ce=await this.h.provideHover(re,ge,V,et)}else Ce=await this.h.provideHover(re,ge,V);if(!Ce||(0,v.$Jb)(Ce.contents))return;Ce.range||(Ce.range=re.getWordRangeAtPosition(ge)),Ce.range||(Ce.range=new n.$LN(ge,ge));const ze=i.Hover.from(Ce),Qe=this.d;if(this.e.size===C.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Qe,Ce),this.d+=1,{...ze,id:Qe}}releaseHover(j){this.e.delete(j)}}class f{constructor(j,B){this.d=j,this.e=B}async provideEvaluatableExpression(j,B,H){const V=this.d.getDocument(j),re=i.Position.to(B),ge=await this.e.provideEvaluatableExpression(V,re,H);if(ge)return i.EvaluatableExpression.from(ge)}}class b{constructor(j,B){this.d=j,this.e=B}async provideInlineValues(j,B,H,V){const re=this.d.getDocument(j),ge=await this.e.provideInlineValues(re,i.Range.to(B),i.InlineValueContext.to(H),V);if(Array.isArray(ge))return ge.map(Ce=>i.InlineValue.from(Ce))}}class M{constructor(j,B){this.d=j,this.e=B}async provideDocumentHighlights(j,B,H){const V=this.d.getDocument(j),re=i.Position.to(B),ge=await this.e.provideDocumentHighlights(V,re,H);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class N{constructor(j,B){this.d=j,this.e=B}async provideMultiDocumentHighlights(j,B,H,V){const re=this.d.getDocument(j),ge=H.map(Qe=>this.d.getDocument(Qe)),Ce=i.Position.to(B),ze=await this.e.provideMultiDocumentHighlights(re,Ce,ge,V);if(Array.isArray(ze))return ze.map(i.MultiDocumentHighlight.from)}}class F{constructor(j,B){this.d=j,this.e=B}async provideLinkedEditingRanges(j,B,H){const V=this.d.getDocument(j),re=i.Position.to(B),ge=await this.e.provideLinkedEditingRanges(V,re,H);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,v.$Gb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class W{constructor(j,B){this.d=j,this.e=B}async provideReferences(j,B,H,V){const re=this.d.getDocument(j),ge=i.Position.to(B),Ce=await this.e.provideReferences(re,ge,H,V);if(Array.isArray(Ce))return Ce.map(i.location.from)}}class K{static{this.d=1e3}constructor(j,B,H,V,re,ge,Ce){this.g=j,this.h=B,this.j=H,this.k=V,this.l=re,this.m=ge,this.n=Ce,this.e=new g.$epc("CodeAction"),this.f=new Map}async provideCodeActions(j,B,H,V){const re=this.g.getDocument(j),ge=d.$Pt.isISelection(B)?i.Selection.to(B):i.Range.to(B),Ce=[];for(const et of this.j.getDiagnostics(j))if(ge.intersection(et.range)&&Ce.push(et)>K.d)break;const ze={diagnostics:Ce,only:H.only?new n.$8N(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},Qe=await this.k.provideCodeActions(re,ge,ze,V);if(!(0,v.$Kb)(Qe)||V.isCancellationRequested)return;const _e=this.e.add(Qe),tt=new A.$Tc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Qe.length;et++){const rt=Qe[et];if(rt)if(K.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{ze.only&&(rt.kind?ze.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$eH)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$eH)(this.m,"codeActionRanges")?(0,v.$Gb)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(j,B){const[H,V]=j,re=this.e.get(H,V);if(!re||K.o(re))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(re,B)??re;let Ce;ge.edit&&(Ce=i.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const Qe=this.f.get(H);Qe&&(ze=this.h.toInternal(ge.command,Qe))}return{edit:Ce,command:ze}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class L{constructor(j,B,H,V,re){this.e=j,this.f=B,this.g=H,this.h=V,this.j=re,this.d=new g.$epc("DocumentPasteEdit")}async prepareDocumentPaste(j,B,H,V){if(!this.g.prepareDocumentPaste)return;const re=this.f.getDocument(j),ge=B.map(Qe=>i.Range.to(Qe)),Ce=i.DataTransfer.toDataTransfer(H,()=>{throw new O.$0});if(await this.g.prepareDocumentPaste(re,ge,Ce,V),V.isCancellationRequested)return;const ze=Array.from(Ce).filter(([,Qe])=>!(Qe instanceof n.$BO));return i.DataTransfer.from(ze)}async providePasteEdits(j,B,H,V,re,ge){if(!this.g.provideDocumentPasteEdits)return[];const Ce=this.f.getDocument(B),ze=H.map(nt=>i.Range.to(nt)),Qe=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolvePasteFileData(this.h,j,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ce,ze,Qe,{only:re.only?new n.$GO(re.only):void 0,triggerKind:re.triggerKind},ge);if(!_e||ge.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10787,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,B){const[H,V]=j,re=this.d.get(H,V);if(!re||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(re,B)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class Q{constructor(j,B){this.d=j,this.e=B}async provideDocumentFormattingEdits(j,B,H){const V=this.d.getDocument(j),re=await this.e.provideDocumentFormattingEdits(V,B,H);if(Array.isArray(re))return re.map(i.TextEdit.from)}}class X{constructor(j,B){this.d=j,this.e=B}async provideDocumentRangeFormattingEdits(j,B,H,V){const re=this.d.getDocument(j),ge=i.Range.to(B),Ce=await this.e.provideDocumentRangeFormattingEdits(re,ge,H,V);if(Array.isArray(Ce))return Ce.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,B,H,V){(0,y.$og)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const re=this.d.getDocument(j),ge=B.map(i.Range.to),Ce=await this.e.provideDocumentRangesFormattingEdits(re,ge,H,V);if(Array.isArray(Ce))return Ce.map(i.TextEdit.from)}}class ue{constructor(j,B){this.d=j,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,B,H,V,re){const ge=this.d.getDocument(j),Ce=i.Position.to(B),ze=await this.e.provideOnTypeFormattingEdits(ge,Ce,H,V,re);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class ee{constructor(j,B){this.e=j,this.f=B,this.d=new g.$epc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,B){const H=await this.e.provideWorkspaceSymbols(j,B);if(!(0,v.$Kb)(H))return{symbols:[]};const V=this.d.add(H),re={cacheId:V,symbols:[]};for(let ge=0;ge<H.length;ge++){const Ce=H[ge];if(!Ce||!Ce.name){this.f.warn("INVALID SymbolInformation",Ce);continue}re.symbols.push({...i.WorkspaceSymbol.from(Ce),cacheId:[V,ge]})}return re}async resolveWorkspaceSymbol(j,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const H=this.d.get(...j.cacheId);if(H){const V=await this.e.resolveWorkspaceSymbol(H,B);return V&&(0,$.$go)(j,i.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class me{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,B,H){this.d=j,this.e=B,this.f=H}async provideRenameEdits(j,B,H,V){const re=this.d.getDocument(j),ge=i.Position.to(B);try{const Ce=await this.e.provideRenameEdits(re,ge,H,V);return Ce?i.WorkspaceEdit.from(Ce):void 0}catch(Ce){const ze=me.g(Ce);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ce)}}async resolveRenameLocation(j,B,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(j),re=i.Position.to(B);try{const ge=await this.e.prepareRename(V,re,H);let Ce,ze;if(n.$LN.isRange(ge)?(Ce=ge,ze=V.getText(ge)):(0,y.$gg)(ge)&&(Ce=ge.range,ze=ge.placeholder),!Ce||!ze)return;if(Ce.start.line>re.line||Ce.end.line<re.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ce),text:ze}}catch(ge){const Ce=me.g(ge);return Ce?{rejectReason:Ce,range:void 0,text:void 0}:Promise.reject(ge)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class oe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(j,B,H){this.e=j,this.f=B,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,B,H,V){const re=this.e.getDocument(j),ge=i.Range.to(B);try{const Ce=oe.d[H],ze=await this.f.provideNewSymbolNames(re,ge,Ce,V);return ze?ze.map(Qe=>typeof Qe=="string"?{newSymbolName:Qe}:{newSymbolName:Qe.newSymbolName,tags:Qe.tags}):void 0}catch(Ce){this.g.error(oe.h(Ce)??JSON.stringify(Ce,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ce{constructor(j,B){this.resultId=j,this.tokens=B}}class we{constructor(j,B){this.f=j,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,B,H){const V=this.f.getDocument(j),re=B!==0?this.d.get(B):null;let ge=typeof re?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,re.resultId,H):await this.g.provideDocumentSemanticTokens(V,H);return re&&this.d.delete(B),ge?(ge=we.h(ge),this.o(we.n(re,ge),ge)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return we.j(j)?we.k(j)?j:new n.$7O(new Uint32Array(j.data),j.resultId):we.l(j)?we.m(j)?j:new n.$9O(j.edits.map(B=>new n.$8O(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const B of j.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(j,B){if(!we.j(B)||!j||!j.tokens)return B;const H=j.tokens,V=H.length,re=B.data,ge=re.length;let Ce=0;const ze=Math.min(V,ge);for(;Ce<ze&&H[Ce]===re[Ce];)Ce++;if(Ce===V&&Ce===ge)return new n.$9O([],B.resultId);let Qe=0;const _e=ze-Ce;for(;Qe<_e&&H[V-Qe-1]===re[ge-Qe-1];)Qe++;return new n.$9O([{start:Ce,deleteCount:V-Ce-Qe,data:re.subarray(Ce,ge-Qe)}],B.resultId)}o(j,B){if(we.j(j)){const H=this.e++;return this.d.set(H,new ce(j.resultId,j.data)),(0,o.$Udb)({id:H,type:"full",data:j.data})}if(we.l(j)){const H=this.e++;return we.j(B)?this.d.set(H,new ce(B.resultId,B.data)):this.d.set(H,new ce(j.resultId)),(0,o.$Udb)({id:H,type:"delta",deltas:(j.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class ae{constructor(j,B){this.d=j,this.e=B}async provideDocumentRangeSemanticTokens(j,B,H){const V=this.d.getDocument(j),re=await this.e.provideDocumentRangeSemanticTokens(V,i.Range.to(B),H);return re?this.f(re):null}f(j){return(0,o.$Udb)({id:0,type:"full",data:j.data})}}class Ie{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,B,H,V,re){this.f=j,this.g=B,this.h=H,this.j=V,this.k=re,this.d=new g.$epc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,B,H,V){const re=this.f.getDocument(j),ge=i.Position.to(B),Ce=re.getWordRangeAtPosition(ge)||new n.$LN(ge,ge),ze=Ce.with({end:ge}),Qe=new s.$fe,_e=await this.h.provideCompletionItems(re,ge,V,i.CompletionContext.to(H));if(!_e||V.isCancellationRequested)return;const tt=Array.isArray(_e)?new n.$iO(_e):_e,nt=Ie.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new A.$Tc;this.e.set(nt,et);const rt=[],ft={x:nt,[u.ISuggestResultDtoField.completions]:rt,[u.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ce),insert:i.Range.from(ze)},[u.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[u.ISuggestResultDtoField.duration]:Qe.elapsed()};for(let lt=0;lt<tt.items.length;lt++){const st=tt.items[lt],ct=this.l(st,[nt,lt],ze,Ce);rt.push(ct)}return ft}async resolveCompletionItem(j,B){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...j);if(!H)return;const V=this.l(H,j),re=await this.h.resolveCompletionItem(H,B);if(!re)return;const ge=this.l(re,j);return(V[u.ISuggestDataDtoField.insertText]!==ge[u.ISuggestDataDtoField.insertText]||V[u.ISuggestDataDtoField.insertTextRules]!==ge[u.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V[u.ISuggestDataDtoField.commandIdent]!==ge[u.ISuggestDataDtoField.commandIdent]||V[u.ISuggestDataDtoField.commandId]!==ge[u.ISuggestDataDtoField.commandId]||!(0,$.$ho)(V[u.ISuggestDataDtoField.commandArguments],ge[u.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,[u.ISuggestDataDtoField.documentation]:ge[u.ISuggestDataDtoField.documentation],[u.ISuggestDataDtoField.detail]:ge[u.ISuggestDataDtoField.detail],[u.ISuggestDataDtoField.additionalTextEdits]:ge[u.ISuggestDataDtoField.additionalTextEdits],[u.ISuggestDataDtoField.insertText]:ge[u.ISuggestDataDtoField.insertText],[u.ISuggestDataDtoField.insertTextRules]:ge[u.ISuggestDataDtoField.insertTextRules],[u.ISuggestDataDtoField.commandIdent]:ge[u.ISuggestDataDtoField.commandIdent],[u.ISuggestDataDtoField.commandId]:ge[u.ISuggestDataDtoField.commandId],[u.ISuggestDataDtoField.commandArguments]:ge[u.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,B,H,V){const re=this.e.get(B[0]);if(!re)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(j.command,re),Ce={x:B,[u.ISuggestDataDtoField.label]:j.label,[u.ISuggestDataDtoField.kind]:j.kind!==void 0?i.CompletionItemKind.from(j.kind):void 0,[u.ISuggestDataDtoField.kindModifier]:j.tags&&j.tags.map(i.CompletionItemTag.from),[u.ISuggestDataDtoField.detail]:j.detail,[u.ISuggestDataDtoField.documentation]:typeof j.documentation>"u"?void 0:i.MarkdownString.fromStrict(j.documentation),[u.ISuggestDataDtoField.sortText]:j.sortText!==j.label?j.sortText:void 0,[u.ISuggestDataDtoField.filterText]:j.filterText!==j.label?j.filterText:void 0,[u.ISuggestDataDtoField.preselect]:j.preselect||void 0,[u.ISuggestDataDtoField.insertTextRules]:j.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[u.ISuggestDataDtoField.commitCharacters]:j.commitCharacters?.join(""),[u.ISuggestDataDtoField.additionalTextEdits]:j.additionalTextEdits&&j.additionalTextEdits.map(i.TextEdit.from),[u.ISuggestDataDtoField.commandIdent]:ge?.$ident,[u.ISuggestDataDtoField.commandId]:ge?.id,[u.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ce[u.ISuggestDataDtoField.insertText]=j.textEdit.newText):typeof j.insertText=="string"?Ce[u.ISuggestDataDtoField.insertText]=j.insertText:j.insertText instanceof n.$WN&&(Ce[u.ISuggestDataDtoField.insertText]=j.insertText.value,Ce[u.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let ze;return j.textEdit?ze=j.textEdit.range:j.range&&(ze=j.range),n.$LN.isRange(ze)?Ce[u.ISuggestDataDtoField.range]=i.Range.from(ze):ze&&(!H?.isEqual(ze.inserting)||!V?.isEqual(ze.replacing))&&(Ce[u.ISuggestDataDtoField.range]={insert:i.Range.from(ze.inserting),replace:i.Range.from(ze.replacing)}),Ce}}class Fe{async provideInlineCompletions(j,B,H,V){}async provideInlineEdits(j,B,H,V){}disposeCompletions(j){}handleDidShowCompletionItem(j,B,H){}handlePartialAccept(j,B,H,V){}}class Y extends Fe{constructor(j,B,H,V){super(),this.f=j,this.g=B,this.h=H,this.j=V,this.d=new ne,this.e=(0,t.$eH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$eH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,B,H,V){const re=this.g.getDocument(j),ge=i.Position.to(B),Ce=await this.h.provideInlineCompletionItems(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},V);if(!Ce||V.isCancellationRequested)return;const ze=Array.isArray(Ce)?Ce:Ce.items,Qe=this.e?Array.isArray(Ce)?[]:Ce.commands||[]:[],_e=this.e&&!Array.isArray(Ce)?Ce.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((et,rt)=>{let ft;et.command&&(tt||(tt=new A.$Tc),ft=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new A.$Tc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(j,B,H,V){if(!this.h.provideInlineEdits)return;(0,t.$fH)(this.f,"inlineCompletionsAdditions");const re=this.g.getDocument(j),ge=i.Range.to(B),Ce=await this.h.provideInlineEdits(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind],userPrompt:H.userPrompt},V);if(!Ce||V.isCancellationRequested)return;const ze=Array.isArray(Ce)?Ce:Ce.items,Qe=this.e?Array.isArray(Ce)?[]:Ce.commands||[]:[],_e=this.e&&!Array.isArray(Ce)?Ce.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((et,rt)=>{let ft;et.command&&(tt||(tt=new A.$Tc),ft=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new A.$Tc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,B,H){const V=this.d.get(j)?.items[B];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,H)}handlePartialAccept(j,B,H,V){const re=this.d.get(j)?.items[B];re&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(re,H),this.h.handleDidPartiallyAcceptCompletionItem(re,i.PartialAcceptInfo.to(V)))}}class q{async provideInlineEdits(j,B,H){const V=this.f.getDocument(j),re=await this.g.provideInlineEdit(V,{triggerKind:this.e[B.triggerKind]},H);if(!re||H.isCancellationRequested)return;let ge;const Ce=this.d.createReferenceId({dispose(){ge?.dispose()},item:re});let ze;re.accepted&&(ge||(ge=new A.$Tc),ze=this.h.toInternal(re.accepted,ge));let Qe;return re.rejected&&(ge||(ge=new A.$Tc),Qe=this.h.toInternal(re.rejected,ge)),{pid:Ce,text:re.text,range:i.Range.from(re.range),accepted:ze,rejected:Qe}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,B,H,V){this.f=B,this.g=H,this.h=V,this.d=new ne,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class ne{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const B=this.e++;return this.d.set(B,j),B}disposeReferenceId(j){const B=this.d.get(j);return this.d.delete(j),B}get(j){return this.d.get(j)}}class ye{constructor(j,B){this.e=j,this.f=B,this.d=new g.$epc("SignatureHelp")}async provideSignatureHelp(j,B,H,V){const re=this.e.getDocument(j),ge=i.Position.to(B),Ce=this.g(H),ze=await this.f.provideSignatureHelp(re,ge,V,Ce);if(ze){const Qe=this.d.add([ze]);return{...i.SignatureHelp.from(ze),id:Qe}}}g(j){let B;if(j.activeSignatureHelp){const H=i.SignatureHelp.to(j.activeSignatureHelp),V=this.d.get(j.activeSignatureHelp.id,0);V?(B=V,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...j,activeSignatureHelp:B}}releaseSignatureHelp(j){this.d.delete(j)}}class le{constructor(j,B,H,V,re){this.f=j,this.g=B,this.h=H,this.j=V,this.k=re,this.d=new g.$epc("InlayHints"),this.e=new Map}async provideInlayHints(j,B,H){const V=this.f.getDocument(j),re=i.Range.to(B),ge=await this.h.provideInlayHints(V,re,H);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`);return}if(H.isCancellationRequested)return;const Ce=this.d.add(ge);this.e.set(Ce,new A.$Tc);const ze={hints:[],cacheId:Ce};for(let Qe=0;Qe<ge.length;Qe++)this.l(ge[Qe],re)&&ze.hints.push(this.m(ge[Qe],[Ce,Qe]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`),ze}async resolveInlayHint(j,B){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...j);if(!H)return;const V=await this.h.resolveInlayHint(H,B);if(V&&this.l(V))return this.m(V,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,B){return j.label.length===0||Array.isArray(j.label)&&j.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(B&&!B.contains(j.position))}m(j,B){const H=this.e.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(j.tooltip),position:i.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(i.TextEdit.from),kind:j.kind&&i.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")V.label=j.label;else{const re=[];V.label=re;for(const ge of j.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ce={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$XN.isLocation(ge.location)&&(Ce.location=i.location.from(ge.location)),ge.command&&(Ce.command=this.g.toInternal(ge.command,H)),re.push(Ce)}}return V}}class ve{constructor(j,B){this.e=j,this.f=B,this.d=new g.$epc("DocumentLink")}async provideLinks(j,B){const H=this.e.getDocument(j),V=await this.f.provideDocumentLinks(H,B);if(!(!Array.isArray(V)||V.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(ve.g).map(i.DocumentLink.from)};{const re=this.d.add(V),ge={links:[],cacheId:re};for(let Ce=0;Ce<V.length;Ce++){if(!ve.g(V[Ce]))continue;const ze=i.DocumentLink.from(V[Ce]);ze.cacheId=[re,Ce],ge.links.push(ze)}return ge}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,B){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...j);if(!H)return;const V=await this.f.resolveDocumentLink(H,B);if(!(!V||!ve.g(V)))return i.DocumentLink.from(V)}releaseLinks(j){this.d.delete(j)}}class de{constructor(j,B){this.d=j,this.e=B}async provideColors(j,B){const H=this.d.getDocument(j),V=await this.e.provideDocumentColors(H,B);return Array.isArray(V)?V.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(j,B,H){const V=this.d.getDocument(j),re=i.Range.to(B.range),ge=i.Color.to(B.color),Ce=await this.e.provideColorPresentations(ge,{document:V,range:re},H);if(Array.isArray(Ce))return Ce.map(i.ColorPresentation.from)}}class J{constructor(j,B){this.d=j,this.e=B}async provideFoldingRanges(j,B,H){const V=this.d.getDocument(j),re=await this.e.provideFoldingRanges(V,B,H);if(Array.isArray(re))return re.map(i.FoldingRange.from)}}class x{constructor(j,B,H){this.d=j,this.e=B,this.f=H}async provideSelectionRanges(j,B,H){const V=this.d.getDocument(j),re=B.map(i.Position.to),ge=await this.e.provideSelectionRanges(V,re,H);if(!(0,v.$Kb)(ge))return[];if(ge.length!==re.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ce=[];for(let ze=0;ze<re.length;ze++){const Qe=[];Ce.push(Qe);let _e=re[ze],tt=ge[ze];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ce}}class pe{constructor(j,B){this.f=j,this.g=B,this.d=new T.$mQ(""),this.e=new Map}async prepareSession(j,B,H){const V=this.f.getDocument(j),re=i.Position.to(B),ge=await this.g.prepareCallHierarchy(V,re,H);if(!ge)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ce,ze)):[this.h(Ce,ge)]}async provideCallsTo(j,B,H){const V=this.j(j,B);if(!V)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyIncomingCalls(V,H);if(re)return re.map(ge=>({from:this.h(j,ge.from),fromRanges:ge.fromRanges.map(Ce=>i.Range.from(Ce))}))}async provideCallsFrom(j,B,H){const V=this.j(j,B);if(!V)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyOutgoingCalls(V,H);if(re)return re.map(ge=>({to:this.h(j,ge.to),fromRanges:ge.fromRanges.map(Ce=>i.Range.from(Ce))}))}releaseSession(j){this.e.delete(j)}h(j,B){const H=this.e.get(j),V=i.CallHierarchyItem.from(B,j,H.size.toString(36));return H.set(V._itemId,B),V}j(j,B){return this.e.get(j)?.get(B)}}class $e{constructor(j,B){this.f=j,this.g=B,this.d=new T.$mQ(""),this.e=new Map}async prepareSession(j,B,H){const V=this.f.getDocument(j),re=i.Position.to(B),ge=await this.g.prepareTypeHierarchy(V,re,H);if(!ge)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ce,ze)):[this.h(Ce,ge)]}async provideSupertypes(j,B,H){const V=this.j(j,B);if(!V)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySupertypes(V,H);if(re)return re.map(ge=>this.h(j,ge))}async provideSubtypes(j,B,H){const V=this.j(j,B);if(!V)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySubtypes(V,H);if(re)return re.map(ge=>this.h(j,ge))}releaseSession(j){this.e.delete(j)}h(j,B){const H=this.e.get(j),V=i.TypeHierarchyItem.from(B,j,H.size.toString(36));return H.set(V._itemId,B),V}j(j,B){return this.e.get(j)?.get(B)}}class Ae{constructor(j,B,H,V,re){this.e=j,this.f=B,this.g=H,this.h=V,this.j=re,this.d=new g.$epc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,B,H,V,re){const ge=this.f.getDocument(B),Ce=i.Position.to(H),ze=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,nt)).buffer),Qe=await this.g.provideDocumentDropEdits(ge,Ce,ze,re);if(!Qe)return;const _e=(0,v.$1b)(Qe),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10788,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,B){const[H,V]=j,re=this.d.get(H,V);if(!re||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(re,B)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class Ue{constructor(j,B){this.d=j,this.e=B}async provideMappedEdits(j,B,H,V){const re=a.URI.revive(j),ge=this.d.getDocument(re),Ce=H.documents.map(_e=>_e.map(tt=>({uri:a.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),ze={documents:Ce,selections:Ce[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(ge,B,ze,V);return Qe?i.WorkspaceEdit.from(Qe):null}}class ke{constructor(j,B){this.adapter=j,this.extension=B}}class Pe{static{this.d=0}constructor(j,B,H,V,re,ge,Ce,ze){this.g=B,this.h=H,this.j=V,this.k=re,this.l=ge,this.m=Ce,this.n=ze,this.f=new Map,this.e=j.getProxy(u.$HN.MainThreadLanguageFeatures)}o(j,B){return i.DocumentSelector.from(j,this.g,B)}p(j){return new n.$JN(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Pe.d++}async s(j,B,H,V,re,ge=!1){const Ce=this.f.get(j);if(!Ce||!(Ce.adapter instanceof B))return V;const ze=Date.now();ge||this.l.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Qe=H(Ce.adapter,Ce.extension);return Promise.resolve(Qe).catch(_e=>{(0,O.$3)(_e)||(this.l.error(`[${Ce.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ce.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ce.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),P.CancellationToken.isCancellationToken(re)?(0,R.$th)(Qe,re):Qe}t(j,B){const H=this.q();return this.f.set(H,new ke(j,B)),H}static u(j){return j.displayName||j.name}static w(j){return j.identifier.value}registerDocumentSymbolProvider(j,B,H,V){const re=this.t(new m(this.h,H),j),ge=V&&V.label||Pe.u(j);return this.e.$registerDocumentSymbolProvider(re,this.o(B,j),ge),this.p(re)}$provideDocumentSymbols(j,B,H){return this.s(j,m,V=>V.provideDocumentSymbols(a.URI.revive(B),H),void 0,H)}registerCodeLensProvider(j,B,H){const V=this.q(),re=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new ke(new p(this.h,this.j.converter,H,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(V,this.o(B,j),re);let ge=this.p(V);if(re!==void 0){const Ce=H.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(re));ge=n.$JN.from(ge,Ce)}return ge}$provideCodeLenses(j,B,H){return this.s(j,p,V=>V.provideCodeLenses(a.URI.revive(B),H),void 0,H)}$resolveCodeLens(j,B,H){return this.s(j,p,V=>V.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(j,B){this.s(j,p,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(j,B,H){const V=this.t(new E(this.h,H),j);return this.e.$registerDefinitionSupport(V,this.o(B,j)),this.p(V)}$provideDefinition(j,B,H,V){return this.s(j,E,re=>re.provideDefinition(a.URI.revive(B),H,V),[],V)}registerDeclarationProvider(j,B,H){const V=this.t(new D(this.h,H),j);return this.e.$registerDeclarationSupport(V,this.o(B,j)),this.p(V)}$provideDeclaration(j,B,H,V){return this.s(j,D,re=>re.provideDeclaration(a.URI.revive(B),H,V),[],V)}registerImplementationProvider(j,B,H){const V=this.t(new w(this.h,H),j);return this.e.$registerImplementationSupport(V,this.o(B,j)),this.p(V)}$provideImplementation(j,B,H,V){return this.s(j,w,re=>re.provideImplementation(a.URI.revive(B),H,V),[],V)}registerTypeDefinitionProvider(j,B,H){const V=this.t(new I(this.h,H),j);return this.e.$registerTypeDefinitionSupport(V,this.o(B,j)),this.p(V)}$provideTypeDefinition(j,B,H,V){return this.s(j,I,re=>re.provideTypeDefinition(a.URI.revive(B),H,V),[],V)}registerHoverProvider(j,B,H,V){const re=this.t(new C(this.h,H),j);return this.e.$registerHoverProvider(re,this.o(B,j)),this.p(re)}$provideHover(j,B,H,V,re){return this.s(j,C,ge=>ge.provideHover(a.URI.revive(B),H,V,re),void 0,re)}$releaseHover(j,B){this.s(j,C,H=>Promise.resolve(H.releaseHover(B)),void 0,void 0)}registerEvaluatableExpressionProvider(j,B,H,V){const re=this.t(new f(this.h,H),j);return this.e.$registerEvaluatableExpressionProvider(re,this.o(B,j)),this.p(re)}$provideEvaluatableExpression(j,B,H,V){return this.s(j,f,re=>re.provideEvaluatableExpression(a.URI.revive(B),H,V),void 0,V)}registerInlineValuesProvider(j,B,H,V){const re=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new b(this.h,H),j);this.e.$registerInlineValuesProvider(ge,this.o(B,j),re);let Ce=this.p(ge);if(re!==void 0){const ze=H.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(re));Ce=n.$JN.from(Ce,ze)}return Ce}$provideInlineValues(j,B,H,V,re){return this.s(j,b,ge=>ge.provideInlineValues(a.URI.revive(B),H,V,re),void 0,re)}registerDocumentHighlightProvider(j,B,H){const V=this.t(new M(this.h,H),j);return this.e.$registerDocumentHighlightProvider(V,this.o(B,j)),this.p(V)}registerMultiDocumentHighlightProvider(j,B,H){const V=this.t(new N(this.h,H),j);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(B,j)),this.p(V)}$provideDocumentHighlights(j,B,H,V){return this.s(j,M,re=>re.provideDocumentHighlights(a.URI.revive(B),H,V),void 0,V)}$provideMultiDocumentHighlights(j,B,H,V,re){return this.s(j,N,ge=>ge.provideMultiDocumentHighlights(a.URI.revive(B),H,V.map(Ce=>a.URI.revive(Ce)),re),void 0,re)}registerLinkedEditingRangeProvider(j,B,H){const V=this.t(new F(this.h,H),j);return this.e.$registerLinkedEditingRangeProvider(V,this.o(B,j)),this.p(V)}$provideLinkedEditingRanges(j,B,H,V){return this.s(j,F,async re=>{const ge=await re.provideLinkedEditingRanges(a.URI.revive(B),H,V);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Pe.y(ge.wordPattern):void 0}},void 0,V)}registerReferenceProvider(j,B,H){const V=this.t(new W(this.h,H),j);return this.e.$registerReferenceSupport(V,this.o(B,j)),this.p(V)}$provideReferences(j,B,H,V,re){return this.s(j,W,ge=>ge.provideReferences(a.URI.revive(B),H,V,re),void 0,re)}registerCodeActionProvider(j,B,H,V){const re=new A.$Tc,ge=this.t(new K(this.h,this.j.converter,this.k,H,this.l,j,this.m),j);return this.e.$registerCodeActionSupport(ge,this.o(B,j),{providedKinds:V?.providedCodeActionKinds?.map(Ce=>Ce.value),documentation:V?.documentation?.map(Ce=>({kind:Ce.kind.value,command:this.j.converter.toInternal(Ce.command,re)}))},Pe.u(j),Pe.w(j),!!H.resolveCodeAction),re.add(this.p(ge)),re}$provideCodeActions(j,B,H,V,re){return this.s(j,K,ge=>ge.provideCodeActions(a.URI.revive(B),H,V,re),void 0,re)}$resolveCodeAction(j,B,H){return this.s(j,K,V=>V.resolveCodeAction(B,H),{},void 0)}$releaseCodeActions(j,B){this.s(j,K,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(j,B,H){const V=this.t(new Q(this.h,H),j);return this.e.$registerDocumentFormattingSupport(V,this.o(B,j),j.identifier,j.displayName||j.name),this.p(V)}$provideDocumentFormattingEdits(j,B,H,V){return this.s(j,Q,re=>re.provideDocumentFormattingEdits(a.URI.revive(B),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(j,B,H){const V=typeof H.provideDocumentRangesFormattingEdits=="function",re=this.t(new X(this.h,H),j);return this.e.$registerRangeFormattingSupport(re,this.o(B,j),j.identifier,j.displayName||j.name,V),this.p(re)}$provideDocumentRangeFormattingEdits(j,B,H,V,re){return this.s(j,X,ge=>ge.provideDocumentRangeFormattingEdits(a.URI.revive(B),H,V,re),void 0,re)}$provideDocumentRangesFormattingEdits(j,B,H,V,re){return this.s(j,X,ge=>ge.provideDocumentRangesFormattingEdits(a.URI.revive(B),H,V,re),void 0,re)}registerOnTypeFormattingEditProvider(j,B,H,V){const re=this.t(new ue(this.h,H),j);return this.e.$registerOnTypeFormattingSupport(re,this.o(B,j),V,j.identifier),this.p(re)}$provideOnTypeFormattingEdits(j,B,H,V,re,ge){return this.s(j,ue,Ce=>Ce.provideOnTypeFormattingEdits(a.URI.revive(B),H,V,re,ge),void 0,ge)}registerWorkspaceSymbolProvider(j,B){const H=this.t(new ee(B,this.l),j);return this.e.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(j,B,H){return this.s(j,ee,V=>V.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(j,B,H){return this.s(j,ee,V=>V.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(j,B){this.s(j,ee,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(j,B,H){const V=this.t(new me(this.h,H,this.l),j);return this.e.$registerRenameSupport(V,this.o(B,j),me.supportsResolving(H)),this.p(V)}$provideRenameEdits(j,B,H,V,re){return this.s(j,me,ge=>ge.provideRenameEdits(a.URI.revive(B),H,V,re),void 0,re)}$resolveRenameLocation(j,B,H,V){return this.s(j,me,re=>re.resolveRenameLocation(a.URI.revive(B),H,V),void 0,V)}registerNewSymbolNamesProvider(j,B,H){const V=this.t(new oe(this.h,H,this.l),j);return this.e.$registerNewSymbolNamesProvider(V,this.o(B,j)),this.p(V)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,oe,B=>B.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,B,H,V,re){return this.s(j,oe,ge=>ge.provideNewSymbolNames(a.URI.revive(B),H,V,re),void 0,re)}registerDocumentSemanticTokensProvider(j,B,H,V){const re=this.t(new we(this.h,H),j),ge=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(re,this.o(B,j),V,ge);let Ce=this.p(re);if(ge){const ze=H.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(ge));Ce=n.$JN.from(Ce,ze)}return Ce}$provideDocumentSemanticTokens(j,B,H,V){return this.s(j,we,re=>re.provideDocumentSemanticTokens(a.URI.revive(B),H,V),null,V)}$releaseDocumentSemanticTokens(j,B){this.s(j,we,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,B,H,V){const re=this.t(new ae(this.h,H),j);return this.e.$registerDocumentRangeSemanticTokensProvider(re,this.o(B,j),V),this.p(re)}$provideDocumentRangeSemanticTokens(j,B,H,V){return this.s(j,ae,re=>re.provideDocumentRangeSemanticTokens(a.URI.revive(B),H,V),null,V)}registerCompletionItemProvider(j,B,H,V){const re=this.t(new Ie(this.h,this.j.converter,H,this.m,j),j);return this.e.$registerCompletionsProvider(re,this.o(B,j),V,Ie.supportsResolving(H),j.identifier),this.p(re)}$provideCompletionItems(j,B,H,V,re){return this.s(j,Ie,ge=>ge.provideCompletionItems(a.URI.revive(B),H,V,re),void 0,re)}$resolveCompletionItem(j,B,H){return this.s(j,Ie,V=>V.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(j,B){this.s(j,Ie,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(j,B,H,V){const re=new Y(j,this.h,H,this.j.converter),ge=this.t(re,j);return this.e.$registerInlineCompletionsSupport(ge,this.o(B,j),re.supportsHandleEvents,l.$qn.toKey(j.identifier.value),V?.yieldTo?.map(Ce=>l.$qn.toKey(Ce))||[]),this.p(ge)}$provideInlineCompletions(j,B,H,V,re){return this.s(j,Fe,ge=>ge.provideInlineCompletions(a.URI.revive(B),H,V,re),void 0,re)}$provideInlineEdits(j,B,H,V,re){return this.s(j,Fe,ge=>ge.provideInlineEdits(a.URI.revive(B),H,V,re),void 0,re)}$handleInlineCompletionDidShow(j,B,H,V){this.s(j,Fe,async re=>{re.handleDidShowCompletionItem(B,H,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,B,H,V,re){this.s(j,Fe,async ge=>{ge.handlePartialAccept(B,H,V,re)},void 0,void 0)}$freeInlineCompletionsList(j,B){this.s(j,Fe,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(j,B,H){const V=new q(j,this.h,H,this.j.converter),re=this.t(V,j);return this.e.$registerInlineEditProvider(re,this.o(B,j),j.identifier),this.p(re)}$provideInlineEdit(j,B,H,V){return this.s(j,q,re=>re.provideInlineEdits(a.URI.revive(B),H,V),void 0,V)}$freeInlineEdit(j,B){this.s(j,q,async H=>{H.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(j,B,H,V){const re=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ge=this.t(new ye(this.h,H),j);return this.e.$registerSignatureHelpProvider(ge,this.o(B,j),re),this.p(ge)}$provideSignatureHelp(j,B,H,V,re){return this.s(j,ye,ge=>ge.provideSignatureHelp(a.URI.revive(B),H,V,re),void 0,re)}$releaseSignatureHelp(j,B){this.s(j,ye,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(j,B,H){const V=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,re=this.t(new le(this.h,this.j.converter,H,this.l,j),j);this.e.$registerInlayHintsProvider(re,this.o(B,j),typeof H.resolveInlayHint=="function",V,Pe.u(j));let ge=this.p(re);if(V!==void 0){const Ce=H.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(V));ge=n.$JN.from(ge,Ce)}return ge}$provideInlayHints(j,B,H,V){return this.s(j,le,re=>re.provideInlayHints(a.URI.revive(B),H,V),void 0,V)}$resolveInlayHint(j,B,H){return this.s(j,le,V=>V.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(j,B){this.s(j,le,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(j,B,H){const V=this.t(new ve(this.h,H),j);return this.e.$registerDocumentLinkProvider(V,this.o(B,j),typeof H.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(j,B,H){return this.s(j,ve,V=>V.provideLinks(a.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(j,B,H){return this.s(j,ve,V=>V.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(j,B){this.s(j,ve,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(j,B,H){const V=this.t(new de(this.h,H),j);return this.e.$registerDocumentColorProvider(V,this.o(B,j)),this.p(V)}$provideDocumentColors(j,B,H){return this.s(j,de,V=>V.provideColors(a.URI.revive(B),H),[],H)}$provideColorPresentations(j,B,H,V){return this.s(j,de,re=>re.provideColorPresentations(a.URI.revive(B),H,V),void 0,V)}registerFoldingRangeProvider(j,B,H){const V=this.q(),re=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new ke(new J(this.h,H),j)),this.e.$registerFoldingRangeProvider(V,this.o(B,j),j.identifier,re);let ge=this.p(V);if(re!==void 0){const Ce=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(re));ge=n.$JN.from(ge,Ce)}return ge}$provideFoldingRanges(j,B,H,V){return this.s(j,J,re=>re.provideFoldingRanges(a.URI.revive(B),H,V),void 0,V)}registerSelectionRangeProvider(j,B,H){const V=this.t(new x(this.h,H,this.l),j);return this.e.$registerSelectionRangeProvider(V,this.o(B,j)),this.p(V)}$provideSelectionRanges(j,B,H,V){return this.s(j,x,re=>re.provideSelectionRanges(a.URI.revive(B),H,V),[],V)}registerCallHierarchyProvider(j,B,H){const V=this.t(new pe(this.h,H),j);return this.e.$registerCallHierarchyProvider(V,this.o(B,j)),this.p(V)}$prepareCallHierarchy(j,B,H,V){return this.s(j,pe,re=>Promise.resolve(re.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(j,B,H,V){return this.s(j,pe,re=>re.provideCallsTo(B,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(j,B,H,V){return this.s(j,pe,re=>re.provideCallsFrom(B,H,V),void 0,V)}$releaseCallHierarchy(j,B){this.s(j,pe,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(j,B,H){const V=this.t(new $e(this.h,H),j);return this.e.$registerTypeHierarchyProvider(V,this.o(B,j)),this.p(V)}$prepareTypeHierarchy(j,B,H,V){return this.s(j,$e,re=>Promise.resolve(re.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideTypeHierarchySupertypes(j,B,H,V){return this.s(j,$e,re=>re.provideSupertypes(B,H,V),void 0,V)}$provideTypeHierarchySubtypes(j,B,H,V){return this.s(j,$e,re=>re.provideSubtypes(B,H,V),void 0,V)}$releaseTypeHierarchy(j,B){this.s(j,$e,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(j,B,H,V){const re=this.q();return this.f.set(re,new ke(new Ae(this.e,this.h,H,re,j),j)),this.e.$registerDocumentOnDropEditProvider(re,this.o(B,j),(0,t.$eH)(j,"documentPaste")&&V?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:V.dropMimeTypes}:void 0),this.p(re)}$provideDocumentOnDropEdits(j,B,H,V,re,ge){return this.s(j,Ae,Ce=>Promise.resolve(Ce.provideDocumentOnDropEdits(B,a.URI.revive(H),V,re,ge)),void 0,void 0)}$resolveDropEdit(j,B,H){return this.s(j,Ae,V=>V.resolveDropEdit(B,H),{},void 0)}$releaseDocumentOnDropEdits(j,B){this.s(j,Ae,H=>Promise.resolve(H.releaseDropEdits(B)),void 0,void 0)}registerMappedEditsProvider(j,B,H){const V=this.t(new Ue(this.h,H),j);return this.e.$registerMappedEditsProvider(V,this.o(B,j),j.displayName??j.name),this.p(V)}$provideMappedEdits(j,B,H,V,re){return this.s(j,Ue,ge=>Promise.resolve(ge.provideMappedEdits(B,H,V,re)),null,re)}registerDocumentPasteEditProvider(j,B,H,V){const re=this.q();return this.f.set(re,new ke(new L(this.e,this.h,H,re,j),j)),this.e.$registerPasteEditProvider(re,this.o(B,j),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:V.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(re)}$prepareDocumentPaste(j,B,H,V,re){return this.s(j,L,ge=>ge.prepareDocumentPaste(a.URI.revive(B),H,V,re),void 0,re)}$providePasteEdits(j,B,H,V,re,ge,Ce){return this.s(j,L,ze=>ze.providePasteEdits(B,a.URI.revive(H),V,re,ge,Ce),void 0,Ce)}$resolvePasteEdit(j,B,H){return this.s(j,L,V=>V.resolvePasteEdit(B,H),{},void 0)}$releasePasteEdits(j,B){this.s(j,L,H=>Promise.resolve(H.releasePasteEdits(B)),void 0,void 0)}static y(j){return{pattern:j.source,flags:j.flags}}static z(j){return{decreaseIndentPattern:Pe.y(j.decreaseIndentPattern),increaseIndentPattern:Pe.y(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Pe.y(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Pe.y(j.unIndentedLinePattern):void 0}}static B(j){return{beforeText:Pe.y(j.beforeText),afterText:j.afterText?Pe.y(j.afterText):void 0,previousLineText:j.previousLineText?Pe.y(j.previousLineText):void 0,action:j.action}}static C(j){return j.map(Pe.B)}static D(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(B=>n.SyntaxTokenType.toString(B)):void 0}}static E(j){return j.map(Pe.D)}setLanguageConfiguration(j,B,H){const{wordPattern:V}=H;if(V&&(0,k.$rf)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(B,V):this.h.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const re=this.q(),ge={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Pe.y(H.wordPattern):void 0,indentationRules:H.indentationRules?Pe.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Pe.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Pe.E(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(re,B,ge),this.p(re)}$setWordDefinitions(j){for(const B of j)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.$opc=Pe}),define(Oe[244],Ne([1,0,4,5,8]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=void 0,P=We(P);class O{constructor(A){this.a=new Map,this.c=new Map,this.b=A.getProxy(R.$HN.MainThreadLanguageModelTools),this.b.$getTools().then($=>{for(const s of $)this.c.set(s.name,s)})}async invokeTool(A,$,s){return await this.b.$invokeTool(A,$,s)}async $acceptToolDelta(A){A.added&&this.c.set(A.added.name,A.added),A.removed&&this.c.delete(A.removed)}get tools(){return Array.from(this.c.values()).map(A=>P.LanguageModelToolDescription.to(A))}async $invokeTool(A,$,s){const k=this.a.get(A);if(!k)throw new Error(`Unknown tool ${A}`);return await k.tool.invoke($,s)}registerTool(A,$,s){return this.a.set($,{extension:A,tool:s}),this.b.$registerTool($),(0,v.$Sc)(()=>{this.a.delete($),this.b.$unregisterTool($)})}}e.$Sqc=O}),define(Oe[94],Ne([1,0,10,21,42,13,6,39,4,9,18,3,11,76,5,90,16,8,7,117,24]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=e.$8pc=void 0,c=We(c),l=We(l),e.$8pc=(0,y.$Ei)("IExtHostLanguageModels");class g{constructor(h,E){this.option=h,this.stream=new v.$8h,this.stream=E??new v.$8h}}class u{constructor(){this.a=new Map,this.b=new v.$8h,this.c=!1;const h=this;this.apiObject={get stream(){return h.b.asyncIterable},get text(){return v.$5h.map(h.b.asyncIterable,E=>{if(E instanceof l.$4P)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;let E=this.a.get(h.index);E||(this.a.size===0?E=new g(h.index,this.b):E=new g(h.index),this.a.set(h.index,E));let D;h.part.type==="text"?D=new l.$4P(h.part.value):D=new l.$3P(h.part.name,h.part.parameters),E.stream.emitOne(D)}reject(h){this.c=!0;for(const E of this.d())E.reject(h)}resolve(){this.c=!0;for(const h of this.d())h.resolve()}}let m=class{static{t=this}static{this.a=1}constructor(h,E,D){this.j=E,this.k=D,this.c=new T.$le,this.d=new T.$le,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new k.$sn,this.i=new Map,this.s=new Set,this.b=h.getProxy(d.$HN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,E,D,w){const I=t.a++;this.f.set(I,{extension:h.identifier,provider:D,languageModelId:E});let C;w.auth&&(C={providerLabel:h.displayName||h.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(I,`${k.$qn.toKey(h.identifier)}/${I}/${E}`,{extension:h.identifier,id:E,vendor:w.vendor??k.$qn.toKey(h.identifier),name:w.name??"",family:w.family??"",version:w.version,maxInputTokens:w.maxInputTokens,maxOutputTokens:w.maxOutputTokens,auth:C,targetExtensions:w.extensions});const f=D.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:M,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new k.$qn(b),M,N)});return(0,$.$Sc)(()=>{this.f.delete(I),this.b.$unregisterProvider(I),f?.dispose()})}async $startChatRequest(h,E,D,w,I,C){const f=this.f.get(h);if(!f)throw new Error("Provider not found");const b=new S.$yw(async N=>{if(C.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let F;if(N.part instanceof l.$3P?F={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof l.$4P&&(F={type:"text",value:N.part.value}),!F){this.j.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:F})});let M;if(f.provider.provideLanguageModelResponse2)M=Promise.resolve(f.provider.provideLanguageModelResponse2(w.map(c.LanguageModelChatMessage.to),I,k.$qn.toKey(D),b,C));else{const N=new S.$yw(async F=>{b.report({index:F.index,part:new l.$4P(F.part)})});M=Promise.resolve(f.provider.provideLanguageModelResponse(w.map(c.LanguageModelChatMessage.to),I?.modelOptions??{},k.$qn.toKey(D),N,C))}M.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,O.$1)(N))})}$provideTokenLength(h,E,D){const w=this.f.get(h);return w?Promise.resolve(w.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(h){if(h.added)for(const{identifier:E,metadata:D}of h.added)this.g.set(E,{metadata:D,apiObjects:new k.$sn});if(h.removed)for(const E of h.removed){this.g.delete(E);for(const[D,w]of this.i)w.languageModelId===E&&(w.res.reject(new O.$4),this.i.delete(D))}h.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(h,E){const D=await this.b.$selectChatModels({...E,extension:h.identifier}),w=[],I=this;for(const C of D){const f=this.g.get(C);if(!f)continue;this.o(h.identifier,f.metadata)&&await this.q(f.metadata);let b=f.apiObjects.get(h.identifier);b||(b={id:C,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(M,N){if(!I.g.has(C))throw l.$8P.NotFound(C);return I.r(C,M,N??R.CancellationToken.None)},sendRequest(M,N,F){if(!I.g.has(C))throw l.$8P.NotFound(C);return I.l(h,C,M,N??{},F??R.CancellationToken.None)}},Object.freeze(b),f.apiObjects.set(h.identifier,b)),w.push(b)}return w}async l(h,E,D,w,I){const C=this.m(h,D),f=h.identifier,b=this.g.get(E)?.metadata;if(!b||!this.g.has(E))throw l.$8P.NotFound(`Language model '${E}' is unknown.`);if(this.o(f,b)&&(!await this.n(h,{identifier:b.extension,displayName:b.auth.providerLabel},w.justification,!1)||!this.h.get(f)?.has(b.extension)))throw l.$8P.NoPermissions(`Language model '${E}' cannot be used by '${f.value}'.`);try{const M=Math.random()*1e6|0,N=new u;this.i.set(M,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(f,E,M,C,w,I)}catch(F){throw this.i.delete(M),F}return N.apiObject}catch(M){throw M.name===l.$8P.name?M:new l.$8P(`Language model '${E}' errored: ${(0,P.$pj)(M)}`,"Unknown",M)}}m(h,E){const D=[];for(const w of E)w.role===l.LanguageModelChatMessageRole.System&&(0,n.$fH)(h,"languageModelSystem"),w.content2 instanceof l.$1P&&(0,n.$fH)(h,"lmTools"),D.push(c.LanguageModelChatMessage.from(w));return D}async $acceptResponsePart(h,E){const D=this.i.get(h);D&&D.res.handleFragment(E)}async $acceptResponseDone(h,E){const D=this.i.get(h);D&&(this.i.delete(h),E?D.res.reject((0,O.$2)(E)):D.res.resolve())}async n(h,E,D,w){const I=i.$JM+E.identifier.value;if(await this.k.getSession(h,I,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0;if(w)return!1;try{const f=D?(0,s.localize)(10786,null,E.displayName,D):void 0;return await this.k.getSession(h,I,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(h,E){return!!E.auth&&!k.$qn.equals(E.extension,h)}async q(h){if(h.auth)for(const E of this.s)try{await this.n(E,{identifier:h.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(h,E,D){if(!this.g.get(h))throw l.$8P.NotFound(`Language model '${h}' is unknown.`);const I=A.Iterable.find(this.f.values(),C=>C.languageModelId===h);return I?I.provider.provideTokenCount(E,D):this.b.$countTokens(h,typeof E=="string"?E:c.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(h){const E=new Array;for(const{from:D,to:w,enabled:I}of h){const C=this.h.get(D)??new k.$rn;if(C.has(w)!==I){I?C.add(w):C.delete(w),this.h.set(D,C);const b={from:D,to:w};E.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(h){this.s.add(h);const E=this,D=T.Event.signal(T.Event.filter(this.c.event,I=>k.$qn.equals(I.from,h.identifier))),w=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(D,w)},canSendRequest(I){let C;e:for(const[b,M]of E.g)for(const N of M.apiObjects.values())if(N===I){C=M.metadata;break e}if(!C)return;if(!E.o(h.identifier,C))return!0;const f=E.h.get(h.identifier);if(f)return f.has(C.extension)}}}};e.$9pc=m,e.$9pc=m=t=Je([Ve(0,o.$hQ),Ve(1,a.$_j),Ve(2,r.$qpc)],m)});var xt=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[245],Ne([1,0,5,8,7,35,10,4,24]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=void 0,R=We(R),O=xt(O);class s{constructor(y,a,S,d){this.c=a,this.d=S,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$HN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,a){await this.a.$changeLanguage(y,a);const S=this.c.getDocumentData(y);if(!S)throw new Error(`document '${y.toString()}' NOT found`);return S.document}async tokenAtPosition(y,a){const S=y.version,d=R.Position.from(a),r=await this.a.$tokensAtPosition(y.uri,d),o={type:P.StandardTokenType.Other,range:y.getWordRangeAtPosition(a)??new P.$LN(a.line,a.character,a.line,a.character)};if(!r)return o;const c={range:R.Range.to(r.range),type:R.TokenType.to(r.type)};return!c.range.contains(a)||S!==y.version?o:c}createLanguageStatusItem(y,a,S){const d=this.f++,r=this.a,o=this.g,c=`${y.identifier.value}/${a}`;if(o.has(c))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);o.add(c);const l={selector:S,id:a,name:y.displayName??y.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new A.$Tc,t=()=>{if(i?.dispose(),!o.has(c)){console.warn(`LanguageStatusItem (${a}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,T.$Gh)(()=>{n.clear(),this.a.$setLanguageStatus(d,{id:c,name:l.name??y.displayName??y.name,source:y.displayName??y.name,selector:R.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===P.LanguageStatusSeverity.Error?O.default.Error:l.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:l.command&&this.d.toInternal(l.command,n),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},g={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(d),o.delete(c)},get id(){return l.id},get name(){return l.name},set name(u){l.name=u,t()},get selector(){return l.selector},set selector(u){l.selector=u,t()},get text(){return l.text},set text(u){l.text=u,t()},set text2(u){(0,$.$fH)(y,"languageStatusText"),l.text=u,t()},get text2(){return(0,$.$fH)(y,"languageStatusText"),l.text},get detail(){return l.detail},set detail(u){l.detail=u,t()},get severity(){return l.severity},set severity(u){l.severity=u,t()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(u){l.accessibilityInformation=u,t()},get command(){return l.command},set command(u){l.command=u,t()},get busy(){return l.busy},set busy(u){l.busy=u,t()}};return t(),g}}e.$Tqc=s}),define(Oe[246],Ne([1,0,15,2,8,7,89]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=e.$Eqc=void 0,P=We(P),T=We(T);class A{constructor(y,a,S,d){this.start=y,this.deletedCount=a,this.deletedItems=S,this.items=d}asApiEvent(){return{range:new O.$bP(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,a,S){this.notebook=y,this.h=a,this.j=S,this.handle=S.handle,this.uri=R.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(P.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(S)}return this.f}setOutputs(y){this.a=y.map(P.NotebookCellOutput.to)}setOutputItems(y,a,S){const d=S.map(P.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===y);if(r&&(a||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(o=>T.$KL(o.mime)))){const o=new Map,c=[];r.items.forEach(l=>{let i;o.has(l.mime)?i=o.get(l.mime):(i=[],o.set(l.mime,i),c.push(l.mime)),i.push(l.data)}),r.items.length=0,c.forEach(l=>{const i=T.$LL(o.get(l));r.items.push({mime:l,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Eqc=$;class s{static{this.a=0}constructor(y,a,S,d,r){this.k=y,this.l=a,this.m=S,this.uri=d,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,a={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(S){return S=y.n(S),y.b[S].apiCell},getCells(S){return(S?y.p(S):y.b).map(r=>r.apiCell)},save(){return y.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,a,S){this.g=y.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:S});const d={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},r=[];for(const c of y.rawEvents)c.kind===T.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,d.contentChanges):c.kind===T.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,d.contentChanges):c.kind===T.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===T.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===T.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===T.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),r.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),r.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const o=new Map;for(let c=0;c<r.length;c++){const l=r[c],i=o.get(l.cell);if(i===void 0){const n=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});o.set(l.cell,n-1)}else d.cellChanges[i]={...d.cellChanges[i],...l}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let a=y.start|0,S=y.end|0;return a<0&&(a=0),S>this.b.length&&(S=this.b.length),y.with({start:a,end:S})}p(y){y=this.o(y);const a=[];for(let S=y.start;S<y.end;S++)a.push(this.b[S]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,a,S){if(this.j)return;const d=[],r=[],o=[];if(y.reverse().forEach(c=>{const i=c[2].map(g=>{const u=new $(this,this.l,g);return a||r.push($.asModelAddData(g)),u}),n=new A(c[0],c[1],[],i),t=this.b.splice(c[0],c[1],...i);for(const g of t)o.push(g.uri),n.deletedItems.push(g.apiCell);d.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),S)for(const c of d)S.push(c.asApiEvent())}s(y,a,S,d){const r=this.b.splice(y,a);this.b.splice(S,0,...r);const o=[new A(y,a,r.map(c=>c.apiCell),[]),new A(S,0,[],r)];for(const c of o)d.push(c.asApiEvent())}t(y,a){this.b[y].setOutputs(a)}u(y,a,S,d){this.b[y].setOutputItems(a,S,d)}v(y,a){const S=this.b[y];S.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(S.uri,a)}w(y,a){const S=this.b[y];S.apiCell.mime=a}x(y,a){this.b[y].setMetadata(a)}y(y,a){this.b[y].setInternalMetadata(a)}getCellFromApiCell(y){return this.b.find(a=>a.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(a=>a.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Fqc=s}),define(Oe[247],Ne([1,0,6,2,8,7,38]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=void 0;class A{constructor(s,k,y,a={timeout:1500,errors:3}){this.b=s,this.c=k,this.d=y,this.f=a,this.a=new v.$ne}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(k,y,a)=>{const S=function(r){k.call(y,r)};return S.extension=s,this.a.event(S,void 0,a)}}async $participateInSave(s,k,y){const a=R.URI.revive(s),S=this.c.getNotebookDocument(a);if(!S)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:P.TextDocumentSaveReason.to(k)},y,async(o,c)=>{const l=Date.now(),i=await await Promise.resolve(o);Date.now()-l>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof O.$VN?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const o of d){const{edits:c}=P.WorkspaceEdit.from(o);r.edits=r.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new T.$Ww(r))}}e.$Vqc=A}),define(Oe[124],Ne([1,0,13,8,7]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=void 0,R=We(R),P=We(P);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(A,$,s,k,y,a){this.id=A,this.f=$,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=k,this.c=a}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection($){this.selections=[$]},get selections(){return A.a},set selections($){if(!Array.isArray($)||!$.every(P.$bP.isNotebookRange))throw(0,v.$6)("selections");A.a=$,A.g($)},get visibleRanges(){return A.b},revealRange($,s){A.f.$tryRevealRange(A.id,R.NotebookRange.from($),s??P.NotebookEditorRevealType.Default)},get viewColumn(){return A.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(R.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.$Gqc=O}),define(Oe[248],Ne([1,0,6,11,8]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=void 0,P=We(P);let O=class{constructor(A,$){this.c=A,this.d=$,this.a=new v.$le,this.b=new v.$le,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,$);const s=this.d.getEditorById(A);$.visibleRanges&&s._acceptVisibleRanges($.visibleRanges.ranges.map(P.NotebookRange.to)),$.selections&&s._acceptSelections($.selections.selections.map(P.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const $ in A)this.d.getEditorById($)._acceptViewColumn(P.ViewColumn.to(A[$]))}};e.$Xqc=O,e.$Xqc=O=Je([Ve(0,R.$_j)],O)}),define(Oe[249],Ne([1,0,6,5,124]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0;class O{constructor(A,$){this.c=$,this.a=new Map,this.b=A.getProxy(R.$HN.MainThreadNotebookRenderers)}$postRendererMessage(A,$,s){const k=this.c.getEditorById(A);this.a.get($)?.fire({editor:k.apiEditor,message:s})}createRendererMessaging(A,$){if(!A.contributes?.notebookRenderer?.some(k=>k.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(k,y,a)=>this.d($).event(k,y,a),postMessage:(k,y)=>{P.$Gqc.apiEditorsToExtHost.has(k)&&([k,y]=[y,k]);const a=y&&P.$Gqc.apiEditorsToExtHost.get(y);return this.b.$postMessage(a?.id,$,k)}}}d(A){let $=this.a.get(A);return $||($=new v.$le({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(A)}}),this.a.set(A,$),$)}}e.$1qc=O}),define(Oe[250],Ne([1,0,8,76,21,71,13]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0;class A{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,a,S){const d=this.b++,{title:r,location:o,cancellable:c}=a,l={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(o),title:r,source:l,cancellable:c},y.isUnderDevelopment?void 0:y.identifier.value).catch(T.$Z),this.d(d,S,!!c)}d(y,a,S){let d;S&&(d=new P.$we,this.c.set(y,d));const r=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let o;try{o=a(new s(this.a,y),S&&d?d.token:P.CancellationToken.None)}catch(c){throw r(y),c}return o.then(c=>r(y),c=>r(y)),o}$acceptProgressCanceled(y){const a=this.c.get(y);a&&(a.cancel(),this.c.delete(y))}}e.$5qc=A;function $(k,y){return k.message=y.message,typeof y.increment=="number"&&(typeof k.increment=="number"?k.increment+=y.increment:k.increment=y.increment),k}class s extends R.$yw{constructor(y,a){super(S=>this.throttledReport(S)),this.c=y,this.d=a}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,O.$$h)(100,(k,y)=>$(k,y),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Oe[251],Ne([1,0,2,5,10,8]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0;class T{static{this.a=0}constructor($,s){this.d=s,this.c=new Map,this.b=$.getProxy(R.$HN.MainThreadQuickDiff)}$provideOriginalResource($,s,k){const y=v.URI.revive(s),a=this.c.get($);return a?(0,P.$wh)(()=>a.provideOriginalResource(y,k)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,s,k,y){const a=T.a++;return this.c.set(a,s),this.b.$registerQuickDiffProvider(a,O.DocumentSelector.from($,this.d),k,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$6qc=T});var xt=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[252],Ne([1,0,21,6,4,5,2,7,13,17,35,34,24,8]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=d,k=xt(k);function d(r,o,c){const l=r.getProxy(O.$HN.MainThreadQuickOpen);class i{constructor(D,w){this.e=new Map,this.f=0,this.a=D,this.b=w}showQuickPick(D,w,I,C=v.CancellationToken.None){this.c=void 0;const f=Promise.resolve(w),b=++this.f,M=l.$show(b,{title:I?.title,placeHolder:I?.placeHolder,matchOnDescription:I?.matchOnDescription,matchOnDetail:I?.matchOnDetail,ignoreFocusLost:I?.ignoreFocusOut,canPickMany:I?.canPickMany},C),N={},F=M.then(()=>N);return Promise.race([F,f]).then(W=>{if(W===N)return;const K=(0,a.$eH)(D,"quickPickItemTooltip");return f.then(L=>{const Q=[];for(let X=0;X<L.length;X++){const ue=L[X];if(typeof ue=="string")Q.push({label:ue,handle:X});else if(ue.kind===A.QuickPickItemKind.Separator)Q.push({type:"separator",label:ue.label});else{ue.tooltip&&!K&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const ee=ue.iconPath?m(ue.iconPath):void 0;Q.push({label:ue.label,iconPath:ee?.iconPath,iconClass:ee?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:K?S.MarkdownString.fromStrict(ue.tooltip):void 0,handle:X})}}return I&&typeof I.onDidSelectItem=="function"&&(this.c=X=>{I.onDidSelectItem(L[X])}),l.$setItems(b,Q),M.then(X=>{if(typeof X=="number")return L[X];if(Array.isArray(X))return X.map(ue=>L[ue])})})}).then(void 0,W=>{if(!(0,$.$3)(W))return l.$setError(b,W),Promise.reject(W)})}$onItemSelected(D){this.c?.(D)}showInput(D,w=v.CancellationToken.None){return this.d=D?.validateInput,l.$input(D,typeof this.d=="function",w).then(void 0,I=>{if(!(0,$.$3)(I))return Promise.reject(I)})}async $validateInput(D){if(!this.d)return;const w=await this.d(D);if(!w||typeof w=="string")return w;let I;switch(w.severity){case A.InputBoxValidationSeverity.Info:I=k.default.Info;break;case A.InputBoxValidationSeverity.Warning:I=k.default.Warning;break;case A.InputBoxValidationSeverity.Error:I=k.default.Error;break;default:I=w.message?k.default.Error:k.default.Ignore;break}return{content:w.message,severity:I}}async showWorkspaceFolderPick(D,w=v.CancellationToken.None){const I=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!I)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(f=>f.uri.toString()===I.uri.toString())}createQuickPick(D){const w=new p(D,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}createInputBox(D){const w=new h(D,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}$onDidChangeValue(D,w){this.e.get(D)?._fireDidChangeValue(w)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,w){const I=this.e.get(D);I instanceof p&&I._fireDidChangeActive(w)}$onDidChangeSelection(D,w){const I=this.e.get(D);I instanceof p&&I._fireDidChangeSelection(w)}$onDidTriggerButton(D,w){this.e.get(D)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(D,w,I){const C=this.e.get(D);C instanceof p&&C._fireDidTriggerItemButton(w,I)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class n{static{this.a=1}constructor(D,w){this.x=D,this.y=w,this._id=p.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$le,this.q=new R.$le,this.r=new R.$le,this.s=new R.$le,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const w=(0,a.$eH)(this.x,"quickInputButtonLocation");!w&&D.some(I=>I.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((I,C)=>{const f=I===A.$$O.Back?-1:C;this.o.set(f,I)}),this.z({buttons:D.map((I,C)=>({...m(I.iconPath),tooltip:I.tooltip,handle:I===A.$$O.Back?-1:C,location:w?I.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const w=this.o.get(D);w&&this.r.fire(w)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(D){if(!this.v){for(const w of Object.keys(D)){const I=D[w];this.u[w]=I===void 0?null:I}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof A.$IO)return{id:E.id};const D=u(E),w=g(E);return{dark:typeof D=="string"?T.URI.file(D):D,light:typeof w=="string"?T.URI.file(w):w}}function g(E){return typeof E=="object"&&"light"in E?E.light:E}function u(E){return typeof E=="object"&&"dark"in E?E.dark:E}function m(E){const D=t(E);let w,I;return"id"in D?I=y.ThemeIcon.asClassName(D):w=D,{iconPath:w,iconClass:I}}class p extends n{constructor(D,w){super(D,w),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$le,this.L=[],this.M=new R.$le,this.N=new R.$le,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((C,f)=>{this.C.set(f,C),this.D.set(C,f)});const w=(0,a.$eH)(this.x,"quickPickItemTooltip"),I=[];for(let C=0;C<D.length;C++){const f=D[C];if(f.kind===A.QuickPickItemKind.Separator)I.push({type:"separator",label:f.label});else{f.tooltip&&!w&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const b=f.iconPath?m(f.iconPath):void 0;I.push({handle:C,label:f.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:w?S.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((M,N)=>({...m(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.z({items:I})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(w=>this.D.has(w)),this.z({activeItems:this.J.map(w=>this.D.get(w))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(w=>this.D.has(w)),this.z({selectedItems:this.L.map(w=>this.D.get(w))})}_fireDidChangeActive(D){const w=(0,s.$Gb)(D.map(I=>this.C.get(I)));this.J=w,this.K.fire(w)}_fireDidChangeSelection(D){const w=(0,s.$Gb)(D.map(I=>this.C.get(I)));this.L=w,this.M.fire(w)}_fireDidTriggerItemButton(D,w){const I=this.C.get(D);if(!I||!I.buttons||!I.buttons.length)return;const C=I.buttons[w];C&&this.N.fire({button:C,item:I})}}class h extends n{constructor(D,w){super(D,w),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:k.default.Error}):this.z({validationMessage:D.message,severity:D.severity??k.default.Error}):this.z({validationMessage:void 0,severity:k.default.Ignore})}}return new i(o,c)}}),define(Oe[253],Ne([1,0,2,6,71,4,10,5,17,145,11,18,36,34,8,24,15,20]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=e.$8qc=void 0;function i(N){return N instanceof v.URI}function n(N,F){return N.scheme===o.Schemas.file&&F.scheme===o.Schemas.file&&c.$l?N.toString()===F.toString():N.toString().toLowerCase()===F.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?v.URI.file(N.iconPath):v.URI.isUri(N.iconPath)||S.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function g(N){if(N){if(v.URI.isUri(N))return N;if(S.ThemeIcon.isThemeIcon(N))return N;{const F=N;return{light:F.light,dark:F.dark}}}else return}function u(N){const F=g(N.icon),W=N.labels?.map(K=>({title:K.title,icon:g(K.icon)}));return{...N,icon:F,labels:W}}function m(N,F){if(!N.iconPath&&!F.iconPath)return 0;if(N.iconPath){if(!F.iconPath)return 1}else return-1;const W=typeof N.iconPath=="string"?N.iconPath:v.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,K=typeof F.iconPath=="string"?F.iconPath:v.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,s.$Jr)(W,K)}function p(N,F){let W=0;if(N.strikeThrough!==F.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==F.faded)return N.faded?1:-1;if(N.tooltip!==F.tooltip)return(N.tooltip||"").localeCompare(F.tooltip||"");if(W=m(N,F),W!==0)return W;if(N.light&&F.light)W=m(N.light,F.light);else{if(N.light)return 1;if(F.light)return-1}if(W!==0)return W;if(N.dark&&F.dark)W=m(N.dark,F.dark);else{if(N.dark)return 1;if(F.dark)return-1}return W}function h(N,F){if(N.command!==F.command)return N.command<F.command?-1:1;if(N.title!==F.title)return N.title<F.title?-1:1;if(N.tooltip!==F.tooltip){if(N.tooltip!==void 0&&F.tooltip!==void 0)return N.tooltip<F.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(N.arguments===F.arguments)return 0;if(N.arguments)if(F.arguments){if(N.arguments.length!==F.arguments.length)return N.arguments.length-F.arguments.length}else return 1;else return-1;for(let W=0;W<N.arguments.length;W++){const K=N.arguments[W],L=F.arguments[W];if(K!==L&&!(i(K)&&i(L)&&n(K,L)))return K<L?-1:1}return 0}function E(N,F){let W=(0,s.$Jr)(N.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(W!==0)return W;if(N.command&&F.command)W=h(N.command,F.command);else{if(N.command)return 1;if(F.command)return-1}if(W!==0)return W;if(N.decorations&&F.decorations)W=p(N.decorations,F.decorations);else{if(N.decorations)return 1;if(F.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)W=(0,s.$Jr)(N.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)W=(0,s.$Jr)(N.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return W}function D(N,F){for(let W=0;W<N.length;W++)if(N[W]!==F[W])return!1;return!0}function w(N,F){return N.command===F.command&&N.title===F.title&&N.tooltip===F.tooltip&&(N.arguments&&F.arguments?D(N.arguments,F.arguments):N.arguments===F.arguments)}function I(N,F){return(0,$.$tb)(N,F,w)}class C{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.m,F),this.o(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.m,F),this.f=F}get validateInput(){return(0,r.$fH)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,r.$fH)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.m,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.m,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.m,F))}get document(){return(0,r.$fH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(F,W,K,L,Q){this.k=F,this.m=L,this.n=Q,this.d="",this.e=new R.$le,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=K}showValidationMessage(F,W){(0,r.$fH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,F,W)}$onInputBoxValueChange(F){this.o(F)}o(F){this.d=F,this.e.fire(F)}}e.$8qc=C;class f{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(F){this.w=F,this.s.$updateGroupLabel(this.u,this.handle,F)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(F){this.q=F,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,W,K,L,Q,X,ue){this.s=F,this.t=W,this.u=K,this.v=L,this.w=Q,this.multiDiffEditorEnableViewChanges=X,this.x=ue,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$le,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new R.$le,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=f.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,W){const K=this.h.get(F);return K?(0,T.$wh)(()=>this.t.executeCommand(K.command,...K.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(E),K=(0,$.$Cb)(this.p,F,E).map(X=>{const ue=X.toInsert.map(ee=>{const me=this.e++;this.g.set(me,ee);const oe=ee.resourceUri;let ce;if(ee.command)if(ee.command.command==="vscode.open"||ee.command.command==="vscode.diff"||ee.command.command==="vscode.changes"){const x=new O.$Tc;ce=this.t.converter.toInternal(ee.command,x),this.j.set(me,x)}else this.h.set(me,ee.command);const we=(0,r.$eH)(this.x,"scmMultiDiffEditor"),ae=we?ee.multiDiffEditorOriginalUri:void 0,Ie=we?ee.multiFileDiffEditorModifiedUri:void 0,Fe=t(ee.decorations),Y=ee.decorations&&t(ee.decorations.light)||Fe,q=ee.decorations&&t(ee.decorations.dark)||Fe,ne=[Y,q],ye=ee.decorations&&ee.decorations.tooltip||"",le=ee.decorations&&!!ee.decorations.strikeThrough,ve=ee.decorations&&!!ee.decorations.faded,de=ee.contextValue||"";return{rawResource:[me,oe,ne,ye,le,ve,de,ce,ae,Ie],handle:me}});return{start:X.start,deleteCount:X.deleteCount,toInsert:ue}}),L=K.map(({start:X,deleteCount:ue,toInsert:ee})=>[X,ue,ee.map(me=>me.rawResource)]),Q=K.reverse();for(const{start:X,deleteCount:ue,toInsert:ee}of Q){const me=ee.map(ce=>ce.handle),oe=this.o.splice(X,ue,...me);for(const ce of oe)this.g.delete(ce),this.h.delete(ce),this.j.get(ce)?.dispose(),this.j.delete(ce)}return this.p=F,L}dispose(){this.m=!0,this.n.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let W;(0,r.$eH)(this.y,"quickDiffProvider")&&(W=F?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:W})}get historyProvider(){return(0,r.$fH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,r.$fH)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new O.$Tc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.m=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,this.#e.$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new O.$Tc,this.p=F;const W=this.z.converter.toInternal(F,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:W})}get actionButton(){return(0,r.$fH)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,r.$fH)(this.y,"scmActionButton"),this.q.value=new O.$Tc,this.s=F;const W=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(K=>K.map(L=>this.z.converter.toInternal(L,this.q.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:W??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&I(this.u,F))return;this.t.value=new O.$Tc,this.u=F;const W=(F||[]).map(K=>this.z.converter.toInternal(K,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:W})}get selected(){return this.v}constructor(F,W,K,L,Q,X,ue){this.y=F,this.z=L,this.A=Q,this.B=X,this.C=ue,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Vc,this.n=void 0,this.o=new O.$Vc,this.p=void 0,this.q=new O.$Vc,this.t=new O.$Vc,this.u=void 0,this.v=!1,this.w=new R.$le,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,this.#e=K;const ee=v.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${Q}/scm${this.x}/input`,query:ue?`rootUri=${encodeURIComponent(ue.toString())}`:void 0});this.f=new C(F,W,this.#e,this.x,ee),this.#e.$registerSourceControl(this.x,Q,X,ue,ee)}createResourceGroup(F,W,K){const L=(0,r.$eH)(this.y,"scmMultiDiffEditor")&&K?.multiDiffEditorEnableViewChanges===!0,Q=new f(this.#e,this.z,this.x,F,W,L,this.y),X=R.Event.once(Q.onDidDispose)(()=>this.D.delete(Q));return this.D.set(Q,X),this.eventuallyAddResourceGroups(),Q}eventuallyAddResourceGroups(){const F=[],W=[];for(const[K,L]of this.D){L.dispose();const Q=K.onDidUpdateResourceStates(()=>{this.E.add(K),this.eventuallyUpdateResourceStates()});R.Event.once(K.onDidDispose)(()=>{this.E.delete(K),Q.dispose(),this.e.delete(K.handle),this.#e.$unregisterGroup(this.x,K.handle)}),F.push([K.handle,K.id,K.label,K.features,K.multiDiffEditorEnableViewChanges]);const X=K._takeResourceStateSnapshot();X.length>0&&W.push([K.handle,X]),this.e.set(K.handle,K)}this.#e.$registerGroups(this.x,F,W),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(W=>{const K=W._takeResourceStateSnapshot();K.length!==0&&F.push([W.handle,K])}),F.length>0&&this.#e.$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,P.$0h)(100)],b.prototype,"eventuallyAddResourceGroups",null),Je([(0,P.$0h)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{l=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(F,W,K,L){this.m=W,this.n=K,this.o=L,this.g=new Map,this.h=new y.$sn,this.j=new R.$le,this.e=F.getProxy(A.$HN.MainThreadSCM),this.f=F.getProxy(A.$HN.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:Q=>{if(Q&&Q.$mid===a.MarshalledId.ScmResource){const X=this.g.get(Q.sourceControlHandle);if(!X)return Q;const ue=X.getResourceGroup(Q.groupHandle);return ue?ue.getResourceState(Q.handle):Q}else if(Q&&Q.$mid===a.MarshalledId.ScmResourceGroup){const X=this.g.get(Q.sourceControlHandle);return X?X.getResourceGroup(Q.groupHandle):Q}else if(Q&&Q.$mid===a.MarshalledId.ScmProvider){const X=this.g.get(Q.handle);return X||Q}return Q}})}createSourceControl(F,W,K,L){this.o.trace("ExtHostSCM#createSourceControl",F.identifier.value,W,K,L),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const Q=l.d++,X=new b(F,this.n,this.e,this.m,W,K,L);this.g.set(Q,X);const ue=this.h.get(F.identifier)||[];return ue.push(X),this.h.set(F.identifier,ue),X}getLastInputBox(F){this.o.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const W=this.h.get(F.identifier),K=W&&W[W.length-1];return K&&K.inputBox}$provideOriginalResource(F,W,K){const L=v.URI.revive(W);this.o.trace("ExtHostSCM#$provideOriginalResource",F,L.toString());const Q=this.g.get(F);return!Q||!Q.quickDiffProvider||!Q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.$wh)(()=>Q.quickDiffProvider.provideOriginalResource(L,K)).then(X=>X||null)}$onInputBoxValueChange(F,W){this.o.trace("ExtHostSCM#$onInputBoxValueChange",F);const K=this.g.get(F);return K&&K.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(F,W,K,L){this.o.trace("ExtHostSCM#$executeResourceCommand",F,W,K);const Q=this.g.get(F);if(!Q)return Promise.resolve(void 0);const X=Q.getResourceGroup(W);return X?X.$executeResourceCommand(K,L):Promise.resolve(void 0)}$validateInput(F,W,K){this.o.trace("ExtHostSCM#$validateInput",F);const L=this.g.get(F);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,T.$wh)(()=>L.inputBox.validateInput(W,K)).then(Q=>{if(!Q)return Promise.resolve(void 0);const X=d.MarkdownString.fromStrict(Q.message);return X?Promise.resolve([X,Q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,W,K,L){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,K,L)??void 0}async $resolveHistoryItemGroupCommonAncestor2(F,W,K){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(W,K)??void 0}async $provideHistoryItems(F,W,K,L){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(W,K,L))?.map(ue=>u(ue))??void 0}async $provideHistoryItems2(F,W,K){return(await this.g.get(F)?.historyProvider?.provideHistoryItems2(W,K))?.map(X=>u(X))??void 0}async $provideHistoryItemSummary(F,W,K,L){const Q=this.g.get(F)?.historyProvider;if(typeof Q?.provideHistoryItemSummary!="function")return;const X=await Q.provideHistoryItemSummary(W,K,L);return X?u(X):void 0}async $provideHistoryItemChanges(F,W,K,L){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(W,K,L)??void 0}};e.$9qc=M,e.$9qc=M=l=Je([Ve(3,k.$_j)],M)}),define(Oe[254],Ne([1,0,5,8,2]),function(be,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0;class O{static{this.a=0}constructor(A,$){this.d=$,this.c=new Map,this.b=A.getProxy(v.$HN.MainThreadShare)}async $provideShare(A,$,s){return await this.c.get(A)?.provideShare({selection:R.Range.to($.selection),resourceUri:P.URI.revive($.resourceUri)},s)??void 0}registerShareProvider(A,$){const s=O.a++;return this.c.set(s,$),this.b.$registerShareProvider(s,R.DocumentSelector.from(A,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$0qc=O}),define(Oe[255],Ne([1,0,7,5,9,4,8,14]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=e.$_qc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$JO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$JO("statusBarItem.warningForeground")]])}#e;#t;constructor(a,S,d,r,o,c=v.StatusBarAlignment.Left,l){if(this.i=!1,this.k="",this.q=new O.$Tc,this.#e=a,this.#t=S,o&&r){this.c=(0,v.$lO)(r.identifier,o);const i=d.get(this.c);i&&(c=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,l=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=r,this.f=o,this.g=c,this.h=this.u(l)}u(a){if((0,A.$ig)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!$.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new O.$Tc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let S;this.m?S=this.m:S=(0,P.localize)(10779,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=$.b.get(this.o.id));const r=T.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,S,this.k,r,this.r?.internal,d,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$_qc=$;class s{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(10780,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const S={message:a};return this.b.unshift(S),this.c(),new v.$JN(()=>{const d=this.b.indexOf(S);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class k{constructor(a,S){this.e=new Map,this.a=a.getProxy(R.$HN.MainThreadStatusBar),this.b=S,this.c=new s(this)}$acceptStaticEntries(a){for(const S of a)this.e.set(S.entryId,S)}createStatusBarEntry(a,S,d,r){return new $(this.a,this.b,this.e,a,S,d,r)}setStatusBarMessage(a,S){const d=this.c.setMessage(a);let r;return typeof S=="number"?r=setTimeout(()=>d.dispose(),S):typeof S<"u"&&S.then(()=>d.dispose(),()=>d.dispose()),new v.$JN(()=>{d.dispose(),clearTimeout(r)})}}e.$arc=k}),define(Oe[125],Ne([1,0,32,116,54,81,55,8,2]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wQ=e.$vQ=e.$uQ=e.$tQ=void 0,v=We(v),A=We(A);const s=(i,n,t,g)=>{let u=n;return{enumerable:!0,configurable:!1,get(){return u},set(m){if(!t(u,m)){const p=u;u=m,i.listener?.(g(m,p))}}}},k=(i,n)=>i===n,y={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(g=>t.id===g.id)))},a=i=>n=>({op:O.TestItemEventOp.SetProp,update:i(n)}),S=(i,n)=>({range:(()=>{let t;const g=a(u=>({range:v.$Nt.lift(A.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return t},set(u){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),y.range(t,u)||(t=u,i.listener?.(g(u)))}}})(),label:s(i,n,y.label,a(t=>({label:t}))),description:s(i,void 0,y.description,a(t=>({description:t}))),sortText:s(i,void 0,y.sortText,a(t=>({sortText:t}))),canResolveChildren:s(i,!1,y.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,y.busy,a(t=>({busy:t}))),error:s(i,void 0,y.error,a(t=>({error:A.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],y.tags,(t,g)=>({op:O.TestItemEventOp.SetTags,new:t.map(A.TestTag.from),old:g.map(A.TestTag.from)}))}),d=i=>{const n=P.$5I.fromString(i.extId),t=new o(n.controllerId,n.localId,i.label,$.URI.revive(i.uri)||void 0);return t.range=A.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(g=>A.TestTag.to({id:(0,T.$$I)(g).tagId})),t},r=i=>{let n;for(const t of i.tests){const g=d(t.item);(0,R.$dQ)(g).parent=n,n=g}return n};e.$tQ=r;class o{constructor(n,t,g,u){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const m=(0,R.$cQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return m.parent instanceof c?void 0:m.parent}},children:{value:(0,O.$bQ)(m,R.$dQ,o),enumerable:!0,writable:!1},...S(m,g)})}}e.$uQ=o;class c extends o{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$vQ=c;class l extends O.$0P{constructor(n,t,g){super({controllerId:n,getDocumentVersion:u=>u&&g.getDocument(u)?.version,getApiFor:R.$dQ,getChildren:u=>u.children,root:new c(n,t),toITestItem:A.TestItem.from})}}e.$wQ=l}),define(Oe[33],Ne([1,0,14,7,8,25,5,17,11,40,32,101,2,4,3,16,125,22,38,42,69,63,66,37]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=e.$GQ=e.$FQ=e.$EQ=e.$DQ=e.$CQ=void 0,R=We(R),P=We(P);let m=class{#e;#t;#i;constructor(I,C,f){this.b=new Map,this.c=new Map,this.#e=I.getProxy(T.$HN.MainThreadCommands),this.d=C,this.#i=f,this.#t=I.getProxy(T.$HN.MainThreadTelemetry),this.converter=new p(this,b=>{const M=this.c.get(b);return M?.result===E.Void?M:void 0},C),this.f=[{processArgument(b){return(0,s.$bi)(b)}},{processArgument(b){return(0,O.$fo)(b,function(M){if(k.$Nt.isIRange(M))return P.Range.to(M);if(y.$Mt.isIPosition(M))return P.Position.to(M);if(k.$Nt.isIRange(M.range)&&a.URI.isUri(M.uri))return P.location.to(M);if(M instanceof c.$Ne)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const C=this.registerCommand(!1,I.id,async(...f)=>{const b=I.args.map((N,F)=>{if(!N.validate(f[F]))throw new Error(`Invalid argument '${N.name}' when running '${I.id}', received: ${typeof f[F]=="object"?JSON.stringify(f[F],null,"	"):f[F]} `);return N.convert(f[F])}),M=await this.executeCommand(I.internalId,...b);return I.result.convert(M,f,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new R.$JN(()=>{C.dispose(),this.c.delete(I.id)})}registerCommand(I,C,f,b,M,N){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:f,thisArg:b,metadata:M,extension:N}),I&&this.#e.$registerCommand(C),new R.$JN(()=>{this.b.delete(C)&&I&&this.#e.$unregisterCommand(C)})}executeCommand(I,...C){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,C,!0)}async g(I,C,f){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,C,!1);{let b=!1;const M=(0,O.$fo)(C,function(N){if(N instanceof R.$KN)return P.Position.from(N);if(N instanceof R.$LN)return P.Range.from(N);if(N instanceof R.$XN)return P.location.from(N);if(R.$bP.isNotebookRange(N))return P.NotebookRange.from(N);if(N instanceof ArrayBuffer)return b=!0,c.$Ne.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return b=!0,c.$Ne.wrap(N);if(N instanceof c.$Ne)return b=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(I,b?new l.$Ww(M):M,f);return(0,s.$bi)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(I,C,!1);throw N}}}async h(I,C,f){const b=this.b.get(I);if(!b)throw new Error("Unknown command");const{callback:M,thisArg:N,metadata:F}=b;if(F?.args)for(let K=0;K<F.args.length;K++)try{(0,v.$vg)(C[K],F.args[K].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${F.args[K].name}' - ${F.args[K].description}`)}const W=n.$fe.create();try{return await M.apply(N,C)}catch(K){if(I===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...C);L&&(I=L.command)}if(this.d.error(K,I,b.extension?.identifier),!f)throw K;if(b.extension?.identifier){const L=this.#i.onExtensionError(b.extension.identifier,K);this.d.trace("forwarded error to extension?",L,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$pj)(K)),this.id=I,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,I,W.elapsed())}}j(I,C,f){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new t.$wp(C),duration:f})}$executeContributedCommand(I,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const f=this.b.get(I);return f?(C=C.map(b=>this.f.reduce((M,N)=>N.processArgument(M,f.extension?.identifier),b)),this.h(I,C,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(C=>(I&&(C=C.filter(f=>f[0]!=="_")),C))}$getContributedCommandMetadata(){const I=Object.create(null);for(const[C,f]of this.b){const{metadata:b}=f;b&&(I[C]=b)}return Promise.resolve(I)}};e.$CQ=m,e.$CQ=m=Je([Ve(0,r.$hQ),Ve(1,$.$_j),Ve(2,g.$BQ)],m),e.$DQ=(0,d.$Ei)("IExtHostCommands");class p{constructor(I,C,f){this.d=I,this.f=C,this.g=f,this.delegatingCommandId=`__vsc${(0,u.$1g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,C){if(!I)return;const f={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return f;const b=this.f(I.command);if(b)f.id=b.internalId,f.arguments=b.args.map((M,N)=>M.convert(I.arguments&&I.arguments[N]));else if((0,A.$Kb)(I.arguments)){const M=`${I.command} /${++this.c}`;this.b.set(M,I),C.add((0,S.$Sc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),f.$ident=M,f.id=this.delegatingCommandId,f.arguments=[M],this.g.trace("CommandsConverter#CREATE",I.command,M)}return f}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const C=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$EQ=p;class h{static{this.Uri=new h("uri","Uri of a text document",I=>a.URI.isUri(I),I=>I)}static{this.Position=new h("position","A position in a text document",I=>R.$KN.isPosition(I),P.Position.from)}static{this.Range=new h("range","A range in a text document",I=>R.$LN.isRange(I),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",I=>R.$MN.isSelection(I),P.Selection.from)}static{this.Number=new h("number","",I=>typeof I=="number",I=>I)}static{this.String=new h("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=h.Arr(h.String)}static Arr(I){return new h(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,C=>Array.isArray(C)&&C.every(f=>I.validate(f)),C=>C.map(f=>I.convert(f)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",I=>I instanceof R.$0N,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",I=>I instanceof R.$wP,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",I=>I instanceof o.$uQ,P.TestItem.from)}constructor(I,C,f,b){this.name=I,this.description=C,this.validate=f,this.convert=b}optional(){return new h(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,C){return new h(I??this.name,C??this.description,this.validate,this.convert)}}e.$FQ=h;class E{static{this.Void=new E("no result",I=>I)}constructor(I,C){this.description=I,this.convert=C}}e.$GQ=E;class D{constructor(I,C,f,b,M){this.id=I,this.internalId=C,this.description=f,this.args=b,this.result=M}}e.$HQ=D}),define(Oe[256],Ne([1,0,17,15,2,93,103,31,33,8,7]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=void 0,O=We(O),s=We(s),k=We(k);const y=[new $.$HQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to an array of DocumentHighlight-instances.",S(s.DocumentHighlight.to))),new $.$HQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$FQ.Uri],new $.$GQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,v.$Jb)(r))return;class c extends k.$5N{static to(i){const n=new c(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new k.$XN(o[0],s.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=s.Range.to(i.selectionRange),n.children=i.children?i.children.map(c.to):[],n}}return r.map(c.to)})),new $.$HQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$FQ.Uri,new $.$FQ("options","Formatting options",r=>!0,r=>r)],new $.$GQ("A promise that resolves to an array of TextEdits.",S(s.TextEdit.to))),new $.$HQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$FQ.Uri,$.$FQ.Range,new $.$FQ("options","Formatting options",r=>!0,r=>r)],new $.$GQ("A promise that resolves to an array of TextEdits.",S(s.TextEdit.to))),new $.$HQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$FQ.Uri,$.$FQ.Position,new $.$FQ("ch","Trigger character",r=>typeof r=="string",r=>r),new $.$FQ("options","Formatting options",r=>!0,r=>r)],new $.$GQ("A promise that resolves to an array of TextEdits.",S(s.TextEdit.to))),new $.$HQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$HQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$HQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$HQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$HQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to an array of Location-instances.",S(s.location.to))),new $.$HQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to an array of Hover-instances.",S(s.Hover.to))),new $.$HQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$FQ.Uri,new $.$FQ("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>k.$KN.isPosition(o)),r=>r.map(s.Position.from))],new $.$GQ("A promise that resolves to an array of ranges.",r=>r.map(o=>{let c;for(const l of o.reverse())c=new k.$9N(s.Range.to(l),c);return c}))),new $.$HQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$FQ.String.with("query","Search string")],new $.$GQ("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(s.WorkspaceSymbol.to))),new $.$HQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(s.CallHierarchyItem.to))),new $.$HQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$FQ.CallHierarchyItem],new $.$GQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(s.CallHierarchyIncomingCall.to))),new $.$HQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$FQ.CallHierarchyItem],new $.$GQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(s.CallHierarchyOutgoingCall.to))),new $.$HQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:s.Range.to(r.range),placeholder:r.text}})),new $.$HQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$FQ.Uri,$.$FQ.Position,$.$FQ.String.with("newName","The new symbol name")],new $.$GQ("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return s.WorkspaceEdit.to(r)}})),new $.$HQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$FQ.Uri,$.$FQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$GQ("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(s.DocumentLink.to))),new $.$HQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$FQ.Uri],new $.$GQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new k.$5O(r.tokenTypes,r.tokenModifiers)})),new $.$HQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$FQ.Uri],new $.$GQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,T.$Vdb)(r);if(o.type==="full")return new k.$7O(o.data,void 0)})),new $.$HQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$FQ.Uri,$.$FQ.Range.optional()],new $.$GQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new k.$5O(r.tokenTypes,r.tokenModifiers)})),new $.$HQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$FQ.Uri,$.$FQ.Range],new $.$GQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,T.$Vdb)(r);if(o.type==="full")return new k.$7O(o.data,void 0)})),new $.$HQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$FQ.Uri,$.$FQ.Position,$.$FQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$FQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$GQ("A promise that resolves to a CompletionList-instance.",(r,o,c)=>{if(!r)return new k.$iO([]);const l=r.suggestions.map(i=>s.CompletionItem.to(i,c));return new k.$iO(l,r.incomplete)})),new $.$HQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$FQ.Uri,$.$FQ.Position,$.$FQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$GQ("A promise that resolves to SignatureHelp.",r=>{if(r)return s.SignatureHelp.to(r)})),new $.$HQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$FQ.Uri,$.$FQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$GQ("A promise that resolves to an array of CodeLens-instances.",(r,o,c)=>S(l=>new k.$aO(s.Range.to(l.range),l.command&&c.fromInternal(l.command)))(r))),new $.$HQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$FQ.Uri,new $.$FQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>k.$LN.isRange(r),r=>k.$MN.isSelection(r)?s.Selection.from(r):s.Range.from(r)),$.$FQ.String.with("kind","Code action kind to return code actions for").optional(),$.$FQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$GQ("A promise that resolves to an array of Command-instances.",(r,o,c)=>S(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(l.command)}else{const i=new k.$7N(l.title,l.kind?new k.$8N(l.kind):void 0);return l.edit&&(i.edit=s.WorkspaceEdit.to(l.edit)),l.command&&(i.command=c.fromInternal(l.command)),i.isPreferred=l.isPreferred,i}})(r))),new $.$HQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$FQ.Uri],new $.$GQ("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new k.$oO(s.Range.to(o.range),s.Color.to(o.color))):[])),new $.$HQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$FQ("color","The color to show and insert",r=>r instanceof k.$nO,s.Color.from),new $.$FQ("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:s.Range.from(r.range)}))],new $.$GQ("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(s.ColorPresentation.to):[])),new $.$HQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$FQ.Uri,$.$FQ.Range],new $.$GQ("A promise that resolves to an array of Inlay objects",(r,o,c)=>r.map(s.InlayHint.to.bind(void 0,c)))),new $.$HQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$FQ.Uri],new $.$GQ("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(s.FoldingRange.to)})),new $.$HQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$GQ("A promise that resolves to an array of NotebookContentProvider static info objects.",S(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>s.NotebookExclusiveDocumentPattern.to(o))})))),new $.$HQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$FQ.Uri,$.$FQ.Range,new $.$FQ("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof k.$LN,r=>s.InlineValueContext.from(r))],new $.$GQ("A promise that resolves to an array of InlineValue objects",r=>r.map(s.InlineValue.to))),new $.$HQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$FQ("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,R.$Og)(r,R.Schemas.http,R.Schemas.https),r=>r),new $.$FQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional(),$.$FQ.String.with("label","").optional()],$.$GQ.Void),new $.$HQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$FQ.Uri.with("resource","Resource to open"),$.$FQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$FQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional()],$.$GQ.Void),new $.$HQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$FQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$FQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$FQ.String.with("title","Human readable title for the diff editor").optional(),new $.$FQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)]).optional()],$.$GQ.Void),new $.$HQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$FQ.String.with("title","Human readable title for the changes editor"),new $.$FQ("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[c,l,i]=o;if(!P.URI.isUri(c)||!P.URI.isUri(l)&&l!==void 0&&l!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],$.$GQ.Void),new $.$HQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$FQ.Uri,$.$FQ.Position],new $.$GQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new $.$HQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$FQ.TypeHierarchyItem],new $.$GQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new $.$HQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$FQ.TypeHierarchyItem],new $.$GQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new $.$HQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$FQ.TestItem],$.$GQ.Void),new $.$HQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$FQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$GQ.Void),new $.$HQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$FQ.String.with("name","The context key name"),new $.$FQ("value","The context key value",()=>!0,r=>r)],$.$GQ.Void),new $.$HQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$FQ.Uri,$.$FQ.StringArray,new $.$FQ("MappedEditsContext","Mapped Edits Context",r=>s.MappedEditsContext.is(r),r=>s.MappedEditsContext.from(r))],new $.$GQ("A promise that resolves to a workspace edit or null",r=>r?s.WorkspaceEdit.to(r):null)),new $.$HQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$FQ("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?s.Range.from(r.initialRange):void 0,initialSelection:k.$MN.isSelection(r.initialSelection)?s.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?s.Position.from(r.position):void 0}})],$.$GQ.Void)];class a{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",A.$Dj)}}e.$ppc=a;function S(r){return o=>{if(Array.isArray(o))return o.map(r)}}function d(r){if(!Array.isArray(r))return;const o=[];for(const c of r)O.$Ku(c)?o.push(s.DefinitionLink.to(c)):o.push(s.location.to(c));return o}}),define(Oe[257],Ne([1,0,2,33]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=void 0;class P{constructor(T,A,$,s,k){this.a=A,this.b=$,this.c=s;const y=new R.$HQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$FQ("showOptions","Show Options",a=>!0,a=>a),new R.$FQ("resource","Interactive resource Uri",a=>!0,a=>a),new R.$FQ("controllerId","Notebook controller Id",a=>!0,a=>a),new R.$FQ("title","Interactive editor title",a=>!0,a=>a)],new R.$GQ("Notebook and input URI",a=>{if(k.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const S=this.a.getEditorById(a.notebookEditorId);return k.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri),notebookEditor:S.apiEditor}}return k.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(T,A,$,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:$,uri:T,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(T,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.$Qqc=P}),define(Oe[258],Ne([1,0,17,10,21,6,4,28,2,18,11,5,33,8,7,82,197,24,38,198]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=void 0,e.$Zqc=h,S=We(S);let n=class{constructor(D,w,I,C,f){this.m=w,this.n=I,this.o=C,this.q=f,this.b=new A.$Ac,this.c=new A.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$le,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$HN.MainThreadNotebookKernels);const b=new a.$HQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$FQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const F=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:F}}else if(N&&"notebookEditor"in N){const F=this.n.getIdByEditor(N.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return N})],a.$GQ.Void),M=new a.$HQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[a.$FQ.Uri],new a.$GQ("A promise that resolves to an array of variables",(N,F)=>N.map(W=>({variable:{name:W.name,value:W.value,expression:W.expression,type:W.type,language:W.language},hasNamedChildren:W.hasNamedChildren,indexedChildrenCount:W.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(M)}createNotebookController(D,w,I,C,f,b){for(const ae of this.j.values())if(ae.controller.id===w&&s.$qn.equals(D.identifier,ae.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const M=this.k++,N=this;this.q.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${w}`);const F=()=>console.warn(`NO execute handler from notebook controller '${Q.id}' of extension: '${D.identifier}'`);let W=!1;const K=new O.$le,L=new O.$le,Q={id:h(D.identifier,w),notebookType:I,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:C||D.identifier.value,preloads:b?b.map(S.NotebookRendererScript.from):[]};let X=f??F,ue,ee;this.a.$addKernel(M,Q).catch(ae=>{console.log(ae),W=!0});let me=0;const oe=()=>{if(W)return;const ae=++me;Promise.resolve().then(()=>{ae===me&&this.a.$updateKernel(M,Q)})},ce=new A.$Ac,we={get id(){return w},get notebookType(){return Q.notebookType},onDidChangeSelectedNotebooks:K.event,get label(){return Q.label},set label(ae){Q.label=ae??D.displayName??D.name,oe()},get detail(){return Q.detail??""},set detail(ae){Q.detail=ae,oe()},get description(){return Q.description??""},set description(ae){Q.description=ae,oe()},get supportedLanguages(){return Q.supportedLanguages},set supportedLanguages(ae){Q.supportedLanguages=ae,oe()},get supportsExecutionOrder(){return Q.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){Q.supportsExecutionOrder=ae,oe()},get rendererScripts(){return Q.preloads?Q.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(ae){X=ae??F},get interruptHandler(){return ue},set interruptHandler(ae){ue=ae,Q.supportsInterrupt=!!ae,oe()},set variableProvider(ae){(0,c.$fH)(D,"notebookVariableProvider"),ee=ae,Q.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Ie=>N.a.$variablesUpdated(Ie.uri)),oe()},get variableProvider(){return ee},createNotebookCellExecution(ae){if(W)throw new Error("notebook controller is DISPOSED");if(!ce.has(ae.notebook.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return N._createNotebookCellExecution(ae,h(D.identifier,this.id))},createNotebookExecution(ae){if((0,c.$fH)(D,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!ce.has(ae.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return N._createNotebookExecution(ae,h(D.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${M}], DISPOSED`),W=!0,this.j.delete(M),K.dispose(),L.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(ae,Ie){Ie===d.NotebookControllerAffinity2.Hidden&&(0,c.$fH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(M,ae.uri,Ie)},onDidReceiveMessage:L.event,postMessage(ae,Ie){return(0,c.$fH)(D,"notebookMessaging"),N.a.$postMessage(M,Ie&&N.n.getIdByEditor(Ie),ae)},asWebviewUri(ae){return(0,c.$fH)(D,"notebookMessaging"),(0,r.$CDb)(ae,N.m.remote)}};return this.j.set(M,{extensionId:D.identifier,controller:we,onDidReceiveMessage:L,onDidChangeSelection:K,associatedNotebooks:ce}),we}getIdByController(D){for(const[w,I]of this.j)if(I.controller===D)return h(I.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,w){const I=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${I}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(I,w);const f={dispose:()=>{this.f.delete(I),C.a.$removeKernelDetectionTask(I)}};return this.f.set(I,f),f}registerKernelSourceActionProvider(D,w,I){const C=this.i++,f=typeof I.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,b=this;this.h.set(C,I),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,w);let M;return f!==void 0&&(M=I.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.h.delete(C),b.a.$removeKernelSourceActionProvider(C,C),M?.dispose()}}}async $provideKernelSourceActions(D,w){const I=this.h.get(D);if(I){const C=new T.$Tc;return(await I.provideNotebookKernelSourceActions(w)??[]).map(b=>S.NotebookKernelSourceAction.from(b,this.o.converter,C))}return[]}$acceptNotebookAssociation(D,w,I){const C=this.j.get(D);if(C){const f=this.n.getNotebookDocument($.URI.revive(w));I?C.associatedNotebooks.set(f.uri,!0):C.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,f.uri.toString(),I),C.onDidChangeSelection.fire({selected:I,notebook:f.apiNotebook})}}async $executeCells(D,w,I){const C=this.j.get(D);if(!C)return;const f=this.n.getNotebookDocument($.URI.revive(w)),b=[];for(const M of I){const N=f.getCell(M);N&&b.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,f.uri.toString(),b.length),await C.controller.executeHandler.call(C.controller,b,f.apiNotebook,C.controller)}catch(M){this.q.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,w,I){const C=this.j.get(D);if(!C)return;const f=this.n.getNotebookDocument($.URI.revive(w));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,f.apiNotebook);else for(const b of I){const M=f.getCell(b);M&&this.b.get(M.uri)?.cancel()}if(C.controller.interruptHandler){const b=this.c.get(f.uri);this.c.delete(f.uri),I.length&&Array.isArray(b)&&b.length&&b.forEach(M=>M.dispose())}}async $provideVariables(D,w,I,C,f,b,M){const N=this.j.get(D);if(!N)return;const F=this.n.getNotebookDocument($.URI.revive(I)),W=N.controller.variableProvider;if(!W)return;let K;if(C!==void 0){if(K=this.s[C],!K)return}else this.s={};const L=f==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,Q=W.provideVariables(F.apiNotebook,K,L,b,M);let X=0;for await(const ue of Q){if(M.isCancellationRequested)return;const ee={id:this.r++,name:ue.variable.name,value:ue.variable.value,type:ue.variable.type,interfaces:ue.variable.interfaces,language:ue.variable.language,expression:ue.variable.expression,hasNamedChildren:ue.hasNamedChildren,indexedChildrenCount:ue.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[ee.id]=ue.variable,this.a.$receiveVariable(w,ee),X++>=i.$XK)return}}$acceptKernelMessageFromRenderer(D,w,I){const C=this.j.get(D);if(!C)return;const f=this.n.getEditorById(w);C.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:I}))}$cellExecutionChanged(D,w,I){const f=this.n.getNotebookDocument($.URI.revive(D)).getCell(w);if(f){const b=I?S.NotebookCellExecutionState.to(I):d.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:f.apiCell,state:b})}}_createNotebookCellExecution(D,w){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const f=new g(w,C,this.a);this.b.set(C.uri,f);const b=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),b.dispose(),this.b.delete(C.uri))});return f.asApiObject()}_createNotebookExecution(D,w){const I=this.n.getNotebookDocument(D.uri),C=D.getCells().find(M=>{const N=I.getCellFromApiCell(M);return N&&this.b.has(N.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(I.uri))throw new Error(`duplicate notebook execution for ${I.uri}`);const f=new m(w,I,this.a),b=f.onDidChangeState(()=>{f.state===u.Resolved&&(f.dispose(),b.dispose(),this.c.delete(I.uri))});return this.c.set(I.uri,[f,b]),f.asApiObject()}};e.$Yqc=n,e.$Yqc=n=Je([Ve(4,k.$_j)],n);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class g extends T.$Uc{static{this.a=0}get state(){return this.f}constructor(D,w,I){super(),this.m=w,this.n=I,this.b=g.a++,this.c=new O.$le,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$we),this.h=new p(10,C=>this.s(C)),this.j=w.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const w=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new l.$Ww(w))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let w=this.m;if(D&&(w=this.m.notebook.getCellFromApiCell(D)),!w)throw new Error("INVALID cell");return w.handle}y(D){return D.map(w=>{const I=d.$fP.ensureUniqueMimeTypes(w.items,!0);return I===w.items?S.NotebookCellOutput.from(w):S.NotebookCellOutput.from({items:I,id:w.id,metadata:w.metadata})})}async z(D,w,I){const C=this.w(w),f=this.y((0,v.$1b)(D));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:C,append:I,outputs:f})}async C(D,w,I){return D=d.$fP.ensureUniqueMimeTypes((0,v.$1b)(D),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:D.map(S.NotebookCellOutputItem.from),outputId:w.id,append:I})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(I){D.j=I,D.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(I){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:I})},end(I,C,f){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const b=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;D.n.$completeExecution(D.b,new l.$Ww({runEndTime:C,lastRunSuccess:I,error:b}))},clearOutput(I){return D.t(),D.z([],I,!1)},appendOutput(I,C){return D.t(),D.z(I,C,!0)},replaceOutput(I,C){return D.t(),D.z(I,C,!1)},appendOutputItems(I,C){return D.t(),D.C(I,C,!0)},replaceOutputItems(I,C){return D.t(),D.C(I,C,!1)}})}}var u;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(u||(u={}));class m extends T.$Uc{static{this.a=0}get state(){return this.f}constructor(D,w,I){super(),this.h=w,this.j=I,this.b=m.a++,this.c=new O.$le,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new P.$we),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class p{constructor(D,w){this.f=D,this.g=w,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new R.$2h,this.b=Date.now(),(0,R.$Fh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const w=this.a;return this.a=[],this.g(w).finally(()=>D.complete())}}function h(E,D){return`${E.value}/${D}`}}),define(Oe[56],Ne([1,0,6,5,3,2,16,4,7,9,13,179,21,37,180,181,34,10,8,33,36]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=e.$6pc=e.$5pc=e.$4pc=void 0,e.$4pc=(0,P.$Ei)("IExtHostTerminalService");class t extends A.$Uc{constructor(f,b,M,N){super(),this.u=f,this._id=b,this.w=M,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$le),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const F=this;this.value={get name(){return F.y||""},get processId(){return F.b},get creationOptions(){return F.w},get exitStatus(){return F.j},get state(){return F.m},get selection(){return F.n},get shellIntegration(){return F.shellIntegration},sendText(W,K=!0){F.C(),F.u.$sendText(F._id,W,K)},show(W){F.C(),F.u.$show(F._id,W)},hide(){F.C(),F.u.$hide(F._id)},dispose(){F.a||(F.a=!0,F.u.$dispose(F._id))},get dimensions(){if(!(F.f===void 0||F.h===void 0))return{columns:F.f,rows:F.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??b?.cwd??void 0,env:f.env??void 0,icon:D(f.iconPath)??void 0,color:o.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(f.location,b?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,b,M,N,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:o.ThemeColor.isThemeColor(F)?F.id:void 0,location:b?.location||this.z(f,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,b){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in f?{viewColumn:l.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,b){this.j=Object.freeze({code:f,reason:b})}setDimensions(f,b){return f===this.f&&b===this.h||f===0||b===0?!1:(this.f=f,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(b=>{b!==f&&(this.b=Promise.resolve(f))})}}e.$5pc=t;class g{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new v.$le,this.onProcessData=this.a.event,this.b=new v.$le,this.d=new v.$le,this.onDidChangeProperty=this.d.event,this.f=new v.$le,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,b){this.g.setDimensions?.({columns:f,rows:b})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:d.ProcessPropertyType.Title,value:b})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,m=class extends A.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,b,M){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new A.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$le,this.onDidCloseTerminal=this.H.event,this.I=new v.$le,this.onDidOpenTerminal=this.I.event,this.J=new v.$le,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$le,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$le,this.onDidChangeTerminalState=this.M.event,this.N=new v.$le,this.onDidChangeShell=this.N.event,this.O=new v.$le({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$le({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(R.$HN.MainThreadTerminalService),this.y=new r.$Sxb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:N=>{const F=W=>{const K=W;return this.getTerminalById(K.instanceId)?.value};switch(N?.$mid){case n.MarshalledId.TerminalContext:return F(N);default:{if(Array.isArray(N))for(let W=0;W<N.length&&N[W].$mid===n.MarshalledId.TerminalContext;W++)N[W]=F(N[W]);return N}}}}),this.B({dispose:()=>{for(const[N,F]of this.g)F.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,b){const M=new t(this.a,(0,S.$1g)(),f,f.name),N=new g(f.pty);return M.createExtensionTerminal(f.location,b,this.R(f,b).resolvedExtHostIdentifier,D(f.iconPath),w(f.color)).then(F=>{const W=this.S(F,N);this.h[F]=W}),this.f.push(M),M.value}R(f,b){if(b=b||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const M=f.location.parentTerminal;if(M){const N=this.f.find(F=>F.value===M);N&&(b.resolvedExtHostIdentifier=N._id)}}else f.location&&typeof f.location!="object"?b.location=f.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(f,b){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const N=new g(b),F=this.S(f,N);this.h[f]=F}async $acceptActiveTerminalChanged(f){const b=this.b;if(f===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(f);M&&(this.b=M,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,b){const M=this.getTerminalById(f);M&&this.O.fire({terminal:M.value,data:b})}async $acceptTerminalDimensions(f,b,M){const N=this.getTerminalById(f);N&&N.setDimensions(b,M)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(f,b){const M=this.getTerminalById(f);M&&this.P.fire({terminal:M.value,...b})}async $acceptTerminalMaximumDimensions(f,b,M){this.g.get(f)?.resize(b,M)}async $acceptTerminalTitleChange(f,b){const M=this.getTerminalById(f);M&&(M.name=b)}async $acceptTerminalClosed(f,b,M){const N=this.X(this.f,f);if(N!==null){const F=this.f.splice(N,1)[0];F.setExitStatus(b,M),this.H.fire(F.value)}}$acceptTerminalOpened(f,b,M,N){if(b){const K=this.X(this.f,b);if(K!==null){this.f[K]._id=f,this.I.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const F={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},W=new t(this.a,f,F,M);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(f,b){this.getTerminalById(f)?._setProcessId(b)}async $startExtensionTerminal(f,b){const M=this.getTerminalById(f);if(!M)return{message:(0,s.localize)(10777,null,f)};M.isOpen||await new Promise(F=>{const W=this.onDidOpenTerminal(async K=>{K===M.value&&(W.dispose(),F())})});const N=this.g.get(f);N?N.startSendingEvents(b):this.j[f]={initialDimensions:b}}S(f,b){const M=new A.$Tc;M.add(b.onProcessReady(F=>this.a.$sendProcessReady(f,F.pid,F.cwd,F.windowsPty))),M.add(b.onDidChangeProperty(F=>this.a.$sendProcessProperty(f,F))),this.y.startBuffering(f,b.onProcessData),M.add(b.onProcessExit(F=>this.U(f,F))),this.g.set(f,b);const N=this.j[f];return N&&b instanceof g&&(b.startSendingEvents(N.initialDimensions),delete this.j[f]),M}$acceptProcessAckDataEvent(f,b){this.g.get(f)?.acknowledgeDataEvent(b)}$acceptProcessInput(f,b){this.g.get(f)?.input(b)}$acceptTerminalInteraction(f){const b=this.getTerminalById(f);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(f,b){this.getTerminalById(f)?.setSelection(b)}$acceptProcessResize(f,b,M){try{this.g.get(f)?.resize(b,M)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(f,b){this.g.get(f)?.shutdown(b)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(b=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new $.$JN(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,b,M){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,M),this.a.$registerProfileProvider(b,f.identifier.value),new $.$JN(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(f,b,M){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,M),this.a.$registerQuickFixProvider(f,b),new $.$JN(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,b){const M=new a.$we().token;if(M.isCancellationRequested)return;const N=this.D.get(f);if(!N)return;const F=await N.provideTerminalQuickFixes(b,M);if(F===null||Array.isArray(F)&&F.length===0)return;const W=new A.$Tc;if(this.w.value=W,!Array.isArray(F))return F?l.TerminalQuickFix.from(F,this.Q.converter,W):void 0;const K=[];for(const L of F){const Q=l.TerminalQuickFix.from(L,this.Q.converter,W);Q&&K.push(Q)}return K}async $createContributedProfileTerminal(f,b){const M=new a.$we().token;let N=await this.C.get(f)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,b);return}this.createTerminalFromOptions(N.options,b)}}async $provideLinks(f,b){const M=this.getTerminalById(f);if(!M)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const F=new a.$we;this.G.set(f,F);const W=[],K={terminal:M.value,line:b},L=[];for(const ue of this.z)L.push(c.Promises.withAsyncBody(async ee=>{F.token.onCancellationRequested(()=>ee({provider:ue,links:[]}));const me=await ue.provideTerminalLinks(K,F.token)||[];F.token.isCancellationRequested||ee({provider:ue,links:me})}));const Q=await Promise.all(L);if(F.token.isCancellationRequested)return[];const X=new Map;for(const ue of Q)ue&&ue.links.length>0&&W.push(...ue.links.map(ee=>{const me={id:u++,startIndex:ee.startIndex,length:ee.length,label:ee.tooltip};return X.set(me.id,{provider:ue.provider,link:ee}),me}));return this.F.set(f,X),W}$activateLink(f,b){const M=this.F.get(f)?.get(b);M&&M.provider.handleTerminalLink(M.link)}U(f,b){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const M=this.h[f];M&&(M.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,b)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const b=this.f.findIndex(M=>M.value===f);return b>=0?b:null}W(f,b){const M=this.X(f,b);return M!==null?f[M]:null}X(f,b){const M=f.findIndex(N=>N._id===b);return M>=0?M:null}getEnvironmentVariableCollection(f){let b=this.n.get(f.identifier.value);return b||(b=this.B(new p),this.Z(f.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(f,b){const M=(0,y.$Es)(b.map),N=(0,y.$Fs)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(f,b.persistent,M.length===0?void 0:M,N)}$initEnvironmentVariableCollections(f){f.forEach(b=>{const M=b[0],N=this.B(new p(b[1]));this.Z(M,N)})}$acceptDefaultProfile(f,b){const M=this.s;this.s=f,this.u=b,M?.path!==f.path&&this.N.fire(f.path)}Z(f,b){this.n.set(f,b),this.B(b.onDidChangeCollection(()=>{this.Y(f,b)}))}};e.$6pc=m,e.$6pc=m=Je([Ve(1,i.$DQ),Ve(2,T.$hQ)],m);class p extends A.$Uc{get persistent(){return this.b}set persistent(f){this.b=f,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(f){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$le,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const b=this.j(f);let M=this.a.get(b);return M||(M=new h(this,f),this.a.set(b,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(f,b,M,N){this.g(f,{value:b,type:$.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:N})}append(f,b,M,N){this.g(f,{value:b,type:$.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:N})}prepend(f,b,M,N){this.g(f,{value:b,type:$.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:N})}g(f,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(f,b.scope),N=this.map.get(M),F=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==b.value||N.type!==b.type||N.options?.applyAtProcessCreation!==F.applyAtProcessCreation||N.options?.applyAtShellIntegration!==F.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const W=this.h(f,b.scope),K={variable:f,...b,options:F};this.map.set(W,K),this.f.fire()}}get(f,b){const M=this.h(f,b),N=this.map.get(M);return N?I(N):void 0}h(f,b){const M=this.j(b);return M.length?`${f}:::${M}`:f}j(f){return this.m(f?.workspaceFolder)??""}m(f){return f?f.uri.toString():void 0}getVariableMap(f){const b=new Map;for(const[M,N]of this.map)this.j(N.scope)===this.j(f)&&b.set(N.variable,I(N));return b}delete(f,b){const M=this.h(f,b);this.map.delete(M),this.f.fire()}clear(f){if(f?.workspaceFolder){for(const[b,M]of this.map)M.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(b);this.n(f)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(f,b){const M=this.j(b),N=this.descriptionMap.get(M);if(!N||N.description!==f){let F;typeof f=="string"?F=f:F=f?.value.split(`

`)[0];const W={description:F,scope:b};this.descriptionMap.set(M,W),this.f.fire()}}getDescription(f){const b=this.j(f);return this.descriptionMap.get(b)?.description}n(f){const b=this.j(f);this.descriptionMap.delete(b)}}class h{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,b){this.b=f,this.d=b,this.a=new v.$le}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,b,M){this.b.replace(f,b,M,this.d)}append(f,b,M){this.b.append(f,b,M,this.d)}prepend(f,b,M){this.b.prepend(f,b,M,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,b){this.b.getVariableMap(this.d).forEach((M,N)=>f.call(b,N,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends m{constructor(f,b){super(!1,f,b)}createTerminal(f,b,M){throw new k.$$}createTerminalFromOptions(f,b){throw new k.$$}};e.$7pc=E,e.$7pc=E=Je([Ve(0,i.$DQ),Ve(1,T.$hQ)],E);function D(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function w(C){return o.ThemeColor.isThemeColor(C)?C:void 0}function I(C){const f={...C};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Oe[126],Ne([1,0,7,4,3,5,16,56,6,2,10]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=void 0,e.$erc=(0,P.$Ei)("IExtHostTerminalShellIntegration");let y=class extends R.$Uc{constructor(o,c){super(),this.h=c,this.b=new Map,this.c=new $.$le,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$le,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$le,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$HN.MainThreadTerminalShellIntegration),this.B((0,R.$Sc)(()=>{for(const[l,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(o){const c=this.h.getTerminalById(o);if(!c)return;const l=c.value;let i=this.b.get(o);i||(i=new a(c.value,this.f),this.b.set(o,i),i.store.add(c.onWillDispose(()=>this.b.get(o)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(o,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),c.shellIntegration=i.value),this.c.fire({terminal:l,shellIntegration:i.value})}$shellExecutionStart(o,c,l,i,n){this.b.has(o)||this.$shellIntegrationChange(o);const t={value:c,confidence:l,isTrusted:i};this.b.get(o)?.startShellExecution(t,s.URI.revive(n))}$shellExecutionEnd(o,c,l,i,n){const t={value:c,confidence:l,isTrusted:i};this.b.get(o)?.endShellExecution(t,n)}$shellExecutionData(o,c){this.b.get(o)?.emitData(c)}$cwdChange(o,c){this.b.get(o)?.setCwd(s.URI.revive(c))}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$frc=y,e.$frc=y=Je([Ve(0,T.$hQ),Ve(1,A.$4pc)],y);class a extends R.$Uc{get currentExecution(){return this.a}constructor(o,c){super(),this.j=o,this.m=c,this.b=!1,this.store=this.B(new R.$Tc),this.f=this.B(new $.$le),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$le),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$le),this.onDidRequestEndExecution=this.h.event;const l=this;this.value={get cwd(){return l.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(m=>`${m.replaceAll('"','\\"')}`).join('" "')}"`),l.g.fire(t);const g={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=l.startShellExecution(g,l.c,!0).value;return l.b=!0,u}}}startShellExecution(o,c,l){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new S(o,c??this.c);l?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,c){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(o){let c=!1;s.URI.isUri(this.c)?c=!s.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(c=!0),c&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(o,c){this.c=o,this.cwd=c,this.b=!1;const l=this;this.value={get commandLine(){return l.c},get cwd(){return l.cwd},read(){return l.d()}}}d(){if(!this.a){if(this.b)return k.$5h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends R.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new k.$Dh);const o=this.a;return new k.$5h(async l=>{this.b.push(l),await o.wait()})}emitData(o){for(const c of this.b)c.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Oe[127],Ne([1,0,61,13,96,8,7]),function(be,e,v,R,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=e.$oQ=void 0,O=We(O);class A{static{this.c=new P.$mQ("TextEditorDecorationType")}constructor(a,S,d){const r=A.c.nextId();a.$registerTextEditorDecorationType(S.identifier,r,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){a.$removeTextEditorDecorationType(r)}})}}e.$oQ=A;class ${constructor(a,S){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,S){this.k();let d=null;if(a instanceof T.$KN)d=new T.$LN(a,a);else if(a instanceof T.$LN)d=a;else throw new Error("Unrecognized location");this.l(d,S,!1)}insert(a,S){this.k(),this.l(new T.$LN(a,a),S,!0)}delete(a){this.k();let S=null;if(a instanceof T.$LN)S=a;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(a,S,d){const r=this.c.validateRange(a);this.g.push({range:r,text:S,forceMoveMarkers:d})}setEndOfLine(a){if(this.k(),a!==T.EndOfLine.LF&&a!==T.EndOfLine.CRLF)throw(0,R.$6)("endOfLine");this.h=a}}class s{constructor(a,S,d,r){this.c=a,this.d=S,this._accept(d),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(c){o.n(c)},get indentSize(){return o.g},set indentSize(c){o.p(c)},get insertSpaces(){return o.j},set insertSpaces(c){o.s(c)},get cursorStyle(){return o.k},set cursorStyle(c){o.t(c)},get lineNumbers(){return o.l},set lineNumbers(c){o.u(c)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.originalIndentSize,this.j=a.insertSpaces,this.k=a.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(a.lineNumbers)}m(a){if(a==="auto")return"auto";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}n(a){const S=this.m(a);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}p(a){const S=this.o(a);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(a){return a==="auto"?"auto":a==="false"?!1:!!a}s(a){const S=this.q(a);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(a){this.k!==a&&(this.k=a,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}u(a){this.l!==a&&(this.l=a,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(a)})))}assign(a){const S={};let d=!1;if(typeof a.tabSize<"u"){const r=this.m(a.tabSize);r==="auto"?(d=!0,S.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,S.tabSize=r)}if(typeof a.indentSize<"u"){const r=this.o(a.indentSize);r==="tabSize"?(d=!0,S.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,S.indentSize=r)}if(typeof a.insertSpaces<"u"){const r=this.q(a.insertSpaces);r==="auto"?(d=!0,S.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,S.insertSpaces=r)}typeof a.cursorStyle<"u"&&this.k!==a.cursorStyle&&(this.k=a.cursorStyle,d=!0,S.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.l!==a.lineNumbers&&(this.l=a.lineNumbers,d=!0,S.lineNumbers=O.TextEditorLineNumbersStyle.from(a.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(a,S){S.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(d)})}}e.$pQ=s;class k{constructor(a,S,d,r,o,c,l,i){this.id=a,this.j=S,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new s(this.j,this.id,c,d),this.e=l,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new R.$8("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof T.$MN))throw(0,R.$6)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(g=>!(g instanceof T.$MN)))throw(0,R.$6)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new R.$8("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new R.$8("viewColumn")},edit(t,g={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(r.value,g);return t(u),n.m(u)},insertSnippet(t,g,u={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!g||Array.isArray(g)&&g.length===0)m=n.c.map(p=>O.Range.from(p));else if(g instanceof T.$KN){const{lineNumber:p,column:h}=O.Position.from(g);m=[{startLineNumber:p,startColumn:h,endLineNumber:p,endColumn:h}]}else if(g instanceof T.$LN)m=[O.Range.from(g)];else{m=[];for(const p of g)if(p instanceof T.$LN)m.push(O.Range.from(p));else{const{lineNumber:h,column:E}=O.Position.from(p);m.push({startLineNumber:h,startColumn:E,endLineNumber:h,endColumn:E})}}return S.$tryInsertSnippet(a,r.value.version,t.value,m,u)},setDecorations(t,g){const u=g.length===0;u&&!n.h.has(t.key)||(u?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(O.$eQ(g))return S.$trySetDecorations(a,t.key,O.$fQ(g));{const m=new Array(4*g.length);for(let p=0,h=g.length;p<h;p++){const E=g[p];m[4*p]=E.start.line+1,m[4*p+1]=E.start.character+1,m[4*p+2]=E.end.line+1,m[4*p+3]=E.end.character+1}return S.$trySetDecorationsFast(a,t.key,m)}}))},revealRange(t,g){n.n(()=>S.$tryRevealRange(a,O.Range.from(t),g||T.TextEditorRevealType.Default))},show(t){S.$tryShowEditor(a,O.ViewColumn.from(t))},hide(){S.$tryHideEditor(a)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,v.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,v.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,v.ok)(!this.g),this.f=a}_acceptSelections(a){(0,v.ok)(!this.g),this.c=a}async l(){const a=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const S=a.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const d=S.edits.map(o=>o.range);d.sort((o,c)=>o.end.line===c.end.line?o.end.character===c.end.character?o.start.line===c.start.line?o.start.character-c.start.character:o.start.line-c.start.line:o.end.character-c.end.character:o.end.line-c.end.line);for(let o=0,c=d.length-1;o<c;o++){const l=d[o].end;if(d[o+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=S.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,r,{setEndOfLine:typeof S.setEndOfLine=="number"?O.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$qQ=k}),define(Oe[57],Ne([1,0,61,6,4,2,3,5,123,16,127,8,11,28,15,39,48]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=void 0,v=We(v),y=We(y);class c{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new R.$le,this.e=new R.$le,this.f=new R.$le,this.g=new R.$le,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],g=[],u=[];if(n.removedDocuments)for(const m of n.removedDocuments){const p=O.URI.revive(m),h=this.c.get(p);h?.unref()&&(this.c.delete(p),t.push(h.value))}if(n.addedDocuments)for(const m of n.addedDocuments){const p=O.URI.revive(m.uri);let h=this.c.get(p);if(h&&p.scheme!==d.Schemas.vscodeNotebookCell&&p.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${p} already exists!'`);h||(h=new c(new $.$kQ(this.h.getProxy(A.$HN.MainThreadDocuments),p,m.lines,m.EOL,m.versionId,m.languageId,m.isDirty)),this.c.set(p,h),g.push(h.value)),h.ref()}if(n.removedEditors)for(const m of n.removedEditors){const p=this.b.get(m);this.b.delete(m),p&&u.push(p)}if(n.addedEditors)for(const m of n.addedEditors){const p=O.URI.revive(m.documentUri);v.ok(this.c.has(p),`document '${p}' does not exist`),v.ok(!this.b.has(m.id),`editor '${m.id}' already exists!`);const h=this.c.get(p).value,E=new k.$qQ(m.id,this.h.getProxy(A.$HN.MainThreadTextEditors),this.i,new o.$T(()=>h.document),m.selections.map(y.Selection.to),m.options,m.visibleRanges.map(D=>y.Range.to(D)),typeof m.editorPosition=="number"?y.ViewColumn.to(m.editorPosition):void 0);this.b.set(m.id,E)}n.newActiveEditor!==void 0&&(v.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,P.$Pc)(t),(0,P.$Pc)(u),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(g),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(m=>m.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$rQ=l,e.$rQ=l=Je([Ve(0,s.$hQ),Ve(1,a.$_j)],l),e.$sQ=(0,T.$Ei)("IExtHostDocumentsAndEditors")}),define(Oe[95],Ne([1,0,10,22,21,6,231,75,4,36,14,37,3,11,5,33,57,16,125,8,7,200,54,81,55,24]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=e.$nqc=e.$mqc=e.$lqc=void 0,i=We(i);let h=0;const E=new WeakMap;e.$lqc=(0,a.$Ei)("IExtHostTesting");let D=class extends $.$Uc{constructor(ee,me,oe,ce){super(),this.C=me,this.D=oe,this.F=ce,this.f=this.B(new O.$le),this.g=new Map,this.w=this.B(new O.$le),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=ee.getProxy(d.$HN.MainThreadTesting),this.m=new W(this.h),this.j=new f(this.h,me),oe.registerArgumentProcessor({processArgument:we=>{switch(we?.$mid){case s.MarshalledId.TestItemContext:{const ae=we,Ie=ae.tests[ae.tests.length-1].item.extId;return this.g.get(g.$5I.root(Ie))?.collection.tree.get(Ie)?.actual??(0,l.$tQ)(we)}case s.MarshalledId.TestMessageMenuArgs:{const{test:ae,message:Ie}=we,Fe=ae.item.extId;return{test:this.g.get(g.$5I.root(Fe))?.collection.tree.get(Fe)?.actual??(0,l.$tQ)({$mid:s.MarshalledId.TestItemContext,tests:[ae]}),message:i.TestMessage.to(Ie)}}default:return we}}}),oe.registerCommand(!1,"testing.getExplorerSelection",async()=>{const we=await oe.executeCommand(t.TestCommandId.GetExplorerSelection),ae=Ie=>{const Fe=this.g.get(g.$5I.root(Ie));if(Fe)return g.$5I.isRoot(Ie)?Fe.controller:Fe.collection.tree.get(Ie)?.actual};return{include:we?.include.map(ae).filter(k.$mg)||[],exclude:we?.exclude.map(ae).filter(k.$mg)||[]}})}createTestController(ee,me,oe,ce){if(this.g.has(me))throw new Error(`Attempt to insert a duplicate controller with ID "${me}"`);const we=new $.$Tc,ae=we.add(new l.$wQ(me,oe,this.F));ae.root.label=oe;const Ie=new Map,Fe=new Set,Y=this.h,q={items:ae.root.children,get label(){return oe},set label(ye){oe=ye,ae.root.label=ye,Y.$updateController(me,{label:oe})},get refreshHandler(){return ce},set refreshHandler(ye){ce=ye,Y.$updateController(me,{canRefresh:!!ye})},get id(){return me},createRunProfile:(ye,le,ve,de,J,x)=>{let pe=(0,A.$sj)(ye);for(;Ie.has(pe);)pe++;return new L(this.h,Ie,Fe,this.w.event,me,pe,ye,le,ve,de,J,x)},createTestItem(ye,le,ve){return new l.$uQ(me,ye,le,ve)},createTestRun:(ye,le,ve=!0)=>this.j.createTestRun(ee,me,ae,ye,le,ve),invalidateTestResults:ye=>{if(ye===void 0)this.h.$markTestRetired(void 0);else{const le=ye instanceof Array?ye:[ye];this.h.$markTestRetired(le.map(ve=>g.$5I.fromExtHostTestItem(ve,me).toString()))}},set resolveHandler(ye){ae.resolveHandler=ye},get resolveHandler(){return ae.resolveHandler},dispose:()=>{we.dispose()}};Y.$registerTestController(me,oe,!!ce),we.add((0,$.$Sc)(()=>Y.$unregisterTestController(me)));const ne={controller:q,collection:ae,profiles:Ie,extension:ee,activeProfiles:Fe};return this.g.set(me,ne),we.add((0,$.$Sc)(()=>this.g.delete(me))),we.add(ae.onDidGenerateDiff(ye=>Y.$publishDiff(me,ye.map(m.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(ee,me=P.CancellationToken.None){const oe=b(ee);if(!oe)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(oe.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:ee.preserveFocus??!0,group:Q[oe.kind],targets:[{testIds:ee.include?.map(we=>g.$5I.fromExtHostTestItem(we,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:oe.profileId,controllerId:oe.controllerId}],exclude:ee.exclude?.map(we=>we.id)},me)}registerTestFollowupProvider(ee){return this.y.add(ee),{dispose:()=>{this.y.delete(ee)}}}$syncTests(){for(const{collection:ee}of this.g.values())ee.flushDiff();return Promise.resolve()}async $getCoverageDetails(ee,me,oe){return(await this.j.getCoverageDetails(ee,me,oe))?.map(i.TestCoverage.fromDetails)}async $disposeRun(ee){this.j.disposeTestRun(ee)}$configureRunProfile(ee,me){this.g.get(ee)?.profiles.get(me)?.configureHandler?.()}$setDefaultRunProfiles(ee){const me=new Map;for(const[oe,ce]of Object.entries(ee)){const we=this.g.get(oe);if(!we)continue;const ae=new Map,Ie=ce.filter(Y=>!we.activeProfiles.has(Y)),Fe=[...we.activeProfiles].filter(Y=>!ce.includes(Y));for(const Y of Ie)ae.set(Y,!0),we.activeProfiles.add(Y);for(const Y of Fe)ae.set(Y,!1),we.activeProfiles.delete(Y);ae.size&&me.set(oe,ae)}this.w.fire(me)}async $refreshTests(ee,me){await this.g.get(ee)?.controller.refreshHandler?.(me)}$publishTestResults(ee){this.results=Object.freeze(ee.map(me=>{const oe=i.TestResults.to(me);return E.set(oe,me.id),oe}).concat(this.results).sort((me,oe)=>oe.completedAt-me.completedAt).slice(0,32)),this.f.fire()}async $expandTest(ee,me){const oe=this.g.get(g.$5I.fromString(ee).controllerId)?.collection;oe&&(await oe.expand(ee,me<0?1/0:me),oe.flushDiff())}$acceptDiff(ee){this.m.applyDiff(ee.map(me=>m.TestsDiffOp.deserialize({asCanonicalUri:oe=>oe},me)))}async $runControllerTests(ee,me){return Promise.all(ee.map(oe=>this.G(oe,!1,me)))}async $startContinuousRun(ee,me){const oe=new P.$we(me),ce=await Promise.all(ee.map(we=>this.G(we,!0,oe.token)));return!me.isCancellationRequested&&!ce.some(we=>we.error)&&await new Promise(we=>me.onCancellationRequested(we)),oe.dispose(!0),ce}async $provideTestFollowups(ee,me){const oe=this.results.find(ae=>E.get(ae)===ee.resultId),ce=oe&&X(g.$5I.fromString(ee.extId),oe?.results);if(!ce)return[];let we=[];return await Promise.all([...this.y].map(async ae=>{try{const Ie=await ae.provideFollowup(oe,ce,ee.taskIndex,ee.messageIndex,me);Ie&&(we=we.concat(Ie))}catch(Ie){this.C.error("Error thrown while providing followup for test message",Ie)}})),me.isCancellationRequested?[]:we.map(ae=>{const Ie=h++;return this.z.set(Ie,ae),{title:ae.title,id:Ie}})}$disposeTestFollowups(ee){for(const me of ee)this.z.delete(me)}$executeTestFollowup(ee){const me=this.z.get(ee);return me?this.D.executeCommand(me.command,...me.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(ee){ee===void 0?this.j.cancelAllRuns():this.j.cancelRunById(ee)}getMetadataForRun(ee){for(const me of this.j.trackers){const oe=me.getTaskIdForRun(ee);if(oe)return{taskId:oe,runId:me.id}}}async G(ee,me,oe){const ce=this.g.get(ee.controllerId);if(!ce)return{};const{collection:we,profiles:ae,extension:Ie}=ce,Fe=ae.get(ee.profileId);if(!Fe)return{};const Y=ee.testIds.map(le=>we.tree.get(le)).filter(k.$mg),q=ee.excludeExtIds.map(le=>ce.collection.tree.get(le)).filter(k.$mg).filter(le=>Y.some(ve=>ve.fullId.compare(le.fullId)===g.TestPosition.IsChild));if(!Y.length)return{};const ne=new n.$mP(Y.some(le=>le.actual instanceof l.$vQ)?void 0:Y.map(le=>le.actual),q.map(le=>le.actual),Fe,me),ye=(0,m.$8I)(ee)&&this.j.prepareForMainThreadTestRun(Ie,ne,M.fromInternal(ee,ce.collection),Fe,oe);try{return await Fe.runHandler(ne,oe),{}}catch(le){return{error:String(le)}}finally{ye&&ye.hasRunningTasks&&!oe.isCancellationRequested&&await O.Event.toPromise(ye.onEnd)}}};e.$mqc=D,e.$mqc=D=Je([Ve(0,c.$hQ),Ve(1,S.$_j),Ve(2,r.$DQ),Ve(3,o.$sQ)],D);const w=1e4;var I;(function(ue){ue[ue.Running=0]="Running",ue[ue.Cancelling=1]="Cancelling",ue[ue.Ended=2]="Ended"})(I||(I={}));class C extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(ee,me,oe,ce,we,ae){super(),this.z=ee,this.C=me,this.D=oe,this.F=ce,this.G=we,this.c=I.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$le),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$we(ae));const Ie=this.B(new v.$Qh(()=>this.H(),w));this.B(this.j.token.onCancellationRequested(()=>Ie.schedule()));const Fe=new O.$le;this.w=Fe.event,this.B((0,$.$Sc)(()=>{Fe.fire(),Fe.dispose()}))}getTaskIdForRun(ee){for(const[me,{run:oe}]of this.g)if(oe===ee)return me}cancel(){this.c===I.Running?(this.j.cancel(),this.c=I.Cancelling):this.c===I.Cancelling&&this.H()}async getCoverageDetails(ee,me,oe){const[,ce]=g.$5I.fromString(ee).path,we=this.y.get(ee);if(!we)return[];const{report:ae,extIds:Ie}=we,Fe=this.g.get(ce);if(!Fe)throw new Error("unreachable: run task was not found");let Y;if(me&&ae instanceof n.$sP){const ne=Ie.indexOf(me);if(ne===-1)return[];Y=ae.fromTests[ne]}return await(Y?this.F?.loadDetailedCoverageForTest?.(Fe.run,ae,Y,oe):this.F?.loadDetailedCoverage?.(Fe.run,ae,oe))??[]}createRun(ee){const me=this.z.id,oe=this.z.controllerId,ce=(0,y.$1g)(),we=Y=>(q,...ne)=>{if(Ie){this.D.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.J(q),Y(q,...ne)},ae=(Y,q)=>{const ne=q instanceof Array?q.map(i.TestMessage.from):[i.TestMessage.from(q)];if(Y.uri&&Y.range){const ye={range:i.Range.from(Y.range),uri:Y.uri};for(const le of ne)le.location=le.location||ye}this.C.$appendTestMessagesInRun(me,ce,g.$5I.fromExtHostTestItem(Y,oe).toString(),ne)};let Ie=!1;const Fe={isPersisted:this.z.isPersisted,token:this.j.token,name:ee,onDidDispose:this.w,addCoverage:Y=>{if(Ie)return;const q=Y instanceof n.$sP?Y.fromTests:[];if(q.length){(0,p.$fH)(this.G,"attributableCoverage");for(const le of q)this.J(le)}const ne=Y.uri.toString(),ye=new g.$5I([me,ce,ne]).toString();this.y.set(ye,{report:Y,extIds:q.map(le=>g.$5I.fromExtHostTestItem(le,oe).toString())}),this.C.$appendCoverage(me,ce,i.TestCoverage.fromFile(oe,ye,Y))},enqueued:we(Y=>{this.C.$updateTestStateInRun(me,ce,g.$5I.fromExtHostTestItem(Y,oe).toString(),m.TestResultState.Queued)}),skipped:we(Y=>{this.C.$updateTestStateInRun(me,ce,g.$5I.fromExtHostTestItem(Y,oe).toString(),m.TestResultState.Skipped)}),started:we(Y=>{this.C.$updateTestStateInRun(me,ce,g.$5I.fromExtHostTestItem(Y,oe).toString(),m.TestResultState.Running)}),errored:we((Y,q,ne)=>{ae(Y,q),this.C.$updateTestStateInRun(me,ce,g.$5I.fromExtHostTestItem(Y,oe).toString(),m.TestResultState.Errored,ne)}),failed:we((Y,q,ne)=>{ae(Y,q),this.C.$updateTestStateInRun(me,ce,g.$5I.fromExtHostTestItem(Y,oe).toString(),m.TestResultState.Failed,ne)}),passed:we((Y,q)=>{this.C.$updateTestStateInRun(me,ce,g.$5I.fromExtHostTestItem(Y,this.z.controllerId).toString(),m.TestResultState.Passed,q)}),appendOutput:(Y,q,ne)=>{Ie||(ne&&this.J(ne),this.C.$appendOutputToRun(me,ce,R.$Ne.fromString(Y),q&&i.location.from(q),ne&&g.$5I.fromExtHostTestItem(ne,oe).toString()))},end:()=>{Ie||(Ie=!0,this.C.$finishedTestRunTask(me,ce),--this.f||this.I())}};return this.f++,this.g.set(ce,{run:Fe}),this.C.$startedTestRunTask(me,{id:ce,ctrlId:this.z.controllerId,name:ee,running:!0}),Fe}H(){for(const{run:ee}of this.g.values())ee.end()}I(){this.c!==I.Ended&&(this.c=I.Ended,this.m.fire())}J(ee){if(!(ee instanceof l.$uQ))throw new u.$_P(ee.id);if(this.h.has(g.$5I.fromExtHostTestItem(ee,this.z.controllerId).toString()))return;const me=[],oe=this.z.colllection.root;for(;;){const ce=i.TestItem.from(ee);if(me.unshift(ce),this.h.has(ce.extId)||(this.h.add(ce.extId),ee===oe))break;ee=ee.parent||oe}this.C.$addTestsToRun(this.z.controllerId,this.z.id,me)}dispose(){this.I(),super.dispose()}}class f{get trackers(){return this.c.values()}constructor(ee,me){this.g=ee,this.h=me,this.c=new Map,this.f=new Map}getCoverageDetails(ee,me,oe){const ce=g.$5I.root(ee);return this.f.get(ce)?.getCoverageDetails(ee,me,oe)||[]}disposeTestRun(ee){this.f.get(ee)?.dispose(),this.f.delete(ee);for(const[me,{id:oe}]of this.c)oe===ee&&this.c.delete(me)}prepareForMainThreadTestRun(ee,me,oe,ce,we){return this.j(me,oe,ce,ee,we)}cancelRunById(ee){this.f.get(ee)?.cancel()}cancelAllRuns(){for(const ee of this.c.values())ee.cancel()}createTestRun(ee,me,oe,ce,we,ae){const Ie=this.c.get(ce);if(Ie)return Ie.createRun(we);const Fe=M.fromPublic(me,oe,ce,ae),Y=b(ce);this.g.$startedExtensionTestRun({controllerId:me,continuous:!!ce.continuous,profile:Y&&{group:Q[Y.kind],id:Y.profileId},exclude:ce.exclude?.map(ne=>g.$5I.fromExtHostTestItem(ne,oe.root.id).toString())??[],id:Fe.id,include:ce.include?.map(ne=>g.$5I.fromExtHostTestItem(ne,oe.root.id).toString())??[oe.root.id],preserveFocus:ce.preserveFocus??!0,persist:ae});const q=this.j(ce,Fe,ce.profile,ee);return O.Event.once(q.onEnd)(()=>{this.g.$finishedExtensionTestRun(Fe.id)}),q.createRun(we)}j(ee,me,oe,ce,we){const ae=new C(me,this.g,this.h,oe,ce,we);return this.c.set(ee,ae),this.f.set(ae.id,ae),ae}}e.$nqc=f;const b=ue=>{if(ue.profile){if(!(ue.profile instanceof L))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ue.profile}};class M{static fromPublic(ee,me,oe,ce){return new M(ee,(0,y.$1g)(),ce,me)}static fromInternal(ee,me){return new M(ee.controllerId,ee.runId,!0,me)}constructor(ee,me,oe,ce){this.controllerId=ee,this.id=me,this.isPersisted=oe,this.colllection=ce}}e.$oqc=M;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(ee){this.j=ee,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(ee){this.c.add(ee)}update(ee){Object.assign(ee.revived,i.TestItem.toPlain(ee.item)),this.c.has(ee)||this.f.add(ee)}remove(ee){if(this.c.has(ee)){this.c.delete(ee);return}this.f.delete(ee);const me=g.$5I.parentId(ee.item.extId);if(me&&this.h.has(me.toString())){this.h.add(ee.item.extId);return}this.g.add(ee)}getChangeEvent(){const{c:ee,f:me,g:oe}=this;return{get added(){return[...ee].map(ce=>ce.revived)},get updated(){return[...me].map(ce=>ce.revived)},get removed(){return[...oe].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class F extends m.$bJ{constructor(){super(...arguments),this.y=new O.$le,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(ee){return this.f.get(ee)}getMirroredTestDataByReference(ee){return this.f.get(ee.id)}x(ee,me){return{...ee,revived:i.TestItem.toPlain(ee.item),depth:me?me.depth+1:0,children:new Set}}w(){return new N(this.y)}}class W{constructor(ee){this.f=ee}checkout(){this.c||(this.c=this.g());const ee=this.c;return ee.observers++,{onDidChangeTest:ee.tests.onDidChangeTests,get tests(){return[...ee.tests.rootTests].map(me=>me.revived)},dispose:(0,T.$cb)(()=>{--ee.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(ee){return this.c?.tests.getMirroredTestDataByReference(ee)}applyDiff(ee){this.c?.tests.apply(ee)}g(){const ee=new F({asCanonicalUri:me=>me});return this.f.$subscribeToDiffs(),{observers:0,tests:ee}}}const K=(ue,ee,me,oe)=>{me?Object.assign(me,oe):ee.$updateTestRunConfig(ue.controllerId,ue.profileId,oe)};class L{#e;#t;#i;#n;#s;get label(){return this.f}set label(ee){ee!==this.f&&(this.f=ee,K(this,this.#e,this.#n,{label:ee}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(ee){ee!==this.g&&(this.g=ee,K(this,this.#e,this.#n,{supportsContinuousRun:ee}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(ee){ee!==this.isDefault&&(ee?this.#t.add(this.profileId):this.#t.delete(this.profileId),K(this,this.#e,this.#n,{isDefault:ee}))}get tag(){return this._tag}set tag(ee){ee?.id!==this._tag?.id&&(this._tag=ee,K(this,this.#e,this.#n,{tag:ee?i.TestTag.namespace(this.controllerId,ee.id):null}))}get configureHandler(){return this.c}set configureHandler(ee){ee!==this.c&&(this.c=ee,K(this,this.#e,this.#n,{hasConfigurationHandler:!!ee}))}get onDidChangeDefault(){return O.Event.chain(this.#i,ee=>ee.map(me=>me.get(this.controllerId)?.get(this.profileId)).filter(k.$mg))}constructor(ee,me,oe,ce,we,ae,Ie,Fe,Y,q=!1,ne=void 0,ye=!1){this.controllerId=we,this.profileId=ae,this.f=Ie,this.kind=Fe,this.runHandler=Y,this._tag=ne,this.g=ye,this.#e=ee,this.#s=me,this.#t=oe,this.#i=ce,me.set(ae,this);const le=Q[Fe];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Fe}`);q&&oe.add(ae),this.#n={profileId:ae,controllerId:we,tag:ne?i.TestTag.namespace(this.controllerId,ne.id):null,label:Ie,group:le,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:ye},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$pqc=L;const Q={[n.TestRunProfileKind.Coverage]:m.TestRunProfileBitset.Coverage,[n.TestRunProfileKind.Debug]:m.TestRunProfileBitset.Debug,[n.TestRunProfileKind.Run]:m.TestRunProfileBitset.Run};function X(ue,ee){for(let me=0;me<ue.path.length;me++){const oe=ee.find(ce=>ce.id===ue.path[me]);if(!oe)return;if(me===ue.path.length-1)return oe;ee=oe.children}}}),define(Oe[259],Ne([1,0,17,6,4,5,127,8,7]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=void 0,v=We(v),A=We(A);class s extends P.$Uc{constructor(y,a){super(),this.m=a,this.a=new R.$le,this.b=new R.$le,this.c=new R.$le,this.f=new R.$le,this.g=new R.$le,this.h=new R.$le,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(O.$HN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(S=>this.h.fire(S))),this.B(this.m.onDidChangeActiveTextEditor(S=>this.g.fire(S)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const a=this.m.allEditors();return y?a:a.map(S=>S.value)}async showTextDocument(y,a,S){let d;typeof a=="number"?d={position:A.ViewColumn.from(a),preserveFocus:S}:typeof a=="object"?d={position:A.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?A.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:d={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(y.uri,d),o=r&&this.m.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,a){return new T.$oQ(this.j,y,a).value}$acceptEditorPropertiesChanged(y,a){const S=this.m.getEditor(y);if(!S)throw new Error("unknown text editor");if(a.options&&S._acceptOptions(a.options),a.selections){const d=a.selections.selections.map(A.Selection.to);S._acceptSelections(d)}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(A.Range.to));S._acceptVisibleRanges(d)}if(a.options&&this.b.fire({textEditor:S.value,options:{...a.options,lineNumbers:A.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const d=$.TextEditorSelectionChangeKind.fromValue(a.selections.source),r=a.selections.selections.map(A.Selection.to);this.a.fire({textEditor:S.value,selections:r,kind:d})}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(A.Range.to));this.c.fire({textEditor:S.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const a in y){const S=this.m.getEditor(a);if(!S)throw new Error("Unknown text editor");const d=A.ViewColumn.to(y[a]);S.value.viewColumn!==d&&(S._acceptViewColumn(d),this.f.fire({textEditor:S.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$wpc=s}),define(Oe[260],Ne([1,0,2,3,5,4,7,8,18,36,14]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=e.$hrc=void 0,e.$hrc=(0,R.$Ei)("IExtHostTimeline");class y{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$HN.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(o,c)=>{if(o&&o.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&$.$qn.equals(c,this.b.get(o.source)?.extension)){const l=o.uri===void 0?void 0:v.URI.revive(o.uri);return this.c.get(o.source)?.get(a(l))?.get(o.handle)}else return;return o}})}async $getTimeline(d,r,o,c){return this.b.get(d)?.provider.provideTimeline(v.URI.revive(r),o,c)}registerTimelineProvider(d,r,o,c){const l=new O.$Tc,i=this.d(r.id,c,l).bind(this);let n;r.onDidChange&&(n=r.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:r.id}),this));const t=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(g,u,m){u?.resetCache&&(l.clear(),t.get(r.id)?.clear());const p=await r.provideTimeline(g,u,m);if(p==null)return;const h=i(g,u);return{...p,source:r.id,items:p.items.map(h)}},dispose(){for(const g of t.values())g.get(r.id)?.clear();n?.dispose(),l.dispose()}},o)}d(d,r,o){return(c,l)=>{let i;if(l?.cacheResults){let n=this.c.get(d);n===void 0&&(n=new Map,this.c.set(d,n));const t=a(c);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...g}=n,u=`${d}|${n.id??n.timestamp}`;i?.set(u,n);let m,p,h;n.iconPath&&(t instanceof T.$IO?h={id:t.id,color:t.color}:v.URI.isUri(t)?(m=t,p=t):{light:m,dark:p}=t);let E;return T.$bO.isMarkdownString(g.tooltip)?E=A.MarkdownString.from(g.tooltip):(0,k.$eg)(g.tooltip)?E=g.tooltip:T.$bO.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=A.MarkdownString.from(g.detail)):(0,k.$eg)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.detail),{...g,id:g.id??void 0,handle:u,source:d,command:n.command?r.toInternal(n.command,o):void 0,icon:m,iconDark:p,themeIcon:h,tooltip:E,accessibilityInformation:n.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,O.$Sc)(()=>{for(const c of this.c.values())c.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$irc=y;function a(S){return S?.toString()}}),define(Oe[261],Ne([1,0,9,23,2,6,4,192,10,7,14,17,8,59,21,163,24]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0,s=We(s);function c(n,t){if((0,k.$eg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let g;return Array.isArray(n.highlights)&&(g=n.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),g=g.length?g:void 0),{label:n.label,highlights:g}}}class l extends T.$Uc{constructor(t,g,u){super(),this.f=t,this.g=g,this.h=u,this.a=new Map,this.b=new r.$L_;function m(p){return p&&p.$treeViewId&&(p.$treeItemHandle||p.$selectedTreeItems||p.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:p=>m(p)?this.r(p):Array.isArray(p)&&p.length>0?p.map(h=>m(h)?this.r(h):h):p})}registerTreeDataProvider(t,g,u){const m=this.createTreeView(t,{treeDataProvider:g},u);return{dispose:()=>m.dispose()}}createTreeView(t,g,u){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=g.dragAndDropController?.dropMimeTypes??[],p=g.dragAndDropController?.dragMimeTypes??[],h=!!g.dragAndDropController?.handleDrag,E=!!g.dragAndDropController?.handleDrop,D=this.m(t,g,u),w={showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:m,dragMimeTypes:p,hasHandleDrag:h,hasHandleDrop:E,manuallyManageCheckboxes:!!g.manageCheckboxStateManually},I=this.f.$registerTreeViewDataProvider(t,w),C={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$fH)(u,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$fH)(u,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(f){(0,S.$5k)(f)&&(0,o.$fH)(u,"treeViewMarkdownMessage"),D.message=f},get title(){return D.title},set title(f){D.title=f},get description(){return D.description},set description(f){D.description=f},get badge(){return D.badge},set badge(f){f!==void 0&&s.ViewBadge.isViewBadge(f)?D.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(D.badge=void 0)},reveal:(f,b)=>D.reveal(f,b),dispose:async()=>{await I,this.a.delete(t),D.dispose()}};return this.B(C),C}$getChildren(t,g){const u=this.a.get(t);return u?u.getChildren(g):Promise.reject(new A.$BG(t))}async $handleDrop(t,g,u,m,p,h,E,D){const w=this.a.get(t);if(!w)return Promise.reject(new A.$BG(t));const I=a.DataTransfer.toDataTransfer(u,async C=>(await this.f.$resolveDropFileData(t,g,C)).buffer);return E===t&&D&&await this.j(I,w,D,p,h),w.onDrop(I,m,p)}async j(t,g,u,m,p){const h=this.b.removeDragOperationTransfer(p);if(h)(await h)?.forEach((E,D)=>{E&&t.set(D,E)});else if(p&&g.handleDrag){const E=g.handleDrag(u,t,m);this.b.addDragOperationTransfer(p,E),await E}return t}async $handleDrag(t,g,u,m){const p=this.a.get(t);if(!p)return Promise.reject(new A.$BG(t));const h=await this.j(new s.$EO,p,g,m,u);if(!(!h||m.isCancellationRequested))return a.DataTransfer.from(h)}async $hasResolve(t){const g=this.a.get(t);if(!g)throw new A.$BG(t);return g.hasResolve}$resolve(t,g,u){const m=this.a.get(t);if(!m)throw new A.$BG(t);return m.resolveTreeItem(g,u)}$setExpanded(t,g,u){const m=this.a.get(t);if(!m)throw new A.$BG(t);m.setExpanded(g,u)}$setSelectionAndFocus(t,g,u){const m=this.a.get(t);if(!m)throw new A.$BG(t);m.setSelectionAndFocus(g,u)}$setVisible(t,g){const u=this.a.get(t);if(!u){if(!g)return;throw new A.$BG(t)}u.setVisible(g)}$changeCheckboxState(t,g){const u=this.a.get(t);if(!u)throw new A.$BG(t);u.setCheckboxState(g)}m(t,g,u){const m=this.B(new i(t,g,this.f,this.g.converter,this.h,u));return this.a.set(t,m),m}r(t){const g=this.a.get(t.$treeViewId);return g&&"$treeItemHandle"in t?g.getExtensionElement(t.$treeItemHandle):g&&"$focusedTreeItem"in t&&t.$focusedTreeItem?g.focusedElement:null}}e.$jrc=l;class i extends T.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,k.$ng)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,g,u,m,p,h){if(super(),this.I=t,this.J=u,this.L=m,this.M=p,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$le),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$le),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$le),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$le),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$le),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$le),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$le),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$we,h.contributes&&h.contributes.views)for(const I in h.contributes.views)for(const C of h.contributes.views[I])C.id===t&&(this.P=C.name);this.f=g.treeDataProvider,this.g=g.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(I=>{Array.isArray(I)&&I.length===0||this.F.fire({message:!1,element:I})}));let E,D;const w=O.Event.debounce(this.F.event,(I,C)=>(I||(I={message:!1,elements:[]}),C.element!==!1&&(E||(E=new Promise(f=>D=f),this.G=this.G.then(()=>E)),Array.isArray(C.element)?I.elements.push(...C.element):I.elements.push(C.element)),C.message&&(I.message=!0),I),200,!0);this.B(w(({message:I,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const f=D;return E=null,this.$(C).then(()=>f())})),I&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const g=t?this.getExtensionElement(t):void 0;if(t&&!g)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let u=this.X(t);return u||(u=await this.Y(g)),u?u.map(m=>m.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,g){g=g||{select:!0,focus:!1};const u=(0,k.$ng)(g.select)?!0:g.select,m=(0,k.$ng)(g.focus)?!1:g.focus,p=(0,k.$ng)(g.expand)?!1:g.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(h=>this.W(t,h[h.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:h.map(D=>D.item)},{select:u,focus:m,expand:p})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:u,focus:m,expand:p})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=a.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,g){const u=this.getExtensionElement(t);u&&(g?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(t,g){const u=!(0,y.$tb)(this.s,t);this.s=t;const m=this.t!==g;this.t=g,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),m&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const g=(await Promise.all(t.map(async u=>{const m=this.getExtensionElement(u.treeItemHandle);return m?{extensionItem:m,treeItem:await this.f.getTreeItem(m),newState:u.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);g.forEach(u=>{u.treeItem.checkboxState=u.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:g.map(u=>[u.extensionItem,u.newState])})}async handleDrag(t,g,u){const m=[];for(const p of t){const h=this.getExtensionElement(p);h&&m.push(h)}if(!(!this.g?.handleDrag||m.length===0))return await this.g.handleDrag(m,g,u),g}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,g,u){const m=g?this.getExtensionElement(g):void 0;if(!(!m&&g||!this.g?.handleDrop))return(0,$.$wh)(()=>this.g?.handleDrop?this.g.handleDrop(m,t,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,g){if(!this.f.resolveTreeItem)return;const u=this.j.get(t);if(u){const m=this.m.get(u);if(m){const p=await this.f.resolveTreeItem(m.extensionItem,u,g)??m.extensionItem;return this.hb(p),m.item.tooltip=this.eb(p.tooltip),m.item.command=this.fb(m.disposableStore,p.command),m.item}}}S(t){return this.U(t).then(g=>g?this.S(g).then(u=>this.W(g,u[u.length-1]).then(m=>(u.push(m),u))):Promise.resolve([]))}U(t){const g=this.m.get(t);return g?Promise.resolve(g.parent?this.j.get(g.parent.item.handle):void 0):(0,$.$wh)(()=>this.f.getParent(t))}W(t,g){const u=this.m.get(t);return u?Promise.resolve(u):(0,$.$wh)(()=>this.f.getTreeItem(t)).then(m=>this.kb(t,m,g,!0)).then(m=>this.getChildren(g?g.item.handle:void 0).then(()=>{const p=this.getExtensionElement(m);if(p){const h=this.m.get(p);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${m} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let g;if(typeof t=="string"){const u=this.getExtensionElement(t);g=u?this.m.get(u):void 0}else g=t;return g&&g.children||void 0}return this.h}async Y(t){this.rb(t);const g=new d.$we(this.Z.token);try{const u=t?this.m.get(t):void 0,m=await this.f.getChildren(t);if(g.token.isCancellationRequested)return;const p=(0,y.$Gb)(m||[]),h=await Promise.all((0,y.$Gb)(p).map(D=>this.f.getTreeItem(D)));if(g.token.isCancellationRequested)return;const E=h.map((D,w)=>D?this.db(p[w],D,u):null);return(0,y.$Gb)(E)}finally{g.dispose()}}$(t){if(t.some(u=>!u))return this.Z.dispose(!0),this.Z=new d.$we,this.tb(),this.J.$refresh(this.I);{const u=this.ab(t);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(t){const g=new Set,u=t.map(p=>this.m.get(p));for(const p of u)if(p&&!g.has(p.item.handle)){let h=p;for(;h&&h.parent&&u.findIndex(E=>h&&h.parent&&E&&E.item.handle===h.parent.item.handle)===-1;){const E=this.j.get(h.parent.item.handle);h=E?this.m.get(E):void 0}h&&!h.parent&&g.add(p.item.handle)}const m=[];return g.forEach(p=>{const h=this.j.get(p);if(h){const E=this.m.get(h);E&&(!E.parent||!g.has(E.parent.item.handle))&&m.push(p)}}),m}bb(t){const g={};return Promise.all(t.map(u=>this.cb(u).then(m=>{m&&(g[u]=m.item)}))).then(()=>Object.keys(g).length?this.J.$refresh(this.I,g):void 0)}cb(t){const g=this.getExtensionElement(t);if(g){const u=this.m.get(g);if(u)return this.rb(g),(0,$.$wh)(()=>this.f.getTreeItem(g)).then(m=>{if(m){const p=this.ib(g,m,u.parent);return this.pb(g,p,u,u.parent),u.dispose(),p}return null})}return Promise.resolve(null)}db(t,g,u){const m=this.ib(t,g,u);if(g.id&&this.j.has(m.item.handle))throw new Error((0,v.localize)(10776,null,g.id));return this.ob(t,m),this.qb(m,u),m}eb(t){return s.$bO.isMarkdownString(t)?a.MarkdownString.from(t):t}fb(t,g){return g?{...this.L.toInternal(g,t),originalId:g.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let g,u,m;return typeof t.checkboxState=="number"?g=t.checkboxState:(g=t.checkboxState.state,u=t.checkboxState.tooltip,m=t.checkboxState.accessibilityInformation),{isChecked:g===s.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:m}}hb(t){if(!s.$zO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,g,u){this.hb(g);const m=this.B(new T.$Tc),p=this.kb(t,g,u),h=this.lb(g);return{item:{handle:p,parentHandle:u?u.item.handle:void 0,label:c(g.label,this.N),description:g.description,resourceUri:g.resourceUri,tooltip:this.eb(g.tooltip),command:this.fb(m,g.command),contextValue:g.contextValue,icon:h,iconDark:this.mb(g)||h,themeIcon:this.jb(g),collapsibleState:(0,k.$ng)(g.collapsibleState)?s.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.gb(g)},extensionItem:g,parent:u,children:void 0,disposableStore:m,dispose(){m.dispose()}}}jb(t){return t.iconPath instanceof s.$IO?t.iconPath:void 0}kb(t,{id:g,label:u,resourceUri:m},p,h){if(g)return`${i.b}/${g}`;const E=c(u,this.N),D=p?p.item.handle:i.a;let w=E?E.label:m?(0,R.$ch)(m):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const I=this.m.has(t)?this.m.get(t).item.handle:void 0,C=this.X(p)||[];let f,b=0;do{if(f=`${D}/${b}:${w}`,h||!this.j.has(f)||I===f)break;b++}while(b<=C.length);return f}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$IO))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$IO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,g){this.j.set(g.item.handle,t),this.m.set(t,g)}pb(t,g,u,m){this.j.delete(g.item.handle),this.m.delete(t),g.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(t,g);const p=this.X(m)||[],h=p.filter(E=>E.item.handle===u.item.handle)[0];h&&p.splice(p.indexOf(h),1,g)}qb(t,g){g?(g.children||(g.children=[]),g.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const m=this.j.get(u.item.handle);m&&this.sb(m)}g.children=void 0}}else this.tb()}sb(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const m=this.j.get(u.item.handle);m&&this.sb(m)}this.m.delete(t),this.j.delete(g.item.handle),g.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Oe[262],Ne([1,0,6,4,2,37,8,67,5,7]),function(be,e,v,R,P,O,T,A,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0,T=We(T),$=We($),s=We(s);class k extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(d,r,o,c){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$le),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$le),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=o,this.#i=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#l=c.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(d){this.#u||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#l=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:T.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends R.$Uc{static c(){return(0,O.$1g)()}constructor(d,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy($.$HN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,o,c,l={}){const i=typeof c=="object"?c.viewColumn:c,n={viewColumn:T.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},t=(0,A.$Lpc)(d),g=y.c();this.f.$createWebviewPanel((0,A.$Npc)(d),g,r,{title:o,panelOptions:a(l),webviewOptions:(0,A.$Opc)(d,this.m,l),serializeBuffersForPostMessage:t},n);const u=this.j.createNewWebview(g,l,d);return this.createNewWebviewPanel(g,r,o,i,l,u,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((o,c)=>{const l=d[o],i=d[c];return l.active?1:i.active?-1:+l.visible-+i.visible});for(const o of r){const c=this.getWebviewPanel(o);if(!c)continue;const l=d[o];c._updateViewState({active:l.active,visible:l.visible,viewColumn:T.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,A.$Lpc)(d)}),new s.$JN(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,o,c){const l=this.h.get(r);if(!l)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=l,t=this.j.createNewWebview(d,o.webviewOptions,n),g=this.createNewWebviewPanel(d,r,o.title,c,o.panelOptions,t,o.active);await i.deserializeWebviewPanel(g,o.state)}createNewWebviewPanel(d,r,o,c,l,i,n){const t=new k(d,this.f,i,{viewType:r,title:o,viewColumn:c,panelOptions:l,active:n});return this.g.set(d,t),t}getWebviewPanel(d){return this.g.get(d)}}e.$Ppc=y;function a(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Oe[263],Ne([1,0,6,4,67,8,5,7]),function(be,e,v,R,P,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=void 0,T=We(T),A=We(A);class $ extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,a,S,d,r,o){super(),this.#s=!1,this.#l=this.B(new v.$le),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$le),this.onDidDispose=this.#u.event,this.#i=S,this.#a=d,this.#e=y,this.#t=a,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(y,a){this.d=a,this.b=new Map,this.c=new Map,this.a=y.getProxy(T.$HN.MainThreadWebviewViews)}registerWebviewViewProvider(y,a,S,d){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:S,extension:y}),this.a.$registerWebviewViewProvider((0,P.$Npc)(y),a,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Lpc)(y)}),new A.$JN(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(y,a,S,d,r){const o=this.b.get(a);if(!o)throw new Error(`No view provider found for '${a}'`);const{provider:c,extension:l}=o,i=this.d.createNewWebview(y,{},l),n=new $(y,this.a,a,S,i,!0);this.c.set(y,n),await c.resolveWebviewView(n,{state:d},r)}async $onDidChangeWebviewViewVisibility(y,a){this.e(y)._setVisible(a)}async $disposeWebviewView(y){const a=this.e(y);this.c.delete(y),a.dispose(),this.d.deleteWebview(y)}e(y){const a=this.c.get(y);if(!a)throw new Error("No webview found");return a}}e.$mrc=s}),define(Oe[264],Ne([1,0,6,30,31,3]),function(be,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.OutputChannelUpdateMode=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=void 0,e.$PM="text/x-code-output",e.$QM="output",e.$RM="Log",e.$SM="text/x-code-log-output",e.$TM="log",e.$UM="workbench.panel.output",e.$VM=new P.$Vj("inOutput",!1),e.$WM=new P.$Vj("activeLogOutput",!1),e.$XM=new P.$Vj("activeLogOutput.levelSettable",!1),e.$YM=new P.$Vj("activeLogOutput.level",""),e.$ZM=new P.$Vj("activeLogOutput.levelIsDefault",!1),e.$1M=new P.$Vj("outputView.scrollLock",!1),e.$2M=(0,O.$Ei)("outputService");var T;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.$3M={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new v.$le,this.onDidRegisterChannel=this.b.event,this.c=new v.$le,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(k=>s.push(k)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}R.$qo.add(e.$3M.OutputChannels,new A),e.$4M=new P.$Vj("activeOutputChannel","")}),define(Oe[128],Ne([1,0,5,3,16,18,11,264,68,26,50,165,22,14,29,6,4]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=e.$2qc=void 0;class c extends T.$fk{get disposed(){return this.n}constructor(t,g,u,m,p){super(),this.id=t,this.name=g,this.r=u,this.s=m,this.extension=p,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,A.OutputChannelUpdateMode.Clear,t)}replace(t){const g=this.m;this.info(t),this.s.$update(this.id,A.OutputChannelUpdateMode.Replace,g),this.visible&&this.r.flush()}show(t,g){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:g))}hide(){this.s.$close(this.id)}g(t,g){this.m+=a.$Ne.fromString(g).byteLength,(0,T.log)(this.r,t,g),this.visible&&(this.r.flush(),this.s.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends c{appendLine(t){this.append(t)}}let i=class{constructor(t,g,u,m,p,h){this.i=g,this.j=u,this.k=m,this.l=p,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$HN.MainThreadOutputService),this.b=this.k.extUri.joinPath(g.logsLocation,`output_logging_${(0,y.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[g,u]of this.g)u.visible=g===this.h}createOutputChannel(t,g,u){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const m=typeof g=="object"&&g.log,p=(0,S.$eg)(g)?g:void 0;if((0,S.$eg)(p)&&!p.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const E=this.i.environment.extensionLogLevel?.find(([w])=>O.$qn.equals(u.identifier,w))?.[1];E&&(h=(0,T.$qk)(E));const D=m?this.o(t,h,u):this.n(t,p,u);return D.then(w=>{this.g.set(w.id,w),w.visible=w.id===this.h}),m?this.r(t,h??this.m.getLevel(),D):this.q(t,D)}async n(t,g,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const m=await this.c,p=this.k.extUri.joinPath(m,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(p,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,p,g,u.identifier.value);return new c(E,t,h,this.a,u)}async o(t,g,u){const m=await this.p(u),p=t.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(m,`${p}.log`),E=`${u.identifier.value}.${p}`,D=this.l.createLogger(h,{id:E,name:t,logLevel:g,extensionId:u.identifier.value});return new l(E,t,D,this.a,u)}p(t){let g=this.d.get(t.identifier.value);if(!g){const u=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,g=(async()=>{try{await this.j.value.createDirectory(u)}catch(m){if((0,d.$pl)(m)!==d.FileSystemProviderErrorCode.FileExists)throw m}return u})())}return g}q(t,g){let u=!1;const m=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return t},append(p){m(),g.then(h=>h.append(p))},appendLine(p){m(),g.then(h=>h.appendLine(p))},clear(){m(),g.then(p=>p.clear())},replace(p){m(),g.then(h=>h.replace(p))},show(p,h){m(),g.then(E=>E.show(p,h))},hide(){m(),g.then(p=>p.hide())},dispose(){u=!0,g.then(p=>p.dispose())}}}r(t,g,u){const m=new o.$Tc,p=()=>{if(m.isDisposed)throw new Error("Channel has been closed")},h=m.add(new r.$le);function E(D){g=D,h.fire(D)}return u.then(D=>{m.add(D),D.logLevel!==g&&E(D.logLevel),m.add(D.onDidChangeLogLevel(w=>E(w)))}),{...this.q(t,u),get logLevel(){return g},onDidChangeLogLevel:h.event,trace(D,...w){p(),u.then(I=>I.trace(D,...w))},debug(D,...w){p(),u.then(I=>I.debug(D,...w))},info(D,...w){p(),u.then(I=>I.info(D,...w))},warn(D,...w){p(),u.then(I=>I.warn(D,...w))},error(D,...w){p(),u.then(I=>I.error(D,...w))},dispose(){m.dispose()}}}};e.$2qc=i,e.$2qc=i=Je([Ve(0,P.$hQ),Ve(1,s.$xQ),Ve(2,$.$Hpc),Ve(3,k.$kpc),Ve(4,T.$ak),Ve(5,T.$_j)],i),e.$3qc=(0,R.$Ei)("IExtHostOutputService")}),define(Oe[129],Ne([1,0,3,10]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,v.$Ei)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let A=0;A<this.maxSampleCount;A++){const $=await P.getRoundTripTime();if($===void 0)return;O=Math.min(O,$/2),await(0,R.$Fh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(O):T=this.initial.reduce((A,$)=>A+$,0)/this.initial.length,this.lastMeasurement={initial:T,current:O,average:this.average.reduce((A,$)=>A+$,0)/this.average.length,high:typeof T>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>T*this.highLatencyMultiple},this.lastMeasurement}}}),define(Oe[265],Ne([1,0,9,53,30,49,43,4,6,129,20,25,10,113]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=void 0,e.$bL=Object.freeze({id:"application",order:100,title:(0,v.localize)(12500,null),type:"object"}),e.$cL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(12501,null),type:"object"}),e.$dL=Object.freeze({id:"security",scope:R.ConfigurationScope.APPLICATION,title:(0,v.localize)(12502,null),type:"object",order:7}),e.$eL=Object.freeze({id:"problems",title:(0,v.localize)(12503,null),type:"object",order:101}),e.$fL=Object.freeze({id:"window",order:8,title:(0,v.localize)(12504,null),type:"object"}),e.$gL={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new $.$le,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new d;P.$qo.add(e.$gL.ConfigurationMigration,r);let o=class extends A.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const u of g.added)await this.f(u,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(g=>this.g(g,n?.uri))])}async g(n,t){const g=this.a.inspect(n.key,{resource:t}),u=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE],["workspaceFolder",T.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE]];for(const[m,p]of u){const h=g[m];if(!h)continue;const E=[];if(h.value!==void 0){const D=await this.h(n,m,h.value,t,void 0);for(const w of D??[])E.push([w,[]])}for(const{identifiers:D,value:w}of h.overrides??[])if(w!==void 0){const I=await this.h(n,m,w,t,D);for(const C of I??[])E.push([C,D])}E.length&&await Promise.allSettled(E.map(async([[D,w],I])=>this.a.updateValue(D,w.value,{resource:t,overrideIdentifiers:I},p)))}}async h(n,t,g,u,m){const p=E=>{const w=this.a.inspect(E,{resource:u})[t];if(w)return m?w.overrides?.find(({identifiers:I})=>(0,y.$ho)(I,m))?.value:w.value},h=await n.migrateFn(g,p);return Array.isArray(h)?h:[[n.key,h]]}};e.$hL=o,e.$hL=o=Je([Ve(0,T.$$i),Ve(1,O.$Ni)],o);let c=class extends A.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new a.$2h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!k.$j&&(await this.b.getEnvironment())?.os!==k.OperatingSystem.Windows)return;P.$qo.as(R.$vo.Configuration).registerConfiguration({...e.$dL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(12505,null)},default:[],markdownDescription:(0,v.localize)(12506,null),scope:R.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(12507,null),scope:R.ConfigurationScope.MACHINE}}})}};e.$iL=c,e.$iL=c=Je([Ve(0,s.$Vm)],c),e.$jL="window.newWindowProfile";let l=class extends A.$Uc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(g=>{g.source!==T.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(e.$jL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$qo.as(R.$vo.Configuration),t={...e.$fL,properties:{[e.$jL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,v.localize)(12508,null)],description:(0,v.localize)(12509,null),scope:R.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$jL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$jL);if(!n)return;const t=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$jL,t?.name)}};e.$kL=l,e.$kL=l=Je([Ve(0,S.$Ll),Ve(1,T.$$i)],l)}),define(Oe[266],Ne([1,0,41,15,19,23,9,265,53,3,30]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$mL=e.$lL=void 0,e.$nL=r,e.$oL=o,v=We(v),e.$lL=(0,s.$Ei)("editorResolverService"),e.$mL="workbench.editorAssociations";const y=k.$qo.as($.$vo.Configuration),a={...A.$cL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(2013,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(a);var S;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(S||(e.RegisteredEditorPriority=S={}));var d;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(c){switch(c){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function o(c,l){if(new Set([R.Schemas.extension,R.Schemas.webviewPanel,R.Schemas.vscodeWorkspaceTrust,R.Schemas.vscodeSettings]).has(l.scheme))return!1;const t=typeof c=="string"&&c.indexOf(P.$gc.sep)>=0?`${l.scheme}:${l.path}`:(0,O.$ch)(l);return v.$yk(typeof c=="string"?c.toLowerCase():c,t.toLowerCase())}}),define(Oe[267],Ne([1,0,51,15,19,20,23,2,3,186,49,205,129]),function(be,e,v,R,P,O,T,A,$,s,k,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=void 0,e.$jN=(0,$.$Ei)("pathService");let d=S=class{constructor(o,c,l,i){this.d=o,this.e=c,this.f=l,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??o})()}hasValidBasename(o,c,l){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(o,i,c)):this.h(o,c,l)}h(o,c,l){return o.scheme===R.Schemas.file||o.scheme===R.Schemas.vscodeRemote?(0,v.$Bg)(l??(0,T.$ch)(o),c===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,c){if(o.remoteAuthority)return R.Schemas.vscodeRemote;const l=(0,s.$gN)(c.getWorkspace());if(l)return l;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=c.getWorkspace().configuration;return n?n.scheme:R.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===O.OperatingSystem.Windows?P.$fc:P.$gc)}async fileURI(o){let c="";if(await this.a===O.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(c=o.substring(2),o="/"):(c=o.substring(2,i),o=o.substring(i)||"/")}return A.URI.from({scheme:R.Schemas.file,authority:c,path:o,query:"",fragment:""})}};e.$kN=d,e.$kN=d=S=Je([Ve(1,a.$Vm),Ve(2,y.$5M),Ve(3,k.$Ni)],d)}),define(Oe[130],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.$XL=e.$WL=e.TextSearchCompleteMessageType=e.$VL=e.$UL=void 0;class v{constructor(k,y){this.line=k,this.character=y}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,y){return new v(0,0)}with(k){return new v(0,0)}}e.$UL=v;class R{constructor(k,y,a,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(k,y),this.end=new v(a,S)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new R(0,0,0,0)}with(k){return new R(0,0,0,0)}}e.$VL=R;var P;(function(s){s[s.Information=1]="Information",s[s.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}));class O{constructor(k,y,a){this.uri=k,this.ranges=y,this.previewText=a}}e.$WL=O;class T{constructor(k,y,a){this.uri=k,this.text=y,this.lineNumber=a}}e.$XL=T;var A;(function(s){s[s.none=1]="none",s[s.filesExclude=2]="filesExclude",s[s.searchAndFilesExclude=3]="searchAndFilesExclude"})(A||(e.ExcludeSettingOptions=A={}));var $;(function(s){s[s.Information=1]="Information",s[s.Warning=2]="Warning"})($||(e.TextSearchCompleteMessageTypeNew=$={}))}),define(Oe[44],Ne([1,0,17,41,25,51,12,3,19,13,130,10]),function(be,e,v,R,P,O,T,A,$,s,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$jM=e.$cM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$_L=e.$$L=e.$0L=e.$9L=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.TextSearchCompleteMessageType=void 0,e.$6L=c,e.$7L=l,e.$8L=i,e.$aM=D,e.$bM=w,e.$dM=f,e.$eM=b,e.$fM=M,e.$gM=N,e.$hM=F,e.$iM=W,e.$kM=L,e.$mM=ue,e.$nM=ee,R=We(R),P=We(P),O=We(O),$=We($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return k.TextSearchCompleteMessageType}}),e.$YL="workbench.view.search",e.$ZL="workbench.panel.search",e.$1L="workbench.view.search",e.$2L="search-result",e.$3L="search.exclude",e.$4L=2e4;const a="\u27EA ",S=" characters skipped \u27EB",d=(a.length+S.length+5)*2;e.$5L=(0,A.$Ei)("searchService");var r;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text",oe[oe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text",oe[oe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function c(oe){return!!oe.preview}function l(oe){return!!oe.resource}function i(oe){return!!oe.message}var n;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$9L=t;class g{constructor(ce,we,ae,Ie){this.ranges=we,this.webviewIndex=Ie;const Fe=Array.isArray(we)?we:[we];if(ae&&ae.matchLines===1&&u(Fe)){ce=(0,T.$0f)(ce,ae.matchLines);let Y="",q=0,ne=0;const ye=Math.floor(ae.charsPerLine/5),le=[];for(const ve of Fe){const de=Math.max(ve.startColumn-ye,0),J=ve.startColumn+ae.charsPerLine;if(de>ne+ye+d){const x=a+(de-ne)+S;Y+=x+ce.slice(de,J),q+=de-(ne+x.length)}else Y+=ce.slice(ne,J);le.push(new p(0,ve.startColumn-q,ve.endColumn-q)),ne=J}this.preview={text:Y,matches:Array.isArray(this.ranges)?le:le[0]}}else{const Y=Array.isArray(we)?we[0].startLineNumber:we.startLineNumber;this.preview={text:ce,matches:(0,v.$Zb)(we,q=>new m(q.startLineNumber-Y,q.startColumn,q.endLineNumber-Y,q.endColumn))}}}}e.$0L=g;function u(oe){const ce=oe[0].startLineNumber;for(const we of oe)if(we.startLineNumber!==ce||we.endLineNumber!==ce)return!1;return!0}class m{constructor(ce,we,ae,Ie){this.startLineNumber=ce,this.startColumn=we,this.endLineNumber=ae,this.endColumn=Ie}}e.$$L=m;class p extends m{constructor(ce,we,ae){super(ce,we,ce,ae)}}e.$_L=p;var h;(function(oe){oe.List="list",oe.Tree="tree"})(h||(e.ViewMode=h={}));var E;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(oe,ce=!0){const we=oe&&oe.files&&oe.files.exclude,ae=ce&&oe&&oe.search&&oe.search.exclude;if(!we&&!ae)return;if(!we||!ae)return we||ae||void 0;let Ie=Object.create(null);return Ie=P.$go(Ie,P.$do(we)),Ie=P.$go(Ie,P.$do(ae),!0),Ie}function w(oe,ce){return oe.excludePattern&&R.$yk(oe.excludePattern,ce)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&R.$yk(oe.includePattern,ce)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(we=>{const ae=we.folder.fsPath;if(O.$Dg(ce,ae)){const Ie=$.$lc(ae,ce);return!we.includePattern||!!R.$yk(we.includePattern,Ie)}else return!1}):!1:!0}var I;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(I||(e.SearchErrorCode=I={}));class C extends Error{constructor(ce,we){super(ce),this.code=we}}e.$cM=C;function f(oe){const ce=oe.message;if((0,s.$3)(oe))return new C(ce,I.canceled);try{const we=JSON.parse(ce);return new C(we.message,we.code)}catch{return new C(ce,I.other)}}function b(oe){const ce={message:oe.message,code:oe.code};return new Error(JSON.stringify(ce))}function M(oe){return oe.type==="error"?!0:oe.type==="success"}function N(oe){return oe.type==="success"}function F(oe){return!!oe.path}function W(oe,ce,we=!0){const ae=oe.searchPath?oe.searchPath:oe.relativePath;return we?(0,T.$7f)(ae,ce):R.$yk(ce,ae)}class K{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$jM=K;function L(oe,ce){const we={...oe||{},...ce||{}};return Object.keys(we).filter(ae=>{const Ie=we[ae];return typeof Ie=="boolean"&&Ie})}class Q{constructor(ce,we){this.c=null,this.a={...ce.excludePattern||{},...we.excludePattern||{}},this.b=R.$zk(this.a);let ae=ce.includePattern;we.includePattern&&(ae?ae={...ae,...we.includePattern}:ae=we.includePattern),ae&&(this.c=R.$zk(ae))}matchesExcludesSync(ce,we,ae){return!!(this.b&&this.b(ce,we,ae))}includedInQuerySync(ce,we,ae){return!(this.b&&this.b(ce,we,ae)||this.c&&!this.c(ce,we,ae))}includedInQuery(ce,we,ae){const Ie=this.b(ce,we,ae),Fe=()=>this.c?!!this.c(ce,we,ae):!0;return(0,y.$qh)(Ie)?Ie.then(Y=>Y?!1:Fe()):Fe()}hasSiblingExcludeClauses(){return X(this.a)}}e.$lM=Q;function X(oe){for(const ce in oe)if(typeof oe[ce]!="boolean")return!0;return!1}function ue(oe){if(!oe)return;let ce;return we=>(ce||(ce=(oe()||Promise.resolve([])).then(ae=>ae?me(ae):{})),ce.then(ae=>!!ae[we]))}function ee(oe){if(!oe)return;let ce;return we=>{if(!ce){const ae=oe();ce=ae?me(ae):{}}return!!ce[we]}}function me(oe){const ce={};for(const we of oe)ce[we]=!0;return ce}}),define(Oe[45],Ne([1,0,17,10,21,6,4,58,15,140,23,12,2,9,29,3,11,173,49,50,26,16,8,7,65,44,5,40]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u,m,p,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=e.$Bpc=void 0;function D(F,W,K){return new k.$7g(L=>f(L,K)).isEqual(F,W)}function w(F,W,K){return D(F.uri,W.uri,K)?0:(0,y.$yf)(F.uri.toString(),W.uri.toString())}function I(F,W,K){return F.index!==W.index?F.index<W.index?-1:1:D(F.uri,W.uri,K)?(0,y.$yf)(F.name,W.name):(0,y.$yf)(F.uri.toString(),W.uri.toString())}function C(F,W,K,L){const Q=F.slice(0).sort((ue,ee)=>K(ue,ee,L)),X=W.slice(0).sort((ue,ee)=>K(ue,ee,L));return(0,v.$Db)(Q,X,(ue,ee)=>K(ue,ee,L))}function f(F,W){const K=W.getCapabilities(F.scheme);return!(K&&K&d.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends l.$Xi{static toExtHostWorkspace(W,K,L,Q){if(!W)return{workspace:null,added:[],removed:[]};const{id:X,name:ue,folders:ee,configuration:me,transient:oe,isUntitled:ce}=W,we=[],ae=K;K?ee.forEach((q,ne)=>{const ye=a.URI.revive(q.uri),le=b.o(L||K,ye,Q);le?(le.name=q.name,le.index=q.index,we.push(le)):we.push({uri:ye,name:q.name,index:ne})}):we.push(...ee.map(({uri:q,name:ne,index:ye})=>({uri:a.URI.revive(q),name:ne,index:ye}))),we.sort((q,ne)=>q.index<ne.index?-1:1);const Ie=new b(X,ue,we,!!oe,me?a.URI.revive(me):null,!!ce,q=>f(q,Q)),{added:Fe,removed:Y}=C(ae?ae.workspaceFolders:[],Ie.workspaceFolders,w,Q);return{workspace:Ie,added:Fe,removed:Y}}static o(W,K,L){for(let Q=0;Q<W.folders.length;Q++){const X=W.workspaceFolders[Q];if(D(X.uri,K,L))return X}}constructor(W,K,L,Q,X,ue,ee){super(W,L.map(me=>new l.$Yi(me)),Q,X,ee),this.t=K,this.u=ue,this.q=[],this.s=A.$Ki.forUris(ee,()=>!0),L.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,K){return K&&this.s.get(W)&&(W=(0,k.$eh)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let M=class{constructor(W,K,L,Q,X){this.c=new O.$le,this.onDidChangeWorkspace=this.c.event,this.g=new O.$le,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$ne,this.C=new Map,this.h=Q,this.s=L,this.t=X,this.j=new s.$Mm,this.k=new R.$Dh,this.o=W.getProxy(h.$HN.MainThreadWorkspace),this.q=W.getProxy(h.$HN.MainThreadMessageService);const ue=K.workspace;this.l=ue?new b(ue.id,ue.name,[],!!ue.transient,ue.configuration?a.URI.revive(ue.configuration):null,!!ue.isUntitled,ee=>f(ee,L)):void 0}$initializeWorkspace(W,K){this.v=K,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:$.Schemas.untitled,path:(0,k.$ch)((0,k.$eh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,K,L,...Q){const X=[];if(Array.isArray(Q)&&Q.forEach(ce=>{a.URI.isUri(ce.uri)&&!X.some(we=>D(we.uri,ce.uri,this.s))&&X.push({uri:ce.uri,name:ce.name||(0,k.$bh)(ce.uri)})}),this.n||[K,L].some(ce=>typeof ce!="number"||ce<0)||L===0&&X.length===0)return!1;const ue=this.x?this.x.workspaceFolders:[];if(K+L>ue.length)return!1;const ee=ue.slice(0);ee.splice(K,L,...X.map(ce=>({uri:ce.uri,name:ce.name||(0,k.$bh)(ce.uri),index:void 0})));for(let ce=0;ce<ee.length;ce++){const we=ee[ce];if(ee.some((ae,Ie)=>Ie!==ce&&D(we.uri,ae.uri,this.s)))return!1}ee.forEach((ce,we)=>ce.index=we);const{added:me,removed:oe}=C(ue,ee,I,this.s);if(me.length===0&&oe.length===0)return!1;if(this.o){const ce=W.displayName||W.name;this.o.$updateWorkspaceFolders(ce,K,L,X).then(void 0,we=>{this.n=void 0;const ae={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(c.Severity.Error,(0,S.localize)(10773,null,ce,we.toString()),ae,[])})}return this.y(ee),!0}getWorkspaceFolder(W,K){if(this.x)return this.x.getWorkspaceFolder(W,K)}async getWorkspaceFolder2(W,K){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,K)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,K){let L,Q="";if(typeof W=="string"?(L=a.URI.file(W),Q=W):typeof W<"u"&&(L=W,Q=W.fsPath),!L)return Q;const X=this.getWorkspaceFolder(L,!0);if(!X)return Q;typeof K>"u"&&this.x&&(K=this.x.folders.length>1);let ue=(0,k.$hh)(X.uri,L);return K&&X.name&&(ue=`${X.name}/${ue}`),ue}y(W){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:K,added:L,removed:Q}=b.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=K||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:Q}))}findFiles(W,K,L,Q,X=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Q.value}, entryPoint: findFiles`);let ue="",ee=!0;return K===null?ee=!1:K!==void 0&&(typeof K=="string"?ue=K:ue=K.pattern),this.z(W,void 0,{exclude:ue,maxResults:L,useDefaultExcludes:ee,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},X)}findFiles2(W,K={},L,Q=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${L.value}, entryPoint: findFiles2`),this.z(void 0,W,K,Q)}async z(W,K,L,Q=P.CancellationToken.None){if(Q&&Q.isCancellationRequested)return Promise.resolve([]);const X=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,ue={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof L.useDefaultSearchExcludes=="boolean"?!L.useDefaultSearchExcludes:!1,maxResults:L.maxResults,excludePattern:X,shouldGlobSearch:typeof L.fuzzy=="boolean"?!L.fuzzy:!0,_reason:"startFileSearch"};let ee;if(W){const{includePattern:me,folder:oe}=N(g.GlobPattern.from(W));ee=oe,ue.includePattern=me}else{const{includePattern:me,folder:oe}=N(g.GlobPattern.from(K));ee=oe,ue.filePattern=me}return this.o.$startFileSearch(ee??null,ue,Q).then(me=>Array.isArray(me)?me.map(oe=>a.URI.revive(oe)):[])}async findTextInFiles(W,K,L,Q,X=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Q.value}, entryPoint: findTextInFiles`);const ue=this.j.getNext(),ee=typeof K.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:K.previewOptions,{includePattern:me,folder:oe}=N(g.GlobPattern.from(K.include)),ce=typeof K.exclude=="string"?K.exclude:K.exclude?K.exclude.pattern:void 0,we={ignoreSymlinks:typeof K.followSymlinks=="boolean"?!K.followSymlinks:void 0,disregardIgnoreFiles:typeof K.useIgnoreFiles=="boolean"?!K.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof K.useGlobalIgnoreFiles=="boolean"?!K.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof K.useParentIgnoreFiles=="boolean"?!K.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof K.useDefaultExcludes=="boolean"?!K.useDefaultExcludes:!0,fileEncoding:K.encoding,maxResults:K.maxResults,previewOptions:ee,afterContext:K.afterContext,beforeContext:K.beforeContext,includePattern:me,excludePattern:ce},ae=!1;if(this.u[ue]=Ie=>{if(ae)return;const Fe=a.URI.revive(Ie.resource);Ie.results.forEach(Y=>{const q=(0,E.$bi)(Y);(0,p.$6L)(q)?L({uri:Fe,preview:{text:q.preview.text,matches:(0,v.$Zb)(q.preview.matches,ne=>new u.$LN(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,v.$Zb)(q.ranges,ne=>new u.$LN(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):L({uri:Fe,text:q.text,lineNumber:q.lineNumber})})},X.isCancellationRequested)return{};try{const Ie=await this.o.$startTextSearch(W,oe??null,we,ue,X);return delete this.u[ue],Ie||{}}catch(Ie){throw delete this.u[ue],Ie}}$handleTextSearchResult(W,K){this.u[K]?.(W)}async save(W){const K=await this.o.$save(W,{saveAs:!1});return a.URI.revive(K)}async saveAs(W){const K=await this.o.$save(W,{saveAs:!0});return a.URI.revive(K)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}lookupAuthorization(W){return this.o.$lookupAuthorization(W)}lookupKerberosAuthorization(W){return this.o.$lookupKerberosAuthorization(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,K){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,K);const L=this.t.transformOutgoingScheme(W),Q=this.A++;return this.o.$registerEditSessionIdentityProvider(Q,L),(0,T.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(Q)})}async $getEditSessionIdentifier(W,K){this.h.info("Getting edit session identifier for workspaceFolder",W);const L=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const Q=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!Q),!Q)return;const X=await Q.provideEditSessionIdentity(L,K);if(this.h.info("Provider returned edit session identifier: ",X),!!X)return X}async $provideEditSessionIdentityMatch(W,K,L,Q){this.h.info("Getting edit session identifier for workspaceFolder",W);const X=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!X){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",X);const ue=this.w.get(X.uri.scheme);if(this.h.info(`Provider for scheme ${X.uri.scheme} is defined: `,!!ue),!ue)return;const ee=await ue.provideEditSessionIdentityMatch?.(K,L,Q);if(this.h.info("Provider returned edit session identifier match result: ",ee),!!ee)return ee}getOnWillCreateEditSessionIdentityEvent(W){return(K,L,Q)=>{const X=function(ee){K.call(L,ee)};return X.extension=W,this.B.event(X,void 0,Q)}}async $onWillCreateEditSessionIdentity(W,K,L){const Q=await this.resolveWorkspaceFolder(a.URI.revive(W));if(Q===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:Q},K,async(X,ue)=>{const ee=Date.now();await Promise.resolve(X),Date.now()-ee>L&&this.h.warn("SLOW edit session create-participant",ue.extension.identifier)}),K.isCancellationRequested}registerCanonicalUriProvider(W,K){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,K);const L=this.t.transformOutgoingScheme(W),Q=this.A++;return this.o.$registerCanonicalUriProvider(Q,L),(0,T.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(Q)})}async provideCanonicalUri(W,K,L){const Q=this.C.get(W.scheme);if(!Q)return;const X=await Q.provideCanonicalUri?.(a.URI.revive(W),K,L);if(X)return X}async $provideCanonicalUri(W,K,L){return this.provideCanonicalUri(a.URI.revive(W),{targetScheme:K},L)}};e.$Bpc=M,e.$Bpc=M=Je([Ve(0,t.$hQ),Ve(1,n.$xQ),Ve(2,i.$kpc),Ve(3,o.$_j),Ve(4,m.$zpc)],M),e.$Cpc=(0,r.$Ei)("IExtHostWorkspace");function N(F){let W,K;return F&&(typeof F=="string"?W=F:(W=F.pattern,K=a.URI.revive(F.baseUri))),{includePattern:W,folder:K}}}),define(Oe[46],Ne([1,0,25,6,45,5,7,43,174,53,14,10,3,16,11,2]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=e.$Epc=e.$Dpc=void 0;function o(m,p){if(p){const h=p.split(".");let E=m;for(let D=0;E&&D<h.length;D++)E=E[h[D]];return E}}function c(m){return m instanceof r.URI}function l(m){return m&&m.uri instanceof r.URI&&m.languageId&&typeof m.languageId=="string"}function i(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function n(m){return m&&m.uri instanceof r.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function t(m){if(c(m))return{resource:m};if(l(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(i(m))return{overrideIdentifier:m.languageId};if(n(m))return{resource:m.uri};if(m===null)return{resource:null}}let g=class{constructor(p,h,E){this.a=p.getProxy(O.$HN.MainThreadConfiguration),this.c=h,this.b=E,this.d=new y.$Dh,this.e=null}getConfigProvider(){return this.d.wait().then(p=>this.e)}$initializeConfiguration(p){this.e=new u(this.a,this.c,p,this.b),this.d.open()}$acceptConfigurationChanged(p,h){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(p,h))}};e.$Dpc=g,e.$Dpc=g=Je([Ve(0,S.$hQ),Ve(1,P.$Cpc),Ve(2,d.$_j)],g);class u{constructor(p,h,E,D){this.a=new R.$le,this.b=p,this.f=D,this.c=h,this.e=$.$Qo.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(p,h){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Qo.parse(p,this.f),this.d=this.k(p.configurationScopes),this.a.fire(this.j(h,E))}getConfiguration(p,h,E){const D=t(h)||{},w=this.g(p?o(this.e.getValue(void 0,D,this.c.workspace),p):this.e.getValue(void 0,D,this.c.workspace));p&&this.h(p,D,E?.identifier);function I(f){if(f==null)return null;if(typeof f=="boolean")return f?A.ConfigurationTarget.USER:A.ConfigurationTarget.WORKSPACE;switch(f){case T.ConfigurationTarget.Global:return A.ConfigurationTarget.USER;case T.ConfigurationTarget.Workspace:return A.ConfigurationTarget.WORKSPACE;case T.ConfigurationTarget.WorkspaceFolder:return A.ConfigurationTarget.WORKSPACE_FOLDER}}const C={has(f){return typeof o(w,f)<"u"},get:(f,b)=>{this.h(p?`${p}.${f}`:f,D,E?.identifier);let M=o(w,f);if(typeof M>"u")M=b;else{let N;const F=(W,K)=>{if((0,k.$gg)(W)){let L;const Q=()=>{N=N||(0,v.$do)(w),L=L||o(N,K)};return new Proxy(W,{get:(X,ue)=>{if(typeof ue=="string"&&ue.toLowerCase()==="tojson")return Q(),()=>L;if(N)return L=L||o(N,K),L[ue];const ee=X[ue];return typeof ue=="string"?F(ee,`${K}.${ue}`):ee},set:(X,ue,ee)=>(Q(),L&&(L[ue]=ee),!0),deleteProperty:(X,ue)=>(Q(),L&&delete L[ue],!0),defineProperty:(X,ue,ee)=>(Q(),L&&Object.defineProperty(L,ue,ee),!0)})}return Array.isArray(W)?(0,v.$do)(W):W};M=F(M,f)}return M},update:(f,b,M,N)=>{f=p?`${p}.${f}`:f;const F=I(M);return b!==void 0?this.b.$updateConfigurationOption(F,f,b,D,N):this.b.$removeConfigurationOption(F,f,D,N)},inspect:f=>{f=p?`${p}.${f}`:f;const b=this.e.inspect(f,D,this.c.workspace);if(b)return{key:f,defaultValue:(0,v.$do)(b.policy?.value??b.default?.value),globalValue:(0,v.$do)(b.user?.value??b.application?.value),workspaceValue:(0,v.$do)(b.workspace?.value),workspaceFolderValue:(0,v.$do)(b.workspaceFolder?.value),defaultLanguageValue:(0,v.$do)(b.default?.override),globalLanguageValue:(0,v.$do)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,v.$do)(b.workspace?.override),workspaceFolderLanguageValue:(0,v.$do)(b.workspaceFolder?.override),languageIds:(0,v.$do)(b.overrideIdentifiers)}}};return typeof w=="object"&&(0,v.$go)(C,w,!1),Object.freeze(C)}g(p){const h=E=>(0,k.$gg)(E)?new Proxy(E,{get:(D,w)=>h(D[w]),set:(D,w,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(D,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(D,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return h(p)}h(p,h,E){const D=s.$Fo.test(p)?s.ConfigurationScope.RESOURCE:this.d.get(p),w=E?`[${E.value}] `:"";if(s.ConfigurationScope.RESOURCE===D){typeof h?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${p}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===D){h?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${p}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(p,h){const E=new $.$So(p,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,w)=>E.affectsConfiguration(D,t(w))})}k(p){return p.reduce((h,E)=>(h.set(E[0],E[1]),h),new Map)}}e.$Epc=u,e.$Fpc=(0,a.$Ei)("IExtHostConfiguration")}),define(Oe[131],Ne([1,0,2,10,6,5,7,45,57,46,21,56,16,26,3,15,20,11,84,209,13]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=e.$crc=e.$brc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,T=We(T),o=We(o);var t;(function(N){function F(K){if(K!=null)return K}N.from=F;function W(K){if(K!=null)return K}N.to=W})(t||(t={}));var g;(function(N){function F(K){if(K!=null)return K}N.from=F;function W(K){if(K!=null)return K}N.to=W})(g||(g={}));var u;(function(N){function F(K){if(K!=null)return K}N.from=F;function W(K){if(K!=null)return K}N.to=W})(u||(u={}));var m;(function(N){function F(L){if(L){const Q=L;return Q&&!!Q.process}else return!1}N.is=F;function W(L){if(L==null)return;const Q={process:L.process,args:L.args};return L.options&&(Q.options=u.from(L.options)),Q}N.from=W;function K(L){if(L!=null)return new T.$vO(L.process,L.args,L.options)}N.to=K})(m||(m={}));var p;(function(N){function F(K){if(K!=null)return K}N.from=F;function W(K){if(K!=null)return K}N.to=W})(p||(p={}));var h;(function(N){function F(L){if(L){const Q=L;return Q&&(!!Q.commandLine||!!Q.command)}else return!1}N.is=F;function W(L){if(L==null)return;const Q={};return L.commandLine!==void 0?Q.commandLine=L.commandLine:(Q.command=L.command,Q.args=L.args),L.options&&(Q.options=p.from(L.options)),Q}N.from=W;function K(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new T.$wO(L.commandLine,L.options):new T.$wO(L.command,L.args?L.args:[],L.options)}N.to=K})(h||(h={}));var E;(function(N){function F(L){if(L){const Q=L;return Q&&Q.customExecution==="customExecution"}else return!1}N.is=F;function W(L){return{customExecution:"customExecution"}}N.from=W;function K(L,Q){return Q.get(L)}N.to=K})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function F(W,K){let L;return W.scope!==void 0&&typeof W.scope!="number"?L=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===T.TaskScope.Workspace&&K&&K.workspaceFile?L=K.workspaceFile:L=i.$TI),{id:W._id,workspaceFolder:L}}N.from=F})(D||(e.TaskHandleDTO=D={}));var w;(function(N){function F(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}N.from=F})(w||(w={}));var I;(function(N){function F(L,Q){if(L==null)return[];const X=[];for(const ue of L){const ee=W(ue,Q);ee&&X.push(ee)}return X}N.fromMany=F;function W(L,Q){if(L==null)return;let X;L.execution instanceof T.$vO?X=m.from(L.execution):L.execution instanceof T.$wO?X=h.from(L.execution):L.execution&&L.execution instanceof T.$xO&&(X=E.from(L.execution));const ue=t.from(L.definition);let ee;return L.scope?typeof L.scope=="number"?ee=L.scope:ee=L.scope.uri:ee=T.TaskScope.Workspace,!ue||!ee?void 0:{_id:L._id,definition:ue,name:L.name,source:{extensionId:Q.identifier.value,label:L.source,scope:ee},execution:X,isBackground:L.isBackground,group:w.from(L.group),presentationOptions:g.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}N.from=W;async function K(L,Q,X){if(L==null)return;let ue;m.is(L.execution)?ue=m.to(L.execution):h.is(L.execution)?ue=h.to(L.execution):E.is(L.execution)&&(ue=E.to(L._id,X));const ee=t.to(L.definition);let me;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?me=L.source.scope:me=await Q.resolveWorkspaceFolder(v.URI.revive(L.source.scope)):me=T.TaskScope.Workspace),!ee||!me)return;const oe=new T.$yO(ee,me,L.name,L.source.label,ue,L.problemMatchers);return L.isBackground!==void 0&&(oe.isBackground=L.isBackground),L.group!==void 0&&(oe.group=T.$uO.from(L.group._id),oe.group&&L.group.isDefault&&(oe.group=new T.$uO(oe.group.id,oe.group.label),L.group.isDefault===!0&&(oe.group.isDefault=L.group.isDefault))),L.presentationOptions&&(oe.presentationOptions=g.to(L.presentationOptions)),L._id&&(oe._id=L._id),L.detail&&(oe.detail=L.detail),oe}N.to=K})(I||(e.TaskDTO=I={}));var C;(function(N){function F(K){return K}N.from=F;function W(K){if(K)return Object.assign(Object.create(null),K)}N.to=W})(C||(C={}));class f{#e;constructor(F,W,K){this._id=W,this.a=K,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let b=class{constructor(F,W,K,L,Q,X,ue,ee){this.q=new P.$le,this.r=new P.$le,this.s=new P.$le,this.u=new P.$le,this.a=F.getProxy(O.$HN.MainThreadTask),this.b=K,this.c=L,this.d=Q,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,W,K){if(!K)return new T.$JN(()=>{});const L=this.x();return this.j.set(L,{type:W,provider:K,extension:F}),this.a.$registerTaskProvider(L,W),new T.$JN(()=>{this.j.delete(L),this.a.$unregisterTaskProvider(L)})}registerTaskSystem(F,W){this.a.$registerTaskSystem(F,W)}fetchTasks(F){return this.a.$fetchTasks(C.from(F)).then(async W=>{const K=[];for(const L of W){const Q=await I.to(L,this.b,this.m);Q&&K.push(Q)}return K})}get taskExecutions(){const F=[];return this.k.forEach(W=>F.push(W)),F}terminateTask(F){if(!(F instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,W,K){const L=this.m.get(F.id);L&&(this.o.set(F.id,L),this.e.attachPtyToTerminal(W,await L.callback(K))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const W=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const W=await this.z(F.id);this.s.fire({execution:W,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const W=await this.z(F.id);this.u.fire({execution:W,exitCode:F.exitCode})}$provideTasks(F,W){const K=this.j.get(F);if(!K)return Promise.reject(new Error("no handler found"));const L=[],Q=(0,R.$wh)(()=>K.provider.provideTasks(k.CancellationToken.None)).then(X=>this.v(W,L,K,X));return new Promise(X=>{Q.then(ue=>{Promise.all(L).then(()=>{X(ue)})})})}async $resolveTask(F,W){const K=this.j.get(F);if(!K)return Promise.reject(new Error("no handler found"));if(W.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${K.type}].`);const L=await I.to(W,this.b,this.m);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const Q=await K.provider.resolveTask(L,k.CancellationToken.None);if(!Q)return;this.A(Q,K);const X=I.from(Q,K.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(Q.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(X.execution)&&await this.y(X,Q,!0),await this.w(X)}x(){return this.h++}async y(F,W,K){const L=await this.a.$createTaskId(F);!K&&!this.m.has(L)&&(this.n.add(L),this.o.set(L,W.execution)),this.m.set(L,W.execution)}async z(F,W){if(typeof F=="string"){const Q=this.l.get(F);if(!Q)throw new n.$ab("Unexpected: The specified task is missing an execution");return Q}const K=this.l.get(F.id);if(K)return K;let L;return W?L=Promise.resolve(new f(this,F.id,W)):L=I.to(F.task,this.b,this.m).then(Q=>{if(!Q)throw new n.$ab("Unexpected: Task does not exist.");return new f(this,F.id,Q)}),this.l.set(F.id,L),L.then(Q=>(this.k.set(F.id,Q),Q))}A(F,W){F._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const K=this.n.values();let L=K.next();for(;!L.done;)!this.o.has(L.value)&&this.p!==L.value&&(this.m.delete(L.value),this.n.delete(L.value)),L=K.next()}};e.$brc=b,e.$brc=b=Je([Ve(0,a.$hQ),Ve(1,S.$xQ),Ve(2,A.$Cpc),Ve(3,$.$sQ),Ve(4,s.$Fpc),Ve(5,y.$4pc),Ve(6,c.$_j),Ve(7,l.$gpc)],b);let M=class extends b{constructor(F,W,K,L,Q,X,ue,ee){super(F,W,K,L,Q,X,ue,ee),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$i(o.Platform.Web)})}async executeTask(F,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const K=I.from(W,F);if(K===void 0)throw new Error("Task is not valid");if(E.is(K.execution))await this.y(K,W,!1);else throw new n.$$;const L=await this.z(await this.a.$getTaskExecution(K),W);return this.a.$executeTask(K).catch(Q=>{throw new Error(Q)}),L}v(F,W,K,L){const Q=[];if(L)for(const X of L){if(this.A(X,K),!X.definition||!F[X.definition.type]){const ee=X.source?X.source:"No task source";this.f.warn(`The task [${ee}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=I.from(X,K.extension);ue&&E.is(ue.execution)?(Q.push(ue),W.push(this.y(ue,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Q,extension:K.extension}}async w(F){if(E.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,W,K){}};e.$crc=M,e.$crc=M=Je([Ve(0,a.$hQ),Ve(1,S.$xQ),Ve(2,A.$Cpc),Ve(3,$.$sQ),Ve(4,s.$Fpc),Ve(5,y.$4pc),Ve(6,c.$_j),Ve(7,l.$gpc)],M),e.$drc=(0,d.$Ei)("IExtHostTask")}),define(Oe[268],Ne([1,0,44,32]),function(be,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=void 0,e.$tM=P,e.$vM=O;function P(T){return"cellResults"in T}e.$uM="rawCell#";function O(T,A){let $=-1;const s=[];let k=[];return T.forEach(a=>{a.range.startLineNumber!==$&&k.length>0&&(s.push([...k]),k=[]),k.push(a),$=a.range.endLineNumber}),k.length>0&&s.push([...k]),s.map(a=>{const S=[],d=a[0].range.startLineNumber,r=a[a.length-1].range.endLineNumber;for(let o=d;o<=r;o++)S.push(A.getLineContent(o));return new v.$0L(S.join(`
`)+`
`,a.map(o=>new R.$Nt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Oe[269],Ne([1,0,9,22,6,4,28,36,12,14,2,29,79,5,33,8,7,38,246,124,25,15,44,199,268,266]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0,y=We(y),r=We(r),o=We(o);class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,w,I,C,f,b,M){this.q=I,this.r=C,this.s=f,this.t=b,this.u=M,this.f=new Map,this.g=new T.$Ac,this.h=new Map,this.j=new P.$le,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$le,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$le,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$le,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new a.$epc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(S.$HN.MainThreadNotebook),this.c=D.getProxy(S.$HN.MainThreadNotebookDocuments),this.d=D.getProxy(S.$HN.MainThreadNotebookEditors),this.i=w.converter,w.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===A.MarshalledId.NotebookCellActionContext){const F=N.notebookEditor?.notebookUri,W=N.cell.handle,L=this.g.get(F)?.getCell(W);if(L)return L.apiCell}if(N&&N.$mid===A.MarshalledId.NotebookActionContext){const F=N.uri,W=this.g.get(F);if(W)return W.apiNotebook}return N}}),h.C(w)}getEditorById(D){const w=this.h.get(D);if(!w)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return w}getIdByEditor(D){for(const[w,I]of this.h)if(I.apiEditor===D)return w}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,w){const I=this.g.get(D);if(!I&&!w)throw new Error(`NO notebook document for '${D}'`);return I}static w(D,w){if(!w)return;const I=w.filenamePattern.map(C=>r.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(w.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:w.displayName,filenamePattern:I,priority:w.exclusive?p.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,w,I){const C=h.a++,f=typeof I.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(C,I),this.b.$registerNotebookCellStatusBarItemProvider(C,f,w);let b;return f!==void 0&&(b=I.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(f))),new o.$JN(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,f),b?.dispose()})}async createNotebookDocument(D){const w=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&r.NotebookData.from(D.content)});return k.URI.revive(w)}async openNotebookDocument(D){const w=this.g.get(D);if(w)return w.apiNotebook;const I=await this.c.$tryOpenNotebook(D),C=this.g.get(k.URI.revive(I));return(0,s.$pg)(C?.apiNotebook)}async showNotebookDocument(D,w){k.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let I;typeof w=="object"?I={position:r.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(r.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:I={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,I),f=C&&this.h.get(C)?.apiEditor;if(f)return f;throw C?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,w,I,C){const f=this.f.get(D),b=k.URI.revive(w),M=this.g.get(b);if(!M||!f)return;const N=M.getCellFromIndex(I);if(!N)return;const F=await f.provideCellStatusBarItems(N.apiCell,C);if(!F)return;const W=new O.$Tc,K=this.p.add([W]),Q=(Array.isArray(F)?F:[F]).map(X=>r.NotebookStatusBarItem.from(X,this.i,W));return{cacheId:K,items:Q}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,w,I,C,f){if((0,$.$cf)(w))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:w,serializer:I,options:C}),this.b.$registerNotebookSerializer(b,{id:D.identifier,location:D.extensionLocation},w,r.NotebookDocumentContentOptions.from(C),h.w(D,f)),(0,O.$Sc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(D,w,I){const C=this.y.get(D);if(!C)throw new Error("NO serializer found");const f=await C.serializer.deserializeNotebook(w.buffer,I);return new c.$Ww(r.NotebookData.from(f))}async $notebookToData(D,w,I){const C=this.y.get(D);if(!C)throw new Error("NO serializer found");const f=await C.serializer.serializeNotebook(r.NotebookData.to(w.value),I);return R.$Ne.wrap(f)}async $saveNotebook(D,w,I,C,f){const b=k.URI.revive(w),M=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${I}, ${b.toString()})`),!M)throw new Error("NO serializer found");const N=this.g.get(b);if(!N)throw new Error("Document NOT found");if(N.versionId!==I)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new y.$ul((0,v.localize)(10781,null,this.A(b)),y.FileOperationResult.FILE_PERMISSION_DENIED);const F={metadata:(0,n.$lo)(N.apiNotebook.metadata,X=>!(M.options?.transientDocumentMetadata??{})[X]),cells:[]};for(const X of N.apiNotebook.getCells()){const ue=new o.$cP(X.kind,X.document.getText(),X.document.languageId,X.mime,M.options?.transientOutputs?[]:[...X.outputs],X.metadata,X.executionSummary);ue.metadata=(0,n.$lo)(X.metadata,ee=>!(M.options?.transientCellMetadata??{})[ee]),F.cells.push(ue)}if(await this.z(b,C),f.isCancellationRequested)throw new Error("canceled");const W=await M.serializer.serializeNotebook(F,f);if(f.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${I} ${b.toString()}`),await this.s.value.writeFile(b,W),this.D(`Finished write versionId: ${I} ${b.toString()}`);const K=this.s.getFileSystemProviderExtUri(b.scheme),L=await this.s.value.stat(b),Q={name:K.basename(b),isFile:(L.type&y.FileType.File)!==0,isDirectory:(L.type&y.FileType.Directory)!==0,isSymbolicLink:(L.type&y.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((L.permissions??0)&y.FilePermission.Locked),etag:y.$Fl({mtime:L.mtime,size:L.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${I}, ${b.toString()})`),Q}async $searchInNotebooks(D,w,I,C,f){const b=this.y.get(D)?.serializer;if(!b)return{limitHit:!1,results:[]};const M=new T.$Bc;await(async(L,Q,X)=>{await Promise.all(L.map(async ue=>await Promise.all(ue.filenamePatterns.map(ee=>{const me={_reason:X._reason,folderQueries:X.folderQueries,includePattern:X.includePattern,excludePattern:X.excludePattern,maxResults:X.maxResults,type:g.QueryType.File,filePattern:ee};return this.t.doInternalFileSearchWithCustomCallback(me,Q,oe=>{oe.forEach(ce=>{M.has(ce)||C.some(ae=>ue.isFromSettings&&!ae.isFromSettings?!1:ae.filenamePatterns.some(Ie=>(0,p.$oL)(Ie,ce)))||M.add(ce)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(I,f,w);const F=new T.$Ac;let W=!1;const K=Array.from(M).map(async L=>{const Q=[];try{if(f.isCancellationRequested)return;if(w.maxResults&&[...F.values()].reduce((me,oe)=>me+oe.cellResults.length,0)>w.maxResults){W=!0;return}const X=[],ue=this.g.get(L);if(ue)ue.apiNotebook.getCells().forEach(oe=>X.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(ce=>ce.items.map(we=>we.data.toString()))}));else{const me=await this.s.value.readFile(L),oe=R.$Ne.fromString(me.toString()),ce=await b.deserializeNotebook(oe.buffer,f);if(f.isCancellationRequested)return;r.NotebookData.from(ce).cells.forEach(ae=>X.push({input:ae.source,outputs:ae.outputs.flatMap(Ie=>Ie.items.map(Fe=>Fe.valueBytes.toString()))}))}if(f.isCancellationRequested)return;X.forEach((me,oe)=>{const ce=w.contentPattern.pattern,we=new u.$d1b(me.input,void 0,me.outputs),ae=we.findInInputs(ce),Ie=we.findInOutputs(ce),Fe=Ie.flatMap(Y=>(0,m.$vM)(Y.matches,Y.textBuffer)).map((Y,q)=>(Y.webviewIndex=q,Y));if(ae.length>0||Ie.length>0){const Y={index:oe,contentResults:(0,m.$vM)(ae,we.inputTextBuffer),webviewResults:Fe};Q.push(Y)}});const ee={resource:L,cellResults:Q};F.set(L,ee);return}catch{return}});return await Promise.all(K),{limitHit:W,results:[...F.values()]}}async z(D,w){const I=await this.s.value.stat(D);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==y.$El&&typeof I.mtime=="number"&&typeof I.size=="number"&&w.mtime<I.mtime&&w.etag!==y.$Fl({mtime:w.mtime,size:I.size}))throw new y.$ul((0,v.localize)(10782,null),y.FileOperationResult.FILE_MODIFIED_SINCE,w)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,w,I){if(this.h.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const C=new i.$Gqc(w,this.d,D,I.visibleRanges.map(r.NotebookRange.to),I.selections.map(r.NotebookRange.to),typeof I.viewColumn=="number"?r.ViewColumn.to(I.viewColumn):void 0);this.h.set(w,C)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const I of D.value.removedDocuments){const C=k.URI.revive(I),f=this.g.get(C);f&&(f.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(f.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===C.toString()&&this.h.delete(b.id)}if(D.value.addedDocuments){const I=[];for(const C of D.value.addedDocuments){const f=k.URI.revive(C.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const b=new l.$Fqc(this.c,this.q,this.r,f,C);I.push(...C.cells.map(M=>l.$Eqc.asModelAddData(M))),this.g.get(f)?.dispose(),this.g.set(f,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this.m.fire(b.apiNotebook)}}if(D.value.addedEditors)for(const I of D.value.addedEditors){if(this.h.has(I.id))return;const C=k.URI.revive(I.documentUri),f=this.g.get(C);f&&this.B(f,I.id,I)}const w=[];if(D.value.removedEditors)for(const I of D.value.removedEditors){const C=this.h.get(I);C&&(this.h.delete(I),this.k?.id===C.id&&(this.k=void 0),w.push(C))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const I=new Set;this.l.forEach(C=>I.add(C.id));for(const C of this.h.values()){const f=I.has(C.id);C._acceptVisibility(f)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const w=d.$FQ.String.with("notebookType","A notebook type"),I=new d.$HQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new d.$FQ("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>R.$Ne.wrap(f))],new d.$GQ("Notebook Data",f=>r.NotebookData.to(f.value))),C=new d.$HQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new d.$FQ("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new c.$Ww(r.NotebookData.from(f)))],new d.$GQ("Bytes",f=>f.buffer));D.registerApiCommand(I),D.registerApiCommand(C)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Pqc=h}),define(Oe[270],Ne([1,0,19,21,42,41,23,69,44]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=void 0,v=We(v),O=We(O),T=We(T);class s{constructor(a,S,d){this.k=a,this.l=S,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&O.$zk(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&O.$zk(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const S=this.k.folderQueries||[];return new Promise((d,r)=>{const o=c=>{this.f++,a(c)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const l=c.toString(),i=v.$nc(l);this.j&&this.j(l,i)||this.v(o,{base:c,basename:i})}),Promise.all(S.map(c=>this.p(c,o))).then(c=>{d({limitHit:this.e,stats:c[0]||void 0})},c=>{r(new Error((0,P.$pj)(c)))})})}async p(a,S){const d=new R.$we,r=this.q(a),o=this.r(),c=new $.$lM(this.k,a),l=!c.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=A.$fe.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),t=i.elapsed(),g=A.$fe.create();return this.g&&!this.e||(n&&n.forEach(u=>{const m=v.$gc.relative(a.folder.path,u.path);if(l){const p=v.$nc(u.path);this.v(S,{base:a.folder,relativePath:m,basename:p});return}this.s(o,a.folder,m,S)}),this.g&&!this.e)?null:(this.u(o,c,S),{providerTime:t,postProcessTime:g.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(a){const S=(0,$.$kM)(this.k.includePattern,a.includePattern),d=(0,$.$kM)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:d,includes:S,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},S,d,r){if(d===this.a){const c=v.$nc(this.a);this.v(r,{base:S,relativePath:this.a,basename:c})}function o(c){const l=v.$nc(c),i=v.$mc(c);let n=a[i];n||(n=a[i]=[],o(i)),n.push({base:S,relativePath:c,basename:l})}o(d)}u({rootEntries:a,pathToEntries:S},d,r){const o=this,c=this.a;function l(i){const n=(0,$.$nM)(()=>i.map(t=>t.basename));for(let t=0,g=i.length;t<g;t++){const u=i[t],{relativePath:m,basename:p}=u;if(d.matchesExcludesSync(m,p,c!==p?n:void 0))continue;const h=S[m];if(h)l(h);else{if(m===c)continue;o.v(r,u)}if(o.e)break}}l(a)}v(a,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(S))}}class k{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,S,d,r){const o=this.c(a.cacheKey),c=new s(a,S,o&&o.token);let l=0;const i=n=>{l+=n.length,d(n.map(t=>this.d(t)))};return this.e(c,k.a,i,r).then(n=>({limitHit:n.limitHit,stats:n.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:n.stats}:void 0,messages:[]}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new R.$we),this.b.get(a)}d(a){return a.relativePath?{resource:T.$fh(a.base,a.relativePath)}:{resource:a.base}}e(a,S,d,r){const o=r.onCancellationRequested(()=>{a.cancel()}),c=i=>{i&&(l.push(i),S>0&&l.length>=S&&(d(l),l=[]))};let l=[];return a.search(c).then(i=>(l.length&&d(l),o.dispose(),i),i=>(l.length&&d(l),o.dispose(),Promise.reject(i)))}}e.$Hqc=k}),define(Oe[271],Ne([1,0,17,240,41,99,28,15,19,23,12,14,2,102,9,43,11,49,118,267,44]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0,e.$mN=w,v=We(v),R=We(R),P=We(P),$=We($),k=We(k),d=We(d);let t=class{constructor(C,f,b,M,N){this.a=C,this.b=f,this.c=b,this.d=M,this.e=N}text(C,f,b={}){C=this.f(C,b);const M=this.a.getValue(),N=f&&f.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(f?.map(c.$Zi),b),type:n.QueryType.Text,contentPattern:C,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:M.search.usePCRE2||N||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}f(C,f){const b=this.a.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const M={...C,wordSeparators:b.editor.wordSeparators};return this.j(C,f)&&(M.isCaseSensitive=!0),this.k(C)&&(M.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),M}file(C,f={}){return{...this.h(C,f),type:n.QueryType.File,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey,shouldGlobMatchFilePattern:f.shouldGlobSearch}}g(C,f){return C?(C=Array.isArray(C)?C.map(h):h(C),f?this.parseSearchPaths(C):{pattern:u(...Array.isArray(C)?C:[C])}):{}}h(C=[],f={}){const b=this.g(f.includePattern,f.expandPatterns),M=this.g(f.excludePattern,f.expandPatterns),N=C.length>1,F=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(L=>this.q(L,f,M)):C.map(L=>this.r(L,f,M,N))).filter(L=>!!L),W={_reason:f._reason,folderQueries:F,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:M.pattern,includePattern:b.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const L=v.$Gb(this.c.groups.flatMap(ue=>ue.editors.map(ee=>ee.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const Q=L.filter(ue=>(0,n.$bM)(W,ue.fsPath)),X=this.i(Q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...W,...X}}const K=f.extraFileResources&&f.extraFileResources.filter(L=>(0,n.$bM)(W,L.fsPath));return W.extraFileResources=K&&K.length?K:void 0,W}i(C){const f=[],b=new T.$Ac,M={};let N=!1;return C.forEach(F=>{if(F.scheme===A.Schemas.walkThrough)return;if((0,s.$jh)(F)){const K=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$mc(F.fsPath)});let L=b.get(K);L||(N=!0,L={folder:K,includePattern:{}},f.push(L),b.set(K,L));const Q=$.$lc(K.fsPath,F.fsPath);(0,y.$pg)(L.includePattern)[Q.replace(/\\/g,"/")]=!0}else F.fsPath&&(N=!0,M[F.fsPath]=!0)}),{folderQueries:f,includePattern:M,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(C,f){if(f.isSmartCase){if(C.isRegExp){if(k.$8f(C.pattern,!0))return!0}else if(k.$8f(C.pattern))return!0}return!!C.isCaseSensitive}k(C){return C.isMultiline||C.isRegExp&&(0,S.$kD)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const f=X=>$.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),M=(Array.isArray(C)?C:m(C)).map(X=>{const ue=this.e.resolvedUserHome;return ue?(0,O.$2w)(X,ue.scheme===A.Schemas.file?ue.fsPath:ue.path):X}),N=R.$c(M,X=>f(X)?"searchPaths":"exprSegments"),F=(N.exprSegments||[]).map(X=>k.$nf(X,"/")).map(X=>k.$nf(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),p(X))),W={},K=this.m(N.searchPaths||[]);K&&K.length&&(W.searchPaths=K);const L=F.flat(),Q=u(...L);return Q&&(W.pattern=Q),W}l(C,f){return f.disregardExcludeSettings?void 0:(0,n.$aM)(C,!f.disregardSearchExcludeSettings)}m(C){if(!C||!C.length)return[];const f=C.flatMap(M=>{let{pathPortion:N,globPortion:F}=g(M);return F&&(F=E(F)),this.n(N).flatMap(K=>this.o(K,F))}),b=new Map;return f.forEach(M=>{const N=M.searchPath.toString(),F=b.get(N);F?M.pattern&&(F.pattern=F.pattern||{},F.pattern[M.pattern]=!0):b.set(N,{searchPath:M.searchPath,pattern:M.pattern?u(M.pattern):void 0})}),Array.from(b.values())}n(C){if($.$ic(C)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==A.Schemas.file?[{searchPath:f[0].uri.with({path:C})}]:[{searchPath:a.URI.file($.$hc(C))}]}if(this.b.getWorkbenchState()===c.WorkbenchState.FOLDER){const f=this.b.getWorkspace().folders[0].uri;if(C=h(C),C.startsWith("../")||C===".."){const M=$.$gc.resolve(f.path,C);return[{searchPath:f.with({path:M})}]}const b=E(C);return[{searchPath:f,pattern:b}]}else{if(C==="./"||C===".\\")return[];{const f=C.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(N=>{const F=f.match(new RegExp(`^${k.$hf(N.name)}(?:/(.*)|$)`));return F?{match:F,folder:N}:null}).filter(y.$mg);if(M.length)return M.map(N=>{const F=N.match[1];return{searchPath:N.folder.uri,pattern:F&&E(F)}});{const N=C.match(/\.[\/\\](.+)[\/\\]?/),F=N?N[1]:C,W=d.localize(1621,null,F);throw new Error(W)}}}}o(C,f){const b=C.pattern&&f?`${C.pattern}/${f}`:C.pattern||f,M=[{searchPath:C.searchPath,pattern:b}];return b&&!b.endsWith("**")&&M.push({searchPath:C.searchPath,pattern:b+"/**"}),M}q(C,f,b){const M=this.r((0,c.$Zi)(C.searchPath),f,b,!1);return M?{...M,includePattern:C.pattern}:null}r(C,f,b,M){let N;const F=a.URI.isUri(C)?C:C.uri;if(b.searchPaths){const X=b.searchPaths.filter(ue=>(0,s.$$g)(ue.searchPath,F))[0];if(X&&!X.pattern)return null;X&&(N=X.pattern)}const W=this.a.getValue({resource:F}),L={...this.l(W,f)||{},...N||{}},Q=a.URI.isUri(C)?(0,s.$ch)(C):C.name;return{folder:F,folderName:M?Q:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!W.search.followSymlinks}}};e.$lN=t,e.$lN=t=Je([Ve(0,r.$$i),Ve(1,c.$Ni),Ve(2,l.$sE),Ve(3,o.$_j),Ve(4,i.$jN)],t);function g(I){const C=I.match(/[\*\{\}\(\)\[\]\?]/);if(C){const f=C.index,b=I.substr(0,f).match(/[/|\\][^/\\]*$/);if(b){let M=I.substr(0,b.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:I.substr((b.index||0)+1)}}}return{pathPortion:I}}function u(...I){return I.length?I.reduce((C,f)=>(C[f]=!0,C),Object.create(null)):void 0}function m(I){return P.$xk(I,",").map(C=>C.trim()).filter(C=>!!C.length)}function p(I){return[`**/${I}/**`,`**/${I}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function h(I){return I.replace(/\\/g,"/")}function E(I){return h(I).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(I){return I.replace(/([?*[\]])/g,"[$1]")}function w(I,C){I=v.$Lb(I,M=>M.toString());const f=[],b=C.getWorkspace();return I&&I.forEach(M=>{let N;if(C.getWorkbenchState()===c.WorkbenchState.FOLDER)N=(0,s.$hh)(b.folders[0].uri,M),N&&N!=="."&&(N="./"+N);else{const F=C.getWorkspaceFolder(M);if(F){const W=F.name;if(b.folders.filter(L=>L.name===W).length===1){const L=(0,s.$hh)(F.uri,M);L===""?N=`./${F.name}`:N=`./${F.name}/${L}`}else N=M.fsPath}}N&&f.push(D(N))}),f}}),define(Oe[272],Ne([1,0,23,2,21,13,3,271,44,49,10]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yyb=a,e.$zyb=r,v=We(v),O=We(O);const y=7e3;function a(o,c){const l=c.activationEvents;if(!l)return Promise.resolve(void 0);const i=[],n=[];for(const h of l)if(/^workspaceContains:/.test(h)){const E=h.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||o.forceUsingSearch?n.push(E):i.push(E)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:g}=(0,k.$xh)(),u=h=>g({activationEvent:h}),m=Promise.all(i.map(h=>S(o,h,u))).then(()=>{}),p=d(o,c.identifier,n,u);return Promise.all([m,p]).then(()=>{g(void 0)}),t}async function S(o,c,l){for(const i of o.folders)if(await o.exists(v.$fh(R.URI.revive(i),c))){l(`workspaceContains:${c}`);return}}async function d(o,c,l,i){if(l.length===0)return Promise.resolve(void 0);const n=new P.$we,t=o.checkExists(o.folders,l,n.token),g=setTimeout(async()=>{n.cancel(),o.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},y);let u=!1;try{u=await t}catch(m){O.$3(m)||O.$Y(m)}n.dispose(),clearTimeout(g),u&&i(`workspaceContains:${l.join(",")}`)}function r(o,c,l,i){const n=o.get(T.$Di),t=o.get($.$5L),u=n.createInstance(A.$lN).file(c.map(m=>(0,s.$Zi)(R.URI.revive(m))),{_reason:"checkExists",includePattern:l,exists:!0});return t.fileSearch(u,i).then(m=>!!m.limitHit,m=>O.$3(m)?!1:Promise.reject(m))}}),define(Oe[47],Ne([1,0,9,19,64,23,10,4,58,2,11,5,46,206,88,45,24,119,13,18,22,189,7,109,3,26,91,16,74,92,56,94,6,272,87,191,15,85,69,20,86]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u,m,p,h,E,D,w,I,C,f,b,M,N,F,W,K,L,Q){"use strict";var X;Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=e.$hqc=e.$gqc=e.$fqc=e.$eqc=void 0,v=We(v),R=We(R),P=We(P),l=We(l),e.$eqc=(0,m.$Ei)("IHostUtils");let ue=X=class extends A.$Uc{constructor(Y,q,ne,ye,le,ve,de,J,x,pe,$e,Ae,Ue){super(),this.Y=Ae,this.Z=Ue,this.a=this.B(new f.$le),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=ne,this.f=de,this.j=ye,this.m=le,this.s=ve,this.t=x,this.u=pe,this.w=$e,this.y=this.g.getProxy(y.$HN.MainThreadWorkspace),this.z=this.g.getProxy(y.$HN.MainThreadTelemetry),this.C=this.g.getProxy(y.$HN.MainThreadExtensionService),this.D=new T.$Dh,this.F=new T.$Dh,this.G=new T.$Dh,this.H=new T.$Dh,this.I=new Ie(this.f.extensions.activationEvents),this.L=new c.$Edc(this.I,this.f.extensions.allExtensions);const ke=new i.$rn(this.f.extensions.myExtensions);this.J=new c.$Edc(this.I,we(this.L,ke)),L.$u&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new d.$Zpc(this.g,this.s),this.N=new M.$0pc(this.g),this.O=J,this.h=this.q.add(Y.createChild(new D.$Ci([d.$1pc,this.M],[M.$$pc,this.N]))),this.P=this.B(new S.$Ypc(this.J,this.L,{onExtensionActivationError:(Pe,Te,j)=>{this.C.$onExtensionActivationError(Pe,l.$1(Te),j)},actualActivateExtension:async(Pe,Te)=>{if(c.$Edc.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,Te),new S.$Xpc;const j=this.J.getExtensionDescription(Pe);return this.fb(j,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){l.$Y(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this.eb(le))}catch{}await Promise.all(Y)}terminate(Y,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ne=this.$();Promise.race([(0,T.$Fh)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const q=await this.C.$getExtension(Y);return q&&{...q,identifier:new i.$qn(q.identifier.value),extensionLocation:s.URI.revive(q.extensionLocation)}}ab(Y,q){return this.P.activateByEvent(Y,q)}bb(Y,q){return this.P.activateById(Y,q)}activateByIdWithErrors(Y,q){return this.bb(Y,q).then(()=>{const ne=this.P.getActivatedExtension(Y);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===F.Schemas.file&&this.c.fsRealpath){const q=Y.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const ne=await this.R.get(q);return s.URI.file(ne)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new ae(Y))),this.Q}async db(Y){const q=$.$Ki.forUris(ne=>O.$9g.ignorePathCasing(ne));return await Promise.all(Y.map(async ne=>{if(this.wb(ne)){const ye=await this.cb(ne.extensionLocation);q.set(ye,ne)}})),q}eb(Y){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return q;const ne=this.P.getActivatedExtension(Y);if(!ne)return q;try{typeof ne.module.deactivate=="function"&&(q=Promise.resolve(ne.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(ye)}try{ne.disposable.dispose()}catch(ye){this.s.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this.s.error(ye)}return q}async fb(Y,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,q).then(ne=>{const ye=ne.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,q),this.gb(Y,q,"success",ye),ne},ne=>{throw this.gb(Y,q,"failure"),ne})}gb(Y,q,ne,ye){const le=me(Y,q);this.z.$publicLog2("extensionActivationTimes",{...le,...ye||{},outcome:ne})}hb(Y,q){const ne=me(Y,q);this.z.$publicLog2("activatePlugin",ne);const ye=this.wb(Y);if(!ye)return Promise.resolve(new S.$Wpc(S.$Tpc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Y.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const le=new A.$Tc,ve=new S.$Upc(q.startup);return Promise.all([this.xb(Y,(0,O.$fh)(Y.extensionLocation,ye),ve),this.ib(Y,le)]).then(de=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),X.jb(this.s,Y.identifier,de[0],de[1],le,ve))).then(de=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),de))}ib(Y,q){const ne=this.Z.createLanguageModelAccessInformation(Y),ye=q.add(new t.$3pc(Y,this.M)),le=q.add(new t.$2pc(Y.identifier.value,!1,this.M)),ve=q.add(new N.$_pc(Y,this.N)),de=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?g.ExtensionMode.Test:g.ExtensionMode.Development:g.ExtensionMode.Production,J=this.f.remote.isRemote?g.ExtensionKind.Workspace:g.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ye.whenReady,le.whenReady,this.O.whenReady]).then(()=>{const x=this;let pe,$e;const Ae=(0,o.$eH)(Y,"ipc")?this.f.messagePorts?.get(i.$qn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ye,workspaceState:le,secrets:ve,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Ue){return R.$jc(Y.extensionLocation.fsPath,Ue)},get storagePath(){return x.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return x.O.globalValue(Y).fsPath},get logPath(){return R.$jc(x.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return s.URI.joinPath(x.f.logsLocation,Y.identifier.value)},get storageUri(){return x.O.workspaceValue(Y)},get globalStorageUri(){return x.O.globalValue(Y)},get extensionMode(){return de},get extension(){return pe===void 0&&(pe=new ce(x,Y.identifier,Y,J,!1)),pe},get extensionRuntime(){return(0,o.$fH)(Y,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!$e){if(!Ae)return;const Ue=f.Event.buffer(f.Event.fromDOMEventEmitter(Ae,"message",ke=>ke.data));Ae.start(),$e={onDidReceiveMessage:Ue,postMessage:Ae.postMessage.bind(Ae)}}return $e}})})}static jb(Y,q,ne,ye,le,ve){return ne=ne||{activate:void 0,deactivate:void 0},this.kb(Y,q,ne,ye,ve).then(de=>new S.$Vpc(!1,null,ve.build(),ne,de,(0,A.$Sc)(()=>{le.dispose(),(0,A.$Pc)(ye.subscriptions)})))}static kb(Y,q,ne,ye,le){if(typeof ne.activate=="function")try{le.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${q.value}`);const ve=typeof global=="object"?global:self,de=ne.activate.apply(ve,[ye]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(de).then(J=>(le.activateResolveStop(),J))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(ne)}lb(Y,q){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:q}).then(void 0,ne=>{this.s.error(ne)})}mb(Y,q=0){const ye=Date.now();(0,L.$C)(()=>{for(let le=q;le<Y.length;le+=1){const ve=Y[le];for(const de of ve.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-ye>50){this.mb(Y,le);break}else this.lb(ve,de)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const q=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(q)this.mb(ne);else for(const ye of ne)if(ye.activationEvents)for(const le of ye.activationEvents)le==="onStartupFinished"&&this.lb(ye,le)})}ob(){const Y=this.ab("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.pb(ve.added)));const q=this.j.workspace?this.j.workspace.folders:[],ne=this.pb(q),ye=this.rb(),le=Promise.all([ye,Y,ne]).then(()=>{});return Promise.race([le,(0,T.$Fh)(1e4)]).then(()=>{this.nb()}),le}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(Y,q))).then(()=>{})}async qb(Y,q){if(this.isActivated(q.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:Y.map(ve=>ve.uri),forceUsingSearch:ne||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,de,J)=>this.y.$checkExists(ve,de,J)},le=await(0,b.$yyb)(ye,q);if(le)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:le.activationEvent}).then(void 0,ve=>this.s.error(ve))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:q}=this.f.environment;if(!Y||!q)throw new Error(v.localize(10789,null));const ne=await this.xb(null,q,new S.$Upc(!1));if(!ne||typeof ne.run!="function")throw new Error(v.localize(10790,null,q.toString()));return new Promise((ye,le)=>{const ve=(x,pe)=>{x?(L.$u&&this.s.error("Test runner called back with error",x),le(x)):(L.$u&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof pe=="number"&&pe>0?1:0))},de=(0,O.$6g)(q),J=ne.run(de,ve);J&&J.then&&J.then(()=>{L.$u&&this.s.info("Test runner finished successfully."),ye(0)}).catch(x=>{L.$u&&this.s.error("Test runner finished with error",x),le(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,T.$Fh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,q){return this.S[Y]=q,(0,A.$Sc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:q}=await this.ub(Y);return q?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const q=Y.indexOf("+");if(q===-1)throw new g.$RN("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Y.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.S[ne]}}async $resolveAuthority(Y,q){const ne=K.$fe.create(!1),ye=()=>`[resolveAuthority(${(0,u.$Ul)(Y)},${q})][${ne.elapsed()}ms] `,le=B=>this.s.info(`${ye()}${B}`),ve=B=>this.s.warn(`${ye()}${B}`),de=(B,H=void 0)=>this.s.error(`${ye()}${B}`,H),J=B=>{if(B instanceof g.$RN)return{type:"error",error:{code:B._code,message:B._message,detail:B._detail}};throw B},x=async B=>{le(`activating resolver for ${B}...`);const{resolver:H,authorityPrefix:V}=await this.ub(B);if(!H)throw de(`no resolver for ${V}`),new g.$RN(`No remote extension installed to resolve ${V}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:V,remoteAuthority:B}},pe=Y.split(/@|%40/g).reverse();le(`activating remote resolvers ${pe.join(" -> ")}`);let $e;try{$e=await Promise.all(pe.map(x)).catch(async B=>{if(!(B instanceof g.$RN)||B._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw B;return ve(`resolving nested authorities failed: ${B.message}`),[await x(Y)]})}catch(B){return J(B)}const Ae=new T.$Ph;Ae.cancelAndSet(()=>le("waiting..."),1e3);let Ue,ke;for(const[B,{authorityPrefix:H,resolver:V,remoteAuthority:re}]of $e.entries())try{if(B===$e.length-1)le("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${H}`),Ue=await V.resolve(re,{resolveAttempt:q,execServer:ke}),P.mark(`code/extHost/didResolveAuthorityOK/${H}`),le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(V,g.$QN.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(le(`invoking resolveExecServer() for ${re}`),P.mark(`code/extHost/willResolveExecServer/${H}`),ke=await V.resolveExecServer?.(re,{resolveAttempt:q,execServer:ke}),!ke)throw new g.$RN(`Exec server was not available for ${re}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ge){return P.mark(`code/extHost/didResolveAuthorityError/${H}`),de("returned an error",ge),Ae.dispose(),J(ge)}Ae.dispose();const Pe={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};le(`returned ${g.$QN.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let j;if(g.$QN.isManagedResolvedAuthority(Ue)){const B=q;this.Y.setFactory(B,Ue.makeConnection),j={authority:Y,connectTo:new u.$Rl(B),connectionToken:Ue.connectionToken}}else j={authority:Y,connectTo:new u.$Sl(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:j,options:Te,tunnelInformation:Pe}}}async $getCanonicalURI(Y,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Ul)(Y)})`);const{resolver:ne}=await this.ub(Y);if(!ne)return null;const ye=s.URI.revive(q);if(typeof ne.getCanonicalURI>"u")return ye;const le=await(0,T.$wh)(()=>ne.getCanonicalURI(ye));return le||ye}async $startExtensionHost(Y){Y.toAdd.forEach(ve=>ve.extensionLocation=s.URI.revive(ve.extensionLocation));const{globalRegistry:q,myExtensions:ne}=ee(this.I,this.L,this.J,Y),ye=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),L.$u&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(Y,q){return q===o.ActivationKind.Immediate?this.D.wait().then(ne=>this.ab(Y,!1)):this.G.wait().then(ne=>this.ab(Y,!1))}async $activate(Y,q){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,q),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(ve=>ve.extensionLocation=s.URI.revive(ve.extensionLocation));const{globalRegistry:q,myExtensions:ne}=ee(this.I,this.L,this.J,Y),ye=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),L.$u&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const q=n.$Ne.alloc(Y),ne=Math.random()%256;for(let ye=0;ye<Y;ye++)q.writeUInt8(ne,ye);return q}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$fqc=ue,e.$fqc=ue=X=Je([Ve(0,m.$Di),Ve(1,e.$eqc),Ve(2,E.$hQ),Ve(3,r.$Cpc),Ve(4,a.$Fpc),Ve(5,k.$_j),Ve(6,p.$xQ),Ve(7,h.$Ipc),Ve(8,w.$eGb),Ve(9,I.$4pc),Ve(10,W.$bqc),Ve(11,Q.$cqc),Ve(12,C.$8pc)],ue);function ee(Fe,Y,q,ne){Fe.addActivationEvents(ne.addActivationEvents);const ye=new c.$Edc(Fe,Y.getAllExtensionDescriptions());ye.deltaExtensions(ne.toAdd,ne.toRemove);const le=new i.$rn(q.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ne.myToRemove)le.delete(de);for(const de of ne.myToAdd)le.add(de);const ve=we(ye,le);return{globalRegistry:ye,myExtensions:ve}}function me(Fe,Y){return{id:Fe.identifier.value,name:Fe.name,extensionVersion:Fe.version,publisherDisplayName:Fe.publisher,activationEvents:Fe.activationEvents?Fe.activationEvents.join(","):null,isBuiltin:Fe.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function oe(Fe){return Fe.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$gqc=(0,m.$Ei)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(Y,q,ne,ye,le){this.#e=Y,this.#t=q,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=R.$hc((0,O.$6g)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ye,this.isFromDifferentExtensionHost=le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$hqc=ce;function we(Fe,Y){return Fe.getAllExtensionDescriptions().filter(q=>Y.has(q.identifier))}class ae{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$iqc=ae;class Ie{constructor(Y){this.a=new i.$sn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const q of Object.keys(Y))this.a.set(q,Y[q])}}}),define(Oe[273],Ne([1,0,64,2,5,46,24,18,16,26,3,47,11,12]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=void 0,v=We(v);let r=class{constructor(n,t,g,u,m,p,h){this.c=n,this.d=t,this.e=g,this.f=u,this.g=m,this.h=p,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new c(this.c,t,this.d,n,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(l,t,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$trc=r,e.$trc=r=Je([Ve(2,k.$Di),Ve(3,O.$Fpc),Ve(4,y.$gqc),Ve(5,s.$xQ),Ve(6,a.$_j)],r);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&d.a.size){const t=(0,S.$hf)(this.c(n.environment.appRoot.fsPath)),g="[a-z0-9_.-]",u=`@${g}+\\/${g}+|${g}+`,m="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${m}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,g,u,m]=t,p=d.a.get(u);if(p!==void 0)return console.warn(`${u} as been renamed to ${p}, please update your imports`),g+p+m}c(n){return n.replace(/\\/g,"/")}};o=d=Je([Ve(0,s.$xQ)],o);class c{constructor(n,t,g,u,m){this.c=n,this.d=t,this.e=g,this.f=u,this.g=m,this.nodeModuleName="vscode",this.a=new A.$sn}load(n,t){const g=this.d.findSubstr(t);if(g){let u=this.a.get(g.identifier);return u||(u=this.c(g,this.e,this.f),this.a.set(g.identifier,u)),u}if(!this.b){let u="";this.d.forEach((m,p)=>u+=`	${p} -> ${m.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${u}`),this.b=this.c(T.$_G,this.e,this.f)}return this.b}}let l=class{constructor(n,t,g){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=g.getProxy(P.$HN.MainThreadTelemetry);const u=g.getProxy(P.$HN.MainThreadWindow);this.c=(m,p)=>{const h=R.URI.parse(m);return p?this.g(m,p):h.scheme==="http"||h.scheme==="https"?u.$openUri(h,m,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?u.$openUri(h,m,{}):this.g(m,p)}}load(n,t,g){const u=this.e.findSubstr(t);return u&&(this.a=u.identifier.value,this.h()),this.b=g(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=Je([Ve(2,$.$hQ)],l)}),define(Oe[132],Ne([1,0,48,4,19,78,3,57,70,47,7,45,203,46]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0,P=We(P),O=We(O),e.$jqc=(0,T.$Ei)("IExtHostVariableResolverProvider");class d extends a.$lR{constructor(c,l,i,n,t,g,u){function m(){if(i){const p=i.activeEditor();if(p)return p.document.uri;const h=n.tabGroups.all.find(E=>E.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof k.$yP||h.input instanceof k.$DP)return h.input.modified;if(h.input instanceof k.$xP||h.input instanceof k.$CP||h.input instanceof k.$AP)return h.input.uri}}}super({getFolderUri:p=>{const h=g.folders.filter(E=>E.name===p);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>g.folders.length,getConfigurationValue:(p,h)=>t.getConfiguration(void 0,p).get(h),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const p=m();if(p)return P.$hc(p.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const p=m();if(p){const h=l.getWorkspaceFolder(p);if(h)return P.$hc(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const p=i.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(i){const p=i.activeEditor();if(p)return String(p.selection.end.line+1)}},getExtension:p=>c.getExtension(p)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(O.env))}}let r=class extends R.$Uc{constructor(c,l,i,n,t){super(),this.b=c,this.c=l,this.g=i,this.h=n,this.j=t,this.a=new v.$T(async()=>{const g=await this.h.getConfigProvider(),m={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async p=>{m.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,g,m,this.m())})}getResolver(){return this.a.value}m(){}};e.$kqc=r,e.$kqc=r=Je([Ve(0,s.$gqc),Ve(1,y.$Cpc),Ve(2,A.$sQ),Ve(3,S.$Fpc),Ve(4,$.$Rpc)],r)}),define(Oe[133],Ne([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,80,196,46,132,34,33,8,17,95]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=e.$tqc=e.$sqc=e.$rqc=e.$qqc=void 0,t=We(t),e.$qqc=(0,A.$Ei)("IExtHostDebugService");let m=class extends O.$Uc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(C,f,b,M,N,F,W,K){super(),this.Y=f,this.Z=b,this.$=M,this.ab=N,this.bb=F,this.cb=W,this.db=K,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new R.$le),this.z=this.B(new R.$le),this.C=this.B(new R.$le),this.F=this.B(new R.$le),this.u=C.getProxy($.$HN.MainThreadDebugService),this.I=this.B(new R.$le),this.L=this.B(new R.$le),this.G=new h(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(L=>{this.B(L.onDidChange(Q=>{this.fb(L)})),this.fb(L)})}async $getVisualizerTreeItem(C,f){const b=this.gb(f);if(!b)return;const M=await this.Q.get(C)?.getTreeItem?.(b);return M?this.eb(C,M):void 0}registerDebugVisualizationTree(C,f,b){const M=T.$qn.toKey(C.identifier),N=this.ub(M,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.Q.set(N,b),this.u.$registerDebugVisualizerTree(N,!!b.editItem),(0,O.$Sc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(f)})}async $getVisualizerTreeItemChildren(C,f){const b=this.S.get(f)?.item;return b?(await this.Q.get(C)?.getChildren?.(b))?.map(N=>this.eb(C,N))||[]:[]}async $editVisualizerTreeItem(C,f){const b=this.S.get(C);if(!b)return;const M=await this.Q.get(b.provider)?.editItem?.(b.item,f);return this.eb(b.provider,M||b.item)}$disposeVisualizedTree(C){const f=this.S.get(C);if(!f)return;const b=[f.children];for(const M of b)if(M)for(const N of M)b.push(this.S.get(N)?.children),this.S.delete(N)}eb(C,f){let b=this.R.get(f);return b||(b=this.O++,this.R.set(f,b),this.S.set(b,{provider:C,item:f})),t.DebugTreeItem.from(f,b)}asDebugSourceUri(C,f){const b=C;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let M=`debug:${encodeURIComponent(b.path||"")}`,N="?";return f&&(M+=`${N}session=${encodeURIComponent(f.id)}`,N="&"),M+=`${N}ref=${b.sourceReference}`,P.URI.parse(M)}else{if(b.path)return P.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(C){const f=[];for(const b of C.getAllExtensionDescriptions())if(b.contributes){const M=b.contributes.debuggers;if(M&&M.length>0)for(const N of M)(0,o.$0H)(N)&&f.push(N.type)}this.u.$registerDebugTypes(f)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const C=[];return this.H.forEach(f=>C.push(f)),C}async $resolveDebugVisualizer(C,f){const b=this.W.get(C);if(!b)throw new Error(`No debug visualizer found with id '${C}'`);let{v:M,provider:N,extensionId:F}=b;if(M.visualization||(M=await N.resolveDebugVisualization?.(M,f)||M,b.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(F,M.visualization)}async $executeDebugVisualizerCommand(C){const f=this.W.get(C);if(!f)throw new Error(`No debug visualizer found with id '${C}'`);const b=f.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(C){const f=this.w.get(C.sessionId);return f&&{session:f.api,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId}}async $provideDebugVisualizers(C,f,b,M){const N=this.gb(b),F=this.ub(C,f),W=this.P.get(F);if(!N||!W)return[];const K=await W.provideDebugVisualization(N,M);return K?K.map(L=>{const Q=++this.X;this.W.set(Q,{v:L,provider:W,extensionId:C});const X=L.iconPath?this.wb(L.iconPath):void 0;return{id:Q,name:L.name,iconClass:X?.iconClass,iconPath:X?.iconPath,visualization:this.vb(C,L.visualization)}}):[]}$disposeDebugVisualizers(C){for(const f of C)this.W.delete(f)}registerDebugVisualizationProvider(C,f,b){if(!C.contributes?.debugVisualizers?.some(F=>F.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const M=T.$qn.toKey(C.identifier),N=this.ub(M,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.P.set(N,b),this.u.$registerDebugVisualizer(M,f),(0,O.$Sc)(()=>{this.u.$unregisterDebugVisualizer(M,f),this.P.delete(f)})}addBreakpoints(C){const f=C.filter(N=>{const F=N.id;return this.H.has(F)?!1:(this.H.set(F,N),!0)});this.rb(f,[],[]);const b=[],M=new Map;for(const N of f)if(N instanceof a.$NO){let F=M.get(N.location.uri.toString());F||(F={type:"sourceMulti",uri:N.location.uri,lines:[]},M.set(N.location.uri.toString(),F),b.push(F)),F.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof a.$OO&&b.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(C){const f=C.filter(F=>this.H.delete(F.id));this.rb([],f,[]);const b=f.filter(F=>F instanceof a.$NO).map(F=>F.id),M=f.filter(F=>F instanceof a.$OO).map(F=>F.id),N=f.filter(F=>F instanceof a.$PO).map(F=>F.id);return this.u.$unregisterBreakpoints(b,M,N)}startDebugging(C,f,b){const M=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(C?C.uri:void 0,f,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===a.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(C){return this.u.$stopDebugging(C?C.id:void 0)}registerDebugConfigurationProvider(C,f,b){if(!f)return new a.$JN(()=>{});const M=this.f++;return this.g.push({type:C,handle:M,provider:f}),this.u.$registerDebugConfigurationProvider(C,b,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,M),new a.$JN(()=>{this.g=this.g.filter(N=>N.provider!==f),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(C,f,b){if(!b)return new a.$JN(()=>{});if(!this.nb(C,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.kb(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:f,handle:M,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(f,M),new a.$JN(()=>{this.j=this.j.filter(N=>N.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(C,f){if(!f)return new a.$JN(()=>{});const b=this.m++;return this.n.push({type:C,handle:b,factory:f}),new a.$JN(()=>{this.n=this.n.filter(M=>M.factory!==f)})}async $runInTerminal(C,f){return Promise.resolve(void 0)}async $substituteVariables(C,f){let b;const M=await this.tb(C);return M&&(b={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,f)}hb(C,f){if(C.type==="implementation")return new D(C.implementation)}ib(){}async $startDASession(C,f){const b=this,M=await this.sb(f);return this.pb(this.kb(M.type),M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const F=this.jb(N),W=this.hb(F,M);if(!W)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const K=W;return this.M.set(C,K),this.ob(M).then(L=>(L&&this.N.set(C,L),K.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const X=Q,ue={type:"response",seq:0,command:X.command,request_seq:X.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const ee=await this.U.sign(X.arguments.value);ue.body={signature:ee},K.sendResponse(ue)}else throw new Error("no signer")}catch(ee){ue.success=!1,ue.message=ee.message,K.sendResponse(ue)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(Q),Q=(0,o.$cI)(Q,!0),b.u.$acceptDAMessage(C,Q)}),K.onError(Q=>{L&&L.onError&&L.onError(Q),this.u.$acceptDAError(C,Q.name,Q.message,Q.stack)}),K.onExit(Q=>{L&&L.onExit&&L.onExit(Q??void 0,void 0),this.u.$acceptDAExit(C,Q??void 0,void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),K.startSession()))})}$sendDAMessage(C,f){f=(0,o.$bI)(f,!1);const b=this.N.get(C);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(f),this.M.get(C)?.sendMessage(f)}$stopDASession(C){const f=this.N.get(C);this.N.delete(C),f&&f.onWillStopSession&&f.onWillStopSession();const b=this.M.get(C);return this.M.delete(C),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(C){const f=[],b=[],M=[];if(C.added)for(const N of C.added){const F=N.id;if(F&&!this.H.has(F)){let W;if(N.type==="function")W=new a.$OO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")W=new a.$PO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const K=P.URI.revive(N.uri);W=new a.$NO(new a.$XN(K,new a.$KN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,a.$LO)(W,F),this.H.set(F,W),f.push(W)}}if(C.removed)for(const N of C.removed){const F=this.H.get(N);F&&(this.H.delete(N),b.push(F))}if(C.changed){for(const N of C.changed)if(N.id){const F=this.H.get(N.id);if(F){if(F instanceof a.$OO&&N.type==="function"){const W=F;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.functionName=N.functionName}else if(F instanceof a.$NO&&N.type==="source"){const W=F;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.location=new a.$XN(P.URI.revive(N.uri),new a.$KN(N.line,N.character))}M.push(F)}}}this.rb(f,b,M)}async $acceptStackFrameFocus(C){let f;if(C){const b=await this.sb(C.sessionId);C.kind==="thread"?f=new a.$VO(b.api,C.threadId):f=new a.$UO(b.api,C.threadId,C.frameId)}this.J=f,this.L.fire(this.J)}$provideDebugConfigurations(C,f,b){return(0,v.$wh)(async()=>{const M=this.mb(C);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(f);return M.provideDebugConfigurations(N,b)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(C,f,b,M){return(0,v.$wh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.tb(f);return N.resolveDebugConfiguration(F,b,M)})}$resolveDebugConfigurationWithSubstitutedVariables(C,f,b,M){return(0,v.$wh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.tb(f);return N.resolveDebugConfigurationWithSubstitutedVariables(F,b,M)})}async $provideDebugAdapter(C,f){const b=this.lb(C);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(f);return this.pb(b,M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(C){const f=await this.sb(C);this.y.fire(f.api)}async $acceptDebugSessionTerminated(C){const f=await this.sb(C);f&&(this.z.fire(f.api),this.w.delete(f.id))}async $acceptDebugSessionActiveChanged(C){this.D=C?await this.sb(C):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(C,f){(await this.sb(C))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(C,f){const M={session:(await this.sb(C)).api,event:f.event,body:f.body};this.F.fire(M)}jb(C){if(C instanceof a.$QO)return{type:"executable",command:C.command,args:C.args,options:C.options};if(C instanceof a.$RO)return{type:"server",port:C.port,host:C.host};if(C instanceof a.$SO)return{type:"pipeServer",path:C.path};if(C instanceof a.$TO)return{type:"implementation",implementation:C.implementation};throw new Error("convertToDto unexpected type")}kb(C){const f=this.j.filter(b=>b.type===C);if(f.length>0)return f[0].factory}lb(C){const f=this.j.filter(b=>b.handle===C);if(f.length>0)return f[0].factory}mb(C){const f=this.g.filter(b=>b.handle===C);if(f.length>0)return f[0].provider}nb(C,f){if(C.contributes){const b=C.contributes.debuggers;if(b&&b.length>0){for(const M of b)if(M.label&&M.type&&M.type===f)return!0}}return!1}ob(C){const b=C.configuration.type,M=this.n.filter(N=>N.type===b||N.type==="*").map(N=>(0,v.$wh)(()=>N.factory.createDebugAdapterTracker(C.api)).then(F=>F,F=>null));return Promise.race([Promise.all(M).then(N=>{const F=(0,g.$Gb)(N);if(F.length>0)return new E(F)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(C,f){const b=f.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new a.$RO(b));if(C){const N=await this.Z.getExtensionRegistry();return(0,v.$wh)(()=>C.createDebugAdapterDescriptor(f.api,this.qb(f,N))).then(F=>{if(F)return F})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(f,M))}qb(C,f){}rb(C,f,b){(C.length>0||f.length>0||b.length>0)&&this.I.fire(Object.freeze({added:C,removed:f,changed:b}))}async sb(C){if(C)if(typeof C=="string"){const f=this.w.get(C);if(f)return f}else{let f=this.w.get(C.id);if(!f){const b=await this.tb(C.folderUri),M=C.parent?this.w.get(C.parent):void 0;f=new p(this.u,C.id,C.type,C.name,b,C.configuration,M?.api),this.w.set(f.id,f),this.u.$sessionCached(f.id)}return f}throw new Error("cannot find session")}tb(C){if(C){const f=P.URI.revive(C);return this.Y.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}ub(C,f){return`${C}\0${f}`}vb(C,f){if(f){if("title"in f&&"command"in f)return{type:r.DebugVisualizationType.Command};if("treeId"in f)return{type:r.DebugVisualizationType.Tree,id:`${C}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(C){const f=this.xb(C);let b,M;return"id"in f?M=i.ThemeIcon.asClassName(f):b=f,{iconPath:b,iconClass:M}}xb(C){if(C instanceof a.$IO)return{id:C.id};const f=typeof C=="object"&&"dark"in C?C.dark:C,b=typeof C=="object"&&"light"in C?C.light:C;return{dark:typeof f=="string"?P.URI.file(f):f,light:typeof b=="string"?P.URI.file(b):b}}};e.$rqc=m,e.$rqc=m=Je([Ve(0,y.$hQ),Ve(1,S.$Cpc),Ve(2,k.$gqc),Ve(3,c.$Fpc),Ve(4,s.$Rpc),Ve(5,l.$jqc),Ve(6,n.$DQ),Ve(7,u.$lqc)],m);class p{constructor(C,f,b,M,N,F,W){this.f=C,this.g=f,this.h=b,this.j=M,this.k=N,this.l=F,this.m=W}get api(){const C=this;return this.d??=Object.freeze({id:C.g,type:C.h,get name(){return C.j},set name(f){C.j=f,C.f.$setDebugSessionName(C.g,f)},parentSession:C.m,workspaceFolder:C.k,configuration:C.l,customRequest(f,b){return C.f.$customDebugAdapterRequest(C.g,f,b)},getDebugProtocolBreakpoint(f){return C.f.$getDebugProtocolBreakpoint(C.g,f.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(C){this.j=C}get configuration(){return this.l}}e.$sqc=p;class h{constructor(C){this.value=Object.freeze({append(f){C.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.$tqc=h;class E{constructor(C){this.d=C}onWillStartSession(){this.d.forEach(C=>C.onWillStartSession?C.onWillStartSession():void 0)}onWillReceiveMessage(C){this.d.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(C):void 0)}onDidSendMessage(C){this.d.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(C):void 0)}onWillStopSession(){this.d.forEach(C=>C.onWillStopSession?C.onWillStopSession():void 0)}onError(C){this.d.forEach(f=>f.onError?f.onError(C):void 0)}onExit(C,f){this.d.forEach(b=>b.onExit?b.onExit(C,f):void 0)}}class D extends d.$5tb{constructor(C){super(),this.h=C,C.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(C){this.h.handleMessage(C)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends m{constructor(C,f,b,M,N,F,W,K){super(C,f,b,M,N,F,W,K)}};e.$uqc=w,e.$uqc=w=Je([Ve(0,y.$hQ),Ve(1,S.$Cpc),Ve(2,k.$gqc),Ve(3,c.$Fpc),Ve(4,s.$Rpc),Ve(5,l.$jqc),Ve(6,n.$DQ),Ve(7,u.$lqc)],w)}),define(Oe[274],Ne([1,0,13,64,2,5,224,11,60,74,26,170,16,65,47,66]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=e.$urc=void 0,v=We(v),R=We(R);class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(A.$_j),g=i.get(a.$hQ).getProxy(O.$HN.MainThreadErrors);v.setUnexpectedErrorHandler(u=>{n.error(u);const m=v.$1(u);g.$onUnexpectedError(m)})}static async installFullHandler(i){const n=i.get(A.$_j),t=i.get(a.$hQ),g=i.get(d.$gqc),u=i.get(r.$BQ),m=t.getProxy(O.$HN.MainThreadExtensionService),p=t.getProxy(O.$HN.MainThreadErrors),h=await g.getExtensionPathIndex(),E=new WeakMap;function D(C,f){if(E.has(C))return E.get(C).stack;let b="",M,N;for(const W of f)b+=`
	at ${W.toString()}`,N=W.getFileName(),!M&&N&&(M=h.findSubstr(P.URI.file(N)));const F=`${C.name||"Error"}: ${C.message||""}${b}`;return E.set(C,{extensionIdentifier:M?.identifier,stack:F}),F}const w=Symbol("prepareStackTrace wrapped");let I=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return I},set(C){if(C===D||!C||C[w]){I=C||D;return}I=function(f,b){return D(f,b),C.call(Error,f,b)},Object.assign(I,{[w]:!0})}}),v.setUnexpectedErrorHandler(C=>{n.error(C);const f=v.$1(C),b=E.get(C);if(!b?.extensionIdentifier){p.$onUnexpectedError(f);return}m.$onExtensionRuntimeError(b.extensionIdentifier,f);const M=u.onExtensionError(b.extensionIdentifier,C);n.trace("forwarded error to extension?",M,b)})}}e.$urc=o;class c{constructor(i,n,t,g,u){this.a=t,this.b=new T.$Mdc(i,null,g),n=c.e(n,this.b);const m=new s.$Ci(...(0,$.$Rs)());m.set(k.$xQ,{_serviceBrand:void 0,...n,messagePorts:u}),m.set(a.$hQ,new a.$iQ(this.b)),m.set(S.$zpc,new S.$Apc(g)),m.set(d.$eqc,t);const p=new y.$vr(m,!0);p.invokeFunction(o.installEarlyHandler),this.d=p.invokeFunction(h=>h.get(A.$_j)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=p.invokeFunction(h=>h.get(d.$gqc)),this.c.initialize(),p.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(O.$HN.MainThreadExtensionService);return P.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(g=>{g.extensionLocation=P.URI.revive(n.transformIncomingURIs(g.extensionLocation))}),i.environment.appRoot=P.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(g=>P.URI.revive(n.transformIncomingURIs(g)))),i.environment.extensionTestsLocationURI=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$vrc=c}),define(Oe[275],Ne([1,0,17,10,21,42,15,19,23,2,44]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=e.$Jqc=e.$Iqc=void 0,e.$Kqc=r,A=We(A),$=We($);class y{constructor(l,i,n){this.d=l,this.e=i,this.f=n,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(l,i){const n=this.g.folderQueries||[],t=new P.$we(i);return new Promise((g,u)=>{this.a=new S(l);let m=!1;const p=(h,E)=>{if(!m&&!this.b){const D=this.h(h);r(h)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,m=!0,t.cancel(),h=this.j(h,this.g.maxResults-this.c));const w=this.h(h);this.c+=w,(w>0||!r(h))&&this.a.add(h,E)}};Promise.all(n.map((h,E)=>this.k(h,D=>p(D,E),t.token))).then(h=>{t.dispose(),this.a.flush();const E=h.some(D=>!!D&&!!D.limitHit);g({limitHit:this.b||E,messages:h.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},h=>{t.dispose();const E=(0,O.$pj)(h);u(new Error(E))})})}h(l){return r(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,i){const n=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:n.slice(0,i),preview:{matches:t.slice(0,i),text:l.preview.text},uri:l.uri}}async k(l,i,n){const t=new k.$lM(this.g,l),g=[],u={report:h=>{if(!this.l(h))return;const E=l.folder.scheme===T.Schemas.file?(0,k.$mM)(()=>this.e.readdir($.$eh(h.uri))):void 0,D=$.$hh(l.folder,h.uri);if(D){const w=t.includedInQuery(D,A.$nc(D),E);(0,R.$qh)(w)?g.push(w.then(I=>{I&&i(h)})):w&&i(h)}}},m=this.n(l);let p;return this.d.query.type===k.QueryType.aiText?p=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,m,u,n):p=await this.d.provider.provideTextSearchResults(a(this.d.query.contentPattern),m,u,n),g.length&&await Promise.all(g),p}l(l){if(r(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const i=(0,k.$kM)(this.g.includePattern,l.includePattern),n=(0,k.$kM)(this.g.excludePattern,l.excludePattern),t={folder:s.URI.from(l.folder),excludes:n,includes:i,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.e.toCanonicalName(l.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??k.$4L,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Iqc=y;function a(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class S{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(l,i){this.d&&(this.b!==i||!$.$$g(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:l.uri,results:[]}),this.d.results.push(d(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$Jqc=S;function d(c){return r(c)?{preview:{matches:(0,v.$Zb)(c.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:c.preview.text},ranges:(0,v.$Zb)(c.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function r(c){return!!c.preview}class o{static{this.a=4e3}static{this.b=50}constructor(l,i){this.g=l,this.h=i,this.c=0,this.d=[],this.e=0}addItem(l,i){l&&this.j(l,i)}addItems(l,i){l&&this.k(l,i)}j(l,i){this.d.push(l),this.e+=i,this.l()}k(l,i){this.d=this.d.concat(l),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Lqc=o}),define(Oe[134],Ne([1,0,4,5,3,270,16,65,11,2,275]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=e.$Mqc=void 0,e.$Oqc=a,e.$Mqc=(0,P.$Ei)("IExtHostSearch");let y=class{constructor(r,o,c){this.n=r,this.o=o,this.q=c,this.c=this.n.getProxy(R.$HN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Hqc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const c=this.d++;return this.e.set(c,o),this.c.$registerTextSearchProvider(c,this.s(r)),(0,v.$Sc)(()=>{this.g.delete(r),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const c=this.d++;return this.h.set(c,o),this.c.$registerAITextSearchProvider(c,this.s(r)),(0,v.$Sc)(()=>{this.i.delete(r),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const c=this.d++;return this.j.set(c,o),this.c.$registerFileSearchProvider(c,this.s(r)),(0,v.$Sc)(()=>{this.k.delete(r),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(r,o,c,l){const i=a(c),n=this.j.get(r);if(n)return this.l.fileSearch(i,n,t=>{this.c.$handleFileMatch(r,o,t.map(g=>g.resource))},l);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,c){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,c,l){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${r}`);const n=a(c);return this.t(n,i).search(g=>this.c.$handleTextMatch(r,o,g),l)}$provideAITextSearchResults(r,o,c,l){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${r}`);const n=a(c);return this.v(n,i).search(g=>this.c.$handleTextMatch(r,o,g),l)}$enableExtensionHostSearch(){}t(r,o){return new k.$Iqc({query:r,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(r,o){return new k.$Iqc({query:r,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$Nqc=y,e.$Nqc=y=Je([Ve(0,T.$hQ),Ve(1,A.$zpc),Ve(2,$.$_j)],y);function a(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(S),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>s.URI.revive(r))}}function S(d){return{...d,folder:s.URI.revive(d.folder)}}});var xt=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[276],Ne([1,0,10,21,13,6,4,15,35,2,105,157,158,52,18,29,11,62,63,185,5,227,256,84,90,232,233,234,211,201,33,235,46,236,133,122,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,94,245,85,86,217,269,247,190,248,258,249,128,218,250,251,252,16,253,134,87,254,219,255,88,91,131,66,56,126,95,259,230,260,261,92,8,7,220,65,221,67,262,263,121,45,80,83,24,130]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u,m,p,h,E,D,w,I,C,f,b,M,N,F,W,K,L,Q,X,ue,ee,me,oe,ce,we,ae,Ie,Fe,Y,q,ne,ye,le,ve,de,J,x,pe,$e,Ae,Ue,ke,Pe,Te,j,B,H,V,re,ge,Ce,ze,Qe,_e,tt,nt,et,rt,ft,lt,st,ct,gt,$t,qe,je,te,_,Z,Xe,xe,ht,bt,Ft,Ht,_t,ei,oi,Rt,Ye,Mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=hi,P=We(P),$=xt($),a=We(a),r=We(r),_=We(_),Z=We(Z);function hi(mt){const Et=mt.get(Fe.$xQ),ti=mt.get(Ie.$kpc),ii=mt.get(we.$Hpc),jt=mt.get(oe.$gqc),pt=mt.get(ei.$Cpc),zt=mt.get(ft.$BQ),ni=mt.get(f.$Fpc),ai=mt.get(xe.$zpc),Ge=mt.get(re.$hQ),ci=mt.get(nt.$1pc),di=mt.get(et.$Ipc),fi=mt.get(o.$ak),vt=mt.get(o.$_j),Lt=mt.get(te.$eGb),Tt=mt.get(u.$gpc),Wt=mt.get(_t.$orc),ri=mt.get(ze.$$pc),Kt=mt.get(ue.$Rpc),li=mt.get(J.$cqc),Bt=mt.get(m.$qpc),Qt=mt.get(le.$8pc);Ge.set(n.$IN.ExtHostFileSystemInfo,ti),Ge.set(n.$IN.ExtHostLogLevelServiceShape,fi),Ge.set(n.$IN.ExtHostWorkspace,pt),Ge.set(n.$IN.ExtHostConfiguration,ni),Ge.set(n.$IN.ExtHostExtensionService,jt),Ge.set(n.$IN.ExtHostStorage,ci),Ge.set(n.$IN.ExtHostTunnelService,Lt),Ge.set(n.$IN.ExtHostWindow,Wt),Ge.set(n.$IN.ExtHostSecretState,ri),Ge.set(n.$IN.ExtHostTelemetry,zt),Ge.set(n.$IN.ExtHostEditorTabs,Kt),Ge.set(n.$IN.ExtHostManagedSockets,li),Ge.set(n.$IN.ExtHostAuthentication,Bt),Ge.set(n.$IN.ExtHostChatProvider,Qt);const Gt=Ge.set(n.$IN.ExtHostDecorations,mt.get(N.$wqc)),Nt=Ge.set(n.$IN.ExtHostDocumentsAndEditors,mt.get(X.$sQ)),wt=Ge.set(n.$IN.ExtHostCommands,mt.get(I.$DQ)),kt=Ge.set(n.$IN.ExtHostTerminalService,mt.get(lt.$4pc)),Vt=Ge.set(n.$IN.ExtHostTerminalShellIntegration,mt.get(st.$erc)),It=Ge.set(n.$IN.ExtHostDebugService,mt.get(M.$qqc)),gi=Ge.set(n.$IN.ExtHostSearch,mt.get(Ce.$Mqc)),Yt=Ge.set(n.$IN.ExtHostTask,mt.get(rt.$drc)),Si=Ge.set(n.$IN.ExtHostOutputService,mt.get(Te.$3qc)),$i=Ge.set(n.$IN.ExtHostLocalization,mt.get(de.$bqc)),Ai=Ge.set(n.$IN.ExtHostUrls,new ht.$lrc(Ge)),At=Ge.set(n.$IN.ExtHostDocuments,new Q.$npc(Ge,Nt)),Ni=Ge.set(n.$IN.ExtHostDocumentContentProviders,new K.$yqc(Ge,Nt,vt)),ui=Ge.set(n.$IN.ExtHostDocumentSaveParticipant,new L.$zqc(vt,At,Ge.getProxy(n.$HN.MainThreadBulkEdits))),Ct=Ge.set(n.$IN.ExtHostNotebook,new pe.$Pqc(Ge,wt,Nt,At,ii,gi,vt)),Ti=Ge.set(n.$IN.ExtHostNotebookDocuments,new Ae.$Wqc(Ct)),ki=Ge.set(n.$IN.ExtHostNotebookEditors,new Ue.$Xqc(vt,Ct)),Ei=Ge.set(n.$IN.ExtHostNotebookKernels,new ke.$Yqc(Ge,Et,Ct,wt,vt)),Fi=Ge.set(n.$IN.ExtHostNotebookRenderers,new Pe.$1qc(Ge,Ct)),wi=Ge.set(n.$IN.ExtHostNotebookDocumentSaveParticipant,new $e.$Vqc(vt,Ct,Ge.getProxy(n.$HN.MainThreadBulkEdits))),qt=Ge.set(n.$IN.ExtHostEditors,new gt.$wpc(Ge,Nt)),De=Ge.set(n.$IN.ExtHostTreeViews,new je.$jrc(Ge.getProxy(n.$HN.MainThreadTreeViews),wt,vt)),Re=Ge.set(n.$IN.ExtHostEditorInsets,new w.$xpc(Ge.getProxy(n.$HN.MainThreadEditorInsets),qt,Et.remote)),he=Ge.set(n.$IN.ExtHostDiagnostics,new F.$mpc(Ge,vt,ti,Nt)),G=Ge.set(n.$IN.ExtHostLanguages,new ve.$Tqc(Ge,At,wt.converter,ai)),Ee=Ge.set(n.$IN.ExtHostLanguageFeatures,new ne.$opc(Ge,ai,At,wt,he,vt,Tt,zt)),Be=Ge.set(n.$IN.ExtHostFileSystem,new ce.$Cqc(Ge,Ee)),Ze=Ge.set(n.$IN.ExtHostFileSystemEventService,new ae.$Dqc(Ge,vt,Nt)),He=Ge.set(n.$IN.ExtHostQuickOpen,(0,V.$7qc)(Ge,pt,wt)),ut=Ge.set(n.$IN.ExtHostSCM,new ge.$9qc(Ge,wt,At,vt)),Pt=Ge.set(n.$IN.ExtHostQuickDiff,new H.$6qc(Ge,ai)),Jt=Ge.set(n.$IN.ExtHostShare,new Qe.$0qc(Ge,ai)),si=Ge.set(n.$IN.ExtHostComments,(0,C.$ypc)(Ge,wt,At)),Ut=Ge.set(n.$IN.ExtHostProgress,new B.$5qc(Ge.getProxy(n.$HN.MainThreadProgress))),Zt=Ge.set(n.$IN.ExtHostLabelService,new q.$Rqc(Ge)),qi=Ge.set(n.$IN.ExtHostTheming,new $t.$grc(Ge)),nn=Ge.set(n.$IN.ExtHostTimeline,new qe.$irc(Ge,wt)),Wi=Ge.set(n.$IN.ExtHostWebviews,new bt.$Mpc(Ge,Et.remote,pt,vt,Tt)),Li=Ge.set(n.$IN.ExtHostWebviewPanels,new Ft.$Ppc(Ge,Wi,pt)),Vi=Ge.set(n.$IN.ExtHostCustomEditors,new b.$Qpc(Ge,At,di,Wi,Li)),Hi=Ge.set(n.$IN.ExtHostWebviewViews,new Ht.$mrc(Ge,Wi)),Ii=Ge.set(n.$IN.ExtHostTesting,mt.get(ct.$lqc)),rn=Ge.set(n.$IN.ExtHostUriOpeners,new Xe.$krc(Ge)),sn=Ge.set(n.$IN.ExtHostProfileContentHandlers,new j.$4qc(Ge));Ge.set(n.$IN.ExtHostInteractive,new Y.$Qqc(Ge,Ct,Nt,wt,vt));const Mi=Ge.set(n.$IN.ExtHostChatAgents2,new h.$tpc(Ge,vt,wt,At)),on=Ge.set(n.$IN.ExtHostChatVariables,new E.$upc(Ge)),Ui=Ge.set(n.$IN.ExtHostLanguageModelTools,new ye.$Sqc(Ge)),Qi=Ge.set(n.$IN.ExtHostAiRelatedInformation,new t.$fpc(Ge)),yn=Ge.set(n.$IN.ExtHostAiEmbeddingVector,new me.$Bqc(Ge)),an=Ge.set(n.$IN.ExtHostStatusBar,new tt.$arc(Ge,wt.converter)),Ki=Ge.set(n.$IN.ExtHostSpeech,new _e.$$qc(Ge)),Ci=Ge.set(n.$IN.ExtHostEmbeddings,new ee.$Aqc(Ge)),En=Object.values(n.$IN);Ge.assertRegistered(En);const Dn=new p.$spc(Ge,Nt),cn=new D.$vpc(Ge),Gi=new x.$Uqc(Ge,vt),Ji=new W.$xqc(Ge);return g.$ppc.register(wt),function(Me,bi,Xi){function ot(ie){return(fe,Le,at)=>{const Dt=ie(Ot=>{try{fe.call(Le,Ot)}catch(Pi){P.$Z(new Error(`[ExtensionListenerError] Extension '${Me.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),zt.onExtensionError(Me.identifier,Pi)}});return at?.push(Dt),Dt}}const St=function(){let ie=!Me.isUnderDevelopment;function fe(){ie||(vt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Le(at){if(Array.isArray(at))at.forEach(Le);else if(typeof at=="string")fe();else{const Dt=at;typeof Dt.scheme>"u"&&fe(),typeof Dt.exclusive=="boolean"&&(0,Ye.$fH)(Me,"documentFiltersExclusive")}return at}}(),Yi={getSession(ie,fe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ye.$fH)(Me,"authLearnMore"),Le?.account&&(0,Ye.$fH)(Me,"authGetSessions"),Bt.getSession(Me,ie,fe,Le)},getAccounts(ie){return(0,Ye.$fH)(Me,"authGetSessions"),Bt.getAccounts(ie)},async hasSession(ie,fe){return(0,Ye.$fH)(Me,"authSession"),!!await Bt.getSession(Me,ie,fe,{silent:!0})},get onDidChangeSessions(){return ot(Bt.onDidChangeSessions)},registerAuthenticationProvider(ie,fe,Le,at){return Bt.registerAuthenticationProvider(ie,fe,Le,at)}},ln={registerCommand(ie,fe,Le){return wt.registerCommand(!0,ie,fe,Le,void 0,Me)},registerTextEditorCommand(ie,fe,Le){return wt.registerCommand(!0,ie,(...at)=>{const Dt=qt.getActiveTextEditor();if(!Dt){vt.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Dt.edit(Ot=>{fe.apply(Le,[Dt,Ot,...at])}).then(Ot=>{Ot||vt.warn("Edits from command "+ie+" were not applied.")},Ot=>{vt.warn("An error occurred while running command "+ie,Ot)})},void 0,void 0,Me)},registerDiffInformationCommand:(ie,fe,Le)=>((0,Ye.$fH)(Me,"diffCommand"),wt.registerCommand(!0,ie,async(...at)=>{const Dt=Nt.activeEditor(!0);if(!Dt){vt.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Ot=await qt.getDiffInformation(Dt.id);fe.apply(Le,[Ot,...at])},void 0,void 0,Me)),executeCommand(ie,...fe){return wt.executeCommand(ie,...fe)},getCommands(ie=!1){return wt.getCommands(ie)}},vi={get machineId(){return Et.telemetryInfo.machineId},get sessionId(){return Et.telemetryInfo.sessionId},get language(){return Et.environment.appLanguage},get appName(){return Et.environment.appName},get appRoot(){return Et.environment.appRoot?.fsPath??""},get appHost(){return Et.environment.appHost},get uriScheme(){return Et.environment.appUriScheme},get clipboard(){return cn.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return ot(kt.onDidChangeShell)},get isTelemetryEnabled(){return zt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(zt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$fH)(Me,"telemetry"),zt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$fH)(Me,"telemetry"),ot(zt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ft.$AQ)(Et.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,fe){return ft.$zQ.validateSender(ie),zt.instantiateLogger(Me,ie,fe)},openExternal(ie,fe){return Wt.openUri(ie,{allowTunneling:!!Et.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===Et.environment.appUriScheme)return Ai.createAppUri(ie);try{return await Wt.asExternalUri(ie,{allowTunneling:!!Et.remote.authority})}catch(fe){if((0,A.$Ng)(ie,A.Schemas.http)||(0,A.$Ng)(ie,A.Schemas.https))return ie;throw fe}},get remoteName(){return(0,c.$hn)(Et.remote.authority)},get remoteAuthority(){return(0,Ye.$fH)(Me,"resolvers"),Et.remote.authority},get uiKind(){return Et.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return ot(vt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$fH)(Me,"resolvers"),Et.quality},get appCommit(){return(0,Ye.$fH)(Me,"resolvers"),Et.commit}};Et.environment.extensionTestsLocationURI||Object.freeze(vi);const zi={createTestController(ie,fe,Le){return Ii.createTestController(Me,ie,fe,Le)},createTestObserver(){return(0,Ye.$fH)(Me,"testObserver"),Ii.createTestObserver()},runTests(ie){return(0,Ye.$fH)(Me,"testObserver"),Ii.runTests(ie)},registerTestFollowupProvider(ie){return(0,Ye.$fH)(Me,"testObserver"),Ii.registerTestFollowupProvider(ie)},get onDidChangeTestResults(){return(0,Ye.$fH)(Me,"testObserver"),ot(Ii.onResultsChanged)},get testResults(){return(0,Ye.$fH)(Me,"testObserver"),Ii.results}},ji=Et.remote.isRemote?Z.ExtensionKind.Workspace:Z.ExtensionKind.UI,mi={getExtension(ie,fe){(0,Ye.$eH)(Me,"extensionsAny")||(fe=!1);const Le=bi.mine.getExtensionDescription(ie);if(Le)return new oe.$hqc(jt,Me.identifier,Le,ji,!1);if(fe){const at=bi.all.getExtensionDescription(ie);if(at)return new oe.$hqc(jt,Me.identifier,at,ji,!0)}},get all(){const ie=[];for(const fe of bi.mine.getAllExtensionDescriptions())ie.push(new oe.$hqc(jt,Me.identifier,fe,ji,!1));return ie},get allAcrossExtensionHosts(){(0,Ye.$fH)(Me,"extensionsAny");const ie=new d.$rn(bi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),fe=[];for(const Le of bi.all.getAllExtensionDescriptions()){const at=!ie.has(Le.identifier);fe.push(new oe.$hqc(jt,Me.identifier,Le,ji,at))}return fe},get onDidChange(){return(0,Ye.$eH)(Me,"extensionsAny")?ot(O.Event.any(bi.mine.onDidChange,bi.all.onDidChange)):ot(bi.mine.onDidChange)}},Bi={createDiagnosticCollection(ie){return he.createDiagnosticCollection(Me.identifier,ie)},get onDidChangeDiagnostics(){return ot(he.onDidChangeDiagnostics)},getDiagnostics:ie=>he.getDiagnostics(ie),getLanguages(){return G.getLanguages()},setTextDocumentLanguage(ie,fe){return G.changeLanguage(ie.uri,fe)},match(ie,fe){const Le=_.LanguageSelector.from(ie);let at;return(0,y.$wu)(Le)&&(at=Ct.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Ot=>Ot.document===fe))?.apiNotebook),(0,y.$vu)(Le,fe.uri,fe.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ie,fe,Le){return Ee.registerCodeActionProvider(Me,St(ie),fe,Le)},registerDocumentPasteEditProvider(ie,fe,Le){return(0,Ye.$fH)(Me,"documentPaste"),Ee.registerDocumentPasteEditProvider(Me,St(ie),fe,Le)},registerCodeLensProvider(ie,fe){return Ee.registerCodeLensProvider(Me,St(ie),fe)},registerDefinitionProvider(ie,fe){return Ee.registerDefinitionProvider(Me,St(ie),fe)},registerDeclarationProvider(ie,fe){return Ee.registerDeclarationProvider(Me,St(ie),fe)},registerImplementationProvider(ie,fe){return Ee.registerImplementationProvider(Me,St(ie),fe)},registerTypeDefinitionProvider(ie,fe){return Ee.registerTypeDefinitionProvider(Me,St(ie),fe)},registerHoverProvider(ie,fe){return Ee.registerHoverProvider(Me,St(ie),fe,Me.identifier)},registerEvaluatableExpressionProvider(ie,fe){return Ee.registerEvaluatableExpressionProvider(Me,St(ie),fe,Me.identifier)},registerInlineValuesProvider(ie,fe){return Ee.registerInlineValuesProvider(Me,St(ie),fe,Me.identifier)},registerDocumentHighlightProvider(ie,fe){return Ee.registerDocumentHighlightProvider(Me,St(ie),fe)},registerMultiDocumentHighlightProvider(ie,fe){return Ee.registerMultiDocumentHighlightProvider(Me,St(ie),fe)},registerLinkedEditingRangeProvider(ie,fe){return Ee.registerLinkedEditingRangeProvider(Me,St(ie),fe)},registerReferenceProvider(ie,fe){return Ee.registerReferenceProvider(Me,St(ie),fe)},registerRenameProvider(ie,fe){return Ee.registerRenameProvider(Me,St(ie),fe)},registerNewSymbolNamesProvider(ie,fe){return(0,Ye.$fH)(Me,"newSymbolNamesProvider"),Ee.registerNewSymbolNamesProvider(Me,St(ie),fe)},registerDocumentSymbolProvider(ie,fe,Le){return Ee.registerDocumentSymbolProvider(Me,St(ie),fe,Le)},registerWorkspaceSymbolProvider(ie){return Ee.registerWorkspaceSymbolProvider(Me,ie)},registerDocumentFormattingEditProvider(ie,fe){return Ee.registerDocumentFormattingEditProvider(Me,St(ie),fe)},registerDocumentRangeFormattingEditProvider(ie,fe){return Ee.registerDocumentRangeFormattingEditProvider(Me,St(ie),fe)},registerOnTypeFormattingEditProvider(ie,fe,Le,...at){return Ee.registerOnTypeFormattingEditProvider(Me,St(ie),fe,[Le].concat(at))},registerDocumentSemanticTokensProvider(ie,fe,Le){return Ee.registerDocumentSemanticTokensProvider(Me,St(ie),fe,Le)},registerDocumentRangeSemanticTokensProvider(ie,fe,Le){return Ee.registerDocumentRangeSemanticTokensProvider(Me,St(ie),fe,Le)},registerSignatureHelpProvider(ie,fe,Le,...at){return typeof Le=="object"?Ee.registerSignatureHelpProvider(Me,St(ie),fe,Le):Ee.registerSignatureHelpProvider(Me,St(ie),fe,typeof Le>"u"?[]:[Le,...at])},registerCompletionItemProvider(ie,fe,...Le){return Ee.registerCompletionItemProvider(Me,St(ie),fe,Le)},registerInlineCompletionItemProvider(ie,fe,Le){return fe.handleDidShowCompletionItem&&(0,Ye.$fH)(Me,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$fH)(Me,"inlineCompletionsAdditions"),Le&&(0,Ye.$fH)(Me,"inlineCompletionsAdditions"),Ee.registerInlineCompletionsProvider(Me,St(ie),fe,Le)},registerInlineEditProvider(ie,fe){return(0,Ye.$fH)(Me,"inlineEdit"),Ee.registerInlineEditProvider(Me,St(ie),fe)},registerDocumentLinkProvider(ie,fe){return Ee.registerDocumentLinkProvider(Me,St(ie),fe)},registerColorProvider(ie,fe){return Ee.registerColorProvider(Me,St(ie),fe)},registerFoldingRangeProvider(ie,fe){return Ee.registerFoldingRangeProvider(Me,St(ie),fe)},registerSelectionRangeProvider(ie,fe){return Ee.registerSelectionRangeProvider(Me,ie,fe)},registerCallHierarchyProvider(ie,fe){return Ee.registerCallHierarchyProvider(Me,ie,fe)},registerTypeHierarchyProvider(ie,fe){return Ee.registerTypeHierarchyProvider(Me,ie,fe)},setLanguageConfiguration:(ie,fe)=>Ee.setLanguageConfiguration(Me,ie,fe),getTokenInformationAtPosition(ie,fe){return(0,Ye.$fH)(Me,"tokenInformation"),G.tokenAtPosition(ie,fe)},registerInlayHintsProvider(ie,fe){return Ee.registerInlayHintsProvider(Me,ie,fe)},createLanguageStatusItem(ie,fe){return G.createLanguageStatusItem(Me,ie,fe)},registerDocumentDropEditProvider(ie,fe,Le){return Ee.registerDocumentOnDropEditProvider(Me,ie,fe,(0,Ye.$eH)(Me,"documentPaste")?Le:void 0)}},un={get activeTextEditor(){return qt.getActiveTextEditor()},get visibleTextEditors(){return qt.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(ie,fe,Le){s.URI.isUri(ie)&&ie.scheme===A.Schemas.vscodeRemote&&!ie.authority&&Tt.report("workspace.showTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(s.URI.isUri(ie)?Promise.resolve(Zi.openTextDocument(ie)):Promise.resolve(ie));return qt.showTextDocument(at,fe,Le)},createTextEditorDecorationType(ie){return qt.createTextEditorDecorationType(Me,ie)},onDidChangeActiveTextEditor(ie,fe,Le){return ot(qt.onDidChangeActiveTextEditor)(ie,fe,Le)},onDidChangeVisibleTextEditors(ie,fe,Le){return ot(qt.onDidChangeVisibleTextEditors)(ie,fe,Le)},onDidChangeTextEditorSelection(ie,fe,Le){return ot(qt.onDidChangeTextEditorSelection)(ie,fe,Le)},onDidChangeTextEditorOptions(ie,fe,Le){return ot(qt.onDidChangeTextEditorOptions)(ie,fe,Le)},onDidChangeTextEditorVisibleRanges(ie,fe,Le){return ot(qt.onDidChangeTextEditorVisibleRanges)(ie,fe,Le)},onDidChangeTextEditorViewColumn(ie,fe,Le){return ot(qt.onDidChangeTextEditorViewColumn)(ie,fe,Le)},onDidCloseTerminal(ie,fe,Le){return ot(kt.onDidCloseTerminal)(ie,fe,Le)},onDidOpenTerminal(ie,fe,Le){return ot(kt.onDidOpenTerminal)(ie,fe,Le)},onDidChangeActiveTerminal(ie,fe,Le){return ot(kt.onDidChangeActiveTerminal)(ie,fe,Le)},onDidChangeTerminalDimensions(ie,fe,Le){return(0,Ye.$fH)(Me,"terminalDimensions"),ot(kt.onDidChangeTerminalDimensions)(ie,fe,Le)},onDidChangeTerminalState(ie,fe,Le){return ot(kt.onDidChangeTerminalState)(ie,fe,Le)},onDidWriteTerminalData(ie,fe,Le){return(0,Ye.$fH)(Me,"terminalDataWriteEvent"),ot(kt.onDidWriteTerminalData)(ie,fe,Le)},onDidExecuteTerminalCommand(ie,fe,Le){return(0,Ye.$fH)(Me,"terminalExecuteCommandEvent"),ot(kt.onDidExecuteTerminalCommand)(ie,fe,Le)},onDidChangeTerminalShellIntegration(ie,fe,Le){return(0,Ye.$fH)(Me,"terminalShellIntegration"),ot(Vt.onDidChangeTerminalShellIntegration)(ie,fe,Le)},onDidStartTerminalShellExecution(ie,fe,Le){return(0,Ye.$fH)(Me,"terminalShellIntegration"),ot(Vt.onDidStartTerminalShellExecution)(ie,fe,Le)},onDidEndTerminalShellExecution(ie,fe,Le){return(0,Ye.$fH)(Me,"terminalShellIntegration"),ot(Vt.onDidEndTerminalShellExecution)(ie,fe,Le)},get state(){return Wt.getState()},onDidChangeWindowState(ie,fe,Le){return ot(Wt.onDidChangeWindowState)(ie,fe,Le)},showInformationMessage(ie,...fe){return Gi.showMessage(Me,$.default.Info,ie,fe[0],fe.slice(1))},showWarningMessage(ie,...fe){return Gi.showMessage(Me,$.default.Warning,ie,fe[0],fe.slice(1))},showErrorMessage(ie,...fe){return Gi.showMessage(Me,$.default.Error,ie,fe[0],fe.slice(1))},showQuickPick(ie,fe,Le){return He.showQuickPick(Me,ie,fe,Le)},showWorkspaceFolderPick(ie){return He.showWorkspaceFolderPick(ie)},showInputBox(ie,fe){return He.showInput(ie,fe)},showOpenDialog(ie){return Ji.showOpenDialog(Me,ie)},showSaveDialog(ie){return Ji.showSaveDialog(ie)},createStatusBarItem(ie,fe,Le){let at,Dt,Ot;return typeof ie=="string"?(at=ie,Dt=fe,Ot=Le):(Dt=ie,Ot=fe),an.createStatusBarEntry(Me,at,Dt,Ot)},setStatusBarMessage(ie,fe){return an.setStatusBarMessage(ie,fe)},withScmProgress(ie){return Tt.report("window.withScmProgress",Me,"Use 'withProgress' instead."),Ut.withProgress(Me,{location:Z.ProgressLocation.SourceControl},(fe,Le)=>ie({report(at){}}))},withProgress(ie,fe){return Ut.withProgress(Me,ie,fe)},createOutputChannel(ie,fe){return Si.createOutputChannel(ie,fe,Me)},createWebviewPanel(ie,fe,Le,at){return Li.createWebviewPanel(Me,ie,fe,Le,at)},createWebviewTextEditorInset(ie,fe,Le,at){return(0,Ye.$fH)(Me,"editorInsets"),Re.createWebviewEditorInset(ie,fe,Le,at,Me)},createTerminal(ie,fe,Le){return typeof ie=="object"?"pty"in ie?kt.createExtensionTerminal(ie):kt.createTerminalFromOptions(ie):kt.createTerminal(ie,fe,Le)},registerTerminalLinkProvider(ie){return kt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,fe){return kt.registerProfileProvider(Me,ie,fe)},registerTerminalQuickFixProvider(ie,fe){return(0,Ye.$fH)(Me,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(ie,Me.identifier.value,fe)},registerTreeDataProvider(ie,fe){return De.registerTreeDataProvider(ie,fe,Me)},createTreeView(ie,fe){return De.createTreeView(ie,fe,Me)},registerWebviewPanelSerializer:(ie,fe)=>Li.registerWebviewPanelSerializer(Me,ie,fe),registerCustomEditorProvider:(ie,fe,Le={})=>Vi.registerCustomEditorProvider(Me,ie,fe,Le),registerFileDecorationProvider(ie){return Gt.registerFileDecorationProvider(ie,Me)},registerUriHandler(ie){return Ai.registerUriHandler(Me,ie)},createQuickPick(){return He.createQuickPick(Me)},createInputBox(){return He.createInputBox(Me)},get activeColorTheme(){return qi.activeColorTheme},onDidChangeActiveColorTheme(ie,fe,Le){return ot(qi.onDidChangeActiveColorTheme)(ie,fe,Le)},registerWebviewViewProvider(ie,fe,Le){return Hi.registerWebviewViewProvider(Me,ie,fe,Le?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,fe,Le){return ot(Ct.onDidChangeActiveNotebookEditor)(ie,fe,Le)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ie,fe,Le){return ot(ki.onDidChangeNotebookEditorSelection)(ie,fe,Le)},onDidChangeNotebookEditorVisibleRanges(ie,fe,Le){return ot(ki.onDidChangeNotebookEditorVisibleRanges)(ie,fe,Le)},showNotebookDocument(ie,fe){return Ct.showNotebookDocument(ie,fe)},registerExternalUriOpener(ie,fe,Le){return(0,Ye.$fH)(Me,"externalUriOpener"),rn.registerExternalUriOpener(Me.identifier,ie,fe,Le)},registerProfileContentHandler(ie,fe){return(0,Ye.$fH)(Me,"profileContentHandlers"),sn.registerProfileContentHandler(Me,ie,fe)},registerQuickDiffProvider(ie,fe,Le,at){return(0,Ye.$fH)(Me,"quickDiffProvider"),Pt.registerQuickDiffProvider(St(ie),fe,Le,at)},get tabGroups(){return Kt.tabGroups},registerShareProvider(ie,fe){return(0,Ye.$fH)(Me,"shareProvider"),Jt.registerShareProvider(St(ie),fe)}},Zi={get rootPath(){return Tt.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(ie){throw new P.$8("rootPath")},getWorkspaceFolder(ie){return pt.getWorkspaceFolder(ie)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(ie){throw new P.$8("name")},get workspaceFile(){return pt.workspaceFile},set workspaceFile(ie){throw new P.$8("workspaceFile")},updateWorkspaceFolders:(ie,fe,...Le)=>pt.updateWorkspaceFolders(Me,ie,fe||0,...Le),onDidChangeWorkspaceFolders:function(ie,fe,Le){return ot(pt.onDidChangeWorkspace)(ie,fe,Le)},asRelativePath:(ie,fe)=>pt.getRelativePath(ie,fe),findFiles:(ie,fe,Le,at)=>pt.findFiles(ie,fe,Le,Me.identifier,at),findFiles2:(ie,fe,Le)=>((0,Ye.$fH)(Me,"findFiles2"),pt.findFiles2(ie,fe,Me.identifier,Le)),findFiles2New:(ie,fe,Le)=>((0,Ye.$fH)(Me,"findFiles2New"),Promise.resolve([])),findTextInFiles:(ie,fe,Le,at)=>{(0,Ye.$fH)(Me,"findTextInFiles");let Dt,Ot;return typeof fe=="object"?(Dt=fe,Ot=Le):(Dt={},Ot=fe,at=Le),pt.findTextInFiles(ie,Dt||{},Ot,Me.identifier,at)},findTextInFilesNew:(ie,fe,Le)=>((0,Ye.$fH)(Me,"findTextInFilesNew"),{results:v.$5h.fromArray([]),complete:Promise.resolve({limitHit:!1})}),save:ie=>pt.save(ie),saveAs:ie=>pt.saveAs(ie),saveAll:ie=>pt.saveAll(ie),applyEdit(ie,fe){return Dn.applyWorkspaceEdit(ie,Me,fe)},createFileSystemWatcher:(ie,fe,Le,at)=>{let Dt;return typeof fe=="boolean"?Dt={ignoreCreateEvents:!!fe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!at,correlate:!1}:fe&&((0,Ye.$fH)(Me,"createFileSystemWatcher"),Dt={...fe,correlate:!0}),Ze.createFileSystemWatcher(pt,Me,ie,Dt)},get textDocuments(){return At.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new P.$8("textDocuments")},openTextDocument(ie){let fe;const Le=ie;if(typeof ie=="string")fe=Promise.resolve(s.URI.file(ie));else if(s.URI.isUri(ie))fe=Promise.resolve(ie);else if(!Le||typeof Le=="object")fe=At.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&Tt.report("workspace.openTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority."),At.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(ie,fe,Le)=>ot(At.onDidAddDocument)(ie,fe,Le),onDidCloseTextDocument:(ie,fe,Le)=>ot(At.onDidRemoveDocument)(ie,fe,Le),onDidChangeTextDocument:(ie,fe,Le)=>ot(At.onDidChangeDocument)(ie,fe,Le),onDidSaveTextDocument:(ie,fe,Le)=>ot(At.onDidSaveDocument)(ie,fe,Le),onWillSaveTextDocument:(ie,fe,Le)=>ot(ui.getOnWillSaveTextDocumentEvent(Me))(ie,fe,Le),get notebookDocuments(){return Ct.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,fe){let Le;if(s.URI.isUri(ie))Le=ie,await Ct.openNotebookDocument(ie);else if(typeof ie=="string")Le=s.URI.revive(await Ct.createNotebookDocument({viewType:ie,content:fe}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(ie,fe,Le){return ot(Ti.onDidSaveNotebookDocument)(ie,fe,Le)},onDidChangeNotebookDocument(ie,fe,Le){return ot(Ti.onDidChangeNotebookDocument)(ie,fe,Le)},onWillSaveNotebookDocument(ie,fe,Le){return ot(wi.getOnWillSaveNotebookDocumentEvent(Me))(ie,fe,Le)},get onDidOpenNotebookDocument(){return ot(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(ie,fe,Le,at){return Ct.registerNotebookSerializer(Me,ie,fe,Le,(0,Ye.$eH)(Me,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ie,fe,Le)=>ot(Xi.onDidChangeConfiguration)(ie,fe,Le),getConfiguration(ie,fe){return fe=arguments.length===1?void 0:fe,Xi.getConfiguration(ie,fe,Me)},registerTextDocumentContentProvider(ie,fe){return Ni.registerTextDocumentContentProvider(ie,fe)},registerTaskProvider:(ie,fe)=>(Tt.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(Me,ie,fe)),registerFileSystemProvider(ie,fe,Le){return(0,T.$Rc)(Be.registerFileSystemProvider(Me,ie,fe,Le),ii.addFileSystemProvider(ie,fe,Le))},get fs(){return ii.value},registerFileSearchProvider:(ie,fe)=>((0,Ye.$fH)(Me,"fileSearchProvider"),gi.registerFileSearchProvider(ie,fe)),registerTextSearchProvider:(ie,fe)=>((0,Ye.$fH)(Me,"textSearchProvider"),gi.registerTextSearchProvider(ie,fe)),registerAITextSearchProvider:(ie,fe)=>((0,Ye.$fH)(Me,"aiTextSearchProvider"),(0,Ye.$fH)(Me,"textSearchProvider"),gi.registerAITextSearchProvider(ie,fe)),registerFileSearchProviderNew:(ie,fe)=>((0,Ye.$fH)(Me,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(ie,fe)=>((0,Ye.$fH)(Me,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(ie,fe)=>((0,Ye.$fH)(Me,"aiTextSearchProviderNew"),(0,Ye.$fH)(Me,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(ie,fe)=>((0,Ye.$fH)(Me,"resolvers"),jt.registerRemoteAuthorityResolver(ie,fe)),registerResourceLabelFormatter:ie=>((0,Ye.$fH)(Me,"resolvers"),Zt.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Ye.$fH)(Me,"resolvers"),jt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,fe,Le)=>ot(Ze.onDidCreateFile)(ie,fe,Le),onDidDeleteFiles:(ie,fe,Le)=>ot(Ze.onDidDeleteFile)(ie,fe,Le),onDidRenameFiles:(ie,fe,Le)=>ot(Ze.onDidRenameFile)(ie,fe,Le),onWillCreateFiles:(ie,fe,Le)=>ot(Ze.getOnWillCreateFileEvent(Me))(ie,fe,Le),onWillDeleteFiles:(ie,fe,Le)=>ot(Ze.getOnWillDeleteFileEvent(Me))(ie,fe,Le),onWillRenameFiles:(ie,fe,Le)=>ot(Ze.getOnWillRenameFileEvent(Me))(ie,fe,Le),openTunnel:ie=>((0,Ye.$fH)(Me,"tunnels"),Lt.openTunnel(Me,ie).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ye.$fH)(Me,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(ie,fe,Le)=>((0,Ye.$fH)(Me,"tunnels"),ot(Lt.onDidChangeTunnels)(ie,fe,Le)),registerPortAttributesProvider:(ie,fe)=>((0,Ye.$fH)(Me,"portsAttributes"),Lt.registerPortsAttributesProvider(ie,fe)),registerTunnelProvider:(ie,fe)=>((0,Ye.$fH)(Me,"tunnelFactory"),Lt.registerTunnelProvider(ie,fe)),registerTimelineProvider:(ie,fe)=>((0,Ye.$fH)(Me,"timeline"),nn.registerTimelineProvider(ie,fe,Me.identifier,wt.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:ie=>((0,Ye.$fH)(Me,"workspaceTrust"),pt.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,fe,Le)=>ot(pt.onDidGrantWorkspaceTrust)(ie,fe,Le),registerEditSessionIdentityProvider:(ie,fe)=>((0,Ye.$fH)(Me,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(ie,fe)),onWillCreateEditSessionIdentity:(ie,fe,Le)=>((0,Ye.$fH)(Me,"editSessionIdentityProvider"),ot(pt.getOnWillCreateEditSessionIdentityEvent(Me))(ie,fe,Le)),registerCanonicalUriProvider:(ie,fe)=>((0,Ye.$fH)(Me,"canonicalUriProvider"),pt.registerCanonicalUriProvider(ie,fe)),getCanonicalUri:(ie,fe,Le)=>((0,Ye.$fH)(Me,"canonicalUriProvider"),pt.provideCanonicalUri(ie,fe,Le))},hn={get inputBox(){return Tt.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Me)},createSourceControl(ie,fe,Le){return ut.createSourceControl(Me,ie,fe,Le)}},dn={createCommentController(ie,fe){return si.createCommentController(Me,ie,fe)}},Sn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(ie,fe){return(0,Ye.$fH)(Me,"debugVisualization"),It.registerDebugVisualizationProvider(Me,ie,fe)},registerDebugVisualizationTreeProvider(ie,fe){return(0,Ye.$fH)(Me,"debugVisualization"),It.registerDebugVisualizationTree(Me,ie,fe)},onDidStartDebugSession(ie,fe,Le){return ot(It.onDidStartDebugSession)(ie,fe,Le)},onDidTerminateDebugSession(ie,fe,Le){return ot(It.onDidTerminateDebugSession)(ie,fe,Le)},onDidChangeActiveDebugSession(ie,fe,Le){return ot(It.onDidChangeActiveDebugSession)(ie,fe,Le)},onDidReceiveDebugSessionCustomEvent(ie,fe,Le){return ot(It.onDidReceiveDebugSessionCustomEvent)(ie,fe,Le)},onDidChangeBreakpoints(ie,fe,Le){return ot(It.onDidChangeBreakpoints)(ie,fe,Le)},onDidChangeActiveStackItem(ie,fe,Le){return ot(It.onDidChangeActiveStackItem)(ie,fe,Le)},registerDebugConfigurationProvider(ie,fe,Le){return It.registerDebugConfigurationProvider(ie,fe,Le||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,fe){return It.registerDebugAdapterDescriptorFactory(Me,ie,fe)},registerDebugAdapterTrackerFactory(ie,fe){return It.registerDebugAdapterTrackerFactory(ie,fe)},startDebugging(ie,fe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?It.startDebugging(ie,fe,{parentSession:Le}):It.startDebugging(ie,fe,Le||{})},stopDebugging(ie){return It.stopDebugging(ie)},addBreakpoints(ie){return It.addBreakpoints(ie)},removeBreakpoints(ie){return It.removeBreakpoints(ie)},asDebugSourceUri(ie,fe){return It.asDebugSourceUri(ie,fe)}},fn={registerTaskProvider:(ie,fe)=>Yt.registerTaskProvider(Me,ie,fe),fetchTasks:ie=>Yt.fetchTasks(ie),executeTask:ie=>Yt.executeTask(Me,ie),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(ie,fe,Le)=>ot(Yt.onDidStartTask)(ie,fe,Le),onDidEndTask:(ie,fe,Le)=>ot(Yt.onDidEndTask)(ie,fe,Le),onDidStartTaskProcess:(ie,fe,Le)=>ot(Yt.onDidStartTaskProcess)(ie,fe,Le),onDidEndTaskProcess:(ie,fe,Le)=>ot(Yt.onDidEndTaskProcess)(ie,fe,Le)},gn={createNotebookController(ie,fe,Le,at,Dt){return Ei.createNotebookController(Me,ie,fe,Le,at,(0,Ye.$eH)(Me,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,fe)=>Ct.registerNotebookCellStatusBarItemProvider(Me,ie,fe),createRendererMessaging(ie){return Fi.createRendererMessaging(Me,ie)},createNotebookControllerDetectionTask(ie){return(0,Ye.$fH)(Me,"notebookKernelSource"),Ei.createNotebookControllerDetectionTask(Me,ie)},registerKernelSourceActionProvider(ie,fe){return(0,Ye.$fH)(Me,"notebookKernelSource"),Ei.registerKernelSourceActionProvider(Me,ie,fe)},onDidChangeNotebookCellExecutionState(ie,fe,Le){return(0,Ye.$fH)(Me,"notebookCellExecutionState"),ot(Ei.onDidChangeNotebookCellExecutionState)(ie,fe,Le)}},kn={t(...ie){if(typeof ie[0]=="string"){const fe=ie.shift(),Le=!ie||typeof ie[0]!="object"?ie:ie[0];return $i.getMessage(Me.identifier.value,{message:fe,args:Le})}return $i.getMessage(Me.identifier.value,ie[0])},get bundle(){return $i.getBundle(Me.identifier.value)},get uri(){return $i.getBundleUri(Me.identifier.value)}},In={_version:1,transferActiveChat(ie){return(0,Ye.$fH)(Me,"interactive"),Mi.transferActiveChat(ie)}},mn={getRelatedInformation(ie,fe){return(0,Ye.$fH)(Me,"aiRelatedInformation"),Qi.getRelatedInformation(Me,ie,fe)},registerRelatedInformationProvider(ie,fe){return(0,Ye.$fH)(Me,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Me,ie,fe)},registerEmbeddingVectorProvider(ie,fe){return(0,Ye.$fH)(Me,"aiRelatedInformation"),yn.registerEmbeddingVectorProvider(Me,ie,fe)}},xi={_version:1,registerChatResponseProvider(ie,fe,Le){return(0,Ye.$fH)(Me,"chatProvider"),Qt.registerLanguageModel(Me,ie,fe,Le)},registerChatVariableResolver(ie,fe,Le,at,Dt,Ot,Pi,_i){return(0,Ye.$fH)(Me,"chatVariableResolver"),on.registerVariableResolver(Me,ie,fe,Le,at,Dt,Ot,Pi,_i?.id)},registerMappedEditsProvider(ie,fe){return(0,Ye.$fH)(Me,"mappedEditsProvider"),Ee.registerMappedEditsProvider(Me,ie,fe)},createChatParticipant(ie,fe){return Mi.createChatAgent(Me,ie,fe)},createDynamicChatParticipant(ie,fe,Le){return(0,Ye.$fH)(Me,"chatParticipantPrivate"),Mi.createDynamicChatAgent(Me,ie,fe,Le)}},pn={selectChatModels:ie=>Qt.selectLanguageModels(Me,ie??{}),onDidChangeChatModels:(ie,fe,Le)=>Qt.onDidChangeProviders(ie,fe,Le),registerChatModelProvider:(ie,fe,Le)=>((0,Ye.$fH)(Me,"chatProvider"),Qt.registerLanguageModel(Me,ie,fe,Le)),get embeddingModels(){return(0,Ye.$fH)(Me,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(ie,fe,Le)=>((0,Ye.$fH)(Me,"embeddings"),Ci.onDidChange(ie,fe,Le)),registerEmbeddingsProvider(ie,fe){return(0,Ye.$fH)(Me,"embeddings"),Ci.registerEmbeddingsProvider(Me,ie,fe)},async computeEmbeddings(ie,fe,Le){return(0,Ye.$fH)(Me,"embeddings"),Ci.computeEmbeddings(ie,fe,Le)},registerTool(ie,fe){return(0,Ye.$fH)(Me,"lmTools"),Ui.registerTool(Me,ie,fe)},invokeTool(ie,fe,Le){return(0,Ye.$fH)(Me,"lmTools"),Ui.invokeTool(ie,fe,Le)},get tools(){return(0,Ye.$fH)(Me,"lmTools"),Ui.tools}},$n={registerSpeechProvider(ie,fe){return(0,Ye.$fH)(Me,"speech"),Ki.registerProvider(Me.identifier,ie,fe)}};return{version:Et.version,ai:mn,authentication:Yi,commands:ln,comments:dn,chat:xi,debug:Sn,env:vi,extensions:mi,interactive:In,l10n:kn,languages:Bi,lm:pn,notebooks:gn,scm:hn,speech:$n,tasks:fn,tests:zi,window:un,workspace:Zi,Breakpoint:Z.$MO,TerminalOutputAnchor:Z.TerminalOutputAnchor,ChatResultFeedbackKind:Z.ChatResultFeedbackKind,ChatVariableLevel:Z.ChatVariableLevel,ChatCompletionItem:Z.$IP,CallHierarchyIncomingCall:Z.$$N,CallHierarchyItem:Z.$0N,CallHierarchyOutgoingCall:Z.$_N,CancellationError:P.$4,CancellationTokenSource:R.$we,CandidatePortSource:n.CandidatePortSource,CodeAction:Z.$7N,CodeActionKind:Z.$8N,CodeActionTriggerKind:Z.CodeActionTriggerKind,CodeLens:Z.$aO,Color:Z.$nO,ColorInformation:Z.$oO,ColorPresentation:Z.$pO,ColorThemeKind:Z.ColorThemeKind,CommentMode:Z.CommentMode,CommentState:Z.CommentState,CommentThreadCollapsibleState:Z.CommentThreadCollapsibleState,CommentThreadState:Z.CommentThreadState,CommentThreadApplicability:Z.CommentThreadApplicability,CommentThreadFocus:Z.CommentThreadFocus,CompletionItem:Z.$hO,CompletionItemKind:Z.CompletionItemKind,CompletionItemTag:Z.CompletionItemTag,CompletionList:Z.$iO,CompletionTriggerKind:Z.CompletionTriggerKind,ConfigurationTarget:Z.ConfigurationTarget,CustomExecution:Z.$xO,DebugAdapterExecutable:Z.$QO,DebugAdapterInlineImplementation:Z.$TO,DebugAdapterNamedPipeServer:Z.$SO,DebugAdapterServer:Z.$RO,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Z.DebugConsoleMode,DebugVisualization:Z.$0O,DecorationRangeBehavior:Z.DecorationRangeBehavior,Diagnostic:Z.$ZN,DiagnosticRelatedInformation:Z.$YN,DiagnosticSeverity:Z.DiagnosticSeverity,DiagnosticTag:Z.DiagnosticTag,Disposable:Z.$JN,DocumentHighlight:Z.$3N,DocumentHighlightKind:Z.DocumentHighlightKind,MultiDocumentHighlight:Z.$4N,DocumentLink:Z.$mO,DocumentSymbol:Z.$6N,EndOfLine:Z.EndOfLine,EnvironmentVariableMutatorType:Z.EnvironmentVariableMutatorType,EvaluatableExpression:Z.$WO,InlineValueText:Z.$XO,InlineValueVariableLookup:Z.$YO,InlineValueEvaluatableExpression:Z.$ZO,InlineCompletionTriggerKind:Z.InlineCompletionTriggerKind,EventEmitter:O.$le,ExtensionKind:Z.ExtensionKind,ExtensionMode:Z.ExtensionMode,ExternalUriOpenerPriority:Z.ExternalUriOpenerPriority,FileChangeType:Z.FileChangeType,FileDecoration:Z.$_O,FileDecoration2:Z.$_O,FileSystemError:Z.$3O,FileType:r.FileType,FilePermission:r.FilePermission,FoldingRange:Z.$4O,FoldingRangeKind:Z.FoldingRangeKind,FunctionBreakpoint:Z.$OO,InlineCompletionItem:Z.$jO,InlineCompletionList:Z.$kO,Hover:Z.$1N,VerboseHover:Z.$2N,HoverVerbosityAction:Z.HoverVerbosityAction,IndentAction:a.IndentAction,Location:Z.$XN,MarkdownString:Z.$bO,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:Z.$cO,PortAutoForwardAction:Z.PortAutoForwardAction,Position:Z.$KN,ProcessExecution:Z.$vO,ProgressLocation:Z.ProgressLocation,QuickInputButtonLocation:Z.QuickInputButtonLocation,QuickInputButtons:Z.$$O,Range:Z.$LN,RelativePattern:Z.$KO,Selection:Z.$MN,SelectionRange:Z.$9N,SemanticTokens:Z.$7O,SemanticTokensBuilder:Z.$6O,SemanticTokensEdit:Z.$8O,SemanticTokensEdits:Z.$9O,SemanticTokensLegend:Z.$5O,ShellExecution:Z.$wO,ShellQuoting:Z.ShellQuoting,SignatureHelp:Z.$eO,SignatureHelpTriggerKind:Z.SignatureHelpTriggerKind,SignatureInformation:Z.$dO,SnippetString:Z.$WN,SourceBreakpoint:Z.$NO,StandardTokenType:Z.StandardTokenType,StatusBarAlignment:Z.StatusBarAlignment,SymbolInformation:Z.$5N,SymbolKind:Z.SymbolKind,SymbolTag:Z.SymbolTag,Task:Z.$yO,TaskGroup:Z.$uO,TaskPanelKind:Z.TaskPanelKind,TaskRevealKind:Z.TaskRevealKind,TaskScope:Z.TaskScope,TerminalLink:Z.$qO,TerminalQuickFixTerminalCommand:Z.$sO,TerminalQuickFixOpener:Z.$rO,TerminalLocation:Z.TerminalLocation,TerminalProfile:Z.$tO,TerminalExitReason:Z.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Z.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Z.TextDocumentSaveReason,TextEdit:Z.$SN,SnippetTextEdit:Z.$UN,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Z.TextEditorLineNumbersStyle,TextEditorRevealType:Z.TextEditorRevealType,TextEditorSelectionChangeKind:Z.TextEditorSelectionChangeKind,SyntaxTokenType:Z.SyntaxTokenType,TextDocumentChangeReason:Z.TextDocumentChangeReason,ThemeColor:Z.$JO,ThemeIcon:Z.$IO,TreeItem:Z.$zO,TreeItemCheckboxState:Z.TreeItemCheckboxState,TreeItemCollapsibleState:Z.TreeItemCollapsibleState,TypeHierarchyItem:Z.$wP,UIKind:Rt.UIKind,Uri:s.URI,ViewColumn:Z.ViewColumn,WorkspaceEdit:Z.$VN,DocumentPasteTriggerKind:Z.DocumentPasteTriggerKind,DocumentDropEdit:Z.$FO,DocumentDropOrPasteEditKind:Z.$GO,DocumentPasteEdit:Z.$HO,InlayHint:Z.$gO,InlayHintLabelPart:Z.$fO,InlayHintKind:Z.InlayHintKind,RemoteAuthorityResolverError:Z.$RN,ResolvedAuthority:Z.$PN,ManagedResolvedAuthority:Z.$QN,SourceControlInputBoxValidationType:Z.SourceControlInputBoxValidationType,ExtensionRuntime:Z.ExtensionRuntime,TimelineItem:Z.$jP,NotebookRange:Z.$bP,NotebookCellKind:Z.NotebookCellKind,NotebookCellExecutionState:Z.NotebookCellExecutionState,NotebookCellData:Z.$cP,NotebookData:Z.$dP,NotebookRendererScript:Z.$hP,NotebookCellStatusBarAlignment:Z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Z.NotebookEditorRevealType,NotebookCellOutput:Z.$fP,NotebookCellOutputItem:Z.$eP,NotebookCellStatusBarItem:Z.$gP,NotebookControllerAffinity:Z.NotebookControllerAffinity,NotebookControllerAffinity2:Z.NotebookControllerAffinity2,NotebookEdit:Z.$TN,NotebookKernelSourceAction:Z.$iP,NotebookVariablesRequestKind:Z.NotebookVariablesRequestKind,PortAttributes:Z.$lP,LinkedEditingRanges:Z.$kP,TestResultState:Z.TestResultState,TestRunRequest:Z.$mP,TestMessage:Z.$nP,TestMessage2:Z.$nP,TestMessageStackFrame:Z.$pP,TestTag:Z.$oP,TestRunProfileKind:Z.TestRunProfileKind,TextSearchCompleteMessageType:Mt.TextSearchCompleteMessageType,DataTransfer:Z.$EO,DataTransferItem:Z.$AO,TestCoverageCount:Z.$qP,FileCoverage:Z.$sP,FileCoverage2:Z.$sP,StatementCoverage:Z.$tP,BranchCoverage:Z.$uP,DeclarationCoverage:Z.$vP,WorkspaceTrustState:Z.WorkspaceTrustState,LanguageStatusSeverity:Z.LanguageStatusSeverity,QuickPickItemKind:Z.QuickPickItemKind,InputBoxValidationSeverity:Z.InputBoxValidationSeverity,TabInputText:Z.$xP,TabInputTextDiff:Z.$yP,TabInputTextMerge:Z.$zP,TabInputCustom:Z.$AP,TabInputNotebook:Z.$CP,TabInputNotebookDiff:Z.$DP,TabInputWebview:Z.$BP,TabInputTerminal:Z.$EP,TabInputInteractiveWindow:Z.$FP,TabInputChat:Z.$GP,TabInputTextMultiDiff:Z.$HP,TelemetryTrustedValue:l.$wp,LogLevel:o.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Z.InteractiveSessionVoteDirection,ChatCopyKind:Z.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Z.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Z.$UO,DebugThread:Z.$VO,RelatedInformationType:Z.RelatedInformationType,SpeechToTextStatus:Z.SpeechToTextStatus,TextToSpeechStatus:Z.TextToSpeechStatus,PartialAcceptTriggerKind:Z.PartialAcceptTriggerKind,KeywordRecognitionStatus:Z.KeywordRecognitionStatus,ChatResponseMarkdownPart:Z.$JP,ChatResponseFileTreePart:Z.$NP,ChatResponseAnchorPart:Z.$OP,ChatResponseProgressPart:Z.$PP,ChatResponseProgressPart2:Z.$QP,ChatResponseReferencePart:Z.$TP,ChatResponseReferencePart2:Z.$TP,ChatResponseCodeCitationPart:Z.$UP,ChatResponseWarningPart:Z.$RP,ChatResponseTextEditPart:Z.$VP,ChatResponseMarkdownWithVulnerabilitiesPart:Z.$KP,ChatResponseCommandButtonPart:Z.$SP,ChatResponseDetectedParticipantPart:Z.$LP,ChatResponseConfirmationPart:Z.$MP,ChatResponseReferencePartStatusKind:Z.ChatResponseReferencePartStatusKind,ChatRequestTurn:Z.$WP,ChatResponseTurn:Z.$XP,ChatLocation:Z.ChatLocation,ChatRequestEditorData:Z.$YP,ChatRequestNotebookData:Z.$ZP,LanguageModelChatMessageRole:Z.LanguageModelChatMessageRole,LanguageModelChatMessage:Z.$2P,LanguageModelChatMessageFunctionResultPart:Z.$1P,LanguageModelChatResponseTextPart:Z.$4P,LanguageModelChatResponseFunctionUsePart:Z.$3P,LanguageModelError:Z.$8P,NewSymbolName:Z.$2O,NewSymbolNameTag:Z.NewSymbolNameTag,NewSymbolNameTriggerKind:Z.NewSymbolNameTriggerKind,InlineEdit:Z.$9P,InlineEditTriggerKind:Z.InlineEditTriggerKind,ExcludeSettingOptions:Mt.ExcludeSettingOptions,TextSearchContextNew:Mt.$XL,TextSearchMatchNew:Mt.$WL,TextSearchCompleteMessageTypeNew:Mt.TextSearchCompleteMessageTypeNew}}}}),define(Oe[277],Ne([1,0,60,128,45,122,46,33,57,56,131,133,134,88,92,84,121,68,50,87,66,70,216,11,132,85,86,90,94,126,95]),function(be,e,v,R,P,O,T,A,$,s,k,y,a,S,d,r,o,c,l,i,n,t,g,u,m,p,h,E,D,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Qs)(p.$bqc,p.$aqc,v.InstantiationType.Delayed),(0,v.$Qs)(u.$ak,g.$qrc,v.InstantiationType.Delayed),(0,v.$Qs)(r.$gpc,r.$hpc,v.InstantiationType.Delayed),(0,v.$Qs)(A.$DQ,A.$CQ,v.InstantiationType.Eager),(0,v.$Qs)(E.$qpc,E.$rpc,v.InstantiationType.Eager),(0,v.$Qs)(D.$8pc,D.$9pc,v.InstantiationType.Eager),(0,v.$Qs)(T.$Fpc,T.$Dpc,v.InstantiationType.Eager),(0,v.$Qs)(c.$Hpc,c.$Gpc,v.InstantiationType.Eager),(0,v.$Qs)(I.$lqc,I.$mqc,v.InstantiationType.Eager),(0,v.$Qs)(y.$qqc,y.$uqc,v.InstantiationType.Eager),(0,v.$Qs)(O.$wqc,O.$vqc,v.InstantiationType.Eager),(0,v.$Qs)($.$sQ,$.$rQ,v.InstantiationType.Eager),(0,v.$Qs)(h.$cqc,h.$dqc,v.InstantiationType.Eager),(0,v.$Qs)(l.$kpc,l.$jpc,v.InstantiationType.Eager),(0,v.$Qs)(R.$3qc,R.$2qc,v.InstantiationType.Delayed),(0,v.$Qs)(a.$Mqc,a.$Nqc,v.InstantiationType.Eager),(0,v.$Qs)(S.$1pc,S.$Zpc,v.InstantiationType.Eager),(0,v.$Qs)(k.$drc,k.$crc,v.InstantiationType.Eager),(0,v.$Qs)(s.$4pc,s.$7pc,v.InstantiationType.Eager),(0,v.$Qs)(w.$erc,w.$frc,v.InstantiationType.Eager),(0,v.$Qs)(d.$eGb,d.$fGb,v.InstantiationType.Eager),(0,v.$Qs)(o.$orc,o.$nrc,v.InstantiationType.Eager),(0,v.$Qs)(P.$Cpc,P.$Bpc,v.InstantiationType.Eager),(0,v.$Qs)(i.$$pc,i.$0pc,v.InstantiationType.Eager),(0,v.$Qs)(n.$BQ,n.$yQ,v.InstantiationType.Eager),(0,v.$Qs)(t.$Rpc,t.$Spc,v.InstantiationType.Eager),(0,v.$Qs)(m.$jqc,m.$kqc,v.InstantiationType.Eager)}),define(Oe[278],Ne([1,0,276,47,2,273,7,10,223]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ctc=void 0;class s extends O.$trc{j(){}getModule(S,d){for(const r of this.b){const o=r(S);if(o){S=o;break}}if(this.a.has(S))return this.a.get(S).load(S,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends R.$fqc{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$Btc);const S=this.h.invokeFunction(v.$prc);this.r=this.h.createInstance(s,S,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(S){return S.browser}async xb(S,d,r){d=d.with({path:y(d.path,".js")});const o=S?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const c=P.URI.revive(await this.C.$asBrowserUri(d)),l=await fetch(c.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),l.status!==200)throw new Error(l.statusText);const i=await l.text(),n=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let g;try{g=new Function("module","exports","require",t)}catch(h){throw console.error(o?`Loading code for extension ${o} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${d.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}S&&await this.w.initializeLocalizedMessages(S);const u={},m={exports:u},p=h=>{const E=this.r.getModule(h,d);if(E===void 0)throw new Error(`Cannot load module '${h}'`);return E};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),g(m,u,p),m.exports!==u?m.exports:u}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(S){}async Bb(S=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+S;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,A.$Fh)(10)}}e.$Ctc=k;function y(a,S){return a.endsWith(S)?a:a+S}}),define(Oe[279],Ne([1,0,73,60,11,47,188,91,278]),function(be,e,v,R,P,O,T,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.$Qs)(P.$_j,new v.$Bi(T.$src,[!0],!0)),(0,R.$Qs)(O.$gqc,$.$Ctc,R.InstantiationType.Eager),(0,R.$Qs)(A.$Ipc,A.$Jpc,R.InstantiationType.Eager)}),define(Oe[287],Ne([1,0,22,6,83,274,225,19,64,15,2,277,279]),function(be,e,v,R,P,O,T,A,$,s,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,A=We(A),$=We($);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(g){return/^(file|vscode-remote):/i.test(g)}const d=fetch.bind(self);function r(g){self.fetch=async function(u,m){return u instanceof Request||S(String(u))&&(u=(await g(k.URI.parse(String(u)))).toString(!0)),d(u,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,m,p,h,E){(async()=>(S(m.toString())&&(m=(await g(k.URI.parse(m.toString()))).toString(!0)),super.open(u,m,p??!0,h,E)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=self.Worker;Worker=function(u,m){if(/^file:/i.test(u.toString()))u=s.$Yg.uriToBrowserUri(k.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(I){function C(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const f=fetch.bind(self);self.fetch=function(M,N){return M instanceof Request?f(M,N):f(C(M),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,N,F,W,K){return super.open(M,C(N),F??!0,W,K)}};const b=importScripts.bind(self);self.importScripts=(...M)=>{b(...M.map(C))},b(I)}.toString()}('${u}'))`;m=m||{},m.name=`${name} -> ${m.name||A.$nc(u.toString())}`;const E=new Blob([h],{type:"application/javascript"}),D=URL.createObjectURL(E);return new g(D,m)}}else self.Worker=class extends T.$Dtc{constructor(g,u){super(a,g,{name:A.$nc(g.toString()),...u})}};const o=new class{constructor(){this.pid=void 0}exit(g){y()}};class c{constructor(){const u=new MessageChannel,m=new R.$le;let p=!1;a(u.port2,[u.port2]),u.port1.onmessage=h=>{const{data:E}=h;if(!(E instanceof ArrayBuffer)){console.warn("UNKNOWN data received",E);return}const D=v.$Ne.wrap(new Uint8Array(E,0,E.byteLength));if((0,P.$Bn)(D,P.MessageType.Terminate)){p=!0,i("received terminate message from renderer");return}m.fire(D)},this.protocol={onMessage:m.event,send:h=>{if(!p){const E=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);u.port1.postMessage(E,[E])}}}}}function l(g){return new Promise(u=>{const m=g.onMessage(p=>{m.dispose();const h=JSON.parse(p.toString());g.send((0,P.$An)(P.MessageType.Initialized)),u({protocol:g,initData:h})});g.send((0,P.$An)(P.MessageType.Ready))})}let i=g=>y();function n(g){return!!g&&typeof g=="object"&&g.type==="vscode.init"&&g.data instanceof Map}function t(){$.mark("code/extHost/willConnectToRenderer");const g=new c;return{onmessage(u){n(u)&&l(g.protocol).then(m=>{$.mark("code/extHost/didWaitForInitData");const p=new O.$vrc(m.protocol,m.initData,o,null,u.data);r(h=>p.asBrowserUri(h)),i=h=>p.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/97d1b933ada0ca69bea107f7a89e029991277ccc/core/vs/workbench/api/worker/extensionHostWorker.js.map
